/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/arrays","vs/base/common/uri","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(Z){for(var t=[],w=0,i=Z.length;w<i;w++)t[w]=pe[Z[w]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function Ut(Z){if(Array.isArray(Z)){for(var t=0,w=Array(Z.length);t<Z.length;t++)w[t]=Z[t];return w}else return Array.from(Z)}var Vt=Object.hasOwnProperty,Lt=Object.setPrototypeOf,$t=Object.isFrozen,Kt=Object.getPrototypeOf,qt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,xt=Object.create,Nt=typeof Reflect<"u"&&Reflect,vt=Nt.apply,Et=Nt.construct;vt||(vt=function(t,w,i){return t.apply(w,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,w){return new(Function.prototype.bind.apply(t,[null].concat(Ut(w))))});var jt=nt(Array.prototype.forEach),kt=nt(Array.prototype.pop),pt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Gt=nt(String.prototype.indexOf),Yt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Xt(TypeError);function nt(Z){return function(t){for(var w=arguments.length,i=Array(w>1?w-1:0),B=1;B<w;B++)i[B-1]=arguments[B];return vt(Z,t,i)}}function Xt(Z){return function(){for(var t=arguments.length,w=Array(t),i=0;i<t;i++)w[i]=arguments[i];return Et(Z,w)}}function Be(Z,t){Lt&&Lt(Z,null);for(var w=t.length;w--;){var i=t[w];if(typeof i=="string"){var B=ut(i);B!==i&&($t(t)||(t[w]=B),i=B)}Z[i]=!0}return Z}function ct(Z){var t=xt(null),w=void 0;for(w in Z)vt(Vt,Z,[w])&&(t[w]=Z[w]);return t}function Dt(Z,t){for(;Z!==null;){var w=qt(Z,t);if(w){if(w.get)return nt(w.get);if(typeof w.value=="function")return nt(w.value)}Z=Kt(Z)}function i(B){return console.warn("fallback value for",B),null}return i}var Mt=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),_t=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Zt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Qt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=et(["#text"]),Bt=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),At=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),Jt=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ei=ot(/<%[\s\S]*|[\s\S]*%>/gm),ti=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ii=ot(/^aria-[\-\w]+$/),ni=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),si=ot(/^(?:\w+script|data):/i),ri=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Z){return typeof Z}:function(Z){return Z&&typeof Symbol=="function"&&Z.constructor===Symbol&&Z!==Symbol.prototype?"symbol":typeof Z};function rt(Z){if(Array.isArray(Z)){for(var t=0,w=Array(Z.length);t<Z.length;t++)w[t]=Z[t];return w}else return Array.from(Z)}var oi=function(){return typeof window>"u"?null:window},ai=function(t,w){if((typeof t>"u"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,B="data-tt-policy-suffix";w.currentScript&&w.currentScript.hasAttribute(B)&&(i=w.currentScript.getAttribute(B));var H="dompurify"+(i?"#"+i:"");try{return t.createPolicy(H,{createHTML:function(v){return v}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Wt(){var Z=arguments.length>0&&arguments[0]!==void 0?arguments[0]:oi(),t=function(re){return Wt(re)};if(t.version="2.3.1",t.removed=[],!Z||!Z.document||Z.document.nodeType!==9)return t.isSupported=!1,t;var w=Z.document,i=Z.document,B=Z.DocumentFragment,H=Z.HTMLTemplateElement,y=Z.Node,v=Z.Element,h=Z.NodeFilter,g=Z.NamedNodeMap,f=g===void 0?Z.NamedNodeMap||Z.MozNamedAttrMap:g,I=Z.Text,o=Z.Comment,n=Z.DOMParser,e=Z.trustedTypes,r=v.prototype,a=Dt(r,"cloneNode"),c=Dt(r,"nextSibling"),m=Dt(r,"childNodes"),s=Dt(r,"parentNode");if(typeof H=="function"){var l=i.createElement("template");l.content&&l.content.ownerDocument&&(i=l.content.ownerDocument)}var p=ai(e,w),_=p&&X?p.createHTML(""):"",L=i,S=L.implementation,A=L.createNodeIterator,u=L.createDocumentFragment,E=L.getElementsByTagName,b=w.importNode,D={};try{D=ct(i).documentMode?i.documentMode:{}}catch{}var z={};t.isSupported=typeof s=="function"&&S&&typeof S.createHTMLDocument<"u"&&D!==9;var x=Jt,ie=ei,Q=ti,me=ii,ae=si,fe=ri,le=ni,de=null,Se=Be({},[].concat(rt(Mt),rt(_t),rt(Ct),rt(St),rt(Ot))),ee=null,ye=Be({},[].concat(rt(Bt),rt(At),rt(Ht),rt(yt))),se=null,te=null,ce=!0,ne=!0,T=!1,V=!1,j=!1,P=!1,d=!1,F=!1,U=!1,$=!0,X=!1,N=!0,R=!0,W=!1,C={},k=null,M=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),O=null,K=Be({},["audio","video","img","source","image","track"]),J=null,ue=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),he="http://www.w3.org/1998/Math/MathML",De="http://www.w3.org/2000/svg",Ee="http://www.w3.org/1999/xhtml",Ne=Ee,Ae=!1,ve=null,Re=i.createElement("form"),Pe=function(re){ve&&ve===re||((!re||(typeof re>"u"?"undefined":bt(re))!=="object")&&(re={}),re=ct(re),de="ALLOWED_TAGS"in re?Be({},re.ALLOWED_TAGS):Se,ee="ALLOWED_ATTR"in re?Be({},re.ALLOWED_ATTR):ye,J="ADD_URI_SAFE_ATTR"in re?Be(ct(ue),re.ADD_URI_SAFE_ATTR):ue,O="ADD_DATA_URI_TAGS"in re?Be(ct(K),re.ADD_DATA_URI_TAGS):K,k="FORBID_CONTENTS"in re?Be({},re.FORBID_CONTENTS):M,se="FORBID_TAGS"in re?Be({},re.FORBID_TAGS):{},te="FORBID_ATTR"in re?Be({},re.FORBID_ATTR):{},C="USE_PROFILES"in re?re.USE_PROFILES:!1,ce=re.ALLOW_ARIA_ATTR!==!1,ne=re.ALLOW_DATA_ATTR!==!1,T=re.ALLOW_UNKNOWN_PROTOCOLS||!1,V=re.SAFE_FOR_TEMPLATES||!1,j=re.WHOLE_DOCUMENT||!1,F=re.RETURN_DOM||!1,U=re.RETURN_DOM_FRAGMENT||!1,$=re.RETURN_DOM_IMPORT!==!1,X=re.RETURN_TRUSTED_TYPE||!1,d=re.FORCE_BODY||!1,N=re.SANITIZE_DOM!==!1,R=re.KEEP_CONTENT!==!1,W=re.IN_PLACE||!1,le=re.ALLOWED_URI_REGEXP||le,Ne=re.NAMESPACE||Ee,V&&(ne=!1),U&&(F=!0),C&&(de=Be({},[].concat(rt(Ot))),ee=[],C.html===!0&&(Be(de,Mt),Be(ee,Bt)),C.svg===!0&&(Be(de,_t),Be(ee,At),Be(ee,yt)),C.svgFilters===!0&&(Be(de,Ct),Be(ee,At),Be(ee,yt)),C.mathMl===!0&&(Be(de,St),Be(ee,Ht),Be(ee,yt))),re.ADD_TAGS&&(de===Se&&(de=ct(de)),Be(de,re.ADD_TAGS)),re.ADD_ATTR&&(ee===ye&&(ee=ct(ee)),Be(ee,re.ADD_ATTR)),re.ADD_URI_SAFE_ATTR&&Be(J,re.ADD_URI_SAFE_ATTR),re.FORBID_CONTENTS&&(k===M&&(k=ct(k)),Be(k,re.FORBID_CONTENTS)),R&&(de["#text"]=!0),j&&Be(de,["html","head","body"]),de.table&&(Be(de,["tbody"]),delete se.tbody),et&&et(re),ve=re)},$e=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),ze=Be({},_t);Be(ze,Ct),Be(ze,Zt);var Je=Be({},St);Be(Je,Qt);var it=function(re){var Ce=s(re);(!Ce||!Ce.tagName)&&(Ce={namespaceURI:Ee,tagName:"template"});var Le=ut(re.tagName),We=ut(Ce.tagName);if(re.namespaceURI===De)return Ce.namespaceURI===Ee?Le==="svg":Ce.namespaceURI===he?Le==="svg"&&(We==="annotation-xml"||$e[We]):Boolean(ze[Le]);if(re.namespaceURI===he)return Ce.namespaceURI===Ee?Le==="math":Ce.namespaceURI===De?Le==="math"&&He[We]:Boolean(Je[Le]);if(re.namespaceURI===Ee){if(Ce.namespaceURI===De&&!He[We]||Ce.namespaceURI===he&&!$e[We])return!1;var je=Be({},["title","style","font","a","script"]);return!Je[Le]&&(je[Le]||!ze[Le])}return!1},Oe=function(re){pt(t.removed,{element:re});try{re.parentNode.removeChild(re)}catch{try{re.outerHTML=_}catch{re.remove()}}},qe=function(re,Ce){try{pt(t.removed,{attribute:Ce.getAttributeNode(re),from:Ce})}catch{pt(t.removed,{attribute:null,from:Ce})}if(Ce.removeAttribute(re),re==="is"&&!ee[re])if(F||U)try{Oe(Ce)}catch{}else try{Ce.setAttribute(re,"")}catch{}},Ye=function(re){var Ce=void 0,Le=void 0;if(d)re="<remove></remove>"+re;else{var We=Pt(re,/^[\r\n\t ]+/);Le=We&&We[0]}var je=p?p.createHTML(re):re;if(Ne===Ee)try{Ce=new n().parseFromString(je,"text/html")}catch{}if(!Ce||!Ce.documentElement){Ce=S.createDocument(Ne,"template",null);try{Ce.documentElement.innerHTML=Ae?"":je}catch{}}var Xe=Ce.body||Ce.documentElement;return re&&Le&&Xe.insertBefore(i.createTextNode(Le),Xe.childNodes[0]||null),Ne===Ee?E.call(Ce,j?"html":"body")[0]:j?Ce.documentElement:Xe},q=function(re){return A.call(re.ownerDocument||re,re,h.SHOW_ELEMENT|h.SHOW_COMMENT|h.SHOW_TEXT,null,!1)},oe=function(re){return re instanceof I||re instanceof o?!1:typeof re.nodeName!="string"||typeof re.textContent!="string"||typeof re.removeChild!="function"||!(re.attributes instanceof f)||typeof re.removeAttribute!="function"||typeof re.setAttribute!="function"||typeof re.namespaceURI!="string"||typeof re.insertBefore!="function"},we=function(re){return(typeof y>"u"?"undefined":bt(y))==="object"?re instanceof y:re&&(typeof re>"u"?"undefined":bt(re))==="object"&&typeof re.nodeType=="number"&&typeof re.nodeName=="string"},_e=function(re,Ce,Le){!z[re]||jt(z[re],function(We){We.call(t,Ce,Le,ve)})},Fe=function(re){var Ce=void 0;if(_e("beforeSanitizeElements",re,null),oe(re)||Pt(re.nodeName,/[\u0080-\uFFFF]/))return Oe(re),!0;var Le=ut(re.nodeName);if(_e("uponSanitizeElement",re,{tagName:Le,allowedTags:de}),!we(re.firstElementChild)&&(!we(re.content)||!we(re.content.firstElementChild))&&at(/<[/\w]/g,re.innerHTML)&&at(/<[/\w]/g,re.textContent)||Le==="select"&&at(/<template/i,re.innerHTML))return Oe(re),!0;if(!de[Le]||se[Le]){if(R&&!k[Le]){var We=s(re)||re.parentNode,je=m(re)||re.childNodes;if(je&&We)for(var Xe=je.length,Ze=Xe-1;Ze>=0;--Ze)We.insertBefore(a(je[Ze],!0),c(re))}return Oe(re),!0}return re instanceof v&&!it(re)||(Le==="noscript"||Le==="noembed")&&at(/<\/no(script|embed)/i,re.innerHTML)?(Oe(re),!0):(V&&re.nodeType===3&&(Ce=re.textContent,Ce=lt(Ce,x," "),Ce=lt(Ce,ie," "),re.textContent!==Ce&&(pt(t.removed,{element:re.cloneNode()}),re.textContent=Ce)),_e("afterSanitizeElements",re,null),!1)},Me=function(re,Ce,Le){if(N&&(Ce==="id"||Ce==="name")&&(Le in i||Le in Re))return!1;if(!(ne&&!te[Ce]&&at(Q,Ce))){if(!(ce&&at(me,Ce))){if(!ee[Ce]||te[Ce])return!1;if(!J[Ce]){if(!at(le,lt(Le,fe,""))){if(!((Ce==="src"||Ce==="xlink:href"||Ce==="href")&&re!=="script"&&Gt(Le,"data:")===0&&O[re])){if(!(T&&!at(ae,lt(Le,fe,"")))){if(Le)return!1}}}}}}return!0},Ve=function(re){var Ce=void 0,Le=void 0,We=void 0,je=void 0;_e("beforeSanitizeAttributes",re,null);var Xe=re.attributes;if(!!Xe){var Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ee};for(je=Xe.length;je--;){Ce=Xe[je];var st=Ce,ht=st.name,dt=st.namespaceURI;if(Le=Yt(Ce.value),We=ut(ht),Ze.attrName=We,Ze.attrValue=Le,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,_e("uponSanitizeAttribute",re,Ze),Le=Ze.attrValue,!Ze.forceKeepAttr&&(qe(ht,re),!!Ze.keepAttr)){if(at(/\/>/i,Le)){qe(ht,re);continue}V&&(Le=lt(Le,x," "),Le=lt(Le,ie," "));var Tt=re.nodeName.toLowerCase();if(!!Me(Tt,We,Le))try{dt?re.setAttributeNS(dt,ht,Le):re.setAttribute(ht,Le),kt(t.removed)}catch{}}}_e("afterSanitizeAttributes",re,null)}},tt=function ke(re){var Ce=void 0,Le=q(re);for(_e("beforeSanitizeShadowDOM",re,null);Ce=Le.nextNode();)_e("uponSanitizeShadowNode",Ce,null),!Fe(Ce)&&(Ce.content instanceof B&&ke(Ce.content),Ve(Ce));_e("afterSanitizeShadowDOM",re,null)};return t.sanitize=function(ke,re){var Ce=void 0,Le=void 0,We=void 0,je=void 0,Xe=void 0;if(Ae=!ke,Ae&&(ke="<!-->"),typeof ke!="string"&&!we(ke)){if(typeof ke.toString!="function")throw Rt("toString is not a function");if(ke=ke.toString(),typeof ke!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(Z.toStaticHTML)==="object"||typeof Z.toStaticHTML=="function"){if(typeof ke=="string")return Z.toStaticHTML(ke);if(we(ke))return Z.toStaticHTML(ke.outerHTML)}return ke}if(P||Pe(re),t.removed=[],typeof ke=="string"&&(W=!1),!W)if(ke instanceof y)Ce=Ye("<!---->"),Le=Ce.ownerDocument.importNode(ke,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?Ce=Le:Ce.appendChild(Le);else{if(!F&&!V&&!j&&ke.indexOf("<")===-1)return p&&X?p.createHTML(ke):ke;if(Ce=Ye(ke),!Ce)return F?null:_}Ce&&d&&Oe(Ce.firstChild);for(var Ze=q(W?ke:Ce);We=Ze.nextNode();)We.nodeType===3&&We===je||Fe(We)||(We.content instanceof B&&tt(We.content),Ve(We),je=We);if(je=null,W)return ke;if(F){if(U)for(Xe=u.call(Ce.ownerDocument);Ce.firstChild;)Xe.appendChild(Ce.firstChild);else Xe=Ce;return $&&(Xe=b.call(w,Xe,!0)),Xe}var st=j?Ce.outerHTML:Ce.innerHTML;return V&&(st=lt(st,x," "),st=lt(st,ie," ")),p&&X?p.createHTML(st):st},t.setConfig=function(ke){Pe(ke),P=!0},t.clearConfig=function(){ve=null,P=!1},t.isValidAttribute=function(ke,re,Ce){ve||Pe({});var Le=ut(ke),We=ut(re);return Me(Le,We,Ce)},t.addHook=function(ke,re){typeof re=="function"&&(z[ke]=z[ke]||[],pt(z[ke],re))},t.removeHook=function(ke){z[ke]&&kt(z[ke])},t.removeHooks=function(ke){z[ke]&&(z[ke]=[])},t.removeAllHooks=function(){z={}},t}var li=Wt();define("vs/base/browser/dompurify/dompurify",function(){return li}),define(pe[40],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class w{constructor(y){this.domNode=y,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(y){const v=i(y);this._maxWidth!==v&&(this._maxWidth=v,this.domNode.style.maxWidth=this._maxWidth)}setWidth(y){const v=i(y);this._width!==v&&(this._width=v,this.domNode.style.width=this._width)}setHeight(y){const v=i(y);this._height!==v&&(this._height=v,this.domNode.style.height=this._height)}setTop(y){const v=i(y);this._top!==v&&(this._top=v,this.domNode.style.top=this._top)}setLeft(y){const v=i(y);this._left!==v&&(this._left=v,this.domNode.style.left=this._left)}setBottom(y){const v=i(y);this._bottom!==v&&(this._bottom=v,this.domNode.style.bottom=this._bottom)}setRight(y){const v=i(y);this._right!==v&&(this._right=v,this.domNode.style.right=this._right)}setFontFamily(y){this._fontFamily!==y&&(this._fontFamily=y,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(y){this._fontWeight!==y&&(this._fontWeight=y,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(y){const v=i(y);this._fontSize!==v&&(this._fontSize=v,this.domNode.style.fontSize=this._fontSize)}setFontStyle(y){this._fontStyle!==y&&(this._fontStyle=y,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(y){this._fontFeatureSettings!==y&&(this._fontFeatureSettings=y,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(y){this._textDecoration!==y&&(this._textDecoration=y,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(y){const v=i(y);this._lineHeight!==v&&(this._lineHeight=v,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(y){const v=i(y);this._letterSpacing!==v&&(this._letterSpacing=v,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(y){this._className!==y&&(this._className=y,this.domNode.className=this._className)}toggleClassName(y,v){this.domNode.classList.toggle(y,v),this._className=this.domNode.className}setDisplay(y){this._display!==y&&(this._display=y,this.domNode.style.display=this._display)}setPosition(y){this._position!==y&&(this._position=y,this.domNode.style.position=this._position)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this.domNode.style.visibility=this._visibility)}setColor(y){this._color!==y&&(this._color=y,this.domNode.style.color=this._color)}setBackgroundColor(y){this._backgroundColor!==y&&(this._backgroundColor=y,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(y){this._layerHint!==y&&(this._layerHint=y,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this._boxShadow!==y&&(this._boxShadow=y,this.domNode.style.boxShadow=y)}setContain(y){this._contain!==y&&(this._contain=y,this.domNode.style.contain=this._contain)}setAttribute(y,v){this.domNode.setAttribute(y,v)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=w;function i(H){return typeof H=="number"?`${H}px`:H}function B(H){return new w(H)}t.createFastDomNode=B}),define(pe[66],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let w=!1,i=null;function B(y){if(!y.parent||y.parent===y)return null;try{const v=y.location,h=y.parent.location;if(v.origin!=="null"&&h.origin!=="null"&&v.origin!==h.origin)return w=!0,null}catch{return w=!0,null}return y.parent}class H{static getSameOriginWindowChain(){if(!i){i=[];let v=window,h;do h=B(v),h?i.push({window:v,iframeElement:v.frameElement||null}):i.push({window:v,iframeElement:null}),v=h;while(v)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),w}static getPositionOfChildWindowRelativeToAncestorWindow(v,h){if(!h||v===h)return{top:0,left:0};let g=0,f=0;const I=this.getSameOriginWindowChain();for(const o of I){if(g+=o.window.scrollY,f+=o.window.scrollX,o.window===h||!o.iframeElement)break;const n=o.iframeElement.getBoundingClientRect();g+=n.top,f+=n.left}return{top:g,left:f}}}t.IframeUtils=H}),define(pe[67],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var w;(function(H){H[H.Copy=0]="Copy",H[H.Move=1]="Move"})(w=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,v){super(`ListError [${y}] ${v}`)}}t.ListError=i;class B{constructor(){this.cache=new WeakMap}getHeight(y){return this.cache.get(y)??this.estimateHeight(y)}setDynamicHeight(y,v){v>0&&this.cache.set(y,v)}}t.CachedListVirtualDelegate=B}),define(pe[68],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class w{constructor(B){this.spliceables=B}splice(B,H,y){this.spliceables.forEach(v=>v.splice(B,H,y))}}t.CombinedSpliceable=w}),define(pe[41],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const w=20;class i{constructor(H,y,v,h,g,f){this._scrollbarSize=Math.round(y),this._oppositeScrollbarSize=Math.round(v),this._arrowSize=Math.round(H),this._visibleSize=h,this._scrollSize=g,this._scrollPosition=f,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(H){const y=Math.round(H);return this._visibleSize!==y?(this._visibleSize=y,this._refreshComputedValues(),!0):!1}setScrollSize(H){const y=Math.round(H);return this._scrollSize!==y?(this._scrollSize=y,this._refreshComputedValues(),!0):!1}setScrollPosition(H){const y=Math.round(H);return this._scrollPosition!==y?(this._scrollPosition=y,this._refreshComputedValues(),!0):!1}setScrollbarSize(H){this._scrollbarSize=Math.round(H)}setOppositeScrollbarSize(H){this._oppositeScrollbarSize=Math.round(H)}static _computeValues(H,y,v,h,g){const f=Math.max(0,v-H),I=Math.max(0,f-2*y),o=h>0&&h>v;if(!o)return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(w,Math.floor(v*I/h))),e=(I-n)/(h-v),r=g*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(r)}}_refreshComputedValues(){const H=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=H.computedAvailableSize,this._computedIsNeeded=H.computedIsNeeded,this._computedSliderSize=H.computedSliderSize,this._computedSliderRatio=H.computedSliderRatio,this._computedSliderPosition=H.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(H){if(!this._computedIsNeeded)return 0;const y=H-this._arrowSize-this._computedSliderSize/2;return Math.round(y/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(H){if(!this._computedIsNeeded)return 0;const y=H-this._arrowSize;let v=this._scrollPosition;return y<this._computedSliderPosition?v-=this._visibleSize:v+=this._visibleSize,v}getDesiredScrollPositionFromDelta(H){if(!this._computedIsNeeded)return 0;const y=this._computedSliderPosition+H;return Math.round(y/this._computedSliderRatio)}}t.ScrollbarState=i}),define(pe[23],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var w;(function(v){v[v.Hidden=0]="Hidden",v[v.Visible=1]="Visible",v[v.Recurse=2]="Recurse"})(w=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(v){v[v.Unknown=0]="Unknown",v[v.Twistie=1]="Twistie",v[v.Element=2]="Element",v[v.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var B;(function(v){v[v.Down=0]="Down",v[v.Up=1]="Up"})(B=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(v=!1){return{accept:!0,bubble:0,autoExpand:v}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(v=!1){return{accept:!0,bubble:0,effect:0,autoExpand:v}}};class H extends Error{constructor(h,g){super(`TreeError [${h}] ${g}`)}}t.TreeError=H;class y{constructor(h){this.fn=h,this._map=new WeakMap}map(h){let g=this._map.get(h);return g||(g=this.fn(h),this._map.set(h,g)),g}}t.WeakMapper=y}),define(pe[12],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function w(y){return y?y.replace(/\$\((.*?)\)/g,(v,h)=>` ${h} `).trim():""}t.getCodiconAriaLabel=w;class i{constructor(v,h,g){this.id=v,this.definition=h,this.description=g,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function B(y,v){const h=["codicon","codicon-"+y];return v&&h.push("codicon-modifier-"+v),h}t.getClassNamesArray=B;var H;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function h(I){if(I instanceof i)return["codicon","codicon-"+I.id];const o=v.exec(I.id);if(!o)return h(i.error);const[,n,e]=o,r=["codicon","codicon-"+n];return e&&r.push("codicon-modifier-"+e.substr(1)),r}y.asClassNameArray=h;function g(I){return h(I).join(" ")}y.asClassName=g;function f(I){return"."+h(I).join(".")}y.asCSSSelector=f})(H=t.CSSIcon||(t.CSSIcon={}))}),define(pe[69],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function w(y,v){const h=Object.create(null);for(const g of y){const f=v(g);let I=h[f];I||(I=h[f]=[]),I.push(g)}return h}t.groupBy=w;function i(y,v){const h=[],g=[];for(const f of y)v.has(f)||h.push(f);for(const f of v)y.has(f)||g.push(f);return{removed:h,added:g}}t.diffSets=i;function B(y,v){const h=[],g=[];for(const[f,I]of y)v.has(f)||h.push(I);for(const[f,I]of v)y.has(f)||g.push(I);return{removed:h,added:g}}t.diffMaps=B;class H{constructor(){this.map=new Map}add(v,h){let g=this.map.get(v);g||(g=new Set,this.map.set(v,g)),g.add(h)}delete(v,h){const g=this.map.get(v);!g||(g.delete(h),g.size===0&&this.map.delete(v))}forEach(v,h){const g=this.map.get(v);!g||g.forEach(h)}}t.SetMap=H}),define(pe[24],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function w(v,h){const g=Math.pow(10,h);return Math.round(v*g)/g}class i{constructor(h,g,f,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=w(Math.max(Math.min(1,I),0),3)}static equals(h,g){return h.r===g.r&&h.g===g.g&&h.b===g.b&&h.a===g.a}}t.RGBA=i;class B{constructor(h,g,f,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=w(Math.max(Math.min(1,g),0),3),this.l=w(Math.max(Math.min(1,f),0),3),this.a=w(Math.max(Math.min(1,I),0),3)}static equals(h,g){return h.h===g.h&&h.s===g.s&&h.l===g.l&&h.a===g.a}static fromRGBA(h){const g=h.r/255,f=h.g/255,I=h.b/255,o=h.a,n=Math.max(g,f,I),e=Math.min(g,f,I);let r=0,a=0;const c=(e+n)/2,m=n-e;if(m>0){switch(a=Math.min(c<=.5?m/(2*c):m/(2-2*c),1),n){case g:r=(f-I)/m+(f<I?6:0);break;case f:r=(I-g)/m+2;break;case I:r=(g-f)/m+4;break}r*=60,r=Math.round(r)}return new B(r,a,c,o)}static _hue2rgb(h,g,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?h+(g-h)*6*f:f<1/2?g:f<2/3?h+(g-h)*(2/3-f)*6:h}static toRGBA(h){const g=h.h/360,{s:f,l:I,a:o}=h;let n,e,r;if(f===0)n=e=r=I;else{const a=I<.5?I*(1+f):I+f-I*f,c=2*I-a;n=B._hue2rgb(c,a,g+1/3),e=B._hue2rgb(c,a,g),r=B._hue2rgb(c,a,g-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(r*255),o)}}t.HSLA=B;class H{constructor(h,g,f,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=w(Math.max(Math.min(1,g),0),3),this.v=w(Math.max(Math.min(1,f),0),3),this.a=w(Math.max(Math.min(1,I),0),3)}static equals(h,g){return h.h===g.h&&h.s===g.s&&h.v===g.v&&h.a===g.a}static fromRGBA(h){const g=h.r/255,f=h.g/255,I=h.b/255,o=Math.max(g,f,I),n=Math.min(g,f,I),e=o-n,r=o===0?0:e/o;let a;return e===0?a=0:o===g?a=((f-I)/e%6+6)%6:o===f?a=(I-g)/e+2:a=(g-f)/e+4,new H(Math.round(a*60),r,o,h.a)}static toRGBA(h){const{h:g,s:f,v:I,a:o}=h,n=I*f,e=n*(1-Math.abs(g/60%2-1)),r=I-n;let[a,c,m]=[0,0,0];return g<60?(a=n,c=e):g<120?(a=e,c=n):g<180?(c=n,m=e):g<240?(c=e,m=n):g<300?(a=e,m=n):g<=360&&(a=n,m=e),a=Math.round((a+r)*255),c=Math.round((c+r)*255),m=Math.round((m+r)*255),new i(a,c,m,o)}}t.HSVA=H;class y{static fromHex(h){return y.Format.CSS.parseHex(h)||y.red}static equals(h,g){return!h&&!g?!0:!h||!g?!1:h.equals(g)}get hsla(){return this._hsla?this._hsla:B.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:H.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof i)this.rgba=h;else if(h instanceof B)this._hsla=h,this.rgba=B.toRGBA(h);else if(h instanceof H)this._hsva=h,this.rgba=H.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&i.equals(this.rgba,h.rgba)&&B.equals(this.hsla,h.hsla)&&H.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=y._relativeLuminanceForComponent(this.rgba.r),g=y._relativeLuminanceForComponent(this.rgba.g),f=y._relativeLuminanceForComponent(this.rgba.b),I=.2126*h+.7152*g+.0722*f;return w(I,4)}static _relativeLuminanceForComponent(h){const g=h/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(h){const g=this.getRelativeLuminance(),f=h.getRelativeLuminance();return g>f?(g+.05)/(f+.05):(f+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const g=this.getRelativeLuminance(),f=h.getRelativeLuminance();return g>f}isDarkerThan(h){const g=this.getRelativeLuminance(),f=h.getRelativeLuminance();return g<f}lighten(h){return new y(new B(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new y(new B(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:g,g:f,b:I,a:o}=this.rgba;return new y(new i(g,f,I,o*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const g=h.rgba,f=this.rgba.a,I=g.a,o=f+I*(1-f);if(o<1e-6)return y.transparent;const n=this.rgba.r*f/o+g.r*I*(1-f)/o,e=this.rgba.g*f/o+g.g*I*(1-f)/o,r=this.rgba.b*f/o+g.b*I*(1-f)/o;return new y(new i(n,e,r,o))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:g,g:f,b:I,a:o}=this.rgba;return new y(new i(h.rgba.r-o*(h.rgba.r-g),h.rgba.g-o*(h.rgba.g-f),h.rgba.b-o*(h.rgba.b-I),1))}flatten(...h){const g=h.reduceRight((f,I)=>y._flatten(I,f));return y._flatten(this,g)}static _flatten(h,g){const f=1-h.rgba.a;return new y(new i(f*g.rgba.r+h.rgba.a*h.rgba.r,f*g.rgba.g+h.rgba.a*h.rgba.g,f*g.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=y.Format.CSS.format(this)),this._toString}static getLighterColor(h,g,f){if(h.isLighterThan(g))return h;f=f||.5;const I=h.getRelativeLuminance(),o=g.getRelativeLuminance();return f=f*(o-I)/o,h.lighten(f)}static getDarkerColor(h,g,f){if(h.isDarkerThan(g))return h;f=f||.5;const I=h.getRelativeLuminance(),o=g.getRelativeLuminance();return f=f*(I-o)/I,h.darken(f)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(v){let h;(function(g){let f;(function(I){function o(_){return _.rgba.a===1?`rgb(${_.rgba.r}, ${_.rgba.g}, ${_.rgba.b})`:v.Format.CSS.formatRGBA(_)}I.formatRGB=o;function n(_){return`rgba(${_.rgba.r}, ${_.rgba.g}, ${_.rgba.b}, ${+_.rgba.a.toFixed(2)})`}I.formatRGBA=n;function e(_){return _.hsla.a===1?`hsl(${_.hsla.h}, ${(_.hsla.s*100).toFixed(2)}%, ${(_.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(_)}I.formatHSL=e;function r(_){return`hsla(${_.hsla.h}, ${(_.hsla.s*100).toFixed(2)}%, ${(_.hsla.l*100).toFixed(2)}%, ${_.hsla.a.toFixed(2)})`}I.formatHSLA=r;function a(_){const L=_.toString(16);return L.length!==2?"0"+L:L}function c(_){return`#${a(_.rgba.r)}${a(_.rgba.g)}${a(_.rgba.b)}`}I.formatHex=c;function m(_,L=!1){return L&&_.rgba.a===1?v.Format.CSS.formatHex(_):`#${a(_.rgba.r)}${a(_.rgba.g)}${a(_.rgba.b)}${a(Math.round(_.rgba.a*255))}`}I.formatHexA=m;function s(_){return _.isOpaque()?v.Format.CSS.formatHex(_):v.Format.CSS.formatRGBA(_)}I.format=s;function l(_){const L=_.length;if(L===0||_.charCodeAt(0)!==35)return null;if(L===7){const S=16*p(_.charCodeAt(1))+p(_.charCodeAt(2)),A=16*p(_.charCodeAt(3))+p(_.charCodeAt(4)),u=16*p(_.charCodeAt(5))+p(_.charCodeAt(6));return new v(new i(S,A,u,1))}if(L===9){const S=16*p(_.charCodeAt(1))+p(_.charCodeAt(2)),A=16*p(_.charCodeAt(3))+p(_.charCodeAt(4)),u=16*p(_.charCodeAt(5))+p(_.charCodeAt(6)),E=16*p(_.charCodeAt(7))+p(_.charCodeAt(8));return new v(new i(S,A,u,E/255))}if(L===4){const S=p(_.charCodeAt(1)),A=p(_.charCodeAt(2)),u=p(_.charCodeAt(3));return new v(new i(16*S+S,16*A+A,16*u+u))}if(L===5){const S=p(_.charCodeAt(1)),A=p(_.charCodeAt(2)),u=p(_.charCodeAt(3)),E=p(_.charCodeAt(4));return new v(new i(16*S+S,16*A+A,16*u+u,(16*E+E)/255))}return null}I.parseHex=l;function p(_){switch(_){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=g.CSS||(g.CSS={}))})(h=v.Format||(v.Format={}))}(y=t.Color||(t.Color={}))}),define(pe[25],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function w(y){return(v,h,g)=>{let f=null,I=null;if(typeof g.value=="function"?(f="value",I=g.value):typeof g.get=="function"&&(f="get",I=g.get),!I)throw new Error("not supported");g[f]=y(I,h)}}t.createDecorator=w;function i(y,v,h){let g=null,f=null;if(typeof h.value=="function"?(g="value",f=h.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(g="get",f=h.get),!f)throw new Error("not supported");const I=`$memoize$${v}`;h[g]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,o)}),this[I]}}t.memoize=i;function B(y,v,h){return w((g,f)=>{const I=`$debounce$${f}`,o=`$debounce$result$${f}`;return function(...n){this[o]||(this[o]=h?h():void 0),clearTimeout(this[I]),v&&(this[o]=v(this[o],...n),n=[this[o]]),this[I]=setTimeout(()=>{g.apply(this,n),this[o]=h?h():void 0},y)}})}t.debounce=B;function H(y,v,h){return w((g,f)=>{const I=`$throttle$timer$${f}`,o=`$throttle$result$${f}`,n=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...r){if(this[o]||(this[o]=h?h():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),v&&(this[o]=v(this[o],...r)),this[e])return;const a=this[n]+y;a<=Date.now()?(this[n]=Date.now(),g.apply(this,[this[o]]),this[o]=h?h():void 0):(this[e]=!0,this[I]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),g.apply(this,[this[o]]),this[o]=h?h():void 0},a-Date.now()))}})}t.throttle=H}),define(pe[70],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class w{constructor(B,H,y,v){this.originalStart=B,this.originalLength=H,this.modifiedStart=y,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=w}),define(pe[9],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(_){setTimeout(()=>{throw _.stack?s.isErrorNoTelemetry(_)?new s(_.message+`

`+_.stack):new Error(_.message+`

`+_.stack):_},0)}}addListener(_){return this.listeners.push(_),()=>{this._removeListener(_)}}emit(_){this.listeners.forEach(L=>{L(_)})}_removeListener(_){this.listeners.splice(this.listeners.indexOf(_),1)}setUnexpectedErrorHandler(_){this.unexpectedErrorHandler=_}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(_){this.unexpectedErrorHandler(_),this.emit(_)}onUnexpectedExternalError(_){this.unexpectedErrorHandler(_)}}t.ErrorHandler=w,t.errorHandler=new w;function i(p){t.errorHandler.setUnexpectedErrorHandler(p)}t.setUnexpectedErrorHandler=i;function B(p){h(p)||t.errorHandler.onUnexpectedError(p)}t.onUnexpectedError=B;function H(p){h(p)||t.errorHandler.onUnexpectedExternalError(p)}t.onUnexpectedExternalError=H;function y(p){if(p instanceof Error){const{name:_,message:L}=p,S=p.stacktrace||p.stack;return{$isError:!0,name:_,message:L,stack:S,noTelemetry:s.isErrorNoTelemetry(p)}}return p}t.transformErrorForSerialization=y;const v="Canceled";function h(p){return p instanceof g?!0:p instanceof Error&&p.name===v&&p.message===v}t.isCancellationError=h;class g extends Error{constructor(){super(v),this.name=this.message}}t.CancellationError=g;function f(){const p=new Error(v);return p.name=p.message,p}t.canceled=f;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}t.illegalArgument=I;function o(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}t.illegalState=o;function n(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(p){const _=new Error(`${p} has been disposed`);return _.name="DISPOSED",_}t.disposed=e;function r(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}t.getErrorMessage=r;class a extends Error{constructor(_){super("NotImplemented"),_&&(this.message=_)}}t.NotImplementedError=a;class c extends Error{constructor(_){super("NotSupported"),_&&(this.message=_)}}t.NotSupportedError=c;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=m;class s extends Error{constructor(_){super(_),this.name="CodeExpectedError"}static fromError(_){if(_ instanceof s)return _;const L=new s;return L.message=_.message,L.stack=_.stack,L}static isErrorNoTelemetry(_){return _.name==="CodeExpectedError"}}t.ErrorNoTelemetry=s;class l extends Error{constructor(_){super(_||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype);debugger}}t.BugIndicatingError=l}),define(pe[14],be([1,0,9]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(N,R=0){return N[N.length-(1+R)]}t.tail=i;function B(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}t.tail2=B;function H(N,R,W=(C,k)=>C===k){if(N===R)return!0;if(!N||!R||N.length!==R.length)return!1;for(let C=0,k=N.length;C<k;C++)if(!W(N[C],R[C]))return!1;return!0}t.equals=H;function y(N,R){const W=N.length-1;R<W&&(N[R]=N[W]),N.pop()}t.removeFastWithoutKeepingOrder=y;function v(N,R,W){return h(N.length,C=>W(N[C],R))}t.binarySearch=v;function h(N,R){let W=0,C=N-1;for(;W<=C;){const k=(W+C)/2|0,M=R(k);if(M<0)W=k+1;else if(M>0)C=k-1;else return k}return-(W+1)}t.binarySearch2=h;function g(N,R){let W=0,C=N.length;if(C===0)return 0;for(;W<C;){const k=Math.floor((W+C)/2);R(N[k])?C=k:W=k+1}return W}t.findFirstInSorted=g;function f(N,R,W){if(N=N|0,N>=R.length)throw new TypeError("invalid index");const C=R[Math.floor(R.length*Math.random())],k=[],M=[],O=[];for(const K of R){const J=W(K,C);J<0?k.push(K):J>0?M.push(K):O.push(K)}return N<k.length?f(N,k,W):N<k.length+O.length?O[0]:f(N-(k.length+O.length),M,W)}t.quickSelect=f;function I(N,R){const W=[];let C;for(const k of N.slice(0).sort(R))!C||R(C[0],k)!==0?(C=[k],W.push(C)):C.push(k);return W}t.groupBy=I;function o(N,R,W){const C=[];function k(K,J,ue){if(J===0&&ue.length===0)return;const he=C[C.length-1];he&&he.start+he.deleteCount===K?(he.deleteCount+=J,he.toInsert.push(...ue)):C.push({start:K,deleteCount:J,toInsert:ue})}let M=0,O=0;for(;;){if(M===N.length){k(M,0,R.slice(O));break}if(O===R.length){k(M,N.length-M,[]);break}const K=N[M],J=R[O],ue=W(K,J);ue===0?(M+=1,O+=1):ue<0?(k(M,1,[]),M+=1):ue>0&&(k(M,0,[J]),O+=1)}return C}t.sortedDiff=o;function n(N,R,W){const C=o(N,R,W),k=[],M=[];for(const O of C)k.push(...N.slice(O.start,O.start+O.deleteCount)),M.push(...O.toInsert);return{removed:k,added:M}}t.delta=n;function e(N,R,W){if(W===0)return[];const C=N.slice(0,W).sort(R);return a(N,R,C,W,N.length),C}t.top=e;function r(N,R,W,C,k){return W===0?Promise.resolve([]):new Promise((M,O)=>{(async()=>{const K=N.length,J=N.slice(0,W).sort(R);for(let ue=W,he=Math.min(W+C,K);ue<K;ue=he,he=Math.min(he+C,K)){if(ue>W&&await new Promise(De=>setTimeout(De)),k&&k.isCancellationRequested)throw new w.CancellationError;a(N,R,J,ue,he)}return J})().then(M,O)})}t.topAsync=r;function a(N,R,W,C,k){for(const M=W.length;C<k;C++){const O=N[C];if(R(O,W[M-1])<0){W.pop();const K=g(W,J=>R(O,J)<0);W.splice(K,0,O)}}}function c(N){return N.filter(R=>!!R)}t.coalesce=c;function m(N){let R=0;for(let W=0;W<N.length;W++)N[W]&&(N[R]=N[W],R+=1);N.length=R}t.coalesceInPlace=m;function s(N,R,W){N.splice(W,0,N.splice(R,1)[0])}t.move=s;function l(N){return!Array.isArray(N)||N.length===0}t.isFalsyOrEmpty=l;function p(N){return Array.isArray(N)&&N.length>0}t.isNonEmptyArray=p;function _(N,R=W=>W){const W=new Set;return N.filter(C=>{const k=R(C);return W.has(k)?!1:(W.add(k),!0)})}t.distinct=_;function L(N){const R=new Set;return W=>{const C=N(W);return R.has(C)?!1:(R.add(C),!0)}}t.uniqueFilter=L;function S(N,R){const W=A(N,R);if(W!==-1)return N[W]}t.findLast=S;function A(N,R){for(let W=N.length-1;W>=0;W--){const C=N[W];if(R(C))return W}return-1}t.lastIndex=A;function u(N,R){return N.length>0?N[0]:R}t.firstOrDefault=u;function E(N,R){return N.length>0?N[N.length-1]:R}t.lastOrDefault=E;function b(N,R,W=(C,k)=>C===k){let C=0;for(let k=0,M=Math.min(N.length,R.length);k<M&&W(N[k],R[k]);k++)C++;return C}t.commonPrefixLength=b;function D(N){return[].concat(...N)}t.flatten=D;function z(N,R){let W=typeof R=="number"?N:0;typeof R=="number"?W=N:(W=0,R=N);const C=[];if(W<=R)for(let k=W;k<R;k++)C.push(k);else for(let k=W;k>R;k--)C.push(k);return C}t.range=z;function x(N,R,W){return N.reduce((C,k)=>(C[R(k)]=W?W(k):k,C),Object.create(null))}t.index=x;function ie(N,R){return N.push(R),()=>Q(N,R)}t.insert=ie;function Q(N,R){const W=N.indexOf(R);if(W>-1)return N.splice(W,1),R}t.remove=Q;function me(N,R,W){const C=N.slice(0,R),k=N.slice(R);return C.concat(W,k)}t.arrayInsert=me;function ae(N,R){let W;if(typeof R=="number"){let C=R;W=()=>{const k=Math.sin(C++)*179426549;return k-Math.floor(k)}}else W=Math.random;for(let C=N.length-1;C>0;C-=1){const k=Math.floor(W()*(C+1)),M=N[C];N[C]=N[k],N[k]=M}}t.shuffle=ae;function fe(N,R){const W=N.indexOf(R);W>-1&&(N.splice(W,1),N.unshift(R))}t.pushToStart=fe;function le(N,R){const W=N.indexOf(R);W>-1&&(N.splice(W,1),N.push(R))}t.pushToEnd=le;function de(N,R){for(const W of R)N.push(W)}t.pushMany=de;function Se(N,R){return Array.isArray(N)?N.map(R):R(N)}t.mapArrayOrNot=Se;function ee(N){return Array.isArray(N)?N:[N]}t.asArray=ee;function ye(N){return N[Math.floor(Math.random()*N.length)]}t.getRandomElement=ye;function se(N,R){for(const W of N){const C=R(W);if(C!==void 0)return C}}t.mapFind=se;function te(N,R,W){const C=ne(N,R),k=N.length,M=W.length;N.length=k+M;for(let O=k-1;O>=C;O--)N[O+M]=N[O];for(let O=0;O<M;O++)N[O+C]=W[O]}t.insertInto=te;function ce(N,R,W,C){const k=ne(N,R),M=N.splice(k,W);return te(N,k,C),M}t.splice=ce;function ne(N,R){return R<0?Math.max(R+N.length,0):Math.min(R,N.length)}var T;(function(N){function R(k){return k<0}N.isLessThan=R;function W(k){return k>0}N.isGreaterThan=W;function C(k){return k===0}N.isNeitherLessOrGreaterThan=C,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(T=t.CompareResult||(t.CompareResult={}));function V(N,R){return(W,C)=>R(N(W),N(C))}t.compareBy=V;function j(...N){return(R,W)=>{for(const C of N){const k=C(R,W);if(!T.isNeitherLessOrGreaterThan(k))return k}return T.neitherLessOrGreaterThan}}t.tieBreakComparators=j;const P=(N,R)=>N-R;t.numberComparator=P;function d(N,R){if(N.length===0)return;let W=N[0];for(let C=1;C<N.length;C++){const k=N[C];R(k,W)>0&&(W=k)}return W}t.findMaxBy=d;function F(N,R){if(N.length===0)return;let W=N[0];for(let C=1;C<N.length;C++){const k=N[C];R(k,W)>=0&&(W=k)}return W}t.findLastMaxBy=F;function U(N,R){return d(N,(W,C)=>-R(W,C))}t.findMinBy=U;class ${constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let W=this.firstIdx;for(;W<this.items.length&&R(this.items[W]);)W++;const C=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,C}takeFromEndWhile(R){let W=this.lastIdx;for(;W>=0&&R(this.items[W]);)W--;const C=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,C}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const R=this.items[this.firstIdx];return this.firstIdx++,R}removeLast(){const R=this.items[this.lastIdx];return this.lastIdx--,R}takeCount(R){const W=this.items.slice(this.firstIdx,this.firstIdx+R);return this.firstIdx+=R,W}}t.ArrayQueue=$;class X{constructor(R){this.iterate=R}forEach(R){this.iterate(W=>(R(W),!0))}toArray(){const R=[];return this.iterate(W=>(R.push(W),!0)),R}filter(R){return new X(W=>this.iterate(C=>R(C)?W(C):!0))}map(R){return new X(W=>this.iterate(C=>W(R(C))))}some(R){let W=!1;return this.iterate(C=>(W=R(C),!W)),W}findFirst(R){let W;return this.iterate(C=>R(C)?(W=C,!1):!0),W}findLast(R){let W;return this.iterate(C=>(R(C)&&(W=C),!0)),W}findLastMaxBy(R){let W,C=!0;return this.iterate(k=>((C||T.isGreaterThan(R(k,W)))&&(C=!1,W=k),!0)),W}}t.CallbackIterable=X,X.empty=new X(N=>{})}),define(pe[71],be([1,0,9]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(h,g){if(!h)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}t.ok=i;function B(h,g="Unreachable"){throw new Error(g)}t.assertNever=B;function H(h){if(!h)throw new w.BugIndicatingError("Assertion Failed")}t.assert=H;function y(h){if(!h()){debugger;h(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function v(h,g){let f=0;for(;f<h.length-1;){const I=h[f],o=h[f+1];if(!g(I,o))return!1;f++}return!0}t.checkAdjacentItems=v}),define(pe[42],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function w(i){const B=this;let H=!1,y;return function(){return H||(H=!0,y=i.apply(B,arguments)),y}}t.once=w}),define(pe[72],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class w{constructor(B){this._prefix=B,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=w,t.defaultGenerator=new w("id#")}),define(pe[26],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var w;(function(i){function B(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}i.is=B;const H=Object.freeze([]);function y(){return H}i.empty=y;function*v(s){yield s}i.single=v;function h(s){return s||H}i.from=h;function g(s){return!s||s[Symbol.iterator]().next().done===!0}i.isEmpty=g;function f(s){return s[Symbol.iterator]().next().value}i.first=f;function I(s,l){for(const p of s)if(l(p))return!0;return!1}i.some=I;function o(s,l){for(const p of s)if(l(p))return p}i.find=o;function*n(s,l){for(const p of s)l(p)&&(yield p)}i.filter=n;function*e(s,l){let p=0;for(const _ of s)yield l(_,p++)}i.map=e;function*r(...s){for(const l of s)for(const p of l)yield p}i.concat=r;function a(s,l,p){let _=p;for(const L of s)_=l(_,L);return _}i.reduce=a;function*c(s,l,p=s.length){for(l<0&&(l+=s.length),p<0?p+=s.length:p>s.length&&(p=s.length);l<p;l++)yield s[l]}i.slice=c;function m(s,l=Number.POSITIVE_INFINITY){const p=[];if(l===0)return[p,s];const _=s[Symbol.iterator]();for(let L=0;L<l;L++){const S=_.next();if(S.done)return[p,i.empty()];p.push(S.value)}return[p,{[Symbol.iterator](){return _}}]}i.consume=m})(w=t.Iterable||(t.Iterable={}))}),define(pe[43],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var w;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(w=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(r,a){this._keyCodeToStr[r]=a,this._strToKeyCode[a.toLowerCase()]=r}keyCodeToStr(r){return this._keyCodeToStr[r]}strToKeyCode(r){return this._strToKeyCode[r.toLowerCase()]||0}}const H=new B,y=new B,v=new B;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],g=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>g[e]||0,toString:e=>h[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",r=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],a=[],c=[];for(const m of r){const[s,l,p,_,L,S,A,u,E,b]=m;if(c[p]||(c[p]=!0,h[p]=_,g[_]=p,f[_.toLowerCase()]=p,l&&(t.IMMUTABLE_CODE_TO_KEY_CODE[p]=L,L!==0&&L!==3&&L!==5&&L!==4&&L!==6&&L!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[L]=p))),!a[L]){if(a[L]=!0,!S)throw new Error(`String representation missing for key code ${L} around scan code ${_}`);H.define(L,S),y.define(L,E||S),v.define(L,b||E||S)}A&&(t.EVENT_KEY_CODE_MAP[A]=L),u&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[u]=L)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(e){function r(p){return H.keyCodeToStr(p)}e.toString=r;function a(p){return H.strToKeyCode(p)}e.fromString=a;function c(p){return y.keyCodeToStr(p)}e.toUserSettingsUS=c;function m(p){return v.keyCodeToStr(p)}e.toUserSettingsGeneral=m;function s(p){return y.strToKeyCode(p)||v.strToKeyCode(p)}e.fromUserSettings=s;function l(p){if(p>=93&&p<=108)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(p)}e.toElectronAccelerator=l})(I=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function n(e,r){const a=(r&65535)<<16>>>0;return(e|a)>>>0}t.KeyChord=n}),define(pe[73],be([1,0,9]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(i||(i={}));function B(I,o){if(I===0)return null;const n=(I&65535)>>>0,e=(I&4294901760)>>>16;return e!==0?new v([H(n,o),H(e,o)]):new v([H(n,o)])}t.createKeybinding=B;function H(I,o){const n=!!(I&2048),e=!!(I&256),r=o===2?e:n,a=!!(I&1024),c=!!(I&512),m=o===2?n:e,s=I&255;return new y(r,a,c,m,s)}t.createSimpleKeybinding=H;class y{constructor(o,n,e,r,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=r,this.keyCode=a}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",r=this.metaKey?"1":"0";return`${o}${n}${e}${r}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new v([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class v{constructor(o){if(o.length===0)throw(0,w.illegalArgument)("parts");this.parts=o}getHashCode(){let o="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(o+=";"),o+=this.parts[n].getHashCode();return o}equals(o){if(o===null||this.parts.length!==o.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(o.parts[n]))return!1;return!0}}t.ChordKeybinding=v;class h{constructor(o,n,e,r,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=r,this.scanCode=a}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=h;class g{constructor(o,n,e,r,a,c){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=r,this.keyLabel=a,this.keyAriaLabel=c}}t.ResolvedKeybindingPart=g;class f{}t.ResolvedKeybinding=f}),define(pe[44],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class w{constructor(B){this.executor=B,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(B){this._error=B}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(B){return new w(()=>B(this.getValue()))}}t.Lazy=w}),define(pe[2],be([1,0,42,26]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const B=!1;let H=null;function y(E){H=E}if(t.setDisposableTracker=y,B){const E="__is_disposable_tracked__";y(new class{trackDisposable(b){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[E]||console.log(D)},3e3)}setParent(b,D){if(b&&b!==m.None)try{b[E]=!0}catch{}}markAsDisposed(b){if(b&&b!==m.None)try{b[E]=!0}catch{}}markAsSingleton(b){}})}function v(E){return H?.trackDisposable(E),E}function h(E){H?.markAsDisposed(E)}function g(E,b){H?.setParent(E,b)}function f(E,b){if(!!H)for(const D of E)H.setParent(D,b)}function I(E){return H?.markAsSingleton(E),E}t.markAsSingleton=I;function o(E){return typeof E.dispose=="function"&&E.dispose.length===0}t.isDisposable=o;function n(E){if(i.Iterable.is(E)){const b=[];for(const D of E)if(D)try{D.dispose()}catch(z){b.push(z)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}t.dispose=n;function e(E){for(const b of E)o(b)&&b.dispose();return[]}t.disposeIfDisposable=e;function r(...E){const b=a(()=>n(E));return f(E,b),b}t.combinedDisposable=r;function a(E){const b=v({dispose:(0,w.once)(()=>{h(b),E()})});return b}t.toDisposable=a;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{n(this._toDispose)}finally{this._toDispose.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return g(b,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(b),b}}t.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new c,v(this),g(this._store,this)}dispose(){h(this),this._store.dispose()}_register(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(b)}}t.Disposable=m,m.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(b){this._isDisposed||b===this._value||(this._value?.dispose(),b&&g(b,this),this._value=b)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const b=this._value;return this._value=void 0,b&&g(b,null),b}}t.MutableDisposable=s;class l{constructor(b){this._disposable=b,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=l;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(b){let D=b;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,h(this))},this}}t.SafeDisposable=p;class _{constructor(){this.references=new Map}acquire(b,...D){let z=this.references.get(b);z||(z={counter:0,object:this.createReferencedObject(b,...D)},this.references.set(b,z));const{object:x}=z,ie=(0,w.once)(()=>{--z.counter===0&&(this.destroyReferencedObject(b,z.object),this.references.delete(b))});return z.counter++,{object:x,dispose:ie}}}t.ReferenceCollection=_;class L{constructor(b){this.referenceCollection=b}async acquire(b,...D){const z=this.referenceCollection.acquire(b,...D);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(x){throw z.dispose(),x}}}t.AsyncReferenceCollection=L;class S{constructor(b){this.object=b}dispose(){}}t.ImmortalReference=S;function A(E){const b=new c;try{E(b)}finally{b.dispose()}}t.disposeOnReturn=A;class u{constructor(){this._store=new Map,this._isDisposed=!1,v(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{n(this._store.values())}finally{this._store.clear()}}has(b){return this._store.has(b)}get(b){return this._store.get(b)}set(b,D,z=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this._store.get(b)?.dispose(),this._store.set(b,D)}deleteAndDispose(b){this._store.get(b)?.dispose(),this._store.delete(b)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=u}),define(pe[45],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class w{constructor(H){this.element=H,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class i{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let H=this._first;for(;H!==w.Undefined;){const y=H.next;H.prev=w.Undefined,H.next=w.Undefined,H=y}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(H){return this._insert(H,!1)}push(H){return this._insert(H,!0)}_insert(H,y){const v=new w(H);if(this._first===w.Undefined)this._first=v,this._last=v;else if(y){const g=this._last;this._last=v,v.prev=g,g.next=v}else{const g=this._first;this._first=v,v.next=g,g.prev=v}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(v))}}shift(){if(this._first!==w.Undefined){const H=this._first.element;return this._remove(this._first),H}}pop(){if(this._last!==w.Undefined){const H=this._last.element;return this._remove(this._last),H}}_remove(H){if(H.prev!==w.Undefined&&H.next!==w.Undefined){const y=H.prev;y.next=H.next,H.next.prev=y}else H.prev===w.Undefined&&H.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):H.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):H.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let H=this._first;for(;H!==w.Undefined;)yield H.element,H=H.next}}t.LinkedList=i}),define(pe[74],be([1,0]),function(Z,t){"use strict";var w,i,B;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function H(e,r,a){let c=e.get(r);return c===void 0&&(c=a,e.set(r,c)),c}t.getOrSet=H;function y(e){const r=[];return e.forEach((a,c)=>{r.push(`${c} => ${a}`)}),`Map(${e.size}) {${r.join(", ")}}`}t.mapToString=y;function v(e){const r=[];return e.forEach(a=>{r.push(a)}),`Set(${e.size}) {${r.join(", ")}}`}t.setToString=v;class h{constructor(r,a){this.uri=r,this.value=a}}class g{constructor(r,a){this[w]="ResourceMap",r instanceof g?(this.map=new Map(r.map),this.toKey=a??g.defaultToKey):(this.map=new Map,this.toKey=r??g.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),new h(r,a)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a<"u"&&(r=r.bind(a));for(const[c,m]of this.map)r(m.value,m.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=g,g.defaultToKey=e=>e.toString();class f{constructor(r,a){this[i]="ResourceSet",!r||typeof r=="function"?this._map=new g(r):(this._map=new g(a),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,a){this._map.forEach((c,m)=>r.call(a,m,m,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=f;var I;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(I=t.Touch||(t.Touch={}));class o{constructor(){this[B]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const c=this._map.get(r);if(!!c)return a!==0&&this.touch(c,a),c.value}set(r,a,c=0){let m=this._map.get(r);if(m)m.value=a,c!==0&&this.touch(m,c);else{switch(m={key:r,value:a,next:void 0,previous:void 0},c){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const c=this._state;let m=this._head;for(;m;){if(a?r.bind(a)(m.value,m.key,this):r(m.value,m.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,a=this._state;let c=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const s={value:c.key,done:!1};return c=c.next,s}else return{value:void 0,done:!0}}};return m}values(){const r=this,a=this._state;let c=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const s={value:c.value,done:!1};return c=c.next,s}else return{value:void 0,done:!0}}};return m}entries(){const r=this,a=this._state;let c=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const s={value:[c.key,c.value],done:!1};return c=c.next,s}else return{value:void 0,done:!0}}};return m}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,c=this.size;for(;a&&c>r;)this._map.delete(a.key),a=a.next,c--;this._head=a,this._size=c,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,c=r.previous;if(!a||!c)throw new Error("Invalid list");a.previous=c,c.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const c=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(c.previous=m,m.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const c=r.next,m=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=m,m.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,c)=>{r.push([c,a])}),r}fromJSON(r){this.clear();for(const[a,c]of r)this.set(a,c)}}t.LinkedMap=o;class n extends o{constructor(r,a=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=n}),function(Z,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(pe[75],be([0]),t):(Z=typeof globalThis<"u"?globalThis:Z||self,t(Z.marked={}))}(this,function(Z){"use strict";function t(N,R){for(var W=0;W<R.length;W++){var C=R[W];C.enumerable=C.enumerable||!1,C.configurable=!0,"value"in C&&(C.writable=!0),Object.defineProperty(N,C.key,C)}}function w(N,R,W){return R&&t(N.prototype,R),W&&t(N,W),Object.defineProperty(N,"prototype",{writable:!1}),N}function i(N,R){if(!!N){if(typeof N=="string")return B(N,R);var W=Object.prototype.toString.call(N).slice(8,-1);if(W==="Object"&&N.constructor&&(W=N.constructor.name),W==="Map"||W==="Set")return Array.from(N);if(W==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(W))return B(N,R)}}function B(N,R){(R==null||R>N.length)&&(R=N.length);for(var W=0,C=new Array(R);W<R;W++)C[W]=N[W];return C}function H(N,R){var W=typeof Symbol<"u"&&N[Symbol.iterator]||N["@@iterator"];if(W)return(W=W.call(N)).next.bind(W);if(Array.isArray(N)||(W=i(N))||R&&N&&typeof N.length=="number"){W&&(N=W);var C=0;return function(){return C>=N.length?{done:!0}:{done:!1,value:N[C++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=y();function v(N){Z.defaults=N}var h=/[&<>"']/,g=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(R){return o[R]};function e(N,R){if(R){if(h.test(N))return N.replace(g,n)}else if(f.test(N))return N.replace(I,n);return N}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(N){return N.replace(r,function(R,W){return W=W.toLowerCase(),W==="colon"?":":W.charAt(0)==="#"?W.charAt(1)==="x"?String.fromCharCode(parseInt(W.substring(2),16)):String.fromCharCode(+W.substring(1)):""})}var c=/(^|[^\[])\^/g;function m(N,R){N=typeof N=="string"?N:N.source,R=R||"";var W={replace:function(k,M){return M=M.source||M,M=M.replace(c,"$1"),N=N.replace(k,M),W},getRegex:function(){return new RegExp(N,R)}};return W}var s=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(N,R,W){if(N){var C;try{C=decodeURIComponent(a(W)).replace(s,"").toLowerCase()}catch{return null}if(C.indexOf("javascript:")===0||C.indexOf("vbscript:")===0||C.indexOf("data:")===0)return null}R&&!l.test(W)&&(W=u(R,W));try{W=encodeURI(W).replace(/%25/g,"%")}catch{return null}return W}var _={},L=/^[^:]+:\/*[^/]*$/,S=/^([^:]+:)[\s\S]*$/,A=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(N,R){_[" "+N]||(L.test(N)?_[" "+N]=N+"/":_[" "+N]=z(N,"/",!0)),N=_[" "+N];var W=N.indexOf(":")===-1;return R.substring(0,2)==="//"?W?R:N.replace(S,"$1")+R:R.charAt(0)==="/"?W?R:N.replace(A,"$1")+R:N+R}var E={exec:function(){}};function b(N){for(var R=1,W,C;R<arguments.length;R++){W=arguments[R];for(C in W)Object.prototype.hasOwnProperty.call(W,C)&&(N[C]=W[C])}return N}function D(N,R){var W=N.replace(/\|/g,function(M,O,K){for(var J=!1,ue=O;--ue>=0&&K[ue]==="\\";)J=!J;return J?"|":" |"}),C=W.split(/ \|/),k=0;if(C[0].trim()||C.shift(),C.length>0&&!C[C.length-1].trim()&&C.pop(),C.length>R)C.splice(R);else for(;C.length<R;)C.push("");for(;k<C.length;k++)C[k]=C[k].trim().replace(/\\\|/g,"|");return C}function z(N,R,W){var C=N.length;if(C===0)return"";for(var k=0;k<C;){var M=N.charAt(C-k-1);if(M===R&&!W)k++;else if(M!==R&&W)k++;else break}return N.slice(0,C-k)}function x(N,R){if(N.indexOf(R[1])===-1)return-1;for(var W=N.length,C=0,k=0;k<W;k++)if(N[k]==="\\")k++;else if(N[k]===R[0])C++;else if(N[k]===R[1]&&(C--,C<0))return k;return-1}function ie(N){N&&N.sanitize&&!N.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Q(N,R){if(R<1)return"";for(var W="";R>1;)R&1&&(W+=N),R>>=1,N+=N;return W+N}function me(N,R,W,C){var k=R.href,M=R.title?e(R.title):null,O=N[1].replace(/\\([\[\]])/g,"$1");if(N[0].charAt(0)!=="!"){C.state.inLink=!0;var K={type:"link",raw:W,href:k,title:M,text:O,tokens:C.inlineTokens(O)};return C.state.inLink=!1,K}return{type:"image",raw:W,href:k,title:M,text:e(O)}}function ae(N,R){var W=N.match(/^(\s+)(?:```)/);if(W===null)return R;var C=W[1];return R.split(`
`).map(function(k){var M=k.match(/^\s+/);if(M===null)return k;var O=M[0];return O.length>=C.length?k.slice(C.length):k}).join(`
`)}var fe=function(){function N(W){this.options=W||Z.defaults}var R=N.prototype;return R.space=function(C){var k=this.rules.block.newline.exec(C);if(k&&k[0].length>0)return{type:"space",raw:k[0]}},R.code=function(C){var k=this.rules.block.code.exec(C);if(k){var M=k[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:k[0],codeBlockStyle:"indented",text:this.options.pedantic?M:z(M,`
`)}}},R.fences=function(C){var k=this.rules.block.fences.exec(C);if(k){var M=k[0],O=ae(M,k[3]||"");return{type:"code",raw:M,lang:k[2]?k[2].trim():k[2],text:O}}},R.heading=function(C){var k=this.rules.block.heading.exec(C);if(k){var M=k[2].trim();if(/#$/.test(M)){var O=z(M,"#");(this.options.pedantic||!O||/ $/.test(O))&&(M=O.trim())}return{type:"heading",raw:k[0],depth:k[1].length,text:M,tokens:this.lexer.inline(M)}}},R.hr=function(C){var k=this.rules.block.hr.exec(C);if(k)return{type:"hr",raw:k[0]}},R.blockquote=function(C){var k=this.rules.block.blockquote.exec(C);if(k){var M=k[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:k[0],tokens:this.lexer.blockTokens(M,[]),text:M}}},R.list=function(C){var k=this.rules.block.list.exec(C);if(k){var M,O,K,J,ue,he,De,Ee,Ne,Ae,ve,Re,Pe=k[1].trim(),$e=Pe.length>1,He={type:"list",raw:"",ordered:$e,start:$e?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=$e?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=$e?Pe:"[*+-]");for(var ze=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");C&&(Re=!1,!(!(k=ze.exec(C))||this.rules.block.hr.test(C)));){if(M=k[0],C=C.substring(M.length),Ee=k[2].split(`
`,1)[0],Ne=C.split(`
`,1)[0],this.options.pedantic?(J=2,ve=Ee.trimLeft()):(J=k[2].search(/[^ ]/),J=J>4?1:J,ve=Ee.slice(J),J+=k[1].length),he=!1,!Ee&&/^ *$/.test(Ne)&&(M+=Ne+`
`,C=C.substring(Ne.length+1),Re=!0),!Re)for(var Je=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,J-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,J-1)+"}#");C&&(Ae=C.split(`
`,1)[0],Ee=Ae,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(Ee)||qe.test(Ee)||Je.test(Ee)||it.test(C)));){if(Ee.search(/[^ ]/)>=J||!Ee.trim())ve+=`
`+Ee.slice(J);else if(!he)ve+=`
`+Ee;else break;!he&&!Ee.trim()&&(he=!0),M+=Ae+`
`,C=C.substring(Ae.length+1)}He.loose||(De?He.loose=!0:/\n *\n *$/.test(M)&&(De=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ve),O&&(K=O[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:M,task:!!O,checked:K,loose:!1,text:ve}),He.raw+=M}He.items[He.items.length-1].raw=M.trimRight(),He.items[He.items.length-1].text=ve.trimRight(),He.raw=He.raw.trimRight();var Ye=He.items.length;for(ue=0;ue<Ye;ue++){this.lexer.state.top=!1,He.items[ue].tokens=this.lexer.blockTokens(He.items[ue].text,[]);var q=He.items[ue].tokens.filter(function(we){return we.type==="space"}),oe=q.every(function(we){for(var _e=we.raw.split(""),Fe=0,Me=H(_e),Ve;!(Ve=Me()).done;){var tt=Ve.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!He.loose&&q.length&&oe&&(He.loose=!0,He.items[ue].loose=!0)}return He}},R.html=function(C){var k=this.rules.block.html.exec(C);if(k){var M={type:"html",raw:k[0],pre:!this.options.sanitizer&&(k[1]==="pre"||k[1]==="script"||k[1]==="style"),text:k[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]);M.type="paragraph",M.text=O,M.tokens=this.lexer.inline(O)}return M}},R.def=function(C){var k=this.rules.block.def.exec(C);if(k){k[3]&&(k[3]=k[3].substring(1,k[3].length-1));var M=k[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:M,raw:k[0],href:k[2],title:k[3]}}},R.table=function(C){var k=this.rules.block.table.exec(C);if(k){var M={type:"table",header:D(k[1]).map(function(De){return{text:De}}),align:k[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:k[3]&&k[3].trim()?k[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(M.header.length===M.align.length){M.raw=k[0];var O=M.align.length,K,J,ue,he;for(K=0;K<O;K++)/^ *-+: *$/.test(M.align[K])?M.align[K]="right":/^ *:-+: *$/.test(M.align[K])?M.align[K]="center":/^ *:-+ *$/.test(M.align[K])?M.align[K]="left":M.align[K]=null;for(O=M.rows.length,K=0;K<O;K++)M.rows[K]=D(M.rows[K],M.header.length).map(function(De){return{text:De}});for(O=M.header.length,J=0;J<O;J++)M.header[J].tokens=this.lexer.inline(M.header[J].text);for(O=M.rows.length,J=0;J<O;J++)for(he=M.rows[J],ue=0;ue<he.length;ue++)he[ue].tokens=this.lexer.inline(he[ue].text);return M}}},R.lheading=function(C){var k=this.rules.block.lheading.exec(C);if(k)return{type:"heading",raw:k[0],depth:k[2].charAt(0)==="="?1:2,text:k[1],tokens:this.lexer.inline(k[1])}},R.paragraph=function(C){var k=this.rules.block.paragraph.exec(C);if(k){var M=k[1].charAt(k[1].length-1)===`
`?k[1].slice(0,-1):k[1];return{type:"paragraph",raw:k[0],text:M,tokens:this.lexer.inline(M)}}},R.text=function(C){var k=this.rules.block.text.exec(C);if(k)return{type:"text",raw:k[0],text:k[0],tokens:this.lexer.inline(k[0])}},R.escape=function(C){var k=this.rules.inline.escape.exec(C);if(k)return{type:"escape",raw:k[0],text:e(k[1])}},R.tag=function(C){var k=this.rules.inline.tag.exec(C);if(k)return!this.lexer.state.inLink&&/^<a /i.test(k[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(k[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(k[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(k[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:k[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]}},R.link=function(C){var k=this.rules.inline.link.exec(C);if(k){var M=k[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;var O=z(M.slice(0,-1),"\\");if((M.length-O.length)%2===0)return}else{var K=x(k[2],"()");if(K>-1){var J=k[0].indexOf("!")===0?5:4,ue=J+k[1].length+K;k[2]=k[2].substring(0,K),k[0]=k[0].substring(0,ue).trim(),k[3]=""}}var he=k[2],De="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ee&&(he=Ee[1],De=Ee[3])}else De=k[3]?k[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(M)?he=he.slice(1):he=he.slice(1,-1)),me(k,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:De&&De.replace(this.rules.inline._escapes,"$1")},k[0],this.lexer)}},R.reflink=function(C,k){var M;if((M=this.rules.inline.reflink.exec(C))||(M=this.rules.inline.nolink.exec(C))){var O=(M[2]||M[1]).replace(/\s+/g," ");if(O=k[O.toLowerCase()],!O||!O.href){var K=M[0].charAt(0);return{type:"text",raw:K,text:K}}return me(M,O,M[0],this.lexer)}},R.emStrong=function(C,k,M){M===void 0&&(M="");var O=this.rules.inline.emStrong.lDelim.exec(C);if(!!O&&!(O[3]&&M.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var K=O[1]||O[2]||"";if(!K||K&&(M===""||this.rules.inline.punctuation.exec(M))){var J=O[0].length-1,ue,he,De=J,Ee=0,Ne=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,k=k.slice(-1*C.length+J);(O=Ne.exec(k))!=null;)if(ue=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!ue){if(he=ue.length,O[3]||O[4]){De+=he;continue}else if((O[5]||O[6])&&J%3&&!((J+he)%3)){Ee+=he;continue}if(De-=he,!(De>0)){if(he=Math.min(he,he+De+Ee),Math.min(J,he)%2){var Ae=C.slice(1,J+O.index+he);return{type:"em",raw:C.slice(0,J+O.index+he+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var ve=C.slice(2,J+O.index+he-1);return{type:"strong",raw:C.slice(0,J+O.index+he+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},R.codespan=function(C){var k=this.rules.inline.code.exec(C);if(k){var M=k[2].replace(/\n/g," "),O=/[^ ]/.test(M),K=/^ /.test(M)&&/ $/.test(M);return O&&K&&(M=M.substring(1,M.length-1)),M=e(M,!0),{type:"codespan",raw:k[0],text:M}}},R.br=function(C){var k=this.rules.inline.br.exec(C);if(k)return{type:"br",raw:k[0]}},R.del=function(C){var k=this.rules.inline.del.exec(C);if(k)return{type:"del",raw:k[0],text:k[2],tokens:this.lexer.inlineTokens(k[2])}},R.autolink=function(C,k){var M=this.rules.inline.autolink.exec(C);if(M){var O,K;return M[2]==="@"?(O=e(this.options.mangle?k(M[1]):M[1]),K="mailto:"+O):(O=e(M[1]),K=O),{type:"link",raw:M[0],text:O,href:K,tokens:[{type:"text",raw:O,text:O}]}}},R.url=function(C,k){var M;if(M=this.rules.inline.url.exec(C)){var O,K;if(M[2]==="@")O=e(this.options.mangle?k(M[0]):M[0]),K="mailto:"+O;else{var J;do J=M[0],M[0]=this.rules.inline._backpedal.exec(M[0])[0];while(J!==M[0]);O=e(M[0]),M[1]==="www."?K="http://"+O:K=O}return{type:"link",raw:M[0],text:O,href:K,tokens:[{type:"text",raw:O,text:O}]}}},R.inlineText=function(C,k){var M=this.rules.inline.text.exec(C);if(M){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]:O=e(this.options.smartypants?k(M[0]):M[0]),{type:"text",raw:M[0],text:O}}},N}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=m(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=m(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=m(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=m(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=m(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=m(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=b({},le),le.gfm=b({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=m(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=m(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=b({},le.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:m(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var de={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};de._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",de.punctuation=m(de.punctuation).replace(/punctuation/g,de._punctuation).getRegex(),de.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,de.escapedEmSt=/\\\*|\\_/g,de._comment=m(le._comment).replace("(?:-->|$)","-->").getRegex(),de.emStrong.lDelim=m(de.emStrong.lDelim).replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimAst=m(de.emStrong.rDelimAst,"g").replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimUnd=m(de.emStrong.rDelimUnd,"g").replace(/punct/g,de._punctuation).getRegex(),de._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,de._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,de._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,de.autolink=m(de.autolink).replace("scheme",de._scheme).replace("email",de._email).getRegex(),de._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,de.tag=m(de.tag).replace("comment",de._comment).replace("attribute",de._attribute).getRegex(),de._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,de._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,de._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,de.link=m(de.link).replace("label",de._label).replace("href",de._href).replace("title",de._title).getRegex(),de.reflink=m(de.reflink).replace("label",de._label).replace("ref",le._label).getRegex(),de.nolink=m(de.nolink).replace("ref",le._label).getRegex(),de.reflinkSearch=m(de.reflinkSearch,"g").replace("reflink",de.reflink).replace("nolink",de.nolink).getRegex(),de.normal=b({},de),de.pedantic=b({},de.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",de._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",de._label).getRegex()}),de.gfm=b({},de.normal,{escape:m(de.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),de.gfm.url=m(de.gfm.url,"i").replace("email",de.gfm._extended_email).getRegex(),de.breaks=b({},de.gfm,{br:m(de.br).replace("{2,}","*").getRegex(),text:m(de.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(N){return N.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(N){var R="",W,C,k=N.length;for(W=0;W<k;W++)C=N.charCodeAt(W),Math.random()>.5&&(C="x"+C.toString(16)),R+="&#"+C+";";return R}var ye=function(){function N(W){this.tokens=[],this.tokens.links=Object.create(null),this.options=W||Z.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var C={block:le.normal,inline:de.normal};this.options.pedantic?(C.block=le.pedantic,C.inline=de.pedantic):this.options.gfm&&(C.block=le.gfm,this.options.breaks?C.inline=de.breaks:C.inline=de.gfm),this.tokenizer.rules=C}N.lex=function(C,k){var M=new N(k);return M.lex(C)},N.lexInline=function(C,k){var M=new N(k);return M.inlineTokens(C)};var R=N.prototype;return R.lex=function(C){C=C.replace(/\r\n|\r/g,`
`),this.blockTokens(C,this.tokens);for(var k;k=this.inlineQueue.shift();)this.inlineTokens(k.src,k.tokens);return this.tokens},R.blockTokens=function(C,k){var M=this;k===void 0&&(k=[]),this.options.pedantic?C=C.replace(/\t/g,"    ").replace(/^ +$/gm,""):C=C.replace(/^( *)(\t+)/gm,function(De,Ee,Ne){return Ee+"    ".repeat(Ne.length)});for(var O,K,J,ue;C;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(De){return(O=De.call({lexer:M},C,k))?(C=C.substring(O.raw.length),k.push(O),!0):!1}))){if(O=this.tokenizer.space(C)){C=C.substring(O.raw.length),O.raw.length===1&&k.length>0?k[k.length-1].raw+=`
`:k.push(O);continue}if(O=this.tokenizer.code(C)){C=C.substring(O.raw.length),K=k[k.length-1],K&&(K.type==="paragraph"||K.type==="text")?(K.raw+=`
`+O.raw,K.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=K.text):k.push(O);continue}if(O=this.tokenizer.fences(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.heading(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.hr(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.blockquote(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.list(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.html(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.def(C)){C=C.substring(O.raw.length),K=k[k.length-1],K&&(K.type==="paragraph"||K.type==="text")?(K.raw+=`
`+O.raw,K.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=K.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.lheading(C)){C=C.substring(O.raw.length),k.push(O);continue}if(J=C,this.options.extensions&&this.options.extensions.startBlock&&function(){var De=1/0,Ee=C.slice(1),Ne=void 0;M.options.extensions.startBlock.forEach(function(Ae){Ne=Ae.call({lexer:this},Ee),typeof Ne=="number"&&Ne>=0&&(De=Math.min(De,Ne))}),De<1/0&&De>=0&&(J=C.substring(0,De+1))}(),this.state.top&&(O=this.tokenizer.paragraph(J))){K=k[k.length-1],ue&&K.type==="paragraph"?(K.raw+=`
`+O.raw,K.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=K.text):k.push(O),ue=J.length!==C.length,C=C.substring(O.raw.length);continue}if(O=this.tokenizer.text(C)){C=C.substring(O.raw.length),K=k[k.length-1],K&&K.type==="text"?(K.raw+=`
`+O.raw,K.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=K.text):k.push(O);continue}if(C){var he="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,k},R.inline=function(C,k){return k===void 0&&(k=[]),this.inlineQueue.push({src:C,tokens:k}),k},R.inlineTokens=function(C,k){var M=this;k===void 0&&(k=[]);var O,K,J,ue=C,he,De,Ee;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(ue))!=null;)Ne.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(ue=ue.slice(0,he.index)+"["+Q("a",he[0].length-2)+"]"+ue.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(ue))!=null;)ue=ue.slice(0,he.index)+"["+Q("a",he[0].length-2)+"]"+ue.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(ue))!=null;)ue=ue.slice(0,he.index)+"++"+ue.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;C;)if(De||(Ee=""),De=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(O=ve.call({lexer:M},C,k))?(C=C.substring(O.raw.length),k.push(O),!0):!1}))){if(O=this.tokenizer.escape(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.tag(C)){C=C.substring(O.raw.length),K=k[k.length-1],K&&O.type==="text"&&K.type==="text"?(K.raw+=O.raw,K.text+=O.text):k.push(O);continue}if(O=this.tokenizer.link(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.reflink(C,this.tokens.links)){C=C.substring(O.raw.length),K=k[k.length-1],K&&O.type==="text"&&K.type==="text"?(K.raw+=O.raw,K.text+=O.text):k.push(O);continue}if(O=this.tokenizer.emStrong(C,ue,Ee)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.codespan(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.br(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.del(C)){C=C.substring(O.raw.length),k.push(O);continue}if(O=this.tokenizer.autolink(C,ee)){C=C.substring(O.raw.length),k.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(C,ee))){C=C.substring(O.raw.length),k.push(O);continue}if(J=C,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Re=C.slice(1),Pe=void 0;M.options.extensions.startInline.forEach(function($e){Pe=$e.call({lexer:this},Re),typeof Pe=="number"&&Pe>=0&&(ve=Math.min(ve,Pe))}),ve<1/0&&ve>=0&&(J=C.substring(0,ve+1))}(),O=this.tokenizer.inlineText(J,Se)){C=C.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Ee=O.raw.slice(-1)),De=!0,K=k[k.length-1],K&&K.type==="text"?(K.raw+=O.raw,K.text+=O.text):k.push(O);continue}if(C){var Ae="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return k},w(N,null,[{key:"rules",get:function(){return{block:le,inline:de}}}]),N}(),se=function(){function N(W){this.options=W||Z.defaults}var R=N.prototype;return R.code=function(C,k,M){var O=(k||"").match(/\S*/)[0];if(this.options.highlight){var K=this.options.highlight(C,O);K!=null&&K!==C&&(M=!0,C=K)}return C=C.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+e(O,!0)+'">'+(M?C:e(C,!0))+`</code></pre>
`:"<pre><code>"+(M?C:e(C,!0))+`</code></pre>
`},R.blockquote=function(C){return`<blockquote>
`+C+`</blockquote>
`},R.html=function(C){return C},R.heading=function(C,k,M,O){if(this.options.headerIds){var K=this.options.headerPrefix+O.slug(M);return"<h"+k+' id="'+K+'">'+C+"</h"+k+`>
`}return"<h"+k+">"+C+"</h"+k+`>
`},R.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},R.list=function(C,k,M){var O=k?"ol":"ul",K=k&&M!==1?' start="'+M+'"':"";return"<"+O+K+`>
`+C+"</"+O+`>
`},R.listitem=function(C){return"<li>"+C+`</li>
`},R.checkbox=function(C){return"<input "+(C?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},R.paragraph=function(C){return"<p>"+C+`</p>
`},R.table=function(C,k){return k&&(k="<tbody>"+k+"</tbody>"),`<table>
<thead>
`+C+`</thead>
`+k+`</table>
`},R.tablerow=function(C){return`<tr>
`+C+`</tr>
`},R.tablecell=function(C,k){var M=k.header?"th":"td",O=k.align?"<"+M+' align="'+k.align+'">':"<"+M+">";return O+C+("</"+M+`>
`)},R.strong=function(C){return"<strong>"+C+"</strong>"},R.em=function(C){return"<em>"+C+"</em>"},R.codespan=function(C){return"<code>"+C+"</code>"},R.br=function(){return this.options.xhtml?"<br/>":"<br>"},R.del=function(C){return"<del>"+C+"</del>"},R.link=function(C,k,M){if(C=p(this.options.sanitize,this.options.baseUrl,C),C===null)return M;var O='<a href="'+e(C)+'"';return k&&(O+=' title="'+k+'"'),O+=">"+M+"</a>",O},R.image=function(C,k,M){if(C=p(this.options.sanitize,this.options.baseUrl,C),C===null)return M;var O='<img src="'+C+'" alt="'+M+'"';return k&&(O+=' title="'+k+'"'),O+=this.options.xhtml?"/>":">",O},R.text=function(C){return C},N}(),te=function(){function N(){}var R=N.prototype;return R.strong=function(C){return C},R.em=function(C){return C},R.codespan=function(C){return C},R.del=function(C){return C},R.html=function(C){return C},R.text=function(C){return C},R.link=function(C,k,M){return""+M},R.image=function(C,k,M){return""+M},R.br=function(){return""},N}(),ce=function(){function N(){this.seen={}}var R=N.prototype;return R.serialize=function(C){return C.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},R.getNextSafeSlug=function(C,k){var M=C,O=0;if(this.seen.hasOwnProperty(M)){O=this.seen[C];do O++,M=C+"-"+O;while(this.seen.hasOwnProperty(M))}return k||(this.seen[C]=O,this.seen[M]=0),M},R.slug=function(C,k){k===void 0&&(k={});var M=this.serialize(C);return this.getNextSafeSlug(M,k.dryrun)},N}(),ne=function(){function N(W){this.options=W||Z.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new ce}N.parse=function(C,k){var M=new N(k);return M.parse(C)},N.parseInline=function(C,k){var M=new N(k);return M.parseInline(C)};var R=N.prototype;return R.parse=function(C,k){k===void 0&&(k=!0);var M="",O,K,J,ue,he,De,Ee,Ne,Ae,ve,Re,Pe,$e,He,ze,Je,it,Oe,qe,Ye=C.length;for(O=0;O<Ye;O++){if(ve=C[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(qe=this.options.extensions.renderers[ve.type].call({parser:this},ve),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){M+=qe||"";continue}switch(ve.type){case"space":continue;case"hr":{M+=this.renderer.hr();continue}case"heading":{M+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,a(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{M+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ne="",Ee="",ue=ve.header.length,K=0;K<ue;K++)Ee+=this.renderer.tablecell(this.parseInline(ve.header[K].tokens),{header:!0,align:ve.align[K]});for(Ne+=this.renderer.tablerow(Ee),Ae="",ue=ve.rows.length,K=0;K<ue;K++){for(De=ve.rows[K],Ee="",he=De.length,J=0;J<he;J++)Ee+=this.renderer.tablecell(this.parseInline(De[J].tokens),{header:!1,align:ve.align[J]});Ae+=this.renderer.tablerow(Ee)}M+=this.renderer.table(Ne,Ae);continue}case"blockquote":{Ae=this.parse(ve.tokens),M+=this.renderer.blockquote(Ae);continue}case"list":{for(Re=ve.ordered,Pe=ve.start,$e=ve.loose,ue=ve.items.length,Ae="",K=0;K<ue;K++)ze=ve.items[K],Je=ze.checked,it=ze.task,He="",ze.task&&(Oe=this.renderer.checkbox(Je),$e?ze.tokens.length>0&&ze.tokens[0].type==="paragraph"?(ze.tokens[0].text=Oe+" "+ze.tokens[0].text,ze.tokens[0].tokens&&ze.tokens[0].tokens.length>0&&ze.tokens[0].tokens[0].type==="text"&&(ze.tokens[0].tokens[0].text=Oe+" "+ze.tokens[0].tokens[0].text)):ze.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(ze.tokens,$e),Ae+=this.renderer.listitem(He,it,Je);M+=this.renderer.list(Ae,Re,Pe);continue}case"html":{M+=this.renderer.html(ve.text);continue}case"paragraph":{M+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ae=ve.tokens?this.parseInline(ve.tokens):ve.text;O+1<Ye&&C[O+1].type==="text";)ve=C[++O],Ae+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);M+=k?this.renderer.paragraph(Ae):Ae;continue}default:{var q='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return M},R.parseInline=function(C,k){k=k||this.renderer;var M="",O,K,J,ue=C.length;for(O=0;O<ue;O++){if(K=C[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[K.type]&&(J=this.options.extensions.renderers[K.type].call({parser:this},K),J!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(K.type))){M+=J||"";continue}switch(K.type){case"escape":{M+=k.text(K.text);break}case"html":{M+=k.html(K.text);break}case"link":{M+=k.link(K.href,K.title,this.parseInline(K.tokens,k));break}case"image":{M+=k.image(K.href,K.title,K.text);break}case"strong":{M+=k.strong(this.parseInline(K.tokens,k));break}case"em":{M+=k.em(this.parseInline(K.tokens,k));break}case"codespan":{M+=k.codespan(K.text);break}case"br":{M+=k.br();break}case"del":{M+=k.del(this.parseInline(K.tokens,k));break}case"text":{M+=k.text(K.text);break}default:{var he='Token with "'+K.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return M},N}();function T(N,R,W){if(typeof N>"u"||N===null)throw new Error("marked(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");if(typeof R=="function"&&(W=R,R=null),R=b({},T.defaults,R||{}),ie(R),W){var C=R.highlight,k;try{k=ye.lex(N,R)}catch(ue){return W(ue)}var M=function(he){var De;if(!he)try{R.walkTokens&&T.walkTokens(k,R.walkTokens),De=ne.parse(k,R)}catch(Ee){he=Ee}return R.highlight=C,he?W(he):W(null,De)};if(!C||C.length<3||(delete R.highlight,!k.length))return M();var O=0;T.walkTokens(k,function(ue){ue.type==="code"&&(O++,setTimeout(function(){C(ue.text,ue.lang,function(he,De){if(he)return M(he);De!=null&&De!==ue.text&&(ue.text=De,ue.escaped=!0),O--,O===0&&M()})},0))}),O===0&&M();return}function K(ue){if(ue.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(ue.message+"",!0)+"</pre>";throw ue}try{var J=ye.lex(N,R);if(R.walkTokens){if(R.async)return Promise.all(T.walkTokens(J,R.walkTokens)).then(function(){return ne.parse(J,R)}).catch(K);T.walkTokens(J,R.walkTokens)}return ne.parse(J,R)}catch(ue){K(ue)}}T.options=T.setOptions=function(N){return b(T.defaults,N),v(T.defaults),T},T.getDefaults=y,T.defaults=Z.defaults,T.use=function(){for(var N=arguments.length,R=new Array(N),W=0;W<N;W++)R[W]=arguments[W];var C=b.apply(void 0,[{}].concat(R)),k=T.defaults.extensions||{renderers:{},childTokens:{}},M;R.forEach(function(O){if(O.extensions&&(M=!0,O.extensions.forEach(function(J){if(!J.name)throw new Error("extension name required");if(J.renderer){var ue=k.renderers?k.renderers[J.name]:null;ue?k.renderers[J.name]=function(){for(var he=arguments.length,De=new Array(he),Ee=0;Ee<he;Ee++)De[Ee]=arguments[Ee];var Ne=J.renderer.apply(this,De);return Ne===!1&&(Ne=ue.apply(this,De)),Ne}:k.renderers[J.name]=J.renderer}if(J.tokenizer){if(!J.level||J.level!=="block"&&J.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");k[J.level]?k[J.level].unshift(J.tokenizer):k[J.level]=[J.tokenizer],J.start&&(J.level==="block"?k.startBlock?k.startBlock.push(J.start):k.startBlock=[J.start]:J.level==="inline"&&(k.startInline?k.startInline.push(J.start):k.startInline=[J.start]))}J.childTokens&&(k.childTokens[J.name]=J.childTokens)})),O.renderer&&function(){var J=T.defaults.renderer||new se,ue=function(Ee){var Ne=J[Ee];J[Ee]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Re=0;Re<Ae;Re++)ve[Re]=arguments[Re];var Pe=O.renderer[Ee].apply(J,ve);return Pe===!1&&(Pe=Ne.apply(J,ve)),Pe}};for(var he in O.renderer)ue(he);C.renderer=J}(),O.tokenizer&&function(){var J=T.defaults.tokenizer||new fe,ue=function(Ee){var Ne=J[Ee];J[Ee]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Re=0;Re<Ae;Re++)ve[Re]=arguments[Re];var Pe=O.tokenizer[Ee].apply(J,ve);return Pe===!1&&(Pe=Ne.apply(J,ve)),Pe}};for(var he in O.tokenizer)ue(he);C.tokenizer=J}(),O.walkTokens){var K=T.defaults.walkTokens;C.walkTokens=function(J){var ue=[];return ue.push(O.walkTokens.call(this,J)),K&&(ue=ue.concat(K.call(this,J))),ue}}M&&(C.extensions=k),T.setOptions(C)})},T.walkTokens=function(N,R){for(var W=[],C=function(){var K=M.value;switch(W=W.concat(R.call(T,K)),K.type){case"table":{for(var J=H(K.header),ue;!(ue=J()).done;){var he=ue.value;W=W.concat(T.walkTokens(he.tokens,R))}for(var De=H(K.rows),Ee;!(Ee=De()).done;)for(var Ne=Ee.value,Ae=H(Ne),ve;!(ve=Ae()).done;){var Re=ve.value;W=W.concat(T.walkTokens(Re.tokens,R))}break}case"list":{W=W.concat(T.walkTokens(K.items,R));break}default:T.defaults.extensions&&T.defaults.extensions.childTokens&&T.defaults.extensions.childTokens[K.type]?T.defaults.extensions.childTokens[K.type].forEach(function(Pe){W=W.concat(T.walkTokens(K[Pe],R))}):K.tokens&&(W=W.concat(T.walkTokens(K.tokens,R)))}},k=H(N),M;!(M=k()).done;)C();return W},T.parseInline=function(N,R){if(typeof N>"u"||N===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");R=b({},T.defaults,R||{}),ie(R);try{var W=ye.lexInline(N,R);return R.walkTokens&&T.walkTokens(W,R.walkTokens),ne.parseInline(W,R)}catch(C){if(C.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(C.message+"",!0)+"</pre>";throw C}},T.Parser=ne,T.parser=ne.parse,T.Renderer=se,T.TextRenderer=te,T.Lexer=ye,T.lexer=ye.lex,T.Tokenizer=fe,T.Slugger=ce,T.parse=T;var V=T.options,j=T.setOptions,P=T.use,d=T.walkTokens,F=T.parseInline,U=T,$=ne.parse,X=ye.lex;Z.Lexer=ye,Z.Parser=ne,Z.Renderer=se,Z.Slugger=ce,Z.TextRenderer=te,Z.Tokenizer=fe,Z.getDefaults=y,Z.lexer=X,Z.marked=T,Z.options=V,Z.parse=U,Z.parseInline=F,Z.parser=$,Z.setOptions=j,Z.use=P,Z.walkTokens=d,Object.defineProperty(Z,"__esModule",{value:!0})}),define(pe[76],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class w{constructor(B,H=0,y=B.length,v=H-1){this.items=B,this.start=H,this.end=y,this.index=v}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=w}),define(pe[77],be([1,0,76]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],v=10){this._initialize(y),this._limit=v,this._onChange()}getHistory(){return this._elements}add(y){this._history.delete(y),this._history.add(y),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(y){return this._history.has(y)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const y=this._elements;this._navigator=new w.ArrayNavigator(y,0,y.length,y.length)}_reduceToLimit(){const y=this._elements;y.length>this._limit&&this._initialize(y.slice(y.length-this._limit))}_currentPosition(){const y=this._navigator.current();return y?this._elements.indexOf(y):-1}_initialize(y){this._history=new Set;for(const v of y)this._history.add(v)}get _elements(){const y=[];return this._history.forEach(v=>y.push(v)),y}}t.HistoryNavigator=i;class B{constructor(y,v=10){if(this.capacity=v,y.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:y[0],previous:void 0,next:void 0};for(let h=1;h<y.length;h++)this.add(y[h])}add(y){const v={value:y,previous:this.tail,next:void 0};for(this.tail.next=v,this.tail=v,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(y){const v=this.tail.value;return this.tail.value=y,v}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(y){let v=this.head;for(;v;){if(v.value===y)return!0;v=v.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let y=this.head;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=B}),define(pe[46],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function w(v,h,g){return Math.min(Math.max(v,h),g)}t.clamp=w;function i(v,h){return(h+v%h)%h}t.rot=i;class B{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=B;class H{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=H;class y{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const g=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=g,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=y}),define(pe[47],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var w;(function(i){function B(h,g){if(h.start>=g.end||g.start>=h.end)return{start:0,end:0};const f=Math.max(h.start,g.start),I=Math.min(h.end,g.end);return I-f<=0?{start:0,end:0}:{start:f,end:I}}i.intersect=B;function H(h){return h.end-h.start<=0}i.isEmpty=H;function y(h,g){return!H(B(h,g))}i.intersects=y;function v(h,g){const f=[],I={start:h.start,end:Math.min(g.start,h.end)},o={start:Math.max(g.end,h.start),end:h.end};return H(I)||f.push(I),H(o)||f.push(o),f}i.relativeComplement=v})(w=t.Range||(t.Range={}))}),define(pe[78],be([1,0,47]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(h,g){const f=[];for(const I of g){if(h.start>=I.range.end)continue;if(h.end<I.range.start)break;const o=w.Range.intersect(h,I.range);w.Range.isEmpty(o)||f.push({range:o,size:I.size})}return f}t.groupIntersect=i;function B({start:h,end:g},f){return{start:h+f,end:g+f}}t.shift=B;function H(h){const g=[];let f=null;for(const I of h){const o=I.range.start,n=I.range.end,e=I.size;if(f&&e===f.size){f.range.end=n;continue}f={range:{start:o,end:n},size:e},g.push(f)}return g}t.consolidate=H;function y(...h){return H(h.reduce((g,f)=>g.concat(f),[]))}class v{constructor(){this.groups=[],this._size=0}splice(g,f,I=[]){const o=I.length-f,n=i({start:0,end:g},this.groups),e=i({start:g+f,end:Number.POSITIVE_INFINITY},this.groups).map(a=>({range:B(a.range,o),size:a.size})),r=I.map((a,c)=>({range:{start:g+c,end:g+c+1},size:a.size}));this.groups=y(n,r,e),this._size=this.groups.reduce((a,c)=>a+c.size*(c.range.end-c.range.start),0)}get count(){const g=this.groups.length;return g?this.groups[g-1].range.end:0}get size(){return this._size}indexAt(g){if(g<0)return-1;let f=0,I=0;for(const o of this.groups){const n=o.range.end-o.range.start,e=I+n*o.size;if(g<e)return f+Math.floor((g-I)/o.size);f+=n,I=e}return f}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let f=0,I=0;for(const o of this.groups){const n=o.range.end-o.range.start,e=I+n;if(g<e)return f+(g-I)*o.size;f+=n*o.size,I=e}return-1}}t.RangeMap=v}),define(pe[79],be([1,0,9,2]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function B(l){const p=l;return p?typeof p.read=="function":!1}t.isReadable=B;function H(l){const p=l;return p?[p.on,p.pause,p.resume,p.destroy].every(_=>typeof _=="function"):!1}t.isReadableStream=H;function y(l){const p=l;return p?H(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}t.isReadableBufferedStream=y;function v(l,p){return new h(l,p)}t.newWriteableStream=v;class h{constructor(p,_){this.reducer=p,this.options=_,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(_=>this.pendingWritePromises.push(_))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(_=>_(p))}emitError(p){this.listeners.error.length===0?(0,w.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(_=>_(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,_){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(_),this.resume();break;case"end":this.listeners.end.push(_),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(_),this.state.flowing&&this.flowErrors();break}}removeListener(p,_){if(this.state.destroyed)return;let L;switch(p){case"data":L=this.listeners.data;break;case"end":L=this.listeners.end;break;case"error":L=this.listeners.error;break}if(L){const S=L.indexOf(_);S>=0&&L.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const _=[...this.pendingWritePromises];this.pendingWritePromises.length=0,_.forEach(L=>L())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(l,p){const _=[];let L;for(;(L=l.read())!==null;)_.push(L);return p(_)}t.consumeReadable=g;function f(l,p,_){const L=[];let S;for(;(S=l.read())!==null&&L.length<_;)L.push(S);return S===null&&L.length>0?p(L):{read:()=>{if(L.length>0)return L.shift();if(typeof S<"u"){const A=S;return S=void 0,A}return l.read()}}}t.peekReadable=f;function I(l,p){return new Promise((_,L)=>{const S=[];o(l,{onData:A=>{p&&S.push(A)},onError:A=>{p?L(A):_(void 0)},onEnd:()=>{_(p?p(S):void 0)}})})}t.consumeStream=I;function o(l,p){let _=!1;return l.on("error",L=>{_||p.onError(L)}),l.on("end",()=>{_||p.onEnd()}),l.on("data",L=>{_||p.onData(L)}),(0,i.toDisposable)(()=>_=!0)}t.listenStream=o;function n(l,p){return new Promise((_,L)=>{const S=new i.DisposableStore,A=[],u=D=>{if(A.push(D),A.length>p)return S.dispose(),l.pause(),_({stream:l,buffer:A,ended:!1})},E=D=>L(D),b=()=>_({stream:l,buffer:A,ended:!0});S.add((0,i.toDisposable)(()=>l.removeListener("error",E))),l.on("error",E),S.add((0,i.toDisposable)(()=>l.removeListener("end",b))),l.on("end",b),S.add((0,i.toDisposable)(()=>l.removeListener("data",u))),l.on("data",u)})}t.peekStream=n;function e(l,p){const _=v(p);return _.end(l),_}t.toStream=e;function r(){const l=v(()=>{throw new Error("not supported")});return l.end(),l}t.emptyStream=r;function a(l){let p=!1;return{read:()=>p?null:(p=!0,l)}}t.toReadable=a;function c(l,p,_){const L=v(_);return o(l,{onData:S=>L.write(p.data(S)),onError:S=>L.error(p.error?p.error(S):S),onEnd:()=>L.end()}),L}t.transform=c;function m(l,p,_){let L=!1;return{read:()=>{const S=p.read();return L?S:(L=!0,S!==null?_([l,S]):l)}}}t.prefixedReadable=m;function s(l,p,_){let L=!1;const S=v(_);return o(p,{onData:A=>L?S.write(A):(L=!0,S.write(_([l,A]))),onError:A=>S.error(A),onEnd:()=>{L||(L=!0,S.write(l)),S.end()}}),S}t.prefixedStream=s}),define(pe[31],be([1,0,79]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let B,H;class y{static alloc(D){return i?new y(Buffer.allocUnsafe(D)):new y(new Uint8Array(D))}static wrap(D){return i&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new y(D)}static fromString(D,z){return!(z?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(D)):(B||(B=new TextEncoder),new y(B.encode(D)))}static fromByteArray(D){const z=y.alloc(D.length);for(let x=0,ie=D.length;x<ie;x++)z.buffer[x]=D[x];return z}static concat(D,z){if(typeof z>"u"){z=0;for(let Q=0,me=D.length;Q<me;Q++)z+=D[Q].byteLength}const x=y.alloc(z);let ie=0;for(let Q=0,me=D.length;Q<me;Q++){const ae=D[Q];x.set(ae,ie),ie+=ae.byteLength}return x}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=y.alloc(this.byteLength);return D.set(this),D}toString(){return i?this.buffer.toString():(H||(H=new TextDecoder),H.decode(this.buffer))}slice(D,z){return new y(this.buffer.subarray(D,z))}set(D,z){if(D instanceof y)this.buffer.set(D.buffer,z);else if(D instanceof Uint8Array)this.buffer.set(D,z);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),z);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return g(this.buffer,D)}writeUInt32BE(D,z){f(this.buffer,D,z)}readUInt32LE(D){return I(this.buffer,D)}writeUInt32LE(D,z){o(this.buffer,D,z)}readUInt8(D){return n(this.buffer,D)}writeUInt8(D,z){e(this.buffer,D,z)}}t.VSBuffer=y;function v(b,D){return b[D+0]<<0>>>0|b[D+1]<<8>>>0}t.readUInt16LE=v;function h(b,D,z){b[z+0]=D&255,D=D>>>8,b[z+1]=D&255}t.writeUInt16LE=h;function g(b,D){return b[D]*2**24+b[D+1]*2**16+b[D+2]*2**8+b[D+3]}t.readUInt32BE=g;function f(b,D,z){b[z+3]=D,D=D>>>8,b[z+2]=D,D=D>>>8,b[z+1]=D,D=D>>>8,b[z]=D}t.writeUInt32BE=f;function I(b,D){return b[D+0]<<0>>>0|b[D+1]<<8>>>0|b[D+2]<<16>>>0|b[D+3]<<24>>>0}t.readUInt32LE=I;function o(b,D,z){b[z+0]=D&255,D=D>>>8,b[z+1]=D&255,D=D>>>8,b[z+2]=D&255,D=D>>>8,b[z+3]=D&255}t.writeUInt32LE=o;function n(b,D){return b[D]}t.readUInt8=n;function e(b,D,z){b[z]=D}t.writeUInt8=e;function r(b){return w.consumeReadable(b,D=>y.concat(D))}t.readableToBuffer=r;function a(b){return w.toReadable(b)}t.bufferToReadable=a;function c(b){return w.consumeStream(b,D=>y.concat(D))}t.streamToBuffer=c;async function m(b){return b.ended?y.concat(b.buffer):y.concat([...b.buffer,await c(b.stream)])}t.bufferedStreamToBuffer=m;function s(b){return w.toStream(b,D=>y.concat(D))}t.bufferToStream=s;function l(b){return w.transform(b,{data:D=>typeof D=="string"?y.fromString(D):y.wrap(D)},D=>y.concat(D))}t.streamToBufferReadableStream=l;function p(b){return w.newWriteableStream(D=>y.concat(D),b)}t.newWriteableBufferStream=p;function _(b,D){return w.prefixedReadable(b,D,z=>y.concat(z))}t.prefixedBufferReadable=_;function L(b,D){return w.prefixedStream(b,D,z=>y.concat(z))}t.prefixedBufferStream=L;function S(b){let D=0,z=0,x=0;const ie=new Uint8Array(Math.floor(b.length/4*3)),Q=ae=>{switch(z){case 3:ie[x++]=D|ae,z=0;break;case 2:ie[x++]=D|ae>>>2,D=ae<<6,z=3;break;case 1:ie[x++]=D|ae>>>4,D=ae<<4,z=2;break;default:D=ae<<2,z=1}};for(let ae=0;ae<b.length;ae++){const fe=b.charCodeAt(ae);if(fe>=65&&fe<=90)Q(fe-65);else if(fe>=97&&fe<=122)Q(fe-97+26);else if(fe>=48&&fe<=57)Q(fe-48+52);else if(fe===43||fe===45)Q(62);else if(fe===47||fe===95)Q(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${b[ae]}`)}}const me=x;for(;z>0;)Q(0);return y.wrap(ie).slice(0,me)}t.decodeBase64=S;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:b},D=!0,z=!1){const x=z?u:A;let ie="";const Q=b.byteLength%3;let me=0;for(;me<b.byteLength-Q;me+=3){const ae=b[me+0],fe=b[me+1],le=b[me+2];ie+=x[ae>>>2],ie+=x[(ae<<4|fe>>>4)&63],ie+=x[(fe<<2|le>>>6)&63],ie+=x[le&63]}if(Q===1){const ae=b[me+0];ie+=x[ae>>>2],ie+=x[ae<<4&63],D&&(ie+="==")}else if(Q===2){const ae=b[me+0],fe=b[me+1];ie+=x[ae>>>2],ie+=x[(ae<<4|fe>>>4)&63],ie+=x[fe<<2&63],D&&(ie+="=")}return ie}t.encodeBase64=E}),define(pe[6],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function w(L){return typeof L=="string"}t.isString=w;function i(L){return Array.isArray(L)&&L.every(S=>w(S))}t.isStringArray=i;function B(L){return typeof L=="object"&&L!==null&&!Array.isArray(L)&&!(L instanceof RegExp)&&!(L instanceof Date)}t.isObject=B;function H(L){const S=Object.getPrototypeOf(Uint8Array);return typeof L=="object"&&L instanceof S}t.isTypedArray=H;function y(L){return typeof L=="number"&&!isNaN(L)}t.isNumber=y;function v(L){return!!L&&typeof L[Symbol.iterator]=="function"}t.isIterable=v;function h(L){return L===!0||L===!1}t.isBoolean=h;function g(L){return typeof L>"u"}t.isUndefined=g;function f(L){return!I(L)}t.isDefined=f;function I(L){return g(L)||L===null}t.isUndefinedOrNull=I;function o(L,S){if(!L)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}t.assertType=o;function n(L){if(I(L))throw new Error("Assertion Failed: argument is undefined or null");return L}t.assertIsDefined=n;function e(...L){const S=[];for(let A=0;A<L.length;A++){const u=L[A];if(I(u))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);S.push(u)}return S}t.assertAllDefined=e;const r=Object.prototype.hasOwnProperty;function a(L){if(!B(L))return!1;for(const S in L)if(r.call(L,S))return!1;return!0}t.isEmptyObject=a;function c(L){return typeof L=="function"}t.isFunction=c;function m(...L){return L.length>0&&L.every(c)}t.areFunctions=m;function s(L,S){const A=Math.min(L.length,S.length);for(let u=0;u<A;u++)l(L[u],S[u])}t.validateConstraints=s;function l(L,S){if(w(S)){if(typeof L!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(c(S)){try{if(L instanceof S)return}catch{}if(!I(L)&&L.constructor===S||S.length===1&&S.call(void 0,L)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=l;function p(L){return L===null?void 0:L}t.withNullAsUndefined=p;function _(L){return typeof L>"u"?null:L}t.withUndefinedAsNull=_}),define(pe[27],be([1,0,6]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const m=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([s,l])=>{m[s]=l&&typeof l=="object"?i(l):l}),m}t.deepClone=i;function B(c){if(!c||typeof c!="object")return c;const m=[c];for(;m.length>0;){const s=m.shift();Object.freeze(s);for(const l in s)if(H.call(s,l)){const p=s[l];typeof p=="object"&&!Object.isFrozen(p)&&!(0,w.isTypedArray)(p)&&m.push(p)}}return c}t.deepFreeze=B;const H=Object.prototype.hasOwnProperty;function y(c,m){return v(c,m,new Set)}t.cloneAndChange=y;function v(c,m,s){if((0,w.isUndefinedOrNull)(c))return c;const l=m(c);if(typeof l<"u")return l;if(Array.isArray(c)){const p=[];for(const _ of c)p.push(v(_,m,s));return p}if((0,w.isObject)(c)){if(s.has(c))throw new Error("Cannot clone recursive data-structure");s.add(c);const p={};for(const _ in c)H.call(c,_)&&(p[_]=v(c[_],m,s));return s.delete(c),p}return c}function h(c,m,s=!0){return(0,w.isObject)(c)?((0,w.isObject)(m)&&Object.keys(m).forEach(l=>{l in c?s&&((0,w.isObject)(c[l])&&(0,w.isObject)(m[l])?h(c[l],m[l],s):c[l]=m[l]):c[l]=m[l]}),c):m}t.mixin=h;function g(c,m){if(c===m)return!0;if(c==null||m===null||m===void 0||typeof c!=typeof m||typeof c!="object"||Array.isArray(c)!==Array.isArray(m))return!1;let s,l;if(Array.isArray(c)){if(c.length!==m.length)return!1;for(s=0;s<c.length;s++)if(!g(c[s],m[s]))return!1}else{const p=[];for(l in c)p.push(l);p.sort();const _=[];for(l in m)_.push(l);if(_.sort(),!g(p,_))return!1;for(s=0;s<p.length;s++)if(!g(c[p[s]],m[p[s]]))return!1}return!0}t.equals=g;function f(c){const m=new Set;return JSON.stringify(c,(s,l)=>{if((0,w.isObject)(l)||Array.isArray(l)){if(m.has(l))return"[Circular]";m.add(l)}return l})}t.safeStringify=f;function I(c,m){const s=Object.create(null);return!c||!m||Object.keys(m).forEach(p=>{const _=c[p],L=m[p];g(_,L)||(s[p]=L)}),s}t.distinct=I;function o(c,m){const s=m.toLowerCase(),l=Object.keys(c).find(p=>p.toLowerCase()===s);return l?c[l]:c[m]}t.getCaseInsensitive=o;function n(c,m){const s=Object.create(null);for(const[l,p]of Object.entries(c))m(l,p)&&(s[l]=p);return s}t.filter=n;function e(c){let m=[],s=Object.getPrototypeOf(c);for(;Object.prototype!==s;)m=m.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return m}t.getAllPropertyNames=e;function r(c){const m=[];for(const s of e(c))typeof c[s]=="function"&&m.push(s);return m}t.getAllMethodNames=r;function a(c,m){const s=p=>function(){const _=Array.prototype.slice.call(arguments,0);return m(p,_)},l={};for(const p of c)l[p]=s(p);return l}t.createProxyObject=a}),define(pe[80],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(pe[81],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class w{constructor(B,H){this.sender=B,this.onMessage=H}send(B){try{this.sender.send("vscode:message",B.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=w}),define(pe[48],be([7]),{}),define(pe[82],be([7]),{}),define(pe[83],be([7]),{}),define(pe[84],be([7]),{}),define(pe[85],be([1,0,12,83,84]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(B){let H=B.definition;for(;H instanceof w.Codicon;)H=H.definition;return`.codicon-${B.id}:before { content: '${H.fontCharacter}'; }`}t.formatRule=i}),define(pe[86],be([7]),{}),define(pe[87],be([7]),{}),define(pe[88],be([7]),{}),define(pe[89],be([7]),{}),define(pe[90],be([7]),{}),define(pe[91],be([7]),{}),define(pe[92],be([7]),{}),define(pe[93],be([7]),{}),define(pe[94],be([7]),{}),define(pe[95],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(pe[96],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInput",t)}),define(pe[97],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(pe[98],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(pe[99],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(pe[100],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(pe[101],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/tree/abstractTree",t)}),define(pe[102],be([13,10]),function(Z,t){return Z.create("vs/base/common/actions",t)}),define(pe[103],be([13,10]),function(Z,t){return Z.create("vs/base/common/platform",t)}),define(pe[5],be([1,0,103]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,B=!1,H=!1,y=!1,v=!1,h=!1,g=!1,f=!1,I=!1,o=!1,n,e=t.LANGUAGE_DEFAULT,r,a;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?c=t.globals.vscode.process:typeof process<"u"&&(c=process);const m=typeof c?.versions?.electron=="string",s=m&&c?.type==="renderer";if(typeof navigator=="object"&&!s)a=navigator.userAgent,i=a.indexOf("Windows")>=0,B=a.indexOf("Macintosh")>=0,f=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=a.indexOf("Linux")>=0,o=a?.indexOf("Mobi")>=0,h=!0,n=w.getConfiguredDefaultLocale(w.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof c=="object"){i=c.platform==="win32",B=c.platform==="darwin",H=c.platform==="linux",y=H&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,g=m,I=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const b=c.env.VSCODE_NLS_CONFIG;if(b)try{const D=JSON.parse(b),z=D.availableLanguages["*"];n=D.locale,e=z||t.LANGUAGE_DEFAULT,r=D._translationsConfigFile}catch{}v=!0}else console.error("Unable to resolve platform.");var l;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(l=t.Platform||(t.Platform={}));function p(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=p;let _=0;B?_=1:i?_=3:H&&(_=2),t.isWindows=i,t.isMacintosh=B,t.isLinux=H,t.isLinuxSnap=y,t.isNative=v,t.isElectron=g,t.isWeb=h,t.isWebWorker=h&&typeof t.globals.importScripts=="function",t.isIOS=f,t.isMobile=o,t.isCI=I,t.platform=_,t.userAgent=a,t.language=e;var L;(function(b){function D(){return t.language}b.value=D;function z(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}b.isDefaultVariant=z;function x(){return t.language==="en"}b.isDefault=x})(L=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=r,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const b=[];t.globals.addEventListener("message",z=>{if(z.data&&z.data.vscodeScheduleAsyncWork)for(let x=0,ie=b.length;x<ie;x++){const Q=b[x];if(Q.id===z.data.vscodeScheduleAsyncWork){b.splice(x,1),Q.callback();return}}});let D=0;return z=>{const x=++D;b.push({id:x,callback:z}),t.globals.postMessage({vscodeScheduleAsyncWork:x},"*")}}return b=>setTimeout(b)})();var S;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(S=t.OperatingSystem||(t.OperatingSystem={})),t.OS=B||f?2:i?1:3;let A=!0,u=!1;function E(){if(!u){u=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,A=new Uint16Array(b.buffer)[0]===(2<<8)+1}return A}t.isLittleEndian=E,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(pe[104],be([1,0,5]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const B=w.globals.vscode.process;i={get platform(){return B.platform},get arch(){return B.arch},get env(){return B.env},cwd(){return B.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(pe[21],be([1,0,104]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,B=97,H=90,y=122,v=46,h=47,g=92,f=58,I=63;class o extends Error{constructor(l,p,_){let L;typeof p=="string"&&p.indexOf("not ")===0?(L="must not be",p=p.replace(/^not /,"")):L="must be";const S=l.indexOf(".")!==-1?"property":"argument";let A=`The "${l}" ${S} ${L} of type ${p}`;A+=`. Received type ${typeof _}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function n(s,l){if(typeof s!="string")throw new o(l,"string",s)}function e(s){return s===h||s===g}function r(s){return s===h}function a(s){return s>=i&&s<=H||s>=B&&s<=y}function c(s,l,p,_){let L="",S=0,A=-1,u=0,E=0;for(let b=0;b<=s.length;++b){if(b<s.length)E=s.charCodeAt(b);else{if(_(E))break;E=h}if(_(E)){if(!(A===b-1||u===1))if(u===2){if(L.length<2||S!==2||L.charCodeAt(L.length-1)!==v||L.charCodeAt(L.length-2)!==v){if(L.length>2){const D=L.lastIndexOf(p);D===-1?(L="",S=0):(L=L.slice(0,D),S=L.length-1-L.lastIndexOf(p)),A=b,u=0;continue}else if(L.length!==0){L="",S=0,A=b,u=0;continue}}l&&(L+=L.length>0?`${p}..`:"..",S=2)}else L.length>0?L+=`${p}${s.slice(A+1,b)}`:L=s.slice(A+1,b),S=b-A-1;A=b,u=0}else E===v&&u!==-1?++u:u=-1}return L}function m(s,l){if(l===null||typeof l!="object")throw new o("pathObject","Object",l);const p=l.dir||l.root,_=l.base||`${l.name||""}${l.ext||""}`;return p?p===l.root?`${p}${_}`:`${p}${s}${_}`:_}t.win32={resolve(...s){let l="",p="",_=!1;for(let L=s.length-1;L>=-1;L--){let S;if(L>=0){if(S=s[L],n(S,"path"),S.length===0)continue}else l.length===0?S=w.cwd():(S=w.env[`=${l}`]||w.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==l.toLowerCase()&&S.charCodeAt(2)===g)&&(S=`${l}\\`));const A=S.length;let u=0,E="",b=!1;const D=S.charCodeAt(0);if(A===1)e(D)&&(u=1,b=!0);else if(e(D))if(b=!0,e(S.charCodeAt(1))){let z=2,x=z;for(;z<A&&!e(S.charCodeAt(z));)z++;if(z<A&&z!==x){const ie=S.slice(x,z);for(x=z;z<A&&e(S.charCodeAt(z));)z++;if(z<A&&z!==x){for(x=z;z<A&&!e(S.charCodeAt(z));)z++;(z===A||z!==x)&&(E=`\\\\${ie}\\${S.slice(x,z)}`,u=z)}}}else u=1;else a(D)&&S.charCodeAt(1)===f&&(E=S.slice(0,2),u=2,A>2&&e(S.charCodeAt(2))&&(b=!0,u=3));if(E.length>0)if(l.length>0){if(E.toLowerCase()!==l.toLowerCase())continue}else l=E;if(_){if(l.length>0)break}else if(p=`${S.slice(u)}\\${p}`,_=b,b&&l.length>0)break}return p=c(p,!_,"\\",e),_?`${l}\\${p}`:`${l}${p}`||"."},normalize(s){n(s,"path");const l=s.length;if(l===0)return".";let p=0,_,L=!1;const S=s.charCodeAt(0);if(l===1)return r(S)?"\\":s;if(e(S))if(L=!0,e(s.charCodeAt(1))){let u=2,E=u;for(;u<l&&!e(s.charCodeAt(u));)u++;if(u<l&&u!==E){const b=s.slice(E,u);for(E=u;u<l&&e(s.charCodeAt(u));)u++;if(u<l&&u!==E){for(E=u;u<l&&!e(s.charCodeAt(u));)u++;if(u===l)return`\\\\${b}\\${s.slice(E)}\\`;u!==E&&(_=`\\\\${b}\\${s.slice(E,u)}`,p=u)}}}else p=1;else a(S)&&s.charCodeAt(1)===f&&(_=s.slice(0,2),p=2,l>2&&e(s.charCodeAt(2))&&(L=!0,p=3));let A=p<l?c(s.slice(p),!L,"\\",e):"";return A.length===0&&!L&&(A="."),A.length>0&&e(s.charCodeAt(l-1))&&(A+="\\"),_===void 0?L?`\\${A}`:A:L?`${_}\\${A}`:`${_}${A}`},isAbsolute(s){n(s,"path");const l=s.length;if(l===0)return!1;const p=s.charCodeAt(0);return e(p)||l>2&&a(p)&&s.charCodeAt(1)===f&&e(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let l,p;for(let S=0;S<s.length;++S){const A=s[S];n(A,"path"),A.length>0&&(l===void 0?l=p=A:l+=`\\${A}`)}if(l===void 0)return".";let _=!0,L=0;if(typeof p=="string"&&e(p.charCodeAt(0))){++L;const S=p.length;S>1&&e(p.charCodeAt(1))&&(++L,S>2&&(e(p.charCodeAt(2))?++L:_=!1))}if(_){for(;L<l.length&&e(l.charCodeAt(L));)L++;L>=2&&(l=`\\${l.slice(L)}`)}return t.win32.normalize(l)},relative(s,l){if(n(s,"from"),n(l,"to"),s===l)return"";const p=t.win32.resolve(s),_=t.win32.resolve(l);if(p===_||(s=p.toLowerCase(),l=_.toLowerCase(),s===l))return"";let L=0;for(;L<s.length&&s.charCodeAt(L)===g;)L++;let S=s.length;for(;S-1>L&&s.charCodeAt(S-1)===g;)S--;const A=S-L;let u=0;for(;u<l.length&&l.charCodeAt(u)===g;)u++;let E=l.length;for(;E-1>u&&l.charCodeAt(E-1)===g;)E--;const b=E-u,D=A<b?A:b;let z=-1,x=0;for(;x<D;x++){const Q=s.charCodeAt(L+x);if(Q!==l.charCodeAt(u+x))break;Q===g&&(z=x)}if(x!==D){if(z===-1)return _}else{if(b>D){if(l.charCodeAt(u+x)===g)return _.slice(u+x+1);if(x===2)return _.slice(u+x)}A>D&&(s.charCodeAt(L+x)===g?z=x:x===2&&(z=3)),z===-1&&(z=0)}let ie="";for(x=L+z+1;x<=S;++x)(x===S||s.charCodeAt(x)===g)&&(ie+=ie.length===0?"..":"\\..");return u+=z,ie.length>0?`${ie}${_.slice(u,E)}`:(_.charCodeAt(u)===g&&++u,_.slice(u,E))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const l=t.win32.resolve(s);if(l.length<=2)return s;if(l.charCodeAt(0)===g){if(l.charCodeAt(1)===g){const p=l.charCodeAt(2);if(p!==I&&p!==v)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(a(l.charCodeAt(0))&&l.charCodeAt(1)===f&&l.charCodeAt(2)===g)return`\\\\?\\${l}`;return s},dirname(s){n(s,"path");const l=s.length;if(l===0)return".";let p=-1,_=0;const L=s.charCodeAt(0);if(l===1)return e(L)?s:".";if(e(L)){if(p=_=1,e(s.charCodeAt(1))){let u=2,E=u;for(;u<l&&!e(s.charCodeAt(u));)u++;if(u<l&&u!==E){for(E=u;u<l&&e(s.charCodeAt(u));)u++;if(u<l&&u!==E){for(E=u;u<l&&!e(s.charCodeAt(u));)u++;if(u===l)return s;u!==E&&(p=_=u+1)}}}}else a(L)&&s.charCodeAt(1)===f&&(p=l>2&&e(s.charCodeAt(2))?3:2,_=p);let S=-1,A=!0;for(let u=l-1;u>=_;--u)if(e(s.charCodeAt(u))){if(!A){S=u;break}}else A=!1;if(S===-1){if(p===-1)return".";S=p}return s.slice(0,S)},basename(s,l){l!==void 0&&n(l,"ext"),n(s,"path");let p=0,_=-1,L=!0,S;if(s.length>=2&&a(s.charCodeAt(0))&&s.charCodeAt(1)===f&&(p=2),l!==void 0&&l.length>0&&l.length<=s.length){if(l===s)return"";let A=l.length-1,u=-1;for(S=s.length-1;S>=p;--S){const E=s.charCodeAt(S);if(e(E)){if(!L){p=S+1;break}}else u===-1&&(L=!1,u=S+1),A>=0&&(E===l.charCodeAt(A)?--A===-1&&(_=S):(A=-1,_=u))}return p===_?_=u:_===-1&&(_=s.length),s.slice(p,_)}for(S=s.length-1;S>=p;--S)if(e(s.charCodeAt(S))){if(!L){p=S+1;break}}else _===-1&&(L=!1,_=S+1);return _===-1?"":s.slice(p,_)},extname(s){n(s,"path");let l=0,p=-1,_=0,L=-1,S=!0,A=0;s.length>=2&&s.charCodeAt(1)===f&&a(s.charCodeAt(0))&&(l=_=2);for(let u=s.length-1;u>=l;--u){const E=s.charCodeAt(u);if(e(E)){if(!S){_=u+1;break}continue}L===-1&&(S=!1,L=u+1),E===v?p===-1?p=u:A!==1&&(A=1):p!==-1&&(A=-1)}return p===-1||L===-1||A===0||A===1&&p===L-1&&p===_+1?"":s.slice(p,L)},format:m.bind(null,"\\"),parse(s){n(s,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return l;const p=s.length;let _=0,L=s.charCodeAt(0);if(p===1)return e(L)?(l.root=l.dir=s,l):(l.base=l.name=s,l);if(e(L)){if(_=1,e(s.charCodeAt(1))){let z=2,x=z;for(;z<p&&!e(s.charCodeAt(z));)z++;if(z<p&&z!==x){for(x=z;z<p&&e(s.charCodeAt(z));)z++;if(z<p&&z!==x){for(x=z;z<p&&!e(s.charCodeAt(z));)z++;z===p?_=z:z!==x&&(_=z+1)}}}}else if(a(L)&&s.charCodeAt(1)===f){if(p<=2)return l.root=l.dir=s,l;if(_=2,e(s.charCodeAt(2))){if(p===3)return l.root=l.dir=s,l;_=3}}_>0&&(l.root=s.slice(0,_));let S=-1,A=_,u=-1,E=!0,b=s.length-1,D=0;for(;b>=_;--b){if(L=s.charCodeAt(b),e(L)){if(!E){A=b+1;break}continue}u===-1&&(E=!1,u=b+1),L===v?S===-1?S=b:D!==1&&(D=1):S!==-1&&(D=-1)}return u!==-1&&(S===-1||D===0||D===1&&S===u-1&&S===A+1?l.base=l.name=s.slice(A,u):(l.name=s.slice(A,S),l.base=s.slice(A,u),l.ext=s.slice(S,u))),A>0&&A!==_?l.dir=s.slice(0,A-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...s){let l="",p=!1;for(let _=s.length-1;_>=-1&&!p;_--){const L=_>=0?s[_]:w.cwd();n(L,"path"),L.length!==0&&(l=`${L}/${l}`,p=L.charCodeAt(0)===h)}return l=c(l,!p,"/",r),p?`/${l}`:l.length>0?l:"."},normalize(s){if(n(s,"path"),s.length===0)return".";const l=s.charCodeAt(0)===h,p=s.charCodeAt(s.length-1)===h;return s=c(s,!l,"/",r),s.length===0?l?"/":p?"./":".":(p&&(s+="/"),l?`/${s}`:s)},isAbsolute(s){return n(s,"path"),s.length>0&&s.charCodeAt(0)===h},join(...s){if(s.length===0)return".";let l;for(let p=0;p<s.length;++p){const _=s[p];n(_,"path"),_.length>0&&(l===void 0?l=_:l+=`/${_}`)}return l===void 0?".":t.posix.normalize(l)},relative(s,l){if(n(s,"from"),n(l,"to"),s===l||(s=t.posix.resolve(s),l=t.posix.resolve(l),s===l))return"";const p=1,_=s.length,L=_-p,S=1,A=l.length-S,u=L<A?L:A;let E=-1,b=0;for(;b<u;b++){const z=s.charCodeAt(p+b);if(z!==l.charCodeAt(S+b))break;z===h&&(E=b)}if(b===u)if(A>u){if(l.charCodeAt(S+b)===h)return l.slice(S+b+1);if(b===0)return l.slice(S+b)}else L>u&&(s.charCodeAt(p+b)===h?E=b:b===0&&(E=0));let D="";for(b=p+E+1;b<=_;++b)(b===_||s.charCodeAt(b)===h)&&(D+=D.length===0?"..":"/..");return`${D}${l.slice(S+E)}`},toNamespacedPath(s){return s},dirname(s){if(n(s,"path"),s.length===0)return".";const l=s.charCodeAt(0)===h;let p=-1,_=!0;for(let L=s.length-1;L>=1;--L)if(s.charCodeAt(L)===h){if(!_){p=L;break}}else _=!1;return p===-1?l?"/":".":l&&p===1?"//":s.slice(0,p)},basename(s,l){l!==void 0&&n(l,"ext"),n(s,"path");let p=0,_=-1,L=!0,S;if(l!==void 0&&l.length>0&&l.length<=s.length){if(l===s)return"";let A=l.length-1,u=-1;for(S=s.length-1;S>=0;--S){const E=s.charCodeAt(S);if(E===h){if(!L){p=S+1;break}}else u===-1&&(L=!1,u=S+1),A>=0&&(E===l.charCodeAt(A)?--A===-1&&(_=S):(A=-1,_=u))}return p===_?_=u:_===-1&&(_=s.length),s.slice(p,_)}for(S=s.length-1;S>=0;--S)if(s.charCodeAt(S)===h){if(!L){p=S+1;break}}else _===-1&&(L=!1,_=S+1);return _===-1?"":s.slice(p,_)},extname(s){n(s,"path");let l=-1,p=0,_=-1,L=!0,S=0;for(let A=s.length-1;A>=0;--A){const u=s.charCodeAt(A);if(u===h){if(!L){p=A+1;break}continue}_===-1&&(L=!1,_=A+1),u===v?l===-1?l=A:S!==1&&(S=1):l!==-1&&(S=-1)}return l===-1||_===-1||S===0||S===1&&l===_-1&&l===p+1?"":s.slice(l,_)},format:m.bind(null,"/"),parse(s){n(s,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return l;const p=s.charCodeAt(0)===h;let _;p?(l.root="/",_=1):_=0;let L=-1,S=0,A=-1,u=!0,E=s.length-1,b=0;for(;E>=_;--E){const D=s.charCodeAt(E);if(D===h){if(!u){S=E+1;break}continue}A===-1&&(u=!1,A=E+1),D===v?L===-1?L=E:b!==1&&(b=1):L!==-1&&(b=-1)}if(A!==-1){const D=S===0&&p?1:S;L===-1||b===0||b===1&&L===A-1&&L===S+1?l.base=l.name=s.slice(D,A):(l.name=s.slice(D,L),l.base=s.slice(D,A),l.ext=s.slice(L,A))}return S>0?l.dir=s.slice(0,S-1):p&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=w.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=w.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=w.platform==="win32"?t.win32.join:t.posix.join,t.resolve=w.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=w.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=w.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=w.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=w.platform==="win32"?t.win32.extname:t.posix.extname,t.format=w.platform==="win32"?t.win32.format:t.posix.format,t.parse=w.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=w.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=w.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=w.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(pe[105],be([1,0,21]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(f){const I=(0,w.extname)(f),o=i[I.toLowerCase()];return o!==void 0?o:y(f)}t.getMediaOrTextMime=H;function y(f){const I=(0,w.extname)(f);return B[I.toLowerCase()]}t.getMediaMime=y;function v(f){for(const I in B)if(B[I]===f)return I}t.getExtensionForMimeType=v;const h=/^(.+)\/(.+?)(;.+)?$/;function g(f,I){const o=h.exec(f);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:I?void 0:f}t.normalizeMimeType=g}),define(pe[106],be([1,0,5]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=w.globals.performance&&typeof w.globals.performance.now=="function";class B{static create(y=!0){return new B(y)}constructor(y){this._highResolution=i&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}t.StopWatch=B}),define(pe[3],be([1,0,9,42,2,45,106]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const v=!1,h=!1;var g;(function(E){E.None=()=>B.Disposable.None;function b(d){if(h){const{onListenerDidAdd:F}=d,U=e.create();let $=0;d.onListenerDidAdd=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),F?.()}}}function D(d){return(F,U=null,$)=>{let X=!1,N;return N=d(R=>{if(!X)return N?N.dispose():X=!0,F.call(U,R)},null,$),X&&N.dispose(),N}}E.once=D;function z(d,F,U){return fe(($,X=null,N)=>d(R=>$.call(X,F(R)),null,N),U)}E.map=z;function x(d,F,U){return fe(($,X=null,N)=>d(R=>{F(R),$.call(X,R)},null,N),U)}E.forEach=x;function ie(d,F,U){return fe(($,X=null,N)=>d(R=>F(R)&&$.call(X,R),null,N),U)}E.filter=ie;function Q(d){return d}E.signal=Q;function me(...d){return(F,U=null,$)=>(0,B.combinedDisposable)(...d.map(X=>X(N=>F.call(U,N),null,$)))}E.any=me;function ae(d,F,U,$){let X=U;return z(d,N=>(X=F(X,N),X),$)}E.reduce=ae;function fe(d,F){let U;const $={onFirstListenerAdd(){U=d(X.fire,X)},onLastListenerRemove(){U?.dispose()}};F||b($);const X=new a($);return F?.add(X),X.event}function le(d,F,U=100,$=!1,X,N){let R,W,C,k=0;const M={leakWarningThreshold:X,onFirstListenerAdd(){R=d(K=>{k++,W=F(W,K),$&&!C&&(O.fire(W),W=void 0),clearTimeout(C),C=setTimeout(()=>{const J=W;W=void 0,C=void 0,(!$||k>1)&&O.fire(J),k=0},U)})},onLastListenerRemove(){R.dispose()}};N||b(M);const O=new a(M);return N?.add(O),O.event}E.debounce=le;function de(d,F=($,X)=>$===X,U){let $=!0,X;return ie(d,N=>{const R=$||!F(N,X);return $=!1,X=N,R},U)}E.latch=de;function Se(d,F,U){return[E.filter(d,F,U),E.filter(d,$=>!F($),U)]}E.split=Se;function ee(d,F=!1,U=[]){let $=U.slice(),X=d(W=>{$?$.push(W):R.fire(W)});const N=()=>{$?.forEach(W=>R.fire(W)),$=null},R=new a({onFirstListenerAdd(){X||(X=d(W=>R.fire(W)))},onFirstListenerDidAdd(){$&&(F?setTimeout(N):N())},onLastListenerRemove(){X&&X.dispose(),X=null}});return R.event}E.buffer=ee;class ye{constructor(F){this.event=F,this.disposables=new B.DisposableStore}map(F){return new ye(z(this.event,F,this.disposables))}forEach(F){return new ye(x(this.event,F,this.disposables))}filter(F){return new ye(ie(this.event,F,this.disposables))}reduce(F,U){return new ye(ae(this.event,F,U,this.disposables))}latch(){return new ye(de(this.event,void 0,this.disposables))}debounce(F,U=100,$=!1,X){return new ye(le(this.event,F,U,$,X,this.disposables))}on(F,U,$){return this.event(F,U,$)}once(F,U,$){return D(this.event)(F,U,$)}dispose(){this.disposables.dispose()}}function se(d){return new ye(d)}E.chain=se;function te(d,F,U=$=>$){const $=(...W)=>R.fire(U(...W)),X=()=>d.on(F,$),N=()=>d.removeListener(F,$),R=new a({onFirstListenerAdd:X,onLastListenerRemove:N});return R.event}E.fromNodeEventEmitter=te;function ce(d,F,U=$=>$){const $=(...W)=>R.fire(U(...W)),X=()=>d.addEventListener(F,$),N=()=>d.removeEventListener(F,$),R=new a({onFirstListenerAdd:X,onLastListenerRemove:N});return R.event}E.fromDOMEventEmitter=ce;function ne(d){return new Promise(F=>D(d)(F))}E.toPromise=ne;function T(d,F){return F(void 0),d(U=>F(U))}E.runAndSubscribe=T;function V(d,F){let U=null;function $(N){U?.dispose(),U=new B.DisposableStore,F(N,U)}$(void 0);const X=d(N=>$(N));return(0,B.toDisposable)(()=>{X.dispose(),U?.dispose()})}E.runAndSubscribeWithStore=V;class j{constructor(F,U){this.obs=F,this._counter=0,this._hasChanged=!1;const $={onFirstListenerAdd:()=>{F.addObserver(this)},onLastListenerRemove:()=>{F.removeObserver(this)}};U||b($),this.emitter=new a($),U&&U.add(this.emitter)}beginUpdate(F){this._counter++}handleChange(F,U){this._hasChanged=!0}endUpdate(F){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function P(d,F){return new j(d,F).emitter.event}E.fromObservable=P})(g=t.Event||(t.Event={}));class f{constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${f._idPool++}`,f.all.add(this)}start(b){this._stopWatch=new y.StopWatch(!0),this.listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=f,f.all=new Set,f._idPool=0;let I=-1;function o(E){const b=I;return I=E,{dispose(){I=b}}}t.setGlobalLeakWarningThreshold=o;class n{constructor(b,D=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=D,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b,D){let z=I;if(typeof this.customThreshold=="number"&&(z=this.customThreshold),z<=0||D<z)return;this._stacks||(this._stacks=new Map);const x=this._stacks.get(b.value)||0;if(this._stacks.set(b.value,x+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;let ie,Q=0;for(const[me,ae]of this._stacks)(!ie||Q<ae)&&(ie=me,Q=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${Q}):`),console.warn(ie)}return()=>{const ie=this._stacks.get(b.value)||0;this._stacks.set(b.value,ie-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class r{constructor(b,D,z){this.callback=b,this.callbackThis=D,this.stack=z,this.subscription=new B.SafeDisposable}invoke(b){this.callback.call(this.callbackThis,b)}}class a{constructor(b){this._disposed=!1,this._options=b,this._leakageMon=I>0?new n(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(v){const b=Array.from(this._listeners);queueMicrotask(()=>{for(const D of b)D.subscription.isset()&&(D.subscription.unset(),D.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(b,D,z)=>{this._listeners||(this._listeners=new H.LinkedList);const x=this._listeners.isEmpty();x&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let ie,Q;this._leakageMon&&this._listeners.size>=30&&(Q=e.create(),ie=this._leakageMon.check(Q,this._listeners.size+1)),v&&(Q=Q??e.create());const me=new r(b,D,Q),ae=this._listeners.push(me);x&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,D);const fe=me.subscription.set(()=>{ie?.(),this._disposed||(ae(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return z instanceof B.DisposableStore?z.add(fe):Array.isArray(z)&&z.push(fe),fe}),this._event}fire(b){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const D of this._listeners)this._deliveryQueue.push(this,D,b);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=a;class c{constructor(){this._queue=new H.LinkedList}get size(){return this._queue.size}push(b,D,z){this._queue.push(new s(b,D,z))}clear(b){const D=new H.LinkedList;for(const z of this._queue)z.emitter!==b&&D.push(z);this._queue=D}deliver(){for(;this._queue.size>0;){const b=this._queue.shift();try{b.listener.invoke(b.event)}catch(D){(0,w.onUnexpectedError)(D)}}}}t.EventDeliveryQueue=c;class m extends c{clear(b){this._queue.clear()}}class s{constructor(b,D,z){this.emitter=b,this.listener=D,this.event=z}}class l extends a{async fireAsync(b,D,z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new H.LinkedList);for(const x of this._listeners)this._asyncDeliveryQueue.push([x,b]);for(;this._asyncDeliveryQueue.size>0&&!D.isCancellationRequested;){const[x,ie]=this._asyncDeliveryQueue.shift(),Q=[],me={...ie,token:D,waitUntil:ae=>{if(Object.isFrozen(Q))throw new Error("waitUntil can NOT be called asynchronous");z&&(ae=z(ae,x.callback)),Q.push(ae)}};try{x.invoke(me)}catch(ae){(0,w.onUnexpectedError)(ae);continue}Object.freeze(Q),await Promise.allSettled(Q).then(ae=>{for(const fe of ae)fe.status==="rejected"&&(0,w.onUnexpectedError)(fe.reason)})}}}}t.AsyncEmitter=l;class p extends a{constructor(b){super(b),this._isPaused=0,this._eventQueue=new H.LinkedList,this._mergeFn=b?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}t.PauseableEmitter=p;class _ extends p{constructor(b){super(b),this._delay=b.delay??100}fire(b){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(b)}}t.DebounceEmitter=_;class L extends a{constructor(b){super(b),this._queuedEvents=[],this._mergeFn=b?.merge}fire(b){!this.hasListeners()||(this._queuedEvents.push(b),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(D=>super.fire(D)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=L;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const D={event:b,listener:null};this.events.push(D),this.hasListeners&&this.hook(D);const z=()=>{this.hasListeners&&this.unhook(D);const x=this.events.indexOf(D);this.events.splice(x,1)};return(0,B.toDisposable)((0,i.once)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(D=>this.emitter.fire(D))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=S;class A{constructor(){this.buffers=[]}wrapEvent(b){return(D,z,x)=>b(ie=>{const Q=this.buffers[this.buffers.length-1];Q?Q.push(()=>D.call(z,ie)):D.call(z,ie)},void 0,x)}bufferEvents(b){const D=[];this.buffers.push(D);const z=b();return this.buffers.pop(),D.forEach(x=>x()),z}}t.EventBufferer=A;class u{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=B.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=u}),define(pe[16],be([1,0,3,2]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class B{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new w.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(s,l){this._zoomLevel!==s&&(this._zoomLevel=s)}getZoomFactor(){return this._zoomFactor}setZoomFactor(s){this._zoomFactor=s}setFullscreen(s){this._fullscreen!==s&&(this._fullscreen=s,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}B.INSTANCE=new B;class H extends i.Disposable{constructor(){super(),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(s){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),s&&this._onDidChange.fire()}}class y extends i.Disposable{get value(){return this._value}constructor(){super(),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const s=this._register(new H);this._register(s.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}_getPixelRatio(){const s=document.createElement("canvas").getContext("2d"),l=window.devicePixelRatio||1,p=s.webkitBackingStorePixelRatio||s.mozBackingStorePixelRatio||s.msBackingStorePixelRatio||s.oBackingStorePixelRatio||s.backingStorePixelRatio||1;return l/p}}class v{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new y)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function h(m,s){typeof m=="string"&&(m=window.matchMedia(m)),m.addEventListener("change",s)}t.addMatchMediaChangeListener=h,t.PixelRatio=new v;function g(m,s){B.INSTANCE.setZoomLevel(m,s)}t.setZoomLevel=g;function f(){return B.INSTANCE.getZoomLevel()}t.getZoomLevel=f;function I(){return B.INSTANCE.getZoomFactor()}t.getZoomFactor=I;function o(m){B.INSTANCE.setZoomFactor(m)}t.setZoomFactor=o;function n(m){B.INSTANCE.setFullscreen(m)}t.setFullscreen=n;function e(){return B.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=B.INSTANCE.onDidChangeFullscreen;const r=navigator.userAgent;t.isFirefox=r.indexOf("Firefox")>=0,t.isWebKit=r.indexOf("AppleWebKit")>=0,t.isChrome=r.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&r.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=r.indexOf("Electron/")>=0,t.isAndroid=r.indexOf("Android")>=0;let a=!1;if(window.matchMedia){const m=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),s=window.matchMedia("(display-mode: fullscreen)");a=m.matches,h(m,({matches:l})=>{a&&s.matches||(a=l)})}function c(){return a}t.isStandalone=c}),define(pe[107],be([1,0,16,5]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var B;(function(H){H[H.Always=0]="Always",H[H.FullScreen=1]="FullScreen",H[H.None=2]="None"})(B=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||w.isStandalone()?0:navigator.keyboard||w.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(pe[18],be([1,0,3]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.emitter.event}constructor(H,y,v){const h=g=>this.emitter.fire(g);this.emitter=new w.Emitter({onFirstListenerAdd:()=>H.addEventListener(y,h,v),onLastListenerRemove:()=>H.removeEventListener(y,h,v)})}dispose(){this.emitter.dispose()}}t.DomEmitter=i}),define(pe[19],be([1,0,16,43,73,5]),function(Z,t,w,i,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const a=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(a)}const r=e.keyCode;if(r===3)return 7;if(w.isFirefox){if(r===59)return 80;if(r===107)return 81;if(r===109)return 83;if(H.isMacintosh&&r===224)return 57}else if(w.isWebKit){if(r===91)return 57;if(H.isMacintosh&&r===93)return 57;if(!H.isMacintosh&&r===92)return 57}return i.EVENT_KEY_CODE_MAP[r]||0}const v=H.isMacintosh?256:2048,h=512,g=1024,f=H.isMacintosh?2048:256;function I(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=I;function o(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class n{constructor(r){this._standardKeyboardEventBrand=!0;const a=r;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.keyCode=y(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(r){return this._asKeybinding===r}_computeKeybinding(){let r=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode);let a=0;return this.ctrlKey&&(a|=v),this.altKey&&(a|=h),this.shiftKey&&(a|=g),this.metaKey&&(a|=f),a|=r,a}_computeRuntimeKeybinding(){let r=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode),new B.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,r)}}t.StandardKeyboardEvent=n}),define(pe[20],be([1,0,16,66,5]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class H{constructor(g){this.timestamp=Date.now(),this.browserEvent=g,this.leftButton=g.button===0,this.middleButton=g.button===1,this.rightButton=g.button===2,this.buttons=g.buttons,this.target=g.target,this.detail=g.detail||1,g.type==="dblclick"&&(this.detail=2),this.ctrlKey=g.ctrlKey,this.shiftKey=g.shiftKey,this.altKey=g.altKey,this.metaKey=g.metaKey,typeof g.pageX=="number"?(this.posx=g.pageX,this.posy=g.pageY):(this.posx=g.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=g.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,g.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=H;class y extends H{constructor(g){super(g),this.dataTransfer=g.dataTransfer}}t.DragMouseEvent=y;class v{constructor(g,f=0,I=0){if(this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=I,this.deltaX=f,g){const o=g,n=g;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(g.type==="wheel"){const e=g;e.deltaMode===e.DOM_DELTA_LINE?w.isFirefox&&!B.isMacintosh?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof o.wheelDeltaX<"u")w.isSafari&&B.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const e=g;e.deltaMode===e.DOM_DELTA_LINE?w.isFirefox&&!B.isMacintosh?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=v}),define(pe[32],be([1,0,3,2,102]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class H extends i.Disposable{constructor(o,n="",e="",r=!0,a){super(),this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=o,this._label=n,this._cssClass=e,this._enabled=r,this._actionCallback=a}get id(){return this._id}get label(){return this._label}set label(o){this._setLabel(o)}_setLabel(o){this._label!==o&&(this._label=o,this._onDidChange.fire({label:o}))}get tooltip(){return this._tooltip||""}set tooltip(o){this._setTooltip(o)}_setTooltip(o){this._tooltip!==o&&(this._tooltip=o,this._onDidChange.fire({tooltip:o}))}get class(){return this._cssClass}set class(o){this._setClass(o)}_setClass(o){this._cssClass!==o&&(this._cssClass=o,this._onDidChange.fire({class:o}))}get enabled(){return this._enabled}set enabled(o){this._setEnabled(o)}_setEnabled(o){this._enabled!==o&&(this._enabled=o,this._onDidChange.fire({enabled:o}))}get checked(){return this._checked}set checked(o){this._setChecked(o)}_setChecked(o){this._checked!==o&&(this._checked=o,this._onDidChange.fire({checked:o}))}async run(o,n){this._actionCallback&&await this._actionCallback(o)}}t.Action=H;class y extends i.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new w.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new w.Emitter),this.onDidRun=this._onDidRun.event}async run(o,n){if(!o.enabled)return;this._onWillRun.fire({action:o});let e;try{await this.runAction(o,n)}catch(r){e=r}this._onDidRun.fire({action:o,error:e})}async runAction(o,n){await o.run(n)}}t.ActionRunner=y;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let n=[];for(const e of o)e.length&&(n.length?n=[...n,new v,...e]:n=e);return n}async run(){}}t.Separator=v,v.ID="vs.actions.separator";class h{get actions(){return this._actions}constructor(o,n,e,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=n,this.class=r,this._actions=e}async run(){}}t.SubmenuAction=h;class g extends H{constructor(){super(g.ID,B.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=g,g.ID="vs.actions.empty";function f(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}t.toAction=f}),define(pe[28],be([1,0,3]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(v,h){const g=setTimeout(v.bind(h),0);return{dispose(){clearTimeout(g)}}});var B;(function(v){function h(g){return g===v.None||g===v.Cancelled||g instanceof H?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}v.isCancellationToken=h,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(B=t.CancellationToken||(t.CancellationToken={}));class H{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new H),this._token}cancel(){this._token?this._token instanceof H&&this._token.cancel():this._token=B.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof H&&this._token.dispose():this._token=B.None}}t.CancellationTokenSource=y}),define(pe[108],be([1,0,28]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new w.CancellationTokenSource,h=this.task(v.token);return this.result={promise:h,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}t.Cache=i;class B{constructor(v){this.fn=v,this.lastCache=void 0,this.lastArgKey=void 0}get(v){const h=JSON.stringify(v);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(v)),this.lastCache}}t.LRUCachedFunction=B;class H{get cachedValues(){return this._map}constructor(v){this.fn=v,this._map=new Map}get(v){if(this._map.has(v))return this._map.get(v);const h=this.fn(v);return this._map.set(v,h),h}}t.CachedFunction=H}),define(pe[49],be([1,0,3,2]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var B;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(B=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class H{constructor(e,r,a,c,m,s,l){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(r=r|0,a=a|0,c=c|0,m=m|0,s=s|0,l=l|0),this.rawScrollLeft=c,this.rawScrollTop=l,r<0&&(r=0),c+r>a&&(c=a-r),c<0&&(c=0),m<0&&(m=0),l+m>s&&(l=s-m),l<0&&(l=0),this.width=r,this.scrollWidth=a,this.scrollLeft=c,this.height=m,this.scrollHeight=s,this.scrollTop=l}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,r){return new H(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,r){const a=this.width!==e.width,c=this.scrollWidth!==e.scrollWidth,m=this.scrollLeft!==e.scrollLeft,s=this.height!==e.height,l=this.scrollHeight!==e.scrollHeight,p=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:r,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:c,scrollLeftChanged:m,heightChanged:s,scrollHeightChanged:l,scrollTopChanged:p}}}t.ScrollState=H;class y extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new w.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new H(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,r){const a=this._state.withScrollDimensions(e,r);this._setState(a,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const r=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(r,!1)}setScrollPositionSmooth(e,r){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const a=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===a.scrollLeft&&this._smoothScrolling.to.scrollTop===a.scrollTop)return;let c;r?c=new f(this._smoothScrolling.from,a,this._smoothScrolling.startTime,this._smoothScrolling.duration):c=this._smoothScrolling.combine(this._state,a,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=c}else{const a=this._state.withScrollPosition(e);this._smoothScrolling=f.start(this._state,a,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),r=this._state.withScrollPosition(e);if(this._setState(r,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,r){const a=this._state;a.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(a,r)))}}t.Scrollable=y;class v{constructor(e,r,a){this.scrollLeft=e,this.scrollTop=r,this.isDone=a}}t.SmoothScrollingUpdate=v;function h(n,e){const r=e-n;return function(a){return n+r*o(a)}}function g(n,e,r){return function(a){return a<r?n(a/r):e((a-r)/(1-r))}}class f{constructor(e,r,a,c){this.from=e,this.to=r,this.duration=c,this.startTime=a,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,r,a){if(Math.abs(e-r)>2.5*a){let m,s;return e<r?(m=e+.75*a,s=r-.75*a):(m=e-.75*a,s=r+.75*a),g(h(e,m),h(s,r),.33)}return h(e,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const r=(e-this.startTime)/this.duration;if(r<1){const a=this.scrollLeft(r),c=this.scrollTop(r);return new v(a,c,!1)}return new v(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,r,a){return f.start(e,r,a)}static start(e,r,a){a=a+10;const c=Date.now()-10;return new f(e,r,c,a)}}t.SmoothScrollingOperation=f;function I(n){return Math.pow(n,3)}function o(n){return 1-I(1-n)}}),define(pe[11],be([1,0,108,44]),function(Z,t,w,i){"use strict";var B;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function H(q){return!q||typeof q!="string"?!0:q.trim().length===0}t.isFalsyOrWhitespace=H;const y=/{(\d+)}/g;function v(q,...oe){return oe.length===0?q:q.replace(y,function(we,_e){const Fe=parseInt(_e,10);return isNaN(Fe)||Fe<0||Fe>=oe.length?we:oe[Fe]})}t.format=v;const h=/{([^}]+)}/g;function g(q,oe){return q.replace(h,(we,_e)=>oe[_e]??we)}t.format2=g;function f(q){return q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=f;function I(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=I;function o(q,oe){let we=0;const _e=oe.charCodeAt(0);for(let Fe=q.length-1;Fe>=0;Fe--)q.charCodeAt(Fe)===_e&&we++;return we}t.count=o;function n(q,oe,we="\u2026"){return q.length<=oe?q:`${q.substr(0,oe)}${we}`}t.truncate=n;function e(q,oe=" "){const we=r(q,oe);return a(we,oe)}t.trim=e;function r(q,oe){if(!q||!oe)return q;const we=oe.length;if(we===0||q.length===0)return q;let _e=0;for(;q.indexOf(oe,_e)===_e;)_e=_e+we;return q.substring(_e)}t.ltrim=r;function a(q,oe){if(!q||!oe)return q;const we=oe.length,_e=q.length;if(we===0||_e===0)return q;let Fe=_e,Me=-1;for(;Me=q.lastIndexOf(oe,Fe-1),!(Me===-1||Me+we!==Fe);){if(Me===0)return"";Fe=Me}return q.substring(0,Fe)}t.rtrim=a;function c(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=c;function m(q){return q.replace(/\*/g,"")}t.stripWildcards=m;function s(q,oe,we={}){if(!q)throw new Error("Cannot create regex from empty string");oe||(q=I(q)),we.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let _e="";return we.global&&(_e+="g"),we.matchCase||(_e+="i"),we.multiline&&(_e+="m"),we.unicode&&(_e+="u"),new RegExp(q,_e)}t.createRegExp=s;function l(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}t.regExpLeadsToEndlessLoop=l;function p(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=p;function _(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}t.regExpFlags=_;function L(q){return q.split(/\r\n|\r|\n/)}t.splitLines=L;function S(q){for(let oe=0,we=q.length;oe<we;oe++){const _e=q.charCodeAt(oe);if(_e!==32&&_e!==9)return oe}return-1}t.firstNonWhitespaceIndex=S;function A(q,oe=0,we=q.length){for(let _e=oe;_e<we;_e++){const Fe=q.charCodeAt(_e);if(Fe!==32&&Fe!==9)return q.substring(oe,_e)}return q.substring(oe,we)}t.getLeadingWhitespace=A;function u(q,oe=q.length-1){for(let we=oe;we>=0;we--){const _e=q.charCodeAt(we);if(_e!==32&&_e!==9)return we}return-1}t.lastNonWhitespaceIndex=u;function E(q,oe,we){const _e=[];let Fe=0;for(const Me of q.matchAll(oe)){if(_e.push(q.slice(Fe,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Fe=Me.index+Me[0].length,_e.push(we(Me[0],...Me.slice(1),Me.index,q,Me.groups))}return _e.push(q.slice(Fe)),Promise.all(_e).then(Me=>Me.join(""))}t.replaceAsync=E;function b(q,oe){return q<oe?-1:q>oe?1:0}t.compare=b;function D(q,oe,we=0,_e=q.length,Fe=0,Me=oe.length){for(;we<_e&&Fe<Me;we++,Fe++){const ke=q.charCodeAt(we),re=oe.charCodeAt(Fe);if(ke<re)return-1;if(ke>re)return 1}const Ve=_e-we,tt=Me-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstring=D;function z(q,oe){return x(q,oe,0,q.length,0,oe.length)}t.compareIgnoreCase=z;function x(q,oe,we=0,_e=q.length,Fe=0,Me=oe.length){for(;we<_e&&Fe<Me;we++,Fe++){let ke=q.charCodeAt(we),re=oe.charCodeAt(Fe);if(ke===re)continue;if(ke>=128||re>=128)return D(q.toLowerCase(),oe.toLowerCase(),we,_e,Fe,Me);Q(ke)&&(ke-=32),Q(re)&&(re-=32);const Ce=ke-re;if(Ce!==0)return Ce}const Ve=_e-we,tt=Me-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstringIgnoreCase=x;function ie(q){return q>=48&&q<=57}t.isAsciiDigit=ie;function Q(q){return q>=97&&q<=122}t.isLowerAsciiLetter=Q;function me(q){return q>=65&&q<=90}t.isUpperAsciiLetter=me;function ae(q,oe){return q.length===oe.length&&x(q,oe)===0}t.equalsIgnoreCase=ae;function fe(q,oe){const we=oe.length;return oe.length>q.length?!1:x(q,oe,0,we)===0}t.startsWithIgnoreCase=fe;function le(q,oe){const we=Math.min(q.length,oe.length);let _e;for(_e=0;_e<we;_e++)if(q.charCodeAt(_e)!==oe.charCodeAt(_e))return _e;return we}t.commonPrefixLength=le;function de(q,oe){const we=Math.min(q.length,oe.length);let _e;const Fe=q.length-1,Me=oe.length-1;for(_e=0;_e<we;_e++)if(q.charCodeAt(Fe-_e)!==oe.charCodeAt(Me-_e))return _e;return we}t.commonSuffixLength=de;function Se(q){return 55296<=q&&q<=56319}t.isHighSurrogate=Se;function ee(q){return 56320<=q&&q<=57343}t.isLowSurrogate=ee;function ye(q,oe){return(q-55296<<10)+(oe-56320)+65536}t.computeCodePoint=ye;function se(q,oe,we){const _e=q.charCodeAt(we);if(Se(_e)&&we+1<oe){const Fe=q.charCodeAt(we+1);if(ee(Fe))return ye(_e,Fe)}return _e}t.getNextCodePoint=se;function te(q,oe){const we=q.charCodeAt(oe-1);if(ee(we)&&oe>1){const _e=q.charCodeAt(oe-2);if(Se(_e))return ye(_e,we)}return we}class ce{get offset(){return this._offset}constructor(oe,we=0){this._str=oe,this._len=oe.length,this._offset=we}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=te(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=se(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=ce;class ne{get offset(){return this._iterator.offset}constructor(oe,we=0){this._iterator=new ce(oe,we)}nextGraphemeLength(){const oe=$e.getInstance(),we=this._iterator,_e=we.offset;let Fe=oe.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Me=we.offset,Ve=oe.getGraphemeBreakType(we.nextCodePoint());if(Re(Fe,Ve)){we.setOffset(Me);break}Fe=Ve}return we.offset-_e}prevGraphemeLength(){const oe=$e.getInstance(),we=this._iterator,_e=we.offset;let Fe=oe.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Me=we.offset,Ve=oe.getGraphemeBreakType(we.prevCodePoint());if(Re(Ve,Fe)){we.setOffset(Me);break}Fe=Ve}return _e-we.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ne;function T(q,oe){return new ne(q,oe).nextGraphemeLength()}t.nextCharLength=T;function V(q,oe){return new ne(q,oe).prevGraphemeLength()}t.prevCharLength=V;function j(q,oe){oe>0&&ee(q.charCodeAt(oe))&&oe--;const we=oe+T(q,oe);return[we-V(q,we),we]}t.getCharContainingOffset=j;function P(q){const oe=new ne(q);let we=0;for(;!oe.eol();)we++,oe.nextGraphemeLength();return we}t.charCount=P;let d;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(q){return d||(d=F()),d.test(q)}t.containsRTL=U;const $=/^[\t\n\r\x20-\x7E]*$/;function X(q){return $.test(q)}t.isBasicASCII=X,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(q){return t.UNUSUAL_LINE_TERMINATORS.test(q)}t.containsUnusualLineTerminators=N;function R(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}t.isFullWidthCharacter=R;function W(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}t.isEmojiImprecise=W;function C(q,oe){if(q.length<oe)return q;const we=/\b/g;let _e=0;for(;we.test(q)&&!(q.length-we.lastIndex<oe);)_e=we.lastIndex,we.lastIndex+=1;return q.substring(_e).replace(/^\s/,"")}t.lcut=C;const k=/\x1B\x5B[12]?K/g,M=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function K(q){return q&&(q=q.replace(k,""),q=q.replace(M,""),q=q.replace(O,"")),q}t.removeAnsiEscapeCodes=K,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function J(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}t.startsWithUTF8BOM=J;function ue(q){return J(q)?q.substr(1):q}t.stripUTF8BOM=ue;function he(q,oe){if(!q||!oe||q.length<oe.length)return!1;const we=oe.length,_e=q.toLowerCase();let Fe=0,Me=-1;for(;Fe<we;){const Ve=_e.indexOf(oe[Fe],Me+1);if(Ve<0)return!1;Me=Ve,Fe++}return!0}t.fuzzyContains=he;function De(q,oe=!1){return q?(oe&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}t.containsUppercaseCharacter=De;function Ee(q){return q.charAt(0).toUpperCase()+q.slice(1)}t.uppercaseFirstLetter=Ee;function Ne(q,oe=1){if(oe===0)return"";let we=-1;do we=q.indexOf(`
`,we+1),oe--;while(oe>0&&we>=0);return we===-1?q:(q[we-1]==="\r"&&we--,q.substr(0,we))}t.getNLines=Ne;function Ae(q){return q=q%(2*26),q<26?String.fromCharCode(97+q):String.fromCharCode(65+q-26)}t.singleLetterHash=Ae;function ve(q){return $e.getInstance().getGraphemeBreakType(q)}t.getGraphemeBreakType=ve;function Re(q,oe){return q===0?oe!==5&&oe!==7:q===2&&oe===3?!1:q===4||q===2||q===3||oe===4||oe===2||oe===3?!0:!(q===8&&(oe===8||oe===9||oe===11||oe===12)||(q===11||q===9)&&(oe===9||oe===10)||(q===12||q===10)&&oe===10||oe===5||oe===13||oe===7||q===1||q===13&&oe===14||q===6&&oe===6)}var Pe;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class $e{static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}constructor(){this._data=He()}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const we=this._data,_e=we.length/3;let Fe=1;for(;Fe<=_e;)if(oe<we[3*Fe])Fe=2*Fe;else if(oe>we[3*Fe+1])Fe=2*Fe+1;else return we[3*Fe+2];return 0}}$e._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(q,oe){if(q===0)return 0;const we=Je(q,oe);if(we!==void 0)return we;const _e=new ce(oe,q);return _e.prevCodePoint(),_e.offset}t.getLeftDeleteOffset=ze;function Je(q,oe){const we=new ce(oe,q);let _e=we.prevCodePoint();for(;it(_e)||_e===65039||_e===8419;){if(we.offset===0)return;_e=we.prevCodePoint()}if(!W(_e))return;let Fe=we.offset;return Fe>0&&we.prevCodePoint()===8205&&(Fe=we.offset),Fe}function it(q){return 127995<=q&&q<=127999}var Oe;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.noBreakWhitespace="\xA0";class qe{static getInstance(oe){return qe.cache.get(Array.from(oe))}static getLocales(){return qe._locales.getValue()}constructor(oe){this.confusableDictionary=oe}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=qe,B=qe,qe.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new w.LRUCachedFunction(q=>{function oe(re){const Ce=new Map;for(let Le=0;Le<re.length;Le+=2)Ce.set(re[Le],re[Le+1]);return Ce}function we(re,Ce){const Le=new Map(re);for(const[We,je]of Ce)Le.set(We,je);return Le}function _e(re,Ce){if(!re)return Ce;const Le=new Map;for(const[We,je]of re)Ce.has(We)&&Le.set(We,je);return Le}const Fe=B.ambiguousCharacterData.getValue();let Me=q.filter(re=>!re.startsWith("_")&&re in Fe);Me.length===0&&(Me=["_default"]);let Ve;for(const re of Me){const Ce=oe(Fe[re]);Ve=_e(Ve,Ce)}const tt=oe(Fe._common),ke=we(tt,Ve);return new qe(ke)}),qe._locales=new i.Lazy(()=>Object.keys(qe.ambiguousCharacterData.getValue()).filter(q=>!q.startsWith("_")));class Ye{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ye.getRawData())),this._data}static isInvisibleCharacter(oe){return Ye.getData().has(oe)}static get codePoints(){return Ye.getData()}}t.InvisibleCharacters=Ye,Ye._data=void 0}),define(pe[109],be([1,0,21,5,11,6]),function(Z,t,w,i,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(u){return u===47||u===92}t.isPathSeparator=y;function v(u){return u.replace(/[\\/]/g,w.posix.sep)}t.toSlashes=v;function h(u){return u.indexOf("/")===-1&&(u=v(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}t.toPosixPath=h;function g(u,E=w.posix.sep){if(!u)return"";const b=u.length,D=u.charCodeAt(0);if(y(D)){if(y(u.charCodeAt(1))&&!y(u.charCodeAt(2))){let x=3;const ie=x;for(;x<b&&!y(u.charCodeAt(x));x++);if(ie!==x&&!y(u.charCodeAt(x+1))){for(x+=1;x<b;x++)if(y(u.charCodeAt(x)))return u.slice(0,x+1).replace(/[\\/]/g,E)}}return E}else if(c(D)&&u.charCodeAt(1)===58)return y(u.charCodeAt(2))?u.slice(0,2)+E:u.slice(0,2);let z=u.indexOf("://");if(z!==-1){for(z+=3;z<b;z++)if(y(u.charCodeAt(z)))return u.slice(0,z+1)}return""}t.getRoot=g;function f(u){if(!i.isWindows||!u||u.length<5)return!1;let E=u.charCodeAt(0);if(E!==92||(E=u.charCodeAt(1),E!==92))return!1;let b=2;const D=b;for(;b<u.length&&(E=u.charCodeAt(b),E!==92);b++);return!(D===b||(E=u.charCodeAt(b+1),isNaN(E)||E===92))}t.isUNC=f;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(u,E=i.isWindows){const b=E?I:o;return!(!u||u.length===0||/^\s+$/.test(u)||(b.lastIndex=0,b.test(u))||E&&n.test(u)||u==="."||u===".."||E&&u[u.length-1]==="."||E&&u.length!==u.trim().length||u.length>255)}t.isValidBasename=e;function r(u,E,b){const D=u===E;return!b||D?D:!u||!E?!1:(0,B.equalsIgnoreCase)(u,E)}t.isEqual=r;function a(u,E,b,D=w.sep){if(u===E)return!0;if(!u||!E||E.length>u.length)return!1;if(b){if(!(0,B.startsWithIgnoreCase)(u,E))return!1;if(E.length===u.length)return!0;let x=E.length;return E.charAt(E.length-1)===D&&x--,u.charAt(x)===D}return E.charAt(E.length-1)!==D&&(E+=D),u.indexOf(E)===0}t.isEqualOrParent=a;function c(u){return u>=65&&u<=90||u>=97&&u<=122}t.isWindowsDriveLetter=c;function m(u,E){return i.isWindows&&u.endsWith(":")&&(u+=w.sep),(0,w.isAbsolute)(u)||(u=(0,w.join)(E,u)),u=(0,w.normalize)(u),i.isWindows?(u=(0,B.rtrim)(u,w.sep),u.endsWith(":")&&(u+=w.sep)):(u=(0,B.rtrim)(u,w.sep),u||(u=w.sep)),u}t.sanitizeFilePath=m;function s(u){const E=(0,w.normalize)(u);return i.isWindows?u.length>3?!1:l(E)&&(u.length===2||E.charCodeAt(2)===92):E===w.posix.sep}t.isRootOrDriveLetter=s;function l(u,E=i.isWindows){return E?c(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}t.hasDriveLetter=l;function p(u){return l(u)?u[0]:void 0}t.getDriveLetter=p;function _(u,E,b){return E.length>u.length?-1:u===E?0:(b&&(u=u.toLowerCase(),E=E.toLowerCase()),u.indexOf(E))}t.indexOfPath=_;function L(u){const E=u.split(":");let b,D,z;for(const x of E){const ie=Number(x);(0,H.isNumber)(ie)?D===void 0?D=ie:z===void 0&&(z=ie):b=b?[b,x].join(":"):x}if(!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:D!==void 0?D:void 0,column:z!==void 0?z:D!==void 0?1:void 0}}t.parseLineAndColumnAware=L;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function A(u,E,b=8){let D="";for(let x=0;x<b;x++)D+=S.charAt(Math.floor(Math.random()*S.length));let z;return E?z=`${E}-${D}`:z=D,u?(0,w.join)(u,z):z}t.randomPath=A}),define(pe[33],be([1,0,74,11]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function B(...M){return function(O,K){for(let J=0,ue=M.length;J<ue;J++){const he=M[J](O,K);if(he)return he}return null}}t.or=B,t.matchesStrictPrefix=H.bind(void 0,!1),t.matchesPrefix=H.bind(void 0,!0);function H(M,O,K){if(!K||K.length<O.length)return null;let J;return M?J=i.startsWithIgnoreCase(K,O):J=K.indexOf(O)===0,J?O.length>0?[{start:0,end:O.length}]:[]:null}function y(M,O){const K=O.toLowerCase().indexOf(M.toLowerCase());return K===-1?null:[{start:K,end:K+M.length}]}t.matchesContiguousSubString=y;function v(M,O){return h(M.toLowerCase(),O.toLowerCase(),0,0)}t.matchesSubString=v;function h(M,O,K,J){if(K===M.length)return[];if(J===O.length)return null;if(M[K]===O[J]){let ue=null;return(ue=h(M,O,K+1,J+1))?c({start:J,end:J+1},ue):null}return h(M,O,K,J+1)}function g(M){return 97<=M&&M<=122}function f(M){return 65<=M&&M<=90}t.isUpper=f;function I(M){return 48<=M&&M<=57}function o(M){return M===32||M===9||M===10||M===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(M=>n.add(M.charCodeAt(0)));function e(M){return o(M)||n.has(M)}function r(M,O){return M===O||e(M)&&e(O)}function a(M){return g(M)||f(M)||I(M)}function c(M,O){return O.length===0?O=[M]:M.end===O[0].start?O[0].start=M.start:O.unshift(M),O}function m(M,O){for(let K=O;K<M.length;K++){const J=M.charCodeAt(K);if(f(J)||I(J)||K>0&&!a(M.charCodeAt(K-1)))return K}return M.length}function s(M,O,K,J){if(K===M.length)return[];if(J===O.length)return null;if(M[K]!==O[J].toLowerCase())return null;{let ue=null,he=J+1;for(ue=s(M,O,K+1,J+1);!ue&&(he=m(O,he))<O.length;)ue=s(M,O,K+1,he),he++;return ue===null?null:c({start:J,end:J+1},ue)}}function l(M){let O=0,K=0,J=0,ue=0,he=0;for(let ve=0;ve<M.length;ve++)he=M.charCodeAt(ve),f(he)&&O++,g(he)&&K++,a(he)&&J++,I(he)&&ue++;const De=O/M.length,Ee=K/M.length,Ne=J/M.length,Ae=ue/M.length;return{upperPercent:De,lowerPercent:Ee,alphaPercent:Ne,numericPercent:Ae}}function p(M){const{upperPercent:O,lowerPercent:K}=M;return K===0&&O>.6}function _(M){const{upperPercent:O,lowerPercent:K,alphaPercent:J,numericPercent:ue}=M;return K>.2&&O<.8&&J>.6&&ue<.2}function L(M){let O=0,K=0,J=0,ue=0;for(let he=0;he<M.length;he++)J=M.charCodeAt(he),f(J)&&O++,g(J)&&K++,o(J)&&ue++;return(O===0||K===0)&&ue===0?M.length<=30:O<=5}function S(M,O){if(!O||(O=O.trim(),O.length===0)||!L(M)||O.length>60)return null;const K=l(O);if(!_(K)){if(!p(K))return null;O=O.toLowerCase()}let J=null,ue=0;for(M=M.toLowerCase();ue<O.length&&(J=s(M,O,0,ue))===null;)ue=m(O,ue+1);return J}t.matchesCamelCase=S;function A(M,O,K=!1){if(!O||O.length===0)return null;let J=null,ue=0;for(M=M.toLowerCase(),O=O.toLowerCase();ue<O.length&&(J=u(M,O,0,ue,K))===null;)ue=E(O,ue+1);return J}t.matchesWords=A;function u(M,O,K,J,ue){if(K===M.length)return[];if(J===O.length)return null;if(r(M.charCodeAt(K),O.charCodeAt(J))){let he=null,De=J+1;if(he=u(M,O,K+1,J+1,ue),!ue)for(;!he&&(De=E(O,De))<O.length;)he=u(M,O,K+1,De,ue),De++;return he?M.charCodeAt(K)!==O.charCodeAt(J)?he:c({start:J,end:J+1},he):null}else return null}function E(M,O){for(let K=O;K<M.length;K++)if(e(M.charCodeAt(K))||K>0&&e(M.charCodeAt(K-1)))return K;return M.length}const b=B(t.matchesPrefix,S,y),D=B(t.matchesPrefix,S,v),z=new w.LRUCache(1e4);function x(M,O,K=!1){if(typeof M!="string"||typeof O!="string")return null;let J=z.get(M);J||(J=new RegExp(i.convertSimple2RegExpPattern(M),"i"),z.set(M,J));const ue=J.exec(O);return ue?[{start:ue.index,end:ue.index+ue[0].length}]:K?D(M,O):b(M,O)}t.matchesFuzzy=x;function ie(M,O){const K=$(M,M.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return K?me(K):null}t.matchesFuzzy2=ie;function Q(M,O,K,J,ue,he){const De=Math.min(13,M.length);for(;K<De;K++){const Ee=$(M,O,K,J,ue,he,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,he]}t.anyScore=Q;function me(M){if(typeof M>"u")return[];const O=[],K=M[1];for(let J=M.length-1;J>1;J--){const ue=M[J]+K,he=O[O.length-1];he&&he.end===ue?he.end=ue+1:O.push({start:ue,end:ue+1})}return O}t.createMatches=me;const ae=128;function fe(){const M=[],O=[];for(let K=0;K<=ae;K++)O[K]=0;for(let K=0;K<=ae;K++)M.push(O.slice(0));return M}function le(M){const O=[];for(let K=0;K<=M;K++)O[K]=0;return O}const de=le(2*ae),Se=le(2*ae),ee=fe(),ye=fe(),se=fe(),te=!1;function ce(M,O,K,J,ue){function he(Ee,Ne,Ae=" "){for(;Ee.length<Ne;)Ee=Ae+Ee;return Ee}let De=` |   |${J.split("").map(Ee=>he(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=K;Ee++)Ee===0?De+=" |":De+=`${O[Ee-1]}|`,De+=M[Ee].slice(0,ue+1).map(Ne=>he(Ne.toString(),3)).join("|")+`
`;return De}function ne(M,O,K,J){M=M.substr(O),K=K.substr(J),console.log(ce(ye,M,M.length,K,K.length)),console.log(ce(se,M,M.length,K,K.length)),console.log(ce(ee,M,M.length,K,K.length))}function T(M,O){if(O<0||O>=M.length)return!1;const K=M.codePointAt(O);switch(K){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(K)}}function V(M,O){if(O<0||O>=M.length)return!1;switch(M.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function j(M,O,K){return O[M]!==K[M]}function P(M,O,K,J,ue,he,De=!1){for(;O<K&&ue<he;)M[O]===J[ue]&&(De&&(de[O]=ue),O+=1),ue+=1;return O===K}t.isPatternInWord=P;var d;(function(M){M[M.Diag=1]="Diag",M[M.Left=2]="Left",M[M.LeftLeft=3]="LeftLeft"})(d||(d={}));var F;(function(M){M.Default=[-100,0];function O(K){return!K||K.length===2&&K[0]===-100&&K[1]===0}M.isDefault=O})(F=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(O,K){this.firstMatchCanBeWeak=O,this.boostFullMatch=K}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(M,O,K,J,ue,he,De=U.default){const Ee=M.length>ae?ae:M.length,Ne=J.length>ae?ae:J.length;if(K>=Ee||he>=Ne||Ee-K>Ne-he||!P(O,K,Ee,ue,he,Ne,!0))return;X(Ee,Ne,K,he,O,ue);let Ae=1,ve=1,Re=K,Pe=he;const $e=[!1];for(Ae=1,Re=K;Re<Ee;Ae++,Re++){const Oe=de[Re],qe=Se[Re],Ye=Re+1<Ee?Se[Re+1]:Ne;for(ve=Oe-he+1,Pe=Oe;Pe<Ye;ve++,Pe++){let q=Number.MIN_SAFE_INTEGER,oe=!1;Pe<=qe&&(q=N(M,O,Re,K,J,ue,Pe,Ne,he,ee[Ae-1][ve-1]===0,$e));let we=0;q!==Number.MAX_SAFE_INTEGER&&(oe=!0,we=q+ye[Ae-1][ve-1]);const _e=Pe>Oe,Fe=_e?ye[Ae][ve-1]+(ee[Ae][ve-1]>0?-5:0):0,Me=Pe>Oe+1&&ee[Ae][ve-1]>0,Ve=Me?ye[Ae][ve-2]+(ee[Ae][ve-2]>0?-5:0):0;if(Me&&(!_e||Ve>=Fe)&&(!oe||Ve>=we))ye[Ae][ve]=Ve,se[Ae][ve]=3,ee[Ae][ve]=0;else if(_e&&(!oe||Fe>=we))ye[Ae][ve]=Fe,se[Ae][ve]=2,ee[Ae][ve]=0;else if(oe)ye[Ae][ve]=we,se[Ae][ve]=1,ee[Ae][ve]=ee[Ae-1][ve-1]+1;else throw new Error("not possible")}}if(te&&ne(M,K,J,he),!$e[0]&&!De.firstMatchCanBeWeak)return;Ae--,ve--;const He=[ye[Ae][ve],he];let ze=0,Je=0;for(;Ae>=1;){let Oe=ve;do{const qe=se[Ae][Oe];if(qe===3)Oe=Oe-2;else if(qe===2)Oe=Oe-1;else break}while(Oe>=1);ze>1&&O[K+Ae-1]===ue[he+ve-1]&&!j(Oe+he-1,J,ue)&&ze+1>ee[Ae][Oe]&&(Oe=ve),Oe===ve?ze++:ze=1,Je||(Je=Oe),Ae--,ve=Oe-1,He.push(ve)}Ne===Ee&&De.boostFullMatch&&(He[0]+=2);const it=Je-Ee;return He[0]-=it,He}t.fuzzyScore=$;function X(M,O,K,J,ue,he){let De=M-1,Ee=O-1;for(;De>=K&&Ee>=J;)ue[De]===he[Ee]&&(Se[De]=Ee,De--),Ee--}function N(M,O,K,J,ue,he,De,Ee,Ne,Ae,ve){if(O[K]!==he[De])return Number.MIN_SAFE_INTEGER;let Re=1,Pe=!1;return De===K-J?Re=M[K]===ue[De]?7:5:j(De,ue,he)&&(De===0||!j(De-1,ue,he))?(Re=M[K]===ue[De]?7:5,Pe=!0):T(he,De)&&(De===0||!T(he,De-1))?Re=5:(T(he,De-1)||V(he,De-1))&&(Re=5,Pe=!0),Re>1&&K===J&&(ve[0]=!0),Pe||(Pe=j(De,ue,he)||T(he,De-1)||V(he,De-1)),K===J?De>Ne&&(Re-=Pe?3:5):Ae?Re+=Pe?2:0:Re+=Pe?0:1,De+1===Ee&&(Re-=Pe?3:5),Re}function R(M,O,K,J,ue,he,De){return C(M,O,K,J,ue,he,!0,De)}t.fuzzyScoreGracefulAggressive=R;function W(M,O,K,J,ue,he,De){return C(M,O,K,J,ue,he,!1,De)}t.fuzzyScoreGraceful=W;function C(M,O,K,J,ue,he,De,Ee){let Ne=$(M,O,K,J,ue,he,Ee);if(Ne&&!De)return Ne;if(M.length>=3){const Ae=Math.min(7,M.length-1);for(let ve=K+1;ve<Ae;ve++){const Re=k(M,ve);if(Re){const Pe=$(Re,Re.toLowerCase(),K,J,ue,he,Ee);Pe&&(Pe[0]-=3,(!Ne||Pe[0]>Ne[0])&&(Ne=Pe))}}}return Ne}function k(M,O){if(O+1>=M.length)return;const K=M[O],J=M[O+1];if(K!==J)return M.slice(0,O)+J+K+M.slice(O+2)}}),define(pe[110],be([1,0,11]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(c){return B(c,0)}t.hash=i;function B(c,m){switch(typeof c){case"object":return c===null?H(349,m):Array.isArray(c)?h(c,m):g(c,m);case"string":return v(c,m);case"boolean":return y(c,m);case"number":return H(c,m);case"undefined":return H(937,m);default:return H(617,m)}}t.doHash=B;function H(c,m){return(m<<5)-m+c|0}t.numberHash=H;function y(c,m){return H(c?433:863,m)}function v(c,m){m=H(149417,m);for(let s=0,l=c.length;s<l;s++)m=H(c.charCodeAt(s),m);return m}t.stringHash=v;function h(c,m){return m=H(104579,m),c.reduce((s,l)=>B(l,s),m)}function g(c,m){return m=H(181387,m),Object.keys(c).sort().reduce((s,l)=>(s=v(l,s),B(c[l],s)),m)}class f{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=B(m,this._value),this._value}}t.Hasher=f;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(c,m,s=32){const l=s-m,p=~((1<<l)-1);return(c<<m|(p&c)>>>l)>>>0}function n(c,m=0,s=c.byteLength,l=0){for(let p=0;p<s;p++)c[m+p]=l}function e(c,m,s="0"){for(;c.length<m;)c=s+c;return c}function r(c,m=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(s=>s.toString(16).padStart(2,"0")).join(""):e((c>>>0).toString(16),m/4)}t.toHexString=r;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const s=m.length;if(s===0)return;const l=this._buff;let p=this._buffLen,_=this._leftoverHighSurrogate,L,S;for(_!==0?(L=_,S=-1,_=0):(L=m.charCodeAt(0),S=0);;){let A=L;if(w.isHighSurrogate(L))if(S+1<s){const u=m.charCodeAt(S+1);w.isLowSurrogate(u)?(S++,A=w.computeCodePoint(L,u)):A=65533}else{_=L;break}else w.isLowSurrogate(L)&&(A=65533);if(p=this._push(l,p,A),S++,S<s)L=m.charCodeAt(S);else break}this._buffLen=p,this._leftoverHighSurrogate=_}_push(m,s,l){return l<128?m[s++]=l:l<2048?(m[s++]=192|(l&1984)>>>6,m[s++]=128|(l&63)>>>0):l<65536?(m[s++]=224|(l&61440)>>>12,m[s++]=128|(l&4032)>>>6,m[s++]=128|(l&63)>>>0):(m[s++]=240|(l&1835008)>>>18,m[s++]=128|(l&258048)>>>12,m[s++]=128|(l&4032)>>>6,m[s++]=128|(l&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),r(this._h0)+r(this._h1)+r(this._h2)+r(this._h3)+r(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,n(this._buff,this._buffLen),this._buffLen>56&&(this._step(),n(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=a._bigBlock32,s=this._buffDV;for(let b=0;b<64;b+=4)m.setUint32(b,s.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)m.setUint32(b,o(m.getUint32(b-12,!1)^m.getUint32(b-32,!1)^m.getUint32(b-56,!1)^m.getUint32(b-64,!1),1),!1);let l=this._h0,p=this._h1,_=this._h2,L=this._h3,S=this._h4,A,u,E;for(let b=0;b<80;b++)b<20?(A=p&_|~p&L,u=1518500249):b<40?(A=p^_^L,u=1859775393):b<60?(A=p&_|p&L|_&L,u=2400959708):(A=p^_^L,u=3395469782),E=o(l,5)+A+S+u+m.getUint32(b*4,!1)&4294967295,S=L,L=_,_=o(p,30),p=l,l=E;this._h0=this._h0+l&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+_&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+S&4294967295}}t.StringSHA1=a,a._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[111],be([1,0,70,110]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class B{constructor(o){this.source=o}getElements(){const o=this.source,n=new Int32Array(o.length);for(let e=0,r=o.length;e<r;e++)n[e]=o.charCodeAt(e);return n}}t.StringDiffSequence=B;function H(I,o,n){return new f(new B(I),new B(o)).ComputeDiff(n).changes}t.stringDiff=H;class y{static Assert(o,n){if(!o)throw new Error(n)}}t.Debug=y;class v{static Copy(o,n,e,r,a){for(let c=0;c<a;c++)e[r+c]=o[n+c]}static Copy2(o,n,e,r,a){for(let c=0;c<a;c++)e[r+c]=o[n+c]}}t.MyArray=v;var h;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class g{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new w.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(o,n){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,n),this.m_originalCount++}AddModifiedElement(o,n){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,n),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class f{constructor(o,n,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=o,this._modifiedSequence=n;const[r,a,c]=f._getElements(o),[m,s,l]=f._getElements(n);this._hasStrings=c&&l,this._originalStringElements=r,this._originalElementsOrHash=a,this._modifiedStringElements=m,this._modifiedElementsOrHash=s,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(o){return o.length>0&&typeof o[0]=="string"}static _getElements(o){const n=o.getElements();if(f._isStringArray(n)){const e=new Int32Array(n.length);for(let r=0,a=n.length;r<a;r++)e[r]=(0,i.stringHash)(n[r],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}ElementsAreEqual(o,n){return this._originalElementsOrHash[o]!==this._modifiedElementsOrHash[n]?!1:this._hasStrings?this._originalStringElements[o]===this._modifiedStringElements[n]:!0}ElementsAreStrictEqual(o,n){if(!this.ElementsAreEqual(o,n))return!1;const e=f._getStrictElement(this._originalSequence,o),r=f._getStrictElement(this._modifiedSequence,n);return e===r}static _getStrictElement(o,n){return typeof o.getStrictElement=="function"?o.getStrictElement(n):null}OriginalElementsAreEqual(o,n){return this._originalElementsOrHash[o]!==this._originalElementsOrHash[n]?!1:this._hasStrings?this._originalStringElements[o]===this._originalStringElements[n]:!0}ModifiedElementsAreEqual(o,n){return this._modifiedElementsOrHash[o]!==this._modifiedElementsOrHash[n]?!1:this._hasStrings?this._modifiedStringElements[o]===this._modifiedStringElements[n]:!0}ComputeDiff(o){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,o)}_ComputeDiff(o,n,e,r,a){const c=[!1];let m=this.ComputeDiffRecursive(o,n,e,r,c);return a&&(m=this.PrettifyChanges(m)),{quitEarly:c[0],changes:m}}ComputeDiffRecursive(o,n,e,r,a){for(a[0]=!1;o<=n&&e<=r&&this.ElementsAreEqual(o,e);)o++,e++;for(;n>=o&&r>=e&&this.ElementsAreEqual(n,r);)n--,r--;if(o>n||e>r){let _;return e<=r?(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),_=[new w.DiffChange(o,0,e,r-e+1)]):o<=n?(y.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),_=[new w.DiffChange(o,n-o+1,e,0)]):(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),y.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),_=[]),_}const c=[0],m=[0],s=this.ComputeRecursionPoint(o,n,e,r,c,m,a),l=c[0],p=m[0];if(s!==null)return s;if(!a[0]){const _=this.ComputeDiffRecursive(o,l,e,p,a);let L=[];return a[0]?L=[new w.DiffChange(l+1,n-(l+1)+1,p+1,r-(p+1)+1)]:L=this.ComputeDiffRecursive(l+1,n,p+1,r,a),this.ConcatenateChanges(_,L)}return[new w.DiffChange(o,n-o+1,e,r-e+1)]}WALKTRACE(o,n,e,r,a,c,m,s,l,p,_,L,S,A,u,E,b,D){let z=null,x=null,ie=new g,Q=n,me=e,ae=S[0]-E[0]-r,fe=-1073741824,le=this.m_forwardHistory.length-1;do{const de=ae+o;de===Q||de<me&&l[de-1]<l[de+1]?(_=l[de+1],A=_-ae-r,_<fe&&ie.MarkNextChange(),fe=_,ie.AddModifiedElement(_+1,A),ae=de+1-o):(_=l[de-1]+1,A=_-ae-r,_<fe&&ie.MarkNextChange(),fe=_-1,ie.AddOriginalElement(_,A+1),ae=de-1-o),le>=0&&(l=this.m_forwardHistory[le],o=l[0],Q=1,me=l.length-1)}while(--le>=-1);if(z=ie.getReverseChanges(),D[0]){let de=S[0]+1,Se=E[0]+1;if(z!==null&&z.length>0){const ee=z[z.length-1];de=Math.max(de,ee.getOriginalEnd()),Se=Math.max(Se,ee.getModifiedEnd())}x=[new w.DiffChange(de,L-de+1,Se,u-Se+1)]}else{ie=new g,Q=c,me=m,ae=S[0]-E[0]-s,fe=1073741824,le=b?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const de=ae+a;de===Q||de<me&&p[de-1]>=p[de+1]?(_=p[de+1]-1,A=_-ae-s,_>fe&&ie.MarkNextChange(),fe=_+1,ie.AddOriginalElement(_+1,A+1),ae=de+1-a):(_=p[de-1],A=_-ae-s,_>fe&&ie.MarkNextChange(),fe=_,ie.AddModifiedElement(_+1,A+1),ae=de-1-a),le>=0&&(p=this.m_reverseHistory[le],a=p[0],Q=1,me=p.length-1)}while(--le>=-1);x=ie.getChanges()}return this.ConcatenateChanges(z,x)}ComputeRecursionPoint(o,n,e,r,a,c,m){let s=0,l=0,p=0,_=0,L=0,S=0;o--,e--,a[0]=0,c[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const A=n-o+(r-e),u=A+1,E=new Int32Array(u),b=new Int32Array(u),D=r-e,z=n-o,x=o-e,ie=n-r,me=(z-D)%2===0;E[D]=o,b[z]=n,m[0]=!1;for(let ae=1;ae<=A/2+1;ae++){let fe=0,le=0;p=this.ClipDiagonalBound(D-ae,ae,D,u),_=this.ClipDiagonalBound(D+ae,ae,D,u);for(let Se=p;Se<=_;Se+=2){Se===p||Se<_&&E[Se-1]<E[Se+1]?s=E[Se+1]:s=E[Se-1]+1,l=s-(Se-D)-x;const ee=s;for(;s<n&&l<r&&this.ElementsAreEqual(s+1,l+1);)s++,l++;if(E[Se]=s,s+l>fe+le&&(fe=s,le=l),!me&&Math.abs(Se-z)<=ae-1&&s>=b[Se])return a[0]=s,c[0]=l,ee<=b[Se]&&1447>0&&ae<=1447+1?this.WALKTRACE(D,p,_,x,z,L,S,ie,E,b,s,n,a,l,r,c,me,m):null}const de=(fe-o+(le-e)-ae)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(fe,de))return m[0]=!0,a[0]=fe,c[0]=le,de>0&&1447>0&&ae<=1447+1?this.WALKTRACE(D,p,_,x,z,L,S,ie,E,b,s,n,a,l,r,c,me,m):(o++,e++,[new w.DiffChange(o,n-o+1,e,r-e+1)]);L=this.ClipDiagonalBound(z-ae,ae,z,u),S=this.ClipDiagonalBound(z+ae,ae,z,u);for(let Se=L;Se<=S;Se+=2){Se===L||Se<S&&b[Se-1]>=b[Se+1]?s=b[Se+1]-1:s=b[Se-1],l=s-(Se-z)-ie;const ee=s;for(;s>o&&l>e&&this.ElementsAreEqual(s,l);)s--,l--;if(b[Se]=s,me&&Math.abs(Se-D)<=ae&&s<=E[Se])return a[0]=s,c[0]=l,ee>=E[Se]&&1447>0&&ae<=1447+1?this.WALKTRACE(D,p,_,x,z,L,S,ie,E,b,s,n,a,l,r,c,me,m):null}if(ae<=1447){let Se=new Int32Array(_-p+2);Se[0]=D-p+1,v.Copy2(E,p,Se,1,_-p+1),this.m_forwardHistory.push(Se),Se=new Int32Array(S-L+2),Se[0]=z-L+1,v.Copy2(b,L,Se,1,S-L+1),this.m_reverseHistory.push(Se)}}return this.WALKTRACE(D,p,_,x,z,L,S,ie,E,b,s,n,a,l,r,c,me,m)}PrettifyChanges(o){for(let n=0;n<o.length;n++){const e=o[n],r=n<o.length-1?o[n+1].originalStart:this._originalElementsOrHash.length,a=n<o.length-1?o[n+1].modifiedStart:this._modifiedElementsOrHash.length,c=e.originalLength>0,m=e.modifiedLength>0;for(;e.originalStart+e.originalLength<r&&e.modifiedStart+e.modifiedLength<a&&(!c||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!m||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const l=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!l)break;e.originalStart++,e.modifiedStart++}const s=[null];if(n<o.length-1&&this.ChangesOverlap(o[n],o[n+1],s)){o[n]=s[0],o.splice(n+1,1),n--;continue}}for(let n=o.length-1;n>=0;n--){const e=o[n];let r=0,a=0;if(n>0){const _=o[n-1];r=_.originalStart+_.originalLength,a=_.modifiedStart+_.modifiedLength}const c=e.originalLength>0,m=e.modifiedLength>0;let s=0,l=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let _=1;;_++){const L=e.originalStart-_,S=e.modifiedStart-_;if(L<r||S<a||c&&!this.OriginalElementsAreEqual(L,L+e.originalLength)||m&&!this.ModifiedElementsAreEqual(S,S+e.modifiedLength))break;const u=(L===r&&S===a?5:0)+this._boundaryScore(L,e.originalLength,S,e.modifiedLength);u>l&&(l=u,s=_)}e.originalStart-=s,e.modifiedStart-=s;const p=[null];if(n>0&&this.ChangesOverlap(o[n-1],o[n],p)){o[n-1]=p[0],o.splice(n,1),n++;continue}}if(this._hasStrings)for(let n=1,e=o.length;n<e;n++){const r=o[n-1],a=o[n],c=a.originalStart-r.originalStart-r.originalLength,m=r.originalStart,s=a.originalStart+a.originalLength,l=s-m,p=r.modifiedStart,_=a.modifiedStart+a.modifiedLength,L=_-p;if(c<5&&l<20&&L<20){const S=this._findBetterContiguousSequence(m,l,p,L,c);if(S){const[A,u]=S;(A!==r.originalStart+r.originalLength||u!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=A-r.originalStart,r.modifiedLength=u-r.modifiedStart,a.originalStart=A+c,a.modifiedStart=u+c,a.originalLength=s-a.originalStart,a.modifiedLength=_-a.modifiedStart)}}}return o}_findBetterContiguousSequence(o,n,e,r,a){if(n<a||r<a)return null;const c=o+n-a+1,m=e+r-a+1;let s=0,l=0,p=0;for(let _=o;_<c;_++)for(let L=e;L<m;L++){const S=this._contiguousSequenceScore(_,L,a);S>0&&S>s&&(s=S,l=_,p=L)}return s>0?[l,p]:null}_contiguousSequenceScore(o,n,e){let r=0;for(let a=0;a<e;a++){if(!this.ElementsAreEqual(o+a,n+a))return 0;r+=this._originalStringElements[o+a].length}return r}_OriginalIsBoundary(o){return o<=0||o>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[o])}_OriginalRegionIsBoundary(o,n){if(this._OriginalIsBoundary(o)||this._OriginalIsBoundary(o-1))return!0;if(n>0){const e=o+n;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(o){return o<=0||o>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[o])}_ModifiedRegionIsBoundary(o,n){if(this._ModifiedIsBoundary(o)||this._ModifiedIsBoundary(o-1))return!0;if(n>0){const e=o+n;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(o,n,e,r){const a=this._OriginalRegionIsBoundary(o,n)?1:0,c=this._ModifiedRegionIsBoundary(e,r)?1:0;return a+c}ConcatenateChanges(o,n){const e=[];if(o.length===0||n.length===0)return n.length>0?n:o;if(this.ChangesOverlap(o[o.length-1],n[0],e)){const r=new Array(o.length+n.length-1);return v.Copy(o,0,r,0,o.length-1),r[o.length-1]=e[0],v.Copy(n,1,r,o.length,n.length-1),r}else{const r=new Array(o.length+n.length);return v.Copy(o,0,r,0,o.length),v.Copy(n,0,r,o.length,n.length),r}}ChangesOverlap(o,n,e){if(y.Assert(o.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),y.Assert(o.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=n.originalStart||o.modifiedStart+o.modifiedLength>=n.modifiedStart){const r=o.originalStart;let a=o.originalLength;const c=o.modifiedStart;let m=o.modifiedLength;return o.originalStart+o.originalLength>=n.originalStart&&(a=n.originalStart+n.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=n.modifiedStart&&(m=n.modifiedStart+n.modifiedLength-o.modifiedStart),e[0]=new w.DiffChange(r,a,c,m),!0}else return e[0]=null,!1}ClipDiagonalBound(o,n,e,r){if(o>=0&&o<r)return o;const a=e,c=r-e-1,m=n%2===0;if(o<0){const s=a%2===0;return m===s?0:1}else{const s=c%2===0;return m===s?r-1:r-2}}}t.LcsDiff=f}),define(pe[34],be([1,0,12,33,11]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const H=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(w.CSSIcon.iconNameCharacter),v=new RegExp(`(\\\\)?${H.source}`,"g");function h(a){return a.replace(v,(c,m)=>m?c:`\\${c}`)}t.escapeIcons=h;const g=new RegExp(`\\\\${H.source}`,"g");function f(a){return a.replace(g,c=>`\\${c}`)}t.markdownEscapeEscapedIcons=f;const I=new RegExp(`(\\s)?(\\\\)?${H.source}(\\s)?`,"g");function o(a){return a.indexOf(t.iconStartMarker)===-1?a:a.replace(I,(c,m,s,l)=>s?c:m||l||"")}t.stripIcons=o;function n(a){const c=a.indexOf(t.iconStartMarker);return c===-1?{text:a}:e(a,c)}t.parseLabelWithIcons=n;function e(a,c){const m=[];let s="";function l(b){if(b){s+=b;for(const D of b)m.push(L)}}let p=-1,_="",L=0,S,A,u=c;const E=a.length;for(l(a.substr(0,c));u<E;)S=a[u],A=a[u+1],S===t.iconStartMarker[0]&&A===t.iconStartMarker[1]?(p=u,l(_),_=t.iconStartMarker,u++):S===")"&&p!==-1?(L+=u-p+1,p=-1,_=""):p!==-1?y.test(S)?_+=S:(l(_),p=-1,_=""):l(S),u++;return l(_),{text:s,iconOffsets:m}}function r(a,c,m=!1){const{text:s,iconOffsets:l}=c;if(!l||l.length===0)return(0,i.matchesFuzzy)(a,s,m);const p=(0,B.ltrim)(s," "),_=s.length-p.length,L=(0,i.matchesFuzzy)(a,p,m);if(L)for(const S of L){const A=l[S.start+_]+_;S.start+=A,S.end+=A}return L}t.matchesFuzzyIconAware=r}),define(pe[112],be([1,0,14,11]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class B{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const e=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return e-r}value(){return this._value[this._pos]}}t.StringIterator=B;class H{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,i.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=H;class y{constructor(n=!0,e=!0){this._splitOnBackslash=n,this._caseSensitive=e}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let e=n.length-1;e>=0;e--,this._valueLen--){const r=this._value.charCodeAt(e);if(!(r===47||this._splitOnBackslash&&r===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const e=this._value.charCodeAt(this._to);if(e===47||this._splitOnBackslash&&e===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,i.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=y;var v;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(n,e){this._ignorePathCasing=n,this._ignoreQueryAndFragment=e,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,i.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=h;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(f||(f={}));class I{static forUris(n=()=>!1,e=()=>!1){return new I(new h(n,e))}static forPaths(n=!1){return new I(new y(void 0,!n))}static forStrings(){return new I(new B)}static forConfigKeys(){return new I(new H)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,e){if(e){const r=e.slice(0);(0,w.shuffle)(r);for(const a of r)this.set(a,n)}else{const r=n.slice(0);(0,w.shuffle)(r);for(const a of r)this.set(a[0],a[1])}}set(n,e){const r=this._iter.reset(n);let a;this._root||(this._root=new g,this._root.segment=r.value());const c=[];for(a=this._root;;){const s=r.cmp(a.segment);if(s>0)a.left||(a.left=new g,a.left.segment=r.value()),c.push([-1,a]),a=a.left;else if(s<0)a.right||(a.right=new g,a.right.segment=r.value()),c.push([1,a]),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new g,a.mid.segment=r.value()),c.push([0,a]),a=a.mid;else break}const m=a.value;a.value=e,a.key=n;for(let s=c.length-1;s>=0;s--){const l=c[s][1];l.updateHeight();const p=l.balanceFactor();if(p<-1||p>1){const _=c[s][0],L=c[s+1][0];if(_===1&&L===1)c[s][1]=l.rotateLeft();else if(_===-1&&L===-1)c[s][1]=l.rotateRight();else if(_===1&&L===-1)l.right=c[s+1][1]=c[s+1][1].rotateRight(),c[s][1]=l.rotateLeft();else if(_===-1&&L===1)l.left=c[s+1][1]=c[s+1][1].rotateLeft(),c[s][1]=l.rotateRight();else throw new Error;if(s>0)switch(c[s-1][0]){case-1:c[s-1][1].left=c[s][1];break;case 1:c[s-1][1].right=c[s][1];break;case 0:c[s-1][1].mid=c[s][1];break}else this._root=c[0][1]}}return m}get(n){return this._getNode(n)?.value}_getNode(n){const e=this._iter.reset(n);let r=this._root;for(;r;){const a=e.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(e.hasNext())e.next(),r=r.mid;else break}return r}has(n){const e=this._getNode(n);return!(e?.value===void 0&&e?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,e){const r=this._iter.reset(n),a=[];let c=this._root;for(;c;){const m=r.cmp(c.segment);if(m>0)a.push([-1,c]),c=c.left;else if(m<0)a.push([1,c]),c=c.right;else if(r.hasNext())r.next(),a.push([0,c]),c=c.mid;else break}if(!!c){if(e?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const m=this._min(c.right);if(m.key){const{key:s,value:l,segment:p}=m;this._delete(m.key,!1),c.key=s,c.value=l,c.segment=p}}else{const m=c.left??c.right;if(a.length>0){const[s,l]=a[a.length-1];switch(s){case-1:l.left=m;break;case 0:l.mid=m;break;case 1:l.right=m;break}}else this._root=m}for(let m=a.length-1;m>=0;m--){const s=a[m][1];s.updateHeight();const l=s.balanceFactor();if(l>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[m][1]=s.rotateLeft()):l<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[m][1]=s.rotateRight()),m>0)switch(a[m-1][0]){case-1:a[m-1][1].left=a[m][1];break;case 1:a[m-1][1].right=a[m][1];break;case 0:a[m-1][1].mid=a[m][1];break}else this._root=a[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const e=this._iter.reset(n);let r=this._root,a;for(;r;){const c=e.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(e.hasNext())e.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(n){const e=this._iter.reset(n);let r=this._root;for(;r;){const a=e.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(e.hasNext())e.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[e,r]of this)n(r,e)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const e=[];return this._dfsEntries(n,e),e[Symbol.iterator]()}_dfsEntries(n,e){!n||(n.left&&this._dfsEntries(n.left,e),n.value&&e.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,e),n.right&&this._dfsEntries(n.right,e))}_isBalanced(){const n=e=>{if(!e)return!0;const r=e.balanceFactor();return r<-1||r>1?!1:n(e.left)&&n(e.right)};return n(this._root)}}t.TernarySearchTree=I}),define(pe[15],be([1,0,21,5]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const B=/^\w[\w\d+.-]*$/,H=/^\//,y=/^\/\//;function v(S,A){if(!S.scheme&&A)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${S.authority}", path: "${S.path}", query: "${S.query}", fragment: "${S.fragment}"}`);if(S.scheme&&!B.test(S.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(S.path){if(S.authority){if(!H.test(S.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(S.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(S,A){return!S&&!A?"file":S}function g(S,A){switch(S){case"https":case"http":case"file":A?A[0]!==I&&(A=I+A):A=I;break}return A}const f="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(A){return A instanceof n?!0:A?typeof A.authority=="string"&&typeof A.fragment=="string"&&typeof A.path=="string"&&typeof A.query=="string"&&typeof A.scheme=="string"&&typeof A.fsPath=="string"&&typeof A.with=="function"&&typeof A.toString=="function":!1}constructor(A,u,E,b,D,z=!1){typeof A=="object"?(this.scheme=A.scheme||f,this.authority=A.authority||f,this.path=A.path||f,this.query=A.query||f,this.fragment=A.fragment||f):(this.scheme=h(A,z),this.authority=u||f,this.path=g(this.scheme,E||f),this.query=b||f,this.fragment=D||f,v(this,z))}get fsPath(){return s(this,!1)}with(A){if(!A)return this;let{scheme:u,authority:E,path:b,query:D,fragment:z}=A;return u===void 0?u=this.scheme:u===null&&(u=f),E===void 0?E=this.authority:E===null&&(E=f),b===void 0?b=this.path:b===null&&(b=f),D===void 0?D=this.query:D===null&&(D=f),z===void 0?z=this.fragment:z===null&&(z=f),u===this.scheme&&E===this.authority&&b===this.path&&D===this.query&&z===this.fragment?this:new r(u,E,b,D,z)}static parse(A,u=!1){const E=o.exec(A);return E?new r(E[2]||f,L(E[4]||f),L(E[5]||f),L(E[7]||f),L(E[9]||f),u):new r(f,f,f,f,f)}static file(A){let u=f;if(i.isWindows&&(A=A.replace(/\\/g,I)),A[0]===I&&A[1]===I){const E=A.indexOf(I,2);E===-1?(u=A.substring(2),A=I):(u=A.substring(2,E),A=A.substring(E)||I)}return new r("file",u,A,f,f)}static from(A){const u=new r(A.scheme,A.authority,A.path,A.query,A.fragment);return v(u,!0),u}static joinPath(A,...u){if(!A.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return i.isWindows&&A.scheme==="file"?E=n.file(w.win32.join(s(A,!0),...u)).path:E=w.posix.join(A.path,...u),A.with({path:E})}toString(A=!1){return l(this,A)}toJSON(){return this}static revive(A){if(A){if(A instanceof n)return A;{const u=new r(A);return u._formatted=A.external,u._fsPath=A._sep===e?A.fsPath:null,u}}else return A}}t.URI=n;const e=i.isWindows?1:void 0;class r extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(A=!1){return A?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const A={$mid:1};return this._fsPath&&(A.fsPath=this._fsPath,A._sep=e),this._formatted&&(A.external=this._formatted),this.path&&(A.path=this.path),this.scheme&&(A.scheme=this.scheme),this.authority&&(A.authority=this.authority),this.query&&(A.query=this.query),this.fragment&&(A.fragment=this.fragment),A}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(S,A){let u,E=-1;for(let b=0;b<S.length;b++){const D=S.charCodeAt(b);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||A&&D===47)E!==-1&&(u+=encodeURIComponent(S.substring(E,b)),E=-1),u!==void 0&&(u+=S.charAt(b));else{u===void 0&&(u=S.substr(0,b));const z=a[D];z!==void 0?(E!==-1&&(u+=encodeURIComponent(S.substring(E,b)),E=-1),u+=z):E===-1&&(E=b)}}return E!==-1&&(u+=encodeURIComponent(S.substring(E))),u!==void 0?u:S}function m(S){let A;for(let u=0;u<S.length;u++){const E=S.charCodeAt(u);E===35||E===63?(A===void 0&&(A=S.substr(0,u)),A+=a[E]):A!==void 0&&(A+=S[u])}return A!==void 0?A:S}function s(S,A){let u;return S.authority&&S.path.length>1&&S.scheme==="file"?u=`//${S.authority}${S.path}`:S.path.charCodeAt(0)===47&&(S.path.charCodeAt(1)>=65&&S.path.charCodeAt(1)<=90||S.path.charCodeAt(1)>=97&&S.path.charCodeAt(1)<=122)&&S.path.charCodeAt(2)===58?A?u=S.path.substr(1):u=S.path[1].toLowerCase()+S.path.substr(2):u=S.path,i.isWindows&&(u=u.replace(/\//g,"\\")),u}t.uriToFsPath=s;function l(S,A){const u=A?m:c;let E="",{scheme:b,authority:D,path:z,query:x,fragment:ie}=S;if(b&&(E+=b,E+=":"),(D||b==="file")&&(E+=I,E+=I),D){let Q=D.indexOf("@");if(Q!==-1){const me=D.substr(0,Q);D=D.substr(Q+1),Q=me.indexOf(":"),Q===-1?E+=u(me,!1):(E+=u(me.substr(0,Q),!1),E+=":",E+=u(me.substr(Q+1),!1)),E+="@"}D=D.toLowerCase(),Q=D.indexOf(":"),Q===-1?E+=u(D,!1):(E+=u(D.substr(0,Q),!1),E+=D.substr(Q))}if(z){if(z.length>=3&&z.charCodeAt(0)===47&&z.charCodeAt(2)===58){const Q=z.charCodeAt(1);Q>=65&&Q<=90&&(z=`/${String.fromCharCode(Q+32)}:${z.substr(3)}`)}else if(z.length>=2&&z.charCodeAt(1)===58){const Q=z.charCodeAt(0);Q>=65&&Q<=90&&(z=`${String.fromCharCode(Q+32)}:${z.substr(2)}`)}E+=u(z,!0)}return x&&(E+="?",E+=u(x,!1)),ie&&(E+="#",E+=A?ie:c(ie,!1)),E}function p(S){try{return decodeURIComponent(S)}catch{return S.length>3?S.substr(0,3)+p(S.substr(3)):S}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(S){return S.match(_)?S.replace(_,A=>p(A)):S}}),define(pe[50],be([1,0,31,11,15]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function H(g){return JSON.stringify(g,v)}t.stringify=H;function y(g){let f=JSON.parse(g);return f=h(f),f}t.parse=y;function v(g,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:(0,i.regExpFlags)(f)}:f}function h(g,f=0){if(!g||f>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return B.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 15:return new Date(g.source)}if(g instanceof w.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let I=0;I<g.length;++I)g[I]=h(g[I],f+1);else for(const I in g)Object.hasOwnProperty.call(g,I)&&(g[I]=h(g[I],f+1))}return g}t.revive=h}),define(pe[35],be([1,0,5,15]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var B;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebook="vscode-notebook",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(B=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class H{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${B.vscodeRemoteResource}`}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g){this._remoteResourcesPath=`${g}/${B.vscodeRemoteResource}`}set(g,f,I){this._hosts[g]=f,this._ports[g]=I}setConnectionToken(g,f){this._connectionTokens[g]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)return this._delegate(g);const f=g.authority;let I=this._hosts[f];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const o=this._ports[f],n=this._connectionTokens[f];let e=`path=${encodeURIComponent(g.path)}`;return typeof n=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(n)}`),i.URI.from({scheme:w.isWeb?this._preferredWebSchema:B.vscodeRemoteResource,authority:`${I}:${o}`,path:this._remoteResourcesPath,query:e})}}t.RemoteAuthorities=new H;class y{asBrowserUri(g,f){const I=this.toUri(g,f);return I.scheme===B.vscodeRemote?t.RemoteAuthorities.rewrite(I):I.scheme===B.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${B.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?I.with({scheme:B.vscodeFileResource,authority:I.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(g,f){const I=this.toUri(g,f);return I.scheme===B.vscodeFileResource?I.with({scheme:B.file,authority:I.authority!==y.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(g,f){return i.URI.isUri(g)?g:i.URI.parse(f.toUrl(g))}}y.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new y;var v;(function(h){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(g.get("3"));const f="vscode-coi";function I(n){let e;typeof n=="string"?e=new URL(n).searchParams:n instanceof URL?e=n.searchParams:i.URI.isUri(n)&&(e=new URL(n.toString(!0)).searchParams);const r=e?.get(f);if(!!r)return g.get(r)}h.getHeadersFromQuery=I;function o(n,e,r){if(!globalThis.crossOriginIsolated)return;const a=e&&r?"3":r?"2":"1";n instanceof URLSearchParams?n.set(f,a):n[f]=a}h.addSearchParam=o})(v=t.COI||(t.COI={}))}),define(pe[36],be([1,0,109,35,21,5,11,15]),function(Z,t,w,i,B,H,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function h(n){return(0,v.uriToFsPath)(n,!0)}t.originalFSPath=h;class g{constructor(e){this._ignorePathCasing=e}compare(e,r,a=!1){return e===r?0:(0,y.compare)(this.getComparisonKey(e,a),this.getComparisonKey(r,a))}isEqual(e,r,a=!1){return e===r?!0:!e||!r?!1:this.getComparisonKey(e,a)===this.getComparisonKey(r,a)}getComparisonKey(e,r=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,r,a=!1){if(e.scheme===r.scheme){if(e.scheme===i.Schemas.file)return w.isEqualOrParent(h(e),h(r),this._ignorePathCasing(e))&&e.query===r.query&&(a||e.fragment===r.fragment);if((0,t.isEqualAuthority)(e.authority,r.authority))return w.isEqualOrParent(e.path,r.path,this._ignorePathCasing(e),"/")&&e.query===r.query&&(a||e.fragment===r.fragment)}return!1}joinPath(e,...r){return v.URI.joinPath(e,...r)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return B.posix.basename(e.path)}extname(e){return B.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let r;return e.scheme===i.Schemas.file?r=v.URI.file(B.dirname(h(e))).path:(r=B.posix.dirname(e.path),e.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),r="/")),e.with({path:r})}normalizePath(e){if(!e.path.length)return e;let r;return e.scheme===i.Schemas.file?r=v.URI.file(B.normalize(h(e))).path:r=B.posix.normalize(e.path),e.with({path:r})}relativePath(e,r){if(e.scheme!==r.scheme||!(0,t.isEqualAuthority)(e.authority,r.authority))return;if(e.scheme===i.Schemas.file){const m=B.relative(h(e),h(r));return H.isWindows?w.toSlashes(m):m}let a=e.path||"/";const c=r.path||"/";if(this._ignorePathCasing(e)){let m=0;for(const s=Math.min(a.length,c.length);m<s&&!(a.charCodeAt(m)!==c.charCodeAt(m)&&a.charAt(m).toLowerCase()!==c.charAt(m).toLowerCase());m++);a=c.substr(0,m)+a.substr(m)}return B.posix.relative(a,c)}resolvePath(e,r){if(e.scheme===i.Schemas.file){const a=v.URI.file(B.resolve(h(e),r));return e.with({authority:a.authority,path:a.path})}return r=w.toPosixPath(r),e.with({path:B.posix.resolve(e.path,r)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,r){return e===r||e!==void 0&&r!==void 0&&(0,y.equalsIgnoreCase)(e,r)}hasTrailingPathSeparator(e,r=B.sep){if(e.scheme===i.Schemas.file){const a=h(e);return a.length>w.getRoot(a).length&&a[a.length-1]===r}else{const a=e.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,r=B.sep){return(0,t.hasTrailingPathSeparator)(e,r)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,r=B.sep){let a=!1;if(e.scheme===i.Schemas.file){const c=h(e);a=c!==void 0&&c.length===w.getRoot(c).length&&c[c.length-1]===r}else{r="/";const c=e.path;a=c.length===1&&c.charCodeAt(c.length-1)===47}return!a&&!(0,t.hasTrailingPathSeparator)(e,r)?e.with({path:e.path+"/"}):e}}t.ExtUri=g,t.extUri=new g(()=>!1),t.extUriBiasedIgnorePathCase=new g(n=>n.scheme===i.Schemas.file?!H.isLinux:!0),t.extUriIgnorePathCase=new g(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function f(n,e){const r=[];for(let a=0;a<n.length;a++){const c=e(n[a]);n.some((m,s)=>s===a?!1:(0,t.isEqualOrParent)(c,e(m)))||r.push(n[a])}return r}t.distinctParents=f;var I;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(r){const a=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(s=>{const[l,p]=s.split(":");l&&p&&a.set(l,p)});const m=r.path.substring(0,r.path.indexOf(";"));return m&&a.set(n.META_DATA_MIME,m),a}n.parseMetaData=e})(I=t.DataUri||(t.DataUri={}));function o(n,e,r){if(e){let a=n.path;return a&&a[0]!==B.posix.sep&&(a=B.posix.sep+a),n.with({scheme:r,authority:e,path:a})}return n.with({scheme:r})}t.toLocalResource=o}),define(pe[8],be([1,0,28,9,3,2,36,5]),function(Z,t,w,i,B,H,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function h(j){return!!j&&typeof j.then=="function"}t.isThenable=h;function g(j){const P=new w.CancellationTokenSource,d=j(P.token),F=new Promise((U,$)=>{const X=P.token.onCancellationRequested(()=>{X.dispose(),P.dispose(),$(new i.CancellationError)});Promise.resolve(d).then(N=>{X.dispose(),P.dispose(),U(N)},N=>{X.dispose(),P.dispose(),$(N)})});return new class{cancel(){P.cancel()}then(U,$){return F.then(U,$)}catch(U){return this.then(void 0,U)}finally(U){return F.finally(U)}}}t.createCancelablePromise=g;function f(j,P,d){return new Promise((F,U)=>{const $=P.onCancellationRequested(()=>{$.dispose(),F(d)});j.then(F,U).finally(()=>$.dispose())})}t.raceCancellation=f;function I(j,P){return new Promise((d,F)=>{const U=P.onCancellationRequested(()=>{U.dispose(),F(new i.CancellationError)});j.then(d,F).finally(()=>U.dispose())})}t.raceCancellationError=I;async function o(j){let P=-1;const d=j.map((U,$)=>U.then(X=>(P=$,X))),F=await Promise.race(d);return j.forEach((U,$)=>{$!==P&&U.cancel()}),F}t.raceCancellablePromises=o;function n(j,P,d){let F;const U=setTimeout(()=>{F?.(void 0),d?.()},P);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise($=>F=$)])}t.raceTimeout=n;function e(j){return new Promise((P,d)=>{const F=j();h(F)?F.then(P,d):P(F)})}t.asPromise=e;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(P){if(this.activePromise){if(this.queuedPromiseFactory=P,!this.queuedPromise){const d=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(d,d).then(F)})}return new Promise((d,F)=>{this.queuedPromise.then(d,F)})}return this.activePromise=P(),new Promise((d,F)=>{this.activePromise.then(U=>{this.activePromise=null,d(U)},U=>{this.activePromise=null,F(U)})})}}t.Throttler=r;class a{constructor(){this.current=Promise.resolve(null)}queue(P){return this.current=this.current.then(()=>P(),()=>P())}}t.Sequencer=a;class c{constructor(){this.promiseMap=new Map}queue(P,d){const U=(this.promiseMap.get(P)??Promise.resolve()).catch(()=>{}).then(d).finally(()=>{this.promiseMap.get(P)===U&&this.promiseMap.delete(P)});return this.promiseMap.set(P,U),U}}t.SequencerByKey=c;const m=(j,P)=>{let d=!0;const F=setTimeout(()=>{d=!1,P()},j);return{isTriggered:()=>d,dispose:()=>{clearTimeout(F),d=!1}}},s=j=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,j())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(P){this.defaultDelay=P,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(P,d=this.defaultDelay){this.task=P,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,$)=>{this.doResolve=U,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const F=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=d===t.MicrotaskDelay?s(F):m(d,F),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=l;class p{constructor(P){this.delayer=new l(P),this.throttler=new r}trigger(P,d){return this.delayer.trigger(()=>this.throttler.queue(P),d)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=p;class _{constructor(){this._isOpen=!1,this._promise=new Promise((P,d)=>{this._completePromise=P})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=_;class L extends _{constructor(P){super(),this._timeout=setTimeout(()=>this.open(),P)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=L;function S(j,P){return P?new Promise((d,F)=>{const U=setTimeout(()=>{$.dispose(),d()},j),$=P.onCancellationRequested(()=>{clearTimeout(U),$.dispose(),F(new i.CancellationError)})}):g(d=>S(j,d))}t.timeout=S;function A(j,P=0){const d=setTimeout(j,P);return(0,H.toDisposable)(()=>clearTimeout(d))}t.disposableTimeout=A;function u(j){const P=[];let d=0;const F=j.length;function U(){return d<F?j[d++]():null}function $(X){X!=null&&P.push(X);const N=U();return N?N.then($):Promise.resolve(P)}return Promise.resolve(null).then($)}t.sequence=u;function E(j,P=F=>!!F,d=null){let F=0;const U=j.length,$=()=>{if(F>=U)return Promise.resolve(d);const X=j[F++];return Promise.resolve(X()).then(R=>P(R)?Promise.resolve(R):$())};return $()}t.first=E;function b(j,P=F=>!!F,d=null){if(j.length===0)return Promise.resolve(d);let F=j.length;const U=()=>{F=-1;for(const $ of j)$.cancel?.()};return new Promise(($,X)=>{for(const N of j)N.then(R=>{--F>=0&&P(R)?(U(),$(R)):F===0&&$(d)}).catch(R=>{--F>=0&&(U(),X(R))})})}t.firstParallel=b;class D{constructor(P){this._size=0,this.maxDegreeOfParalellism=P,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new B.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(P){return this._size++,new Promise((d,F)=>{this.outstandingPromises.push({factory:P,c:d,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const P=this.outstandingPromises.shift();this.runningPromises++;const d=P.factory();d.then(P.c,P.e),d.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=D;class z extends D{constructor(){super(1)}}t.Queue=z;class x{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const P=new se;return this.drainers.add(P),P.p}isDrained(){for(const[,P]of this.queues)if(P.size>0)return!1;return!0}queueFor(P,d=y.extUri){const F=d.getComparisonKey(P);let U=this.queues.get(F);return U||(U=new z,B.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(F),this.onDidQueueDrain()}),this.queues.set(F,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const P of this.drainers)P.complete();this.drainers.clear()}dispose(){for(const[,P]of this.queues)P.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=x;class ie{constructor(P,d){this._token=-1,typeof P=="function"&&typeof d=="number"&&this.setIfNotSet(P,d)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(P,d){this.cancel(),this._token=setTimeout(()=>{this._token=-1,P()},d)}setIfNotSet(P,d){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,P()},d))}}t.TimeoutTimer=ie;class Q{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(P,d){this.cancel(),this._token=setInterval(()=>{P()},d)}}t.IntervalTimer=Q;class me{constructor(P,d){this.timeoutToken=-1,this.runner=P,this.timeout=d,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(P=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,P)}get delay(){return this.timeout}set delay(P){this.timeout=P}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=me;class ae{constructor(P,d){d%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.runner=P,this.timeout=d,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(P=this.timeout){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(P/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ae;class fe extends me{constructor(P,d){super(P,d),this.units=[]}work(P){this.units.push(P),this.isScheduled()||this.schedule()}doRun(){const P=this.units;this.units=[],this.runner?.(P)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=fe;class le extends H.Disposable{constructor(P,d){super(),this.options=P,this.handler=d,this.pendingWork=[],this.throttler=this._register(new H.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(P){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+P.length>this.options.maxBufferedWork)return!1}else if(this.pending+P.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...P),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new me(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=le,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=j=>{(0,v.setTimeout0)(()=>{if(P)return;const d=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,d-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:t.runWhenIdle=(j,P)=>{const d=requestIdleCallback(j,typeof P=="number"?{timeout:P}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(d))}}}}();class de{constructor(P){this._didRun=!1,this._executor=()=>{try{this._value=P()}catch(d){this._error=d}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=de;async function Se(j,P,d){let F;for(let U=0;U<d;U++)try{return await j()}catch($){F=$,await S(P)}throw F}t.retry=Se;class ee{hasPending(P){return this._pending?typeof P=="number"?this._pending.taskId===P:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(P,d,F){return this._pending={taskId:P,cancel:()=>F?.(),promise:d},d.then(()=>this.donePending(P),()=>this.donePending(P)),d}donePending(P){this._pending&&P===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const P=this._next;this._next=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}setNext(P){if(this._next)this._next.run=P;else{let d,F;const U=new Promise(($,X)=>{d=$,F=X});this._next={run:P,promise:U,promiseResolve:d,promiseReject:F}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}t.TaskSequentializer=ee;class ye{constructor(P,d=()=>Date.now()){this.interval=P,this.nowFn=d,this.lastIncrementTime=0,this.value=0}increment(){const P=this.nowFn();return P-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=P,this.value=0),this.value++,this.value}}t.IntervalCounter=ye;class se{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((P,d)=>{this.completeCallback=P,this.errorCallback=d})}complete(P){return new Promise(d=>{this.completeCallback(P),this.resolved=!0,d()})}error(P){return new Promise(d=>{this.errorCallback(P),this.rejected=!0,d()})}cancel(){new Promise(P=>{this.errorCallback(new i.CancellationError),this.rejected=!0,P()})}}t.DeferredPromise=se;var te;(function(j){async function P(F){let U;const $=await Promise.all(F.map(X=>X.then(N=>N,N=>{U||(U=N)})));if(typeof U<"u")throw U;return $}j.settled=P;function d(F){return new Promise(async(U,$)=>{try{await F(U,$)}catch(X){$(X)}})}j.withAsyncBody=d})(te=t.Promises||(t.Promises={}));var ce;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ce||(ce={}));class ne{static fromArray(P){return new ne(d=>{d.emitMany(P)})}static fromPromise(P){return new ne(async d=>{d.emitMany(await P)})}static fromPromises(P){return new ne(async d=>{await Promise.all(P.map(async F=>d.emitOne(await F)))})}static merge(P){return new ne(async d=>{await Promise.all(P.map(async F=>{for await(const U of F)d.emitOne(U)}))})}constructor(P){this._state=0,this._results=[],this._error=null,this._onStateChanged=new B.Emitter,queueMicrotask(async()=>{const d={emitOne:F=>this.emitOne(F),emitMany:F=>this.emitMany(F),reject:F=>this.reject(F)};try{await Promise.resolve(P(d)),this.resolve()}catch(F){this.reject(F)}finally{d.emitOne=void 0,d.emitMany=void 0,d.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(P<this._results.length)return{done:!1,value:this._results[P++]};if(this._state===1)return{done:!0,value:void 0};await B.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(P,d){return new ne(async F=>{for await(const U of P)F.emitOne(d(U))})}map(P){return ne.map(this,P)}static filter(P,d){return new ne(async F=>{for await(const U of P)d(U)&&F.emitOne(U)})}filter(P){return ne.filter(this,P)}static coalesce(P){return ne.filter(P,d=>!!d)}coalesce(){return ne.coalesce(this)}static async toPromise(P){const d=[];for await(const F of P)d.push(F);return d}toPromise(){return ne.toPromise(this)}emitOne(P){this._state===0&&(this._results.push(P),this._onStateChanged.fire())}emitMany(P){this._state===0&&(this._results=this._results.concat(P),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(P){this._state===0&&(this._state=2,this._error=P,this._onStateChanged.fire())}}t.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class T extends ne{constructor(P,d){super(d),this._source=P}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=T;function V(j){const P=new w.CancellationTokenSource,d=j(P.token);return new T(P,async F=>{const U=P.token.onCancellationRequested(()=>{U.dispose(),P.dispose(),F.reject(new i.CancellationError)});try{for await(const $ of d){if(P.token.isCancellationRequested)return;F.emitOne($)}U.dispose(),P.dispose()}catch($){U.dispose(),P.dispose(),F.reject($)}})}t.createCancelableAsyncIterable=V}),define(pe[4],be([1,0,16,107,19,20,8,9,3,113,2,35,5,6,15]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function r(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.clearNode=r;function a(Y){return Y?.isConnected??!1}t.isInDOM=a;class c{constructor(G,ge,Ie,Te){this._node=G,this._type=ge,this._handler=Ie,this._options=Te||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function m(Y,G,ge,Ie){return new c(Y,G,ge,Ie)}t.addDisposableListener=m;function s(Y){return function(G){return Y(new H.StandardMouseEvent(G))}}function l(Y){return function(G){return Y(new B.StandardKeyboardEvent(G))}}const p=function(G,ge,Ie,Te){let Ke=Ie;return ge==="click"||ge==="mousedown"?Ke=s(Ie):(ge==="keydown"||ge==="keypress"||ge==="keyup")&&(Ke=l(Ie)),m(G,ge,Ke,Te)};t.addStandardDisposableListener=p;const _=function(G,ge,Ie){const Te=s(ge);return S(G,Te,Ie)};t.addStandardDisposableGenericMouseDownListener=_;const L=function(G,ge,Ie){const Te=s(ge);return u(G,Te,Ie)};t.addStandardDisposableGenericMouseUpListener=L;function S(Y,G,ge){return m(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,ge)}t.addDisposableGenericMouseDownListener=S;function A(Y,G,ge){return m(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,ge)}t.addDisposableGenericMouseMoveListener=A;function u(Y,G,ge){return m(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,ge)}t.addDisposableGenericMouseUpListener=u;class E{constructor(G,ge=0){this._runner=G,this.priority=ge,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(G){(0,v.onUnexpectedError)(G)}}static sort(G,ge){return ge.priority-G.priority}}(function(){let Y=[],G=null,ge=!1,Ie=!1;const Te=()=>{for(ge=!1,G=Y,Y=[],Ie=!0;G.length>0;)G.sort(E.sort),G.shift().execute();Ie=!1};t.scheduleAtNextAnimationFrame=(Ke,Ue=0)=>{const Ge=new E(Ke,Ue);return Y.push(Ge),ge||(ge=!0,requestAnimationFrame(Te)),Ge},t.runAtThisOrScheduleAtNextAnimationFrame=(Ke,Ue)=>{if(Ie){const Ge=new E(Ke,Ue);return G.push(Ge),Ge}else return(0,t.scheduleAtNextAnimationFrame)(Ke,Ue)}})();function b(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=b;function D(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=D;const z=8,x=function(Y,G){return G};class ie extends f.Disposable{constructor(G,ge,Ie,Te=x,Ke=z){super();let Ue=null,Ge=0;const Qe=this._register(new y.TimeoutTimer),gt=()=>{Ge=new Date().getTime(),Ie(Ue),Ue=null};this._register(m(G,ge,It=>{Ue=Te(Ue,It);const mt=new Date().getTime()-Ge;mt>=Ke?(Qe.cancel(),gt()):Qe.setIfNotSet(gt,Ke-mt)}))}}function Q(Y,G,ge,Ie,Te){return new ie(Y,G,ge,Ie,Te)}t.addDisposableThrottledListener=Q;function me(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=me;function ae(Y){if(Y!==document.body)return new le(Y.clientWidth,Y.clientHeight);if(o.isIOS&&window.visualViewport)return new le(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new le(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new le(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new le(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ae;class fe{static convertToPixels(G,ge){return parseFloat(ge)||0}static getDimension(G,ge,Ie){const Te=me(G),Ke=Te?Te.getPropertyValue(ge):"0";return fe.convertToPixels(G,Ke)}static getBorderLeftWidth(G){return fe.getDimension(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return fe.getDimension(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return fe.getDimension(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return fe.getDimension(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return fe.getDimension(G,"padding-left","paddingLeft")}static getPaddingRight(G){return fe.getDimension(G,"padding-right","paddingRight")}static getPaddingTop(G){return fe.getDimension(G,"padding-top","paddingTop")}static getPaddingBottom(G){return fe.getDimension(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return fe.getDimension(G,"margin-left","marginLeft")}static getMarginTop(G){return fe.getDimension(G,"margin-top","marginTop")}static getMarginRight(G){return fe.getDimension(G,"margin-right","marginRight")}static getMarginBottom(G){return fe.getDimension(G,"margin-bottom","marginBottom")}}class le{constructor(G,ge){this.width=G,this.height=ge}with(G=this.width,ge=this.height){return G!==this.width||ge!==this.height?new le(G,ge):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof le?G:new le(G.width,G.height)}static equals(G,ge){return G===ge?!0:!G||!ge?!1:G.width===ge.width&&G.height===ge.height}}t.Dimension=le,le.None=new le(0,0);function de(Y){let G=Y.offsetParent,ge=Y.offsetTop,Ie=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){ge-=Y.scrollTop;const Te=W(Y)?null:me(Y);Te&&(Ie-=Te.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Ie+=fe.getBorderLeftWidth(Y),ge+=fe.getBorderTopWidth(Y),ge+=Y.offsetTop,Ie+=Y.offsetLeft,G=Y.offsetParent)}return{left:Ie,top:ge}}t.getTopLeftOffset=de;function Se(Y,G,ge){typeof G=="number"&&(Y.style.width=`${G}px`),typeof ge=="number"&&(Y.style.height=`${ge}px`)}t.size=Se;function ee(Y,G,ge,Ie,Te,Ke="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof ge=="number"&&(Y.style.right=`${ge}px`),typeof Ie=="number"&&(Y.style.bottom=`${Ie}px`),typeof Te=="number"&&(Y.style.left=`${Te}px`),Y.style.position=Ke}t.position=ee;function ye(Y){const G=Y.getBoundingClientRect();return{left:G.left+window.scrollX,top:G.top+window.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=ye;function se(Y){let G=Y,ge=1;do{const Ie=me(G).zoom;Ie!=null&&Ie!=="1"&&(ge*=Ie),G=G.parentElement}while(G!==null&&G!==document.documentElement);return ge}t.getDomNodeZoomLevel=se;function te(Y){const G=fe.getMarginLeft(Y)+fe.getMarginRight(Y);return Y.offsetWidth+G}t.getTotalWidth=te;function ce(Y){const G=fe.getBorderLeftWidth(Y)+fe.getBorderRightWidth(Y),ge=fe.getPaddingLeft(Y)+fe.getPaddingRight(Y);return Y.offsetWidth-G-ge}t.getContentWidth=ce;function ne(Y){const G=fe.getMarginLeft(Y)+fe.getMarginRight(Y);return Y.scrollWidth+G}t.getTotalScrollWidth=ne;function T(Y){const G=fe.getBorderTopWidth(Y)+fe.getBorderBottomWidth(Y),ge=fe.getPaddingTop(Y)+fe.getPaddingBottom(Y);return Y.offsetHeight-G-ge}t.getContentHeight=T;function V(Y){const G=fe.getMarginTop(Y)+fe.getMarginBottom(Y);return Y.offsetHeight+G}t.getTotalHeight=V;function j(Y,G){if(Y===null)return 0;const ge=de(Y),Ie=de(G);return ge.left-Ie.left}function P(Y,G){const ge=G.map(Te=>Math.max(ne(Te),te(Te))+j(Te,Y)||0);return Math.max(...ge)}t.getLargestChildWidth=P;function d(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.isAncestor=d;const F="parentFlowToElementId";function U(Y,G){Y.dataset[F]=G.id}t.setParentFlowTo=U;function $(Y){const G=Y.dataset[F];return typeof G=="string"?document.getElementById(G):null}function X(Y,G){let ge=Y;for(;ge;){if(ge===G)return!0;if(ge instanceof HTMLElement){const Ie=$(ge);if(Ie){ge=Ie;continue}}ge=ge.parentNode}return!1}t.isAncestorUsingFlowTo=X;function N(Y,G,ge){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(ge){if(typeof ge=="string"){if(Y.classList.contains(ge))return null}else if(Y===ge)return null}Y=Y.parentNode}return null}t.findParentWithClass=N;function R(Y,G,ge){return!!N(Y,G,ge)}t.hasParentWithClass=R;function W(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=W;function C(Y){return!!k(Y)}t.isInShadowDOM=C;function k(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return W(Y)?Y:null}t.getShadowRoot=k;function M(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=M;function O(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",Y.appendChild(G),G}t.createStyleSheet=O;function K(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.createMetaElement=K;let J=null;function ue(){return J||(J=O()),J}function he(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function De(Y,G,ge=ue()){!ge||!G||ge.sheet.insertRule(Y+"{"+G+"}",0)}t.createCSSRule=De;function Ee(Y,G=ue()){if(!G)return;const ge=he(G),Ie=[];for(let Te=0;Te<ge.length;Te++)ge[Te].selectorText.indexOf(Y)!==-1&&Ie.push(Te);for(let Te=Ie.length-1;Te>=0;Te--)G.sheet.deleteRule(Ie[Te])}t.removeCSSRulesContainingSelector=Ee;function Ne(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Ne,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:w.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:w.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:w.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(Y,G)=>(Y.preventDefault(),G&&Y.stopPropagation(),Y)};function Ae(Y){const G=[];for(let ge=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ge++)G[ge]=Y.scrollTop,Y=Y.parentNode;return G}t.saveParentsScrollTop=Ae;function ve(Y,G){for(let ge=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ge++)Y.scrollTop!==G[ge]&&(Y.scrollTop=G[ge]),Y=Y.parentNode}t.restoreParentsScrollTop=ve;class Re extends f.Disposable{static hasFocusWithin(G){const ge=k(G),Ie=ge?ge.activeElement:document.activeElement;return d(Ie,G)}constructor(G){super(),this._onDidFocus=this._register(new h.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new h.Emitter),this.onDidBlur=this._onDidBlur.event;let ge=Re.hasFocusWithin(G),Ie=!1;const Te=()=>{Ie=!1,ge||(ge=!0,this._onDidFocus.fire())},Ke=()=>{ge&&(Ie=!0,window.setTimeout(()=>{Ie&&(Ie=!1,ge=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Re.hasFocusWithin(G)!==ge&&(ge?Ke():Te())},this._register(m(G,t.EventType.FOCUS,Te,!0)),this._register(m(G,t.EventType.BLUR,Ke,!0)),this._register(m(G,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(m(G,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}refreshState(){this._refreshStateHandler()}}function Pe(Y){return new Re(Y)}t.trackFocus=Pe;function $e(Y,G){return Y.after(G),G}t.after=$e;function He(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=He;function ze(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.prepend=ze;function Je(Y,...G){Y.innerText="",He(Y,...G)}t.reset=Je;const it=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Oe;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(Oe=t.Namespace||(t.Namespace={}));function qe(Y,G,ge,...Ie){const Te=it.exec(G);if(!Te)throw new Error("Bad use of emmet");ge={...ge||{}};const Ke=Te[1]||"div";let Ue;return Y!==Oe.HTML?Ue=document.createElementNS(Y,Ke):Ue=document.createElement(Ke),Te[3]&&(Ue.id=Te[3]),Te[4]&&(Ue.className=Te[4].replace(/\./g," ").trim()),Object.keys(ge).forEach(Ge=>{const Qe=ge[Ge];typeof Qe>"u"||(/^on\w+$/.test(Ge)?Ue[Ge]=Qe:Ge==="selected"?Qe&&Ue.setAttribute(Ge,"true"):Ue.setAttribute(Ge,Qe))}),Ue.append(...Ie),Ue}function Ye(Y,G,...ge){return qe(Oe.HTML,Y,G,...ge)}t.$=Ye,Ye.SVG=function(Y,G,...ge){return qe(Oe.SVG,Y,G,...ge)};function q(Y,G){const ge=[];return Y.forEach((Ie,Te)=>{Te>0&&(G instanceof Node?ge.push(G.cloneNode()):ge.push(document.createTextNode(G))),ge.push(Ie)}),ge}t.join=q;function oe(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.show=oe;function we(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=we;function _e(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function Fe(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&_e(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Fe;function Me(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.finalHandler=Me;function Ve(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=Ve;function tt(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=tt;function ke(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=ke;const re=780,Ce=640;function Le(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-re/2),ge=Math.floor(window.screenTop+window.innerHeight/2-Ce/2);window.open(Y,"_blank",`width=${re},height=${Ce},top=${ge},left=${G}`)}t.windowOpenPopup=Le;function We(Y,G=!0){const ge=window.open();return ge?(G&&(ge.opener=null),ge.location.href=Y,!0):!1}t.windowOpenWithSuccess=We;function je(Y){const G=()=>{Y(),ge=(0,t.scheduleAtNextAnimationFrame)(G)};let ge=(0,t.scheduleAtNextAnimationFrame)(G);return(0,f.toDisposable)(()=>ge.dispose())}t.animate=je,I.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Xe(Y){return Y?`url('${I.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Xe;function Ze(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Ze;function st(Y,G){let ge;if(e.URI.isUri(Y))ge=Y.toString(!0);else{const Te=new Blob([Y]);ge=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(ge))}const Ie=document.createElement("a");document.body.appendChild(Ie),Ie.download=G,Ie.href=ge,Ie.click(),setTimeout(()=>document.body.removeChild(Ie))}t.triggerDownload=st;function ht(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(G,"input"))(()=>{Y((0,n.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=ht;var dt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(dt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function Tt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.detectFullscreen=Tt;function Ft(Y,G=!1){const ge=document.createElement("a");return g.addHook("afterSanitizeAttributes",Ie=>{for(const Te of["href","src"])if(Ie.hasAttribute(Te)){const Ke=Ie.getAttribute(Te);if(Te==="href"&&Ke.startsWith("#"))continue;if(ge.href=Ke,!Y.includes(ge.protocol.replace(/:$/,""))){if(G&&Te==="src"&&ge.href.startsWith("data:"))continue;Ie.removeAttribute(Te)}}}),(0,f.toDisposable)(()=>{g.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Ft;const ui=[I.Schemas.http,I.Schemas.https,I.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);function ci(Y,G){const ge={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Ie=Ft(ui);try{const Te=g.sanitize(G,{...ge,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Te}finally{Ie.dispose()}}t.safeInnerHtml=ci;function hi(Y){const G=new Uint16Array(Y.length);for(let Te=0;Te<G.length;Te++)G[Te]=Y.charCodeAt(Te);let ge="";const Ie=new Uint8Array(G.buffer);for(let Te=0;Te<Ie.length;Te++)ge+=String.fromCharCode(Ie[Te]);return ge}function di(Y){return btoa(hi(Y))}t.multibyteAwareBtoa=di;class ft extends h.Emitter{constructor(){super(),this._subscriptions=new f.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(m(window,"keydown",G=>{if(G.defaultPrevented)return;const ge=new B.StandardKeyboardEvent(G);if(!(ge.keyCode===6&&G.repeat)){if(G.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(G.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(G.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(G.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(ge.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=G,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(m(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!G.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!G.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!G.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=G,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(m(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(m(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(m(document.body,"mousemove",G=>{G.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(m(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function fi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=fi;class gi extends f.Disposable{constructor(G,ge){super(),this.element=G,this.callbacks=ge,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(m(this.element,t.EventType.DRAG_ENTER,G=>{this.counter++,this.dragStartTime=G.timeStamp,this.callbacks.onDragEnter(G)})),this._register(m(this.element,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.callbacks.onDragOver?.(G,G.timeStamp-this.dragStartTime)})),this._register(m(this.element,t.EventType.DRAG_LEAVE,G=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(G))})),this._register(m(this.element,t.EventType.DRAG_END,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(G)})),this._register(m(this.element,t.EventType.DROP,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(G)}))}}t.DragAndDropObserver=gi;const mi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function pi(Y,...G){let ge,Ie;Array.isArray(G[0])?(ge={},Ie=G[0]):(ge=G[0]||{},Ie=G[1]);const Te=mi.exec(Y);if(!Te||!Te.groups)throw new Error("Bad use of h");const Ke=Te.groups.tag||"div",Ue=document.createElement(Ke);Te.groups.id&&(Ue.id=Te.groups.id),Te.groups.class&&(Ue.className=Te.groups.class.replace(/\./g," ").trim());const Ge={};if(Te.groups.name&&(Ge[Te.groups.name]=Ue),Ie)for(const Qe of Ie)Qe instanceof HTMLElement?Ue.appendChild(Qe):typeof Qe=="string"?Ue.append(Qe):(Object.assign(Ge,Qe),Ue.appendChild(Qe.root));for(const[Qe,gt]of Object.entries(ge))if(Qe==="style")for(const[It,mt]of Object.entries(gt))Ue.style.setProperty(zt(It),typeof mt=="number"?mt+"px":""+mt);else Qe==="tabIndex"?Ue.tabIndex=gt:Ue.setAttribute(zt(Qe),gt.toString());return Ge.root=Ue,Ge}t.h=pi;function zt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(pe[51],be([1,0,4,2,105]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class H extends i.Disposable{constructor(h,g){super(),this._register((0,w.addDisposableListener)(h,"dragover",f=>{f.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{g(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this._register((0,w.addDisposableListener)(h,f,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=H,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.Mimes.text};function y(v,h,g){const f=document.createElement("div");f.className=g,f.textContent=h,v.dataTransfer&&(document.body.appendChild(f),v.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>document.body.removeChild(f),0))}t.applyDragImage=y}),define(pe[52],be([1,0,4]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(o,n={}){const e=H(n);return e.textContent=o,e}t.renderText=i;function B(o,n={}){const e=H(n);return h(e,g(o,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=B;function H(o){const n=o.inline?"span":"div",e=document.createElement(n);return o.className&&(e.className=o.className),e}t.createElement=H;class y{constructor(n){this.source=n,this.index=0}eos(){return this.index>=this.source.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.source[this.index]}advance(){this.index++}}var v;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(v||(v={}));function h(o,n,e,r){let a;if(n.type===2)a=document.createTextNode(n.content||"");else if(n.type===3)a=document.createElement("b");else if(n.type===4)a=document.createElement("i");else if(n.type===7&&r)a=document.createElement("code");else if(n.type===5&&e){const c=document.createElement("a");e.disposables.add(w.addStandardDisposableListener(c,"click",m=>{e.callback(String(n.index),m)})),a=c}else n.type===8?a=document.createElement("br"):n.type===1&&(a=o);a&&o!==a&&o.appendChild(a),a&&Array.isArray(n.children)&&n.children.forEach(c=>{h(a,c,e,r)})}function g(o,n){const e={type:1,children:[]};let r=0,a=e;const c=[],m=new y(o);for(;!m.eos();){let s=m.next();const l=s==="\\"&&I(m.peek(),n)!==0;if(l&&(s=m.next()),!l&&f(s,n)&&s===m.peek()){m.advance(),a.type===2&&(a=c.pop());const p=I(s,n);if(a.type===p||a.type===5&&p===6)a=c.pop();else{const _={type:p,children:[]};p===5&&(_.index=r,r++),a.children.push(_),c.push(a),a=_}}else if(s===`
`)a.type===2&&(a=c.pop()),a.children.push({type:8});else if(a.type!==2){const p={type:2,content:s};a.children.push(p),c.push(a),a=p}else a.content+=s}return a.type===2&&(a=c.pop()),c.length,e}function f(o,n){return I(o,n)!==0}function I(o,n){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(pe[53],be([1,0,4,2]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class B{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(y,v){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const h=this._onStopCallback;this._onStopCallback=null,y&&h&&h(v)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(y,v,h,g,f){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=g,this._onStopCallback=f;let I=y;try{y.setPointerCapture(v),this._hooks.add((0,i.toDisposable)(()=>{try{y.releasePointerCapture(v)}catch{}}))}catch{I=window}this._hooks.add(w.addDisposableListener(I,w.EventType.POINTER_MOVE,o=>{if(o.buttons!==h){this.stopMonitoring(!0);return}o.preventDefault(),this._pointerMoveCallback(o)})),this._hooks.add(w.addDisposableListener(I,w.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=B});var xe=this&&this.__decorate||function(Z,t,w,i){var B=arguments.length,H=B<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,w):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(Z,t,w,i);else for(var v=Z.length-1;v>=0;v--)(y=Z[v])&&(H=(B<3?y(H):B>3?y(t,w,H):y(t,w))||H);return B>3&&H&&Object.defineProperty(t,w,H),H};define(pe[22],be([1,0,4,14,25,2,45]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var v;(function(g){g.Tap="-monaco-gesturetap",g.Change="-monaco-gesturechange",g.Start="-monaco-gesturestart",g.End="-monaco-gesturesend",g.Contextmenu="-monaco-gesturecontextmenu"})(v=t.EventType||(t.EventType={}));class h extends H.Disposable{constructor(){super(),this.dispatched=!1,this.targets=new y.LinkedList,this.ignoreTargets=new y.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(w.addDisposableListener(document,"touchstart",f=>this.onTouchStart(f),{passive:!1})),this._register(w.addDisposableListener(document,"touchend",f=>this.onTouchEnd(f))),this._register(w.addDisposableListener(document,"touchmove",f=>this.onTouchMove(f),{passive:!1}))}static addTarget(f){if(!h.isTouchDevice())return H.Disposable.None;h.INSTANCE||(h.INSTANCE=new h);const I=h.INSTANCE.targets.push(f);return(0,H.toDisposable)(I)}static ignoreTarget(f){if(!h.isTouchDevice())return H.Disposable.None;h.INSTANCE||(h.INSTANCE=new h);const I=h.INSTANCE.ignoreTargets.push(f);return(0,H.toDisposable)(I)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(f){const I=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let o=0,n=f.targetTouches.length;o<n;o++){const e=f.targetTouches.item(o);this.activeTouches[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:I,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[I],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const r=this.newGestureEvent(v.Start,e.target);r.pageX=e.pageX,r.pageY=e.pageY,this.dispatchEvent(r)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}onTouchEnd(f){const I=Date.now(),o=Object.keys(this.activeTouches).length;for(let n=0,e=f.changedTouches.length;n<e;n++){const r=f.changedTouches.item(n);if(!this.activeTouches.hasOwnProperty(String(r.identifier))){console.warn("move of an UNKNOWN touch",r);continue}const a=this.activeTouches[r.identifier],c=Date.now()-a.initialTimeStamp;if(c<h.HOLD_DELAY&&Math.abs(a.initialPageX-i.tail(a.rollingPageX))<30&&Math.abs(a.initialPageY-i.tail(a.rollingPageY))<30){const m=this.newGestureEvent(v.Tap,a.initialTarget);m.pageX=i.tail(a.rollingPageX),m.pageY=i.tail(a.rollingPageY),this.dispatchEvent(m)}else if(c>=h.HOLD_DELAY&&Math.abs(a.initialPageX-i.tail(a.rollingPageX))<30&&Math.abs(a.initialPageY-i.tail(a.rollingPageY))<30){const m=this.newGestureEvent(v.Contextmenu,a.initialTarget);m.pageX=i.tail(a.rollingPageX),m.pageY=i.tail(a.rollingPageY),this.dispatchEvent(m)}else if(o===1){const m=i.tail(a.rollingPageX),s=i.tail(a.rollingPageY),l=i.tail(a.rollingTimestamps)-a.rollingTimestamps[0],p=m-a.rollingPageX[0],_=s-a.rollingPageY[0],L=[...this.targets].filter(S=>a.initialTarget instanceof Node&&S.contains(a.initialTarget));this.inertia(L,I,Math.abs(p)/l,p>0?1:-1,m,Math.abs(_)/l,_>0?1:-1,s)}this.dispatchEvent(this.newGestureEvent(v.End,a.initialTarget)),delete this.activeTouches[r.identifier]}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}newGestureEvent(f,I){const o=document.createEvent("CustomEvent");return o.initEvent(f,!1,!0),o.initialTarget=I,o.tapCount=0,o}dispatchEvent(f){if(f.type===v.Tap){const I=new Date().getTime();let o=0;I-this._lastSetTapCountTime>h.CLEAR_TAP_COUNT_TIME?o=1:o=2,this._lastSetTapCountTime=I,f.tapCount=o}else(f.type===v.Change||f.type===v.Contextmenu)&&(this._lastSetTapCountTime=0);if(f.initialTarget instanceof Node){for(const I of this.ignoreTargets)if(I.contains(f.initialTarget))return;for(const I of this.targets)I.contains(f.initialTarget)&&(I.dispatchEvent(f),this.dispatched=!0)}}inertia(f,I,o,n,e,r,a,c){this.handle=w.scheduleAtNextAnimationFrame(()=>{const m=Date.now(),s=m-I;let l=0,p=0,_=!0;o+=h.SCROLL_FRICTION*s,r+=h.SCROLL_FRICTION*s,o>0&&(_=!1,l=n*o*s),r>0&&(_=!1,p=a*r*s);const L=this.newGestureEvent(v.Change);L.translationX=l,L.translationY=p,f.forEach(S=>S.dispatchEvent(L)),_||this.inertia(f,m,o,n,e+l,r,a,c+p)})}onTouchMove(f){const I=Date.now();for(let o=0,n=f.changedTouches.length;o<n;o++){const e=f.changedTouches.item(o);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const r=this.activeTouches[e.identifier],a=this.newGestureEvent(v.Change,r.initialTarget);a.translationX=e.pageX-i.tail(r.rollingPageX),a.translationY=e.pageY-i.tail(r.rollingPageY),a.pageX=e.pageX,a.pageY=e.pageY,this.dispatchEvent(a),r.rollingPageX.length>3&&(r.rollingPageX.shift(),r.rollingPageY.shift(),r.rollingTimestamps.shift()),r.rollingPageX.push(e.pageX),r.rollingPageY.push(e.pageY),r.rollingTimestamps.push(I)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}}h.SCROLL_FRICTION=-.005,h.HOLD_DELAY=700,h.CLEAR_TAP_COUNT_TIME=400,xe([B.memoize],h,"isTouchDevice",null),t.Gesture=h}),define(pe[54],be([1,0,4,5,82]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const B=2e4;let H,y,v,h,g;function f(e){H=document.createElement("div"),H.className="monaco-aria-container";const r=()=>{const c=document.createElement("div");return c.className="monaco-alert",c.setAttribute("role","alert"),c.setAttribute("aria-atomic","true"),H.appendChild(c),c};y=r(),v=r();const a=()=>{const c=document.createElement("div");return c.className="monaco-status",c.setAttribute("role","complementary"),c.setAttribute("aria-live","polite"),c.setAttribute("aria-atomic","true"),H.appendChild(c),c};h=a(),g=a(),e.appendChild(H)}t.setARIAContainer=f;function I(e){!H||(y.textContent!==e?(w.clearNode(v),n(y,e)):(w.clearNode(y),n(v,e)))}t.alert=I;function o(e){!H||(i.isMacintosh?I(e):h.textContent!==e?(w.clearNode(g),n(h,e)):(w.clearNode(h),n(g,e)))}t.status=o;function n(e,r){w.clearNode(e),r.length>B&&(r=r.substr(0,B)),e.textContent=r,e.style.visibility="hidden",e.style.visibility="visible"}}),define(pe[114],be([1,0,4,12]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const B=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function H(v){const h=new Array;let g,f=0,I=0;for(;(g=B.exec(v))!==null;){I=g.index||0,f<I&&h.push(v.substring(f,I)),f=(g.index||0)+g[0].length;const[,o,n]=g;h.push(o?`$(${n})`:y({id:n}))}return f<v.length&&h.push(v.substring(f)),h}t.renderLabelWithIcons=H;function y(v){const h=w.$("span");return h.classList.add(...i.CSSIcon.asClassNameArray(v)),h}t.renderIcon=y}),define(pe[115],be([1,0,4]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(H){try{H.parentElement?.removeChild(H)}catch{}}class B{constructor(y){this.renderers=y,this.cache=new Map}alloc(y){let v=this.getTemplateCache(y).pop();if(!v){const h=(0,w.$)(".monaco-list-row"),f=this.getRenderer(y).renderTemplate(h);v={domNode:h,templateId:y,templateData:f}}return v}release(y){!y||this.releaseRow(y)}releaseRow(y){const{domNode:v,templateId:h}=y;v&&(v.classList.remove("scrolling"),i(v)),this.getTemplateCache(h).push(y)}getTemplateCache(y){let v=this.cache.get(y);return v||(v=[],this.cache.set(y,v)),v}dispose(){this.cache.forEach((y,v)=>{for(const h of y)this.getRenderer(v).disposeTemplate(h.templateData),h.templateData=null}),this.cache.clear()}getRenderer(y){const v=this.renderers.get(y);if(!v)throw new Error(`No renderer found for ${y}`);return v}}t.RowCache=B}),define(pe[116],be([1,0,8,2]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class B extends i.Disposable{constructor(y,v,h){super(),this._visibility=y,this._visibleClassName=v,this._invisibleClassName=h,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new w.TimeoutTimer)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this._updateShouldBeVisible())}setShouldBeVisible(y){this._rawShouldBeVisible=y,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const y=this._applyVisibilitySetting();this._shouldBeVisible!==y&&(this._shouldBeVisible=y,this.ensureVisibility())}setIsNeeded(y){this._isNeeded!==y&&(this._isNeeded=y,this.ensureVisibility())}setDomNode(y){this._domNode=y,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(y){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(y?" fade":"")))}}t.ScrollbarVisibilityController=B}),define(pe[117],be([1,0,4,22,14,3,2,5]),function(Z,t,w,i,B,H,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class h extends y.Disposable{constructor(f,I,o,n){super(),this.selected=0,this.selectBoxOptions=n||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new H.Emitter),this.styles=o,this.registerListeners(),this.setOptions(f,I)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(f=>{this._register(w.addDisposableListener(this.selectElement,f,I=>{this.selectElement.focus()}))}),this._register(w.addStandardDisposableListener(this.selectElement,"click",f=>{w.EventHelper.stop(f,!0)})),this._register(w.addStandardDisposableListener(this.selectElement,"change",f=>{this.selectElement.title=f.target.value,this._onDidSelect.fire({index:f.target.selectedIndex,selected:f.target.value})})),this._register(w.addStandardDisposableListener(this.selectElement,"keydown",f=>{let I=!1;v.isMacintosh?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(I=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(I=!0),I&&f.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(f,I){(!this.options||!B.equals(this.options,f))&&(this.options=f,this.selectElement.options.length=0,this.options.forEach((o,n)=>{this.selectElement.add(this.createOption(o.text,n,o.isDisabled))})),I!==void 0&&this.select(I)}select(f){this.options.length===0?this.selected=0:f>=0&&f<this.options.length?this.selected=f:f>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(f){this.selectBoxOptions.ariaLabel=f,this.selectElement.setAttribute("aria-label",f)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(f){this.selectElement.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(f){this.styles=f,this.applyStyles()}applyStyles(){if(this.selectElement){const f=this.styles.selectBackground?this.styles.selectBackground.toString():"",I=this.styles.selectForeground?this.styles.selectForeground.toString():"",o=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=f,this.selectElement.style.color=I,this.selectElement.style.borderColor=o}}createOption(f,I,o){const n=document.createElement("option");return n.value=f,n.text=f,n.disabled=!!o,n}}t.SelectBoxNative=h}),define(pe[55],be([1,0,23,14,8,111,3,26]),function(Z,t,w,i,B,H,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function h(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=h;function g(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=g;function f(o){return typeof o.collapsible=="boolean"}class I{constructor(n,e,r,a={}){this.user=n,this.list=e,this.rootRef=[],this.eventBufferer=new y.EventBufferer,this._onDidChangeCollapseState=new y.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new y.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new y.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new B.Delayer(B.MicrotaskDelay),this.collapseByDefault=typeof a.collapseByDefault>"u"?!1:a.collapseByDefault,this.filter=a.filter,this.autoExpandSingleChildren=typeof a.autoExpandSingleChildren>"u"?!1:a.autoExpandSingleChildren,this.root={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,r=v.Iterable.empty(),a={}){if(n.length===0)throw new w.TreeError(this.user,"Invalid tree location");a.diffIdentityProvider?this.spliceSmart(a.diffIdentityProvider,n,e,r,a):this.spliceSimple(n,e,r,a)}spliceSmart(n,e,r,a=v.Iterable.empty(),c,m=c.diffDepth??0){const{parentNode:s}=this.getParentNodeWithListIndex(e);if(!s.lastDiffIds)return this.spliceSimple(e,r,a,c);const l=[...a],p=e[e.length-1],_=new H.LcsDiff({getElements:()=>s.lastDiffIds},{getElements:()=>[...s.children.slice(0,p),...l,...s.children.slice(p+r)].map(E=>n.getId(E.element).toString())}).ComputeDiff(!1);if(_.quitEarly)return s.lastDiffIds=void 0,this.spliceSimple(e,r,l,c);const L=e.slice(0,-1),S=(E,b,D)=>{if(m>0)for(let z=0;z<D;z++)E--,b--,this.spliceSmart(n,[...L,E,0],Number.MAX_SAFE_INTEGER,l[b].children,c,m-1)};let A=Math.min(s.children.length,p+r),u=l.length;for(const E of _.changes.sort((b,D)=>D.originalStart-b.originalStart))S(A,u,A-(E.originalStart+E.originalLength)),A=E.originalStart,u=E.modifiedStart-p,this.spliceSimple([...L,A],E.originalLength,v.Iterable.slice(l,u,u+E.modifiedLength),c);S(A,u,A)}spliceSimple(n,e,r=v.Iterable.empty(),{onDidCreateNode:a,onDidDeleteNode:c,diffIdentityProvider:m}){const{parentNode:s,listIndex:l,revealed:p,visible:_}=this.getParentNodeWithListIndex(n),L=[],S=v.Iterable.map(r,ae=>this.createTreeNode(ae,s,s.visible?1:0,p,L,a)),A=n[n.length-1],u=s.children.length>0;let E=0;for(let ae=A;ae>=0&&ae<s.children.length;ae--){const fe=s.children[ae];if(fe.visible){E=fe.visibleChildIndex;break}}const b=[];let D=0,z=0;for(const ae of S)b.push(ae),z+=ae.renderNodeCount,ae.visible&&(ae.visibleChildIndex=E+D++);const x=(0,i.splice)(s.children,A,e,b);m?s.lastDiffIds?(0,i.splice)(s.lastDiffIds,A,e,b.map(ae=>m.getId(ae.element).toString())):s.lastDiffIds=s.children.map(ae=>m.getId(ae.element).toString()):s.lastDiffIds=void 0;let ie=0;for(const ae of x)ae.visible&&ie++;if(ie!==0)for(let ae=A+b.length;ae<s.children.length;ae++){const fe=s.children[ae];fe.visible&&(fe.visibleChildIndex-=ie)}if(s.visibleChildrenCount+=D-ie,p&&_){const ae=x.reduce((fe,le)=>fe+(le.visible?le.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(s,z-ae),this.list.splice(l,ae,L)}if(x.length>0&&c){const ae=fe=>{c(fe),fe.children.forEach(ae)};x.forEach(ae)}this._onDidSplice.fire({insertedNodes:b,deletedNodes:x});const Q=s.children.length>0;u!==Q&&this.setCollapsible(n.slice(0,-1),Q);let me=s;for(;me;){if(me.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}me=me.parent}}rerender(n){if(n.length===0)throw new w.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:r,revealed:a}=this.getTreeNodeWithListIndex(n);e.visible&&a&&this.list.splice(r,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new w.TreeError(this.user,"Invalid tree location");const{listIndex:r}=this.getTreeNodeWithListIndex(n);this.list.updateElementHeight(r,e)}has(n){return this.hasTreeNode(n)}getListIndex(n){const{listIndex:e,visible:r,revealed:a}=this.getTreeNodeWithListIndex(n);return r&&a?e:-1}getListRenderCount(n){return this.getTreeNode(n).renderNodeCount}isCollapsible(n){return this.getTreeNode(n).collapsible}setCollapsible(n,e){const r=this.getTreeNode(n);typeof e>"u"&&(e=!r.collapsible);const a={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(n,a))}isCollapsed(n){return this.getTreeNode(n).collapsed}setCollapsed(n,e,r){const a=this.getTreeNode(n);typeof e>"u"&&(e=!a.collapsed);const c={collapsed:e,recursive:r||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(n,c))}_setCollapseState(n,e){const{node:r,listIndex:a,revealed:c}=this.getTreeNodeWithListIndex(n),m=this._setListNodeCollapseState(r,a,c,e);if(r!==this.root&&this.autoExpandSingleChildren&&m&&!f(e)&&r.collapsible&&!r.collapsed&&!e.recursive){let s=-1;for(let l=0;l<r.children.length;l++)if(r.children[l].visible)if(s>-1){s=-1;break}else s=l;s>-1&&this._setCollapseState([...n,s],e)}return m}_setListNodeCollapseState(n,e,r,a){const c=this._setNodeCollapseState(n,a,!1);if(!r||!n.visible||!c)return c;const m=n.renderNodeCount,s=this.updateNodeAfterCollapseChange(n),l=m-(e===-1?0:1);return this.list.splice(e+1,l,s.slice(1)),c}_setNodeCollapseState(n,e,r){let a;if(n===this.root?a=!1:(f(e)?(a=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(a=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):a=!1,a&&this._onDidChangeCollapseState.fire({node:n,deep:r})),!f(e)&&e.recursive)for(const c of n.children)a=this._setNodeCollapseState(c,e,!0)||a;return a}expandTo(n){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this._setCollapseState(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,n,e),this.refilterDelayer.cancel()}createTreeNode(n,e,r,a,c,m){const s={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.collapseByDefault:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},l=this._filterNode(s,r);s.visibility=l,a&&c.push(s);const p=n.children||v.Iterable.empty(),_=a&&l!==0&&!s.collapsed,L=v.Iterable.map(p,u=>this.createTreeNode(u,s,l,_,c,m));let S=0,A=1;for(const u of L)s.children.push(u),A+=u.renderNodeCount,u.visible&&(u.visibleChildIndex=S++);return s.collapsible=s.collapsible||s.children.length>0,s.visibleChildrenCount=S,s.visible=l===2?S>0:l===1,s.visible?s.collapsed||(s.renderNodeCount=A):(s.renderNodeCount=0,a&&c.pop()),m?.(s),s}updateNodeAfterCollapseChange(n){const e=n.renderNodeCount,r=[];return this._updateNodeAfterCollapseChange(n,r),this._updateAncestorsRenderNodeCount(n.parent,r.length-e),r}_updateNodeAfterCollapseChange(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const r of n.children)n.renderNodeCount+=this._updateNodeAfterCollapseChange(r,e);return this._onDidChangeRenderNodeCount.fire(n),n.renderNodeCount}updateNodeAfterFilterChange(n){const e=n.renderNodeCount,r=[];return this._updateNodeAfterFilterChange(n,n.visible?1:0,r),this._updateAncestorsRenderNodeCount(n.parent,r.length-e),r}_updateNodeAfterFilterChange(n,e,r,a=!0){let c;if(n!==this.root){if(c=this._filterNode(n,e),c===0)return n.visible=!1,n.renderNodeCount=0,!1;a&&r.push(n)}const m=r.length;n.renderNodeCount=n===this.root?0:1;let s=!1;if(!n.collapsed||c!==0){let l=0;for(const p of n.children)s=this._updateNodeAfterFilterChange(p,c,r,a&&!n.collapsed)||s,p.visible&&(p.visibleChildIndex=l++);n.visibleChildrenCount=l}else n.visibleChildrenCount=0;return n!==this.root&&(n.visible=c===2?s:c===1,n.visibility=c),n.visible?n.collapsed||(n.renderNodeCount+=r.length-m):(n.renderNodeCount=0,a&&r.pop()),this._onDidChangeRenderNodeCount.fire(n),n.visible}_updateAncestorsRenderNodeCount(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(n),n=n.parent}_filterNode(n,e){const r=this.filter?this.filter.filter(n.element,e):1;return typeof r=="boolean"?(n.filterData=void 0,r?1:0):h(r)?(n.filterData=r.data,g(r.visibility)):(n.filterData=void 0,g(r))}hasTreeNode(n,e=this.root){if(!n||n.length===0)return!0;const[r,...a]=n;return r<0||r>e.children.length?!1:this.hasTreeNode(a,e.children[r])}getTreeNode(n,e=this.root){if(!n||n.length===0)return e;const[r,...a]=n;if(r<0||r>e.children.length)throw new w.TreeError(this.user,"Invalid tree location");return this.getTreeNode(a,e.children[r])}getTreeNodeWithListIndex(n){if(n.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:r,revealed:a,visible:c}=this.getParentNodeWithListIndex(n),m=n[n.length-1];if(m<0||m>e.children.length)throw new w.TreeError(this.user,"Invalid tree location");const s=e.children[m];return{node:s,listIndex:r,revealed:a,visible:c&&s.visible}}getParentNodeWithListIndex(n,e=this.root,r=0,a=!0,c=!0){const[m,...s]=n;if(m<0||m>e.children.length)throw new w.TreeError(this.user,"Invalid tree location");for(let l=0;l<m;l++)r+=e.children[l].renderNodeCount;return a=a&&!e.collapsed,c=c&&e.visible,s.length===0?{parentNode:e,listIndex:r,revealed:a,visible:c}:this.getParentNodeWithListIndex(s,e.children[m],r+1,a,c)}getNode(n=[]){return this.getTreeNode(n)}getNodeLocation(n){const e=[];let r=n;for(;r.parent;)e.push(r.parent.children.indexOf(r)),r=r.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.getTreeNode(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.getTreeNode(n);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(n){return n.children.length===0?n.element:this._getLastElementAncestor(n.children[n.children.length-1])}}t.IndexTreeModel=I}),define(pe[118],be([1,0,55,23,26]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class H{get size(){return this.nodes.size}constructor(v,h,g={}){this.user=v,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new w.IndexTreeModel(v,h,null,g),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,g.sorter&&(this.sorter={compare(f,I){return g.sorter.compare(f.element,I.element)}}),this.identityProvider=g.identityProvider}setChildren(v,h=B.Iterable.empty(),g={}){const f=this.getElementLocation(v);this._setChildren(f,this.preserveCollapseState(h),g)}_setChildren(v,h=B.Iterable.empty(),g){const f=new Set,I=new Set,o=e=>{if(e.element===null)return;const r=e;if(f.add(r.element),this.nodes.set(r.element,r),this.identityProvider){const a=this.identityProvider.getId(r.element).toString();I.add(a),this.nodesByIdentity.set(a,r)}g.onDidCreateNode?.(r)},n=e=>{if(e.element===null)return;const r=e;if(f.has(r.element)||this.nodes.delete(r.element),this.identityProvider){const a=this.identityProvider.getId(r.element).toString();I.has(a)||this.nodesByIdentity.delete(a)}g.onDidDeleteNode?.(r)};this.model.splice([...v,0],Number.MAX_VALUE,h,{...g,onDidCreateNode:o,onDidDeleteNode:n})}preserveCollapseState(v=B.Iterable.empty()){return this.sorter&&(v=[...v].sort(this.sorter.compare.bind(this.sorter))),B.Iterable.map(v,h=>{let g=this.nodes.get(h.element);if(!g&&this.identityProvider){const o=this.identityProvider.getId(h.element).toString();g=this.nodesByIdentity.get(o)}if(!g)return{...h,children:this.preserveCollapseState(h.children)};const f=typeof h.collapsible=="boolean"?h.collapsible:g.collapsible,I=typeof h.collapsed<"u"?h.collapsed:g.collapsed;return{...h,collapsible:f,collapsed:I,children:this.preserveCollapseState(h.children)}})}rerender(v){const h=this.getElementLocation(v);this.model.rerender(h)}updateElementHeight(v,h){const g=this.getElementLocation(v);this.model.updateElementHeight(g,h)}resort(v=null,h=!0){if(!this.sorter)return;const g=this.getElementLocation(v),f=this.model.getNode(g);this._setChildren(g,this.resortChildren(f,h),{})}resortChildren(v,h,g=!0){let f=[...v.children];return(h||g)&&(f=f.sort(this.sorter.compare.bind(this.sorter))),B.Iterable.map(f,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.resortChildren(I,h,!1)}))}getFirstElementChild(v=null){const h=this.getElementLocation(v);return this.model.getFirstElementChild(h)}getLastElementAncestor(v=null){const h=this.getElementLocation(v);return this.model.getLastElementAncestor(h)}has(v){return this.nodes.has(v)}getListIndex(v){const h=this.getElementLocation(v);return this.model.getListIndex(h)}getListRenderCount(v){const h=this.getElementLocation(v);return this.model.getListRenderCount(h)}isCollapsible(v){const h=this.getElementLocation(v);return this.model.isCollapsible(h)}setCollapsible(v,h){const g=this.getElementLocation(v);return this.model.setCollapsible(g,h)}isCollapsed(v){const h=this.getElementLocation(v);return this.model.isCollapsed(h)}setCollapsed(v,h,g){const f=this.getElementLocation(v);return this.model.setCollapsed(f,h,g)}expandTo(v){const h=this.getElementLocation(v);this.model.expandTo(h)}refilter(){this.model.refilter()}getNode(v=null){if(v===null)return this.model.getNode(this.model.rootRef);const h=this.nodes.get(v);if(!h)throw new i.TreeError(this.user,`Tree element not found: ${v}`);return h}getNodeLocation(v){return v.element}getParentNodeLocation(v){if(v===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const h=this.nodes.get(v);if(!h)throw new i.TreeError(this.user,`Tree element not found: ${v}`);const g=this.model.getNodeLocation(h),f=this.model.getParentNodeLocation(g);return this.model.getNode(f).element}getElementLocation(v){if(v===null)return[];const h=this.nodes.get(v);if(!h)throw new i.TreeError(this.user,`Tree element not found: ${v}`);return this.model.getNodeLocation(h)}}t.ObjectTreeModel=H}),define(pe[17],be([1,0,4,19,20,22,2]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class v extends y.Disposable{onclick(g,f){this._register(w.addDisposableListener(g,w.EventType.CLICK,I=>f(new B.StandardMouseEvent(I))))}onmousedown(g,f){this._register(w.addDisposableListener(g,w.EventType.MOUSE_DOWN,I=>f(new B.StandardMouseEvent(I))))}onmouseover(g,f){this._register(w.addDisposableListener(g,w.EventType.MOUSE_OVER,I=>f(new B.StandardMouseEvent(I))))}onmouseleave(g,f){this._register(w.addDisposableListener(g,w.EventType.MOUSE_LEAVE,I=>f(new B.StandardMouseEvent(I))))}onkeydown(g,f){this._register(w.addDisposableListener(g,w.EventType.KEY_DOWN,I=>f(new i.StandardKeyboardEvent(I))))}onkeyup(g,f){this._register(w.addDisposableListener(g,w.EventType.KEY_UP,I=>f(new i.StandardKeyboardEvent(I))))}oninput(g,f){this._register(w.addDisposableListener(g,w.EventType.INPUT,f))}onblur(g,f){this._register(w.addDisposableListener(g,w.EventType.BLUR,f))}onfocus(g,f){this._register(w.addDisposableListener(g,w.EventType.FOCUS,f))}onchange(g,f){this._register(w.addDisposableListener(g,w.EventType.CHANGE,f))}ignoreGesture(g){return H.Gesture.ignoreTarget(g)}}t.Widget=v}),define(pe[37],be([1,0,53,17,8,4]),function(Z,t,w,i,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(h){super(),this._onActivate=h.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=h.bgWidth+"px",this.bgDomNode.style.height=h.bgHeight+"px",typeof h.top<"u"&&(this.bgDomNode.style.top="0px"),typeof h.left<"u"&&(this.bgDomNode.style.left="0px"),typeof h.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof h.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=h.className,this.domNode.classList.add(...h.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof h.top<"u"&&(this.domNode.style.top=h.top+"px"),typeof h.left<"u"&&(this.domNode.style.left=h.left+"px"),typeof h.bottom<"u"&&(this.domNode.style.bottom=h.bottom+"px"),typeof h.right<"u"&&(this.domNode.style.right=h.right+"px"),this._pointerMoveMonitor=this._register(new w.GlobalPointerMoveMonitor),this._register(H.addStandardDisposableListener(this.bgDomNode,H.EventType.POINTER_DOWN,g=>this._arrowPointerDown(g))),this._register(H.addStandardDisposableListener(this.domNode,H.EventType.POINTER_DOWN,g=>this._arrowPointerDown(g))),this._pointerdownRepeatTimer=this._register(new B.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new B.TimeoutTimer)}_arrowPointerDown(h){if(!h.target||!(h.target instanceof Element))return;const g=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(g,200),this._pointerMoveMonitor.startMonitoring(h.target,h.pointerId,h.buttons,f=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),h.preventDefault()}}t.ScrollbarArrow=y}),define(pe[56],be([1,0,4,40,53,37,116,17,5]),function(Z,t,w,i,B,H,y,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const g=140;class f extends v.Widget{constructor(o){super(),this._lazyRender=o.lazyRender,this._host=o.host,this._scrollable=o.scrollable,this._scrollByPage=o.scrollByPage,this._scrollbarState=o.scrollbarState,this._visibilityController=this._register(new y.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new B.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(w.addDisposableListener(this.domNode.domNode,w.EventType.POINTER_DOWN,n=>this._domNodePointerDown(n)))}_createArrow(o){const n=this._register(new H.ScrollbarArrow(o));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}_createSlider(o,n,e,r){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof r=="number"&&this.slider.setHeight(r),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(w.addDisposableListener(this.slider.domNode,w.EventType.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this._sliderPointerDown(a))})),this.onclick(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}_onElementSize(o){return this._scrollbarState.setVisibleSize(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(o){return this._scrollbarState.setScrollSize(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(o){return this._scrollbarState.setScrollPosition(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(o){o.target===this.domNode.domNode&&this._onPointerDown(o)}delegatePointerDown(o){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this._scrollbarState.getSliderPosition(),r=n+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),a=this._sliderPointerPosition(o);e<=a&&a<=r?o.button===0&&(o.preventDefault(),this._sliderPointerDown(o)):this._onPointerDown(o)}_onPointerDown(o){let n,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")n=o.offsetX,e=o.offsetY;else{const a=w.getDomNodePagePosition(this.domNode.domNode);n=o.pageX-a.left,e=o.pageY-a.top}const r=this._pointerDownRelativePosition(n,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(r):this._scrollbarState.getDesiredScrollPositionFromOffset(r)),o.button===0&&(o.preventDefault(),this._sliderPointerDown(o))}_sliderPointerDown(o){if(!o.target||!(o.target instanceof Element))return;const n=this._sliderPointerPosition(o),e=this._sliderOrthogonalPointerPosition(o),r=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(o.target,o.pointerId,o.buttons,a=>{const c=this._sliderOrthogonalPointerPosition(a),m=Math.abs(c-e);if(h.isWindows&&m>g){this._setDesiredScrollPositionNow(r.getScrollPosition());return}const l=this._sliderPointerPosition(a)-n;this._setDesiredScrollPositionNow(r.getDesiredScrollPositionFromDelta(l))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(o){const n={};this.writeScrollPosition(n,o),this._scrollable.setScrollPositionNow(n)}updateScrollbarSize(o){this._updateScrollbarSize(o),this._scrollbarState.setScrollbarSize(o),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=f}),define(pe[119],be([1,0,20,56,37,41,12]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class v extends i.AbstractScrollbar{constructor(g,f,I){const o=g.getScrollDimensions(),n=g.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:I,scrollbarState:new H.ScrollbarState(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,o.width,o.scrollWidth,n.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-B.ARROW_IMG_SIZE)/2,r=(f.horizontalScrollbarSize-B.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:r,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new w.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new w.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}_updateSlider(g,f){this.slider.setWidth(g),this.slider.setLeft(f)}_renderDomNode(g,f){this.domNode.setWidth(g),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this._shouldRender=this._onElementScrollSize(g.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(g.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(g.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(g,f){return g}_sliderPointerPosition(g){return g.pageX}_sliderOrthogonalPointerPosition(g){return g.pageY}_updateScrollbarSize(g){this.slider.setHeight(g)}writeScrollPosition(g,f){g.scrollLeft=f}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this._visibilityController.setVisibility(g.horizontal),this._scrollByPage=g.scrollByPage}}t.HorizontalScrollbar=v}),define(pe[120],be([1,0,20,56,37,41,12]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class v extends i.AbstractScrollbar{constructor(g,f,I){const o=g.getScrollDimensions(),n=g.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:I,scrollbarState:new H.ScrollbarState(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,o.height,o.scrollHeight,n.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-B.ARROW_IMG_SIZE)/2,r=(f.verticalScrollbarSize-B.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:r,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new w.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:r,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new w.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}_updateSlider(g,f){this.slider.setHeight(g),this.slider.setTop(f)}_renderDomNode(g,f){this.domNode.setWidth(f),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this._shouldRender=this._onElementScrollSize(g.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(g.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(g.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(g,f){return f}_sliderPointerPosition(g){return g.pageY}_sliderOrthogonalPointerPosition(g){return g.pageX}_updateScrollbarSize(g){this.slider.setWidth(g)}writeScrollPosition(g,f){g.scrollTop=f}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(g.vertical),this._scrollByPage=g.scrollByPage}}t.VerticalScrollbar=v}),define(pe[57],be([1,0,16,4,40,20,119,120,17,8,3,2,5,49,89]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,r=50,a=!0;class c{constructor(A,u,E){this.timestamp=A,this.deltaX=u,this.deltaY=E,this.score=0}}class m{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let A=1,u=0,E=1,b=this._rear;do{const D=b===this._front?A:Math.pow(2,-E);if(A-=D,u+=this._memory[b].score*D,b===this._front)break;b=(this._capacity+b-1)%this._capacity,E++}while(!0);return u<=.5}accept(A,u,E){const b=new c(A,u,E);b.score=this._computeScore(b),this._front===-1&&this._rear===-1?(this._memory[0]=b,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=b)}_computeScore(A){if(Math.abs(A.deltaX)>0&&Math.abs(A.deltaY)>0)return 1;let u=.5;const E=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(A.deltaX)||!this._isAlmostInt(A.deltaY))&&(u+=.25),Math.min(Math.max(u,0),1)}_isAlmostInt(A){return Math.abs(Math.round(A)-A)<.01}}t.MouseWheelClassifier=m,m.INSTANCE=new m;class s extends h.Widget{get options(){return this._options}constructor(A,u,E){super(),this._onScroll=this._register(new f.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new f.Emitter),this.onWillScroll=this._onWillScroll.event,A.style.overflow="hidden",this._options=L(u),this._scrollable=E,this._register(this._scrollable.onScroll(D=>{this._onWillScroll.fire(D),this._onDidScroll(D),this._onScroll.fire(D)}));const b={onMouseWheel:D=>this._onMouseWheel(D),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new v.VerticalScrollbar(this._scrollable,this._options,b)),this._horizontalScrollbar=this._register(new y.HorizontalScrollbar(this._scrollable,this._options,b)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(A),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,B.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,B.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,B.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,D=>this._onMouseOver(D)),this.onmouseleave(this._listenOnDomNode,D=>this._onMouseLeave(D)),this._hideTimeout=this._register(new g.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,I.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(A){this._verticalScrollbar.delegatePointerDown(A)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(A){this._scrollable.setScrollDimensions(A,!1)}updateClassName(A){this._options.className=A,o.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(A){typeof A.handleMouseWheel<"u"&&(this._options.handleMouseWheel=A.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof A.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=A.mouseWheelScrollSensitivity),typeof A.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=A.fastScrollSensitivity),typeof A.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=A.scrollPredominantAxis),typeof A.horizontal<"u"&&(this._options.horizontal=A.horizontal),typeof A.vertical<"u"&&(this._options.vertical=A.vertical),typeof A.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=A.horizontalScrollbarSize),typeof A.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=A.verticalScrollbarSize),typeof A.scrollByPage<"u"&&(this._options.scrollByPage=A.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(A){this._revealOnScroll=A}delegateScrollFromMouseWheelEvent(A){this._onMouseWheel(new H.StandardWheelEvent(A))}_setListeningToMouseWheel(A){if(this._mouseWheelToDispose.length>0!==A&&(this._mouseWheelToDispose=(0,I.dispose)(this._mouseWheelToDispose),A)){const E=b=>{this._onMouseWheel(new H.StandardWheelEvent(b))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,E,{passive:!1}))}}_onMouseWheel(A){const u=m.INSTANCE;if(a){const D=window.devicePixelRatio/(0,w.getZoomFactor)();o.isWindows||o.isLinux?u.accept(Date.now(),A.deltaX/D,A.deltaY/D):u.accept(Date.now(),A.deltaX,A.deltaY)}let E=!1;if(A.deltaY||A.deltaX){let D=A.deltaY*this._options.mouseWheelScrollSensitivity,z=A.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(D)>=Math.abs(z)?z=0:D=0),this._options.flipAxes&&([D,z]=[z,D]);const x=!o.isMacintosh&&A.browserEvent&&A.browserEvent.shiftKey;(this._options.scrollYToX||x)&&!z&&(z=D,D=0),A.browserEvent&&A.browserEvent.altKey&&(z=z*this._options.fastScrollSensitivity,D=D*this._options.fastScrollSensitivity);const ie=this._scrollable.getFutureScrollPosition();let Q={};if(D){const me=r*D,ae=ie.scrollTop-(me<0?Math.floor(me):Math.ceil(me));this._verticalScrollbar.writeScrollPosition(Q,ae)}if(z){const me=r*z,ae=ie.scrollLeft-(me<0?Math.floor(me):Math.ceil(me));this._horizontalScrollbar.writeScrollPosition(Q,ae)}Q=this._scrollable.validateScrollPosition(Q),(ie.scrollLeft!==Q.scrollLeft||ie.scrollTop!==Q.scrollTop)&&(a&&this._options.mouseWheelSmoothScroll&&u.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(Q):this._scrollable.setScrollPositionNow(Q),E=!0)}let b=E;!b&&this._options.alwaysConsumeMouseWheel&&(b=!0),!b&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(b=!0),b&&(A.preventDefault(),A.stopPropagation())}_onDidScroll(A){this._shouldRender=this._horizontalScrollbar.onDidScroll(A)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(A)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const A=this._scrollable.getCurrentScrollPosition(),u=A.scrollTop>0,E=A.scrollLeft>0,b=E?" left":"",D=u?" top":"",z=E||u?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${b}`),this._topShadowDomNode.setClassName(`shadow${D}`),this._topLeftShadowDomNode.setClassName(`shadow${z}${D}${b}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(A){this._mouseIsOver=!1,this._hide()}_onMouseOver(A){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=s;class l extends s{constructor(A,u){u=u||{},u.mouseWheelSmoothScroll=!1;const E=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>i.scheduleAtNextAnimationFrame(b)});super(A,u,E),this._register(E)}setScrollPosition(A){this._scrollable.setScrollPositionNow(A)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=l;class p extends s{constructor(A,u,E){super(A,u,E)}setScrollPosition(A){A.reuseAnimation?this._scrollable.setScrollPositionSmooth(A,A.reuseAnimation):this._scrollable.setScrollPositionNow(A)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=p;class _ extends s{constructor(A,u){u=u||{},u.mouseWheelSmoothScroll=!1;const E=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>i.scheduleAtNextAnimationFrame(b)});super(A,u,E),this._register(E),this._element=A,this.onScroll(b=>{b.scrollTopChanged&&(this._element.scrollTop=b.scrollTop),b.scrollLeftChanged&&(this._element.scrollLeft=b.scrollLeft)}),this.scanDomNode()}setScrollPosition(A){this._scrollable.setScrollPositionNow(A)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=_;function L(S){const A={lazyRender:typeof S.lazyRender<"u"?S.lazyRender:!1,className:typeof S.className<"u"?S.className:"",useShadows:typeof S.useShadows<"u"?S.useShadows:!0,handleMouseWheel:typeof S.handleMouseWheel<"u"?S.handleMouseWheel:!0,flipAxes:typeof S.flipAxes<"u"?S.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof S.consumeMouseWheelIfScrollbarIsNeeded<"u"?S.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof S.alwaysConsumeMouseWheel<"u"?S.alwaysConsumeMouseWheel:!1,scrollYToX:typeof S.scrollYToX<"u"?S.scrollYToX:!1,mouseWheelScrollSensitivity:typeof S.mouseWheelScrollSensitivity<"u"?S.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof S.fastScrollSensitivity<"u"?S.fastScrollSensitivity:5,scrollPredominantAxis:typeof S.scrollPredominantAxis<"u"?S.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof S.mouseWheelSmoothScroll<"u"?S.mouseWheelSmoothScroll:!0,arrowSize:typeof S.arrowSize<"u"?S.arrowSize:11,listenOnDomNode:typeof S.listenOnDomNode<"u"?S.listenOnDomNode:null,horizontal:typeof S.horizontal<"u"?S.horizontal:1,horizontalScrollbarSize:typeof S.horizontalScrollbarSize<"u"?S.horizontalScrollbarSize:10,horizontalSliderSize:typeof S.horizontalSliderSize<"u"?S.horizontalSliderSize:0,horizontalHasArrows:typeof S.horizontalHasArrows<"u"?S.horizontalHasArrows:!1,vertical:typeof S.vertical<"u"?S.vertical:1,verticalScrollbarSize:typeof S.verticalScrollbarSize<"u"?S.verticalScrollbarSize:10,verticalHasArrows:typeof S.verticalHasArrows<"u"?S.verticalHasArrows:!1,verticalSliderSize:typeof S.verticalSliderSize<"u"?S.verticalSliderSize:0,scrollByPage:typeof S.scrollByPage<"u"?S.scrollByPage:!1};return A.horizontalSliderSize=typeof S.horizontalSliderSize<"u"?S.horizontalSliderSize:A.horizontalScrollbarSize,A.verticalSliderSize=typeof S.verticalSliderSize<"u"?S.verticalSliderSize:A.verticalScrollbarSize,o.isMacintosh&&(A.className+=" mac"),A}}),define(pe[58],be([1,0,51,4,18,22,57,14,8,25,3,2,47,49,78,115,9]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n,e,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const c={CurrentDragAndDropData:void 0},m={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(A){return[A]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class s{get context(){return this._context}set context(u){this._context=u}constructor(u){this.elements=u}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=s;class l{constructor(u){this.elements=u}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=l;class p{constructor(){this.types=[],this.files=[]}update(u){if(u.types&&this.types.splice(0,this.types.length,...u.types),u.files){this.files.splice(0,this.files.length);for(let E=0;E<u.files.length;E++){const b=u.files.item(E);b&&(b.size||b.type)&&this.files.push(b)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=p;function _(A,u){return Array.isArray(A)&&Array.isArray(u)?(0,v.equals)(A,u):A===u}class L{constructor(u){u?.getSetSize?this.getSetSize=u.getSetSize.bind(u):this.getSetSize=(E,b,D)=>D,u?.getPosInSet?this.getPosInSet=u.getPosInSet.bind(u):this.getPosInSet=(E,b)=>b+1,u?.getRole?this.getRole=u.getRole.bind(u):this.getRole=E=>"listitem",u?.isChecked?this.isChecked=u.isChecked.bind(u):this.isChecked=E=>{}}}class S{get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(u){if(u!==this._horizontalScrolling){if(u&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=u,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const E of this.items)this.measureItemWidth(E);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,i.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(u,E,b,D=m){if(this.virtualDelegate=E,this.domId=`list_id_${++S.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new h.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=I.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=I.Disposable.None,this.onDragLeaveTimeout=I.Disposable.None,this.disposables=new I.DisposableStore,this._onDidChangeContentHeight=new f.Emitter,this.onDidChangeContentHeight=f.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,D.horizontalScrolling&&D.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new e.RangeMap;for(const x of b)this.renderers.set(x.templateId,x);this.cache=this.disposables.add(new r.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof D.mouseSupport=="boolean"?D.mouseSupport:!0),this._horizontalScrolling=D.horizontalScrolling??m.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof D.additionalScrollHeight>"u"?0:D.additionalScrollHeight,this.accessibilityProvider=new L(D.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(D.transformOptimization??m.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(H.Gesture.addTarget(this.rowsContainer)),this.scrollable=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:D.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:x=>(0,i.scheduleAtNextAnimationFrame)(x)}),this.scrollableElement=this.disposables.add(new y.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:D.alwaysConsumeMouseWheel??m.alwaysConsumeMouseWheel,horizontal:1,vertical:D.verticalScrollMode??m.verticalScrollMode,useShadows:D.useShadows??m.useShadows,mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity,fastScrollSensitivity:D.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),u.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,i.addDisposableListener)(this.rowsContainer,H.EventType.Change,x=>this.onTouchChange(x))),this.disposables.add((0,i.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",x=>x.target.scrollTop=0)),this.disposables.add((0,i.addDisposableListener)(this.domNode,"dragover",x=>this.onDragOver(this.toDragEvent(x)))),this.disposables.add((0,i.addDisposableListener)(this.domNode,"drop",x=>this.onDrop(this.toDragEvent(x)))),this.disposables.add((0,i.addDisposableListener)(this.domNode,"dragleave",x=>this.onDragLeave(this.toDragEvent(x)))),this.disposables.add((0,i.addDisposableListener)(this.domNode,"dragend",x=>this.onDragEnd(x))),this.setRowLineHeight=D.setRowLineHeight??m.setRowLineHeight,this.setRowHeight=D.setRowHeight??m.setRowHeight,this.supportDynamicHeights=D.supportDynamicHeights??m.supportDynamicHeights,this.dnd=D.dnd??m.dnd,this.layout()}updateOptions(u){u.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=u.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),u.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(u.smoothScrolling?125:0),u.horizontalScrolling!==void 0&&(this.horizontalScrolling=u.horizontalScrolling),u.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:u.mouseWheelScrollSensitivity}),u.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:u.fastScrollSensitivity})}delegateScrollFromMouseWheelEvent(u){this.scrollableElement.delegateScrollFromMouseWheelEvent(u)}delegateVerticalScrollbarPointerDown(u){this.scrollableElement.delegateVerticalScrollbarPointerDown(u)}updateElementHeight(u,E,b){if(u<0||u>=this.items.length)return;const D=this.items[u].size;if(typeof E>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[u].lastDynamicHeightWidth=void 0,E=D+this.probeDynamicHeight(u)}if(D===E)return;const z=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let x=0;u<z.start||b!==null&&b>u&&b<=z.end?x=E-D:x=0,this.rangeMap.splice(u,1,[{size:E}]),this.items[u].size=E,this.render(z,Math.max(0,this.lastRenderTop+x),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(u,E,b=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(u,E,b)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(u,E,b=[]){const D=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),z={start:u,end:u+E},x=o.Range.intersect(D,z),ie=new Map;for(let V=x.end-1;V>=x.start;V--){const j=this.items[V];if(j.dragStartDisposable.dispose(),j.checkedDisposable.dispose(),j.row){let P=ie.get(j.templateId);P||(P=[],ie.set(j.templateId,P));const d=this.renderers.get(j.templateId);d&&d.disposeElement&&d.disposeElement(j.element,V,j.row.templateData,j.size),P.push(j.row)}j.row=null}const Q={start:u+E,end:this.items.length},me=o.Range.intersect(Q,D),ae=o.Range.relativeComplement(Q,D),fe=b.map(V=>({id:String(this.itemId++),element:V,templateId:this.virtualDelegate.getTemplateId(V),size:this.virtualDelegate.getHeight(V),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.Disposable.None,checkedDisposable:I.Disposable.None}));let le;u===0&&E>=this.items.length?(this.rangeMap=new e.RangeMap,this.rangeMap.splice(0,0,fe),le=this.items,this.items=fe):(this.rangeMap.splice(u,E,fe),le=this.items.splice(u,E,...fe));const de=b.length-E,Se=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ee=(0,e.shift)(me,de),ye=o.Range.intersect(Se,ee);for(let V=ye.start;V<ye.end;V++)this.updateItemInDOM(this.items[V],V);const se=o.Range.relativeComplement(ee,Se);for(const V of se)for(let j=V.start;j<V.end;j++)this.removeItemFromDOM(j);const te=ae.map(V=>(0,e.shift)(V,de)),ne=[{start:u,end:u+b.length},...te].map(V=>o.Range.intersect(Se,V)),T=this.getNextToLastElement(ne);for(const V of ne)for(let j=V.start;j<V.end;j++){const P=this.items[j],F=ie.get(P.templateId)?.pop();this.insertItemInDOM(j,T,F)}for(const V of ie.values())for(const j of V)this.cache.release(j);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),le.map(V=>V.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,i.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let u=0;for(const E of this.items)typeof E.width<"u"&&(u=Math.max(u,E.width));this.scrollWidth=u,this.scrollableElement.setScrollDimensions({scrollWidth:u===0?0:u+10})}updateWidth(u){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const E=this.items[u];this.measureItemWidth(E),typeof E.width<"u"&&E.width>this.scrollWidth&&(this.scrollWidth=E.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const u of this.items)u.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const u=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),E=this.rangeMap.positionAt(u.start),b=this.rangeMap.positionAt(u.start+1);return b!==-1&&(b-E)/2+E<this.scrollTop?u.start+1:u.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(u){return this.items[u].element}indexOf(u){return this.items.findIndex(E=>E.element===u)}domElement(u){const E=this.items[u].row;return E&&E.domNode}elementHeight(u){return this.items[u].size}elementTop(u){return this.rangeMap.positionAt(u)}indexAt(u){return this.rangeMap.indexAt(u)}indexAfter(u){return this.rangeMap.indexAfter(u)}layout(u,E){const b={height:typeof u=="number"?u:(0,i.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,b.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(b),typeof E<"u"&&(this.renderWidth=E,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof E=="number"?E:(0,i.getContentWidth)(this.domNode)})}render(u,E,b,D,z,x=!1){const ie=this.getRenderRange(E,b),Q=o.Range.relativeComplement(ie,u),me=o.Range.relativeComplement(u,ie),ae=this.getNextToLastElement(Q);if(x){const fe=o.Range.intersect(u,ie);for(let le=fe.start;le<fe.end;le++)this.updateItemInDOM(this.items[le],le)}for(const fe of Q)for(let le=fe.start;le<fe.end;le++)this.insertItemInDOM(le,ae);for(const fe of me)for(let le=fe.start;le<fe.end;le++)this.removeItemFromDOM(le);D!==void 0&&(this.rowsContainer.style.left=`-${D}px`),this.rowsContainer.style.top=`-${E}px`,this.horizontalScrolling&&z!==void 0&&(this.rowsContainer.style.width=`${Math.max(z,this.renderWidth)}px`),this.lastRenderTop=E,this.lastRenderHeight=b}insertItemInDOM(u,E,b){const D=this.items[u];D.row||(D.row=b??this.cache.alloc(D.templateId));const z=this.accessibilityProvider.getRole(D.element)||"listitem";D.row.domNode.setAttribute("role",z);const x=this.accessibilityProvider.isChecked(D.element);if(typeof x=="boolean")D.row.domNode.setAttribute("aria-checked",String(!!x));else if(x){const me=ae=>D.row.domNode.setAttribute("aria-checked",String(!!ae));me(x.value),D.checkedDisposable=x.onDidChange(me)}D.row.domNode.parentElement||(E?this.rowsContainer.insertBefore(D.row.domNode,E):this.rowsContainer.appendChild(D.row.domNode)),this.updateItemInDOM(D,u);const ie=this.renderers.get(D.templateId);if(!ie)throw new Error(`No renderer found for template id ${D.templateId}`);ie?.renderElement(D.element,u,D.row.templateData,D.size);const Q=this.dnd.getDragURI(D.element);D.dragStartDisposable.dispose(),D.row.domNode.draggable=!!Q,Q&&(D.dragStartDisposable=(0,i.addDisposableListener)(D.row.domNode,"dragstart",me=>this.onDragStart(D.element,Q,me))),this.horizontalScrolling&&(this.measureItemWidth(D),this.eventuallyUpdateScrollWidth())}measureItemWidth(u){if(!u.row||!u.row.domNode)return;u.row.domNode.style.width="fit-content",u.width=(0,i.getContentWidth)(u.row.domNode);const E=window.getComputedStyle(u.row.domNode);E.paddingLeft&&(u.width+=parseFloat(E.paddingLeft)),E.paddingRight&&(u.width+=parseFloat(E.paddingRight)),u.row.domNode.style.width=""}updateItemInDOM(u,E){u.row.domNode.style.top=`${this.elementTop(E)}px`,this.setRowHeight&&(u.row.domNode.style.height=`${u.size}px`),this.setRowLineHeight&&(u.row.domNode.style.lineHeight=`${u.size}px`),u.row.domNode.setAttribute("data-index",`${E}`),u.row.domNode.setAttribute("data-last-element",E===this.length-1?"true":"false"),u.row.domNode.setAttribute("data-parity",E%2===0?"even":"odd"),u.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(u.element,E,this.length))),u.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(u.element,E))),u.row.domNode.setAttribute("id",this.getElementDomId(E)),u.row.domNode.classList.toggle("drop-target",u.dropTarget)}removeItemFromDOM(u){const E=this.items[u];if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const b=this.renderers.get(E.templateId);b&&b.disposeElement&&b.disposeElement(E.element,u,E.row.templateData,E.size),this.cache.release(E.row),E.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(u,E){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:u,reuseAnimation:E})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(u){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:u})}get scrollTop(){return this.getScrollTop()}set scrollTop(u){this.setScrollTop(u)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"click")).event,u=>this.toMouseEvent(u),this.disposables)}get onMouseDblClick(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"dblclick")).event,u=>this.toMouseEvent(u),this.disposables)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"auxclick")).event,u=>this.toMouseEvent(u),this.disposables),u=>u.browserEvent.button===1,this.disposables)}get onMouseUp(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mouseup")).event,u=>this.toMouseEvent(u),this.disposables)}get onMouseDown(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mousedown")).event,u=>this.toMouseEvent(u),this.disposables)}get onMouseOver(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mouseover")).event,u=>this.toMouseEvent(u),this.disposables)}get onMouseMove(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mousemove")).event,u=>this.toMouseEvent(u),this.disposables)}get onMouseOut(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mouseout")).event,u=>this.toMouseEvent(u),this.disposables)}get onContextMenu(){return f.Event.any(f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"contextmenu")).event,u=>this.toMouseEvent(u),this.disposables),f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,H.EventType.Contextmenu)).event,u=>this.toGestureEvent(u),this.disposables))}get onTouchStart(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"touchstart")).event,u=>this.toTouchEvent(u),this.disposables)}get onTap(){return f.Event.map(this.disposables.add(new B.DomEmitter(this.rowsContainer,H.EventType.Tap)).event,u=>this.toGestureEvent(u),this.disposables)}toMouseEvent(u){const E=this.getItemIndexFromEventTarget(u.target||null),b=typeof E>"u"?void 0:this.items[E],D=b&&b.element;return{browserEvent:u,index:E,element:D}}toTouchEvent(u){const E=this.getItemIndexFromEventTarget(u.target||null),b=typeof E>"u"?void 0:this.items[E],D=b&&b.element;return{browserEvent:u,index:E,element:D}}toGestureEvent(u){const E=this.getItemIndexFromEventTarget(u.initialTarget||null),b=typeof E>"u"?void 0:this.items[E],D=b&&b.element;return{browserEvent:u,index:E,element:D}}toDragEvent(u){const E=this.getItemIndexFromEventTarget(u.target||null),b=typeof E>"u"?void 0:this.items[E],D=b&&b.element;return{browserEvent:u,index:E,element:D}}onScroll(u){try{const E=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(E,u.scrollTop,u.height,u.scrollLeft,u.scrollWidth),this.supportDynamicHeights&&this._rerender(u.scrollTop,u.height,u.inSmoothScrolling)}catch(E){throw console.error("Got bad scroll event:",u),E}}onTouchChange(u){u.preventDefault(),u.stopPropagation(),this.scrollTop-=u.translationY}onDragStart(u,E,b){if(!b.dataTransfer)return;const D=this.dnd.getDragElements(u);if(b.dataTransfer.effectAllowed="copyMove",b.dataTransfer.setData(w.DataTransfers.TEXT,E),b.dataTransfer.setDragImage){let z;this.dnd.getDragLabel&&(z=this.dnd.getDragLabel(D,b)),typeof z>"u"&&(z=String(D.length));const x=(0,i.$)(".monaco-drag-image");x.textContent=z,document.body.appendChild(x),b.dataTransfer.setDragImage(x,-10,-10),setTimeout(()=>document.body.removeChild(x),0)}this.domNode.classList.add("dragging"),this.currentDragData=new s(D),c.CurrentDragAndDropData=new l(D),this.dnd.onDragStart?.(this.currentDragData,b)}onDragOver(u){if(u.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),c.CurrentDragAndDropData&&c.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(u.browserEvent),!u.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(c.CurrentDragAndDropData)this.currentDragData=c.CurrentDragAndDropData;else{if(!u.browserEvent.dataTransfer.types)return!1;this.currentDragData=new p}const E=this.dnd.onDragOver(this.currentDragData,u.element,u.index,u.browserEvent);if(this.canDrop=typeof E=="boolean"?E:E.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;u.browserEvent.dataTransfer.dropEffect=typeof E!="boolean"&&E.effect===0?"copy":"move";let b;if(typeof E!="boolean"&&E.feedback?b=E.feedback:typeof u.index>"u"?b=[-1]:b=[u.index],b=(0,v.distinct)(b).filter(D=>D>=-1&&D<this.length).sort((D,z)=>D-z),b=b[0]===-1?[-1]:b,_(this.currentDragFeedback,b))return!0;if(this.currentDragFeedback=b,this.currentDragFeedbackDisposable.dispose(),b[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,I.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const D of b){const z=this.items[D];z.dropTarget=!0,z.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,I.toDisposable)(()=>{for(const D of b){const z=this.items[D];z.dropTarget=!1,z.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(u){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,h.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,u.element,u.index,u.browserEvent)}onDrop(u){if(!this.canDrop)return;const E=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,c.CurrentDragAndDropData=void 0,!(!E||!u.browserEvent.dataTransfer)&&(u.browserEvent.preventDefault(),E.update(u.browserEvent.dataTransfer),this.dnd.drop(E,u.element,u.index,u.browserEvent))}onDragEnd(u){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,c.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(u)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=I.Disposable.None}setupDragAndDropScrollTopAnimation(u){if(!this.dragOverAnimationDisposable){const E=(0,i.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,i.animate)(this.animateDragAndDropScrollTop.bind(this,E))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,h.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=u.pageY}animateDragAndDropScrollTop(u){if(this.dragOverMouseY===void 0)return;const E=this.dragOverMouseY-u,b=this.renderHeight-35;E<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(E-35))):E>b&&(this.scrollTop+=Math.min(14,Math.floor(.3*(E-b))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(u){const E=this.scrollableElement.getDomNode();let b=u;for(;b instanceof HTMLElement&&b!==this.rowsContainer&&E.contains(b);){const D=b.getAttribute("data-index");if(D){const z=Number(D);if(!isNaN(z))return z}b=b.parentElement}}getRenderRange(u,E){return{start:this.rangeMap.indexAt(u),end:this.rangeMap.indexAfter(u+E-1)}}_rerender(u,E,b){const D=this.getRenderRange(u,E);let z,x;u===this.elementTop(D.start)?(z=D.start,x=0):D.end-D.start>1&&(z=D.start+1,x=this.elementTop(z)-u);let ie=0;for(;;){const Q=this.getRenderRange(u,E);let me=!1;for(let ae=Q.start;ae<Q.end;ae++){const fe=this.probeDynamicHeight(ae);fe!==0&&this.rangeMap.splice(ae,1,[this.items[ae]]),ie+=fe,me=me||fe!==0}if(!me){ie!==0&&this.eventuallyUpdateScrollDimensions();const ae=o.Range.relativeComplement(D,Q);for(const le of ae)for(let de=le.start;de<le.end;de++)this.items[de].row&&this.removeItemFromDOM(de);const fe=o.Range.relativeComplement(Q,D);for(const le of fe)for(let de=le.start;de<le.end;de++){const Se=de+1,ee=Se<this.items.length?this.items[Se].row:null,ye=ee?ee.domNode:null;this.insertItemInDOM(de,ye)}for(let le=Q.start;le<Q.end;le++)this.items[le].row&&this.updateItemInDOM(this.items[le],le);if(typeof z=="number"){const le=this.scrollable.getFutureScrollPosition().scrollTop-u,de=this.elementTop(z)-x+le;this.setScrollTop(de,b)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(u){const E=this.items[u];if(this.virtualDelegate.getDynamicHeight){const x=this.virtualDelegate.getDynamicHeight(E.element);if(x!==null){const ie=E.size;return E.size=x,E.lastDynamicHeightWidth=this.renderWidth,x-ie}}if(!E.hasDynamicHeight||E.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(E.element))return 0;const b=E.size;if(E.row)return E.row.domNode.style.height="",E.size=E.row.domNode.offsetHeight,E.lastDynamicHeightWidth=this.renderWidth,E.size-b;const D=this.cache.alloc(E.templateId);D.domNode.style.height="",this.rowsContainer.appendChild(D.domNode);const z=this.renderers.get(E.templateId);if(!z)throw new a.BugIndicatingError("Missing renderer for templateId: "+E.templateId);return z.renderElement(E.element,u,D.templateData,void 0),E.size=D.domNode.offsetHeight,z.disposeElement?.(E.element,u,D.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(E.element,E.size),E.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(D.domNode),this.cache.release(D),E.size-b}getNextToLastElement(u){const E=u[u.length-1];if(!E)return null;const b=this.items[E.end];return!b||!b.row?null:b.row.domNode}getElementDomId(u){return`${this.domId}_${u}`}dispose(){if(this.items){for(const u of this.items)if(u.row){const E=this.renderers.get(u.row.templateId);E&&(E.disposeElement?.(u.element,-1,u.row.templateData,void 0),E.disposeTemplate(u.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,I.dispose)(this.disposables)}}S.InstanceCount=0,xe([g.memoize],S.prototype,"onMouseClick",null),xe([g.memoize],S.prototype,"onMouseDblClick",null),xe([g.memoize],S.prototype,"onMouseMiddleClick",null),xe([g.memoize],S.prototype,"onMouseUp",null),xe([g.memoize],S.prototype,"onMouseDown",null),xe([g.memoize],S.prototype,"onMouseOver",null),xe([g.memoize],S.prototype,"onMouseMove",null),xe([g.memoize],S.prototype,"onMouseOut",null),xe([g.memoize],S.prototype,"onContextMenu",null),xe([g.memoize],S.prototype,"onTouchStart",null),xe([g.memoize],S.prototype,"onTap",null),t.ListView=S}),define(pe[59],be([1,0,4,18,19,22,54,68,14,8,24,25,3,33,2,46,27,5,6,67,58,88]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n,e,r,a,c,m,s,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class p{constructor(d){this.trait=d,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(d){return d}renderElement(d,F,U){const $=this.renderedElements.findIndex(X=>X.templateData===U);if($>=0){const X=this.renderedElements[$];this.trait.unrender(U),X.index=F}else{const X={index:F,templateData:U};this.renderedElements.push(X)}this.trait.renderIndex(F,U)}splice(d,F,U){const $=[];for(const X of this.renderedElements)X.index<d?$.push(X):X.index>=d+F&&$.push({index:X.index+U-F,templateData:X.templateData});this.renderedElements=$}renderIndexes(d){for(const{index:F,templateData:U}of this.renderedElements)d.indexOf(F)>-1&&this.trait.renderIndex(F,U)}disposeTemplate(d){const F=this.renderedElements.findIndex(U=>U.templateData===d);F<0||this.renderedElements.splice(F,1)}}class _{get name(){return this._trait}get renderer(){return new p(this)}constructor(d){this._trait=d,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new o.Emitter,this.onChange=this._onChange.event}splice(d,F,U){F=Math.max(0,Math.min(F,this.length-d));const $=U.length-F,X=d+F,N=[...this.sortedIndexes.filter(W=>W<d),...U.map((W,C)=>W?C+d:-1).filter(W=>W!==-1),...this.sortedIndexes.filter(W=>W>=X).map(W=>W+$)],R=this.length+$;if(this.sortedIndexes.length>0&&N.length===0&&R>0){const W=this.sortedIndexes.find(C=>C>=d)??R-1;N.push(Math.min(W,R-1))}this.renderer.splice(d,F,U.length),this._set(N,N),this.length=R}renderIndex(d,F){F.classList.toggle(this._trait,this.contains(d))}unrender(d){d.classList.remove(this._trait)}set(d,F){return this._set(d,[...d].sort(ce),F)}_set(d,F,U){const $=this.indexes,X=this.sortedIndexes;this.indexes=d,this.sortedIndexes=F;const N=se(X,d);return this.renderer.renderIndexes(N),this._onChange.fire({indexes:d,browserEvent:U}),$}get(){return this.indexes}contains(d){return(0,h.binarySearch)(this.sortedIndexes,d,ce)>=0}dispose(){(0,e.dispose)(this._onChange)}}xe([I.memoize],_.prototype,"renderer",null);class L extends _{constructor(d){super("selected"),this.setAriaSelected=d}renderIndex(d,F){super.renderIndex(d,F),this.setAriaSelected&&(this.contains(d)?F.setAttribute("aria-selected","true"):F.setAttribute("aria-selected","false"))}}class S{constructor(d,F,U){this.trait=d,this.view=F,this.identityProvider=U}splice(d,F,U){if(!this.identityProvider)return this.trait.splice(d,F,U.map(()=>!1));const $=this.trait.get().map(N=>this.identityProvider.getId(this.view.element(N)).toString()),X=U.map(N=>$.indexOf(this.identityProvider.getId(N).toString())>-1);this.trait.splice(d,F,X)}}function A(P){return P.tagName==="INPUT"||P.tagName==="TEXTAREA"}t.isInputElement=A;function u(P){return P.classList.contains("monaco-editor")?!0:P.classList.contains("monaco-list")||!P.parentElement?!1:u(P.parentElement)}t.isMonacoEditor=u;function E(P){return P.tagName==="A"&&P.classList.contains("monaco-button")||P.tagName==="DIV"&&P.classList.contains("monaco-button-dropdown")?!0:P.classList.contains("monaco-list")||!P.parentElement?!1:E(P.parentElement)}t.isButton=E;class b{get onKeyDown(){return this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(d=>!A(d.target)).map(d=>new B.StandardKeyboardEvent(d)))}constructor(d,F,U){this.list=d,this.view=F,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter($=>$.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter($=>$.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter($=>$.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter($=>$.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter($=>$.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter($=>$.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter($=>(c.isMacintosh?$.metaKey:$.ctrlKey)&&$.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),d.multipleSelectionSupport&&this.onKeyDown.filter(F=>(c.isMacintosh?F.metaKey:F.ctrlKey)&&F.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(d){d.preventDefault(),d.stopPropagation(),this.list.setSelection(this.list.getFocus(),d.browserEvent)}onUpArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusPrevious(1,!1,d.browserEvent);const F=this.list.getFocus()[0];this.list.setAnchor(F),this.list.reveal(F),this.view.domNode.focus()}onDownArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusNext(1,!1,d.browserEvent);const F=this.list.getFocus()[0];this.list.setAnchor(F),this.list.reveal(F),this.view.domNode.focus()}onPageUpArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusPreviousPage(d.browserEvent);const F=this.list.getFocus()[0];this.list.setAnchor(F),this.list.reveal(F),this.view.domNode.focus()}onPageDownArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusNextPage(d.browserEvent);const F=this.list.getFocus()[0];this.list.setAnchor(F),this.list.reveal(F),this.view.domNode.focus()}onCtrlA(d){d.preventDefault(),d.stopPropagation(),this.list.setSelection((0,h.range)(this.list.length),d.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(d){this.list.getSelection().length&&(d.preventDefault(),d.stopPropagation(),this.list.setSelection([],d.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}xe([I.memoize],b.prototype,"onKeyDown",null);var D;(function(P){P[P.Automatic=0]="Automatic",P[P.Trigger=1]="Trigger"})(D=t.TypeNavigationMode||(t.TypeNavigationMode={}));var z;(function(P){P[P.Idle=0]="Idle",P[P.Typing=1]="Typing"})(z||(z={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(P){return P.ctrlKey||P.metaKey||P.altKey?!1:P.keyCode>=31&&P.keyCode<=56||P.keyCode>=21&&P.keyCode<=30||P.keyCode>=93&&P.keyCode<=102||P.keyCode>=80&&P.keyCode<=90}};class x{constructor(d,F,U,$,X){this.list=d,this.view=F,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=$,this.delegate=X,this.enabled=!1,this.state=z.Idle,this.mode=D.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(d.options)}updateOptions(d){d.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=d.typeNavigationMode??D.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let d=!1;const F=this.enabledDisposables.add(o.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(X=>!A(X.target)).filter(()=>this.mode===D.Automatic||this.triggered).map(X=>new B.StandardKeyboardEvent(X)).filter(X=>d||this.keyboardNavigationEventFilter(X)).filter(X=>this.delegate.mightProducePrintableCharacter(X)).forEach(X=>w.EventHelper.stop(X,!0)).map(X=>X.browserEvent.key).event,U=o.Event.debounce(F,()=>null,800,void 0,void 0,this.enabledDisposables);o.Event.reduce(o.Event.any(F,U),(X,N)=>N===null?null:(X||"")+N,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),F(()=>d=!0,void 0,this.enabledDisposables),U(()=>d=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const d=this.list.getFocus();if(d.length>0&&d[0]===this.previouslyFocused){const F=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(d[0]));F&&(0,y.alert)(F)}this.previouslyFocused=-1}onInput(d){if(!d){this.state=z.Idle,this.triggered=!1;return}const F=this.list.getFocus(),U=F.length>0?F[0]:0,$=this.state===z.Idle?1:0;this.state=z.Typing;for(let X=0;X<this.list.length;X++){const N=(U+X+$)%this.list.length,R=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(N)),W=R&&R.toString();if(typeof W>"u"||(0,n.matchesPrefix)(d,W)){this.previouslyFocused=U,this.list.setFocus([N]),this.list.reveal(N);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class ie{constructor(d,F){this.list=d,this.view=F,this.disposables=new e.DisposableStore,this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(F.domNode,"keydown")).event)).filter($=>!A($.target)).map($=>new B.StandardKeyboardEvent($)).filter($=>$.keyCode===2&&!$.ctrlKey&&!$.metaKey&&!$.shiftKey&&!$.altKey).on(this.onTab,this,this.disposables)}onTab(d){if(d.target!==this.view.domNode)return;const F=this.list.getFocus();if(F.length===0)return;const U=this.view.domElement(F[0]);if(!U)return;const $=U.querySelector("[tabIndex]");if(!$||!($ instanceof HTMLElement)||$.tabIndex===-1)return;const X=window.getComputedStyle($);X.visibility==="hidden"||X.display==="none"||(d.preventDefault(),d.stopPropagation(),$.focus())}dispose(){this.disposables.dispose()}}function Q(P){return c.isMacintosh?P.browserEvent.metaKey:P.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Q;function me(P){return P.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=me;function ae(P){return P instanceof MouseEvent&&P.button===2}const fe={isSelectionSingleChangeEvent:Q,isSelectionRangeChangeEvent:me};class le{constructor(d){this.list=d,this.disposables=new e.DisposableStore,this._onPointer=new o.Emitter,this.onPointer=this._onPointer.event,d.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||fe),this.mouseSupport=typeof d.options.mouseSupport>"u"||!!d.options.mouseSupport,this.mouseSupport&&(d.onMouseDown(this.onMouseDown,this,this.disposables),d.onContextMenu(this.onContextMenu,this,this.disposables),d.onMouseDblClick(this.onDoubleClick,this,this.disposables),d.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(H.Gesture.addTarget(d.getHTMLElement()))),o.Event.any(d.onMouseClick,d.onMouseMiddleClick,d.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,d.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||fe))}isSelectionSingleChangeEvent(d){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(d):!1}isSelectionRangeChangeEvent(d){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(d):!1}isSelectionChangeEvent(d){return this.isSelectionSingleChangeEvent(d)||this.isSelectionRangeChangeEvent(d)}onMouseDown(d){u(d.browserEvent.target)||document.activeElement!==d.browserEvent.target&&this.list.domFocus()}onContextMenu(d){if(u(d.browserEvent.target))return;const F=typeof d.index>"u"?[]:[d.index];this.list.setFocus(F,d.browserEvent)}onViewPointer(d){if(!this.mouseSupport||A(d.browserEvent.target)||u(d.browserEvent.target))return;const F=d.index;if(typeof F>"u"){this.list.setFocus([],d.browserEvent),this.list.setSelection([],d.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(d))return this.changeSelection(d);if(this.isSelectionChangeEvent(d))return this.changeSelection(d);this.list.setFocus([F],d.browserEvent),this.list.setAnchor(F),ae(d.browserEvent)||this.list.setSelection([F],d.browserEvent),this._onPointer.fire(d)}onDoubleClick(d){if(A(d.browserEvent.target)||u(d.browserEvent.target)||this.isSelectionChangeEvent(d))return;const F=this.list.getFocus();this.list.setSelection(F,d.browserEvent)}changeSelection(d){const F=d.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(d)){typeof U>"u"&&(U=this.list.getFocus()[0]??F,this.list.setAnchor(U));const $=Math.min(U,F),X=Math.max(U,F),N=(0,h.range)($,X+1),R=this.list.getSelection(),W=ye(se(R,[U]),U);if(W.length===0)return;const C=se(N,te(R,W));this.list.setSelection(C,d.browserEvent),this.list.setFocus([F],d.browserEvent)}else if(this.isSelectionSingleChangeEvent(d)){const $=this.list.getSelection(),X=$.filter(N=>N!==F);this.list.setFocus([F]),this.list.setAnchor(F),$.length===X.length?this.list.setSelection([...X,F],d.browserEvent):this.list.setSelection(X,d.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=le;class de{constructor(d,F){this.styleElement=d,this.selectorSuffix=F}style(d){const F=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];d.listBackground&&(d.listBackground.isOpaque()?U.push(`.monaco-list${F} .monaco-list-rows { background: ${d.listBackground}; }`):c.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),d.listFocusBackground&&(U.push(`.monaco-list${F}:focus .monaco-list-row.focused { background-color: ${d.listFocusBackground}; }`),U.push(`.monaco-list${F}:focus .monaco-list-row.focused:hover { background-color: ${d.listFocusBackground}; }`)),d.listFocusForeground&&U.push(`.monaco-list${F}:focus .monaco-list-row.focused { color: ${d.listFocusForeground}; }`),d.listActiveSelectionBackground&&(U.push(`.monaco-list${F}:focus .monaco-list-row.selected { background-color: ${d.listActiveSelectionBackground}; }`),U.push(`.monaco-list${F}:focus .monaco-list-row.selected:hover { background-color: ${d.listActiveSelectionBackground}; }`)),d.listActiveSelectionForeground&&U.push(`.monaco-list${F}:focus .monaco-list-row.selected { color: ${d.listActiveSelectionForeground}; }`),d.listActiveSelectionIconForeground&&U.push(`.monaco-list${F}:focus .monaco-list-row.selected .codicon { color: ${d.listActiveSelectionIconForeground}; }`),d.listFocusAndSelectionOutline&&U.push(`.monaco-list${F}:focus .monaco-list-row.selected { outline-color: ${d.listFocusAndSelectionOutline} !important; }`),d.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${F}:focus .monaco-list-row.selected.focused { background-color: ${d.listFocusAndSelectionBackground}; }
			`),d.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${F}:focus .monaco-list-row.selected.focused { color: ${d.listFocusAndSelectionForeground}; }
			`),d.listInactiveFocusForeground&&(U.push(`.monaco-list${F} .monaco-list-row.focused { color:  ${d.listInactiveFocusForeground}; }`),U.push(`.monaco-list${F} .monaco-list-row.focused:hover { color:  ${d.listInactiveFocusForeground}; }`)),d.listInactiveSelectionIconForeground&&U.push(`.monaco-list${F} .monaco-list-row.focused .codicon { color:  ${d.listInactiveSelectionIconForeground}; }`),d.listInactiveFocusBackground&&(U.push(`.monaco-list${F} .monaco-list-row.focused { background-color:  ${d.listInactiveFocusBackground}; }`),U.push(`.monaco-list${F} .monaco-list-row.focused:hover { background-color:  ${d.listInactiveFocusBackground}; }`)),d.listInactiveSelectionBackground&&(U.push(`.monaco-list${F} .monaco-list-row.selected { background-color:  ${d.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${F} .monaco-list-row.selected:hover { background-color:  ${d.listInactiveSelectionBackground}; }`)),d.listInactiveSelectionForeground&&U.push(`.monaco-list${F} .monaco-list-row.selected { color: ${d.listInactiveSelectionForeground}; }`),d.listHoverBackground&&U.push(`.monaco-list${F}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${d.listHoverBackground}; }`),d.listHoverForeground&&U.push(`.monaco-list${F}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${d.listHoverForeground}; }`),d.listSelectionOutline&&U.push(`.monaco-list${F} .monaco-list-row.selected { outline: 1px dotted ${d.listSelectionOutline}; outline-offset: -1px; }`),d.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${F}:focus .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${F}.last-focused .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
			`),d.listInactiveFocusOutline&&U.push(`.monaco-list${F} .monaco-list-row.focused { outline: 1px dotted ${d.listInactiveFocusOutline}; outline-offset: -1px; }`),d.listHoverOutline&&U.push(`.monaco-list${F} .monaco-list-row:hover { outline: 1px dashed ${d.listHoverOutline}; outline-offset: -1px; }`),d.listDropBackground&&U.push(`
				.monaco-list${F}.drop-target,
				.monaco-list${F} .monaco-list-rows.drop-target,
				.monaco-list${F} .monaco-list-row.drop-target { background-color: ${d.listDropBackground} !important; color: inherit !important; }
			`),d.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${d.tableColumnsBorder};
			}`),d.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${d.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=de;const Se={listFocusBackground:f.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:f.Color.fromHex("#0E639C"),listActiveSelectionForeground:f.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:f.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:f.Color.fromHex("#094771"),listFocusAndSelectionForeground:f.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:f.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listHoverBackground:f.Color.fromHex("#2A2D2E"),listDropBackground:f.Color.fromHex("#383B3D"),treeIndentGuidesStroke:f.Color.fromHex("#a9a9a9"),tableColumnsBorder:f.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:f.Color.fromHex("#cccccc").transparent(.04)},ee={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ye(P,d){const F=P.indexOf(d);if(F===-1)return[];const U=[];let $=F-1;for(;$>=0&&P[$]===d-(F-$);)U.push(P[$--]);for(U.reverse(),$=F;$<P.length&&P[$]===d+($-F);)U.push(P[$++]);return U}function se(P,d){const F=[];let U=0,$=0;for(;U<P.length||$<d.length;)if(U>=P.length)F.push(d[$++]);else if($>=d.length)F.push(P[U++]);else if(P[U]===d[$]){F.push(P[U]),U++,$++;continue}else P[U]<d[$]?F.push(P[U++]):F.push(d[$++]);return F}function te(P,d){const F=[];let U=0,$=0;for(;U<P.length||$<d.length;)if(U>=P.length)F.push(d[$++]);else if($>=d.length)F.push(P[U++]);else if(P[U]===d[$]){U++,$++;continue}else P[U]<d[$]?F.push(P[U++]):$++;return F}const ce=(P,d)=>P-d;class ne{constructor(d,F){this._templateId=d,this.renderers=F}get templateId(){return this._templateId}renderTemplate(d){return this.renderers.map(F=>F.renderTemplate(d))}renderElement(d,F,U,$){let X=0;for(const N of this.renderers)N.renderElement(d,F,U[X++],$)}disposeElement(d,F,U,$){let X=0;for(const N of this.renderers)N.disposeElement?.(d,F,U[X],$),X+=1}disposeTemplate(d){let F=0;for(const U of this.renderers)U.disposeTemplate(d[F++])}}class T{constructor(d){this.accessibilityProvider=d,this.templateId="a18n"}renderTemplate(d){return d}renderElement(d,F,U){const $=this.accessibilityProvider.getAriaLabel(d);$?U.setAttribute("aria-label",$):U.removeAttribute("aria-label");const X=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(d);typeof X=="number"?U.setAttribute("aria-level",`${X}`):U.removeAttribute("aria-level")}disposeTemplate(d){}}class V{constructor(d,F){this.list=d,this.dnd=F}getDragElements(d){const F=this.list.getSelectedElements();return F.indexOf(d)>-1?F:[d]}getDragURI(d){return this.dnd.getDragURI(d)}getDragLabel(d,F){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(d,F)}onDragStart(d,F){this.dnd.onDragStart?.(d,F)}onDragOver(d,F,U,$){return this.dnd.onDragOver(d,F,U,$)}onDragLeave(d,F,U,$){this.dnd.onDragLeave?.(d,F,U,$)}onDragEnd(d){this.dnd.onDragEnd?.(d)}drop(d,F,U,$){this.dnd.drop(d,F,U,$)}}class j{get onDidChangeFocus(){return o.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),d=>this.toListEvent(d),this.disposables)}get onDidChangeSelection(){return o.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),d=>this.toListEvent(d),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let d=!1;const F=this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(X=>new B.StandardKeyboardEvent(X)).filter(X=>d=X.keyCode===58||X.shiftKey&&X.keyCode===68).map(X=>w.EventHelper.stop(X,!0)).filter(()=>!1).event,U=this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>d=!1).map(X=>new B.StandardKeyboardEvent(X)).filter(X=>X.keyCode===58||X.shiftKey&&X.keyCode===68).map(X=>w.EventHelper.stop(X,!0)).map(({browserEvent:X})=>{const N=this.getFocus(),R=N.length?N[0]:void 0,W=typeof R<"u"?this.view.element(R):void 0,C=typeof R<"u"?this.view.domElement(R):this.view.domNode;return{index:R,element:W,anchor:C,browserEvent:X}}).event,$=this.disposables.add(o.Event.chain(this.view.onContextMenu)).filter(X=>!d).map(({element:X,index:N,browserEvent:R})=>({element:X,index:N,anchor:{x:R.pageX+1,y:R.pageY},browserEvent:R})).event;return o.Event.any(F,U,$)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(d,F,U,$,X=ee){this.user=d,this._options=X,this.focus=new _("focused"),this.anchor=new _("anchor"),this.eventBufferer=new o.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new o.Emitter,this.onDidDispose=this._onDidDispose.event;const N=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new L(N!=="listbox"),(0,a.mixin)(X,Se,!1);const R=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=X.accessibilityProvider,this.accessibilityProvider&&(R.push(new T(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),$=$.map(C=>new ne(C.templateId,[...R,C]));const W={...X,dnd:X.dnd&&new V(this,X.dnd)};if(this.view=new l.ListView(F,U,$,W),this.view.domNode.setAttribute("role",N),X.styleController)this.styleController=X.styleController(this.view.domId);else{const C=(0,w.createStyleSheet)(this.view.domNode);this.styleController=new de(C,this.view.domId)}if(this.spliceable=new v.CombinedSpliceable([new S(this.focus,this.view,X.identityProvider),new S(this.selection,this.view,X.identityProvider),new S(this.anchor,this.view,X.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new ie(this,this.view)),(typeof X.keyboardSupport!="boolean"||X.keyboardSupport)&&(this.keyboardController=new b(this,this.view,X),this.disposables.add(this.keyboardController)),X.keyboardNavigationLabelProvider){const C=X.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new x(this,this.view,X.keyboardNavigationLabelProvider,X.keyboardNavigationEventFilter??(()=>!0),C),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(X),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createMouseController(d){return new le(this)}updateOptions(d={}){this._options={...this._options,...d},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(d),this.keyboardController?.updateOptions(d),this.view.updateOptions(d)}get options(){return this._options}splice(d,F,U=[]){if(d<0||d>this.view.length)throw new s.ListError(this.user,`Invalid start index: ${d}`);if(F<0)throw new s.ListError(this.user,`Invalid delete count: ${F}`);F===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(d,F,U))}updateWidth(d){this.view.updateWidth(d)}updateElementHeight(d,F){this.view.updateElementHeight(d,F,null)}rerender(){this.view.rerender()}element(d){return this.view.element(d)}indexOf(d){return this.view.indexOf(d)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(d){this.view.setScrollTop(d)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(d){this.view.setScrollLeft(d)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(d){this._ariaLabel=d,this.view.domNode.setAttribute("aria-label",d)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(d,F){this.view.layout(d,F)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(d,F){for(const U of d)if(U<0||U>=this.length)throw new s.ListError(this.user,`Invalid index ${U}`);this.selection.set(d,F)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(d=>this.view.element(d))}setAnchor(d){if(typeof d>"u"){this.anchor.set([]);return}if(d<0||d>=this.length)throw new s.ListError(this.user,`Invalid index ${d}`);this.anchor.set([d])}getAnchor(){return(0,h.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const d=this.getAnchor();return typeof d>"u"?void 0:this.element(d)}setFocus(d,F){for(const U of d)if(U<0||U>=this.length)throw new s.ListError(this.user,`Invalid index ${U}`);this.focus.set(d,F)}focusNext(d=1,F=!1,U,$){if(this.length===0)return;const X=this.focus.get(),N=this.findNextIndex(X.length>0?X[0]+d:0,F,$);N>-1&&this.setFocus([N],U)}focusPrevious(d=1,F=!1,U,$){if(this.length===0)return;const X=this.focus.get(),N=this.findPreviousIndex(X.length>0?X[0]-d:0,F,$);N>-1&&this.setFocus([N],U)}async focusNextPage(d,F){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const $=this.getFocus()[0];if($!==U&&($===void 0||U>$)){const X=this.findPreviousIndex(U,!1,F);X>-1&&$!==X?this.setFocus([X],d):this.setFocus([U],d)}else{const X=this.view.getScrollTop();let N=X+this.view.renderHeight;U>$&&(N-=this.view.elementHeight(U)),this.view.setScrollTop(N),this.view.getScrollTop()!==X&&(this.setFocus([]),await(0,g.timeout)(0),await this.focusNextPage(d,F))}}async focusPreviousPage(d,F){let U;const $=this.view.getScrollTop();$===0?U=this.view.indexAt($):U=this.view.indexAfter($-1);const X=this.getFocus()[0];if(X!==U&&(X===void 0||X>=U)){const N=this.findNextIndex(U,!1,F);N>-1&&X!==N?this.setFocus([N],d):this.setFocus([U],d)}else{const N=$;this.view.setScrollTop($-this.view.renderHeight),this.view.getScrollTop()!==N&&(this.setFocus([]),await(0,g.timeout)(0),await this.focusPreviousPage(d,F))}}focusLast(d,F){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,F);U>-1&&this.setFocus([U],d)}focusFirst(d,F){this.focusNth(0,d,F)}focusNth(d,F,U){if(this.length===0)return;const $=this.findNextIndex(d,!1,U);$>-1&&this.setFocus([$],F)}findNextIndex(d,F=!1,U){for(let $=0;$<this.length;$++){if(d>=this.length&&!F)return-1;if(d=d%this.length,!U||U(this.element(d)))return d;d++}return-1}findPreviousIndex(d,F=!1,U){for(let $=0;$<this.length;$++){if(d<0&&!F)return-1;if(d=(this.length+d%this.length)%this.length,!U||U(this.element(d)))return d;d--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(d=>this.view.element(d))}reveal(d,F){if(d<0||d>=this.length)throw new s.ListError(this.user,`Invalid index ${d}`);const U=this.view.getScrollTop(),$=this.view.elementTop(d),X=this.view.elementHeight(d);if((0,m.isNumber)(F)){const N=X-this.view.renderHeight;this.view.setScrollTop(N*(0,r.clamp)(F,0,1)+$)}else{const N=$+X,R=U+this.view.renderHeight;$<U&&N>=R||($<U||N>=R&&X>=this.view.renderHeight?this.view.setScrollTop($):N>=R&&this.view.setScrollTop(N-this.view.renderHeight))}}getRelativeTop(d){if(d<0||d>=this.length)throw new s.ListError(this.user,`Invalid index ${d}`);const F=this.view.getScrollTop(),U=this.view.elementTop(d),$=this.view.elementHeight(d);if(U<F||U+$>F+this.view.renderHeight)return null;const X=$-this.view.renderHeight;return Math.abs((F-U)/X)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(d){return this.view.getElementDomId(d)}style(d){this.styleController.style(d)}toListEvent({indexes:d,browserEvent:F}){return{indexes:d,elements:d.map(U=>this.view.element(U)),browserEvent:F}}_onFocusChange(){const d=this.focus.get();this.view.domNode.classList.toggle("element-focused",d.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const d=this.focus.get();if(d.length>0){let F;this.accessibilityProvider?.getActiveDescendantId&&(F=this.accessibilityProvider.getActiveDescendantId(this.view.element(d[0]))),this.view.domNode.setAttribute("aria-activedescendant",F||this.view.getElementDomId(d[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const d=this.selection.get();this.view.domNode.classList.toggle("selection-none",d.length===0),this.view.domNode.classList.toggle("selection-single",d.length===1),this.view.domNode.classList.toggle("selection-multiple",d.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}xe([I.memoize],j.prototype,"onDidChangeFocus",null),xe([I.memoize],j.prototype,"onDidChangeSelection",null),xe([I.memoize],j.prototype,"onContextMenu",null),xe([I.memoize],j.prototype,"onKeyDown",null),xe([I.memoize],j.prototype,"onKeyUp",null),xe([I.memoize],j.prototype,"onKeyPress",null),xe([I.memoize],j.prototype,"onDidFocus",null),xe([I.memoize],j.prototype,"onDidBlur",null),t.List=j}),define(pe[60],be([1,0,9,34,36,11,15]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var v;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(v=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class h{constructor(c="",m=!1){if(this.value=c,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(c,m=0){return this.value+=o(this.supportThemeIcons?(0,i.escapeIcons)(c):c).replace(/([ \t]+)/g,(s,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,m){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(c,m,s){return this.value+="[",this.value+=this._escape(m,"]"),this.value+="](",this.value+=this._escape(String(c),")"),s&&(this.value+=` "${this._escape(this._escape(s,'"'),")")}"`),this.value+=")",this}_escape(c,m){const s=new RegExp((0,H.escapeRegExpCharacters)(m),"g");return c.replace(s,(l,p)=>c.charAt(p-1)!=="\\"?`\\${l}`:l)}}t.MarkdownString=h;function g(a){return f(a)?!a.value:Array.isArray(a)?a.every(g):!0}t.isEmptyMarkdownString=g;function f(a){return a instanceof h?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}t.isMarkdownString=f;function I(a,c){return a===c?!0:!a||!c?!1:a.value===c.value&&a.isTrusted===c.isTrusted&&a.supportThemeIcons===c.supportThemeIcons&&a.supportHtml===c.supportHtml&&(a.baseUri===c.baseUri||!!a.baseUri&&!!c.baseUri&&(0,B.isEqual)(y.URI.from(a.baseUri),y.URI.from(c.baseUri)))}t.markdownStringEqual=I;function o(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function n(a){return a.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function r(a){const c=[],m=a.split("|").map(l=>l.trim());a=m[0];const s=m[1];if(s){const l=/height=(\d+)/.exec(s),p=/width=(\d+)/.exec(s),_=l?l[1]:"",L=p?p[1]:"",S=isFinite(parseInt(L)),A=isFinite(parseInt(_));S&&c.push(`width="${L}"`),A&&c.push(`height="${_}"`)}return{href:a,dimensions:c}}t.parseHrefAndDimensions=r}),define(pe[121],be([1,0,4,113,18,52,20,114,9,3,60,34,72,44,2,75,50,35,27,36,11,15]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n,e,r,a,c,m,s,l,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const _=Object.freeze({image:(ie,Q,me)=>{let ae=[],fe=[];return ie&&({href:ie,dimensions:ae}=(0,f.parseHrefAndDimensions)(ie),fe.push(`src="${(0,f.escapeDoubleQuotes)(ie)}"`)),me&&fe.push(`alt="${(0,f.escapeDoubleQuotes)(me)}"`),Q&&fe.push(`title="${(0,f.escapeDoubleQuotes)(Q)}"`),ae.length&&(fe=fe.concat(ae)),"<img "+fe.join(" ")+">"},paragraph:ie=>`<p>${ie}</p>`,link:(ie,Q,me)=>typeof ie!="string"?"":(ie===me&&(me=(0,f.removeMarkdownEscapes)(me)),Q=typeof Q=="string"?(0,f.escapeDoubleQuotes)((0,f.removeMarkdownEscapes)(Q)):"",ie=(0,f.removeMarkdownEscapes)(ie),ie=ie.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${ie}" title="${Q||ie}">${me}</a>`)});function L(ie,Q={},me={}){const ae=new e.DisposableStore;let fe=!1;const le=(0,H.createElement)(Q),de=function(T){let V;try{V=(0,a.parse)(decodeURIComponent(T))}catch{}return V?(V=(0,m.cloneAndChange)(V,j=>{if(ie.uris&&ie.uris[j])return p.URI.revive(ie.uris[j])}),encodeURIComponent(JSON.stringify(V))):T},Se=function(T,V){const j=ie.uris&&ie.uris[T];let P=p.URI.revive(j);return V?T.startsWith(c.Schemas.data+":")?T:(P||(P=p.URI.parse(T)),c.FileAccess.asBrowserUri(P).toString(!0)):!P||p.URI.parse(T).toString()===P.toString()?T:(P.query&&(P=P.with({query:de(P.query)})),P.toString())},ee=new r.marked.Renderer;ee.image=_.image,ee.link=_.link,ee.paragraph=_.paragraph;const ye=[];if(Q.codeBlockRenderer&&(ee.code=(T,V)=>{const j=o.defaultGenerator.nextId(),P=Q.codeBlockRenderer(S(V),T);return ye.push(P.then(d=>[j,d])),`<div class="code" data-code="${j}">${(0,l.escape)(T)}</div>`}),Q.actionHandler){const T=Q.actionHandler.disposables.add(new B.DomEmitter(le,"click")),V=Q.actionHandler.disposables.add(new B.DomEmitter(le,"auxclick"));Q.actionHandler.disposables.add(g.Event.any(T.event,V.event)(j=>{const P=new y.StandardMouseEvent(j);if(!P.leftButton&&!P.middleButton)return;let d=P.target;if(!(d.tagName!=="A"&&(d=d.parentElement,!d||d.tagName!=="A")))try{let F=d.dataset.href;F&&(ie.baseUri&&(F=A(p.URI.from(ie.baseUri),F)),Q.actionHandler.callback(F,P))}catch(F){(0,h.onUnexpectedError)(F)}finally{P.preventDefault()}}))}ie.supportHtml||(me.sanitizer=T=>(ie.isTrusted?T.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?T:"",me.sanitize=!0,me.silent=!0),me.renderer=ee;let se=ie.value??"";se.length>1e5&&(se=`${se.substr(0,1e5)}\u2026`),ie.supportThemeIcons&&(se=(0,I.markdownEscapeEscapedIcons)(se));let te=r.marked.parse(se,me);ie.supportThemeIcons&&(te=(0,v.renderLabelWithIcons)(te).map(V=>typeof V=="string"?V:V.outerHTML).join(""));const ne=new DOMParser().parseFromString(u(ie,te),"text/html");if(ne.body.querySelectorAll("img").forEach(T=>{const V=T.getAttribute("src");if(V){let j=V;try{ie.baseUri&&(j=A(p.URI.from(ie.baseUri),j))}catch{}T.src=Se(j,!0)}}),ne.body.querySelectorAll("a").forEach(T=>{const V=T.getAttribute("href");if(T.setAttribute("href",""),!V||/^data:|javascript:/i.test(V)||/^command:/i.test(V)&&!ie.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(V))T.replaceWith(...T.childNodes);else{let j=Se(V,!1);ie.baseUri&&(j=A(p.URI.from(ie.baseUri),V)),T.dataset.href=j}}),le.innerHTML=u(ie,ne.body.innerHTML),ye.length>0&&Promise.all(ye).then(T=>{if(fe)return;const V=new Map(T),j=le.querySelectorAll("div[data-code]");for(const P of j){const d=V.get(P.dataset.code??"");d&&w.reset(P,d)}Q.asyncRenderCallback?.()}),Q.asyncRenderCallback)for(const T of le.getElementsByTagName("img")){const V=ae.add(w.addDisposableListener(T,"load",()=>{V.dispose(),Q.asyncRenderCallback()}))}return{element:le,dispose:()=>{fe=!0,ae.dispose()}}}t.renderMarkdown=L;function S(ie){if(!ie)return"";const Q=ie.split(/[\s+|:|,|\{|\?]/,1);return Q.length?Q[0]:ie}function A(ie,Q){return/^\w[\w\d+.-]*:/.test(Q)?Q:ie.path.endsWith("/")?(0,s.resolvePath)(ie,Q).toString():(0,s.resolvePath)((0,s.dirname)(ie),Q).toString()}function u(ie,Q){const{config:me,allowedSchemes:ae}=E(ie);i.addHook("uponSanitizeAttribute",(le,de)=>{if(de.attrName==="style"||de.attrName==="class"){if(le.tagName==="SPAN"){if(de.attrName==="style"){de.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(de.attrValue);return}else if(de.attrName==="class"){de.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(de.attrValue);return}}de.keepAttr=!1;return}});const fe=w.hookDomPurifyHrefAndSrcSanitizer(ae);try{return i.sanitize(Q,{...me,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),fe.dispose()}}t.allowedMarkdownAttr=["align","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function E(ie){const Q=[c.Schemas.http,c.Schemas.https,c.Schemas.mailto,c.Schemas.data,c.Schemas.file,c.Schemas.vscodeFileResource,c.Schemas.vscodeRemote,c.Schemas.vscodeRemoteResource];return ie.isTrusted&&Q.push(c.Schemas.command),{config:{ALLOWED_TAGS:[...w.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Q}}function b(ie){return typeof ie=="string"?ie:D(ie)}t.renderStringAsPlaintext=b;function D(ie){let Q=ie.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`);const me=r.marked.parse(Q,{renderer:x.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,ae=>z.get(ae)??ae);return u({isTrusted:!1},me).toString()}t.renderMarkdownAsPlaintext=D;const z=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),x=new n.Lazy(()=>{const ie=new r.marked.Renderer;return ie.code=Q=>Q,ie.blockquote=Q=>Q,ie.html=Q=>"",ie.heading=(Q,me,ae)=>Q+`
`,ie.hr=()=>"",ie.list=(Q,me)=>Q,ie.listitem=Q=>Q+`
`,ie.paragraph=Q=>Q+`
`,ie.table=(Q,me)=>Q+me+`
`,ie.tablerow=Q=>Q,ie.tablecell=(Q,me)=>Q+" ",ie.strong=Q=>Q,ie.em=Q=>Q,ie.codespan=Q=>Q,ie.br=()=>`
`,ie.del=Q=>Q,ie.image=(Q,me,ae)=>"",ie.text=Q=>Q,ie.link=(Q,me,ae)=>ae,ie})}),define(pe[122],be([1,0,4,8,28,60,34,2,6,98]),function(Z,t,w,i,B,H,y,v,h,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function f(n,e){(0,h.isString)(e)?n.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=f;class I{constructor(e,r,a){this.hoverDelegate=e,this.target=r,this.fadeInAnimation=a}async update(e,r,a){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let c;if(e===void 0||(0,h.isString)(e)||e instanceof HTMLElement)c=e;else if(!(0,h.isFunction)(e.markdown))c=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,g.localize)(0,null),r),this._cancellationTokenSource=new B.CancellationTokenSource;const m=this._cancellationTokenSource.token;if(c=await e.markdown(m),c===void 0&&(c=e.markdownNotSupportedFallback),this.isDisposed||m.isCancellationRequested)return}this.show(c,r,a)}show(e,r,a){const c=this._hoverWidget;if(this.hasContent(e)){const m={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!c,...a};this._hoverWidget=this.hoverDelegate.showHover(m,r)}c?.dispose()}hasContent(e){return e?(0,H.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function o(n,e,r,a){let c,m;const s=(S,A)=>{S&&(m?.dispose(),m=void 0),A&&(c?.dispose(),c=void 0),n.onDidHideHover?.()},l=(S,A,u)=>new i.TimeoutTimer(async()=>{(!m||m.isDisposed)&&(m=new I(n,u||e,S>0),await m.update(r,A,a))},S),p=()=>{if(c)return;const S=new v.DisposableStore,A=b=>s(!1,b.fromElement===e);S.add(w.addDisposableListener(e,w.EventType.MOUSE_LEAVE,A,!0));const u=()=>s(!0,!0);S.add(w.addDisposableListener(e,w.EventType.MOUSE_DOWN,u,!0));const E={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const b=D=>{E.x=D.x+10,D.target instanceof HTMLElement&&D.target.classList.contains("action-label")&&s(!0,!0)};S.add(w.addDisposableListener(e,w.EventType.MOUSE_MOVE,b,!0))}S.add(l(n.delay,!1,E)),c=S},_=w.addDisposableListener(e,w.EventType.MOUSE_OVER,p,!0);return{show:S=>{s(!1,!0),l(0,S)},hide:()=>{s(!0,!0)},update:async(S,A)=>{r=S,await m?.update(r,void 0,A)},dispose:()=>{_.dispose(),s(!0,!0)}}}t.setupCustomHover=o}),define(pe[123],be([1,0,4,18,19,121,59,14,3,43,2,5,100,91]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=w.$,e="selectOption.entry.template";class r{get templateId(){return e}renderTemplate(m){const s=Object.create(null);return s.root=m,s.text=w.append(m,n(".option-text")),s.detail=w.append(m,n(".option-detail")),s.decoratorRight=w.append(m,n(".option-decorator-right")),s}renderElement(m,s,l){const p=l,_=m.text,L=m.detail,S=m.decoratorRight,A=m.isDisabled;p.text.textContent=_,p.detail.textContent=L||"",p.decoratorRight.innerText=S||"",A?p.root.classList.add("option-disabled"):p.root.classList.remove("option-disabled")}disposeTemplate(m){}}class a extends f.Disposable{constructor(m,s,l,p,_){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=_||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=a.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new h.Emitter,this._register(this._onDidSelect),this.styles=p,this.registerListeners(),this.constructSelectDropDown(l),this.selected=s||0,m&&this.setOptions(m,s)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(m){this.contextViewProvider=m,this.selectDropDownContainer=w.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=w.append(this.selectDropDownContainer,n(".select-box-details-pane"));const s=w.append(this.selectDropDownContainer,n(".select-box-dropdown-container-width-control")),l=w.append(s,n(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",w.append(l,this.widthControlElement),this._dropDownPosition=0,this.styleElement=w.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(w.addDisposableListener(this.selectDropDownContainer,w.EventType.DRAG_START,p=>{w.EventHelper.stop(p,!0)}))}registerListeners(){this._register(w.addStandardDisposableListener(this.selectElement,"change",s=>{this.selected=s.target.selectedIndex,this._onDidSelect.fire({index:s.target.selectedIndex,selected:s.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(w.addDisposableListener(this.selectElement,w.EventType.CLICK,s=>{w.EventHelper.stop(s),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(w.addDisposableListener(this.selectElement,w.EventType.MOUSE_DOWN,s=>{w.EventHelper.stop(s)}));let m;this._register(w.addDisposableListener(this.selectElement,"touchstart",s=>{m=this._isVisible})),this._register(w.addDisposableListener(this.selectElement,"touchend",s=>{w.EventHelper.stop(s),m?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(w.addDisposableListener(this.selectElement,w.EventType.KEY_DOWN,s=>{const l=new B.StandardKeyboardEvent(s);let p=!1;I.isMacintosh?(l.keyCode===18||l.keyCode===16||l.keyCode===10||l.keyCode===3)&&(p=!0):(l.keyCode===18&&l.altKey||l.keyCode===16&&l.altKey||l.keyCode===10||l.keyCode===3)&&(p=!0),p&&(this.showSelectDropDown(),w.EventHelper.stop(s,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(m,s){v.equals(this.options,m)||(this.options=m,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((l,p)=>{this.selectElement.add(this.createOption(l.text,p,l.isDisabled)),typeof l.description=="string"&&(this._hasDetails=!0)})),s!==void 0&&(this.select(s),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(m){m>=0&&m<this.options.length?this.selected=m:m>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(m){this.selectBoxOptions.ariaLabel=m,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(m){this.selectElement.tabIndex=m?0:-1}render(m){this.container=m,m.classList.add("select-container"),m.appendChild(this.selectElement),this.applyStyles()}style(m){const s=[];this.styles=m,this.styles.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=s.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const m=this.styles.selectBackground?this.styles.selectBackground.toString():"",s=this.styles.selectForeground?this.styles.selectForeground.toString():"",l=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=m,this.selectElement.style.color=s,this.selectElement.style.borderColor=l}this.selectList&&this.styleList()}styleList(){if(this.selectList){const m=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const s=this.styles.selectListBackground?this.styles.selectListBackground.toString():m;this.selectDropDownListContainer.style.backgroundColor=s,this.selectionDetailsPane.style.backgroundColor=s;const l=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=l,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(m,s,l){const p=document.createElement("option");return p.value=m,p.text=m,p.disabled=!!l,p}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:m=>this.renderSelectDropDown(m,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:m=>this.renderSelectDropDown(m),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(m){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),m&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(m,s){return m.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(s),{dispose:()=>{try{m.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let m=0;return this.options.forEach((s,l)=>{this.updateDetail(l),this.selectionDetailsPane.offsetHeight>m&&(m=this.selectionDetailsPane.offsetHeight)}),m}layoutSelectDropDown(m){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const s=w.getDomNodePagePosition(this.selectElement),l=getComputedStyle(this.selectElement),p=parseFloat(l.getPropertyValue("--dropdown-padding-top"))+parseFloat(l.getPropertyValue("--dropdown-padding-bottom")),_=window.innerHeight-s.top-s.height-(this.selectBoxOptions.minBottomMargin||0),L=s.top-a.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,S=this.selectElement.offsetWidth,A=this.setWidthControlElement(this.widthControlElement),u=Math.max(A,Math.round(S)).toString()+"px";this.selectDropDownContainer.style.width=u,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let E=this.selectList.contentHeight;const b=this._hasDetails?this.measureMaxDetailsHeight():0,D=E+p+b,z=Math.floor((_-p-b)/this.getHeight()),x=Math.floor((L-p-b)/this.getHeight());if(m)return s.top+s.height>window.innerHeight-22||s.top<a.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||z<1&&x<1?!1:(z<a.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&x>z&&this.options.length>z?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(s.top+s.height>window.innerHeight-22||s.top<a.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&z<1||this._dropDownPosition===1&&x<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&z+x<1)return this.hideSelectDropDown(!0),!1;D>_&&(E=z*this.getHeight())}else D>L&&(E=x*this.getHeight());return this.selectList.layout(E),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=E+p+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=E+p+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=u,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(m){let s=0;if(m){let l=0,p=0;this.options.forEach((_,L)=>{const S=_.detail?_.detail.length:0,A=_.decoratorRight?_.decoratorRight.length:0,u=_.text.length+S+A;u>p&&(l=L,p=u)}),m.textContent=this.options[l].text+(this.options[l].decoratorRight?this.options[l].decoratorRight+" ":""),s=w.getTotalWidth(m)}return s}createSelectList(m){if(this.selectList)return;this.selectDropDownListContainer=w.append(m,n(".select-box-dropdown-list-container")),this.listRenderer=new r,this.selectList=new y.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:p=>{let _=p.text;return p.detail&&(_+=`. ${p.detail}`),p.decoratorRight&&(_+=`. ${p.decoratorRight}`),p.description&&(_+=`. ${p.description}`),_},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const s=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),l=h.Event.chain(s.event).filter(()=>this.selectList.length>0).map(p=>new B.StandardKeyboardEvent(p));this._register(l.filter(p=>p.keyCode===3).on(p=>this.onEnter(p),this)),this._register(l.filter(p=>p.keyCode===2).on(p=>this.onEnter(p),this)),this._register(l.filter(p=>p.keyCode===9).on(p=>this.onEscape(p),this)),this._register(l.filter(p=>p.keyCode===16).on(p=>this.onUpArrow(p),this)),this._register(l.filter(p=>p.keyCode===18).on(p=>this.onDownArrow(p),this)),this._register(l.filter(p=>p.keyCode===12).on(this.onPageDown,this)),this._register(l.filter(p=>p.keyCode===11).on(this.onPageUp,this)),this._register(l.filter(p=>p.keyCode===14).on(this.onHome,this)),this._register(l.filter(p=>p.keyCode===13).on(this.onEnd,this)),this._register(l.filter(p=>p.keyCode>=21&&p.keyCode<=56||p.keyCode>=80&&p.keyCode<=108).on(this.onCharacter,this)),this._register(w.addDisposableListener(this.selectList.getHTMLElement(),w.EventType.POINTER_UP,p=>this.onPointerUp(p))),this._register(this.selectList.onMouseOver(p=>typeof p.index<"u"&&this.selectList.setFocus([p.index]))),this._register(this.selectList.onDidChangeFocus(p=>this.onListFocus(p))),this._register(w.addDisposableListener(this.selectDropDownContainer,w.EventType.FOCUS_OUT,p=>{!this._isVisible||w.isAncestor(p.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(m){if(!this.selectList.length)return;w.EventHelper.stop(m);const s=m.target;if(!s||s.classList.contains("slider"))return;const l=s.closest(".monaco-list-row");if(!l)return;const p=Number(l.getAttribute("data-index")),_=l.classList.contains("option-disabled");p>=0&&p<this.options.length&&!_&&(this.selected=p,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(m,s){const l=_=>{for(let L=0;L<_.childNodes.length;L++){const S=_.childNodes.item(L);(S.tagName&&S.tagName.toLowerCase())==="img"?_.removeChild(S):l(S)}},p=(0,H.renderMarkdown)({value:m,supportThemeIcons:!0},{actionHandler:s});return p.element.classList.add("select-box-description-markdown"),l(p.element),p.element}onListFocus(m){!this._isVisible||!this._hasDetails||this.updateDetail(m.indexes[0])}updateDetail(m){this.selectionDetailsPane.innerText="";const s=this.options[m],l=s?.description??"",p=s?.descriptionIsMarkdown??!1;if(l){if(p){const _=s.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(l,_))}else this.selectionDetailsPane.innerText=l;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(m){w.EventHelper.stop(m),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(m){w.EventHelper.stop(m),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(m){if(this.selected<this.options.length-1){w.EventHelper.stop(m,!0);const s=this.options[this.selected+1].isDisabled;if(s&&this.options.length>this.selected+2)this.selected+=2;else{if(s)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(m){this.selected>0&&(w.EventHelper.stop(m,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(m){w.EventHelper.stop(m),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(m){w.EventHelper.stop(m),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(m){w.EventHelper.stop(m),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(m){w.EventHelper.stop(m),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(m){const s=g.KeyCodeUtils.toString(m.keyCode);let l=-1;for(let p=0;p<this.options.length-1;p++)if(l=(p+this.selected+1)%this.options.length,this.options[l].text.charAt(0).toUpperCase()===s&&!this.options[l].isDisabled){this.select(l),this.selectList.setFocus([l]),this.selectList.reveal(this.selectList.getFocus()[0]),w.EventHelper.stop(m);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=a,a.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,a.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,a.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(pe[124],be([1,0,123,117,17,24,27,5,90]),function(Z,t,w,i,B,H,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:H.Color.fromHex("#3C3C3C"),selectForeground:H.Color.fromHex("#F0F0F0"),selectBorder:H.Color.fromHex("#3C3C3C")};class h extends B.Widget{constructor(f,I,o,n=(0,y.deepClone)(t.defaultStyles),e){super(),v.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(f,I,n,e):this.selectBoxDelegate=new w.SelectBoxList(f,I,o,n,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(f,I){this.selectBoxDelegate.setOptions(f,I)}select(f){this.selectBoxDelegate.select(f)}setAriaLabel(f){this.selectBoxDelegate.setAriaLabel(f)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(f){this.selectBoxDelegate.setFocusable(f)}render(f){this.selectBoxDelegate.render(f)}style(f){this.selectBoxDelegate.style(f)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=h}),define(pe[61],be([1,0,16,51,4,22,122,124,32,2,5,6,95,48]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends g.Disposable{get action(){return this._action}constructor(c,m,s={}){super(),this.options=s,this._context=c||this,this._action=m,m instanceof h.Action&&this._register(m.onDidChange(l=>{!this.element||this.handleActionChangeEvent(l)}))}handleActionChangeEvent(c){c.enabled!==void 0&&this.updateEnabled(),c.checked!==void 0&&this.updateChecked(),c.class!==void 0&&this.updateClass(),c.label!==void 0&&(this.updateLabel(),this.updateTooltip()),c.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new h.ActionRunner)),this._actionRunner}set actionRunner(c){this._actionRunner=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const m=this.element=c;this._register(H.Gesture.addTarget(c));const s=this.options&&this.options.draggable;s&&(c.draggable=!0,w.isFirefox&&this._register((0,B.addDisposableListener)(c,B.EventType.DRAG_START,l=>l.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,B.addDisposableListener)(m,H.EventType.Tap,l=>this.onClick(l,!0))),this._register((0,B.addDisposableListener)(m,B.EventType.MOUSE_DOWN,l=>{s||B.EventHelper.stop(l,!0),this._action.enabled&&l.button===0&&m.classList.add("active")})),f.isMacintosh&&this._register((0,B.addDisposableListener)(m,B.EventType.CONTEXT_MENU,l=>{l.button===0&&l.ctrlKey===!0&&this.onClick(l)})),this._register((0,B.addDisposableListener)(m,B.EventType.CLICK,l=>{B.EventHelper.stop(l,!0),this.options&&this.options.isMenu||this.onClick(l)})),this._register((0,B.addDisposableListener)(m,B.EventType.DBLCLICK,l=>{B.EventHelper.stop(l,!0)})),[B.EventType.MOUSE_UP,B.EventType.MOUSE_OUT].forEach(l=>{this._register((0,B.addDisposableListener)(m,l,p=>{B.EventHelper.stop(p),m.classList.remove("active")}))})}onClick(c,m=!1){B.EventHelper.stop(c,!0);const s=I.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?c:{preserveFocus:m}:this._context;this.actionRunner.run(this._action,s)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const c=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(c):(this.customHover=(0,y.setupCustomHover)(this.options.hoverDelegate,this.element,c),this._store.add(this.customHover))):this.element.title=c}updateAriaLabel(){if(this.element){const c=this.getTooltip()??"";this.element.setAttribute("aria-label",c)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(c,m,s={}){super(c,m,s),this.options=s,this.options.icon=s.icon!==void 0?s.icon:!1,this.options.label=s.label!==void 0?s.label:!0,this.cssClass=""}render(c){super.render(c),this.element&&(this.label=(0,B.append)(this.element,(0,B.$)("a.action-label"))),this.label&&(this._action.id===h.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,B.append)(this.element,(0,B.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(c){this.label&&(this.label.tabIndex=c?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(c=this.action.label,this.options.keybinding&&(c=o.localize(0,null,c,this.options.keybinding))),c??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const c=this.getTooltip()??"";this.label.setAttribute("aria-label",c)}}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class r extends n{constructor(c,m,s,l,p,_){super(c,m),this.selectBox=new v.SelectBox(s,l,p,void 0,_),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(c,m){this.selectBox.setOptions(c,m)}select(c){this.selectBox.select(c)}registerListeners(){this._register(this.selectBox.onDidSelect(c=>this.runAction(c.selected,c.index)))}runAction(c,m){this.actionRunner.run(this._action,this.getActionContext(c,m))}getActionContext(c,m){return c}setFocusable(c){this.selectBox.setFocusable(c)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(c){this.selectBox.render(c)}}t.SelectActionViewItem=r}),define(pe[62],be([1,0,4,19,61,32,3,2,6,48]),function(Z,t,w,i,B,H,y,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var g;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(g=t.ActionsOrientation||(t.ActionsOrientation={}));class f extends v.Disposable{constructor(n,e={}){super(),this._actionRunnerDisposables=this._register(new v.DisposableStore),this.viewItemDisposables=this._register(new v.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new y.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new y.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new y.Emitter),this.onWillRun=this._onWillRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new H.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(c=>this._onDidRun.fire(c))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(c=>this._onWillRun.fire(c))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let r,a;switch(this._orientation){case 0:r=[15],a=[17];break;case 1:r=[16],a=[18],this.domNode.className+=" vertical";break}this._register(w.addDisposableListener(this.domNode,w.EventType.KEY_DOWN,c=>{const m=new i.StandardKeyboardEvent(c);let s=!0;const l=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;r&&(m.equals(r[0])||m.equals(r[1]))?s=this.focusPrevious():a&&(m.equals(a[0])||m.equals(a[1]))?s=this.focusNext():m.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():m.equals(14)?s=this.focusFirst():m.equals(13)?s=this.focusLast():m.equals(2)&&l instanceof B.BaseActionViewItem&&l.trapsArrowNavigation?s=this.focusNext():this.isTriggerKeyEvent(m)?this._triggerKeys.keyDown?this.doTrigger(m):this.triggerKeyDown=!0:s=!1,s&&(m.preventDefault(),m.stopPropagation())})),this._register(w.addDisposableListener(this.domNode,w.EventType.KEY_UP,c=>{const m=new i.StandardKeyboardEvent(c);this.isTriggerKeyEvent(m)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(m)),m.preventDefault(),m.stopPropagation()):(m.equals(2)||m.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(w.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(w.getActiveElement()===this.domNode||!w.isAncestor(w.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),n.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(n){n?this.actionsList.setAttribute("aria-label",n):this.actionsList.removeAttribute("aria-label")}setFocusable(n){if(this.focusable=n,this.focusable){const e=this.viewItems.find(r=>r instanceof B.BaseActionViewItem&&r.isEnabled());e instanceof B.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof B.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(n){let e=!1;return this._triggerKeys.keys.forEach(r=>{e=e||n.equals(r)}),e}updateFocusedItem(){for(let n=0;n<this.actionsList.children.length;n++){const e=this.actionsList.children[n];if(w.isAncestor(w.getActiveElement(),e)){this.focusedItem=n;break}}}get context(){return this._context}set context(n){this._context=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this._actionRunner}set actionRunner(n){this._actionRunner=n,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(e=>this._onDidRun.fire(e))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(e=>this._onWillRun.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.actionsList;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.actionsList.childNodes.length;e++)if(this.actionsList.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const r=Array.isArray(n)?n:[n];let a=h.isNumber(e.index)?e.index:null;r.forEach(c=>{const m=document.createElement("li");m.className="action-item",m.setAttribute("role","presentation");let s;this.options.actionViewItemProvider&&(s=this.options.actionViewItemProvider(c)),s||(s=new B.ActionViewItem(this.context,c,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(s,w.addDisposableListener(m,w.EventType.CONTEXT_MENU,l=>{w.EventHelper.stop(l,!0)})),s.actionRunner=this._actionRunner,s.setActionContext(this.context),s.render(m),this.focusable&&s instanceof B.BaseActionViewItem&&this.viewItems.length===0&&s.setFocusable(!0),a===null||a<0||a>=this.actionsList.children.length?(this.actionsList.appendChild(m),this.viewItems.push(s)):(this.actionsList.insertBefore(m,this.actionsList.children[a]),this.viewItems.splice(a,0,s),a++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(n){if(n>=0&&n<this.actionsList.children.length){const e=this.actionsList.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.actionsList.children.length){const e=this.actionsList.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[n]),this.viewItemDisposables.deleteAndDispose(this.viewItems[n]),(0,v.dispose)(this.viewItems.splice(n,1)),this.refreshRole())}clear(){this.viewItems=(0,v.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),w.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,r;if(n===void 0?e=!0:typeof n=="number"?r=n:typeof n=="boolean"&&(e=n),e&&typeof this.focusedItem>"u"){const a=this.viewItems.findIndex(c=>c.isEnabled());this.focusedItem=a===-1?void 0:a,this.updateFocus(void 0,void 0,!0)}else r!==void 0&&(this.focusedItem=r),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(n){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let r;do{if(!n&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,r=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===H.Separator.ID));return this.updateFocus(),!0}focusPrevious(n){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let r;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!n&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}r=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===H.Separator.ID));return this.updateFocus(!0),!0}updateFocus(n,e,r=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const a=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(a){let c=!0;h.isFunction(a.focus)||(c=!1),this.options.focusOnlyEnabledItems&&h.isFunction(a.isEnabled)&&!a.isEnabled()&&(c=!1),a.action.id===H.Separator.ID&&(c=!1),c?(r||this.previouslyFocusedItem!==this.focusedItem)&&(a.focus(n),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(n){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof B.BaseActionViewItem){const r=e._context===null||e._context===void 0?n:e._context;this.run(e._action,r)}}async run(n,e){await this._actionRunner.run(n,e)}dispose(){this.viewItems=(0,v.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=f;function I(o){if(!o.length)return o;let n=-1;for(let r=0;r<o.length;r++)if(o[r].id!==H.Separator.ID){n=r;break}if(n===-1)return[];o=o.slice(n);for(let r=o.length-1;r>=0&&o[r].id===H.Separator.ID;r--)o.splice(r,1);let e=!1;for(let r=o.length-1;r>=0;r--){const a=o[r].id===H.Separator.ID;a&&!e?o.splice(r,1):a?a&&(e=!1):e=!0}return o}t.prepareActions=I}),define(pe[125],be([1,0,4,18,52,62,54,57,17,24,3,77,27,99,87]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=w.$;var r;(function(s){s[s.INFO=1]="INFO",s[s.WARNING=2]="WARNING",s[s.ERROR=3]="ERROR"})(r=t.MessageType||(t.MessageType={}));const a={inputBackground:g.Color.fromHex("#3C3C3C"),inputForeground:g.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:g.Color.fromHex("#55AAFF"),inputValidationInfoBackground:g.Color.fromHex("#063B49"),inputValidationWarningBorder:g.Color.fromHex("#B89500"),inputValidationWarningBackground:g.Color.fromHex("#352A05"),inputValidationErrorBorder:g.Color.fromHex("#BE1100"),inputValidationErrorBackground:g.Color.fromHex("#5A1D1D")};class c extends h.Widget{constructor(l,p,_){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new f.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=p,this.options=_||Object.create(null),(0,o.mixin)(this.options,a,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=w.append(l,e(".monaco-inputbox.idle"));const L=this.options.flexibleHeight?"textarea":"input",S=w.append(this.element,e(".ibwrapper"));if(this.input=w.append(S,e(L+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=w.append(S,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new v.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),w.append(l,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(E=>this.input.scrollTop=E.scrollTop));const A=this._register(new i.DomEmitter(document,"selectionchange")),u=f.Event.filter(A.event,()=>document.getSelection()?.anchorNode===S);this._register(u(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new H.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(l){this.placeholder=l,this.input.setAttribute("placeholder",l)}setTooltip(l){this.tooltip=l,this.input.title=l}setAriaLabel(l){this.ariaLabel=l,l?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(l){this.input.value!==l&&(this.input.value=l,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:w.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(l=null){this.input.select(),l&&(this.input.setSelectionRange(l.start,l.end),l.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(l){l?this.enable():this.disable()}get width(){return w.getTotalWidth(this.input)}set width(l){if(this.options.flexibleHeight&&this.options.flexibleWidth){let p=0;if(this.mirror){const _=parseFloat(this.mirror.style.paddingLeft||"")||0,L=parseFloat(this.mirror.style.paddingRight||"")||0;p=_+L}this.input.style.width=l-p+"px"}else this.input.style.width=l+"px";this.mirror&&(this.mirror.style.width=l+"px")}set paddingRight(l){this.input.style.width=`calc(100% - ${l}px)`,this.mirror&&(this.mirror.style.paddingRight=l+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const l=this.cachedContentHeight,p=this.cachedHeight,_=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:l,height:p}),this.scrollableElement.setScrollPosition({scrollTop:_})}showMessage(l,p){this.message=l,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(l.type));const _=this.stylesForType(this.message.type);this.element.style.border=_.border?`1px solid ${_.border}`:"",this.message.content&&(this.hasFocus()||p)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let l=null;return this.validation&&(l=this.validation(this.value),l?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(l)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),l?.type}stylesForType(l){switch(l){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(l){switch(l){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let l;const p=()=>l.style.width=w.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:L=>{if(!this.message)return null;l=w.append(L,e(".monaco-inputbox-container")),p();const S={inline:!0,className:"monaco-inputbox-message"},A=this.message.formatContent?(0,B.renderFormattedText)(this.message.content,S):(0,B.renderText)(this.message.content,S);A.classList.add(this.classForType(this.message.type));const u=this.stylesForType(this.message.type);return A.style.backgroundColor=u.background?u.background.toString():"",A.style.color=u.foreground?u.foreground.toString():"",A.style.border=u.border?`1px solid ${u.border}`:"",w.append(l,A),null},onHide:()=>{this.state="closed"},layout:p});let _;this.message.type===3?_=n.localize(0,null,this.message.content):this.message.type===2?_=n.localize(1,null,this.message.content):_=n.localize(2,null,this.message.content),y.alert(_),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const l=this.value,_=l.charCodeAt(l.length-1)===10?" ":"";(l+_).replace(/\u000c/g,"")?this.mirror.textContent=l+_:this.mirror.innerText="\xA0",this.layout()}style(l){this.inputBackground=l.inputBackground,this.inputForeground=l.inputForeground,this.inputBorder=l.inputBorder,this.inputValidationInfoBackground=l.inputValidationInfoBackground,this.inputValidationInfoForeground=l.inputValidationInfoForeground,this.inputValidationInfoBorder=l.inputValidationInfoBorder,this.inputValidationWarningBackground=l.inputValidationWarningBackground,this.inputValidationWarningForeground=l.inputValidationWarningForeground,this.inputValidationWarningBorder=l.inputValidationWarningBorder,this.inputValidationErrorBackground=l.inputValidationErrorBackground,this.inputValidationErrorForeground=l.inputValidationErrorForeground,this.inputValidationErrorBorder=l.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const l=this.inputBackground?this.inputBackground.toString():"",p=this.inputForeground?this.inputForeground.toString():"",_=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=l,this.element.style.color=p,this.input.style.backgroundColor="inherit",this.input.style.color=p,this.element.style.borderWidth=_?"1px":"",this.element.style.borderStyle=_?"solid":"",this.element.style.borderColor=_}layout(){if(!this.mirror)return;const l=this.cachedContentHeight;this.cachedContentHeight=w.getTotalHeight(this.mirror),l!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(l){const p=this.inputElement,_=p.selectionStart,L=p.selectionEnd,S=p.value;_!==null&&L!==null&&(this.value=S.substr(0,_)+l+S.substr(L),p.setSelectionRange(_+1,_+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=c;class m extends c{constructor(l,p,_){const L=n.localize(3,null),S=` or \u21C5 ${L}`,A=` (\u21C5 ${L})`;super(l,p,_),this._onDidFocus=this._register(new f.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new f.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new I.HistoryNavigator(_.history,100);const u=()=>{if(_.showHistoryHint&&_.showHistoryHint()&&!this.placeholder.endsWith(S)&&!this.placeholder.endsWith(A)&&this.history.getHistory().length){const E=this.placeholder.endsWith(")")?S:A,b=this.placeholder+E;_.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=b:this.setPlaceHolder(b)}};this.observer=new MutationObserver((E,b)=>{E.forEach(D=>{D.target.textContent||u()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>u()),this.onblur(this.input,()=>{const E=b=>{if(this.placeholder.endsWith(b)){const D=this.placeholder.slice(0,this.placeholder.length-b.length);return _.showPlaceholderOnFocus?this.placeholder=D:this.setPlaceHolder(D),!0}else return!1};E(A)||E(S)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let l=this.getNextValue();l&&(l=l===this.value?this.getNextValue():l),l&&(this.value=l,y.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let l=this.getPreviousValue();l&&(l=l===this.value?this.getPreviousValue():l),l&&(this.value=l,y.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let l=this.history.current();return l||(l=this.history.last(),this.history.next()),l}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=m}),define(pe[63],be([1,0,61,17,12,24,3,92]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const v={inputActiveOptionBorder:H.Color.fromHex("#007ACC00"),inputActiveOptionForeground:H.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:H.Color.fromHex("#0E639C50")};class h extends w.BaseActionViewItem{constructor(o,n,e){super(o,n,e),this.toggle=this._register(new g({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(o){this.element=o,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(o){this.toggle.domNode.tabIndex=o?0:-1}}t.ToggleActionViewItem=h;class g extends i.Widget{constructor(o){super(),this._onChange=this._register(new y.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...v,...o},this._checked=this._opts.isChecked;const n=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,n.push(...B.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&n.push(...this._opts.actionClassName.split(" ")),this._checked&&n.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...n),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(o){this._checked=o,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(o){this._icon&&this.domNode.classList.remove(...B.CSSIcon.asClassNameArray(this._icon)),this._icon=o,this._icon&&this.domNode.classList.add(...B.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(o){o.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=o.inputActiveOptionBorder),o.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=o.inputActiveOptionForeground),o.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=o.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this.domNode.title=o,this.domNode.setAttribute("aria-label",o)}}t.Toggle=g;class f extends i.Widget{constructor(o,n){super(),this.title=o,this.isChecked=n,this.checkbox=new g({title:this.title,isChecked:this.isChecked,icon:B.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(o){this.checkbox.checked=o,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(o){this.styles=o,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=f}),define(pe[126],be([1,0,63,12,97]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const H=B.localize(0,null),y=B.localize(1,null),v=B.localize(2,null);class h extends w.Toggle{constructor(o){super({icon:i.Codicon.caseSensitive,title:H+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=h;class g extends w.Toggle{constructor(o){super({icon:i.Codicon.wholeWord,title:y+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=g;class f extends w.Toggle{constructor(o){super({icon:i.Codicon.regex,title:v+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=f}),define(pe[127],be([1,0,4,126,125,17,3,96,2,86]),function(Z,t,w,i,B,H,y,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const g=v.localize(0,null);class f extends H.Widget{constructor(o,n,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new h.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new y.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new y.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new y.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new y.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new y.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new y.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||g,this.showCommonFindToggles=!!e.showCommonFindToggles,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const r=e.appendCaseSensitiveLabel||"",a=e.appendWholeWordsLabel||"",c=e.appendRegexLabel||"",m=e.history||[],s=!!e.flexibleHeight,l=!!e.flexibleWidth,p=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new B.HistoryInputBox(this.domNode,n,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:m,showHistoryHint:e.showHistoryHint,flexibleHeight:s,flexibleWidth:l,flexibleMaxHeight:p})),this.regex=this._register(new i.RegexToggle({appendTitle:c,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(L=>{this._onDidOptionChange.fire(L),!L&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(L=>{this._onRegexKeyDown.fire(L)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:a,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(L=>{this._onDidOptionChange.fire(L),!L&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:r,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(L=>{this._onDidOptionChange.fire(L),!L&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(L=>{this._onCaseSensitiveKeyDown.fire(L)}));const _=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,L=>{if(L.equals(15)||L.equals(17)||L.equals(9)){const S=_.indexOf(document.activeElement);if(S>=0){let A=-1;L.equals(17)?A=(S+1)%_.length:L.equals(15)&&(S===0?A=_.length-1:A=S-1),L.equals(9)?(_[S].blur(),this.inputBox.focus()):A>=0&&_[A].focus(),w.EventHelper.stop(L,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this.showCommonFindToggles||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none"),this.setAdditionalToggles(e?.additionalToggles),this.domNode.appendChild(this.controls),o?.appendChild(this.domNode),this._register(w.addDisposableListener(this.inputBox.inputElement,"compositionstart",L=>{this.imeSessionInProgress=!0})),this._register(w.addDisposableListener(this.inputBox.inputElement,"compositionend",L=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,L=>this._onKeyDown.fire(L)),this.onkeyup(this.inputBox.inputElement,L=>this._onKeyUp.fire(L)),this.oninput(this.inputBox.inputElement,L=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,L=>this._onMouseDown.fire(L))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const o of this.additionalToggles)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const o of this.additionalToggles)o.disable()}setFocusInputOnOptionClick(o){this.fixFocusOnOptionClickEnabled=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const n of this.additionalToggles)n.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new h.DisposableStore;for(const n of o??[])this.additionalTogglesDisposables.add(n),this.controls.appendChild(n.domNode),this.additionalTogglesDisposables.add(n.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(n);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this.showCommonFindToggles?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((n,e)=>n+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}style(o){this.inputActiveOptionBorder=o.inputActiveOptionBorder,this.inputActiveOptionForeground=o.inputActiveOptionForeground,this.inputActiveOptionBackground=o.inputActiveOptionBackground,this.inputBackground=o.inputBackground,this.inputForeground=o.inputForeground,this.inputBorder=o.inputBorder,this.inputValidationInfoBackground=o.inputValidationInfoBackground,this.inputValidationInfoForeground=o.inputValidationInfoForeground,this.inputValidationInfoBorder=o.inputValidationInfoBorder,this.inputValidationWarningBackground=o.inputValidationWarningBackground,this.inputValidationWarningForeground=o.inputValidationWarningForeground,this.inputValidationWarningBorder=o.inputValidationWarningBorder,this.inputValidationErrorBackground=o.inputValidationErrorBackground,this.inputValidationErrorForeground=o.inputValidationErrorForeground,this.inputValidationErrorBorder=o.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const o={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(o),this.wholeWords.style(o),this.caseSensitive.style(o);for(const e of this.additionalToggles)e.style(o);const n={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(n)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(o){this.caseSensitive.checked=o}getWholeWords(){return this.wholeWords.checked}setWholeWords(o){this.wholeWords.checked=o}getRegex(){return this.regex.checked}setRegex(o){this.regex.checked=o,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(pe[128],be([1,0,4,18,19,62,127,58,59,63,55,23,32,14,8,12,69,3,33,2,46,6,101,93]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n,e,r,a,c,m,s,l,p,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class L extends v.ElementsDragAndDropData{set context(T){this.data.context=T}get context(){return this.data.context}constructor(T){super(T.elements.map(V=>V.element)),this.data=T}}function S(ne){return ne instanceof v.ElementsDragAndDropData?new L(ne):ne}class A{constructor(T,V){this.modelProvider=T,this.dnd=V,this.autoExpandDisposable=s.Disposable.None}getDragURI(T){return this.dnd.getDragURI(T.element)}getDragLabel(T,V){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(T.map(j=>j.element),V)}onDragStart(T,V){this.dnd.onDragStart?.(S(T),V)}onDragOver(T,V,j,P,d=!0){const F=this.dnd.onDragOver(S(T),V&&V.element,j,P),U=this.autoExpandNode!==V;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=V),typeof V>"u")return F;if(U&&typeof F!="boolean"&&F.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const W=this.modelProvider(),C=W.getNodeLocation(V);W.isCollapsed(C)&&W.setCollapsed(C,!1),this.autoExpandNode=void 0},500)),typeof F=="boolean"||!F.accept||typeof F.bubble>"u"||F.feedback){if(!d){const W=typeof F=="boolean"?F:F.accept,C=typeof F=="boolean"?void 0:F.effect;return{accept:W,effect:C,feedback:[j]}}return F}if(F.bubble===1){const W=this.modelProvider(),C=W.getNodeLocation(V),k=W.getParentNodeLocation(C),M=W.getNode(k),O=k&&W.getListIndex(k);return this.onDragOver(T,M,O,P,!1)}const $=this.modelProvider(),X=$.getNodeLocation(V),N=$.getListIndex(X),R=$.getListRenderCount(X);return{...F,feedback:(0,n.range)(N,N+R)}}drop(T,V,j,P){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(S(T),V&&V.element,j,P)}onDragEnd(T){this.dnd.onDragEnd?.(T)}}function u(ne,T){return T&&{...T,identityProvider:T.identityProvider&&{getId(V){return T.identityProvider.getId(V.element)}},dnd:T.dnd&&new A(ne,T.dnd),multipleSelectionController:T.multipleSelectionController&&{isSelectionSingleChangeEvent(V){return T.multipleSelectionController.isSelectionSingleChangeEvent({...V,element:V.element})},isSelectionRangeChangeEvent(V){return T.multipleSelectionController.isSelectionRangeChangeEvent({...V,element:V.element})}},accessibilityProvider:T.accessibilityProvider&&{...T.accessibilityProvider,getSetSize(V){const j=ne(),P=j.getNodeLocation(V),d=j.getParentNodeLocation(P);return j.getNode(d).visibleChildrenCount},getPosInSet(V){return V.visibleChildIndex+1},isChecked:T.accessibilityProvider&&T.accessibilityProvider.isChecked?V=>T.accessibilityProvider.isChecked(V.element):void 0,getRole:T.accessibilityProvider&&T.accessibilityProvider.getRole?V=>T.accessibilityProvider.getRole(V.element):()=>"treeitem",getAriaLabel(V){return T.accessibilityProvider.getAriaLabel(V.element)},getWidgetAriaLabel(){return T.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:T.accessibilityProvider&&T.accessibilityProvider.getWidgetRole?()=>T.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:T.accessibilityProvider&&T.accessibilityProvider.getAriaLevel?V=>T.accessibilityProvider.getAriaLevel(V.element):V=>V.depth,getActiveDescendantId:T.accessibilityProvider.getActiveDescendantId&&(V=>T.accessibilityProvider.getActiveDescendantId(V.element))},keyboardNavigationLabelProvider:T.keyboardNavigationLabelProvider&&{...T.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(V){return T.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(V.element)}}}}class E{constructor(T){this.delegate=T}getHeight(T){return this.delegate.getHeight(T.element)}getTemplateId(T){return this.delegate.getTemplateId(T.element)}hasDynamicHeight(T){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(T.element)}setDynamicHeight(T,V){this.delegate.setDynamicHeight?.(T.element,V)}}t.ComposedTreeDelegate=E;class b{static lift(T){return T instanceof b?T:new b(T)}static empty(T=0){return new b({focus:[],selection:[],expanded:Object.create(null),scrollTop:T})}constructor(T){if(this.focus=new Set(T.focus),this.selection=new Set(T.selection),T.expanded instanceof Array){this.expanded=Object.create(null);for(const V of T.expanded)this.expanded[V]=1}else this.expanded=T.expanded;this.expanded=T.expanded,this.scrollTop=T.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=b;var D;(function(ne){ne.None="none",ne.OnHover="onHover",ne.Always="always"})(D=t.RenderIndentGuides||(t.RenderIndentGuides={}));class z{get elements(){return this._elements}constructor(T,V=[]){this._elements=V,this.disposables=new s.DisposableStore,this.onDidChange=c.Event.forEach(T,j=>this._elements=j,this.disposables)}dispose(){this.disposables.dispose()}}class x{constructor(T,V,j,P,d,F={}){this.renderer=T,this.modelProvider=V,this.activeNodes=P,this.renderedIndentGuides=d,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=x.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=s.Disposable.None,this.disposables=new s.DisposableStore,this.templateId=T.templateId,this.updateOptions(F),c.Event.map(j,U=>U.node)(this.onDidChangeNodeTwistieState,this,this.disposables),T.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(T={}){if(typeof T.indent<"u"){const V=(0,l.clamp)(T.indent,0,40);if(V!==this.indent){this.indent=V;for(const[j,P]of this.renderedNodes)this.renderTreeElement(j,P)}}if(typeof T.renderIndentGuides<"u"){const V=T.renderIndentGuides!==D.None;if(V!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=V,this.indentGuidesDisposable.dispose(),V)){const j=new s.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,j),this.indentGuidesDisposable=j,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof T.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=T.hideTwistiesOfChildlessElements)}renderTemplate(T){const V=(0,w.append)(T,(0,w.$)(".monaco-tl-row")),j=(0,w.append)(V,(0,w.$)(".monaco-tl-indent")),P=(0,w.append)(V,(0,w.$)(".monaco-tl-twistie")),d=(0,w.append)(V,(0,w.$)(".monaco-tl-contents")),F=this.renderer.renderTemplate(d);return{container:T,indent:j,twistie:P,indentGuidesDisposable:s.Disposable.None,templateData:F}}renderElement(T,V,j,P){this.renderedNodes.set(T,j),this.renderedElements.set(T.element,T),this.renderTreeElement(T,j),this.renderer.renderElement(T,V,j.templateData,P)}disposeElement(T,V,j,P){j.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(T,V,j.templateData,P),typeof P=="number"&&(this.renderedNodes.delete(T),this.renderedElements.delete(T.element))}disposeTemplate(T){this.renderer.disposeTemplate(T.templateData)}onDidChangeTwistieState(T){const V=this.renderedElements.get(T);!V||this.onDidChangeNodeTwistieState(V)}onDidChangeNodeTwistieState(T){const V=this.renderedNodes.get(T);!V||(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(T,V))}renderTreeElement(T,V){const j=x.DefaultIndent+(T.depth-1)*this.indent;V.twistie.style.paddingLeft=`${j}px`,V.indent.style.width=`${j+this.indent-16}px`,T.collapsible?V.container.setAttribute("aria-expanded",String(!T.collapsed)):V.container.removeAttribute("aria-expanded"),V.twistie.classList.remove(...r.Codicon.treeItemExpanded.classNamesArray);let P=!1;if(this.renderer.renderTwistie&&(P=this.renderer.renderTwistie(T.element,V.twistie)),T.collapsible&&(!this.hideTwistiesOfChildlessElements||T.visibleChildrenCount>0)?(P||V.twistie.classList.add(...r.Codicon.treeItemExpanded.classNamesArray),V.twistie.classList.add("collapsible"),V.twistie.classList.toggle("collapsed",T.collapsed)):V.twistie.classList.remove("collapsible","collapsed"),(0,w.clearNode)(V.indent),V.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const d=new s.DisposableStore,F=this.modelProvider();for(;;){const U=F.getNodeLocation(T),$=F.getParentNodeLocation(U);if(!$)break;const X=F.getNode($),N=(0,w.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(X)&&N.classList.add("active"),V.indent.childElementCount===0?V.indent.appendChild(N):V.indent.insertBefore(N,V.indent.firstElementChild),this.renderedIndentGuides.add(X,N),d.add((0,s.toDisposable)(()=>this.renderedIndentGuides.delete(X,N))),T=X}V.indentGuidesDisposable=d}_onDidChangeActiveNodes(T){if(!this.shouldRenderIndentGuides)return;const V=new Set,j=this.modelProvider();T.forEach(P=>{const d=j.getNodeLocation(P);try{const F=j.getParentNodeLocation(d);P.collapsible&&P.children.length>0&&!P.collapsed?V.add(P):F&&V.add(j.getNode(F))}catch{}}),this.activeIndentNodes.forEach(P=>{V.has(P)||this.renderedIndentGuides.forEach(P,d=>d.classList.remove("active"))}),V.forEach(P=>{this.activeIndentNodes.has(P)||this.renderedIndentGuides.forEach(P,d=>d.classList.add("active"))}),this.activeIndentNodes=V}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,s.dispose)(this.disposables)}}x.DefaultIndent=8;class ie{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(T){this._pattern=T,this._lowercasePattern=T.toLowerCase()}constructor(T,V,j){this.tree=T,this.keyboardNavigationLabelProvider=V,this._filter=j,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new s.DisposableStore,T.onWillRefilter(this.reset,this,this.disposables)}filter(T,V){let j=1;if(this._filter){const F=this._filter.filter(T,V);if(typeof F=="boolean"?j=F?1:0:(0,f.isFilterResult)(F)?j=(0,f.getVisibleState)(F.visibility):j=F,j===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:m.FuzzyScore.Default,visibility:j};const P=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(T),d=Array.isArray(P)?P:[P];for(const F of d){const U=F&&F.toString();if(typeof U>"u")return{data:m.FuzzyScore.Default,visibility:j};const $=(0,m.fuzzyScore)(this._pattern,this._lowercasePattern,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if($)return this._matchCount++,d.length===1?{data:$,visibility:j}:{data:{label:U,score:$},visibility:j}}return this.tree.findMode===me.Filter?2:{data:m.FuzzyScore.Default,visibility:j}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,s.dispose)(this.disposables)}}class Q extends g.Toggle{constructor(T){super({icon:r.Codicon.listFilter,title:(0,_.localize)(0,null),isChecked:T?.isChecked??!1,inputActiveOptionBorder:T?.inputActiveOptionBorder,inputActiveOptionForeground:T?.inputActiveOptionForeground,inputActiveOptionBackground:T?.inputActiveOptionBackground})}}t.ModeToggle=Q;var me;(function(ne){ne[ne.Highlight=0]="Highlight",ne[ne.Filter=1]="Filter"})(me=t.TreeFindMode||(t.TreeFindMode={}));class ae extends s.Disposable{set mode(T){this.modeToggle.checked=T===me.Filter,this.findInput.inputBox.setPlaceHolder(T===me.Filter?(0,_.localize)(1,null):(0,_.localize)(2,null))}get value(){return this.findInput.inputBox.value}set value(T){this.findInput.inputBox.value=T}constructor(T,V,j,P,d){super(),this.tree=V,this.elements=(0,w.h)(".monaco-tree-type-filter",[(0,w.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,w.h)(".monaco-tree-type-filter-input@findInput"),(0,w.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new c.Emitter,this.onDidDisable=this._onDidDisable.event,T.appendChild(this.elements.root),this._register((0,s.toDisposable)(()=>T.removeChild(this.elements.root))),this.modeToggle=this._register(new Q({...d,isChecked:P===me.Filter})),this.onDidChangeMode=c.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?me.Filter:me.Highlight,this._store),this.findInput=this._register(new y.FindInput(this.elements.findInput,j,{label:(0,_.localize)(3,null),additionalToggles:[this.modeToggle],showCommonFindToggles:!1})),this.actionbar=this._register(new H.ActionBar(this.elements.actionbar)),this.mode=P;const F=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(c.Event.chain(F.event)).map(R=>new B.StandardKeyboardEvent(R)).event;this._register(U(R=>{switch(R.keyCode){case 18:R.preventDefault(),R.stopPropagation(),this.tree.domFocus();return}}));const $=this._register(new o.Action("close",(0,_.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push($,{icon:!0,label:!1});const X=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(X.event(R=>{const W=new s.DisposableStore,C=W.add(new i.DomEmitter(window,"mousemove")),k=W.add(new i.DomEmitter(window,"mouseup")),M=this.right,O=R.pageX,K=this.top,J=R.pageY;this.elements.grab.classList.add("grabbing");const ue=this.elements.root.style.transition;this.elements.root.style.transition="unset";const he=De=>{const Ee=De.pageX-O;this.right=M-Ee;const Ne=De.pageY-J;this.top=K+Ne,this.layout()};W.add(C.event(he)),W.add(k.event(De=>{he(De),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=ue,W.dispose()}))}));const N=this._register(c.Event.chain(this._register(new i.DomEmitter(this.elements.grab,"keydown")).event)).map(R=>new B.StandardKeyboardEvent(R)).event;this._register(N(R=>{let W,C;if(R.keyCode===15?W=Number.POSITIVE_INFINITY:R.keyCode===17?W=0:R.keyCode===10&&(W=this.right===0?Number.POSITIVE_INFINITY:0),R.keyCode===16?C=0:R.keyCode===18&&(C=Number.POSITIVE_INFINITY),W!==void 0&&(R.preventDefault(),R.stopPropagation(),this.right=W,this.layout()),C!==void 0){R.preventDefault(),R.stopPropagation(),this.top=C;const k=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=k},0)}})),this.onDidChangeValue=this.findInput.onDidChange,this.style(d??{})}style(T){this.findInput.style(T),T.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=T.listFilterWidgetBackground.toString()),T.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${T.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(T=this.width){this.width=T,this.right=(0,l.clamp)(this.right,0,Math.max(0,T-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,l.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(T){this.findInput.showMessage(T)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class fe{get pattern(){return this._pattern}get mode(){return this._mode}set mode(T){T!==this._mode&&(this._mode=T,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(T))}constructor(T,V,j,P,d){this.tree=T,this.view=j,this.filter=P,this.contextViewProvider=d,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new c.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new c.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new c.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new s.DisposableStore,this.disposables=new s.DisposableStore,this._mode=T.options.defaultFindMode??me.Highlight,V.onDidSplice(this.onDidSpliceModel,this,this.disposables)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.mode=this.tree.options.defaultFindMode??me.Highlight,this.widget=new ae(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(T=>this.mode=T,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new s.DisposableStore,this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(T){this._pattern=T,this._onDidChangePattern.fire(T),this.filter.pattern=T,this.tree.refilter(),T&&this.tree.focusNext(0,!0,void 0,j=>!m.FuzzyScore.isDefault(j.filterData));const V=this.tree.getFocus();if(V.length>0){const j=V[0];this.tree.getRelativeTop(j)===null&&this.tree.reveal(j,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const T=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&T?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,_.localize)(5,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(T){return!this.widget||!this.pattern||this._mode===me.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!m.FuzzyScore.isDefault(T.filterData)}style(T){this.styles=T,this.widget?.style(T)}layout(T){this.width=T,this.widget?.layout(T)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function le(ne){let T=I.TreeMouseEventTarget.Unknown;return(0,w.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?T=I.TreeMouseEventTarget.Twistie:(0,w.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?T=I.TreeMouseEventTarget.Element:(0,w.hasParentWithClass)(ne.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(T=I.TreeMouseEventTarget.Filter),{browserEvent:ne.browserEvent,element:ne.element?ne.element.element:null,target:T}}function de(ne){return{element:ne.element?ne.element.element:null,browserEvent:ne.browserEvent,anchor:ne.anchor}}function Se(ne,T){T(ne),ne.children.forEach(V=>Se(V,T))}class ee{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(T,V){this.getFirstViewElementWithTrait=T,this.identityProvider=V,this.nodes=[],this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event}set(T,V){!V?.__forceEvent&&(0,n.equals)(this.nodes,T)||this._set(T,!1,V)}_set(T,V,j){if(this.nodes=[...T],this.elements=void 0,this._nodeSet=void 0,!V){const P=this;this._onDidChange.fire({get elements(){return P.get()},browserEvent:j})}}get(){return this.elements||(this.elements=this.nodes.map(T=>T.element)),[...this.elements]}getNodes(){return this.nodes}has(T){return this.nodeSet.has(T)}onDidModelSplice({insertedNodes:T,deletedNodes:V}){if(!this.identityProvider){const $=this.createNodeSet(),X=N=>$.delete(N);V.forEach(N=>Se(N,X)),this.set([...$.values()]);return}const j=new Set,P=$=>j.add(this.identityProvider.getId($.element).toString());V.forEach($=>Se($,P));const d=new Map,F=$=>d.set(this.identityProvider.getId($.element).toString(),$);T.forEach($=>Se($,F));const U=[];for(const $ of this.nodes){const X=this.identityProvider.getId($.element).toString();if(!j.has(X))U.push($);else{const R=d.get(X);R&&U.push(R)}}if(this.nodes.length>0&&U.length===0){const $=this.getFirstViewElementWithTrait();$&&U.push($)}this._set(U,!0)}createNodeSet(){const T=new Set;for(const V of this.nodes)T.add(V);return T}}class ye extends h.MouseController{constructor(T,V){super(T),this.tree=V}onViewPointer(T){if((0,h.isButton)(T.browserEvent.target)||(0,h.isInputElement)(T.browserEvent.target)||(0,h.isMonacoEditor)(T.browserEvent.target))return;const V=T.element;if(!V)return super.onViewPointer(T);if(this.isSelectionRangeChangeEvent(T)||this.isSelectionSingleChangeEvent(T))return super.onViewPointer(T);const j=T.browserEvent.target,P=j.classList.contains("monaco-tl-twistie")||j.classList.contains("monaco-icon-label")&&j.classList.contains("folder-icon")&&T.browserEvent.offsetX<16;let d=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?d=this.tree.expandOnlyOnTwistieClick(V.element):d=!!this.tree.expandOnlyOnTwistieClick,d&&!P&&T.browserEvent.detail!==2)return super.onViewPointer(T);if(!this.tree.expandOnDoubleClick&&T.browserEvent.detail===2)return super.onViewPointer(T);if(V.collapsible){const F=this.tree.model,U=F.getNodeLocation(V),$=T.browserEvent.altKey;if(this.tree.setFocus([U]),F.setCollapsed(U,void 0,$),d&&P)return}super.onViewPointer(T)}onDoubleClick(T){T.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(T)}}class se extends h.List{constructor(T,V,j,P,d,F,U,$){super(T,V,j,P,$),this.focusTrait=d,this.selectionTrait=F,this.anchorTrait=U}createMouseController(T){return new ye(this,T.tree)}splice(T,V,j=[]){if(super.splice(T,V,j),j.length===0)return;const P=[],d=[];let F;j.forEach((U,$)=>{this.focusTrait.has(U)&&P.push(T+$),this.selectionTrait.has(U)&&d.push(T+$),this.anchorTrait.has(U)&&(F=T+$)}),P.length>0&&super.setFocus((0,n.distinct)([...super.getFocus(),...P])),d.length>0&&super.setSelection((0,n.distinct)([...super.getSelection(),...d])),typeof F=="number"&&super.setAnchor(F)}setFocus(T,V,j=!1){super.setFocus(T,V),j||this.focusTrait.set(T.map(P=>this.element(P)),V)}setSelection(T,V,j=!1){super.setSelection(T,V),j||this.selectionTrait.set(T.map(P=>this.element(P)),V)}setAnchor(T,V=!1){super.setAnchor(T),V||(typeof T>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(T)]))}}class te{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return c.Event.map(this.view.onMouseClick,le)}get onMouseDblClick(){return c.Event.filter(c.Event.map(this.view.onMouseDblClick,le),T=>T.target!==I.TreeMouseEventTarget.Filter)}get onContextMenu(){return c.Event.map(this.view.onContextMenu,de)}get onTap(){return c.Event.map(this.view.onTap,le)}get onPointer(){return c.Event.map(this.view.onPointer,le)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return c.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??me.Highlight}set findMode(T){this.findController&&(this.findController.mode=T)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:c.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(T,V,j,P,d={}){this._user=T,this._options=d,this.eventBufferer=new c.EventBufferer,this.onDidChangeFindOpenState=c.Event.None,this.disposables=new s.DisposableStore,this._onWillRefilter=new c.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new c.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const F=new E(j),U=new c.Relay,$=new c.Relay,X=this.disposables.add(new z($.event)),N=new a.SetMap;this.renderers=P.map(C=>new x(C,()=>this.model,U.event,X,N,d));for(const C of this.renderers)this.disposables.add(C);let R;d.keyboardNavigationLabelProvider&&(R=new ie(this,d.keyboardNavigationLabelProvider,d.filter),d={...d,filter:R},this.disposables.add(R)),this.focus=new ee(()=>this.view.getFocusedElements()[0],d.identityProvider),this.selection=new ee(()=>this.view.getSelectedElements()[0],d.identityProvider),this.anchor=new ee(()=>this.view.getAnchorElement(),d.identityProvider),this.view=new se(T,V,F,this.renderers,this.focus,this.selection,this.anchor,{...u(()=>this.model,d),tree:this}),this.model=this.createModel(T,this.view,d),U.input=this.model.onDidChangeCollapseState;const W=c.Event.forEach(this.model.onDidSplice,C=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(C),this.selection.onDidModelSplice(C)})},this.disposables);if(W(()=>null,null,this.disposables),$.input=c.Event.chain(c.Event.any(W,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const C=new Set;for(const k of this.focus.getNodes())C.add(k);for(const k of this.selection.getNodes())C.add(k);return[...C.values()]}).event,d.keyboardSupport!==!1){const C=c.Event.chain(this.view.onKeyDown).filter(k=>!(0,h.isInputElement)(k.target)).map(k=>new B.StandardKeyboardEvent(k));C.filter(k=>k.keyCode===15).on(this.onLeftArrow,this,this.disposables),C.filter(k=>k.keyCode===17).on(this.onRightArrow,this,this.disposables),C.filter(k=>k.keyCode===10).on(this.onSpace,this,this.disposables)}(d.findWidgetEnabled??!0)&&d.keyboardNavigationLabelProvider&&d.contextViewProvider?(this.findController=new fe(this,this.model,this.view,R,d.contextViewProvider),this.focusNavigationFilter=C=>this.findController.shouldAllowFocus(C),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=c.Event.None,this.styleElement=(0,w.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===D.Always)}updateOptions(T={}){this._options={...this._options,...T};for(const V of this.renderers)V.updateOptions(T);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===D.Always)}get options(){return this._options}updateWidth(T){const V=this.model.getListIndex(T);V!==-1&&this.view.updateWidth(V)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(T){this.view.scrollTop=T}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(T){this.view.scrollLeft=T}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const T=this.view.firstVisibleIndex;return T<0||T>=this.view.length?void 0:this.view.element(T).element}get lastVisibleElement(){const T=this.view.lastVisibleIndex;return this.view.element(T).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(T){this.view.ariaLabel=T}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(T,V){this.view.layout(T,V),(0,p.isNumber)(V)&&this.findController?.layout(V)}style(T){const V=`.${this.view.domId}`,j=[];T.treeIndentGuidesStroke&&(j.push(`.monaco-list${V}:hover .monaco-tl-indent > .indent-guide, .monaco-list${V}.always .monaco-tl-indent > .indent-guide  { border-color: ${T.treeIndentGuidesStroke.transparent(.4)}; }`),j.push(`.monaco-list${V} .monaco-tl-indent > .indent-guide.active { border-color: ${T.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=j.join(`
`),this.findController?.style(T),this.view.style(T)}getParentElement(T){const V=this.model.getParentNodeLocation(T);return this.model.getNode(V).element}getFirstElementChild(T){return this.model.getFirstElementChild(T)}getNode(T){return this.model.getNode(T)}collapse(T,V=!1){return this.model.setCollapsed(T,!0,V)}expand(T,V=!1){return this.model.setCollapsed(T,!1,V)}toggleCollapsed(T,V=!1){return this.model.setCollapsed(T,void 0,V)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(T){return this.model.isCollapsible(T)}setCollapsible(T,V){return this.model.setCollapsible(T,V)}isCollapsed(T){return this.model.isCollapsed(T)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(T){if(typeof T>"u")return this.view.setAnchor(void 0);const V=this.model.getNode(T);this.anchor.set([V]);const j=this.model.getListIndex(T);j>-1&&this.view.setAnchor(j,!0)}getAnchor(){return(0,n.firstOrDefault)(this.anchor.get(),void 0)}setSelection(T,V){const j=T.map(d=>this.model.getNode(d));this.selection.set(j,V);const P=T.map(d=>this.model.getListIndex(d)).filter(d=>d>-1);this.view.setSelection(P,V,!0)}getSelection(){return this.selection.get()}setFocus(T,V){const j=T.map(d=>this.model.getNode(d));this.focus.set(j,V);const P=T.map(d=>this.model.getListIndex(d)).filter(d=>d>-1);this.view.setFocus(P,V,!0)}focusNext(T=1,V=!1,j,P=this.focusNavigationFilter){this.view.focusNext(T,V,j,P)}focusPrevious(T=1,V=!1,j,P=this.focusNavigationFilter){this.view.focusPrevious(T,V,j,P)}focusNextPage(T,V=this.focusNavigationFilter){return this.view.focusNextPage(T,V)}focusPreviousPage(T,V=this.focusNavigationFilter){return this.view.focusPreviousPage(T,V)}focusLast(T,V=this.focusNavigationFilter){this.view.focusLast(T,V)}focusFirst(T,V=this.focusNavigationFilter){this.view.focusFirst(T,V)}getFocus(){return this.focus.get()}reveal(T,V){this.model.expandTo(T);const j=this.model.getListIndex(T);j!==-1&&this.view.reveal(j,V)}getRelativeTop(T){const V=this.model.getListIndex(T);return V===-1?null:this.view.getRelativeTop(V)}getViewState(T=this.options.identityProvider){if(!T)throw new I.TreeError(this._user,"Can't get tree view state without an identity provider");const V=F=>T.getId(F).toString(),j=b.empty(this.scrollTop);for(const F of this.getFocus())j.focus.add(V(F));for(const F of this.getSelection())j.selection.add(V(F));const P=this.model.getNode(),d=[P];for(;d.length>0;){const F=d.shift();F!==P&&F.collapsible&&(j.expanded[V(F.element)]=F.collapsed?0:1),d.push(...F.children)}return j}onLeftArrow(T){T.preventDefault(),T.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],P=this.model.getNodeLocation(j);if(!this.model.setCollapsed(P,!0)){const F=this.model.getParentNodeLocation(P);if(!F)return;const U=this.model.getListIndex(F);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(T){T.preventDefault(),T.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],P=this.model.getNodeLocation(j);if(!this.model.setCollapsed(P,!1)){if(!j.children.some($=>$.visible))return;const[F]=this.view.getFocus(),U=F+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(T){T.preventDefault(),T.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],P=this.model.getNodeLocation(j),d=T.browserEvent.altKey;this.model.setCollapsed(P,void 0,d)}navigate(T){return new ce(this.view,this.model,T)}dispose(){(0,s.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=te;class ce{constructor(T,V,j){this.view=T,this.model=V,j?this.index=this.model.getListIndex(j):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(pe[129],be([1,0,128,118,23,26]),function(Z,t,w,i,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends w.AbstractTree{constructor(h,g,f,I,o,n={}){super(h,g,f,I,n),this.user=h,this.dataSource=o,this.nodesByIdentity=new Map,this.identityProvider=n.identityProvider}getInput(){return this.input}setInput(h,g){if(g&&!this.identityProvider)throw new B.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=h,!h){this.nodesByIdentity.clear(),this.model.setChildren(null,H.Iterable.empty());return}if(!g){this._refresh(h);return}const f=[],I=[],o=e=>{const r=this.identityProvider.getId(e).toString();return!g.expanded[r]},n=e=>{const r=this.identityProvider.getId(e.element).toString();g.focus.has(r)&&f.push(e.element),g.selection.has(r)&&I.push(e.element)};this._refresh(h,o,n),this.setFocus(f),this.setSelection(I),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(h=this.input){if(typeof this.input>"u")throw new B.TreeError(this.user,"Tree input not set");let g;this.identityProvider&&(g=f=>{const I=this.identityProvider.getId(f).toString(),o=this.nodesByIdentity.get(I);if(!!o)return o.collapsed}),this._refresh(h,g)}resort(h=this.input,g=!0){this.model.resort(h===this.input?null:h,g)}refresh(h){if(h===void 0){this.view.rerender();return}this.model.rerender(h)}_refresh(h,g,f){let I;if(this.identityProvider){const o=new Set,n=f;f=e=>{const r=this.identityProvider.getId(e.element).toString();o.add(r),this.nodesByIdentity.set(r,e),n?.(e)},I=e=>{const r=this.identityProvider.getId(e.element).toString();o.has(r)||this.nodesByIdentity.delete(r)}}this.model.setChildren(h===this.input?null:h,this.iterate(h,g).elements,{onDidCreateNode:f,onDidDeleteNode:I})}iterate(h,g){const f=[...this.dataSource.getChildren(h)];return{elements:H.Iterable.map(f,o=>{const{elements:n,size:e}=this.iterate(o,g),r=this.dataSource.hasChildren?this.dataSource.hasChildren(o):void 0,a=e===0?void 0:g&&g(o);return{element:o,children:n,collapsible:r,collapsed:a}}),size:f.length}}createModel(h,g,f){return new i.ObjectTreeModel(h,g,f)}}t.DataTree=y}),define(pe[38],be([1,0,14,8,31,28,25,9,3,2,50,11,6]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var n;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(n=t.RequestType||(t.RequestType={}));function e(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var r;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(r=t.ResponseType||(t.ResponseType={}));function a(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(c||(c={}));class m{constructor(te){this.buffer=te,this.pos=0}read(te){const ce=this.buffer.slice(this.pos,this.pos+te);return this.pos+=ce.byteLength,ce}}class s{constructor(){this.buffers=[]}get buffer(){return B.VSBuffer.concat(this.buffers)}write(te){this.buffers.push(te)}}var l;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object"})(l||(l={}));function p(se){const te=B.VSBuffer.alloc(4);return te.writeUInt32BE(se,0),te}function _(se){return se.read(4).readUInt32BE(0)}function L(se){const te=B.VSBuffer.alloc(1);return te.writeUInt8(se,0),te}const S={Undefined:L(l.Undefined),String:L(l.String),Buffer:L(l.Buffer),VSBuffer:L(l.VSBuffer),Array:L(l.Array),Object:L(l.Object)},A=typeof Buffer<"u";function u(se,te){if(typeof te>"u")se.write(S.Undefined);else if(typeof te=="string"){const ce=B.VSBuffer.fromString(te);se.write(S.String),se.write(p(ce.byteLength)),se.write(ce)}else if(A&&Buffer.isBuffer(te)){const ce=B.VSBuffer.wrap(te);se.write(S.Buffer),se.write(p(ce.byteLength)),se.write(ce)}else if(te instanceof B.VSBuffer)se.write(S.VSBuffer),se.write(p(te.byteLength)),se.write(te);else if(Array.isArray(te)){se.write(S.Array),se.write(p(te.length));for(const ce of te)u(se,ce)}else{const ce=B.VSBuffer.fromString(JSON.stringify(te));se.write(S.Object),se.write(p(ce.byteLength)),se.write(ce)}}function E(se){switch(se.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return se.read(_(se)).toString();case l.Buffer:return se.read(_(se)).buffer;case l.VSBuffer:return se.read(_(se));case l.Array:{const ce=_(se),ne=[];for(let T=0;T<ce;T++)ne.push(E(se));return ne}case l.Object:return JSON.parse(se.read(_(se)).toString())}}class b{constructor(te,ce,ne=null,T=1e3){this.protocol=te,this.ctx=ce,this.logger=ne,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(te,ce){this.channels.set(te,ce),setTimeout(()=>this.flushPendingRequests(te),0)}sendResponse(te){switch(te.type){case 200:{const ce=this.send([te.type]);this.logger?.logOutgoing(ce,0,1,a(te.type));return}case 201:case 202:case 204:case 203:{const ce=this.send([te.type,te.id],te.data);this.logger?.logOutgoing(ce,te.id,1,a(te.type),te.data);return}}}send(te,ce=void 0){const ne=new s;return u(ne,te),u(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(te){try{return this.protocol.send(te),te.byteLength}catch{return 0}}onRawMessage(te){const ce=new m(te),ne=E(ce),T=E(ce),V=ne[0];switch(V){case 100:return this.logger?.logIncoming(te.byteLength,ne[1],1,`${e(V)}: ${ne[2]}.${ne[3]}`,T),this.onPromise({type:V,id:ne[1],channelName:ne[2],name:ne[3],arg:T});case 102:return this.logger?.logIncoming(te.byteLength,ne[1],1,`${e(V)}: ${ne[2]}.${ne[3]}`,T),this.onEventListen({type:V,id:ne[1],channelName:ne[2],name:ne[3],arg:T});case 101:return this.logger?.logIncoming(te.byteLength,ne[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:ne[1]});case 103:return this.logger?.logIncoming(te.byteLength,ne[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:ne[1]})}}onPromise(te){const ce=this.channels.get(te.channelName);if(!ce){this.collectPendingRequest(te);return}const ne=new H.CancellationTokenSource;let T;try{T=ce.call(this.ctx,te.name,te.arg,ne.token)}catch(P){T=Promise.reject(P)}const V=te.id;T.then(P=>{this.sendResponse({id:V,data:P,type:201}),this.activeRequests.delete(te.id)},P=>{P instanceof Error?this.sendResponse({id:V,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.sendResponse({id:V,data:P,type:203}),this.activeRequests.delete(te.id)});const j=(0,g.toDisposable)(()=>ne.cancel());this.activeRequests.set(te.id,j)}onEventListen(te){const ce=this.channels.get(te.channelName);if(!ce){this.collectPendingRequest(te);return}const ne=te.id,V=ce.listen(this.ctx,te.name,te.arg)(j=>this.sendResponse({id:ne,data:j,type:204}));this.activeRequests.set(te.id,V)}disposeActiveRequest(te){const ce=this.activeRequests.get(te.id);ce&&(ce.dispose(),this.activeRequests.delete(te.id))}collectPendingRequest(te){let ce=this.pendingRequests.get(te.channelName);ce||(ce=[],this.pendingRequests.set(te.channelName,ce));const ne=setTimeout(()=>{console.error(`Unknown channel: ${te.channelName}`),te.type===100&&this.sendResponse({id:te.id,data:{name:"Unknown channel",message:`Channel name '${te.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ce.push({request:te,timeoutTimer:ne})}flushPendingRequests(te){const ce=this.pendingRequests.get(te);if(ce){for(const ne of ce)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(te)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=b;var D;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(D=t.RequestInitiator||(t.RequestInitiator={}));class z{constructor(te,ce=null){this.protocol=te,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=ce}getChannel(te){const ce=this;return{call(ne,T,V){return ce.isDisposed?Promise.reject(new v.CancellationError):ce.requestPromise(te,ne,T,V)},listen(ne,T){return ce.isDisposed?h.Event.None:ce.requestEvent(te,ne,T)}}}requestPromise(te,ce,ne,T=H.CancellationToken.None){const V=this.lastRequestId++,P={id:V,type:100,channelName:te,name:ce,arg:ne};if(T.isCancellationRequested)return Promise.reject(new v.CancellationError);let d;return new Promise((U,$)=>{if(T.isCancellationRequested)return $(new v.CancellationError);const X=()=>{const C=k=>{switch(k.type){case 201:this.handlers.delete(V),U(k.data);break;case 202:{this.handlers.delete(V);const M=new Error(k.data.message);M.stack=k.data.stack,M.name=k.data.name,$(M);break}case 203:this.handlers.delete(V),$(k.data);break}};this.handlers.set(V,C),this.sendRequest(P)};let N=null;this.state===c.Idle?X():(N=(0,i.createCancelablePromise)(C=>this.whenInitialized()),N.then(()=>{N=null,X()}));const R=()=>{N?(N.cancel(),N=null):this.sendRequest({id:V,type:101}),$(new v.CancellationError)},W=T.onCancellationRequested(R);d=(0,g.combinedDisposable)((0,g.toDisposable)(R),W),this.activeRequests.add(d)}).finally(()=>{this.activeRequests.delete(d)})}requestEvent(te,ce,ne){const T=this.lastRequestId++,j={id:T,type:102,channelName:te,name:ce,arg:ne};let P=null;const d=new h.Emitter({onFirstListenerAdd:()=>{P=(0,i.createCancelablePromise)(U=>this.whenInitialized()),P.then(()=>{P=null,this.activeRequests.add(d),this.sendRequest(j)})},onLastListenerRemove:()=>{P?(P.cancel(),P=null):(this.activeRequests.delete(d),this.sendRequest({id:T,type:103}))}}),F=U=>d.fire(U.data);return this.handlers.set(T,F),d.event}sendRequest(te){switch(te.type){case 100:case 102:{const ce=this.send([te.type,te.id,te.channelName,te.name],te.arg);this.logger?.logOutgoing(ce,te.id,0,`${e(te.type)}: ${te.channelName}.${te.name}`,te.arg);return}case 101:case 103:{const ce=this.send([te.type,te.id]);this.logger?.logOutgoing(ce,te.id,0,e(te.type));return}}}send(te,ce=void 0){const ne=new s;return u(ne,te),u(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(te){try{return this.protocol.send(te),te.byteLength}catch{return 0}}onBuffer(te){const ce=new m(te),ne=E(ce),T=E(ce),V=ne[0];switch(V){case 200:return this.logger?.logIncoming(te.byteLength,0,0,a(V)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(te.byteLength,ne[1],0,a(V),T),this.onResponse({type:ne[0],id:ne[1],data:T})}}onResponse(te){if(te.type===200){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(te.id)?.(te)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}xe([y.memoize],z.prototype,"onDidInitializePromise",null),t.ChannelClient=z;class x{get connections(){const te=[];return this._connections.forEach(ce=>te.push(ce)),te}constructor(te){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,te(({protocol:ce,onDidClientDisconnect:ne})=>{h.Event.once(ce.onMessage)(V=>{const j=new m(V),P=E(j),d=new b(ce,P),F=new z(ce);this.channels.forEach(($,X)=>d.registerChannel(X,$));const U={channelServer:d,channelClient:F,ctx:P};this._connections.add(U),this._onDidAddConnection.fire(U),ne(()=>{d.dispose(),F.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}getChannel(te,ce){const ne=this;return{call(T,V,j){let P;if((0,o.isFunction)(ce)){const F=(0,w.getRandomElement)(ne.connections.filter(ce));P=F?Promise.resolve(F):h.Event.toPromise(h.Event.filter(ne.onDidAddConnection,ce))}else P=ce.routeCall(ne,T,V);const d=P.then(F=>F.channelClient.getChannel(te));return Q(d).call(T,V,j)},listen(T,V){if((0,o.isFunction)(ce))return ne.getMulticastEvent(te,ce,T,V);const j=ce.routeEvent(ne,T,V).then(P=>P.channelClient.getChannel(te));return Q(j).listen(T,V)}}}getMulticastEvent(te,ce,ne,T){const V=this;let j=new g.DisposableStore;const P=new h.Emitter({onFirstListenerAdd:()=>{j=new g.DisposableStore;const d=new h.EventMultiplexer,F=new Map,U=X=>{const R=X.channelClient.getChannel(te).listen(ne,T),W=d.add(R);F.set(X,W)},$=X=>{const N=F.get(X);!N||(N.dispose(),F.delete(X))};V.connections.filter(ce).forEach(U),h.Event.filter(V.onDidAddConnection,ce)(U,void 0,j),V.onDidRemoveConnection($,void 0,j),d.event(P.fire,P,j),j.add(d)},onLastListenerRemove:()=>{j.dispose()}});return P.event}registerChannel(te,ce){this.channels.set(te,ce),this._connections.forEach(ne=>{ne.channelServer.registerChannel(te,ce)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=x;class ie{constructor(te,ce,ne=null){const T=new s;u(T,ce),te.send(T.buffer),this.channelClient=new z(te,ne),this.channelServer=new b(te,ce,ne)}getChannel(te){return this.channelClient.getChannel(te)}registerChannel(te,ce){this.channelServer.registerChannel(te,ce)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ie;function Q(se){return{call(te,ce,ne){return se.then(T=>T.call(te,ce,ne))},listen(te,ce){const ne=new h.Relay;return se.then(T=>ne.input=T.listen(te,ce)),ne.event}}}t.getDelayedChannel=Q;function me(se){let te=!1;return{call(ce,ne,T){return te?se.call(ce,ne,T):(0,i.timeout)(0).then(()=>te=!0).then(()=>se.call(ce,ne,T))},listen(ce,ne){if(te)return se.listen(ce,ne);const T=new h.Relay;return(0,i.timeout)(0).then(()=>te=!0).then(()=>T.input=se.listen(ce,ne)),T.event}}}t.getNextTickChannel=me;class ae{constructor(te){this.fn=te}routeCall(te){return this.route(te)}routeEvent(te){return this.route(te)}async route(te){for(const ce of te.connections)if(await Promise.resolve(this.fn(ce.ctx)))return Promise.resolve(ce);return await h.Event.toPromise(te.onDidAddConnection),await this.route(te)}}t.StaticRouter=ae;var fe;(function(se){function te(V,j){const P=V,d=j&&j.disableMarshalling,F=new Map;for(const U in P)ne(U)&&F.set(U,h.Event.buffer(P[U],!0));return new class{listen(U,$,X){const N=F.get($);if(N)return N;if(T($)){const R=P[$];if(typeof R=="function")return R.call(P,X)}throw new Error(`Event not found: ${$}`)}call(U,$,X){const N=P[$];if(typeof N=="function"){if(!d&&Array.isArray(X))for(let R=0;R<X.length;R++)X[R]=(0,f.revive)(X[R]);return N.apply(P,X)}throw new Error(`Method not found: ${$}`)}}}se.fromService=te;function ce(V,j){const P=j&&j.disableMarshalling;return new Proxy({},{get(d,F){if(typeof F=="string")return j?.properties?.has(F)?j.properties.get(F):T(F)?function(U){return V.listen(F,U)}:ne(F)?V.listen(F):async function(...U){let $;j&&!(0,o.isUndefinedOrNull)(j.context)?$=[j.context,...U]:$=U;const X=await V.call(F,$);return P?X:(0,f.revive)(X)};throw new Error(`Property not found: ${String(F)}`)}})}se.toService=ce;function ne(V){return V[0]==="o"&&V[1]==="n"&&I.isUpperAsciiLetter(V.charCodeAt(2))}function T(V){return/^onDynamic/.test(V)&&I.isUpperAsciiLetter(V.charCodeAt(9))}})(fe=t.ProxyChannel||(t.ProxyChannel={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const te=se.toString();if(te!=="[object Object]")return te}return se}function Se(se){return Array.isArray(se)?se.map(de):de(se)}function ee(se,te,ce,ne,T,V,j){j=Se(j);const P=le[T],d=P[ne%P.length];let F=[`%c[${se}]%c[${String(te).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(V)?(F=F.concat(j),F.push(")")):F.push(j),console.log.apply(console,F)}t.logWithColors=ee;class ye{constructor(te,ce){this._outgoingPrefix=te,this._incomingPrefix=ce,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(te,ce,ne,T,V){this._totalOutgoing+=te,ee(this._outgoingPrefix,this._totalOutgoing,te,ce,ne,T,V)}logIncoming(te,ce,ne,T,V){this._totalIncoming+=te,ee(this._incomingPrefix,this._totalIncoming,te,ce,ne,T,V)}}t.IPCLogger=ye}),define(pe[29],be([1,0,5]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=w.globals.vscode.ipcRenderer,t.ipcMessagePort=w.globals.vscode.ipcMessagePort,t.webFrame=w.globals.vscode.webFrame,t.process=w.globals.vscode.process,t.context=w.globals.vscode.context}),define(pe[130],be([1,0,80,29]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let B=0;function H(v,h,g){const f=[],I=B++,o=`vscode:onContextMenu${I}`,n=(e,r,a)=>{f[r].click?.(a)};i.ipcRenderer.once(o,n),i.ipcRenderer.once(w.CONTEXT_MENU_CLOSE_CHANNEL,(e,r)=>{r===I&&(i.ipcRenderer.removeListener(o,n),g?.())}),i.ipcRenderer.send(w.CONTEXT_MENU_CHANNEL,I,v.map(e=>y(e,f)),o,h)}t.popup=H;function y(v,h){const g={id:h.length,label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:typeof v.enabled=="boolean"?v.enabled:!0,visible:typeof v.visible=="boolean"?v.visible:!0};return h.push(v),Array.isArray(v.submenu)&&(g.submenu=v.submenu.map(f=>y(f,h))),g}}),define(pe[131],be([1,0,31,3,38,81,29]),function(Z,t,w,i,B,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class v extends B.IPCClient{static createProtocol(){const g=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(f,I)=>w.VSBuffer.wrap(I));return y.ipcRenderer.send("vscode:hello"),new H.Protocol(y.ipcRenderer,g)}constructor(g){const f=v.createProtocol();super(f,g),this.protocol=f}dispose(){this.protocol.disconnect()}}t.Client=v}),define(pe[132],be([13,10]),function(Z,t){return Z.create("vs/platform/files/common/files",t)}),define(pe[133],be([13,10]),function(Z,t){return Z.create("vs/platform/theme/common/iconRegistry",t)}),define(pe[64],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class w{constructor(B,H=[],y=!1){this.ctor=B,this.staticArguments=H,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=w}),define(pe[134],be([1,0,64]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var B;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(B=t.InstantiationType||(t.InstantiationType={}));function H(v,h,g){h instanceof w.SyncDescriptor||(h=new w.SyncDescriptor(h,[],Boolean(g))),i.push([v,h])}t.registerSingleton=H;function y(){return i}t.getSingletonServiceDescriptors=y}),define(pe[30],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var w;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function v(h){return h[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=v})(w=t._util||(t._util={})),t.IInstantiationService=B("instantiationService");function i(y,v,h){v[w.DI_TARGET]===v?v[w.DI_DEPENDENCIES].push({id:y,index:h}):(v[w.DI_DEPENDENCIES]=[{id:y,index:h}],v[w.DI_TARGET]=v)}function B(y){if(w.serviceIds.has(y))return w.serviceIds.get(y);const v=function(h,g,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(v,h,f)};return v.toString=()=>y,w.serviceIds.set(y,v),v}t.createDecorator=B;function H(y){return y}t.refineServiceDecorator=H}),define(pe[135],be([1,0,30]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,w.createDecorator)(t.ID);function i(H){return!!H.hostName&&!!H.errorMessage}t.isRemoteDiagnosticError=i;class B{async getPerformanceInfo(y,v){return{}}async getSystemInfo(y,v){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,v){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=B}),define(pe[136],be([1,0,112,21,11,6,15,132,30]),function(Z,t,w,i,B,H,y,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,h.createDecorator)("fileService");function g(ee){return ee.create===!0}t.isFileOpenForWriteOptions=g;var f;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(f=t.FileType||(t.FileType={}));var I;(function(ee){ee[ee.Readonly=1]="Readonly"})(I=t.FilePermission||(t.FilePermission={}));var o;(function(ee){ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileClone=32768]="FileClone"})(o=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(ee){return!!(ee.capabilities&2)}t.hasReadWriteCapability=n;function e(ee){return!!(ee.capabilities&8)}t.hasFileFolderCopyCapability=e;function r(ee){return!!(ee.capabilities&32768)}t.hasFileCloneCapability=r;function a(ee){return!!(ee.capabilities&4)}t.hasOpenReadWriteCloseCapability=a;function c(ee){return!!(ee.capabilities&16)}t.hasFileReadStreamCapability=c;function m(ee){return n(ee)?!!(ee.capabilities&16384):!1}t.hasFileAtomicReadCapability=m;var s;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(s=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class l extends Error{constructor(ye,se){super(ye),this.code=se}}t.FileSystemProviderError=l;function p(ee,ye){const se=new l(ee.toString(),ye);return L(se,ye),se}t.createFileSystemProviderError=p;function _(ee){return ee||p((0,v.localize)(0,null),s.Unknown)}t.ensureFileSystemProviderError=_;function L(ee,ye){return ee.name=ye?`${ye} (FileSystemError)`:"FileSystemError",ee}t.markAsFileSystemProviderError=L;function S(ee){if(!ee)return s.Unknown;if(ee instanceof l)return ee.code;const ye=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ye)return s.Unknown;switch(ye[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileExceedsMemoryLimit:return s.FileExceedsMemoryLimit;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}t.toFileSystemProviderErrorCode=S;function A(ee){if(ee instanceof x)return ee.fileOperationResult;switch(S(ee)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 10;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileExceedsMemoryLimit:return 9;case s.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=A;var u;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(u=t.FileOperation||(t.FileOperation={}));class E{constructor(ye,se,te){this.resource=ye,this.operation=se,this.target=te}isOperation(ye){return this.operation===ye}}t.FileOperationEvent=E;var b;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(b=t.FileChangeType||(t.FileChangeType={}));class D{constructor(ye,se){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ye;const te=new Map;for(const ce of ye){const ne=te.get(ce.type);switch(ne?ne.push([ce.resource,ce]):te.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,ne]of te)switch(ce){case 1:this.added=w.TernarySearchTree.forUris(()=>se),this.added.fill(ne);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>se),this.updated.fill(ne);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>se),this.deleted.fill(ne);break}}contains(ye,...se){return this.doContains(ye,{includeChildren:!1},...se)}affects(ye,...se){return this.doContains(ye,{includeChildren:!0},...se)}doContains(ye,se,...te){if(!ye)return!1;const ce=te.length>0;return!!((!ce||te.includes(1))&&(this.added?.get(ye)||se.includeChildren&&this.added?.findSuperstr(ye))||(!ce||te.includes(0))&&(this.updated?.get(ye)||se.includeChildren&&this.updated?.findSuperstr(ye))||(!ce||te.includes(2))&&(this.deleted?.findSubstr(ye)||se.includeChildren&&this.deleted?.findSuperstr(ye)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=D;function z(ee,ye,se){return!ee||!ye||ee===ye||ye.length>ee.length?!1:(ye.charAt(ye.length-1)!==i.sep&&(ye+=i.sep),se?(0,B.startsWithIgnoreCase)(ee,ye):ee.indexOf(ye)===0)}t.isParent=z;class x extends Error{constructor(ye,se,te){super(ye),this.fileOperationResult=se,this.options=te}}t.FileOperationError=x;class ie extends x{constructor(ye,se,te){super(ye,2,te),this.stat=se}}t.NotModifiedSinceFileOperationError=ie;var Q;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ee[ee.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var me;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(me=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function ae(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}t.etag=ae;async function fe(ee,ye){if(!ye.hasProvider(y.URI.from({scheme:ee.scheme})))return new Promise(se=>{const te=ye.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===ee.scheme&&ce.added&&(te.dispose(),se())})})}t.whenProviderRegistered=fe,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(ye){return(0,H.isNumber)(ye)||(ye=0),ye<le.KB?(0,v.localize)(1,null,ye.toFixed(0)):ye<le.MB?(0,v.localize)(2,null,(ye/le.KB).toFixed(2)):ye<le.GB?(0,v.localize)(3,null,(ye/le.MB).toFixed(2)):ye<le.TB?(0,v.localize)(4,null,(ye/le.GB).toFixed(2)):(0,v.localize)(5,null,(ye/le.TB).toFixed(2))}}t.ByteSize=le,le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB;var de;(function(ee){ee[ee.IA32=0]="IA32",ee[ee.OTHER=1]="OTHER"})(de=t.Arch||(t.Arch={}));function Se(ee){return{maxFileSize:ee===0?300*le.MB:16*le.GB,maxHeapSize:ee===0?700*le.MB:2*700*le.MB}}t.getPlatformLimits=Se}),define(pe[137],be([1,0,2,131]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class B extends w.Disposable{constructor(y){super(),this.mainProcessConnection=this._register(new i.Client(`window:${y}`))}getChannel(y){return this.mainProcessConnection.getChannel(y)}registerChannel(y,v){this.mainProcessConnection.registerChannel(y,v)}}t.ElectronIPCMainProcessService=B});var wt=this&&this.__param||function(Z,t){return function(w,i){t(w,i,Z)}};define(pe[138],be([1,0,38,64,134,30]),function(Z,t,w,i,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(n,e,r,a){const c=r.getChannel(n);return v(e)?a.createInstance(new i.SyncDescriptor(e.channelClientCtor,[c])):w.ProxyChannel.toService(c,e?.proxyOptions)}}function v(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,H.createDecorator)("mainProcessService");let h=class extends y{constructor(n,e,r,a){super(n,e,r,a)}};h=xe([wt(2,t.IMainProcessService),wt(3,H.IInstantiationService)],h);function g(o,n,e){(0,B.registerSingleton)(o,new i.SyncDescriptor(h,[n,e],!0))}t.registerMainProcessRemoteService=g,t.ISharedProcessService=(0,H.createDecorator)("sharedProcessService");let f=class extends y{constructor(n,e,r,a){super(n,e,r,a)}};f=xe([wt(2,t.ISharedProcessService),wt(3,H.IInstantiationService)],f);function I(o,n,e){(0,B.registerSingleton)(o,new i.SyncDescriptor(f,[n,e],!0))}t.registerSharedProcessRemoteService=I}),define(pe[139],be([1,0,38,138]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let B=class{constructor(y,v){return this.windowId=y,w.ProxyChannel.toService(v.getChannel("nativeHost"),{context:y,properties:(()=>{const h=new Map;return h.set("windowId",y),h})()})}};B=xe([wt(1,i.IMainProcessService)],B),t.NativeHostService=B}),define(pe[39],be([1,0,71,6]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class B{constructor(){this.data=new Map}add(y,v){w.ok(i.isString(y)),w.ok(i.isObject(v)),w.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,v)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}t.Registry=new B}),define(pe[140],be([1,0,3,39]),function(Z,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function B(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class H{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,g){this.schemasById[B(h)]=g,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new H;i.Registry.add(t.Extensions.JSONContribution,y)}),define(pe[141],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var w;(function(H){H.DARK="dark",H.LIGHT="light",H.HIGH_CONTRAST_DARK="hcDark",H.HIGH_CONTRAST_LIGHT="hcLight"})(w=t.ColorScheme||(t.ColorScheme={}));function i(H){return H===w.HIGH_CONTRAST_DARK||H===w.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function B(H){return H===w.DARK||H===w.HIGH_CONTRAST_DARK}t.isDark=B}),define(pe[65],be([1,0,12,3,2,30,39,141]),function(Z,t,w,i,B,H,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,H.createDecorator)("themeService");var h;(function(a){function c(m){return m&&typeof m=="object"&&typeof m.id=="string"}a.isThemeColor=c})(h=t.ThemeColor||(t.ThemeColor={}));function g(a){return{id:a}}t.themeColorFromId=g;var f;(function(a){function c(A){return A&&typeof A=="object"&&typeof A.id=="string"&&(typeof A.color>"u"||h.isThemeColor(A.color))}a.isThemeIcon=c;const m=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function s(A){const u=m.exec(A);if(!u)return;const[,E]=u;return{id:E}}a.fromString=s;function l(A){return{id:A}}a.fromId=l;function p(A,u){let E=A.id;const b=E.lastIndexOf("~");return b!==-1&&(E=E.substring(0,b)),u&&(E=`${E}~${u}`),{id:E}}a.modify=p;function _(A){const u=A.id.lastIndexOf("~");if(u!==-1)return A.id.substring(u+1)}a.getModifier=_;function L(A,u){return A.id===u.id&&A.color?.id===u.color?.id}a.isEqual=L;function S(A,u){return{id:A.id,color:u?g(u):void 0}}a.asThemeIcon=S,a.asClassNameArray=w.CSSIcon.asClassNameArray,a.asClassName=w.CSSIcon.asClassName,a.asCSSSelector=w.CSSIcon.asCSSSelector})(f=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=w.Codicon.file,t.FolderThemeIcon=w.Codicon.folder;function I(a){switch(a){case v.ColorScheme.DARK:return"vs-dark";case v.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case v.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=I,t.Extensions={ThemingContribution:"base.contributions.theming"};class o{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(c){return this.themingParticipants.push(c),this.onThemingParticipantAddedEmitter.fire(c),(0,B.toDisposable)(()=>{const m=this.themingParticipants.indexOf(c);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const n=new o;y.Registry.add(t.Extensions.ThemingContribution,n);function e(a){return n.onColorThemeChange(a)}t.registerThemingParticipant=e;class r extends B.Disposable{constructor(c){super(),this.themeService=c,this.theme=c.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(c){this.theme=c,this.updateStyles()}updateStyles(){}getColor(c,m){let s=this.theme.getColor(c);return s&&m&&(s=m(s,this.theme)),s?s.toString():null}}t.Themable=r}),define(pe[142],be([1,0,8,12,3,6,15,133,140,39,65]),function(Z,t,w,i,B,H,y,v,h,g,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var I;(function(l){function p(_,L){let S=_.defaults;for(;f.ThemeIcon.isThemeIcon(S);){const A=e.getIcon(S.id);if(!A)return;S=A.defaults}return S}l.getDefinition=p})(I=t.IconContribution||(t.IconContribution={}));var o;(function(l){function p(L){return{weight:L.weight,style:L.style,src:L.src.map(S=>({format:S.format,location:S.location.toString()}))}}l.toJSONObject=p;function _(L){const S=A=>(0,H.isString)(A)?A:void 0;if(L&&Array.isArray(L.src)&&L.src.every(A=>(0,H.isString)(A.format)&&(0,H.isString)(A.location)))return{weight:S(L.weight),style:S(L.style),src:L.src.map(A=>({format:A.format,location:y.URI.parse(A.location)}))}}l.fromJSONObject=_})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this._onDidChange=new B.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,v.localize)(0,null)},fontCharacter:{type:"string",description:(0,v.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,_,L,S){const A=this.iconsById[p];if(A){if(L&&!A.description){A.description=L,this.iconSchema.properties[p].markdownDescription=`${L} $(${p})`;const b=this.iconReferenceSchema.enum.indexOf(p);b!==-1&&(this.iconReferenceSchema.enumDescriptions[b]=L),this._onDidChange.fire()}return A}const u={id:p,description:L,defaults:_,deprecationMessage:S};this.iconsById[p]=u;const E={$ref:"#/definitions/icons"};return S&&(E.deprecationMessage=S),L&&(E.markdownDescription=`${L}: $(${p})`),this.iconSchema.properties[p]=E,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(L||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const _=this.iconReferenceSchema.enum.indexOf(p);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,_){const L=this.iconFontsById[p];return L||(this.iconFontsById[p]=_,this._onDidChange.fire(),_)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(A,u)=>A.id.localeCompare(u.id),_=A=>{for(;f.ThemeIcon.isThemeIcon(A.defaults);)A=this.iconsById[A.defaults.id];return`codicon codicon-${A?A.id:""}`},L=[];L.push("| preview     | identifier                        | default codicon ID                | description"),L.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const S=Object.keys(this.iconsById).map(A=>this.iconsById[A]);for(const A of S.filter(u=>!!u.description).sort(p))L.push(`|<i class="${_(A)}"></i>|${A.id}|${f.ThemeIcon.isThemeIcon(A.defaults)?A.defaults.id:A.id}|${A.description||""}|`);L.push("| preview     | identifier                        "),L.push("| ----------- | --------------------------------- |");for(const A of S.filter(u=>!f.ThemeIcon.isThemeIcon(u.defaults)).sort(p))L.push(`|<i class="${_(A)}"></i>|${A.id}|`);return L.join(`
`)}}const e=new n;g.Registry.add(t.Extensions.IconContribution,e);function r(l,p,_,L){return e.registerIcon(l,p,_,L)}t.registerIcon=r;function a(){return e}t.getIconRegistry=a;function c(){for(const l of i.Codicon.getAll())e.registerIcon(l.id,l.definition,l.description)}c(),t.iconsSchemaId="vscode://schemas/icons";const m=g.Registry.as(h.Extensions.JSONContribution);m.registerSchema(t.iconsSchemaId,e.getIconSchema());const s=new w.RunOnceScheduler(()=>m.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{s.isScheduled()||s.schedule()}),t.widgetClose=r("widget-close",i.Codicon.close,(0,v.localize)(2,null)),t.gotoPreviousLocation=r("goto-previous-location",i.Codicon.arrowUp,(0,v.localize)(3,null)),t.gotoNextLocation=r("goto-next-location",i.Codicon.arrowDown,(0,v.localize)(4,null)),t.syncing=f.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=f.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(pe[143],be([1,0,4,3,142,65]),function(Z,t,w,i,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(h){const g=new i.Emitter,f=(0,B.getIconRegistry)();return f.onDidChange(()=>g.fire()),h?.onDidProductIconThemeChange(()=>g.fire()),{onDidChange:g.event,getCSS(){const I=h?h.getProductIconTheme():new v,o={},n=r=>{const a=I.getIcon(r);if(!a)return;const c=a.font;return c?(o[c.id]=c.definition,`.codicon-${r.id}:before { content: '${a.fontCharacter}'; font-family: ${(0,w.asCSSPropertyValue)(c.id)}; }`):`.codicon-${r.id}:before { content: '${a.fontCharacter}'; }`},e=[];for(const r of f.getIcons()){const a=n(r);a&&e.push(a)}for(const r in o){const a=o[r],c=a.weight?`font-weight: ${a.weight};`:"",m=a.style?`font-style: ${a.style};`:"",s=a.src.map(l=>`${(0,w.asCSSUrl)(l.location)} format('${l.format}')`).join(", ");e.push(`@font-face { src: ${s}; font-family: ${(0,w.asCSSPropertyValue)(r)};${c}${m} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class v{getIcon(g){const f=(0,B.getIconRegistry)();let I=g.defaults;for(;H.ThemeIcon.isThemeIcon(I);){const o=f.getIcon(I.id);if(!o)return;I=o.defaults}return I}}t.UnthemedProductIconTheme=v}),define(pe[144],be([1,0,5]),function(Z,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(f){return!!f.workspaceUri}t.isWorkspaceToOpen=i;function B(f){return!!f.folderUri}t.isFolderToOpen=B;function H(f){return!!f.fileUri}t.isFileToOpen=H;function y(f){const I=v(f),o=f.getValue("window.menuBarVisibility");return o==="default"||I==="native"&&o==="compact"||w.isMacintosh&&w.isNative?"classic":o}t.getMenuBarVisibility=y;function v(f){if(w.isWeb)return"custom";const I=f.getValue("window");if(I){if(w.isMacintosh&&I.nativeTabs===!0||w.isMacintosh&&I.nativeFullScreen===!1)return"native";const e=I.titleBarStyle;if(e==="native"||e==="custom")return e}return w.isLinux?"native":"custom"}t.getTitleBarStyle=v;function h(f){if(!w.isWindows||w.isWeb||v(f)==="native")return!1;const I=f.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:!1}t.useWindowControlsOverlay=h;function g(f=0){return Math.pow(1.2,f)}t.zoomLevelToZoomFactor=g}),define(pe[145],be([1,0,16,29,144]),function(Z,t,w,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function H(h){i.webFrame.setZoomLevel(h),(0,w.setZoomFactor)((0,B.zoomLevelToZoomFactor)(h)),(0,w.setZoomLevel)(h,!1)}t.applyZoom=H;function y(){H((0,w.getZoomLevel)()+1)}t.zoomIn=y;function v(){H((0,w.getZoomLevel)()-1)}t.zoomOut=v}),define(pe[146],be([1,0,10,4,129,8,130,29,135,136,137,139,143,145,94,85]),function(Z,t,w,i,B,H,y,v,h,g,f,I,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,r=/\s--(inspect|debug)-port=(\d+)/;class a{getHeight(D){return 22}getTemplateId(D){return S(D)?"process":_(D)?"machine":(0,h.isRemoteDiagnosticError)(D)?"error":L(D)?"header":""}}class c{hasChildren(D){return(0,h.isRemoteDiagnosticError)(D)?!1:S(D)?!!D.children?.length:!0}getChildren(D){return S(D)?D.children?D.children:[]:(0,h.isRemoteDiagnosticError)(D)?[]:L(D)?D.processRoots.length>1?D.processRoots:[D.processRoots[0].rootProcess]:_(D)?[D.rootProcess]:[D.processes]}}class m{constructor(){this.templateId="header"}renderTemplate(D){const z=Object.create(null),x=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(x,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)(x,(0,i.$)(".cpu")),z.memory=(0,i.append)(x,(0,i.$)(".memory")),z.PID=(0,i.append)(x,(0,i.$)(".pid")),z}renderElement(D,z,x,ie){x.name.textContent=(0,w.localize)(0,null),x.CPU.textContent=(0,w.localize)(1,null),x.PID.textContent=(0,w.localize)(2,null),x.memory.textContent=(0,w.localize)(3,null)}disposeTemplate(D){}}class s{constructor(){this.templateId="machine"}renderTemplate(D){const z=Object.create(null),x=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(x,(0,i.$)(".nameLabel")),z}renderElement(D,z,x,ie){x.name.textContent=D.element.name}disposeTemplate(D){}}class l{constructor(){this.templateId="error"}renderTemplate(D){const z=Object.create(null),x=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(x,(0,i.$)(".nameLabel")),z}renderElement(D,z,x,ie){x.name.textContent=D.element.errorMessage}disposeTemplate(D){}}class p{constructor(D,z,x){this.platform=D,this.totalMem=z,this.mapPidToWindowTitle=x,this.templateId="process"}renderTemplate(D){const z=Object.create(null),x=(0,i.append)(D,(0,i.$)(".row"));return z.name=(0,i.append)(x,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)(x,(0,i.$)(".cpu")),z.memory=(0,i.append)(x,(0,i.$)(".memory")),z.PID=(0,i.append)(x,(0,i.$)(".pid")),z}renderElement(D,z,x,ie){const{element:Q}=D;let me=Q.name;me==="window"&&(me=this.mapPidToWindowTitle.get(Q.pid)!==void 0?`${me} (${this.mapPidToWindowTitle.get(Q.pid)})`:me);const ae=Q.pid.toFixed(0);x.name.textContent=me,x.name.title=Q.cmd,x.CPU.textContent=Q.load.toFixed(0),x.PID.textContent=ae,x.PID.parentElement.id=`pid-${ae}`;const fe=this.platform==="win32"?Q.mem:this.totalMem*(Q.mem/100);x.memory.textContent=(fe/g.ByteSize.MB).toFixed(0)}disposeTemplate(D){}}function _(b){return!!b.name&&!!b.rootProcess}function L(b){return!!b.processRoots}function S(b){return!!b.pid}class A{constructor(D,z){this.data=z,this.mapPidToWindowTitle=new Map;const x=new f.ElectronIPCMainProcessService(D);this.nativeHostService=new I.NativeHostService(D,x),this.applyStyles(z.styles),this.setEventHandlers(z),v.ipcRenderer.on("vscode:windowsInfoResponse",(ie,Q)=>{this.mapPidToWindowTitle=new Map,Q.forEach(me=>this.mapPidToWindowTitle.set(me.pid,me.title))}),v.ipcRenderer.on("vscode:listProcessesResponse",async(ie,Q)=>{Q.forEach((me,ae)=>{S(me.rootProcess)&&(me.rootProcess.name=ae===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:Q}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(Q),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),v.ipcRenderer.send("vscode:windowsInfoRequest"),v.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(D){document.onkeydown=z=>{const x=D.platform==="darwin"?z.metaKey:z.ctrlKey;x&&z.keyCode===87&&(z.stopPropagation(),z.preventDefault(),v.ipcRenderer.send("vscode:closeProcessExplorer")),x&&z.keyCode===187&&(0,n.zoomIn)(),x&&z.keyCode===189&&(0,n.zoomOut)()}}async createProcessTree(D){const z=document.getElementById("process-list");if(!z)return;const{totalmem:x}=await this.nativeHostService.getOSStatistics(),ie=[new p(this.data.platform,x,this.mapPidToWindowTitle),new m,new s,new l];this.tree=new B.DataTree("processExplorer",z,new a,ie,new c,{identityProvider:{getId:Q=>S(Q)?Q.pid.toString():(0,h.isRemoteDiagnosticError)(Q)?Q.hostName:L(Q)?"processes":_(Q)?Q.name:"header"}}),this.tree.setInput({processes:{processRoots:D}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(Q=>{S(Q.element)&&this.showContextMenu(Q.element,!0)}),z.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{z.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(D){const z=e.exec(D);return z&&z.length>=2||D.indexOf("node ")>=0||D.indexOf("node.exe")>=0}attachTo(D){const z={type:"node",request:"attach",name:`process ${D.pid}`};let x=e.exec(D.cmd);x&&x.length>=2?(x.length===4&&x[3]&&(z.port=parseInt(x[3])),z.protocol=x[1]==="debug"?"legacy":"inspector"):z.processId=String(D.pid),x=r.exec(D.cmd),x&&x.length===3&&(z.port=parseInt(x[2])),v.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[z]})}applyStyles(D){const z=(0,i.createStyleSheet)(),x=[];D.listFocusBackground&&(x.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${D.listFocusBackground}; }`),x.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${D.listFocusBackground}; }`)),D.listFocusForeground&&x.push(`.monaco-list:focus .monaco-list-row.focused { color: ${D.listFocusForeground}; }`),D.listActiveSelectionBackground&&(x.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${D.listActiveSelectionBackground}; }`),x.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${D.listActiveSelectionBackground}; }`)),D.listActiveSelectionForeground&&x.push(`.monaco-list:focus .monaco-list-row.selected { color: ${D.listActiveSelectionForeground}; }`),D.listHoverBackground&&x.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${D.listHoverBackground}; }`),D.listHoverForeground&&x.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${D.listHoverForeground}; }`),D.listFocusOutline&&x.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }`),D.listHoverOutline&&x.push(`.monaco-list-row:hover { outline: 1px dashed ${D.listHoverOutline}; outline-offset: -1px; }`),D.scrollbarShadowColor&&x.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${D.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),D.scrollbarSliderBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${D.scrollbarSliderBackgroundColor};
				}
			`),D.scrollbarSliderHoverBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${D.scrollbarSliderHoverBackgroundColor};
				}
			`),D.scrollbarSliderActiveBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${D.scrollbarSliderActiveBackgroundColor};
				}
			`),z.textContent=x.join(`
`),D.color&&(document.body.style.color=D.color)}showContextMenu(D,z){const x=[],ie=Number(D.pid);z&&(x.push({label:(0,w.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ie,"SIGTERM")}}),x.push({label:(0,w.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ie,"SIGKILL")}}),x.push({type:"separator"})),x.push({label:(0,w.localize)(6,null),click:()=>{const Q=this.tree?.getSelection()?.map(ae=>{if(!(!ae||!("pid"in ae)))return ae.pid}).filter(ae=>!!ae);Q?.includes(ie)||(Q.length=0,Q.push(ie));const me=Q?.map(ae=>document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(me){const ae=me.map(fe=>fe.innerText).filter(fe=>!!fe);this.nativeHostService.writeClipboardText(ae.join(`
`))}}}),x.push({label:(0,w.localize)(7,null),click:()=>{const Q=document.getElementById("process-list");Q&&this.nativeHostService.writeClipboardText(Q.innerText)}}),D&&z&&this.isDebuggable(D.cmd)&&(x.push({type:"separator"}),x.push({label:(0,w.localize)(8,null),click:()=>{this.attachTo(D)}})),(0,y.popup)(x)}requestProcessList(D){setTimeout(()=>{const z=Date.now(),x=D+z-this.lastRequestTime;this.lastRequestTime=z,x>1e3?(v.ipcRenderer.send("vscode:windowsInfoRequest"),v.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(x)},200)}}function u(){const b=(0,i.createStyleSheet)();b.id="codiconStyles";const D=(0,o.getIconsStyleSheet)(void 0);function z(){b.textContent=D.getCSS()}const x=new H.RunOnceScheduler(z,0);D.onDidChange(()=>x.schedule()),x.schedule()}function E(b){const D=b.data.platform==="win32"?"windows":b.data.platform==="linux"?"linux":"mac";document.body.classList.add(D),u(),(0,n.applyZoom)(b.data.zoomLevel),new A(b.windowId,b.data)}t.startup=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1c78193f54fac6036829ec554ce218d99afc1f15/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
