/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/base/common/map","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(_){for(var e=[],C=0,R=_.length;C<R;C++)e[C]=Q[_[C]];return e};define(Q[49],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function C(O){return(E,g,h)=>{let w=null,b=null;if(typeof h.value=="function"?(w="value",b=h.value):typeof h.get=="function"&&(w="get",b=h.get),!b)throw new Error("not supported");h[w]=O(b,g)}}e.createDecorator=C;function R(O,E,g){let h=null,w=null;if(typeof g.value=="function"?(h="value",w=g.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(h="get",w=g.get),!w)throw new Error("not supported");const b=`$memoize$${E}`;g[h]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,m)}),this[b]}}e.memoize=R;function D(O,E,g){return C((h,w)=>{const b=`$debounce$${w}`,m=`$debounce$result$${w}`;return function(...v){this[m]||(this[m]=g?g():void 0),clearTimeout(this[b]),E&&(this[m]=E(this[m],...v),v=[this[m]]),this[b]=setTimeout(()=>{h.apply(this,v),this[m]=g?g():void 0},O)}})}e.debounce=D;function k(O,E,g){return C((h,w)=>{const b=`$throttle$timer$${w}`,m=`$throttle$result$${w}`,v=`$throttle$lastRun$${w}`,p=`$throttle$pending$${w}`;return function(...P){if(this[m]||(this[m]=g?g():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),E&&(this[m]=E(this[m],...P)),this[p])return;const y=this[v]+O;y<=Date.now()?(this[v]=Date.now(),h.apply(this,[this[m]]),this[m]=g?g():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),h.apply(this,[this[m]]),this[m]=g?g():void 0},y-Date.now()))}})}e.throttle=k}),define(Q[68],Z([0,1,11]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(g,h){if(!g)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=R;function D(g,h="Unreachable"){throw new Error(h)}e.assertNever=D;function k(g){if(!g)throw new C.BugIndicatingError("Assertion Failed")}e.assert=k;function O(g){if(!g()){debugger;g(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function E(g,h){let w=0;for(;w<g.length-1;){const b=g[w],m=g[w+1];if(!h(b,m))return!1;w++}return!0}e.checkAdjacentItems=E}),define(Q[50],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function O(t,n=!1){let i=0;const r=t.length;let o="",c=0,a=16,f=0;function I(re){let fe=0,le=0;for(;fe<re;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,fe++}return fe<re&&(le=-1),le}function N(re){i=re,o="",c=0,a=16,f=0}function B(){const re=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&h(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&h(t.charCodeAt(i)))for(i++;i<t.length&&h(t.charCodeAt(i));)i++;else return f=3,t.substring(re,i);let fe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&h(t.charCodeAt(i))){for(i++;i<t.length&&h(t.charCodeAt(i));)i++;fe=i}else f=3;return t.substring(re,fe)}function K(){let re="",fe=i;for(;;){if(i>=r){re+=t.substring(fe,i),f=2;break}const le=t.charCodeAt(i);if(le===34){re+=t.substring(fe,i),i++;break}if(le===92){if(re+=t.substring(fe,i),i++,i>=r){f=2;break}switch(t.charCodeAt(i++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const W=I(4);W>=0?re+=String.fromCharCode(W):f=4;break}default:f=5}fe=i;continue}if(le>=0&&le<=31)if(g(le)){re+=t.substring(fe,i),f=2;break}else f=6;i++}return re}function J(){if(o="",f=0,c=i,i>=r)return c=r,a=17;let re=t.charCodeAt(i);if(E(re)){do i++,o+=String.fromCharCode(re),re=t.charCodeAt(i);while(E(re));return a=15}if(g(re))return i++,o+=String.fromCharCode(re),re===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(re){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=K(),a=10;case 47:{const fe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!g(t.charCodeAt(i));)i++;return o=t.substring(fe,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const le=r-1;let ie=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,f=1),o=t.substring(fe,i),a=13}return o+=String.fromCharCode(re),i++,a=16}case 45:if(o+=String.fromCharCode(re),i++,i===r||!h(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=B(),a=11;default:for(;i<r&&ne(re);)i++,re=t.charCodeAt(i);if(c!==i){switch(o=t.substring(c,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(re),i++,a=16}}function ne(re){if(E(re)||g(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=J();while(re>=12&&re<=15);return re}return{setPosition:N,getPosition:()=>i,scan:n?oe:J,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>f}}e.createScanner=O;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function h(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function b(t,n){const i=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function f(I,N,B,K){c.value=I,c.offset=N,c.length=B,c.type=K,c.colonOffset=void 0,o=c}try{S(t,{onObjectBegin:(I,N)=>{if(n<=I)throw r;o=void 0,a=n>I,i.push("")},onObjectProperty:(I,N,B)=>{if(n<N||(f(I,N,B,"property"),i[i.length-1]=I,n<=N+B))throw r},onObjectEnd:(I,N)=>{if(n<=I)throw r;o=void 0,i.pop()},onArrayBegin:(I,N)=>{if(n<=I)throw r;o=void 0,i.push(0)},onArrayEnd:(I,N)=>{if(n<=I)throw r;o=void 0,i.pop()},onLiteralValue:(I,N,B)=>{if(n<N||(f(I,N,B,s(I)),n<=N+B))throw r},onSeparator:(I,N,B)=>{if(n<=N)throw r;if(I===":"&&o&&o.type==="property")o.colonOffset=N,a=!1,o=void 0;else if(I===","){const K=i[i.length-1];typeof K=="number"?i[i.length-1]=K+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(I){if(I!==r)throw I}return{path:i,previousNode:o,isAtPropertyKey:a,matches:I=>{let N=0;for(let B=0;N<I.length&&B<i.length;B++)if(I[N]===i[B]||I[N]==="*")N++;else if(I[N]!=="**")return!1;return N===I.length}}}e.getLocation=b;function m(t,n=[],i=k.DEFAULT){let r=null,o=[];const c=[];function a(I){Array.isArray(o)?o.push(I):r!==null&&(o[r]=I)}return S(t,{onObjectBegin:()=>{const I={};a(I),c.push(o),o=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const I=[];a(I),c.push(o),o=I,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(I,N,B)=>{n.push({error:I,offset:N,length:B})}},i),o[0]}e.parse=m;function v(t,n=[],i=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(I){r.type==="property"&&(r.length=I-r.offset,r=r.parent)}function c(I){return r.children.push(I),I}S(t,{onObjectBegin:I=>{r=c({type:"object",offset:I,length:-1,parent:r,children:[]})},onObjectProperty:(I,N,B)=>{r=c({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:I,offset:N,length:B,parent:r})},onObjectEnd:(I,N)=>{r.length=I+N-r.offset,r=r.parent,o(I+N)},onArrayBegin:(I,N)=>{r=c({type:"array",offset:I,length:-1,parent:r,children:[]})},onArrayEnd:(I,N)=>{r.length=I+N-r.offset,r=r.parent,o(I+N)},onLiteralValue:(I,N,B)=>{c({type:s(I),offset:N,length:B,parent:r,value:I}),o(N+B)},onSeparator:(I,N,B)=>{r.type==="property"&&(I===":"?r.colonOffset=N:I===","&&o(N))},onError:(I,N,B)=>{n.push({error:I,offset:N,length:B})}},i);const f=r.children[0];return f&&delete f.parent,f}e.parseTree=v;function p(t,n){if(!t)return;let i=t;for(const r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===r){i=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=p;function P(t){if(!t.parent||!t.parent.children)return[];const n=P(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=P;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":{const n=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=y(r))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=y;function l(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=l;function d(t,n,i=!1){if(l(t,n,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=d(r[o],n,i);if(c)return c}return t}}e.findNodeAtOffset=d;function S(t,n,i=k.DEFAULT){const r=O(t,!1);function o(A){return A?()=>A(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(A){return A?x=>A(x,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),f=c(n.onObjectProperty),I=o(n.onObjectEnd),N=o(n.onArrayBegin),B=o(n.onArrayEnd),K=c(n.onLiteralValue),J=c(n.onSeparator),ne=o(n.onComment),oe=c(n.onError),re=i&&i.disallowComments,fe=i&&i.allowTrailingComma;function le(){for(;;){const A=r.scan();switch(r.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:re||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:re?ie(10):ne();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,x=[],L=[]){if(oe(A),x.length+L.length>0){let T=r.getToken();for(;T!==17;){if(x.indexOf(T)!==-1){le();break}else if(L.indexOf(T)!==-1)break;T=le()}}}function W(A){const x=r.getTokenValue();return A?K(x):f(x),le(),!0}function M(){switch(r.getToken()){case 11:{let A=0;try{A=JSON.parse(r.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}K(A);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return le(),!0}function F(){return r.getToken()!==10?(ie(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(J(":"),le(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function z(){a(),le();let A=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),J(","),le(),r.getToken()===2&&fe)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return I(),r.getToken()!==2?ie(7,[2],[]):le(),!0}function $(){N(),le();let A=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),J(","),le(),r.getToken()===4&&fe)break}else A&&ie(6,[],[]);Y()||ie(4,[],[4,5]),A=!0}return B(),r.getToken()!==4?ie(8,[4],[]):le(),!0}function Y(){switch(r.getToken()){case 3:return $();case 1:return z();case 10:return W(!0);default:return M()}}return le(),r.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(r.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.visit=S;function u(t,n){const i=O(t),r=[];let o,c=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:c!==a&&r.push(t.substring(c,a)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),c=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=u;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function _(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function O(g){k.push(g,Date.now())}function E(){const g=[];for(let h=0;h<k.length;h+=2)g.push({name:k[h],startTime:k[h+1]});return g}return{mark:O,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const O of performance.getEntriesByType("mark"))k.push({name:O.name,startTime:Math.round(D+O.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function C(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=C(R))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var R in C)(typeof exports=="object"?exports:_)[R]=C[R]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function C(R){if(e[R])return e[R].exports;var D=e[R]={i:R,l:!1,exports:{}};return _[R].call(D.exports,D,D.exports,C),D.l=!0,D.exports}return C.m=_,C.c=e,C.d=function(R,D,k){C.o(R,D)||Object.defineProperty(R,D,{enumerable:!0,get:k})},C.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},C.t=function(R,D){if(1&D&&(R=C(R)),8&D||4&D&&typeof R=="object"&&R&&R.__esModule)return R;var k=Object.create(null);if(C.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:R}),2&D&&typeof R!="string")for(var O in R)C.d(k,O,function(E){return R[E]}.bind(null,O));return k},C.n=function(R){var D=R&&R.__esModule?function(){return R.default}:function(){return R};return C.d(D,"a",D),D},C.o=function(R,D){return Object.prototype.hasOwnProperty.call(R,D)},C.p="",C(C.s=0)}([function(_,e,C){(function(R){var D;e=_.exports=L,D=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],g=e.src=[],h=0,w=h++;g[w]="0|[1-9]\\d*";var b=h++;g[b]="[0-9]+";var m=h++;g[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=h++;g[v]="("+g[w]+")\\.("+g[w]+")\\.("+g[w]+")";var p=h++;g[p]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var P=h++;g[P]="(?:"+g[w]+"|"+g[m]+")";var y=h++;g[y]="(?:"+g[b]+"|"+g[m]+")";var l=h++;g[l]="(?:-("+g[P]+"(?:\\."+g[P]+")*))";var d=h++;g[d]="(?:-?("+g[y]+"(?:\\."+g[y]+")*))";var S=h++;g[S]="[0-9A-Za-z-]+";var u=h++;g[u]="(?:\\+("+g[S]+"(?:\\."+g[S]+")*))";var s=h++,t="v?"+g[v]+g[l]+"?"+g[u]+"?";g[s]="^"+t+"$";var n="[v=\\s]*"+g[p]+g[d]+"?"+g[u]+"?",i=h++;g[i]="^"+n+"$";var r=h++;g[r]="((?:<|>)?=?)";var o=h++;g[o]=g[b]+"|x|X|\\*";var c=h++;g[c]=g[w]+"|x|X|\\*";var a=h++;g[a]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[l]+")?"+g[u]+"?)?)?";var f=h++;g[f]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[d]+")?"+g[u]+"?)?)?";var I=h++;g[I]="^"+g[r]+"\\s*"+g[a]+"$";var N=h++;g[N]="^"+g[r]+"\\s*"+g[f]+"$";var B=h++;g[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=h++;g[K]="(?:~>?)";var J=h++;g[J]="(\\s*)"+g[K]+"\\s+",E[J]=new RegExp(g[J],"g");var ne=h++;g[ne]="^"+g[K]+g[a]+"$";var oe=h++;g[oe]="^"+g[K]+g[f]+"$";var re=h++;g[re]="(?:\\^)";var fe=h++;g[fe]="(\\s*)"+g[re]+"\\s+",E[fe]=new RegExp(g[fe],"g");var le=h++;g[le]="^"+g[re]+g[a]+"$";var ie=h++;g[ie]="^"+g[re]+g[f]+"$";var W=h++;g[W]="^"+g[r]+"\\s*("+n+")$|^$";var M=h++;g[M]="^"+g[r]+"\\s*("+t+")$|^$";var F=h++;g[F]="(\\s*)"+g[r]+"\\s*("+n+"|"+g[a]+")",E[F]=new RegExp(g[F],"g");var z=h++;g[z]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var $=h++;g[$]="^\\s*("+g[f]+")\\s+-\\s+("+g[f]+")\\s*$";var Y=h++;g[Y]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)D(A,g[A]),E[A]||(E[A]=new RegExp(g[A]));function x(V,G){if(V instanceof L)return V;if(typeof V!="string"||V.length>k||!(G?E[i]:E[s]).test(V))return null;try{return new L(V,G)}catch{return null}}function L(V,G){if(V instanceof L){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof L))return new L(V,G);D("SemVer",V,G),this.loose=G;var X=V.trim().match(G?E[i]:E[s]);if(!X)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<O)return me}return ue}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=x,e.valid=function(V,G){var X=x(V,G);return X?X.version:null},e.clean=function(V,G){var X=x(V.trim().replace(/^[=v]+/,""),G);return X?X.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(V){return D("SemVer.compare",this.version,this.loose,V),V instanceof L||(V=new L(V,this.loose)),this.compareMain(V)||this.comparePre(V)},L.prototype.compareMain=function(V){return V instanceof L||(V=new L(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},L.prototype.comparePre=function(V){if(V instanceof L||(V=new L(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var X=this.prerelease[G],ue=V.prerelease[G];if(D("prerelease compare",G,X,ue),X===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(X===void 0)return-1;if(X!==ue)return U(X,ue)}while(++G)},L.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,G,X,ue){typeof X=="string"&&(ue=X,X=void 0);try{return new L(V,X).inc(G,ue).version}catch{return null}},e.diff=function(V,G){if(ae(V,G))return null;var X=x(V),ue=x(G);if(X.prerelease.length||ue.prerelease.length){for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ue[me])return me},e.compareIdentifiers=U;var T=/^[0-9]+$/;function U(V,G){var X=T.test(V),ue=T.test(G);return X&&ue&&(V=+V,G=+G),X&&!ue?-1:ue&&!X?1:V<G?-1:V>G?1:0}function j(V,G,X){return new L(V,X).compare(new L(G,X))}function q(V,G,X){return j(V,G,X)>0}function H(V,G,X){return j(V,G,X)<0}function ae(V,G,X){return j(V,G,X)===0}function ce(V,G,X){return j(V,G,X)!==0}function pe(V,G,X){return j(V,G,X)>=0}function ye(V,G,X){return j(V,G,X)<=0}function te(V,G,X,ue){var me;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),me=V===X;break;case"!==":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),me=V!==X;break;case"":case"=":case"==":me=ae(V,X,ue);break;case"!=":me=ce(V,X,ue);break;case">":me=q(V,X,ue);break;case">=":me=pe(V,X,ue);break;case"<":me=H(V,X,ue);break;case"<=":me=ye(V,X,ue);break;default:throw new TypeError("Invalid operator: "+G)}return me}function se(V,G){if(V instanceof se){if(V.loose===G)return V;V=V.value}if(!(this instanceof se))return new se(V,G);D("comparator",V,G),this.loose=G,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(V,G){return U(G,V)},e.major=function(V,G){return new L(V,G).major},e.minor=function(V,G){return new L(V,G).minor},e.patch=function(V,G){return new L(V,G).patch},e.compare=j,e.compareLoose=function(V,G){return j(V,G,!0)},e.rcompare=function(V,G,X){return j(G,V,X)},e.sort=function(V,G){return V.sort(function(X,ue){return e.compare(X,ue,G)})},e.rsort=function(V,G){return V.sort(function(X,ue){return e.rcompare(X,ue,G)})},e.gt=q,e.lt=H,e.eq=ae,e.neq=ce,e.gte=pe,e.lte=ye,e.cmp=te,e.Comparator=se;var ge={};function de(V,G){if(V instanceof de)return V.loose===G?V:new de(V.raw,G);if(V instanceof se)return new de(V.value,G);if(!(this instanceof de))return new de(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ve(V){return!V||V.toLowerCase()==="x"||V==="*"}function ke(V,G,X,ue,me,De,we,Oe,be,Ce,Me,Re,Le){return((G=ve(X)?"":ve(ue)?">="+X+".0.0":ve(me)?">="+X+"."+ue+".0":">="+G)+" "+(Oe=ve(be)?"":ve(Ce)?"<"+(+be+1)+".0.0":ve(Me)?"<"+be+"."+(+Ce+1)+".0":Re?"<="+be+"."+Ce+"."+Me+"-"+Re:"<="+Oe)).trim()}function Fe(V,G){for(var X=0;X<V.length;X++)if(!V[X].test(G))return!1;if(G.prerelease.length){for(X=0;X<V.length;X++)if(D(V[X].semver),V[X].semver!==ge&&V[X].semver.prerelease.length>0){var ue=V[X].semver;if(ue.major===G.major&&ue.minor===G.minor&&ue.patch===G.patch)return!0}return!1}return!0}function Ue(V,G,X){try{G=new de(G,X)}catch{return!1}return G.test(V)}function xe(V,G,X,ue){var me,De,we,Oe,be;switch(V=new L(V,ue),G=new de(G,ue),X){case">":me=q,De=ye,we=H,Oe=">",be=">=";break;case"<":me=H,De=pe,we=q,Oe="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(V,G,ue))return!1;for(var Ce=0;Ce<G.set.length;++Ce){var Me=G.set[Ce],Re=null,Le=null;if(Me.forEach(function(Ae){Ae.semver===ge&&(Ae=new se(">=0.0.0")),Re=Re||Ae,Le=Le||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Le.semver,ue)&&(Le=Ae)}),Re.operator===Oe||Re.operator===be||(!Le.operator||Le.operator===Oe)&&De(V,Le.semver)||Le.operator===be&&we(V,Le.semver))return!1}return!0}se.prototype.parse=function(V){var G=this.loose?E[W]:E[M],X=V.match(G);if(!X)throw new TypeError("Invalid comparator: "+V);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new L(X[2],this.loose):this.semver=ge},se.prototype.toString=function(){return this.value},se.prototype.test=function(V){return D("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new L(V,this.loose)),te(V,this.operator,this.semver,this.loose))},se.prototype.intersects=function(V,G){if(!(V instanceof se))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new de(V.value,G),Ue(this.value,X,G);if(V.operator==="")return X=new de(this.value,G),Ue(V.semver,X,G);var ue=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Oe=te(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),be=te(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ue||me||De&&we||Oe||be},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),D("range",V,G);var X=G?E[$]:E[z];V=V.replace(X,ke),D("hyphen replace",V),V=V.replace(E[F],"$1$2$3"),D("comparator trim",V,E[F]),V=(V=(V=V.replace(E[J],"$1~")).replace(E[fe],"$1^")).split(/\s+/).join(" ");var ue=G?E[W]:E[M],me=V.split(" ").map(function(De){return function(we,Oe){return D("comp",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Le){D("caret",Re,Le);var Ae=Le?E[ie]:E[le];return Re.replace(Ae,function(Ne,Se,Ee,Pe,Ie){var Te;return D("caret",Re,Ne,Se,Ee,Pe,Ie),ve(Se)?Te="":ve(Ee)?Te=">="+Se+".0.0 <"+(+Se+1)+".0.0":ve(Pe)?Te=Se==="0"?">="+Se+"."+Ee+".0 <"+Se+"."+(+Ee+1)+".0":">="+Se+"."+Ee+".0 <"+(+Se+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Te=Se==="0"?Ee==="0"?">="+Se+"."+Ee+"."+Pe+Ie+" <"+Se+"."+Ee+"."+(+Pe+1):">="+Se+"."+Ee+"."+Pe+Ie+" <"+Se+"."+(+Ee+1)+".0":">="+Se+"."+Ee+"."+Pe+Ie+" <"+(+Se+1)+".0.0"):(D("no pr"),Te=Se==="0"?Ee==="0"?">="+Se+"."+Ee+"."+Pe+" <"+Se+"."+Ee+"."+(+Pe+1):">="+Se+"."+Ee+"."+Pe+" <"+Se+"."+(+Ee+1)+".0":">="+Se+"."+Ee+"."+Pe+" <"+(+Se+1)+".0.0"),D("caret return",Te),Te})}(Me,Ce)}).join(" ")}(we,Oe),D("caret",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Le){var Ae=Le?E[oe]:E[ne];return Re.replace(Ae,function(Ne,Se,Ee,Pe,Ie){var Te;return D("tilde",Re,Ne,Se,Ee,Pe,Ie),ve(Se)?Te="":ve(Ee)?Te=">="+Se+".0.0 <"+(+Se+1)+".0.0":ve(Pe)?Te=">="+Se+"."+Ee+".0 <"+Se+"."+(+Ee+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Te=">="+Se+"."+Ee+"."+Pe+Ie+" <"+Se+"."+(+Ee+1)+".0"):Te=">="+Se+"."+Ee+"."+Pe+" <"+Se+"."+(+Ee+1)+".0",D("tilde return",Te),Te})}(Me,Ce)}).join(" ")}(we,Oe),D("tildes",we),we=function(be,Ce){return D("replaceXRanges",be,Ce),be.split(/\s+/).map(function(Me){return function(Re,Le){Re=Re.trim();var Ae=Le?E[N]:E[I];return Re.replace(Ae,function(Ne,Se,Ee,Pe,Ie,Te){D("xRange",Re,Ne,Se,Ee,Pe,Ie,Te);var We=ve(Ee),Ve=We||ve(Pe),ze=Ve||ve(Ie);return Se==="="&&ze&&(Se=""),We?Ne=Se===">"||Se==="<"?"<0.0.0":"*":Se&&ze?(Ve&&(Pe=0),ze&&(Ie=0),Se===">"?(Se=">=",Ve?(Ee=+Ee+1,Pe=0,Ie=0):ze&&(Pe=+Pe+1,Ie=0)):Se==="<="&&(Se="<",Ve?Ee=+Ee+1:Pe=+Pe+1),Ne=Se+Ee+"."+Pe+"."+Ie):Ve?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),D("xRange return",Ne),Ne})}(Me,Ce)}).join(" ")}(we,Oe),D("xrange",we),we=function(be,Ce){return D("replaceStars",be,Ce),be.trim().replace(E[Y],"")}(we,Oe),D("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(ue)})),me=me.map(function(De){return new se(De,G)})},de.prototype.intersects=function(V,G){if(!(V instanceof de))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(ue){return V.set.some(function(me){return me.every(function(De){return ue.intersects(De,G)})})})})},e.toComparators=function(V,G){return new de(V,G).set.map(function(X){return X.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new L(V,this.loose));for(var G=0;G<this.set.length;G++)if(Fe(this.set[G],V))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(V,G,X){var ue=null,me=null;try{var De=new de(G,X)}catch{return null}return V.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==-1||(me=new L(ue=we,X)))}),ue},e.minSatisfying=function(V,G,X){var ue=null,me=null;try{var De=new de(G,X)}catch{return null}return V.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==1||(me=new L(ue=we,X)))}),ue},e.validRange=function(V,G){try{return new de(V,G).range||"*"}catch{return null}},e.ltr=function(V,G,X){return xe(V,G,"<",X)},e.gtr=function(V,G,X){return xe(V,G,">",X)},e.outside=xe,e.prerelease=function(V,G){var X=x(V,G);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(V,G,X){return V=new de(V,X),G=new de(G,X),V.intersects(G)},e.coerce=function(V){if(V instanceof L)return V;if(typeof V!="string")return null;var G=V.match(E[B]);return G==null?null:x((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,C(1))},function(_,e){var C,R,D=_.exports={};function k(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function E(y){if(C===setTimeout)return setTimeout(y,0);if((C===k||!C)&&setTimeout)return C=setTimeout,setTimeout(y,0);try{return C(y,0)}catch{try{return C.call(null,y,0)}catch{return C.call(this,y,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:k}catch{C=k}try{R=typeof clearTimeout=="function"?clearTimeout:O}catch{R=O}})();var g,h=[],w=!1,b=-1;function m(){w&&g&&(w=!1,g.length?h=g.concat(h):b=-1,h.length&&v())}function v(){if(!w){var y=E(m);w=!0;for(var l=h.length;l;){for(g=h,h=[];++b<l;)g&&g[b].run();b=-1,l=h.length}g=null,w=!1,function(d){if(R===clearTimeout)return clearTimeout(d);if((R===O||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(d);try{R(d)}catch{try{return R.call(null,d)}catch{return R.call(this,d)}}}(y)}}function p(y,l){this.fun=y,this.array=l}function P(){}D.nextTick=function(y){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];h.push(new p(y,l)),h.length!==1||w||E(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=P,D.addListener=P,D.once=P,D.off=P,D.removeListener=P,D.removeAllListeners=P,D.emit=P,D.prependListener=P,D.prependOnceListener=P,D.listeners=function(y){return[]},D.binding=function(y){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(y){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(_,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(E,g,h){this.level=E,this.key=g,this.value=h,this.forward=[]}}const D=void 0;class k{constructor(E,g=2**16){this.comparator=E,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(g)|0),this._header=new R(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,D,D)}has(E){return Boolean(k._search(this,E,this.comparator))}get(E){return k._search(this,E,this.comparator)?.value}set(E,g){return k._insert(this,E,g,this.comparator)&&(this._size+=1),this}delete(E){const g=k._delete(this,E,this.comparator);return g&&(this._size-=1),g}forEach(E,g){let h=this._header.forward[0];for(;h;)E.call(g,h.value,h.key,this),h=h.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",g=this._header.forward[0];for(;g;)E+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return E}static _search(E,g,h){let w=E._header;for(let b=E._level-1;b>=0;b--)for(;w.forward[b]&&h(w.forward[b].key,g)<0;)w=w.forward[b];if(w=w.forward[0],w&&h(w.key,g)===0)return w}static _insert(E,g,h,w){const b=[];let m=E._header;for(let v=E._level-1;v>=0;v--){for(;m.forward[v]&&w(m.forward[v].key,g)<0;)m=m.forward[v];b[v]=m}if(m=m.forward[0],m&&w(m.key,g)===0)return m.value=h,!1;{const v=k._randomLevel(E);if(v>E._level){for(let p=E._level;p<v;p++)b[p]=E._header;E._level=v}m=new R(v,g,h);for(let p=0;p<v;p++)m.forward[p]=b[p].forward[p],b[p].forward[p]=m;return!0}}static _randomLevel(E,g=.5){let h=1;for(;Math.random()<g&&h<E._maxLevel;)h+=1;return h}static _delete(E,g,h){const w=[];let b=E._header;for(let m=E._level-1;m>=0;m--){for(;b.forward[m]&&h(b.forward[m].key,g)<0;)b=b.forward[m];w[m]=b}if(b=b.forward[0],!b||h(b.key,g)!==0)return!1;for(let m=0;m<E._level&&w[m].forward[m]===b;m++)w[m].forward[m]=b.forward[m];for(;E._level>0&&E._header.forward[E._level-1]===D;)E._level-=1;return!0}}e.SkipList=k}),define(Q[43],Z([0,1,11,2]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(u){const s=u;return s?typeof s.read=="function":!1}e.isReadable=D;function k(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=k;function O(u){const s=u;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=O;function E(u,s){return new g(u,s)}e.newWriteableStream=E;class g{constructor(s,t){this.reducer=s,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(t=>t(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(t=>t(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,t){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(s,t){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const i=n.indexOf(t);i>=0&&n.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(u,s){const t=[];let n;for(;(n=u.read())!==null;)t.push(n);return s(t)}e.consumeReadable=h;function w(u,s,t){const n=[];let i;for(;(i=u.read())!==null&&n.length<t;)n.push(i);return i===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return u.read()}}}e.peekReadable=w;function b(u,s){return new Promise((t,n)=>{const i=[];m(u,{onData:r=>{s&&i.push(r)},onError:r=>{s?n(r):t(void 0)},onEnd:()=>{t(s?s(i):void 0)}})})}e.consumeStream=b;function m(u,s){let t=!1;return u.on("error",n=>{t||s.onError(n)}),u.on("end",()=>{t||s.onEnd()}),u.on("data",n=>{t||s.onData(n)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=m;function v(u,s){return new Promise((t,n)=>{const i=new R.DisposableStore,r=[],o=f=>{if(r.push(f),r.length>s)return i.dispose(),u.pause(),t({stream:u,buffer:r,ended:!1})},c=f=>n(f),a=()=>t({stream:u,buffer:r,ended:!0});i.add((0,R.toDisposable)(()=>u.removeListener("error",c))),u.on("error",c),i.add((0,R.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),i.add((0,R.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=v;function p(u,s){const t=E(s);return t.end(u),t}e.toStream=p;function P(){const u=E(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=P;function y(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}e.toReadable=y;function l(u,s,t){const n=E(t);return m(u,{onData:i=>n.write(s.data(i)),onError:i=>n.error(s.error?s.error(i):i),onEnd:()=>n.end()}),n}e.transform=l;function d(u,s,t){let n=!1;return{read:()=>{const i=s.read();return n?i:(n=!0,i!==null?t([u,i]):u)}}}e.prefixedReadable=d;function S(u,s,t){let n=!1;const i=E(t);return m(s,{onData:r=>n?i.write(r):(n=!0,i.write(t([u,r]))),onError:r=>i.error(r),onEnd:()=>{n||(n=!0,i.write(u)),i.end()}}),i}e.prefixedStream=S}),define(Q[15],Z([0,1,43]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let D,k;class O{static alloc(f){return R?new O(Buffer.allocUnsafe(f)):new O(new Uint8Array(f))}static wrap(f){return R&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new O(f)}static fromString(f,I){return!(I?.dontUseNodeBuffer||!1)&&R?new O(Buffer.from(f)):(D||(D=new TextEncoder),new O(D.encode(f)))}static fromByteArray(f){const I=O.alloc(f.length);for(let N=0,B=f.length;N<B;N++)I.buffer[N]=f[N];return I}static concat(f,I){if(typeof I>"u"){I=0;for(let K=0,J=f.length;K<J;K++)I+=f[K].byteLength}const N=O.alloc(I);let B=0;for(let K=0,J=f.length;K<J;K++){const ne=f[K];N.set(ne,B),B+=ne.byteLength}return N}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=O.alloc(this.byteLength);return f.set(this),f}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(f,I){return new O(this.buffer.subarray(f,I))}set(f,I){if(f instanceof O)this.buffer.set(f.buffer,I);else if(f instanceof Uint8Array)this.buffer.set(f,I);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),I);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return h(this.buffer,f)}writeUInt32BE(f,I){w(this.buffer,f,I)}readUInt32LE(f){return b(this.buffer,f)}writeUInt32LE(f,I){m(this.buffer,f,I)}readUInt8(f){return v(this.buffer,f)}writeUInt8(f,I){p(this.buffer,f,I)}}e.VSBuffer=O;function E(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0}e.readUInt16LE=E;function g(a,f,I){a[I+0]=f&255,f=f>>>8,a[I+1]=f&255}e.writeUInt16LE=g;function h(a,f){return a[f]*2**24+a[f+1]*2**16+a[f+2]*2**8+a[f+3]}e.readUInt32BE=h;function w(a,f,I){a[I+3]=f,f=f>>>8,a[I+2]=f,f=f>>>8,a[I+1]=f,f=f>>>8,a[I]=f}e.writeUInt32BE=w;function b(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0|a[f+2]<<16>>>0|a[f+3]<<24>>>0}e.readUInt32LE=b;function m(a,f,I){a[I+0]=f&255,f=f>>>8,a[I+1]=f&255,f=f>>>8,a[I+2]=f&255,f=f>>>8,a[I+3]=f&255}e.writeUInt32LE=m;function v(a,f){return a[f]}e.readUInt8=v;function p(a,f,I){a[I]=f}e.writeUInt8=p;function P(a){return C.consumeReadable(a,f=>O.concat(f))}e.readableToBuffer=P;function y(a){return C.toReadable(a)}e.bufferToReadable=y;function l(a){return C.consumeStream(a,f=>O.concat(f))}e.streamToBuffer=l;async function d(a){return a.ended?O.concat(a.buffer):O.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=d;function S(a){return C.toStream(a,f=>O.concat(f))}e.bufferToStream=S;function u(a){return C.transform(a,{data:f=>typeof f=="string"?O.fromString(f):O.wrap(f)},f=>O.concat(f))}e.streamToBufferReadableStream=u;function s(a){return C.newWriteableStream(f=>O.concat(f),a)}e.newWriteableBufferStream=s;function t(a,f){return C.prefixedReadable(a,f,I=>O.concat(I))}e.prefixedBufferReadable=t;function n(a,f){return C.prefixedStream(a,f,I=>O.concat(I))}e.prefixedBufferStream=n;function i(a){let f=0,I=0,N=0;const B=new Uint8Array(Math.floor(a.length/4*3)),K=ne=>{switch(I){case 3:B[N++]=f|ne,I=0;break;case 2:B[N++]=f|ne>>>2,f=ne<<6,I=3;break;case 1:B[N++]=f|ne>>>4,f=ne<<4,I=2;break;default:f=ne<<2,I=1}};for(let ne=0;ne<a.length;ne++){const oe=a.charCodeAt(ne);if(oe>=65&&oe<=90)K(oe-65);else if(oe>=97&&oe<=122)K(oe-97+26);else if(oe>=48&&oe<=57)K(oe-48+52);else if(oe===43||oe===45)K(62);else if(oe===47||oe===95)K(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ne]}`)}}const J=N;for(;I>0;)K(0);return O.wrap(B).slice(0,J)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},f=!0,I=!1){const N=I?o:r;let B="";const K=a.byteLength%3;let J=0;for(;J<a.byteLength-K;J+=3){const ne=a[J+0],oe=a[J+1],re=a[J+2];B+=N[ne>>>2],B+=N[(ne<<4|oe>>>4)&63],B+=N[(oe<<2|re>>>6)&63],B+=N[re&63]}if(K===1){const ne=a[J+0];B+=N[ne>>>2],B+=N[ne<<4&63],f&&(B+="==")}else if(K===2){const ne=a[J+0],oe=a[J+1];B+=N[ne>>>2],B+=N[(ne<<4|oe>>>4)&63],B+=N[oe<<2&63],f&&(B+="=")}return B}e.encodeBase64=c}),define(Q[26],Z([0,1,5]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([S,u])=>{d[S]=u&&typeof u=="object"?R(u):u}),d}e.deepClone=R;function D(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const S=d.shift();Object.freeze(S);for(const u in S)if(k.call(S,u)){const s=S[u];typeof s=="object"&&!Object.isFrozen(s)&&!(0,C.isTypedArray)(s)&&d.push(s)}}return l}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function O(l,d){return E(l,d,new Set)}e.cloneAndChange=O;function E(l,d,S){if((0,C.isUndefinedOrNull)(l))return l;const u=d(l);if(typeof u<"u")return u;if(Array.isArray(l)){const s=[];for(const t of l)s.push(E(t,d,S));return s}if((0,C.isObject)(l)){if(S.has(l))throw new Error("Cannot clone recursive data-structure");S.add(l);const s={};for(const t in l)k.call(l,t)&&(s[t]=E(l[t],d,S));return S.delete(l),s}return l}function g(l,d,S=!0){return(0,C.isObject)(l)?((0,C.isObject)(d)&&Object.keys(d).forEach(u=>{u in l?S&&((0,C.isObject)(l[u])&&(0,C.isObject)(d[u])?g(l[u],d[u],S):l[u]=d[u]):l[u]=d[u]}),l):d}e.mixin=g;function h(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let S,u;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(S=0;S<l.length;S++)if(!h(l[S],d[S]))return!1}else{const s=[];for(u in l)s.push(u);s.sort();const t=[];for(u in d)t.push(u);if(t.sort(),!h(s,t))return!1;for(S=0;S<s.length;S++)if(!h(l[s[S]],d[s[S]]))return!1}return!0}e.equals=h;function w(l){const d=new Set;return JSON.stringify(l,(S,u)=>{if((0,C.isObject)(u)||Array.isArray(u)){if(d.has(u))return"[Circular]";d.add(u)}return u})}e.safeStringify=w;function b(l,d){const S=Object.create(null);return!l||!d||Object.keys(d).forEach(s=>{const t=l[s],n=d[s];h(t,n)||(S[s]=n)}),S}e.distinct=b;function m(l,d){const S=d.toLowerCase(),u=Object.keys(l).find(s=>s.toLowerCase()===S);return u?l[u]:l[d]}e.getCaseInsensitive=m;function v(l,d){const S=Object.create(null);for(const[u,s]of Object.entries(l))d(u,s)&&(S[u]=s);return S}e.filter=v;function p(l){let d=[],S=Object.getPrototypeOf(l);for(;Object.prototype!==S;)d=d.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return d}e.getAllPropertyNames=p;function P(l){const d=[];for(const S of p(l))typeof l[S]=="function"&&d.push(S);return d}e.getAllMethodNames=P;function y(l,d){const S=s=>function(){const t=Array.prototype.slice.call(arguments,0);return d(s,t)},u={};for(const s of l)u[s]=S(s);return u}e.createProxyObject=y}),define(Q[30],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return C.test(D)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(E){for(let g=0;g<E.length;g++)E[g]=Math.floor(Math.random()*256);return E};const k=new Uint8Array(16),O=[];for(let E=0;E<256;E++)O.push(E.toString(16).padStart(2,"0"));return function(){D(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,h="";return h+=O[k[g++]],h+=O[k[g++]],h+=O[k[g++]],h+=O[k[g++]],h+="-",h+=O[k[g++]],h+=O[k[g++]],h+="-",h+=O[k[g++]],h+=O[k[g++]],h+="-",h+=O[k[g++]],h+=O[k[g++]],h+="-",h+=O[k[g++]],h+=O[k[g++]],h+=O[k[g++]],h+=O[k[g++]],h+=O[k[g++]],h+=O[k[g++]],h}}()}),define(Q[70],Z([6,7]),function(_,e){return _.create("vs/base/common/date",e)}),define(Q[71],Z([0,1,70]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,k=D*24,O=k*7,E=k*30,g=k*365;function h(b,m,v){typeof b!="number"&&(b=b.getTime());const p=Math.round((new Date().getTime()-b)/1e3);if(p<-30)return(0,C.localize)(0,null,h(new Date().getTime()+p*1e3,!1));if(p<30)return(0,C.localize)(1,null);let P;return p<R?(P=p,m?P===1?v?(0,C.localize)(2,null,P):(0,C.localize)(3,null,P):v?(0,C.localize)(4,null,P):(0,C.localize)(5,null,P):P===1?v?(0,C.localize)(6,null,P):(0,C.localize)(7,null,P):v?(0,C.localize)(8,null,P):(0,C.localize)(9,null,P)):p<D?(P=Math.floor(p/R),m?P===1?v?(0,C.localize)(10,null,P):(0,C.localize)(11,null,P):v?(0,C.localize)(12,null,P):(0,C.localize)(13,null,P):P===1?v?(0,C.localize)(14,null,P):(0,C.localize)(15,null,P):v?(0,C.localize)(16,null,P):(0,C.localize)(17,null,P)):p<k?(P=Math.floor(p/D),m?P===1?v?(0,C.localize)(18,null,P):(0,C.localize)(19,null,P):v?(0,C.localize)(20,null,P):(0,C.localize)(21,null,P):P===1?v?(0,C.localize)(22,null,P):(0,C.localize)(23,null,P):v?(0,C.localize)(24,null,P):(0,C.localize)(25,null,P)):p<O?(P=Math.floor(p/k),m?P===1?(0,C.localize)(26,null,P):(0,C.localize)(27,null,P):P===1?(0,C.localize)(28,null,P):(0,C.localize)(29,null,P)):p<E?(P=Math.floor(p/O),m?P===1?v?(0,C.localize)(30,null,P):(0,C.localize)(31,null,P):v?(0,C.localize)(32,null,P):(0,C.localize)(33,null,P):P===1?v?(0,C.localize)(34,null,P):(0,C.localize)(35,null,P):v?(0,C.localize)(36,null,P):(0,C.localize)(37,null,P)):p<g?(P=Math.floor(p/E),m?P===1?v?(0,C.localize)(38,null,P):(0,C.localize)(39,null,P):v?(0,C.localize)(40,null,P):(0,C.localize)(41,null,P):P===1?v?(0,C.localize)(42,null,P):(0,C.localize)(43,null,P):v?(0,C.localize)(44,null,P):(0,C.localize)(45,null,P)):(P=Math.floor(p/g),m?P===1?v?(0,C.localize)(46,null,P):(0,C.localize)(47,null,P):v?(0,C.localize)(48,null,P):(0,C.localize)(49,null,P):P===1?v?(0,C.localize)(50,null,P):(0,C.localize)(51,null,P):v?(0,C.localize)(52,null,P):(0,C.localize)(53,null,P))}e.fromNow=h;function w(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=w}),define(Q[72],Z([6,7]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(Q[31],Z([0,1,19,5,72]),function(_,e,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(b,m){return m&&(b.stack||b.stacktrace)?D.localize(0,null,E(b),O(b.stack)||O(b.stacktrace)):E(b)}function O(b){return Array.isArray(b)?b.join(`
`):b}function E(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function g(b=null,m=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const v=C.coalesce(b),p=g(v[0],m);return v.length>1?D.localize(4,null,p,v.length):p}if(R.isString(b))return b;if(b.detail){const v=b.detail;if(v.error)return k(v.error,m);if(v.exception)return k(v.exception,m)}return b.stack?k(b,m):b.message?b.message:D.localize(5,null)}e.toErrorMessage=g;function h(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=h;function w(b,m){let v;return typeof b=="string"?v=new Error(b):v=b,v.actions=m,v}e.createErrorWithActions=w}),define(Q[73],Z([6,7]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(Q[74],Z([0,1,73]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(D){switch(D){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Q[51],Z([0,1,12]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var D;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(E,...g){const h=g.reduce((m,v)=>(m[v]=!0,m),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(m=>!h[m]).forEach(m=>{for(let v=0;v<w.length;v++)if(m.search(w[v])!==-1){delete E[m];break}})}e.sanitizeProcessEnvironment=k;function O(E){!E||(delete E.DEBUG,C.isMacintosh&&delete E.DYLD_LIBRARY_PATH,C.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(Q[52],Z([0,1,4,2]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=O=>({onDidChange:C.Event.None,value:O});e.staticObservableValue=D;class k extends R.Disposable{get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}constructor(E){super(),this._value=E,this.changeEmitter=this._register(new C.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=k}),define(Q[53],Z([0,1,27]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(l){return D(l,0)}e.hash=R;function D(l,d){switch(typeof l){case"object":return l===null?k(349,d):Array.isArray(l)?g(l,d):h(l,d);case"string":return E(l,d);case"boolean":return O(l,d);case"number":return k(l,d);case"undefined":return k(937,d);default:return k(617,d)}}e.doHash=D;function k(l,d){return(d<<5)-d+l|0}e.numberHash=k;function O(l,d){return k(l?433:863,d)}function E(l,d){d=k(149417,d);for(let S=0,u=l.length;S<u;S++)d=k(l.charCodeAt(S),d);return d}e.stringHash=E;function g(l,d){return d=k(104579,d),l.reduce((S,u)=>D(u,S),d)}function h(l,d){return d=k(181387,d),Object.keys(l).sort().reduce((S,u)=>(S=E(u,S),D(l[u],S)),d)}class w{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=D(d,this._value),this._value}}e.Hasher=w;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(l,d,S=32){const u=S-d,s=~((1<<u)-1);return(l<<d|(s&l)>>>u)>>>0}function v(l,d=0,S=l.byteLength,u=0){for(let s=0;s<S;s++)l[d+s]=u}function p(l,d,S="0"){for(;l.length<d;)l=S+l;return l}function P(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(S=>S.toString(16).padStart(2,"0")).join(""):p((l>>>0).toString(16),d/4)}e.toHexString=P;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const S=d.length;if(S===0)return;const u=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,n,i;for(t!==0?(n=t,i=-1,t=0):(n=d.charCodeAt(0),i=0);;){let r=n;if(C.isHighSurrogate(n))if(i+1<S){const o=d.charCodeAt(i+1);C.isLowSurrogate(o)?(i++,r=C.computeCodePoint(n,o)):r=65533}else{t=n;break}else C.isLowSurrogate(n)&&(r=65533);if(s=this._push(u,s,r),i++,i<S)n=d.charCodeAt(i);else break}this._buffLen=s,this._leftoverHighSurrogate=t}_push(d,S,u){return u<128?d[S++]=u:u<2048?(d[S++]=192|(u&1984)>>>6,d[S++]=128|(u&63)>>>0):u<65536?(d[S++]=224|(u&61440)>>>12,d[S++]=128|(u&4032)>>>6,d[S++]=128|(u&63)>>>0):(d[S++]=240|(u&1835008)>>>18,d[S++]=128|(u&258048)>>>12,d[S++]=128|(u&4032)>>>6,d[S++]=128|(u&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),P(this._h0)+P(this._h1)+P(this._h2)+P(this._h3)+P(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=y._bigBlock32,S=this._buffDV;for(let a=0;a<64;a+=4)d.setUint32(a,S.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,m(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let u=this._h0,s=this._h1,t=this._h2,n=this._h3,i=this._h4,r,o,c;for(let a=0;a<80;a++)a<20?(r=s&t|~s&n,o=1518500249):a<40?(r=s^t^n,o=1859775393):a<60?(r=s&t|s&n|t&n,o=2400959708):(r=s^t^n,o=3395469782),c=m(u,5)+r+i+o+d.getUint32(a*4,!1)&4294967295,i=n,n=t,t=m(s,30),s=u,u=c;this._h0=this._h0+u&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const k="error",O="warning",E="warn",g="info",h="ignore";function w(m){return m?C.equalsIgnoreCase(k,m)?D.Error:C.equalsIgnoreCase(O,m)||C.equalsIgnoreCase(E,m)?D.Warning:C.equalsIgnoreCase(g,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=w;function b(m){switch(m){case D.Error:return k;case D.Warning:return O;case D.Info:return g;default:return h}}D.toString=b}(R||(R={})),e.default=R}),define(Q[75],Z([0,1,8]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(h){const w=h;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.isRemoteConsoleLog=R;function D(h){const w=[];let b;try{const m=JSON.parse(h.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),b=v.__$stack),w.push(...m)}catch{w.push("Unable to log remote console arguments",h.arguments)}return{args:w,stack:b}}e.parse=D;function k(h){if(typeof h!="string")return k(D(h).stack);const w=h;if(w){const b=O(w),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:C.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function O(h){if(!h)return h;const w=h.indexOf(`
`);return w===-1?h:h.substring(0,w)}function E(h,w){const{args:b,stack:m}=D(h),v=typeof b[0]=="string"&&b.length===1;let p=O(m);p&&(p=`(${p.trim()})`);let P=[];if(typeof b[0]=="string"?p&&v?P=[`%c[${w}] %c${b[0]} %c${p}`,g("blue"),g(""),g("grey")]:P=[`%c[${w}] %c${b[0]}`,g("blue"),g(""),...b.slice(1)]:P=[`%c[${w}]%`,g("blue"),...b],p&&!v&&P.push(p),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,P)}e.log=E;function g(h){return`color: ${h}`}}),define(Q[44],Z([0,1,15,27,8]),function(_,e,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(h){return JSON.stringify(h,E)}e.stringify=k;function O(h){let w=JSON.parse(h);return w=g(w),w}e.parse=O;function E(h,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,R.regExpFlags)(w)}:w}function g(h,w=0){if(!h||w>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 15:return new Date(h.source)}if(h instanceof C.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let b=0;b<h.length;++b)h[b]=g(h[b],w+1);else for(const b in h)Object.hasOwnProperty.call(h,b)&&(h[b]=g(h[b],w+1))}return h}e.revive=g}),define(Q[76],Z([0,1,37,14,20]),function(_,e,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,O=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var g;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(g||(g={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class b{constructor(s,t,n){this.exePath=s,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:u=!1}={}){return u?h===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:u=!1,findPreview:s=!1}={}){const t=m({useAlternateBitness:u});if(!t)return null;const n=R.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const a of await D.Promises.readdir(n)){let f=-1;if(s){const N=a.indexOf("-");if(N<0)continue;const B=a.substring(0,N);if(!k.test(B)||a.substring(N+1)!=="preview")continue;f=parseInt(B,10)}else{if(!k.test(a))continue;f=parseInt(a,10)}if(f<=i)continue;const I=R.join(n,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(I)||(r=I,i=f)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",c=s?" Preview":"";return new b(r,`PowerShell${c}${o}`,!0)}async function p({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=u?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(s))if(t.test(i)){const r=R.join(s,i,"pwsh.exe");return new b(r,n)}return null}function P(){const u=R.join(C.homedir(),".dotnet","tools","pwsh.exe");return new b(u,".NET Core PowerShell Global Tool")}function y(){const u=R.join(process.env.windir,h===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(u,"Windows PowerShell",!0)}async function*l(){let u=await v();u&&(yield u),u=await v({useAlternateBitness:!0}),u&&(yield u),u=await p(),u&&(yield u),u=P(),u&&(yield u),u=await v({findPreview:!0}),u&&(yield u),u=await p({findPreview:!0}),u&&(yield u),u=await v({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=y(),u&&(yield u)}async function*d(){for await(const u of l())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=d;async function S(){for await(const u of d())return u;return null}e.getFirstAvailablePowerShellInstallation=S}),define(Q[55],Z([0,1,14,12,32,51,5,20]),function(_,e,C,R,D,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function g(b=D.env){return b.comspec||"cmd.exe"}e.getWindowsShell=g;function h(b){let m=[],v=!1;const p=function(P){if(v){m.push(P);return}(!b.send(P,l=>{if(l&&console.error(l),v=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(S=>p(S))}})||R.isWindows)&&(v=!0)};return{send:p}}e.createQueuedSender=h;var w;(function(b){async function m(v,p,P){if(C.isAbsolute(v))return v;if(p===void 0&&(p=D.cwd()),C.dirname(v)!=="."||(P===void 0&&O.isString(D.env.PATH)&&(P=D.env.PATH.split(C.delimiter)),P===void 0||P.length===0))return C.join(p,v);async function l(d){if(await E.Promises.exists(d)){let S;try{S=await E.Promises.stat(d)}catch(u){u.message.startsWith("EACCES")&&(S=await E.Promises.lstat(d))}return S?!S.isDirectory():!1}return!1}for(const d of P){let S;if(C.isAbsolute(d)?S=C.join(d,v):S=C.join(p,d,v),await l(S))return S;let u=S+".com";if(await l(u)||(u=S+".exe",await l(u)))return u}return C.join(p,v)}b.findExecutable=m})(w=e.win32||(e.win32={}))}),define(Q[77],Z([0,1,37,12,76,55]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function O(v,p){return v===1?R.isWindows?b():k.getWindowsShell(p):h(v,p)}e.getSystemShell=O;function E(v,p){return v===1?R.isWindows?m(p):k.getWindowsShell(p):h(v,p)}e.getSystemShellSync=E;let g=null;function h(v,p){if(R.isLinux&&v===2||R.isMacintosh&&v===3)return"/bin/bash";if(!g){let P;if(R.isWindows)P="/bin/bash";else{if(P=p.SHELL,!P)try{P=(0,C.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}g=P}return g}let w=null;async function b(){return w||(w=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),w}function m(v){if(w)return w;const p=R.isWindows&&parseFloat((0,C.release)())>=10,P=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${P?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return p?y:k.getWindowsShell(v)}});var he=this&&this.__decorate||function(_,e,C,R){var D=arguments.length,k=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,C):R,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(_,e,C,R);else for(var E=_.length-1;E>=0;E--)(O=_[E])&&(k=(D<3?O(k):D>3?O(e,C,k):O(e,C))||k);return D>3&&k&&Object.defineProperty(e,C,k),k};define(Q[56],Z([0,1,19,3,15,24,49,11,4,2,44,27,5]),function(_,e,C,R,D,k,O,E,g,h,w,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function p(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(P=e.ResponseType||(e.ResponseType={}));function y(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));class d{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class S{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var u;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(u||(u={}));function s(M){const F=D.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function t(M){return M.read(4).readUInt32BE(0)}function n(M){const F=D.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const i={Undefined:n(u.Undefined),String:n(u.String),Buffer:n(u.Buffer),VSBuffer:n(u.VSBuffer),Array:n(u.Array),Object:n(u.Object)},r=typeof Buffer<"u";function o(M,F){if(typeof F>"u")M.write(i.Undefined);else if(typeof F=="string"){const z=D.VSBuffer.fromString(F);M.write(i.String),M.write(s(z.byteLength)),M.write(z)}else if(r&&Buffer.isBuffer(F)){const z=D.VSBuffer.wrap(F);M.write(i.Buffer),M.write(s(z.byteLength)),M.write(z)}else if(F instanceof D.VSBuffer)M.write(i.VSBuffer),M.write(s(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(i.Array),M.write(s(F.length));for(const z of F)o(M,z)}else{const z=D.VSBuffer.fromString(JSON.stringify(F));M.write(i.Object),M.write(s(z.byteLength)),M.write(z)}}function c(M){switch(M.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return M.read(t(M)).toString();case u.Buffer:return M.read(t(M)).buffer;case u.VSBuffer:return M.read(t(M));case u.Array:{const z=t(M),$=[];for(let Y=0;Y<z;Y++)$.push(c(M));return $}case u.Object:return JSON.parse(M.read(t(M)).toString())}}class a{constructor(F,z,$=null,Y=1e3){this.protocol=F,this.ctx=z,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger?.logOutgoing(z,0,1,y(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(z,F.id,1,y(F.type),F.data);return}}}send(F,z=void 0){const $=new S;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const z=new d(F),$=c(z),Y=c(z),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=new k.CancellationTokenSource;let Y;try{Y=z.call(this.ctx,F.name,F.arg,$.token)}catch(L){Y=Promise.reject(L)}const A=F.id;Y.then(L=>{this.sendResponse({id:A,data:L,type:201}),this.activeRequests.delete(F.id)},L=>{L instanceof Error?this.sendResponse({id:A,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:A,data:L,type:203}),this.activeRequests.delete(F.id)});const x=(0,h.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,x)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=F.id,A=z.listen(this.ctx,F.name,F.arg)(x=>this.sendResponse({id:$,data:x,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var f;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class I{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=z}getChannel(F){const z=this;return{call($,Y,A){return z.isDisposed?Promise.reject(new E.CancellationError):z.requestPromise(F,$,Y,A)},listen($,Y){return z.isDisposed?g.Event.None:z.requestEvent(F,$,Y)}}}requestPromise(F,z,$,Y=k.CancellationToken.None){const A=this.lastRequestId++,L={id:A,type:100,channelName:F,name:z,arg:$};if(Y.isCancellationRequested)return Promise.reject(new E.CancellationError);let T;return new Promise((j,q)=>{if(Y.isCancellationRequested)return q(new E.CancellationError);const H=()=>{const ye=te=>{switch(te.type){case 201:this.handlers.delete(A),j(te.data);break;case 202:{this.handlers.delete(A);const se=new Error(te.data.message);se.stack=te.data.stack,se.name=te.data.name,q(se);break}case 203:this.handlers.delete(A),q(te.data);break}};this.handlers.set(A,ye),this.sendRequest(L)};let ae=null;this.state===l.Idle?H():(ae=(0,R.createCancelablePromise)(ye=>this.whenInitialized()),ae.then(()=>{ae=null,H()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:A,type:101}),q(new E.CancellationError)},pe=Y.onCancellationRequested(ce);T=(0,h.combinedDisposable)((0,h.toDisposable)(ce),pe),this.activeRequests.add(T)}).finally(()=>{this.activeRequests.delete(T)})}requestEvent(F,z,$){const Y=this.lastRequestId++,x={id:Y,type:102,channelName:F,name:z,arg:$};let L=null;const T=new g.Emitter({onFirstListenerAdd:()=>{L=(0,R.createCancelablePromise)(j=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(T),this.sendRequest(x)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(T),this.sendRequest({id:Y,type:103}))}}),U=j=>T.fire(j.data);return this.handlers.set(Y,U),T.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(z,F.id,0,`${p(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger?.logOutgoing(z,F.id,0,p(F.type));return}}}send(F,z=void 0){const $=new S;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const z=new d(F),$=c(z),Y=c(z),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,y(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,y(A),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([O.memoize],I.prototype,"onDidInitializePromise",null),e.ChannelClient=I;class N{get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:$})=>{g.Event.once(z.onMessage)(A=>{const x=new d(A),L=c(x),T=new a(z,L),U=new I(z);this.channels.forEach((q,H)=>T.registerChannel(H,q));const j={channelServer:T,channelClient:U,ctx:L};this._connections.add(j),this._onDidAddConnection.fire(j),$(()=>{T.dispose(),U.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}getChannel(F,z){const $=this;return{call(Y,A,x){let L;if((0,m.isFunction)(z)){const U=(0,C.getRandomElement)($.connections.filter(z));L=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter($.onDidAddConnection,z))}else L=z.routeCall($,Y,A);const T=L.then(U=>U.channelClient.getChannel(F));return K(T).call(Y,A,x)},listen(Y,A){if((0,m.isFunction)(z))return $.getMulticastEvent(F,z,Y,A);const x=z.routeEvent($,Y,A).then(L=>L.channelClient.getChannel(F));return K(x).listen(Y,A)}}}getMulticastEvent(F,z,$,Y){const A=this;let x=new h.DisposableStore;const L=new g.Emitter({onFirstListenerAdd:()=>{x=new h.DisposableStore;const T=new g.EventMultiplexer,U=new Map,j=H=>{const ce=H.channelClient.getChannel(F).listen($,Y),pe=T.add(ce);U.set(H,pe)},q=H=>{const ae=U.get(H);!ae||(ae.dispose(),U.delete(H))};A.connections.filter(z).forEach(j),g.Event.filter(A.onDidAddConnection,z)(j,void 0,x),A.onDidRemoveConnection(q,void 0,x),T.event(L.fire,L,x),x.add(T)},onLastListenerRemove:()=>{x.dispose()}});return L.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach($=>{$.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=N;class B{constructor(F,z,$=null){const Y=new S;o(Y,z),F.send(Y.buffer),this.channelClient=new I(F,$),this.channelServer=new a(F,z,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function K(M){return{call(F,z,$){return M.then(Y=>Y.call(F,z,$))},listen(F,z){const $=new g.Relay;return M.then(Y=>$.input=Y.listen(F,z)),$.event}}}e.getDelayedChannel=K;function J(M){let F=!1;return{call(z,$,Y){return F?M.call(z,$,Y):(0,R.timeout)(0).then(()=>F=!0).then(()=>M.call(z,$,Y))},listen(z,$){if(F)return M.listen(z,$);const Y=new g.Relay;return(0,R.timeout)(0).then(()=>F=!0).then(()=>Y.input=M.listen(z,$)),Y.event}}}e.getNextTickChannel=J;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await g.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=ne;var oe;(function(M){function F(A,x){const L=A,T=x&&x.disableMarshalling,U=new Map;for(const j in L)$(j)&&U.set(j,g.Event.buffer(L[j],!0));return new class{listen(j,q,H){const ae=U.get(q);if(ae)return ae;if(Y(q)){const ce=L[q];if(typeof ce=="function")return ce.call(L,H)}throw new Error(`Event not found: ${q}`)}call(j,q,H){const ae=L[q];if(typeof ae=="function"){if(!T&&Array.isArray(H))for(let ce=0;ce<H.length;ce++)H[ce]=(0,w.revive)(H[ce]);return ae.apply(L,H)}throw new Error(`Method not found: ${q}`)}}}M.fromService=F;function z(A,x){const L=x&&x.disableMarshalling;return new Proxy({},{get(T,U){if(typeof U=="string")return x?.properties?.has(U)?x.properties.get(U):Y(U)?function(j){return A.listen(U,j)}:$(U)?A.listen(U):async function(...j){let q;x&&!(0,m.isUndefinedOrNull)(x.context)?q=[x.context,...j]:q=j;const H=await A.call(U,q);return L?H:(0,w.revive)(H)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=z;function $(A){return A[0]==="o"&&A[1]==="n"&&b.isUpperAsciiLetter(A.charCodeAt(2))}function Y(A){return/^onDynamic/.test(A)&&b.isUpperAsciiLetter(A.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const F=M.toString();if(F!=="[object Object]")return F}return M}function le(M){return Array.isArray(M)?M.map(fe):fe(M)}function ie(M,F,z,$,Y,A,x){x=le(x);const L=re[Y],T=L[$%L.length];let U=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(A)?(U=U.concat(x),U.push(")")):U.push(x),console.log.apply(console,U)}e.logWithColors=ie;class W{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,$,Y,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,z,$,Y,A)}logIncoming(F,z,$,Y,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,z,$,Y,A)}}e.IPCLogger=W}),define(Q[78],Z([0,1,57,3,15,24,75,11,4,2,26,55,51,56]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends v.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=p;class P{constructor(l,d){this.modulePath=l,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new R.Delayer(S),this.child=null,this._client=null}getChannel(l){const d=this;return{call(S,u,s){return d.requestPromise(l,S,u,s)},listen(S,u){return d.requestEvent(l,S,u)}}}requestPromise(l,d,S,u=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),t=(0,R.createCancelablePromise)(r=>s.call(d,S,r)),n=u.onCancellationRequested(()=>t.cancel()),i=(0,h.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(l,d,S){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let u;const s=new g.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(l).listen(d,S)(s.fire,s),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(d.env),this.child=(0,C.fork)(this.modulePath,l,d);const S=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,O.isRemoteConsoleLog)(o)){(0,O.log)(o,`IPC Library: ${this.options.serverName}`);return}S.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=S.event,i={send:t,onMessage:n};this._client=new v.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,h.dispose)(a)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(l){let d=this.channels.get(l);return d||(d=this.client.getChannel(l),this.channels.set(l,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=P}),define(Q[79],Z([0,1,3,4,2,5]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));function E(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var g;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class h extends D.Disposable{constructor(m,v=Object.create(null)){super(),this.database=m,this.options=v,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((v,p)=>this.accept(p,v)),m.deleted?.forEach(v=>this.accept(v,void 0))}accept(m,v){if(this.state===g.Closed)return;let p=!1;(0,k.isUndefinedOrNull)(v)?p=this.cache.delete(m):this.cache.get(m)!==v&&(this.cache.set(m,v),p=!0),p&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,v){const p=this.cache.get(m);return(0,k.isUndefinedOrNull)(p)?v:p}getBoolean(m,v){const p=this.get(m);return(0,k.isUndefinedOrNull)(p)?v:p==="true"}getNumber(m,v){const p=this.get(m);return(0,k.isUndefinedOrNull)(p)?v:parseInt(p,10)}async set(m,v){if(this.state===g.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(m);const p=String(v);if(this.cache.get(m)!==p)return this.cache.set(m,p),this.pendingInserts.set(m,p),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===g.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((v,p)=>this.items.set(p,v)),m.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=w}),define(Q[80],Z([6,7]),function(_,e){return _.create("vs/base/node/zip",e)}),define(Q[81],Z([6,7]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[82],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[83],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[84],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[85],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[86],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[87],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[88],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[89],Z([6,7]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[90],Z([6,7]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(Q[91],Z([6,7]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(Q[92],Z([6,7]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[93],Z([6,7]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[94],Z([6,7]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(Q[95],Z([6,7]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(Q[96],Z([6,7]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[97],Z([6,7]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[98],Z([6,7]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(Q[99],Z([0,1,71,49,17,14,32,18,8]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("",_).fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const P=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",P)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(g.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const P=O.env.VSCODE_PORTABLE;return P?g.URI.file((0,k.join)(P,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const P=this.args["builtin-extensions-dir"];return P?(0,k.resolve)(P):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const P=this.args["extensions-download-dir"];return P?(0,k.resolve)(P):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const P=this.args["extensions-dir"];if(P)return(0,k.resolve)(P);const y=O.env.VSCODE_EXTENSIONS;if(y)return y;const l=O.env.VSCODE_PORTABLE;return l?(0,k.join)(l,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const P=this.args.extensionDevelopmentPath;if(Array.isArray(P))return P.map(y=>/^[^:/?#]+?:\/\//.test(y)?g.URI.parse(y):g.URI.file((0,k.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(P=>P==="ui"||P==="workspace"||P==="web"?P:"workspace")}get extensionTestsLocationURI(){const P=this.args.extensionTestsPath;if(P)return/^[^:/?#]+?:\/\//.test(P)?g.URI.parse(P):g.URI.file((0,k.normalize)(P))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const P=this.args["disable-extension"];if(P){if(typeof P=="string")return[P];if(Array.isArray(P)&&P.length>0)return P}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(P=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(P))}get extensionLogLevel(){const P=[];for(const y of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);l&&l[1]&&l[2]&&P.push([l[1],l[2]])}return P.length?P:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const P=O.env.VSCODE_PORTABLE;return P?g.URI.file((0,k.join)(P,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(P){this.args.continueOn=P}get args(){return this._args}constructor(P,y,l){this._args=P,this.paths=y,this.productService=l,this.editSessionId=this.args.editSessionId}}he([R.memoize],h.prototype,"appRoot",null),he([R.memoize],h.prototype,"userHome",null),he([R.memoize],h.prototype,"userDataPath",null),he([R.memoize],h.prototype,"appSettingsHome",null),he([R.memoize],h.prototype,"tmpDir",null),he([R.memoize],h.prototype,"cacheHome",null),he([R.memoize],h.prototype,"stateResource",null),he([R.memoize],h.prototype,"userRoamingDataHome",null),he([R.memoize],h.prototype,"userDataSyncHome",null),he([R.memoize],h.prototype,"userDataSyncLogResource",null),he([R.memoize],h.prototype,"editSessionsLogResource",null),he([R.memoize],h.prototype,"sync",null),he([R.memoize],h.prototype,"machineSettingsResource",null),he([R.memoize],h.prototype,"workspaceStorageHome",null),he([R.memoize],h.prototype,"localHistoryHome",null),he([R.memoize],h.prototype,"keyboardLayoutResource",null),he([R.memoize],h.prototype,"argvResource",null),he([R.memoize],h.prototype,"isExtensionDevelopment",null),he([R.memoize],h.prototype,"untitledWorkspacesHome",null),he([R.memoize],h.prototype,"installSourcePath",null),he([R.memoize],h.prototype,"builtinExtensionsPath",null),he([R.memoize],h.prototype,"extensionsPath",null),he([R.memoize],h.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],h.prototype,"extensionDevelopmentKind",null),he([R.memoize],h.prototype,"extensionTestsLocationURI",null),he([R.memoize],h.prototype,"debugExtensionHost",null),he([R.memoize],h.prototype,"logLevel",null),he([R.memoize],h.prototype,"extensionLogLevel",null),he([R.memoize],h.prototype,"serviceMachineIdResource",null),he([R.memoize],h.prototype,"telemetryLogResource",null),he([R.memoize],h.prototype,"disableWorkspaceTrust",null),he([R.memoize],h.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=h;function w(p,P){return v(p["inspect-extensions"],p["inspect-brk-extensions"],5870,P,p.debugId,p.extensionEnvironment)}e.parseExtensionHostPort=w;function b(p,P){return v(p["inspect-search"],p["inspect-brk-search"],5876,P,p.extensionEnvironment)}e.parseSearchPort=b;function m(p,P){return v(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,P,p.extensionEnvironment)}e.parsePtyHostPort=m;function v(p,P,y,l,d,S){const s=Number(P||p)||(l?null:y),t=s?Boolean(!!P):!1;let n;if(S)try{n=JSON.parse(S)}catch{}return{port:s,break:t,debugId:d,env:n}}}),function(){"use strict";function _(e,C,R){function D(O,E){const g=k(O,E),h=[g];return e.isAbsolute(g)||h.unshift(R),e.resolve(...h)}function k(O,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,E);const w=O["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(b,"AppData","Roaming")}break;case"darwin":h=e.join(C.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,E)}return{getUserDataPath:D}}if(typeof define=="function")define(Q[100],Z([150,37,32]),function(e,C,R){return _(e,C,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),C=require("os");module.exports=_(e,C,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,37,99,100]),function(_,e,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(E,g){super(E,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E,g.nameShort)},g)}}e.NativeEnvironmentService=k}),define(Q[102],Z([0,1,5,85]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(O,E,g){try{k(O,E,g)}catch{}return O}e.localizeManifest=D;function k(O,E,g){const h=(w,b,m)=>{const v=w[b];if((0,C.isString)(v)){const p=v,P=p.length;if(P>1&&p[0]==="%"&&p[P-1]==="%"){const y=p.substr(1,P-2);let l=E[y];l===void 0&&g&&(l=g[y]);const d=typeof l=="string"?l:l.message;if(d!==void 0){const S=g?.[y],u=typeof S=="string"?S:S?.message;if(m&&(b==="title"||b==="category")&&u&&u!==d){const s={value:d,original:u};w[b]=s}else w[b]=d}else console.warn(`[${O.name}]: ${(0,R.localize)(0,null,y)}`)}}else if((0,C.isObject)(v))for(const p in v)v.hasOwnProperty(p)&&(p==="commands"?h(v,p,!0):h(v,p,m));else if(Array.isArray(v))for(let p=0;p<v.length;p++)h(v,p,m)};for(const w in O)O.hasOwnProperty(w)&&h(O,w)}}),define(Q[45],Z([0,1,18,54,89,38]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function g(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=g;function h(l){if(!g(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=h;function w(l){if(!l)return null;const d=l.majorBase,S=l.majorMustEqual,u=l.minorBase;let s=l.minorMustEqual;const t=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(d===0||(s=!1),n=!1);let i=0;if(l.preRelease){const r=E.exec(l.preRelease);if(r){const[,o,c,a]=r;i=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:d,majorMustEqual:S,minorBase:u,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=w;function b(l,d,S){let u;typeof l=="string"?u=w(h(l)):u=l;let s;d instanceof Date?s=d.getTime():typeof d=="string"&&(s=new Date(d).getTime());let t;if(typeof S=="string"?t=w(h(S)):t=S,!u||!t)return!1;const n=u.majorBase,i=u.minorBase,r=u.patchBase;let o=t.majorBase,c=t.minorBase,a=t.patchBase;const f=t.notBefore;let I=t.majorMustEqual,N=t.minorMustEqual,B=t.patchMustEqual;return t.isMinimum?n>o?!0:n<o?!1:i>c?!0:i<c||s&&s<f?!1:r>=a:(n===1&&o===0&&(!I||!N||!B)&&(o=1,c=0,a=0,I=!0,N=!1,B=!1),n<o?!1:n>o?!I:i<c?!1:i>c?!N:r<a?!1:r>a?!B:!(s&&s<f))}e.isValidVersion=b;function m(l,d,S,u,s){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([R.default.Error,D.localize(0,null)]),t;if(typeof u.name!="string")return t.push([R.default.Error,D.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([R.default.Error,D.localize(2,null,"version")]),t;if(!u.engines)return t.push([R.default.Error,D.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([R.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!y(u.extensionDependencies))return t.push([R.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!y(u.activationEvents))return t.push([R.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([R.default.Error,D.localize(7,null,"activationEvents","main")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([R.default.Warning,D.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([R.default.Error,D.localize(9,null,"main")]),t;{const r=(0,C.joinPath)(S,u.main);(0,C.isEqualOrParent)(r,S)||t.push([R.default.Warning,D.localize(10,null,r.path,S.path)])}if(typeof u.activationEvents>"u")return t.push([R.default.Error,D.localize(11,null,"activationEvents","main")]),t}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([R.default.Error,D.localize(12,null,"browser")]),t;{const r=(0,C.joinPath)(S,u.browser);(0,C.isEqualOrParent)(r,S)||t.push([R.default.Warning,D.localize(13,null,r.path,S.path)])}if(typeof u.activationEvents>"u")return t.push([R.default.Error,D.localize(14,null,"activationEvents","browser")]),t}if(!k.valid(u.version))return t.push([R.default.Error,D.localize(15,null)]),t;const n=[];if(!v(l,d,u,s,n))for(const r of n)t.push([R.default.Error,r]);return t}e.validateExtensionManifest=m;function v(l,d,S,u,s){return u||typeof S.main>"u"&&typeof S.browser>"u"?!0:P(l,d,S.engines.vscode,s)}e.isValidExtensionVersion=v;function p(l,d,S){return l==="*"||P(d,S,l)}e.isEngineValid=p;function P(l,d,S,u=[]){const s=w(h(S));if(!s)return u.push(D.localize(16,null,S)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return u.push(D.localize(17,null,S)),!1}else if(!s.majorMustEqual)return u.push(D.localize(18,null,S)),!1;return b(l,d,s)?!0:(u.push(D.localize(19,null,l,S)),!1)}function y(l){if(!Array.isArray(l))return!1;for(let d=0,S=l.length;d<S;d++)if(typeof l[d]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,O,E){let g=E&&E.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const w=(await O.readFile(k.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(w)?w:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await O.writeFile(k.serviceMachineIdResource,C.VSBuffer.fromString(g))}catch{}}return E?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=D}),define(Q[46],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(D,k=[],O=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=C}),define(Q[104],Z([0,1,46]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var D;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function k(E,g,h){g instanceof C.SyncDescriptor||(g=new C.SyncDescriptor(g,[],Boolean(h))),R.push([E,g])}e.registerSingleton=k;function O(){return R}e.getSingletonServiceDescriptors=O}),define(Q[105],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(k,O){this.key=k,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=C;class R{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const O of this._nodes.values())O.outgoing.size===0&&k.push(O);return k}insertEdge(k,O){const E=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(O);E.outgoing.set(g.key,g),g.incoming.set(E.key,E)}removeNode(k){const O=this._hashFn(k);this._nodes.delete(O);for(const E of this._nodes.values())E.outgoing.delete(O),E.incoming.delete(O)}lookupOrInsertNode(k){const O=this._hashFn(k);let E=this._nodes.get(O);return E||(E=new C(O,k),this._nodes.set(O,E)),E}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[O,E]of this._nodes)k.push(`${O}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,O]of this._nodes){const E=new Set([k]),g=this._findCycle(O,E);if(g)return g}}_findCycle(k,O){for(const[E,g]of k.outgoing){if(O.has(E))return[...O,E].join(" -> ");O.add(E);const h=this._findCycle(g,O);if(h)return h;O.delete(E)}}}e.Graph=R}),define(Q[21],Z([0,1,5,8,9]),function(_,e,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof R.URI)}e.isConfigurationOverrides=k;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=O;var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function h(l,d){const S=Object.create(null);for(const u in l)w(S,u,l[u],d);return S}e.toValuesTree=h;function w(l,d,S,u){const s=d.split("."),t=s.pop();let n=l;for(let i=0;i<s.length;i++){const r=s[i];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:u(`Ignoring ${d} as ${s.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[t]=S}catch{u(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}else u(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=w;function b(l,d){const S=d.split(".");m(l,S)}e.removeFromValueTree=b;function m(l,d){const S=d.shift();if(d.length===0){delete l[S];return}if(Object.keys(l).indexOf(S)!==-1){const u=l[S];typeof u=="object"&&!Array.isArray(u)&&(m(u,d),Object.keys(u).length===0&&delete l[S])}}function v(l,d,S){function u(n,i){let r=n;for(const o of i){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=d.split("."),t=u(l,s);return typeof t>"u"?S:t}e.getConfigurationValue=v;function p(l,d,S){Object.keys(d).forEach(u=>{u!=="__proto__"&&(u in l?C.isObject(l[u])&&C.isObject(d[u])?p(l[u],d[u],S):S&&(l[u]=d[u]):l[u]=d[u])})}e.merge=p;function P(l,d,S){const u=l.inspect(d),s=l.inspect(S);return typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:u.defaultValue}e.getMigratedSettingValue=P;function y(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(Q[58],Z([0,1,9]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[16],Z([0,1,9]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[22],Z([0,1,83,9]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function k(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function O(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function E(l,d){return d==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function g(l,d,S){return E(d,S)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===S?!0:h(S).includes(l)}e.isTargetPlatformCompatible=g;function h(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function w(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=w;var b;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var p;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var P;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(d,S){super(d),this.code=S,this.name=S}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,C.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,15,11,91,13]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(w,b,m,v,p,P){let y;try{await E(w,b,m,v,p,P)}catch(l){y=l}finally{y&&p.errorTransformer&&(y=p.errorTransformer(y)),typeof y<"u"&&m.error(y),m.end()}}e.readFileIntoStream=O;async function E(w,b,m,v,p,P){g(P);const y=await w.open(b,{create:!1});try{g(P);let l=0,d=0,S=p&&typeof p.length=="number"?p.length:void 0,u=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof S=="number"?S:p.bufferSize)),s=p&&typeof p.position=="number"?p.position:0,t=0;do d=await w.read(y,s,u.buffer,t,u.byteLength-t),s+=d,t+=d,l+=d,typeof S=="number"&&(S-=d),t===u.byteLength&&(await m.write(v(u)),u=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof S=="number"?S:p.bufferSize)),t=0);while(d>0&&(typeof S!="number"||S>0)&&g(P)&&h(l,p));if(t>0){let n=t;typeof S=="number"&&(n=Math.min(t,S)),m.write(v(u.slice(0,n)))}}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await w.close(y)}}function g(w){if(w.isCancellationRequested)throw(0,R.canceled)();return!0}function h(w,b){if(b?.limits){if(typeof b.limits.memory=="number"&&w>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&w>b.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,151,2,12,152]),function(_,e,C,R,D,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(h){const w=this.normalizeRequests(h),b=w.filter(v=>{const p=this.watchers.get(v.path);return p?!(0,R.patternsEquals)(p.request.excludes,v.excludes)||!(0,R.patternsEquals)(p.request.includes,v.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:v})=>!w.find(p=>p.path===v.path&&(0,R.patternsEquals)(p.excludes,v.excludes)&&(0,R.patternsEquals)(p.includes,v.includes))).map(({request:v})=>v.path);b.length&&this.trace(`Request to start watching: ${b.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.stopWatching(v);for(const v of b)this.startWatching(v)}startWatching(h){const w=new O.NodeJSFileWatcherLibrary(h,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),b={request:h,instance:w};this.watchers.set(h.path,b)}async stop(){for(const[h]of this.watchers)this.stopWatching(h);this.watchers.clear()}stopWatching(h){const w=this.watchers.get(h);w&&(this.watchers.delete(h),w.instance.dispose())}normalizeRequests(h){const w=new Map;for(const b of h){const m=k.isLinux?b.path:b.path.toLowerCase();w.set(m,b)}return Array.from(w.values())}async setVerboseLogging(h){this.verboseLogging=h;for(const[,w]of this.watchers)w.instance.setVerboseLogging(h)}trace(h){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h)})}toMessage(h,w){return w?`[File Watcher (node.js)] ${h} (path: ${w.request.path})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=E}),define(Q[107],Z([0,1,60,106]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends C.AbstractNonRecursiveWatcherClient{constructor(O,E,g){super(O,E,g),this.init()}createWatcher(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(Q[108],Z([0,1,17,56,78,60]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends k.AbstractUniversalWatcherClient{constructor(g,h,w){super(g,h,w),this.init()}createWatcher(g){const h=g.add(new D.Client(C.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(h.onDidProcessExit(({code:w,signal:b})=>this.onError(`terminated by itself with code ${w}, signal: ${b}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(h.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(Q[61],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...D){this._entries=new Map;for(const[k,O]of D)this.set(k,O)}set(D,k){const O=this._entries.get(D);return this._entries.set(D,k),O}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=C}),define(Q[109],Z([0,1,3,11,2,46,105,9,61,153]),function(_,e,C,R,D,k,O,E,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class b extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class m{constructor(y=new g.ServiceCollection,l=!1,d,S=w){this._services=y,this._strict=l,this._parent=d,this._enableTracing=S,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=S?d?._globalGraph??new O.Graph(u=>u):void 0}createChild(y){return new m(y,this._strict,this,this._enableTracing)}invokeFunction(y,...l){const d=p.traceInvocation(this._enableTracing,y);let S=!1;try{return y({get:s=>{if(S)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(s,d);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...l)}finally{S=!0,d.stop()}}createInstance(y,...l){let d,S;return y instanceof k.SyncDescriptor?(d=p.traceCreation(this._enableTracing,y.ctor),S=this._createInstance(y.ctor,y.staticArguments.concat(l),d)):(d=p.traceCreation(this._enableTracing,y),S=this._createInstance(y,l,d)),d.stop(),S}_createInstance(y,l=[],d){const S=E._util.getServiceDependencies(y).sort((t,n)=>t.index-n.index),u=[];for(const t of S){const n=this._getOrCreateServiceInstance(t.id,d);n||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(n)}const s=S.length>0?S[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${y.name} at position ${s+1} conflicts with ${l.length} static arguments`);const t=s-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,s)}return Reflect.construct(y,l.concat(u))}_setServiceInstance(y,l){if(this._services.get(y)instanceof k.SyncDescriptor)this._services.set(y,l);else if(this._parent)this._parent._setServiceInstance(y,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const l=this._services.get(y);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):l}_getOrCreateServiceInstance(y,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const d=this._getServiceInstanceOrDescriptor(y);return d instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,d,l.branch(y,!0)):(l.branch(y,!1),d)}_safeCreateAndCacheServiceInstance(y,l,d){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,l,d)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,l,d){const S=new O.Graph(t=>t.id.toString());let u=0;const s=[{id:y,desc:l,_trace:d}];for(;s.length;){const t=s.pop();if(S.lookupOrInsertNode(t),u++>1e3)throw new b(S);for(const n of E._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(n.id);if(i||this._throwIfStrict(`[createInstance] ${y} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),i instanceof k.SyncDescriptor){const r={id:n.id,desc:i,_trace:t._trace.branch(n.id,!0)};S.insertEdge(t,r),s.push(r)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new b(S);break}for(const{data:n}of t){if(this._getServiceInstanceOrDescriptor(n.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setServiceInstance(n.id,r)}S.removeNode(n)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,l,d=[],S,u){if(this._services.get(y)instanceof k.SyncDescriptor)return this._createServiceInstance(y,l,d,S,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,l,d,S,u);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(y,l,d=[],S,u){if(S){const s=new m(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(y);const t=new Map,n=new C.IdleValue(()=>{const i=s._createInstance(l,d,u);for(const[r,o]of t){const c=i[r];if(typeof c=="function")for(const a of o)c.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=t.get(r);return a||(a=new h.LinkedList,t.set(r,a)),(I,N,B)=>{const K=a.push([I,N,B]);return(0,D.toDisposable)(K)}}if(r in i)return i[r];const o=n.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),i[r]=c),c},set(i,r,o){return n.value[r]=o,!0}})}else return this._createInstance(l,d,u)}_throwIfStrict(y,l){if(l&&console.warn(y),this._strict)throw new Error(y)}}e.InstantiationService=m;var v;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(v||(v={}));class p{static traceInvocation(y,l){return y?new p(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(y,l){return y?new p(0,l.name):p._None}constructor(y,l){this.type=y,this.name=l,this._start=Date.now(),this._dep=[]}branch(y,l){const d=new p(2,y.toString());return this._dep.push([y,l,d]),d}stop(){const y=Date.now()-this._start;p._totals+=y;let l=!1;function d(u,s){const t=[],n=new Array(u+1).join("	");for(const[i,r,o]of s._dep)if(r&&o){l=!0,t.push(`${n}CREATES -> ${i}`);const c=d(u+1,o);c&&t.push(c)}else t.push(`${n}uses -> ${i}`);return t.join(`
`)}const S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(y>2||l)&&p.all.add(S.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0});var ee=this&&this.__param||function(_,e){return function(C,R){e(C,R,_)}};define(Q[62],Z([0,1,24,2,12,93,22,9]),function(_,e,C,R,D,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,E.createDecorator)("languagePackService");let g=class extends R.Disposable{constructor(w){super(),this.extensionGalleryService=w}async getAvailableLanguages(){const w=new C.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const v=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(P=>P.startsWith("lp-"))).map(p=>{const P=p.properties.localizedLanguages?.[0],y=this.getLocale(p);return{...this.createQuickPickItem(y,P,p),extensionId:p.identifier.id,galleryExtension:p}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(w){return w.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(w,b,m){const v=b??w;let p;if(v!==w&&(p=`(${w})`),w.toLowerCase()===D.language.toLowerCase()&&(p??="",p+=(0,k.localize)(0,null)),m?.installCount){p??="";const P=m.installCount;let y;P>1e6?y=`${Math.floor(P/1e5)/10}M`:P>1e3?y=`${Math.floor(P/1e3)}K`:y=String(P),p+=` $(cloud-download) ${y}`}return{id:w,label:v,description:p}}};g=he([ee(0,O.IExtensionGalleryService)],g),e.LanguagePackBaseService=g}),define(Q[10],Z([0,1,31,4,2,39,12,8,9]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function h(){return new Date().toISOString()}var w;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function b(c,a,f){switch(a){case w.Trace:c.trace(f);break;case w.Debug:c.debug(f);break;case w.Info:c.info(f);break;case w.Warning:c.warn(f);break;case w.Error:c.error(f);break;case w.Critical:c.critical(f);break;default:throw new Error("Invalid log level")}}e.log=b;function m(c){let a="";for(let f=0;f<c.length;f++){let I=c[f];if(typeof I=="object")try{I=JSON.stringify(I)}catch{}a+=(f>0?" ":"")+I}return a}e.format=m;class v extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class p extends v{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...f){this.checkLogLevel(w.Trace)&&this.log(w.Trace,m([a,...f]))}debug(a,...f){this.checkLogLevel(w.Debug)&&this.log(w.Debug,m([a,...f]))}info(a,...f){this.checkLogLevel(w.Info)&&this.log(w.Info,m([a,...f]))}warn(a,...f){this.checkLogLevel(w.Warning)&&this.log(w.Warning,m([a,...f]))}error(a,...f){if(this.checkLogLevel(w.Error))if(a instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=a.stack,this.log(w.Error,m(I))}else this.log(w.Error,m([a,...f]))}critical(a,...f){this.checkLogLevel(w.Critical)&&this.log(w.Critical,m([a,...f]))}flush(){}}e.AbstractMessageLogger=p;class P extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!O.isWindows}trace(a,...f){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.log(`[main ${h()}]`,a,...f))}debug(a,...f){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.log(`[main ${h()}]`,a,...f))}info(a,...f){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.log(`[main ${h()}]`,a,...f))}warn(a,...f){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,a,...f):console.warn(`[main ${h()}]`,a,...f))}error(a,...f){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,a,...f):console.error(`[main ${h()}]`,a,...f))}critical(a,...f){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.error(`[main ${h()}]`,a,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class y extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...f){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",a,...f)}debug(a,...f){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...f)}info(a,...f){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",a,...f)}warn(a,...f){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",a,...f)}error(a,...f){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",a,...f)}critical(a,...f){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...f)}dispose(){}flush(){}}e.ConsoleLogger=y;class l extends v{constructor(a,f=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(f)}trace(a,...f){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(a),...f])}debug(a,...f){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(a),...f])}info(a,...f){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(a),...f])}warn(a,...f){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(a),...f])}error(a,...f){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(a),...f])}critical(a,...f){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(a),...f])}extractMessage(a){return typeof a=="string"?a:(0,C.toErrorMessage)(a,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=l;class d extends v{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const f of this.logServices)f.setLevel(a);super.setLevel(a)}trace(a,...f){for(const I of this.logServices)I.trace(a,...f)}debug(a,...f){for(const I of this.logServices)I.debug(a,...f)}info(a,...f){for(const I of this.logServices)I.info(a,...f)}warn(a,...f){for(const I of this.logServices)I.warn(a,...f)}error(a,...f){for(const I of this.logServices)I.error(a,...f)}critical(a,...f){for(const I of this.logServices)I.critical(a,...f)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=d;class S extends D.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...f){this.logger.trace(a,...f)}debug(a,...f){this.logger.debug(a,...f)}info(a,...f){this.logger.info(a,...f)}warn(a,...f){this.logger.warn(a,...f)}error(a,...f){this.logger.error(a,...f)}critical(a,...f){this.logger.critical(a,...f)}flush(){this.logger.flush()}}e.LogService=S;class u extends D.Disposable{constructor(a,f){super(),this.logLevel=a,this.loggerItems=new k.ResourceMap,this._register(f(I=>this.setLevel(I)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,f,I){let N=this.loggerItems.get(a)?.logger;return N||(I=f?.always?w.Trace:I,N=this.doCreateLogger(a,I??this.logLevel,f),this.loggerItems.set(a,{logger:N,logLevel:I})),N}setLevel(a,f){const I=E.URI.isUri(a)?a:void 0,N=I?f:a;if(I){const B=this.loggerItems.get(I);B&&B.logLevel!==N&&(B.logLevel=N,B.logger.setLevel(N))}else this.logLevel=N,this.loggerItems.forEach(({logLevel:B,logger:K})=>{B===void 0&&K.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=u;class s{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(a){}getLevel(){return w.Info}trace(a,...f){}debug(a,...f){}info(a,...f){}warn(a,...f){}error(a,...f){}critical(a,...f){}dispose(){}flush(){}}e.NullLogger=s;class t extends s{}e.NullLogService=t;class n extends u{constructor(){super(w.Info,R.Event.None)}doCreateLogger(a,f,I){return new s}}e.NullLoggerService=n;function i(c){if(c.verbose)return w.Trace;if(typeof c.logLevel=="string"){const a=r(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function r(c){switch(c){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=r;function o(c){switch(c){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=o}),define(Q[110],Z([0,1,19,3,11,4,2,14,60,10]),function(_,e,C,R,D,k,O,E,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class w extends O.Disposable{constructor(m,v){super(),this.logService=m,this.options=v,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(m,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,v):this.watchNonRecursive(m,v)}watchUniversal(m,v){const p={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive},P=(0,C.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,O.toDisposable)(()=>{P(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,g.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(v)&&m.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,v){const p={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:!1},P=(0,C.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,O.toDisposable)(()=>{P(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,g.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,E.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=w}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,112,17,113,18,43,90,13,59,10]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends h.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${s}`);const n=new h.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(i=>this._onDidFilesChange.fire(new y.FileChangesEvent(i,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,h.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){t.push(n)}}),!this.provider.has(s)&&await R.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return g.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,v.isAbsolutePath)(s))throw new y.FileOperationError((0,P.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const n=new Error;throw n.name="ENOPRO",n.message=(0,P.localize)(1,null,s.toString()),n}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)||(0,y.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(n){throw(0,y.toFileSystemProviderErrorCode)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,P.localize)(2,null,this.resourceForError(s)),1):(0,y.ensureFileSystemProviderError)(n)}}async doResolveFile(s,t){const n=await this.withProvider(s),i=this.isPathCaseSensitive(n),r=t?.resolveTo,o=t?.resolveSingleChildDescendants,c=t?.resolveMetadata,a=await n.stat(s);let f;return this.toFileStat(n,s,a,void 0,!!c,(I,N)=>(f||(f=w.TernarySearchTree.forUris(()=>!i),f.set(s,!0),r&&f.fill(!0,r)),f.get(I.resource)||f.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&o?N===1:!1))}async toFileStat(s,t,n,i,r,o){const{providerExtUri:c}=this.getExtUri(s),a={resource:t,name:c.basename(t),isFile:(n.type&y.FileType.File)!==0,isDirectory:(n.type&y.FileType.Directory)!==0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const f=await s.readdir(t),I=await R.Promises.settled(f.map(async([N,B])=>{try{const K=c.joinPath(t,N),J=r?await s.stat(K):{type:B};return await this.toFileStat(s,K,J,f.length,r,o)}catch(K){return this.logService.trace(K),null}}));a.children=(0,C.coalesce)(I)}catch(f){this.logService.trace(f),a.children=[]}return a}return a}async resolveAll(s){return R.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),n=await t.stat(s);return this.toFileStat(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(n){return n}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,P.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const i=await this.writeFile(s,t);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,i)),i}async writeFile(s,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,s,n)||await this.mkdirp(i,r.dirname(s));let c;if((0,y.hasReadWriteCapability)(i)&&!(t instanceof D.VSBuffer))if((0,p.isReadableStream)(t)){const a=await(0,p.peekStream)(t,3);a.ended?c=D.VSBuffer.concat(a.buffer):c=a}else c=(0,p.peekReadable)(t,a=>D.VSBuffer.concat(a),3);else c=t;!(0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)&&c instanceof D.VSBuffer?await this.doWriteUnbuffered(i,s,n,c):await this.doWriteBuffered(i,s,n,c instanceof D.VSBuffer?(0,D.bufferToReadable)(c):c),this._onDidRunOperation.fire(new y.FileOperationEvent(s,4))}catch(o){throw new y.FileOperationError((0,P.localize)(4,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,P.localize)(5,null,this.resourceForError(t)));let r;try{r=await s.stat(t)}catch{return}if((r.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,P.localize)(6,null,this.resourceForError(t)),0,n);if(this.throwIfFileIsReadonly(t,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,y.etag)({mtime:n.mtime,size:r.size}))throw new y.FileOperationError((0,P.localize)(7,null),3,n);return r}async readFile(s,t,n){const i=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(i,s,t,n):this.doReadFile(i,s,t,n)}async doReadFileAtomic(s,t,n,i){return new Promise((r,o)=>{this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(s,t,n,i);r(c)}catch(c){o(c)}})})}async doReadFile(s,t,n,i){const r=await this.doReadFileStream(s,t,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(s,t,n){const i=await this.withReadProvider(s);return this.doReadFileStream(i,s,t,n)}async doReadFileStream(s,t,n,i){const r=new k.CancellationTokenSource(i),o=this.validateReadFile(t,n).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&await o,n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)||!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&n?.preferUnbuffered?c=this.readFileUnbuffered(s,t,n):(0,y.hasFileReadStreamCapability)(s)?c=this.readFileStreamed(s,t,r.token,n):c=this.readFileBuffered(s,t,r.token,n),{...await o,value:c}}catch(a){c&&await(0,p.consumeStream)(c);const f=(0,P.localize)(8,null,this.resourceForError(t),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(f,a.stat,n):new y.FileOperationError(f,(0,y.toFileOperationResult)(a),n)}}readFileStreamed(s,t,n,i=Object.create(null)){const r=s.readFileStream(t,i,n);return(0,p.transform)(r,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,P.localize)(9,null,this.resourceForError(t),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),i)},o=>D.VSBuffer.concat(o))}readFileBuffered(s,t,n,i=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,t,r,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new y.FileOperationError((0,P.localize)(10,null,this.resourceForError(t),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),i)},n),r}readFileUnbuffered(s,t,n){const i=(0,p.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)?r=await s.readFile(t,{atomic:!0}):r=await s.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(t,r.byteLength,n),i.end(D.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new y.FileOperationError((0,P.localize)(11,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==y.ETAG_DISABLED&&t.etag===n.etag)throw new y.NotModifiedSinceFileOperationError((0,P.localize)(12,null),n,t);return this.validateReadFileLimits(s,n.size,t),n}validateReadFileLimits(s,t,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&t>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&t>n.limits.size&&(i=7),typeof i=="number")throw new y.FileOperationError((0,P.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,t,n){return this.doCanMoveCopy(s,t,"move",n)}async canCopy(s,t,n){return this.doCanMoveCopy(s,t,"copy",n)}async doCanMoveCopy(s,t,n,i){if(s.toString()!==t.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(r,s,o,t,n,i)}catch(r){return r}return!0}async move(s,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,s,r,t,"move",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,t,n){const i=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,s,r,t,"copy",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="copy"?3:2,c)),c}async doMoveCopy(s,t,n,i,r,o){if(t.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(s,t,n,i,r,o);if(c&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),r==="copy"){if(s===n&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(t,i,{overwrite:o});else{const f=await this.resolve(t);f.isDirectory?await this.doCopyFolder(s,f,n,i):await this.doCopyFile(s,t,n,i)}return r}else return s===n?(await s.rename(t,i,{overwrite:o}),r):(await this.doMoveCopy(s,t,n,i,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,n,i){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,t,n,i);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,t,n,i);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,t,n,i);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,t,n,i)}async doCopyFolder(s,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,t,n,i,r,o){let c=!1;if(s===n){const{providerExtUri:f,isPathCaseSensitive:I}=this.getExtUri(s);if(I||(c=f.isEqual(t,i)),c&&r==="copy")throw new Error((0,P.localize)(14,null,this.resourceForError(t),this.resourceForError(i)));if(!c&&f.isEqualOrParent(i,t))throw new Error((0,P.localize)(15,null,this.resourceForError(t),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!c){if(!o)throw new y.FileOperationError((0,P.localize)(16,null,this.resourceForError(t),this.resourceForError(i)),4);if(s===n){const{providerExtUri:f}=this.getExtUri(s);if(f.isEqualOrParent(t,i))throw new Error((0,P.localize)(17,null,this.resourceForError(t),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,n)),n}async mkdirp(s,t){const n=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(t,i.dirname(t));)try{if(((await s.stat(t)).type&y.FileType.Directory)===0)throw new Error((0,P.localize)(18,null,this.resourceForError(t)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(t)),t=i.dirname(t)}for(let r=n.length-1;r>=0;r--){t=i.joinPath(t,n[r]);try{await s.mkdir(t)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(n){return n}return!0}async doValidateDelete(s,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!t?.useTrash&&!(n.capabilities&4096))throw new Error((0,P.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new y.FileOperationError((0,P.localize)(20,null,this.resourceForError(s)),1);if(!!!t?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,P.localize)(21,null,this.resourceForError(s)))}return n}async del(s,t){const n=await this.doValidateDelete(s,t),i=!!t?.useTrash,r=!!t?.recursive;await n.delete(s,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.withProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(s,t))return;if(n===i&&(0,y.hasFileCloneCapability)(n))return n.cloneFile(s,t);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===i&&(0,y.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,t,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,i,t))}watch(s,t={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,h.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,t);i?(0,h.dispose)(o):r=()=>(0,h.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,t){const n=await this.withProvider(s),i=(0,E.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),t]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:n.watch(s,t)},this.activeWatchers.set(i,r)),r.count+=1,(0,h.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,h.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,h.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,n,i){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,r,i):await this.doWriteReadableBufferedQueued(s,r,i)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,t,n){let i=0,r;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,t,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,p.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(s,t,a,a.byteLength,i,0)}catch(f){return c(f)}i+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,t,n){let i=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,t,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(s,t,n,i,r,o){let c=0;for(;c<i;)c+=await s.write(t,r+c,n.buffer,o+c,i-c)}async doWriteUnbuffered(s,t,n,i){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,t,n,i))}async doWriteUnbufferedQueued(s,t,n,i){let r;i instanceof D.VSBuffer?r=i:(0,p.isReadableStream)(i)?r=await(0,D.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?r=await(0,D.bufferedStreamToBuffer)(i):r=(0,D.readableToBuffer)(i),await s.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,t,n,i))}async doPipeBufferedQueued(s,t,n,i){let r,o;try{r=await s.open(t,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const c=D.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,f=0,I=0;do I=await s.read(r,a,c.buffer,f,c.byteLength-f),await this.doWriteBuffer(n,o,c,I,a,f),a+=I,f+=I,f===c.byteLength&&(f=0);while(I>0)}catch(c){throw(0,y.ensureFileSystemProviderError)(c)}finally{await R.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,t,n,i))}async doPipeUnbufferedQueued(s,t,n,i){return n.writeFile(i,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,t,n,i))}async doPipeUnbufferedToBufferedQueued(s,t,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(t);await this.doWriteBuffer(n,r,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,t,n,i){const r=await(0,D.streamToBuffer)(this.readFileBuffered(s,t,k.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,r)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new y.FileOperationError((0,P.localize)(22,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,P.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString(!0)}};S=he([ee(0,d.ILogService)],S),e.FileService=S}),define(Q[114],Z([0,1,115,154,3,39,15,4,155,2,14,12,18,43,20,92,13,59,110,31,108,107]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l,d,S,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(n)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new k.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:o}=await p.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await p.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(i,c.name))).type:a=this.toType(c),o.push([c.name,a])}catch(a){this.logService.trace(a)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let o;return r?.dangling?o=y.FileType.Unknown:i.isFile()?o=y.FileType.File:i.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,r&&(o|=y.FileType.SymbolicLink),o}async createResourceLock(i){const r=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new D.Barrier;return this.resourceLocks.set(i,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,h.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(i,r){let o;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const c=this.toFilePath(i);return await p.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,r,o){const c=(0,v.newWriteableStream)(a=>O.VSBuffer.concat(a.map(f=>O.VSBuffer.wrap(f))).buffer);return(0,l.readFileIntoStream)(this,i,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(i,r,o){let c;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await p.Promises.exists(a)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,P.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,P.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,r){const o=this.toFilePath(i);let c;(0,y.isFileOpenForWriteOptions)(r)&&(c=await this.createResourceLock(i));let a;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:I}=await p.SymlinkSupport.stat(o);I.mode&128||await p.Promises.chmod(o,I.mode|128)}catch(I){this.logService.trace(I)}let f;if((0,y.isFileOpenForWriteOptions)(r)){if(b.isWindows)try{await p.Promises.truncate(o,0),f="r+"}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}f||(f="w")}else f="r";a=await p.Promises.open(o,f)}catch(f){throw c?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(a,0),(0,y.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(a,i),c){const f=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,c),f&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),f.dispose())}return a}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await p.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.logService.error(o)}return await p.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,o,c,a){const f=this.normalizePos(i,r);let I=null;try{I=(await p.Promises.read(i,o,c,a,f)).bytesRead}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(i,f,I)}return I}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,o){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,c+o):this.mapHandleToPos.delete(i)))}async write(i,r,o,c,a){return(0,D.retry)(()=>this.doWrite(i,r,o,c,a),100,3)}async doWrite(i,r,o,c,a){const f=this.normalizePos(i,r);let I=null;try{I=(await p.Promises.write(i,o,c,a,f)).bytesWritten}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),N)}finally{this.updatePos(i,f,I)}return I}async mkdir(i){try{await p.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const o=this.toFilePath(i);r.recursive?await p.Promises.rm(o,p.RimRafMode.MOVE):await p.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,r,o){const c=this.toFilePath(i),a=this.toFilePath(r);if(c!==a)try{await this.validateTargetDeleted(i,r,"move",o.overwrite),await p.Promises.move(c,a)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,P.localize)(2,null,(0,w.basename)(c),(0,w.basename)((0,w.dirname)(a)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(i,r,o){const c=this.toFilePath(i),a=this.toFilePath(r);if(c!==a)try{await this.validateTargetDeleted(i,r,"copy",o.overwrite),await p.Promises.copy(c,a,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,P.localize)(3,null,(0,w.basename)(c),(0,w.basename)((0,w.dirname)(a)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(i,r,o,c){const a=this.toFilePath(i),f=this.toFilePath(r);let I=!1;if(!!(this.capabilities&1024)||(I=(0,g.isEqual)(a,f,!0)),I&&o==="copy")throw(0,y.createFileSystemProviderError)((0,P.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!I&&await p.Promises.exists(f)){if(!c)throw(0,y.createFileSystemProviderError)((0,P.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,o){const c=this.toFilePath(i),a=this.toFilePath(r),f=!!(this.capabilities&1024);if((0,g.isEqual)(c,a,!f))return;const I=new h.DisposableStore;try{const[N,B]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);I.add(N),I.add(B),o&&await p.Promises.mkdir((0,w.dirname)(a),{recursive:!0}),await p.Promises.copyFile(c,a)}catch(N){if(N.code==="ENOENT"&&!o)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(N)}finally{I.dispose()}}createUniversalWatcher(i,r,o){return new u.UniversalWatcherClient(c=>i(c),c=>r(c),o)}createNonRecursiveWatcher(i,r,o){return new s.NodeJSWatcherClient(c=>i(c),c=>r(c),o)}toFileSystemProviderError(i){if(i instanceof y.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let o=this.toFileSystemProviderError(r);if(i&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await p.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(o=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(Q[116],Z([0,1,13,10]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(E,g,h,w,b){try{const m=await new Promise((p,P)=>{_(["spdlog"],p,P)});m.setFlushOn(R.LogLevel.Trace);const v=await m.createAsyncRotatingLogger(E,g,h,w);return b?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(m){console.error(m)}return null}function k(E,g,h){switch(g){case R.LogLevel.Trace:E.trace(h);break;case R.LogLevel.Debug:E.debug(h);break;case R.LogLevel.Info:E.info(h);break;case R.LogLevel.Warning:E.warn(h);break;case R.LogLevel.Error:E.error(h);break;case R.LogLevel.Critical:E.critical(h);break;default:throw new Error("Invalid log level")}}class O extends R.AbstractMessageLogger{constructor(g,h,w,b,m){super(),this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(g,h,w,b),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(g,h,w,b){const m=w?6:1,v=30/m*C.ByteSize.MB,p=await D(g,h,v,m,b);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:P,message:y}of this.buffer)k(this._logger,P,y);this.buffer=[]}}log(g,h){this._logger?k(this._logger,g,h):this.getLevel()<=g&&this.buffer.push({level:g,message:h})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=O}),define(Q[36],Z([0,1,4,63,2,9]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class O extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(h){const w=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...h,...this.policyDefinitions},w!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(h),R.Iterable.reduce(this.policies.entries(),(b,[m,v])=>({...b,[m]:v}),{})}getPolicyValue(h){return this.policies.get(h)}serialize(){return R.Iterable.reduce(Object.entries(this.policyDefinitions),(h,[w,b])=>({...h,[w]:{definition:b,value:this.policies.get(w)}}),{})}}e.AbstractPolicyService=O;class E{constructor(){this.onDidChange=C.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(Q[117],Z([0,1,3,4,63,5,13,10,36]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function h(b,m){const v=[];for(const p of D.Iterable.concat(b.keys(),m.keys()))b.get(p)!==m.get(p)&&v.push(p);return v}let w=class extends g.AbstractPolicyService{constructor(m,v,p){super(),this.file=m,this.fileService=v,this.logService=p,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const P=R.Event.filter(v.onDidFilesChange,y=>y.affects(m));this._register(v.watch(m)),this._register(P(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(m){await this.refresh()}async read(){const m=new Map;try{const v=await this.fileService.readFile(this.file),p=JSON.parse(v.value.toString());if(!(0,k.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(p))this.policyDefinitions[P]&&m.set(P,p[P])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return m}async refresh(){const m=await this.read(),v=h(this.policies,m);this.policies=m,v.length>0&&this._onDidChange.fire(v)}};w=he([ee(1,O.IFileService),ee(2,E.ILogService)],w),e.FilePolicyService=w}),define(Q[28],Z([0,1,9]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,68,5]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(O,E){C.ok(R.isString(O)),C.ok(R.isObject(E)),C.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,E)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new D}),define(Q[118],Z([0,1,4,33]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class k{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,h){this.schemasById[D(g)]=h,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new k;R.Registry.add(e.Extensions.JSONContribution,O)}),define(Q[40],Z([0,1,19,4,5,81,21,118,33]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=g.Registry.as(E.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const i=this.doRegisterConfigurations(t,n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const n=this.doDeregisterConfigurations(t);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:t,remove:n}){const i=[];i.push(...this.doDeregisterConfigurations(n)),i.push(...this.doRegisterConfigurations(t,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(i)})}registerDefaultConfigurations(t){const n=[],i=[];for(const{overrides:r,source:o}of t)for(const c in r)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.configurationDefaultsOverrides.get(c),f=a?.valuesSources??new Map;if(o)for(const K of Object.keys(r[c]))f.set(K,o);const I={...a?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:I,valuesSources:f});const N=(0,O.getLanguageTagSettingPlainKey)(c),B={type:"object",default:I,description:k.localize(1,null,N),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:I,source:D.isString(o)?void 0:o,defaultValueSource:o};i.push(...P(c)),this.configurationProperties[c]=B,this.defaultLanguageConfigurationOverridesNode.properties[c]=B}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:o});const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const n=[];for(const{overrides:i,source:r}of t)for(const o in i){const c=this.configurationDefaultsOverrides.get(o),a=D.isString(r)?r:r?.id,f=D.isString(c?.source)?c?.source:c?.source?.id;if(a===f)if(n.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const I=this.configurationProperties[o];I&&(this.updatePropertyDefaultValue(o,I),this.updateSchema(o,I))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const n of t)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,n){const i=[];return t.forEach(r=>{i.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),i}doDeregisterConfigurations(t){const n=[],i=r=>{if(r.properties)for(const o in r.properties){n.push(o);const c=this.configurationProperties[o];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>i(o))};for(const r of t){i(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(t,n=!0,i,r,o=3){o=D.isUndefinedOrNull(t.scope)?o:t.scope;const c=[],a=t.properties;if(a)for(const I in a){const N=a[I];if(n&&S(I,N)){delete a[I];continue}if(N.source=i,N.defaultDefaultValue=a[I].default,this.updatePropertyDefaultValue(I,N),e.OVERRIDE_PROPERTY_REGEX.test(I)?N.scope=void 0:(N.scope=D.isUndefinedOrNull(N.scope)?o:N.scope,N.restricted=D.isUndefinedOrNull(N.restricted)?!!r?.includes(I):N.restricted),a[I].hasOwnProperty("included")&&!a[I].included){this.excludedConfigurationProperties[I]=a[I],delete a[I];continue}else this.configurationProperties[I]=a[I],a[I].policy?.name&&this.policyConfigurations.set(a[I].policy.name,I);!a[I].deprecationMessage&&a[I].markdownDeprecationMessage&&(a[I].deprecationMessage=a[I].markdownDeprecationMessage),c.push(I)}const f=t.allOf;if(f)for(const I of f)c.push(...this.validateAndRegisterProperties(I,n,i,r,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const n=i=>{const r=i.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);i.allOf?.forEach(n)};n(t)}updateSchema(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.resourceLanguageSettingsSchema.properties[t]=n;break}}removeFromSchema(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const n=`[${t}]`,i={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,n){const i=this.configurationDefaultsOverrides.get(t);let r=i?.value,o=i?.source;D.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),D.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function P(s){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=p.exec(s);for(;n?.length;){const i=n[1].trim();i&&t.push(i),n=p.exec(s)}}return(0,C.distinct)(t)}e.overrideIdentifiersFromKey=P;function y(s){return s.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=y;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const d=new m;g.Registry.add(e.Extensions.Configuration,d);function S(s,t){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?k.localize(7,null,s):d.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,s,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}e.validateProperty=S;function u(){const s=[],t=d.getConfigurationProperties();for(const n of Object.keys(t))s.push([n,t[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=u}),define(Q[64],Z([0,1,19,4,50,2,39,26,5,8,21,40,33]),function(_,e,C,R,D,k,O,E,g,h,w,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(n={},i=[],r=[],o){this._contents=n,this._keys=i,this._overrides=r,this.raw=o,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof v)return i;const r=new p("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,w.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,c=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,i){const r=this.getContentsForOverrideIdentifer(i);return r?n?(0,w.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return C.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return C.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=E.deepClone(this.contents),r=E.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of n)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(i,a.contents);for(const f of a.overrides){const[I]=r.filter(N=>C.equals(N.identifiers,f.identifiers));I?(this.mergeContents(I.contents,f.contents),I.keys.push(...f.keys),I.keys=C.distinct(I.keys)):r.push(E.deepClone(f))}for(const f of a.keys)o.indexOf(f)===-1&&o.push(f)}return new v(i,o,r,c.every(a=>a instanceof v)?void 0:c)}freeze(){return this.frozen=!0,this}clone(){return new v(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const a=i[o];a&&(typeof c=="object"&&typeof a=="object"?(c=E.deepClone(c),this.mergeContents(c,a)):c=a),r[o]=c}return new v(r,this.keys,this.overrides)}mergeContents(n,i){for(const r of Object.keys(i)){if(r in n&&g.isObject(n[r])&&g.isObject(i[r])){this.mergeContents(n[r],i[r]);continue}n[r]=E.deepClone(i[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?E.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,r=null;const o=c=>{c&&(r?this.mergeContents(r,c):r=E.deepClone(c))};for(const c of this.overrides)C.equals(c.identifiers,[n])?i=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,w.addToValueTree)(this.contents,n,i,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,w.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let r=0;r<i;r++)n.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,n)}removeKey(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=v;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!g.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:f}=this.doParseRaw(n,i);this._configurationModel=new v(r,o,c,f?[n]:void 0),this._restrictedConfigurations=a||[]}doParseContent(n){let i={},r=null,o=[];const c=[],a=[];function f(N){Array.isArray(o)?o.push(N):r!==null&&(o[r]=N)}const I={onObjectBegin:()=>{const N={};f(N),c.push(o),o=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const N=[];f(N),c.push(o),o=N,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:f,onError:(N,B,K)=>{a.push({error:N,offset:B,length:K})}};if(n)try{D.visit(n,I),i=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return i}doParseRaw(n,i){const r=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,i);n=o.raw;const c=(0,w.toValuesTree)(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),a=Object.keys(n),f=this.toOverrides(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:c,keys:a,overrides:f,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(n,i,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const a={},f=[];for(const I in n)if(b.OVERRIDE_PROPERTY_REGEX.test(I)&&r){const N=this.filter(n[I],i,!1,o);a[I]=N.raw,c=c||N.hasExcludedProperties,f.push(...N.restricted)}else{const N=i[I],B=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&f.push(I),(B===void 0||o.scopes===void 0||o.scopes.includes(B))&&!(o.skipRestricted&&N?.restricted)?a[I]=n[I]:c=!0}return{raw:a,restricted:f,hasExcludedProperties:c}}toOverrides(n,i){const r=[];for(const o of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in n[o])c[a]=n[o][a];r.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,w.toValuesTree)(c,i)})}return r}}e.ConfigurationModelParser=p;class P extends k.Disposable{constructor(n,i,r,o){super(),this.userSettingsResource=n,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class y{constructor(n,i,r,o,c,a,f,I,N,B,K,J,ne){this.key=n,this.overrides=i,this.value=r,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=a,this.applicationConfiguration=f,this.userConfiguration=I,this.localUserConfiguration=N,this.remoteUserConfiguration=B,this.workspaceConfiguration=K,this.folderConfigurationModel=J,this.memoryInspectValue=ne}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class l{constructor(n,i,r,o,c=new v,a=new v,f=new O.ResourceMap,I=new v,N=new O.ResourceMap,B=!0){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=a,this._folderConfigurations=f,this._memoryConfiguration=I,this._memoryConfigurationByResource=N,this._freeze=B,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(n,i,r){return this.getConsolidatedConfigurationModel(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,r){const o=this.getConsolidatedConfigurationModel(n,i,r),c=C.distinct(o.overrides.map(I=>I.identifiers).flat()).filter(I=>o.getOverrideValue(n,I)!==void 0),a=this.getFolderConfigurationModelForResource(i.resource,r),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration;return new y(n,i,o.getValue(n),c.length?c:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,f.inspect(n,i.overrideIdentifier))}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:c,removed:a}=u(this._defaultConfiguration,n);i=[...o,...c,...a]}for(const o of i)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(c),f=n.getKeysForOverrideIdentifier(c),I=[...f.filter(N=>a.indexOf(N)===-1),...a.filter(N=>f.indexOf(N)===-1),...a.filter(N=>!E.equals(this._defaultConfiguration.override(c).getValue(N),n.override(c).getValue(N)))];r.push([c,I])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=u(this._policyConfiguration,n),c=[...i,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.applicationConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.localUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.remoteUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.workspaceConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(n,i){const r=this.folderConfigurations.get(n),{added:o,updated:c,removed:a,overrides:f}=u(r,i),I=[...o,...c,...a];return(I.length||!r)&&this.updateFolderConfiguration(n,i),{keys:I,overrides:f}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:a}=u(i,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,r){let o=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const o=i.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(n);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(i=r.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=r}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(i);return n.push([i,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),c=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),f=n.folders.reduce((I,N)=>(I.set(h.URI.revive(N[0]),this.parseConfigurationModel(N[1])),I),new O.ResourceMap);return new l(i,r,o,c,new v,a,f,new v,new O.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=l;function d(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const n=new Set,i=new Map;for(const o of t)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,a])=>{const f=(0,O.getOrSet)(i,c,new Set);a.forEach(I=>f.add(I))});const r=[];return i.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=d;class S{constructor(n,i,r,o){this.change=n,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(f=>c.add(f)),n.overrides.forEach(([,f])=>f.forEach(I=>c.add(I))),this.affectedKeys=[...c.values()];const a=new v;this.affectedKeys.forEach(f=>a.setValue(f,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!E.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let r=(0,w.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=S;function u(t,n){const{added:i,removed:r,updated:o}=s(n?.rawConfiguration,t?.rawConfiguration),c=[],a=t?.getAllOverrideIdentifiers()||[],f=n?.getAllOverrideIdentifiers()||[];if(n){const I=f.filter(N=>!a.includes(N));for(const N of I)c.push([N,n.getKeysForOverrideIdentifier(N)])}if(t){const I=a.filter(N=>!f.includes(N));for(const N of I)c.push([N,t.getKeysForOverrideIdentifier(N)])}if(n&&t){for(const I of a)if(f.includes(I)){const N=s({contents:t.getOverrideValue(void 0,I)||{},keys:t.getKeysForOverrideIdentifier(I)},{contents:n.getOverrideValue(void 0,I)||{},keys:n.getKeysForOverrideIdentifier(I)});c.push([I,[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:r,updated:o,overrides:c}}function s(t,n){const i=t?n?t.keys.filter(c=>n.keys.indexOf(c)===-1):[...t.keys]:[],r=n?t?n.keys.filter(c=>t.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(t&&n){for(const c of n.keys)if(t.keys.indexOf(c)!==-1){const a=(0,w.getConfigurationValue)(n.contents,c),f=(0,w.getConfigurationValue)(t.contents,c);E.equals(a,f)||o.push(c)}}return{added:i,removed:r,updated:o}}}),define(Q[119],Z([0,1,19,4,2,26,5,21,64,40,10,36,33]),function(_,e,C,R,D,k,O,E,g,h,w,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new p(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:S})=>this.onDidUpdateConfiguration(d,S))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(d,S){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:d})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class p extends g.ConfigurationModel{constructor(d={}){const S=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(S),s=Object.create(null),t=[];for(const n in S){const i=d[n],r=i!==void 0?i:S[n].default;(0,E.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))h.OVERRIDE_PROPERTY_REGEX.test(n)&&t.push({identifiers:(0,h.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,E.toValuesTree)(s[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(s,u,t)}}e.DefaultConfigurationModel=p;class P{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new g.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=P;let y=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(d,S,u){super(),this.defaultConfiguration=d,this.policyService=S,this.logService=u,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new g.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(d=>this.onDidChangePolicies(d))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:d})=>this.update(await this.registerPolicyDefinitions(d),!0))),this._configurationModel}async registerPolicyDefinitions(d){const S={},u=[],s=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const t of d){const n=s[t];if(!n){u.push(t);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}u.push(t),S[n.policy.name]={type:n.type}}}return(0,O.isEmptyObject)(S)||await this.policyService.registerPolicyDefinitions(S),u}onDidChangePolicies(d){const S=m.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),u=(0,C.coalesce)(d.map(s=>S.get(s)));this.update(u,!0)}update(d,S){const u=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),s=[],t=this._configurationModel.isEmpty();for(const n of d){const i=u[n]?.policy?.name;if(i){const r=this.policyService.getPolicyValue(i);(t?r!==void 0:!(0,k.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new g.ConfigurationModel;for(const i of n.keys)this._configurationModel.setValue(i,n.getValue(i));for(const[i,r]of s)r===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,r);S&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=he([ee(1,b.IPolicyService),ee(2,w.ILogService)],y),e.PolicyConfiguration=y}),define(Q[120],Z([0,1,3,4,2,18,21,64,119,36]),function(_,e,C,R,D,k,O,E,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class w extends D.Disposable{constructor(m,v,p,P){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration),this.policyConfiguration=p instanceof h.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,p,P)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,v)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:l})=>this.onDidDefaultConfigurationChange(y,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,v,p]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(m,v,new E.ConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(m,v){const p=typeof m=="string"?m:void 0,P=(0,O.isConfigurationOverrides)(m)?m:(0,O.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(p,P,void 0)}updateValue(m,v,p,P){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const v=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(p,v,2)}onDidDefaultConfigurationChange(m,v){const p=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(m,v);this.trigger(P,p,7)}onDidPolicyConfigurationChange(m){const v=this.configuration.toData(),p=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(p,v,7)}trigger(m,v,p){const P=new E.ConfigurationChangeEvent(m,{data:v},this.configuration);P.source=p,P.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(P)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=w}),define(Q[121],Z([0,1,17]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(h){return h.scheme===C.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=R;function D(h){if(!h)return;const w=h.indexOf("+");return w<0?h:h.substr(0,w)}e.getRemoteName=D;function k(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=k;function O(h){const{host:w,port:b}=g(h);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:b}}e.parseAuthorityWithPort=O;function E(h,w){let{host:b,port:m}=g(h);return typeof m>"u"&&(m=w),{host:b,port:m}}e.parseAuthorityWithOptionalPort=E;function g(h){const w=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const b=h.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=h.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:h,port:void 0}}}),define(Q[34],Z([0,1,27,9,121]),function(_,e,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=k;function O(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var g;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class h{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,y){if(typeof P>"u"||P===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof P=="string"||typeof y=="string"){const l=typeof P=="string"?P:P.value,d=typeof y=="string"?y:y.value;return C.equalsIgnoreCase(l,d)}return P._lower===y._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=h;function w(p){return b(p)}e.isApplicationScopedExtension=w;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function v(p,P){if(P){const y=`onResolveRemoteAuthority:${(0,D.getRemoteName)(P)}`;return p.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,12,8,11,32]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function h(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,C.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=h;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,r,o)}static parse(i){const r=w.exec(i);return r&&r[1]&&r[2]?new b({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?h(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(n){const i=m.exec(n);return i&&i[1]?[P(i[1]),i[2]]:[P(n),void 0]}e.getIdAndVersion=v;function p(n,i){return`${n}.${i}`}e.getExtensionId=p;function P(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(n,i){return P(p(n,i))}e.getGalleryExtensionId=y;function l(n,i){const r=[],o=c=>{for(const a of r)if(a.some(f=>h(i(f),i(c))))return a;return null};for(const c of n){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=l;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function S(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function u(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!h(a.identifier,{id:c}))){const a=n.filter(f=>h(f.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=u;async function s(n,i){if(!k.isLinux)return!1;let r;try{r=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function t(n,i){const r=await s(n,i),o=(0,R.getTargetPlatform)(r?"alpine":k.platform,g.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=t}),define(Q[122],Z([0,1,24,11,17,18,38,8,84,22,23,34]),function(_,e,C,R,D,k,O,E,g,h,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=y=>(0,g.localize)(0,null,y),v=(0,g.localize)(1,null,"ms-dotnettools.csharp");function p(y,l){return l?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let P=class{constructor(l,d){this.extensionManagementService=l,this.extensionGalleryService=d}get location(){}async listExtensions(l,d,S,u=console){let s=await this.extensionManagementService.getInstalled(1,S);const t=b.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(d&&d!==""){if(t.indexOf(d.toLowerCase())<0){u.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(i=>i.manifest.categories?i.manifest.categories.map(o=>o.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){u.log("Possible Categories: "),t.forEach(i=>{u.log(i)});return}this.location&&u.log((0,g.localize)(2,null,this.location)),s=s.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let n;for(const i of s)n!==i.identifier.id&&(n=i.identifier.id,u.log(p(i.manifest,l)))}async installExtensions(l,d,S,u,s=console){const t=[],n=[];l.length&&s.log(this.location?(0,g.localize)(3,null,this.location):(0,g.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1,S.profileLocation),r=(f,I)=>{const N=i.find(B=>(0,w.areSameExtensions)(B.identifier,{id:f}));if(N){if(!u&&(!I||I==="prerelease"&&N.preRelease))return s.log((0,g.localize)(5,null,f,N.manifest.version,f)),!1;if(I&&N.manifest.version===I)return s.log((0,g.localize)(6,null,`${f}@${I}`)),!1}return!0},o=(f,I,N)=>{a.push({id:f,version:I!=="prerelease"?I:void 0,installOptions:{...S,isBuiltin:N,installPreReleaseVersion:I==="prerelease"||S.installPreReleaseVersion}})},c=[],a=[];for(const f of l)if(f instanceof E.URI)c.push(f);else{const[I,N]=(0,w.getIdAndVersion)(f);r(I,N)&&o(I,N,!1)}for(const f of d){const[I,N]=(0,w.getIdAndVersion)(f);r(I,N)&&o(I,N,!0)}if(c.length&&await Promise.all(c.map(async f=>{try{const I=await this.installVSIX(f,{...S,isBuiltin:!1},u,s);I&&n.push(I)}catch(I){s.error(I.message||I.stack||I),t.push(f.toString())}})),a.length){const f=await this.getGalleryExtensions(a);await Promise.all(a.map(async I=>{const N=f.get(I.id.toLowerCase());if(N)try{const B=await this.installFromGallery(I,N,i,u,s);B&&n.push(B)}catch(B){s.error(B.message||B.stack||B),t.push(I.id)}else s.error(`${m(I.version?`${I.id}@${I.version}`:I.id)}
${v}`),t.push(I.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async installVSIX(l,d,S,u){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,S,d.profileLocation,u))try{return await this.extensionManagementService.install(l,d),u.log((0,g.localize)(8,null,(0,k.basename)(l))),s}catch(n){if((0,R.isCancellationError)(n))return u.log((0,g.localize)(9,null,(0,k.basename)(l))),null;throw n}return null}async getGalleryExtensions(l){const d=new Map,S=l.some(s=>s.installOptions.installPreReleaseVersion),u=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:S})),C.CancellationToken.None);for(const s of u)d.set(s.identifier.id.toLowerCase(),s);return d}async installFromGallery({id:l,version:d,installOptions:S},u,s,t,n){const i=await this.extensionGalleryService.getManifest(u,C.CancellationToken.None);if(i&&!this.validateExtensionKind(i,n))return null;const r=s.find(o=>(0,w.areSameExtensions)(o.identifier,u.identifier));if(r){if(u.version===r.manifest.version)return n.log((0,g.localize)(10,null,d?`${l}@${d}`:l)),null;n.log((0,g.localize)(11,null,l,u.version))}try{S.isBuiltin?n.log(d?(0,g.localize)(12,null,l,d):(0,g.localize)(13,null,l)):n.log(d?(0,g.localize)(14,null,l,d):(0,g.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(u,{...S,installGivenVersion:!!d});return n.log((0,g.localize)(16,null,l,o.manifest.version)),i}catch(o){if((0,R.isCancellationError)(o))return n.log((0,g.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,d){return!0}async validateVSIX(l,d,S,u){const s={id:(0,w.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.extensionManagementService.getInstalled(1,S)).find(i=>(0,w.areSameExtensions)(s,i.identifier)&&(0,O.gt)(i.manifest.version,l.version));return n&&!d?(u.log((0,g.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.validateExtensionKind(l,u)}async uninstallExtensions(l,d,S,u=console){const s=async n=>{if(n instanceof E.URI){const i=await this.extensionManagementService.getManifest(n);return p(i)}return n},t=[];for(const n of l){const i=await s(n),o=(await this.extensionManagementService.getInstalled(void 0,S)).filter(c=>(0,w.areSameExtensions)(c.identifier,{id:i}));if(!o.length)throw new Error(`${this.notInstalled(i)}
${v}`);if(o.some(c=>c.type===0)){u.log((0,g.localize)(19,null,i));return}if(!d&&o.some(c=>c.isBuiltin)){u.log((0,g.localize)(20,null,i));return}u.log((0,g.localize)(21,null,i));for(const c of o)await this.extensionManagementService.uninstall(c,{profileLocation:S}),t.push(c);this.location?u.log((0,g.localize)(22,null,i,this.location)):u.log((0,g.localize)(23,null,i))}}async locateExtension(l,d=console){const S=await this.extensionManagementService.getInstalled();l.forEach(u=>{S.forEach(s=>{if(s.identifier.id===u&&s.location.scheme===D.Schemas.file){d.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,g.localize)(24,null,l,this.location):(0,g.localize)(25,null,l)}};P=he([ee(0,h.IExtensionManagementService),ee(1,h.IExtensionGalleryService)],P),e.ExtensionManagementCLI=P}),define(Q[41],Z([0,1,3,15,2,39,8,23,13,9,10]),function(_,e,C,R,D,k,O,E,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,h.createDecorator)("IExtensionsProfileScannerService");let b=class extends D.Disposable{constructor(v,p){super(),this.fileService=v,this.logService=p,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,p){return this.withProfileExtensions(p,P=>(P=P.filter(y=>v.some(([l])=>!(0,E.areSameExtensions)(y.identifier,l.identifier))),P.push(...v.map(([y,l])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:l}))),P))}removeExtensionFromProfile(v,p){return this.withProfileExtensions(p,P=>P.filter(y=>!(0,E.areSameExtensions)(y.identifier,v)))}async withProfileExtensions(v,p){return this.getResourceAccessQueue(v).queue(async()=>{let P=[];try{const y=await this.fileService.readFile(v),l=JSON.parse(y.value.toString());for(const d of l){if(!d.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",d);continue}if(!d.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",d);continue}if(!d.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",d);continue}P.push({identifier:d.identifier,location:O.URI.revive(d.location),version:d.version,metadata:d.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(p){P=p(P);const y=P.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(v,R.VSBuffer.fromString(JSON.stringify(y)))}return P})}getResourceAccessQueue(v){let p=this.resourcesAccessQueueMap.get(v);return p||(p=new C.Queue,this.resourcesAccessQueueMap.set(v,p)),p}};b=he([ee(0,g.IFileService),ee(1,w.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Q[123],Z([0,1,3,11,2,12,18,38,8,30,20,16,22,23,13,10]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=class extends D.Disposable{constructor(d,S,u,s){super(),this.fileService=S,this.extensionGalleryService=u,this.logService=s,this.extensionsDownloadDir=g.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,S){await this.cleanUpPromise;const u=this.getName(d),s=(0,O.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(s)){const t=(0,O.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(d,t,S);try{await this.rename(t,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(t)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,t.path),n}}return s}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,S,u){try{await w.Promises.rename(d.fsPath,S.fsPath)}catch(s){if(k.isWindows&&s&&s.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${d} to ${S} with 'EPERM' error. Trying again...`),this.rename(d,S,u);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const S=[],u=[];for(const n of d.children){const i=v.ExtensionKey.parse(n.name);i&&u.push([i,n])}const s=(0,v.groupByExtension)(u,([n])=>n),t=[];for(const n of s)n.sort((i,r)=>E.rcompare(i[0].version,r[0].version)),S.push(...n.slice(1).map(i=>i[1].resource)),t.push(n[0][1]);t.sort((n,i)=>n.mtime-i.mtime),S.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(S.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?v.ExtensionKey.create(d).toString().toLowerCase():(0,h.generateUuid)()}};y=he([ee(0,b.INativeEnvironmentService),ee(1,p.IFileService),ee(2,m.IExtensionGalleryService),ee(3,P.ILogService)],y),e.ExtensionsDownloader=y}),define(Q[124],Z([0,1,2,14,20,34]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends C.Disposable{constructor(g,h){super(),this.environmentService=g,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(h.onDidUninstallExtension(w=>this.onDidUnInstallExtension(w)))}onDidInstallExtensions(g){g.some(h=>!!h.local)&&this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Q[125],Z([0,1,156,19,3,2,17,14,20,16,22,23,10,62,12,8]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends v.LanguagePackBaseService{constructor(u,s,t,n){super(t),this.extensionManagementService=u,this.logService=n,this.cache=this._register(new l(s,n)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getBuiltInExtensionTranslationsUri(u){const t=(await this.cache.getLanguagePacks())[p.Language.value()];if(!t){this.logService.warn(`No language pack found for ${p.Language.value()}`);return}const n=t.translations[u];return n?P.URI.file(n):void 0}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),s=Object.keys(u).map(t=>{const n=u[t];return{...this.createQuickPickItem(t,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),s.sort((t,n)=>t.label.localeCompare(n.label)),s}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const s=await this.cache.getLanguagePacks();Object.keys(s).some(t=>s[t]&&s[t].extensions.some(n=>(0,b.areSameExtensions)(n.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),t=await this.cache.update(s);return!(0,R.equals)(Object.keys(u),Object.keys(t))}};y=he([ee(0,w.IExtensionManagementService),ee(1,h.INativeEnvironmentService),ee(2,w.IExtensionGalleryService),ee(3,m.ILogService)],y),e.NativeLanguagePackService=y;let l=class extends k.Disposable{constructor(u,s){super(),this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(s=>{Object.keys(s).forEach(t=>delete s[t]),this.createLanguagePacksFromExtensions(s,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...s){for(const t of s)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,t);Object.keys(u).forEach(t=>this.updateHash(u[t]))}createLanguagePacksFromExtension(u,s){const t=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of n)if(s.location.scheme===O.Schemas.file&&d(i)){let r=u[i.languageId];r||(r={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},u[i.languageId]=r);const o=r.extensions.filter(c=>(0,b.areSameExtensions)(c.extensionIdentifier,t))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:t,version:s.manifest.version});for(const c of i.translations)r.translations[c.id]=(0,E.join)(s.location.fsPath,c.path)}}updateHash(u){if(u){const s=(0,C.createHash)("md5");for(const t of u.extensions)s.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);u.hash=s.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return g.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(s=u(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.languagePacks=t,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),g.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>s,t=>this.logService.error(t))})}};l=he([ee(0,h.INativeEnvironmentService),ee(1,m.ILogService)],l);function d(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const u of S.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,9,33]),function(_,e,C,R,D,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function E(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=E;function g(P){return P.res.statusCode===204}async function h(P){return g(P)?null:(await(0,C.streamToBuffer)(P.stream)).toString()}e.asText=h;async function w(P){if(!E(P))throw new Error("Server returned "+P.res.statusCode);return h(P)}e.asTextOrError=w;async function b(P){if(!E(P))throw new Error("Server returned "+P.res.statusCode);if(g(P))return null;const l=(await(0,C.streamToBuffer)(P.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}e.asJson=b;function m(P){p(P)}e.updateProxyConfigurationsScope=m;let v;function p(P){const y=O.Registry.as(D.Extensions.Configuration),l=v;v={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[v],remove:l?[l]:[]})}p(2)}),define(Q[126],Z([0,1,24,17,13,47]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(g,h){this.requestService=g,this.fileService=h}async download(g,h,w=C.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(g,h);return}const b={type:"GET",url:g.toString(!0)},m=await this.requestService.request(b,w);if(m.res.statusCode===200)await this.fileService.writeFile(h,m.stream);else{const v=await(0,k.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};O=he([ee(0,k.IRequestService),ee(1,D.IFileService)],O),e.DownloadService=O}),define(Q[127],Z([0,1,128,5]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(O,E){return O.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:O.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function k(O,E,g={}){const h=(0,C.parse)(O),w=g.proxyUrl||D(h,E);if(!w)return null;const b=(0,C.parse)(w);if(!/^https?:$/.test(b.protocol||""))return null;const m={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((v,p)=>{_(["http-proxy-agent"],v,p)}))(m):new(await new Promise((v,p)=>{_(["https-proxy-agent"],v,p)}))(m)}e.getProxyAgent=k}),define(Q[129],Z([0,1,57,14,95,24,31,11,12,30,77,157,3]),function(_,e,C,R,D,k,O,E,g,h,w,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let p;async function P(l,d,S){return d["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(S)&&!d["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(S)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(u,s)=>{const t=new k.CancellationTokenSource,n=setTimeout(()=>{t.dispose(!0),s(new Error((0,D.localize)(0,null)))},v);try{u(await y(l,t.token))}catch(i){!(0,E.isCancellationError)(i)&&!t.token.isCancellationRequested?s(new Error((0,D.localize)(1,null,(0,O.toErrorMessage)(i)))):u({})}finally{clearTimeout(n),t.dispose()}})),p)}e.getResolvedShellEnv=P;async function y(l,d){const S=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",S);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",u);const s=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const i=await(0,w.getSystemShell)(g.OS,n);return l.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(d.isCancellationRequested)return o((0,E.canceled)());const c=(0,R.basename)(i);let a,f;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${I} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,f=["-Login","-Command"]):(a=`'${process.execPath}' ${I} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?f=["-ic"]:f=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),a);const N=(0,C.spawn)(i,[...f,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});d.onCancellationRequested(()=>(N.kill(),o((0,E.canceled)()))),N.on("error",J=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(J)),o(J)});const B=[];N.stdout.on("data",J=>B.push(J));const K=[];N.stderr.on("data",J=>K.push(J)),N.on("close",(J,ne)=>{const oe=Buffer.concat(B).toString("utf8");l.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(K).toString("utf8");if(re.trim()&&l.trace("getUnixShellEnvironment#stderr",re),J||ne)return o(new Error((0,D.localize)(2,null,J,ne)));const fe=t.exec(oe),le=fe?fe[1]:"{}";try{const ie=JSON.parse(le);S?ie.ELECTRON_RUN_AS_NODE=S:delete ie.ELECTRON_RUN_AS_NODE,u?ie.ELECTRON_NO_ATTACH_CONSOLE=u:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ie),r(ie)}catch(ie){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[65],Z([0,1,9]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,C.createDecorator)("stateService")}),define(Q[130],Z([0,1,3,15,5,16,13,10]),function(_,e,C,R,D,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(b,m,v){this.storagePath=b,this.logService=m,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new C.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,m){const v=this.storage[b];return(0,D.isUndefinedOrNull)(v)?m:v}setItem(b,m){this.setItems([{key:b,data:m}])}setItems(b){let m=!1;for(const{key:v,data:p}of b)this.storage[v]!==p&&((0,D.isUndefinedOrNull)(p)?(0,D.isUndefined)(this.storage[v])||(this.storage[v]=void 0,m=!0):(this.storage[v]=p,m=!0));m&&this.save()}removeItem(b){(0,D.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(b)),this.lastSavedStorageContents=b}catch(m){this.logService.error(m)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=g;let h=class{constructor(b,m,v){this.fileStorage=new g(b.stateResource,m,v)}async init(){await this.fileStorage.init()}getItem(b,m){return this.fileStorage.getItem(b,m)}};h=he([ee(0,k.IEnvironmentService),ee(1,E.ILogService),ee(2,O.IFileService)],h),e.StateService=h}),define(Q[66],Z([0,1,12,32,8,30]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(h){if(C.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function E(h,w,b,m,v,p,P,y,l,d){const S=Object.create(null);S["common.machineId"]=P,S.sessionID=(0,k.generateUuid)()+Date.now(),S.commitHash=v,S.version=p,S["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,C.PlatformToString)(C.platform),S["common.nodePlatform"]=R.platform,S["common.nodeArch"]=m,S["common.product"]=d||"desktop",y&&(S["common.msftInternal"]=y);let u=0;const s=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),C.isLinuxSnap&&(S["common.snap"]="true");const t=O(b);t&&(S["common.platformDetail"]=t);try{const n=await h.readFile(D.URI.file(l));S["common.source"]=n.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=E;function g(h){const w=R.env.USERDNSDOMAIN;if(!w)return!1;const b=w.toLowerCase();return h.some(m=>b===m)}e.verifyMicrosoftInternalDomain=g}),define(Q[35],Z([0,1,9]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,35]),function(_,e,C,R,D,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class g{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,R.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=g,e.NullTelemetryService=new g;class h{async publicLog(r,o,c){}async publicLogError(r,o,c){}}e.NullEndpointTelemetryService=h,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:l(o.sourceConfig)})})}e.configurationTelemetry=w;function b(i,r){return!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=b;function m(i){const r=i.getValue(E.TELEMETRY_SETTING_ID),o=i.getValue("telemetry.enableCrashReporter");if(i.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function v(i){const r={},o={},c={};y(i,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const f=c[a];typeof f=="number"?o[a]=f:typeof f=="boolean"?o[a]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${f.length}`),r[a]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(r[a]=f)}return{properties:r,measurements:o}}e.validateTelemetryData=v;const p=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function P(i){if(!i)return"none";for(const r of p)if(i.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=P;function y(i,r,o=0,c){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const f=i[a],I=c?c+a:a;Array.isArray(f)?r[I]=(0,C.safeStringify)(f):f instanceof Date?r[I]=f.toISOString():(0,D.isObject)(f)?o<2?y(f,r,o+1,I+"."):r[I]=(0,C.safeStringify)(f):r[I]=f}}function l(i){if(!i)return[];const r=[];return d(r,"",i),r}function d(i,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(c=>d(i,r?`${r}.${c}`:c,o[c])):i.push(r)}function S(i,r){const o=i.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=S;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=u;function s(i,r){let o=i;const c=[];for(const N of r)for(;;){const B=N.exec(i);if(!B)break;c.push([B.index,N.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let I=0;for(o="";;){const N=f.exec(i);if(!N)break;!a.test(N[0])&&c.every(([B,K])=>N.index<B||N.index>=K)&&(o+=i.substring(I,N.index)+"<REDACTED: user-file-path>",I=f.lastIndex)}return I<i.length&&(o+=i.substr(I)),o}function t(i){if(!i)return i;const r=i.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of o)if(c.regex.test(r))return`<REDACTED: ${c.label}>`;return i}function n(i,r){return(0,C.cloneAndChange)(i,o=>{if(typeof o=="string"){let c=o;c=s(c,r);for(const a of r)c=c.replace(a,"");return c=t(c),c}})}e.cleanData=n}),define(Q[131],Z([0,1,103,42]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(k,O,E,g,h,w,b){const m={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${O.nameShort})`};if((0,R.supportsTelemetry)(O,E)&&(0,R.getTelemetryLevel)(g)===3){const v=await(0,C.getServiceMachineId)(E,h,w),{sessionId:p}=await b.getTelemetryInfo();m["X-Market-User-Id"]=v,m["VSCode-SessionId"]=p}return m}e.resolveMarketplaceHeaders=D}),define(Q[132],Z([0,1,11,26,42]),function(_,e,C,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function O(g,h,w){const b=await new Promise((y,l)=>{_(["@microsoft/1ds-core-js"],y,l)}),m=await new Promise((y,l)=>{_(["@microsoft/1ds-post-js"],y,l)}),v=new b.AppInsightsCore,p=new m.PostChannel,P={instrumentationKey:g,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(w){P.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:w};P.extensionConfig[p.identifier]=y}return v.initialize(P,[]),v.addTelemetryInitializer(y=>{h&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),v}class E{constructor(h,w,b,m,v){this._isInternalTelemetry=h,this._eventPrefix=w,this._defaultData=b,this._xhrOverride=v,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(h){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){h(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=O(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(w=>{h(w)},w=>{(0,C.onUnexpectedError)(w),console.error(w)})}}log(h,w){if(!this._aiCoreOrKey)return;w=(0,R.mixin)(w,this._defaultData),w=(0,D.validateTelemetryData)(w);const b=this._eventPrefix+"/"+h;try{this._withAIClient(m=>{m.pluginVersionString=w?.properties.version??"Unknown",m.track({name:b,baseData:{name:b,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(h=>{this._withAIClient(w=>{w.unload(!0,()=>{this._aiCoreOrKey=void 0,h(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=E}),define(Q[133],Z([0,1,2,26,52,12,27,96,21,40,134,28,33,35,42]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{constructor(d,S,u){this._configurationService=S,this._productService=u,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(d,S){this._experimentProperties[d]=S}_updateTelemetryLevel(){let d=(0,p.getTelemetryLevel)(this._configurationService);const S=this._productService.enabledTelemetryLevels;if(S){this._sendErrorTelemetry=this.sendErrorTelemetry?S.error:!1;const u=S.usage?3:S.error?2:0;d=Math.min(d,u)}this.telemetryLevel.value=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const d=await this._commonProperties,S=d.sessionID,u=d["common.machineId"],s=d["common.firstSessionDate"],t=d["common.msftInternal"];return{sessionId:S,machineId:u,firstSessionDate:s,msftInternal:t}}dispose(){this._disposables.dispose()}_log(d,S,u,s){return this.telemetryLevel.value<S?Promise.resolve(void 0):this._commonProperties.then(t=>{u=(0,R.mixin)(u,t),u=(0,R.mixin)(u,this._experimentProperties),u=(0,p.cleanData)(u,this._cleanupPatterns),this._appenders.forEach(n=>n.log(d,u))},t=>{console.error(t)})}publicLog(d,S,u){return this._log(d,3,S,u)}publicLog2(d,S,u){return this.publicLog(d,S,u)}publicLogError(d,S){return this._sendErrorTelemetry?this._log(d,2,S,!0):Promise.resolve(void 0)}publicLogError2(d,S){return this.publicLogError(d,S)}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=he([ee(1,g.IConfigurationService),ee(2,b.IProductService)],P),e.TelemetryService=P;function y(){const l=(0,E.localize)(0,null,w.default.nameLong),d=w.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=k.isWeb?"":(0,E.localize)(3,null),u=(0,E.localize)(4,null),s=(0,E.localize)(5,null),t=(0,E.localize)(6,null),n=(0,E.localize)(7,null),i=`
|       | ${u} | ${s} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,E.localize)(8,null);return`
${l} ${d} ${S}

&nbsp;

${n}
${i}

&nbsp;

${r}
`}m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,E.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,E.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[135],Z([0,1,158,132]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends R.AbstractOneDataSystemAppender{constructor(O,E,g,h){const w={sendPOST:(b,m)=>{const v={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const p=C.request(b.urlString,v,P=>{P.on("data",function(y){m(P.statusCode??200,P.headers,y.toString())}),P.on("error",function(y){m(0,{})})});p.write(b.data),p.end()}catch{m(0,{})}}};super(O,E,g,h,w)}}e.OneDataSystemAppender=D}),define(Q[136],Z([0,1,14,20]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function D(k,O){const E=Object.create(null),g=(w,b)=>{const m=JSON.parse(w);E[b]=m};if(O){const w=[],b=await R.Promises.readdir(O);for(const v of b)try{(await R.Promises.stat((0,C.join)(O,v))).isDirectory()&&w.push(v)}catch{}const m=[];for(const v of w)(await R.Promises.readdir((0,C.join)(O,v))).filter(P=>P==="telemetry.json").length===1&&m.push(v);for(const v of m){const p=(await R.Promises.readFile((0,C.join)(O,v,"telemetry.json"))).toString();g(p,v)}}let h=(await R.Promises.readFile((0,C.join)(k,"telemetry-core.json"))).toString();return g(h,"vscode-core"),h=(await R.Promises.readFile((0,C.join)(k,"telemetry-extensions.json"))).toString(),g(h,"vscode-extensions"),JSON.stringify(E,null,4)}e.buildTelemetryMessage=D}),define(Q[29],Z([0,1,9]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[137],Z([0,1,4,2,8,16,23,13,10,29]),function(_,e,C,R,D,k,O,E,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let w=class extends R.Disposable{constructor(m,v,p,P,y){super(),this.extensionsManagementService=m,this.logService=P,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(d=>{this.installedExtensions=d.map(S=>S.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(d=>this.onInstallExtension(d))),this._register(m.onDidInstallExtensions(d=>this.onDidInstallExtensions(d))),this._register(m.onDidUninstallExtension(d=>this.onDidUninstallExtension(d)));const l=D.URI.file(p.extensionsPath);this._register(v.watch(l)),this._register(C.Event.filter(v.onDidFilesChange,d=>d.rawChanges.some(S=>this.doesChangeAffects(S,l)))(()=>this.onDidChange()))}doesChangeAffects(m,v){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),v)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const v of m)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(v=>!(0,O.areSameExtensions)(v,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,O.areSameExtensions)(v,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),v=m.filter(P=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,O.areSameExtensions)(y,P.identifier))?!1:P.installedTimestamp&&P.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",P.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",P.identifier.id),!1)),p=this.installedExtensions.filter(P=>this.installingExtensions.some(y=>(0,O.areSameExtensions)(y,P))?!1:m.every(y=>!(0,O.areSameExtensions)(y.identifier,P))?(this.logService.info("Detected extension removed from another source",P.id),!0):!1);this.installedExtensions=m.map(P=>P.identifier),(v.length||p.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:p})}}};w=he([ee(1,E.IFileService),ee(2,k.INativeEnvironmentService),ee(3,g.ILogService),ee(4,h.IUriIdentityService)],w),e.ExtensionsWatcher=w}),define(Q[138],Z([0,1,29,104,13,18,69,4,2]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class h{constructor(m){this.uri=m,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let w=class{constructor(m){this._fileService=m,this._dispooables=new g.DisposableStore,this._limit=2**16;const v=new Map,p=P=>{let y=v.get(P.scheme);return y===void 0&&(y=m.hasProvider(P)&&!this._fileService.hasCapability(P,1024),v.set(P.scheme,y)),y};this._dispooables.add(E.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(P=>{v.delete(P.scheme)})),this.extUri=new k.ExtUri(p),this._canonicalUris=new O.SkipList((P,y)=>this.extUri.compare(P,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,k.normalizePath)(m));const v=this._canonicalUris.get(m);return v?v.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new h(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((p,P)=>p[1].touch<P[1].touch?1:p[1].touch>P[1].touch?-1:0);h._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let p=0;p<v;p++)this._canonicalUris.set(m[p][0],m[p][1].touch())}};w=he([ee(0,D.IFileService)],w),e.UriIdentityService=w,(0,R.registerSingleton)(C.IUriIdentityService,w,1)}),define(Q[139],Z([0,1,98,14,112,18,8,9,17]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function h(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=h,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function w(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,R.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=w;function b(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function P(n){const i=n;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=P;class y{constructor(i,r,o,c,a){this._id=i,this._transient=o,this._configuration=c,this._ignorePathCasing=a,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,k.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function d(n){return new l({uri:n,index:0,name:(0,k.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(n,i){return k.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function u(n){let i;return O.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=u;function s(n,i){return!S(n,i)&&!u(n)}e.isSavedWorkspace=s;function t(n){return(typeof n=="string"?(0,R.extname)(n):(0,k.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Q[25],Z([0,1,53,4,2,18,5,8,97,16,13,9,10,139,39,29,3,30,27]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function S(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&E.URI.isUri(r.location)&&E.URI.isUri(r.globalStorageHome)&&E.URI.isUri(r.settingsResource)&&E.URI.isUri(r.keybindingsResource)&&E.URI.isUri(r.tasksResource)&&E.URI.isUri(r.snippetsHome)&&((0,O.isUndefined)(r.extensionsResource)||E.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=S,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function u(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:E.URI.revive(i.location).with({scheme:r}),globalStorageHome:E.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:E.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:E.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:E.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:E.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:E.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(i,r,o,c){return{id:i,name:r,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,k.joinPath)(o,"globalStorage"),settingsResource:(0,k.joinPath)(o,"settings.json"),keybindingsResource:(0,k.joinPath)(o,"keybindings.json"),tasksResource:(0,k.joinPath)(o,"tasks.json"),snippetsHome:(0,k.joinPath)(o,"snippets"),extensionsResource:(0,k.joinPath)(o,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=s;let t=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,o,c,a){super(),this.environmentService=r,this.fileService=o,this.uriIdentityService=c,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new R.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new R.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new R.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(f=>s((0,k.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags})):[];let o;const c=new p.ResourceMap,a=s((0,C.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,g.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),r.length){const f=this.getStoredProfileAssociations();if(f.workspaces)for(const[I,N]of Object.entries(f.workspaces)){const B=E.URI.parse(I),K=E.URI.parse(N),J=r.find(ne=>this.uriIdentityService.extUri.isEqual(ne.location,K));J&&c.set(B,J)}if(f.emptyWindow){const I=E.URI.parse(f.emptyWindow);o=r.find(N=>this.uriIdentityService.extUri.isEqual(N.location,I))}}this._profilesObject={profiles:r,workspaces:c,emptyWindow:o}}return this._profilesObject}async createTransientProfile(r){const o="Temp",c=new RegExp(`${(0,d.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const I of this.profiles){const N=c.exec(I.name),B=N?parseInt(N[1]):0;a=B>a?B:a}const f=`${o} ${a+1}`;return this.createProfile((0,C.hash)((0,l.generateUuid)()).toString(16),f,{transient:!0},r)}async createNamedProfile(r,o,c){return this.createProfile((0,C.hash)((0,l.generateUuid)()).toString(16),r,o,c)}async createProfile(r,o,c,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.doCreateProfile(r,o,c);return a&&await this.setProfileForWorkspace(a,f),f}async doCreateProfile(r,o,c){let a=this.profileCreationPromises.get(o);return a||(a=(async()=>{try{const f=this.profiles.find(B=>B.name===o||B.id===r);if(f)return f;const I=s(r,o,(0,k.joinPath)(this.profilesHome,r),c);await this.fileService.createFolder(I.location);const N=[];return this._onWillCreateProfile.fire({profile:I,join(B){N.push(B)}}),await y.Promises.settled(N),this.updateProfiles([I],[],[]),I}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,a)),a}async updateProfile(r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=s(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.logService.error(a)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(r,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(r);return c||(c=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,c)),c}async setProfileForWorkspace(r,o){this.setProfileForWorkspaceSync(r,o)}setProfileForWorkspaceSync(r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(r,c)}unsetWorkspace(r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.getWorkspace(r);return E.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(r){return(0,v.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,v.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}isProfileAssociatedToWorkspace(r){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,r.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,r.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location)))}updateProfiles(r,o,c){const a=[...this.profiles,...r],f=[];this.transientProfilesObject.profiles=[];for(let I of a)I.isDefault||o.some(N=>I.id===N.id)||(I=c.find(N=>I.id===N.id)??I,I.isTransient?this.transientProfilesObject.profiles.push(I):f.push({location:I.location,name:I.name,shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}));this.saveStoredProfiles(f),this._profilesObject=void 0,this.triggerProfilesChanges(r,o,c)}triggerProfilesChanges(r,o,c){this._onDidChangeProfiles.fire({added:r,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(r,o,c){c=o?.isTransient?!0:c,c||this.updateWorkspaceAssociation(r,void 0,!0);const a=this.getWorkspace(r),f=c?this.transientProfilesObject:this.profilesObject;E.URI.isUri(a)?(f.workspaces.delete(a),o&&f.workspaces.set(a,o)):f.emptyWindow=o,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[c,a]of this.profilesObject.workspaces.entries())r[c.toString()]=a.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",t=he([ee(0,h.IEnvironmentService),ee(1,w.IFileService),ee(2,P.IUriIdentityService),ee(3,m.ILogService)],t),e.UserDataProfilesService=t;class n extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=n}),define(Q[140],Z([0,1,19,3,24,11,4,2,12,8,82,22,23,34,10,28,35,25]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends E.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,r,o,c,a){super(),this.galleryService=i,this.telemetryService=r,this.logService=o,this.productService=c,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this._onDidInstallExtensions=this._register(new O.Emitter),this._onUninstallExtension=this._register(new O.Emitter),this._onDidUninstallExtension=this._register(new O.Emitter),this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(({task:f})=>f.cancel()),this.uninstallingExtensions.forEach(f=>f.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,b.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(w.localize(0,null),b.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:o}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(o),u(o)}}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}async reinstallFromGallery(i){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",i.identifier.id),!this.galleryService.isEnabled())throw new Error(w.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...i.identifier,preRelease:i.preRelease}],{targetPlatform:r,compatible:!0},D.CancellationToken.None);if(!o)throw new Error(w.localize(2,null));await this.createUninstallExtensionTask(i,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,r,o){const c=K=>`${m.ExtensionKey.create(K).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!h.URI.isUri(r)){const K=this.installingExtensions.get(c(r));if(K){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:J}=await K.task.waitUntilTaskIsFinished();return J}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],f=[],I=[],N=this.createInstallExtensionTask(i,r,o);h.URI.isUri(r)||this.installingExtensions.set(c(r),{task:N,waitingTasks:[]}),this._onInstallExtension.fire({identifier:N.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",N.identifier.id),a.push({task:N,manifest:i});let B=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const J=await this.getAllDepsAndPackExtensions(N.identifier,i,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:oe,manifest:re}of J){B=B||!!re.extensionDependencies?.some(ie=>(0,m.areSameExtensions)({id:ie},N.identifier));const fe=c(oe),le=this.installingExtensions.get(fe);if(le){if(this.canWaitForTask(N,le.task)){this.logService.info("Waiting for already requested installing extension",oe.identifier.id,N.identifier.id),le.waitingTasks.push(N);const ie=le.task.identifier;f.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,W=>W.some(M=>(0,m.areSameExtensions)(M.identifier,ie)))).then(W=>{if(!W.find(F=>(0,m.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!ne.some(({identifier:ie})=>(0,m.areSameExtensions)(ie,oe.identifier))){const ie=this.createInstallExtensionTask(re,oe,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(fe,{task:ie,waitingTasks:[N]}),this._onInstallExtension.fire({identifier:ie.identifier,source:oe,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,N.identifier.id),a.push({task:ie,manifest:re})}}}catch(J){if(h.URI.isUri(N.source))(0,C.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",N.identifier.id,J.message),(0,C.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",N.identifier.id,J.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),J}const K=a.reduce((J,{task:ne,manifest:oe})=>(J.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:oe}),J),new Map);for(;K.size;){let J;const ne=[...K.values()].filter(({manifest:oe})=>!oe.extensionDependencies?.some(re=>K.has(re.toLowerCase())));ne.length?J=K.size===1?ne:ne.filter(({task:oe})=>!(oe===N&&!B)):(this.logService.info("Found extensions with circular dependencies",ne.map(({task:oe})=>oe.identifier.id)),J=[...K.values()]),await this.joinAllSettled(J.map(async({task:oe})=>{const re=new Date().getTime();try{const{local:fe}=await oe.run();if(await this.joinAllSettled(this.participants.map(le=>le.postInstall(fe,oe.source,o,D.CancellationToken.None))),!h.URI.isUri(oe.source)){const le=oe.operation===3,ie=le?void 0:(new Date().getTime()-oe.source.lastUpdated)/1e3;if(s(this.telemetryService,le?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(oe.source),duration:new Date().getTime()-re,durationSinceUpdate:ie}),g.isWeb&&oe.operation!==3)try{await this.galleryService.reportStatistic(fe.manifest.publisher,fe.manifest.name,fe.manifest.version,"install")}catch{}}I.push({local:fe,identifier:oe.identifier,operation:oe.operation,source:oe.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:fe.isApplicationScoped})}catch(fe){throw h.URI.isUri(oe.source)||s(this.telemetryService,oe.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(oe.source),duration:new Date().getTime()-re,error:fe}),this.logService.error("Error while installing the extension:",oe.identifier.id),fe}finally{K.delete(oe.identifier.id.toLowerCase())}}))}return f.length&&await this.joinAllSettled(f),I.forEach(({identifier:J})=>this.logService.info("Extension installed successfully:",J.id)),this._onDidInstallExtensions.fire(I),I.filter(({identifier:J})=>(0,m.areSameExtensions)(J,N.identifier))[0].local}catch(K){if(a.forEach(({task:J})=>J.cancel()),I.length)try{const J=await Promise.allSettled(I.map(({local:ne})=>this.createUninstallExtensionTask(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<J.length;ne++){const oe=J[ne],{identifier:re}=I[ne];oe.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",re.id):this.logService.warn("Rollback: Error while uninstalling extension",re.id,(0,k.getErrorMessage)(oe.reason))}}catch(J){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(J),I.map(({identifier:ne})=>ne.id))}throw this._onDidInstallExtensions.fire(a.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:o.context,profileLocation:o.profileLocation}))),K}finally{for(const[K,{task:J,waitingTasks:ne}]of this.installingExtensions.entries()){const oe=ne.indexOf(N);oe!==-1&&ne.splice(oe,1),ne.length===0&&(J===N||oe!==-1)&&this.installingExtensions.delete(K)}}}canWaitForTask(i,r){for(const[,{task:o,waitingTasks:c}]of this.installingExtensions.entries())if(o===i&&(c.includes(r)||c.some(a=>this.canWaitForTask(a,r)))||o===r&&c[0]&&!this.canWaitForTask(i,c[0]))return!1;return!0}async joinAllSettled(i){const r=[],o=[],c=await Promise.allSettled(i);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw S(o);return r}async getAllDepsAndPackExtensions(i,r,o,c,a){if(!this.galleryService.isEnabled())return[];const f=await this.getInstalled(void 0,a),I=[i],N=[],B=async(K,J)=>{const ne=J.extensionDependencies||[],oe=[...ne];if(J.extensionPack){const re=o?f.find(fe=>(0,m.areSameExtensions)(fe.identifier,K)):void 0;for(const fe of J.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(le=>(0,m.areSameExtensions)({id:le},{id:fe}))||oe.every(le=>!(0,m.areSameExtensions)({id:le},{id:fe}))&&oe.push(fe)}if(oe.length){const re=[...I,...N.map(le=>le.gallery.identifier)],fe=oe.filter(le=>re.every(ie=>!(0,m.areSameExtensions)(ie,{id:le})));if(fe.length){const le=await this.galleryService.getExtensions(fe.map(ie=>({id:ie,preRelease:c})),D.CancellationToken.None);for(const ie of le){if(re.find(F=>(0,m.areSameExtensions)(F,ie.identifier)))continue;const W=ne.some(F=>(0,m.areSameExtensions)({id:F},ie.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(ie,!1,c)}catch(F){if(F instanceof b.ExtensionManagementError&&F.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}N.push({gallery:M.extension,manifest:M.manifest}),await B(M.extension.identifier,M.manifest)}}}};return await B(i,r),N}async checkAndGetCompatibleVersion(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(I=>(0,m.areSameExtensions)(i.identifier,I)))throw new b.ExtensionManagementError(w.localize(3,null,i.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const I=await this.getTargetPlatform();throw new b.ExtensionManagementError(w.localize(4,null,i.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(I)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(i,r,o);if(a){if(o&&!r&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(w.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],D.CancellationToken.None))[0]?new b.ExtensionManagementError(w.localize(6,null,i.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(w.localize(7,null,i.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const f=await this.galleryService.getManifest(a,D.CancellationToken.None);if(f===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(f.version!==a.version)throw new b.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:f}}async getCompatibleVersion(i,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(i,o,c)&&(a=i),a||(r?a=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(i,o,c)),a}async uninstallExtension(i,r){const o=B=>`${B.id.toLowerCase()}${r.versionOnly?`-${i.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,c=this.uninstallingExtensions.get(o(i.identifier));if(c)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),c.waitUntilTaskIsFinished();const a=(B,K)=>{const J=this.createUninstallExtensionTask(B,K);return this.uninstallingExtensions.set(o(J.extension.identifier),J),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${B.identifier.id}@${B.manifest.version}`),this._onUninstallExtension.fire({identifier:B.identifier,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped}),J},f=(B,K)=>{K?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString(),K.message):this.logService.error("Failed to uninstall extension:",`${B.identifier.id}@${B.manifest.version}`,K.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${B.identifier.id}@${B.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(B),error:K}),this._onDidUninstallExtension.fire({identifier:B.identifier,version:B.manifest.version,error:K?.code,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped})},I=[],N=[];try{I.push(a(i,r));const B=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const K=this.getAllPackExtensionsToUninstall(i,B);for(const J of K)this.uninstallingExtensions.has(o(J.identifier))?this.logService.info("Extensions is already requested to uninstall",J.identifier.id):I.push(a(J,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(I.map(K=>K.extension),B,i),await this.joinAllSettled(I.map(async K=>{try{if(await K.run(),await this.joinAllSettled(this.participants.map(J=>J.postUninstall(K.extension,r,D.CancellationToken.None))),K.extension.identifier.uuid)try{await this.galleryService.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,"uninstall")}catch{}f(K.extension)}catch(J){const ne=J instanceof b.ExtensionManagementError?J:new b.ExtensionManagementError((0,k.getErrorMessage)(J),b.ExtensionManagementErrorCode.Internal);throw f(K.extension,ne),ne}finally{N.push(K)}}))}catch(B){const K=B instanceof b.ExtensionManagementError?B:new b.ExtensionManagementError((0,k.getErrorMessage)(B),b.ExtensionManagementErrorCode.Internal);for(const J of I){try{J.cancel()}catch{}N.includes(J)||f(J.extension,K)}throw K}finally{for(const B of I)this.uninstallingExtensions.delete(o(B.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}checkForDependents(i,r,o){for(const c of i){const a=this.getDependents(c,r);if(a.length){const f=a.filter(I=>!i.some(N=>(0,m.areSameExtensions)(N.identifier,I.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(c,f,o))}}}getDependentsErrorMessage(i,r,o){return o===i?r.length===1?w.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?w.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):w.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?w.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?w.localize(12,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):w.localize(13,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const a=r.filter(I=>!I.isBuiltin&&c.some(N=>(0,m.areSameExtensions)({id:N},I.identifier))),f=[];for(const I of a)f.push(...this.getAllPackExtensionsToUninstall(I,r,o));return[...a,...f]}return[]}getDependents(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,m.areSameExtensions)({id:c},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(i,r,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(i)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(i,r,o)}createUninstallExtensionTask(i,r){return r.profileLocation&&i.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(i,r)}};d=he([ee(0,b.IExtensionGalleryService),ee(1,y.ITelemetryService),ee(2,p.ILogService),ee(3,P.IProductService),ee(4,l.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function S(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=S;function u(n){if(n instanceof b.ExtensionManagementError)return n;const i=new b.ExtensionManagementError(n.message,b.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function s(n,i,{extensionData:r,duration:o,error:c,durationSinceUpdate:a}){const f=c?c instanceof b.ExtensionManagementError?c.code:b.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(i,{...r,success:!c,duration:o,errorcode:f,durationSinceUpdate:a})}e.reportTelemetry=s;class t{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(i=>new Promise((r,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(Q[48],Z([0,1,19,3,26,15,11,50,74,2,17,14,12,18,38,54,5,8,86,16,23,34,45,13,9,10,28,4,44,41,25,29,102]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l,d,S,u,s,t,n,i,r,o,c,a,f,I,N,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ie){function W(M,F){if(M===F)return!0;const z=Object.keys(M),$=new Set;for(const Y of Object.keys(F))$.add(Y);if(z.length!==$.size)return!1;for(const Y of z){if(M[Y]!==F[Y])return!1;$.delete(Y)}return $.size===0}ie.equals=W})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let J=class extends h.Disposable{constructor(W,M,F,z,$,Y,A,x,L,T,U){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=M,this.extensionsControlLocation=F,this.cacheLocation=z,this.userDataProfilesService=$,this.extensionsProfileScannerService=Y,this.fileService=A,this.logService=x,this.environmentService=L,this.productService=T,this.instantiationService=U,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,v.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,v.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,M,F){const[z,$]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(M)]),Y=F?await this.scanExtensionsUnderDevelopment(W,[...z,...$]):[];return this.dedupExtensions(z,$,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const M=[];M.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),M.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[F,z]=await Promise.all(M);return this.applyScanOptions([...F,...z],0,W,!1)}async scanUserExtensions(W){this.logService.trace("Started scanning user extensions");const M=await this.createExtensionScannerInput(W.profileLocation??this.userExtensionsLocation,!!W.profileLocation,1,!W.includeUninstalled,W.language);let z=await(W.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return z=await this.applyScanOptions(z,1,W,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(W,M){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===w.Schemas.file).map(async z=>{const $=await this.createExtensionScannerInput(z,!1,1,!0,W.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=M.find(x=>(0,u.areSameExtensions)(x.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",W,!0)}return[]}async scanExistingExtension(W,M,F){const z=await this.createExtensionScannerInput(W,!1,M,!0,F.language),$=await this.extensionsScanner.scanExtension(z);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(W,M,F){const z=await this.createExtensionScannerInput(W,!1,M,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions($,M,F,!0)}async scanMetadata(W){const M=(0,v.joinPath)(W,"package.json"),F=(await this.fileService.readFile(M)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(W,M){const F=(0,v.joinPath)(W,"package.json"),z=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(z);M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.installedTimestamp=M.installedTimestamp||void 0,$.__metadata={...$.__metadata,...M},await this.fileService.writeFile((0,v.joinPath)(W,"package.json"),k.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(W,M,F,z){return F.includeAllVersions||(W=this.dedupExtensions(M===0?W:void 0,M===1?W:void 0,M==="development"?W:void 0,await this.getTargetPlatform(),z)),F.includeInvalid||(W=W.filter($=>$.isValid)),W.sort(($,Y)=>{const A=b.basename($.location.fsPath),x=b.basename(Y.location.fsPath);return A<x?-1:A>x?1:0})}dedupExtensions(W,M,F,z,$){const Y=(x,L,T)=>{if(x.isValid&&!L.isValid)return!1;if(x.isValid===L.isValid){if($&&p.gt(x.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(p.eq(x.manifest.version,L.manifest.version)){if(x.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===z)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return T?this.logService.warn(`Overwriting user extension ${x.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${x.location.path} with ${L.location.path}.`),!0},A=new Map;return W?.forEach(x=>{const L=s.ExtensionIdentifier.toKey(x.identifier.id),T=A.get(L);(!T||Y(T,x,!1))&&A.set(L,x)}),M?.forEach(x=>{const L=s.ExtensionIdentifier.toKey(x.identifier.id),T=A.get(L);if(!T&&W&&x.type===0){this.logService.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!T||Y(T,x,!1))&&A.set(L,x)}),F?.forEach(x=>{const L=s.ExtensionIdentifier.toKey(x.identifier.id),T=A.get(L);(!T||Y(T,x,!0))&&A.set(L,x),A.set(L,x)}),[...A.values()]}async scanDefaultSystemExtensions(W,M){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,M),$=await(W&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(W,M){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=M?await this.getBuiltInExtensionControl():{},$=[],Y=l.URI.file(b.normalize(b.join(w.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions")));for(const x of F){const L=z[x.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(Y,x.name));break;default:$.push(l.URI.file(L));break}}const A=await Promise.all($.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,!1,0,!0,W))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,C.coalesce)(A)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,M,F,z,$,Y=!0){const A=await this.getTranslations($??m.language),x=await this.getMtime(W),L=M?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,T=L?await this.getMtime(L):void 0;return new ne(W,x,L,T,M,F,z,Y,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(W){try{const M=await this.fileService.stat(W);if(typeof M.mtime=="number")return M.mtime}catch{}}};J=he([ee(4,I.IUserDataProfilesService),ee(5,f.IExtensionsProfileScannerService),ee(6,n.IFileService),ee(7,r.ILogService),ee(8,S.IEnvironmentService),ee(9,o.IProductService),ee(10,i.IInstantiationService)],J),e.AbstractExtensionsScannerService=J;class ne{constructor(W,M,F,z,$,Y,A,x,L,T,U,j,q,H){this.location=W,this.mtime=M,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=Y,this.excludeObsolete=A,this.validate=x,this.productVersion=L,this.productDate=T,this.productCommit=U,this.devMode=j,this.language=q,this.translations=H}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,M){return(0,v.isEqual)(W.location,M.location)&&W.mtime===M.mtime&&(0,v.isEqual)(W.applicationExtensionslocation,M.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===M.applicationExtensionslocationMtime&&W.profile===M.profile&&W.type===M.type&&W.excludeObsolete===M.excludeObsolete&&W.validate===M.validate&&W.productVersion===M.productVersion&&W.productDate===M.productDate&&W.productCommit===M.productCommit&&W.devMode===M.devMode&&W.language===M.language&&K.equals(W.translations,M.translations)}}let oe=class extends h.Disposable{constructor(W,M,F,z,$){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=M,this.uriIdentityService=F,this.fileService=z,this.logService=$}async scanExtensions(W){const M=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let F={};if(W.excludeObsolete&&W.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(z)}catch{}return(0,y.isEmptyObject)(F)?M:M.filter(z=>!F[u.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(W){const M=await this.fileService.resolve(W.location);if(!M.children?.length)return[];const F=await Promise.all(M.children.map(async z=>{if(!z.isDirectory||W.type===1&&(0,v.basename)(z.resource).indexOf(".")===0)return null;const $=new ne(z.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension($)}));return(0,C.coalesce)(F).sort((z,$)=>z.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(W){let M=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){M=M.filter(z=>!z.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,W);M.push(...F)}return M}async scanExtensionsFromProfileResource(W,M,F){const z=await this.extensionsProfileScannerService.scanProfileExtensions(W);if(!z.length)return[];const $=await Promise.all(z.map(async Y=>{if(M(Y)){const A=new ne(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,Y.metadata)}return null}));return(0,C.coalesce)($)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,v.joinPath)(W.location,"package.json"))){const M=await this.scanExtension(W);return M?[M]:[]}else return await this.scanExtensions(W)}catch(M){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,O.getErrorMessage)(M)),[]}}async scanExtension(W,M){try{let F=await this.scanExtensionManifest(W.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),M=M??F.__metadata,delete F.__metadata;const z=(0,u.getGalleryExtensionId)(F.publisher,F.name),$=M?.id?{id:z,uuid:M.id}:{id:z},Y=M?.isSystem?0:W.type,A=Y===0||!!M?.isBuiltin;F=await this.translateManifest(W.location,F,ne.createNlsConfiguration(W));const x={type:Y,identifier:$,manifest:F,location:W.location,isBuiltin:A,targetPlatform:M?.targetPlatform??"undefined",metadata:M,isValid:!0,validations:[]};return W.validate?this.validate(x,W):x}}catch(F){W.type!==0&&this.logService.error(F)}return null}validate(W,M){let F=!0;const z=(0,t.validateExtensionManifest)(M.productVersion,M.productDate,M.location,W.manifest,W.isBuiltin);for(const[$,Y]of z)$===P.default.Error&&(F=!1,this.logService.error(this.formatMessage(M.location,Y)));return W.isValid=F,W.validations=z,W}async scanExtensionManifest(W){const M=(0,v.joinPath)(W,"package.json");let F;try{F=(await this.fileService.readFile(M)).value.toString()}catch($){return(0,n.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(W,(0,d.localize)(0,null,M.path,$.message))),null}let z;try{z=JSON.parse(F)}catch{const Y=[];(0,E.parse)(F,Y);for(const A of Y)this.logService.error(this.formatMessage(W,(0,d.localize)(1,null,M.path,A.offset,A.length,(0,g.getParseErrorMessage)(A.error))));return null}return(0,E.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(W,(0,d.localize)(2,null,M.path))),null):z}async translateManifest(W,M,F){const z=await this.getLocalizedMessages(W,M,F);if(z)try{const $=[],Y=await this.resolveOriginalMessageBundle(z.default,$);if($.length>0)return $.forEach(x=>{this.logService.error(this.formatMessage(W,(0,d.localize)(3,null,z.default?.path,(0,g.getParseErrorMessage)(x.error))))}),M;if((0,E.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(W,(0,d.localize)(4,null,z.default?.path))),M;const A=z.values||Object.create(null);return(0,B.localizeManifest)(M,A,Y)}catch{}return M}async getLocalizedMessages(W,M,F){const z=(0,v.joinPath)(W,"package.nls.json"),$=(L,T)=>{T.forEach(U=>{this.logService.error(this.formatMessage(W,(0,d.localize)(5,null,L?.path,(0,g.getParseErrorMessage)(U.error))))})},Y=L=>{this.logService.error(this.formatMessage(W,(0,d.localize)(6,null,L?.path)))},A=`${M.publisher}.${M.name}`,x=F.translations[A];if(x)try{const L=l.URI.file(x),T=(await this.fileService.readFile(L)).value.toString(),U=[],j=(0,E.parse)(T,U);return U.length>0?($(L,U),{values:void 0,default:z}):(0,E.getNodeType)(j)!=="object"?(Y(L),{values:void 0,default:z}):{values:j.contents?j.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let T;try{T=await this.findMessageBundles(W,F)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const U=(await this.fileService.readFile(T.localized)).value.toString(),j=[],q=(0,E.parse)(U,j);return j.length>0?($(T.localized,j),{values:void 0,default:T.original}):(0,E.getNodeType)(q)!=="object"?(Y(T.localized),{values:void 0,default:T.original}):{values:q,default:T.original}}catch{return{values:void 0,default:T.original}}}}async resolveOriginalMessageBundle(W,M){if(W)try{const F=(await this.fileService.readFile(W)).value.toString();return(0,E.parse)(F,M)}catch{}}findMessageBundles(W,M){return new Promise((F,z)=>{const $=Y=>{const A=(0,v.joinPath)(W,`package.nls.${Y}.json`);this.fileService.exists(A).then(x=>{x&&F({localized:A,original:(0,v.joinPath)(W,"package.nls.json")});const L=Y.lastIndexOf("-");L===-1?F({localized:(0,v.joinPath)(W,"package.nls.json"),original:null}):(Y=Y.substring(0,L),$(Y))})};if(M.devMode||M.pseudo||!M.language)return F({localized:(0,v.joinPath)(W,"package.nls.json"),original:null});$(M.language)})}formatMessage(W,M){return`[${W.path}]: ${M}`}};oe=he([ee(1,f.IExtensionsProfileScannerService),ee(2,N.IUriIdentityService),ee(3,n.IFileService),ee(4,r.ILogService)],oe);let re=class extends oe{constructor(W,M,F,z,$,Y){super(M,F,z,$,Y),this.cacheFile=W,this.cacheValidatorThrottler=this._register(new R.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const M=await this.readExtensionCache();if(this.input=W,M&&M.input&&ne.equals(M.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),M.result.map(z=>(z.location=l.URI.revive(z.location),z));const F=await super.scanExtensions(W);return await this.writeExtensionCache({input:W,result:F}),F}async readExtensionCache(){try{const W=await this.fileService.readFile(this.cacheFile),M=JSON.parse(W.value.toString());return{result:M.result,input:(0,a.revive)(M.input)}}catch(W){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(W))}return null}async writeExtensionCache(W){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(W)))}catch(M){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(M))}}async validateCache(){if(!this.input)return;const W=await this.readExtensionCache();if(!W)return;const M=W.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(F,M))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};re=he([ee(2,f.IExtensionsProfileScannerService),ee(3,N.IUriIdentityService),ee(4,n.IFileService),ee(5,r.ILogService)],re);function fe(ie,W){const M=(0,u.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:M,identifier:new s.ExtensionIdentifier(M),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:W,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=fe;class le extends J{constructor(W,M,F,z,$,Y,A,x,L,T,U){super(W,M,(0,v.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,Y,A,x,L,T,U),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const j=await this.fileService.readFile(l.URI.file(m.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=le}),define(Q[141],Z([0,1,57,3,31,4,2,17,14,20,10,25]),function(_,e,C,R,D,k,O,E,g,h,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends O.Disposable{constructor(p,P){super(),this.userDataProfilesService=p,this.logService=P,this.processesLimiter=new R.Limiter(5)}async postUninstall(p){const P=this.parseScript(p,"uninstall");return P&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(P.script,"uninstall",P.args,!0,p).then(()=>this.logService.info(p.identifier.id,p.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(p.identifier.id,p.manifest.version,`Failed to run post uninstall script: ${y}`)))),h.Promises.rm(this.getExtensionStoragePath(p)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(p,P){const y=`vscode:${P}`;if(p.location.scheme===E.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[y]=="string"){const l=p.manifest.scripts[y].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${y} should be a node script`),null):{script:(0,g.join)(p.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(p,P,y,l,d){return new Promise((S,u)=>{const s=this.start(p,P,y,d);let t;const n=i=>{t&&(clearTimeout(t),t=null),i?u(i):S(void 0)};s.on("error",i=>{n((0,D.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${P} process exited with code ${i}`:void 0)}),l&&(t=setTimeout(()=>{t=null,s.kill(),u("timed out")},5e3))})}start(p,P,y,l){const d={silent:!0,execArgv:void 0},S=(0,C.fork)(p,[`--type=extension-post-${P}`,...y],d);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const u=k.Event.fromNodeEventEmitter(S.stdout,"data"),s=k.Event.fromNodeEventEmitter(S.stderr,"data");u(i=>this.logService.info(l.identifier.id,l.manifest.version,`post-${P}`,i)),s(i=>this.logService.error(l.identifier.id,l.manifest.version,`post-${P}`,i));const t=k.Event.any(k.Event.map(u,i=>({data:`%c${i}`,format:[""]})),k.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return k.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(l.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),S}getExtensionStoragePath(p){return(0,g.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};m=he([ee(0,b.IUserDataProfilesService),ee(1,w.ILogService)],m),e.ExtensionsLifecycle=m}),define(Q[142],Z([0,1,8,16,41,48,13,9,10,28,25]),function(_,e,C,R,D,k,O,E,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends k.NativeExtensionsScannerService{constructor(v,p,P,y,l,d,S){super(C.URI.file(l.builtinExtensionsPath),C.URI.file(l.extensionsPath),l.userHome,C.URI.file(l.userDataPath),v,p,P,y,l,d,S)}};b=he([ee(0,w.IUserDataProfilesService),ee(1,D.IExtensionsProfileScannerService),ee(2,O.IFileService),ee(3,g.ILogService),ee(4,R.INativeEnvironmentService),ee(5,h.IProductService),ee(6,E.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(Q[143],Z([0,1,3,4,2,113,5,79,9,25]),function(_,e,C,R,D,k,O,E,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var w;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function v(d){const S=d.get(e.TARGET_KEY);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}e.loadKeyTargets=v;class p extends D.Disposable{constructor(S={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=S,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,u){if(u===e.TARGET_KEY){switch(S){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:S})}else this._onDidChangeValue.fire({scope:S,key:u,target:this.getKeyTargets(S)[u]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,u,s){return this.getStorage(u)?.get(S,s)}getBoolean(S,u,s){return this.getStorage(u)?.getBoolean(S,s)}getNumber(S,u,s){return this.getStorage(u)?.getNumber(S,s)}store(S,u,s,t){if((0,O.isUndefinedOrNull)(u)){this.remove(S,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,s,t),this.getStorage(s)?.set(S,u)})}remove(S,u){this.withPausedEmitters(()=>{this.updateKeyTarget(S,u,void 0),this.getStorage(u)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,u){const s=[],t=this.getKeyTargets(S);for(const n of Object.keys(t))t[n]===u&&s.push(n);return s}updateKeyTarget(S,u,s){const t=this.getKeyTargets(u);typeof s=="number"?t[S]!==s&&(t[S]=s,this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[S]=="number"&&(delete t[S],this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(S){switch(S){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(S){const u=this.getStorage(S);return u?v(u):Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=w.NONE){this._onWillSaveState.fire({reason:S});const u=this.getStorage(-1),s=this.getStorage(0),t=this.getStorage(1);switch(S){case w.NONE:await C.Promises.settled([u?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await C.Promises.settled([u?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(S,u,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(S,u){return this.emitWillSaveState(w.NONE),(0,h.isUserDataProfile)(S)?this.switchToProfile(S,u):this.switchToWorkspace(S,u)}canSwitchProfile(S,u){return!(S.id===u.id||P(u)&&P(S))}switchData(S,u,s,t){this.withPausedEmitters(()=>{if(t)for(const[n,i]of S)u.set(n,i);else{const n=new Set;for(const[i,r]of S)n.add(i),u.get(i)!==r&&this.emitDidChangeValue(s,i);for(const[i]of u.items)n.has(i)||this.emitDidChangeValue(s,i)}})}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;function P(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=P;class y extends p{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.profileStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S))),this._register(this.applicationStorage.onDidChangeStorage(S=>this.emitDidChangeValue(-1,S)))}getStorage(S){switch(S){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(S){switch(S){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(S){return!1}}e.InMemoryStorageService=y;async function l(d,S,u,s,t,n){const i=K=>{try{return JSON.parse(K)}catch{return K}},r=new Map,o=new Map;d.forEach((K,J)=>{r.set(J,K),o.set(J,i(K))});const c=new Map,a=new Map;S.forEach((K,J)=>{c.set(J,K),a.set(J,i(K))});const f=new Map,I=new Map;u.forEach((K,J)=>{f.set(J,K),I.set(J,i(K))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const N=[];if(r.forEach((K,J)=>{N.push({key:J,value:K})}),console.table(N),console.groupEnd(),console.log(o),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const K=[];c.forEach((J,ne)=>{K.push({key:ne,value:J})}),console.table(K),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const B=[];f.forEach((K,J)=>{B.push({key:J,value:K})}),console.table(B),console.groupEnd(),console.log(I)}e.logStorage=l}),define(Q[144],Z([0,1,19,24,11,12,32,5,8,21,16,22,23,45,13,10,28,47,131,143,35]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l,d,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=k.isWeb?"web":(0,b.getTargetPlatform)(k.platform,O.arch);var t;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...L){return String(L.reduce((T,U)=>T|U,0))}var i;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class f{constructor(T=a){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(T,U=this.state.pageSize){return new f({...this.state,pageNumber:T,pageSize:U})}withFilter(T,...U){const j=[...this.state.criteria,...U.length?U.map(q=>({filterType:T,value:q})):[{filterType:T}]];return new f({...this.state,criteria:j})}withSortBy(T){return new f({...this.state,sortBy:T})}withSortOrder(T){return new f({...this.state,sortOrder:T})}withFlags(...T){return new f({...this.state,flags:T.reduce((U,j)=>U|j,0)})}withAssetTypes(...T){return new f({...this.state,assetTypes:T})}withSource(T){return new f({...this.state,source:T})}get raw(){const{criteria:T,pageNumber:U,pageSize:j,sortBy:q,sortOrder:H,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:T,pageNumber:U,pageSize:j,sortBy:q,sortOrder:H}],assetTypes:ce,flags:ae}}get searchText(){const T=this.state.criteria.filter(U=>U.filterType===i.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function I(L,T){const U=(L||[]).filter(j=>j.statisticName===T)[0];return U?U.value:0}function N(L){const T="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(j=>j.assetType.indexOf(T)===0).reduce((j,q)=>{const H=J(L,q.assetType);return H&&j.push([q.assetType.substring(T.length),H]),j},[])}function B(L){if(L.properties){const T=L.properties.filter(q=>q.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=T.filter(q=>U.test(q.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return J(L,r.Repository)}function K(L){return{uri:`${L.fallbackAssetUri}/${r.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${r.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function J(L,T){return L.files.filter(j=>j.assetType===T)[0]?{uri:`${L.assetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ne(L,T){const U=L.properties?L.properties.filter(q=>q.key===T):[],j=U.length>0&&U[0].value;return j?j.split(",").map(q=>(0,m.adoptToGalleryExtensionId)(q)):[]}function oe(L){const T=L.properties?L.properties.filter(U=>U.key===o.Engine):[];return T.length>0&&T[0].value||""}function re(L){const T=L.properties?L.properties.filter(U=>U.key===o.PreRelease):[];return T.length>0&&T[0].value==="true"}function fe(L){const T=L.properties?L.properties.filter(j=>j.key===o.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function le(L){return L.properties?.find(T=>T.key===o.SponsorLink)?.value}function ie(L){return L.indexOf("preview")!==-1}function W(L){return L.targetPlatform?(0,b.toTargetPlatform)(L.targetPlatform):"undefined"}function M(L){const T=(0,C.distinct)(L.versions.map(W)),U=!!L.tags?.includes(b.WEB_EXTENSION_TAG),j=T.indexOf("web");return U?j===-1&&T.push("web"):j!==-1&&T.splice(j,1),T}function F(L,T){const U=(0,b.getFallbackTargetPlarforms)(T);for(let j=0;j<L.length;j++){const q=L[j];if(q.version===L[j-1]?.version){let H=j;const ae=W(q);if(ae===T)for(;H>0&&L[H-1].version===q.version;)H--;else if(U.includes(ae))for(;H>0&&L[H-1].version===q.version&&W(L[H-1])!==T;)H--;H!==j&&(L.splice(j,1),L.splice(H,0,q))}}return L}e.sortExtensionVersions=F;function z(L,T,U){L.telemetryData={index:T,querySource:U}}function $(L,T,U){const j=L.versions[0],q={manifest:J(T,r.Manifest),readme:J(T,r.Details),changelog:J(T,r.Changelog),license:J(T,r.License),repository:B(T),download:K(T),icon:J(T,r.Icon),coreTranslations:N(T)};return{identifier:{id:(0,m.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:T.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(j),description:L.shortDescription||"",installCount:I(L.statistics,"install"),rating:I(L.statistics,"averagerating"),ratingCount:I(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:U,assets:q,properties:{dependencies:ne(T,o.Dependency),extensionPack:ne(T,o.ExtensionPack),engine:oe(T),localizedLanguages:fe(T),targetPlatform:W(T),isPreReleaseVersion:re(T)},hasPreReleaseVersion:re(j),hasReleaseVersion:!0,preview:ie(L.flags)}}let Y=class{constructor(T,U,j,q,H,ae,ce,pe){this.requestService=U,this.logService=j,this.environmentService=q,this.telemetryService=H,this.fileService=ae,this.productService=ce,this.configurationService=pe;const ye=ce.extensionsGallery;this.extensionsGalleryUrl=ye?.serviceUrl,this.extensionsGallerySearchUrl=ye?.searchUrl,this.extensionsControlUrl=ye?.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,T,this.telemetryService)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,U,j){const q=R.CancellationToken.isCancellationToken(U)?{}:U,H=R.CancellationToken.isCancellationToken(U)?U:j,ae=[],ce=[],pe=[],ye=[];let te=!0;for(const de of T){de.uuid?ce.push(de.uuid):ae.push(de.id);const ve=!!(de.version||de.preRelease);pe.push({id:de.id,uuid:de.uuid,includePreRelease:ve}),de.version&&ye.push({id:de.id,uuid:de.uuid,version:de.version}),te=te&&!!de.hasPreRelease&&!ve}if(!ce.length&&!ae.length)return[];let se=new f().withPage(1,T.length);ce.length&&(se=se.withFilter(i.ExtensionId,...ce)),ae.length&&(se=se.withFilter(i.ExtensionName,...ae)),(q.queryAllVersions||te)&&(se=se.withFlags(se.flags,t.IncludeVersions)),q.source&&(se=se.withSource(q.source));const{extensions:ge}=await this.queryGalleryExtensions(se,{targetPlatform:q.targetPlatform??s,includePreRelease:pe,versions:ye,compatible:!!q.compatible},H);return q.source&&ge.forEach((de,ve)=>z(de,ve,q.source)),ge}async getCompatibleExtension(T,U,j){if((0,b.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(T,U,j))return T;const q=new f().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,T.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(q,{targetPlatform:j,compatible:!0,includePreRelease:U},R.CancellationToken.None);return H[0]||null}async isExtensionCompatible(T,U,j){if(!(0,b.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,j)||!U&&T.properties.isPreReleaseVersion)return!1;let q=T.properties.engine;if(!q){const H=await this.getManifest(T,R.CancellationToken.None);if(!H)throw new Error("Manifest was not found");q=H.engines.vscode}return(0,v.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(T,U,j,q,H){if(!(0,b.isTargetPlatformCompatible)(W(T),q,H)||U!=="any"&&re(T)!==(U==="prerelease"))return!1;if(j)try{const ae=await this.getEngine(T);if(!(0,v.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${T.version}.`,(0,D.getErrorMessage)(ae)),!1}return!0}async query(T,U){let j=T.text||"";const q=T.pageSize??50;let H=new f().withPage(1,q);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,se,ge)=>(H=H.withFilter(i.Category,ge||se),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,se,ge)=>(H=H.withFilter(i.Tag,ge||se),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(i.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),H=H.withFilter(i.SearchText,j)),H=H.withSortBy(0)):T.ids?H=H.withFilter(i.ExtensionId,...T.ids):T.names?H=H.withFilter(i.ExtensionName,...T.names):H=H.withSortBy(4),typeof T.sortBy=="number"&&(H=H.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(H=H.withSortOrder(T.sortOrder)),T.source&&(H=H.withSource(T.source));const ae=async(te,se)=>{const{extensions:ge,total:de}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!T.includePreRelease},se);return ge.forEach((ve,ke)=>z(ve,(te.pageNumber-1)*te.pageSize+ke,T.source)),{extensions:ge,total:de}},{extensions:ce,total:pe}=await ae(H,U),ye=async(te,se)=>{if(se.isCancellationRequested)throw new D.CancellationError;const{extensions:ge}=await ae(H.withPage(te+1),se);return ge};return{firstPage:ce,total:pe,pageSize:H.pageSize,getPage:ye}}async queryGalleryExtensions(T,U,j){const q=T.flags;!!(T.flags&t.IncludeLatestVersionOnly)&&!!(T.flags&t.IncludeVersions)&&(T=T.withFlags(T.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(T.flags&t.IncludeLatestVersionOnly)&&!(T.flags&t.IncludeVersions)&&(T=T.withFlags(T.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(T=T.withFlags(T.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),T=T.withFlags(T.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:H,total:ae}=await this.queryRawGalleryExtensions(T,j);if(!(T.flags&t.IncludeLatestVersionOnly)){const te=[];for(const se of H){const ge=await this.toGalleryExtensionWithCriteria(se,U);ge&&te.push(ge)}return{extensions:te,total:ae}}const pe=[],ye=new Map;for(let te=0;te<H.length;te++){const se=H[te],ge={id:(0,m.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},de=(0,E.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ke=>(0,m.areSameExtensions)(ke,ge))?.includePreRelease;if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(M(se),U.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(se,U);!ve||ve.properties.isPreReleaseVersion&&(!de||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==U.targetPlatform&&ve.hasPreReleaseVersion?ye.set(se.extensionId,te):pe.push([te,ve])}if(ye.size){const te=new Date().getTime(),se=new f().withFlags(q&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ye.size).withFilter(i.ExtensionId,...ye.keys()),{extensions:ge}=await this.queryGalleryExtensions(se,U,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:ye.size});for(const de of ge){const ve=ye.get(de.identifier.uuid);pe.push([ve,de])}}return{extensions:pe.sort((te,se)=>te[0]-se[0]).map(([,te])=>te),total:ae}}async toGalleryExtensionWithCriteria(T,U){const j={id:(0,m.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},q=U.versions?.find(pe=>(0,m.areSameExtensions)(pe,j))?.version,H=(0,E.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(pe=>(0,m.areSameExtensions)(pe,j))?.includePreRelease,ae=M(T),ce=F(T.versions,U.targetPlatform);if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(ae,U.targetPlatform))return null;for(let pe=0;pe<ce.length;pe++){const ye=ce[pe];if(!(q&&ye.version!==q)){if(await this.isValidVersion(ye,H?"any":"release",U.compatible,ae,U.targetPlatform))return $(T,ye,ae);if(q&&ye.version===q)return null}}return q||U.compatible?null:$(T,T.versions[0],ae)}async queryRawGalleryExtensions(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(t.Unpublished));const j=await this.commonHeadersPromise,q=JSON.stringify(T.raw),H={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ae=new Date().getTime();let ce,pe,ye=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&T.criteria.some(se=>se.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:H},U),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:ye};const te=await(0,l.asJson)(ce);if(te){const se=te.results[0],ge=se.extensions,de=se.resultMetadata&&se.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return ye=de&&de.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ye}}return{galleryExtensions:[],total:ye}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ae,success:!!ce&&(0,l.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:pe?(0,D.isCancellationError)(pe)?"canceled":(0,D.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(T,U,j,q){if(!this.isEnabled())return;const H=k.isWeb?this.api(`/itemName/${T}.${U}/version/${j}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${T}/extensions/${U}/${j}/stats?statType=${q}`),ae=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:H,headers:pe},R.CancellationToken.None)}catch{}}async download(T,U,j){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const q=(0,m.getGalleryExtensionTelemetryData)(T),H=new Date().getTime(),ae=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:te}),ce=j===2?"install":j===3?"update":"",pe=ce?{uri:`${T.assets.download.uri}${g.URI.parse(T.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${T.assets.download.fallbackUri}${g.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:T.assets.download,ye=await this.getAsset(pe);await this.fileService.writeFile(U,ye.stream),ae(new Date().getTime()-H)}async getReadme(T,U){if(T.assets.readme){const j=await this.getAsset(T.assets.readme,{},U);return await(0,l.asTextOrError)(j)||""}return""}async getManifest(T,U){if(T.assets.manifest){const j=await this.getAsset(T.assets.manifest,{},U),q=await(0,l.asTextOrError)(j);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(T,U){const j=J(T,r.Manifest);if(!j)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},H=await this.getAsset(j,{headers:q});return await(0,l.asJson)(H)}async getCoreTranslation(T,U){const j=T.assets.coreTranslations.filter(q=>q[0]===U.toUpperCase())[0];if(j){const q=await this.getAsset(j[1]),H=await(0,l.asTextOrError)(q);return H?JSON.parse(H):null}return null}async getChangelog(T,U){if(T.assets.changelog){const j=await this.getAsset(T.assets.changelog,{},U);return await(0,l.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(T,U,j){let q=new f().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?q=q.withFilter(i.ExtensionId,T.identifier.uuid):q=q.withFilter(i.ExtensionName,T.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(q,R.CancellationToken.None);if(!H.length)return[];const ae=M(H[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(ae,j))return[];const ce=[];await Promise.all(H[0].versions.map(async te=>{try{await this.isValidVersion(te,U?"any":"release",!0,ae,j)&&ce.push(te)}catch{}}));const pe=[],ye=new Set;for(const te of F(ce,j))ye.has(te.version)||(ye.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:re(te)}));return pe}async getAsset(T,U={},j=R.CancellationToken.None){const q=await this.commonHeadersPromise,H={type:"GET"},ae={...q,...U.headers||{}};U={...U,...H,headers:ae};const ce=T.uri,pe=T.fallbackUri,ye={...U,url:ce};try{const te=await this.requestService.request(ye,j);if(te.res.statusCode===200)return te;const se=await(0,l.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${se}`)}catch(te){if((0,D.isCancellationError)(te))throw te;const se=(0,D.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:se});const ge={...U,url:pe};return this.requestService.request(ge,j)}}async getEngine(T){let U=oe(T);if(!U){const j=await this.getManifestFromRawExtensionVersion(T,R.CancellationToken.None);if(!j)throw new Error("Manifest was not found");U=j.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(T),j=[],q={};if(U){for(const H of U.malicious)j.push({id:H});if(U.migrateToPreRelease)for(const[H,ae]of Object.entries(U.migrateToPreRelease))(!ae.engine||(0,v.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(q[H.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[H,ae]of Object.entries(U.deprecated))ae&&(q[H.toLowerCase()]=(0,E.isBoolean)(ae)?{}:ae)}return{malicious:j,deprecated:q}}};Y=he([ee(1,l.IRequestService),ee(2,P.ILogService),ee(3,w.IEnvironmentService),ee(4,u.ITelemetryService),ee(5,p.IFileService),ee(6,y.IProductService),ee(7,h.IConfigurationService)],Y);let A=class extends Y{constructor(T,U,j,q,H,ae,ce,pe){super(T,U,j,q,H,ae,ce,pe)}};A=he([ee(0,S.IStorageService),ee(1,l.IRequestService),ee(2,P.ILogService),ee(3,w.IEnvironmentService),ee(4,u.ITelemetryService),ee(5,p.IFileService),ee(6,y.IProductService),ee(7,h.IConfigurationService)],A),e.ExtensionGalleryService=A;let x=class extends Y{constructor(T,U,j,q,H,ae,ce){super(void 0,T,U,j,q,H,ae,ce)}};x=he([ee(0,l.IRequestService),ee(1,P.ILogService),ee(2,w.IEnvironmentService),ee(3,u.ITelemetryService),ee(4,p.IFileService),ee(5,y.IProductService),ee(6,h.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(Q[145],Z([0,1,44,16,13,10,65,29,25]),function(_,e,C,R,D,k,O,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let h=class je extends g.UserDataProfilesService{constructor(b,m,v,p,P){super(v,p,m,P),this.stateService=b}getStoredProfiles(){return(0,C.revive)(this.stateService.getItem(je.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,C.revive)(this.stateService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{}))}};h=he([ee(0,O.IStateService),ee(1,E.IUriIdentityService),ee(2,R.IEnvironmentService),ee(3,D.IFileService),ee(4,k.ILogService)],h),e.UserDataProfilesService=h}),define(Q[146],Z([0,1,36,3,159,2]),function(_,e,C,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class O extends C.AbstractPolicyService{constructor(g){super(),this.productName=g,this.throttler=new R.Throttler,this.watcher=this._register(new k.MutableDisposable)}async initializePolicies(g){await this.throttler.queue(()=>new Promise((h,w)=>{try{this.watcher.value=(0,D.createWatcher)(this.productName,g,b=>{for(const m in b){const v=b[m];v===void 0?this.policies.delete(m):this.policies.set(m,v)}this._onDidChange.fire(Object.keys(b)),h()})}catch(b){w(b)}}))}}e.NativePolicyService=O}),define(Q[67],Z([0,1,115,3,14,5,20,80,160,161]),function(_,e,C,R,D,k,O,E,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class w extends Error{constructor(t,n){let i=n.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=n}}e.ExtractError=w;function b(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,i)=>n+i,t&61440)}function m(s){if(s instanceof w)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new w(t,s)}function v(s,t,n,i,r,o){const c=D.dirname(t),a=D.join(i,c);if(!a.startsWith(i))return Promise.reject(new Error(E.localize(0,null,t)));const f=D.join(i,t);let I;return o.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((N,B)=>{if(!o.isCancellationRequested)try{I=(0,C.createWriteStream)(f,{mode:n}),I.once("close",()=>N()),I.once("error",B),s.once("error",B),s.pipe(I)}catch(K){B(K)}}))}function p(s,t,n,i){let r=(0,R.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,a)=>{const f=new R.Sequencer,I=N=>{N.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===o?c():a(new w("Incomplete",new Error(E.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",N=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(N.fileName)){I(i);return}const B=N.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(B)){const ne=D.join(t,B);r=(0,R.createCancelablePromise)(oe=>O.Promises.mkdir(ne,{recursive:!0}).then(()=>I(oe)).then(void 0,a));return}const K=y(s,N),J=b(N);r=(0,R.createCancelablePromise)(ne=>f.queue(()=>K.then(oe=>v(oe,B,J,t,n,ne).then(()=>I(ne)))).then(null,a))})})}function P(s,t=!1){return new Promise((n,i)=>{(0,g.open)(s,t?{lazyEntries:!0}:void 0,(r,o)=>{r?i(m(r)):n((0,k.assertIsDefined)(o))})})}function y(s,t){return new Promise((n,i)=>{s.openReadStream(t,(r,o)=>{r?i(m(r)):n((0,k.assertIsDefined)(o))})})}function l(s,t){return new Promise((n,i)=>{const r=new h.ZipFile;t.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,C.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(s))})}e.zip=l;function d(s,t,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=P(s,!0);return n.overwrite&&(o=o.then(c=>O.Promises.rm(t).then(()=>c))),o.then(c=>p(c,t,{sourcePathRegex:r},i))}e.extract=d;function S(s,t){return P(s).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===t&&y(n,o).then(c=>i(c),c=>r(c))}),n.once("close",()=>r(new Error(E.localize(2,null,t))))}))}function u(s,t){return S(s,t).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=u}),define(Q[147],Z([0,1,67,88]),function(_,e,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,C.buffer)(k,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=D}),define(Q[148],Z([0,1,3,31,11,2,17,14,12,18,38,5,8,30,20,67,87,58,16,140,22,23,41,48,123,141,147,124,137,34,45,13,9,10,28,35,29,25]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l,d,S,u,s,t,n,i,r,o,c,a,f,I,N,B,K,J,ne,oe,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,B.refineServiceDecorator)(u.IExtensionManagementService);let fe=class extends S.AbstractExtensionManagementService{constructor(A,x,L,T,U,j,q,H,ae,ce,pe,ye){super(A,x,L,ce,ye),this.extensionsScannerService=U,this.extensionsProfileScannerService=j,this.downloadService=q,this.fileService=ae,this.installGalleryExtensionsTasks=new Map;const te=this._register(H.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(le,ge=>te.postUninstall(ge))),this.manifestCache=this._register(new c.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(H.createInstance(i.ExtensionsDownloader));const se=this._register(new a.ExtensionsWatcher(this,ae,T,L,pe));this._register(se.onDidChangeExtensionsByAnotherSource(({added:ge,removed:de})=>{ge.length&&this._onDidInstallExtensions.fire(ge.map(ve=>({identifier:ve.identifier,operation:1,local:ve}))),de.forEach(ve=>this._onDidUninstallExtension.fire({identifier:ve}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const x=await this.collectFiles(A),L=await(0,P.zip)((0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,x);return m.URI.file(L)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:x,cleanup:L}=await this.downloadVsix(A),T=E.resolve(x.fsPath);try{return await(0,o.getManifest)(T)}finally{await L()}}getInstalled(A,x){return this.extensionsScanner.scanExtensions(A??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,x={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:L,cleanup:T}=await this.downloadVsix(A);try{const U=await(0,o.getManifest)(E.resolve(L.fsPath));if(U.engines&&U.engines.vscode&&!(0,I.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,s.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return await this.installExtension(U,L,x)}finally{await T()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,x){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const L={...x};return x.isPreReleaseVersion&&(L.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,L),this.manifestCache.invalidate(),A}async updateExtensionScope(A,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:x}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===O.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const x=(0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(A,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(T){this.logService.error(T)}}}}doCreateInstallExtensionTask(A,x,L){let T;if(m.URI.isUri(x))T=new M(A,x,L,this.galleryService,this.extensionsScanner,this.logService);else{const U=s.ExtensionKey.create(x).toString();T=this.installGalleryExtensionsTasks.get(U),T||(this.installGalleryExtensionsTasks.set(U,T=new W(A,x,L,this.extensionsDownloader,this.extensionsScanner,this.logService)),T.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(U)))}return L.profileLocation?new F(T,L.profileLocation,this.extensionsProfileScannerService):T}doCreateUninstallExtensionTask(A,x){return x.profileLocation?new $(A,x.profileLocation,this.extensionsProfileScannerService):new z(A,x,this.extensionsScanner)}async collectFiles(A){const x=async T=>{let U=await p.Promises.readdir(T);U=U.map(H=>E.join(T,H));const j=await Promise.all(U.map(H=>p.Promises.stat(H)));let q=Promise.resolve([]);return j.forEach((H,ae)=>{const ce=U[ae];H.isFile()&&(q=q.then(pe=>[...pe,ce])),H.isDirectory()&&(q=q.then(pe=>x(ce).then(ye=>[...pe,...ye])))}),q};return(await x(A.location.fsPath)).map(T=>({path:`extension/${E.relative(A.location.fsPath,T)}`,localPath:T}))}};fe=he([ee(0,u.IExtensionGalleryService),ee(1,ne.ITelemetryService),ee(2,K.ILogService),ee(3,d.INativeEnvironmentService),ee(4,n.IExtensionsScannerService),ee(5,t.IExtensionsProfileScannerService),ee(6,l.IDownloadService),ee(7,B.IInstantiationService),ee(8,N.IFileService),ee(9,J.IProductService),ee(10,oe.IUriIdentityService),ee(11,re.IUserDataProfilesService)],fe),e.ExtensionManagementService=fe;let le=class extends k.Disposable{constructor(A,x,L,T){super(),this.beforeRemovingExtension=A,this.fileService=x,this.extensionsScannerService=L,this.logService=T,this.uninstalledPath=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new C.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,x){const L={includeInvalid:!0,profileLocation:x};let T=[];return A===null||A===0?T.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},L,!1)):A===1&&T.push(...await this.extensionsScannerService.scanUserExtensions(L)),T=A!==null?T.filter(U=>U.type===A):T,Promise.all(T.map(U=>this.toLocalExtension(U)))}async scanUserExtensions(A){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(x.map(L=>this.toLocalExtension(L)))}async extractUserExtension(A,x,L,T){const U=A.toString(),j=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),q=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await p.Promises.rm(q)}catch{throw new u.ExtensionManagementError(y.localize(1,null,q,A.id),u.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,x,j,T),await this.extensionsScannerService.updateMetadata(m.URI.file(j),L);try{await this.rename(A,j,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(H){try{await p.Promises.rm(j)}catch{}if(H.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(H)}. Deleted from extracted location`,j),H}return this.scanLocalExtension(m.URI.file(q),1)}async updateMetadata(A,x){return await this.extensionsScannerService.updateMetadata(A.location,x),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const x=A.map(L=>s.ExtensionKey.create(L));await this.withUninstalledExtensions(L=>{x.forEach(T=>L[T.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(T=>delete T[A.toString()]);const L=(await this.scanUserExtensions(!0)).find(T=>s.ExtensionKey.create(T).equals(A))||null;return L?this.updateMetadata(L,{installedTimestamp:Date.now()}):null}async removeExtension(A,x){this.logService.trace(`Deleting ${x} extension from disk`,A.identifier.id,A.location.fsPath),await p.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(T){if(T.code!=="ENOENT")throw T}let L={};if(x)try{L=JSON.parse(x)}catch{}return A&&(A(L),Object.keys(L).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(L)):await p.Promises.rm(this.uninstalledPath)),L})}async extractAtLocation(A,x,L,T){this.logService.trace(`Started extracting the extension from ${x} to ${L}`);try{await p.Promises.rm(L)}catch(U){throw new u.ExtensionManagementError(this.joinErrors(U).message,u.ExtensionManagementErrorCode.Delete)}try{await(0,P.extract)(x,L,{sourcePath:"extension",overwrite:!0},T),this.logService.info(`Extracted extension to ${L}:`,A.id)}catch(U){try{await p.Promises.rm(L)}catch{}let j=u.ExtensionManagementErrorCode.Extract;throw U instanceof P.ExtractError&&(U.type==="CorruptZip"?j=u.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(j=u.ExtensionManagementErrorCode.IncompleteZip)),new u.ExtensionManagementError(U.message,j)}}async rename(A,x,L,T){try{await p.Promises.rename(x,L)}catch(U){if(g.isWindows&&U&&U.code==="EPERM"&&Date.now()<T)return this.logService.info(`Failed renaming ${x} to ${L} with 'EPERM' error. Trying again...`,A.id),this.rename(A,x,L,T);throw new u.ExtensionManagementError(U.message||y.localize(2,null,x,L),U.code||u.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,x){const L=await this.extensionsScannerService.scanExistingExtension(A,x,{includeInvalid:!0});if(L)return this.toLocalExtension(L);throw new Error(y.localize(3,null,A.path))}async toLocalExtension(A){const x=await this.fileService.resolve(A.location);let L,T;return x.children&&(L=x.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,T=x.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:L,changelogUrl:T,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const j of x)A[s.ExtensionKey.create(j).toString()]||L.add(j.identifier.id.toLowerCase());const T=(0,s.groupByExtension)(x,j=>j.identifier);await C.Promises.settled(T.map(async j=>{const q=j.sort((H,ae)=>w.rcompare(H.manifest.version,ae.manifest.version))[0];L.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}));const U=x.filter(j=>A[s.ExtensionKey.create(j).toString()]);await C.Promises.settled(U.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=[],T=await this.extensionsScannerService.getTargetPlatform(),U=(0,s.groupByExtension)(x,j=>j.identifier);for(const j of U)if(j.length>1&&L.push(...j.sort((q,H)=>{const ae=w.rcompare(q.manifest.version,H.manifest.version);return ae!==0?ae:q.targetPlatform===T?-1:1}).slice(1)),j[0].type===0){const q=A.find(H=>(0,s.areSameExtensions)(H.identifier,j[0].identifier));(!q||w.gte(q.manifest.version,j[0].manifest.version))&&L.push(j[0])}await C.Promises.settled(L.map(j=>this.removeExtension(j,"outdated")))}joinErrors(A){const x=Array.isArray(A)?A:[A];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((L,T)=>new Error(`${L.message}${L.message?",":""}${T instanceof Error?T.message:T}`),new Error(""))}};le=he([ee(1,N.IFileService),ee(2,n.IExtensionsScannerService),ee(3,K.ILogService)],le);class ie extends S.AbstractExtensionTask{get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(A,x,L,T,U){super(),this.identifier=A,this.source=x,this.options=L,this.extensionsScanner=T,this.logService=U,this._operation=2}async installExtension(A,x){try{const L=await this.unsetUninstalledAndGetLocal(A.key);if(L)return this.extensionsScanner.updateMetadata(L,A.metadata)}catch{throw g.isMacintosh?new u.ExtensionManagementError(y.localize(4,null),u.ExtensionManagementErrorCode.Internal):new u.ExtensionManagementError(y.localize(5,null),u.ExtensionManagementErrorCode.Internal)}return this.extract(A,x)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const L=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),L}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:x,metadata:L},T){const U=await this.extensionsScanner.extractUserExtension(x,A,L,T);return this.logService.info("Extracting completed.",x.id),U}}class W extends ie{constructor(A,x,L,T,U,j){super(x.identifier,x,L,U,j),this.manifest=A,this.gallery=x,this.extensionsDownloader=T}async doRun(A){const L=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,s.areSameExtensions)(j.identifier,this.gallery.identifier));L&&(this._operation=3);const T={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,f.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(L,T),metadata:T};const U=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:U,key:s.ExtensionKey.create(this.gallery),metadata:T},A);return L&&!this.options.profileLocation&&(L.targetPlatform!==j.targetPlatform||w.neq(L.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(L),{local:j,metadata:T}}catch(j){throw await this.deleteDownloadedVSIX(U),j}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(m.URI.file(A))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,D.getErrorMessage)(x))}}async downloadExtension(A,x){let L;try{this.logService.trace("Started downloading extension:",A.identifier.id),L=(await this.extensionsDownloader.downloadExtension(A,x)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,L)}catch(T){throw new u.ExtensionManagementError((0,S.joinErrors)(T).message,u.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(L),L}catch(T){throw await this.deleteDownloadedVSIX(L),new u.ExtensionManagementError((0,S.joinErrors)(T).message,u.ExtensionManagementErrorCode.Invalid)}}}class M extends ie{constructor(A,x,L,T,U,j){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},x,L,U,j),this.manifest=A,this.location=x,this.galleryService=T}async doRun(A){const x=new s.ExtensionKey(this.identifier,this.manifest.version),T=(await this.extensionsScanner.scanExtensions(1,void 0)).find(q=>(0,s.areSameExtensions)(this.identifier,q.identifier)),U=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(U.isApplicationScoped=(0,f.isApplicationScopedExtension)(this.manifest),U.isMachineScoped=this.options.isMachineScoped||T?.isMachineScoped,U.isBuiltin=this.options.isBuiltin||T?.isBuiltin,U.installedTimestamp=Date.now(),T)if(this._operation=3,x.equals(new s.ExtensionKey(T.identifier,T.manifest.version)))try{await this.extensionsScanner.removeExtension(T,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&w.gt(T.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(T);else{const q=await this.unsetUninstalledAndGetLocal(x);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:E.resolve(this.location.fsPath),key:x,metadata:U},A),metadata:U}}async getMetadata(A,x,L){try{let[T]=await this.galleryService.getExtensions([{id:A,version:x}],L);if(T||([T]=await this.galleryService.getExtensions([{id:A}],L)),T)return{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId,isPreReleaseVersion:T.properties.isPreReleaseVersion,preRelease:T.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,x,L){this.task=A,this.profileLocation=x,this.extensionsProfileScannerService=L,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class z extends S.AbstractExtensionTask{constructor(A,x,L){super(),this.extension=A,this.options=x,this.extensionsScanner=L}async doRun(A){const x=[],L=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const T=s.ExtensionKey.create(this.extension);x.push(...L.filter(U=>T.equals(s.ExtensionKey.create(U))))}else x.push(...L.filter(T=>(0,s.areSameExtensions)(T.identifier,this.extension.identifier)));if(!x.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const T of x)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(T)}catch(U){throw new Error(y.localize(9,null,(0,R.toErrorMessage)(U)))}}}class $ extends S.AbstractExtensionTask{constructor(A,x,L){super(),this.extension=A,this.profileLocation=x,this.extensionsProfileScannerService=L}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[149],Z([0,1,128,3,15,11,2,5,21,16,129,10,127,162]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends O.Disposable{constructor(y,l,d){super(),this.environmentService=l,this.logService=d,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,l){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:d,strictSSL:S}=this;let u;try{u=await(0,w.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...u},t=y.agent?y.agent:await(0,m.getProxyAgent)(y.url||"",s,{proxyUrl:d,strictSSL:S});y.agent=t,y.strictSSL=S,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(y,l);return this.logService.trace("RequestService#request (node) - success",y.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",y.url,n),n}}async getNodeRequest(y){return((0,C.parse)(y.url).protocol==="https:"?await new Promise((S,u)=>{_(["https"],S,u)}):await new Promise((S,u)=>{_(["http"],S,u)})).request}_request(y,l){return R.Promises.withAsyncBody(async(d,S)=>{const u=(0,C.parse)(y.url),s=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),t={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,E.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(t.auth=y.user+":"+y.password);const n=s(t,i=>{const r=(0,E.isNumber)(y.followRedirects)?y.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...y,url:i.headers.location,followRedirects:r-1},l).then(d,S);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,v.createGunzip)())),d({res:i,stream:(0,D.streamToBufferReadableStream)(o)})}});n.on("error",S),y.timeout&&n.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&n.write(y.data),n.end(),l.onCancellationRequested(()=>{n.abort(),S(new k.CancellationError)})})}async resolveProxy(y){}};p=he([ee(0,g.IConfigurationService),ee(1,h.INativeEnvironmentService),ee(2,b.ILogService)],p),e.RequestService=p}),define(Q[163],Z([0,1,37,3,15,31,11,2,17,14,12,32,8,20,21,120,58,126,16,101,144,22,122,41,48,148,142,13,111,114,46,109,61,62,125,10,116,117,36,146,134,28,47,149,65,130,66,35,133,42,135,136,29,138,25,145]),function(_,e,C,R,D,k,O,E,g,h,w,b,m,v,p,P,y,l,d,S,u,s,t,n,i,r,o,c,a,f,I,N,B,K,J,ne,oe,re,fe,le,ie,W,M,F,z,$,Y,A,x,L,T,U,j,q,H,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ce extends E.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,se]=await this.initServices();return te.invokeFunction(async ge=>{const de=ge.get(ne.ILogService),ve=ge.get(c.IFileService),ke=ge.get(d.INativeEnvironmentService),Fe=ge.get(H.IUserDataProfilesService);de.info("CLI main",this.argv),this.registerErrorHandler(de),await this.doRun(ke,ve,Fe,te),await Promise.all(se.map(Ue=>{(0,R.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new B.ServiceCollection,se={_serviceBrand:void 0,...ie.default};te.set(W.IProductService,se);const ge=new S.NativeEnvironmentService(this.argv,se);te.set(d.INativeEnvironmentService,ge),await Promise.all([ge.appSettingsHome.fsPath,ge.extensionsPath].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0));const de=(0,ne.getLogLevel)(ge),ve=[];ve.push(new oe.SpdLogLogger("cli",(0,h.join)(ge.logsPath,"cli.log"),!0,!1,de)),de===ne.LogLevel.Trace&&ve.push(new ne.ConsoleLogger(de));const ke=this._register(new ne.MultiplexLogService(ve));te.set(ne.ILogService,ke);const Fe=this._register(new a.FileService(ke));te.set(c.IFileService,Fe);const Ue=this._register(new f.DiskFileSystemProvider(ke));Fe.registerProvider(g.Schemas.file,Ue);const xe=new $.StateService(ge,ke,Fe);te.set(z.IStateService,xe);const V=new q.UriIdentityService(Fe);te.set(j.IUriIdentityService,V);const G=new ae.UserDataProfilesService(xe,V,ge,Fe,ke);te.set(H.IUserDataProfilesService,G);const X=w.isWindows&&se.win32RegValueName?this._register(new le.NativePolicyService(se.win32RegValueName)):ge.policyFile?this._register(new re.FilePolicyService(ge.policyFile,Fe,ke)):new fe.NullPolicyService;te.set(fe.IPolicyService,X);const ue=this._register(new P.ConfigurationService(G.defaultProfile.settingsResource,Fe,X,ke));te.set(p.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),G.setEnablement(se.quality!=="stable"||ue.getValue(H.PROFILES_ENABLEMENT_CONFIG)),te.set(j.IUriIdentityService,new q.UriIdentityService(Fe)),te.set(M.IRequestService,new I.SyncDescriptor(F.RequestService,void 0,!0)),te.set(y.IDownloadService,new I.SyncDescriptor(l.DownloadService,void 0,!0)),te.set(n.IExtensionsProfileScannerService,new I.SyncDescriptor(n.ExtensionsProfileScannerService,void 0,!0)),te.set(i.IExtensionsScannerService,new I.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),te.set(r.INativeServerExtensionManagementService,new I.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new I.SyncDescriptor(u.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(K.ILanguagePackService,new I.SyncDescriptor(J.NativeLanguagePackService,void 0,!1));const me=[],De=(0,L.isInternalTelemetry)(se,ue);if((0,L.supportsTelemetry)(se,ge)){se.aiConfig&&se.aiConfig.ariaKey&&me.push(new T.OneDataSystemAppender(De,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:we}=ge,Oe={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const Ce=await v.Promises.readFile(ge.stateResource.fsPath);be=JSON.parse(Ce.toString())[A.machineIdKey]}catch(Ce){Ce.code!=="ENOENT"&&ke.error(Ce)}return(0,Y.resolveCommonProperties)(Fe,(0,C.release)(),(0,C.hostname)(),process.arch,se.commit,se.version,be,De,we)})(),piiPaths:(0,L.getPiiPathsFromEnvironment)(ge)};te.set(A.ITelemetryService,new I.SyncDescriptor(x.TelemetryService,[Oe],!1))}else te.set(A.ITelemetryService,L.NullTelemetryService);return[new N.InstantiationService(te),me]}registerErrorHandler(te){(0,O.setUnexpectedErrorHandler)(se=>{const ge=(0,k.toErrorMessage)(se,!0);!ge||te.error(`[uncaught exception in CLI]: ${ge}`)}),process.on("uncaughtException",se=>(0,O.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,O.onUnexpectedError)(se))}async doRun(te,se,ge,de){const ve=te.args.profile?ge.profiles.find(ke=>ke.name===te.args.profile)?.extensionsResource:ge.defaultProfile.extensionsResource;if(this.argv["install-source"])return this.setInstallSource(te,se,this.argv["install-source"]);if(this.argv["list-extensions"])return de.createInstance(t.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,ve);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ke={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ve};return de.createInstance(t.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ke,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return de.createInstance(t.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ve);if(this.argv["locate-extension"])return de.createInstance(t.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(se=>/\.vsix$/i.test(se)?m.URI.file((0,h.isAbsolute)(se)?se:(0,h.join)((0,b.cwd)(),se)):se)}async setInstallSource(te,se,ge){await se.writeFile(m.URI.file(te.installSourcePath),D.VSBuffer.fromString(ge.slice(0,30)))}}async function pe(ye){const te=new ce(ye);try{await te.run()}finally{te.dispose()}}e.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1c78193f54fac6036829ec554ce218d99afc1f15/core/vs/code/node/cliProcessMain.js.map
