/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(J){for(var e=[],c=0,t=J.length;c<t;c++)e[c]=Ce[J[c]];return e};define(Ce[77],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function c(C){return C?C.replace(/\$\((.*?)\)/g,(T,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(T,S,D){this.id=T,this.definition=S,this.description=D,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(C,T){const S=["codicon","codicon-"+C];return T&&S.push("codicon-modifier-"+T),S}e.getClassNamesArray=I;var P;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(k){if(k instanceof t)return["codicon","codicon-"+k.id];const E=T.exec(k.id);if(!E)return S(t.error);const[,y,w]=E,h=["codicon","codicon-"+y];return w&&h.push("codicon-modifier-"+w.substr(1)),h}C.asClassNameArray=S;function D(k){return S(k).join(" ")}C.asClassName=D;function A(k){return"."+S(k).join(".")}C.asCSSSelector=A})(P=e.CSSIcon||(e.CSSIcon={}))}),define(Ce[78],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(C,T){const S=Object.create(null);for(const D of C){const A=T(D);let k=S[A];k||(k=S[A]=[]),k.push(D)}return S}e.groupBy=c;function t(C,T){const S=[],D=[];for(const A of C)T.has(A)||S.push(A);for(const A of T)C.has(A)||D.push(A);return{removed:S,added:D}}e.diffSets=t;function I(C,T){const S=[],D=[];for(const[A,k]of C)T.has(A)||S.push(k);for(const[A,k]of T)C.has(A)||D.push(k);return{removed:S,added:D}}e.diffMaps=I;class P{constructor(){this.map=new Map}add(T,S){let D=this.map.get(T);D||(D=new Set,this.map.set(T,D)),D.add(S)}delete(T,S){const D=this.map.get(T);!D||(D.delete(S),D.size===0&&this.map.delete(T))}forEach(T,S){const D=this.map.get(T);!D||D.forEach(S)}}e.SetMap=P}),define(Ce[59],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(C){return(T,S,D)=>{let A=null,k=null;if(typeof D.value=="function"?(A="value",k=D.value):typeof D.get=="function"&&(A="get",k=D.get),!k)throw new Error("not supported");D[A]=C(k,S)}}e.createDecorator=c;function t(C,T,S){let D=null,A=null;if(typeof S.value=="function"?(D="value",A=S.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(D="get",A=S.get),!A)throw new Error("not supported");const k=`$memoize$${T}`;S[D]=function(...E){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,E)}),this[k]}}e.memoize=t;function I(C,T,S){return c((D,A)=>{const k=`$debounce$${A}`,E=`$debounce$result$${A}`;return function(...y){this[E]||(this[E]=S?S():void 0),clearTimeout(this[k]),T&&(this[E]=T(this[E],...y),y=[this[E]]),this[k]=setTimeout(()=>{D.apply(this,y),this[E]=S?S():void 0},C)}})}e.debounce=I;function P(C,T,S){return c((D,A)=>{const k=`$throttle$timer$${A}`,E=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...h){if(this[E]||(this[E]=S?S():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...h)),this[w])return;const g=this[y]+C;g<=Date.now()?(this[y]=Date.now(),D.apply(this,[this[E]]),this[E]=S?S():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),D.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=P}),define(Ce[11],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?m.isErrorNoTelemetry(o)?new m(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(u=>{u(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=c,e.errorHandler=new c;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function I(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=I;function P(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=P;function C(b){if(b instanceof Error){const{name:o,message:u}=b,s=b.stacktrace||b.stack;return{$isError:!0,name:o,message:u,stack:s,noTelemetry:m.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=C;const T="Canceled";function S(b){return b instanceof D?!0:b instanceof Error&&b.name===T&&b.message===T}e.isCancellationError=S;class D extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=D;function A(){const b=new Error(T);return b.name=b.message,b}e.canceled=A;function k(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=k;function E(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=E;function y(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function w(b){const o=new Error(`${b} has been disposed`);return o.name="DISPOSED",o}e.disposed=w;function h(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=h;class g extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=g;class f extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=f;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class m extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof m)return o;const u=new m;return u.message=o.message,u.stack=o.stack,u}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class r extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype);debugger}}e.BugIndicatingError=r}),define(Ce[17],De([1,0,11]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function I(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=I;function P(oe,le,ge=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!ge(oe[Z],le[Z]))return!1;return!0}e.equals=P;function C(oe,le){const ge=oe.length-1;le<ge&&(oe[le]=oe[ge]),oe.pop()}e.removeFastWithoutKeepingOrder=C;function T(oe,le,ge){return S(oe.length,Z=>ge(oe[Z],le))}e.binarySearch=T;function S(oe,le){let ge=0,Z=oe-1;for(;ge<=Z;){const ae=(ge+Z)/2|0,ne=le(ae);if(ne<0)ge=ae+1;else if(ne>0)Z=ae-1;else return ae}return-(ge+1)}e.binarySearch2=S;function D(oe,le){let ge=0,Z=oe.length;if(Z===0)return 0;for(;ge<Z;){const ae=Math.floor((ge+Z)/2);le(oe[ae])?Z=ae:ge=ae+1}return ge}e.findFirstInSorted=D;function A(oe,le,ge){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ne=[],ie=[];for(const N of le){const j=ge(N,Z);j<0?ae.push(N):j>0?ne.push(N):ie.push(N)}return oe<ae.length?A(oe,ae,ge):oe<ae.length+ie.length?ie[0]:A(oe-(ae.length+ie.length),ne,ge)}e.quickSelect=A;function k(oe,le){const ge=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],ge.push(Z)):Z.push(ae);return ge}e.groupBy=k;function E(oe,le,ge){const Z=[];function ae(N,j,G){if(j===0&&G.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===N?(X.deleteCount+=j,X.toInsert.push(...G)):Z.push({start:N,deleteCount:j,toInsert:G})}let ne=0,ie=0;for(;;){if(ne===oe.length){ae(ne,0,le.slice(ie));break}if(ie===le.length){ae(ne,oe.length-ne,[]);break}const N=oe[ne],j=le[ie],G=ge(N,j);G===0?(ne+=1,ie+=1):G<0?(ae(ne,1,[]),ne+=1):G>0&&(ae(ne,0,[j]),ie+=1)}return Z}e.sortedDiff=E;function y(oe,le,ge){const Z=E(oe,le,ge),ae=[],ne=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:ae,added:ne}}e.delta=y;function w(oe,le,ge){if(ge===0)return[];const Z=oe.slice(0,ge).sort(le);return g(oe,le,Z,ge,oe.length),Z}e.top=w;function h(oe,le,ge,Z,ae){return ge===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const N=oe.length,j=oe.slice(0,ge).sort(le);for(let G=ge,X=Math.min(ge+Z,N);G<N;G=X,X=Math.min(X+Z,N)){if(G>ge&&await new Promise(pe=>setTimeout(pe)),ae&&ae.isCancellationRequested)throw new c.CancellationError;g(oe,le,j,G,X)}return j})().then(ne,ie)})}e.topAsync=h;function g(oe,le,ge,Z,ae){for(const ne=ge.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,ge[ne-1])<0){ge.pop();const N=D(ge,j=>le(ie,j)<0);ge.splice(N,0,ie)}}}function f(oe){return oe.filter(le=>!!le)}e.coalesce=f;function v(oe){let le=0;for(let ge=0;ge<oe.length;ge++)oe[ge]&&(oe[le]=oe[ge],le+=1);oe.length=le}e.coalesceInPlace=v;function m(oe,le,ge){oe.splice(ge,0,oe.splice(le,1)[0])}e.move=m;function r(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=r;function b(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=b;function o(oe,le=ge=>ge){const ge=new Set;return oe.filter(Z=>{const ae=le(Z);return ge.has(ae)?!1:(ge.add(ae),!0)})}e.distinct=o;function u(oe){const le=new Set;return ge=>{const Z=oe(ge);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=u;function s(oe,le){const ge=l(oe,le);if(ge!==-1)return oe[ge]}e.findLast=s;function l(oe,le){for(let ge=oe.length-1;ge>=0;ge--){const Z=oe[ge];if(le(Z))return ge}return-1}e.lastIndex=l;function a(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=a;function d(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=d;function n(oe,le,ge=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ne=Math.min(oe.length,le.length);ae<ne&&ge(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=n;function i(oe){return[].concat(...oe)}e.flatten=i;function p(oe,le){let ge=typeof le=="number"?oe:0;typeof le=="number"?ge=oe:(ge=0,le=oe);const Z=[];if(ge<=le)for(let ae=ge;ae<le;ae++)Z.push(ae);else for(let ae=ge;ae>le;ae--)Z.push(ae);return Z}e.range=p;function _(oe,le,ge){return oe.reduce((Z,ae)=>(Z[le(ae)]=ge?ge(ae):ae,Z),Object.create(null))}e.index=_;function R(oe,le){return oe.push(le),()=>M(oe,le)}e.insert=R;function M(oe,le){const ge=oe.indexOf(le);if(ge>-1)return oe.splice(ge,1),le}e.remove=M;function H(oe,le,ge){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(ge,ae)}e.arrayInsert=H;function $(oe,le){let ge;if(typeof le=="number"){let Z=le;ge=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else ge=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(ge()*(Z+1)),ne=oe[Z];oe[Z]=oe[ae],oe[ae]=ne}}e.shuffle=$;function L(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.unshift(le))}e.pushToStart=L;function B(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.push(le))}e.pushToEnd=B;function O(oe,le){for(const ge of le)oe.push(ge)}e.pushMany=O;function z(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=z;function U(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=U;function F(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=F;function V(oe,le){for(const ge of oe){const Z=le(ge);if(Z!==void 0)return Z}}e.mapFind=V;function x(oe,le,ge){const Z=K(oe,le),ae=oe.length,ne=ge.length;oe.length=ae+ne;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ne]=oe[ie];for(let ie=0;ie<ne;ie++)oe[ie+Z]=ge[ie]}e.insertInto=x;function Q(oe,le,ge,Z){const ae=K(oe,le),ne=oe.splice(ae,ge);return x(oe,ae,Z),ne}e.splice=Q;function K(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var ue;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function ge(ae){return ae>0}oe.isGreaterThan=ge;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ue=e.CompareResult||(e.CompareResult={}));function te(oe,le){return(ge,Z)=>le(oe(ge),oe(Z))}e.compareBy=te;function he(...oe){return(le,ge)=>{for(const Z of oe){const ae=Z(le,ge);if(!ue.isNeitherLessOrGreaterThan(ae))return ae}return ue.neitherLessOrGreaterThan}}e.tieBreakComparators=he;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function fe(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>0&&(ge=ae)}return ge}e.findMaxBy=fe;function be(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>=0&&(ge=ae)}return ge}e.findLastMaxBy=be;function ke(oe,le){return fe(oe,(ge,Z)=>-le(ge,Z))}e.findMinBy=ke;class Re{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ge=this.firstIdx;for(;ge<this.items.length&&le(this.items[ge]);)ge++;const Z=ge===this.firstIdx?null:this.items.slice(this.firstIdx,ge);return this.firstIdx=ge,Z}takeFromEndWhile(le){let ge=this.lastIdx;for(;ge>=0&&le(this.items[ge]);)ge--;const Z=ge===this.lastIdx?null:this.items.slice(ge+1,this.lastIdx+1);return this.lastIdx=ge,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const ge=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,ge}}e.ArrayQueue=Re;class ze{constructor(le){this.iterate=le}forEach(le){this.iterate(ge=>(le(ge),!0))}toArray(){const le=[];return this.iterate(ge=>(le.push(ge),!0)),le}filter(le){return new ze(ge=>this.iterate(Z=>le(Z)?ge(Z):!0))}map(le){return new ze(ge=>this.iterate(Z=>ge(le(Z))))}some(le){let ge=!1;return this.iterate(Z=>(ge=le(Z),!ge)),ge}findFirst(le){let ge;return this.iterate(Z=>le(Z)?(ge=Z,!1):!0),ge}findLast(le){let ge;return this.iterate(Z=>(le(Z)&&(ge=Z),!0)),ge}findLastMaxBy(le){let ge,Z=!0;return this.iterate(ae=>((Z||ue.isGreaterThan(le(ae,ge)))&&(Z=!1,ge=ae),!0)),ge}}e.CallbackIterable=ze,ze.empty=new ze(oe=>{})}),define(Ce[48],De([1,0,11]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,D){if(!S)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function I(S,D="Unreachable"){throw new Error(D)}e.assertNever=I;function P(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=P;function C(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function T(S,D){let A=0;for(;A<S.length-1;){const k=S[A],E=S[A+1];if(!D(k,E))return!1;A++}return!0}e.checkAdjacentItems=T}),define(Ce[60],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const I=this;let P=!1,C;return function(){return P||(P=!0,C=t.apply(I,arguments)),C}}e.once=c}),define(Ce[98],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(Ce[61],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function I(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}t.is=I;const P=Object.freeze([]);function C(){return P}t.empty=C;function*T(m){yield m}t.single=T;function S(m){return m||P}t.from=S;function D(m){return!m||m[Symbol.iterator]().next().done===!0}t.isEmpty=D;function A(m){return m[Symbol.iterator]().next().value}t.first=A;function k(m,r){for(const b of m)if(r(b))return!0;return!1}t.some=k;function E(m,r){for(const b of m)if(r(b))return b}t.find=E;function*y(m,r){for(const b of m)r(b)&&(yield b)}t.filter=y;function*w(m,r){let b=0;for(const o of m)yield r(o,b++)}t.map=w;function*h(...m){for(const r of m)for(const b of r)yield b}t.concat=h;function g(m,r,b){let o=b;for(const u of m)o=r(o,u);return o}t.reduce=g;function*f(m,r,b=m.length){for(r<0&&(r+=m.length),b<0?b+=m.length:b>m.length&&(b=m.length);r<b;r++)yield m[r]}t.slice=f;function v(m,r=Number.POSITIVE_INFINITY){const b=[];if(r===0)return[b,m];const o=m[Symbol.iterator]();for(let u=0;u<r;u++){const s=o.next();if(s.done)return[b,t.empty()];b.push(s.value)}return[b,{[Symbol.iterator](){return o}}]}t.consume=v})(c=e.Iterable||(e.Iterable={}))}),define(Ce[144],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(o){o.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function C(o,u=!1){let s=0;const l=o.length;let a="",d=0,n=16,i=0;function p(B){let O=0,z=0;for(;O<B;){const U=o.charCodeAt(s);if(U>=48&&U<=57)z=z*16+U-48;else if(U>=65&&U<=70)z=z*16+U-65+10;else if(U>=97&&U<=102)z=z*16+U-97+10;else break;s++,O++}return O<B&&(z=-1),z}function _(B){s=B,a="",d=0,n=16,i=0}function R(){const B=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&D(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&D(o.charCodeAt(s)))for(s++;s<o.length&&D(o.charCodeAt(s));)s++;else return i=3,o.substring(B,s);let O=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&D(o.charCodeAt(s))){for(s++;s<o.length&&D(o.charCodeAt(s));)s++;O=s}else i=3;return o.substring(B,O)}function M(){let B="",O=s;for(;;){if(s>=l){B+=o.substring(O,s),i=2;break}const z=o.charCodeAt(s);if(z===34){B+=o.substring(O,s),s++;break}if(z===92){if(B+=o.substring(O,s),s++,s>=l){i=2;break}switch(o.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const F=p(4);F>=0?B+=String.fromCharCode(F):i=4;break}default:i=5}O=s;continue}if(z>=0&&z<=31)if(S(z)){B+=o.substring(O,s),i=2;break}else i=6;s++}return B}function H(){if(a="",i=0,d=s,s>=l)return d=l,n=17;let B=o.charCodeAt(s);if(T(B)){do s++,a+=String.fromCharCode(B),B=o.charCodeAt(s);while(T(B));return n=15}if(S(B))return s++,a+=String.fromCharCode(B),B===13&&o.charCodeAt(s)===10&&(s++,a+=`
`),n=14;switch(B){case 123:return s++,n=1;case 125:return s++,n=2;case 91:return s++,n=3;case 93:return s++,n=4;case 58:return s++,n=6;case 44:return s++,n=5;case 34:return s++,a=M(),n=10;case 47:{const O=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<l&&!S(o.charCodeAt(s));)s++;return a=o.substring(O,s),n=12}if(o.charCodeAt(s+1)===42){s+=2;const z=l-1;let U=!1;for(;s<z;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,i=1),a=o.substring(O,s),n=13}return a+=String.fromCharCode(B),s++,n=16}case 45:if(a+=String.fromCharCode(B),s++,s===l||!D(o.charCodeAt(s)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),n=11;default:for(;s<l&&$(B);)s++,B=o.charCodeAt(s);if(d!==s){switch(a=o.substring(d,s),a){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return a+=String.fromCharCode(B),s++,n=16}}function $(B){if(T(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let B;do B=H();while(B>=12&&B<=15);return B}return{setPosition:_,getPosition:()=>s,scan:u?L:H,getToken:()=>n,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>i}}e.createScanner=C;function T(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function S(o){return o===10||o===13||o===8232||o===8233}function D(o){return o>=48&&o<=57}var A;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(A||(A={}));function k(o,u){const s=[],l=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function i(p,_,R,M){d.value=p,d.offset=_,d.length=R,d.type=M,d.colonOffset=void 0,a=d}try{m(o,{onObjectBegin:(p,_)=>{if(u<=p)throw l;a=void 0,n=u>p,s.push("")},onObjectProperty:(p,_,R)=>{if(u<_||(i(p,_,R,"property"),s[s.length-1]=p,u<=_+R))throw l},onObjectEnd:(p,_)=>{if(u<=p)throw l;a=void 0,s.pop()},onArrayBegin:(p,_)=>{if(u<=p)throw l;a=void 0,s.push(0)},onArrayEnd:(p,_)=>{if(u<=p)throw l;a=void 0,s.pop()},onLiteralValue:(p,_,R)=>{if(u<_||(i(p,_,R,b(p)),u<=_+R))throw l},onSeparator:(p,_,R)=>{if(u<=_)throw l;if(p===":"&&a&&a.type==="property")a.colonOffset=_,n=!1,a=void 0;else if(p===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(n=!0,s[s.length-1]=""),a=void 0}}})}catch(p){if(p!==l)throw p}return{path:s,previousNode:a,isAtPropertyKey:n,matches:p=>{let _=0;for(let R=0;_<p.length&&R<s.length;R++)if(p[_]===s[R]||p[_]==="*")_++;else if(p[_]!=="**")return!1;return _===p.length}}}e.getLocation=k;function E(o,u=[],s=P.DEFAULT){let l=null,a=[];const d=[];function n(p){Array.isArray(a)?a.push(p):l!==null&&(a[l]=p)}return m(o,{onObjectBegin:()=>{const p={};n(p),d.push(a),a=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const p=[];n(p),d.push(a),a=p,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:n,onError:(p,_,R)=>{u.push({error:p,offset:_,length:R})}},s),a[0]}e.parse=E;function y(o,u=[],s=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){l.type==="property"&&(l.length=p-l.offset,l=l.parent)}function d(p){return l.children.push(p),p}m(o,{onObjectBegin:p=>{l=d({type:"object",offset:p,length:-1,parent:l,children:[]})},onObjectProperty:(p,_,R)=>{l=d({type:"property",offset:_,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:p,offset:_,length:R,parent:l})},onObjectEnd:(p,_)=>{l.length=p+_-l.offset,l=l.parent,a(p+_)},onArrayBegin:(p,_)=>{l=d({type:"array",offset:p,length:-1,parent:l,children:[]})},onArrayEnd:(p,_)=>{l.length=p+_-l.offset,l=l.parent,a(p+_)},onLiteralValue:(p,_,R)=>{d({type:b(p),offset:_,length:R,parent:l,value:p}),a(_+R)},onSeparator:(p,_,R)=>{l.type==="property"&&(p===":"?l.colonOffset=_:p===","&&a(_))},onError:(p,_,R)=>{u.push({error:p,offset:_,length:R})}},s);const i=l.children[0];return i&&delete i.parent,i}e.parseTree=y;function w(o,u){if(!o)return;let s=o;for(const l of u)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===l){s=d.children[1],a=!0;break}if(!a)return}else{const a=l;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=w;function h(o){if(!o.parent||!o.parent.children)return[];const u=h(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;u.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&u.push(s)}return u}e.getNodePath=h;function g(o){switch(o.type){case"array":return o.children.map(g);case"object":{const u=Object.create(null);for(const s of o.children){const l=s.children[1];l&&(u[s.children[0].value]=g(l))}return u}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=g;function f(o,u,s=!1){return u>=o.offset&&u<o.offset+o.length||s&&u===o.offset+o.length}e.contains=f;function v(o,u,s=!1){if(f(o,u,s)){const l=o.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=u;a++){const d=v(l[a],u,s);if(d)return d}return o}}e.findNodeAtOffset=v;function m(o,u,s=P.DEFAULT){const l=C(o,!1);function a(te){return te?()=>te(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(te){return te?he=>te(he,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=a(u.onObjectBegin),i=d(u.onObjectProperty),p=a(u.onObjectEnd),_=a(u.onArrayBegin),R=a(u.onArrayEnd),M=d(u.onLiteralValue),H=d(u.onSeparator),$=a(u.onComment),L=d(u.onError),B=s&&s.disallowComments,O=s&&s.allowTrailingComma;function z(){for(;;){const te=l.scan();switch(l.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:B||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(te){case 12:case 13:B?U(10):$();break;case 16:U(1);break;case 15:case 14:break;default:return te}}}function U(te,he=[],Y=[]){if(L(te),he.length+Y.length>0){let fe=l.getToken();for(;fe!==17;){if(he.indexOf(fe)!==-1){z();break}else if(Y.indexOf(fe)!==-1)break;fe=z()}}}function F(te){const he=l.getTokenValue();return te?M(he):i(he),z(),!0}function V(){switch(l.getToken()){case 11:{let te=0;try{te=JSON.parse(l.getTokenValue()),typeof te!="number"&&(U(2),te=0)}catch{U(2)}M(te);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return z(),!0}function x(){return l.getToken()!==10?(U(3,[],[2,5]),!1):(F(!1),l.getToken()===6?(H(":"),z(),ue()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Q(){n(),z();let te=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(te||U(4,[],[]),H(","),z(),l.getToken()===2&&O)break}else te&&U(6,[],[]);x()||U(4,[],[2,5]),te=!0}return p(),l.getToken()!==2?U(7,[2],[]):z(),!0}function K(){_(),z();let te=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(te||U(4,[],[]),H(","),z(),l.getToken()===4&&O)break}else te&&U(6,[],[]);ue()||U(4,[],[4,5]),te=!0}return R(),l.getToken()!==4?U(8,[4],[]):z(),!0}function ue(){switch(l.getToken()){case 3:return K();case 1:return Q();case 10:return F(!0);default:return V()}}return z(),l.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):ue()?(l.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=m;function r(o,u){const s=C(o),l=[];let a,d=0,n;do switch(n=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:d!==n&&l.push(o.substring(d,n)),u!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,u)),d=s.getPosition();break}while(a!==17);return l.join("")}e.stripComments=r;function b(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(Ce[79],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new c(()=>I(this.getValue()))}}e.Lazy=c}),define(Ce[6],De([1,0,60,61]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let P=null;function C(d){P=d}if(e.setDisposableTracker=C,I){const d="__is_disposable_tracked__";C(new class{trackDisposable(n){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[d]||console.log(i)},3e3)}setParent(n,i){if(n&&n!==v.None)try{n[d]=!0}catch{}}markAsDisposed(n){if(n&&n!==v.None)try{n[d]=!0}catch{}}markAsSingleton(n){}})}function T(d){return P?.trackDisposable(d),d}function S(d){P?.markAsDisposed(d)}function D(d,n){P?.setParent(d,n)}function A(d,n){if(!!P)for(const i of d)P.setParent(i,n)}function k(d){return P?.markAsSingleton(d),d}e.markAsSingleton=k;function E(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=E;function y(d){if(t.Iterable.is(d)){const n=[];for(const i of d)if(i)try{i.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.dispose=y;function w(d){for(const n of d)E(n)&&n.dispose();return[]}e.disposeIfDisposable=w;function h(...d){const n=g(()=>y(d));return A(d,n),n}e.combinedDisposable=h;function g(d){const n=T({dispose:(0,c.once)(()=>{S(n),d()})});return n}e.toDisposable=g;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,T(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{y(this._toDispose)}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return D(n,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new f,T(this),D(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,T(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&D(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&D(n,null),n}}e.MutableDisposable=m;class r{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let i=n;return this.unset=()=>i=void 0,this.isset=()=>i!==void 0,this.dispose=()=>{i&&(i(),i=void 0,S(this))},this}}e.SafeDisposable=b;class o{constructor(){this.references=new Map}acquire(n,...i){let p=this.references.get(n);p||(p={counter:0,object:this.createReferencedObject(n,...i)},this.references.set(n,p));const{object:_}=p,R=(0,c.once)(()=>{--p.counter===0&&(this.destroyReferencedObject(n,p.object),this.references.delete(n))});return p.counter++,{object:_,dispose:R}}}e.ReferenceCollection=o;class u{constructor(n){this.referenceCollection=n}async acquire(n,...i){const p=this.referenceCollection.acquire(n,...i);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(_){throw p.dispose(),_}}}e.AsyncReferenceCollection=u;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s;function l(d){const n=new f;try{d(n)}finally{n.dispose()}}e.disposeOnReturn=l;class a{constructor(){this._store=new Map,this._isDisposed=!1,T(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{y(this._store.values())}finally{this._store.clear()}}has(n){return this._store.has(n)}get(n){return this._store.get(n)}set(n,i,p=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this._store.get(n)?.dispose(),this._store.set(n,i)}deleteAndDispose(n){this._store.get(n)?.dispose(),this._store.delete(n)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(Ce[62],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(P){this.element=P,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this._first=c.Undefined,this._last=c.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===c.Undefined}clear(){let P=this._first;for(;P!==c.Undefined;){const C=P.next;P.prev=c.Undefined,P.next=c.Undefined,P=C}this._first=c.Undefined,this._last=c.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,C){const T=new c(P);if(this._first===c.Undefined)this._first=T,this._last=T;else if(C){const D=this._last;this._last=T,T.prev=D,D.next=T}else{const D=this._first;this._first=T,T.next=D,D.prev=T}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(T))}}shift(){if(this._first!==c.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==c.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==c.Undefined&&P.next!==c.Undefined){const C=P.prev;C.next=P.next,P.next.prev=C}else P.prev===c.Undefined&&P.next===c.Undefined?(this._first=c.Undefined,this._last=c.Undefined):P.next===c.Undefined?(this._last=this._last.prev,this._last.next=c.Undefined):P.prev===c.Undefined&&(this._first=this._first.next,this._first.prev=c.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==c.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),define(Ce[28],De([1,0]),function(J,e){"use strict";var c,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function P(w,h,g){let f=w.get(h);return f===void 0&&(f=g,w.set(h,f)),f}e.getOrSet=P;function C(w){const h=[];return w.forEach((g,f)=>{h.push(`${f} => ${g}`)}),`Map(${w.size}) {${h.join(", ")}}`}e.mapToString=C;function T(w){const h=[];return w.forEach(g=>{h.push(g)}),`Set(${w.size}) {${h.join(", ")}}`}e.setToString=T;class S{constructor(h,g){this.uri=h,this.value=g}}class D{constructor(h,g){this[c]="ResourceMap",h instanceof D?(this.map=new Map(h.map),this.toKey=g??D.defaultToKey):(this.map=new Map,this.toKey=h??D.defaultToKey)}set(h,g){return this.map.set(this.toKey(h),new S(h,g)),this}get(h){return this.map.get(this.toKey(h))?.value}has(h){return this.map.has(this.toKey(h))}get size(){return this.map.size}clear(){this.map.clear()}delete(h){return this.map.delete(this.toKey(h))}forEach(h,g){typeof g<"u"&&(h=h.bind(g));for(const[f,v]of this.map)h(v.value,v.uri,this)}*values(){for(const h of this.map.values())yield h.value}*keys(){for(const h of this.map.values())yield h.uri}*entries(){for(const h of this.map.values())yield[h.uri,h.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.map)yield[h.uri,h.value]}}e.ResourceMap=D,D.defaultToKey=w=>w.toString();class A{constructor(h,g){this[t]="ResourceSet",!h||typeof h=="function"?this._map=new D(h):(this._map=new D(g),h.forEach(this.add,this))}get size(){return this._map.size}add(h){return this._map.set(h,h),this}clear(){this._map.clear()}delete(h){return this._map.delete(h)}forEach(h,g){this._map.forEach((f,v)=>h.call(g,v,v,this))}has(h){return this._map.has(h)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=A;var k;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(h){return this._map.has(h)}get(h,g=0){const f=this._map.get(h);if(!!f)return g!==0&&this.touch(f,g),f.value}set(h,g,f=0){let v=this._map.get(h);if(v)v.value=g,f!==0&&this.touch(v,f);else{switch(v={key:h,value:g,next:void 0,previous:void 0},f){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(h,v),this._size++}return this}delete(h){return!!this.remove(h)}remove(h){const g=this._map.get(h);if(!!g)return this._map.delete(h),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const h=this._head;return this._map.delete(h.key),this.removeItem(h),this._size--,h.value}forEach(h,g){const f=this._state;let v=this._head;for(;v;){if(g?h.bind(g)(v.value,v.key,this):h(v.value,v.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const h=this,g=this._state;let f=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.key,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return v}values(){const h=this,g=this._state;let f=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.value,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return v}entries(){const h=this,g=this._state;let f=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:[f.key,f.value],done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return v}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(h){if(h>=this.size)return;if(h===0){this.clear();return}let g=this._head,f=this.size;for(;g&&f>h;)this._map.delete(g.key),g=g.next,f--;this._head=g,this._size=f,g&&(g.previous=void 0),this._state++}addItemFirst(h){if(!this._head&&!this._tail)this._tail=h;else if(this._head)h.next=this._head,this._head.previous=h;else throw new Error("Invalid list");this._head=h,this._state++}addItemLast(h){if(!this._head&&!this._tail)this._head=h;else if(this._tail)h.previous=this._tail,this._tail.next=h;else throw new Error("Invalid list");this._tail=h,this._state++}removeItem(h){if(h===this._head&&h===this._tail)this._head=void 0,this._tail=void 0;else if(h===this._head){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this._head=h.next}else if(h===this._tail){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this._tail=h.previous}else{const g=h.next,f=h.previous;if(!g||!f)throw new Error("Invalid list");g.previous=f,f.next=g}h.next=void 0,h.previous=void 0,this._state++}touch(h,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(h===this._head)return;const f=h.next,v=h.previous;h===this._tail?(v.next=void 0,this._tail=v):(f.previous=v,v.next=f),h.previous=void 0,h.next=this._head,this._head.previous=h,this._head=h,this._state++}else if(g===2){if(h===this._tail)return;const f=h.next,v=h.previous;h===this._head?(f.previous=void 0,this._head=f):(f.previous=v,v.next=f),h.next=void 0,h.previous=this._tail,this._tail.next=h,this._tail=h,this._state++}}}toJSON(){const h=[];return this.forEach((g,f)=>{h.push([f,g])}),h}fromJSON(h){this.clear();for(const[g,f]of h)this.set(g,f)}}e.LinkedMap=E;class y extends E{constructor(h,g=1){super(),this._limit=h,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(h){this._limit=h,this.checkTrim()}get ratio(){return this._ratio}set ratio(h){this._ratio=Math.min(Math.max(0,h),1),this.checkTrim()}get(h,g=2){return super.get(h,g)}peek(h){return super.get(h,0)}set(h,g){return super.set(h,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[145],De([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var ge=0;ge<le.length;ge++){var Z=le[ge];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function c(oe,le,ge){return le&&e(oe.prototype,le),ge&&e(oe,ge),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return I(oe,le);var ge=Object.prototype.toString.call(oe).slice(8,-1);if(ge==="Object"&&oe.constructor&&(ge=oe.constructor.name),ge==="Map"||ge==="Set")return Array.from(oe);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return I(oe,le)}}function I(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var ge=0,Z=new Array(le);ge<le;ge++)Z[ge]=oe[ge];return Z}function P(oe,le){var ge=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(ge)return(ge=ge.call(oe)).next.bind(ge);if(Array.isArray(oe)||(ge=t(oe))||le&&oe&&typeof oe.length=="number"){ge&&(oe=ge);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=C();function T(oe){J.defaults=oe}var S=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(le){return E[le]};function w(oe,le){if(le){if(S.test(oe))return oe.replace(D,y)}else if(A.test(oe))return oe.replace(k,y);return oe}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(oe){return oe.replace(h,function(le,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var ge={replace:function(ae,ne){return ne=ne.source||ne,ne=ne.replace(f,"$1"),oe=oe.replace(ae,ne),ge},getRegex:function(){return new RegExp(oe,le)}};return ge}var m=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(oe,le,ge){if(oe){var Z;try{Z=decodeURIComponent(g(ge)).replace(m,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!r.test(ge)&&(ge=a(le,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var o={},u=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(oe,le){o[" "+oe]||(u.test(oe)?o[" "+oe]=oe+"/":o[" "+oe]=p(oe,"/",!0)),oe=o[" "+oe];var ge=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?ge?le:oe.replace(s,"$1")+le:le.charAt(0)==="/"?ge?le:oe.replace(l,"$1")+le:oe+le}var d={exec:function(){}};function n(oe){for(var le=1,ge,Z;le<arguments.length;le++){ge=arguments[le];for(Z in ge)Object.prototype.hasOwnProperty.call(ge,Z)&&(oe[Z]=ge[Z])}return oe}function i(oe,le){var ge=oe.replace(/\|/g,function(ne,ie,N){for(var j=!1,G=ie;--G>=0&&N[G]==="\\";)j=!j;return j?"|":" |"}),Z=ge.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function p(oe,le,ge){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ne=oe.charAt(Z-ae-1);if(ne===le&&!ge)ae++;else if(ne!==le&&ge)ae++;else break}return oe.slice(0,Z-ae)}function _(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var ge=oe.length,Z=0,ae=0;ae<ge;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function R(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,le){if(le<1)return"";for(var ge="";le>1;)le&1&&(ge+=oe),le>>=1,oe+=oe;return ge+oe}function H(oe,le,ge,Z){var ae=le.href,ne=le.title?w(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var N={type:"link",raw:ge,href:ae,title:ne,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,N}return{type:"image",raw:ge,href:ae,title:ne,text:w(ie)}}function $(oe,le){var ge=oe.match(/^(\s+)(?:```)/);if(ge===null)return le;var Z=ge[1];return le.split(`
`).map(function(ae){var ne=ae.match(/^\s+/);if(ne===null)return ae;var ie=ne[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var L=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ne=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:p(ne,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ne=ae[0],ie=$(ne,ae[3]||"");return{type:"code",raw:ne,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ne=ae[2].trim();if(/#$/.test(ne)){var ie=p(ne,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ne=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ne=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ne,ie,N,j,G,X,pe,we,ce,Ie,ye,We,qe=ae[1].trim(),Ze=qe.length>1,Ye={type:"list",raw:"",ordered:Ze,start:Ze?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Ze?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Ze?qe:"[*+-]");for(var Ne=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(We=!1,!(!(ae=Ne.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ae[0],Z=Z.substring(ne.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(j=2,ye=we.trimLeft()):(j=ae[2].search(/[^ ]/),j=j>4?1:j,ye=we.slice(j),j+=ae[1].length),X=!1,!we&&/^ *$/.test(ce)&&(ne+=ce+`
`,Z=Z.substring(ce.length+1),We=!0),!We)for(var at=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");Z&&(Ie=Z.split(`
`,1)[0],we=Ie,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||at.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=j||!we.trim())ye+=`
`+we.slice(j);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ne+=Ie+`
`,Z=Z.substring(Ie.length+1)}Ye.loose||(pe?Ye.loose=!0:/\n *\n *$/.test(ne)&&(pe=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(N=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ne,task:!!ie,checked:N,loose:!1,text:ye}),Ye.raw+=ne}Ye.items[Ye.items.length-1].raw=ne.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var xe=Ye.items.length;for(G=0;G<xe;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var me=Ye.items[G].tokens.filter(function(Oe){return Oe.type==="space"}),Ae=me.every(function(Oe){for(var Me=Oe.raw.split(""),Ke=0,Je=P(Me),st;!(st=Je()).done;){var vt=st.value;if(vt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&me.length&&Ae&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ne={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]);ne.type="paragraph",ne.text=ie,ne.tokens=this.lexer.inline(ie)}return ne}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ne=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ne={type:"table",header:i(ae[1]).map(function(pe){return{text:pe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ae[0];var ie=ne.align.length,N,j,G,X;for(N=0;N<ie;N++)/^ *-+: *$/.test(ne.align[N])?ne.align[N]="right":/^ *:-+: *$/.test(ne.align[N])?ne.align[N]="center":/^ *:-+ *$/.test(ne.align[N])?ne.align[N]="left":ne.align[N]=null;for(ie=ne.rows.length,N=0;N<ie;N++)ne.rows[N]=i(ne.rows[N],ne.header.length).map(function(pe){return{text:pe}});for(ie=ne.header.length,j=0;j<ie;j++)ne.header[j].tokens=this.lexer.inline(ne.header[j].text);for(ie=ne.rows.length,j=0;j<ie;j++)for(X=ne.rows[j],G=0;G<X.length;G++)X[G].tokens=this.lexer.inline(X[G].text);return ne}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ne=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:w(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ne=ae[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ie=p(ne.slice(0,-1),"\\");if((ne.length-ie.length)%2===0)return}else{var N=_(ae[2],"()");if(N>-1){var j=ae[0].indexOf("!")===0?5:4,G=j+ae[1].length+N;ae[2]=ae[2].substring(0,N),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var X=ae[2],pe="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],pe=we[3])}else pe=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ne)?X=X.slice(1):X=X.slice(1,-1)),H(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var ie=(ne[2]||ne[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var N=ne[0].charAt(0);return{type:"text",raw:N,text:N}}return H(ne,ie,ne[0],this.lexer)}},le.emStrong=function(Z,ae,ne){ne===void 0&&(ne="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=ie[1]||ie[2]||"";if(!N||N&&(ne===""||this.rules.inline.punctuation.exec(ne))){var j=ie[0].length-1,G,X,pe=j,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+j);(ie=ce.exec(ae))!=null;)if(G=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!G){if(X=G.length,ie[3]||ie[4]){pe+=X;continue}else if((ie[5]||ie[6])&&j%3&&!((j+X)%3)){we+=X;continue}if(pe-=X,!(pe>0)){if(X=Math.min(X,X+pe+we),Math.min(j,X)%2){var Ie=Z.slice(1,j+ie.index+X);return{type:"em",raw:Z.slice(0,j+ie.index+X+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var ye=Z.slice(2,j+ie.index+X-1);return{type:"strong",raw:Z.slice(0,j+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ne=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ne),N=/^ /.test(ne)&&/ $/.test(ne);return ie&&N&&(ne=ne.substring(1,ne.length-1)),ne=w(ne,!0),{type:"codespan",raw:ae[0],text:ne}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ne=this.rules.inline.autolink.exec(Z);if(ne){var ie,N;return ne[2]==="@"?(ie=w(this.options.mangle?ae(ne[1]):ne[1]),N="mailto:"+ie):(ie=w(ne[1]),N=ie),{type:"link",raw:ne[0],text:ie,href:N,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ne;if(ne=this.rules.inline.url.exec(Z)){var ie,N;if(ne[2]==="@")ie=w(this.options.mangle?ae(ne[0]):ne[0]),N="mailto:"+ie;else{var j;do j=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(j!==ne[0]);ie=w(ne[0]),ne[1]==="www."?N="http://"+ie:N=ie}return{type:"link",raw:ne[0],text:ie,href:N,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ne=this.rules.inline.text.exec(Z);if(ne){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]):ne[0]:ie=w(this.options.smartypants?ae(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ie}}},oe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=v(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=v(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=v(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=v(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=v(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=v(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=n({},B),B.gfm=n({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=v(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=v(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=n({},B.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:v(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=v(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=v(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=v(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=v(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=v(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=v(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=v(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=v(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=v(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=v(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=v(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=n({},O),O.pedantic=n({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=n({},O.normal,{escape:v(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=v(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=n({},O.gfm,{br:v(O.br).replace("{2,}","*").getRegex(),text:v(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(oe){var le="",ge,Z,ae=oe.length;for(ge=0;ge<ae;ge++)Z=oe.charCodeAt(ge),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var F=function(){function oe(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||J.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:B.normal,inline:O.normal};this.options.pedantic?(Z.block=B.pedantic,Z.inline=O.pedantic):this.options.gfm&&(Z.block=B.gfm,this.options.breaks?Z.inline=O.breaks:Z.inline=O.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ne=new oe(ae);return ne.lex(Z)},oe.lexInline=function(Z,ae){var ne=new oe(ae);return ne.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(pe,we,ce){return we+"    ".repeat(ce.length)});for(var ie,N,j,G;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(ie=pe.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+ie.raw,N.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+ie.raw,N.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,we=Z.slice(1),ce=void 0;ne.options.extensions.startBlock.forEach(function(Ie){ce=Ie.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(pe=Math.min(pe,ce))}),pe<1/0&&pe>=0&&(j=Z.substring(0,pe+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(j))){N=ae[ae.length-1],G&&N.type==="paragraph"?(N.raw+=`
`+ie.raw,N.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(ie),G=j.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=`
`+ie.raw,N.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]);var ie,N,j,G=Z,X,pe,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)ce.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(pe||(we=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),N=ae[ae.length-1],N&&ie.type==="text"&&N.type==="text"?(N.raw+=ie.raw,N.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),N=ae[ae.length-1],N&&ie.type==="text"&&N.type==="text"?(N.raw+=ie.raw,N.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,G,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,U)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,U))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,We=Z.slice(1),qe=void 0;ne.options.extensions.startInline.forEach(function(Ze){qe=Ze.call({lexer:this},We),typeof qe=="number"&&qe>=0&&(ye=Math.min(ye,qe))}),ye<1/0&&ye>=0&&(j=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(j,z)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),pe=!0,N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=ie.raw,N.text+=ie.text):ae.push(ie);continue}if(Z){var Ie="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ae},c(oe,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),oe}(),V=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ne){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(Z,ie);N!=null&&N!==Z&&(ne=!0,Z=N)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+w(ie,!0)+'">'+(ne?Z:w(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:w(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ne,ie){if(this.options.headerIds){var N=this.options.headerPrefix+ie.slug(ne);return"<h"+ae+' id="'+N+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ne){var ie=ae?"ol":"ul",N=ae&&ne!==1?' start="'+ne+'"':"";return"<"+ie+N+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ne=ae.header?"th":"td",ie=ae.align?"<"+ne+' align="'+ae.align+'">':"<"+ne+">";return ie+Z+("</"+ne+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ne){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<a href="'+w(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ne+"</a>",ie},le.image=function(Z,ae,ne){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<img src="'+Z+'" alt="'+ne+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),x=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ne){return""+ne},le.image=function(Z,ae,ne){return""+ne},le.br=function(){return""},oe}(),Q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ne=Z,ie=0;if(this.seen.hasOwnProperty(ne)){ie=this.seen[Z];do ie++,ne=Z+"-"+ie;while(this.seen.hasOwnProperty(ne))}return ae||(this.seen[Z]=ie,this.seen[ne]=0),ne},le.slug=function(Z,ae){ae===void 0&&(ae={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ae.dryrun)},oe}(),K=function(){function oe(ge){this.options=ge||J.defaults,this.options.renderer=this.options.renderer||new V,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Q}oe.parse=function(Z,ae){var ne=new oe(ae);return ne.parse(Z)},oe.parseInline=function(Z,ae){var ne=new oe(ae);return ne.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ne="",ie,N,j,G,X,pe,we,ce,Ie,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,xe=Z.length;for(ie=0;ie<xe;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ne+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,g(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",G=ye.header.length,N=0;N<G;N++)we+=this.renderer.tablecell(this.parseInline(ye.header[N].tokens),{header:!0,align:ye.align[N]});for(ce+=this.renderer.tablerow(we),Ie="",G=ye.rows.length,N=0;N<G;N++){for(pe=ye.rows[N],we="",X=pe.length,j=0;j<X;j++)we+=this.renderer.tablecell(this.parseInline(pe[j].tokens),{header:!1,align:ye.align[j]});Ie+=this.renderer.tablerow(we)}ne+=this.renderer.table(ce,Ie);continue}case"blockquote":{Ie=this.parse(ye.tokens),ne+=this.renderer.blockquote(Ie);continue}case"list":{for(We=ye.ordered,qe=ye.start,Ze=ye.loose,G=ye.items.length,Ie="",N=0;N<G;N++)Ne=ye.items[N],at=Ne.checked,re=Ne.task,Ye="",Ne.task&&(se=this.renderer.checkbox(at),Ze?Ne.tokens.length>0&&Ne.tokens[0].type==="paragraph"?(Ne.tokens[0].text=se+" "+Ne.tokens[0].text,Ne.tokens[0].tokens&&Ne.tokens[0].tokens.length>0&&Ne.tokens[0].tokens[0].type==="text"&&(Ne.tokens[0].tokens[0].text=se+" "+Ne.tokens[0].tokens[0].text)):Ne.tokens.unshift({type:"text",text:se}):Ye+=se),Ye+=this.parse(Ne.tokens,Ze),Ie+=this.renderer.listitem(Ye,re,at);ne+=this.renderer.list(Ie,We,qe);continue}case"html":{ne+=this.renderer.html(ye.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ie=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<xe&&Z[ie+1].type==="text";)ye=Z[++ie],Ie+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ne+=ae?this.renderer.paragraph(Ie):Ie;continue}default:{var me='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(me);return}else throw new Error(me)}}}return ne},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ne="",ie,N,j,G=Z.length;for(ie=0;ie<G;ie++){if(N=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&(j=this.options.extensions.renderers[N.type].call({parser:this},N),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){ne+=j||"";continue}switch(N.type){case"escape":{ne+=ae.text(N.text);break}case"html":{ne+=ae.html(N.text);break}case"link":{ne+=ae.link(N.href,N.title,this.parseInline(N.tokens,ae));break}case"image":{ne+=ae.image(N.href,N.title,N.text);break}case"strong":{ne+=ae.strong(this.parseInline(N.tokens,ae));break}case"em":{ne+=ae.em(this.parseInline(N.tokens,ae));break}case"codespan":{ne+=ae.codespan(N.text);break}case"br":{ne+=ae.br();break}case"del":{ne+=ae.del(this.parseInline(N.tokens,ae));break}case"text":{ne+=ae.text(N.text);break}default:{var X='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ne},oe}();function ue(oe,le,ge){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(ge=le,le=null),le=n({},ue.defaults,le||{}),R(le),ge){var Z=le.highlight,ae;try{ae=F.lex(oe,le)}catch(G){return ge(G)}var ne=function(X){var pe;if(!X)try{le.walkTokens&&ue.walkTokens(ae,le.walkTokens),pe=K.parse(ae,le)}catch(we){X=we}return le.highlight=Z,X?ge(X):ge(null,pe)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ne();var ie=0;ue.walkTokens(ae,function(G){G.type==="code"&&(ie++,setTimeout(function(){Z(G.text,G.lang,function(X,pe){if(X)return ne(X);pe!=null&&pe!==G.text&&(G.text=pe,G.escaped=!0),ie--,ie===0&&ne()})},0))}),ie===0&&ne();return}function N(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+w(G.message+"",!0)+"</pre>";throw G}try{var j=F.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(ue.walkTokens(j,le.walkTokens)).then(function(){return K.parse(j,le)}).catch(N);ue.walkTokens(j,le.walkTokens)}return K.parse(j,le)}catch(G){N(G)}}ue.options=ue.setOptions=function(oe){return n(ue.defaults,oe),T(ue.defaults),ue},ue.getDefaults=C,ue.defaults=J.defaults,ue.use=function(){for(var oe=arguments.length,le=new Array(oe),ge=0;ge<oe;ge++)le[ge]=arguments[ge];var Z=n.apply(void 0,[{}].concat(le)),ae=ue.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(ie){if(ie.extensions&&(ne=!0,ie.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var G=ae.renderers?ae.renderers[j.name]:null;G?ae.renderers[j.name]=function(){for(var X=arguments.length,pe=new Array(X),we=0;we<X;we++)pe[we]=arguments[we];var ce=j.renderer.apply(this,pe);return ce===!1&&(ce=G.apply(this,pe)),ce}:ae.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[j.level]?ae[j.level].unshift(j.tokenizer):ae[j.level]=[j.tokenizer],j.start&&(j.level==="block"?ae.startBlock?ae.startBlock.push(j.start):ae.startBlock=[j.start]:j.level==="inline"&&(ae.startInline?ae.startInline.push(j.start):ae.startInline=[j.start]))}j.childTokens&&(ae.childTokens[j.name]=j.childTokens)})),ie.renderer&&function(){var j=ue.defaults.renderer||new V,G=function(we){var ce=j[we];j[we]=function(){for(var Ie=arguments.length,ye=new Array(Ie),We=0;We<Ie;We++)ye[We]=arguments[We];var qe=ie.renderer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.renderer)G(X);Z.renderer=j}(),ie.tokenizer&&function(){var j=ue.defaults.tokenizer||new L,G=function(we){var ce=j[we];j[we]=function(){for(var Ie=arguments.length,ye=new Array(Ie),We=0;We<Ie;We++)ye[We]=arguments[We];var qe=ie.tokenizer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.tokenizer)G(X);Z.tokenizer=j}(),ie.walkTokens){var N=ue.defaults.walkTokens;Z.walkTokens=function(j){var G=[];return G.push(ie.walkTokens.call(this,j)),N&&(G=G.concat(N.call(this,j))),G}}ne&&(Z.extensions=ae),ue.setOptions(Z)})},ue.walkTokens=function(oe,le){for(var ge=[],Z=function(){var N=ne.value;switch(ge=ge.concat(le.call(ue,N)),N.type){case"table":{for(var j=P(N.header),G;!(G=j()).done;){var X=G.value;ge=ge.concat(ue.walkTokens(X.tokens,le))}for(var pe=P(N.rows),we;!(we=pe()).done;)for(var ce=we.value,Ie=P(ce),ye;!(ye=Ie()).done;){var We=ye.value;ge=ge.concat(ue.walkTokens(We.tokens,le))}break}case"list":{ge=ge.concat(ue.walkTokens(N.items,le));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[N.type]?ue.defaults.extensions.childTokens[N.type].forEach(function(qe){ge=ge.concat(ue.walkTokens(N[qe],le))}):N.tokens&&(ge=ge.concat(ue.walkTokens(N.tokens,le)))}},ae=P(oe),ne;!(ne=ae()).done;)Z();return ge},ue.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=n({},ue.defaults,le||{}),R(le);try{var ge=F.lexInline(oe,le);return le.walkTokens&&ue.walkTokens(ge,le.walkTokens),K.parseInline(ge,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+w(Z.message+"",!0)+"</pre>";throw Z}},ue.Parser=K,ue.parser=K.parse,ue.Renderer=V,ue.TextRenderer=x,ue.Lexer=F,ue.lexer=F.lex,ue.Tokenizer=L,ue.Slugger=Q,ue.parse=ue;var te=ue.options,he=ue.setOptions,Y=ue.use,fe=ue.walkTokens,be=ue.parseInline,ke=ue,Re=K.parse,ze=F.lex;J.Lexer=F,J.Parser=K,J.Renderer=V,J.Slugger=Q,J.TextRenderer=x,J.Tokenizer=L,J.getDefaults=C,J.lexer=ze,J.marked=ue,J.options=te,J.parse=ke,J.parseInline=be,J.parser=Re,J.setOptions=he,J.use=Y,J.walkTokens=fe,Object.defineProperty(J,"__esModule",{value:!0})}),define(Ce[80],De([1,0,28]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function I(D){return S(D,"NFC",t)}e.normalizeNFC=I;const P=new c.LRUCache(1e4);function C(D){return S(D,"NFD",P)}e.normalizeNFD=C;const T=/[^\u0000-\u0080]/;function S(D,A,k){if(!D)return D;const E=k.get(D);if(E)return E;let y;return T.test(D)?y=D.normalize(A):y=D,k.set(D,y),y}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(A){return C(A).replace(D,"")}}()}),define(Ce[99],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,S,D){return Math.min(Math.max(T,S),D)}e.clamp=c;function t(T,S){return(S+T%S)%S}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class P{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class C{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const D=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=D,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function J(I){const P=[];typeof I=="number"&&P.push("code/timeOrigin",I);function C(S){P.push(S,Date.now())}function T(){const S=[];for(let D=0;D<P.length;D+=2)S.push({name:P[D],startTime:P[D+1]});return S}return{mark:C,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))P.push({name:C.name,startTime:Math.round(I+C.startTime)});return P}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function c(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:J)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function c(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return J[t].call(I.exports,I,I.exports,c),I.l=!0,I.exports}return c.m=J,c.c=e,c.d=function(t,I,P){c.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:P})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,I){if(1&I&&(t=c(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(c.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var C in t)c.d(P,C,function(T){return t[T]}.bind(null,C));return P},c.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(I,"a",I),I},c.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},c.p="",c(c.s=0)}([function(J,e,c){(function(t){var I;e=J.exports=Y,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],D=0,A=D++;S[A]="0|[1-9]\\d*";var k=D++;S[k]="[0-9]+";var E=D++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=D++;S[y]="("+S[A]+")\\.("+S[A]+")\\.("+S[A]+")";var w=D++;S[w]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var h=D++;S[h]="(?:"+S[A]+"|"+S[E]+")";var g=D++;S[g]="(?:"+S[k]+"|"+S[E]+")";var f=D++;S[f]="(?:-("+S[h]+"(?:\\."+S[h]+")*))";var v=D++;S[v]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var m=D++;S[m]="[0-9A-Za-z-]+";var r=D++;S[r]="(?:\\+("+S[m]+"(?:\\."+S[m]+")*))";var b=D++,o="v?"+S[y]+S[f]+"?"+S[r]+"?";S[b]="^"+o+"$";var u="[v=\\s]*"+S[w]+S[v]+"?"+S[r]+"?",s=D++;S[s]="^"+u+"$";var l=D++;S[l]="((?:<|>)?=?)";var a=D++;S[a]=S[k]+"|x|X|\\*";var d=D++;S[d]=S[A]+"|x|X|\\*";var n=D++;S[n]="[v=\\s]*("+S[d]+")(?:\\.("+S[d]+")(?:\\.("+S[d]+")(?:"+S[f]+")?"+S[r]+"?)?)?";var i=D++;S[i]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[v]+")?"+S[r]+"?)?)?";var p=D++;S[p]="^"+S[l]+"\\s*"+S[n]+"$";var _=D++;S[_]="^"+S[l]+"\\s*"+S[i]+"$";var R=D++;S[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;S[M]="(?:~>?)";var H=D++;S[H]="(\\s*)"+S[M]+"\\s+",T[H]=new RegExp(S[H],"g");var $=D++;S[$]="^"+S[M]+S[n]+"$";var L=D++;S[L]="^"+S[M]+S[i]+"$";var B=D++;S[B]="(?:\\^)";var O=D++;S[O]="(\\s*)"+S[B]+"\\s+",T[O]=new RegExp(S[O],"g");var z=D++;S[z]="^"+S[B]+S[n]+"$";var U=D++;S[U]="^"+S[B]+S[i]+"$";var F=D++;S[F]="^"+S[l]+"\\s*("+u+")$|^$";var V=D++;S[V]="^"+S[l]+"\\s*("+o+")$|^$";var x=D++;S[x]="(\\s*)"+S[l]+"\\s*("+u+"|"+S[n]+")",T[x]=new RegExp(S[x],"g");var Q=D++;S[Q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var K=D++;S[K]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var ue=D++;S[ue]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)I(te,S[te]),T[te]||(T[te]=new RegExp(S[te]));function he(ce,Ie){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>P||!(Ie?T[s]:T[b]).test(ce))return null;try{return new Y(ce,Ie)}catch{return null}}function Y(ce,Ie){if(ce instanceof Y){if(ce.loose===Ie)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ce,Ie);I("SemVer",ce,Ie),this.loose=Ie;var ye=ce.trim().match(Ie?T[s]:T[b]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var qe=+We;if(qe>=0&&qe<C)return qe}return We}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=he,e.valid=function(ce,Ie){var ye=he(ce,Ie);return ye?ye.version:null},e.clean=function(ce,Ie){var ye=he(ce.trim().replace(/^[=v]+/,""),Ie);return ye?ye.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return I("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ie=0;do{var ye=this.prerelease[Ie],We=ce.prerelease[Ie];if(I("prerelease compare",Ie,ye,We),ye===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ye===void 0)return-1;if(ye!==We)return be(ye,We)}while(++Ie)},Y.prototype.inc=function(ce,Ie){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ie,ye,We){typeof ye=="string"&&(We=ye,ye=void 0);try{return new Y(ce,ye).inc(Ie,We).version}catch{return null}},e.diff=function(ce,Ie){if(oe(ce,Ie))return null;var ye=he(ce),We=he(Ie);if(ye.prerelease.length||We.prerelease.length){for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return"pre"+qe;return"prerelease"}for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return qe},e.compareIdentifiers=be;var fe=/^[0-9]+$/;function be(ce,Ie){var ye=fe.test(ce),We=fe.test(Ie);return ye&&We&&(ce=+ce,Ie=+Ie),ye&&!We?-1:We&&!ye?1:ce<Ie?-1:ce>Ie?1:0}function ke(ce,Ie,ye){return new Y(ce,ye).compare(new Y(Ie,ye))}function Re(ce,Ie,ye){return ke(ce,Ie,ye)>0}function ze(ce,Ie,ye){return ke(ce,Ie,ye)<0}function oe(ce,Ie,ye){return ke(ce,Ie,ye)===0}function le(ce,Ie,ye){return ke(ce,Ie,ye)!==0}function ge(ce,Ie,ye){return ke(ce,Ie,ye)>=0}function Z(ce,Ie,ye){return ke(ce,Ie,ye)<=0}function ae(ce,Ie,ye,We){var qe;switch(Ie){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce!==ye;break;case"":case"=":case"==":qe=oe(ce,ye,We);break;case"!=":qe=le(ce,ye,We);break;case">":qe=Re(ce,ye,We);break;case">=":qe=ge(ce,ye,We);break;case"<":qe=ze(ce,ye,We);break;case"<=":qe=Z(ce,ye,We);break;default:throw new TypeError("Invalid operator: "+Ie)}return qe}function ne(ce,Ie){if(ce instanceof ne){if(ce.loose===Ie)return ce;ce=ce.value}if(!(this instanceof ne))return new ne(ce,Ie);I("comparator",ce,Ie),this.loose=Ie,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ce,Ie){return be(Ie,ce)},e.major=function(ce,Ie){return new Y(ce,Ie).major},e.minor=function(ce,Ie){return new Y(ce,Ie).minor},e.patch=function(ce,Ie){return new Y(ce,Ie).patch},e.compare=ke,e.compareLoose=function(ce,Ie){return ke(ce,Ie,!0)},e.rcompare=function(ce,Ie,ye){return ke(Ie,ce,ye)},e.sort=function(ce,Ie){return ce.sort(function(ye,We){return e.compare(ye,We,Ie)})},e.rsort=function(ce,Ie){return ce.sort(function(ye,We){return e.rcompare(ye,We,Ie)})},e.gt=Re,e.lt=ze,e.eq=oe,e.neq=le,e.gte=ge,e.lte=Z,e.cmp=ae,e.Comparator=ne;var ie={};function N(ce,Ie){if(ce instanceof N)return ce.loose===Ie?ce:new N(ce.raw,Ie);if(ce instanceof ne)return new N(ce.value,Ie);if(!(this instanceof N))return new N(ce,Ie);if(this.loose=Ie,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function j(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function G(ce,Ie,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,xe){return((Ie=j(ye)?"":j(We)?">="+ye+".0.0":j(qe)?">="+ye+"."+We+".0":">="+Ie)+" "+(Ne=j(at)?"":j(re)?"<"+(+at+1)+".0.0":j(se)?"<"+at+"."+(+re+1)+".0":Ee?"<="+at+"."+re+"."+se+"-"+Ee:"<="+Ne)).trim()}function X(ce,Ie){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ie))return!1;if(Ie.prerelease.length){for(ye=0;ye<ce.length;ye++)if(I(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var We=ce[ye].semver;if(We.major===Ie.major&&We.minor===Ie.minor&&We.patch===Ie.patch)return!0}return!1}return!0}function pe(ce,Ie,ye){try{Ie=new N(Ie,ye)}catch{return!1}return Ie.test(ce)}function we(ce,Ie,ye,We){var qe,Ze,Ye,Ne,at;switch(ce=new Y(ce,We),Ie=new N(Ie,We),ye){case">":qe=Re,Ze=Z,Ye=ze,Ne=">",at=">=";break;case"<":qe=ze,Ze=ge,Ye=Re,Ne="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ce,Ie,We))return!1;for(var re=0;re<Ie.set.length;++re){var se=Ie.set[re],Ee=null,xe=null;if(se.forEach(function(me){me.semver===ie&&(me=new ne(">=0.0.0")),Ee=Ee||me,xe=xe||me,qe(me.semver,Ee.semver,We)?Ee=me:Ye(me.semver,xe.semver,We)&&(xe=me)}),Ee.operator===Ne||Ee.operator===at||(!xe.operator||xe.operator===Ne)&&Ze(ce,xe.semver)||xe.operator===at&&Ye(ce,xe.semver))return!1}return!0}ne.prototype.parse=function(ce){var Ie=this.loose?T[F]:T[V],ye=ce.match(Ie);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new Y(ye[2],this.loose):this.semver=ie},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ce){return I("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ce,Ie){if(!(ce instanceof ne))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new N(ce.value,Ie),pe(this.value,ye,Ie);if(ce.operator==="")return ye=new N(this.value,Ie),pe(ce.semver,ye,Ie);var We=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ne=ae(this.semver,"<",ce.semver,Ie)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),at=ae(this.semver,">",ce.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return We||qe||Ze&&Ye||Ne||at},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(ce){var Ie=this.loose;ce=ce.trim(),I("range",ce,Ie);var ye=Ie?T[K]:T[Q];ce=ce.replace(ye,G),I("hyphen replace",ce),ce=ce.replace(T[x],"$1$2$3"),I("comparator trim",ce,T[x]),ce=(ce=(ce=ce.replace(T[H],"$1~")).replace(T[O],"$1^")).split(/\s+/).join(" ");var We=Ie?T[F]:T[V],qe=ce.split(" ").map(function(Ze){return function(Ye,Ne){return I("comp",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,xe){I("caret",Ee,xe);var me=xe?T[U]:T[z];return Ee.replace(me,function(Ae,Oe,Me,Ke,Je){var st;return I("caret",Ee,Ae,Oe,Me,Ke,Je),j(Oe)?st="":j(Me)?st=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":j(Ke)?st=Oe==="0"?">="+Oe+"."+Me+".0 <"+Oe+"."+(+Me+1)+".0":">="+Oe+"."+Me+".0 <"+(+Oe+1)+".0.0":Je?(I("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=Oe==="0"?Me==="0"?">="+Oe+"."+Me+"."+Ke+Je+" <"+Oe+"."+Me+"."+(+Ke+1):">="+Oe+"."+Me+"."+Ke+Je+" <"+Oe+"."+(+Me+1)+".0":">="+Oe+"."+Me+"."+Ke+Je+" <"+(+Oe+1)+".0.0"):(I("no pr"),st=Oe==="0"?Me==="0"?">="+Oe+"."+Me+"."+Ke+" <"+Oe+"."+Me+"."+(+Ke+1):">="+Oe+"."+Me+"."+Ke+" <"+Oe+"."+(+Me+1)+".0":">="+Oe+"."+Me+"."+Ke+" <"+(+Oe+1)+".0.0"),I("caret return",st),st})}(se,re)}).join(" ")}(Ye,Ne),I("caret",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,xe){var me=xe?T[L]:T[$];return Ee.replace(me,function(Ae,Oe,Me,Ke,Je){var st;return I("tilde",Ee,Ae,Oe,Me,Ke,Je),j(Oe)?st="":j(Me)?st=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":j(Ke)?st=">="+Oe+"."+Me+".0 <"+Oe+"."+(+Me+1)+".0":Je?(I("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=">="+Oe+"."+Me+"."+Ke+Je+" <"+Oe+"."+(+Me+1)+".0"):st=">="+Oe+"."+Me+"."+Ke+" <"+Oe+"."+(+Me+1)+".0",I("tilde return",st),st})}(se,re)}).join(" ")}(Ye,Ne),I("tildes",Ye),Ye=function(at,re){return I("replaceXRanges",at,re),at.split(/\s+/).map(function(se){return function(Ee,xe){Ee=Ee.trim();var me=xe?T[_]:T[p];return Ee.replace(me,function(Ae,Oe,Me,Ke,Je,st){I("xRange",Ee,Ae,Oe,Me,Ke,Je,st);var vt=j(Me),nt=vt||j(Ke),it=nt||j(Je);return Oe==="="&&it&&(Oe=""),vt?Ae=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&it?(nt&&(Ke=0),it&&(Je=0),Oe===">"?(Oe=">=",nt?(Me=+Me+1,Ke=0,Je=0):it&&(Ke=+Ke+1,Je=0)):Oe==="<="&&(Oe="<",nt?Me=+Me+1:Ke=+Ke+1),Ae=Oe+Me+"."+Ke+"."+Je):nt?Ae=">="+Me+".0.0 <"+(+Me+1)+".0.0":it&&(Ae=">="+Me+"."+Ke+".0 <"+Me+"."+(+Ke+1)+".0"),I("xRange return",Ae),Ae})}(se,re)}).join(" ")}(Ye,Ne),I("xrange",Ye),Ye=function(at,re){return I("replaceStars",at,re),at.trim().replace(T[ue],"")}(Ye,Ne),I("stars",Ye),Ye}(Ze,Ie)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Ze){return!!Ze.match(We)})),qe=qe.map(function(Ze){return new ne(Ze,Ie)})},N.prototype.intersects=function(ce,Ie){if(!(ce instanceof N))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(We){return ce.set.some(function(qe){return qe.every(function(Ze){return We.intersects(Ze,Ie)})})})})},e.toComparators=function(ce,Ie){return new N(ce,Ie).set.map(function(ye){return ye.map(function(We){return We.value}).join(" ").trim().split(" ")})},N.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if(X(this.set[Ie],ce))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ce,Ie,ye){var We=null,qe=null;try{var Ze=new N(Ie,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==-1||(qe=new Y(We=Ye,ye)))}),We},e.minSatisfying=function(ce,Ie,ye){var We=null,qe=null;try{var Ze=new N(Ie,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==1||(qe=new Y(We=Ye,ye)))}),We},e.validRange=function(ce,Ie){try{return new N(ce,Ie).range||"*"}catch{return null}},e.ltr=function(ce,Ie,ye){return we(ce,Ie,"<",ye)},e.gtr=function(ce,Ie,ye){return we(ce,Ie,">",ye)},e.outside=we,e.prerelease=function(ce,Ie){var ye=he(ce,Ie);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ie,ye){return ce=new N(ce,ye),Ie=new N(Ie,ye),ce.intersects(Ie)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var Ie=ce.match(T[R]);return Ie==null?null:he((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,c(1))},function(J,e){var c,t,I=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function T(g){if(c===setTimeout)return setTimeout(g,0);if((c===P||!c)&&setTimeout)return c=setTimeout,setTimeout(g,0);try{return c(g,0)}catch{try{return c.call(null,g,0)}catch{return c.call(this,g,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:P}catch{c=P}try{t=typeof clearTimeout=="function"?clearTimeout:C}catch{t=C}})();var S,D=[],A=!1,k=-1;function E(){A&&S&&(A=!1,S.length?D=S.concat(D):k=-1,D.length&&y())}function y(){if(!A){var g=T(E);A=!0;for(var f=D.length;f;){for(S=D,D=[];++k<f;)S&&S[k].run();k=-1,f=D.length}S=null,A=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===C||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(g)}}function w(g,f){this.fun=g,this.array=f}function h(){}I.nextTick=function(g){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];D.push(new w(g,f)),D.length!==1||A||T(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=h,I.addListener=h,I.once=h,I.off=h,I.removeListener=h,I.removeAllListeners=h,I.emit=h,I.prependListener=h,I.prependOnceListener=h,I.listeners=function(g){return[]},I.binding=function(g){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(g){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ce[100],De([1,0,11,6]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(r){const b=r;return b?typeof b.read=="function":!1}e.isReadable=I;function P(r){const b=r;return b?[b.on,b.pause,b.resume,b.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=P;function C(r){const b=r;return b?P(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(r,b){return new S(r,b)}e.newWriteableStream=T;class S{constructor(b,o){this.reducer=b,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b<"u"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(o=>o(b))}emitError(b){this.listeners.error.length===0?(0,c.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(o=>o(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,o){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(b,o){if(this.state.destroyed)return;let u;switch(b){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const s=u.indexOf(o);s>=0&&u.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(r,b){const o=[];let u;for(;(u=r.read())!==null;)o.push(u);return b(o)}e.consumeReadable=D;function A(r,b,o){const u=[];let s;for(;(s=r.read())!==null&&u.length<o;)u.push(s);return s===null&&u.length>0?b(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const l=s;return s=void 0,l}return r.read()}}}e.peekReadable=A;function k(r,b){return new Promise((o,u)=>{const s=[];E(r,{onData:l=>{b&&s.push(l)},onError:l=>{b?u(l):o(void 0)},onEnd:()=>{o(b?b(s):void 0)}})})}e.consumeStream=k;function E(r,b){let o=!1;return r.on("error",u=>{o||b.onError(u)}),r.on("end",()=>{o||b.onEnd()}),r.on("data",u=>{o||b.onData(u)}),(0,t.toDisposable)(()=>o=!0)}e.listenStream=E;function y(r,b){return new Promise((o,u)=>{const s=new t.DisposableStore,l=[],a=i=>{if(l.push(i),l.length>b)return s.dispose(),r.pause(),o({stream:r,buffer:l,ended:!1})},d=i=>u(i),n=()=>o({stream:r,buffer:l,ended:!0});s.add((0,t.toDisposable)(()=>r.removeListener("error",d))),r.on("error",d),s.add((0,t.toDisposable)(()=>r.removeListener("end",n))),r.on("end",n),s.add((0,t.toDisposable)(()=>r.removeListener("data",a))),r.on("data",a)})}e.peekStream=y;function w(r,b){const o=T(b);return o.end(r),o}e.toStream=w;function h(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}e.emptyStream=h;function g(r){let b=!1;return{read:()=>b?null:(b=!0,r)}}e.toReadable=g;function f(r,b,o){const u=T(o);return E(r,{onData:s=>u.write(b.data(s)),onError:s=>u.error(b.error?b.error(s):s),onEnd:()=>u.end()}),u}e.transform=f;function v(r,b,o){let u=!1;return{read:()=>{const s=b.read();return u?s:(u=!0,s!==null?o([r,s]):r)}}}e.prefixedReadable=v;function m(r,b,o){let u=!1;const s=T(o);return E(b,{onData:l=>u?s.write(l):(u=!0,s.write(o([r,l]))),onError:l=>s.error(l),onEnd:()=>{u||(u=!0,s.write(r)),s.end()}}),s}e.prefixedStream=m}),define(Ce[23],De([1,0,100]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,P;class C{static alloc(i){return t?new C(Buffer.allocUnsafe(i)):new C(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new C(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&t?new C(Buffer.from(i)):(I||(I=new TextEncoder),new C(I.encode(i)))}static fromByteArray(i){const p=C.alloc(i.length);for(let _=0,R=i.length;_<R;_++)p.buffer[_]=i[_];return p}static concat(i,p){if(typeof p>"u"){p=0;for(let M=0,H=i.length;M<H;M++)p+=i[M].byteLength}const _=C.alloc(p);let R=0;for(let M=0,H=i.length;M<H;M++){const $=i[M];_.set($,R),R+=$.byteLength}return _}constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}clone(){const i=C.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(i,p){return new C(this.buffer.subarray(i,p))}set(i,p){if(i instanceof C)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(i){return D(this.buffer,i)}writeUInt32BE(i,p){A(this.buffer,i,p)}readUInt32LE(i){return k(this.buffer,i)}writeUInt32LE(i,p){E(this.buffer,i,p)}readUInt8(i){return y(this.buffer,i)}writeUInt8(i,p){w(this.buffer,i,p)}}e.VSBuffer=C;function T(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=T;function S(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255}e.writeUInt16LE=S;function D(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=D;function A(n,i,p){n[p+3]=i,i=i>>>8,n[p+2]=i,i=i>>>8,n[p+1]=i,i=i>>>8,n[p]=i}e.writeUInt32BE=A;function k(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=k;function E(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255,i=i>>>8,n[p+2]=i&255,i=i>>>8,n[p+3]=i&255}e.writeUInt32LE=E;function y(n,i){return n[i]}e.readUInt8=y;function w(n,i,p){n[p]=i}e.writeUInt8=w;function h(n){return c.consumeReadable(n,i=>C.concat(i))}e.readableToBuffer=h;function g(n){return c.toReadable(n)}e.bufferToReadable=g;function f(n){return c.consumeStream(n,i=>C.concat(i))}e.streamToBuffer=f;async function v(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await f(n.stream)])}e.bufferedStreamToBuffer=v;function m(n){return c.toStream(n,i=>C.concat(i))}e.bufferToStream=m;function r(n){return c.transform(n,{data:i=>typeof i=="string"?C.fromString(i):C.wrap(i)},i=>C.concat(i))}e.streamToBufferReadableStream=r;function b(n){return c.newWriteableStream(i=>C.concat(i),n)}e.newWriteableBufferStream=b;function o(n,i){return c.prefixedReadable(n,i,p=>C.concat(p))}e.prefixedBufferReadable=o;function u(n,i){return c.prefixedStream(n,i,p=>C.concat(p))}e.prefixedBufferStream=u;function s(n){let i=0,p=0,_=0;const R=new Uint8Array(Math.floor(n.length/4*3)),M=$=>{switch(p){case 3:R[_++]=i|$,p=0;break;case 2:R[_++]=i|$>>>2,i=$<<6,p=3;break;case 1:R[_++]=i|$>>>4,i=$<<4,p=2;break;default:i=$<<2,p=1}};for(let $=0;$<n.length;$++){const L=n.charCodeAt($);if(L>=65&&L<=90)M(L-65);else if(L>=97&&L<=122)M(L-97+26);else if(L>=48&&L<=57)M(L-48+52);else if(L===43||L===45)M(62);else if(L===47||L===95)M(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${n[$]}`)}}const H=_;for(;p>0;)M(0);return C.wrap(R).slice(0,H)}e.decodeBase64=s;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:n},i=!0,p=!1){const _=p?a:l;let R="";const M=n.byteLength%3;let H=0;for(;H<n.byteLength-M;H+=3){const $=n[H+0],L=n[H+1],B=n[H+2];R+=_[$>>>2],R+=_[($<<4|L>>>4)&63],R+=_[(L<<2|B>>>6)&63],R+=_[B&63]}if(M===1){const $=n[H+0];R+=_[$>>>2],R+=_[$<<4&63],i&&(R+="==")}else if(M===2){const $=n[H+0],L=n[H+1];R+=_[$>>>2],R+=_[($<<4|L>>>4)&63],R+=_[L<<2&63],i&&(R+="=")}return R}e.encodeBase64=d}),define(Ce[12],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(u){return typeof u=="string"}e.isString=c;function t(u){return Array.isArray(u)&&u.every(s=>c(s))}e.isStringArray=t;function I(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=I;function P(u){const s=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof s}e.isTypedArray=P;function C(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=C;function T(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=T;function S(u){return u===!0||u===!1}e.isBoolean=S;function D(u){return typeof u>"u"}e.isUndefined=D;function A(u){return!k(u)}e.isDefined=A;function k(u){return D(u)||u===null}e.isUndefinedOrNull=k;function E(u,s){if(!u)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=E;function y(u){if(k(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=y;function w(...u){const s=[];for(let l=0;l<u.length;l++){const a=u[l];if(k(a))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);s.push(a)}return s}e.assertAllDefined=w;const h=Object.prototype.hasOwnProperty;function g(u){if(!I(u))return!1;for(const s in u)if(h.call(u,s))return!1;return!0}e.isEmptyObject=g;function f(u){return typeof u=="function"}e.isFunction=f;function v(...u){return u.length>0&&u.every(f)}e.areFunctions=v;function m(u,s){const l=Math.min(u.length,s.length);for(let a=0;a<l;a++)r(u[a],s[a])}e.validateConstraints=m;function r(u,s){if(c(s)){if(typeof u!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(u instanceof s)return}catch{}if(!k(u)&&u.constructor===s||s.length===1&&s.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function b(u){return u===null?void 0:u}e.withNullAsUndefined=b;function o(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=o}),define(Ce[24],De([1,0,12]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const v=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([m,r])=>{v[m]=r&&typeof r=="object"?t(r):r}),v}e.deepClone=t;function I(f){if(!f||typeof f!="object")return f;const v=[f];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const r in m)if(P.call(m,r)){const b=m[r];typeof b=="object"&&!Object.isFrozen(b)&&!(0,c.isTypedArray)(b)&&v.push(b)}}return f}e.deepFreeze=I;const P=Object.prototype.hasOwnProperty;function C(f,v){return T(f,v,new Set)}e.cloneAndChange=C;function T(f,v,m){if((0,c.isUndefinedOrNull)(f))return f;const r=v(f);if(typeof r<"u")return r;if(Array.isArray(f)){const b=[];for(const o of f)b.push(T(o,v,m));return b}if((0,c.isObject)(f)){if(m.has(f))throw new Error("Cannot clone recursive data-structure");m.add(f);const b={};for(const o in f)P.call(f,o)&&(b[o]=T(f[o],v,m));return m.delete(f),b}return f}function S(f,v,m=!0){return(0,c.isObject)(f)?((0,c.isObject)(v)&&Object.keys(v).forEach(r=>{r in f?m&&((0,c.isObject)(f[r])&&(0,c.isObject)(v[r])?S(f[r],v[r],m):f[r]=v[r]):f[r]=v[r]}),f):v}e.mixin=S;function D(f,v){if(f===v)return!0;if(f==null||v===null||v===void 0||typeof f!=typeof v||typeof f!="object"||Array.isArray(f)!==Array.isArray(v))return!1;let m,r;if(Array.isArray(f)){if(f.length!==v.length)return!1;for(m=0;m<f.length;m++)if(!D(f[m],v[m]))return!1}else{const b=[];for(r in f)b.push(r);b.sort();const o=[];for(r in v)o.push(r);if(o.sort(),!D(b,o))return!1;for(m=0;m<b.length;m++)if(!D(f[b[m]],v[b[m]]))return!1}return!0}e.equals=D;function A(f){const v=new Set;return JSON.stringify(f,(m,r)=>{if((0,c.isObject)(r)||Array.isArray(r)){if(v.has(r))return"[Circular]";v.add(r)}return r})}e.safeStringify=A;function k(f,v){const m=Object.create(null);return!f||!v||Object.keys(v).forEach(b=>{const o=f[b],u=v[b];D(o,u)||(m[b]=u)}),m}e.distinct=k;function E(f,v){const m=v.toLowerCase(),r=Object.keys(f).find(b=>b.toLowerCase()===m);return r?f[r]:f[v]}e.getCaseInsensitive=E;function y(f,v){const m=Object.create(null);for(const[r,b]of Object.entries(f))v(r,b)&&(m[r]=b);return m}e.filter=y;function w(f){let v=[],m=Object.getPrototypeOf(f);for(;Object.prototype!==m;)v=v.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return v}e.getAllPropertyNames=w;function h(f){const v=[];for(const m of w(f))typeof f[m]=="function"&&v.push(m);return v}e.getAllMethodNames=h;function g(f,v){const m=b=>function(){const o=Array.prototype.slice.call(arguments,0);return v(b,o)},r={};for(const b of f)r[b]=m(b);return r}e.createProxyObject=g}),define(Ce[101],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function I(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=I}),define(Ce[31],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return c.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const P=new Uint8Array(16),C=[];for(let T=0;T<256;T++)C.push(T.toString(16).padStart(2,"0"));return function(){I(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,D="";return D+=C[P[S++]],D+=C[P[S++]],D+=C[P[S++]],D+=C[P[S++]],D+="-",D+=C[P[S++]],D+=C[P[S++]],D+="-",D+=C[P[S++]],D+=C[P[S++]],D+="-",D+=C[P[S++]],D+=C[P[S++]],D+="-",D+=C[P[S++]],D+=C[P[S++]],D+=C[P[S++]],D+=C[P[S++]],D+=C[P[S++]],D+=C[P[S++]],D}}()}),define(Ce[102],De([1,0,101]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,c.toUint8)(T);this._defaultValue=S,this._asciiMap=t._createAsciiMap(S),this._map=new Map}static _createAsciiMap(T){const S=new Uint8Array(256);for(let D=0;D<256;D++)S[D]=T;return S}set(T,S){const D=(0,c.toUint8)(S);T>=0&&T<256?this._asciiMap[T]=D:this._map.set(T,D)}get(T){return T>=0&&T<256?this._asciiMap[T]:this._map.get(T)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(I||(I={}));class P{constructor(){this._actual=new t(0)}add(T){this._actual.set(T,1)}has(T){return this._actual.get(T)===1}}e.CharacterSet=P}),define(Ce[49],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(I,P){this.lineNumber=I,this.column=P}with(I=this.lineNumber,P=this.column){return I===this.lineNumber&&P===this.column?this:new c(I,P)}delta(I=0,P=0){return this.with(this.lineNumber+I,this.column+P)}equals(I){return c.equals(this,I)}static equals(I,P){return!I&&!P?!0:!!I&&!!P&&I.lineNumber===P.lineNumber&&I.column===P.column}isBefore(I){return c.isBefore(this,I)}static isBefore(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<P.column}isBeforeOrEqual(I){return c.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<=P.column}static compare(I,P){const C=I.lineNumber|0,T=P.lineNumber|0;if(C===T){const S=I.column|0,D=P.column|0;return S-D}return C-T}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new c(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=c}),define(Ce[35],De([1,0,49]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,C,T,S){P>T||P===T&&C>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=P,this.endColumn=C):(this.startLineNumber=P,this.startColumn=C,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,C){return!(C.lineNumber<P.startLineNumber||C.lineNumber>P.endLineNumber||C.lineNumber===P.startLineNumber&&C.column<P.startColumn||C.lineNumber===P.endLineNumber&&C.column>P.endColumn)}static strictContainsPosition(P,C){return!(C.lineNumber<P.startLineNumber||C.lineNumber>P.endLineNumber||C.lineNumber===P.startLineNumber&&C.column<=P.startColumn||C.lineNumber===P.endLineNumber&&C.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<=P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,C){let T,S,D,A;return C.startLineNumber<P.startLineNumber?(T=C.startLineNumber,S=C.startColumn):C.startLineNumber===P.startLineNumber?(T=C.startLineNumber,S=Math.min(C.startColumn,P.startColumn)):(T=P.startLineNumber,S=P.startColumn),C.endLineNumber>P.endLineNumber?(D=C.endLineNumber,A=C.endColumn):C.endLineNumber===P.endLineNumber?(D=C.endLineNumber,A=Math.max(C.endColumn,P.endColumn)):(D=P.endLineNumber,A=P.endColumn),new t(T,S,D,A)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,C){let T=P.startLineNumber,S=P.startColumn,D=P.endLineNumber,A=P.endColumn;const k=C.startLineNumber,E=C.startColumn,y=C.endLineNumber,w=C.endColumn;return T<k?(T=k,S=E):T===k&&(S=Math.max(S,E)),D>y?(D=y,A=w):D===y&&(A=Math.min(A,w)),T>D||T===D&&S>A?null:new t(T,S,D,A)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,C){return!!P&&!!C&&P.startLineNumber===C.startLineNumber&&P.startColumn===C.startColumn&&P.endLineNumber===C.endLineNumber&&P.endColumn===C.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new c.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new c.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,C){return new t(this.startLineNumber,this.startColumn,P,C)}setStartPosition(P,C){return new t(P,C,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,C=P){return new t(P.lineNumber,P.column,C.lineNumber,C.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<P.startColumn)}static areIntersecting(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<=C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,C){if(P&&C){const D=P.startLineNumber|0,A=C.startLineNumber|0;if(D===A){const k=P.startColumn|0,E=C.startColumn|0;if(k===E){const y=P.endLineNumber|0,w=C.endLineNumber|0;if(y===w){const h=P.endColumn|0,g=C.endColumn|0;return h-g}return y-w}return k-E}return D-A}return(P?1:0)-(C?1:0)}static compareRangesUsingEnds(P,C){return P.endLineNumber===C.endLineNumber?P.endColumn===C.endColumn?P.startLineNumber===C.startLineNumber?P.startColumn-C.startColumn:P.startLineNumber-C.startLineNumber:P.endColumn-C.endColumn:P.endLineNumber-C.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(Ce[146],De([1,0,49,35]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(T,S,D,A){super(T,S,D,A),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=D,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return P.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,T,S):new P(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new P(T,S,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new P(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new P(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new P(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new P(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let D=0,A=T.length;D<A;D++)if(!this.selectionsEqual(T[D],S[D]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,D,A,k){return k===0?new P(T,S,D,A):new P(D,A,T,S)}}e.Selection=P}),define(Ce[147],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[148],De([1,0,102]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends c.CharacterClassifier{constructor(T){super(0);for(let S=0,D=T.length;S<D;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function P(C){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=C(S)),T[S])}e.getMapForWordSeparators=P(C=>new I(C))}),define(Ce[103],De([1,0,61,6,62]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)k.indexOf(y)>=0||(E+="\\"+y);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=P();function C(k){let E=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)E=k;else{let y="g";k.ignoreCase&&(y+="i"),k.multiline&&(y+="m"),k.unicode&&(y+="u"),E=new RegExp(k.source,y)}return E.lastIndex=0,E}e.ensureValidWordDefinition=C;const T=new I.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(k){const E=T.unshift(k);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function D(k,E,y,w,h){if(h||(h=c.Iterable.first(T)),y.length>h.maxLen){let r=k-h.maxLen/2;return r<0?r=0:w+=r,y=y.substring(r,k+h.maxLen/2),D(k,E,y,w,h)}const g=Date.now(),f=k-1-w;let v=-1,m=null;for(let r=1;!(Date.now()-g>=h.timeBudget);r++){const b=f-h.windowSize*r;E.lastIndex=Math.max(0,b);const o=A(E,y,f,v);if(!o&&m||(m=o,b<=0))break;v=b}if(m){const r={word:m[0],startColumn:w+1+m.index,endColumn:w+1+m.index+m[0].length};return E.lastIndex=0,r}return null}e.getWordAtText=D;function A(k,E,y,w){let h;for(;h=k.exec(E);){const g=h.index||0;if(g<=y&&k.lastIndex>=y)return h;if(w>0&&g>w)return null}return null}}),define(Ce[149],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let S=0,D=T.notIn.length;S<D;S++)switch(T.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const D=T.findTokenIndexAtOffset(S-2),A=T.getStandardTokenType(D);return this.isOK(A)}_findNeutralCharacterInRange(T,S){for(let D=T;D<=S;D++){const A=String.fromCharCode(D);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)P(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),P(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),P(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),P(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&P(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function P(C,T,S){C.has(T)?C.get(T).push(S):C.set(T,[S])}}),define(Ce[150],De([1,0,102]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(w,h,g){const f=new Uint8Array(w*h);for(let v=0,m=w*h;v<m;v++)f[v]=g;this._data=f,this.rows=w,this.cols=h}get(w,h){return this._data[w*this.cols+h]}set(w,h,g){this._data[w*this.cols+h]=g}}e.Uint8Matrix=I;class P{constructor(w){let h=0,g=0;for(let v=0,m=w.length;v<m;v++){const[r,b,o]=w[v];b>h&&(h=b),r>g&&(g=r),o>g&&(g=o)}h++,g++;const f=new I(g,h,0);for(let v=0,m=w.length;v<m;v++){const[r,b,o]=w[v];f.set(r,b,o)}this._states=f,this._maxCharCode=h}nextState(w,h){return h<0||h>=this._maxCharCode?0:this._states.get(w,h)}}e.StateMachine=P;let C=null;function T(){return C===null&&(C=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let D=null;function A(){if(D===null){D=new c.CharacterClassifier(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<y.length;h++)D.set(y.charCodeAt(h),1);const w=".,;:";for(let h=0;h<w.length;h++)D.set(w.charCodeAt(h),2)}return D}class k{static _createLink(w,h,g,f,v){let m=v-1;do{const r=h.charCodeAt(m);if(w.get(r)!==2)break;m--}while(m>f);if(f>0){const r=h.charCodeAt(f-1),b=h.charCodeAt(m);(r===40&&b===41||r===91&&b===93||r===123&&b===125)&&m--}return{range:{startLineNumber:g,startColumn:f+1,endLineNumber:g,endColumn:m+2},url:h.substring(f,m+1)}}static computeLinks(w,h=T()){const g=A(),f=[];for(let v=1,m=w.getLineCount();v<=m;v++){const r=w.getLineContent(v),b=r.length;let o=0,u=0,s=0,l=1,a=!1,d=!1,n=!1,i=!1;for(;o<b;){let p=!1;const _=r.charCodeAt(o);if(l===13){let R;switch(_){case 40:a=!0,R=0;break;case 41:R=a?0:1;break;case 91:n=!0,d=!0,R=0;break;case 93:n=!1,R=d?0:1;break;case 123:i=!0,R=0;break;case 125:R=i?0:1;break;case 39:R=s===39?1:0;break;case 34:R=s===34?1:0;break;case 96:R=s===96?1:0;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=n?0:1;break;default:R=g.get(_)}R===1&&(f.push(k._createLink(g,r,v,u,o)),p=!0)}else if(l===12){let R;_===91?(d=!0,R=0):R=g.get(_),R===1?p=!0:l=13}else l=h.nextState(l,_),l===0&&(p=!0);p&&(l=1,a=!1,d=!1,i=!1,u=o+1,s=_),o++}l===13&&f.push(k._createLink(g,r,v,u,b))}return f}}e.LinkComputer=k;function E(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:k.computeLinks(y)}e.computeLinks=E}),define(Ce[104],De([1,0,24]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace),this.bracketPairColorizationOptions=r.bracketPairColorizationOptions}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,r.bracketPairColorizationOptions)}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class A{constructor(r,b){this._findMatchBrand=void 0,this.range=r,this.matches=b}}e.FindMatch=A;var k;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(m){return m&&typeof m.read=="function"}e.isITextSnapshot=E;var y;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(y=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class h{constructor(r,b,o,u,s,l){this.identifier=r,this.range=b,this.text=o,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=s,this._isTracked=l}}e.ValidAnnotatedEditOperation=h;class g{constructor(r,b,o){this.regex=r,this.wordSeparators=b,this.simpleSearch=o}}e.SearchData=g;class f{constructor(r,b,o){this.reverseEdits=r,this.changes=b,this.trimAutoWhitespaceLineNumbers=o}}e.ApplyEditsResult=f;function v(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(Ce[151],De([1,0,17,101]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,t.toUint32)(S);const A=this.values,k=this.prefixSum,E=D.length;return E===0?!1:(this.values=new Uint32Array(A.length+E),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S),S+E),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,D){return S=(0,t.toUint32)(S),D=(0,t.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,t.toUint32)(S),D=(0,t.toUint32)(D);const A=this.values,k=this.prefixSum;if(S>=A.length)return!1;const E=A.length-S;return D>=E&&(D=E),D===0?!1:(this.values=new Uint32Array(A.length-D),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let A=D;A<=S;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let D=0,A=this.values.length-1,k=0,E=0,y=0;for(;D<=A;)if(k=D+(A-D)/2|0,E=this.prefixSum[k],y=E-this.values[k],S<y)A=k-1;else if(S>=E)D=k+1;else break;return new C(k,S-y)}}e.PrefixSumComputer=I;class P{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const D=this._indexBySum[S],A=D>0?this._prefixSum[D-1]:0;return new C(D,S-A)}removeValues(S,D){this._values.splice(S,D),this._invalidate(S)}insertValues(S,D){this._values=(0,c.arrayInsert)(this._values,S,D),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,D=this._values.length;S<D;S++){const A=this._values[S],k=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=k+A;for(let E=0;E<A;E++)this._indexBySum[k+E]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,D){this._values[S]!==D&&(this._values[S]=D,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=P;class C{constructor(S,D){this.index=S,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=C}),define(Ce[152],De([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(Ce[153],De([1,0,152]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,P=I*24,C=P*7,T=P*30,S=P*365;function D(k,E,y){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,c.localize)(0,null,D(new Date().getTime()+w*1e3,!1));if(w<30)return(0,c.localize)(1,null);let h;return w<t?(h=w,E?h===1?y?(0,c.localize)(2,null,h):(0,c.localize)(3,null,h):y?(0,c.localize)(4,null,h):(0,c.localize)(5,null,h):h===1?y?(0,c.localize)(6,null,h):(0,c.localize)(7,null,h):y?(0,c.localize)(8,null,h):(0,c.localize)(9,null,h)):w<I?(h=Math.floor(w/t),E?h===1?y?(0,c.localize)(10,null,h):(0,c.localize)(11,null,h):y?(0,c.localize)(12,null,h):(0,c.localize)(13,null,h):h===1?y?(0,c.localize)(14,null,h):(0,c.localize)(15,null,h):y?(0,c.localize)(16,null,h):(0,c.localize)(17,null,h)):w<P?(h=Math.floor(w/I),E?h===1?y?(0,c.localize)(18,null,h):(0,c.localize)(19,null,h):y?(0,c.localize)(20,null,h):(0,c.localize)(21,null,h):h===1?y?(0,c.localize)(22,null,h):(0,c.localize)(23,null,h):y?(0,c.localize)(24,null,h):(0,c.localize)(25,null,h)):w<C?(h=Math.floor(w/P),E?h===1?(0,c.localize)(26,null,h):(0,c.localize)(27,null,h):h===1?(0,c.localize)(28,null,h):(0,c.localize)(29,null,h)):w<T?(h=Math.floor(w/C),E?h===1?y?(0,c.localize)(30,null,h):(0,c.localize)(31,null,h):y?(0,c.localize)(32,null,h):(0,c.localize)(33,null,h):h===1?y?(0,c.localize)(34,null,h):(0,c.localize)(35,null,h):y?(0,c.localize)(36,null,h):(0,c.localize)(37,null,h)):w<S?(h=Math.floor(w/T),E?h===1?y?(0,c.localize)(38,null,h):(0,c.localize)(39,null,h):y?(0,c.localize)(40,null,h):(0,c.localize)(41,null,h):h===1?y?(0,c.localize)(42,null,h):(0,c.localize)(43,null,h):y?(0,c.localize)(44,null,h):(0,c.localize)(45,null,h)):(h=Math.floor(w/S),E?h===1?y?(0,c.localize)(46,null,h):(0,c.localize)(47,null,h):y?(0,c.localize)(48,null,h):(0,c.localize)(49,null,h):h===1?y?(0,c.localize)(50,null,h):(0,c.localize)(51,null,h):y?(0,c.localize)(52,null,h):(0,c.localize)(53,null,h))}e.fromNow=D;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(Ce[154],De([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(Ce[50],De([1,0,17,12,154]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,E){return E&&(k.stack||k.stacktrace)?I.localize(0,null,T(k),C(k.stack)||C(k.stacktrace)):T(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function T(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function S(k=null,E=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const y=c.coalesce(k),w=S(y[0],E);return y.length>1?I.localize(4,null,w,y.length):w}if(t.isString(k))return k;if(k.detail){const y=k.detail;if(y.error)return P(y.error,E);if(y.exception)return P(y.exception,E)}return k.stack?P(k,E):k.message?k.message:I.localize(5,null)}e.toErrorMessage=S;function D(k){const E=k;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=D;function A(k,E){let y;return typeof k=="string"?y=new Error(k):y=k,y.actions=E,y}e.createErrorWithActions=A}),define(Ce[155],De([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(Ce[10],De([1,0,155]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,P=!1,C=!1,T=!1,S=!1,D=!1,A=!1,k=!1,E=!1,y,w=e.LANGUAGE_DEFAULT,h,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const v=typeof f?.versions?.electron=="string",m=v&&f?.type==="renderer";if(typeof navigator=="object"&&!m)g=navigator.userAgent,t=g.indexOf("Windows")>=0,I=g.indexOf("Macintosh")>=0,A=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,y=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,w=y;else if(typeof f=="object"){t=f.platform==="win32",I=f.platform==="darwin",P=f.platform==="linux",C=P&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,D=v,k=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const i=JSON.parse(n),p=i.availableLanguages["*"];y=i.locale,w=p||e.LANGUAGE_DEFAULT,h=i._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var r;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(r=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let o=0;I?o=1:t?o=3:P&&(o=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=P,e.isLinuxSnap=C,e.isNative=T,e.isElectron=D,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isMobile=E,e.isCI=k,e.platform=o,e.userAgent=g,e.language=w;var u;(function(n){function i(){return e.language}n.value=i;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function _(){return e.language==="en"}n.isDefault=_})(u=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let _=0,R=n.length;_<R;_++){const M=n[_];if(M.id===p.data.vscodeScheduleAsyncWork){n.splice(_,1),M.callback();return}}});let i=0;return p=>{const _=++i;n.push({id:_,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return n=>setTimeout(n)})();var s;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||A?2:t?1:3;let l=!0,a=!1;function d(){if(!a){a=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=d,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[36],De([1,0,10]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const I=c.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Ce[9],De([1,0,36]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,P=90,C=122,T=46,S=47,D=92,A=58,k=63;class E extends Error{constructor(r,b,o){let u;typeof b=="string"&&b.indexOf("not ")===0?(u="must not be",b=b.replace(/^not /,"")):u="must be";const s=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${s} ${u} of type ${b}`;l+=`. Received type ${typeof o}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function y(m,r){if(typeof m!="string")throw new E(r,"string",m)}function w(m){return m===S||m===D}function h(m){return m===S}function g(m){return m>=t&&m<=P||m>=I&&m<=C}function f(m,r,b,o){let u="",s=0,l=-1,a=0,d=0;for(let n=0;n<=m.length;++n){if(n<m.length)d=m.charCodeAt(n);else{if(o(d))break;d=S}if(o(d)){if(!(l===n-1||a===1))if(a===2){if(u.length<2||s!==2||u.charCodeAt(u.length-1)!==T||u.charCodeAt(u.length-2)!==T){if(u.length>2){const i=u.lastIndexOf(b);i===-1?(u="",s=0):(u=u.slice(0,i),s=u.length-1-u.lastIndexOf(b)),l=n,a=0;continue}else if(u.length!==0){u="",s=0,l=n,a=0;continue}}r&&(u+=u.length>0?`${b}..`:"..",s=2)}else u.length>0?u+=`${b}${m.slice(l+1,n)}`:u=m.slice(l+1,n),s=n-l-1;l=n,a=0}else d===T&&a!==-1?++a:a=-1}return u}function v(m,r){if(r===null||typeof r!="object")throw new E("pathObject","Object",r);const b=r.dir||r.root,o=r.base||`${r.name||""}${r.ext||""}`;return b?b===r.root?`${b}${o}`:`${b}${m}${o}`:o}e.win32={resolve(...m){let r="",b="",o=!1;for(let u=m.length-1;u>=-1;u--){let s;if(u>=0){if(s=m[u],y(s,"path"),s.length===0)continue}else r.length===0?s=c.cwd():(s=c.env[`=${r}`]||c.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==r.toLowerCase()&&s.charCodeAt(2)===D)&&(s=`${r}\\`));const l=s.length;let a=0,d="",n=!1;const i=s.charCodeAt(0);if(l===1)w(i)&&(a=1,n=!0);else if(w(i))if(n=!0,w(s.charCodeAt(1))){let p=2,_=p;for(;p<l&&!w(s.charCodeAt(p));)p++;if(p<l&&p!==_){const R=s.slice(_,p);for(_=p;p<l&&w(s.charCodeAt(p));)p++;if(p<l&&p!==_){for(_=p;p<l&&!w(s.charCodeAt(p));)p++;(p===l||p!==_)&&(d=`\\\\${R}\\${s.slice(_,p)}`,a=p)}}}else a=1;else g(i)&&s.charCodeAt(1)===A&&(d=s.slice(0,2),a=2,l>2&&w(s.charCodeAt(2))&&(n=!0,a=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(o){if(r.length>0)break}else if(b=`${s.slice(a)}\\${b}`,o=n,n&&r.length>0)break}return b=f(b,!o,"\\",w),o?`${r}\\${b}`:`${r}${b}`||"."},normalize(m){y(m,"path");const r=m.length;if(r===0)return".";let b=0,o,u=!1;const s=m.charCodeAt(0);if(r===1)return h(s)?"\\":m;if(w(s))if(u=!0,w(m.charCodeAt(1))){let a=2,d=a;for(;a<r&&!w(m.charCodeAt(a));)a++;if(a<r&&a!==d){const n=m.slice(d,a);for(d=a;a<r&&w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&!w(m.charCodeAt(a));)a++;if(a===r)return`\\\\${n}\\${m.slice(d)}\\`;a!==d&&(o=`\\\\${n}\\${m.slice(d,a)}`,b=a)}}}else b=1;else g(s)&&m.charCodeAt(1)===A&&(o=m.slice(0,2),b=2,r>2&&w(m.charCodeAt(2))&&(u=!0,b=3));let l=b<r?f(m.slice(b),!u,"\\",w):"";return l.length===0&&!u&&(l="."),l.length>0&&w(m.charCodeAt(r-1))&&(l+="\\"),o===void 0?u?`\\${l}`:l:u?`${o}\\${l}`:`${o}${l}`},isAbsolute(m){y(m,"path");const r=m.length;if(r===0)return!1;const b=m.charCodeAt(0);return w(b)||r>2&&g(b)&&m.charCodeAt(1)===A&&w(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let r,b;for(let s=0;s<m.length;++s){const l=m[s];y(l,"path"),l.length>0&&(r===void 0?r=b=l:r+=`\\${l}`)}if(r===void 0)return".";let o=!0,u=0;if(typeof b=="string"&&w(b.charCodeAt(0))){++u;const s=b.length;s>1&&w(b.charCodeAt(1))&&(++u,s>2&&(w(b.charCodeAt(2))?++u:o=!1))}if(o){for(;u<r.length&&w(r.charCodeAt(u));)u++;u>=2&&(r=`\\${r.slice(u)}`)}return e.win32.normalize(r)},relative(m,r){if(y(m,"from"),y(r,"to"),m===r)return"";const b=e.win32.resolve(m),o=e.win32.resolve(r);if(b===o||(m=b.toLowerCase(),r=o.toLowerCase(),m===r))return"";let u=0;for(;u<m.length&&m.charCodeAt(u)===D;)u++;let s=m.length;for(;s-1>u&&m.charCodeAt(s-1)===D;)s--;const l=s-u;let a=0;for(;a<r.length&&r.charCodeAt(a)===D;)a++;let d=r.length;for(;d-1>a&&r.charCodeAt(d-1)===D;)d--;const n=d-a,i=l<n?l:n;let p=-1,_=0;for(;_<i;_++){const M=m.charCodeAt(u+_);if(M!==r.charCodeAt(a+_))break;M===D&&(p=_)}if(_!==i){if(p===-1)return o}else{if(n>i){if(r.charCodeAt(a+_)===D)return o.slice(a+_+1);if(_===2)return o.slice(a+_)}l>i&&(m.charCodeAt(u+_)===D?p=_:_===2&&(p=3)),p===-1&&(p=0)}let R="";for(_=u+p+1;_<=s;++_)(_===s||m.charCodeAt(_)===D)&&(R+=R.length===0?"..":"\\..");return a+=p,R.length>0?`${R}${o.slice(a,d)}`:(o.charCodeAt(a)===D&&++a,o.slice(a,d))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const r=e.win32.resolve(m);if(r.length<=2)return m;if(r.charCodeAt(0)===D){if(r.charCodeAt(1)===D){const b=r.charCodeAt(2);if(b!==k&&b!==T)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===D)return`\\\\?\\${r}`;return m},dirname(m){y(m,"path");const r=m.length;if(r===0)return".";let b=-1,o=0;const u=m.charCodeAt(0);if(r===1)return w(u)?m:".";if(w(u)){if(b=o=1,w(m.charCodeAt(1))){let a=2,d=a;for(;a<r&&!w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&!w(m.charCodeAt(a));)a++;if(a===r)return m;a!==d&&(b=o=a+1)}}}}else g(u)&&m.charCodeAt(1)===A&&(b=r>2&&w(m.charCodeAt(2))?3:2,o=b);let s=-1,l=!0;for(let a=r-1;a>=o;--a)if(w(m.charCodeAt(a))){if(!l){s=a;break}}else l=!1;if(s===-1){if(b===-1)return".";s=b}return m.slice(0,s)},basename(m,r){r!==void 0&&y(r,"ext"),y(m,"path");let b=0,o=-1,u=!0,s;if(m.length>=2&&g(m.charCodeAt(0))&&m.charCodeAt(1)===A&&(b=2),r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let l=r.length-1,a=-1;for(s=m.length-1;s>=b;--s){const d=m.charCodeAt(s);if(w(d)){if(!u){b=s+1;break}}else a===-1&&(u=!1,a=s+1),l>=0&&(d===r.charCodeAt(l)?--l===-1&&(o=s):(l=-1,o=a))}return b===o?o=a:o===-1&&(o=m.length),m.slice(b,o)}for(s=m.length-1;s>=b;--s)if(w(m.charCodeAt(s))){if(!u){b=s+1;break}}else o===-1&&(u=!1,o=s+1);return o===-1?"":m.slice(b,o)},extname(m){y(m,"path");let r=0,b=-1,o=0,u=-1,s=!0,l=0;m.length>=2&&m.charCodeAt(1)===A&&g(m.charCodeAt(0))&&(r=o=2);for(let a=m.length-1;a>=r;--a){const d=m.charCodeAt(a);if(w(d)){if(!s){o=a+1;break}continue}u===-1&&(s=!1,u=a+1),d===T?b===-1?b=a:l!==1&&(l=1):b!==-1&&(l=-1)}return b===-1||u===-1||l===0||l===1&&b===u-1&&b===o+1?"":m.slice(b,u)},format:v.bind(null,"\\"),parse(m){y(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const b=m.length;let o=0,u=m.charCodeAt(0);if(b===1)return w(u)?(r.root=r.dir=m,r):(r.base=r.name=m,r);if(w(u)){if(o=1,w(m.charCodeAt(1))){let p=2,_=p;for(;p<b&&!w(m.charCodeAt(p));)p++;if(p<b&&p!==_){for(_=p;p<b&&w(m.charCodeAt(p));)p++;if(p<b&&p!==_){for(_=p;p<b&&!w(m.charCodeAt(p));)p++;p===b?o=p:p!==_&&(o=p+1)}}}}else if(g(u)&&m.charCodeAt(1)===A){if(b<=2)return r.root=r.dir=m,r;if(o=2,w(m.charCodeAt(2))){if(b===3)return r.root=r.dir=m,r;o=3}}o>0&&(r.root=m.slice(0,o));let s=-1,l=o,a=-1,d=!0,n=m.length-1,i=0;for(;n>=o;--n){if(u=m.charCodeAt(n),w(u)){if(!d){l=n+1;break}continue}a===-1&&(d=!1,a=n+1),u===T?s===-1?s=n:i!==1&&(i=1):s!==-1&&(i=-1)}return a!==-1&&(s===-1||i===0||i===1&&s===a-1&&s===l+1?r.base=r.name=m.slice(l,a):(r.name=m.slice(l,s),r.base=m.slice(l,a),r.ext=m.slice(s,a))),l>0&&l!==o?r.dir=m.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let r="",b=!1;for(let o=m.length-1;o>=-1&&!b;o--){const u=o>=0?m[o]:c.cwd();y(u,"path"),u.length!==0&&(r=`${u}/${r}`,b=u.charCodeAt(0)===S)}return r=f(r,!b,"/",h),b?`/${r}`:r.length>0?r:"."},normalize(m){if(y(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===S,b=m.charCodeAt(m.length-1)===S;return m=f(m,!r,"/",h),m.length===0?r?"/":b?"./":".":(b&&(m+="/"),r?`/${m}`:m)},isAbsolute(m){return y(m,"path"),m.length>0&&m.charCodeAt(0)===S},join(...m){if(m.length===0)return".";let r;for(let b=0;b<m.length;++b){const o=m[b];y(o,"path"),o.length>0&&(r===void 0?r=o:r+=`/${o}`)}return r===void 0?".":e.posix.normalize(r)},relative(m,r){if(y(m,"from"),y(r,"to"),m===r||(m=e.posix.resolve(m),r=e.posix.resolve(r),m===r))return"";const b=1,o=m.length,u=o-b,s=1,l=r.length-s,a=u<l?u:l;let d=-1,n=0;for(;n<a;n++){const p=m.charCodeAt(b+n);if(p!==r.charCodeAt(s+n))break;p===S&&(d=n)}if(n===a)if(l>a){if(r.charCodeAt(s+n)===S)return r.slice(s+n+1);if(n===0)return r.slice(s+n)}else u>a&&(m.charCodeAt(b+n)===S?d=n:n===0&&(d=0));let i="";for(n=b+d+1;n<=o;++n)(n===o||m.charCodeAt(n)===S)&&(i+=i.length===0?"..":"/..");return`${i}${r.slice(s+d)}`},toNamespacedPath(m){return m},dirname(m){if(y(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===S;let b=-1,o=!0;for(let u=m.length-1;u>=1;--u)if(m.charCodeAt(u)===S){if(!o){b=u;break}}else o=!1;return b===-1?r?"/":".":r&&b===1?"//":m.slice(0,b)},basename(m,r){r!==void 0&&y(r,"ext"),y(m,"path");let b=0,o=-1,u=!0,s;if(r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let l=r.length-1,a=-1;for(s=m.length-1;s>=0;--s){const d=m.charCodeAt(s);if(d===S){if(!u){b=s+1;break}}else a===-1&&(u=!1,a=s+1),l>=0&&(d===r.charCodeAt(l)?--l===-1&&(o=s):(l=-1,o=a))}return b===o?o=a:o===-1&&(o=m.length),m.slice(b,o)}for(s=m.length-1;s>=0;--s)if(m.charCodeAt(s)===S){if(!u){b=s+1;break}}else o===-1&&(u=!1,o=s+1);return o===-1?"":m.slice(b,o)},extname(m){y(m,"path");let r=-1,b=0,o=-1,u=!0,s=0;for(let l=m.length-1;l>=0;--l){const a=m.charCodeAt(l);if(a===S){if(!u){b=l+1;break}continue}o===-1&&(u=!1,o=l+1),a===T?r===-1?r=l:s!==1&&(s=1):r!==-1&&(s=-1)}return r===-1||o===-1||s===0||s===1&&r===o-1&&r===b+1?"":m.slice(r,o)},format:v.bind(null,"/"),parse(m){y(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const b=m.charCodeAt(0)===S;let o;b?(r.root="/",o=1):o=0;let u=-1,s=0,l=-1,a=!0,d=m.length-1,n=0;for(;d>=o;--d){const i=m.charCodeAt(d);if(i===S){if(!a){s=d+1;break}continue}l===-1&&(a=!1,l=d+1),i===T?u===-1?u=d:n!==1&&(n=1):u!==-1&&(n=-1)}if(l!==-1){const i=s===0&&b?1:s;u===-1||n===0||n===1&&u===l-1&&u===s+1?r.base=r.name=m.slice(i,l):(r.name=m.slice(i,u),r.base=m.slice(i,l),r.ext=m.slice(u,l))}return s>0?r.dir=m.slice(0,s-1):b&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=c.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=c.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=c.platform==="win32"?e.win32.join:e.posix.join,e.resolve=c.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=c.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=c.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=c.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=c.platform==="win32"?e.win32.extname:e.posix.extname,e.format=c.platform==="win32"?e.win32.format:e.posix.format,e.parse=c.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=c.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=c.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=c.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ce[105],De([1,0,9]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const k=(0,c.extname)(A),E=t[k.toLowerCase()];return E!==void 0?E:C(A)}e.getMediaOrTextMime=P;function C(A){const k=(0,c.extname)(A);return I[k.toLowerCase()]}e.getMediaMime=C;function T(A){for(const k in I)if(I[k]===A)return k}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function D(A,k){const E=S.exec(A);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:k?void 0:A}e.normalizeMimeType=D}),define(Ce[106],De([1,0,10]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(T,...S){const D=S.reduce((E,y)=>(E[y]=!0,E),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(E=>!D[E]).forEach(E=>{for(let y=0;y<A.length;y++)if(E.search(A[y])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=P;function C(T){!T||(delete T.DEBUG,c.isMacintosh&&delete T.DYLD_LIBRARY_PATH,c.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(Ce[51],De([1,0,10]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class I{static create(C=!0){return new I(C)}constructor(C){this._highResolution=t&&C,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?c.globals.performance.now():Date.now()}}e.StopWatch=I}),define(Ce[4],De([1,0,11,60,6,62,51]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var D;(function(d){d.None=()=>I.Disposable.None;function n(fe){if(S){const{onListenerDidAdd:be}=fe,ke=w.create();let Re=0;fe.onListenerDidAdd=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function i(fe){return(be,ke=null,Re)=>{let ze=!1,oe;return oe=fe(le=>{if(!ze)return oe?oe.dispose():ze=!0,be.call(ke,le)},null,Re),ze&&oe.dispose(),oe}}d.once=i;function p(fe,be,ke){return L((Re,ze=null,oe)=>fe(le=>Re.call(ze,be(le)),null,oe),ke)}d.map=p;function _(fe,be,ke){return L((Re,ze=null,oe)=>fe(le=>{be(le),Re.call(ze,le)},null,oe),ke)}d.forEach=_;function R(fe,be,ke){return L((Re,ze=null,oe)=>fe(le=>be(le)&&Re.call(ze,le),null,oe),ke)}d.filter=R;function M(fe){return fe}d.signal=M;function H(...fe){return(be,ke=null,Re)=>(0,I.combinedDisposable)(...fe.map(ze=>ze(oe=>be.call(ke,oe),null,Re)))}d.any=H;function $(fe,be,ke,Re){let ze=ke;return p(fe,oe=>(ze=be(ze,oe),ze),Re)}d.reduce=$;function L(fe,be){let ke;const Re={onFirstListenerAdd(){ke=fe(ze.fire,ze)},onLastListenerRemove(){ke?.dispose()}};be||n(Re);const ze=new g(Re);return be?.add(ze),ze.event}function B(fe,be,ke=100,Re=!1,ze,oe){let le,ge,Z,ae=0;const ne={leakWarningThreshold:ze,onFirstListenerAdd(){le=fe(N=>{ae++,ge=be(ge,N),Re&&!Z&&(ie.fire(ge),ge=void 0),clearTimeout(Z),Z=setTimeout(()=>{const j=ge;ge=void 0,Z=void 0,(!Re||ae>1)&&ie.fire(j),ae=0},ke)})},onLastListenerRemove(){le.dispose()}};oe||n(ne);const ie=new g(ne);return oe?.add(ie),ie.event}d.debounce=B;function O(fe,be=(Re,ze)=>Re===ze,ke){let Re=!0,ze;return R(fe,oe=>{const le=Re||!be(oe,ze);return Re=!1,ze=oe,le},ke)}d.latch=O;function z(fe,be,ke){return[d.filter(fe,be,ke),d.filter(fe,Re=>!be(Re),ke)]}d.split=z;function U(fe,be=!1,ke=[]){let Re=ke.slice(),ze=fe(ge=>{Re?Re.push(ge):le.fire(ge)});const oe=()=>{Re?.forEach(ge=>le.fire(ge)),Re=null},le=new g({onFirstListenerAdd(){ze||(ze=fe(ge=>le.fire(ge)))},onFirstListenerDidAdd(){Re&&(be?setTimeout(oe):oe())},onLastListenerRemove(){ze&&ze.dispose(),ze=null}});return le.event}d.buffer=U;class F{constructor(be){this.event=be,this.disposables=new I.DisposableStore}map(be){return new F(p(this.event,be,this.disposables))}forEach(be){return new F(_(this.event,be,this.disposables))}filter(be){return new F(R(this.event,be,this.disposables))}reduce(be,ke){return new F($(this.event,be,ke,this.disposables))}latch(){return new F(O(this.event,void 0,this.disposables))}debounce(be,ke=100,Re=!1,ze){return new F(B(this.event,be,ke,Re,ze,this.disposables))}on(be,ke,Re){return this.event(be,ke,Re)}once(be,ke,Re){return i(this.event)(be,ke,Re)}dispose(){this.disposables.dispose()}}function V(fe){return new F(fe)}d.chain=V;function x(fe,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>fe.on(be,Re),oe=()=>fe.removeListener(be,Re),le=new g({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}d.fromNodeEventEmitter=x;function Q(fe,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>fe.addEventListener(be,Re),oe=()=>fe.removeEventListener(be,Re),le=new g({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}d.fromDOMEventEmitter=Q;function K(fe){return new Promise(be=>i(fe)(be))}d.toPromise=K;function ue(fe,be){return be(void 0),fe(ke=>be(ke))}d.runAndSubscribe=ue;function te(fe,be){let ke=null;function Re(oe){ke?.dispose(),ke=new I.DisposableStore,be(oe,ke)}Re(void 0);const ze=fe(oe=>Re(oe));return(0,I.toDisposable)(()=>{ze.dispose(),ke?.dispose()})}d.runAndSubscribeWithStore=te;class he{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Re={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||n(Re),this.emitter=new g(Re),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Y(fe,be){return new he(fe,be).emitter.event}d.fromObservable=Y})(D=e.Event||(e.Event={}));class A{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${A._idPool++}`,A.all.add(this)}start(n){this._stopWatch=new C.StopWatch(!0),this.listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=A,A.all=new Set,A._idPool=0;let k=-1;function E(d){const n=k;return k=d,{dispose(){k=n}}}e.setGlobalLeakWarningThreshold=E;class y{constructor(n,i=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,i){let p=k;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||i<p)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let R,M=0;for(const[H,$]of this._stacks)(!R||M<$)&&(R=H,M=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${M}):`),console.warn(R)}return()=>{const R=this._stacks.get(n.value)||0;this._stacks.set(n.value,R-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(n,i,p){this.callback=n,this.callbackThis=i,this.stack=p,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=k>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(T){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const i of n)i.subscription.isset()&&(i.subscription.unset(),i.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,i,p)=>{this._listeners||(this._listeners=new P.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,M;this._leakageMon&&this._listeners.size>=30&&(M=w.create(),R=this._leakageMon.check(M,this._listeners.size+1)),T&&(M=M??w.create());const H=new h(n,i,M),$=this._listeners.push(H);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,i);const L=H.subscription.set(()=>{R?.(),this._disposed||($(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return p instanceof I.DisposableStore?p.add(L):Array.isArray(p)&&p.push(L),L}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const i of this._listeners)this._deliveryQueue.push(this,i,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class f{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(n,i,p){this._queue.push(new m(n,i,p))}clear(n){const i=new P.LinkedList;for(const p of this._queue)p.emitter!==n&&i.push(p);this._queue=i}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(i){(0,c.onUnexpectedError)(i)}}}}e.EventDeliveryQueue=f;class v extends f{clear(n){this._queue.clear()}}class m{constructor(n,i,p){this.emitter=n,this.listener=i,this.event=p}}class r extends g{async fireAsync(n,i,p){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,n]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[_,R]=this._asyncDeliveryQueue.shift(),M=[],H={...R,token:i,waitUntil:$=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");p&&($=p($,_.callback)),M.push($)}};try{_.invoke(H)}catch($){(0,c.onUnexpectedError)($);continue}Object.freeze(M),await Promise.allSettled(M).then($=>{for(const L of $)L.status==="rejected"&&(0,c.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=r;class b extends g{constructor(n){super(n),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=b;class o extends b{constructor(n){super(n),this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=o;class u extends g{constructor(n){super(n),this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){!this.hasListeners()||(this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const i={event:n,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const p=()=>{this.hasListeners&&this.unhook(i);const _=this.events.indexOf(i);this.events.splice(_,1)};return(0,I.toDisposable)((0,t.once)(p))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(i=>this.emitter.fire(i))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class l{constructor(){this.buffers=[]}wrapEvent(n){return(i,p,_)=>n(R=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>i.call(p,R)):i.call(p,R)},void 0,_)}bufferEvents(n){const i=[];this.buffers.push(i);const p=n();return this.buffers.pop(),i.forEach(_=>_()),p}}e.EventBufferer=l;class a{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=I.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(Ce[21],De([1,0,4]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const D=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(D)}}});var I;(function(T){function S(D){return D===T.None||D===T.Cancelled||D instanceof P?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new c.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C}),define(Ce[156],De([1,0,21]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new c.CancellationTokenSource,S=this.task(T.token);return this.result={promise:S,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;class I{constructor(T){this.fn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const S=JSON.stringify(T);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(T)),this.lastCache}}e.LRUCachedFunction=I;class P{get cachedValues(){return this._map}constructor(T){this.fn=T,this._map=new Map}get(T){if(this._map.has(T))return this._map.get(T);const S=this.fn(T);return this._map.set(T,S),S}}e.CachedFunction=P}),define(Ce[157],De([1,0,4,6]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const I=C=>({onDidChange:c.Event.None,value:C});e.staticObservableValue=I;class P extends t.Disposable{get value(){return this._value}set value(T){T!==this._value&&(this._value=T,this.changeEmitter.fire(T))}constructor(T){super(),this._value=T,this.changeEmitter=this._register(new c.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=P}),define(Ce[8],De([1,0,156,79]),function(J,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(me){return!me||typeof me!="string"?!0:me.trim().length===0}e.isFalsyOrWhitespace=P;const C=/{(\d+)}/g;function T(me,...Ae){return Ae.length===0?me:me.replace(C,function(Oe,Me){const Ke=parseInt(Me,10);return isNaN(Ke)||Ke<0||Ke>=Ae.length?Oe:Ae[Ke]})}e.format=T;const S=/{([^}]+)}/g;function D(me,Ae){return me.replace(S,(Oe,Me)=>Ae[Me]??Oe)}e.format2=D;function A(me){return me.replace(/[<>&]/g,function(Ae){switch(Ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ae}})}e.escape=A;function k(me){return me.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function E(me,Ae){let Oe=0;const Me=Ae.charCodeAt(0);for(let Ke=me.length-1;Ke>=0;Ke--)me.charCodeAt(Ke)===Me&&Oe++;return Oe}e.count=E;function y(me,Ae,Oe="\u2026"){return me.length<=Ae?me:`${me.substr(0,Ae)}${Oe}`}e.truncate=y;function w(me,Ae=" "){const Oe=h(me,Ae);return g(Oe,Ae)}e.trim=w;function h(me,Ae){if(!me||!Ae)return me;const Oe=Ae.length;if(Oe===0||me.length===0)return me;let Me=0;for(;me.indexOf(Ae,Me)===Me;)Me=Me+Oe;return me.substring(Me)}e.ltrim=h;function g(me,Ae){if(!me||!Ae)return me;const Oe=Ae.length,Me=me.length;if(Oe===0||Me===0)return me;let Ke=Me,Je=-1;for(;Je=me.lastIndexOf(Ae,Ke-1),!(Je===-1||Je+Oe!==Ke);){if(Je===0)return"";Ke=Je}return me.substring(0,Ke)}e.rtrim=g;function f(me){return me.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function v(me){return me.replace(/\*/g,"")}e.stripWildcards=v;function m(me,Ae,Oe={}){if(!me)throw new Error("Cannot create regex from empty string");Ae||(me=k(me)),Oe.wholeWord&&(/\B/.test(me.charAt(0))||(me="\\b"+me),/\B/.test(me.charAt(me.length-1))||(me=me+"\\b"));let Me="";return Oe.global&&(Me+="g"),Oe.matchCase||(Me+="i"),Oe.multiline&&(Me+="m"),Oe.unicode&&(Me+="u"),new RegExp(me,Me)}e.createRegExp=m;function r(me){return me.source==="^"||me.source==="^$"||me.source==="$"||me.source==="^\\s*$"?!1:!!(me.exec("")&&me.lastIndex===0)}e.regExpLeadsToEndlessLoop=r;function b(me){return!!me.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function o(me){return(me.global?"g":"")+(me.ignoreCase?"i":"")+(me.multiline?"m":"")+(me.unicode?"u":"")}e.regExpFlags=o;function u(me){return me.split(/\r\n|\r|\n/)}e.splitLines=u;function s(me){for(let Ae=0,Oe=me.length;Ae<Oe;Ae++){const Me=me.charCodeAt(Ae);if(Me!==32&&Me!==9)return Ae}return-1}e.firstNonWhitespaceIndex=s;function l(me,Ae=0,Oe=me.length){for(let Me=Ae;Me<Oe;Me++){const Ke=me.charCodeAt(Me);if(Ke!==32&&Ke!==9)return me.substring(Ae,Me)}return me.substring(Ae,Oe)}e.getLeadingWhitespace=l;function a(me,Ae=me.length-1){for(let Oe=Ae;Oe>=0;Oe--){const Me=me.charCodeAt(Oe);if(Me!==32&&Me!==9)return Oe}return-1}e.lastNonWhitespaceIndex=a;function d(me,Ae,Oe){const Me=[];let Ke=0;for(const Je of me.matchAll(Ae)){if(Me.push(me.slice(Ke,Je.index)),Je.index===void 0)throw new Error("match.index should be defined");Ke=Je.index+Je[0].length,Me.push(Oe(Je[0],...Je.slice(1),Je.index,me,Je.groups))}return Me.push(me.slice(Ke)),Promise.all(Me).then(Je=>Je.join(""))}e.replaceAsync=d;function n(me,Ae){return me<Ae?-1:me>Ae?1:0}e.compare=n;function i(me,Ae,Oe=0,Me=me.length,Ke=0,Je=Ae.length){for(;Oe<Me&&Ke<Je;Oe++,Ke++){const nt=me.charCodeAt(Oe),it=Ae.charCodeAt(Ke);if(nt<it)return-1;if(nt>it)return 1}const st=Me-Oe,vt=Je-Ke;return st<vt?-1:st>vt?1:0}e.compareSubstring=i;function p(me,Ae){return _(me,Ae,0,me.length,0,Ae.length)}e.compareIgnoreCase=p;function _(me,Ae,Oe=0,Me=me.length,Ke=0,Je=Ae.length){for(;Oe<Me&&Ke<Je;Oe++,Ke++){let nt=me.charCodeAt(Oe),it=Ae.charCodeAt(Ke);if(nt===it)continue;if(nt>=128||it>=128)return i(me.toLowerCase(),Ae.toLowerCase(),Oe,Me,Ke,Je);M(nt)&&(nt-=32),M(it)&&(it-=32);const bt=nt-it;if(bt!==0)return bt}const st=Me-Oe,vt=Je-Ke;return st<vt?-1:st>vt?1:0}e.compareSubstringIgnoreCase=_;function R(me){return me>=48&&me<=57}e.isAsciiDigit=R;function M(me){return me>=97&&me<=122}e.isLowerAsciiLetter=M;function H(me){return me>=65&&me<=90}e.isUpperAsciiLetter=H;function $(me,Ae){return me.length===Ae.length&&_(me,Ae)===0}e.equalsIgnoreCase=$;function L(me,Ae){const Oe=Ae.length;return Ae.length>me.length?!1:_(me,Ae,0,Oe)===0}e.startsWithIgnoreCase=L;function B(me,Ae){const Oe=Math.min(me.length,Ae.length);let Me;for(Me=0;Me<Oe;Me++)if(me.charCodeAt(Me)!==Ae.charCodeAt(Me))return Me;return Oe}e.commonPrefixLength=B;function O(me,Ae){const Oe=Math.min(me.length,Ae.length);let Me;const Ke=me.length-1,Je=Ae.length-1;for(Me=0;Me<Oe;Me++)if(me.charCodeAt(Ke-Me)!==Ae.charCodeAt(Je-Me))return Me;return Oe}e.commonSuffixLength=O;function z(me){return 55296<=me&&me<=56319}e.isHighSurrogate=z;function U(me){return 56320<=me&&me<=57343}e.isLowSurrogate=U;function F(me,Ae){return(me-55296<<10)+(Ae-56320)+65536}e.computeCodePoint=F;function V(me,Ae,Oe){const Me=me.charCodeAt(Oe);if(z(Me)&&Oe+1<Ae){const Ke=me.charCodeAt(Oe+1);if(U(Ke))return F(Me,Ke)}return Me}e.getNextCodePoint=V;function x(me,Ae){const Oe=me.charCodeAt(Ae-1);if(U(Oe)&&Ae>1){const Me=me.charCodeAt(Ae-2);if(z(Me))return F(Me,Oe)}return Oe}class Q{get offset(){return this._offset}constructor(Ae,Oe=0){this._str=Ae,this._len=Ae.length,this._offset=Oe}setOffset(Ae){this._offset=Ae}prevCodePoint(){const Ae=x(this._str,this._offset);return this._offset-=Ae>=65536?2:1,Ae}nextCodePoint(){const Ae=V(this._str,this._len,this._offset);return this._offset+=Ae>=65536?2:1,Ae}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Ae,Oe=0){this._iterator=new Q(Ae,Oe)}nextGraphemeLength(){const Ae=Ze.getInstance(),Oe=this._iterator,Me=Oe.offset;let Ke=Ae.getGraphemeBreakType(Oe.nextCodePoint());for(;!Oe.eol();){const Je=Oe.offset,st=Ae.getGraphemeBreakType(Oe.nextCodePoint());if(We(Ke,st)){Oe.setOffset(Je);break}Ke=st}return Oe.offset-Me}prevGraphemeLength(){const Ae=Ze.getInstance(),Oe=this._iterator,Me=Oe.offset;let Ke=Ae.getGraphemeBreakType(Oe.prevCodePoint());for(;Oe.offset>0;){const Je=Oe.offset,st=Ae.getGraphemeBreakType(Oe.prevCodePoint());if(We(st,Ke)){Oe.setOffset(Je);break}Ke=st}return Me-Oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function ue(me,Ae){return new K(me,Ae).nextGraphemeLength()}e.nextCharLength=ue;function te(me,Ae){return new K(me,Ae).prevGraphemeLength()}e.prevCharLength=te;function he(me,Ae){Ae>0&&U(me.charCodeAt(Ae))&&Ae--;const Oe=Ae+ue(me,Ae);return[Oe-te(me,Oe),Oe]}e.getCharContainingOffset=he;function Y(me){const Ae=new K(me);let Oe=0;for(;!Ae.eol();)Oe++,Ae.nextGraphemeLength();return Oe}e.charCount=Y;let fe;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(me){return fe||(fe=be()),fe.test(me)}e.containsRTL=ke;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(me){return Re.test(me)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(me){return e.UNUSUAL_LINE_TERMINATORS.test(me)}e.containsUnusualLineTerminators=oe;function le(me){return me>=11904&&me<=55215||me>=63744&&me<=64255||me>=65281&&me<=65374}e.isFullWidthCharacter=le;function ge(me){return me>=127462&&me<=127487||me===8986||me===8987||me===9200||me===9203||me>=9728&&me<=10175||me===11088||me===11093||me>=127744&&me<=128591||me>=128640&&me<=128764||me>=128992&&me<=129008||me>=129280&&me<=129535||me>=129648&&me<=129782}e.isEmojiImprecise=ge;function Z(me,Ae){if(me.length<Ae)return me;const Oe=/\b/g;let Me=0;for(;Oe.test(me)&&!(me.length-Oe.lastIndex<Ae);)Me=Oe.lastIndex,Oe.lastIndex+=1;return me.substring(Me).replace(/^\s/,"")}e.lcut=Z;const ae=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function N(me){return me&&(me=me.replace(ae,""),me=me.replace(ne,""),me=me.replace(ie,"")),me}e.removeAnsiEscapeCodes=N,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(me){return!!(me&&me.length>0&&me.charCodeAt(0)===65279)}e.startsWithUTF8BOM=j;function G(me){return j(me)?me.substr(1):me}e.stripUTF8BOM=G;function X(me,Ae){if(!me||!Ae||me.length<Ae.length)return!1;const Oe=Ae.length,Me=me.toLowerCase();let Ke=0,Je=-1;for(;Ke<Oe;){const st=Me.indexOf(Ae[Ke],Je+1);if(st<0)return!1;Je=st,Ke++}return!0}e.fuzzyContains=X;function pe(me,Ae=!1){return me?(Ae&&(me=me.replace(/\\./g,"")),me.toLowerCase()!==me):!1}e.containsUppercaseCharacter=pe;function we(me){return me.charAt(0).toUpperCase()+me.slice(1)}e.uppercaseFirstLetter=we;function ce(me,Ae=1){if(Ae===0)return"";let Oe=-1;do Oe=me.indexOf(`
`,Oe+1),Ae--;while(Ae>0&&Oe>=0);return Oe===-1?me:(me[Oe-1]==="\r"&&Oe--,me.substr(0,Oe))}e.getNLines=ce;function Ie(me){return me=me%(2*26),me<26?String.fromCharCode(97+me):String.fromCharCode(65+me-26)}e.singleLetterHash=Ie;function ye(me){return Ze.getInstance().getGraphemeBreakType(me)}e.getGraphemeBreakType=ye;function We(me,Ae){return me===0?Ae!==5&&Ae!==7:me===2&&Ae===3?!1:me===4||me===2||me===3||Ae===4||Ae===2||Ae===3?!0:!(me===8&&(Ae===8||Ae===9||Ae===11||Ae===12)||(me===11||me===9)&&(Ae===9||Ae===10)||(me===12||me===10)&&Ae===10||Ae===5||Ae===13||Ae===7||me===1||me===13&&Ae===14||me===6&&Ae===6)}var qe;(function(me){me[me.Other=0]="Other",me[me.Prepend=1]="Prepend",me[me.CR=2]="CR",me[me.LF=3]="LF",me[me.Control=4]="Control",me[me.Extend=5]="Extend",me[me.Regional_Indicator=6]="Regional_Indicator",me[me.SpacingMark=7]="SpacingMark",me[me.L=8]="L",me[me.V=9]="V",me[me.T=10]="T",me[me.LV=11]="LV",me[me.LVT=12]="LVT",me[me.ZWJ=13]="ZWJ",me[me.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ze{static getInstance(){return Ze._INSTANCE||(Ze._INSTANCE=new Ze),Ze._INSTANCE}constructor(){this._data=Ye()}getGraphemeBreakType(Ae){if(Ae<32)return Ae===10?3:Ae===13?2:4;if(Ae<127)return 0;const Oe=this._data,Me=Oe.length/3;let Ke=1;for(;Ke<=Me;)if(Ae<Oe[3*Ke])Ke=2*Ke;else if(Ae>Oe[3*Ke+1])Ke=2*Ke+1;else return Oe[3*Ke+2];return 0}}Ze._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(me,Ae){if(me===0)return 0;const Oe=at(me,Ae);if(Oe!==void 0)return Oe;const Me=new Q(Ae,me);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Ne;function at(me,Ae){const Oe=new Q(Ae,me);let Me=Oe.prevCodePoint();for(;re(Me)||Me===65039||Me===8419;){if(Oe.offset===0)return;Me=Oe.prevCodePoint()}if(!ge(Me))return;let Ke=Oe.offset;return Ke>0&&Oe.prevCodePoint()===8205&&(Ke=Oe.offset),Ke}function re(me){return 127995<=me&&me<=127999}var se;(function(me){me[me.zwj=8205]="zwj",me[me.emojiVariantSelector=65039]="emojiVariantSelector",me[me.enclosingKeyCap=8419]="enclosingKeyCap"})(se||(se={})),e.noBreakWhitespace="\xA0";class Ee{static getInstance(Ae){return Ee.cache.get(Array.from(Ae))}static getLocales(){return Ee._locales.getValue()}constructor(Ae){this.confusableDictionary=Ae}isAmbiguous(Ae){return this.confusableDictionary.has(Ae)}getPrimaryConfusable(Ae){return this.confusableDictionary.get(Ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ee,I=Ee,Ee.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.cache=new c.LRUCachedFunction(me=>{function Ae(it){const bt=new Map;for(let yt=0;yt<it.length;yt+=2)bt.set(it[yt],it[yt+1]);return bt}function Oe(it,bt){const yt=new Map(it);for(const[Ct,ht]of bt)yt.set(Ct,ht);return yt}function Me(it,bt){if(!it)return bt;const yt=new Map;for(const[Ct,ht]of it)bt.has(Ct)&&yt.set(Ct,ht);return yt}const Ke=I.ambiguousCharacterData.getValue();let Je=me.filter(it=>!it.startsWith("_")&&it in Ke);Je.length===0&&(Je=["_default"]);let st;for(const it of Je){const bt=Ae(Ke[it]);st=Me(st,bt)}const vt=Ae(Ke._common),nt=Oe(vt,st);return new Ee(nt)}),Ee._locales=new t.Lazy(()=>Object.keys(Ee.ambiguousCharacterData.getValue()).filter(me=>!me.startsWith("_")));class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(Ae){return xe.getData().has(Ae)}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe,xe._data=void 0}),define(Ce[32],De([1,0,9,10,8,12]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(a){return a===47||a===92}e.isPathSeparator=C;function T(a){return a.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function S(a){return a.indexOf("/")===-1&&(a=T(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function D(a,d=c.posix.sep){if(!a)return"";const n=a.length,i=a.charCodeAt(0);if(C(i)){if(C(a.charCodeAt(1))&&!C(a.charCodeAt(2))){let _=3;const R=_;for(;_<n&&!C(a.charCodeAt(_));_++);if(R!==_&&!C(a.charCodeAt(_+1))){for(_+=1;_<n;_++)if(C(a.charCodeAt(_)))return a.slice(0,_+1).replace(/[\\/]/g,d)}}return d}else if(f(i)&&a.charCodeAt(1)===58)return C(a.charCodeAt(2))?a.slice(0,2)+d:a.slice(0,2);let p=a.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(C(a.charCodeAt(p)))return a.slice(0,p+1)}return""}e.getRoot=D;function A(a){if(!t.isWindows||!a||a.length<5)return!1;let d=a.charCodeAt(0);if(d!==92||(d=a.charCodeAt(1),d!==92))return!1;let n=2;const i=n;for(;n<a.length&&(d=a.charCodeAt(n),d!==92);n++);return!(i===n||(d=a.charCodeAt(n+1),isNaN(d)||d===92))}e.isUNC=A;const k=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(a,d=t.isWindows){const n=d?k:E;return!(!a||a.length===0||/^\s+$/.test(a)||(n.lastIndex=0,n.test(a))||d&&y.test(a)||a==="."||a===".."||d&&a[a.length-1]==="."||d&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=w;function h(a,d,n){const i=a===d;return!n||i?i:!a||!d?!1:(0,I.equalsIgnoreCase)(a,d)}e.isEqual=h;function g(a,d,n,i=c.sep){if(a===d)return!0;if(!a||!d||d.length>a.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(a,d))return!1;if(d.length===a.length)return!0;let _=d.length;return d.charAt(d.length-1)===i&&_--,a.charAt(_)===i}return d.charAt(d.length-1)!==i&&(d+=i),a.indexOf(d)===0}e.isEqualOrParent=g;function f(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=f;function v(a,d){return t.isWindows&&a.endsWith(":")&&(a+=c.sep),(0,c.isAbsolute)(a)||(a=(0,c.join)(d,a)),a=(0,c.normalize)(a),t.isWindows?(a=(0,I.rtrim)(a,c.sep),a.endsWith(":")&&(a+=c.sep)):(a=(0,I.rtrim)(a,c.sep),a||(a=c.sep)),a}e.sanitizeFilePath=v;function m(a){const d=(0,c.normalize)(a);return t.isWindows?a.length>3?!1:r(d)&&(a.length===2||d.charCodeAt(2)===92):d===c.posix.sep}e.isRootOrDriveLetter=m;function r(a,d=t.isWindows){return d?f(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function b(a){return r(a)?a[0]:void 0}e.getDriveLetter=b;function o(a,d,n){return d.length>a.length?-1:a===d?0:(n&&(a=a.toLowerCase(),d=d.toLowerCase()),a.indexOf(d))}e.indexOfPath=o;function u(a){const d=a.split(":");let n,i,p;for(const _ of d){const R=Number(_);(0,P.isNumber)(R)?i===void 0?i=R:p===void 0&&(p=R):n=n?[n,_].join(":"):_}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:i!==void 0?i:void 0,column:p!==void 0?p:i!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(a,d,n=8){let i="";for(let _=0;_<n;_++)i+=s.charAt(Math.floor(Math.random()*s.length));let p;return d?p=`${d}-${i}`:p=i,a?(0,c.join)(a,p):p}e.randomPath=l}),define(Ce[107],De([1,0,28,8]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ne){return function(ie,N){for(let j=0,G=ne.length;j<G;j++){const X=ne[j](ie,N);if(X)return X}return null}}e.or=I,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ne,ie,N){if(!N||N.length<ie.length)return null;let j;return ne?j=t.startsWithIgnoreCase(N,ie):j=N.indexOf(ie)===0,j?ie.length>0?[{start:0,end:ie.length}]:[]:null}function C(ne,ie){const N=ie.toLowerCase().indexOf(ne.toLowerCase());return N===-1?null:[{start:N,end:N+ne.length}]}e.matchesContiguousSubString=C;function T(ne,ie){return S(ne.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=T;function S(ne,ie,N,j){if(N===ne.length)return[];if(j===ie.length)return null;if(ne[N]===ie[j]){let G=null;return(G=S(ne,ie,N+1,j+1))?f({start:j,end:j+1},G):null}return S(ne,ie,N,j+1)}function D(ne){return 97<=ne&&ne<=122}function A(ne){return 65<=ne&&ne<=90}e.isUpper=A;function k(ne){return 48<=ne&&ne<=57}function E(ne){return ne===32||ne===9||ne===10||ne===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>y.add(ne.charCodeAt(0)));function w(ne){return E(ne)||y.has(ne)}function h(ne,ie){return ne===ie||w(ne)&&w(ie)}function g(ne){return D(ne)||A(ne)||k(ne)}function f(ne,ie){return ie.length===0?ie=[ne]:ne.end===ie[0].start?ie[0].start=ne.start:ie.unshift(ne),ie}function v(ne,ie){for(let N=ie;N<ne.length;N++){const j=ne.charCodeAt(N);if(A(j)||k(j)||N>0&&!g(ne.charCodeAt(N-1)))return N}return ne.length}function m(ne,ie,N,j){if(N===ne.length)return[];if(j===ie.length)return null;if(ne[N]!==ie[j].toLowerCase())return null;{let G=null,X=j+1;for(G=m(ne,ie,N+1,j+1);!G&&(X=v(ie,X))<ie.length;)G=m(ne,ie,N+1,X),X++;return G===null?null:f({start:j,end:j+1},G)}}function r(ne){let ie=0,N=0,j=0,G=0,X=0;for(let ye=0;ye<ne.length;ye++)X=ne.charCodeAt(ye),A(X)&&ie++,D(X)&&N++,g(X)&&j++,k(X)&&G++;const pe=ie/ne.length,we=N/ne.length,ce=j/ne.length,Ie=G/ne.length;return{upperPercent:pe,lowerPercent:we,alphaPercent:ce,numericPercent:Ie}}function b(ne){const{upperPercent:ie,lowerPercent:N}=ne;return N===0&&ie>.6}function o(ne){const{upperPercent:ie,lowerPercent:N,alphaPercent:j,numericPercent:G}=ne;return N>.2&&ie<.8&&j>.6&&G<.2}function u(ne){let ie=0,N=0,j=0,G=0;for(let X=0;X<ne.length;X++)j=ne.charCodeAt(X),A(j)&&ie++,D(j)&&N++,E(j)&&G++;return(ie===0||N===0)&&G===0?ne.length<=30:ie<=5}function s(ne,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!u(ne)||ie.length>60)return null;const N=r(ie);if(!o(N)){if(!b(N))return null;ie=ie.toLowerCase()}let j=null,G=0;for(ne=ne.toLowerCase();G<ie.length&&(j=m(ne,ie,0,G))===null;)G=v(ie,G+1);return j}e.matchesCamelCase=s;function l(ne,ie,N=!1){if(!ie||ie.length===0)return null;let j=null,G=0;for(ne=ne.toLowerCase(),ie=ie.toLowerCase();G<ie.length&&(j=a(ne,ie,0,G,N))===null;)G=d(ie,G+1);return j}e.matchesWords=l;function a(ne,ie,N,j,G){if(N===ne.length)return[];if(j===ie.length)return null;if(h(ne.charCodeAt(N),ie.charCodeAt(j))){let X=null,pe=j+1;if(X=a(ne,ie,N+1,j+1,G),!G)for(;!X&&(pe=d(ie,pe))<ie.length;)X=a(ne,ie,N+1,pe,G),pe++;return X?ne.charCodeAt(N)!==ie.charCodeAt(j)?X:f({start:j,end:j+1},X):null}else return null}function d(ne,ie){for(let N=ie;N<ne.length;N++)if(w(ne.charCodeAt(N))||N>0&&w(ne.charCodeAt(N-1)))return N;return ne.length}const n=I(e.matchesPrefix,s,C),i=I(e.matchesPrefix,s,T),p=new c.LRUCache(1e4);function _(ne,ie,N=!1){if(typeof ne!="string"||typeof ie!="string")return null;let j=p.get(ne);j||(j=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),p.set(ne,j));const G=j.exec(ie);return G?[{start:G.index,end:G.index+G[0].length}]:N?i(ne,ie):n(ne,ie)}e.matchesFuzzy=_;function R(ne,ie){const N=Re(ne,ne.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?H(N):null}e.matchesFuzzy2=R;function M(ne,ie,N,j,G,X){const pe=Math.min(13,ne.length);for(;N<pe;N++){const we=Re(ne,ie,N,j,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=M;function H(ne){if(typeof ne>"u")return[];const ie=[],N=ne[1];for(let j=ne.length-1;j>1;j--){const G=ne[j]+N,X=ie[ie.length-1];X&&X.end===G?X.end=G+1:ie.push({start:G,end:G+1})}return ie}e.createMatches=H;const $=128;function L(){const ne=[],ie=[];for(let N=0;N<=$;N++)ie[N]=0;for(let N=0;N<=$;N++)ne.push(ie.slice(0));return ne}function B(ne){const ie=[];for(let N=0;N<=ne;N++)ie[N]=0;return ie}const O=B(2*$),z=B(2*$),U=L(),F=L(),V=L(),x=!1;function Q(ne,ie,N,j,G){function X(we,ce,Ie=" "){for(;we.length<ce;)we=Ie+we;return we}let pe=` |   |${j.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=N;we++)we===0?pe+=" |":pe+=`${ie[we-1]}|`,pe+=ne[we].slice(0,G+1).map(ce=>X(ce.toString(),3)).join("|")+`
`;return pe}function K(ne,ie,N,j){ne=ne.substr(ie),N=N.substr(j),console.log(Q(F,ne,ne.length,N,N.length)),console.log(Q(V,ne,ne.length,N,N.length)),console.log(Q(U,ne,ne.length,N,N.length))}function ue(ne,ie){if(ie<0||ie>=ne.length)return!1;const N=ne.codePointAt(ie);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(N)}}function te(ne,ie){if(ie<0||ie>=ne.length)return!1;switch(ne.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function he(ne,ie,N){return ie[ne]!==N[ne]}function Y(ne,ie,N,j,G,X,pe=!1){for(;ie<N&&G<X;)ne[ie]===j[G]&&(pe&&(O[ie]=G),ie+=1),G+=1;return ie===N}e.isPatternInWord=Y;var fe;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(fe||(fe={}));var be;(function(ne){ne.Default=[-100,0];function ie(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}ne.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,N){this.firstMatchCanBeWeak=ie,this.boostFullMatch=N}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,ie,N,j,G,X,pe=ke.default){const we=ne.length>$?$:ne.length,ce=j.length>$?$:j.length;if(N>=we||X>=ce||we-N>ce-X||!Y(ie,N,we,G,X,ce,!0))return;ze(we,ce,N,X,ie,G);let Ie=1,ye=1,We=N,qe=X;const Ze=[!1];for(Ie=1,We=N;We<we;Ie++,We++){const se=O[We],Ee=z[We],xe=We+1<we?z[We+1]:ce;for(ye=se-X+1,qe=se;qe<xe;ye++,qe++){let me=Number.MIN_SAFE_INTEGER,Ae=!1;qe<=Ee&&(me=oe(ne,ie,We,N,j,G,qe,ce,X,U[Ie-1][ye-1]===0,Ze));let Oe=0;me!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Oe=me+F[Ie-1][ye-1]);const Me=qe>se,Ke=Me?F[Ie][ye-1]+(U[Ie][ye-1]>0?-5:0):0,Je=qe>se+1&&U[Ie][ye-1]>0,st=Je?F[Ie][ye-2]+(U[Ie][ye-2]>0?-5:0):0;if(Je&&(!Me||st>=Ke)&&(!Ae||st>=Oe))F[Ie][ye]=st,V[Ie][ye]=3,U[Ie][ye]=0;else if(Me&&(!Ae||Ke>=Oe))F[Ie][ye]=Ke,V[Ie][ye]=2,U[Ie][ye]=0;else if(Ae)F[Ie][ye]=Oe,V[Ie][ye]=1,U[Ie][ye]=U[Ie-1][ye-1]+1;else throw new Error("not possible")}}if(x&&K(ne,N,j,X),!Ze[0]&&!pe.firstMatchCanBeWeak)return;Ie--,ye--;const Ye=[F[Ie][ye],X];let Ne=0,at=0;for(;Ie>=1;){let se=ye;do{const Ee=V[Ie][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Ne>1&&ie[N+Ie-1]===G[X+ye-1]&&!he(se+X-1,j,G)&&Ne+1>U[Ie][se]&&(se=ye),se===ye?Ne++:Ne=1,at||(at=se),Ie--,ye=se-1,Ye.push(ye)}ce===we&&pe.boostFullMatch&&(Ye[0]+=2);const re=at-we;return Ye[0]-=re,Ye}e.fuzzyScore=Re;function ze(ne,ie,N,j,G,X){let pe=ne-1,we=ie-1;for(;pe>=N&&we>=j;)G[pe]===X[we]&&(z[pe]=we,pe--),we--}function oe(ne,ie,N,j,G,X,pe,we,ce,Ie,ye){if(ie[N]!==X[pe])return Number.MIN_SAFE_INTEGER;let We=1,qe=!1;return pe===N-j?We=ne[N]===G[pe]?7:5:he(pe,G,X)&&(pe===0||!he(pe-1,G,X))?(We=ne[N]===G[pe]?7:5,qe=!0):ue(X,pe)&&(pe===0||!ue(X,pe-1))?We=5:(ue(X,pe-1)||te(X,pe-1))&&(We=5,qe=!0),We>1&&N===j&&(ye[0]=!0),qe||(qe=he(pe,G,X)||ue(X,pe-1)||te(X,pe-1)),N===j?pe>ce&&(We-=qe?3:5):Ie?We+=qe?2:0:We+=qe?0:1,pe+1===we&&(We-=qe?3:5),We}function le(ne,ie,N,j,G,X,pe){return Z(ne,ie,N,j,G,X,!0,pe)}e.fuzzyScoreGracefulAggressive=le;function ge(ne,ie,N,j,G,X,pe){return Z(ne,ie,N,j,G,X,!1,pe)}e.fuzzyScoreGraceful=ge;function Z(ne,ie,N,j,G,X,pe,we){let ce=Re(ne,ie,N,j,G,X,we);if(ce&&!pe)return ce;if(ne.length>=3){const Ie=Math.min(7,ne.length-1);for(let ye=N+1;ye<Ie;ye++){const We=ae(ne,ye);if(We){const qe=Re(We,We.toLowerCase(),N,j,G,X,we);qe&&(qe[0]-=3,(!ce||qe[0]>ce[0])&&(ce=qe))}}}return ce}function ae(ne,ie){if(ie+1>=ne.length)return;const N=ne[ie],j=ne[ie+1];if(N!==j)return ne.slice(0,ie)+j+N+ne.slice(ie+2)}}),define(Ce[81],De([1,0,8]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return I(f,0)}e.hash=t;function I(f,v){switch(typeof f){case"object":return f===null?P(349,v):Array.isArray(f)?S(f,v):D(f,v);case"string":return T(f,v);case"boolean":return C(f,v);case"number":return P(f,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=I;function P(f,v){return(v<<5)-v+f|0}e.numberHash=P;function C(f,v){return P(f?433:863,v)}function T(f,v){v=P(149417,v);for(let m=0,r=f.length;m<r;m++)v=P(f.charCodeAt(m),v);return v}e.stringHash=T;function S(f,v){return v=P(104579,v),f.reduce((m,r)=>I(r,m),v)}function D(f,v){return v=P(181387,v),Object.keys(f).sort().reduce((m,r)=>(m=T(r,m),I(f[r],m)),v)}class A{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=I(v,this._value),this._value}}e.Hasher=A;var k;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function E(f,v,m=32){const r=m-v,b=~((1<<r)-1);return(f<<v|(b&f)>>>r)>>>0}function y(f,v=0,m=f.byteLength,r=0){for(let b=0;b<m;b++)f[v+b]=r}function w(f,v,m="0"){for(;f.length<v;)f=m+f;return f}function h(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(m=>m.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),v/4)}e.toHexString=h;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const m=v.length;if(m===0)return;const r=this._buff;let b=this._buffLen,o=this._leftoverHighSurrogate,u,s;for(o!==0?(u=o,s=-1,o=0):(u=v.charCodeAt(0),s=0);;){let l=u;if(c.isHighSurrogate(u))if(s+1<m){const a=v.charCodeAt(s+1);c.isLowSurrogate(a)?(s++,l=c.computeCodePoint(u,a)):l=65533}else{o=u;break}else c.isLowSurrogate(u)&&(l=65533);if(b=this._push(r,b,l),s++,s<m)u=v.charCodeAt(s);else break}this._buffLen=b,this._leftoverHighSurrogate=o}_push(v,m,r){return r<128?v[m++]=r:r<2048?(v[m++]=192|(r&1984)>>>6,v[m++]=128|(r&63)>>>0):r<65536?(v[m++]=224|(r&61440)>>>12,v[m++]=128|(r&4032)>>>6,v[m++]=128|(r&63)>>>0):(v[m++]=240|(r&1835008)>>>18,v[m++]=128|(r&258048)>>>12,v[m++]=128|(r&4032)>>>6,v[m++]=128|(r&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=g._bigBlock32,m=this._buffDV;for(let n=0;n<64;n+=4)v.setUint32(n,m.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)v.setUint32(n,E(v.getUint32(n-12,!1)^v.getUint32(n-32,!1)^v.getUint32(n-56,!1)^v.getUint32(n-64,!1),1),!1);let r=this._h0,b=this._h1,o=this._h2,u=this._h3,s=this._h4,l,a,d;for(let n=0;n<80;n++)n<20?(l=b&o|~b&u,a=1518500249):n<40?(l=b^o^u,a=1859775393):n<60?(l=b&o|b&u|o&u,a=2400959708):(l=b^o^u,a=3395469782),d=E(r,5)+l+s+a+v.getUint32(n*4,!1)&4294967295,s=u,u=o,o=E(b,30),b=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Ce[158],De([1,0,77,107,8]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(c.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${P.source}`,"g");function S(g){return g.replace(T,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=S;const D=new RegExp(`\\\\${P.source}`,"g");function A(g){return g.replace(D,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=A;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function E(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(k,(f,v,m,r)=>m?f:v||r||"")}e.stripIcons=E;function y(g){const f=g.indexOf(e.iconStartMarker);return f===-1?{text:g}:w(g,f)}e.parseLabelWithIcons=y;function w(g,f){const v=[];let m="";function r(n){if(n){m+=n;for(const i of n)v.push(u)}}let b=-1,o="",u=0,s,l,a=f;const d=g.length;for(r(g.substr(0,f));a<d;)s=g[a],l=g[a+1],s===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(b=a,r(o),o=e.iconStartMarker,a++):s===")"&&b!==-1?(u+=a-b+1,b=-1,o=""):b!==-1?C.test(s)?o+=s:(r(o),b=-1,o=""):r(s),a++;return r(o),{text:m,iconOffsets:v}}function h(g,f,v=!1){const{text:m,iconOffsets:r}=f;if(!r||r.length===0)return(0,t.matchesFuzzy)(g,m,v);const b=(0,I.ltrim)(m," "),o=m.length-b.length,u=(0,t.matchesFuzzy)(g,b,v);if(u)for(const s of u){const l=r[s.start+o]+o;s.start+=l,s.end+=l}return u}e.matchesFuzzyIconAware=h}),define(Ce[42],De([1,0,8]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const P="error",C="warning",T="warn",S="info",D="ignore";function A(E){return E?c.equalsIgnoreCase(P,E)?I.Error:c.equalsIgnoreCase(C,E)||c.equalsIgnoreCase(T,E)?I.Warning:c.equalsIgnoreCase(S,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function k(E){switch(E){case I.Error:return P;case I.Warning:return C;case I.Info:return S;default:return D}}I.toString=k}(t||(t={})),e.default=t}),define(Ce[63],De([1,0,17,8]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(y){return this._value=y,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(y){const w=y.charCodeAt(0),h=this._value.charCodeAt(this._pos);return w-h}value(){return this._value[this._pos]}}e.StringIterator=I;class P{constructor(y=!0){this._caseSensitive=y}reset(y){return this._value=y,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let y=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(y)this._from++;else break;else y=!1;return this}cmp(y){return this._caseSensitive?(0,t.compareSubstring)(y,this._value,0,y.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(y,this._value,0,y.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class C{constructor(y=!0,w=!0){this._splitOnBackslash=y,this._caseSensitive=w}reset(y){this._from=0,this._to=0,this._value=y,this._valueLen=y.length;for(let w=y.length-1;w>=0;w--,this._valueLen--){const h=this._value.charCodeAt(w);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let y=!0;for(;this._to<this._valueLen;this._to++){const w=this._value.charCodeAt(this._to);if(w===47||this._splitOnBackslash&&w===92)if(y)this._from++;else break;else y=!1}return this}cmp(y){return this._caseSensitive?(0,t.compareSubstring)(y,this._value,0,y.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(y,this._value,0,y.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(y,w){this._ignorePathCasing=y,this._ignoreQueryAndFragment=w,this._states=[],this._stateIdx=0}reset(y){return this._value=y,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(y)),this._pathIterator.reset(y.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(y)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(y){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(y,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(y,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(y);if(this._states[this._stateIdx]===4)return(0,t.compare)(y,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(y,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(A||(A={}));class k{static forUris(y=()=>!1,w=()=>!1){return new k(new S(y,w))}static forPaths(y=!1){return new k(new C(void 0,!y))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new P)}constructor(y){this._iter=y}clear(){this._root=void 0}fill(y,w){if(w){const h=w.slice(0);(0,c.shuffle)(h);for(const g of h)this.set(g,y)}else{const h=y.slice(0);(0,c.shuffle)(h);for(const g of h)this.set(g[0],g[1])}}set(y,w){const h=this._iter.reset(y);let g;this._root||(this._root=new D,this._root.segment=h.value());const f=[];for(g=this._root;;){const m=h.cmp(g.segment);if(m>0)g.left||(g.left=new D,g.left.segment=h.value()),f.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new D,g.right.segment=h.value()),f.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new D,g.mid.segment=h.value()),f.push([0,g]),g=g.mid;else break}const v=g.value;g.value=w,g.key=y;for(let m=f.length-1;m>=0;m--){const r=f[m][1];r.updateHeight();const b=r.balanceFactor();if(b<-1||b>1){const o=f[m][0],u=f[m+1][0];if(o===1&&u===1)f[m][1]=r.rotateLeft();else if(o===-1&&u===-1)f[m][1]=r.rotateRight();else if(o===1&&u===-1)r.right=f[m+1][1]=f[m+1][1].rotateRight(),f[m][1]=r.rotateLeft();else if(o===-1&&u===1)r.left=f[m+1][1]=f[m+1][1].rotateLeft(),f[m][1]=r.rotateRight();else throw new Error;if(m>0)switch(f[m-1][0]){case-1:f[m-1][1].left=f[m][1];break;case 1:f[m-1][1].right=f[m][1];break;case 0:f[m-1][1].mid=f[m][1];break}else this._root=f[0][1]}}return v}get(y){return this._getNode(y)?.value}_getNode(y){const w=this._iter.reset(y);let h=this._root;for(;h;){const g=w.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else break}return h}has(y){const w=this._getNode(y);return!(w?.value===void 0&&w?.mid===void 0)}delete(y){return this._delete(y,!1)}deleteSuperstr(y){return this._delete(y,!0)}_delete(y,w){const h=this._iter.reset(y),g=[];let f=this._root;for(;f;){const v=h.cmp(f.segment);if(v>0)g.push([-1,f]),f=f.left;else if(v<0)g.push([1,f]),f=f.right;else if(h.hasNext())h.next(),g.push([0,f]),f=f.mid;else break}if(!!f){if(w?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const v=this._min(f.right);if(v.key){const{key:m,value:r,segment:b}=v;this._delete(v.key,!1),f.key=m,f.value=r,f.segment=b}}else{const v=f.left??f.right;if(g.length>0){const[m,r]=g[g.length-1];switch(m){case-1:r.left=v;break;case 0:r.mid=v;break;case 1:r.right=v;break}}else this._root=v}for(let v=g.length-1;v>=0;v--){const m=g[v][1];m.updateHeight();const r=m.balanceFactor();if(r>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[v][1]=m.rotateLeft()):r<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[v][1]=m.rotateRight()),v>0)switch(g[v-1][0]){case-1:g[v-1][1].left=g[v][1];break;case 1:g[v-1][1].right=g[v][1];break;case 0:g[v-1][1].mid=g[v][1];break}else this._root=g[0][1]}}}_min(y){for(;y.left;)y=y.left;return y}findSubstr(y){const w=this._iter.reset(y);let h=this._root,g;for(;h;){const f=w.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(w.hasNext())w.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(y){const w=this._iter.reset(y);let h=this._root;for(;h;){const g=w.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(y){for(const[w,h]of this)y(h,w)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(y){const w=[];return this._dfsEntries(y,w),w[Symbol.iterator]()}_dfsEntries(y,w){!y||(y.left&&this._dfsEntries(y.left,w),y.value&&w.push([y.key,y.value]),y.mid&&this._dfsEntries(y.mid,w),y.right&&this._dfsEntries(y.right,w))}_isBalanced(){const y=w=>{if(!w)return!0;const h=w.balanceFactor();return h<-1||h>1?!1:y(w.left)&&y(w.right)};return y(this._root)}}e.TernarySearchTree=k}),define(Ce[2],De([1,0,9,10]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,P=/^\//,C=/^\/\//;function T(s,l){if(!s.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!P.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,l){return!s&&!l?"file":s}function D(s,l){switch(s){case"https":case"http":case"file":l?l[0]!==k&&(l=k+l):l=k;break}return l}const A="",k="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(l){return l instanceof y?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,a,d,n,i,p=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=S(l,p),this.authority=a||A,this.path=D(this.scheme,d||A),this.query=n||A,this.fragment=i||A,T(this,p))}get fsPath(){return m(this,!1)}with(l){if(!l)return this;let{scheme:a,authority:d,path:n,query:i,fragment:p}=l;return a===void 0?a=this.scheme:a===null&&(a=A),d===void 0?d=this.authority:d===null&&(d=A),n===void 0?n=this.path:n===null&&(n=A),i===void 0?i=this.query:i===null&&(i=A),p===void 0?p=this.fragment:p===null&&(p=A),a===this.scheme&&d===this.authority&&n===this.path&&i===this.query&&p===this.fragment?this:new h(a,d,n,i,p)}static parse(l,a=!1){const d=E.exec(l);return d?new h(d[2]||A,u(d[4]||A),u(d[5]||A),u(d[7]||A),u(d[9]||A),a):new h(A,A,A,A,A)}static file(l){let a=A;if(t.isWindows&&(l=l.replace(/\\/g,k)),l[0]===k&&l[1]===k){const d=l.indexOf(k,2);d===-1?(a=l.substring(2),l=k):(a=l.substring(2,d),l=l.substring(d)||k)}return new h("file",a,l,A,A)}static from(l){const a=new h(l.scheme,l.authority,l.path,l.query,l.fragment);return T(a,!0),a}static joinPath(l,...a){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return t.isWindows&&l.scheme==="file"?d=y.file(c.win32.join(m(l,!0),...a)).path:d=c.posix.join(l.path,...a),l.with({path:d})}toString(l=!1){return r(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof y)return l;{const a=new h(l);return a._formatted=l.external,a._fsPath=l._sep===w?l.fsPath:null,a}}else return l}}e.URI=y;const w=t.isWindows?1:void 0;class h extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(l=!1){return l?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(s,l){let a,d=-1;for(let n=0;n<s.length;n++){const i=s.charCodeAt(n);if(i>=97&&i<=122||i>=65&&i<=90||i>=48&&i<=57||i===45||i===46||i===95||i===126||l&&i===47)d!==-1&&(a+=encodeURIComponent(s.substring(d,n)),d=-1),a!==void 0&&(a+=s.charAt(n));else{a===void 0&&(a=s.substr(0,n));const p=g[i];p!==void 0?(d!==-1&&(a+=encodeURIComponent(s.substring(d,n)),d=-1),a+=p):d===-1&&(d=n)}}return d!==-1&&(a+=encodeURIComponent(s.substring(d))),a!==void 0?a:s}function v(s){let l;for(let a=0;a<s.length;a++){const d=s.charCodeAt(a);d===35||d===63?(l===void 0&&(l=s.substr(0,a)),l+=g[d]):l!==void 0&&(l+=s[a])}return l!==void 0?l:s}function m(s,l){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?l?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=m;function r(s,l){const a=l?v:f;let d="",{scheme:n,authority:i,path:p,query:_,fragment:R}=s;if(n&&(d+=n,d+=":"),(i||n==="file")&&(d+=k,d+=k),i){let M=i.indexOf("@");if(M!==-1){const H=i.substr(0,M);i=i.substr(M+1),M=H.indexOf(":"),M===-1?d+=a(H,!1):(d+=a(H.substr(0,M),!1),d+=":",d+=a(H.substr(M+1),!1)),d+="@"}i=i.toLowerCase(),M=i.indexOf(":"),M===-1?d+=a(i,!1):(d+=a(i.substr(0,M),!1),d+=i.substr(M))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const M=p.charCodeAt(1);M>=65&&M<=90&&(p=`/${String.fromCharCode(M+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const M=p.charCodeAt(0);M>=65&&M<=90&&(p=`${String.fromCharCode(M+32)}:${p.substr(2)}`)}d+=a(p,!0)}return _&&(d+="?",d+=a(_,!1)),R&&(d+="#",d+=l?R:f(R,!1)),d}function b(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+b(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(s){return s.match(o)?s.replace(o,l=>b(l)):s}}),define(Ce[82],De([1,0,23,8,2]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(D){return JSON.stringify(D,T)}e.stringify=P;function C(D){let A=JSON.parse(D);return A=S(A),A}e.parse=C;function T(D,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function S(D,A=0){if(!D||A>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return I.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 15:return new Date(D.source)}if(D instanceof c.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let k=0;k<D.length;++k)D[k]=S(D[k],A+1);else for(const k in D)Object.hasOwnProperty.call(D,k)&&(D[k]=S(D[k],A+1))}return D}e.revive=S}),define(Ce[14],De([1,0,10,2]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}setServerRootPath(D){this._remoteResourcesPath=`${D}/${I.vscodeRemoteResource}`}set(D,A,k){this._hosts[D]=A,this._ports[D]=k}setConnectionToken(D,A){this._connectionTokens[D]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)return this._delegate(D);const A=D.authority;let k=this._hosts[A];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const E=this._ports[A],y=this._connectionTokens[A];let w=`path=${encodeURIComponent(D.path)}`;return typeof y=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:c.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${k}:${E}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new P;class C{asBrowserUri(D,A){const k=this.toUri(D,A);return k.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===I.file&&(c.isNative||c.isWebWorker&&c.globals.origin===`${I.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?k.with({scheme:I.vscodeFileResource,authority:k.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(D,A){const k=this.toUri(D,A);return k.scheme===I.vscodeFileResource?k.with({scheme:I.file,authority:k.authority!==C.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(D,A){return t.URI.isUri(D)?D:t.URI.parse(A.toUrl(D))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C;var T;(function(S){const D=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(D.get("3"));const A="vscode-coi";function k(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:t.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const h=w?.get(A);if(!!h)return D.get(h)}S.getHeadersFromQuery=k;function E(y,w,h){if(!globalThis.crossOriginIsolated)return;const g=w&&h?"3":h?"2":"1";y instanceof URLSearchParams?y.set(A,g):y[A]=g}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(Ce[22],De([1,0,32,14,9,10,8,2]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(y){return(0,T.uriToFsPath)(y,!0)}e.originalFSPath=S;class D{constructor(w){this._ignorePathCasing=w}compare(w,h,g=!1){return w===h?0:(0,C.compare)(this.getComparisonKey(w,g),this.getComparisonKey(h,g))}isEqual(w,h,g=!1){return w===h?!0:!w||!h?!1:this.getComparisonKey(w,g)===this.getComparisonKey(h,g)}getComparisonKey(w,h=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,h,g=!1){if(w.scheme===h.scheme){if(w.scheme===t.Schemas.file)return c.isEqualOrParent(S(w),S(h),this._ignorePathCasing(w))&&w.query===h.query&&(g||w.fragment===h.fragment);if((0,e.isEqualAuthority)(w.authority,h.authority))return c.isEqualOrParent(w.path,h.path,this._ignorePathCasing(w),"/")&&w.query===h.query&&(g||w.fragment===h.fragment)}return!1}joinPath(w,...h){return T.URI.joinPath(w,...h)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return I.posix.basename(w.path)}extname(w){return I.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let h;return w.scheme===t.Schemas.file?h=T.URI.file(I.dirname(S(w))).path:(h=I.posix.dirname(w.path),w.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),h="/")),w.with({path:h})}normalizePath(w){if(!w.path.length)return w;let h;return w.scheme===t.Schemas.file?h=T.URI.file(I.normalize(S(w))).path:h=I.posix.normalize(w.path),w.with({path:h})}relativePath(w,h){if(w.scheme!==h.scheme||!(0,e.isEqualAuthority)(w.authority,h.authority))return;if(w.scheme===t.Schemas.file){const v=I.relative(S(w),S(h));return P.isWindows?c.toSlashes(v):v}let g=w.path||"/";const f=h.path||"/";if(this._ignorePathCasing(w)){let v=0;for(const m=Math.min(g.length,f.length);v<m&&!(g.charCodeAt(v)!==f.charCodeAt(v)&&g.charAt(v).toLowerCase()!==f.charAt(v).toLowerCase());v++);g=f.substr(0,v)+g.substr(v)}return I.posix.relative(g,f)}resolvePath(w,h){if(w.scheme===t.Schemas.file){const g=T.URI.file(I.resolve(S(w),h));return w.with({authority:g.authority,path:g.path})}return h=c.toPosixPath(h),w.with({path:I.posix.resolve(w.path,h)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,h){return w===h||w!==void 0&&h!==void 0&&(0,C.equalsIgnoreCase)(w,h)}hasTrailingPathSeparator(w,h=I.sep){if(w.scheme===t.Schemas.file){const g=S(w);return g.length>c.getRoot(g).length&&g[g.length-1]===h}else{const g=w.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,h=I.sep){return(0,e.hasTrailingPathSeparator)(w,h)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,h=I.sep){let g=!1;if(w.scheme===t.Schemas.file){const f=S(w);g=f!==void 0&&f.length===c.getRoot(f).length&&f[f.length-1]===h}else{h="/";const f=w.path;g=f.length===1&&f.charCodeAt(f.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(w,h)?w.with({path:w.path+"/"}):w}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(y=>y.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(y,w){const h=[];for(let g=0;g<y.length;g++){const f=w(y[g]);y.some((v,m)=>m===g?!1:(0,e.isEqualOrParent)(f,w(v)))||h.push(y[g])}return h}e.distinctParents=A;var k;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function w(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(m=>{const[r,b]=m.split(":");r&&b&&g.set(r,b)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&g.set(y.META_DATA_MIME,v),g}y.parseMetaData=w})(k=e.DataUri||(e.DataUri={}));function E(y,w,h){if(w){let g=y.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),y.with({scheme:h,authority:w,path:g})}return y.with({scheme:h})}e.toLocalResource=E}),define(Ce[18],De([1,0,21,11,4,6,22,10]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(he){return!!he&&typeof he.then=="function"}e.isThenable=S;function D(he){const Y=new c.CancellationTokenSource,fe=he(Y.token),be=new Promise((ke,Re)=>{const ze=Y.token.onCancellationRequested(()=>{ze.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(fe).then(oe=>{ze.dispose(),Y.dispose(),ke(oe)},oe=>{ze.dispose(),Y.dispose(),Re(oe)})});return new class{cancel(){Y.cancel()}then(ke,Re){return be.then(ke,Re)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=D;function A(he,Y,fe){return new Promise((be,ke)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(fe)});he.then(be,ke).finally(()=>Re.dispose())})}e.raceCancellation=A;function k(he,Y){return new Promise((fe,be)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});he.then(fe,be).finally(()=>ke.dispose())})}e.raceCancellationError=k;async function E(he){let Y=-1;const fe=he.map((ke,Re)=>ke.then(ze=>(Y=Re,ze))),be=await Promise.race(fe);return he.forEach((ke,Re)=>{Re!==Y&&ke.cancel()}),be}e.raceCancellablePromises=E;function y(he,Y,fe){let be;const ke=setTimeout(()=>{be?.(void 0),fe?.()},Y);return Promise.race([he.finally(()=>clearTimeout(ke)),new Promise(Re=>be=Re)])}e.raceTimeout=y;function w(he){return new Promise((Y,fe)=>{const be=he();S(be)?be.then(Y,fe):Y(be)})}e.asPromise=w;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const fe=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(fe,fe).then(be)})}return new Promise((fe,be)=>{this.queuedPromise.then(fe,be)})}return this.activePromise=Y(),new Promise((fe,be)=>{this.activePromise.then(ke=>{this.activePromise=null,fe(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=h;class g{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=g;class f{constructor(){this.promiseMap=new Map}queue(Y,fe){const ke=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(fe).finally(()=>{this.promiseMap.get(Y)===ke&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ke),ke}}e.SequencerByKey=f;const v=(he,Y)=>{let fe=!0;const be=setTimeout(()=>{fe=!1,Y()},he);return{isTriggered:()=>fe,dispose:()=>{clearTimeout(be),fe=!1}}},m=he=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,he())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class r{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,fe=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Re)=>{this.doResolve=ke,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=fe===e.MicrotaskDelay?m(be):v(fe,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class b{constructor(Y){this.delayer=new r(Y),this.throttler=new h}trigger(Y,fe){return this.delayer.trigger(()=>this.throttler.queue(Y),fe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class o{constructor(){this._isOpen=!1,this._promise=new Promise((Y,fe)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class u extends o{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function s(he,Y){return Y?new Promise((fe,be)=>{const ke=setTimeout(()=>{Re.dispose(),fe()},he),Re=Y.onCancellationRequested(()=>{clearTimeout(ke),Re.dispose(),be(new t.CancellationError)})}):D(fe=>s(he,fe))}e.timeout=s;function l(he,Y=0){const fe=setTimeout(he,Y);return(0,P.toDisposable)(()=>clearTimeout(fe))}e.disposableTimeout=l;function a(he){const Y=[];let fe=0;const be=he.length;function ke(){return fe<be?he[fe++]():null}function Re(ze){ze!=null&&Y.push(ze);const oe=ke();return oe?oe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=a;function d(he,Y=be=>!!be,fe=null){let be=0;const ke=he.length,Re=()=>{if(be>=ke)return Promise.resolve(fe);const ze=he[be++];return Promise.resolve(ze()).then(le=>Y(le)?Promise.resolve(le):Re())};return Re()}e.first=d;function n(he,Y=be=>!!be,fe=null){if(he.length===0)return Promise.resolve(fe);let be=he.length;const ke=()=>{be=-1;for(const Re of he)Re.cancel?.()};return new Promise((Re,ze)=>{for(const oe of he)oe.then(le=>{--be>=0&&Y(le)?(ke(),Re(le)):be===0&&Re(fe)}).catch(le=>{--be>=0&&(ke(),ze(le))})})}e.firstParallel=n;class i{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((fe,be)=>{this.outstandingPromises.push({factory:Y,c:fe,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const fe=Y.factory();fe.then(Y.c,Y.e),fe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=i;class p extends i{constructor(){super(1)}}e.Queue=p;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new V;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,fe=C.extUri){const be=fe.getComparisonKey(Y);let ke=this.queues.get(be);return ke||(ke=new p,I.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class R{constructor(Y,fe){this._token=-1,typeof Y=="function"&&typeof fe=="number"&&this.setIfNotSet(Y,fe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,fe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},fe)}setIfNotSet(Y,fe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},fe))}}e.TimeoutTimer=R;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,fe){this.cancel(),this._token=setInterval(()=>{Y()},fe)}}e.IntervalTimer=M;class H{constructor(Y,fe){this.timeoutToken=-1,this.runner=Y,this.timeout=fe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class ${constructor(Y,fe){fe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${fe}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=fe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class L extends H{constructor(Y,fe){super(Y,fe),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class B extends P.Disposable{constructor(Y,fe){super(),this.options=Y,this.handler=fe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,T.setTimeout0)(()=>{if(Y)return;const fe=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(he,Y)=>{const fe=requestIdleCallback(he,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(fe))}}}}();class O{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(fe){this._error=fe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(he,Y,fe){let be;for(let ke=0;ke<fe;ke++)try{return await he()}catch(Re){be=Re,await s(Y)}throw be}e.retry=z;class U{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,fe,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:fe},fe.then(()=>this.donePending(Y),()=>this.donePending(Y)),fe}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let fe,be;const ke=new Promise((Re,ze)=>{fe=Re,be=ze});this._next={run:Y,promise:ke,promiseResolve:fe,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=U;class F{constructor(Y,fe=()=>Date.now()){this.interval=Y,this.nowFn=fe,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class V{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,fe)=>{this.completeCallback=Y,this.errorCallback=fe})}complete(Y){return new Promise(fe=>{this.completeCallback(Y),this.resolved=!0,fe()})}error(Y){return new Promise(fe=>{this.errorCallback(Y),this.rejected=!0,fe()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=V;var x;(function(he){async function Y(be){let ke;const Re=await Promise.all(be.map(ze=>ze.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Re}he.settled=Y;function fe(be){return new Promise(async(ke,Re)=>{try{await be(ke,Re)}catch(ze){Re(ze)}})}he.withAsyncBody=fe})(x=e.Promises||(e.Promises={}));var Q;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(fe=>{fe.emitMany(Y)})}static fromPromise(Y){return new K(async fe=>{fe.emitMany(await Y)})}static fromPromises(Y){return new K(async fe=>{await Promise.all(Y.map(async be=>fe.emitOne(await be)))})}static merge(Y){return new K(async fe=>{await Promise.all(Y.map(async be=>{for await(const ke of be)fe.emitOne(ke)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const fe={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(fe)),this.resolve()}catch(be){this.reject(be)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,fe){return new K(async be=>{for await(const ke of Y)be.emitOne(fe(ke))})}map(Y){return K.map(this,Y)}static filter(Y,fe){return new K(async be=>{for await(const ke of Y)fe(ke)&&be.emitOne(ke)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,fe=>!!fe)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const fe=[];for await(const be of Y)fe.push(be);return fe}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class ue extends K{constructor(Y,fe){super(fe),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ue;function te(he){const Y=new c.CancellationTokenSource,fe=he(Y.token);return new ue(Y,async be=>{const ke=Y.token.onCancellationRequested(()=>{ke.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of fe){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}ke.dispose(),Y.dispose()}catch(Re){ke.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=te}),define(Ce[108],De([1,0,18,9]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new c.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),P=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(p,_,R=!1){const M=p||"",H=_||"",$=I.value.collator.compare(M,H);return I.value.collatorIsNumeric&&$===0&&M!==H?M<H?-1:1:$}e.compareFileNames=T;function S(p,_){const R=P.value.collator;return p=p||"",_=_||"",b(R,p,_)}e.compareFileNamesDefault=S;function D(p,_){const R=P.value.collator;return p=p||"",_=_||"",l(p,_)||b(R,p,_)}e.compareFileNamesUpper=D;function A(p,_){const R=P.value.collator;return p=p||"",_=_||"",s(p,_)||b(R,p,_)}e.compareFileNamesLower=A;function k(p,_){return p=p||"",_=_||"",p===_?0:p<_?-1:1}e.compareFileNamesUnicode=k;function E(p,_,R=!1){R||(p=p&&p.toLowerCase(),_=_&&_.toLowerCase());const[M,H]=m(p),[$,L]=m(_);return M!==$?M<$?-1:1:H===L?0:H<L?-1:1}e.noIntlCompareFileNames=E;function y(p,_){const[R,M]=m(p),[H,$]=m(_);let L=I.value.collator.compare(M,$);if(L===0){if(I.value.collatorIsNumeric&&M!==$)return M<$?-1:1;if(L=I.value.collator.compare(R,H),I.value.collatorIsNumeric&&L===0&&R!==H)return R<H?-1:1}return L}e.compareFileExtensions=y;function w(p,_){p=p||"",_=_||"";const R=r(p),M=r(_),H=P.value.collator,$=C.value.collator;return b($,R,M)||b(H,p,_)}e.compareFileExtensionsDefault=w;function h(p,_){p=p||"",_=_||"";const R=r(p),M=r(_),H=P.value.collator,$=C.value.collator;return b($,R,M)||l(p,_)||b(H,p,_)}e.compareFileExtensionsUpper=h;function g(p,_){p=p||"",_=_||"";const R=r(p),M=r(_),H=P.value.collator,$=C.value.collator;return b($,R,M)||s(p,_)||b(H,p,_)}e.compareFileExtensionsLower=g;function f(p,_){p=p||"",_=_||"";const R=r(p).toLowerCase(),M=r(_).toLowerCase();return R!==M?R<M?-1:1:p!==_?p<_?-1:1:0}e.compareFileExtensionsUnicode=f;const v=/^(.*?)(\.([^.]*))?$/;function m(p,_=!1){const R=p?v.exec(p):[];let M=[R&&R[1]||"",R&&R[3]||""];return _&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function r(p){const _=p?v.exec(p):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function b(p,_,R){const M=p.compare(_,R);return M!==0?M:_.length!==R.length?_.length<R.length?-1:1:0}function o(p){const _=p.charAt(0);return _.toLocaleUpperCase()!==_}function u(p){const _=p.charAt(0);return _.toLocaleLowerCase()!==_}function s(p,_){return o(p)&&u(_)?-1:u(p)&&o(_)?1:0}function l(p,_){return u(p)&&o(_)?-1:o(p)&&u(_)?1:0}function a(p,_,R=!1){return R||(p=p&&p.toLowerCase(),_=_&&_.toLowerCase()),p===_?0:p<_?-1:1}function d(p,_,R=!1){const M=p.split(t.sep),H=_.split(t.sep),$=M.length-1,L=H.length-1;let B,O;for(let z=0;;z++){if(B=$===z,O=L===z,B&&O)return T(M[z],H[z],R);if(B)return-1;if(O)return 1;const U=a(M[z],H[z],R);if(U!==0)return U}}e.comparePaths=d;function n(p,_,R){const M=p.toLowerCase(),H=_.toLowerCase(),$=i(p,_,R);if($)return $;const L=M.endsWith(R),B=H.endsWith(R);if(L!==B)return L?-1:1;const O=T(M,H);return O!==0?O:M.localeCompare(H)}e.compareAnything=n;function i(p,_,R){const M=p.toLowerCase(),H=_.toLowerCase(),$=M.startsWith(R),L=H.startsWith(R);if($!==L)return $?-1:1;if($&&L){if(M.length<H.length)return-1;if(M.length>H.length)return 1}return 0}e.compareByPrefix=i}),define(Ce[109],De([1,0,108,107,81,9,10,8]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,D=[S,[]];function A(U,F,V,x){if(!U||!F)return D;const Q=U.length,K=F.length;if(Q<K)return D;const ue=U.toLowerCase();return k(F,V,K,U,ue,Q,x)}e.scoreFuzzy=A;function k(U,F,V,x,Q,K,ue){const te=[],he=[];for(let ke=0;ke<V;ke++){const Re=ke*K,ze=Re-K,oe=ke>0,le=U[ke],ge=F[ke];for(let Z=0;Z<K;Z++){const ae=Z>0,ne=Re+Z,ie=ne-1,N=ze+Z-1,j=ae?te[ie]:0,G=oe&&ae?te[N]:0,X=oe&&ae?he[N]:0;let pe;!G&&oe?pe=0:pe=E(le,ge,x,Q,Z,X),pe&&G+pe>=j&&(ue||oe||Q.startsWith(F,Z))?(he[ne]=X+1,te[ne]=G+pe):(he[ne]=S,te[ne]=j)}}const Y=[];let fe=V-1,be=K-1;for(;fe>=0&&be>=0;){const ke=fe*K+be;he[ke]===S||(Y.push(be),fe--),be--}return[te[V*K-1],Y.reverse()]}function E(U,F,V,x,Q,K){let ue=0;if(!y(F,x[Q]))return ue;if(ue+=1,K>0&&(ue+=K*5),U===V[Q]&&(ue+=1),Q===0)ue+=8;else{const te=w(V.charCodeAt(Q-1));te?ue+=te:(0,t.isUpper)(V.charCodeAt(Q))&&K===0&&(ue+=2)}return ue}function y(U,F){return U===F?!0:U==="/"||U==="\\"?F==="/"||F==="\\":!1}function w(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function g(U,F,V=0,x=0){const Q=F;return Q.values&&Q.values.length>1?f(U,Q.values,V,x):v(U,F,V,x)}e.scoreFuzzy2=g;function f(U,F,V,x){let Q=0;const K=[];for(const ue of F){const[te,he]=v(U,ue,V,x);if(typeof te!="number")return h;Q+=te,K.push(...he)}return[Q,i(K)]}function v(U,F,V,x){const Q=(0,t.fuzzyScore)(F.original,F.originalLowercase,V,U,U.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:h}const m=Object.freeze({score:0}),r=1<<18,b=1<<17,o=1<<16;function u(U,F,V,x){const Q=x.values?x.values:[x];return(0,I.hash)({[x.normalized]:{values:Q.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:U,description:F,allowNonContiguousMatches:V}})}function s(U,F,V,x,Q){if(!U||!F.normalized)return m;const K=x.getItemLabel(U);if(!K)return m;const ue=x.getItemDescription(U),te=u(K,ue,V,F),he=Q[te];if(he)return he;const Y=l(K,ue,x.getItemPath(U),F,V);return Q[te]=Y,Y}e.scoreItemFuzzy=s;function l(U,F,V,x,Q){const K=!V||!x.containsPathSeparator;return V&&(C.isLinux?x.pathNormalized===V:(0,T.equalsIgnoreCase)(x.pathNormalized,V))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:F?[{start:0,end:F.length}]:void 0}:x.values&&x.values.length>1?a(U,F,V,x.values,K,Q):d(U,F,V,x,K,Q)}function a(U,F,V,x,Q,K){let ue=0;const te=[],he=[];for(const Y of x){const{score:fe,labelMatch:be,descriptionMatch:ke}=d(U,F,V,Y,Q,K);if(fe===S)return m;ue+=fe,be&&te.push(...be),ke&&he.push(...ke)}return{score:ue,labelMatch:i(te),descriptionMatch:i(he)}}function d(U,F,V,x,Q,K){if(Q||!F){const[ue,te]=A(U,x.normalized,x.normalizedLowercase,K&&!x.expectContiguousMatch);if(ue){const he=(0,t.matchesPrefix)(x.normalized,U);let Y;return he?(Y=b,Y+=Math.round(x.normalized.length/U.length*100)):Y=o,{score:Y+ue,labelMatch:he||n(te)}}}if(F){let ue=F;V&&(ue=`${F}${P.sep}`);const te=ue.length,he=`${ue}${U}`,[Y,fe]=A(he,x.normalized,x.normalizedLowercase,K&&!x.expectContiguousMatch);if(Y){const be=n(fe),ke=[],Re=[];return be.forEach(ze=>{ze.start<te&&ze.end>te?(ke.push({start:0,end:ze.end-te}),Re.push({start:ze.start,end:te})):ze.start>=te?ke.push({start:ze.start-te,end:ze.end-te}):Re.push(ze)}),{score:Y,labelMatch:ke,descriptionMatch:Re}}}return m}function n(U){const F=[];if(!U)return F;let V;for(const x of U)V&&V.end===x?V.end+=1:(V={start:x,end:x+1},F.push(V));return F}function i(U){const F=U.sort((Q,K)=>Q.start-K.start),V=[];let x;for(const Q of F)!x||!p(x,Q)?(x=Q,V.push(Q)):(x.start=Math.min(x.start,Q.start),x.end=Math.max(x.end,Q.end));return V}function p(U,F){return!(U.end<F.start||F.end<U.start)}function _(U,F,V,x,Q,K){const ue=s(U,V,x,Q,K),te=s(F,V,x,Q,K),he=ue.score,Y=te.score;if((he===r||Y===r)&&he!==Y)return he===r?-1:1;if(he>o||Y>o){if(he!==Y)return he>Y?-1:1;if(he<b&&Y<b){const le=M(ue.labelMatch,te.labelMatch);if(le!==0)return le}const ze=Q.getItemLabel(U)||"",oe=Q.getItemLabel(F)||"";if(ze.length!==oe.length)return ze.length-oe.length}if(he!==Y)return he>Y?-1:1;const fe=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,be=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(fe&&!be)return-1;if(be&&!fe)return 1;const ke=R(U,ue,Q),Re=R(F,te,Q);return ke&&Re&&ke!==Re?Re>ke?-1:1:H(U,F,V,Q)}e.compareItemsByFuzzyScore=_;function R(U,F,V){let x=-1,Q=-1;if(F.descriptionMatch&&F.descriptionMatch.length?x=F.descriptionMatch[0].start:F.labelMatch&&F.labelMatch.length&&(x=F.labelMatch[0].start),F.labelMatch&&F.labelMatch.length){if(Q=F.labelMatch[F.labelMatch.length-1].end,F.descriptionMatch&&F.descriptionMatch.length){const K=V.getItemDescription(U);K&&(Q+=K.length)}}else F.descriptionMatch&&F.descriptionMatch.length&&(Q=F.descriptionMatch[F.descriptionMatch.length-1].end);return Q-x}function M(U,F){if(!U&&!F||(!U||!U.length)&&(!F||!F.length))return 0;if(!F||!F.length)return-1;if(!U||!U.length)return 1;const V=U[0].start,Q=U[U.length-1].end-V,K=F[0].start,te=F[F.length-1].end-K;return Q===te?0:te<Q?1:-1}function H(U,F,V,x){const Q=x.getItemLabel(U)||"",K=x.getItemLabel(F)||"",ue=x.getItemDescription(U),te=x.getItemDescription(F),he=Q.length+(ue?ue.length:0),Y=K.length+(te?te.length:0);if(he!==Y)return he-Y;const fe=x.getItemPath(U),be=x.getItemPath(F);return fe&&be&&fe.length!==be.length?fe.length-be.length:Q!==K?(0,c.compareAnything)(Q,K,V.normalized):ue&&te&&ue!==te?(0,c.compareAnything)(ue,te,V.normalized):fe&&be&&fe!==be?(0,c.compareAnything)(fe,be,V.normalized):0}function $(U){return U.startsWith('"')&&U.endsWith('"')}const L=" ";function B(U){typeof U!="string"&&(U="");const F=U.toLowerCase(),{pathNormalized:V,normalized:x,normalizedLowercase:Q}=O(U),K=V.indexOf(P.sep)>=0,ue=$(U);let te;const he=U.split(L);if(he.length>1)for(const Y of he){const fe=$(Y),{pathNormalized:be,normalized:ke,normalizedLowercase:Re}=O(Y);ke&&(te||(te=[]),te.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Re,expectContiguousMatch:fe}))}return{original:U,originalLowercase:F,pathNormalized:V,normalized:x,normalizedLowercase:Q,values:te,containsPathSeparator:K,expectContiguousMatch:ue}}e.prepareQuery=B;function O(U){let F;C.isWindows?F=U.replace(/\//g,P.sep):F=U.replace(/\\/g,P.sep);const V=(0,T.stripWildcards)(F).replace(/\s|"/g,"");return{pathNormalized:F,normalized:V,normalizedLowercase:V.toLowerCase()}}function z(U){return Array.isArray(U)?B(U.map(F=>F.original).join(L)):B(U.original)}e.pieceToQuery=z}),define(Ce[37],De([1,0,17,18,32,28,9,10,8]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",k="[^/\\\\]",E=/\//g;function y(V,x){switch(V){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${x?`|${A}${k}+`:""})*?`}}function w(V,x){if(!V)return[];const Q=[];let K=!1,ue=!1,te="";for(const he of V){switch(he){case x:if(!K&&!ue){Q.push(te),te="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}te+=he}return te&&Q.push(te),Q}e.splitGlobAware=w;function h(V){if(!V)return"";let x="";const Q=w(V,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))x=".*";else{let K=!1;Q.forEach((ue,te)=>{if(ue===e.GLOBSTAR){if(K)return;x+=y(2,te===Q.length-1)}else{let he=!1,Y="",fe=!1,be="";for(const ke of ue){if(ke!=="}"&&he){Y+=ke;continue}if(fe&&(ke!=="]"||!be)){let Re;ke==="-"?Re=ke:(ke==="^"||ke==="!")&&!be?Re="^":ke===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(ke),be+=Re;continue}switch(ke){case"{":he=!0;continue;case"[":fe=!0;continue;case"}":{x+=`(?:${w(Y,",").map(oe=>h(oe)).join("|")})`,he=!1,Y="";break}case"]":{x+="["+be+"]",fe=!1,be="";break}case"?":x+=k;continue;case"*":x+=y(1);continue;default:x+=(0,S.escapeRegExpCharacters)(ke)}}te<Q.length-1&&(Q[te+1]!==e.GLOBSTAR||te+2<Q.length)&&(x+=A)}K=ue===e.GLOBSTAR})}return x}const g=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new P.LRUCache(1e4),u=function(){return!1},s=function(){return null};function l(V,x){if(!V)return s;let Q;typeof V!="string"?Q=V.pattern:Q=V,Q=Q.trim();const K=`${Q}_${!!x.trimForExclusions}`;let ue=o.get(K);if(ue)return a(ue,V);let te;return g.test(Q)?ue=n(Q.substr(4),Q):(te=f.exec(d(Q,x)))?ue=i(te[1],Q):(x.trimForExclusions?m:v).test(Q)?ue=p(Q,x):(te=r.exec(d(Q,x)))?ue=_(te[1].substr(1),Q,!0):(te=b.exec(d(Q,x)))?ue=_(te[1],Q,!1):ue=R(Q),o.set(K,ue),a(ue,V)}function a(V,x){if(typeof x=="string")return V;const Q=function(K,ue){return(0,I.isEqualOrParent)(K,x.base,!T.isLinux)?V(K.substr(x.base.length+1),ue):null};return Q.allBasenames=V.allBasenames,Q.allPaths=V.allPaths,Q.basenames=V.basenames,Q.patterns=V.patterns,Q}function d(V,x){return x.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function n(V,x){return function(Q,K){return typeof Q=="string"&&Q.endsWith(V)?x:null}}function i(V,x){const Q=`/${V}`,K=`\\${V}`,ue=function(he,Y){return typeof he!="string"?null:Y?Y===V?x:null:he===V||he.endsWith(Q)||he.endsWith(K)?x:null},te=[V];return ue.basenames=te,ue.patterns=[x],ue.allBasenames=te,ue}function p(V,x){const Q=U(V.slice(1,-1).split(",").map(Y=>l(Y,x)).filter(Y=>Y!==s),V),K=Q.length;if(!K)return s;if(K===1)return Q[0];const ue=function(Y,fe){for(let be=0,ke=Q.length;be<ke;be++)if(Q[be](Y,fe))return V;return null},te=Q.find(Y=>!!Y.allBasenames);te&&(ue.allBasenames=te.allBasenames);const he=Q.reduce((Y,fe)=>fe.allPaths?Y.concat(fe.allPaths):Y,[]);return he.length&&(ue.allPaths=he),ue}function _(V,x,Q){const K=C.sep===C.posix.sep,ue=K?V:V.replace(E,C.sep),te=C.sep+ue,he=C.posix.sep+V;let Y;return Q?Y=function(fe,be){return typeof fe=="string"&&(fe===ue||fe.endsWith(te)||!K&&(fe===V||fe.endsWith(he)))?x:null}:Y=function(fe,be){return typeof fe=="string"&&(fe===ue||!K&&fe===V)?x:null},Y.allPaths=[(Q?"*/":"./")+V],Y}function R(V){try{const x=new RegExp(`^${h(V)}$`);return function(Q){return x.lastIndex=0,typeof Q=="string"&&x.test(Q)?V:null}}catch{return s}}function M(V,x,Q){return!V||typeof x!="string"?!1:H(V)(x,void 0,Q)}e.match=M;function H(V,x={}){if(!V)return u;if(typeof V=="string"||$(V)){const Q=l(V,x);if(Q===s)return u;const K=function(ue,te){return!!Q(ue,te)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return O(V,x)}e.parse=H;function $(V){const x=V;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=$;function L(V){return V.allBasenames||[]}e.getBasenameTerms=L;function B(V){return V.allPaths||[]}e.getPathTerms=B;function O(V,x){const Q=U(Object.getOwnPropertyNames(V).map(Y=>z(Y,V[Y],x)).filter(Y=>Y!==s)),K=Q.length;if(!K)return s;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(ke,Re){let ze;for(let oe=0,le=Q.length;oe<le;oe++){const ge=Q[oe](ke,Re);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(ze||(ze=[]),ze.push(ge))}return ze?(async()=>{for(const oe of ze){const le=await oe;if(typeof le=="string")return le}return null})():null},fe=Q.find(ke=>!!ke.allBasenames);fe&&(Y.allBasenames=fe.allBasenames);const be=Q.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return be.length&&(Y.allPaths=be),Y}const ue=function(Y,fe,be){let ke,Re;for(let ze=0,oe=Q.length;ze<oe;ze++){const le=Q[ze];le.requiresSiblings&&be&&(fe||(fe=(0,C.basename)(Y)),ke||(ke=fe.substr(0,fe.length-(0,C.extname)(Y).length)));const ge=le(Y,fe,ke,be);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(Re||(Re=[]),Re.push(ge))}return Re?(async()=>{for(const ze of Re){const oe=await ze;if(typeof oe=="string")return oe}return null})():null},te=Q.find(Y=>!!Y.allBasenames);te&&(ue.allBasenames=te.allBasenames);const he=Q.reduce((Y,fe)=>fe.allPaths?Y.concat(fe.allPaths):Y,[]);return he.length&&(ue.allPaths=he),ue}function z(V,x,Q){if(x===!1)return s;const K=l(V,Q);if(K===s)return s;if(typeof x=="boolean")return K;if(x){const ue=x.when;if(typeof ue=="string"){const te=(he,Y,fe,be)=>{if(!be||!K(he,Y))return null;const ke=ue.replace("$(basename)",fe),Re=be(ke);return(0,t.isThenable)(Re)?Re.then(ze=>ze?V:null):Re?V:null};return te.requiresSiblings=!0,te}}return K}function U(V,x){const Q=V.filter(Y=>!!Y.basenames);if(Q.length<2)return V;const K=Q.reduce((Y,fe)=>{const be=fe.basenames;return be?Y.concat(be):Y},[]);let ue;if(x){ue=[];for(let Y=0,fe=K.length;Y<fe;Y++)ue.push(x)}else ue=Q.reduce((Y,fe)=>{const be=fe.patterns;return be?Y.concat(be):Y},[]);const te=function(Y,fe){if(typeof Y!="string")return null;if(!fe){let ke;for(ke=Y.length;ke>0;ke--){const Re=Y.charCodeAt(ke-1);if(Re===47||Re===92)break}fe=Y.substr(ke)}const be=K.indexOf(fe);return be!==-1?ue[be]:null};te.basenames=K,te.patterns=ue,te.allBasenames=K;const he=V.filter(Y=>!Y.basenames);return he.push(te),he}function F(V,x){return(0,c.equals)(V,x,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=F}),define(Ce[110],De([1,0,11,158,22,8,2]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(f="",v=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(f,v=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(m,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,v){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(f,v,m){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(f),")"),m&&(this.value+=` "${this._escape(this._escape(m,'"'),")")}"`),this.value+=")",this}_escape(f,v){const m=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return f.replace(m,(r,b)=>f.charAt(b-1)!=="\\"?`\\${r}`:r)}}e.MarkdownString=S;function D(g){return A(g)?!g.value:Array.isArray(g)?g.every(D):!0}e.isEmptyMarkdownString=D;function A(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function k(g,f){return g===f?!0:!g||!f?!1:g.value===f.value&&g.isTrusted===f.isTrusted&&g.supportThemeIcons===f.supportThemeIcons&&g.supportHtml===f.supportHtml&&(g.baseUri===f.baseUri||!!g.baseUri&&!!f.baseUri&&(0,I.isEqual)(C.URI.from(g.baseUri),C.URI.from(f.baseUri)))}e.markdownStringEqual=k;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function y(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function w(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function h(g){const f=[],v=g.split("|").map(r=>r.trim());g=v[0];const m=v[1];if(m){const r=/height=(\d+)/.exec(m),b=/width=(\d+)/.exec(m),o=r?r[1]:"",u=b?b[1]:"",s=isFinite(parseInt(u)),l=isFinite(parseInt(o));s&&f.push(`width="${u}"`),l&&f.push(`height="${o}"`)}return{href:g,dimensions:f}}e.parseHrefAndDimensions=h}),define(Ce[111],De([1,0,17,32,9,10,22,8]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(s,l){const{os:a,tildify:d,relative:n}=l;if(n){const _=D(s,n,a);if(typeof _=="string")return _}let i=s.fsPath;if(a===1&&!P.isWindows?i=i.replace(/\//g,"\\"):a!==1&&P.isWindows&&(i=i.replace(/\\/g,"/")),a!==1&&d?.userHome){const _=d.userHome.fsPath;let R;s.scheme!==d.userHome.scheme&&s.path.startsWith(I.posix.sep)?R=d.userHome.with({path:s.path}).fsPath:R=s.fsPath,i=E(R,_,a)}return(a===1?I.win32:I.posix).normalize(A(i,a===1))}e.getPathLabel=S;function D(s,l,a){const d=a===1?I.win32:I.posix,n=a===3?C.extUri:C.extUriIgnorePathCase,i=l.getWorkspace(),p=(0,c.firstOrDefault)(i.folders);if(!p)return;s.scheme!==p.uri.scheme&&s.path.startsWith(I.posix.sep)&&(s=p.uri.with({path:s.path}));const _=l.getWorkspaceFolder(s);if(!_)return;let R;if(n.isEqual(_.uri,s)?R="":R=n.relativePath(_.uri,s)??"",R&&(R=d.normalize(R)),i.folders.length>1&&!l.noPrefix){const M=_.name?_.name:n.basenameOrAuthority(_.uri);R=R?`${M} \u2022 ${R}`:M}return R}function A(s,l=P.isWindows){return(0,t.hasDriveLetter)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=A;let k=Object.create(null);function E(s,l,a=P.OS){if(a===1||!s||!l)return s;let d=k.original===l?k.normalized:void 0;d||(d=l,P.isWindows&&(d=(0,t.toSlashes)(d)),d=`${(0,T.rtrim)(d,I.posix.sep)}${I.posix.sep}`,k={original:l,normalized:d});let n=s;return P.isWindows&&(n=(0,t.toSlashes)(n)),(a===3?n.startsWith(d):(0,T.startsWithIgnoreCase)(n,d))?`~/${n.substr(d.length)}`:s}e.tildify=E;function y(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=y;const w="\u2026",h="\\\\",g="~";function f(s,l=I.sep){const a=new Array(s.length);let d=!1;for(let n=0;n<s.length;n++){const i=s[n];if(i===""){a[n]=`.${l}`;continue}if(!i){a[n]=i;continue}d=!0;let p="",_=i;_.indexOf(h)===0?(p=_.substr(0,_.indexOf(h)+h.length),_=_.substr(_.indexOf(h)+h.length)):_.indexOf(l)===0?(p=_.substr(0,_.indexOf(l)+l.length),_=_.substr(_.indexOf(l)+l.length)):_.indexOf(g)===0&&(p=_.substr(0,_.indexOf(g)+g.length),_=_.substr(_.indexOf(g)+g.length));const R=_.split(l);for(let M=1;d&&M<=R.length;M++)for(let H=R.length-M;d&&H>=0;H--){d=!1;let $=R.slice(H,H+M).join(l);for(let L=0;!d&&L<s.length;L++)if(L!==n&&s[L]&&s[L].indexOf($)>-1){const B=H+M===R.length,O=H>0&&s[L].indexOf(l)>-1?l+$:$,z=s[L].endsWith(O);d=!B||z}if(!d){let L="";(R[0].endsWith(":")||p!=="")&&(H===1&&(H=0,M++,$=R[0]+l+$),H>0&&(L=R[0]+l),L=p+L),H>0&&(L=L+w+l),L=L+$,H+M<R.length&&(L=L+l+w),a[n]=L}}d&&(a[n]=i)}return a}e.shorten=f;var v;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function m(s,l=Object.create(null)){const a=[];let d=!1,n="";for(const i of s)if(i==="$"||d&&i==="{")n&&a.push({value:n,type:v.TEXT}),n="",d=!0;else if(i==="}"&&d){const p=l[n];if(typeof p=="string")p.length&&a.push({value:p,type:v.VARIABLE});else if(p){const _=a[a.length-1];(!_||_.type!==v.SEPARATOR)&&a.push({value:p.label,type:v.SEPARATOR})}n="",d=!1}else n+=i;return n&&!d&&a.push({value:n,type:v.TEXT}),a.filter((i,p)=>{if(i.type===v.SEPARATOR){const _=a[p-1],R=a[p+1];return[_,R].every(M=>M&&(M.type===v.VARIABLE||M.type===v.TEXT)&&M.value.length>0)}return!0}).map(i=>i.value).join("")}e.template=m;function r(s,l){return P.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):s.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=r;function b(s,l){return P.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):P.isWindows?s.replace(/&&|&/g,a=>a==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function o(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=o;function u(s){const l=s.indexOf("/")!==-1?I.posix:I.win32,a=l.basename(s),d=l.dirname(s);return a.length?{name:a,parentPath:d}:{name:d,parentPath:""}}e.splitName=u}),define(Ce[112],De([1,0,2]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(A){return A.toJSON()}class I{constructor(k){this._uriTransformer=k}transformIncoming(k){const E=this._uriTransformer.transformIncoming(k);return E===k?k:t(c.URI.from(E))}transformOutgoing(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:t(c.URI.from(E))}transformOutgoingURI(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:c.URI.from(E)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,k,E){if(!A||E>200)return null;if(typeof A=="object"){if(A instanceof c.URI)return k.transformOutgoing(A);for(const y in A)if(Object.hasOwnProperty.call(A,y)){const w=P(A[y],k,E+1);w!==null&&(A[y]=w)}}return null}function C(A,k){const E=P(A,k,0);return E===null?A:E}e.transformOutgoingURIs=C;function T(A,k,E,y){if(!A||y>200)return null;if(typeof A=="object"){if(A.$mid===1)return E?c.URI.revive(k.transformIncoming(A)):k.transformIncoming(A);for(const w in A)if(Object.hasOwnProperty.call(A,w)){const h=T(A[w],k,E,y+1);h!==null&&(A[w]=h)}}return null}function S(A,k){const E=T(A,k,!1,0);return E===null?A:E}e.transformIncomingURIs=S;function D(A,k){const E=T(A,k,!0,0);return E===null?A:E}e.transformAndReviveIncomingURIs=D}),define(Ce[29],De([1,0,64,83,307,18,32,80,9,10,22,2]),function(J,e,c,t,I,P,C,T,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function y(O,z=E.UNLINK){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===E.UNLINK?h(O):w(O)}async function w(O){try{const z=(0,C.randomPath)((0,t.tmpdir)());try{await c.promises.rename(O,z)}catch(U){return U.code==="ENOENT"?void 0:h(O)}h(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function h(O){return(0,I.promisify)(c.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function g(O){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function f(O,z){return r(await(z?v(O):(0,I.promisify)(c.readdir)(O)))}async function v(O){try{return await(0,I.promisify)(c.readdir)(O,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const z=[],U=await f(O);for(const F of U){let V=!1,x=!1,Q=!1;try{const K=await e.Promises.lstat((0,S.join)(O,F));V=K.isFile(),x=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}z.push({name:F,isFile:()=>V,isDirectory:()=>x,isSymbolicLink:()=>Q})}return z}function m(O){return r(c.readdirSync(O))}e.readdirSync=m;function r(O){return O.map(z=>typeof z=="string"?D.isMacintosh?(0,T.normalizeNFC)(z):z:(z.name=D.isMacintosh?(0,T.normalizeNFC)(z.name):z.name,z))}async function b(O){const z=await f(O),U=[];for(const F of z)await u.existsDirectory((0,S.join)(O,F))&&U.push(F);return U}function o(O,z=1e3){return new Promise(U=>{let F=!1;const V=setInterval(()=>{F||(F=!0,c.access(O,x=>{F=!1,x&&(clearInterval(V),U(void 0))}))},z)})}e.whenDeleted=o;var u;(function(O){async function z(V){let x;try{if(x=await e.Promises.lstat(V),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(D.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw K}throw Q}}O.stat=z;async function U(V){try{const{stat:x,symbolicLink:Q}=await O.stat(V);return x.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=U;async function F(V){try{const{stat:x,symbolicLink:Q}=await O.stat(V);return x.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=F})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new P.ResourceQueue;function l(O,z,U){return s.queueFor(k.URI.file(O),A.extUriBiasedIgnorePathCase).queue(()=>{const F=p(U);return new Promise((V,x)=>n(O,z,F,Q=>Q?x(Q):V()))})}let a=!0;function d(O){a=O}e.configureFlushOnWrite=d;function n(O,z,U,F){if(!a)return c.writeFile(O,z,{mode:U.mode,flag:U.flag},F);c.open(O,U.flag,U.mode,(V,x)=>{if(V)return F(V);c.writeFile(x,z,Q=>{if(Q)return c.close(x,()=>F(Q));c.fdatasync(x,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),d(!1)),c.close(x,ue=>F(ue))))})})}function i(O,z,U){const F=p(U);if(!a)return c.writeFileSync(O,z,{mode:F.mode,flag:F.flag});const V=c.openSync(O,F.flag,F.mode);try{c.writeFileSync(V,z);try{c.fdatasyncSync(V)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),d(!1)}}finally{c.closeSync(V)}}e.writeFileSync=i;function p(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function _(O,z){if(O!==z)try{await e.Promises.rename(O,z)}catch(U){if(O.toLowerCase()!==z.toLowerCase()&&U.code==="EXDEV"||O.endsWith("."))await R(O,z,{preserveSymlinks:!1}),await y(O,E.MOVE);else throw U}}async function R(O,z,U){return H(O,z,{root:{source:O,target:z},options:U,handledSourcePaths:new Set})}const M=511;async function H(O,z,U){if(U.handledSourcePaths.has(O))return;U.handledSourcePaths.add(O);const{stat:F,symbolicLink:V}=await u.stat(O);if(V){if(U.options.preserveSymlinks)try{return await B(O,z,U)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(V.dangling)return}return F.isDirectory()?$(O,z,F.mode&M,U):L(O,z,F.mode&M)}async function $(O,z,U,F){await e.Promises.mkdir(z,{recursive:!0,mode:U});const V=await f(O);for(const x of V)await H((0,S.join)(O,x),(0,S.join)(z,x),F)}async function L(O,z,U){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,U)}async function B(O,z,U){let F=await e.Promises.readlink(O);(0,C.isEqualOrParent)(F,U.root.source,!D.isLinux)&&(F=(0,S.join)(U.root.target,F.substr(U.root.source.length+1))),await e.Promises.symlink(F,z)}e.Promises=new class{get access(){return(0,I.promisify)(c.access)}get stat(){return(0,I.promisify)(c.stat)}get lstat(){return(0,I.promisify)(c.lstat)}get utimes(){return(0,I.promisify)(c.utimes)}get read(){return(O,z,U,F,V)=>new Promise((x,Q)=>{c.read(O,z,U,F,V,(K,ue,te)=>K?Q(K):x({bytesRead:ue,buffer:te}))})}get readFile(){return(0,I.promisify)(c.readFile)}get write(){return(O,z,U,F,V)=>new Promise((x,Q)=>{c.write(O,z,U,F,V,(K,ue,te)=>K?Q(K):x({bytesWritten:ue,buffer:te}))})}get appendFile(){return(0,I.promisify)(c.appendFile)}get fdatasync(){return(0,I.promisify)(c.fdatasync)}get truncate(){return(0,I.promisify)(c.truncate)}get rename(){return(0,I.promisify)(c.rename)}get copyFile(){return(0,I.promisify)(c.copyFile)}get open(){return(0,I.promisify)(c.open)}get close(){return(0,I.promisify)(c.close)}get symlink(){return(0,I.promisify)(c.symlink)}get readlink(){return(0,I.promisify)(c.readlink)}get chmod(){return(0,I.promisify)(c.chmod)}get mkdir(){return(0,I.promisify)(c.mkdir)}get unlink(){return(0,I.promisify)(c.unlink)}get rmdir(){return(0,I.promisify)(c.rmdir)}get realpath(){return(0,I.promisify)(c.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return b}get writeFile(){return l}get rm(){return y}get move(){return _}get copy(){return R}}}),define(Ce[113],De([1,0,64,9,10,8,29]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,C.readdirSync)(y).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=T(y);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const v=T(y);if(v)return(0,t.join)(v,g[f])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(await C.Promises.readdir(y)).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=await S(y);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const v=await S(y);if(v)return(0,t.join)(v,g[f])}}}catch{}return null}e.realcase=S;async function D(E){try{return await C.Promises.realpath(E)}catch{const w=k(E);return await C.Promises.access(w,c.constants.R_OK),w}}e.realpath=D;function A(E){try{return c.realpathSync(E)}catch{const w=k(E);return c.accessSync(w,c.constants.R_OK),w}}e.realpathSync=A;function k(E){return(0,P.rtrim)((0,t.normalize)(E),t.sep)}}),define(Ce[114],De([1,0,9,10,36,106,12,29]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function S(k=I.env){return k.comspec||"cmd.exe"}e.getWindowsShell=S;function D(k){let E=[],y=!1;const w=function(h){if(y){E.push(h);return}(!k.send(h,f=>{if(f&&console.error(f),y=!1,E.length>0){const v=E.slice(0);E=[],v.forEach(m=>w(m))}})||t.isWindows)&&(y=!0)};return{send:w}}e.createQueuedSender=D;var A;(function(k){async function E(y,w,h){if(c.isAbsolute(y))return y;if(w===void 0&&(w=I.cwd()),c.dirname(y)!=="."||(h===void 0&&C.isString(I.env.PATH)&&(h=I.env.PATH.split(c.delimiter)),h===void 0||h.length===0))return c.join(w,y);async function f(v){if(await T.Promises.exists(v)){let m;try{m=await T.Promises.stat(v)}catch(r){r.message.startsWith("EACCES")&&(m=await T.Promises.lstat(v))}return m?!m.isDirectory():!1}return!1}for(const v of h){let m;if(c.isAbsolute(v)?m=c.join(v,y):m=c.join(w,v,y),await f(m))return m;let r=m+".com";if(await f(r)||(r=m+".exe",await f(r)))return r}return c.join(w,y)}k.findExecutable=E})(A=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(J,e,c,t){var I=arguments.length,P=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,c,t);else for(var T=J.length-1;T>=0;T--)(C=J[T])&&(P=(I<3?C(P):I>3?C(e,c,P):C(e,c))||P);return I>3&&P&&Object.defineProperty(e,c,P),P};define(Ce[115],De([1,0,17,18,23,21,59,11,4,6,82,8,12]),function(J,e,c,t,I,P,C,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function w(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));class v{constructor(x){this.buffer=x,this.pos=0}read(x){const Q=this.buffer.slice(this.pos,this.pos+x);return this.pos+=Q.byteLength,Q}}class m{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(r||(r={}));function b(V){const x=I.VSBuffer.alloc(4);return x.writeUInt32BE(V,0),x}function o(V){return V.read(4).readUInt32BE(0)}function u(V){const x=I.VSBuffer.alloc(1);return x.writeUInt8(V,0),x}const s={Undefined:u(r.Undefined),String:u(r.String),Buffer:u(r.Buffer),VSBuffer:u(r.VSBuffer),Array:u(r.Array),Object:u(r.Object)},l=typeof Buffer<"u";function a(V,x){if(typeof x>"u")V.write(s.Undefined);else if(typeof x=="string"){const Q=I.VSBuffer.fromString(x);V.write(s.String),V.write(b(Q.byteLength)),V.write(Q)}else if(l&&Buffer.isBuffer(x)){const Q=I.VSBuffer.wrap(x);V.write(s.Buffer),V.write(b(Q.byteLength)),V.write(Q)}else if(x instanceof I.VSBuffer)V.write(s.VSBuffer),V.write(b(x.byteLength)),V.write(x);else if(Array.isArray(x)){V.write(s.Array),V.write(b(x.length));for(const Q of x)a(V,Q)}else{const Q=I.VSBuffer.fromString(JSON.stringify(x));V.write(s.Object),V.write(b(Q.byteLength)),V.write(Q)}}function d(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(o(V)).toString();case r.Buffer:return V.read(o(V)).buffer;case r.VSBuffer:return V.read(o(V));case r.Array:{const Q=o(V),K=[];for(let ue=0;ue<Q;ue++)K.push(d(V));return K}case r.Object:return JSON.parse(V.read(o(V)).toString())}}class n{constructor(x,Q,K=null,ue=1e3){this.protocol=x,this.ctx=Q,this.logger=K,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:200})}registerChannel(x,Q){this.channels.set(x,Q),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const Q=this.send([x.type]);this.logger?.logOutgoing(Q,0,1,g(x.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(Q,x.id,1,g(x.type),x.data);return}}}send(x,Q=void 0){const K=new m;return a(K,x),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const Q=new v(x),K=d(Q),ue=d(Q),te=K[0];switch(te){case 100:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(te)}: ${K[2]}.${K[3]}`,ue),this.onPromise({type:te,id:K[1],channelName:K[2],name:K[3],arg:ue});case 102:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(te)}: ${K[2]}.${K[3]}`,ue),this.onEventListen({type:te,id:K[1],channelName:K[2],name:K[3],arg:ue});case 101:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(te)}`),this.disposeActiveRequest({type:te,id:K[1]});case 103:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(te)}`),this.disposeActiveRequest({type:te,id:K[1]})}}onPromise(x){const Q=this.channels.get(x.channelName);if(!Q){this.collectPendingRequest(x);return}const K=new P.CancellationTokenSource;let ue;try{ue=Q.call(this.ctx,x.name,x.arg,K.token)}catch(Y){ue=Promise.reject(Y)}const te=x.id;ue.then(Y=>{this.sendResponse({id:te,data:Y,type:201}),this.activeRequests.delete(x.id)},Y=>{Y instanceof Error?this.sendResponse({id:te,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:te,data:Y,type:203}),this.activeRequests.delete(x.id)});const he=(0,D.toDisposable)(()=>K.cancel());this.activeRequests.set(x.id,he)}onEventListen(x){const Q=this.channels.get(x.channelName);if(!Q){this.collectPendingRequest(x);return}const K=x.id,te=Q.listen(this.ctx,x.name,x.arg)(he=>this.sendResponse({id:K,data:he,type:204}));this.activeRequests.set(x.id,te)}disposeActiveRequest(x){const Q=this.activeRequests.get(x.id);Q&&(Q.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let Q=this.pendingRequests.get(x.channelName);Q||(Q=[],this.pendingRequests.set(x.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:x,timeoutTimer:K})}flushPendingRequests(x){const Q=this.pendingRequests.get(x);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=n;var i;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(i=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(x,Q=null){this.protocol=x,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel(x){const Q=this;return{call(K,ue,te){return Q.isDisposed?Promise.reject(new T.CancellationError):Q.requestPromise(x,K,ue,te)},listen(K,ue){return Q.isDisposed?S.Event.None:Q.requestEvent(x,K,ue)}}}requestPromise(x,Q,K,ue=P.CancellationToken.None){const te=this.lastRequestId++,Y={id:te,type:100,channelName:x,name:Q,arg:K};if(ue.isCancellationRequested)return Promise.reject(new T.CancellationError);let fe;return new Promise((ke,Re)=>{if(ue.isCancellationRequested)return Re(new T.CancellationError);const ze=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(te),ke(ae.data);break;case 202:{this.handlers.delete(te);const ne=new Error(ae.data.message);ne.stack=ae.data.stack,ne.name=ae.data.name,Re(ne);break}case 203:this.handlers.delete(te),Re(ae.data);break}};this.handlers.set(te,Z),this.sendRequest(Y)};let oe=null;this.state===f.Idle?ze():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,ze()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:te,type:101}),Re(new T.CancellationError)},ge=ue.onCancellationRequested(le);fe=(0,D.combinedDisposable)((0,D.toDisposable)(le),ge),this.activeRequests.add(fe)}).finally(()=>{this.activeRequests.delete(fe)})}requestEvent(x,Q,K){const ue=this.lastRequestId++,he={id:ue,type:102,channelName:x,name:Q,arg:K};let Y=null;const fe=new S.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(fe),this.sendRequest(he)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(fe),this.sendRequest({id:ue,type:103}))}}),be=ke=>fe.fire(ke.data);return this.handlers.set(ue,be),fe.event}sendRequest(x){switch(x.type){case 100:case 102:{const Q=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(Q,x.id,0,`${w(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const Q=this.send([x.type,x.id]);this.logger?.logOutgoing(Q,x.id,0,w(x.type));return}}}send(x,Q=void 0){const K=new m;return a(K,x),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const Q=new v(x),K=d(Q),ue=d(Q),te=K[0];switch(te){case 200:return this.logger?.logIncoming(x.byteLength,0,0,g(te)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,K[1],0,g(te),ue),this.onResponse({type:K[0],id:K[1],data:ue})}}onResponse(x){if(x.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([C.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class _{get connections(){const x=[];return this._connections.forEach(Q=>x.push(Q)),x}constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:Q,onDidClientDisconnect:K})=>{S.Event.once(Q.onMessage)(te=>{const he=new v(te),Y=d(he),fe=new n(Q,Y),be=new p(Q);this.channels.forEach((Re,ze)=>fe.registerChannel(ze,Re));const ke={channelServer:fe,channelClient:be,ctx:Y};this._connections.add(ke),this._onDidAddConnection.fire(ke),K(()=>{fe.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}getChannel(x,Q){const K=this;return{call(ue,te,he){let Y;if((0,E.isFunction)(Q)){const be=(0,c.getRandomElement)(K.connections.filter(Q));Y=be?Promise.resolve(be):S.Event.toPromise(S.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,ue,te);const fe=Y.then(be=>be.channelClient.getChannel(x));return M(fe).call(ue,te,he)},listen(ue,te){if((0,E.isFunction)(Q))return K.getMulticastEvent(x,Q,ue,te);const he=Q.routeEvent(K,ue,te).then(Y=>Y.channelClient.getChannel(x));return M(he).listen(ue,te)}}}getMulticastEvent(x,Q,K,ue){const te=this;let he=new D.DisposableStore;const Y=new S.Emitter({onFirstListenerAdd:()=>{he=new D.DisposableStore;const fe=new S.EventMultiplexer,be=new Map,ke=ze=>{const le=ze.channelClient.getChannel(x).listen(K,ue),ge=fe.add(le);be.set(ze,ge)},Re=ze=>{const oe=be.get(ze);!oe||(oe.dispose(),be.delete(ze))};te.connections.filter(Q).forEach(ke),S.Event.filter(te.onDidAddConnection,Q)(ke,void 0,he),te.onDidRemoveConnection(Re,void 0,he),fe.event(Y.fire,Y,he),he.add(fe)},onLastListenerRemove:()=>{he.dispose()}});return Y.event}registerChannel(x,Q){this.channels.set(x,Q),this._connections.forEach(K=>{K.channelServer.registerChannel(x,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class R{constructor(x,Q,K=null){const ue=new m;a(ue,Q),x.send(ue.buffer),this.channelClient=new p(x,K),this.channelServer=new n(x,Q,K)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,Q){this.channelServer.registerChannel(x,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function M(V){return{call(x,Q,K){return V.then(ue=>ue.call(x,Q,K))},listen(x,Q){const K=new S.Relay;return V.then(ue=>K.input=ue.listen(x,Q)),K.event}}}e.getDelayedChannel=M;function H(V){let x=!1;return{call(Q,K,ue){return x?V.call(Q,K,ue):(0,t.timeout)(0).then(()=>x=!0).then(()=>V.call(Q,K,ue))},listen(Q,K){if(x)return V.listen(Q,K);const ue=new S.Relay;return(0,t.timeout)(0).then(()=>x=!0).then(()=>ue.input=V.listen(Q,K)),ue.event}}}e.getNextTickChannel=H;class ${constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const Q of x.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=$;var L;(function(V){function x(te,he){const Y=te,fe=he&&he.disableMarshalling,be=new Map;for(const ke in Y)K(ke)&&be.set(ke,S.Event.buffer(Y[ke],!0));return new class{listen(ke,Re,ze){const oe=be.get(Re);if(oe)return oe;if(ue(Re)){const le=Y[Re];if(typeof le=="function")return le.call(Y,ze)}throw new Error(`Event not found: ${Re}`)}call(ke,Re,ze){const oe=Y[Re];if(typeof oe=="function"){if(!fe&&Array.isArray(ze))for(let le=0;le<ze.length;le++)ze[le]=(0,A.revive)(ze[le]);return oe.apply(Y,ze)}throw new Error(`Method not found: ${Re}`)}}}V.fromService=x;function Q(te,he){const Y=he&&he.disableMarshalling;return new Proxy({},{get(fe,be){if(typeof be=="string")return he?.properties?.has(be)?he.properties.get(be):ue(be)?function(ke){return te.listen(be,ke)}:K(be)?te.listen(be):async function(...ke){let Re;he&&!(0,E.isUndefinedOrNull)(he.context)?Re=[he.context,...ke]:Re=ke;const ze=await te.call(be,Re);return Y?ze:(0,A.revive)(ze)};throw new Error(`Property not found: ${String(be)}`)}})}V.toService=Q;function K(te){return te[0]==="o"&&te[1]==="n"&&k.isUpperAsciiLetter(te.charCodeAt(2))}function ue(te){return/^onDynamic/.test(te)&&k.isUpperAsciiLetter(te.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const x=V.toString();if(x!=="[object Object]")return x}return V}function z(V){return Array.isArray(V)?V.map(O):O(V)}function U(V,x,Q,K,ue,te,he){he=z(he);const Y=B[ue],fe=Y[K%Y.length];let be=[`%c[${V}]%c[${String(x).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${fe}`];/\($/.test(te)?(be=be.concat(he),be.push(")")):be.push(he),console.log.apply(console,be)}e.logWithColors=U;class F{constructor(x,Q){this._outgoingPrefix=x,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,Q,K,ue,te){this._totalOutgoing+=x,U(this._outgoingPrefix,this._totalOutgoing,x,Q,K,ue,te)}logIncoming(x,Q,K,ue,te){this._totalIncoming+=x,U(this._incomingPrefix,this._totalIncoming,x,Q,K,ue,te)}}e.IPCLogger=F}),define(Ce[116],De([1,0,23,4,6,115]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let d=0;function n(p,_){if(!a.has(p)){const R=String(++d);a.set(p,R)}return a.get(p)}function i(p,_,R,M){if(!l.enableDiagnostics)return;const H=n(p,_);if(M instanceof c.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const $=c.VSBuffer.alloc(M.byteLength);$.set(M),l.records.push({timestamp:Date.now(),id:H,label:_,type:R,buff:$})}else l.records.push({timestamp:Date.now(),id:H,label:_,type:R,data:M})}l.traceSocketEvent=i})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function A(){return D||(D=c.VSBuffer.alloc(0)),D}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,d){if(a===0)return A();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const _=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=a),_}if(this._chunks[0].byteLength>a){const _=this._chunks[0].slice(0,a);return d&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),_}const n=c.VSBuffer.alloc(a);let i=0,p=0;for(;a>0;){const _=this._chunks[p];if(_.byteLength>a){const R=_.slice(0,a);n.set(R,i),i+=a,d&&(this._chunks[p]=_.slice(a),this._totalLength-=a),a-=a}else n.set(_,i),i+=_.byteLength,d?(this._chunks.shift(),this._totalLength-=_.byteLength):p++,a-=_.byteLength}return n}}e.ChunkStream=k;var E;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(E||(E={}));function y(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(a,d,n,i){this.type=a,this.id=d,this.ack=n,this.data=i,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends I.Disposable{constructor(a){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const n=this._state.messageType,i=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new h(n,i,p,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=c.VSBuffer.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(d,a.data)}_bufferAdd(a,d){const n=this._totalLength===0;return this._data.push(a,d),this._totalLength+=a.byteLength+d.byteLength,n}_bufferTake(){const a=c.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,d){this._bufferAdd(a,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class v extends I.Disposable{constructor(a){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new h(1,0,0,a))}}e.Protocol=v;class m extends P.IPCClient{static fromSocket(a,d){return new m(new v(a),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,d,n=null){super(a,d,n),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=m;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class b{constructor(a){this.data=a,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let a=0,d=this._first;for(;d;)d=d.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let d=0,n=this._first;for(;n;)a[d++]=n.data,n=n.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const d=new b(a);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class u{static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let d=0;d<u._HISTORY_LENGTH;d++)this.lastRuns[d]=a-1e3*d;setInterval(()=>{for(let d=u._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),d=(1+u._HISTORY_LENGTH)*1e3;let n=0;for(let i=0;i<u._HISTORY_LENGTH;i++)a-this.lastRuns[i]<=d&&n++;return 1-n/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a,d=null,n=u.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(i=>this._receiveMessage(i))),this._socketDisposables.push(this._socket.onClose(i=>this._onSocketClose.fire(i))),d&&this._socketReader.acceptChunk(d),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new h(5,0,0,A());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new h(7,0,0,A());this._socketWriter.write(a)}sendResume(){const a=new h(8,0,0,A());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,d){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,A());this._socketWriter.write(a);const d=this._outgoingUnackMsg.toArray();for(let n=0,i=d.length;n<i;n++)this._socketWriter.write(d[n]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new h(6,0,0,A())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let n=0,i=d.length;n<i;n++)this._socketWriter.write(d[n]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new h(1,d,this._incomingAckId,a);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(a){const d=new h(2,0,0,a);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),d=Date.now()-a.writtenTime,n=Date.now()-this._socketReader.lastReadTime,i=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&n>=2e4&&i>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-d,2e4-n,2e4-i,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,A());this._socketWriter.write(a)}_sendKeepAlive(){const a=new h(9,0,0,A());this._socketWriter.write(a)}}e.PersistentProtocol=s}),define(Ce[117],De([1,0,23,11,4,6,9,10,31,115,116]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class E{traceSocketEvent(n,i){A.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,i)}constructor(n,i=""){this._canWrite=!0,this.debugLabel=i,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener),this._closeListener=p=>{this.traceSocketEvent("close",{hadError:p}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(n){const i=p=>{this.traceSocketEvent("read",p),n(c.VSBuffer.wrap(p))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(n){const i=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(n){const i=()=>{n()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(n){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var y;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var w;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(w||(w={}));class h extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(n,i){this.socket.traceSocketEvent(n,i)}constructor(n,i,p,_){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:p?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new g(this,i,p,_,this._onData,(R,M)=>this._write(R,M))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new A.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this._onData.event(n)}onClose(n){return this._onClose.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this._flowManager.writeMessage(n)}_write(n,i){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const _=c.VSBuffer.alloc(p);if(i?_.writeUInt8(194,0):_.writeUInt8(130,0),n.byteLength<126)_.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){_.writeUInt8(126,1);let R=1;_.writeUInt8(n.byteLength>>>8&255,++R),_.writeUInt8(n.byteLength>>>0&255,++R)}else{_.writeUInt8(127,1);let R=1;_.writeUInt8(0,++R),_.writeUInt8(0,++R),_.writeUInt8(0,++R),_.writeUInt8(0,++R),_.writeUInt8(n.byteLength>>>24&255,++R),_.writeUInt8(n.byteLength>>>16&255,++R),_.writeUInt8(n.byteLength>>>8&255,++R),_.writeUInt8(n.byteLength>>>0&255,++R)}this.socket.write(c.VSBuffer.concat([_,n]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(n){if(n.byteLength!==0){for(this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const i=this._incomingData.peek(this._state.readLen),p=i.readUInt8(0),_=(p&128)>>>7,R=(p&64)>>>6,M=i.readUInt8(1),H=(M&128)>>>7,$=M&127;this._state.state=2,this._state.readLen=2+(H?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const i=this._incomingData.read(this._state.readLen),p=i.readUInt8(1),_=(p&128)>>>7;let R=p&127,M=1;R===126?R=i.readUInt8(++M)*2**8+i.readUInt8(++M):R===127&&(R=i.readUInt8(++M)*0+i.readUInt8(++M)*0+i.readUInt8(++M)*0+i.readUInt8(++M)*0+i.readUInt8(++M)*2**24+i.readUInt8(++M)*2**16+i.readUInt8(++M)*2**8+i.readUInt8(++M));let H=0;_&&(H=i.readUInt8(++M)*2**24+i.readUInt8(++M)*2**16+i.readUInt8(++M)*2**8+i.readUInt8(++M)),this._state.state=3,this._state.readLen=R,this._state.mask=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const i=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),m(i,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(i,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class g extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,i,p,_,R,M){super(),this._tracer=n,this._onData=R,this._writeFn=M,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,i?(this._zlibInflateStream=this._register(new f(this._tracer,_,p,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(H=>this._onError.fire(H))),this._register(this._zlibDeflateStream.onError(H=>this._onError.fire(H)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(n){this._writeQueue.push(n),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const n=this._writeQueue.shift();if(this._zlibDeflateStream){const i=await this._deflateMessage(this._zlibDeflateStream,n);this._writeFn(i,!0)}else this._writeFn(n,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(n,i){return new Promise((p,_)=>{n.write(i),n.flush(R=>p(R))})}acceptFrame(n,i,p){this._readQueue.push({data:n,isCompressed:i,isLastFrameOfMessage:p}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const n=this._readQueue.shift();if(this._zlibInflateStream&&n.isCompressed){const i=await this._inflateFrame(this._zlibInflateStream,n.data,n.isLastFrameOfMessage);this._onData.fire(i)}else this._onData.fire(n.data)}this._isProcessingReadQueue=!1}}_inflateFrame(n,i,p){return new Promise((_,R)=>{n.write(i),p&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>_(M))})}}class f extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?c.VSBuffer.concat(this._recordedInflateBytes):c.VSBuffer.alloc(0)}constructor(n,i,p,_){super(),this._tracer=n,this._recordInflateBytes=i,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(_),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(c.VSBuffer.wrap(R))}),p&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(n){this._recordInflateBytes&&this._recordedInflateBytes.push(n.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",n),this._zlibInflate.write(n.buffer)}flush(n){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const i=c.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,n(i)})}}class v extends P.Disposable{constructor(n,i){super(),this._tracer=n,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",p=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibDeflate.on("data",p=>{this._tracer.traceSocketEvent("zlibDeflateData",p),this._pendingDeflateData.push(c.VSBuffer.wrap(p))})}write(n){this._tracer.traceSocketEvent("zlibDeflateWrite",n.buffer),this._zlibDeflate.write(n.buffer)}flush(n){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let i=c.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,i=i.slice(0,i.byteLength-4),n(i)})}}function m(d,n){if(n===0)return;const i=d.byteLength>>>2;for(let $=0;$<i;$++){const L=d.readUInt32BE($*4);d.writeUInt32BE(L^n,$*4)}const p=i*4,_=d.byteLength-p,R=n>>>24&255,M=n>>>16&255,H=n>>>8&255;_>=1&&d.writeUInt8(d.readUInt8(p)^R,p),_>=2&&d.writeUInt8(d.readUInt8(p+1)^M,p+1),_>=3&&d.writeUInt8(d.readUInt8(p+2)^H,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const r={[2]:107,[1]:103};function b(){const d=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):n=(0,C.join)(k().os.tmpdir(),`vscode-ipc-${d}.sock`),u(n),n}e.createRandomIPCHandle=b;function o(d,n,i){const p=k().crypto.createHash("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${i}-${n}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${i}-${n}.sock`):_=(0,C.join)(d,`${i}-${n}.sock`),u(_),_}e.createStaticIPCHandle=o;function u(d){const n=r[T.platform];typeof n=="number"&&d.length>=n&&console.warn(`WARNING: IPC handle "${d}" is longer than ${n} chars, try a shorter --user-data-dir`)}class s extends D.IPCServer{static toClientConnectionEvent(n){const i=I.Event.fromNodeEventEmitter(n,"connection");return I.Event.map(i,p=>({protocol:new A.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(s.toClientConnectionEvent(n)),this.server=n}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function l(d){return new Promise((n,i)=>{const p=k().net.createServer();p.on("error",i),p.listen(d,()=>{p.removeListener("error",i),n(new s(p))})})}e.serve=l;function a(d,n){return new Promise((i,p)=>{const _=k().net.createConnection(d,()=>{_.removeListener("error",p),i(A.Client.fromSocket(new E(_,`ipc-client${n}`),n))});_.once("error",p)})}e.connect=a}),define(Ce[159],De([1,0,37,9]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(P,C,T,S,D,A){if(Array.isArray(P)){let k=0;for(const E of P){const y=I(E,C,T,S,D,A);if(y===10)return y;y>k&&(k=y)}return k}else{if(typeof P=="string")return S?P==="*"?5:P===T?10:0:0;if(P){const{language:k,pattern:E,scheme:y,hasAccessToAllModels:w,notebookType:h}=P;if(!S&&!w)return 0;h&&D&&(C=D);let g=0;if(y)if(y===C.scheme)g=10;else if(y==="*")g=5;else return 0;if(k)if(k===T)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(h)if(h===A)g=10;else if(h==="*"&&A!==void 0)g=Math.max(g,5);else return 0;if(E){let f;if(typeof E=="string"?f=E:f={...E,base:(0,t.normalize)(E.base)},f===C.fsPath||(0,c.match)(f,C.fsPath))g=10;else return 0}return g}else return 0}}e.score=I}),define(Ce[160],De([1,0,8,49,151]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(T,S,D,A){this._uri=T,this._lines=S,this._eol=D,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(T){T.eol&&T.eol!==this._eol&&(this._eol=T.eol,this._lineStarts=null);const S=T.changes;for(const D of S)this._acceptDeleteRange(D.range),this._acceptInsertText(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=T.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const T=this._eol.length,S=this._lines.length,D=new Uint32Array(S);for(let A=0;A<S;A++)D[A]=this._lines[A].length+T;this._lineStarts=new I.PrefixSumComputer(D)}}_setLineText(T,S){this._lines[T]=S,this._lineStarts&&this._lineStarts.setValue(T,this._lines[T].length+this._eol.length)}_acceptDeleteRange(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.startLineNumber-1].substring(T.endColumn-1));return}this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.endLineNumber-1].substring(T.endColumn-1)),this._lines.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}_acceptInsertText(T,S){if(S.length===0)return;const D=(0,c.splitLines)(S);if(D.length===1){this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+D[0]+this._lines[T.lineNumber-1].substring(T.column-1));return}D[D.length-1]+=this._lines[T.lineNumber-1].substring(T.column-1),this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+D[0]);const A=new Uint32Array(D.length-1);for(let k=1;k<D.length;k++)this._lines.splice(T.lineNumber+k-1,0,D[k]),A[k-1]=D[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(T.lineNumber,A)}}e.MirrorTextModel=P}),define(Ce[161],De([1,0,8,148,49,35,104]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(v,m,r,b){this.searchString=v,this.isRegex=m,this.matchCase=r,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=D(this.searchString):v=this.searchString.indexOf(`
`)>=0;let m=null;try{m=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!m)return null;let r=!this.isRegex&&!v;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new C.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,r?this.searchString:null)}}e.SearchParams=S;function D(f){if(!f||f.length===0)return!1;for(let v=0,m=f.length;v<m;v++){const r=f.charCodeAt(v);if(r===10)return!0;if(r===92){if(v++,v>=m)break;const b=f.charCodeAt(v);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=D;function A(f,v,m){if(!m)return new C.FindMatch(f,null);const r=[];for(let b=0,o=v.length;b<o;b++)r[b]=v[b];return new C.FindMatch(f,r)}e.createFindMatch=A;class k{constructor(v){const m=[];let r=0;for(let b=0,o=v.length;b<o;b++)v.charCodeAt(b)===10&&(m[r++]=b);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(v){const m=this._lineFeedsOffsets;let r=0,b=m.length-1;if(b===-1||v<=m[0])return 0;for(;r<b;){const o=r+((b-r)/2>>0);m[o]>=v?b=o-1:m[o+1]>=v?(r=o,b=o):r=o+1}return r+1}}class E{static findMatches(v,m,r,b,o){const u=m.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(v,r,new g(u.wordSeparators,u.regex),b,o):this._doFindMatchesLineByLine(v,r,u,b,o):[]}static _getMultilineMatchRange(v,m,r,b,o,u){let s,l=0;b?(l=b.findLineFeedCountBeforeOffset(o),s=m+o+l):s=m+o;let a;if(b){const p=b.findLineFeedCountBeforeOffset(o+u.length)-l;a=s+u.length+p}else a=s+u.length;const d=v.getPositionAt(s),n=v.getPositionAt(a);return new P.Range(d.lineNumber,d.column,n.lineNumber,n.column)}static _doFindMatchesMultiline(v,m,r,b,o){const u=v.getOffsetAt(m.getStartPosition()),s=v.getValueInRange(m,1),l=v.getEOL()===`\r
`?new k(s):null,a=[];let d=0,n;for(r.reset(0);n=r.next(s);)if(a[d++]=A(this._getMultilineMatchRange(v,u,s,l,n.index,n[0]),n,b),d>=o)return a;return a}static _doFindMatchesLineByLine(v,m,r,b,o){const u=[];let s=0;if(m.startLineNumber===m.endLineNumber){const a=v.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this._findMatchesInLine(r,a,m.startLineNumber,m.startColumn-1,s,u,b,o),u}const l=v.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this._findMatchesInLine(r,l,m.startLineNumber,m.startColumn-1,s,u,b,o);for(let a=m.startLineNumber+1;a<m.endLineNumber&&s<o;a++)s=this._findMatchesInLine(r,v.getLineContent(a),a,0,s,u,b,o);if(s<o){const a=v.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this._findMatchesInLine(r,a,m.endLineNumber,0,s,u,b,o)}return u}static _findMatchesInLine(v,m,r,b,o,u,s,l){const a=v.wordSeparators;if(!s&&v.simpleSearch){const i=v.simpleSearch,p=i.length,_=m.length;let R=-p;for(;(R=m.indexOf(i,R+p))!==-1;)if((!a||h(a,m,_,R,p))&&(u[o++]=new C.FindMatch(new P.Range(r,R+1+b,r,R+1+p+b),null),o>=l))return o;return o}const d=new g(v.wordSeparators,v.regex);let n;d.reset(0);do if(n=d.next(m),n&&(u[o++]=A(new P.Range(r,n.index+1+b,r,n.index+1+n[0].length+b),n,s),o>=l))return o;while(n);return o}static findNextMatch(v,m,r,b){const o=m.parseSearchRequest();if(!o)return null;const u=new g(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(v,r,u,b):this._doFindNextMatchLineByLine(v,r,u,b)}static _doFindNextMatchMultiline(v,m,r,b){const o=new I.Position(m.lineNumber,1),u=v.getOffsetAt(o),s=v.getLineCount(),l=v.getValueInRange(new P.Range(o.lineNumber,o.column,s,v.getLineMaxColumn(s)),1),a=v.getEOL()===`\r
`?new k(l):null;r.reset(m.column-1);const d=r.next(l);return d?A(this._getMultilineMatchRange(v,u,l,a,d.index,d[0]),d,b):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(v,new I.Position(1,1),r,b):null}static _doFindNextMatchLineByLine(v,m,r,b){const o=v.getLineCount(),u=m.lineNumber,s=v.getLineContent(u),l=this._findFirstMatchInLine(r,s,u,m.column,b);if(l)return l;for(let a=1;a<=o;a++){const d=(u+a-1)%o,n=v.getLineContent(d+1),i=this._findFirstMatchInLine(r,n,d+1,1,b);if(i)return i}return null}static _findFirstMatchInLine(v,m,r,b,o){v.reset(b-1);const u=v.next(m);return u?A(new P.Range(r,u.index+1,r,u.index+1+u[0].length),u,o):null}static findPreviousMatch(v,m,r,b){const o=m.parseSearchRequest();if(!o)return null;const u=new g(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(v,r,u,b):this._doFindPreviousMatchLineByLine(v,r,u,b)}static _doFindPreviousMatchMultiline(v,m,r,b){const o=this._doFindMatchesMultiline(v,new P.Range(1,1,m.lineNumber,m.column),r,b,10*T);if(o.length>0)return o[o.length-1];const u=v.getLineCount();return m.lineNumber!==u||m.column!==v.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(v,new I.Position(u,v.getLineMaxColumn(u)),r,b):null}static _doFindPreviousMatchLineByLine(v,m,r,b){const o=v.getLineCount(),u=m.lineNumber,s=v.getLineContent(u).substring(0,m.column-1),l=this._findLastMatchInLine(r,s,u,b);if(l)return l;for(let a=1;a<=o;a++){const d=(o+u-a-1)%o,n=v.getLineContent(d+1),i=this._findLastMatchInLine(r,n,d+1,b);if(i)return i}return null}static _findLastMatchInLine(v,m,r,b){let o=null,u;for(v.reset(0);u=v.next(m);)o=A(new P.Range(r,u.index+1,r,u.index+1+u[0].length),u,b);return o}}e.TextModelSearch=E;function y(f,v,m,r,b){if(r===0)return!0;const o=v.charCodeAt(r-1);if(f.get(o)!==0||o===13||o===10)return!0;if(b>0){const u=v.charCodeAt(r);if(f.get(u)!==0)return!0}return!1}function w(f,v,m,r,b){if(r+b===m)return!0;const o=v.charCodeAt(r+b);if(f.get(o)!==0||o===13||o===10)return!0;if(b>0){const u=v.charCodeAt(r+b-1);if(f.get(u)!==0)return!0}return!1}function h(f,v,m,r,b){return y(f,v,m,r,b)&&w(f,v,m,r,b)}e.isValidMatch=h;class g{constructor(v,m){this._wordSeparators=v,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const m=v.length;let r;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(r=this._searchRegex.exec(v),!r))return null;const b=r.index,o=r[0].length;if(b===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){c.getNextCodePoint(v,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=b,this._prevMatchLength=o,!this._wordSeparators||h(this._wordSeparators,v,m,b,o))return r}while(r);return null}}e.Searcher=g}),define(Ce[118],De([1,0,23,10]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function P(k){for(let E=0,y=k.length;E<y;E+=4){const w=k[E+0],h=k[E+1],g=k[E+2],f=k[E+3];k[E+0]=f,k[E+1]=g,k[E+2]=h,k[E+3]=w}}function C(k){const E=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(E),c.VSBuffer.wrap(E)}function T(k){const E=k.buffer;if(t.isLittleEndian()||P(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const y=new Uint8Array(E.byteLength);return y.set(E),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function S(k){const E=new Uint32Array(D(k));let y=0;if(E[y++]=k.id,k.type==="full")E[y++]=1,E[y++]=k.data.length,E.set(k.data,y),y+=k.data.length;else{E[y++]=2,E[y++]=k.deltas.length;for(const w of k.deltas)E[y++]=w.start,E[y++]=w.deleteCount,w.data?(E[y++]=w.data.length,E.set(w.data,y),y+=w.data.length):E[y++]=0}return C(E)}e.encodeSemanticTokensDto=S;function D(k){let E=0;if(E+=1+1,k.type==="full")E+=1+k.data.length;else{E+=1,E+=(1+1+1)*k.deltas.length;for(const y of k.deltas)y.data&&(E+=y.data.length)}return E}function A(k){const E=T(k);let y=0;const w=E[y++];if(E[y++]===1){const v=E[y++],m=E.subarray(y,y+v);return y+=v,{id:w,type:"full",data:m}}const g=E[y++],f=[];for(let v=0;v<g;v++){const m=E[y++],r=E[y++],b=E[y++];let o;b>0&&(o=E.subarray(y,y+b),y+=b),f[v]={start:m,deleteCount:r,data:o}}return{id:w,type:"delta",deltas:f}}e.decodeSemanticTokensDto=A}),define(Ce[162],De([1,0,4,6]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this._map.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this._map.get(T)===S&&(this._map.delete(T),this.fire([T]))})}registerFactory(T,S){this._factories.get(T)?.dispose();const D=new P(this,T,S);return this._factories.set(T,D),(0,t.toDisposable)(()=>{const A=this._factories.get(T);!A||A!==D||(this._factories.delete(T),A.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const D=this._factories.get(T);return!D||D.isResolved?null:(await D.resolve(),this.get(T))}get(T){return this._map.get(T)||null}isResolved(T){if(this.get(T))return!0;const D=this._factories.get(T);return!!(!D||D.isResolved)}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(T,S,D){super(),this._registry=T,this._languageId=S,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const T=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,T&&!this._isDisposed&&this._register(this._registry.register(this._languageId,T))}}}),define(Ce[65],De([1,0,77,2,35,162]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(p,_,R){this._tokenBrand=void 0,this.offset=p,this.type=_,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class T{constructor(p,_){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=_}}e.TokenizationResult=T;class S{constructor(p,_){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=_}}e.EncodedTokenizationResult=S;var D;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var A;(function(i){const p=new Map;p.set(0,c.Codicon.symbolMethod),p.set(1,c.Codicon.symbolFunction),p.set(2,c.Codicon.symbolConstructor),p.set(3,c.Codicon.symbolField),p.set(4,c.Codicon.symbolVariable),p.set(5,c.Codicon.symbolClass),p.set(6,c.Codicon.symbolStruct),p.set(7,c.Codicon.symbolInterface),p.set(8,c.Codicon.symbolModule),p.set(9,c.Codicon.symbolProperty),p.set(10,c.Codicon.symbolEvent),p.set(11,c.Codicon.symbolOperator),p.set(12,c.Codicon.symbolUnit),p.set(13,c.Codicon.symbolValue),p.set(15,c.Codicon.symbolEnum),p.set(14,c.Codicon.symbolConstant),p.set(15,c.Codicon.symbolEnum),p.set(16,c.Codicon.symbolEnumMember),p.set(17,c.Codicon.symbolKeyword),p.set(27,c.Codicon.symbolSnippet),p.set(18,c.Codicon.symbolText),p.set(19,c.Codicon.symbolColor),p.set(20,c.Codicon.symbolFile),p.set(21,c.Codicon.symbolReference),p.set(22,c.Codicon.symbolCustomColor),p.set(23,c.Codicon.symbolFolder),p.set(24,c.Codicon.symbolTypeParameter),p.set(25,c.Codicon.account),p.set(26,c.Codicon.issues);function _(H){let $=p.get(H);return $||(console.info("No codicon found for CompletionItemKind "+H),$=c.Codicon.symbolProperty),$}i.toIcon=_;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function M(H,$){let L=R.get(H);return typeof L>"u"&&!$&&(L=9),L}i.fromString=M})(A=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(i){i[i.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(i){i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(i){return i&&t.URI.isUri(i.uri)&&I.Range.isIRange(i.range)&&(I.Range.isIRange(i.originSelectionRange)||I.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=v;var m;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var r;(function(i){i[i.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var b;(function(i){const p=new Map;p.set(0,c.Codicon.symbolFile),p.set(1,c.Codicon.symbolModule),p.set(2,c.Codicon.symbolNamespace),p.set(3,c.Codicon.symbolPackage),p.set(4,c.Codicon.symbolClass),p.set(5,c.Codicon.symbolMethod),p.set(6,c.Codicon.symbolProperty),p.set(7,c.Codicon.symbolField),p.set(8,c.Codicon.symbolConstructor),p.set(9,c.Codicon.symbolEnum),p.set(10,c.Codicon.symbolInterface),p.set(11,c.Codicon.symbolFunction),p.set(12,c.Codicon.symbolVariable),p.set(13,c.Codicon.symbolConstant),p.set(14,c.Codicon.symbolString),p.set(15,c.Codicon.symbolNumber),p.set(16,c.Codicon.symbolBoolean),p.set(17,c.Codicon.symbolArray),p.set(18,c.Codicon.symbolObject),p.set(19,c.Codicon.symbolKey),p.set(20,c.Codicon.symbolNull),p.set(21,c.Codicon.symbolEnumMember),p.set(22,c.Codicon.symbolStruct),p.set(23,c.Codicon.symbolEvent),p.set(24,c.Codicon.symbolOperator),p.set(25,c.Codicon.symbolTypeParameter);function _(R){let M=p.get(R);return M||(console.info("No codicon found for SymbolKind "+R),M=c.Codicon.symbolProperty),M}i.toIcon=_})(b=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(p){this.value=p}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var u;(function(i){function p(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}i.is=p})(u=e.Command||(e.Command={}));var s;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var d;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var n;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ce[163],De([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(Ce[119],De([1,0,163,10,103,17,24,147]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=D;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(se,Ee,xe,me){this.id=se,this.name=Ee,this.defaultValue=xe,this.schema=me}applyUpdate(se,Ee){return y(se,Ee)}compute(se,Ee,xe){return xe}}class E{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=E;function y(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new E(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const xe=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new E(se,!xe)}let Ee=!1;for(const xe in se)if(se.hasOwnProperty(xe)){const me=y(re[xe],se[xe]);me.didChange&&(re[xe]=me.newValue,Ee=!0)}return new E(re,Ee)}class w{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return y(se,Ee)}validate(se){return this.defaultValue}}class h{constructor(se,Ee,xe,me){this.id=se,this.name=Ee,this.defaultValue=xe,this.schema=me}applyUpdate(se,Ee){return y(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,xe){return xe}}function g(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=g;class f extends h{constructor(se,Ee,xe,me=void 0){typeof me<"u"&&(me.type="boolean",me.default=xe),super(se,Ee,xe,me)}validate(se){return g(se,this.defaultValue)}}function v(re,se,Ee,xe){if(typeof re>"u")return se;let me=parseInt(re,10);return isNaN(me)?se:(me=Math.max(Ee,me),me=Math.min(xe,me),me|0)}e.clampedInt=v;class m extends h{static clampedInt(se,Ee,xe,me){return v(se,Ee,xe,me)}constructor(se,Ee,xe,me,Ae,Oe=void 0){typeof Oe<"u"&&(Oe.type="integer",Oe.default=xe,Oe.minimum=me,Oe.maximum=Ae),super(se,Ee,xe,Oe),this.minimum=me,this.maximum=Ae}validate(se){return m.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class r extends h{static clamp(se,Ee,xe){return se<Ee?Ee:se>xe?xe:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const xe=parseFloat(se);return isNaN(xe)?Ee:xe}constructor(se,Ee,xe,me,Ae){typeof Ae<"u"&&(Ae.type="number",Ae.default=xe),super(se,Ee,xe,Ae),this.validationFn=me}validate(se){return this.validationFn(r.float(se,this.defaultValue))}}class b extends h{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,xe,me=void 0){typeof me<"u"&&(me.type="string",me.default=xe),super(se,Ee,xe,me)}validate(se){return b.string(se,this.defaultValue)}}function o(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=o;class u extends h{constructor(se,Ee,xe,me,Ae=void 0){typeof Ae<"u"&&(Ae.type="string",Ae.enum=me,Ae.default=xe),super(se,Ee,xe,Ae),this._allowedValues=me}validate(se){return o(se,this.defaultValue,this._allowedValues)}}class s extends k{constructor(se,Ee,xe,me,Ae,Oe,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ae,Me.default=me),super(se,Ee,xe,Me),this._allowedValues=Ae,this._convert=Oe}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function l(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,xe){return xe===0?se.accessibilitySupport:xe}}class d extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:c.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:g(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(re){switch(re){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function R(re){switch(re){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class M extends w{constructor(){super(130)}compute(se,Ee,xe){const me=["monaco-editor"];return Ee.get(34)&&me.push(Ee.get(34)),se.extraEditorClassName&&me.push(se.extraEditorClassName),Ee.get(67)==="default"?me.push("mouse-default"):Ee.get(67)==="copy"&&me.push("mouse-copy"),Ee.get(101)&&me.push("showUnused"),Ee.get(128)&&me.push("showDeprecated"),me.join(" ")}}class H extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(se,Ee,xe){return xe&&se.emptySelectionClipboard}}class $ extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:c.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:g(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":o(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":o(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ee.loop,this.defaultValue.loop)}}}class L extends k{constructor(){super(46,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?L.OFF:se==="true"?L.ON:se:Boolean(se)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class B extends w{constructor(){super(45)}compute(se,Ee,xe){return se.fontInfo}}class O extends h{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(se){const Ee=r.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(Ee,6,100)}compute(se,Ee,xe){return se.fontInfo.fontSize}}class z extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(m.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class U extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:xe,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:xe,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:xe,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:xe,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:xe,description:c.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:o(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??o(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??o(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??o(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??o(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??o(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:c.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:g(Ee.enabled,this.defaultValue.enabled),delay:m.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:g(Ee.sticky,this.defaultValue.sticky),above:g(Ee.above,this.defaultValue.above)}}}var V;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class x extends w{constructor(){super(133)}compute(se,Ee,xe){return x.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,xe=se.scrollBeyondLastLine?Ee-1:0,me=(se.viewLineCount+xe)/(se.pixelRatio*se.height),Ae=Math.floor(se.viewLineCount/me);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:xe,desiredRatio:me,minimapLineCount:Ae}}static _computeMinimapLayout(se,Ee){const xe=se.outerWidth,me=se.outerHeight,Ae=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ae*me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:me};const Oe=Ee.stableMinimapLayoutInput,Me=Oe&&se.outerHeight===Oe.outerHeight&&se.lineHeight===Oe.lineHeight&&se.typicalHalfwidthCharacterWidth===Oe.typicalHalfwidthCharacterWidth&&se.pixelRatio===Oe.pixelRatio&&se.scrollBeyondLastLine===Oe.scrollBeyondLastLine&&se.minimap.enabled===Oe.minimap.enabled&&se.minimap.side===Oe.minimap.side&&se.minimap.size===Oe.minimap.size&&se.minimap.showSlider===Oe.minimap.showSlider&&se.minimap.renderCharacters===Oe.minimap.renderCharacters&&se.minimap.maxColumn===Oe.minimap.maxColumn&&se.minimap.scale===Oe.minimap.scale&&se.verticalScrollbarWidth===Oe.verticalScrollbarWidth&&se.isViewportWrapping===Oe.isViewportWrapping,Ke=se.lineHeight,Je=se.typicalHalfwidthCharacterWidth,st=se.scrollBeyondLastLine,vt=se.minimap.renderCharacters;let nt=Ae>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const it=se.minimap.maxColumn,bt=se.minimap.size,yt=se.minimap.side,Ct=se.verticalScrollbarWidth,ht=se.viewLineCount,Dt=se.remainingWidth,Mt=se.isViewportWrapping,Bt=vt?2:3;let Qe=Math.floor(Ae*me);const Ot=Qe/Ae;let Tt=!1,Nt=!1,gt=Bt*nt,Pe=nt/Ae,Le=1;if(bt==="fill"||bt==="fit"){const{typicalViewportLineCount:ot,extraLinesBeyondLastLine:lt,desiredRatio:It,minimapLineCount:wt}=x.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:st,height:me,lineHeight:Ke,pixelRatio:Ae});if(ht/wt>1)Tt=!0,Nt=!0,nt=1,gt=1,Pe=nt/Ae;else{let Et=!1,Rt=nt+1;if(bt==="fit"){const mt=Math.ceil((ht+lt)*gt);Mt&&Me&&Dt<=Ee.stableFitRemainingWidth?(Et=!0,Rt=Ee.stableFitMaxMinimapScale):Et=mt>Qe}if(bt==="fill"||Et){Tt=!0;const mt=nt;gt=Math.min(Ke*Ae,Math.max(1,Math.floor(1/It))),Mt&&Me&&Dt<=Ee.stableFitRemainingWidth&&(Rt=Ee.stableFitMaxMinimapScale),nt=Math.min(Rt,Math.max(1,Math.floor(gt/Bt))),nt>mt&&(Le=Math.min(2,nt/mt)),Pe=nt/Ae/Le,Qe=Math.ceil(Math.max(ot,ht+lt)*gt),Mt?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Dt,Ee.stableFitMaxMinimapScale=nt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(it*Pe),ee=Math.min(_e,Math.max(0,Math.floor((Dt-Ct-2)*Pe/(Je+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ae*ee);const Ve=Fe/Ae;Fe=Math.floor(Fe*Le);const rt=vt?1:2,Ge=yt==="left"?0:xe-ee-Ct;return{renderMinimap:rt,minimapLeft:Ge,minimapWidth:ee,minimapHeightIsEditorHeight:Tt,minimapIsSampling:Nt,minimapScale:nt,minimapLineHeight:gt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Qe,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:Ot}}static computeLayout(se,Ee){const xe=Ee.outerWidth|0,me=Ee.outerHeight|0,Ae=Ee.lineHeight|0,Oe=Ee.lineNumbersDigitCount|0,Me=Ee.typicalHalfwidthCharacterWidth,Ke=Ee.maxDigitWidth,Je=Ee.pixelRatio,st=Ee.viewLineCount,vt=se.get(125),nt=vt==="inherit"?se.get(124):vt,it=nt==="inherit"?se.get(120):nt,bt=se.get(123),yt=se.get(2),Ct=Ee.isDominatedByLongLines,ht=se.get(51),Dt=se.get(61).renderType!==0,Mt=se.get(62),Bt=se.get(95),Qe=se.get(66),Ot=se.get(93),Tt=Ot.verticalScrollbarSize,Nt=Ot.verticalHasArrows,gt=Ot.arrowSize,Pe=Ot.horizontalScrollbarSize,Le=se.get(59),_e=se.get(38),ee=se.get(100)!=="never";let Fe;if(typeof Le=="string"&&/^\d+(\.\d+)?ch$/.test(Le)){const zt=parseFloat(Le.substr(0,Le.length-2));Fe=m.clampedInt(zt*Me,0,0,1e3)}else Fe=m.clampedInt(Le,0,0,1e3);_e&&ee&&(Fe+=16);let Ve=0;if(Dt){const zt=Math.max(Oe,Mt);Ve=Math.round(zt*Ke)}let rt=0;ht&&(rt=Ae);let Ge=0,ot=Ge+rt,lt=ot+Ve,It=lt+Fe;const wt=xe-rt-Ve-Fe;let kt=!1,Et=!1,Rt=-1;yt!==2&&(nt==="inherit"&&Ct?(kt=!0,Et=!0):it==="on"||it==="bounded"?Et=!0:it==="wordWrapColumn"&&(Rt=bt));const mt=x._computeMinimapLayout({outerWidth:xe,outerHeight:me,lineHeight:Ae,typicalHalfwidthCharacterWidth:Me,pixelRatio:Je,scrollBeyondLastLine:Bt,minimap:Qe,verticalScrollbarWidth:Tt,viewLineCount:st,remainingWidth:wt,isViewportWrapping:Et},Ee.memory||new A);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Ge+=mt.minimapWidth,ot+=mt.minimapWidth,lt+=mt.minimapWidth,It+=mt.minimapWidth);const en=wt-mt.minimapWidth,tn=Math.max(1,Math.floor((en-Tt-2)/Me)),St=Nt?gt:0;return Et&&(Rt=Math.max(1,tn),it==="bounded"&&(Rt=Math.min(Rt,bt))),{width:xe,height:me,glyphMarginLeft:Ge,glyphMarginWidth:rt,lineNumbersLeft:ot,lineNumbersWidth:Ve,decorationsLeft:lt,decorationsWidth:Fe,contentLeft:It,contentWidth:en,minimap:mt,viewportColumn:tn,isWordWrapMinified:kt,isViewportWrapping:Et,wrappingColumn:Rt,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:Pe,overviewRuler:{top:St,width:Tt,height:me-2*St,right:0}}}}e.EditorLayoutInfoComputer=x;class Q extends k{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:c.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:g(se.enabled,this.defaultValue.enabled)}}}class K extends k{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:c.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:c.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:g(Ee.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ue extends k{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:c.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(47,null),c.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:c.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:c.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:c.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:o(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:g(Ee.padding,this.defaultValue.padding)}}}class te extends r{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>r.clamp(se,0,150),{markdownDescription:c.localize(54,null)})}compute(se,Ee,xe){return se.fontInfo.lineHeight}}class he extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:c.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:c.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(57,null),c.localize(58,null),c.localize(59,null)],default:se.size,description:c.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:c.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:c.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:c.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:c.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:g(Ee.enabled,this.defaultValue.enabled),autohide:g(Ee.autohide,this.defaultValue.autohide),size:o(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(Ee.side,this.defaultValue.side,["right","left"]),showSlider:o(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(Ee.scale,1,1,3),maxColumn:m.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:m.clampedInt(Ee.top,0,0,1e3),bottom:m.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends k{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:c.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:c.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:g(Ee.enabled,this.defaultValue.enabled),cycle:g(Ee.cycle,this.defaultValue.cycle)}}}class ke extends w{constructor(){super(131)}compute(se,Ee,xe){return se.pixelRatio}}class Re extends k{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(70,null),c.localize(71,null),c.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:c.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:c.localize(74,null)},other:{anyOf:Ee,default:se.other,description:c.localize(75,null)}},default:se,markdownDescription:c.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Je=se?"on":"off";return{comments:Je,strings:Je,other:Je}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:xe,strings:me}=se,Ae=["on","inline","off"];let Oe,Me,Ke;return typeof Ee=="boolean"?Oe=Ee?"on":"off":Oe=o(Ee,this.defaultValue.other,Ae),typeof xe=="boolean"?Me=xe?"on":"off":Me=o(xe,this.defaultValue.comments,Ae),typeof me=="boolean"?Ke=me?"on":"off":Ke=o(me,this.defaultValue.strings,Ae),{other:Oe,comments:Me,strings:Ke}}}var ze;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(ze=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null),c.localize(80,null)],default:"on",description:c.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,xe=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:xe}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class ge extends k{constructor(){const se=[],Ee={type:"number",description:c.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:c.localize(83,null),format:"color-hex"}}}]},default:se,description:c.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const xe of se)if(typeof xe=="number")Ee.push({column:m.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const me=xe;Ee.push({column:m.clampedInt(me.column,0,0,1e4),color:me.color})}return Ee.sort((xe,me)=>xe.column-me.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(85,null),c.localize(86,null),c.localize(87,null)],default:"auto",description:c.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(89,null),c.localize(90,null),c.localize(91,null)],default:"auto",description:c.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:c.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:c.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:c.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,xe=m.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),me=m.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:g(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:m.clampedInt(Ee.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:me,verticalSliderSize:m.clampedInt(Ee.verticalSliderSize,me,0,1e3),scrollByPage:g(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ne extends k{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:c.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:c.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:c.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:c.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:c.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:c.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:c.localize(102,null)}})}applyUpdate(se,Ee){let xe=!1;Ee.allowedCharacters&&se&&(C.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},xe=!0)),Ee.allowedLocales&&se&&(C.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},xe=!0));const me=super.applyUpdate(se,Ee);return xe?new E(me.newValue,!0):me}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:G(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:G(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:G(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const xe={};for(const[me,Ae]of Object.entries(se))Ae===!0&&(xe[me]=!0);return xe}}class ie extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:c.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:g(Ee.enabled,this.defaultValue.enabled),mode:o(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class N extends k{constructor(){const se={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:c.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:c.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:g(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class j extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(106,null),c.localize(107,null),c.localize(108,null)],default:se.bracketPairs,description:c.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(110,null),c.localize(111,null),c.localize(112,null)],default:se.bracketPairsHorizontal,description:c.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:c.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:c.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(116,null),c.localize(117,null),c.localize(118,null)],default:se.highlightActiveIndentation,description:c.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:G(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:G(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:G(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function G(re,se,Ee){const xe=Ee.indexOf(re);return xe===-1?se:Ee[xe]}class X extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(120,null),c.localize(121,null)],default:se.insertMode,description:c.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:c.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:c.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:c.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:c.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:c.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:c.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:c.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:c.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:o(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ee.preview,this.defaultValue.preview),previewMode:o(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ee.showMethods,this.defaultValue.showMethods),showFunctions:g(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ee.showFields,this.defaultValue.showFields),showVariables:g(Ee.showVariables,this.defaultValue.showVariables),showClasses:g(Ee.showClasses,this.defaultValue.showClasses),showStructs:g(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ee.showModules,this.defaultValue.showModules),showProperties:g(Ee.showProperties,this.defaultValue.showProperties),showEvents:g(Ee.showEvents,this.defaultValue.showEvents),showOperators:g(Ee.showOperators,this.defaultValue.showOperators),showUnits:g(Ee.showUnits,this.defaultValue.showUnits),showValues:g(Ee.showValues,this.defaultValue.showValues),showConstants:g(Ee.showConstants,this.defaultValue.showConstants),showEnums:g(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ee.showKeywords,this.defaultValue.showKeywords),showWords:g(Ee.showWords,this.defaultValue.showWords),showColors:g(Ee.showColors,this.defaultValue.showColors),showFiles:g(Ee.showFiles,this.defaultValue.showFiles),showReferences:g(Ee.showReferences,this.defaultValue.showReferences),showFolders:g(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ee.showUsers,this.defaultValue.showUsers),showIssues:g(Ee.showIssues,this.defaultValue.showIssues)}}}class pe extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends w{constructor(){super(132)}compute(se,Ee,xe){return Ee.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ie(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends w{constructor(){super(134)}compute(se,Ee,xe){const me=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:me.isWordWrapMinified,isViewportWrapping:me.isViewportWrapping,wrappingColumn:me.wrappingColumn}}}class We extends k{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:c.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:g(se.enabled,this.defaultValue.enabled)}}}const qe="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Ye:qe,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(re){return e.editorOptionsRegistry[re.id]=re,re}var at;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(165,null)})),acceptSuggestionOnEnter:Ne(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(166,null),""],markdownDescription:c.localize(167,null)})),accessibilitySupport:Ne(new a),accessibilityPageSize:Ne(new m(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(168,null),tags:["accessibility"]})),ariaLabel:Ne(new b(4,"ariaLabel",c.localize(169,null))),autoClosingBrackets:Ne(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(170,null),c.localize(171,null),""],description:c.localize(172,null)})),autoClosingDelete:Ne(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(173,null),""],description:c.localize(174,null)})),autoClosingOvertype:Ne(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(175,null),""],description:c.localize(176,null)})),autoClosingQuotes:Ne(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(177,null),c.localize(178,null),""],description:c.localize(179,null)})),autoIndent:Ne(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[c.localize(180,null),c.localize(181,null),c.localize(182,null),c.localize(183,null),c.localize(184,null)],description:c.localize(185,null)})),automaticLayout:Ne(new f(10,"automaticLayout",!1)),autoSurround:Ne(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(186,null),c.localize(187,null),c.localize(188,null),""],description:c.localize(189,null)})),bracketPairColorization:Ne(new N),bracketPairGuides:Ne(new j),stickyTabStops:Ne(new f(106,"stickyTabStops",!1,{description:c.localize(190,null)})),codeLens:Ne(new f(14,"codeLens",!0,{description:c.localize(191,null)})),codeLensFontFamily:Ne(new b(15,"codeLensFontFamily","",{description:c.localize(192,null)})),codeLensFontSize:Ne(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(193,null)})),colorDecorators:Ne(new f(17,"colorDecorators",!0,{description:c.localize(194,null)})),columnSelection:Ne(new f(18,"columnSelection",!1,{description:c.localize(195,null)})),comments:Ne(new d),contextmenu:Ne(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new f(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(196,null)})),cursorBlinking:Ne(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(197,null)})),cursorSmoothCaretAnimation:Ne(new f(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(198,null)})),cursorStyle:Ne(new s(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:c.localize(199,null)})),cursorSurroundingLines:Ne(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(200,null)})),cursorSurroundingLinesStyle:Ne(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(201,null),c.localize(202,null)],description:c.localize(203,null)})),cursorWidth:Ne(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(204,null)})),disableLayerHinting:Ne(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new f(30,"domReadOnly",!1)),dragAndDrop:Ne(new f(31,"dragAndDrop",!0,{description:c.localize(205,null)})),emptySelectionClipboard:Ne(new H),dropIntoEditor:Ne(new We),stickyScroll:Ne(new K),extraEditorClassName:Ne(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Ne(new r(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:c.localize(206,null)})),find:Ne(new $),fixedOverflowWidgets:Ne(new f(37,"fixedOverflowWidgets",!1)),folding:Ne(new f(38,"folding",!0,{description:c.localize(207,null)})),foldingStrategy:Ne(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(208,null),c.localize(209,null)],description:c.localize(210,null)})),foldingHighlight:Ne(new f(40,"foldingHighlight",!0,{description:c.localize(211,null)})),foldingImportsByDefault:Ne(new f(41,"foldingImportsByDefault",!1,{description:c.localize(212,null)})),foldingMaximumRegions:Ne(new m(42,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(213,null)})),unfoldOnClickAfterEndOfLine:Ne(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(214,null)})),fontFamily:Ne(new b(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(215,null)})),fontInfo:Ne(new B),fontLigatures2:Ne(new L),fontSize:Ne(new O),fontWeight:Ne(new z),formatOnPaste:Ne(new f(49,"formatOnPaste",!1,{description:c.localize(216,null)})),formatOnType:Ne(new f(50,"formatOnType",!1,{description:c.localize(217,null)})),glyphMargin:Ne(new f(51,"glyphMargin",!0,{description:c.localize(218,null)})),gotoLocation:Ne(new U),hideCursorInOverviewRuler:Ne(new f(53,"hideCursorInOverviewRuler",!1,{description:c.localize(219,null)})),hover:Ne(new F),inDiffEditor:Ne(new f(55,"inDiffEditor",!1)),letterSpacing:Ne(new r(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>r.clamp(re,-5,20),{description:c.localize(220,null)})),lightbulb:Ne(new Q),lineDecorationsWidth:Ne(new h(59,"lineDecorationsWidth",10)),lineHeight:Ne(new te),lineNumbers:Ne(new oe),lineNumbersMinChars:Ne(new m(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new f(63,"linkedEditing",!1,{description:c.localize(221,null)})),links:Ne(new f(64,"links",!0,{description:c.localize(222,null)})),matchBrackets:Ne(new u(65,"matchBrackets","always",["always","near","never"],{description:c.localize(223,null)})),minimap:Ne(new he),mouseStyle:Ne(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new r(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:c.localize(224,null)})),mouseWheelZoom:Ne(new f(69,"mouseWheelZoom",!1,{markdownDescription:c.localize(225,null)})),multiCursorMergeOverlapping:Ne(new f(70,"multiCursorMergeOverlapping",!0,{description:c.localize(226,null)})),multiCursorModifier:Ne(new s(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[c.localize(227,null),c.localize(228,null)],markdownDescription:c.localize(229,null)})),multiCursorPaste:Ne(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(230,null),c.localize(231,null)],markdownDescription:c.localize(232,null)})),occurrencesHighlight:Ne(new f(73,"occurrencesHighlight",!0,{description:c.localize(233,null)})),overviewRulerBorder:Ne(new f(74,"overviewRulerBorder",!0,{description:c.localize(234,null)})),overviewRulerLanes:Ne(new m(75,"overviewRulerLanes",3,0,3)),padding:Ne(new fe),parameterHints:Ne(new be),peekWidgetDefaultFocus:Ne(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(235,null),c.localize(236,null)],description:c.localize(237,null)})),definitionLinkOpensInPeek:Ne(new f(79,"definitionLinkOpensInPeek",!1,{description:c.localize(238,null)})),quickSuggestions:Ne(new Re),quickSuggestionsDelay:Ne(new m(81,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(239,null)})),readOnly:Ne(new f(82,"readOnly",!1)),renameOnType:Ne(new f(83,"renameOnType",!1,{description:c.localize(240,null),markdownDeprecationMessage:c.localize(241,null)})),renderControlCharacters:Ne(new f(84,"renderControlCharacters",!0,{description:c.localize(242,null),restricted:!0})),renderFinalNewline:Ne(new f(85,"renderFinalNewline",!0,{description:c.localize(243,null)})),renderLineHighlight:Ne(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(244,null)],description:c.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Ne(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(246,null)})),renderValidationDecorations:Ne(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(247,null),c.localize(248,null),c.localize(249,null),""],description:c.localize(250,null)})),revealHorizontalRightPadding:Ne(new m(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new f(91,"roundedSelection",!0,{description:c.localize(251,null)})),rulers:Ne(new ge),scrollbar:Ne(new ae),scrollBeyondLastColumn:Ne(new m(94,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(252,null)})),scrollBeyondLastLine:Ne(new f(95,"scrollBeyondLastLine",!0,{description:c.localize(253,null)})),scrollPredominantAxis:Ne(new f(96,"scrollPredominantAxis",!0,{description:c.localize(254,null)})),selectionClipboard:Ne(new f(97,"selectionClipboard",!0,{description:c.localize(255,null),included:t.isLinux})),selectionHighlight:Ne(new f(98,"selectionHighlight",!0,{description:c.localize(256,null)})),selectOnLineNumbers:Ne(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),showUnused:Ne(new f(101,"showUnused",!0,{description:c.localize(261,null)})),showDeprecated:Ne(new f(128,"showDeprecated",!0,{description:c.localize(262,null)})),inlayHints:Ne(new ue),snippetSuggestions:Ne(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(263,null),c.localize(264,null),c.localize(265,null),c.localize(266,null)],description:c.localize(267,null)})),smartSelect:Ne(new pe),smoothScrolling:Ne(new f(104,"smoothScrolling",!1,{description:c.localize(268,null)})),stopRenderingLineAfter:Ne(new m(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new X),inlineSuggest:Ne(new ie),suggestFontSize:Ne(new m(109,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new m(110,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new f(111,"suggestOnTriggerCharacters",!0,{description:c.localize(271,null)})),suggestSelection:Ne(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(272,null),c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),tabCompletion:Ne(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(276,null),c.localize(277,null),c.localize(278,null)],description:c.localize(279,null)})),tabIndex:Ne(new m(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new ne),unusualLineTerminators:Ne(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(280,null),c.localize(281,null),c.localize(282,null)],description:c.localize(283,null)})),useShadowDOM:Ne(new f(117,"useShadowDOM",!0)),useTabStops:Ne(new f(118,"useTabStops",!0,{description:c.localize(284,null)})),wordSeparators:Ne(new b(119,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:c.localize(285,null)})),wordWrap:Ne(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(286,null),c.localize(287,null),c.localize(288,null),c.localize(289,null)],description:c.localize(290,null)})),wordWrapBreakAfterCharacters:Ne(new b(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new b(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new m(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(291,null)})),wordWrapOverride1:Ne(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new s(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ie,{enumDescriptions:[c.localize(292,null),c.localize(293,null),c.localize(294,null),c.localize(295,null)],description:c.localize(296,null)})),wrappingStrategy:Ne(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(297,null),c.localize(298,null)],description:c.localize(299,null)})),editorClassName:Ne(new M),pixelRatio:Ne(new ke),tabFocusMode:Ne(new we),layoutInfo:Ne(new x),wrappingInfo:Ne(new ye)}}),define(Ce[164],De([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[165],De([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[166],De([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[167],De([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[168],De([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(Ce[169],De([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(Ce[170],De([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(Ce[171],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[172],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[173],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[174],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[175],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[176],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[177],De([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[178],De([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[179],De([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ce[180],De([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(Ce[181],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[182],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[183],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[184],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[185],De([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[186],De([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[187],De([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[188],De([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[189],De([1,0,22,42,166,308]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(f){return f=f.trim(),f==="*"||C.test(f)}e.isValidVersionStr=S;function D(f){if(!S(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(C);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=D;function A(f){if(!f)return null;const v=f.majorBase,m=f.majorMustEqual,r=f.minorBase;let b=f.minorMustEqual;const o=f.patchBase;let u=f.patchMustEqual;f.hasCaret&&(v===0||(b=!1),u=!1);let s=0;if(f.preRelease){const l=T.exec(f.preRelease);if(l){const[,a,d,n]=l;s=Date.UTC(Number(a),Number(d)-1,Number(n))}}return{majorBase:v,majorMustEqual:m,minorBase:r,minorMustEqual:b,patchBase:o,patchMustEqual:u,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=A;function k(f,v,m){let r;typeof f=="string"?r=A(D(f)):r=f;let b;v instanceof Date?b=v.getTime():typeof v=="string"&&(b=new Date(v).getTime());let o;if(typeof m=="string"?o=A(D(m)):o=m,!r||!o)return!1;const u=r.majorBase,s=r.minorBase,l=r.patchBase;let a=o.majorBase,d=o.minorBase,n=o.patchBase;const i=o.notBefore;let p=o.majorMustEqual,_=o.minorMustEqual,R=o.patchMustEqual;return o.isMinimum?u>a?!0:u<a?!1:s>d?!0:s<d||b&&b<i?!1:l>=n:(u===1&&a===0&&(!p||!_||!R)&&(a=1,d=0,n=0,p=!0,_=!1,R=!1),u<a?!1:u>a?!p:s<d?!1:s>d?!_:l<n?!1:l>n?!R:!(b&&b<i))}e.isValidVersion=k;function E(f,v,m,r,b){const o=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return o.push([t.default.Error,I.localize(0,null)]),o;if(typeof r.name!="string")return o.push([t.default.Error,I.localize(1,null,"name")]),o;if(typeof r.version!="string")return o.push([t.default.Error,I.localize(2,null,"version")]),o;if(!r.engines)return o.push([t.default.Error,I.localize(3,null,"engines")]),o;if(typeof r.engines.vscode!="string")return o.push([t.default.Error,I.localize(4,null,"engines.vscode")]),o;if(typeof r.extensionDependencies<"u"&&!g(r.extensionDependencies))return o.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),o;if(typeof r.activationEvents<"u"){if(!g(r.activationEvents))return o.push([t.default.Error,I.localize(6,null,"activationEvents")]),o;if(typeof r.main>"u"&&typeof r.browser>"u")return o.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),o}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&o.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return o.push([t.default.Error,I.localize(9,null,"main")]),o;{const l=(0,c.joinPath)(m,r.main);(0,c.isEqualOrParent)(l,m)||o.push([t.default.Warning,I.localize(10,null,l.path,m.path)])}if(typeof r.activationEvents>"u")return o.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),o}if(typeof r.browser<"u"){if(typeof r.browser!="string")return o.push([t.default.Error,I.localize(12,null,"browser")]),o;{const l=(0,c.joinPath)(m,r.browser);(0,c.isEqualOrParent)(l,m)||o.push([t.default.Warning,I.localize(13,null,l.path,m.path)])}if(typeof r.activationEvents>"u")return o.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),o}if(!P.valid(r.version))return o.push([t.default.Error,I.localize(15,null)]),o;const u=[];if(!y(f,v,r,b,u))for(const l of u)o.push([t.default.Error,l]);return o}e.validateExtensionManifest=E;function y(f,v,m,r,b){return r||typeof m.main>"u"&&typeof m.browser>"u"?!0:h(f,v,m.engines.vscode,b)}e.isValidExtensionVersion=y;function w(f,v,m){return f==="*"||h(v,m,f)}e.isEngineValid=w;function h(f,v,m,r=[]){const b=A(D(m));if(!b)return r.push(I.localize(16,null,m)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return r.push(I.localize(17,null,m)),!1}else if(!b.majorMustEqual)return r.push(I.localize(18,null,m)),!1;return k(f,v,b)?!0:(r.push(I.localize(19,null,f,m)),!1)}function g(f){if(!Array.isArray(f))return!1;for(let v=0,m=f.length;v<m;v++)if(typeof f[v]!="string")return!1;return!0}}),define(Ce[120],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(I,P=[],C=!1){this.ctor=I,this.staticArguments=P,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=c}),define(Ce[84],De([1,0,120]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function P(T,S,D){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(D))),t.push([T,S])}e.registerSingleton=P;function C(){return t}e.getSingletonServiceDescriptors=C}),define(Ce[190],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(P,C){this.key=P,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const C of this._nodes.values())C.outgoing.size===0&&P.push(C);return P}insertEdge(P,C){const T=this.lookupOrInsertNode(P),S=this.lookupOrInsertNode(C);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(P){const C=this._hashFn(P);this._nodes.delete(C);for(const T of this._nodes.values())T.outgoing.delete(C),T.incoming.delete(C)}lookupOrInsertNode(P){const C=this._hashFn(P);let T=this._nodes.get(C);return T||(T=new c(C,P),this._nodes.set(C,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[C,T]of this._nodes)P.push(`${C}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,C]of this._nodes){const T=new Set([P]),S=this._findCycle(C,T);if(S)return S}}_findCycle(P,C){for(const[T,S]of P.outgoing){if(C.has(T))return[...C,T].join(" -> ");C.add(T);const D=this._findCycle(S,C);if(D)return D;C.delete(T)}}}e.Graph=t}),define(Ce[3],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(C,T,S){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:C,index:S}):(T[c.DI_DEPENDENCIES]=[{id:C,index:S}],T[c.DI_TARGET]=T)}function I(C){if(c.serviceIds.has(C))return c.serviceIds.get(C);const T=function(S,D,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,A)};return T.toString=()=>C,c.serviceIds.set(C,T),T}e.createDecorator=I;function P(C){return C}e.refineServiceDecorator=P}),define(Ce[66],De([1,0,12,2,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=P;function C(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=C;var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function D(f,v){const m=Object.create(null);for(const r in f)A(m,r,f[r],v);return m}e.toValuesTree=D;function A(f,v,m,r){const b=v.split("."),o=b.pop();let u=f;for(let s=0;s<b.length;s++){const l=b[s];let a=u[l];switch(typeof a){case"undefined":a=u[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${v} as ${b.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}u=a}if(typeof u=="object"&&u!==null)try{u[o]=m}catch{r(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(u)}`)}else r(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=A;function k(f,v){const m=v.split(".");E(f,m)}e.removeFromValueTree=k;function E(f,v){const m=v.shift();if(v.length===0){delete f[m];return}if(Object.keys(f).indexOf(m)!==-1){const r=f[m];typeof r=="object"&&!Array.isArray(r)&&(E(r,v),Object.keys(r).length===0&&delete f[m])}}function y(f,v,m){function r(u,s){let l=u;for(const a of s){if(typeof l!="object"||l===null)return;l=l[a]}return l}const b=v.split("."),o=r(f,b);return typeof o>"u"?m:o}e.getConfigurationValue=y;function w(f,v,m){Object.keys(v).forEach(r=>{r!=="__proto__"&&(r in f?c.isObject(f[r])&&c.isObject(v[r])?w(f[r],v[r],m):m&&(f[r]=v[r]):f[r]=v[r])})}e.merge=w;function h(f,v,m){const r=f.inspect(v),b=f.inspect(m);return typeof r.userValue<"u"||typeof r.workspaceValue<"u"||typeof r.workspaceFolderValue<"u"?r.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:r.defaultValue}e.getMigratedSettingValue=h;function g(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(Ce[52],De([1,0,10,8,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",c.isMacintosh),P.set("isLinux",c.isLinux),P.set("isWindows",c.isWindows),P.set("isWeb",c.isWeb),P.set("isMacNative",c.isMacintosh&&!c.isWeb),P.set("isEdge",c.isEdge),P.set("isFirefox",c.isFirefox),P.set("isChrome",c.isChrome),P.set("isSafari",c.isSafari);const C=Object.prototype.hasOwnProperty;var T;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return k.INSTANCE}static true(){return E.INSTANCE}static has(L){return y.create(L)}static equals(L,B){return w.create(L,B)}static notEquals(L,B){return f.create(L,B)}static regex(L,B){return s.create(L,B)}static in(L,B){return h.create(L,B)}static notIn(L,B){return g.create(L,B)}static not(L){return v.create(L)}static and(...L){return d.create(L,null,!0)}static or(...L){return n.create(L,null,!0)}static greater(L,B){return r.create(L,B)}static greaterEquals(L,B){return b.create(L,B)}static smaller(L,B){return o.create(L,B)}static smallerEquals(L,B){return u.create(L,B)}static deserialize(L,B=!1){if(!!L)return this._deserializeOrExpression(L,B)}static _deserializeOrExpression(L,B){const O=L.split("||");return n.create(O.map(z=>this._deserializeAndExpression(z,B)),null,!0)}static _deserializeAndExpression(L,B){const O=L.split("&&");return d.create(O.map(z=>this._deserializeOne(z,B)),null,!0)}static _deserializeOne(L,B){if(L=L.trim(),L.indexOf("!=")>=0){const O=L.split("!=");return f.create(O[0].trim(),this._deserializeValue(O[1],B))}if(L.indexOf("==")>=0){const O=L.split("==");return w.create(O[0].trim(),this._deserializeValue(O[1],B))}if(L.indexOf("=~")>=0){const O=L.split("=~");return s.create(O[0].trim(),this._deserializeRegexValue(O[1],B))}if(L.indexOf(" not in ")>=0){const O=L.split(" not in ");return g.create(O[0].trim(),this._deserializeValue(O[1],B))}if(L.indexOf(" in ")>=0){const O=L.split(" in ");return h.create(O[0].trim(),this._deserializeValue(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const O=L.split(">=");return b.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const O=L.split(">");return r.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const O=L.split("<=");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const O=L.split("<");return o.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(L)?v.create(L.substr(1).trim()):y.create(L)}static _deserializeValue(L,B){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const O=/^'([^']*)'$/.exec(L);return O?O[1].trim():L}static _deserializeRegexValue(L,B){if((0,t.isFalsyOrWhitespace)(L)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=L.indexOf("/"),z=L.lastIndexOf("/");if(O===z||O<0){if(B)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const U=L.slice(O+1,z),F=L[z+1]==="i"?"i":"";try{return new RegExp(U,F)}catch(V){if(B)throw new Error(`bad regexp-value '${L}', parse error: ${V}`);return console.warn(`bad regexp-value '${L}', parse error: ${V}`),null}}}e.ContextKeyExpr=S;function D($,L){const B=$?$.substituteConstants():void 0,O=L?L.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=D;function A($,L){return $.cmp(L)}class k{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class E{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class y{static create(L,B=null){const O=P.get(L);return typeof O=="boolean"?O?E.INSTANCE:k.INSTANCE:new y(L,B)}constructor(L,B){this.key=L,this.negated=B,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?E.INSTANCE:k.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class w{static create(L,B,O=null){if(typeof B=="boolean")return B?y.create(L,O):v.create(L,O);const z=P.get(L);return typeof z=="boolean"?B===(z?"true":"false")?E.INSTANCE:k.INSTANCE:new w(L,B,O)}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const B=L?"true":"false";return this.value===B?E.INSTANCE:k.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class h{static create(L,B){return new h(L,B)}constructor(L,B){this.key=L,this.valueKey=B,this.type=10,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.valueKey),O=L.getValue(this.key);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?C.call(B,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class g{static create(L,B){return new g(L,B)}constructor(L,B){this.key=L,this.valueKey=B,this.type=11,this._negated=h.create(L,B)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=g;class f{static create(L,B,O=null){if(typeof B=="boolean")return B?v.create(L,O):y.create(L,O);const z=P.get(L);return typeof z=="boolean"?B===(z?"true":"false")?k.INSTANCE:E.INSTANCE:new f(L,B,O)}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const B=L?"true":"false";return this.value===B?k.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class v{static create(L,B=null){const O=P.get(L);return typeof O=="boolean"?O?k.INSTANCE:E.INSTANCE:new v(L,B)}constructor(L,B){this.key=L,this.negated=B,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?k.INSTANCE:E.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function m($,L){if(typeof $=="string"){const B=parseFloat($);isNaN(B)||($=B)}return typeof $=="string"||typeof $=="number"?L($):k.INSTANCE}class r{static create(L,B,O=null){return m(B,z=>new r(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=r;class b{static create(L,B,O=null){return m(B,z=>new b(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=b;class o{static create(L,B,O=null){return m(B,z=>new o(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class u{static create(L,B,O=null){return m(B,z=>new u(L,z,O))}constructor(L,B,O){this.key=L,this.value=B,this.negated=O,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:_(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class s{static create(L,B){return new s(L,B)}constructor(L,B){this.key=L,this.regexp=B,this.type=7,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const B=this.regexp?this.regexp.source:"",O=L.regexp?L.regexp.source:"";return B<O?-1:B>O?1:0}equals(L){if(L.type===this.type){const B=this.regexp?this.regexp.source:"",O=L.regexp?L.regexp.source:"";return this.key===L.key&&B===O}return!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class l{static create(L){return new l(L)}constructor(L){this._actual=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new l(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function a($){let L=null;for(let B=0,O=$.length;B<O;B++){const z=$[B].substituteConstants();if($[B]!==z&&L===null){L=[];for(let U=0;U<B;U++)L[U]=$[U]}L!==null&&(L[B]=z)}return L===null?$:L}class d{static create(L,B,O){return d._normalizeArr(L,B,O)}constructor(L,B){this.expr=L,this.negated=B,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const z=A(this.expr[B],L.expr[B]);if(z!==0)return z}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:d.create(L,this.negated,!1)}evaluate(L){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(L))return!1;return!0}static _normalizeArr(L,B,O){const z=[];let U=!1;for(const F of L)if(!!F){if(F.type===1){U=!0;continue}if(F.type===0)return k.INSTANCE;if(F.type===6){z.push(...F.expr);continue}z.push(F)}if(z.length===0&&U)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(A);for(let F=1;F<z.length;F++)z[F-1].equals(z[F])&&(z.splice(F,1),F--);if(z.length===1)return z[0];for(;z.length>1;){const F=z[z.length-1];if(F.type!==9)break;z.pop();const V=z.pop(),x=z.length===0,Q=n.create(F.expr.map(K=>d.create([K,V],null,O)),null,x);Q&&(z.push(Q),z.sort(A))}if(z.length===1)return z[0];if(O){for(let F=0;F<z.length;F++)for(let V=F+1;V<z.length;V++)if(z[F].negate().equals(z[V]))return k.INSTANCE;if(z.length===1)return z[0]}return new d(z,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new d(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.negated){const L=[];for(const B of this.expr)L.push(B.negate());this.negated=n.create(L,this,!0)}return this.negated}}class n{static create(L,B,O){return n._normalizeArr(L,B,O)}constructor(L,B){this.expr=L,this.negated=B,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const z=A(this.expr[B],L.expr[B]);if(z!==0)return z}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:n.create(L,this.negated,!1)}evaluate(L){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(L))return!0;return!1}static _normalizeArr(L,B,O){let z=[],U=!1;if(L){for(let F=0,V=L.length;F<V;F++){const x=L[F];if(!!x){if(x.type===0){U=!0;continue}if(x.type===1)return E.INSTANCE;if(x.type===9){z=z.concat(x.expr);continue}z.push(x)}}if(z.length===0&&U)return k.INSTANCE;z.sort(A)}if(z.length!==0){if(z.length===1)return z[0];for(let F=1;F<z.length;F++)z[F-1].equals(z[F])&&(z.splice(F,1),F--);if(z.length===1)return z[0];if(O){for(let F=0;F<z.length;F++)for(let V=F+1;V<z.length;V++)if(z[F].negate().equals(z[V]))return E.INSTANCE;if(z.length===1)return z[0]}return new n(z,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new n(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.negated){const L=[];for(const B of this.expr)L.push(B.negate());for(;L.length>1;){const B=L.shift(),O=L.shift(),z=[];for(const U of H(B))for(const F of H(O))z.push(d.create([U,F],null,!1));L.unshift(n.create(z,null,!1))}this.negated=n.create(L,this,!0)}return this.negated}}class i extends y{static all(){return i._info.values()}constructor(L,B,O){super(L,null),this._defaultValue=B,typeof O=="object"?i._info.push({...O,key:L}):O!==!0&&i._info.push({key:L,description:O,type:B!=null?typeof B:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return w.create(this.key,L)}notEqualsTo(L){return f.create(this.key,L)}}e.RawContextKey=i,i._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p($,L){return $<L?-1:$>L?1:0}function _($,L,B,O){return $<B?-1:$>B?1:L<O?-1:L>O?1:0}function R($,L){if($.type===0||L.type===1)return!0;if($.type===9)return L.type===9?M($.expr,L.expr):!1;if(L.type===9){for(const B of L.expr)if(R($,B))return!0;return!1}if($.type===6){if(L.type===6)return M(L.expr,$.expr);for(const B of $.expr)if(R(B,L))return!0;return!1}return $.equals(L)}e.implies=R;function M($,L){let B=0,O=0;for(;B<$.length&&O<L.length;){const z=$[B].cmp(L[O]);if(z<0)return!1;z===0&&B++,O++}return B===$.length}function H($){return $.type===9?$.expr:[$]}}),define(Ce[191],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[121],De([1,0,165,3]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function C(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function T(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(f,v,m){return T(v,m)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===m?!0:D(m).includes(f)}e.isTargetPlatformCompatible=S;function D(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A;var k;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var y;(function(f){f.Install="install",f.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var w;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var h;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(v,m){super(v),this.code=m,this.name=m}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[192],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(Ce[193],De([1,0,44,14,9,10,106,29,114,167,192]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=D.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends E{openTerminal(r,b){return this.spawnTerminal(c,r,S.getWindowsShell(),b)}spawnTerminal(r,b,o,u){const s=b.windowsExec||y.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const l=I.basename(s).toLowerCase();if(l==="cmder"||l==="cmder.exe")return r.spawn(s,u?[u]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),(l==="wt"||l==="wt.exe")&&a.push("-d ."),new Promise((d,n)=>{const i=g(process),p=r.spawn(o,a,{cwd:u,env:i});p.on("error",n),p.on("exit",()=>d())})}runInTerminal(r,b,o,u,s){const l="windowsExec"in s&&s.windowsExec?s.windowsExec:y.getDefaultTerminalWindows();return new Promise((a,d)=>{const n=`"${b} - ${k}"`,i=`""${o.join('" "')}" & pause"`,p=["/c","start",n,"/wait",l,"/c",i],_=Object.assign({},g(process),u);Object.keys(_).filter(H=>_[H]===null).forEach(H=>delete _[H]);const R={cwd:b,env:_,windowsVerbatimArguments:!0};c.spawn(y.CMD,p,R).on("error",H=>{d(f(H))}),a(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class w extends E{openTerminal(r,b){return this.spawnTerminal(c,r,b)}runInTerminal(r,b,o,u,s){const l=s.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((a,d)=>{if(l===A.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const n=l===A.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`,J).fsPath,"-t",r||k,"-w",b];for(const M of o)p.push("-a"),p.push(M);if(u){const M=Object.assign({},g(process),u);for(const H in M){const $=M[H];$===null?(p.push("-u"),p.push(H)):(p.push("-e"),p.push(`${H}=${$}`))}}let _="";const R=c.spawn(w.OSASCRIPT,p);R.on("error",M=>{d(f(M))}),R.stderr.on("data",M=>{_+=M.toString()}),R.on("exit",M=>{if(M===0)a(void 0);else if(_){const H=_.split(`
`,1);d(new Error(H[0]))}else d(new Error(D.localize(1,null,n,M)))})}else d(new Error(D.localize(2,null,l)))})}spawnTerminal(r,b,o){const u=b.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{const a=["-a",u];o&&a.push(o);const d=g(process),n=r.spawn("/usr/bin/open",a,{cwd:o,env:d});n.on("error",l),n.on("exit",()=>s())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class h extends E{openTerminal(r,b){return this.spawnTerminal(c,r,b)}runInTerminal(r,b,o,u,s){const l=s.linuxExec?Promise.resolve(s.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((a,d)=>{const n=[];l.then(i=>{i.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${v(o)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;n.push(`''${p}''`);const _=Object.assign({},g(process),u);Object.keys(_).filter($=>_[$]===null).forEach($=>delete _[$]);const R={cwd:b,env:_};let M="";const H=c.spawn(i,n,R);H.on("error",$=>{d(f($))}),H.stderr.on("data",$=>{M+=$.toString()}),H.on("exit",$=>{if($===0)a(void 0);else if(M){const L=M.split(`
`,1);d(new Error(L[0]))}else d(new Error(D.localize(4,null,i,$)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await T.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(b=>{r?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,b,o){const u=b.linuxExec?Promise.resolve(b.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{u.then(a=>{const d=g(process),n=r.spawn(a,[],{cwd:o,env:d});n.on("error",l),n.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=D.localize(3,null);function g(m){const r={...m.env};return(0,C.sanitizeProcessEnvironment)(r),r}function f(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(D.localize(5,null,m.path)):m}function v(m){let r="";for(const b of m)b.indexOf(" ")>=0?r+='"'+b+'"':r+=b,r+=" ";return r}}),define(Ce[38],De([1,0,63,9,8,12,2,168,3]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function D(U){return U.create===!0}e.isFileOpenForWriteOptions=D;var A;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var k;(function(U){U[U.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var E;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function w(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=w;function h(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=h;function g(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;function v(U){return y(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var m;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class r extends Error{constructor(F,V){super(F),this.code=V}}e.FileSystemProviderError=r;function b(U,F){const V=new r(U.toString(),F);return u(V,F),V}e.createFileSystemProviderError=b;function o(U){return U||b((0,T.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=o;function u(U,F){return U.name=F?`${F} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=u;function s(U){if(!U)return m.Unknown;if(U instanceof r)return U.code;const F=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!F)return m.Unknown;switch(F[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=s;function l(U){if(U instanceof _)return U.fileOperationResult;switch(s(U)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var a;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class d{constructor(F,V,x){this.resource=F,this.operation=V,this.target=x}isOperation(F){return this.operation===F}}e.FileOperationEvent=d;var n;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class i{constructor(F,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=F;const x=new Map;for(const Q of F){const K=x.get(Q.type);switch(K?K.push([Q.resource,Q]):x.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of x)switch(Q){case 1:this.added=c.TernarySearchTree.forUris(()=>V),this.added.fill(K);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>V),this.updated.fill(K);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>V),this.deleted.fill(K);break}}contains(F,...V){return this.doContains(F,{includeChildren:!1},...V)}affects(F,...V){return this.doContains(F,{includeChildren:!0},...V)}doContains(F,V,...x){if(!F)return!1;const Q=x.length>0;return!!((!Q||x.includes(1))&&(this.added?.get(F)||V.includeChildren&&this.added?.findSuperstr(F))||(!Q||x.includes(0))&&(this.updated?.get(F)||V.includeChildren&&this.updated?.findSuperstr(F))||(!Q||x.includes(2))&&(this.deleted?.findSubstr(F)||V.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=i;function p(U,F,V){return!U||!F||U===F||F.length>U.length?!1:(F.charAt(F.length-1)!==t.sep&&(F+=t.sep),V?(0,I.startsWithIgnoreCase)(U,F):U.indexOf(F)===0)}e.isParent=p;class _ extends Error{constructor(F,V,x){super(F),this.fileOperationResult=V,this.options=x}}e.FileOperationError=_;class R extends _{constructor(F,V,x){super(F,2,x),this.stat=V}}e.NotModifiedSinceFileOperationError=R;var M;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=$;async function L(U,F){if(!F.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(V=>{const x=F.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===U.scheme&&Q.added&&(x.dispose(),V())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(F){return(0,P.isNumber)(F)||(F=0),F<B.KB?(0,T.localize)(1,null,F.toFixed(0)):F<B.MB?(0,T.localize)(2,null,(F/B.KB).toFixed(2)):F<B.GB?(0,T.localize)(3,null,(F/B.MB).toFixed(2)):F<B.TB?(0,T.localize)(4,null,(F/B.GB).toFixed(2)):(0,T.localize)(5,null,(F/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var O;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*B.MB:16*B.GB,maxHeapSize:U===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=z}),define(Ce[85],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...I){this._entries=new Map;for(const[P,C]of I)this.set(P,C)}set(I,P){const C=this._entries.get(I);return this._entries.set(I,P),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=c}),define(Ce[194],De([1,0,18,11,6,120,190,3,85,62]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class k extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,f=!1,v,m=A){this._services=g,this._strict=f,this._parent=v,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=m?v?._globalGraph??new C.Graph(r=>r):void 0}createChild(g){return new E(g,this._strict,this,this._enableTracing)}invokeFunction(g,...f){const v=w.traceInvocation(this._enableTracing,g);let m=!1;try{return g({get:b=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(b,v);if(!o)throw new Error(`[invokeFunction] unknown service '${b}'`);return o}},...f)}finally{m=!0,v.stop()}}createInstance(g,...f){let v,m;return g instanceof P.SyncDescriptor?(v=w.traceCreation(this._enableTracing,g.ctor),m=this._createInstance(g.ctor,g.staticArguments.concat(f),v)):(v=w.traceCreation(this._enableTracing,g),m=this._createInstance(g,f,v)),v.stop(),m}_createInstance(g,f=[],v){const m=T._util.getServiceDependencies(g).sort((o,u)=>o.index-u.index),r=[];for(const o of m){const u=this._getOrCreateServiceInstance(o.id,v);u||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${o.id}.`,!1),r.push(u)}const b=m.length>0?m[0].index:f.length;if(f.length!==b){console.trace(`[createInstance] First service dependency of ${g.name} at position ${b+1} conflicts with ${f.length} static arguments`);const o=b-f.length;o>0?f=f.concat(new Array(o)):f=f.slice(0,b)}return Reflect.construct(g,f.concat(r))}_setServiceInstance(g,f){if(this._services.get(g)instanceof P.SyncDescriptor)this._services.set(g,f);else if(this._parent)this._parent._setServiceInstance(g,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const f=this._services.get(g);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):f}_getOrCreateServiceInstance(g,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const v=this._getServiceInstanceOrDescriptor(g);return v instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,v,f.branch(g,!0)):(f.branch(g,!1),v)}_safeCreateAndCacheServiceInstance(g,f,v){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,f,v)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,f,v){const m=new C.Graph(o=>o.id.toString());let r=0;const b=[{id:g,desc:f,_trace:v}];for(;b.length;){const o=b.pop();if(m.lookupOrInsertNode(o),r++>1e3)throw new k(m);for(const u of T._util.getServiceDependencies(o.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(u.id);if(s||this._throwIfStrict(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(o.id),String(u.id)),s instanceof P.SyncDescriptor){const l={id:u.id,desc:s,_trace:o._trace.branch(u.id,!0)};m.insertEdge(o,l),b.push(l)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof P.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,f,v=[],m,r){if(this._services.get(g)instanceof P.SyncDescriptor)return this._createServiceInstance(g,f,v,m,r);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,f,v,m,r);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(g,f,v=[],m,r){if(m){const b=new E(void 0,this._strict,this,this._enableTracing);b._globalGraphImplicitDependency=String(g);const o=new Map,u=new c.IdleValue(()=>{const s=b._createInstance(f,v,r);for(const[l,a]of o){const d=s[l];if(typeof d=="function")for(const n of a)d.apply(s,n)}return o.clear(),s});return new Proxy(Object.create(null),{get(s,l){if(!u.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=o.get(l);return n||(n=new D.LinkedList,o.set(l,n)),(p,_,R)=>{const M=n.push([p,_,R]);return(0,I.toDisposable)(M)}}if(l in s)return s[l];const a=u.value;let d=a[l];return typeof d!="function"||(d=d.bind(a),s[l]=d),d},set(s,l,a){return u.value[l]=a,!0}})}else return this._createInstance(f,v,r)}_throwIfStrict(g,f){if(f&&console.warn(g),this._strict)throw new Error(g)}}e.InstantiationService=E;var y;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(y||(y={}));class w{static traceInvocation(g,f){return g?new w(1,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w._None}static traceCreation(g,f){return g?new w(0,f.name):w._None}constructor(g,f){this.type=g,this.name=f,this._start=Date.now(),this._dep=[]}branch(g,f){const v=new w(2,g.toString());return this._dep.push([g,f,v]),v}stop(){const g=Date.now()-this._start;w._totals+=g;let f=!1;function v(r,b){const o=[],u=new Array(r+1).join("	");for(const[s,l,a]of b._dep)if(l&&a){f=!0,o.push(`${u}CREATES -> ${s}`);const d=v(r+1,a);d&&o.push(d)}else o.push(`${u}uses -> ${s}`);return o.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(g>2||f)&&w.all.add(m.join(`
`))}}e.Trace=w,w.all=new Set,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(Ce[13],De([1,0,50,4,6,28,10,2,3]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function D(){return new Date().toISOString()}var A;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(A=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=A.Info;function k(d,n,i){switch(n){case A.Trace:d.trace(i);break;case A.Debug:d.debug(i);break;case A.Info:d.info(i);break;case A.Warning:d.warn(i);break;case A.Error:d.error(i);break;case A.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}e.log=k;function E(d){let n="";for(let i=0;i<d.length;i++){let p=d[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(i>0?" ":"")+p}return n}e.format=E;class y extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class w extends y{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(A.Trace)&&this.log(A.Trace,E([n,...i]))}debug(n,...i){this.checkLogLevel(A.Debug)&&this.log(A.Debug,E([n,...i]))}info(n,...i){this.checkLogLevel(A.Info)&&this.log(A.Info,E([n,...i]))}warn(n,...i){this.checkLogLevel(A.Warning)&&this.log(A.Warning,E([n,...i]))}error(n,...i){if(this.checkLogLevel(A.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.log(A.Error,E(p))}else this.log(A.Error,E([n,...i]))}critical(n,...i){this.checkLogLevel(A.Critical)&&this.log(A.Critical,E([n,...i]))}flush(){}}e.AbstractMessageLogger=w;class h extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!C.isWindows}trace(n,...i){this.getLevel()<=A.Trace&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...i):console.log(`[main ${D()}]`,n,...i))}debug(n,...i){this.getLevel()<=A.Debug&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...i):console.log(`[main ${D()}]`,n,...i))}info(n,...i){this.getLevel()<=A.Info&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...i):console.log(`[main ${D()}]`,n,...i))}warn(n,...i){this.getLevel()<=A.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,n,...i):console.warn(`[main ${D()}]`,n,...i))}error(n,...i){this.getLevel()<=A.Error&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,n,...i):console.error(`[main ${D()}]`,n,...i))}critical(n,...i){this.getLevel()<=A.Critical&&(this.useColors?console.error(`\x1B[90m[main ${D()}]\x1B[0m`,n,...i):console.error(`[main ${D()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class g extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=A.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=A.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=A.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=A.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=A.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=A.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class f extends y{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=A.Trace&&this.adapter.log(A.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=A.Debug&&this.adapter.log(A.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=A.Info&&this.adapter.log(A.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=A.Warning&&this.adapter.log(A.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=A.Error&&this.adapter.log(A.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=A.Critical&&this.adapter.log(A.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.getLevel()<=A.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class v extends y{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const p of this.logServices)p.trace(n,...i)}debug(n,...i){for(const p of this.logServices)p.debug(n,...i)}info(n,...i){for(const p of this.logServices)p.info(n,...i)}warn(n,...i){for(const p of this.logServices)p.warn(n,...i)}error(n,...i){for(const p of this.logServices)p.error(n,...i)}critical(n,...i){for(const p of this.logServices)p.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class m extends I.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=m;class r extends I.Disposable{constructor(n,i){super(),this.logLevel=n,this.loggerItems=new P.ResourceMap,this._register(i(p=>this.setLevel(p)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:n})=>n)}getLogger(n){return this.loggerItems.get(n)?.logger}createLogger(n,i,p){let _=this.loggerItems.get(n)?.logger;return _||(p=i?.always?A.Trace:p,_=this.doCreateLogger(n,p??this.logLevel,i),this.loggerItems.set(n,{logger:_,logLevel:p})),_}setLevel(n,i){const p=T.URI.isUri(n)?n:void 0,_=p?i:n;if(p){const R=this.loggerItems.get(p);R&&R.logLevel!==_&&(R.logLevel=_,R.logger.setLevel(_))}else this.logLevel=_,this.loggerItems.forEach(({logLevel:R,logger:M})=>{R===void 0&&M.setLevel(this.logLevel)})}getLogLevel(n){return this.loggerItems.get(n)?.logLevel}dispose(){this.loggerItems.forEach(({logger:n})=>n.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=r;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return A.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogger=b;class o extends b{}e.NullLogService=o;class u extends r{constructor(){super(A.Info,t.Event.None)}doCreateLogger(n,i,p){return new b}}e.NullLoggerService=u;function s(d){if(d.verbose)return A.Trace;if(typeof d.logLevel=="string"){const n=l(d.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function l(d){switch(d){case"trace":return A.Trace;case"debug":return A.Debug;case"info":return A.Info;case"warn":return A.Warning;case"error":return A.Error;case"critical":return A.Critical;case"off":return A.Off}}e.parseLogLevel=l;function a(d){switch(d){case A.Trace:return"trace";case A.Debug:return"debug";case A.Info:return"info";case A.Warning:return"warn";case A.Error:return"error";case A.Critical:return"critical";case A.Off:return"off"}}e.LogLevelToString=a}),define(Ce[195],De([1,0,38,13]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(T,S,D,A,k){try{const E=await new Promise((w,h)=>{J(["spdlog"],w,h)});E.setFlushOn(t.LogLevel.Trace);const y=await E.createAsyncRotatingLogger(T,S,D,A);return k?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(E){console.error(E)}return null}function P(T,S,D){switch(S){case t.LogLevel.Trace:T.trace(D);break;case t.LogLevel.Debug:T.debug(D);break;case t.LogLevel.Info:T.info(D);break;case t.LogLevel.Warning:T.warn(D);break;case t.LogLevel.Error:T.error(D);break;case t.LogLevel.Critical:T.critical(D);break;default:throw new Error("Invalid log level")}}class C extends t.AbstractMessageLogger{constructor(S,D,A,k,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(S,D,A,k),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}async _createSpdLogLogger(S,D,A,k){const E=A?6:1,y=30/E*c.ByteSize.MB,w=await I(S,D,y,E,k);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:h,message:g}of this.buffer)P(this._logger,h,g);this.buffer=[]}}log(S,D){this._logger?P(this._logger,S,D):this.getLevel()<=S&&this.buffer.push({level:S,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(Ce[122],De([1,0,42,169,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function D(w,h){return h-w}S.compare=D;const A=Object.create(null);A[S.Error]=(0,t.localize)(0,null),A[S.Warning]=(0,t.localize)(1,null),A[S.Info]=(0,t.localize)(2,null);function k(w){return A[w]||""}S.toString=k;function E(w){switch(w){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=E;function y(w){switch(w){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=y}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const D="";function A(E){return k(E,!0)}S.makeKey=A;function k(E,y){const w=[D];return E.source?w.push(E.source.replace("\xA6","\\\xA6")):w.push(D),E.code?typeof E.code=="string"?w.push(E.code.replace("\xA6","\\\xA6")):w.push(E.code.value.replace("\xA6","\\\xA6")):w.push(D),E.severity!==void 0&&E.severity!==null?w.push(C.toString(E.severity)):w.push(D),E.message&&y?w.push(E.message.replace("\xA6","\\\xA6")):w.push(D),E.startLineNumber!==void 0&&E.startLineNumber!==null?w.push(E.startLineNumber.toString()):w.push(D),E.startColumn!==void 0&&E.startColumn!==null?w.push(E.startColumn.toString()):w.push(D),E.endLineNumber!==void 0&&E.endLineNumber!==null?w.push(E.endLineNumber.toString()):w.push(D),E.endColumn!==void 0&&E.endColumn!==null?w.push(E.endColumn.toString()):w.push(D),w.push(D),w.join("\xA6")}S.makeKeyOptionalMessage=k})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Ce[196],De([1,0,4,42,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var P;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=S}),define(Ce[123],De([1,0,6,8,2,3]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(A){return{resolved:A,dispose(){}}}});function C(A,k){return I.URI.isUri(A)?(0,t.equalsIgnoreCase)(A.scheme,k):(0,t.startsWithIgnoreCase)(A,k+":")}e.matchesScheme=C;function T(A,...k){return k.some(E=>C(A,E))}e.matchesSomeScheme=T;function S(A,k){return A.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=S;function D(A){let k;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(A.fragment);return E&&(k={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},A=A.with({fragment:""})),{selection:k,uri:A}}e.extractSelection=D}),define(Ce[197],De([1,0,14,10,36,22]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const T=t.globals.vscode.context.configuration();if(T)C=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const T=(0,P.dirname)(c.FileAccess.asFileUri("",J));if(C=J.__$__nodeRequire((0,P.joinPath)(T,"product.json").fsPath),I.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const S=J.__$__nodeRequire((0,P.joinPath)(T,"package.json").fsPath);Object.assign(C,{version:S.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(Ce[198],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(J,e){return function(c,t){e(c,t,J)}};define(Ce[124],De([1,0,18,21,6,3]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var C;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this._value}constructor(k){this.callback=k}report(k){this._value=k,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(k,E){super(),this.deferred=new c.DeferredPromise,E.withProgress(k,y=>(this.reporter=y,this.lastStep&&y.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=je([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class D extends I.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(k){this.stop();const E=++this.currentOperationId,y=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>y.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:y.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(Ce[43],De([1,0,48,12]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(C,T){c.ok(t.isString(C)),c.ok(t.isObject(T)),c.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,T)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(Ce[125],De([1,0,4,43]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,D){this.schemasById[I(S)]=D,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new P;t.Registry.add(e.Extensions.JSONContribution,C)}),define(Ce[126],De([1,0,17,4,12,164,66,125,43]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,u=!0){this.registerConfigurations([o],u)}registerConfigurations(o,u=!0){const s=this.doRegisterConfigurations(o,u);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(o){const u=this.doDeregisterConfigurations(o);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:o,remove:u}){const s=[];s.push(...this.doDeregisterConfigurations(u)),s.push(...this.doRegisterConfigurations(o,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,c.distinct)(s)})}registerDefaultConfigurations(o){const u=[],s=[];for(const{overrides:l,source:a}of o)for(const d in l)if(u.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const n=this.configurationDefaultsOverrides.get(d),i=n?.valuesSources??new Map;if(a)for(const M of Object.keys(l[d]))i.set(M,a);const p={...n?.value||{},...l[d]};this.configurationDefaultsOverrides.set(d,{source:a,value:p,valuesSources:i});const _=(0,C.getLanguageTagSettingPlainKey)(d),R={type:"object",default:p,description:P.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:I.isString(a)?void 0:a,defaultValueSource:a};s.push(...h(d)),this.configurationProperties[d]=R,this.defaultLanguageConfigurationOverridesNode.properties[d]=R}else{this.configurationDefaultsOverrides.set(d,{value:l[d],source:a});const n=this.configurationProperties[d];n&&(this.updatePropertyDefaultValue(d,n),this.updateSchema(d,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const u=[];for(const{overrides:s,source:l}of o)for(const a in s){const d=this.configurationDefaultsOverrides.get(a),n=I.isString(l)?l:l?.id,i=I.isString(d?.source)?d?.source:d?.source?.id;if(n===i)if(u.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const p=this.configurationProperties[a];p&&(this.updatePropertyDefaultValue(a,p),this.updateSchema(a,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const u of o)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,u){const s=[];return o.forEach(l=>{s.push(...this.validateAndRegisterProperties(l,u,l.extensionInfo,l.restrictedProperties)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),s}doDeregisterConfigurations(o){const u=[],s=l=>{if(l.properties)for(const a in l.properties){u.push(a);const d=this.configurationProperties[a];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,l.properties[a])}l.allOf?.forEach(a=>s(a))};for(const l of o){s(l);const a=this.configurationContributors.indexOf(l);a!==-1&&this.configurationContributors.splice(a,1)}return u}validateAndRegisterProperties(o,u=!0,s,l,a=3){a=I.isUndefinedOrNull(o.scope)?a:o.scope;const d=[],n=o.properties;if(n)for(const p in n){const _=n[p];if(u&&m(p,_)){delete n[p];continue}if(_.source=s,_.defaultDefaultValue=n[p].default,this.updatePropertyDefaultValue(p,_),e.OVERRIDE_PROPERTY_REGEX.test(p)?_.scope=void 0:(_.scope=I.isUndefinedOrNull(_.scope)?a:_.scope,_.restricted=I.isUndefinedOrNull(_.restricted)?!!l?.includes(p):_.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.excludedConfigurationProperties[p]=n[p],delete n[p];continue}else this.configurationProperties[p]=n[p],n[p].policy?.name&&this.policyConfigurations.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),d.push(p)}const i=o.allOf;if(i)for(const p of i)d.push(...this.validateAndRegisterProperties(p,u,s,l,a));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const u=s=>{const l=s.properties;if(l)for(const d in l)this.updateSchema(d,l[d]);s.allOf?.forEach(u)};u(o)}updateSchema(o,u){switch(e.allSettings.properties[o]=u,u.scope){case 1:e.applicationSettings.properties[o]=u;break;case 2:e.machineSettings.properties[o]=u;break;case 6:e.machineOverridableSettings.properties[o]=u;break;case 3:e.windowSettings.properties[o]=u;break;case 4:e.resourceSettings.properties[o]=u;break;case 5:e.resourceSettings.properties[o]=u,this.resourceLanguageSettingsSchema.properties[o]=u;break}}removeFromSchema(o,u){switch(delete e.allSettings.properties[o],u.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const u=`[${o}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,s),e.allSettings.properties[u]=s,e.applicationSettings.properties[u]=s,e.machineSettings.properties[u]=s,e.machineOverridableSettings.properties[u]=s,e.windowSettings.properties[u]=s,e.resourceSettings.properties[u]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,u){const s=this.configurationDefaultsOverrides.get(o);let l=s?.value,a=s?.source;I.isUndefined(l)&&(l=u.defaultDefaultValue,a=void 0),I.isUndefined(l)&&(l=f(u.type)),u.default=l,u.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",w=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(b){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let u=w.exec(b);for(;u?.length;){const s=u[1].trim();s&&o.push(s),u=w.exec(b)}}return(0,c.distinct)(o)}e.overrideIdentifiersFromKey=h;function g(b){return b.reduce((o,u)=>`${o}[${u}]`,"")}e.keyFromOverrideIdentifiers=g;function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new E;S.Registry.add(e.Extensions.Configuration,v);function m(b,o){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?P.localize(7,null,b):v.getConfigurationProperties()[b]!==void 0?P.localize(8,null,b):o.policy?.name&&v.getPolicyConfigurations().get(o.policy?.name)!==void 0?P.localize(9,null,b,o.policy?.name,v.getPolicyConfigurations().get(o.policy?.name)):null:P.localize(6,null)}e.validateProperty=m;function r(){const b=[],o=v.getConfigurationProperties();for(const u of Object.keys(o))b.push([u,o[u].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=r}),define(Ce[199],De([1,0,17,4,144,6,28,24,12,2,66,126,43]),function(J,e,c,t,I,P,C,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(u={},s=[],l=[],a){this._contents=u,this._keys=s,this._overrides=l,this.raw=a,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const u=this.raw.map(s=>{if(s instanceof y)return s;const l=new w("");return l.parseRaw(s),l.configurationModel});this._rawConfiguration=u.reduce((s,l)=>l===s?l:s.merge(l),u[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(u){return u?(0,A.getConfigurationValue)(this.contents,u):this.contents}inspect(u,s){const l=this.rawConfiguration.getValue(u),a=s?this.rawConfiguration.getOverrideValue(u,s):void 0,d=s?this.rawConfiguration.override(s).getValue(u):l;return{value:l,override:a,merged:d}}getOverrideValue(u,s){const l=this.getContentsForOverrideIdentifer(s);return l?u?(0,A.getConfigurationValue)(l,u):l:void 0}getKeysForOverrideIdentifier(u){const s=[];for(const l of this.overrides)l.identifiers.includes(u)&&s.push(...l.keys);return c.distinct(s)}getAllOverrideIdentifiers(){const u=[];for(const s of this.overrides)u.push(...s.identifiers);return c.distinct(u)}override(u){let s=this.overrideConfigurations.get(u);return s||(s=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,s)),s}merge(...u){const s=T.deepClone(this.contents),l=T.deepClone(this.overrides),a=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const n of u)if(d.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.mergeContents(s,n.contents);for(const i of n.overrides){const[p]=l.filter(_=>c.equals(_.identifiers,i.identifiers));p?(this.mergeContents(p.contents,i.contents),p.keys.push(...i.keys),p.keys=c.distinct(p.keys)):l.push(T.deepClone(i))}for(const i of n.keys)a.indexOf(i)===-1&&a.push(i)}return new y(s,a,l,d.every(n=>n instanceof y)?void 0:d)}freeze(){return this.frozen=!0,this}clone(){return new y(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}createOverrideConfigurationModel(u){const s=this.getContentsForOverrideIdentifer(u);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const l={};for(const a of c.distinct([...Object.keys(this.contents),...Object.keys(s)])){let d=this.contents[a];const n=s[a];n&&(typeof d=="object"&&typeof n=="object"?(d=T.deepClone(d),this.mergeContents(d,n)):d=n),l[a]=d}return new y(l,this.keys,this.overrides)}mergeContents(u,s){for(const l of Object.keys(s)){if(l in u&&S.isObject(u[l])&&S.isObject(s[l])){this.mergeContents(u[l],s[l]);continue}u[l]=T.deepClone(s[l])}}checkAndFreeze(u){return this.frozen&&!Object.isFrozen(u)?T.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let s=null,l=null;const a=d=>{d&&(l?this.mergeContents(l,d):l=T.deepClone(d))};for(const d of this.overrides)c.equals(d.identifiers,[u])?s=d.contents:d.identifiers.includes(u)&&a(d.contents);return a(s),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,s){this.addKey(u),(0,A.addToValueTree)(this.contents,u,s,l=>{throw new Error(l)})}removeValue(u){this.removeKey(u)&&(0,A.removeFromValueTree)(this.contents,u)}addKey(u){let s=this.keys.length;for(let l=0;l<s;l++)u.indexOf(this.keys[l])===0&&(s=l);this.keys.splice(s,1,u)}removeKey(u){const s=this.keys.indexOf(u);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class w{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,s){if(!S.isUndefinedOrNull(u)){const l=this.doParseContent(u);this.parseRaw(l,s)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,s){this._raw=u;const{contents:l,keys:a,overrides:d,restricted:n,hasExcludedProperties:i}=this.doParseRaw(u,s);this._configurationModel=new y(l,a,d,i?[u]:void 0),this._restrictedConfigurations=n||[]}doParseContent(u){let s={},l=null,a=[];const d=[],n=[];function i(_){Array.isArray(a)?a.push(_):l!==null&&(a[l]=_)}const p={onObjectBegin:()=>{const _={};i(_),d.push(a),a=_,l=null},onObjectProperty:_=>{l=_},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const _=[];i(_),d.push(a),a=_,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:i,onError:(_,R,M)=>{n.push({error:_,offset:R,length:M})}};if(u)try{I.visit(u,p),s=a[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return s}doParseRaw(u,s){const l=E.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=this.filter(u,l,!0,s);u=a.raw;const d=(0,A.toValuesTree)(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),n=Object.keys(u),i=this.toOverrides(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:d,keys:n,overrides:i,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(u,s,l,a){let d=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:u,restricted:[],hasExcludedProperties:d};const n={},i=[];for(const p in u)if(k.OVERRIDE_PROPERTY_REGEX.test(p)&&l){const _=this.filter(u[p],s,!1,a);n[p]=_.raw,d=d||_.hasExcludedProperties,i.push(..._.restricted)}else{const _=s[p],R=_?typeof _.scope<"u"?_.scope:3:void 0;_?.restricted&&i.push(p),(R===void 0||a.scopes===void 0||a.scopes.includes(R))&&!(a.skipRestricted&&_?.restricted)?n[p]=u[p]:d=!0}return{raw:n,restricted:i,hasExcludedProperties:d}}toOverrides(u,s){const l=[];for(const a of Object.keys(u))if(k.OVERRIDE_PROPERTY_REGEX.test(a)){const d={};for(const n in u[a])d[n]=u[a][n];l.push({identifiers:(0,k.overrideIdentifiersFromKey)(a),keys:Object.keys(d),contents:(0,A.toValuesTree)(d,s)})}return l}}e.ConfigurationModelParser=w;class h extends P.Disposable{constructor(u,s,l,a){super(),this.userSettingsResource=u,this.scopes=s,this.fileService=a,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&l.isEqual(d.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class g{constructor(u,s,l,a,d,n,i,p,_,R,M,H,$){this.key=u,this.overrides=s,this.value=l,this.overrideIdentifiers=a,this.defaultConfiguration=d,this.policyConfiguration=n,this.applicationConfiguration=i,this.userConfiguration=p,this.localUserConfiguration=_,this.remoteUserConfiguration=R,this.workspaceConfiguration=M,this.folderConfigurationModel=H,this.memoryInspectValue=$}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(u,s,l,a,d=new y,n=new y,i=new C.ResourceMap,p=new y,_=new C.ResourceMap,R=!0){this._defaultConfiguration=u,this._policyConfiguration=s,this._applicationConfiguration=l,this._localUserConfiguration=a,this._remoteUserConfiguration=d,this._workspaceConfiguration=n,this._folderConfigurations=i,this._memoryConfiguration=p,this._memoryConfigurationByResource=_,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(u,s,l){return this.getConsolidatedConfigurationModel(u,s,l).getValue(u)}updateValue(u,s,l={}){let a;l.resource?(a=this._memoryConfigurationByResource.get(l.resource),a||(a=new y,this._memoryConfigurationByResource.set(l.resource,a))):a=this._memoryConfiguration,s===void 0?a.removeValue(u):a.setValue(u,s),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,s,l){const a=this.getConsolidatedConfigurationModel(u,s,l),d=c.distinct(a.overrides.map(p=>p.identifiers).flat()).filter(p=>a.getOverrideValue(u,p)!==void 0),n=this.getFolderConfigurationModelForResource(s.resource,l),i=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration;return new g(u,s,a.getValue(u),d.length?d:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),l?this._workspaceConfiguration.freeze():void 0,n?n.freeze():void 0,i.inspect(u,s.overrideIdentifier))}keys(u){const s=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,s){this._folderConfigurations.set(u,s),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,s){const l=[];if(!s){const{added:a,updated:d,removed:n}=r(this._defaultConfiguration,u);s=[...a,...d,...n]}for(const a of s)for(const d of(0,k.overrideIdentifiersFromKey)(a)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(d),i=u.getKeysForOverrideIdentifier(d),p=[...i.filter(_=>n.indexOf(_)===-1),...n.filter(_=>i.indexOf(_)===-1),...n.filter(_=>!T.equals(this._defaultConfiguration.override(d).getValue(_),u.override(d).getValue(_)))];l.push([d,p])}return this.updateDefaultConfiguration(u),{keys:s,overrides:l}}compareAndUpdatePolicyConfiguration(u){const{added:s,updated:l,removed:a}=r(this._policyConfiguration,u),d=[...s,...l,...a];return d.length&&this.updatePolicyConfiguration(u),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:s,updated:l,removed:a,overrides:d}=r(this.applicationConfiguration,u),n=[...s,...l,...a];return n.length&&this.updateApplicationConfiguration(u),{keys:n,overrides:d}}compareAndUpdateLocalUserConfiguration(u){const{added:s,updated:l,removed:a,overrides:d}=r(this.localUserConfiguration,u),n=[...s,...l,...a];return n.length&&this.updateLocalUserConfiguration(u),{keys:n,overrides:d}}compareAndUpdateRemoteUserConfiguration(u){const{added:s,updated:l,removed:a,overrides:d}=r(this.remoteUserConfiguration,u),n=[...s,...l,...a];return n.length&&this.updateRemoteUserConfiguration(u),{keys:n,overrides:d}}compareAndUpdateWorkspaceConfiguration(u){const{added:s,updated:l,removed:a,overrides:d}=r(this.workspaceConfiguration,u),n=[...s,...l,...a];return n.length&&this.updateWorkspaceConfiguration(u),{keys:n,overrides:d}}compareAndUpdateFolderConfiguration(u,s){const l=this.folderConfigurations.get(u),{added:a,updated:d,removed:n,overrides:i}=r(l,s),p=[...a,...d,...n];return(p.length||!l)&&this.updateFolderConfiguration(u,s),{keys:p,overrides:i}}compareAndDeleteFolderConfiguration(u){const s=this.folderConfigurations.get(u);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:l,updated:a,removed:d,overrides:n}=r(s,void 0);return{keys:[...l,...a,...d],overrides:n}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,s,l){let a=this.getConsolidatedConfigurationModelForResource(s,l);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:u},s){let l=this.getWorkspaceConsolidatedConfiguration();if(s&&u){const a=s.getFolder(u);a&&(l=this.getFolderConsolidatedConfiguration(a.uri)||l);const d=this._memoryConfigurationByResource.get(u);d&&(l=l.merge(d))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let s=this._foldersConsolidatedConfigurations.get(u);if(!s){const l=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(u);a?(s=l.merge(a),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(u,s)):s=l}return s}getFolderConfigurationModelForResource(u,s){if(s&&u){const l=s.getFolder(u);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,s)=>{const{contents:l,overrides:a,keys:d}=this._folderConfigurations.get(s);return u.push([s,{contents:l,overrides:a,keys:d}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>u.add(s)),this.userConfiguration.freeze().keys.forEach(s=>u.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>u.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(l=>u.add(l))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>u.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>u.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>u.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(l=>u.add(l))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>s.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>s.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>s.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(u).forEach(a=>s.add(a))),[...s.values()]}static parse(u){const s=this.parseConfigurationModel(u.defaults),l=this.parseConfigurationModel(u.policy),a=this.parseConfigurationModel(u.application),d=this.parseConfigurationModel(u.user),n=this.parseConfigurationModel(u.workspace),i=u.folders.reduce((p,_)=>(p.set(D.URI.revive(_[0]),this.parseConfigurationModel(_[1])),p),new C.ResourceMap);return new f(s,l,a,d,new y,n,i,new y,new C.ResourceMap,!1)}static parseConfigurationModel(u){return new y(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=f;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const u=new Set,s=new Map;for(const a of o)a.keys.forEach(d=>u.add(d)),a.overrides.forEach(([d,n])=>{const i=(0,C.getOrSet)(s,d,new Set);n.forEach(p=>i.add(p))});const l=[];return s.forEach((a,d)=>l.push([d,[...a.values()]])),{keys:[...u.values()],overrides:l}}e.mergeChanges=v;class m{constructor(u,s,l,a){this.change=u,this.previous=s,this.currentConfiguraiton=l,this.currentWorkspace=a,this._previousConfiguration=void 0;const d=new Set;u.keys.forEach(i=>d.add(i)),u.overrides.forEach(([,i])=>i.forEach(p=>d.add(p))),this.affectedKeys=[...d.values()];const n=new y;this.affectedKeys.forEach(i=>n.setValue(i,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(s){const l=this.previousConfiguration?this.previousConfiguration.getValue(u,s,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(u,s,this.currentWorkspace);return!T.equals(l,a)}return!0}return!1}doesAffectedKeysTreeContains(u,s){let l=(0,A.toValuesTree)({[s]:!0},()=>{}),a;for(;typeof l=="object"&&(a=Object.keys(l)[0]);){if(u=u[a],!u)return!1;l=l[a]}return!0}}e.ConfigurationChangeEvent=m;function r(o,u){const{added:s,removed:l,updated:a}=b(u?.rawConfiguration,o?.rawConfiguration),d=[],n=o?.getAllOverrideIdentifiers()||[],i=u?.getAllOverrideIdentifiers()||[];if(u){const p=i.filter(_=>!n.includes(_));for(const _ of p)d.push([_,u.getKeysForOverrideIdentifier(_)])}if(o){const p=n.filter(_=>!i.includes(_));for(const _ of p)d.push([_,o.getKeysForOverrideIdentifier(_)])}if(u&&o){for(const p of n)if(i.includes(p)){const _=b({contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)},{contents:u.getOverrideValue(void 0,p)||{},keys:u.getKeysForOverrideIdentifier(p)});d.push([p,[..._.added,..._.removed,..._.updated]])}}return{added:s,removed:l,updated:a,overrides:d}}function b(o,u){const s=o?u?o.keys.filter(d=>u.keys.indexOf(d)===-1):[...o.keys]:[],l=u?o?u.keys.filter(d=>o.keys.indexOf(d)===-1):[...u.keys]:[],a=[];if(o&&u){for(const d of u.keys)if(o.keys.indexOf(d)!==-1){const n=(0,A.getConfigurationValue)(u.contents,d),i=(0,A.getConfigurationValue)(o.contents,d);T.equals(n,i)||a.push(d)}}return{added:s,removed:l,updated:a}}}),define(Ce[127],De([1,0,11,3]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends c.ErrorNoTelemetry{static isTemporarilyNotAvailable(T){return T instanceof P&&T._code===I.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof P&&T._code===I.NoResolverFound}static isHandled(T){return T instanceof P&&T.isHandled}constructor(T,S=I.Unknown,D){super(T),this._message=T,this._code=S,this._detail=D,this.isHandled=S===I.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(Ce[86],De([1,0,14]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===c.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function I(D){if(!D)return;const A=D.indexOf("+");return A<0?D:D.substr(0,A)}e.getRemoteName=I;function P(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=P;function C(D){const{host:A,port:k}=S(D);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.parseAuthorityWithPort=C;function T(D,A){let{host:k,port:E}=S(D);return typeof E>"u"&&(E=A),{host:k,port:E}}e.parseAuthorityWithOptionalPort=T;function S(D){const A=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const E=D.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:D,port:void 0}}}),define(Ce[26],De([1,0,8,3,86]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function C(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,g){if(typeof h>"u"||h===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof h=="string"||typeof g=="string"){const f=typeof h=="string"?h:h.value,v=typeof g=="string"?g:g.value;return c.equalsIgnoreCase(f,v)}return h._lower===g._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=D;function A(w){return k(w)}e.isApplicationScopedExtension=A;function k(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function E(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function y(w,h){if(h){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(h)}`;return w.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[200],De([1,0,8,121,26,10,2,11,36]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(u,s){return u.uuid&&s.uuid?u.uuid===s.uuid:u.id===s.id?!0:(0,c.compareIgnoreCase)(u.id,s.id)===0}e.areSameExtensions=D;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(s){const l=s.manifest?s.manifest.version:s.version,a=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new k(s.identifier,l,a)}static parse(s){const l=A.exec(s);return l&&l[1]&&l[2]?new k({id:l[1]},l[2],l[4]||void 0):null}constructor(s,l,a="undefined"){this.version=l,this.targetPlatform=a,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof k?D(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=k;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(u){const s=E.exec(u);return s&&s[1]?[h(s[1]),s[2]]:[h(u),void 0]}e.getIdAndVersion=y;function w(u,s){return`${u}.${s}`}e.getExtensionId=w;function h(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function g(u,s){return h(w(u,s))}e.getGalleryExtensionId=g;function f(u,s){const l=[],a=d=>{for(const n of l)if(n.some(i=>D(s(i),s(d))))return n;return null};for(const d of u){const n=a(d);n?n.push(d):l.push([d])}return l}e.groupByExtension=f;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function m(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function r(u,s){const l=[],a=s.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const d=a.shift();if(d&&l.every(n=>!D(n.identifier,{id:d}))){const n=u.filter(i=>D(i.identifier,{id:d}));n.length===1&&(l.push(n[0]),a.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=r;async function b(u,s){if(!P.isLinux)return!1;let l;try{l=(await u.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await u.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){s.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(d))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function o(u,s){const l=await b(u,s),a=(0,t.getTargetPlatform)(l?"alpine":P.platform,S.arch);return s.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(Ce[201],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.validators=new Map}vsda(){return new Promise((I,P)=>J(["vsda"],I,P))}async createNewMessage(I){try{const P=await this.vsda(),C=new P.validator;if(C){const T=String(c._nextId++);return this.validators.set(T,C),{id:T,data:C.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,P){if(!I.id)return!0;const C=this.validators.get(I.id);if(!C)return!1;this.validators.delete(I.id);try{return C.validate(P)==="ok"}catch{return!1}}async sign(I){try{const P=await this.vsda(),C=new P.signer;if(C)return C.sign(I)}catch{}return I}}e.SignService=c,c._nextId=1}),define(Ce[202],De([1,0,10,36,2,31]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(D){if(c.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function T(D,A,k,E,y,w,h,g,f,v){const m=Object.create(null);m["common.machineId"]=h,m.sessionID=(0,P.generateUuid)()+Date.now(),m.commitHash=y,m.version=w,m["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,c.PlatformToString)(c.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=E,m["common.product"]=v||"desktop",g&&(m["common.msftInternal"]=g);let r=0;const b=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),c.isLinuxSnap&&(m["common.snap"]="true");const o=C(k);o&&(m["common.platformDetail"]=o);try{const u=await D.readFile(I.URI.file(f));m["common.source"]=u.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=T;function S(D){const A=t.env.USERDNSDOMAIN;if(!A)return!1;const k=A.toLowerCase();return D.some(E=>k===E)}e.verifyMicrosoftInternalDomain=S}),define(Ce[203],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[204],De([1,0,24,157,12,66,202,203]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,a){return Promise.resolve(void 0)}publicLog2(l,a){return this.publicLog(l,a)}publicLogError(l,a){return Promise.resolve(void 0)}publicLogError2(l,a){return this.publicLogError(l,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class D{async publicLog(l,a,d){}async publicLogError(l,a,d){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(s,l){return l.onDidChangeConfiguration(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(a.source),configurationKeys:f(a.sourceConfig)})})}e.configurationTelemetry=A;function k(s,l){return!(l.disableTelemetry||!s.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=k;function E(s){const l=s.getValue(T.TELEMETRY_SETTING_ID),a=s.getValue("telemetry.enableCrashReporter");if(s.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function y(s){const l={},a={},d={};g(s,d);for(let n in d){n=n.length>150?n.substr(n.length-149):n;const i=d[n];typeof i=="number"?a[n]=i:typeof i=="boolean"?a[n]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${i.length}`),l[n]=i.substring(0,8191)):typeof i<"u"&&i!==null&&(l[n]=i)}return{properties:l,measurements:a}}e.validateTelemetryData=y;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function h(s){if(!s)return"none";for(const l of w)if(s.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=h;function g(s,l,a=0,d){if(!!s)for(const n of Object.getOwnPropertyNames(s)){const i=s[n],p=d?d+n:n;Array.isArray(i)?l[p]=(0,c.safeStringify)(i):i instanceof Date?l[p]=i.toISOString():(0,I.isObject)(i)?a<2?g(i,l,a+1,p+"."):l[p]=(0,c.safeStringify)(i):l[p]=i}}function f(s){if(!s)return[];const l=[];return v(l,"",s),l}function v(s,l,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(d=>v(s,l?`${l}.${d}`:d,a[d])):s.push(l)}function m(s,l){const a=s.msftInternalDomains||[],d=l.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(a)||d}e.isInternalTelemetry=m;function r(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=r;function b(s,l){let a=s;const d=[];for(const _ of l)for(;;){const R=_.exec(s);if(!R)break;d.push([R.index,_.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(a="";;){const _=i.exec(s);if(!_)break;!n.test(_[0])&&d.every(([R,M])=>_.index<R||_.index>=M)&&(a+=s.substring(p,_.index)+"<REDACTED: user-file-path>",p=i.lastIndex)}return p<s.length&&(a+=s.substr(p)),a}function o(s){if(!s)return s;const l=s.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of a)if(d.regex.test(l))return`<REDACTED: ${d.label}>`;return s}function u(s,l){return(0,c.cloneAndChange)(s,a=>{if(typeof a=="string"){let d=a;d=b(d,l);for(const n of l)d=d.replace(n,"");return d=o(d),d}})}e.cleanData=u}),define(Ce[205],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,P,C=5){const T=P(S=>{const D=typeof S=="string"?S:S.data;let A=this._terminalBufferMap.get(I);if(A){A.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(I),C);A={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),T.dispose()}},this._terminalBufferMap.set(I,A)});return T}stopBuffering(I){this._terminalBufferMap.get(I)?.dispose()}flushBuffer(I){const P=this._terminalBufferMap.get(I);P&&(this._terminalBufferMap.delete(I),this._callback(I,P.data.join("")))}}e.TerminalDataBufferer=c}),define(Ce[206],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===c.HIGH_CONTRAST_DARK||P===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(P){return P===c.DARK||P===c.HIGH_CONTRAST_DARK}e.isDark=I}),define(Ce[87],De([1,0,77,4,6,3,43,206]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var S;(function(g){function f(v){return v&&typeof v=="object"&&typeof v.id=="string"}g.isThemeColor=f})(S=e.ThemeColor||(e.ThemeColor={}));function D(g){return{id:g}}e.themeColorFromId=D;var A;(function(g){function f(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||S.isThemeColor(l.color))}g.isThemeIcon=f;const v=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function m(l){const a=v.exec(l);if(!a)return;const[,d]=a;return{id:d}}g.fromString=m;function r(l){return{id:l}}g.fromId=r;function b(l,a){let d=l.id;const n=d.lastIndexOf("~");return n!==-1&&(d=d.substring(0,n)),a&&(d=`${d}~${a}`),{id:d}}g.modify=b;function o(l){const a=l.id.lastIndexOf("~");if(a!==-1)return l.id.substring(a+1)}g.getModifier=o;function u(l,a){return l.id===a.id&&l.color?.id===a.color?.id}g.isEqual=u;function s(l,a){return{id:l.id,color:a?D(a):void 0}}g.asThemeIcon=s,g.asClassNameArray=c.CSSIcon.asClassNameArray,g.asClassName=c.CSSIcon.asClassName,g.asCSSSelector=c.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function k(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,I.toDisposable)(()=>{const v=this.themingParticipants.indexOf(f);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new E;C.Registry.add(e.Extensions.ThemingContribution,y);function w(g){return y.onColorThemeChange(g)}e.registerThemingParticipant=w;class h extends I.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,v){let m=this.theme.getColor(f);return m&&v&&(m=v(m,this.theme)),m?m.toString():null}}e.Themable=h}),define(Ce[128],De([1,0,4,10,3,13]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var C;(function(h){h.Http="http",h.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=k;function E(h,g){return g?g!==1&&h<1024:!t.isWindows&&h<1024}e.isPortPrivileged=E;class y{constructor(g,f,v){this.remoteAddress=g,this.localAddress=f,this._dispose=v,this._onDispose=new c.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let w=class{constructor(g){this.logService=g,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],f=Array.from(this._tunnels.values());for(const v of f){const m=Array.from(v.values());for(const r of m){const b=await r.value;b&&g.push(b)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:f}of g.values())await f.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}setEnvironmentTunnel(g,f,v,m,r){this.addTunnelToMap(g,f,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:f,localAddress:v,privacy:m,protocol:r,dispose:()=>Promise.resolve()}))}openTunnel(g,f,v,m,r=!1,b,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${m}.`),!g)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(g,f,v,m,r,b,o);return u?u.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const f=this._tunnels.get(g.tunnelRemoteHost);if(f){const v=f.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${f}.`);const m=v.value.then(async r=>{r&&(await r.dispose(!0),this._onTunnelClosed.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(f),m}}async closeTunnel(g,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${f} `);const v=this._tunnels.get(g);if(v&&v.has(f)){const m=v.get(f);m.refcount=0,await this.tryDisposeTunnel(g,f,m)}}addTunnelToMap(g,f,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,f){const v=this._tunnels.get(g);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,f){const v=[g];A(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const m=v.map(r=>this._tunnels.get(r));for(const r of m){const b=r?.get(f);if(b)return b}}canTunnel(g){return!!D(g)}doIsPortPrivileged(g,f,v,m){if(f)return!1;if(v){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(r?.length===4){const b=parseInt(r[1]),o=parseInt(r[2]);if(b>10||b===10&&o>=14)return!1}}return g<1024}createWithProvider(g,f,v,m,r,b,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${m}.`);const u=v;this._factoryInProgress.add(u);const s=m===void 0?v:m,l={elevationRequired:r?this.isPortPrivileged(s):!1},a={remoteAddress:{host:f,port:v},localAddressPort:m,privacy:b,public:b?b!==T.Private:void 0,protocol:o},d=g.forwardPort(a,l);return d?(this.addTunnelToMap(f,v,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),d}};w=je([$e(0,P.ILogService)],w),e.AbstractTunnelService=w}),define(Ce[207],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[208],De([1,0,14]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function I(S){if(S.folders.length)return S.folders.every(D=>t(D.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=I;function P(S){return I(S)?.scheme}e.getVirtualWorkspaceScheme=P;function C(S){return I(S)?.authority}e.getVirtualWorkspaceAuthority=C;function T(S){return I(S)!==void 0}e.isVirtualWorkspace=T}),define(Ce[45],De([1,0,170,9,63,22,2,3,14]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function D(u){const s=u;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function A(u,s){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,t.basename)(u)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const l=u;if(l.configuration)return{id:l.id,configPath:l.configuration};if(l.folders.length===1)return{id:l.id,uri:l.folders[0].uri}}e.toWorkspaceIdentifier=A;function k(u){const s=u;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=k;function E(u){const s=u;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const l=u;if(l?.configPath)return{id:l.id,configPath:C.URI.revive(l.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=E;var y;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function w(u){const s=u;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=w;function h(u){const s=u;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=h;class g{constructor(s,l,a,d,n){this._id=s,this._transient=a,this._configuration=d,this._ignorePathCasing=n,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class f{constructor(s,l){this.raw=l,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,P.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(u){return new f({uri:u,index:0,name:(0,P.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(u,s){return P.extUriBiasedIgnorePathCase.isEqualOrParent(u,s.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function r(u){let s;return C.URI.isUri(u)?s=u:s=u.configuration,s?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=r;function b(u,s){return!m(u,s)&&!r(u)}e.isSavedWorkspace=b;function o(u){return(typeof u=="string"?(0,t.extname)(u):(0,P.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(Ce[88],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const P=this._idPool++;return this._data.set(P,I),this.logDebugInfo(),P}get(I,P){return this._data.has(I)?this._data.get(I)[P]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(Ce[46],De([1,0,14,22,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(T=>{const S=this._providerInfo.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,S)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[25],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(Ce[209],De([1,0,18]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(C,T,S){this._deferredPromises=new Map,this._id=C,this._shared=T,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of D.values())A.complete()}catch(A){for(const k of D.values())k.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,T){let S=this._value[C];return typeof S>"u"&&(S=T),S}update(C,T){this._value[C]=T;const S=this._deferredPromises.get(C);if(S!==void 0)return S.p;const D=new c.DeferredPromise;return this._deferredPromises.set(C,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}constructor(C,T){super(C.identifier.value,!0,T),this._extension=C}}e.ExtensionGlobalMemento=I}),define(Ce[210],De([1,0,4,2]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(C){this._notebooksAndEditors=C,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new c.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(C,T,S,D){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(C)).acceptModelChanged(T.value,S,D);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(C,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(C)).acceptDirty(T)}$acceptModelSaved(C){const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(C));this._onDidSaveNotebookDocument.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Ce[16],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[211],De([1,0,26,4]),function(J,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(T,S){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(T.identifier),tt(this,I,S,"f"),Be(this,I,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(T){return Be(this,I,"f").get(this._id,T)}store(T,S){return Be(this,I,"f").store(this._id,T,S)}delete(T){return Be(this,I,"f").delete(this._id,T)}}e.ExtensionSecrets=P,I=new WeakMap}),define(Ce[53],De([1,0,3,128,4,16]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function D(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=D;function A(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=A})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,k,E,y){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=je([$e(0,P.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Ce[54],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=t}),define(Ce[212],De([1,0,23]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let D=this.buffers.indexOf(S);return D<0&&(D=this.buffers.length,this.buffers.push(S)),D}}function I(T,S){if(S.serializeBuffersForPostMessage){const D=new t,A=(y,w)=>{if(w instanceof ArrayBuffer){const h=D.add(w);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(w)){const h=P(w);if(h){const g=D.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:h,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},k=JSON.stringify(T,A),E=D.buffers.map(y=>{const w=new Uint8Array(y);return c.VSBuffer.wrap(w)});return{message:k,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=I;function P(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(T,S){const D=S.map(E=>{const y=new ArrayBuffer(E.byteLength);return new Uint8Array(y).set(E.buffer),y}),A=S.length?(E,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const w=y,{index:h}=w,g=D[h];if(w.view)switch(w.view.type){case 1:return new Int8Array(g,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(T,A),arrayBuffers:D}}e.deserializeWebviewMessage=C}),define(Ce[213],De([1,0,112]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:P,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function I(P){return new c.URITransformer(t(P))}e.createURITransformer=I}),define(Ce[129],De([1,0,180,12,2,6,3,43,38,14]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var A;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(A=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var k;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(k=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(V){const x=V;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=E;function y(V,x,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===x&&V.matches(K.input))return K.getViewState()}e.findViewStateForEditor=y;function w(V){if(a(V))return!1;const x=V;return I.URI.isUri(x?.resource)}e.isResourceEditorInput=w;function h(V){if(a(V))return!1;const x=V;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=h;function g(V){if(a(V)||h(V))return!1;const x=V;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function f(V){if(a(V))return!1;const x=V;return x?x.resource===void 0||x.resource.scheme===D.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const v=/Untitled-\d+/;function m(V){return V.scheme===D.Schemas.untitled&&V.path.length>1&&!v.test(V.path)}e.isUntitledWithAssociatedResource=m;function r(V){if(a(V))return!1;const x=V;return I.URI.isUri(x?.base?.resource)&&I.URI.isUri(x?.input1?.resource)&&I.URI.isUri(x?.input2?.resource)&&I.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=r;var b;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var o;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,Q){let K=this.mapIdToSaveSource.get(x);return K||(K={source:x,label:Q},this.mapIdToSaveSource.set(x,K)),K.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new u;var s;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor",V[V.MultipleEditors=256]="MultipleEditors"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends P.Disposable{}e.AbstractEditorInput=l;function a(V){return V instanceof l}e.isEditorInput=a;function d(V){const x=V;return I.URI.isUri(x?.preferredResource)}function n(V){const x=V;return a(x?.primary)&&a(x?.secondary)}e.isSideBySideEditorInput=n;function i(V){const x=V;return a(x?.modified)&&a(x?.original)}e.isDiffEditorInput=i;function p(V){return a(V?.editor)}e.isEditorInputWithOptions=p;function _(V){const x=V;return p(V)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=_;function R(V){const x=V;return typeof x?.groupId=="number"&&a(x.editor)}e.isEditorIdentifier=R;var M;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var H;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LOCKED=2]="GROUP_LOCKED",V[V.EDITOR_OPEN=3]="EDITOR_OPEN",V[V.EDITOR_CLOSE=4]="EDITOR_CLOSE",V[V.EDITOR_MOVE=5]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=7]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=9]="EDITOR_PIN",V[V.EDITOR_STICKY=10]="EDITOR_STICKY",V[V.EDITOR_DIRTY=11]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(H=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var $;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})($=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri(x,Q){if(!x)return;if(r(x))return e.EditorResourceAccessor.getOriginalUri(x.result,Q);if(Q?.supportSideBySide){const{primary:ue,secondary:te}=this.getSideEditors(x);if(ue&&te){if(Q?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===$.ANY)return this.getOriginalUri(ue,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(te,{filterByScheme:Q.filterByScheme});x=Q.supportSideBySide===$.PRIMARY?ue:te}}if(h(x)||g(x)||r(x))return;const K=d(x)?x.preferredResource:x.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors(x){return n(x)||g(x)?{primary:x.primary,secondary:x.secondary}:i(x)||h(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,Q){if(!x)return;if(r(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,Q);if(Q?.supportSideBySide){const{primary:ue,secondary:te}=this.getSideEditors(x);if(ue&&te){if(Q?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===$.ANY)return this.getCanonicalUri(ue,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme});x=Q.supportSideBySide===$.PRIMARY?ue:te}}if(h(x)||g(x)||r(x))return;const K=x.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri(x,Q){if(Array.isArray(Q)){if(Q.some(K=>x.scheme===K))return x}else if(Q===x.scheme)return x}}e.EditorResourceAccessor=new L;var B;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const Q=this.instantiationService=x.get(C.IInstantiationService);for(const[K,ue]of this.editorSerializerConstructors)this.createEditorSerializer(K,ue,Q);this.editorSerializerConstructors.clear()}createEditorSerializer(x,Q,K){const ue=K.createInstance(Q);this.editorSerializerInstances.set(x,ue)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,Q){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,Q,this.instantiationService):this.editorSerializerConstructors.set(x,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new O);async function z(V,x,Q){return!V||!V.length?[]:await Promise.all(V.map(async K=>{const ue=I.URI.revive(K.fileUri);if(!ue){Q.info("Cannot resolve the path because it is not valid.",K);return}if(!await x.canHandleResource(ue)){Q.info("Cannot resolve the path because it cannot be handled",K);return}let he=K.exists,Y=K.type;if(typeof he!="boolean"||typeof Y!="number")try{Y=(await x.stat(ue)).isDirectory?S.FileType.Directory:S.FileType.Unknown,he=!0}catch(be){Q.error(be),he=!1}if(!he&&K.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",K);return}if(Y===S.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",K);return}const fe={...K.options,pinned:!0};return he?{resource:ue,options:fe}:{resource:ue,options:fe,forceUntitled:!0}}))}e.pathsToEditors=z;var U;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function F(V){const x=V;if(!x)return!1;const Q=x;if(Q.modified)return F(Q.modified);const K=x;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=F}),define(Ce[89],De([1,0,14,2]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(T,S){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===c.Schemas.file&&(T=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${P(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=I;function P(T){return T.replace(/./g,S=>{const D=S.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?S:"-"+D.toString(16).padStart(4,"0")})}function C(T){return T.replace(/-([0-9a-f]{4})/g,(S,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=C}),define(Ce[214],De([1,0,4,6,89]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(T,S,D){this._proxy=T,this._editors=S,this._remoteInfo=D,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const A=S.getVisibleTextEditors();for(const k of this._insets.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,S,D,A,k){let E;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===T){E=m;break}if(!E)throw new Error("not a visible editor");const y=this,w=this._handlePool++,h=new c.Emitter,g=new c.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,I.asWebviewUri)(m,y._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(m){this._options=m,y._proxy.$setOptions(w,m)}get options(){return this._options}set html(m){this._html=m,y._proxy.$setHtml(w,m)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(m){return y._proxy.$postMessage(w,m)}},v=new class{constructor(){this.editor=T,this.line=S,this.height=D,this.webview=f,this.onDidDispose=g.event}dispose(){y._insets.has(w)&&(y._insets.delete(w),y._proxy.$disposeEditorInset(w),g.fire(),g.dispose(),h.dispose())}};return this._proxy.$createEditorInset(w,E.id,E.value.document.uri,S+1,D,A||{},k.identifier,k.extensionLocation),this._insets.set(w,{editor:T,inset:v,onDidReceiveMessage:h}),v}$onDidDispose(T){const S=this._insets.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this._insets.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=P}),define(Ce[130],De([1,0,4,18,181]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,S,D,A){const k={command:T};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof A=="number"){const E=setTimeout(()=>{clearTimeout(E);const y=this.pendingRequests.get(k.seq);if(y){this.pendingRequests.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:T,message:(0,I.localize)(0,null,A,T)};y(w)}},A)}return D&&this.pendingRequests.set(k.seq,D),k.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,S){return T.type!=="event"||S.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,t.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback?.(T);break;case"request":this.requestCallback?.(T);break;case"response":{const S=T,D=this.pendingRequests.get(S.request_seq);D&&(this.pendingRequests.delete(S.request_seq),D(S));break}}}}internalSend(T,S){S.type=T,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((S,D)=>T.set(D,S)),await(0,t.timeout)(500),T.forEach((S,D)=>{S({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(Ce[215],De([1,0,182,52,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const P=E=>c.localize(51,null,E);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var C;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(C=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var A;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(A=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[216],De([1,0,8,2,9,24,14]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(s,l,a){return s.replace(T,function(d,n){return l&&n.length>0&&n[0]!=="_"?d:a&&a.hasOwnProperty(n)?a[n]:d})}e.formatPII=S;function D(s){const l={};for(const a of Object.keys(s))a.startsWith("!")||(l[a]=s[a]);return l}e.filterExceptionsFromTelemetry=D;function A(s){return s.configuration.request==="attach"&&!k(s)&&(!s.parentSession||A(s.parentSession))}e.isSessionAttach=A;function k(s){let l=s.configuration.type;if(!!l)return l==="vslsShare"&&(l=s.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(l,"extensionhost")||(0,c.equalsIgnoreCase)(l,"pwa-extensionhost")?s:s.parentSession?k(s.parentSession):void 0}e.getExtensionHostDebugSession=k;function E(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=E;function y(s,l,a){let d,n=0;const i=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=i.exec(s);){const _=p.index+1,R=_+p[0].length;if(_<=l&&R>=a){d=p[0],n=_;break}}if(d){const _=/\w+/g;let R=null;for(;(R=_.exec(d))&&!(R.index+1+n+R[0].length>=a););R&&(d=d.substring(0,_.lastIndex))}return d?{start:n,end:n+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=y;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(s){return!!(s&&s.match(w))}e.isUri=h;function g(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(h(s.path))return t.URI.parse(s.path);if((0,I.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function f(s){if(typeof s.path=="object"){const l=t.URI.revive(s.path);if(l)return l.scheme===C.Schemas.file?l.fsPath:l.toString()}return s.path}function v(s,l){const a=l?g:f,d=(0,P.deepClone)(s);return r(d,(n,i)=>{n&&i&&(i.path=a(i))}),d}e.convertToDAPaths=v;function m(s,l){const a=l?g:f,d=(0,P.deepClone)(s);return r(d,(n,i)=>{!n&&i&&(i.path=a(i))}),d}e.convertToVSCPaths=m;function r(s,l){switch(s.type){case"event":{const a=s;switch(a.event){case"output":l(!1,a.body.source);break;case"loadedSource":l(!1,a.body.source);break;case"breakpoint":l(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=s;switch(a.command){case"setBreakpoints":l(!0,a.arguments.source);break;case"breakpointLocations":l(!0,a.arguments.source);break;case"source":l(!0,a.arguments.source);break;case"gotoTargets":l(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(d=>l(!1,d));break;default:break}break}case"response":{const a=s;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(d=>l(!1,d.source));break;case"loadedSources":a.body.sources.forEach(d=>l(!1,d));break;case"scopes":a.body.scopes.forEach(d=>l(!1,d.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(d=>l(!1,d.source));break;case"setBreakpoints":a.body.breakpoints.forEach(d=>l(!1,d.source));break;case"disassemble":a.body?.instructions.forEach(n=>l(!1,n.location));break;default:break}break}}}function b(s){return s.filter(l=>!l.presentation?.hidden).sort((l,a)=>l.presentation?a.presentation?l.presentation.group?a.presentation.group?l.presentation.group!==a.presentation.group?l.presentation.group.localeCompare(a.presentation.group):o(l.presentation.order,a.presentation.order):-1:a.presentation.group?1:o(l.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=b;function o(s,l){return typeof s!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:s-l}async function u(s,l){const a=s.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(a!=="none"&&(await l.saveAll(),a==="allEditorsInActiveGroup")){const d=l.activeEditorPane;d&&d.input.resource?.scheme===C.Schemas.untitled&&await l.save({editor:d.input,groupId:d.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ce[217],De([1,0,44,218,24,9,10,8,29,183,130]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends A.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(f,v){this.outputStream=v,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,f.on("data",m=>this.handleData(m))}sendMessage(f){if(this.outputStream){const v=JSON.stringify(f);this.outputStream.write(`Content-Length: ${Buffer.byteLength(v,"utf8")}${k.TWO_CRLF}${v}`,"utf8")}}handleData(f){for(this.rawData=Buffer.concat([this.rawData,f]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const v=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,v.length>0)try{this.acceptMessage(JSON.parse(v))}catch(m){this._onError.fire(new Error((m.message||m)+`
`+v))}continue}}else{const v=this.rawData.indexOf(k.TWO_CRLF);if(v!==-1){const r=this.rawData.toString("utf8",0,v).split(k.HEADER_LINESEPARATOR);for(const b of r){const o=b.split(k.HEADER_FIELDSEPARATOR);o[0]==="Content-Length"&&(this.contentLength=Number(o[1]))}this.rawData=this.rawData.slice(v+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k,k.TWO_CRLF=`\r
\r
`,k.HEADER_LINESEPARATOR=/\r?\n/,k.HEADER_FIELDSEPARATOR=/: */;class E extends k{startSession(){return new Promise((f,v)=>{let m=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),f(),m=!0}),this.socket.on("close",()=>{m?this._onError.fire(new Error("connection closed")):v(new Error("connection closed"))}),this.socket.on("error",r=>{m?this._onError.fire(r):v(r)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class y extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",f)}}e.SocketDebugAdapter=y;class w extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.path,f)}}e.NamedPipeDebugAdapter=w;class h extends k{constructor(f,v){super(),this.adapterExecutable=f,this.debugType=v}async startSession(){const f=this.adapterExecutable.command,v=this.adapterExecutable.args,m=this.adapterExecutable.options||{};try{if(f)if(P.isAbsolute(f)){if(!await S.Promises.exists(f))throw new Error(D.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let r=process.env;if(m.env&&Object.keys(m.env).length>0&&(r=I.mixin(I.deepClone(process.env),m.env)),f==="node")if(Array.isArray(v)&&v.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:r,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(o.cwd=m.cwd);const u=c.fork(v[0],v.slice(1),o);if(!u.pid)throw new Error(D.localize(2,null,v[0]));this.serverProcess=u}else throw new Error(D.localize(3,null));else{const b={env:r};m.cwd&&(b.cwd=m.cwd),this.serverProcess=c.spawn(f,v,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,o)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(r){this._onError.fire(r)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((f,v)=>{const m=c.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(r,b,o){if(r)return v(r)});m.on("exit",f),m.on("error",v)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(f,v){if(!f)return;const m=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?m.runtime=P.join(v,f.runtime):m.runtime=f.runtime),f.runtimeArgs&&(m.runtimeArgs=f.runtimeArgs),f.program&&(P.isAbsolute(f.program)?m.program=f.program:m.program=P.join(v,f.program)),f.args&&(m.args=f.args);const r=f;return r.win&&(m.win=h.extract(r.win,v)),r.winx86&&(m.winx86=h.extract(r.winx86,v)),r.windows&&(m.windows=h.extract(r.windows,v)),r.osx&&(m.osx=h.extract(r.osx,v)),r.linux&&(m.linux=h.extract(r.linux,v)),m}static platformAdapterExecutable(f,v){let m=Object.create(null);v=v.toLowerCase();for(const l of f)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&T.equalsIgnoreCase(d.type,v)).forEach(d=>{const n=h.extract(d,l.extensionLocation.fsPath);m=I.mixin(m,n,l.isBuiltin)})}let r;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=m.winx86||m.win||m.windows:C.isWindows?r=m.win||m.windows:C.isMacintosh?r=m.osx:C.isLinux&&(r=m.linux),r=r||m;const b=r.program||m.program,o=r.args||m.args,u=r.runtime||m.runtime,s=r.runtimeArgs||m.runtimeArgs;if(u)return{type:"executable",command:u,args:(s||[]).concat(typeof b=="string"?[b]:[]).concat(o||[])};if(b)return{type:"executable",command:b,args:o||[]}}}e.ExecutableDebugAdapter=h}),define(Ce[219],De([1,0,44,32,10]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(D,A){return new Promise((k,E)=>{let y="";const w=c.spawn(D,A);w.pid&&w.stdout.on("data",h=>{y+=h.toString()}),w.on("error",h=>{E(h)}),w.on("close",h=>{k(y)})})}async function C(D){if(D)if(I.isWindows){const A=await new Promise((k,E)=>{J(["windows-process-tree"],k,E)});return new Promise(k=>{A.getProcessTree(D,E=>{k(!!E&&E.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(D)]).then(A=>{const k=A.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var T;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(T||(T={}));function S(D,A,k,E,y){D=D.trim().toLowerCase();let w;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?w=1:D.indexOf("cmd.exe")>=0?w=0:D.indexOf("bash")>=0?w=2:I.isWindows?w=0:w=2;let h,g=" ";switch(w){case 1:if(h=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}:; `),g+=`cd ${h(E)}; `}if(y)for(const f in y){const v=y[f];v===null?g+=`Remove-Item env:${f}; `:g+=`\${env:${f}}='${v}'; `}if(A.length>0){const f=A.shift(),v=k?f:h(f);g+=v[0]==="'"?`& ${v} `:`${v} `;for(const m of A)g+=m==="<"||m===">"||k?m:h(m),g+=" "}break;case 0:if(h=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>f.includes(v))||f.length===0?`"${f}"`:f),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}: && `),g+=`cd ${h(E)} && `}if(y){g+='cmd /C "';for(const f in y){let v=y[f];v===null?g+=`set "${f}=" && `:(v=v.replace(/[&^|<>]/g,m=>`^${m}`),g+=`set "${f}=${v}" && `)}}for(const f of A)g+=f==="<"||f===">"||k?f:h(f),g+=" ";y&&(g+='"');break;case 2:{h=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const f=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(E&&(g+=`cd ${h(E)} ; `),y){g+="/usr/bin/env";for(const v in y){const m=y[v];m===null?g+=` -u ${f(v)}`:g+=` ${f(`${v}=${m}`)}`}g+=" "}for(const v of A)g+=v==="<"||v===">"||k?v:h(v),g+=" ";break}}return g}e.prepareCommand=S}),define(Ce[90],De([1,0,23,37,61,105,14,9,10,52]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var v;(function(z){z.scheme=C.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],F=new RegExp(`^[${U.join("")}]+`),V=7;function x(Y,fe){const be=fe.toString(V),Re=`${be.length<U.length?U[be.length-1]:"z"}${be}s${(0,c.encodeBase64)(c.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:z.scheme,fragment:Re})}z.generate=x;function Q(Y){if(Y.scheme!==z.scheme)return;const fe=Y.fragment.indexOf("s");if(fe<0)return;const be=parseInt(Y.fragment.substring(0,fe).replace(F,""),V),ke=(0,c.decodeBase64)(Y.fragment.substring(fe+1)).toString();if(!isNaN(be))return{handle:be,notebook:Y.with({scheme:ke,fragment:null})}}z.parse=Q;function K(Y,fe){return Y.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${Y.scheme!==C.Schemas.file?Y.scheme:""}`})}z.generateCellOutputUri=K;function ue(Y){if(Y.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!fe)return;const be=fe[1]&&fe[1]!==""?fe[1]:void 0,ke=fe[2];return{outputId:be,notebook:Y.with({scheme:ke||C.Schemas.file,fragment:null})}}z.parseCellOutputUri=ue;function te(Y,fe,be){return z.generate(Y,fe).with({scheme:be})}z.generateCellPropertyUri=te;function he(Y,fe){if(Y.scheme===fe)return z.parse(Y.with({scheme:z.scheme}))}z.parseCellPropertyUri=he})(v=e.CellUri||(e.CellUri={}));const m=z=>S.isWindows?z.replace(/\//g,"\\"):z;class r{constructor(U=[],F=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=F,this.order=[...new Set(U)].map(V=>({pattern:V,matches:t.parse(m(V))}))}sort(U){const F=new Map(I.Iterable.map(U,x=>[x,m(x)]));let V=[];for(const{matches:x}of this.order)for(const[Q,K]of F)if(x(K)){V.push(Q),F.delete(Q);break}return F.size&&(V=V.concat([...F.keys()].sort((x,Q)=>this.defaultOrder.indexOf(x)-this.defaultOrder.indexOf(Q)))),V}prioritize(U,F){const V=this.findIndex(U);if(V===-1){this.order.unshift({pattern:U,matches:t.parse(m(U))});return}const x=new Set(F.map(K=>this.findIndex(K,V)));x.delete(-1);const Q=Array.from(x).sort();this.order.splice(V+1,0,...Q.map(K=>this.order[K]));for(let K=Q.length-1;K>=0;K--)this.order.splice(Q[K],1)}toArray(){return this.order.map(U=>U.pattern)}findIndex(U,F=this.order.length){const V=m(U);for(let x=0;x<F;x++)if(this.order[x].matches(V))return x;return-1}}e.MimeTypeDisplayOrder=r;function b(z,U,F,V=(x,Q)=>x===Q){const x=[];function Q(te,he,Y){if(he===0&&Y.length===0)return;const fe=x[x.length-1];fe&&fe.start+fe.deleteCount===te?(fe.deleteCount+=he,fe.toInsert.push(...Y)):x.push({start:te,deleteCount:he,toInsert:Y})}let K=0,ue=0;for(;;){if(K===z.length){Q(K,0,U.slice(ue));break}if(ue===U.length){Q(K,z.length-K,[]);break}const te=z[K],he=U[ue];if(V(te,he)){K+=1,ue+=1;continue}F(he)?(Q(K,1,[]),K+=1):(Q(K,0,[he]),ue+=1)}return x}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(z){z.default="default",z.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(z){const U=z;return!!((typeof U.include=="string"||t.isRelativePattern(U.include))&&(typeof U.exclude=="string"||t.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=u;function s(z,U,F){if(Array.isArray(z.viewType)&&z.viewType.indexOf(U)>=0||z.viewType===U)return!0;if(z.filenamePattern){const V=u(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,x=u(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(t.match(V,(0,T.basename)(F.fsPath).toLowerCase()))return!(x&&t.match(x,(0,T.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var l;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(U){return`${a._prefix}${U}`}static parse(U){if(U.startsWith(a._prefix))return U.substring(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/";function d(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=d;const n=new TextDecoder;function i(z){const U=[];let F=!1;for(const V of z)(U.length===0||F)&&(U.push(V),F=!0);return M(U),O(c.VSBuffer.concat(U.map(V=>c.VSBuffer.wrap(V))))}e.compressOutputItemStreams=i;const p=`${String.fromCharCode(27)}[A`,_=p.split("").map(z=>z.charCodeAt(0)),R=10;function M(z){z.forEach((U,F)=>{if(F===0||U.length<p.length)return;const V=z[F-1],x=U.subarray(0,p.length);if(x[0]===_[0]&&x[1]===_[1]&&x[2]===_[2]){const Q=V.lastIndexOf(R);if(Q===-1)return;z[F-1]=V.subarray(0,Q),z[F]=U.subarray(p.length)}})}function H(z){let U=z;do z=U,U=z.replace(/[^\n]\x08/gm,"");while(U.length<z.length);return z}function $(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const U=z.match(/^(.*)\r+/m)[1];let F=z.match(/\r+(.*)$/m)[1];F=F+U.slice(F.length,U.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,F)}return z}const L="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(z){return!z.buffer.includes(L)&&!z.buffer.includes(B)?z:c.VSBuffer.fromString($(H(n.decode(z.buffer))))}}),define(Ce[220],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(Ce[221],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=c;function t(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=t;function I(C){return Array.from(C.entries()).map(T=>[T[0],c(T[1].map)])}e.serializeEnvironmentVariableCollections=I;function P(C){return new Map(C.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(Ce[55],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(P){P.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(C,T,S=C.parent){if(C._isRoot)return new I([T]);const D=[C.id];for(let A=S;A&&A.id!==T;A=A.parent)D.push(A.id);return D.push(T),new I(D.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const T=C.indexOf("\0");return T===-1?C:C.slice(0,T)}static fromString(C){return new I(C.split("\0"))}static join(C,T){return new I([...C.path,T])}static joinToString(C,T){return C.toString()+"\0"+T}static parentId(C){const T=C.lastIndexOf("\0");return T===-1?void 0:C.slice(0,T)}static compare(C,T){return C===T?0:T.startsWith(C+"\0")?2:C.startsWith(T+"\0")?3:1}constructor(C,T=C.length){if(this.path=C,this.viewEnd=T,C.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new I(this.path,C)}*idsToRoot(){for(let C=this.viewEnd;C>0;C--)yield new I(this.path,C)}compare(C){if(typeof C=="string")return I.compare(this.toString(),C);for(let T=0;T<C.viewEnd&&T<this.viewEnd;T++)if(C.path[T]!==this.path[T])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=I}),define(Ce[67],De([1,0,2,35,55]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var C;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(n){n.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),n.deserialize=i=>({range:t.Range.lift(i.range),uri:c.URI.revive(i.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var D;(function(n){n.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.deserialize(i.location)})})(D=e.ITestErrorMessage||(e.ITestErrorMessage={}));const A=(n,i)=>`${i?"s":"e"}${n}`;e.getMarkId=A;var k;(function(n){n.serialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.deserialize(i.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(n){n.serialize=i=>i.type===0?D.serialize(i):k.serialize(i),n.deserialize=i=>i.type===0?D.deserialize(i):k.deserialize(i)})(E=e.ITestMessage||(e.ITestMessage={}));var y;(function(n){n.serializeWithoutMessages=i=>({state:i.state,duration:i.duration,messages:[]}),n.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.serialize)}),n.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const w="\0",h=(n,i)=>n+w+i;e.namespaceTestTag=h;const g=n=>{const i=n.indexOf(w);return{ctrlId:n.slice(0,i),tagId:n.slice(i+1)}};e.denamespaceTestTag=g;var f;(function(n){n.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),n.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?c.URI.revive(i.uri):void 0,range:i.range?t.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(f=e.ITestItem||(e.ITestItem={}));var v;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(n){n.serialize=i=>({expand:i.expand,item:f.serialize(i.item)}),n.deserialize=i=>({controllerId:I.TestId.root(i.item.extId),expand:i.expand,item:f.deserialize(i.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var r;(function(n){n.serialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.uri!==void 0&&(p.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(p.range=i.item.range?.toJSON()),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}},n.deserialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.range!==void 0&&(p.range=i.item.range?t.Range.lift(i.item.range):null),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}}})(r=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(n,i)=>{i.expand!==void 0&&(n.expand=i.expand),i.item!==void 0&&(n.item=n.item?Object.assign(n.item,i.item):i.item)};e.applyTestItemUpdate=b;var o;(function(n){n.serializeWithoutMessages=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(y.serializeWithoutMessages),retired:i.retired}),n.serialize=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(y.serialize),retired:i.retired}),n.deserialize=i=>({...m.deserialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(y.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var u;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var s;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(n){n.deserialize=i=>i.op===0?{op:i.op,item:m.deserialize(i.item)}:i.op===1?{op:i.op,item:r.deserialize(i.item)}:i.op===2?{op:i.op,uri:c.URI.revive(i.uri),docv:i.docv}:i,n.serialize=i=>i.op===0?{op:i.op,item:m.serialize(i.item)}:i.op===1?{op:i.op,item:r.serialize(i.item)}:i})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class a{add(i){}update(i){}remove(i,p){}complete(){}}e.IncrementalChangeCollector=a;class d{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const p=this.createChangeCollector();for(const _ of i)switch(_.op){case 0:{const R=m.deserialize(_.item),M=I.TestId.parentId(R.item.extId)?.toString();if(M){if(this.items.has(M)){const H=this.items.get(M);H.children.add(R.item.extId);const $=this.createItem(R,H);this.items.set(R.item.extId,$),p.add($)}}else{const H=this.createItem(R);this.roots.add(H),this.items.set(R.item.extId,H),p.add(H)}R.expand===2&&this.busyControllerCount++;break}case 1:{const R=r.deserialize(_.item),M=this.items.get(R.extId);if(!M)break;R.expand!==void 0&&(M.expand===2&&this.busyControllerCount--,R.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(M,R),p.update(M);break}case 3:{const R=this.items.get(_.itemId);if(!R)break;const M=I.TestId.parentId(R.item.extId)?.toString();M?this.items.get(M).children.delete(R.item.extId):this.roots.delete(R);const H=[[_.itemId]];for(;H.length;)for(const $ of H.pop()){const L=this.items.get($);L&&(H.push(L.children),this.items.delete($),p.remove(L,L!==R),L.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(_.itemId);break;case 4:this.updatePendingRoots(_.amount);break;case 6:this._tags.set(_.tag.id,_.tag);break;case 7:this._tags.delete(_.id);break}p.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new a}}e.AbstractIncrementalTestCollection=d}),define(Ce[91],De([1,0,18,4,6,48,67,55]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(f,v)=>f===v,A={range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:D,label:D,description:D,error:D,tags:(f,v)=>!(f.length!==v.length||f.some(m=>!v.includes(m)))},k=(f,v)=>{let m;for(const[r,b]of Object.entries(A))b(f[r],v[r])||(m?m[r]=v[r]:m={[r]:v[r]});return m};class E extends I.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const m of this.diff)if(m.op===2&&m.uri===v.uri){m.docv=v.docv;return}break}case 1:{const m=this.diff[this.diff.length-1];if(m){if(m.op===1&&m.item.extId===v.item.extId){(0,C.applyTestItemUpdate)(m.item,v.item);return}if(m.op===0&&m.item.item.extId===v.item.extId){(0,C.applyTestItemUpdate)(m.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,m){const r=this.tree.get(v);if(!!r){if((r.expandLevels===void 0||m>r.expandLevels)&&(r.expandLevels=m),r.expand===1){const b=this.resolveChildren(r);return b.isOpen()?this.expandChildren(r,m-1):b.wait().then(()=>this.expandChildren(r,m-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.expandChildren(r,m-1)):this.expandChildren(r,m-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,m){switch(m.op){case 3:this.removeItem(T.TestId.joinToString(v.fullId,m.id));break;case 0:this.upsertItem(m.item,v);break;case 5:for(const r of m.ops)this.onTestItemEvent(v,r);break;case 1:this.diffTagRefs(m.new,m.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:m.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,P.assertNever)(m)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,m){const r=T.TestId.fromExtHostTestItem(v,this.root.id,m?.actual),b=this.options.getApiFor(v);b.parent&&b.parent!==m?.actual&&this.options.getChildren(b.parent).delete(v.id);let o=this.tree.get(r.toString());if(!o){o={fullId:r,actual:v,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(v,m),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,o,m);return}if(o.actual===v){this.connectItem(v,o,m);return}const u=this.options.getChildren(o.actual),s=o.actual,l=k(this.options.toITestItem(s),this.options.toITestItem(v));this.options.getApiFor(s).listener=void 0,o.actual=v,o.expand=0,l&&(l.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,s.tags,r.toString()),delete l.tags),this.onTestItemEvent(o,{op:4,update:l})),this.connectItemAndChildren(v,o,m);for(const[a,d]of u)this.options.getChildren(v).get(d.id)||this.removeItem(T.TestId.joinToString(r,d.id));this.documentSynced(o.actual.uri)}diffTagRefs(v,m,r){const b=new Set(m.map(o=>o.id));for(const o of v)b.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:r,item:{tags:v.map(o=>(0,C.namespaceTestTag)(this.options.controllerId,o.id))}}}),b.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const m=this.tags.get(v.id);m?m.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const m=this.tags.get(v);m&&!--m.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,m){this.options.getApiFor(v).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(v,m,r){this.setItemParent(v,r);const b=this.options.getApiFor(v);b.parent=r?.actual,b.listener=o=>this.onTestItemEvent(m,o),this.updateExpandability(m)}connectItemAndChildren(v,m,r){this.connectItem(v,m,r);for(const[b,o]of this.options.getChildren(v))this.upsertItem(o,m)}updateExpandability(v){let m;this._resolveHandler?v.resolveBarrier?m=v.resolveBarrier.isOpen()?3:2:m=v.actual.canResolveChildren?1:0:m=0,m!==v.expand&&(v.expand=m,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:m}}),m===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,m){if(m<0)return;const r=[];for(const[b,o]of this.options.getChildren(v.actual)){const u=this.expand(T.TestId.joinToString(v.fullId,o.id),m);(0,c.isThenable)(u)&&r.push(u)}if(r.length)return Promise.all(r).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const o=new c.Barrier;return o.open(),o}v.expand=2,this.pushExpandStateUpdate(v);const m=v.resolveBarrier=new c.Barrier,r=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let b;try{b=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(o){r(o)}return(0,c.isThenable)(b)?b.catch(r).then(()=>{m.open(),this.updateExpandability(v)}):(m.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const m=this.tree.get(v);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const r=[m];for(;r.length;){const b=r.pop();if(!!b){this.options.getApiFor(b.actual).listener=void 0;for(const o of b.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(b.fullId.toString());for(const[o,u]of this.options.getChildren(b.actual))r.push(this.tree.get(T.TestId.joinToString(b.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=E;class y extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=y;class w extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class h extends Error{constructor(v,m,r){super(`TestItem with ID "${v}" is from controller "${m}" and cannot be added as a child of an item from controller "${r}".`)}}e.MixedTestItemController=h;const g=(f,v,m)=>{let r=new Map;return{get size(){return r.size},forEach(b,o){for(const u of r.values())b.call(o,u,this)},[Symbol.iterator](){return r.entries()},replace(b){const o=new Map,u=new Set(r.keys()),s={op:5,ops:[]};for(const l of b){if(!(l instanceof m))throw new w(l.id);const a=v(l).controllerId;if(a!==f.controllerId)throw new h(l.id,a,f.controllerId);if(o.has(l.id))throw new y(l.id);o.set(l.id,l),u.delete(l.id),s.ops.push({op:0,item:l})}for(const l of u.keys())s.ops.push({op:3,id:l});f.listener?.(s),r=o},add(b){if(!(b instanceof m))throw new w(b.id);r.set(b.id,b),f.listener?.({op:0,item:b})},delete(b){r.delete(b)&&f.listener?.({op:3,id:b})},get(b){return r.get(b)},toJSON(){return Array.from(r.values())}}};e.createTestItemChildren=g}),define(Ce[131],De([1,0,91]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(C,T)=>{const S={controllerId:T};return t.set(C,S),S};e.createPrivateApiFor=I;const P=C=>{const T=t.get(C);if(!T)throw new c.InvalidTestItemError(C?.id||"<unknown>");return T};e.getPrivateApiFor=P}),define(Ce[222],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(C,T){super(T),this.variable=C}}e.VariableError=I}),define(Ce[223],De([1,0,9,36,12,24,10,111,186,222,8]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(y,w,h,g){this._contributedVariables=new Map,this._context=y,this._labelService=w,this._userHomePromise=h,g&&(this._envVariablesPromise=g.then(f=>this.prepareEnv(f)))}prepareEnv(y){if(C.isWindows){const w=Object.create(null);return Object.keys(y).forEach(h=>{w[h.toLowerCase()]=y[h]}),w}return y}resolveWithEnvironment(y,w,h){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},w?w.uri:void 0,h)}async resolveAsync(y,w){const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,y?y.uri:void 0,w)}async resolveAnyBase(y,w,h,g){const f=P.deepClone(w);C.isWindows&&f.windows?Object.keys(f.windows).forEach(m=>f[m]=f.windows[m]):C.isMacintosh&&f.osx?Object.keys(f.osx).forEach(m=>f[m]=f.osx[m]):C.isLinux&&f.linux&&Object.keys(f.linux).forEach(m=>f[m]=f.linux[m]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,y?y.uri:void 0,f,h,g)}async resolveAnyAsync(y,w,h){return this.resolveAnyBase(y,w,h)}async resolveAnyMap(y,w,h){const g=new Map;return{newConfig:await this.resolveAnyBase(y,w,h,g),resolvedVariables:g}}resolveWithInteractionReplace(y,w,h,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,w,h,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,w){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,w)}async recursiveResolve(y,w,h,g,f){if(I.isString(h))return this.resolveString(y,w,h,g,f);if(Array.isArray(h))return Promise.all(h.map(v=>this.recursiveResolve(y,w,v,g,f)));if(I.isObject(h)){const v=Object.create(null),m=await Promise.all(Object.keys(h).map(async r=>[await this.resolveString(y,w,r,g,f),await this.recursiveResolve(y,w,h[r],g,f)]));for(const[r,b]of m)v[r]=b;return v}return h}resolveString(y,w,h,g,f){return(0,A.replaceAsync)(h,k.VARIABLE_REGEXP,async(v,m)=>{if(m.includes(k.VARIABLE_LHS))return v;let r=await this.evaluateSingleVariable(y,v,m,w,g);return f?.set(m,r),r!==v&&I.isString(r)&&r.match(k.VARIABLE_REGEXP)&&(r=await this.resolveString(y,w,r,g,f)),r})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}async evaluateSingleVariable(y,w,h,g,f){let v;const m=h.split(":");m.length>1&&(h=m[0],v=m[1]);const r=u=>{const s=this._context.getFilePath();if(s)return s;throw new D.VariableError(u,(0,S.localize)(0,null,w))},b=u=>{const s=r(u);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new D.VariableError(u,(0,S.localize)(1,null,w,c.basename(s)))},o=u=>{if(v){const s=this._context.getFolderUri(v);if(s)return s;throw new D.VariableError(u,(0,S.localize)(2,null,w,v))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new D.VariableError(u,(0,S.localize)(3,null,w)):new D.VariableError(u,(0,S.localize)(4,null,w))};switch(h){case"env":if(v){if(y.env){const u=y.env[C.isWindows?v.toLowerCase():v];if(I.isString(u))return u}return""}throw new D.VariableError(D.VariableKind.Env,(0,S.localize)(5,null,w));case"config":if(v){const u=this._context.getConfigurationValue(g,v);if(I.isUndefinedOrNull(u))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(6,null,w,v));if(I.isObject(u))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(7,null,w,v));return u}throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(8,null,w));case"command":return this.resolveFromMap(D.VariableKind.Command,w,v,f,"command");case"input":return this.resolveFromMap(D.VariableKind.Input,w,v,f,"input");case"extensionInstallFolder":if(v){const u=await this._context.getExtension(v);if(!u)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,w,v));return this.fsPath(u.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,w));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(o(D.VariableKind.WorkspaceFolder)));case"cwd":return g||v?(0,T.normalizeDriveLetter)(this.fsPath(o(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(o(D.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(y.userHome)return y.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,S.localize)(11,null,w))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new D.VariableError(D.VariableKind.LineNumber,(0,S.localize)(12,null,w))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new D.VariableError(D.VariableKind.SelectedText,(0,S.localize)(13,null,w))}case"file":return r(D.VariableKind.File);case"fileWorkspaceFolder":return b(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||v?c.relative(this.fsPath(o(D.VariableKind.RelativeFile)),r(D.VariableKind.RelativeFile)):r(D.VariableKind.RelativeFile);case"relativeFileDirname":{const u=c.dirname(r(D.VariableKind.RelativeFileDirname));if(g||v){const s=c.relative(this.fsPath(o(D.VariableKind.RelativeFileDirname)),u);return s.length===0?".":s}return u}case"fileDirname":return c.dirname(r(D.VariableKind.FileDirname));case"fileExtname":return c.extname(r(D.VariableKind.FileExtname));case"fileBasename":return c.basename(r(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=c.basename(r(D.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-c.extname(u).length)}case"fileDirnameBasename":return c.basename(c.dirname(r(D.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||w}case"execInstallFolder":{const u=this._context.getAppRoot();return u||w}case"pathSeparator":return c.sep;default:try{const u=v?`${h}:${v}`:h;return this.resolveFromMap(D.VariableKind.Unknown,w,u,f,void 0)}catch{return w}}}}resolveFromMap(y,w,h,g,f){if(h&&g){const v=f===void 0?g[h]:g[f+":"+h];if(typeof v=="string")return v;throw new D.VariableError(y,(0,S.localize)(14,null,w))}return w}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[132],De([1,0,3,129]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var I;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var P;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var T;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function D(w){const h=w;return(0,t.isEditorInput)(h?.editor)&&(0,t.isEditorInput)(h?.replacement)}e.isEditorReplacement=D;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function E(w){const h=w;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=E;function y(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(Ce[224],De([1,0,3,132]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(P){const C=P;return typeof P=="number"||(0,t.isEditorGroup)(C)}e.isPreferredGroup=I}),define(Ce[225],De([1,0,3,191]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(Ce[226],De([1,0,26,4,9]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class C{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let E of k.activationEvents)E==="onUri"&&(E=`onUri:${c.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,E){this._extensionDescriptions=D(this._extensionDescriptions,E),this._extensionDescriptions=this._extensionDescriptions.concat(k);const y=C._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=D(this._extensionDescriptions,y.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(y)}static _findLoopingExtensions(k){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,v){this.addNode(f),this.addNode(v),this._arcs.has(f)?this._arcs.get(f).push(v):this._arcs.set(f,[v])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,v){const m=E.getArcs(f);for(let r=0;r<m.length;r++)if(!v.has(m[r]))return!1;return!0}getNodes(){return this._nodesArr}},y=new Map;for(const f of k){const v=c.ExtensionIdentifier.toKey(f.identifier);if(y.set(v,f),f.extensionDependencies)for(const m of f.extensionDependencies){const r=c.ExtensionIdentifier.toKey(m);E.addArc(v,r)}}const w=new Set;E.getNodes().filter(f=>E.getArcs(f).length===0).forEach(f=>w.add(f));const h=E.getNodes().filter(f=>!w.has(f));let g;do{g=!1;for(let f=0;f<h.length;f++){const v=h[f];E.hasOnlyGoodArcs(v,w)&&(h.splice(f,1),f--,w.add(v),g=!0)}}while(g);return h.map(f=>y.get(f))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const E=this._activationMap.get(k);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const E=this._extensionsMap.get(c.ExtensionIdentifier.toKey(k));return E||void 0}getExtensionDescriptionByUUID(k){for(const E of this._extensionsArr)if(E.uuid===k)return E}getExtensionDescriptionByIdOrUUID(k,E){return this.getExtensionDescription(k)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=C;var T;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(T||(T={}));function S(A,k){const E=A.isBuiltin?0:A.isUnderDevelopment?2:1,y=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(E!==y)return E-y;const w=I.posix.basename(A.extensionLocation.path),h=I.posix.basename(k.extensionLocation.path);return w<h?-1:w>h?1:0}function D(A,k){const E=new Set;return k.forEach(y=>E.add(c.ExtensionIdentifier.toKey(y))),A.filter(y=>!E.has(c.ExtensionIdentifier.toKey(y.identifier)))}}),define(Ce[227],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(k){k[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(A){delete A[t.ENV_KEY],delete A[I.ENV_KEY],delete A[P.ENV_KEY]}function T(A,k){C(k),A.serialize(k)}e.writeExtHostConnection=T;function S(A){if(A[t.ENV_KEY])return D(A,new t(A[t.ENV_KEY]));if(A[I.ENV_KEY])return D(A,new I);if(A[P.ENV_KEY])return D(A,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function D(A,k){return C(A),k}}),define(Ce[92],De([1,0,23]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function C(D){const A=c.VSBuffer.alloc(1);switch(D){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=C;function T(D,A){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=T;var S;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[93],De([1,0,3,4,13,25,92,86,204,24,2]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class{constructor(h,g){this.initData=h,this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=g.createLogger(A.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(h,g){const f=this.getTelemetryDetails(),v=new E(g,h,this._outputLogger,this.getBuiltInCommonProperties(h),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this._telemetryLoggers.set(h.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(h,g){this._level=h,this._productConfig=g||{usage:!0,error:!0}}getBuiltInCommonProperties(h){const g={};switch(g["common.extname"]=h.name,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,g["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,g["common.vscodeversion"]=this.initData.version,g["common.isnewappinstall"]=y(this.initData.telemetryInfo.firstSessionDate),g["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case C.UIKind.Web:g["common.uikind"]="web";break;case C.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),g}$onDidChangeTelemetryLevel(h){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=h;const g=this.getTelemetryDetails();this._telemetryLoggers.forEach(f=>{f.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(h,g){const f=this._telemetryLoggers.get(h.value);return f?(f.logError(g),!0):!1}};k=je([$e(0,P.IExtHostInitDataService),$e(1,I.ILoggerService)],k),e.ExtHostTelemetry=k;class E{constructor(h,g,f,v,m){this._extension=g,this._logger=f,this._commonProperties=v,this._onDidChangeEnableStates=new t.Emitter,this._appender=h,this._telemetryEnablements={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(h,g){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:h,isErrorsEnabled:g},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(h){return this._appender.ignoreBuiltInCommonProperties||(h=(0,D.mixin)(h,this._commonProperties)),this._appender.additionalCommonProperties&&(h=(0,D.mixin)(h,this._appender.additionalCommonProperties)),h=(0,S.cleanData)(h,[]),h}logEvent(h,g){h=this._extension.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this._appender.logEvent(h,g),this._logger.trace(h,g)}logUsage(h,g){!this._telemetryEnablements.isUsageEnabled||this.logEvent(h,g)}logError(h,g){!this._telemetryEnablements.isErrorsEnabled||(typeof h=="string"?this.logEvent(h,g):this._appender.logException(h,g))}get apiTelemetryLogger(){if(!this._apiObject){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return h._telemetryEnablements.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h._onDidChangeEnableStates.event.bind(h)};this._apiObject=Object.freeze(g)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=E;function y(w){const h=Date.now()-new Date(w).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=y,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(Ce[27],De([1,0,4,2,3,26,200]),function(J,e,c,t,I,P,C){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class S{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class D{constructor(){this.kind=2,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=D;class A{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=A;class k{constructor(d){this.dependency=d}}e.MissingExtensionDependency=k;var E;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=y;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(d,n){const i=[],p=[],_=[],R=[],M=f(this._allExtensions),H=f(d),$=(z,U)=>z.extensionLocation.toString()===U.extensionLocation.toString()||z.isBuiltin===U.isBuiltin||z.isUserBuiltin===U.isUserBuiltin||z.isUnderDevelopment===U.isUnderDevelopment;for(const z of this._allExtensions){const U=H.get(P.ExtensionIdentifier.toKey(z.identifier));if(!U){i.push(z.identifier),M.delete(P.ExtensionIdentifier.toKey(z.identifier));continue}if(!$(z,U)){i.push(z.identifier),M.delete(P.ExtensionIdentifier.toKey(z.identifier));continue}}for(const z of d){const U=M.get(P.ExtensionIdentifier.toKey(z.identifier));if(!U){p.push(z);continue}if(!$(U,z)){i.push(U.identifier),M.delete(P.ExtensionIdentifier.toKey(U.identifier));continue}}const L=g(this._myExtensions),B=g(n);for(const z of this._myExtensions)B.has(P.ExtensionIdentifier.toKey(z))||_.push(z);for(const z of n)L.has(P.ExtensionIdentifier.toKey(z))||R.push(z);const O={toRemove:i,toAdd:p,myToRemove:_,myToAdd:R};return this.delta(O),O}delta(d){const{toRemove:n,toAdd:i,myToRemove:p,myToAdd:_}=d,R=g(n),M=g(p);for(let H=0;H<this._allExtensions.length;H++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[H].identifier))&&(this._allExtensions.splice(H,1),H--);for(let H=0;H<this._myExtensions.length;H++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[H]))&&(this._myExtensions.splice(H,1),H--);for(const H of i)this._allExtensions.push(H);for(const H of _)this._myExtensions.push(H)}containsExtension(d){for(const n of this._myExtensions)if(P.ExtensionIdentifier.equals(n,d))return!0;return!1}}e.ExtensionHostExtensions=w;class h{constructor(d){if(this[T]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,d)for(const n of d)this.add(n)}get size(){return this._map.size}add(d){return this._map.set(this._toKey(d),d),this}clear(){this._map.clear()}delete(d){return this._map.delete(this._toKey(d))}has(d){return this._map.has(this._toKey(d))}forEach(d,n){this._map.forEach(i=>d.call(n,i,i,this))}*entries(){for(const[d,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function g(a){const d=new Set;for(const n of a)d.add(P.ExtensionIdentifier.toKey(n));return d}e.extensionIdentifiersArrayToSet=g;function f(a){const d=new Map;for(const n of a)d.set(P.ExtensionIdentifier.toKey(n.identifier),n);return d}function v(a,d){return a.enabledApiProposals?a.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=v;function m(a,d){if(!v(a,d))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=m;class r{constructor(d,n,i,p){this.codeLoadingTime=d,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=p}}e.ActivationTimes=r;class b{constructor(d,n){this.description=d,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function u(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function s(a,d){return{identifier:new P.ExtensionIdentifier((0,C.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!d,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=s;class l{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,n){return Promise.resolve(0)}getInspectPorts(d,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(d,n){return Promise.resolve()}}e.NullExtensionService=l}),define(Ce[228],De([1,0,11,26,27,13,18]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(g,f,v,m){this.startup=g,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=m}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,f){return g===-1||f===-1?-1:f-g}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class D{constructor(g,f,v,m,r,b){this.activationFailed=g,this.activationFailedError=f,this.activationTimes=v,this.module=m,this.exports=r,this.subscriptions=b}}e.ActivatedExtension=D;class A extends D{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class k extends D{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class E extends D{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let y=class{constructor(g,f,v,m,r){this._logService=r,this._registry=g,this._resolvedExtensionsSet=new Set,f.forEach(b=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(b))),this._externalExtensionsMap=new Map,v.forEach(b=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(b),b)),this._host=m,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[g,f]of this._operations)f.dispose()}isActivated(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));return Boolean(f&&f.value)}getActivatedExtension(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));if(!f||!f.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return f.value}async activateByEvent(g,f){if(this._alreadyActivatedEvents[g])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(g);await this._activateExtensions(v.map(m=>({id:m.identifier,reason:{startup:f,extensionId:m.identifier,activationEvent:g}}))),this._alreadyActivatedEvents[g]=!0}activateById(g,f){const v=this._registry.getExtensionDescription(g);if(!v)throw new Error(`Extension '${g}' is not known`);return this._activateExtensions([{id:v.identifier,reason:f}])}async _activateExtensions(g){const f=g.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(f.map(v=>v.wait()))}_handleActivationRequest(g){if(this._operations.has(t.ExtensionIdentifier.toKey(g.id)))return this._operations.get(t.ExtensionIdentifier.toKey(g.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id)))return this._createAndSaveOperation(g,null,[],null);const f=this._registry.getExtensionDescription(g.id);if(!f){const r=new Error(`Cannot activate unknown extension '${g.id.value}'`),b=this._createAndSaveOperation(g,null,[],new E(r));return this._host.onExtensionActivationError(g.id,r,new I.MissingExtensionDependency(g.id.value)),b}const v=[],m=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const r of m){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(r)))continue;const b=this._operations.get(t.ExtensionIdentifier.toKey(r));if(b){v.push(b);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(r))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(r)),reason:g.reason}));continue}const o=this._registry.getExtensionDescription(r);if(o){if(!o.main&&!o.browser)continue;v.push(this._handleActivationRequest({id:o.identifier,reason:g.reason}));continue}const u=f.displayName||f.identifier.value,s=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${r}'`),l=this._createAndSaveOperation(g,f.displayName,[],new E(s));return this._host.onExtensionActivationError(f.identifier,s,new I.MissingExtensionDependency(r)),l}return this._createAndSaveOperation(g,f.displayName,v,null)}_createAndSaveOperation(g,f,v,m){const r=new w(g.id,f,g.reason,v,m,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(g.id),r),r}};y=je([$e(4,P.ILogService)],y),e.ExtensionsActivator=y;let w=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(g,f,v,m,r,b,o){this._id=g,this._displayName=f,this._reason=v,this._deps=m,this._value=r,this._host=b,this._logService=o,this._barrier=new C.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let g=0;g<this._deps.length;g++){const f=this._deps[g];if(f.value&&!f.value.activationFailed){this._deps.splice(g,1),g--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this._value=new E(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(g=>g.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(g){const f=new Error;if(g&&g.name&&(f.name=g.name),g&&g.message?f.message=`Activating extension '${this._id.value}' failed: ${g.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${g}.`,g&&g.stack&&(f.stack=g.stack),this._value=new E(f),this._isDisposed&&c.isCancellationError(g))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(g)}}};w=je([$e(6,P.ILogService)],w)}),define(Ce[229],De([1,0,13,25,27]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends c.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};P=je([$e(0,c.ILoggerService),$e(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[7],De([1,0,17,11,110,28,105,8,12,2,31,38,127,90,27]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w){"use strict";var h,g,f,v,m,r,b,o,u,s,l,a,d,n,i,p,_,R,M,H,$,L,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(q){return Object.assign(q,{apply:function(){const de=arguments.length===1?[]:arguments[1];return Reflect.construct(q,de,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(q,[]);{const[de,...Te]=arguments;return Reflect.construct(q,Te,de.constructor)}}})}let z=r=class{static from(...W){let de=W;return new r(function(){if(de){for(const Te of de)Te&&typeof Te.dispose=="function"&&Te.dispose();de=void 0}})}constructor(W){h.set(this,void 0),tt(this,h,W,"f")}dispose(){typeof Be(this,h,"f")=="function"&&(Be(this,h,"f").call(this),tt(this,h,void 0,"f"))}};h=new WeakMap,z=r=je([O],z),e.Disposable=z;let U=b=class{static Min(...W){if(W.length===0)throw new TypeError;let de=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isBefore(de)&&(de=Xe)}return de}static Max(...W){if(W.length===0)throw new TypeError;let de=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isAfter(de)&&(de=Xe)}return de}static isPosition(W){if(!W)return!1;if(W instanceof b)return!0;const{line:de,character:Te}=W;return typeof de=="number"&&typeof Te=="number"}static of(W){if(W instanceof b)return W;if(this.isPosition(W))return new b(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,de){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(de<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=de}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,de=0){if(W===null||de===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,de=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&de===0?this:new b(this.line+Te,this.character+de)}with(W,de=this.character){if(W===null||de===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,de=typeof W.character=="number"?W.character:this.character),Te===this.line&&de===this.character?this:new b(Te,de)}toJSON(){return{line:this.line,character:this.character}}};U=b=je([O],U),e.Position=U;let F=o=class{static isRange(W){return W instanceof o?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,de,Te,Xe){let et,ut;if(typeof W=="number"&&typeof de=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new U(W,de),ut=new U(Te,Xe)):U.isPosition(W)&&U.isPosition(de)&&(et=U.of(W),ut=U.of(de)),!et||!ut)throw new Error("Invalid arguments");et.isBefore(ut)?(this._start=et,this._end=ut):(this._start=ut,this._end=et)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const de=U.Max(W.start,this._start),Te=U.Min(W.end,this._end);if(!de.isAfter(Te))return new o(de,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const de=U.Min(W.start,this._start),Te=U.Max(W.end,this.end);return new o(de,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,de=this.end){if(W===null||de===null)throw(0,t.illegalArgument)();let Te;return W?U.isPosition(W)?Te=W:(Te=W.start||this.start,de=W.end||this.end):Te=this.start,Te.isEqual(this._start)&&de.isEqual(this.end)?this:new o(Te,de)}toJSON(){return[this.start,this.end]}};F=o=je([O],F),e.Range=F;let V=u=class extends F{static isSelection(W){return W instanceof u?!0:W?F.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,de,Te,Xe){let et,ut;if(typeof W=="number"&&typeof de=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new U(W,de),ut=new U(Te,Xe)):U.isPosition(W)&&U.isPosition(de)&&(et=U.of(W),ut=U.of(de)),!et||!ut)throw new Error("Invalid arguments");super(et,ut),this._anchor=et,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=u=je([O],V),e.Selection=V;class x{constructor(W,de,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof de!="number"||de===0||Math.round(de)!==de)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(de),this.connectionToken=Te}}e.ResolvedAuthority=x;class Q extends Error{static NotAvailable(W,de){return new Q(W,E.RemoteAuthorityResolverErrorCode.NotAvailable,de)}static TemporarilyNotAvailable(W){return new Q(W,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,de=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=de,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var ue;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(ue=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=s=class{static isTextEdit(W){return W instanceof s?!0:W?F.isRange(W)&&typeof W.newText=="string":!1}static replace(W,de){return new s(W,de)}static insert(W,de){return s.replace(new F(W,W),de)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const de=new s(new F(new U(0,0),new U(0,0)),"");return de.newEol=W,de}get range(){return this._range}set range(W){if(W&&!F.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}constructor(W,de){this._range=W,this._newText=de}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=s=je([O],te),e.TextEdit=te;let he=l=class{static isNotebookCellEdit(W){return W instanceof l?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,de){return new l(W,de)}static insertCells(W,de){return new l(new Vt(W,W),de)}static deleteCells(W){return new l(W,[])}static updateCellMetadata(W,de){const Te=new l(new Vt(W,W),[]);return Te.newCellMetadata=de,Te}static updateNotebookMetadata(W){const de=new l(new Vt(0,0),[]);return de.newNotebookMetadata=W,de}constructor(W,de){this.range=W,this.newCells=de}};he=l=je([O],he),e.NotebookEdit=he;class Y{static isSnippetTextEdit(W){return W instanceof Y?!0:W?F.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,de){return new Y(W,de)}static insert(W,de){return Y.replace(new F(W,W),de)}constructor(W,de){this.range=W,this.snippet=de}}e.SnippetTextEdit=Y;var fe;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(fe=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,de,Te,Xe){this._edits.push({_type:1,from:W,to:de,options:Te,metadata:Xe})}createFile(W,de,Te){this._edits.push({_type:1,from:void 0,to:W,options:de,metadata:Te})}deleteFile(W,de,Te){this._edits.push({_type:1,from:W,to:void 0,options:de,metadata:Te})}replaceNotebookMetadata(W,de,Te){this._edits.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:de},notebookMetadata:de})}replaceNotebookCells(W,de,Te,Xe){const et=de.start,ut=de.end;(et!==ut||Te.length>0)&&this._edits.push({_type:5,uri:W,index:et,count:ut-et,cells:Te,metadata:Xe})}replaceNotebookCellMetadata(W,de,Te,Xe){this._edits.push({_type:3,metadata:Xe,uri:W,edit:{editType:8,index:de,metadata:Te}})}replace(W,de,Te,Xe){this._edits.push({_type:2,uri:W,edit:new te(de,Te),metadata:Xe})}insert(W,de,Te,Xe){this.replace(W,new F(de,de),Te,Xe)}delete(W,de,Te){this.replace(W,de,"",Te)}has(W){return this._edits.some(de=>de._type===2&&de.uri.toString()===W.toString())}set(W,de){if(de)for(const Te of de){if(!Te)continue;let Xe,et;Array.isArray(Te)?(Xe=Te[0],et=Te[1]):Xe=Te,he.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.replaceNotebookCellMetadata(W,Xe.range.start,Xe.newCellMetadata,et):Xe.newNotebookMetadata?this.replaceNotebookMetadata(W,Xe.newNotebookMetadata,et):this.replaceNotebookCells(W,Xe.range,Xe.newCells,et):Y.isSnippetTextEdit(Xe)?this._edits.push({_type:6,uri:W,range:Xe.range,edit:Xe.snippet,metadata:et}):this._edits.push({_type:2,uri:W,edit:Xe,metadata:et})}else{for(let Te=0;Te<this._edits.length;Te++){const Xe=this._edits[Te];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===W.toString()&&(this._edits[Te]=void 0);break}}(0,c.coalesceInPlace)(this._edits)}}get(W){const de=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===W.toString()&&de.push(Te.edit);return de}entries(){const W=new P.ResourceMap;for(const de of this._edits)if(de._type===2){let Te=W.get(de.uri);Te||(Te=[de.uri,[]],W.set(de.uri,Te)),Te[1].push(de.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=je([O],be),e.WorkspaceEdit=be;let ke=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=a._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,de=this._tabstop++){if(typeof W=="function"){const Te=new a;Te._tabstop=this._tabstop,W(Te),this._tabstop=Te._tabstop,W=Te.value}else W=a._escape(W);return this.value+="${",this.value+=de,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,de=this._tabstop++){const Te=W.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=de,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,de){if(typeof de=="function"){const Te=new a;Te._tabstop=this._tabstop,de(Te),this._tabstop=Te._tabstop,de=Te.value}else typeof de=="string"&&(de=de.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,de&&(this.value+=":",this.value+=de),this.value+="}",this}};ke=a=je([O],ke),e.SnippetString=ke;var Re;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var ze;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ze=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=d=class{static isLocation(W){return W instanceof d?!0:W?F.isRange(W.range)&&D.URI.isUri(W.uri):!1}constructor(W,de){if(this.uri=W,de)if(F.isRange(de))this.range=F.of(de);else if(U.isPosition(de))this.range=new F(de,de);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};oe=d=je([O],oe),e.Location=oe;let le=class{static is(W){return W?typeof W.message=="string"&&W.location&&F.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}constructor(W,de){this.location=W,this.message=de}static isEqual(W,de){return W===de?!0:!W||!de?!1:W.message===de.message&&W.location.range.isEqual(de.location.range)&&W.location.uri.toString()===de.location.uri.toString()}};le=je([O],le),e.DiagnosticRelatedInformation=le;let ge=class{constructor(W,de,Te=ze.Error){if(!F.isRange(W))throw new TypeError("range must be set");if(!de)throw new TypeError("message must be set");this.range=W,this.message=de,this.severity=Te}toJSON(){return{severity:ze[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,de){return W===de?!0:!W||!de?!1:W.message===de.message&&W.severity===de.severity&&W.code===de.code&&W.severity===de.severity&&W.source===de.source&&W.range.isEqual(de.range)&&(0,c.equals)(W.tags,de.tags)&&(0,c.equals)(W.relatedInformation,de.relatedInformation,le.isEqual)}};ge=je([O],ge),e.Diagnostic=ge;let Z=class{constructor(W,de){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=de}};Z=je([O],Z),e.Hover=Z;var ae;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(W,de=ae.Text){this.range=W,this.kind=de}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ne=je([O],ne),e.DocumentHighlight=ne;var ie;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var N;(function(q){q[q.Deprecated=1]="Deprecated"})(N=e.SymbolTag||(e.SymbolTag={}));let j=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,de,Te,Xe,et){this.name=W,this.kind=de,this.containerName=et,typeof Te=="string"&&(this.containerName=Te),Xe instanceof oe?this.location=Xe:Te instanceof F&&(this.location=new oe(Xe,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};j=n=je([O],j),e.SymbolInformation=j;let G=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(i.validate)}constructor(W,de,Te,Xe,et){this.name=W,this.detail=de,this.kind=Te,this.range=Xe,this.selectionRange=et,this.children=[],i.validate(this)}};G=i=je([O],G),e.DocumentSymbol=G;var X;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,de){this.title=W,this.kind=de}};pe=je([O],pe),e.CodeAction=pe;let we=p=class{constructor(W){this.value=W}append(W){return new p(this.value?this.value+p.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+p.sep)}};we.sep=".",we=p=je([O],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ce=class{constructor(W,de){if(this.range=W,this.parent=de,de&&!de.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=je([O],ce),e.SelectionRange=ce;class Ie{constructor(W,de,Te,Xe,et,ut){this.kind=W,this.name=de,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.CallHierarchyItem=Ie;class ye{constructor(W,de){this.fromRanges=de,this.from=W}}e.CallHierarchyIncomingCall=ye;class We{constructor(W,de){this.fromRanges=de,this.to=W}}e.CallHierarchyOutgoingCall=We;var qe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,de){this.range=W,this.command=de}get isResolved(){return!!this.command}};Ze=je([O],Ze),e.CodeLens=Ze;let Ye=_=class{static isMarkdownString(W){return W instanceof _?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,de=!1){g.set(this,void 0),tt(this,g,new I.MarkdownString(W,{supportThemeIcons:de}),"f")}get value(){return Be(this,g,"f").value}set value(W){Be(this,g,"f").value=W}get isTrusted(){return Be(this,g,"f").isTrusted}set isTrusted(W){Be(this,g,"f").isTrusted=W}get supportThemeIcons(){return Be(this,g,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,g,"f").supportThemeIcons=W}get supportHtml(){return Be(this,g,"f").supportHtml}set supportHtml(W){Be(this,g,"f").supportHtml=W}get baseUri(){return Be(this,g,"f").baseUri}set baseUri(W){Be(this,g,"f").baseUri=W}appendText(W){return Be(this,g,"f").appendText(W),this}appendMarkdown(W){return Be(this,g,"f").appendMarkdown(W),this}appendCodeblock(W,de){return Be(this,g,"f").appendCodeblock(de??"",W),this}};g=new WeakMap,Ye=_=je([O],Ye),e.MarkdownString=Ye;let Ne=class{constructor(W,de){this.label=W,this.documentation=de}};Ne=je([O],Ne),e.ParameterInformation=Ne;let at=class{constructor(W,de){this.label=W,this.documentation=de,this.parameters=[]}};at=je([O],at),e.SignatureInformation=at;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=je([O],re),e.SignatureHelp=re;var se;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(W){this.value=W}};xe=je([O],xe),e.InlayHintLabelPart=xe;let me=class{constructor(W,de,Te){this.position=W,this.label=de,this.kind=Te}};me=je([O],me),e.InlayHint=me;var Ae;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Oe=e.CompletionItemKind||(e.CompletionItemKind={}));var Me;(function(q){q[q.Deprecated=1]="Deprecated"})(Me=e.CompletionItemTag||(e.CompletionItemTag={}));let Ke=class{constructor(W,de){this.label=W,this.kind=de}toJSON(){return{label:this.label,kind:this.kind&&Oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ke=je([O],Ke),e.CompletionItem=Ke;let Je=class{constructor(W=[],de=!1){this.items=W,this.isIncomplete=de}};Je=je([O],Je),e.CompletionList=Je;let st=class{constructor(W,de,Te){this.insertText=W,this.range=de,this.command=Te}};st=je([O],st),e.InlineSuggestion=st;let vt=class{constructor(W){this.commands=void 0,this.items=W}};vt=je([O],vt),e.InlineSuggestionList=vt;let nt=class{constructor(W,de,Te){this.insertText=W,this.range=de,this.command=Te}};nt=je([O],nt),e.InlineSuggestionNew=nt;let it=class{constructor(W,de){this.items=W,this.commands=de}};it=je([O],it),e.InlineSuggestionsNew=it;var bt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(bt=e.ViewColumn||(e.ViewColumn={}));var yt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(yt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ht;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(ht=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Dt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Dt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Bt;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Bt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function W(de){switch(de){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ot=class{constructor(W,de){if(de&&!D.URI.isUri(de))throw(0,t.illegalArgument)("target");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=de}};Ot=je([O],Ot),e.DocumentLink=Ot;let Tt=class{constructor(W,de,Te,Xe){this.red=W,this.green=de,this.blue=Te,this.alpha=Xe}};Tt=je([O],Tt),e.Color=Tt;let Nt=class{constructor(W,de){if(de&&!(de instanceof Tt))throw(0,t.illegalArgument)("color");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=de}};Nt=je([O],Nt),e.ColorInformation=Nt;let gt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};gt=je([O],gt),e.ColorPresentation=gt;var Pe;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Pe=e.ColorFormat||(e.ColorFormat={}));var Le;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Le=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class ee{constructor(W,de,Te){if(this.startIndex=W,this.length=de,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof de!="number"||de<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=ee;var Fe;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Fe=e.TerminalLocation||(e.TerminalLocation={}));class Ve{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ve;var rt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(rt=e.TaskRevealKind||(e.TaskRevealKind={}));var Ge;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ge=e.TaskPanelKind||(e.TaskPanelKind={}));let ot=R=class{static from(W){switch(W){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(W,de){if(this.label=de,typeof W!="string"||typeof de!="string")throw(0,t.illegalArgument)("name");this._id=W}get id(){return this._id}};ot.Clean=new R("clean","Clean"),ot.Build=new R("build","Build"),ot.Rebuild=new R("rebuild","Rebuild"),ot.Test=new R("test","Test"),ot=R=je([O],ot),e.TaskGroup=ot;function lt(q){let W="";for(let de=0;de<q.length;de++)W+=q[de].replace(/,/g,",,")+",";return W}let It=class{constructor(W,de,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,de!==void 0&&(Array.isArray(de)?(this._args=de,this._options=Te):this._options=de)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const de of this._args)W.push(de);return lt(W)}};It=je([O],It),e.ProcessExecution=It;let wt=class{constructor(W,de,Te){if(this._args=[],Array.isArray(de)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=de,this._options=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=de}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const de of this._args)W.push(typeof de=="string"?de:de.value);return lt(W)}};wt=je([O],wt),e.ShellExecution=wt;var kt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(kt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Rt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Rt;let mt=M=class{constructor(W,de,Te,Xe,et,ut){this.__deprecated=!1,this._definition=this.definition=W;let ft;typeof de=="string"?(this._name=this.name=de,this._source=this.source=Te,this.execution=Xe,ft=et,this.__deprecated=!0):de===Et.Global||de===Et.Workspace?(this.target=de,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ft=ut):(this.target=de,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ft=ut),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof It?this._definition={type:M.ProcessType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:M.ShellType,id:this._execution.computeId()}:this._execution instanceof Rt?this._definition={type:M.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:M.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const de=this._definition.type;(M.EmptyType===de||M.ProcessType===de||M.ShellType===de||M.ExtensionCallbackType===de)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};mt.ExtensionCallbackType="customExecution",mt.ProcessType="process",mt.ShellType="shell",mt.EmptyType="$empty",mt=M=je([O],mt),e.Task=mt;var en;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(en=e.ProgressLocation||(e.ProgressLocation={}));var tn;(function(q){function W(de){const Te=de;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}q.isViewBadge=W})(tn=e.ViewBadge||(e.ViewBadge={}));let St=H=class{static isTreeItem(W,de){if(W instanceof H)return!0;const Te=W;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Xe=Te.iconPath;if(!Xe||!(0,S.isString)(Xe.light)&&!D.URI.isUri(Xe.light)&&!(0,S.isString)(Xe.dark)&&!D.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof Ye))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<zt.None&&Te.collapsibleState>zt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,w.checkProposedApiEnabled)(de,"treeItemCheckbox");const Xe=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,et=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==nn.Checked&&Xe!==nn.Unchecked||et!==void 0&&!(0,S.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,de=zt.None){this.collapsibleState=de,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};St=H=je([O],St),e.TreeItem=St;var zt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(zt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var nn;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(nn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let rn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,de){this.value=W,this.id=de??(0,A.generateUuid)()}};rn=je([O],rn),e.DataTransferItem=rn;let bn=class{constructor(W){f.set(this,new Map);for(const[de,Te]of W??[]){const Xe=Be(this,f,"f").get(de);Xe?Xe.push(Te):Be(this,f,"f").set(de,[Te])}}get(W){return Be(this,f,"f").get(W)?.[0]}set(W,de){Be(this,f,"f").set(W,[de])}forEach(W,de){for(const[Te,Xe]of Be(this,f,"f"))for(const et of Xe)W.call(de,et,Te,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,de]of Be(this,f,"f"))for(const Te of de)yield[W,Te]}};bn=je([O],bn),e.DataTransfer=bn;let Pt=class{constructor(W){this.insertText=W}};Pt=je([O],Pt),e.DocumentDropEdit=Pt;let sn=class{constructor(W){this.insertText=W}};sn=je([O],sn),e.DocumentPasteEdit=sn;let $t=class{constructor(W,de){this.id=W,this.color=de}};$t=je([O],$t),e.ThemeIcon=$t,$t.File=new $t("file"),$t.Folder=new $t("folder");let Qt=class{constructor(W){this.id=W}};Qt=je([O],Qt),e.ThemeColor=Qt;var on;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(on=e.ConfigurationTarget||(e.ConfigurationTarget={}));let dt=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=D.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,de){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof de!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=D.URI.file(W):D.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=de}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};dt=je([O],dt),e.RelativePattern=dt;let Yt=class{constructor(W,de,Te,Xe){this.enabled=typeof W=="boolean"?W:!0,typeof de=="string"&&(this.condition=de),typeof Te=="string"&&(this.hitCondition=Te),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Yt=je([O],Yt),e.Breakpoint=Yt;let Wt=class extends Yt{constructor(W,de,Te,Xe,et){if(super(de,Te,Xe,et),W===null)throw(0,t.illegalArgument)("location");this.location=W}};Wt=je([O],Wt),e.SourceBreakpoint=Wt;let qt=class extends Yt{constructor(W,de,Te,Xe,et){super(de,Te,Xe,et),this.functionName=W}};qt=je([O],qt),e.FunctionBreakpoint=qt;let an=class extends Yt{constructor(W,de,Te,Xe,et,ut,ft){if(super(Xe,et,ut,ft),!de)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=de,this.canPersist=Te}};an=je([O],an),e.DataBreakpoint=an;let wn=class{constructor(W,de,Te){this.command=W,this.args=de||[],this.options=Te}};wn=je([O],wn),e.DebugAdapterExecutable=wn;let cn=class{constructor(W,de){this.port=W,this.host=de}};cn=je([O],cn),e.DebugAdapterServer=cn;let En=class{constructor(W){this.path=W}};En=je([O],En),e.DebugAdapterNamedPipeServer=En;let ln=class{constructor(W){this.implementation=W}};ln=je([O],ln),e.DebugAdapterInlineImplementation=ln;let Jt=class{constructor(W,de){this.range=W,this.expression=de}};Jt=je([O],Jt),e.EvaluatableExpression=Jt;var Nn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Nn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Sn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Sn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Zt=class{constructor(W,de){this.range=W,this.text=de}};Zt=je([O],Zt),e.InlineValueText=Zt;let _n=class{constructor(W,de,Te=!0){this.range=W,this.variableName=de,this.caseSensitiveLookup=Te}};_n=je([O],_n),e.InlineValueVariableLookup=_n;let yn=class{constructor(W,de){this.range=W,this.expression=de}};yn=je([O],yn),e.InlineValueEvaluatableExpression=yn;let Gt=class{constructor(W,de){this.frameId=W,this.stoppedLocation=de}};Gt=je([O],Gt),e.InlineValueContext=Gt;var Fn;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let Cn=$=class extends Error{static FileExists(W){return new $(W,k.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,k.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,k.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,k.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,k.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,k.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,de=k.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,de),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Cn=$=je([O],Cn),e.FileSystemError=Cn;let Dn=class{constructor(W,de,Te){this.start=W,this.end=de,this.kind=Te}};Dn=je([O],Dn),e.FoldingRange=Dn;var Mn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var In;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(In=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Pn=e.CommentMode||(e.CommentMode={}));var An;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(An=e.CommentThreadState||(e.CommentThreadState={}));class He{constructor(W,de=[]){this.tokenTypes=W,this.tokenModifiers=de}}e.SemanticTokensLegend=He;function xt(q){return typeof q>"u"||(0,S.isStringArray)(q)}class un{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let de=0,Te=W.tokenTypes.length;de<Te;de++)this._tokenTypeStrToInt.set(W.tokenTypes[de],de);for(let de=0,Te=W.tokenModifiers.length;de<Te;de++)this._tokenModifierStrToInt.set(W.tokenModifiers[de],de)}}push(W,de,Te,Xe,et){if(typeof W=="number"&&typeof de=="number"&&typeof Te=="number"&&typeof Xe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(W,de,Te,Xe,et);if(F.isRange(W)&&typeof de=="string"&&xt(Te))return this._push(W,de,Te);throw(0,t.illegalArgument)()}_push(W,de,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(de))throw new Error("`tokenType` is not in the provided legend");const Xe=W.start.line,et=W.start.character,ut=W.end.character-W.start.character,ft=this._tokenTypeStrToInt.get(de);let Lt=0;if(Te)for(const Ut of Te){if(!this._tokenModifierStrToInt.has(Ut))throw new Error("`tokenModifier` is not in the provided legend");const Ht=this._tokenModifierStrToInt.get(Ut);Lt|=1<<Ht>>>0}this._pushEncoded(Xe,et,ut,ft,Lt)}_pushEncoded(W,de,Te,Xe,et){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&de<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Lt=this._data.length/5|0;let Ut=0,Ht=0;for(let jt=0;jt<Lt;jt++){let Kt=this._data[5*jt],kn=this._data[5*jt+1];Kt===0?(Kt=Ut,kn+=Ht):Kt+=Ut,this._data[5*jt]=Kt,this._data[5*jt+1]=kn,Ut=Kt,Ht=kn}}let ut=W,ft=de;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=et,this._prevLine=W,this._prevChar=de}static _sortAndDeltaEncode(W){const de=[],Te=W.length/5|0;for(let ft=0;ft<Te;ft++)de[ft]=ft;de.sort((ft,Lt)=>{const Ut=W[5*ft],Ht=W[5*Lt];if(Ut===Ht){const jt=W[5*ft+1],Kt=W[5*Lt+1];return jt-Kt}return Ut-Ht});const Xe=new Uint32Array(W.length);let et=0,ut=0;for(let ft=0;ft<Te;ft++){const Lt=5*de[ft],Ut=W[Lt+0],Ht=W[Lt+1],jt=W[Lt+2],Kt=W[Lt+3],kn=W[Lt+4],Zn=Ut-et,Di=Zn===0?Ht-ut:Ht,Tn=5*ft;Xe[Tn+0]=Zn,Xe[Tn+1]=Di,Xe[Tn+2]=jt,Xe[Tn+3]=Kt,Xe[Tn+4]=kn,et=Ut,ut=Ht}return Xe}build(W){return this._dataIsSortedAndDeltaEncoded?new pt(new Uint32Array(this._data),W):new pt(un._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=un;class pt{constructor(W,de){this.resultId=de,this.data=W}}e.SemanticTokens=pt;class Un{constructor(W,de,Te){this.start=W,this.deleteCount=de,this.data=Te}}e.SemanticTokensEdit=Un;class Bn{constructor(W,de){this.resultId=de,this.edits=W}}e.SemanticTokensEdits=Bn;var Rn;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Rn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let dn=class{constructor(){}};dn.Back={iconPath:new $t("arrow-left")},dn=je([O],dn),e.QuickInputButtons=dn;var hn;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(hn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Wn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Wn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(W){if(W.badge){let de=(0,T.nextCharLength)(W.badge,0);if(de<W.badge.length&&(de+=(0,T.nextCharLength)(W.badge,de)),W.badge.length>de)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,de,Te){this.badge=W,this.tooltip=de,this.color=Te}}e.FileDecoration=Hn;let fn=class{constructor(W){this.kind=W}};fn=je([O],fn),e.ColorTheme=fn;var $n;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})($n=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,de){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(de<0)throw(0,t.illegalArgument)("end must be positive");W<=de?(this._start=W,this._end=de):(this._start=de,this._end=W)}with(W){let de=this._start,Te=this._end;return W.start!==void 0&&(de=W.start),W.end!==void 0&&(Te=W.end),de===this._start&&Te===this._end?this:new Vt(de,Te)}}e.NotebookRange=Vt;class mn{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(de=>mn.isNotebookCellData(de))}static isNotebookCellData(W){return!0}constructor(W,de,Te,Xe,et,ut,ft){this.kind=W,this.value=de,this.languageId=Te,this.mime=Xe,this.outputs=et??[],this.metadata=ut,this.executionSummary=ft,mn.validate(this)}}e.NotebookCellData=mn;class xn{constructor(W){this.cells=W}}e.NotebookData=xn;class Ft{static isNotebookCellOutputItem(W){return W instanceof Ft?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const de={name:W.name,message:W.message,stack:W.stack};return Ft.json(de,"application/vnd.code.notebook.error")}static stdout(W){return Ft.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Ft.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,de="application/octet-stream"){return new Ft(W,de)}static text(W,de=C.Mimes.text){const Te=Be(Ft,v,"f",m).encode(String(W));return new Ft(Te,de)}static json(W,de="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return Ft.text(Te,de)}constructor(W,de){this.data=W,this.mime=de;const Te=(0,C.normalizeMimeType)(de,!0);if(!Te)throw new Error(`INVALID mime type: ${de}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Ft,v=Ft,m={value:new TextEncoder};class gn{static isNotebookCellOutput(W){return W instanceof gn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,de=!1){const Te=new Set,Xe=new Set;for(let et=0;et<W.length;et++){const ut=W[et],ft=(0,C.normalizeMimeType)(ut.mime);if(!Te.has(ft)||(0,y.isTextStreamMime)(ft)){Te.add(ft);continue}Xe.add(et),de&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Xe.size===0?W:W.filter((et,ut)=>!Xe.has(ut))}constructor(W,de,Te){this.items=gn.ensureUniqueMimeTypes(W,!0),typeof de=="string"?(this.id=de,this.metadata=Te):(this.id=(0,A.generateUuid)(),this.metadata=de??Te)}}e.NotebookCellOutput=gn;var ve;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(ve=e.NotebookCellKind||(e.NotebookCellKind={}));var Se;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Se=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ue;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Ue=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ct;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(ct=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class _t{constructor(W,de){this.text=W,this.alignment=de}}e.NotebookCellStatusBarItem=_t;var At;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(At=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ii;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(ii=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ri{constructor(W,de=[]){this.uri=W,this.provides=(0,c.asArray)(de)}}e.NotebookRendererScript=ri;let Vn=class{constructor(W,de){this.label=W,this.timestamp=de}};Vn=je([O],Vn),e.TimelineItem=Vn;var si;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(W,de){this.ranges=W,this.wordPattern=de}}e.LinkedEditingRanges=ci;class li{constructor(W,de){this._port=W,this._autoForwardAction=de}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=li;var ui;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let jn=class{constructor(W=void 0,de=void 0,Te=void 0){this.include=W,this.exclude=de,this.profile=Te}};jn=je([O],jn),e.TestRunRequest=jn;let qn=L=class{static diff(W,de,Te){const Xe=new L(W);return Xe.expectedOutput=de,Xe.actualOutput=Te,Xe}constructor(W){this.message=W}};qn=L=je([O],qn),e.TestMessage=qn;let Gn=class{constructor(W){this.id=W}};Gn=je([O],Gn),e.TestTag=Gn;let pn=class{constructor(W,de){this.covered=W,this.total=de}};pn=je([O],pn),e.CoveredCount=pn;let Kn=B=class{static fromDetails(W,de){const Te=new pn(0,0),Xe=new pn(0,0),et=new pn(0,0);for(const ft of de)if("branches"in ft){Te.total+=1,Te.covered+=ft.executionCount>0?1:0;for(const Lt of ft.branches)Xe.total+=1,Xe.covered+=Lt.executionCount>0?1:0}else et.total+=1,et.covered+=ft.executionCount>0?1:0;const ut=new B(W,Te,Xe.total>0?Xe:void 0,et.total>0?et:void 0);return ut.detailedCoverage=de,ut}constructor(W,de,Te,Xe){this.uri=W,this.statementCoverage=de,this.branchCoverage=Te,this.functionCoverage=Xe}};Kn=B=je([O],Kn),e.FileCoverage=Kn;let Xn=class{constructor(W,de,Te=[]){this.executionCount=W,this.location=de,this.branches=Te}};Xn=je([O],Xn),e.StatementCoverage=Xn;let Qn=class{constructor(W,de){this.executionCount=W,this.location=de}};Qn=je([O],Qn),e.BranchCoverage=Qn;let Yn=class{constructor(W,de){this.executionCount=W,this.location=de}};Yn=je([O],Yn),e.FunctionCoverage=Yn;var hi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(W,de,Te,Xe,et,ut){this.kind=W,this.name=de,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.TypeHierarchyItem=gi;class pi{constructor(W){this.uri=W}}e.TextTabInput=pi;class vi{constructor(W,de){this.original=W,this.modified=de}}e.TextDiffTabInput=vi;class bi{constructor(W,de,Te,Xe){this.base=W,this.input1=de,this.input2=Te,this.result=Xe}}e.TextMergeTabInput=bi;class wi{constructor(W,de){this.uri=W,this.viewType=de}}e.CustomEditorTabInput=wi;class Ei{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ei;class Si{constructor(W,de){this.uri=W,this.notebookType=de}}e.NotebookEditorTabInput=Si;class _i{constructor(W,de,Te){this.original=W,this.modified=de,this.notebookType=Te}}e.NotebookDiffEditorTabInput=_i;class yi{constructor(){}}e.TerminalEditorTabInput=yi;class Ci{constructor(W,de){this.uri=W,this.inputBoxUri=de}}e.InteractiveWindowInput=Ci}),define(Ce[133],De([1,0,48,14,8,160,103,7,17]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function A(w,h){h?D.set(w,h):D.delete(w)}e.setWordDefinitionFor=A;function k(w){return D.get(w)}e.getWordDefinitionFor=k;class E extends P.MirrorTextModel{constructor(h,g,f,v,m,r,b,o){super(g,f,v,m),this._proxy=h,this._languageId=r,this._isDirty=b,this.notebook=o,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,S.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===t.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(g){return g?h._getTextInRange(g):h.getText()},get eol(){return h._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(g){return h._lineAt(g)},offsetAt(g){return h._offsetAt(g)},positionAt(g){return h._positionAt(g)},validateRange(g){return h._validateRange(g)},validatePosition(g){return h._validatePosition(g)},getWordRangeAtPosition(g,f){return h._getWordRangeAtPosition(g,f)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,c.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,c.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const g=this._validateRange(h);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const f=this._eol,v=g.start.line,m=g.end.line,r=[];r.push(this._lines[v].substring(g.start.character));for(let b=v+1;b<m;b++)r.push(this._lines[b]);return r.push(this._lines[m].substring(0,g.end.character)),r.join(f)}_lineAt(h){let g;if(h instanceof T.Position?g=h.line:typeof h=="number"&&(g=h),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this._lines[g],g===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(h),f=this._lines[g.index].length;return new T.Position(g.index,Math.min(g.remainder,f))}_validateRange(h){if(!(h instanceof T.Range))throw new Error("Invalid argument");const g=this._validatePosition(h.start),f=this._validatePosition(h.end);return g===h.start&&f===h.end?h:new T.Range(g.line,g.character,f.line,f.character)}_validatePosition(h){if(!(h instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:g,character:f}=h,v=!1;if(g<0)g=0,f=0,v=!0;else if(g>=this._lines.length)g=this._lines.length-1,f=this._lines[g].length,v=!0;else{const m=this._lines[g].length;f<0?(f=0,v=!0):f>m&&(f=m,v=!0)}return v?new T.Position(g,f):h}_getWordRangeAtPosition(h,g){const f=this._validatePosition(h);if(!g)g=k(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const v=(0,C.getWordAtText)(f.character+1,(0,C.ensureValidWordDefinition)(g),this._lines[f.line],0);if(v)return new T.Range(f.line,v.startColumn-1,f.line,v.endColumn-1)}}e.ExtHostDocumentData=E;class y{constructor(h,g,f){this._line=h,this._text=g,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=y}),define(Ce[230],De([1,0,7,16,4]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(T){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let S;switch(T){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(Ce[15],De([1,0,17,23,110,28,145,82,24,12,2,35,65,122,131,129,90,55,67,224,7,60]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Pe){function Le(ee){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:rt,positionColumn:Ge}=ee,ot=new r.Position(Fe-1,Ve-1),lt=new r.Position(rt-1,Ge-1);return new r.Selection(ot,lt)}Pe.to=Le;function _e(ee){const{anchor:Fe,active:Ve}=ee;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Pe.from=_e})(o=e.Selection||(e.Selection={}));var u;(function(Pe){function Le(ee){if(!ee)return;const{start:Fe,end:Ve}=ee;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Pe.from=Le;function _e(ee){if(!ee)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:rt,endColumn:Ge}=ee;return new r.Range(Fe-1,Ve-1,rt-1,Ge-1)}Pe.to=_e})(u=e.Range||(e.Range={}));var s;(function(Pe){function Le(_e){switch(_e){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Pe.to=Le})(s=e.TokenType||(e.TokenType={}));var l;(function(Pe){function Le(ee){return new r.Position(ee.lineNumber-1,ee.column-1)}Pe.to=Le;function _e(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Pe.from=_e})(l=e.Position||(e.Position={}));var a;(function(Pe){function Le(Fe,Ve){return(0,c.coalesce)((0,c.asArray)(Fe).map(rt=>_e(rt,Ve)))}Pe.from=Le;function _e(Fe,Ve){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ee(Fe.scheme,Ve),pattern:Ee.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function ee(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(a=e.DocumentSelector||(e.DocumentSelector={}));var d;(function(Pe){function Le(ee){switch(ee){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function _e(ee){switch(ee){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Pe.to=_e})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(Pe){function Le(ee){let Fe;return ee.code&&((0,D.isString)(ee.code)||(0,D.isNumber)(ee.code)?Fe=String(ee.code):Fe={value:String(ee.code.value),target:ee.code.target}),{...u.from(ee.range),message:ee.message,source:ee.source,code:Fe,severity:p.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(i.from),tags:Array.isArray(ee.tags)?(0,c.coalesce)(ee.tags.map(d.from)):void 0}}Pe.from=Le;function _e(ee){const Fe=new r.Diagnostic(u.to(ee),ee.message,p.to(ee.severity));return Fe.source=ee.source,Fe.code=(0,D.isString)(ee.code)?ee.code:ee.code?.value,Fe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(i.to),Fe.tags=ee.tags&&(0,c.coalesce)(ee.tags.map(d.to)),Fe}Pe.to=_e})(n=e.Diagnostic||(e.Diagnostic={}));var i;(function(Pe){function Le(ee){return{...u.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Pe.from=Le;function _e(ee){return new r.DiagnosticRelatedInformation(new r.Location(ee.resource,u.to(ee)),ee.message)}Pe.to=_e})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Pe){function Le(ee){switch(ee){case r.DiagnosticSeverity.Error:return y.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return y.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return y.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return y.MarkerSeverity.Hint}return y.MarkerSeverity.Error}Pe.from=Le;function _e(ee){switch(ee){case y.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case y.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case y.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case y.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Pe.to=_e})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var _;(function(Pe){function Le(ee){return typeof ee=="number"&&ee>=r.ViewColumn.One?ee-1:ee===r.ViewColumn.Beside?m.SIDE_GROUP:m.ACTIVE_GROUP}Pe.from=Le;function _e(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=_e})(_=e.ViewColumn||(e.ViewColumn={}));function R(Pe){return typeof Pe.range<"u"}function M(Pe){return Pe.length===0?!0:!!R(Pe[0])}e.isDecorationOptionsArr=M;var H;(function(Pe){function Le(Ge){return Ge.map(Pe.from)}Pe.fromMany=Le;function _e(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ee(Ge){let ot;if(_e(Ge)){const{language:kt,value:Et}=Ge;ot={value:"```"+kt+`
`+Et+"\n```\n"}}else r.MarkdownString.isMarkdownString(Ge)?ot={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ot={value:Ge}:ot={value:""};const lt=Object.create(null);ot.uris=lt;const It=kt=>{try{let Et=A.URI.parse(kt,!0);Et=Et.with({query:Fe(Et.query,lt)}),lt[kt]=Et}catch{}return""},wt=new C.marked.Renderer;return wt.link=It,wt.image=kt=>typeof kt=="string"?It(I.parseHrefAndDimensions(kt).href):"",(0,C.marked)(ot.value,{renderer:wt}),ot}Pe.from=ee;function Fe(Ge,ot){if(!Ge)return Ge;let lt;try{lt=(0,T.parse)(Ge)}catch{}if(!lt)return Ge;let It=!1;return lt=(0,S.cloneAndChange)(lt,wt=>{if(A.URI.isUri(wt)){const kt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[kt]=wt,It=!0,kt}else return}),It?JSON.stringify(lt):Ge}function Ve(Ge){const ot=new r.MarkdownString(Ge.value,Ge.supportThemeIcons);return ot.isTrusted=Ge.isTrusted,ot.supportHtml=Ge.supportHtml,ot.baseUri=Ge.baseUri?A.URI.from(Ge.baseUri):void 0,ot}Pe.to=Ve;function rt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Pe.from(Ge)}Pe.fromStrict=rt})(H=e.MarkdownString||(e.MarkdownString={}));function $(Pe){return M(Pe)?Pe.map(Le=>({range:u.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?H.fromMany(Le.hoverMessage):Le.hoverMessage?H.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:u.from(Le)}))}e.fromRangeOrRangeWithMessage=$;function L(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?A.URI.file(Pe):Pe}e.pathOrURIToURI=L;var B;(function(Pe){function Le(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?L(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Pe.from=Le})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(Pe){function Le(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?L(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?B.from(_e.before):void 0,after:_e.after?B.from(_e.after):void 0}}Pe.from=Le})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Pe){function Le(_e){if(typeof _e>"u")return _e;switch(_e){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(Pe){function Le(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?z.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?O.from(_e.light):void 0,dark:_e.dark?O.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?L(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?B.from(_e.before):void 0,after:_e.after?B.from(_e.after):void 0}}Pe.from=Le})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(Pe){function Le(ee){return{text:ee.newText,eol:ee.newEol&&Ye.from(ee.newEol),range:u.from(ee.range)}}Pe.from=Le;function _e(ee){const Fe=new r.TextEdit(u.to(ee.range),ee.text);return Fe.newEol=typeof ee.eol>"u"?void 0:Ye.to(ee.eol),Fe}Pe.to=_e})(F=e.TextEdit||(e.TextEdit={}));var V;(function(Pe){function Le(ee,Fe){const Ve={edits:[]};if(ee instanceof r.WorkspaceEdit){const rt=new P.ResourceSet;for(const Ge of ee._allEntries())Ge._type===1&&A.URI.isUri(Ge.to)&&Ge.from===void 0&&rt.add(Ge.to);for(const Ge of ee._allEntries())Ge._type===1?Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:F.from(Ge.edit),versionId:rt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:u.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:rt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Je.from)}})}return Ve}Pe.from=Le;function _e(ee){const Fe=new r.WorkspaceEdit;for(const Ve of ee.edits)Ve.textEdit?Fe.replace(A.URI.revive(Ve.resource),u.to(Ve.textEdit.range),Ve.textEdit.text):Fe.renameFile(A.URI.revive(Ve.oldResource),A.URI.revive(Ve.newResource),Ve.options);return Fe}Pe.to=_e})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(Pe){const Le=Object.create(null);Le[r.SymbolKind.File]=0,Le[r.SymbolKind.Module]=1,Le[r.SymbolKind.Namespace]=2,Le[r.SymbolKind.Package]=3,Le[r.SymbolKind.Class]=4,Le[r.SymbolKind.Method]=5,Le[r.SymbolKind.Property]=6,Le[r.SymbolKind.Field]=7,Le[r.SymbolKind.Constructor]=8,Le[r.SymbolKind.Enum]=9,Le[r.SymbolKind.Interface]=10,Le[r.SymbolKind.Function]=11,Le[r.SymbolKind.Variable]=12,Le[r.SymbolKind.Constant]=13,Le[r.SymbolKind.String]=14,Le[r.SymbolKind.Number]=15,Le[r.SymbolKind.Boolean]=16,Le[r.SymbolKind.Array]=17,Le[r.SymbolKind.Object]=18,Le[r.SymbolKind.Key]=19,Le[r.SymbolKind.Null]=20,Le[r.SymbolKind.EnumMember]=21,Le[r.SymbolKind.Struct]=22,Le[r.SymbolKind.Event]=23,Le[r.SymbolKind.Operator]=24,Le[r.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Le[Fe]=="number"?Le[Fe]:6}Pe.from=_e;function ee(Fe){for(const Ve in Le)if(Le[Ve]===Fe)return Number(Ve);return r.SymbolKind.Property}Pe.to=ee})(x=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Pe){function Le(ee){switch(ee){case r.SymbolTag.Deprecated:return 1}}Pe.from=Le;function _e(ee){switch(ee){case 1:return r.SymbolTag.Deprecated}}Pe.to=_e})(Q=e.SymbolTag||(e.SymbolTag={}));var K;(function(Pe){function Le(ee){return{name:ee.name,kind:x.from(ee.kind),tags:ee.tags&&ee.tags.map(Q.from),containerName:ee.containerName,location:fe.from(ee.location)}}Pe.from=Le;function _e(ee){const Fe=new r.SymbolInformation(ee.name,x.to(ee.kind),ee.containerName,fe.to(ee.location));return Fe.tags=ee.tags&&ee.tags.map(Q.to),Fe}Pe.to=_e})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ue;(function(Pe){function Le(ee){const Fe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),kind:x.from(ee.kind),tags:ee.tags?.map(Q.from)??[]};return ee.children&&(Fe.children=ee.children.map(Le)),Fe}Pe.from=Le;function _e(ee){const Fe=new r.DocumentSymbol(ee.name,ee.detail,x.to(ee.kind),u.to(ee.range),u.to(ee.selectionRange));return(0,c.isNonEmptyArray)(ee.tags)&&(Fe.tags=ee.tags.map(Q.to)),ee.children&&(Fe.children=ee.children.map(_e)),Fe}Pe.to=_e})(ue=e.DocumentSymbol||(e.DocumentSymbol={}));var te;(function(Pe){function Le(ee){const Fe=new r.CallHierarchyItem(x.to(ee.kind),ee.name,ee.detail||"",A.URI.revive(ee.uri),u.to(ee.range),u.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Pe.to=Le;function _e(ee,Fe,Ve){if(Fe=Fe??ee._sessionId,Ve=Ve??ee._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ee.name,detail:ee.detail,kind:x.from(ee.kind),uri:ee.uri,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),tags:ee.tags?.map(Q.from)}}Pe.from=_e})(te=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(Pe){function Le(_e){return new r.CallHierarchyIncomingCall(te.to(_e.from),_e.fromRanges.map(ee=>u.to(ee)))}Pe.to=Le})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Pe){function Le(_e){return new r.CallHierarchyOutgoingCall(te.to(_e.to),_e.fromRanges.map(ee=>u.to(ee)))}Pe.to=Le})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var fe;(function(Pe){function Le(ee){return{range:ee.range&&u.from(ee.range),uri:ee.uri}}Pe.from=Le;function _e(ee){return new r.Location(A.URI.revive(ee.uri),u.to(ee.range))}Pe.to=_e})(fe=e.location||(e.location={}));var be;(function(Pe){function Le(ee){const Fe=ee,Ve=ee;return{originSelectionRange:Fe.originSelectionRange?u.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:u.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?u.from(Fe.targetSelectionRange):void 0}}Pe.from=Le;function _e(ee){return{targetUri:A.URI.revive(ee.uri),targetRange:u.to(ee.range),targetSelectionRange:ee.targetSelectionRange?u.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?u.to(ee.originSelectionRange):void 0}}Pe.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Pe){function Le(ee){return{range:u.from(ee.range),contents:H.fromMany(ee.contents)}}Pe.from=Le;function _e(ee){return new r.Hover(ee.contents.map(H.to),u.to(ee.range))}Pe.to=_e})(ke=e.Hover||(e.Hover={}));var Re;(function(Pe){function Le(ee){return{range:u.from(ee.range),expression:ee.expression}}Pe.from=Le;function _e(ee){return new r.EvaluatableExpression(u.to(ee.range),ee.expression)}Pe.to=_e})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ze;(function(Pe){function Le(ee){if(ee instanceof r.InlineValueText)return{type:"text",range:u.from(ee.range),text:ee.text};if(ee instanceof r.InlineValueVariableLookup)return{type:"variable",range:u.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function _e(ee){switch(ee.type){case"text":return{range:u.to(ee.range),text:ee.text};case"variable":return{range:u.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:u.to(ee.range),expression:ee.expression}}}Pe.to=_e})(ze=e.InlineValue||(e.InlineValue={}));var oe;(function(Pe){function Le(ee){return{frameId:ee.frameId,stoppedLocation:u.from(ee.stoppedLocation)}}Pe.from=Le;function _e(ee){return new r.InlineValueContext(ee.frameId,u.to(ee.stoppedLocation))}Pe.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Pe){function Le(ee){return{range:u.from(ee.range),kind:ee.kind}}Pe.from=Le;function _e(ee){return new r.DocumentHighlight(u.to(ee.range),ee.kind)}Pe.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(Pe){function Le(_e){switch(_e){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Pe.to=Le})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Le(_e){return{triggerKind:ge.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Pe.to=Le})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Pe){function Le(ee){switch(ee){case r.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function _e(ee){switch(ee){case 1:return r.CompletionItemTag.Deprecated}}Pe.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Pe){const Le=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function _e(Ve){return Le.get(Ve)??9}Pe.from=_e;const ee=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(Ve){return ee.get(Ve)??r.CompletionItemKind.Property}Pe.to=Fe})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Pe){function Le(_e,ee){const Fe=new r.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ne.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=I.isMarkdownString(_e.documentation)?H.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,k.Range.isIRange(_e.range)?Fe.range=u.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:u.to(_e.range.insert),replacing:u.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new r.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof r.Range?new r.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(Ve=>F.to(Ve))),Fe.command=ee&&_e.command?ee.fromInternal(_e.command):void 0,Fe}Pe.to=Le})(ie=e.CompletionItem||(e.CompletionItem={}));var N;(function(Pe){function Le(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:H.fromStrict(ee.documentation)}}Pe.from=Le;function _e(ee){return{label:ee.label,documentation:I.isMarkdownString(ee.documentation)?H.to(ee.documentation):ee.documentation}}Pe.to=_e})(N=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(Pe){function Le(ee){return{label:ee.label,documentation:H.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(N.from):[],activeParameter:ee.activeParameter}}Pe.from=Le;function _e(ee){return{label:ee.label,documentation:I.isMarkdownString(ee.documentation)?H.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(N.to):[],activeParameter:ee.activeParameter}}Pe.to=_e})(j=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Pe){function Le(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(j.from):[]}}Pe.from=Le;function _e(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(j.to):[]}}Pe.to=_e})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Le(_e,ee){const Fe=new r.InlayHint(l.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(pe.to.bind(void 0,_e)),ee.kind&&we.to(ee.kind));return Fe.textEdits=ee.textEdits&&ee.textEdits.map(F.to),Fe.tooltip=I.isMarkdownString(ee.tooltip)?H.to(ee.tooltip):ee.tooltip,Fe.paddingLeft=ee.paddingLeft,Fe.paddingRight=ee.paddingRight,Fe}Pe.to=Le})(X=e.InlayHint||(e.InlayHint={}));var pe;(function(Pe){function Le(_e,ee){const Fe=new r.InlayHintLabelPart(ee.label);return Fe.tooltip=I.isMarkdownString(ee.tooltip)?H.to(ee.tooltip):ee.tooltip,E.Command.is(ee.command)&&(Fe.command=_e.fromInternal(ee.command)),ee.location&&(Fe.location=fe.to(ee.location)),Fe}Pe.to=Le})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Pe){function Le(ee){return ee}Pe.from=Le;function _e(ee){return ee}Pe.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Pe){function Le(ee){return{range:u.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Pe.from=Le;function _e(ee){let Fe;if(ee.url)try{Fe=typeof ee.url=="string"?A.URI.parse(ee.url,!0):A.URI.revive(ee.url)}catch{}return new r.DocumentLink(u.to(ee.range),Fe)}Pe.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ie;(function(Pe){function Le(ee){const Fe=new r.ColorPresentation(ee.label);return ee.textEdit&&(Fe.textEdit=F.to(ee.textEdit)),ee.additionalTextEdits&&(Fe.additionalTextEdits=ee.additionalTextEdits.map(Ve=>F.to(Ve))),Fe}Pe.to=Le;function _e(ee){return{label:ee.label,textEdit:ee.textEdit?F.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Fe=>F.from(Fe)):void 0}}Pe.from=_e})(Ie=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Pe){function Le(ee){return new r.Color(ee[0],ee[1],ee[2],ee[3])}Pe.to=Le;function _e(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Pe.from=_e})(ye=e.Color||(e.Color={}));var We;(function(Pe){function Le(ee){return{range:u.from(ee.range)}}Pe.from=Le;function _e(ee){return new r.SelectionRange(u.to(ee.range))}Pe.to=_e})(We=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Pe){function Le(_e){switch(_e){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Pe){function Le(ee){switch(ee){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function _e(ee){switch(ee){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Pe.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Le(ee){if(ee===r.EndOfLine.CRLF)return 1;if(ee===r.EndOfLine.LF)return 0}Pe.from=Le;function _e(ee){if(ee===1)return r.EndOfLine.CRLF;if(ee===0)return r.EndOfLine.LF}Pe.to=_e})(Ye=e.EndOfLine||(e.EndOfLine={}));var Ne;(function(Pe){function Le(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(Ne=e.ProgressLocation||(e.ProgressLocation={}));var at;(function(Pe){function Le(_e){const ee={start:_e.start+1,end:_e.end+1};return _e.kind&&(ee.kind=re.from(_e.kind)),ee}Pe.from=Le})(at=e.FoldingRange||(e.FoldingRange={}));var re;(function(Pe){function Le(_e){if(_e)switch(_e){case r.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Pe.from=Le})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Pe){function Le(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?u.from(_e.selection):void 0,override:typeof _e.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Le})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Pe){function Le(Ve){return Ve instanceof r.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:_e(Ve)||ee(Ve)?new r.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Pe.from=Le;function _e(Ve){const rt=Ve;return rt?A.URI.isUri(rt.baseUri)&&typeof rt.pattern=="string":!1}function ee(Ve){const rt=Ve;return rt?typeof rt.base=="string"&&typeof rt.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new r.RelativePattern(A.URI.revive(Ve.baseUri),Ve.pattern)}Pe.to=Fe})(Ee=e.GlobPattern||(e.GlobPattern={}));var xe;(function(Pe){function Le(_e){if(_e){if(Array.isArray(_e))return _e.map(Le);if(typeof _e=="string")return _e;{const ee=_e;return{language:ee.language,scheme:ee.scheme,pattern:Ee.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Pe.from=Le})(xe=e.LanguageSelector||(e.LanguageSelector={}));var me;(function(Pe){function Le(ee){return{start:ee.start,end:ee.end}}Pe.from=Le;function _e(ee){return new r.NotebookRange(ee.start,ee.end)}Pe.to=_e})(me=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Pe){function Le(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Pe.to=Le;function _e(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Pe.from=_e})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Oe;(function(Pe){function Le(_e){if(_e===g.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(_e===g.NotebookCellExecutionState.Pending)return;if(_e===g.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Pe.to=Le})(Oe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(Pe){function Le(ee){switch(ee){case r.NotebookCellKind.Markup:return g.CellKind.Markup;case r.NotebookCellKind.Code:default:return g.CellKind.Code}}Pe.from=Le;function _e(ee){switch(ee){case g.CellKind.Markup:return r.NotebookCellKind.Markup;case g.CellKind.Code:default:return r.NotebookCellKind.Code}}Pe.to=_e})(Me=e.NotebookCellKind||(e.NotebookCellKind={}));var Ke;(function(Pe){function Le(ee){const Fe={metadata:ee.metadata??Object.create(null),cells:[]};for(const Ve of ee.cells)r.NotebookCellData.validate(Ve),Fe.cells.push(Je.from(Ve));return Fe}Pe.from=Le;function _e(ee){const Fe=new r.NotebookData(ee.cells.map(Je.to));return(0,D.isEmptyObject)(ee.metadata)||(Fe.metadata=ee.metadata),Fe}Pe.to=_e})(Ke=e.NotebookData||(e.NotebookData={}));var Je;(function(Pe){function Le(ee){return{cellKind:Me.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:Ae.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(vt.from):[]}}Pe.from=Le;function _e(ee){return new r.NotebookCellData(Me.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(vt.to):void 0,ee.metadata,ee.internalMetadata?Ae.to(ee.internalMetadata):void 0)}Pe.to=_e})(Je=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Pe){function Le(ee){return{mime:ee.mime,valueBytes:t.VSBuffer.wrap(ee.data)}}Pe.from=Le;function _e(ee){return new r.NotebookCellOutputItem(ee.valueBytes.buffer,ee.mime)}Pe.to=_e})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var vt;(function(Pe){function Le(ee){return{outputId:ee.id,items:ee.items.map(st.from),metadata:ee.metadata}}Pe.from=Le;function _e(ee){const Fe=ee.items.map(st.to);return new r.NotebookCellOutput(Fe,ee.outputId,ee.metadata)}Pe.to=_e})(vt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var nt;(function(Pe){function Le(Fe){return ee(Fe)?{include:(0,D.withNullAsUndefined)(Ee.from(Fe.include)),exclude:(0,D.withNullAsUndefined)(Ee.from(Fe.exclude))}:(0,D.withNullAsUndefined)(Ee.from(Fe))}Pe.from=Le;function _e(Fe){return ee(Fe)?{include:Ee.to(Fe.include),exclude:Ee.to(Fe.exclude)}:Ee.to(Fe)}Pe.to=_e;function ee(Fe){const Ve=Fe;return Ve?!(0,D.isUndefinedOrNull)(Ve.include)&&!(0,D.isUndefinedOrNull)(Ve.exclude):!1}})(nt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var it;(function(Pe){function Le(_e,ee,Fe){const Ve=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Ve,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Pe.from=Le})(it=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var bt;(function(Pe){function Le(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{},cellContentMetadata:_e?.cellContentMetadata??{}}}Pe.from=Le})(bt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var yt;(function(Pe){function Le(ee){return{uri:ee.uri,provides:ee.provides}}Pe.from=Le;function _e(ee){return new r.NotebookRendererScript(A.URI.revive(ee.uri),ee.provides)}Pe.to=_e})(yt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ct;(function(Pe){function Le(ee){return{message:H.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,location:ee.location&&{range:u.from(ee.location.range),uri:ee.location.uri}}}Pe.from=Le;function _e(ee){const Fe=new r.TestMessage(typeof ee.message=="string"?ee.message:H.to(ee.message));return Fe.actualOutput=ee.actual,Fe.expectedOutput=ee.expected,Fe.location=ee.location?fe.to(ee.location):void 0,Fe}Pe.to=_e})(Ct=e.TestMessage||(e.TestMessage={}));var ht;(function(Pe){Pe.namespace=v.namespaceTestTag,Pe.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var Dt;(function(Pe){function Le(ee){const Fe=(0,w.getPrivateApiFor)(ee).controllerId;return{extId:f.TestId.fromExtHostTestItem(ee,Fe).toString(),label:ee.label,uri:A.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Ve=>ht.namespace(Fe,Ve.id)),range:k.Range.lift(u.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&H.fromStrict(ee.error)||null}}Pe.from=Le;function _e(ee){return{parent:void 0,error:void 0,id:f.TestId.fromString(ee.extId).localId,label:ee.label,uri:A.URI.revive(ee.uri),tags:(ee.tags||[]).map(Fe=>{const{tagId:Ve}=ht.denamespace(Fe);return new r.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Pe.toPlain=_e})(Dt=e.TestItem||(e.TestItem={})),function(Pe){function Le(ee){return{id:ee.id}}Pe.from=Le;function _e(ee){return new r.TestTag(ee.id)}Pe.to=_e}(ht=e.TestTag||(e.TestTag={}));var Mt;(function(Pe){const Le=(ee,Fe)=>{const Ve=[];for(const[Ge,ot]of Fe)f.TestId.compare(ot.item.extId,Ge)===2&&(Fe.delete(Ge),Ve.push(ot));const rt={...Dt.toPlain(ee.item),parent:void 0,taskStates:ee.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ot=>ot.type===0).map(Ct.to)})),children:Ve.map(Ge=>Le(Ge,Fe))};for(const Ge of rt.children)Ge.parent=rt;return rt};function _e(ee){const Fe=[],Ve=new Map;for(const rt of ee.items){Ve.set(rt.item.extId,rt);const Ge=f.TestId.root(rt.item.extId);ee.request.targets.some(ot=>ot.controllerId===Ge&&ot.testIds.includes(rt.item.extId))&&Fe.push(rt)}return{completedAt:ee.completedAt,results:Fe.map(rt=>Le(rt,Ve))}}Pe.to=_e})(Mt=e.TestResults||(e.TestResults={}));var Bt;(function(Pe){function Le(Ve){return{covered:Ve.covered,total:Ve.covered}}function _e(Ve){return"line"in Ve?l.from(Ve):u.from(Ve)}function ee(Ve){return"branches"in Ve?{count:Ve.executionCount,location:_e(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(rt=>({count:rt.executionCount,location:rt.location&&_e(rt.location)})):void 0}:{type:0,count:Ve.executionCount,location:_e(Ve.location)}}Pe.fromDetailed=ee;function Fe(Ve){return{uri:Ve.uri,statement:Le(Ve.statementCoverage),branch:Ve.branchCoverage&&Le(Ve.branchCoverage),function:Ve.functionCoverage&&Le(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ee)}}Pe.fromFile=Fe})(Bt=e.TestCoverage||(e.TestCoverage={}));var Qe;(function(Pe){function Le(_e){switch(_e){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Pe.to=Le})(Qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(Pe){function Le(ee){const Fe=new r.TypeHierarchyItem(x.to(ee.kind),ee.name,ee.detail||"",A.URI.revive(ee.uri),u.to(ee.range),u.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Pe.to=Le;function _e(ee,Fe,Ve){if(Fe=Fe??ee._sessionId,Ve=Ve??ee._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:x.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),tags:ee.tags?.map(Q.from)}}Pe.from=_e})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Tt;(function(Pe){function Le(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Pe.from=Le})(Tt=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Pe){function Le(_e,ee){const Fe=_e.fileData;return Fe?new class extends r.DataTransferItem{asFile(){return{name:Fe.name,uri:A.URI.revive(Fe.uri),data:(0,b.once)(()=>ee())}}}("",_e.id):new r.DataTransferItem(_e.asString)}Pe.toDataTransferItem=Le})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(Pe){function Le(ee,Fe){const Ve=ee.items.map(([rt,Ge])=>[rt,Nt.toDataTransferItem(Ge,()=>Fe(Ge.id))]);return new r.DataTransfer(Ve)}Pe.toDataTransfer=Le;async function _e(ee){const Fe={items:[]},Ve=[];return ee.forEach((rt,Ge)=>{Ve.push((async()=>{const ot=await rt.asString(),lt=rt.asFile();Fe.items.push([Ge,{id:rt.id,asString:ot,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(Ve),Fe}Pe.toDataTransferDTO=_e})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[231],De([1,0,2,11,7,15,62]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(D,A,k,E={timeout:1500,errors:3}){this._logService=D,this._documents=A,this._mainThreadBulkEdits=k,this._thresholds=E,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(A,k,E)=>{const w={dispose:this._callbacks.push([A,k,D])};return Array.isArray(E)&&E.push(w),w}}async $participateInSave(D,A){const k=c.URI.revive(D);let E=!1;const y=setTimeout(()=>E=!0,this._thresholds.timeout),w=[];try{for(const h of[...this._callbacks]){if(E)break;const g=this._documents.getDocument(k),f=await this._deliverEventAsyncAndBlameBadListeners(h,{document:g,reason:P.TextDocumentSaveReason.to(A)});w.push(f)}}finally{clearTimeout(y)}return w}_deliverEventAsyncAndBlameBadListeners([D,A,k],E){const y=this._badListeners.get(D);return typeof y=="number"&&y>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,D,A,E).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const h=this._badListeners.get(D);this._badListeners.set(D,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,A,k,E){const y=[],w=Date.now(),{document:h,reason:g}=E,{version:f}=h,v=Object.freeze({document:h,reason:g,waitUntil(m){if(Object.isFrozen(y))throw(0,t.illegalState)("waitUntil can not be called async");y.push(Promise.resolve(m))}});try{A.apply(k,[v])}catch(m){return Promise.reject(m)}return Object.freeze(y),new Promise((m,r)=>{const b=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(y).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(b),m(o)}).catch(o=>{clearTimeout(b),r(o)})}).then(m=>{const r={edits:[]};for(const b of m)if(Array.isArray(b)&&b.every(o=>o instanceof I.TextEdit))for(const{newText:o,newEol:u,range:s}of b)r.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:o,eol:u&&P.EndOfLine.from(u)}});if(r.edits.length!==0)return f===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Ce[232],De([1,0,14,2,15,7,90]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(k,E,y,w){this.start=k,this.deletedCount=E,this.deletedItems=y,this.items=w}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(k,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,E,y){this.notebook=k,this._extHostDocument=E,this._cellData=y,this.handle=y.handle,this.uri=t.URI.revive(y.uri),this.cellKind=y.cellKind,this._outputs=y.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=y.internalMetadata??{},this._metadata=Object.freeze(y.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return k._mime},set mime(w){k._mime=w},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(y)}return this._apiCell}setOutputs(k){this._outputs=k.map(I.NotebookCellOutput.to)}setOutputItems(k,E,y){const w=y.map(I.NotebookCellOutputItem.to),h=this._outputs.find(g=>g.id===k);if(h&&(E||(h.items.length=0),h.items.push(...w),h.items.length>1&&h.items.every(g=>C.isTextStreamMime(g.mime)))){const g=new Map,f=[];h.items.forEach(v=>{let m;g.has(v.mime)?m=g.get(v.mime):(m=[],g.set(v.mime,m),f.push(v.mime)),m.push(v.data)}),h.items.length=0,f.forEach(v=>{const m=C.compressOutputItemStreams(g.get(v));h.items.push({mime:v,data:m.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=S;class D{constructor(k,E,y,w,h){this._proxy=k,this._textDocumentsAndEditors=E,this._textDocuments=y,this.uri=w,this.handle=D._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,E={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===c.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(y){return y=k._validateIndex(y),k._cells[y].apiCell},getCells(y){return(y?k._getCells(y):k._cells).map(h=>h.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(E)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,E,y){this._versionId=k.versionId,this._isDirty=E,this.acceptDocumentPropertiesChanged({metadata:y});const w={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},h=[];for(const f of k.rawEvents)f.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,w.contentChanges):f.kind===C.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,w.contentChanges):f.kind===C.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),h.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),h.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),h.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===C.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),h.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),h.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const g=new Map;for(let f=0;f<h.length;f++){const v=h[f],m=g.get(v.cell);if(m===void 0){const r=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});g.set(v.cell,r-1)}else w.cellChanges[m]={...w.cellChanges[m],...v}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let E=k.start|0,y=k.end|0;return E<0&&(E=0),y>this._cells.length&&(y=this._cells.length),k.with({start:E,end:y})}_getCells(k){k=this._validateRange(k);const E=[];for(let y=k.start;y<k.end;y++)E.push(this._cells[y]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,E,y){if(this._disposed)return;const w=[],h=[],g=[];if(k.reverse().forEach(f=>{const m=f[2].map(o=>{const u=new S(this,this._textDocumentsAndEditors,o);return E||h.push(S.asModelAddData(this.apiNotebook,o)),u}),r=new T(f[0],f[1],[],m),b=this._cells.splice(f[0],f[1],...m);for(const o of b)g.push(o.uri),r.deletedItems.push(o.apiCell);w.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:g}),y)for(const f of w)y.push(f.asApiEvent())}_moveCell(k,E,y){const w=this._cells.splice(k,1);this._cells.splice(E,0,...w);const h=[new T(k,1,w.map(g=>g.apiCell),[]),new T(E,0,[],w)];for(const g of h)y.push(g.asApiEvent())}_setCellOutputs(k,E){this._cells[k].setOutputs(E)}_setCellOutputItems(k,E,y,w){this._cells[k].setOutputItems(E,y,w)}_changeCellLanguage(k,E){const y=this._cells[k];y.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelLanguageChanged(y.uri,E)}_changeCellMime(k,E){const y=this._cells[k];y.apiCell.mime=E}_changeCellMetadata(k,E){this._cells[k].setMetadata(E)}_changeCellInternalMetadata(k,E){this._cells[k].setInternalMetadata(E)}getCellFromApiCell(k){return this._cells.find(E=>E.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(E=>E.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=D,D._handlePool=0}),define(Ce[134],De([1,0,11,15,7]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(T,S,D,A,k,E){this.id=T,this._proxy=S,this.notebookData=D,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=A,this._viewColumn=E}get apiEditor(){if(!this._editor){const T=this;this._editor={get document(){return T.notebookData.apiNotebook},get notebook(){return T.notebookData.apiNotebook},get selection(){return T._selections[0]},set selection(S){this.selections=[S]},get selections(){return T._selections},set selections(S){if(!Array.isArray(S)||!S.every(I.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");T._selections=S,T._trySetSelections(S)},get visibleRanges(){return T._visibleRanges},revealRange(S,D){T._proxy.$tryRevealRange(T.id,t.NotebookRange.from(S),D??I.NotebookEditorRevealType.Default)},get viewColumn(){return T._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(T){this._visible=T}_acceptVisibleRanges(T){this._visibleRanges=T}_acceptSelections(T){this._selections=T}_trySetSelections(T){this._proxy.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this._viewColumn=T}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(Ce[233],De([1,0,4,13,15]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(T,S){this._logService=T,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(T,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const D=this._notebooksAndEditors.getEditorById(T);S.visibleRanges&&D._acceptVisibleRanges(S.visibleRanges.ranges.map(I.NotebookRange.to)),S.selections&&D._acceptSelections(S.selections.selections.map(I.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(I.ViewColumn.to(T[S]))}};P=je([$e(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(Ce[234],De([1,0,15,124,173,21,59,11]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,y,w){const h=this._handles++,{title:g,location:f,cancellable:v}=y,m={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(h,{location:c.ProgressLocation.from(f),title:g,source:m,cancellable:v},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(h,w,!!v)}_withProgress(E,y,w){let h;w&&(h=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,h));const g=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),h?.dispose()};let f;try{f=y(new A(this._proxy,E),w&&h?h.token:P.CancellationToken.None)}catch(v){throw g(E),v}return f.then(v=>g(E),v=>g(E)),f}$acceptProgressCanceled(E){const y=this._mapHandleToCancellationSource.get(E);y&&(y.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=S;function D(k,E){return k.message=E.message,typeof E.increment=="number"&&(typeof k.increment=="number"?k.increment+=E.increment:k.increment=E.increment),k}class A extends t.Progress{constructor(E,y){super(w=>this.throttledReport(w)),this._proxy=E,this._handle=y}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}je([(0,C.throttle)(100,(k,E)=>D(k,E),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ce[135],De([1,0,35,131,55,91,67,15,2]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(m,r,b,o)=>{let u=r;return{enumerable:!0,configurable:!1,get(){return u},set(s){if(!b(u,s)){const l=u;u=s,m.listener?.(o(s,l))}}}},A=(m,r)=>m===r,k={range:(m,r)=>m===r?!0:!m||!r?!1:m.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(m,r)=>!(m.length!==r.length||m.some(b=>!r.find(o=>b.id===o.id)))},E=m=>r=>({op:4,update:m(r)}),y=(m,r)=>({range:(()=>{let b;const o=E(u=>({range:c.Range.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return b},set(u){m.listener?.({op:6}),k.range(b,u)||(b=u,m.listener?.(o(u)))}}})(),label:D(m,r,k.label,E(b=>({label:b}))),description:D(m,void 0,k.description,E(b=>({description:b}))),sortText:D(m,void 0,k.sortText,E(b=>({sortText:b}))),canResolveChildren:D(m,!1,k.canResolveChildren,b=>({op:2,state:b})),busy:D(m,!1,k.busy,E(b=>({busy:b}))),error:D(m,void 0,k.error,E(b=>({error:T.MarkdownString.fromStrict(b)||null}))),tags:D(m,[],k.tags,(b,o)=>({op:1,new:b.map(T.TestTag.from),old:o.map(T.TestTag.from)}))}),w=m=>{const r=I.TestId.fromString(m.extId),b=new g(r.controllerId,r.localId,m.label,S.URI.revive(m.uri)||void 0);return b.range=T.Range.to(m.range||void 0),b.description=m.description||void 0,b.sortText=m.sortText||void 0,b.tags=m.tags.map(o=>T.TestTag.to({id:(0,C.denamespaceTestTag)(o).tagId})),b},h=m=>{let r;for(const b of m.tests){const o=w(b.item);(0,t.getPrivateApiFor)(o).parent=r,r=o}return r};e.toItemFromContext=h;class g{constructor(r,b,o,u){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const s=(0,t.createPrivateApiFor)(this,r);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof f?void 0:s.parent}},children:{value:(0,P.createTestItemChildren)(s,t.getPrivateApiFor,g),enumerable:!0,writable:!1},...y(s,o)})}}e.TestItemImpl=g;class f extends g{constructor(r,b){super(r,r,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class v extends P.TestItemCollection{constructor(r,b,o){super({controllerId:r,getDocumentVersion:u=>u&&o.getDocument(u)?.version,getApiFor:t.getPrivateApiFor,getChildren:u=>u.children,root:new f(r,b),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ce[136],De([1,0,48,11,98,15,7]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(E,y,w){const h=T._Keys.nextId();E.$registerTextEditorDecorationType(y.identifier,h,P.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:h,dispose(){E.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=T,T._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(E,y){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=y.undoStopBefore,this._undoStopAfter=y.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,y){this._throwIfFinalized();let w=null;if(E instanceof C.Position)w=new C.Range(E,E);else if(E instanceof C.Range)w=E;else throw new Error("Unrecognized location");this._pushEdit(w,y,!1)}insert(E,y){this._throwIfFinalized(),this._pushEdit(new C.Range(E,E),y,!0)}delete(E){this._throwIfFinalized();let y=null;if(E instanceof C.Range)y=E;else throw new Error("Unrecognized location");this._pushEdit(y,null,!0)}_pushEdit(E,y,w){const h=this._document.validateRange(E);this._collectedEdits.push({range:h,text:y,forceMoveMarkers:w})}setEndOfLine(E){if(this._throwIfFinalized(),E!==C.EndOfLine.LF&&E!==C.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=E}}e.TextEditorEdit=S;class D{constructor(E,y,w,h){this._proxy=E,this._id=y,this._accept(w),this._logService=h;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(f){g._setTabSize(f)},get insertSpaces(){return g._insertSpaces},set insertSpaces(f){g._setInsertSpaces(f)},get cursorStyle(){return g._cursorStyle},set cursorStyle(f){g._setCursorStyle(f)},get lineNumbers(){return g._lineNumbers},set lineNumbers(f){g._setLineNumbers(f)}}}_accept(E){this._tabSize=E.tabSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}_setTabSize(E){const y=this._validateTabSize(E);if(y!==null){if(typeof y=="number"){if(this._tabSize===y)return;this._tabSize=y}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:y}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}_setInsertSpaces(E){const y=this._validateInsertSpaces(E);if(typeof y=="boolean"){if(this._insertSpaces===y)return;this._insertSpaces=y}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:y}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(E)})))}assign(E){const y={};let w=!1;if(typeof E.tabSize<"u"){const h=this._validateTabSize(E.tabSize);h==="auto"?(w=!0,y.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,w=!0,y.tabSize=h)}if(typeof E.insertSpaces<"u"){const h=this._validateInsertSpaces(E.insertSpaces);h==="auto"?(w=!0,y.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,w=!0,y.insertSpaces=h)}typeof E.cursorStyle<"u"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,w=!0,y.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,w=!0,y.lineNumbers=P.TextEditorLineNumbersStyle.from(E.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,y))}_warnOnError(E,y){y.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=D;class A{constructor(E,y,w,h,g,f,v,m){this.id=E,this._proxy=y,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new D(this._proxy,this.id,f,w),this._visibleRanges=v,this._viewColumn=m;const r=this;this.value=Object.freeze({get document(){return h.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(b){if(!(b instanceof C.Selection))throw(0,t.illegalArgument)("selection");r._selections=[b],r._trySetSelection()},get selections(){return r._selections},set selections(b){if(!Array.isArray(b)||b.some(o=>!(o instanceof C.Selection)))throw(0,t.illegalArgument)("selections");r._selections=b,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return r._options.value},set options(b){r._disposed||r._options.assign(b)},get viewColumn(){return r._viewColumn},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,o={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new S(h.getValue(),o);return b(u),r._applyEdit(u)},insertSnippet(b,o,u={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!o||Array.isArray(o)&&o.length===0)s=r._selections.map(l=>P.Range.from(l));else if(o instanceof C.Position){const{lineNumber:l,column:a}=P.Position.from(o);s=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(o instanceof C.Range)s=[P.Range.from(o)];else{s=[];for(const l of o)if(l instanceof C.Range)s.push(P.Range.from(l));else{const{lineNumber:a,column:d}=P.Position.from(l);s.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return y.$tryInsertSnippet(E,h.getValue().version,b.value,s,u)},setDecorations(b,o){const u=o.length===0;u&&!r._hasDecorationsForKey.has(b.key)||(u?r._hasDecorationsForKey.delete(b.key):r._hasDecorationsForKey.add(b.key),r._runOnProxy(()=>{if(P.isDecorationOptionsArr(o))return y.$trySetDecorations(E,b.key,P.fromRangeOrRangeWithMessage(o));{const s=new Array(4*o.length);for(let l=0,a=o.length;l<a;l++){const d=o[l];s[4*l]=d.start.line+1,s[4*l+1]=d.start.character+1,s[4*l+2]=d.end.line+1,s[4*l+3]=d.end.character+1}return y.$trySetDecorationsFast(E,b.key,s)}}))},revealRange(b,o){r._runOnProxy(()=>y.$tryRevealRange(E,P.Range.from(b),o||C.TextEditorRevealType.Default))},show(b){y.$tryShowEditor(E,P.ViewColumn.from(b))},hide(){y.$tryHideEditor(E)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,c.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,c.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,c.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,c.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const y=E.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const w=y.edits.map(g=>g.range);w.sort((g,f)=>g.end.line===f.end.line?g.end.character===f.end.character?g.start.line===f.start.line?g.start.character-f.start.character:g.start.line-f.start.line:g.end.character-f.end.character:g.end.line-f.end.line);for(let g=0,f=w.length-1;g<f;g++){const v=w[g].end;if(w[g+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=y.edits.map(g=>({range:P.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,h,{setEndOfLine:typeof y.setEndOfLine=="number"?P.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this._logService.warn(y),null))}}e.ExtHostTextEditor=A}),define(Ce[235],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[236],De([1,0,187,11,42,121,125,43,26,235,198]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=T.Registry.as(C.Extensions.JSONContribution);class E{constructor(r,b,o){this._messageHandler=r,this._extension=b,this._extensionPointId=o}_msg(r,b){this._messageHandler({type:r,message:b,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(r){this._msg(I.default.Error,r)}warn(r){this._msg(I.default.Warning,r)}info(r){this._msg(I.default.Info,r)}}e.ExtensionMessageCollector=E;class y{static _toSet(r){const b=new Set;for(let o=0,u=r.length;o<u;o++)b.add(S.ExtensionIdentifier.toKey(r[o].description.identifier));return b}static compute(r,b){if(!r||!r.length)return new y(b,[]);if(!b||!b.length)return new y([],r);const o=this._toSet(r),u=this._toSet(b),s=b.filter(a=>!o.has(S.ExtensionIdentifier.toKey(a.description.identifier))),l=r.filter(a=>!u.has(S.ExtensionIdentifier.toKey(a.description.identifier)));return new y(s,l)}constructor(r,b){this.added=r,this.removed=b}}e.ExtensionPointUserDelta=y;class w{constructor(r,b){this.name=r,this.defaultExtensionKind=b,this._handler=null,this._users=null,this._delta=null}setHandler(r){if(this._handler!==null)throw new Error("Handler already set!");this._handler=r,this._handle()}acceptUsers(r){this._delta=y.compute(this._users,r),this._users=r,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(r){(0,t.onUnexpectedError)(r)}}}e.ExtensionPoint=w;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},activationEvents:{description:c.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:c.localize(31,null)},{label:"onUri",body:"onUri",description:c.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(36,null)},{label:"onRenderer",description:c.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(39,null)},{label:"*",description:c.localize(40,null),body:"*"}]}},badges:{type:"array",description:c.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(42,null)},href:{type:"string",description:c.localize(43,null)},description:{type:"string",description:c.localize(44,null)}}}},markdown:{type:"string",description:c.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(49,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(50,null)},{body:["workspace"],description:c.localize(51,null)},{body:["ui","workspace"],description:c.localize(52,null)},{body:["workspace","ui"],description:c.localize(53,null)},{body:[],description:c.localize(54,null)}]},capabilities:{description:c.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(58,null),c.localize(59,null),c.localize(60,null)]},description:{type:"string",markdownDescription:c.localize(61,null)}}},untrustedWorkspaces:{description:c.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(64,null),c.localize(65,null),c.localize(66,null)]},restrictedConfigurations:{description:c.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(68,null)}}}}},sponsor:{description:c.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(71,null),type:"string"},"vscode:uninstall":{description:c.localize(72,null),type:"string"}}},icon:{type:"string",description:c.localize(73,null)},l10n:{type:"string",description:c.localize(74,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(r){if(this._extensionPoints.has(r.extensionPoint))throw new Error("Duplicate extension point: "+r.extensionPoint);const b=new w(r.extensionPoint,r.defaultExtensionKind);return this._extensionPoints.set(r.extensionPoint,b),e.schema.properties.contributes.properties[r.extensionPoint]=r.jsonSchema,k.registerSchema(g,e.schema),b}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=T.Registry.as(v.ExtensionsRegistry),k.registerSchema(g,e.schema),k.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Ce[237],De([1,0,184,12,24,236,52,4]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var D;(function(E){function y(w,h,g){if(!w)return;const f=t.isString(w.type)?w.type:void 0;if(!f||f.length===0){g.error(c.localize(3,null));return}const v=[];if(Array.isArray(w.required))for(const m of w.required)t.isString(m)&&v.push(m);return{extensionId:h.value,taskType:f,required:v,properties:w.properties?I.deepClone(w.properties):{},when:w.when?C.ContextKeyExpr.deserialize(w.when):void 0}}E.from=y})(D||(D={}));const A=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class k{constructor(){this._onDefinitionsChanged=new T.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((y,w)=>{A.setHandler((h,g)=>{this._schema=void 0;try{for(const f of g.removed){const v=f.value;for(const m of v)this.taskTypes&&m.type&&this.taskTypes[m.type]&&delete this.taskTypes[m.type]}for(const f of g.added){const v=f.value;for(const m of v){const r=D.from(m,f.description.identifier,f.collector);r&&(this.taskTypes[r.taskType]=r)}}(g.removed.length>0||g.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}y(void 0)})})}onReady(){return this.readyPromise}get(y){return this.taskTypes[y]}all(){return Object.keys(this.taskTypes).map(y=>this.taskTypes[y])}getJsonSchema(){if(this._schema===void 0){const y=[];for(const w of this.all()){const h={type:"object",additionalProperties:!1};w.required.length>0&&(h.required=w.required.slice(0)),w.properties!==void 0?h.properties=I.deepClone(w.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[w.taskType]},y.push(h)}this._schema={oneOf:y}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(Ce[238],De([1,0,185,12,22,24,52,237]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function z(U){if(!U)return O.Strong;switch(U.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=z}(S=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A=e.RevealKind||(e.RevealKind={})),function(O){function z(U){switch(U.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=z}(A=e.RevealKind||(e.RevealKind={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function z(U){switch(U.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=z}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(O){function z(U){switch(U.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=z}(E=e.PanelKind||(e.PanelKind={}));var y;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(y=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(O){function z(F){switch(F.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=z;function U(F){switch(F){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=U}(w=e.RuntimeType||(e.RuntimeType={}));var h;(function(O){function z(U){return t.isString(U)?U:U.value}O.value=z})(h=e.CommandString||(e.CommandString={}));var g;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function z(F){return F===O.Clean._id||F===O.Build._id||F===O.Rebuild._id||F===O.Test._id}O.is=z;function U(F){if(F!==void 0)return t.isString(F)?z(F)?{_id:F,isDefault:!1}:void 0:F}O.from=U})(g=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var v;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function z(U){switch(U){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=z})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var m;(function(O){O.parallel="parallel",O.sequence="sequence"})(m=e.DependsOrder||(e.DependsOrder={}));var r;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(r=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class o{constructor(z,U,F,V,x,Q){this._label="",this._id=z,U&&(this._label=U),F&&(this.type=F),this.runOptions=V,this.configurationProperties=x,this._source=Q}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.getFolderId(),id:this._id};return JSON.stringify(z)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,U=!1){if(z===void 0)return!1;if(t.isString(z))return z===this._label||z===this.configurationProperties.identifier||U&&z===this._id;const F=this.getDefinition(!0);return F!==void 0&&F._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),z&&(this._taskLoadMessages=this._taskLoadMessages.concat(z))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=o;class u extends o{constructor(z,U,F,V,x,Q,K,ue){super(z,F,void 0,K,ue,U),this.command={},this._source=U,this.hasDefinedMatchers=Q,x&&(this.command=x)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case w.Shell:U="shell";break;case w.Process:U="process";break;case w.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(z){return z instanceof u}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.getFolderId();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(U+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(F)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(z){return new u(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=u;class s extends o{constructor(z,U,F,V,x,Q,K){super(z,F,V,Q,K,U),this._source=U,this.configures=x}static is(z){return z instanceof s}fromObject(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.getFolderId();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(U+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(F)}}e.ConfiguringTask=s;class l extends o{constructor(z,U,F,V,x,Q,K,ue,te){super(z,F,V,ue,te,U),this.defines=x,this.hasDefinedMatchers=K,this.command=Q,this.icon=te.icon,this.hide=te.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof l}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.getFolderId(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(z){return new l(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=l;class a extends o{constructor(z,U,F,V,x,Q){super(z,F,V,x,Q,U),this._source=U}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(z){return new a(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=a;var d;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class i{constructor(z){this._order=new Map;for(let U=0;U<z.length;U++)this._order.set(z[U].uri.toString(),U)}compare(z,U){const F=z.getWorkspaceFolder(),V=U.getWorkspaceFolder();if(F&&V){let x=this._order.get(F.uri.toString());x=x===void 0?0:x+1;let Q=this._order.get(V.uri.toString());return Q=Q===void 0?0:Q+1,x===Q?z._label.localeCompare(U._label):x-Q}else return!F&&V?-1:F&&!V?1:0}}e.TaskSorter=i;var p;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var _;(function(O){O.SingleRun="singleRun",O.Background="background"})(_=e.TaskRunType||(e.TaskRunType={}));var R;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(O){function z(U,F,V,x,Q){if(F){const K={kind:U,taskId:F._id,taskName:F.configurationProperties.name,runType:F.configurationProperties.isBackground?"background":"singleRun",group:F.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:F};return U==="start"?(K.terminalId=V,K.resolvedVariables=x):U==="processStarted"?K.processId=V:U==="processEnded"&&(K.exitCode=V),Object.freeze(K)}else return Object.freeze({kind:"changed"})}O.create=z})(M=e.TaskEvent||(e.TaskEvent={}));var H;(function(O){function z(F){const V=Object.keys(F).sort();let x="";for(const Q of V){let K=F[Q];K instanceof Object?K=z(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),x+=Q+","+K+","}return x}function U(F){const x={_key:z(F),type:F.taskType};return Object.assign(x,F),x}O.create=U})(H=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var $;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})($=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function z(U,F){const V=T.TaskDefinitionRegistry.get(U.type);if(V===void 0){const ue=P.deepClone(U);return delete ue._key,H.create(ue)}const x=Object.create(null);x.type=V.taskType;const Q=new Set;V.required.forEach(ue=>Q.add(ue));const K=V.properties;for(const ue of Object.keys(K)){const te=U[ue];if(te!=null)x[ue]=te;else if(Q.has(ue)){const he=K[ue];if(he.default!==void 0)x[ue]=P.deepClone(he.default);else switch(he.type){case"boolean":x[ue]=!1;break;case"number":case"integer":x[ue]=0;break;case"string":x[ue]="";break;default:F.error(c.localize(2,null,JSON.stringify(U,void 0,0),ue));return}}}return H.create(x)}O.createTaskIdentifier=z})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[239],De([1,0,11]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,T)=>{this._actualOk=C,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,c.onUnexpectedError)(C))}then(C,T){return this._ensureActual().then(C,T)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=t;class I extends t{constructor(){super(),this._hasErr=!0,this._err=new c.CancellationError}}e.CanceledLazyPromise=I}),define(Ce[56],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function I(T){const S=new c(T);return t[S.nid]=S,S}e.createProxyIdentifier=I;function P(T){return t[T].sid}e.getStringIdentifierForProxy=P;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Ce[5],De([1,0,56]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var P;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(g){return g._id=k._n++,g}}e.IdObject=k,k._n=0;var E;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var y;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(y=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[68],De([1,0,3,13,5,16]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,D,A){const k=this.getUsageKey(S,D);this._reportedUsages.has(k)||(this._reportedUsages.add(k),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:S}))}getUsageKey(S,D){return`${S}-${D.identifier.value}`}};C=je([$e(0,P.IExtHostRpcService),$e(1,t.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,D){}})}),define(Ce[240],De([1,0,4,5,7,26]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,D,A,k={}){const E=P.ExtensionIdentifier.toKey(S.identifier),y=this._inFlightRequests.get(E)||[],w=[...A].sort().join(" ");let h=y.find(g=>g.providerId===D&&g.scopes===w);if(h)return h.result;{const g=this._getSession(S,E,D,A,k);h={providerId:D,scopes:w,result:g},y.push(h),this._inFlightRequests.set(E,y);try{await g}finally{const f=y.findIndex(v=>v.providerId===D&&v.scopes===w);f>-1&&(y.splice(f),this._inFlightRequests.set(E,y))}return g}}async _getSession(S,D,A,k,E={}){await this._proxy.$ensureProvider(A);const y=S.displayName||S.name;return this._proxy.$getSession(A,k,D,y,E)}async removeSession(S,D){const A=this._authenticationProviders.get(S);return A?A.provider.removeSession(D):this._proxy.$removeSession(S,D)}registerAuthenticationProvider(S,D,A,k){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:D,provider:A,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(y=>y.id===S)||this._providers.push({id:S,label:D});const E=A.onDidChangeSessions(y=>{this._proxy.$sendDidChangeSessions(S,{added:y.added??[],changed:y.changed??[],removed:y.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,D,k?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(S);const y=this._providers.findIndex(w=>w.id===S);y>-1&&this._providers.splice(y),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,D){return this._onDidChangeSessions.fire({provider:{id:S,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ce[241],De([1,0,5,16,15]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(T,S){this._proxy=T.getProxy(c.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:D=>S.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,D){const A=I.WorkspaceEdit.from(T,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,D?.isRefactoring??!1)}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(Ce[242],De([1,0,5]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const C=P.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(T){return C.$writeText(T)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[39],De([1,0,12,7,15,24,5,17,13,82,35,49,2,6,3,16,135,23,56,50]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m){"use strict";var r,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(n,i){r.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,b.set(this,void 0),tt(this,r,n.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=i,tt(this,b,n.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,p=>{const _=this._apiCommands.get(p);return _?.result===l.Void?_:void 0},i),this._argumentProcessors=[{processArgument(p){return(0,D.revive)(p)}},{processArgument(p){return(0,P.cloneAndChange)(p,function(_){if(A.Range.isIRange(_))return I.Range.to(_);if(k.Position.isIPosition(_))return I.Position.to(_);if(A.Range.isIRange(_.range)&&E.URI.isUri(_.uri))return I.location.to(_);if(_ instanceof f.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const i=this.registerCommand(!1,n.id,async(...p)=>{const _=n.args.map((M,H)=>{if(!M.validate(p[H]))throw new Error(`Invalid argument '${M.name}' when running '${n.id}', received: ${p[H]}`);return M.convert(p[H])}),R=await this.executeCommand(n.internalId,..._);return n.result.convert(R,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{i.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,i,p,_,R,M){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:p,thisArg:_,description:R,extension:M}),n&&Be(this,r,"f").$registerCommand(i),new t.Disposable(()=>{this._commands.delete(i)&&n&&Be(this,r,"f").$unregisterCommand(i)})}executeCommand(n,...i){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,i,!0)}async _doExecuteCommand(n,i,p){if(this._commands.has(n))return Be(this,r,"f").$fireCommandActivationEvent(n),this._executeContributedCommand(n,i,!1);{let _=!1;const R=(0,P.cloneAndChange)(i,function(M){if(M instanceof t.Position)return I.Position.from(M);if(M instanceof t.Range)return I.Range.from(M);if(M instanceof t.Location)return I.location.from(M);if(t.NotebookRange.isNotebookRange(M))return I.NotebookRange.from(M);if(M instanceof ArrayBuffer)return _=!0,f.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return _=!0,f.VSBuffer.wrap(M);if(M instanceof f.VSBuffer)return _=!0,M;if(!Array.isArray(M))return M});try{const M=await Be(this,r,"f").$executeCommand(n,_?new v.SerializableObjectWithBuffers(R):R,p);return(0,D.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(n,i,!1);throw M}}}async _executeContributedCommand(n,i,p){const _=this._commands.get(n);if(!_)throw new Error("Unknown command");this._reportTelemetry(_,n);const{callback:R,thisArg:M,description:H}=_;if(H)for(let $=0;$<H.args.length;$++)try{(0,c.validateConstraint)(i[$],H.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${H.args[$].name}' - ${H.args[$].description}`)}try{return await R.apply(M,i)}catch($){if(n===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...i);L&&(n=L.command)}throw this._logService.error($,n,_.extension?.identifier),p?new class extends Error{constructor(){super((0,m.toErrorMessage)($)),this.id=n,this.source=_.extension?.displayName??_.extension?.name}}:$}}_reportTelemetry(n,i){!n.extension||n.extension.isBuiltin||Be(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:i})}$executeContributedCommand(n,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(i=i.map(p=>this._argumentProcessors.reduce((_,R)=>R.processArgument(_),p)),this._executeContributedCommand(n,i,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Be(this,r,"f").$getCommands().then(i=>(n&&(i=i.filter(p=>p[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[i,p]of this._commands){const{description:_}=p;_&&(n[i]=_)}return Promise.resolve(n)}};r=new WeakMap,b=new WeakMap,o=je([$e(0,h.IExtHostRpcService),$e(1,S.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class u{constructor(n,i,p){this._commands=n,this._lookupApiCommand=i,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,i){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const _=this._lookupApiCommand(n.command);if(_)p.id=_.internalId,p.arguments=_.args.map((R,M)=>R.convert(n.arguments&&n.arguments[M]));else if((0,T.isNonEmptyArray)(n.arguments)){const R=++this._cachIdPool;this._cache.set(R,n),i.add((0,y.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),p.$ident=R,p.id=this.delegatingCommandId,p.arguments=[R],this._logService.trace("CommandsConverter#CREATE",n.command,R)}return p}fromInternal(n){return typeof n.$ident=="number"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const i=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class s{constructor(n,i,p,_){this.name=n,this.description=i,this.validate=p,this.convert=_}optional(){return new s(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,i){return new s(n??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",d=>E.URI.isUri(d),d=>d),s.Position=new s("position","A position in a text document",d=>t.Position.isPosition(d),I.Position.from),s.Range=new s("range","A range in a text document",d=>t.Range.isRange(d),I.Range.from),s.Selection=new s("selection","A selection in a text document",d=>t.Selection.isSelection(d),I.Selection.from),s.Number=new s("number","",d=>typeof d=="number",d=>d),s.String=new s("string","",d=>typeof d=="string",d=>d),s.CallHierarchyItem=new s("item","A call hierarchy item",d=>d instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",d=>d instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",d=>d instanceof g.TestItemImpl,I.TestItem.from);class l{constructor(n,i){this.description=n,this.convert=i}}e.ApiCommandResult=l,l.Void=new l("no result",d=>d);class a{constructor(n,i,p,_,R){this.id=n,this.internalId=i,this.description=p,this.args=_,this.result=R}}e.ApiCommand=a}),define(Ce[243],De([1,0,2,15,7,65,39,17,118,123,14]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",y(t.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,g)=>{if((0,T.isFalsyOrEmpty)(h))return;class f extends I.SymbolInformation{static to(m){const r=new f(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new I.Location(g[0],t.Range.to(m.range)));return r.detail=m.detail,r.range=r.location.range,r.selectionRange=t.Range.to(m.selectionRange),r.children=m.children?m.children.map(f.to):[],r}}return h.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(t.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(t.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(g=>I.Position.isPosition(g)),h=>h.map(t.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(g=>{let f;for(const v of g.reverse())f=new I.SelectionRange(t.Range.to(v),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(t.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:t.Range.to(h.range),placeholder:h.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return t.WorkspaceEdit.to(h)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(t.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new I.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,S.decodeSemanticTokensDto)(h);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new I.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,S.decodeSemanticTokensDto)(h);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,g,f)=>{if(!h)return new I.CompletionList([]);const v=h.suggestions.map(m=>t.CompletionItem.to(m,f));return new I.CompletionList(v,h.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return t.SignatureHelp.to(h)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,g,f)=>y(v=>new I.CodeLens(t.Range.to(v.range),v.command&&f.fromInternal(v.command)))(h))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>I.Range.isRange(h),h=>I.Selection.isSelection(h)?t.Selection.from(h):t.Range.from(h)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,g,f)=>y(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const m=new I.CodeAction(v.title,v.kind?new I.CodeActionKind(v.kind):void 0);return v.edit&&(m.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(m.command=f.fromInternal(v.command)),m.isPreferred=v.isPreferred,m}})(h))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(g=>new I.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",h=>h instanceof I.Color,t.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:t.Range.from(h.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(t.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,g,f)=>h.map(t.InlayHint.to.bind(void 0,f)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",y(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(t.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>c.URI.isUri(h)||typeof h=="string"&&(0,D.matchesSomeScheme)(h,A.Schemas.http,A.Schemas.https),h=>h),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void)];class E{static register(g){k.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function y(h){return g=>{if(Array.isArray(g))return g.map(h)}}function w(h){if(!Array.isArray(h))return;const g=[];for(const f of h)P.isLocationLink(f)?g.push(t.DefinitionLink.to(f)):g.push(t.location.to(f));return g}}),define(Ce[244],De([1,0,18,59,4,6,2,65,26,15,7,27,5]),function(J,e,c,t,I,P,C,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function y(w,h,g){const f=w.getProxy(E.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const n=this._commentControllers.get(d.handle);return n?n.value:d}else if(d&&d.$mid===7){const n=this._commentControllers.get(d.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.commentThreadHandle);return i?i.value:d}else if(d&&d.$mid===8){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);return i?{thread:i.value,text:d.text}:d}else if(d&&d.$mid===9){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);if(!i)return d;const p=d.commentUniqueId,_=i.getCommentByUniqueId(p);return _||d}else if(d&&d.$mid===10){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);if(!i)return d;const p=d.text,_=d.commentUniqueId,R=i.getCommentByUniqueId(_);return R?(typeof R.body=="string"?R.body=p:R.body.value=p,R):d}return d}})}createCommentController(d,n,i){const p=v.handlePool++,_=new r(d,p,n,i);this._commentControllers.set(_.handle,_);const R=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(d.identifier))||[];return R.push(_),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(d.identifier),R),_.value}$createCommentThreadTemplate(d,n,i){const p=this._commentControllers.get(d);!p||p.$createCommentThreadTemplate(n,i)}async $updateCommentThreadTemplate(d,n,i){const p=this._commentControllers.get(d);!p||p.$updateCommentThreadTemplate(n,i)}$deleteCommentThread(d,n){this._commentControllers.get(d)?.$deleteCommentThread(n)}$provideCommentingRanges(d,n,i){const p=this._commentControllers.get(d);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const _=g.getDocument(C.URI.revive(n));return(0,c.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(_,i)).then(R=>R?R.map(M=>D.Range.from(M)):void 0)}$toggleReaction(d,n,i,p,_){const R=this._commentControllers.get(d);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const M=R.getCommentThread(n);if(M){const H=M.getCommentByUniqueId(p.uniqueIdInThread);if(R!==void 0&&H&&R.reactionHandler)return R.reactionHandler(H,u(_))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class m{set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(d){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,n,i,p,_,R,M,H){this._commentControllerHandle=n,this._id=i,this._uri=p,this._range=_,this._comments=R,this.extensionDescription=M,this._isTemplate=H,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),f.$createCommentThread(n,this.handle,this._id,this._uri,D.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(n,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(L){$.range=L},get comments(){return $.comments},set comments(L){$.comments=L},get collapsibleState(){return $.collapsibleState},set collapsibleState(L){$.collapsibleState=L},get canReply(){return $.canReply},set canReply(L){$.canReply=L},get contextValue(){return $.contextValue},set contextValue(L){$.contextValue=L},get label(){return $.label},set label(L){$.label=L},get state(){return $.state},set state(L){$.state=L},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const d=i=>Object.prototype.hasOwnProperty.call(this.modifications,i),n={};d("range")&&(n.range=D.Range.from(this._range)),d("label")&&(n.label=this.label),d("contextValue")&&(n.contextValue=this.contextValue??null),d("comments")&&(n.comments=this._comments.map(i=>b(this,i,this._commentsMap))),d("collapsibleState")&&(n.collapseState=s(this._collapseState)),d("canReply")&&(n.canReply=this.canReply),d("state")&&(n.state=l(this._state)),d("isTemplate")&&(n.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(d){for(const n of this._commentsMap){const i=n[0],p=n[1];if(d===p)return i}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}m._handlePool=0,je([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,n,i,p){this._extension=d,this._handle=n,this._id=i,this._label=p,this._threads=new Map,f.$registerCommentController(this.handle,i,p);const _=this;this.value=Object.freeze({id:_.id,label:_.label,get options(){return _.options},set options(R){_.options=R},get commentingRangeProvider(){return _.commentingRangeProvider},set commentingRangeProvider(R){_.commentingRangeProvider=R},get reactionHandler(){return _.reactionHandler},set reactionHandler(R){_.reactionHandler=R},createCommentThread(R,M,H){return _.createCommentThread(R,M,H).value},dispose:()=>{_.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(d,n,i,p){if(typeof d=="string"){const _=new m(this.id,this.handle,d,n,i,p,this._extension,!1);return this._threads.set(_.handle,_),_}else{const _=new m(this.id,this.handle,void 0,d,n,i,this._extension,!1);return this._threads.set(_.handle,_),_}}$createCommentThreadTemplate(d,n){const i=new m(this.id,this.handle,void 0,C.URI.revive(d),D.Range.to(n),[],this._extension,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(d,n){const i=this._threads.get(d);i&&(i.range=D.Range.to(n))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function b(a,d,n){let i=n.get(d);i||(i=++a.commentHandle,n.set(d,i));const p=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:i,body:typeof d.body=="string"?d.body:D.MarkdownString.from(d.body),userName:d.author.name,userIconPath:p,label:d.label,commentReactions:d.reactions?d.reactions.map(_=>o(_)):void 0,timestamp:d.timestamp?.toJSON()}}function o(a){return{label:a.label,iconPath:a.iconPath?D.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function u(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?C.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function s(a){if(a!==void 0)switch(a){case A.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function l(a){if(a!==void 0)switch(a){case A.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new v}e.createExtHostComments=y}),define(Ce[245],De([1,0,24,5,25,16]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(A,k){this._mainThreadConsole=A.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,k){const E=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){E._handleConsoleCall(A,k,y,arguments)}})}_handleConsoleCall(A,k,E,y){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:S(y,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,E,y)}};C=je([$e(0,P.IExtHostRpcService),$e(1,I.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const T=1e5;function S(D,A){const k=[];if(D.length)for(let E=0;E<D.length;E++){let y=D[E];if(typeof y>"u")y="undefined";else if(y instanceof Error){const w=y;w.stack?y=w.stack:y=w.toString()}k.push(y)}if(A){const E=new Error().stack;E&&k.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,c.safeStringify)(k);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Ce[137],De([1,0,2,5,7,3,16,13,17,8,9]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class Ln{constructor(y,w){this._logService=w,this._provider=new Map,this._proxy=y.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(y,w){const h=Ln._handlePool++;this._provider.set(h,{provider:y,extensionId:w}),this._proxy.$registerDecorationProvider(h,w.value);const g=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(h,null);return}const v=(0,S.asArray)(f);if(v.length<=Ln._maxEventSize){this._proxy.$onDidChange(h,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,v.length);const m=v.map(o=>({uri:o,rank:(0,D.count)(o.path,"/")})),r=(0,S.groupBy)(m,(o,u)=>o.rank-u.rank||(0,D.compare)(o.uri.path,u.uri.path)),b=[];e:for(const o of r){let u;for(const s of o){const l=(0,A.dirname)(s.uri.path);if(u!==l&&(u=l,b.push(s.uri)>=Ln._maxEventSize))break e}}this._proxy.$onDidChange(h,b)});return new I.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(y,w,h){if(!this._provider.has(y))return Object.create(null);const g=Object.create(null),{provider:f,extensionId:v}=this._provider.get(y);return await Promise.all(w.map(async m=>{try{const{uri:r,id:b}=m,o=await Promise.resolve(f.provideFileDecoration(c.URI.revive(r),h));if(!o)return;try{I.FileDecoration.validate(o),g[b]=[o.propagate,o.tooltip,o.badge,o.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(r){this._logService.error(r)}})),g}};k._handlePool=0,k._maxEventSize=250,k=je([$e(0,C.IExtHostRpcService),$e(1,T.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[246],De([1,0,171,122,2,5,7,15,4,13,28,46]),function(J,e,c,t,I,P,C,T,S,D,A,k){"use strict";var E,y,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(v,m,r,b,o,u){this._name=v,this._owner=m,this._maxDiagnosticsPerFile=r,E.set(this,void 0),y.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,tt(this,w,new A.ResourceMap(s=>b.getComparisonKey(s)),"f"),tt(this,E,o,"f"),tt(this,y,u,"f")}dispose(){this._isDisposed||(Be(this,y,"f").fire([...Be(this,w,"f").keys()]),Be(this,E,"f")?.$clear(this._owner),Be(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,m){if(!v){this.clear();return}this._checkDisposed();let r=[];if(I.URI.isUri(v)){if(!m){this.delete(v);return}Be(this,w,"f").set(v,m.slice()),r=[v]}else if(Array.isArray(v)){r=[];let o;v=[...v].sort(h._compareIndexedTuplesByUri);for(const u of v){const[s,l]=u;if((!o||s.toString()!==o.toString())&&(o&&Be(this,w,"f").get(o).length===0&&Be(this,w,"f").delete(o),o=s,r.push(s),Be(this,w,"f").set(s,[])),l)Be(this,w,"f").get(s)?.push(...l);else{const a=Be(this,w,"f").get(s);a&&(a.length=0)}}}if(Be(this,y,"f").fire(r),!Be(this,E,"f"))return;const b=[];for(const o of r){let u=[];const s=Be(this,w,"f").get(o);if(s)if(s.length>this._maxDiagnosticsPerFile){u=[];const l=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const d of s)if(d.severity===l[a]&&u.push(T.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;u.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=s.map(l=>T.Diagnostic.from(l));b.push([o,u])}Be(this,E,"f").$changeMany(this._owner,b)}delete(v){this._checkDisposed(),Be(this,y,"f").fire([v]),Be(this,w,"f").delete(v),Be(this,E,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Be(this,y,"f").fire([...Be(this,w,"f").keys()]),Be(this,w,"f").clear(),Be(this,E,"f")?.$clear(this._owner)}forEach(v,m){this._checkDisposed();for(const[r,b]of this)v.call(m,r,b,this)}*[(E=new WeakMap,y=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Be(this,w,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const m=Be(this,w,"f").get(v);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Be(this,w,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,m){return v[0].toString()<m[0].toString()?-1:v[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=h;let g=class vn{static _mapper(v){const m=new A.ResourceMap;for(const r of v)m.set(r,r);return{uris:Object.freeze(Array.from(m.values()))}}constructor(v,m,r){this._logService=m,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,vn._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,m){const{_collections:r,_proxy:b,_onDidChangeDiagnostics:o,_logService:u,_fileSystemInfoService:s}=this,l=new class{$changeMany(n,i){b.$changeMany(n,i),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,n,i.length===0?"CLEARING":i)}$clear(n){b.$clear(n),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,n)}dispose(){b.dispose()}};let a;if(!m)m="_generated_diagnostic_collection_name_#"+vn._idPool++,a=m;else if(!r.has(m))a=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do a=m+vn._idPool++;while(r.has(a))}return new class extends h{constructor(){super(m,a,vn._maxDiagnosticsPerFile,s.extUri,l,o),r.set(a,this)}dispose(){super.dispose(),r.delete(a)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const m=new Map,r=[];for(const b of this._collections.values())b.forEach((o,u)=>{let s=m.get(o.toString());typeof s>"u"&&(s=r.length,m.set(o.toString(),s),r.push([o,[]])),r[s][1]=r[s][1].concat(...u)});return r}}_getDiagnostics(v){let m=[];for(const r of this._collections.values())r.has(v)&&(m=m.concat(r.get(v)));return m}$acceptMarkersChange(v){if(!this._mirrorCollection){const m="_generated_mirror",r=new h(m,m,vn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,r),this._mirrorCollection=r}for(const[m,r]of v)this._mirrorCollection.set(I.URI.revive(m),r.map(T.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=je([$e(1,D.ILogService),$e(2,k.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(Ce[247],De([1,0,2,5]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(C){this._proxy=C.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(T=>T?T.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=I}),define(Ce[248],De([1,0,11,2,7,5,14,21,8]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(k,E,y){this._documentsAndEditors=E,this._logService=y,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,E){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const y=D._handlePool++;this._documentContentProviders.set(y,E),this._proxy.$registerTextContentProvider(y,k);let w;return typeof E.onDidChange=="function"&&(w=E.onDidChange(h=>{if(h.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(y,h).then(g=>{if(!g&&typeof g!="string")return;const f=this._documentsAndEditors.getDocument(h);if(!f)return;const v=(0,S.splitLines)(g);if(!f.equalLines(v))return this._proxy.$onVirtualDocumentChange(h,g)},c.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(y)&&this._proxy.$unregisterTextContentProvider(y),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,E){const y=this._documentContentProviders.get(k);return y?Promise.resolve(y.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(Ce[249],De([1,0,4,6,2,5,133,15,12,24,7]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(y,w){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const g of h)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const g of h)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(y){if(!y)return;const w=this._documentsAndEditors.getDocument(y);if(w)return w}getDocument(y){const w=this.getDocumentData(y);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return w.document}ensureDocumentData(y){const w=this._documentsAndEditors.getDocument(y);if(w)return Promise.resolve(w);let h=this._documentLoader.get(y.toString());return h||(h=this._proxy.$tryOpenDocument(y).then(g=>{this._documentLoader.delete(y.toString());const f=I.URI.revive(g);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(f))},g=>(this._documentLoader.delete(y.toString()),Promise.reject(g))),this._documentLoader.set(y.toString(),h)),h}createDocumentData(y){return this._proxy.$tryCreateDocument(y).then(w=>I.URI.revive(w))}$acceptModelLanguageChanged(y,w){const h=I.URI.revive(y),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(w),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(y){const w=I.URI.revive(y),h=this._documentsAndEditors.getDocument(w);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(y,w){const h=I.URI.revive(y),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,w,h){const g=I.URI.revive(y),f=this._documentsAndEditors.getDocument(g);if(!f)throw new Error("unknown document");f._acceptIsDirty(h),f.onEvents(w);let v;w.isUndoing?v=A.TextDocumentChangeReason.Undo:w.isRedoing&&(v=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:f.document,contentChanges:w.changes.map(m=>({range:T.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:v}))}setWordDefinitionFor(y,w){(0,C.setWordDefinitionFor)(y,w)}}e.ExtHostDocuments=k}),define(Ce[57],De([1,0,48,4,6,2,3,5,133,16,136,15,13,28,14,61,79]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(r,b){this._extHostRpc=r,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new y.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const b=[],o=[],u=[];if(r.removedDocuments)for(const s of r.removedDocuments){const l=P.URI.revive(s),a=this._documents.get(l);a?.unref()&&(this._documents.delete(l),b.push(a.value))}if(r.addedDocuments)for(const s of r.addedDocuments){const l=P.URI.revive(s.uri);let a=this._documents.get(l);if(a&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new f(new S.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(l,a),o.push(a.value)),a.ref()}if(r.removedEditors)for(const s of r.removedEditors){const l=this._editors.get(s);this._editors.delete(s),l&&u.push(l)}if(r.addedEditors)for(const s of r.addedEditors){const l=P.URI.revive(s.documentUri);c.ok(this._documents.has(l),`document '${l}' does not exist`),c.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(l).value,d=new A.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>a.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(n=>k.Range.to(n)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,d)}r.newActiveEditor!==void 0&&(c.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,I.dispose)(b),(0,I.dispose)(u),r.removedDocuments&&this._onDidRemoveDocuments.fire(b),r.addedDocuments&&this._onDidAddDocuments.fire(o),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return r?b:b?.value}allEditors(){return[...this._editors.values()]}};v=je([$e(0,D.IExtHostRpcService),$e(1,E.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[58],De([1,0,15,5,2,4,3,7,16,12,78]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class k{constructor(g,f,v){this._activeTabIdGetter=v,this._parentGroup=f,this.acceptDtoUpdate(g)}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.id===g._activeTabIdGetter()},get label(){return g._dto.label},get input(){return g._input},get isDirty(){return g._dto.isDirty},get isPinned(){return g._dto.isPinned},get isPreview(){return g._dto.isPreview},get group(){return g._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(g){this._dto=g,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new T.TextTabInput(I.URI.revive(this._dto.input.uri));case 2:return new T.TextDiffTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified));case 3:return new T.TextMergeTabInput(I.URI.revive(this._dto.input.base),I.URI.revive(this._dto.input.input1),I.URI.revive(this._dto.input.input2),I.URI.revive(this._dto.input.result));case 6:return new T.CustomEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new T.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new T.NotebookEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(I.URI.revive(this._dto.input.uri),I.URI.revive(this._dto.input.inputBoxUri));default:return}}}class E{constructor(g,f){this._tabs=[],this._activeTabId="",this._dto=g,this._activeGroupIdGetter=f;for(const v of g.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new k(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.groupId===g._activeGroupIdGetter()},get viewColumn(){return c.ViewColumn.to(g._dto.viewColumn)},get activeTab(){return g._tabs.find(v=>v.tabId===g._activeTabId)?.apiObject},get tabs(){return Object.freeze(g._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(g){this._dto=g}acceptTabOperation(g){if(g.kind===0){const v=new k(g.tabDto,this,()=>this.activeTabId());return this._tabs.splice(g.index,0,v),g.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(g.kind===1){const v=this._tabs.splice(g.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(g.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this._tabs.splice(g.index,0,v),v}const f=this._tabs.find(v=>v.tabId===g.tabDto.id);if(!f)throw new Error("INVALID tab");return g.tabDto.isActive?this._activeTabId=g.tabDto.id:this._activeTabId===g.tabDto.id&&!g.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(g.tabDto),f}activeTabId(){return this._activeTabId}}let y=class{constructor(g){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const g=this,f={onDidChangeTabGroups:g._onDidChangeTabGroups.event,onDidChangeTabs:g._onDidChangeTabs.event,get all(){return Object.freeze(g._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=g._activeGroupId;return(0,D.assertIsDefined)(g._extHostTabGroups.find(r=>r.groupId===v)?.apiObject)},close:async(v,m)=>{const r=Array.isArray(v)?v:[v];return r.length?w(r[0])?this._closeGroups(r,m):this._closeTabs(r,m):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(g){const f=new Set(this._extHostTabGroups.map(s=>s.groupId)),v=new Set(g.map(s=>s.groupId)),m=(0,A.diffSets)(f,v),r=this._extHostTabGroups.filter(s=>m.removed.includes(s.groupId)).map(s=>s.apiObject),b=[],o=[];this._extHostTabGroups=g.map(s=>{const l=new E(s,()=>this._activeGroupId);return m.added.includes(l.groupId)?b.push(l.apiObject):o.push(l.apiObject),l});const u=(0,D.assertIsDefined)(g.find(s=>s.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:b,closed:r,changed:o}))}$acceptTabGroupUpdate(g){const f=this._extHostTabGroups.find(v=>v.groupId===g.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(g),g.isActive&&(this._activeGroupId=g.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const f=this._extHostTabGroups.find(m=>m.groupId===g.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const v=f.acceptTabOperation(g);switch(g.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(g){for(const f of this._extHostTabGroups)for(const v of f.tabs)if(v.apiObject===g)return v}_findExtHostTabGroupFromApi(g){return this._extHostTabGroups.find(f=>f.apiObject===g)}async _closeTabs(g,f){const v=[];for(const m of g){const r=this._findExtHostTabFromApi(m);if(!r)throw new Error("Tab close: Invalid tab not found!");v.push(r.tabId)}return this._proxy.$closeTab(v,f)}async _closeGroups(g,f){const v=[];for(const m of g){const r=this._findExtHostTabGroupFromApi(m);if(!r)throw new Error("Group close: Invalid group not found!");v.push(r.groupId)}return this._proxy.$closeGroup(v,f)}};y=je([$e(0,S.IExtHostRpcService)],y),e.ExtHostEditorTabs=y;function w(h){return h.tabs!==void 0}}),define(Ce[250],De([1,0,2,5,6,7,15,150,8,23,27]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const h=this._schemes.indexOf(w);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),h=[];let g,f,v=14,m=14;for(const r of w){let b=g?(0,S.commonPrefixLength)(g,r):0;for(b===0?f=1:f=m;b<r.length;b++)b+1===r.length?(v=m,m=9):m+=1,h.push([f,r.toUpperCase().charCodeAt(b),m]),h.push([f,r.toLowerCase().charCodeAt(b),m]),f=m;g=r,m=v}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new T.StateMachine(h)}}provideDocumentLinks(w){this._initStateMachine();const h=[],g=T.LinkComputer.computeLinks({getLineContent(f){return w.lineAt(f-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const f of g){const v=C.DocumentLink.to(f);v.target&&h.push(v)}return h}}class E{constructor(w,h){this._extHostLanguageFeatures=h,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,h,g,f={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(v,g);let m=2;f.isCaseSensitive&&(m+=1024),f.isReadonly&&(m+=2048),typeof g.copy=="function"&&(m+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,A.checkProposedApiEnabled)(w,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(v,h,m).catch(b=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${h}`),console.error(b)});const r=g.onDidChangeFile(b=>{const o=[];for(const u of b){const{uri:s,type:l}=u;if(s.scheme!==h)continue;let a;switch(l){case P.FileChangeType.Changed:a=0;break;case P.FileChangeType.Created:a=1;break;case P.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:s,type:a})}this._proxy.$onFileSystemChange(v,o)});return(0,I.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(w){const{type:h,ctime:g,mtime:f,size:v,permissions:m}=w;return{type:h,ctime:g,mtime:f,size:v,permissions:m}}$stat(w,h){return Promise.resolve(this._getFsProvider(w).stat(c.URI.revive(h))).then(g=>E._asIStat(g))}$readdir(w,h){return Promise.resolve(this._getFsProvider(w).readDirectory(c.URI.revive(h)))}$readFile(w,h){return Promise.resolve(this._getFsProvider(w).readFile(c.URI.revive(h))).then(g=>D.VSBuffer.wrap(g))}$writeFile(w,h,g,f){return Promise.resolve(this._getFsProvider(w).writeFile(c.URI.revive(h),g.buffer,f))}$delete(w,h,g){return Promise.resolve(this._getFsProvider(w).delete(c.URI.revive(h),g))}$rename(w,h,g,f){return Promise.resolve(this._getFsProvider(w).rename(c.URI.revive(h),c.URI.revive(g),f))}$copy(w,h,g,f){const v=this._getFsProvider(w);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(c.URI.revive(h),c.URI.revive(g),f))}$mkdir(w,h){return Promise.resolve(this._getFsProvider(w).createDirectory(c.URI.revive(h)))}$watch(w,h,g,f){const v=this._getFsProvider(w).watch(c.URI.revive(g),f);this._watches.set(h,v)}$unwatch(w,h){const g=this._watches.get(h);g&&(g.dispose(),this._watches.delete(h))}$open(w,h,g){const f=this._getFsProvider(w);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(c.URI.revive(h),g))}$close(w,h){const g=this._getFsProvider(w);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(h))}$read(w,h,g,f){const v=this._getFsProvider(w);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const m=D.VSBuffer.alloc(f);return Promise.resolve(v.read(h,g,m.buffer,0,f)).then(r=>m.slice(0,r))}$write(w,h,g,f){const v=this._getFsProvider(w);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(h,g,f.buffer,0,f.byteLength))}_getFsProvider(w){const h=this._fsProvider.get(w);if(!h){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return h}}e.ExtHostFileSystem=E}),define(Ce[69],De([1,0,5,38,7,23,3,16,46,6]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Xt{constructor(E,y){this._fileSystemProvider=new Map,this._proxy=E.getProxy(c.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(h){try{const g=w._fileSystemProvider.get(h.scheme);if(!g)return await w._proxy.$stat(h);await w._proxy.$ensureActivation(h.scheme);const f=await g.stat(h);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(g){Xt._handleError(g)}},async readDirectory(h){try{const g=w._fileSystemProvider.get(h.scheme);return g?(await w._proxy.$ensureActivation(h.scheme),(await g.readDirectory(h)).slice()):await w._proxy.$readdir(h)}catch(g){return Xt._handleError(g)}},async createDirectory(h){try{return await w._proxy.$mkdir(h)}catch(g){return Xt._handleError(g)}},async readFile(h){try{const g=w._fileSystemProvider.get(h.scheme);return g?(await w._proxy.$ensureActivation(h.scheme),(await g.readFile(h)).slice()):(await w._proxy.$readFile(h)).buffer}catch(g){return Xt._handleError(g)}},async writeFile(h,g){try{return await w._proxy.$writeFile(h,P.VSBuffer.wrap(g))}catch(f){return Xt._handleError(f)}},async delete(h,g){try{const f=w._fileSystemProvider.get(h.scheme);return f?(await w._proxy.$ensureActivation(h.scheme),await f.delete(h,{recursive:!1,...g})):await w._proxy.$delete(h,{recursive:!1,useTrash:!1,...g})}catch(f){return Xt._handleError(f)}},async rename(h,g,f){try{return await w._proxy.$rename(h,g,{overwrite:!1,...f})}catch(v){return Xt._handleError(v)}},async copy(h,g,f){try{return await w._proxy.$copy(h,g,{overwrite:!1,...f})}catch(v){return Xt._handleError(v)}},isWritableFileSystem(h){const g=y.getCapabilities(h);if(typeof g=="number")return!(g&2048)}})}static _handleError(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,y){return this._fileSystemProvider.set(E,y),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(E))}};A=je([$e(0,T.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[251],De([1,0,4,37,2,5,15,7]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(k,E,y,w,h,g,f,v){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter;const m=this.ensureWatching(k,y,h);this._config=0,g&&(this._config+=1),f&&(this._config+=2),v&&(this._config+=4);const r=(0,t.parse)(h),b=typeof h=="string",o=w(u=>{if(!g)for(const s of u.created){const l=I.URI.revive(s);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!f)for(const s of u.changed){const l=I.URI.revive(s);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!v)for(const s of u.deleted){const l=I.URI.revive(s);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=T.Disposable.from(m,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}ensureWatching(k,E,y){const w=T.Disposable.from();if(typeof y=="string")return w;const h=k.getProxy(P.MainContext.MainThreadFileSystem);let g=!1;(y.pattern.includes(t.GLOBSTAR)||y.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const f=Math.random();return h.$watch(E.identifier.value,f,y.baseUri,{recursive:g,excludes:[]}),T.Disposable.from({dispose:()=>h.$unwatch(f)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(k,E,y){this._mainContext=k,this._logService=E,this._extHostDocumentsAndEditors=y,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,E,y,w,h,g){return new S(this._mainContext,k,E,this._onFileSystemEvent.event,C.GlobPattern.from(y),w,h,g)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,E){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(y=>({oldUri:I.URI.revive(y.source),newUri:I.URI.revive(y.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,E){return(y,w,h)=>{const g=function(v){y.call(w,v)};return g.extension=k,E.event(g,void 0,h)}}async $onWillRunFileOperation(k,E,y,w){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(h=>({oldUri:I.URI.revive(h.source),newUri:I.URI.revive(h.target)}))},y,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(h=>I.URI.revive(h.target))},y,w);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(h=>I.URI.revive(h.target))},y,w)}}async _fireWillEvent(k,E,y,w){const h=new Set,g=[];if(await k.fireAsync(E,w,async(v,m)=>{const r=Date.now(),b=await Promise.resolve(v);b instanceof T.WorkspaceEdit&&(g.push([m.extension,b]),h.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-r>y&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),w.isCancellationRequested||g.length===0)return;const f={edits:[]};for(const[,v]of g){const{edits:m}=C.WorkspaceEdit.from(v,{getTextDocumentVersion:r=>this._extHostDocumentsAndEditors.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(m)}return{edit:f,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=D}),define(Ce[252],De([1,0,2,39]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(C,T,S,D,A){this._extHostNotebooks=T,this._textDocumentsAndEditors=S,this._commands=D;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const y=this._extHostNotebooks.getEditorById(E.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(C,T,S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=I}),define(Ce[253],De([1,0,6,5]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(C){this._handlePool=0,this._proxy=C.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,C),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=I}),define(Ce[254],De([1,0,2,24,15,7,65,5,8,35,17,12,146,21,6,118,98,88,51,11,18,27]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentSymbols(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideDocumentSymbols(G,j);if(!(0,A.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(I.DocumentSymbol.from):o._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(N){N=N.slice(0).sort((X,pe)=>{let we=X.location.range.start.compareTo(pe.location.range.start);return we===0&&(we=pe.location.range.end.compareTo(X.location.range.end)),we});const j=[],G=[];for(const X of N){const pe={name:X.name||"!!MISSING: name!!",kind:I.SymbolKind.from(X.kind),tags:X.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:I.Range.from(X.location.range),selectionRange:I.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(pe),j.push(pe);break}const we=G[G.length-1];if(D.Range.containsRange(we.range,pe.range)&&!D.Range.equalsRange(we.range,pe.range)){we.children?.push(pe),G.push(pe);break}G.pop()}}return j}}class u{constructor(N,j,G){this._documents=N,this._commands=j,this._provider=G,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideCodeLenses(G,j);if(!X||j.isCancellationRequested)return;const pe=this._cache.add(X),we=new w.DisposableStore;this._disposables.set(pe,we);const ce={cacheId:pe,lenses:[]};for(let Ie=0;Ie<X.length;Ie++)ce.lenses.push({cacheId:[pe,Ie],range:I.Range.from(X[Ie].range),command:this._commands.toInternal(X[Ie].command,we)});return ce}async resolveCodeLens(N,j){const G=N.cacheId&&this._cache.get(...N.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,j),X||(X=G),j.isCancellationRequested)return;const pe=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!pe)return N.command=this._commands.toInternal(X.command??u._badCmd,pe),N}releaseCodeLenses(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ie){return Array.isArray(ie)?ie.map(I.DefinitionLink.from):ie?[I.DefinitionLink.from(ie)]:[]}class l{constructor(N,j){this._documents=N,this._provider=j}async provideDefinition(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideDefinition(X,pe,G);return s(we)}}class a{constructor(N,j){this._documents=N,this._provider=j}async provideDeclaration(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideDeclaration(X,pe,G);return s(we)}}class d{constructor(N,j){this._documents=N,this._provider=j}async provideImplementation(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideImplementation(X,pe,G);return s(we)}}class n{constructor(N,j){this._documents=N,this._provider=j}async provideTypeDefinition(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideTypeDefinition(X,pe,G);return s(we)}}class i{constructor(N,j){this._documents=N,this._provider=j}async provideHover(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideHover(X,pe,G);if(!(!we||(0,A.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(pe)),we.range||(we.range=new P.Range(pe,pe)),I.Hover.from(we)}}class p{constructor(N,j){this._documents=N,this._provider=j}async provideEvaluatableExpression(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideEvaluatableExpression(X,pe,G);if(we)return I.EvaluatableExpression.from(we)}}class _{constructor(N,j){this._documents=N,this._provider=j}async provideInlineValues(N,j,G,X){const pe=this._documents.getDocument(N),we=await this._provider.provideInlineValues(pe,I.Range.to(j),I.InlineValueContext.to(G),X);if(Array.isArray(we))return we.map(ce=>I.InlineValue.from(ce))}}class R{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentHighlights(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideDocumentHighlights(X,pe,G);if(Array.isArray(we))return we.map(I.DocumentHighlight.from)}}class M{constructor(N,j){this._documents=N,this._provider=j}async provideLinkedEditingRanges(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.provideLinkedEditingRanges(X,pe,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,A.coalesce)(we.ranges.map(I.Range.from)),wordPattern:we.wordPattern}}}class H{constructor(N,j){this._documents=N,this._provider=j}async provideReferences(N,j,G,X){const pe=this._documents.getDocument(N),we=I.Position.to(j),ce=await this._provider.provideReferences(pe,we,G,X);if(Array.isArray(ce))return ce.map(I.location.from)}}class ${constructor(N,j,G,X,pe,we,ce){this._documents=N,this._commands=j,this._diagnostics=G,this._provider=X,this._logService=pe,this._extension=we,this._apiDeprecation=ce,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(N,j,G,X){const pe=this._documents.getDocument(N),we=E.Selection.isISelection(j)?I.Selection.to(j):I.Range.to(j),ce=[];for(const Ye of this._diagnostics.getDiagnostics(N))if(we.intersection(Ye.range)&&ce.push(Ye)>$._maxCodeActionsPerFile)break;const Ie={diagnostics:ce,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(pe,we,Ie,X);if(!(0,A.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const We=this._cache.add(ye),qe=new w.DisposableStore;this._disposables.set(We,qe);const Ze=[];for(let Ye=0;Ye<ye.length;Ye++){const Ne=ye[Ye];!Ne||($._isCommand(Ne)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Ne.title,command:this._commands.toInternal(Ne,qe)})):(Ie.only&&(Ne.kind?Ie.only.contains(Ne.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${Ne.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[We,Ye],title:Ne.title,command:Ne.command&&this._commands.toInternal(Ne.command,qe),diagnostics:Ne.diagnostics&&Ne.diagnostics.map(I.Diagnostic.from),edit:Ne.edit&&I.WorkspaceEdit.from(Ne.edit,void 0),kind:Ne.kind&&Ne.kind.value,isPreferred:Ne.isPreferred,disabled:Ne.disabled?.reason})))}return{cacheId:We,actions:Ze}}async resolveCodeAction(N,j){const[G,X]=N,pe=this._cache.get(G,X);if(!pe||$._isCommand(pe)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(pe,j)??pe;return we?.edit?I.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}$._maxCodeActionsPerFile=1e3;class L{constructor(N,j,G,X){this._proxy=N,this._documents=j,this._provider=G,this._handle=X}async prepareDocumentPaste(N,j,G,X){if(!this._provider.prepareDocumentPaste)return;const pe=this._documents.getDocument(N),we=j.map(Ie=>I.Range.to(Ie)),ce=I.DataTransfer.toDataTransfer(G,()=>{throw new m.NotImplementedError});return await this._provider.prepareDocumentPaste(pe,we,ce,X),I.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(N,j,G,X,pe){const we=this._documents.getDocument(j),ce=G.map(We=>I.Range.to(We)),Ie=I.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolvePasteFileData(this._handle,N,We)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ie,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?I.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class B{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentFormattingEdits(N,j,G){const X=this._documents.getDocument(N),pe=await this._provider.provideDocumentFormattingEdits(X,j,G);if(Array.isArray(pe))return pe.map(I.TextEdit.from)}}class O{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentRangeFormattingEdits(N,j,G,X){const pe=this._documents.getDocument(N),we=I.Range.to(j),ce=await this._provider.provideDocumentRangeFormattingEdits(pe,we,G,X);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}}class z{constructor(N,j){this._documents=N,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,j,G,X,pe){const we=this._documents.getDocument(N),ce=I.Position.to(j),Ie=await this._provider.provideOnTypeFormattingEdits(we,ce,G,X,pe);if(Array.isArray(Ie))return Ie.map(I.TextEdit.from)}}class U{constructor(N,j){this._provider=N,this._logService=j,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,j){const G=await this._provider.provideWorkspaceSymbols(N,j);if(!(0,A.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),pe={cacheId:X,symbols:[]};for(let we=0;we<G.length;we++){const ce=G[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}pe.symbols.push({...I.WorkspaceSymbol.from(ce),cacheId:[X,we]})}return pe}async resolveWorkspaceSymbol(N,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const G=this._cache.get(...N.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,j);return X&&(0,t.mixin)(N,I.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(N){this._cache.delete(N)}}class F{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,j,G){this._documents=N,this._provider=j,this._logService=G}async provideRenameEdits(N,j,G,X){const pe=this._documents.getDocument(N),we=I.Position.to(j);try{const ce=await this._provider.provideRenameEdits(pe,we,G,X);return ce?I.WorkspaceEdit.from(ce):void 0}catch(ce){const Ie=F._asMessage(ce);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(N,j,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(N),pe=I.Position.to(j);try{const we=await this._provider.prepareRename(X,pe,G);let ce,Ie;if(P.Range.isRange(we)?(ce=we,Ie=X.getText(we)):(0,k.isObject)(we)&&(ce=we.range,Ie=we.placeholder),!ce||!Ie)return;if(ce.start.line>pe.line||ce.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ce),text:Ie}}catch(we){const ce=F._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class V{constructor(N,j){this.resultId=N,this.tokens=j}}class x{constructor(N,j){this._documents=N,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(N,j,G){const X=this._documents.getDocument(N),pe=j!==0?this._previousResults.get(j):null;let we=typeof pe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,pe.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return pe&&this._previousResults.delete(j),we?(we=x._fixProvidedSemanticTokens(we),this._send(x._convertToEdits(pe,we),we)):null}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return x._isSemanticTokens(N)?x._isCorrectSemanticTokens(N)?N:new P.SemanticTokens(new Uint32Array(N.data),N.resultId):x._isSemanticTokensEdits(N)?x._isCorrectSemanticTokensEdits(N)?N:new P.SemanticTokensEdits(N.edits.map(j=>new P.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const j of N.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,j){if(!x._isSemanticTokens(j)||!N||!N.tokens)return j;const G=N.tokens,X=G.length,pe=j.data,we=pe.length;let ce=0;const Ie=Math.min(X,we);for(;ce<Ie&&G[ce]===pe[ce];)ce++;if(ce===X&&ce===we)return new P.SemanticTokensEdits([],j.resultId);let ye=0;const We=Ie-ce;for(;ye<We&&G[X-ye-1]===pe[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:X-ce-ye,data:pe.subarray(ce,we-ye)}],j.resultId)}_send(N,j){if(x._isSemanticTokens(N)){const G=this._nextResultId++;return this._previousResults.set(G,new V(N.resultId,N.data)),(0,h.encodeSemanticTokensDto)({id:G,type:"full",data:N.data})}if(x._isSemanticTokensEdits(N)){const G=this._nextResultId++;return x._isSemanticTokens(j)?this._previousResults.set(G,new V(j.resultId,j.data)):this._previousResults.set(G,new V(N.resultId)),(0,h.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(N.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class Q{constructor(N,j){this._documents=N,this._provider=j}async provideDocumentRangeSemanticTokens(N,j,G){const X=this._documents.getDocument(N),pe=await this._provider.provideDocumentRangeSemanticTokens(X,I.Range.to(j),G);return pe?this._send(pe):null}_send(N){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=Q;class K{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,j,G,X,pe){this._documents=N,this._commands=j,this._provider=G,this._apiDeprecation=X,this._extension=pe,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(N,j,G,X){const pe=this._documents.getDocument(N),we=I.Position.to(j),ce=pe.getWordRangeAtPosition(we)||new P.Range(we,we),Ie=ce.with({end:we}),ye=new v.StopWatch(!0),We=await this._provider.provideCompletionItems(pe,we,X,I.CompletionContext.to(G));if(!We||X.isCancellationRequested)return;const qe=Array.isArray(We)?new P.CompletionList(We):We,Ze=K.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),Ye=new w.DisposableStore;this._disposables.set(Ze,Ye);const Ne=[],at={x:Ze,b:Ne,a:{replace:I.Range.from(ce),insert:I.Range.from(Ie)},c:qe.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<qe.items.length;re++){const se=qe.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ie,ce);Ne.push(Ee)}return at}async resolveCompletionItem(N,j){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...N);if(!G)return;const X=await this._provider.resolveCompletionItem(G,j);if(!!X)return this._convertCompletionItem(X,N)}releaseCompletionItems(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,j,G,X){const pe=this._disposables.get(j[0]);if(!pe)throw Error("DisposableStore is missing...");const we={x:j,a:N.label,b:N.kind!==void 0?I.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(I.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:I.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(N.command,pe)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=N.textEdit.newText):typeof N.insertText=="string"?we.h=N.insertText:N.insertText instanceof P.SnippetString&&(we.h=N.insertText.value,we.i|=4);let ce;return N.textEdit?ce=N.textEdit.range:N.range&&(ce=N.range),P.Range.isRange(ce)?we.j=I.Range.from(ce):ce&&(!G?.isEqual(ce.inserting)||!X?.isEqual(ce.replacing))&&(we.j={insert:I.Range.from(ce.inserting),replace:I.Range.from(ce.replacing)}),we}}class ue{async provideInlineCompletions(N,j,G,X){}disposeCompletions(N){}handleDidShowCompletionItem(N,j){}}class te extends ue{constructor(N,j,G,X){super(),this._extension=N,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this._isAdditionsProposedApiEnabled=(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,j,G,X){const pe=this._documents.getDocument(N),we=I.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ie=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ie}),items:Ie.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new w.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?I.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new w.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(N){this._references.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,j){const G=this._references.get(N)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class he extends ue{constructor(N,j,G,X){super(),this.extension=N,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this.isAdditionProposedApiEnabled=(0,b.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[C.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(N,j,G,X){const pe=this._documents.getDocument(N),we=I.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ie=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ie}),items:Ie.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new w.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?I.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new w.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(N){this._references.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,j){const G=this._references.get(N)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class Y{constructor(){this._references=new Map,this._idPool=1}createReferenceId(N){const j=this._idPool++;return this._references.set(j,N),j}disposeReferenceId(N){const j=this._references.get(N);return this._references.delete(N),j}get(N){return this._references.get(N)}}class fe{constructor(N,j){this._documents=N,this._provider=j,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,j,G,X){const pe=this._documents.getDocument(N),we=I.Position.to(j),ce=this.reviveContext(G),Ie=await this._provider.provideSignatureHelp(pe,we,X,ce);if(Ie){const ye=this._cache.add([Ie]);return{...I.SignatureHelp.from(Ie),id:ye}}}reviveContext(N){let j;if(N.activeSignatureHelp){const G=I.SignatureHelp.to(N.activeSignatureHelp),X=this._cache.get(N.activeSignatureHelp.id,0);X?(j=X,j.activeSignature=G.activeSignature,j.activeParameter=G.activeParameter):j=G}return{...N,activeSignatureHelp:j}}releaseSignatureHelp(N){this._cache.delete(N)}}class be{constructor(N,j,G,X,pe){this._documents=N,this._commands=j,this._provider=G,this._logService=X,this._extension=pe,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(N,j,G){const X=this._documents.getDocument(N),pe=I.Range.to(j),we=await this._provider.provideInlayHints(X,pe,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${j}`);return}if(G.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new w.DisposableStore);const Ie={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],pe)&&Ie.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ie.hints.length} inlay hints from '${this._extension.identifier.value}' for ${j}`),Ie}async resolveInlayHint(N,j){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...N);if(!G)return;const X=await this._provider.resolveInlayHint(G,j);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,N)}releaseHints(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_isValidInlayHint(N,j){return N.label.length===0||Array.isArray(N.label)&&N.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(j&&!j.contains(N.position))}_convertInlayHint(N,j){const G=this._disposables.get(j[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:j,tooltip:I.MarkdownString.fromStrict(N.tooltip),position:I.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(I.TextEdit.from),kind:N.kind&&I.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?X.label=N.label:X.label=N.label.map(pe=>{const we={label:pe.value};return we.tooltip=I.MarkdownString.fromStrict(pe.tooltip),P.Location.isLocation(pe.location)&&(we.location=I.location.from(pe.location)),pe.command&&(we.command=this._commands.toInternal(pe.command,G)),we}),X}}class ke{constructor(N,j){this._documents=N,this._provider=j,this._cache=new f.Cache("DocumentLink")}async provideLinks(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideDocumentLinks(G,j);if(!(!Array.isArray(X)||X.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(I.DocumentLink.from)};{const pe=this._cache.add(X),we={links:[],cacheId:pe};for(let ce=0;ce<X.length;ce++){if(!ke._validateLink(X[ce]))continue;const Ie=I.DocumentLink.from(X[ce]);Ie.cacheId=[pe,ce],we.links.push(Ie)}return we}}}static _validateLink(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,j){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...N);if(!G)return;const X=await this._provider.resolveDocumentLink(G,j);if(!(!X||!ke._validateLink(X)))return I.DocumentLink.from(X)}releaseLinks(N){this._cache.delete(N)}}class Re{constructor(N,j){this._documents=N,this._provider=j}async provideColors(N,j){const G=this._documents.getDocument(N),X=await this._provider.provideDocumentColors(G,j);return Array.isArray(X)?X.map(we=>({color:I.Color.from(we.color),range:I.Range.from(we.range)})):[]}async provideColorPresentations(N,j,G){const X=this._documents.getDocument(N),pe=I.Range.to(j.range),we=I.Color.to(j.color),ce=await this._provider.provideColorPresentations(we,{document:X,range:pe},G);if(!!Array.isArray(ce))return ce.map(I.ColorPresentation.from)}}class ze{constructor(N,j){this._documents=N,this._provider=j}async provideFoldingRanges(N,j,G){const X=this._documents.getDocument(N),pe=await this._provider.provideFoldingRanges(X,j,G);if(!!Array.isArray(pe))return pe.map(I.FoldingRange.from)}}class oe{constructor(N,j,G){this._documents=N,this._provider=j,this._logService=G}async provideSelectionRanges(N,j,G){const X=this._documents.getDocument(N),pe=j.map(I.Position.to),we=await this._provider.provideSelectionRanges(X,pe,G);if(!(0,A.isNonEmptyArray)(we))return[];if(we.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ie=0;Ie<pe.length;Ie++){const ye=[];ce.push(ye);let We=pe[Ie],qe=we[Ie];for(;;){if(!qe.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(I.SelectionRange.from(qe)),!qe.parent)break;We=qe.range,qe=qe.parent}}return ce}}class le{constructor(N,j){this._documents=N,this._provider=j,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.prepareCallHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ie=>this._cacheAndConvertItem(ce,Ie)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!pe)return pe.map(we=>({from:this._cacheAndConvertItem(N,we.from),fromRanges:we.fromRanges.map(ce=>I.Range.from(ce))}))}async provideCallsFrom(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!pe)return pe.map(we=>({to:this._cacheAndConvertItem(N,we.to),fromRanges:we.fromRanges.map(ce=>I.Range.from(ce))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,j){const G=this._cache.get(N),X=I.CallHierarchyItem.from(j,N,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(N,j){return this._cache.get(N)?.get(j)}}class ge{constructor(N,j){this._documents=N,this._provider=j,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(N,j,G){const X=this._documents.getDocument(N),pe=I.Position.to(j),we=await this._provider.prepareTypeHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ie=>this._cacheAndConvertItem(ce,Ie)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(N,we))}async provideSubtypes(N,j,G){const X=this._itemFromCache(N,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(N,we))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,j){const G=this._cache.get(N),X=I.TypeHierarchyItem.from(j,N,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(N,j){return this._cache.get(N)?.get(j)}}class Z{constructor(N,j,G,X){this._proxy=N,this._documents=j,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(N,j,G,X,pe){const we=this._documents.getDocument(j),ce=I.Position.to(G),Ie=I.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,N,We)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ie,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?I.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ae{constructor(N,j){this.adapter=N,this.extension=j}}class ne{constructor(N,j,G,X,pe,we,ce,Ie){this._uriTransformer=j,this._documents=G,this._commands=X,this._diagnostics=pe,this._logService=we,this._apiDeprecation=ce,this._extensionTelemetry=Ie,this._adapter=new Map,this._proxy=N.getProxy(T.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(N){return I.DocumentSelector.from(N,this._uriTransformer)}_createDisposable(N){return new P.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return ne._handlePool++}async _withAdapter(N,j,G,X,pe,we=!1){const ce=this._adapter.get(N);if(!ce||!(ce.adapter instanceof j))return X;const Ie=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(ce.adapter,ce.extension);return Promise.resolve(ye).catch(We=>{(0,m.isCancellationError)(We)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(We),this._extensionTelemetry.onExtensionError(ce.extension.identifier,We))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),y.CancellationToken.isCancellationToken(pe)?(0,r.raceCancellationError)(ye,pe):ye}_addNewAdapter(N,j){const G=this._nextHandle();return this._adapter.set(G,new ae(N,j)),G}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,j,G,X){const pe=this._addNewAdapter(new o(this._documents,G),N),we=X&&X.label||ne._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(j),we),this._createDisposable(pe)}$provideDocumentSymbols(N,j,G){return this._withAdapter(N,o,X=>X.provideDocumentSymbols(c.URI.revive(j),G),void 0,G)}registerCodeLensProvider(N,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new u(this._documents,this._commands.converter,G),N)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeCodeLenses(Ie=>this._proxy.$emitCodeLensEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(N,j,G){return this._withAdapter(N,u,X=>X.provideCodeLenses(c.URI.revive(j),G),void 0,G)}$resolveCodeLens(N,j,G){return this._withAdapter(N,u,X=>X.resolveCodeLens(j,G),void 0,void 0)}$releaseCodeLenses(N,j){this._withAdapter(N,u,G=>Promise.resolve(G.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(N,j,G){const X=this._addNewAdapter(new l(this._documents,G),N);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDefinition(N,j,G,X){return this._withAdapter(N,l,pe=>pe.provideDefinition(c.URI.revive(j),G,X),[],X)}registerDeclarationProvider(N,j,G){const X=this._addNewAdapter(new a(this._documents,G),N);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDeclaration(N,j,G,X){return this._withAdapter(N,a,pe=>pe.provideDeclaration(c.URI.revive(j),G,X),[],X)}registerImplementationProvider(N,j,G){const X=this._addNewAdapter(new d(this._documents,G),N);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideImplementation(N,j,G,X){return this._withAdapter(N,d,pe=>pe.provideImplementation(c.URI.revive(j),G,X),[],X)}registerTypeDefinitionProvider(N,j,G){const X=this._addNewAdapter(new n(this._documents,G),N);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideTypeDefinition(N,j,G,X){return this._withAdapter(N,n,pe=>pe.provideTypeDefinition(c.URI.revive(j),G,X),[],X)}registerHoverProvider(N,j,G,X){const pe=this._addNewAdapter(new i(this._documents,G),N);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideHover(N,j,G,X){return this._withAdapter(N,i,pe=>pe.provideHover(c.URI.revive(j),G,X),void 0,X)}registerEvaluatableExpressionProvider(N,j,G,X){const pe=this._addNewAdapter(new p(this._documents,G),N);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideEvaluatableExpression(N,j,G,X){return this._withAdapter(N,p,pe=>pe.provideEvaluatableExpression(c.URI.revive(j),G,X),void 0,X)}registerInlineValuesProvider(N,j,G,X){const pe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new _(this._documents,G),N);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(j),pe);let ce=this._createDisposable(we);if(pe!==void 0){const Ie=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(pe));ce=P.Disposable.from(ce,Ie)}return ce}$provideInlineValues(N,j,G,X,pe){return this._withAdapter(N,_,we=>we.provideInlineValues(c.URI.revive(j),G,X,pe),void 0,pe)}registerDocumentHighlightProvider(N,j,G){const X=this._addNewAdapter(new R(this._documents,G),N);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentHighlights(N,j,G,X){return this._withAdapter(N,R,pe=>pe.provideDocumentHighlights(c.URI.revive(j),G,X),void 0,X)}registerLinkedEditingRangeProvider(N,j,G){const X=this._addNewAdapter(new M(this._documents,G),N);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideLinkedEditingRanges(N,j,G,X){return this._withAdapter(N,M,async pe=>{const we=await pe.provideLinkedEditingRanges(c.URI.revive(j),G,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ne._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(N,j,G){const X=this._addNewAdapter(new H(this._documents,G),N);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideReferences(N,j,G,X,pe){return this._withAdapter(N,H,we=>we.provideReferences(c.URI.revive(j),G,X,pe),void 0,pe)}registerCodeActionProvider(N,j,G,X){const pe=new w.DisposableStore,we=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,G,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(j),{providedKinds:X?.providedCodeActionKinds?.map(ce=>ce.value),documentation:X?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,pe)}))},ne._extLabel(N),Boolean(G.resolveCodeAction)),pe.add(this._createDisposable(we)),pe}$provideCodeActions(N,j,G,X,pe){return this._withAdapter(N,$,we=>we.provideCodeActions(c.URI.revive(j),G,X,pe),void 0,pe)}$resolveCodeAction(N,j,G){return this._withAdapter(N,$,X=>X.resolveCodeAction(j,G),void 0,void 0)}$releaseCodeActions(N,j){this._withAdapter(N,$,G=>Promise.resolve(G.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(N,j,G){const X=this._addNewAdapter(new B(this._documents,G),N);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(j),N.identifier,N.displayName||N.name),this._createDisposable(X)}$provideDocumentFormattingEdits(N,j,G,X){return this._withAdapter(N,B,pe=>pe.provideDocumentFormattingEdits(c.URI.revive(j),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(N,j,G){const X=this._addNewAdapter(new O(this._documents,G),N);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(j),N.identifier,N.displayName||N.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(N,j,G,X,pe){return this._withAdapter(N,O,we=>we.provideDocumentRangeFormattingEdits(c.URI.revive(j),G,X,pe),void 0,pe)}registerOnTypeFormattingEditProvider(N,j,G,X){const pe=this._addNewAdapter(new z(this._documents,G),N);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(j),X,N.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(N,j,G,X,pe,we){return this._withAdapter(N,z,ce=>ce.provideOnTypeFormattingEdits(c.URI.revive(j),G,X,pe,we),void 0,we)}registerWorkspaceSymbolProvider(N,j){const G=this._addNewAdapter(new U(j,this._logService),N);return this._proxy.$registerNavigateTypeSupport(G,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(N,j,G){return this._withAdapter(N,U,X=>X.provideWorkspaceSymbols(j,G),{symbols:[]},G)}$resolveWorkspaceSymbol(N,j,G){return this._withAdapter(N,U,X=>X.resolveWorkspaceSymbol(j,G),void 0,void 0)}$releaseWorkspaceSymbols(N,j){this._withAdapter(N,U,G=>G.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(N,j,G){const X=this._addNewAdapter(new F(this._documents,G,this._logService),N);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(j),F.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(N,j,G,X,pe){return this._withAdapter(N,F,we=>we.provideRenameEdits(c.URI.revive(j),G,X,pe),void 0,pe)}$resolveRenameLocation(N,j,G,X){return this._withAdapter(N,F,pe=>pe.resolveRenameLocation(c.URI.revive(j),G,X),void 0,X)}registerDocumentSemanticTokensProvider(N,j,G,X){const pe=this._addNewAdapter(new x(this._documents,G),N),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(j),X,we);let ce=this._createDisposable(pe);if(we){const Ie=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ie)}return ce}$provideDocumentSemanticTokens(N,j,G,X){return this._withAdapter(N,x,pe=>pe.provideDocumentSemanticTokens(c.URI.revive(j),G,X),null,X)}$releaseDocumentSemanticTokens(N,j){this._withAdapter(N,x,G=>G.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,j,G,X){const pe=this._addNewAdapter(new Q(this._documents,G),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(j),X),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(N,j,G,X){return this._withAdapter(N,Q,pe=>pe.provideDocumentRangeSemanticTokens(c.URI.revive(j),G,X),null,X)}registerCompletionItemProvider(N,j,G,X){const pe=this._addNewAdapter(new K(this._documents,this._commands.converter,G,this._apiDeprecation,N),N);return this._proxy.$registerCompletionsProvider(pe,this._transformDocumentSelector(j),X,K.supportsResolving(G),`${N.identifier.value}(${X.join("")})`),this._createDisposable(pe)}$provideCompletionItems(N,j,G,X,pe){return this._withAdapter(N,K,we=>we.provideCompletionItems(c.URI.revive(j),G,X,pe),void 0,pe)}$resolveCompletionItem(N,j,G){return this._withAdapter(N,K,X=>X.resolveCompletionItem(j,G),void 0,G)}$releaseCompletionItems(N,j){this._withAdapter(N,K,G=>G.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(N,j,G){const X=new te(N,this._documents,G,this._commands.converter),pe=this._addNewAdapter(X,N);return this._proxy.$registerInlineCompletionsSupport(pe,this._transformDocumentSelector(j),X.supportsHandleDidShowCompletionItem),this._createDisposable(pe)}registerInlineCompletionsProviderNew(N,j,G){const X=this._addNewAdapter(new he(N,this._documents,G,this._commands.converter),N);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(j),!0),this._createDisposable(X)}$provideInlineCompletions(N,j,G,X,pe){return this._withAdapter(N,ue,we=>we.provideInlineCompletions(c.URI.revive(j),G,X,pe),void 0,pe)}$handleInlineCompletionDidShow(N,j,G){this._withAdapter(N,ue,async X=>{X.handleDidShowCompletionItem(j,G)},void 0,void 0)}$freeInlineCompletionsList(N,j){this._withAdapter(N,ue,async G=>{G.disposeCompletions(j)},void 0,void 0)}registerSignatureHelpProvider(N,j,G,X){const pe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new fe(this._documents,G),N);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(j),pe),this._createDisposable(we)}$provideSignatureHelp(N,j,G,X,pe){return this._withAdapter(N,fe,we=>we.provideSignatureHelp(c.URI.revive(j),G,X,pe),void 0,pe)}$releaseSignatureHelp(N,j){this._withAdapter(N,fe,G=>G.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(N,j,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new be(this._documents,this._commands.converter,G,this._logService,N),N);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(j),typeof G.resolveInlayHint=="function",X,ne._extLabel(N));let we=this._createDisposable(pe);if(X!==void 0){const ce=G.onDidChangeInlayHints(Ie=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(N,j,G,X){return this._withAdapter(N,be,pe=>pe.provideInlayHints(c.URI.revive(j),G,X),void 0,X)}$resolveInlayHint(N,j,G){return this._withAdapter(N,be,X=>X.resolveInlayHint(j,G),void 0,G)}$releaseInlayHints(N,j){this._withAdapter(N,be,G=>G.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(N,j,G){const X=this._addNewAdapter(new ke(this._documents,G),N);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(j),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(N,j,G){return this._withAdapter(N,ke,X=>X.provideLinks(c.URI.revive(j),G),void 0,G,j.scheme==="output")}$resolveDocumentLink(N,j,G){return this._withAdapter(N,ke,X=>X.resolveLink(j,G),void 0,void 0,!0)}$releaseDocumentLinks(N,j){this._withAdapter(N,ke,G=>G.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(N,j,G){const X=this._addNewAdapter(new Re(this._documents,G),N);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentColors(N,j,G){return this._withAdapter(N,Re,X=>X.provideColors(c.URI.revive(j),G),[],G)}$provideColorPresentations(N,j,G,X){return this._withAdapter(N,Re,pe=>pe.provideColorPresentations(c.URI.revive(j),G,X),void 0,X)}registerFoldingRangeProvider(N,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new ze(this._documents,G),N)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(N,j,G,X){return this._withAdapter(N,ze,pe=>pe.provideFoldingRanges(c.URI.revive(j),G,X),void 0,X)}registerSelectionRangeProvider(N,j,G){const X=this._addNewAdapter(new oe(this._documents,G,this._logService),N);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideSelectionRanges(N,j,G,X){return this._withAdapter(N,oe,pe=>pe.provideSelectionRanges(c.URI.revive(j),G,X),[],X)}registerCallHierarchyProvider(N,j,G){const X=this._addNewAdapter(new le(this._documents,G),N);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareCallHierarchy(N,j,G,X){return this._withAdapter(N,le,pe=>Promise.resolve(pe.prepareSession(c.URI.revive(j),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(N,j,G,X){return this._withAdapter(N,le,pe=>pe.provideCallsTo(j,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(N,j,G,X){return this._withAdapter(N,le,pe=>pe.provideCallsFrom(j,G,X),void 0,X)}$releaseCallHierarchy(N,j){this._withAdapter(N,le,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(N,j,G){const X=this._addNewAdapter(new ge(this._documents,G),N);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareTypeHierarchy(N,j,G,X){return this._withAdapter(N,ge,pe=>Promise.resolve(pe.prepareSession(c.URI.revive(j),G,X)),void 0,X)}$provideTypeHierarchySupertypes(N,j,G,X){return this._withAdapter(N,ge,pe=>pe.provideSupertypes(j,G,X),void 0,X)}$provideTypeHierarchySubtypes(N,j,G,X){return this._withAdapter(N,ge,pe=>pe.provideSubtypes(j,G,X),void 0,X)}$releaseTypeHierarchy(N,j){this._withAdapter(N,ge,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(N,j,G){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,G,X),N)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentOnDropEdits(N,j,G,X,pe,we){return this._withAdapter(N,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(j,c.URI.revive(G),X,pe,we)),void 0,void 0)}registerDocumentPasteEditProvider(N,j,G,X){const pe=this._nextHandle();return this._adapter.set(pe,new ae(new L(this._proxy,this._documents,G,pe),N)),this._proxy.$registerPasteEditProvider(pe,this._transformDocumentSelector(j),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(pe)}$prepareDocumentPaste(N,j,G,X,pe){return this._withAdapter(N,L,we=>we.prepareDocumentPaste(c.URI.revive(j),G,X,pe),void 0,pe)}$providePasteEdits(N,j,G,X,pe,we){return this._withAdapter(N,L,ce=>ce.providePasteEdits(j,c.URI.revive(G),X,pe,we),void 0,we)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,S.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:ne._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ne._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ne._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:ne._serializeRegExp(N.beforeText),afterText:N.afterText?ne._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?ne._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(ne._serializeOnEnterRule)}setLanguageConfiguration(N,j,G){const{wordPattern:X}=G;if(X&&(0,S.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(j,X):this._documents.setWordDefinitionFor(j,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const pe=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ne._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ne._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ne._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,j,we),this._createDisposable(pe)}$setWordDefinitions(N){for(const j of N)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(Ce[255],De([1,0,5,15,7,42,18,6]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(A,k,E,y){this._documents=k,this._commands=E,this._uriTransformer=y,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,k){await this._proxy.$changeLanguage(A,k);const E=this._documents.getDocumentData(A);if(!E)throw new Error(`document '${A.toString()}' NOT found`);return E.document}async tokenAtPosition(A,k){const E=A.version,y=t.Position.from(k),w=await this._proxy.$tokensAtPosition(A.uri,y),h={type:I.StandardTokenType.Other,range:A.getWordRangeAtPosition(k)??new I.Range(k.line,k.character,k.line,k.character)};if(!w)return h;const g={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!g.range.contains(k)||E!==A.version?h:g}createLanguageStatusItem(A,k,E){const y=this._handlePool++,w=this._proxy,h=this._ids,g=`${A.identifier.value}/${k}`;if(h.has(g))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);h.add(g);const f={selector:E,id:k,name:A.displayName??A.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const m=new T.DisposableStore,r=()=>{v?.dispose(),v=(0,C.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(y,{id:g,name:f.name??A.displayName??A.name,source:A.displayName??A.name,selector:t.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===I.LanguageStatusSeverity.Error?P.default.Error:f.severity===I.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:f.command&&this._commands.toInternal(f.command,m),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},b={dispose(){m.dispose(),v?.dispose(),w.$removeLanguageStatus(y),h.delete(g)},get id(){return f.id},get name(){return f.name},set name(o){f.name=o,r()},get selector(){return f.selector},set selector(o){f.selector=o,r()},get text(){return f.text},set text(o){f.text=o,r()},get detail(){return f.detail},set detail(o){f.detail=o,r()},get severity(){return f.severity},set severity(o){f.severity=o,r()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(o){f.accessibilityInformation=o,r()},get command(){return f.command},set command(o){f.command=o,r()},get busy(){return f.busy},set busy(o){f.busy=o,r()}};return r(),b}}e.ExtHostLanguages=S}),define(Ce[94],De([1,0,10,8,2,3,13,5,25,16]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(E,y,w){this.logService=w,this.bundleCache=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadLocalization),this.currentLanguage=E.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===c.LANGUAGE_DEFAULT}getMessage(E,y){const{message:w,args:h,comment:g}=y;if(this.isDefaultLanguage)return(0,t.format2)(w,h??{});let f=w;g&&g.length>0&&(f+=`/${Array.isArray(g)?g.join():g}`);const v=this.bundleCache.get(E)?.contents[f];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(v??f,h??{})}getBundle(E){return this.bundleCache.get(E)?.contents}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(this.isDefaultLanguage||!E.l10n&&!E.isBuiltin||this.bundleCache.has(E.identifier.value))return;let y;const w=await this.getBundleLocation(E);if(!w){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const h=await this._proxy.$fetchBundleContents(w),g=JSON.parse(h);y=E.isBuiltin?g.contents?.bundle:g}catch(h){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${w}: ${h.message}`);return}y&&this.bundleCache.set(E.identifier.value,{contents:y,uri:w})}async getBundleLocation(E){if(E.isBuiltin){const y=await this._proxy.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(y)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};A=je([$e(0,S.IExtHostInitDataService),$e(1,D.IExtHostRpcService),$e(2,C.ILogService)],A),e.ExtHostLocalizationService=A,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(Ce[138],De([1,0,13,5,25,16,2,4,12]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends c.AbstractLoggerService{constructor(E,y){super(y.logLevel,T.Event.None),this._proxy=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,y){y?this.setLevel(C.URI.revive(y),E):(0,S.isUndefined)(E)||this.setLevel(E)}doCreateLogger(E,y,w){return new A(this._proxy,E,y,w)}};D=je([$e(0,P.IExtHostRpcService),$e(1,I.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class A extends c.AbstractMessageLogger{constructor(E,y,w,h){super(h?.always),this.proxy=E,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.proxy.$createLogger(y,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,y){const w=[[E,y]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(E){this.proxy.$log(this.file,E)}}}),define(Ce[256],De([1,0,5,13,27]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(T){return T&&T.title}let C=class{constructor(S,D){this._logService=D,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,D,A,k,E){const y={source:{identifier:S.identifier,label:S.displayName||S.name}};let w;typeof k=="string"||P(k)?w=[k,...E]:(y.modal=k?.modal,y.useCustom=k?.useCustom,y.detail=k?.detail,w=E),y.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const h=[];for(let g=0;g<w.length;g++){const f=w[g];if(typeof f=="string")h.push({title:f,handle:g,isCloseAffordance:!1});else if(typeof f=="object"){const{title:v,isCloseAffordance:m}=f;h.push({title:v,isCloseAffordance:!!m,handle:g})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(D,A,y,h).then(g=>{if(typeof g=="number")return w[g]})}};C=je([$e(1,t.ILogService)],C),e.ExtHostMessageService=C}),define(Ce[257],De([1,0,23,4,6,28,8,12,2,88,5,39,15,7,56,232,134]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}constructor(m,r,b,o){this._textDocumentsAndEditors=b,this._textDocuments=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=m.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const s=u.notebookEditor?.notebookUri,l=u.cell.handle,d=this._documents.get(s)?.getCell(l);if(d)return d.apiCell}if(u&&u.$mid===13){const s=u.uri,l=this._documents.get(s);if(l)return l.apiNotebook}return u}}),f._registerApiCommands(r)}getEditorById(m){const r=this._editors.get(m);if(!r)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(m){for(const[r,b]of this._editors)if(b.apiEditor===m)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,r){const b=this._documents.get(m);if(!b&&!r)throw new Error(`NO notebook document for '${m}'`);return b}_getProviderData(m){const r=this._notebookContentProviders.get(m);if(!r)throw new Error(`NO provider for '${m}'`);return r}registerNotebookContentProvider(m,r,b,o,u){if((0,C.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);return this._notebookContentProviders.set(r,{extension:m,provider:b}),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},r,E.NotebookDocumentContentOptions.from(o),f._convertNotebookRegistrationData(m,u)),new y.Disposable(()=>{this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(m,r){if(!r)return;const b=r.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(r.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:r.displayName,filenamePattern:b,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,r,b){const o=f._notebookStatusBarItemProviderHandlePool++,u=typeof b.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,u,r);let s;return u!==void 0&&(s=b.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(u))),new y.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,u),s?.dispose()})}async createNotebookDocument(m){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&E.NotebookData.from(m.content)});return S.URI.revive(r)}async openNotebookDocument(m){const r=this._documents.get(m);if(r)return r.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenNotebook(m),o=this._documents.get(S.URI.revive(b));return(0,T.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(m,r){S.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let b;typeof r=="object"?b={position:E.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(E.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:b={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,b),u=o&&this._editors.get(o)?.apiEditor;if(u)return u;throw o?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,r,b,o){const u=this._notebookStatusBarItemProviders.get(m),s=S.URI.revive(r),l=this._documents.get(s);if(!l||!u)return;const a=l.getCellFromIndex(b);if(!a)return;const d=await u.provideCellStatusBarItems(a.apiCell,o);if(!d)return;const n=new I.DisposableStore,i=this._statusBarCache.add([n]),_=(Array.isArray(d)?d:[d]).map(R=>E.NotebookStatusBarItem.from(R,this._commandsConverter,n));return{cacheId:i,items:_}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,r,b,o,u){if((0,C.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,b),this._notebookProxy.$registerNotebookSerializer(s,{id:m.identifier,location:m.extensionLocation},r,E.NotebookDocumentContentOptions.from(o),f._convertNotebookRegistrationData(m,u)),(0,I.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(m,r,b){const o=this._notebookSerializer.get(m);if(!o)throw new Error("NO serializer found");const u=await o.deserializeNotebook(r.buffer,b);return new w.SerializableObjectWithBuffers(E.NotebookData.from(u))}async $notebookToData(m,r,b){const o=this._notebookSerializer.get(m);if(!o)throw new Error("NO serializer found");const u=await o.serializeNotebook(E.NotebookData.to(r.value),b);return c.VSBuffer.wrap(u)}async $openNotebook(m,r,b,o,u){const{provider:s}=this._getProviderData(m),l=await s.openNotebook(S.URI.revive(r),{backupId:b,untitledDocumentData:o?.buffer},u);return new w.SerializableObjectWithBuffers({metadata:l.metadata??Object.create(null),cells:l.cells.map(E.NotebookCellData.from)})}_createExtHostEditor(m,r,b){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const o=new g.ExtHostNotebookEditor(r,this._notebookEditorsProxy,m,b.visibleRanges.map(E.NotebookRange.to),b.selections.map(E.NotebookRange.to),typeof b.viewColumn=="number"?E.ViewColumn.to(b.viewColumn):void 0);this._editors.set(r,o)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const b of m.value.removedDocuments){const o=S.URI.revive(b),u=this._documents.get(o);u&&(u.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===o.toString()&&this._editors.delete(s.id)}if(m.value.addedDocuments){const b=[];for(const o of m.value.addedDocuments){const u=S.URI.revive(o.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const s=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,o);b.push(...o.cells.map(l=>h.ExtHostCell.asModelAddData(s.apiNotebook,l))),this._documents.get(u)?.dispose(),this._documents.set(u,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(m.value.addedEditors)for(const b of m.value.addedEditors){if(this._editors.has(b.id))return;const o=S.URI.revive(b.documentUri),u=this._documents.get(o);u&&this._createExtHostEditor(u,b.id,b)}const r=[];if(m.value.removedEditors)for(const b of m.value.removedEditors){const o=this._editors.get(b);o&&(this._editors.delete(b),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),r.push(o))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const b=new Set;this._visibleNotebookEditors.forEach(o=>b.add(o.id));for(const o of this._editors.values()){const u=b.has(o.id);o._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(m){const r=k.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[r,new k.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>c.VSBuffer.wrap(u))],new k.ApiCommandResult("Notebook Data",u=>E.NotebookData.to(u.value))),o=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[r,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new w.SerializableObjectWithBuffers(E.NotebookData.from(u)))],new k.ApiCommandResult("Bytes",u=>u.buffer));m.registerApiCommand(b),m.registerApiCommand(o)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(Ce[258],De([1,0,17,18,21,4,6,28,2,26,13,5,39,15,7,89,220,27,56]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let m=class{constructor(l,a,d,n,i){this._initData=a,this._extHostNotebook=d,this._commands=n,this._logService=i,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=l.getProxy(k.MainContext.MainThreadNotebookKernels);const p=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const R=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:R}}else if(_&&"notebookEditor"in _){const R=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return _})],E.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(l,a,d,n,i,p){for(const K of this._kernelData.values())if(K.controller.id===a&&D.ExtensionIdentifier.equals(l.identifier,K.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const _=this._handlePool++,R=this;this._logService.trace(`NotebookController[${_}], CREATED by ${l.identifier.value}, ${a}`);const M=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${l.identifier}'`);let H=!1;const $=new C.DisposableStore,L=new P.Emitter,B=new P.Emitter,O={id:u(l.identifier,a),notebookType:d,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:n||l.identifier.value,preloads:p?p.map(y.NotebookRendererScript.from):[]};let z=i??M,U;this._proxy.$addKernel(_,O).catch(K=>{console.log(K),H=!0});let F=0;const V=()=>{if(H)return;const K=++F;Promise.resolve().then(()=>{K===F&&this._proxy.$updateKernel(_,O)})},x=new T.ResourceMap,Q={get id(){return a},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return O.label},set label(K){O.label=K??l.displayName??l.name,V()},get detail(){return O.detail??""},set detail(K){O.detail=K,V()},get description(){return O.description??""},set description(K){O.description=K,V()},get kind(){return(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),O.kind??""},set kind(K){(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),O.kind=K,V()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(K){O.supportedLanguages=K,V()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(K){O.supportsExecutionOrder=K,V()},get rendererScripts(){return O.preloads?O.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(K){z=K??M},get interruptHandler(){return U},set interruptHandler(K){U=K,O.supportsInterrupt=Boolean(K),V()},createNotebookCellExecution(K){if(H)throw new Error("notebook controller is DISPOSED");if(!x.has(K.notebook.uri))throw R._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return R._createNotebookCellExecution(K,u(l.identifier,this.id))},dispose:()=>{H||(this._logService.trace(`NotebookController[${_}], DISPOSED`),H=!0,this._kernelData.delete(_),$.dispose(),L.dispose(),B.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(K,ue){ue===w.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),R._proxy.$updateNotebookPriority(_,K.uri,ue)},onDidReceiveMessage:B.event,postMessage(K,ue){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),R._proxy.$postMessage(_,ue&&R._extHostNotebook.getIdByEditor(ue),K)},asWebviewUri(K){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),(0,h.asWebviewUri)(K,R._initData.remote)}};return this._kernelData.set(_,{extensionId:l.identifier,controller:Q,onDidReceiveMessage:B,onDidChangeSelection:L,associatedNotebooks:x}),Q}getIdByController(l){for(const[a,d]of this._kernelData)if(d.controller===l)return u(d.extensionId,l.id);return null}$acceptNotebookAssociation(l,a,d){const n=this._kernelData.get(l);if(n){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));d?n.associatedNotebooks.set(i.uri,!0):n.associatedNotebooks.delete(i.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,i.uri.toString(),d),n.onDidChangeSelection.fire({selected:d,notebook:i.apiNotebook})}}async $executeCells(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a)),p=[];for(const _ of d){const R=i.getCell(_);R&&p.push(R.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,i.uri.toString(),p.length),await n.controller.executeHandler.call(n.controller,p,i.apiNotebook,n.controller)}catch(_){this._logService.error(`NotebookController[${l}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,i.apiNotebook);else for(const p of d){const _=i.getCell(p);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getEditorById(a);n.onDidReceiveMessage.fire(Object.freeze({editor:i.apiEditor,message:d}))}$cellExecutionChanged(l,a,d){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(l)).getCell(a);if(i){const p=d?y.NotebookCellExecutionState.to(d):w.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:i.apiCell,state:p})}}_createNotebookCellExecution(l,a){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const i=new b(a,n,this._proxy);this._activeExecutions.set(n.uri,i);const p=i.onDidChangeState(()=>{i.state===r.Resolved&&(i.dispose(),p.dispose(),this._activeExecutions.delete(n.uri))});return i.asApiObject()}};m=je([$e(4,A.ILogService)],m),e.ExtHostNotebookKernels=m;var r;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(r||(r={}));class b extends C.Disposable{get state(){return this._state}constructor(l,a,d){super(),this._cell=a,this._proxy=d,this._handle=b.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new o(10,n=>this.update(n)),this._executionOrder=a.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,l,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const a=Array.isArray(l)?l:[l];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(a))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let a=this._cell;if(l&&(a=this._cell.notebook.getCellFromApiCell(l)),!a)throw new Error("INVALID cell");return a.handle}validateAndConvertOutputs(l){return l.map(a=>{const d=w.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return d===a.items?y.NotebookCellOutput.from(a):y.NotebookCellOutput.from({items:d,id:a.id,metadata:a.metadata})})}async updateOutputs(l,a,d){const n=this.cellIndexToHandle(a),i=this.validateAndConvertOutputs((0,c.asArray)(l));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,cellHandle:n,append:d,outputs:i})}async updateOutputItems(l,a,d){return l=w.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,items:l.map(y.NotebookCellOutputItem.from),outputId:a.id,append:d})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(d){l._executionOrder=d,l.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:l._executionOrder}])},start(d){if(l._state===r.Resolved||l._state===r.Started)throw new Error("Cannot call start again");l._state=r.Started,l._onDidChangeState.fire(),l.update({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,n){if(l._state===r.Resolved)throw new Error("Cannot call resolve twice");l._state=r.Resolved,l._onDidChangeState.fire(),l._collector.flush(),l._proxy.$completeExecution(l._handle,new v.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:d}))},clearOutput(d){return l.verifyStateForOutput(),l.updateOutputs([],d,!1)},appendOutput(d,n){return l.verifyStateForOutput(),l.updateOutputs(d,n,!0)},replaceOutput(d,n){return l.verifyStateForOutput(),l.updateOutputs(d,n,!1)},appendOutputItems(d,n){return l.verifyStateForOutput(),l.updateOutputItems(d,n,!0)},replaceOutputItems(d,n){return l.verifyStateForOutput(),l.updateOutputItems(d,n,!1)}})}}b.HANDLE=0;class o{constructor(l,a){this.delay=l,this.callback=a,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const a=this.batch;return this.batch=[],this.callback(a).finally(()=>l.complete())}}function u(s,l){return`${s.value}/${l}`}e.createKernelId=u}),define(Ce[259],De([1,0,4,5,134]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(T,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,D){const A=this._extHostNotebook.getEditorById(T);this._rendererMessageEmitters.get(S)?.fire({editor:A.apiEditor,message:D})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(A=>A.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(A,k,E)=>this.getOrCreateEmitterFor(S).event(A,k,E),postMessage:(A,k)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const E=k&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(E?.id,S,A)}}}getOrCreateEmitterFor(T){let S=this._rendererMessageEmitters.get(T);return S||(S=new c.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(T)}}),this._rendererMessageEmitters.set(T,S),S)}}e.ExtHostNotebookRenderers=P}),define(Ce[260],De([1,0,21,4,6,5,2,7,11,17,42,87]),function(J,e,c,t,I,P,C,T,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(y,w,h){const g=y.getProxy(P.MainContext.MainThreadQuickOpen);class f{constructor(a,d){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=d}showQuickPick(a,d,n=c.CancellationToken.None){this._onDidSelectItem=void 0;const i=Promise.resolve(a),p=++this._instances,_=g.$show(p,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},n),R={},M=_.then(()=>R);return Promise.race([M,i]).then(H=>{if(H!==R)return i.then($=>{const L=[];for(let B=0;B<$.length;B++){const O=$[B];typeof O=="string"?L.push({label:O,handle:B}):O.kind===T.QuickPickItemKind.Separator?L.push({type:"separator",label:O.label}):L.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{d.onDidSelectItem($[B])}),g.$setItems(p,L),_.then(B=>{if(typeof B=="number")return $[B];if(Array.isArray(B))return B.map(O=>$[O])})})}).then(void 0,H=>{if(!(0,S.isCancellationError)(H))return g.$setError(p,H),Promise.reject(H)})}$onItemSelected(a){this._onDidSelectItem?.(a)}showInput(a,d=c.CancellationToken.None){return this._validateInput=a?.validateInput,g.$input(a,typeof this._validateInput=="function",d).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(a){if(!this._validateInput)return;const d=await this._validateInput(a);if(!d||typeof d=="string")return d;let n;switch(d.severity){case T.InputBoxValidationSeverity.Info:n=A.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=A.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=A.default.Error;break;default:n=d.message?A.default.Error:A.default.Ignore;break}return{content:d.message,severity:n}}async showWorkspaceFolderPick(a,d=c.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!n)return;const i=await this._workspace.getWorkspaceFolders2();if(!!i)return i.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(a){const d=new u(a,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(a){const d=new s(a,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(a,d){this._sessions.get(a)?._fireDidChangeValue(d)}$onDidAccept(a){this._sessions.get(a)?._fireDidAccept()}$onDidChangeActive(a,d){const n=this._sessions.get(a);n instanceof u&&n._fireDidChangeActive(d)}$onDidChangeSelection(a,d){const n=this._sessions.get(a);n instanceof u&&n._fireDidChangeSelection(d)}$onDidTriggerButton(a,d){this._sessions.get(a)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(a,d,n){const i=this._sessions.get(a);i instanceof u&&i._fireDidTriggerItemButton(d,n)}$onDidHide(a){this._sessions.get(a)?._fireDidHide()}}class v{constructor(a,d){this._extensionId=a,this._onDidDispose=d,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((d,n)=>{const i=d===T.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(i,d)}),this.update({buttons:a.map((d,n)=>({...o(d),tooltip:d.tooltip,handle:d===T.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const d=this._handlesToButtons.get(a);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(a){if(!this._disposed){for(const d of Object.keys(a)){const n=a[d];this._pendingUpdate[d]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function m(l){if(l instanceof T.ThemeIcon)return{id:l.id};const a=b(l),d=r(l);return{dark:typeof a=="string"?C.URI.file(a):a,light:typeof d=="string"?C.URI.file(d):d}}function r(l){return typeof l=="object"&&"light"in l?l.light:l}function b(l){return typeof l=="object"&&"dark"in l?l.dark:l}function o(l){const a=m(l.iconPath);let d,n;return"id"in a?n=k.ThemeIcon.asClassName(a):d=a,{iconPath:d,iconClass:n}}class u extends v{constructor(a,d){super(a.identifier,d),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((n,i)=>{this._handlesToItems.set(i,n),this._itemsToHandles.set(n,i)});const d=[];for(let n=0;n<a.length;n++){const i=a[n];i.kind===T.QuickPickItemKind.Separator?d.push({type:"separator",label:i.label}):d.push({handle:n,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,buttons:i.buttons?.map((p,_)=>({...o(p),tooltip:p.tooltip,handle:_}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(a){const d=(0,D.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(a){const d=(0,D.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(a,d){const n=this._handlesToItems.get(a);if(!n||!n.buttons||!n.buttons.length)return;const i=n.buttons[d];i&&this._onDidTriggerItemButtonEmitter.fire({button:i,item:n})}}class s extends v{constructor(a,d){super(a.identifier,d),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,a?typeof a=="string"?this.update({validationMessage:a,severity:A.default.Error}):this.update({validationMessage:a.message,severity:a.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new f(w,h)}e.createExtHostQuickOpen=E});var Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c};define(Ce[261],De([1,0,2,4,59,6,18,5,17,108,13,26,87,15,27]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w){"use strict";var h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(i){if(i)return typeof i.iconPath=="string"?c.URI.file(i.iconPath):c.URI.isUri(i.iconPath)||E.ThemeIcon.isThemeIcon(i.iconPath)?i.iconPath:void 0}function v(i,p){if(!i.iconPath&&!p.iconPath)return 0;if(i.iconPath){if(!p.iconPath)return 1}else return-1;const _=typeof i.iconPath=="string"?i.iconPath:c.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id,R=typeof p.iconPath=="string"?p.iconPath:c.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,D.comparePaths)(_,R)}function m(i,p){let _=0;if(i.strikeThrough!==p.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==p.faded)return i.faded?1:-1;if(i.tooltip!==p.tooltip)return(i.tooltip||"").localeCompare(p.tooltip||"");if(_=v(i,p),_!==0)return _;if(i.light&&p.light)_=v(i.light,p.light);else{if(i.light)return 1;if(p.light)return-1}if(_!==0)return _;if(i.dark&&p.dark)_=v(i.dark,p.dark);else{if(i.dark)return 1;if(p.dark)return-1}return _}function r(i,p){if(i.command!==p.command)return i.command<p.command?-1:1;if(i.title!==p.title)return i.title<p.title?-1:1;if(i.tooltip!==p.tooltip){if(i.tooltip!==void 0&&p.tooltip!==void 0)return i.tooltip<p.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(i.arguments===p.arguments)return 0;if(i.arguments)if(p.arguments){if(i.arguments.length!==p.arguments.length)return i.arguments.length-p.arguments.length}else return 1;else return-1;for(let _=0;_<i.arguments.length;_++){const R=i.arguments[_],M=p.arguments[_];if(R!==M)return R<M?-1:1}return 0}function b(i,p){let _=(0,D.comparePaths)(i.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(_!==0)return _;if(i.command&&p.command)_=r(i.command,p.command);else{if(i.command)return 1;if(p.command)return-1}if(_!==0)return _;if(i.decorations&&p.decorations)_=m(i.decorations,p.decorations);else{if(i.decorations)return 1;if(p.decorations)return-1}return _}function o(i,p){for(let _=0;_<i.length;_++)if(i[_]!==p[_])return!1;return!0}function u(i,p){return i.command===p.command&&i.title===p.title&&i.tooltip===p.tooltip&&(i.arguments&&p.arguments?o(i.arguments,p.arguments):i.arguments===p.arguments)}function s(i,p){return(0,S.equals)(i,p,u)}class l{get value(){return this._value}set value(p){p=p??"",Be(this,h,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Be(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Be(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Be(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Be(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,_,R){this._extension=p,this._sourceControlHandle=R,h.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,h,_,"f")}showValidationMessage(p,_){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Be(this,h,"f").$showValidationMessage(this._sourceControlHandle,p,_)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=l,h=new WeakMap;class a{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,_,R,M,H){this._proxy=p,this._commands=_,this._sourceControlHandle=R,this._id=M,this._label=H,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,_){const R=this._resourceStatesCommandsMap.get(p);return R?(0,C.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(b),R=(0,S.sortedDiff)(this._resourceSnapshot,p,b).map($=>{const L=$.toInsert.map(B=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,B);const z=B.resourceUri;let U;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const fe=new P.DisposableStore;U=this._commands.converter.toInternal(B.command,fe),this._resourceStatesDisposablesMap.set(O,fe)}else this._resourceStatesCommandsMap.set(O,B.command);const F=f(B.decorations),V=B.decorations&&f(B.decorations.light)||F,x=B.decorations&&f(B.decorations.dark)||F,Q=[V,x],K=B.decorations&&B.decorations.tooltip||"",ue=B.decorations&&!!B.decorations.strikeThrough,te=B.decorations&&!!B.decorations.faded,he=B.contextValue||"";return{rawResource:[O,z,Q,K,ue,te,he,U],handle:O}});return{start:$.start,deleteCount:$.deleteCount,toInsert:L}}),M=R.map(({start:$,deleteCount:L,toInsert:B})=>[$,L,B.map(O=>O.rawResource)]),H=R.reverse();for(const{start:$,deleteCount:L,toInsert:B}of H){const O=B.map(U=>U.handle),z=this._handlesSnapshot.splice($,L,...O);for(const U of z)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=p,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class d{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Be(this,g,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Be(this,g,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Be(this,g,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=p;const _=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Be(this,g,"f").$updateSourceControl(this.handle,{acceptInputCommand:_})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=p;const _=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(R=>R.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Be(this,g,"f").$updateSourceControl(this.handle,{actionButton:_??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&s(this._statusBarCommands,p))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=p;const _=(p||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Be(this,g,"f").$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}constructor(p,_,R,M,H,$){this._extension=p,this._commands=R,this._id=M,this._label=H,this._rootUri=$,g.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=d._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,g,_,"f"),this._inputBox=new l(p,Be(this,g,"f"),this.handle),Be(this,g,"f").$registerSourceControl(this.handle,M,H,$)}createResourceGroup(p,_){const R=new a(Be(this,g,"f"),this._commands,this.handle,p,_),M=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,M),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const p=[],_=[];for(const[R,M]of this.createdResourceGroups){M.dispose();const H=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),H.dispose(),this._groups.delete(R.handle),Be(this,g,"f").$unregisterGroup(this.handle,R.handle)}),p.push([R.handle,R.id,R.label,R.features]);const $=R._takeResourceStateSnapshot();$.length>0&&_.push([R.handle,$]),this._groups.set(R.handle,R)}Be(this,g,"f").$registerGroups(this.handle,p,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(_=>{const R=_._takeResourceStateSnapshot();R.length!==0&&p.push([_.handle,R])}),p.length>0&&Be(this,g,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Be(this,g,"f").$unregisterSourceControl(this.handle)}}g=new WeakMap,d._handlePool=0,je([(0,I.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let n=class ei{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,_,R){this._commands=_,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=p.getProxy(T.MainContext.MainThreadSCM),this._telemetry=p.getProxy(T.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const H=this._sourceControls.get(M.sourceControlHandle);if(!H)return M;const $=H.getResourceGroup(M.groupHandle);return $?$.getResourceState(M.handle):M}else if(M&&M.$mid===4){const H=this._sourceControls.get(M.sourceControlHandle);return H?H.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const H=this._sourceControls.get(M.handle);return H||M}return M}})}createSourceControl(p,_,R,M){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,_,R,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const H=ei._handlePool++,$=new d(p,this._proxy,this._commands,_,R,M);this._sourceControls.set(H,$);const L=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(p.identifier))||[];return L.push($),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(p.identifier),L),$}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const _=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(p.identifier)),R=_&&_[_.length-1];return R&&R.inputBox}$provideOriginalResource(p,_,R){const M=c.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,M.toString());const H=this._sourceControls.get(p);return!H||!H.quickDiffProvider||!H.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>H.quickDiffProvider.provideOriginalResource(M,R)).then($=>$||null)}$onInputBoxValueChange(p,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const R=this._sourceControls.get(p);return R&&R.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(p,_,R,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,_,R);const H=this._sourceControls.get(p);if(!H)return Promise.resolve(void 0);const $=H.getResourceGroup(_);return $?$.$executeResourceCommand(R,M):Promise.resolve(void 0)}$validateInput(p,_,R){this.logService.trace("ExtHostSCM#$validateInput",p);const M=this._sourceControls.get(p);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>M.inputBox.validateInput(_,R)).then(H=>{if(!H)return Promise.resolve(void 0);const $=y.MarkdownString.fromStrict(H.message);return $?Promise.resolve([$,H.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};n._handlePool=0,n=je([$e(2,A.ILogService)],n),e.ExtHostSCM=n}),define(Ce[95],De([1,0,5,4,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(T){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,S){return this._proxy.$getPassword(T,S)}store(T,S,D){return this._proxy.$setPassword(T,S,D)}delete(T,S){return this._proxy.$deletePassword(T,S)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[262],De([1,0,7,5,174,6,15,12]),function(J,e,c,t,I,P,C,T){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(w,h,g,f,v=c.StatusBarAlignment.Left,m){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,S,w,"f"),tt(this,D,h,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=f,this._alignment=v,this._priority=this.validatePriority(m)}validatePriority(w){if(!!(0,T.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!A.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Be(this,D,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Be(this,D,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let h;this._name?h=this._name:h=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=C.MarkdownString.fromStrict(this._tooltip);Be(this,S,"f").$setEntry(this._entryId,w,h,this._text,f,this._command?.internal,g,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,S=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const h={message:w};return this._messages.unshift(h),this._update(),new c.Disposable(()=>{const g=this._messages.indexOf(h);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(w,h){this._proxy=w.getProxy(t.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new k(this)}createStatusBarEntry(w,h,g,f){return new A(this._proxy,this._commands,w,h,g,f)}setStatusBarMessage(w,h){const g=this._statusMessage.setMessage(w);let f;return typeof h=="number"?f=setTimeout(()=>g.dispose(),h):typeof h<"u"&&h.then(()=>g.dispose(),()=>g.dispose()),new c.Disposable(()=>{g.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=E}),define(Ce[96],De([1,0,5,4,3]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(T){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this._proxy.$registerExtensionStorageKeysToSync(T,S)}initializeExtensionStorage(T,S,D){return this._proxy.$initializeExtensionStorage(T,S).then(A=>A||D)}setValue(T,S,D){return this._proxy.$setValue(T,S,D)}$acceptValue(T,S,D){this._onDidChangeStorage.fire({shared:T,key:S,value:D})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Ce[70],De([1,0,3,25,13,69,2]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(D,A,k){this._logService=A,this._extHostFileSystem=k,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(E=>this._value=E)}async _getWorkspaceStorageURI(D){return C.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,A=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this._value)return C.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return C.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=je([$e(0,t.IExtHostInitDataService),$e(1,I.ILogService),$e(2,P.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Ce[40],De([1,0,4,5,3,2,16,6,7,175,11,221,21,31,205,87,12,18,15]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class m{constructor(n,i,p,_){this._proxy=n,this._id=i,this._creationOptions=p,this._name=_,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(M,H=!0){R._checkDisposed(),R._proxy.$sendText(R._id,M,H)},show(M){R._checkDisposed(),R._proxy.$show(R._id,M)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(l(n.iconPath)),color:h.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this._serializeParentTerminal(n.location,i?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,i,p,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:h.ThemeColor.isThemeColor(_)?_.id:void 0,location:this._serializeParentTerminal(n,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,i){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in n?{viewColumn:v.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,i){this._exitStatus=Object.freeze({code:n,reason:i})}setDimensions(n,i){return n===this._cols&&i===this._rows||n===0||i===0?!1:(this._cols=n,this._rows=i,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=m;class r{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${i}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,i){this._pty.setDimensions?.({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose?.((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions?.(i=>{i&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this._pty.onDidChangeName?.(i=>{this._onDidChangeProperty.fire({type:"title",value:i})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=r;let b=1,o=class extends T.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,i){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new c.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=i.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[p,_]of this._terminalProcesses)_.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,i){const p=new m(this._proxy,(0,y.generateUuid)(),n,n.name),_=new r(n.pty);return p.createExtensionTerminal(n.location,this._serializeParentTerminal(n,i).resolvedExtHostIdentifier,l(n.iconPath),a(n.color)).then(R=>{const M=this._setupExtHostProcessListeners(R,_);this._terminalProcessDisposables[R]=M}),this._terminals.push(p),p.value}_serializeParentTerminal(n,i){if(i=i||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const _=this._terminals.find(R=>R.value===p);_&&(i.resolvedExtHostIdentifier=_._id)}}else n.location&&typeof n.location!="object"?i.location=n.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(n,i){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const _=new r(i),R=this._setupExtHostProcessListeners(n,_);this._terminalProcessDisposables[n]=R}async $acceptActiveTerminalChanged(n){const i=this._activeTerminal;if(n===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(n);p&&(this._activeTerminal=p,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,i){const p=this._getTerminalById(n);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:i})}async $acceptTerminalDimensions(n,i,p){const _=this._getTerminalById(n);_&&_.setDimensions(i,p)&&this._onDidChangeTerminalDimensions.fire({terminal:_.value,dimensions:_.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,p){this._terminalProcesses.get(n)?.resize(i,p)}async $acceptTerminalTitleChange(n,i){const p=this._getTerminalById(n);p&&(p.name=i)}async $acceptTerminalClosed(n,i,p){const _=this._getTerminalObjectIndexById(this._terminals,n);if(_!==null){const R=this._terminals.splice(_,1)[0];R.setExitStatus(i,p),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(n,i,p,_){if(i){const H=this._getTerminalObjectIndexById(this._terminals,i);if(H!==null){this._terminals[H]._id=n,this._onDidOpenTerminal.fire(this.terminals[H]),this._terminals[H].isOpen=!0;return}}const R={name:_.name,shellPath:_.executable,shellArgs:_.args,cwd:typeof _.cwd=="string"?_.cwd:P.URI.revive(_.cwd),env:_.env,hideFromUser:_.hideFromUser},M=new m(this._proxy,n,R,p);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,i){this._getTerminalById(n)?._setProcessId(i)}async $startExtensionTerminal(n,i){const p=this._getTerminalById(n);if(!p)return{message:(0,D.localize)(0,null,n)};p.isOpen||await new Promise(R=>{const M=this.onDidOpenTerminal(async H=>{H===p.value&&(M.dispose(),R())})});const _=this._terminalProcesses.get(n);_?_.startSendingEvents(i):this._extensionTerminalAwaitingStart[n]={initialDimensions:i}}_setupExtHostProcessListeners(n,i){const p=new T.DisposableStore;p.add(i.onProcessReady(R=>this._proxy.$sendProcessReady(n,R.pid,R.cwd))),p.add(i.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(n,R))),this._bufferer.startBuffering(n,i.onProcessData),p.add(i.onProcessExit(R=>this._onProcessExit(n,R))),this._terminalProcesses.set(n,i);const _=this._extensionTerminalAwaitingStart[n];return _&&i instanceof r&&(i.startSendingEvents(_.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),p}$acceptProcessAckDataEvent(n,i){this._terminalProcesses.get(n)?.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){this._terminalProcesses.get(n)?.input(i)}$acceptTerminalInteraction(n){const i=this._getTerminalById(n);i?.setInteractedWith()&&this._onDidChangeTerminalState.fire(i.value)}$acceptProcessResize(n,i,p){try{this._terminalProcesses.get(n)?.resize(i,p)}catch(_){if(_.code!=="EPIPE"&&_.code!=="ERR_IPC_CHANNEL_CLOSED")throw _}}$acceptProcessShutdown(n,i){this._terminalProcesses.get(n)?.shutdown(i)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:i}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,i,p){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,p),this._proxy.$registerProfileProvider(i,n.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(n,i){const p=new E.CancellationTokenSource().token;let _=await this._profileProviders.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(_&&!("options"in _)&&(_={options:_}),!_||!("options"in _))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in _.options){this.createExtensionTerminal(_.options,i);return}this.createTerminalFromOptions(_.options,i)}}async $provideLinks(n,i){const p=this._getTerminalById(n);if(!p)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const R=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,R);const M=[],H={terminal:p.value,line:i},$=[];for(const O of this._linkProviders)$.push(f.Promises.withAsyncBody(async z=>{R.token.onCancellationRequested(()=>z({provider:O,links:[]}));const U=await O.provideTerminalLinks(H,R.token)||[];R.token.isCancellationRequested||z({provider:O,links:U})}));const L=await Promise.all($);if(R.token.isCancellationRequested)return[];const B=new Map;for(const O of L)O&&O.links.length>0&&M.push(...O.links.map(z=>{const U={id:b++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return B.set(U.id,{provider:O.provider,link:z}),U}));return this._terminalLinkCache.set(n,B),M}$activateLink(n,i){const p=this._terminalLinkCache.get(n)?.get(i);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(n,i){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const p=this._terminalProcessDisposables[n];p&&(p.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,i)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,i){const p=this._getTerminalObjectIndexById(n,i);return p!==null?n[p]:null}_getTerminalObjectIndexById(n,i){let p=null;return n.some((_,R)=>_._id===i?(p=R,!0):!1),p}getEnvironmentVariableCollection(n){let i=this._environmentVariableCollections.get(n.identifier.value);return i||(i=new u,this._setEnvironmentVariableCollection(n.identifier.value,i)),i}_syncEnvironmentVariableCollection(n,i){const p=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(n,i.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const p=i[0],_=new u(i[1]);this._setEnvironmentVariableCollection(p,_)})}$acceptDefaultProfile(n,i){const p=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=i,p?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,i){this._environmentVariableCollections.set(n,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,i)})}};o=je([$e(1,C.IExtHostRpcService)],o),e.BaseExtHostTerminalService=o;class u{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Replace})}append(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,i){const p=this.map.get(n);(!p||p.value!==i.value||p.type!==i.type)&&(this.map.set(n,i),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((p,_)=>n.call(i,_,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let s=class extends o{constructor(n){super(!1,n)}createTerminal(n,i,p){throw new A.NotSupportedError}createTerminalFromOptions(n,i){throw new A.NotSupportedError}};s=je([$e(0,C.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function l(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function a(d){return h.ThemeColor.isThemeColor(d)?d:void 0}});var Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c};define(Ce[263],De([1,0,17,23,21,4,60,81,6,24,12,31,5,16,135,15,7,55,91,67]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m){"use strict";var r,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(H,$,L){this.editors=L,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=H.getProxy(E.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new s(this.proxy),$.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==14)return B;const O=B,z=O.tests[O.tests.length-1].item.extId;return this.controllers.get(f.TestId.root(z))?.collection.tree.get(z)?.actual??(0,w.toItemFromContext)(B)}})}createTestController(H,$,L){if(this.controllers.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const B=new S.DisposableStore,O=B.add(new w.ExtHostTestItemCollection(H,$,this.editors));O.root.label=$;const z=new Map,U=this.proxy,F={items:O.root.children,get label(){return $},set label(x){$=x,O.root.label=x,U.$updateController(H,{label:$})},get refreshHandler(){return L},set refreshHandler(x){L=x,U.$updateController(H,{canRefresh:!!x})},get id(){return H},createRunProfile:(x,Q,K,ue,te)=>{let he=(0,T.hash)(x);for(;z.has(he);)he++;return new _(this.proxy,z,H,he,x,Q,K,ue,te)},createTestItem(x,Q,K){return new w.TestItemImpl(H,x,Q,K)},createTestRun:(x,Q,K=!0)=>this.runTracker.createTestRun(H,O,x,Q,K),set resolveHandler(x){O.resolveHandler=x},get resolveHandler(){return O.resolveHandler},dispose:()=>{B.dispose()}};U.$registerTestController(H,$,!!L),B.add((0,S.toDisposable)(()=>U.$unregisterTestController(H)));const V={controller:F,collection:O,profiles:z};return this.controllers.set(H,V),B.add((0,S.toDisposable)(()=>this.controllers.delete(H))),B.add(O.onDidGenerateDiff(x=>U.$publishDiff(H,x.map(m.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(H,$=I.CancellationToken.None){const L=l(H);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(L.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:H.include?.map(O=>f.TestId.fromExtHostTestItem(O,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:R[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:H.exclude?.map(O=>O.id)},$)}$syncTests(){for(const{collection:H}of this.controllers.values())H.flushDiff();return Promise.resolve()}$provideFileCoverage(H,$,L){return(0,c.mapFind)(this.runTracker.trackers,O=>O.id===H?O.getCoverage($):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(H,$,L,B){return(0,c.mapFind)(this.runTracker.trackers,z=>z.id===H?z.getCoverage($):void 0)?.resolveFileCoverage(L,B)??Promise.resolve([])}$configureRunProfile(H,$){this.controllers.get(H)?.profiles.get($)?.configureHandler?.()}async $refreshTests(H,$){await this.controllers.get(H)?.controller.refreshHandler?.($)}$publishTestResults(H){this.results=Object.freeze(H.map($=>(0,D.deepFreeze)(h.TestResults.to($))).concat(this.results).sort(($,L)=>L.completedAt-$.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(H,$){const L=this.controllers.get(f.TestId.fromString(H).controllerId)?.collection;L&&(await L.expand(H,$<0?1/0:$),L.flushDiff())}$acceptDiff(H){this.observer.applyDiff(H.map(m.TestsDiffOp.deserialize))}async $runControllerTests(H,$){return Promise.all(H.map(L=>this.runControllerTestRequest(L,$)))}async runControllerTestRequest(H,$){const L=this.controllers.get(H.controllerId);if(!L)return{};const{collection:B,profiles:O}=L,z=O.get(H.profileId);if(!z)return{};const U=H.testIds.map(Q=>B.tree.get(Q)).filter(A.isDefined),F=H.excludeExtIds.map(Q=>L.collection.tree.get(Q)).filter(A.isDefined).filter(Q=>U.some(K=>K.fullId.compare(Q.fullId)===2));if(!U.length)return{};const V=new g.TestRunRequest(U.some(Q=>Q.actual instanceof w.TestItemRootImpl)?void 0:U.map(Q=>Q.actual),F.map(Q=>Q.actual),z),x=this.runTracker.prepareForMainThreadTestRun(V,a.fromInternal(H,L.collection),$);try{return await z.runHandler(V,$),{}}catch(Q){return{error:String(Q)}}finally{x.isRunning&&!$.isCancellationRequested&&await P.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(H){H===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(H)}};o=je([$e(0,y.IExtHostRpcService)],o),e.ExtHostTesting=o;class u extends S.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(H,$,L){super(),this.dto=H,this.proxy=$,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}getCoverage(H){return this.tasks.get(H)?.coverage}createRun(H){const $=this.dto.id,L=this.dto.controllerId,B=(0,k.generateUuid)(),O=new d(this.proxy,$,B),z=x=>(Q,...K)=>{if(F){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),x(Q,...K))},U=(x,Q)=>{const K=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if(x.uri&&x.range){const ue={range:h.Range.from(x.range),uri:x.uri};for(const te of K)te.location=te.location||ue}this.proxy.$appendTestMessagesInRun($,B,f.TestId.fromExtHostTestItem(x,L).toString(),K)};let F=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:H,get coverageProvider(){return O.coverageProvider},set coverageProvider(x){O.coverageProvider=x},enqueued:z(x=>{this.proxy.$updateTestStateInRun($,B,f.TestId.fromExtHostTestItem(x,L).toString(),1)}),skipped:z(x=>{this.proxy.$updateTestStateInRun($,B,f.TestId.fromExtHostTestItem(x,L).toString(),5)}),started:z(x=>{this.proxy.$updateTestStateInRun($,B,f.TestId.fromExtHostTestItem(x,L).toString(),2)}),errored:z((x,Q,K)=>{U(x,Q),this.proxy.$updateTestStateInRun($,B,f.TestId.fromExtHostTestItem(x,L).toString(),6,K)}),failed:z((x,Q,K)=>{U(x,Q),this.proxy.$updateTestStateInRun($,B,f.TestId.fromExtHostTestItem(x,L).toString(),4,K)}),passed:z((x,Q)=>{this.proxy.$updateTestStateInRun($,B,f.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,Q)}),appendOutput:(x,Q,K)=>{F||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun($,B,t.VSBuffer.fromString(x),Q&&h.location.from(Q),K&&f.TestId.fromExtHostTestItem(K,L).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask($,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:V,coverage:O}),this.proxy.$startedTestRunTask($,{id:B,name:H,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(H){if(!(H instanceof w.TestItemImpl))throw new v.InvalidTestItemError(H.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString()))return;const $=[],L=this.dto.colllection.root;for(;;){const B=h.TestItem.from(H);if($.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),H===L))break;H=H.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,$)}}class s{get trackers(){return this.tracked.values()}constructor(H){this.proxy=H,this.tracked=new Map}prepareForMainThreadTestRun(H,$,L){return this.getTracker(H,$,L)}cancelRunById(H){for(const $ of this.tracked.values())if($.id===H){$.dispose();return}}cancelAllRuns(){for(const H of this.tracked.values())H.dispose()}createTestRun(H,$,L,B,O){const z=this.tracked.get(L);if(z)return z.createRun(B);const U=a.fromPublic(H,$,L,O),F=l(L);this.proxy.$startedExtensionTestRun({controllerId:H,profile:F&&{group:R[F.kind],id:F.profileId},exclude:L.exclude?.map(x=>f.TestId.fromExtHostTestItem(x,$.root.id).toString())??[],id:U.id,include:L.include?.map(x=>f.TestId.fromExtHostTestItem(x,$.root.id).toString())??[$.root.id],persist:O});const V=this.getTracker(L,U);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),V.createRun(B)}getTracker(H,$,L){const B=new u($,this.proxy,L);return this.tracked.set(H,B),B.onEnd(()=>this.tracked.delete(H)),B}}e.TestRunCoordinator=s;const l=M=>{if(!!M.profile){if(!(M.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class a{static fromPublic(H,$,L,B){return new a(H,(0,k.generateUuid)(),L.include?.map(O=>f.TestId.fromExtHostTestItem(O,H).toString())??[H],L.exclude?.map(O=>f.TestId.fromExtHostTestItem(O,H).toString())??[],B,$)}static fromInternal(H,$){return new a(H.controllerId,H.runId,H.testIds,H.excludeExtIds,!0,$)}constructor(H,$,L,B,O,z){this.controllerId=H,this.id=$,this.isPersisted=O,this.colllection=z,this.includePrefix=L.map(U=>U+"\0"),this.excludePrefix=B.map(U=>U+"\0")}isIncluded(H){const $=f.TestId.fromExtHostTestItem(H,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if($===L||$.startsWith(L))return!1;for(const L of this.includePrefix)if($===L||$.startsWith(L))return!0;return!1}}e.TestRunDto=a;class d{set coverageProvider(H){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!H||(this._coverageProvider=H,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(H,$,L){this.proxy=H,this.runId=$,this.taskId=L}async provideFileCoverage(H){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(H))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch($){throw this.fileCoverage=void 0,$}}async resolveFileCoverage(H,$){const L=await this.fileCoverage;let B=L?.[H];return!this._coverageProvider||!L||!B?[]:(B.detailedCoverage||(B=L[H]=await this._coverageProvider.resolveFileCoverage?.(B,$)??B),B.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class n extends m.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(H){super(),this.emitter=H,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(H){this.added.add(H)}update(H){Object.assign(H.revived,h.TestItem.toPlain(H.item)),this.added.has(H)||this.updated.add(H)}remove(H){if(this.added.has(H)){this.added.delete(H);return}this.updated.delete(H);const $=f.TestId.parentId(H.item.extId);if($&&this.alreadyRemoved.has($.toString())){this.alreadyRemoved.add(H.item.extId);return}this.removed.add(H)}getChangeEvent(){const{added:H,updated:$,removed:L}=this;return{get added(){return[...H].map(B=>B.revived)},get updated(){return[...$].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class i extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(H){return this.items.get(H)}getMirroredTestDataByReference(H){return this.items.get(H.id)}createItem(H,$){return{...H,revived:h.TestItem.toPlain(H.item),depth:$?$.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=i;class p{constructor(H){this.proxy=H}checkout(){this.current||(this.current=this.createObserverData());const H=this.current;return H.observers++,{onDidChangeTest:H.tests.onDidChangeTests,get tests(){return[...H.tests.rootTests].map($=>$.revived)},dispose:(0,C.once)(()=>{--H.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(H){return this.current?.tests.getMirroredTestDataByReference(H)}applyDiff(H){this.current?.tests.apply(H)}createObserverData(){const H=new i;return this.proxy.$subscribeToDiffs(),{observers:0,tests:H}}}class _{get label(){return this._label}set label(H){H!==this._label&&(this._label=H,Be(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:H}))}get isDefault(){return this._isDefault}set isDefault(H){H!==this._isDefault&&(this._isDefault=H,Be(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:H}))}get tag(){return this._tag}set tag(H){H?.id!==this._tag?.id&&(this._tag=H,Be(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:H?h.TestTag.namespace(this.controllerId,H.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(H){H!==this._configureHandler&&(this._configureHandler=H,Be(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!H}))}constructor(H,$,L,B,O,z,U,F=!1,V=void 0){this.controllerId=L,this.profileId=B,this._label=O,this.kind=z,this.runHandler=U,this._isDefault=F,this._tag=V,r.set(this,void 0),b.set(this,void 0),tt(this,r,H,"f"),tt(this,b,$,"f"),$.set(B,this);const x=R[z];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);Be(this,r,"f").$publishTestRunProfile({profileId:B,controllerId:L,tag:V?h.TestTag.namespace(this.controllerId,V.id):null,label:O,group:x,isDefault:F,hasConfigurationHandler:!1})}dispose(){Be(this,b,"f")?.delete(this.profileId)&&(tt(this,b,void 0,"f"),Be(this,r,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_,r=new WeakMap,b=new WeakMap;const R={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(Ce[264],De([1,0,17,4,5,136,15,7]),function(J,e,c,t,I,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(A,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const k=this._extHostDocumentsAndEditors.allEditors();return A?k:k.map(E=>E.value)}async showTextDocument(A,k,E){let y;typeof k=="number"?y={position:C.ViewColumn.from(k),preserveFocus:E}:typeof k=="object"?y={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:y={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(A.uri,y),h=w&&this._extHostDocumentsAndEditors.getEditor(w);if(h)return h.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new P.TextEditorDecorationType(this._proxy,A,k).value}$acceptEditorPropertiesChanged(A,k){const E=this._extHostDocumentsAndEditors.getEditor(A);if(!E)throw new Error("unknown text editor");if(k.options&&E._acceptOptions(k.options),k.selections){const y=k.selections.selections.map(C.Selection.to);E._acceptSelections(y)}if(k.visibleRanges){const y=c.coalesce(k.visibleRanges.map(C.Range.to));E._acceptVisibleRanges(y)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...k.options,lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const y=T.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:w,kind:y})}if(k.visibleRanges){const y=c.coalesce(k.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:y})}}$acceptEditorPositionData(A){for(const k in A){const E=this._extHostDocumentsAndEditors.getEditor(k);if(!E)throw new Error("Unknown text editor");const y=C.ViewColumn.to(A[k]);E.value.viewColumn!==y&&(E._acceptViewColumn(y),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:y}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=S}),define(Ce[265],De([1,0,2,3,5,6,7,15,12]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class D{constructor(E,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const h=w.uri===void 0?void 0:c.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(A(h))?.get(w.handle)}return w}})}async $getTimeline(E,y,w,h){return this._providers.get(E)?.provideTimeline(c.URI.revive(y),w,h)}registerTimelineProvider(E,y,w,h){const g=new P.DisposableStore,f=this.convertTimelineItem(y.id,h,g).bind(this);let v;y.onDidChange&&(v=y.onDidChange(r=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...r,id:y.id}),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:E,onDidChange:void 0,async provideTimeline(r,b,o){b?.resetCache&&(g.clear(),m.get(y.id)?.clear());const u=await y.provideTimeline(r,b,o);if(u==null)return;const s=f(r,b);return{...u,source:y.id,items:u.items.map(s)}},dispose(){for(const r of m.values())r.get(y.id)?.clear();v?.dispose(),g.dispose()}})}convertTimelineItem(E,y,w){return(h,g)=>{let f;if(g?.cacheResults){let v=this._itemsBySourceAndUriMap.get(E);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(E,v));const m=A(h);f=v.get(m),f===void 0&&(f=new Map,v.set(m,f))}return v=>{const{iconPath:m,...r}=v,b=`${E}|${v.id??v.timestamp}`;f?.set(b,v);let o,u,s;v.iconPath&&(m instanceof C.ThemeIcon?s={id:m.id,color:m.color}:c.URI.isUri(m)?(o=m,u=m):{light:o,dark:u}=m);let l;return C.MarkdownString.isMarkdownString(r.tooltip)?l=T.MarkdownString.from(r.tooltip):(0,S.isString)(r.tooltip)?l=r.tooltip:C.MarkdownString.isMarkdownString(r.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=T.MarkdownString.from(r.detail)):(0,S.isString)(r.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=r.detail),{...r,id:r.id??void 0,handle:b,source:E,command:v.command?y.toInternal(v.command,w):void 0,icon:o,iconDark:u,themeIcon:s,tooltip:l,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(E){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,E),(0,P.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=D;function A(k){return k?.toString()}}),define(Ce[266],De([1,0,6,14,2,5]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this._openers=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,D,A,k){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const E=k.schemes.find(y=>!C.supportedSchemes.has(y));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,A),this._proxy.$registerUriOpener(D,k.schemes,S,k.label),(0,c.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(S,D,A){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const E=I.URI.revive(D);return k.canOpenExternalUri(E,A)}async $openUri(S,D,A){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(I.URI.revive(D.resolvedUri),{sourceUri:I.URI.revive(D.sourceUri)},A)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Ce[267],De([1,0,5,2,6,11,26]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(D,A){if(this.handles.has(C.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const k=T.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(D)),this.handlers.set(k,A),this._proxy.$registerUriHandler(k,D),(0,I.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(D)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(D,A){const k=this.handlers.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(A))}catch(E){(0,P.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=T,T.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[71],De([1,0,4,14,2,189,212,89,5]),function(J,e,c,t,I,P,C,T,S){"use strict";var D,A,k,E,y,w,h,g,f,v,m,r,b;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(_,R,M,H,$,L,B){D.set(this,void 0),A.set(this,void 0),k.set(this,void 0),E.set(this,void 0),y.set(this,void 0),w.set(this,void 0),h.set(this,""),g.set(this,void 0),f.set(this,!1),v.set(this,!1),m.set(this,void 0),r.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,b.set(this,new c.Emitter),this._onDidDispose=Be(this,b,"f").event,tt(this,D,_,"f"),tt(this,A,R,"f"),tt(this,g,M,"f"),tt(this,E,H,"f"),tt(this,y,$,"f"),tt(this,w,L,"f"),tt(this,m,u(L),"f"),tt(this,r,s(L),"f"),tt(this,k,B,"f")}dispose(){tt(this,f,!0,"f"),Be(this,b,"f").fire(),Be(this,b,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return tt(this,v,!0,"f"),(0,T.asWebviewUri)(_,Be(this,E,"f"))}get cspSource(){const _=Be(this,w,"f").extensionLocation;if(_.scheme===t.Schemas.https||_.scheme===t.Schemas.http){let R=_.toString();return R.endsWith("/")||(R+="/"),R+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,h,"f")}set html(_){this.assertNotDisposed(),Be(this,h,"f")!==_&&(tt(this,h,_,"f"),Be(this,r,"f")&&!Be(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(tt(this,v,!0,"f"),Be(this,k,"f").report("Webview vscode-resource: uris",Be(this,w,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,A,"f").$setHtml(Be(this,D,"f"),this.rewriteOldResourceUrlsIfNeeded(_)))}get options(){return this.assertNotDisposed(),Be(this,g,"f")}set options(_){this.assertNotDisposed(),Be(this,A,"f").$setOptions(Be(this,D,"f"),d(Be(this,w,"f"),Be(this,y,"f"),_)),tt(this,g,_,"f")}async postMessage(_){if(Be(this,f,"f"))return!1;const R=(0,C.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Be(this,m,"f")});return Be(this,A,"f").$postMessage(Be(this,D,"f"),R.message,...R.buffers)}assertNotDisposed(){if(Be(this,f,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(_){if(!Be(this,r,"f"))return _;const R=Be(this,w,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,M=Be(this,w,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Be(this,w,"f").extensionLocation.authority:void 0;return _.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,$,L,B,O,z)=>{const U=I.URI.from({scheme:B||"file",path:decodeURIComponent(O)}),F=(0,T.asWebviewUri)(U,{isRemote:R,authority:M}).toString();return`${$}${F}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,$,L,B,O,z)=>{const U=I.URI.from({scheme:B||"file",path:decodeURIComponent(O)}),F=(0,T.asWebviewUri)(U,{isRemote:R,authority:M}).toString();return`${$}${F}${z}`})}}e.ExtHostWebview=o,D=new WeakMap,A=new WeakMap,k=new WeakMap,E=new WeakMap,y=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,v=new WeakMap,m=new WeakMap,r=new WeakMap,b=new WeakMap;function u(p){try{const _=(0,P.normalizeVersion)((0,P.parseVersion)(p.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function s(p){try{const _=(0,P.normalizeVersion)((0,P.parseVersion)(p.engines.vscode));return _?_.majorBase<1||_.majorBase===1&&_.minorBase<60:!1}catch{return!1}}class l{constructor(_,R,M,H,$){this.remoteInfo=R,this.workspace=M,this._logService=H,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=_.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(_,R,M){const H=this.getWebview(_);if(H){const{message:$}=(0,C.deserializeWebviewMessage)(R,M.value);H._onMessageEmitter.fire($)}}$onMissingCsp(_,R){this._logService.warn(`${R} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,R,M){const H=new o(_,this._webviewProxy,n(R),this.remoteInfo,this.workspace,M,this._deprecationService);return this._webviews.set(_,H),H._onDidDispose(()=>{this._webviews.delete(_)}),H}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=l;function a(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=a;function d(p,_,R){return{enableCommandUris:R.enableCommandUris,enableScripts:R.enableScripts,enableForms:R.enableForms,portMapping:R.portMapping,localResourceRoots:R.localResourceRoots||i(p,_)}}e.serializeWebviewOptions=d;function n(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(_=>I.URI.from(_))}}e.reviveOptions=n;function i(p,_){return[...(_?.getWorkspaceFolders()||[]).map(R=>R.uri),p.extensionLocation]}}),define(Ce[268],De([1,0,21,81,6,14,22,2,15,71,88,5,7]),function(J,e,c,t,I,P,C,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class y{constructor(u,s){this.document=u,this._storagePath=s,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,s){await this.getEdit(u).undo(),s||this.disposeBackup()}async redo(u,s){await this.getEdit(u).redo(),s||this.disposeBackup()}disposeEdits(u){for(const s of u)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=b(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const s=this._edits.get(u,0);if(!s)throw new Error("No edit found");return s}}class w{constructor(){this._documents=new Map}get(u,s){return this._documents.get(this.key(u,s))}add(u,s,l){const a=this.key(u,s.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${u} resource:${s.uri}`);const d=new y(s,l);return this._documents.set(a,d),d}delete(u,s){const l=this.key(u,s.uri);this._documents.delete(l)}key(u,s){return`${u}@@@${s}`}}var h;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(h||(h={}));class g{constructor(){this._providers=new Map}addTextProvider(u,s,l){return this.add(0,u,s,l)}addCustomProvider(u,s,l){return this.add(1,u,s,l)}get(u){return this._providers.get(u)}add(u,s,l,a){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:u,extension:l,provider:a}),new E.Disposable(()=>this._providers.delete(s))}}class f{constructor(u,s,l,a,d){this._extHostDocuments=s,this._extensionStoragePaths=l,this._extHostWebview=a,this._extHostWebviewPanels=d,this._editorProviders=new g,this._documents=new w,this._proxy=u.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,s,l,a){const d=new I.DisposableStore;return m(l)?(d.add(this._editorProviders.addTextProvider(s,u,l)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(u),s,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(u))):(d.add(this._editorProviders.addCustomProvider(s,u,l)),v(l)&&d.add(l.onDidChangeCustomDocument(n=>{const i=this.getCustomDocumentEntry(s,n.document.uri);if(r(n)){const p=i.addEdit(n);this._proxy.$onDidEdit(n.document.uri,s,p,n.label)}else this._proxy.$onContentChange(n.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(u),s,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(u))),E.Disposable.from(d,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(u,s,l,a,d){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${s}'`);const i=T.URI.revive(u),p=await n.provider.openCustomDocument(i,{backupId:l,untitledDocumentData:a?.buffer},d);let _;return v(n.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(s,p,_),{editable:v(n.provider)}}async $disposeCustomDocument(u,s){const l=this._editorProviders.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const a=T.URI.revive(u),{document:d}=this.getCustomDocumentEntry(s,a);this._documents.delete(s,d),d.dispose()}async $resolveWebviewEditor(u,s,l,a,d,n){const i=this._editorProviders.get(l);if(!i)throw new Error(`No provider found for '${l}'`);const p=S.ViewColumn.to(d),_=this._extHostWebview.createNewWebview(s,a.contentOptions,i.extension),R=this._extHostWebviewPanels.createNewWebviewPanel(s,l,a.title,p,a.options,_,!0),M=T.URI.revive(u);switch(i.type){case 1:{const{document:H}=this.getCustomDocumentEntry(l,M);return i.provider.resolveCustomEditor(H,R,n)}case 0:{const H=this._extHostDocuments.getDocument(M);return i.provider.resolveCustomTextEditor(H,R,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,s,l){this.getCustomDocumentEntry(s,u).disposeEdits(l)}async $onMoveCustomEditor(u,s,l){const a=this._editorProviders.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const d=this._extHostWebviewPanels.getWebviewPanel(u);if(!d)throw new Error("No webview found");const n=T.URI.revive(s),i=this._extHostDocuments.getDocument(n);await a.provider.moveCustomTextEditor(i,d,c.CancellationToken.None)}async $undo(u,s,l,a){return this.getCustomDocumentEntry(s,u).undo(l,a)}async $redo(u,s,l,a){return this.getCustomDocumentEntry(s,u).redo(l,a)}async $revert(u,s,l){const a=this.getCustomDocumentEntry(s,u);await this.getCustomEditorProvider(s).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(u,s,l){const a=this.getCustomDocumentEntry(s,u);await this.getCustomEditorProvider(s).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(u,s,l,a){const d=this.getCustomDocumentEntry(s,u);return this.getCustomEditorProvider(s).saveCustomDocumentAs(d.document,T.URI.revive(l),a)}async $backup(u,s,l){const a=this.getCustomDocumentEntry(s,u),n=await this.getCustomEditorProvider(s).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(n),n.id}getCustomDocumentEntry(u,s){const l=this._documents.get(u,T.URI.revive(s));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(u){const l=this._editorProviders.get(u)?.provider;if(!l||!v(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=f;function v(o){return!!o.onDidChangeCustomDocument}function m(o){return typeof o.resolveCustomTextEditor=="function"}function r(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function b(o){const u=o.scheme===P.Schemas.file||o.scheme===P.Schemas.untitled?o.fsPath:o.toString();return(0,t.hash)(u)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[269],De([1,0,4,6,2,31,15,71,5,7]),function(J,e,c,t,I,P,C,T,S,D){"use strict";var A,k,E,y,w,h,g,f,v,m,r,b,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends t.Disposable{constructor(d,n,i,p){super(),A.set(this,void 0),k.set(this,void 0),E.set(this,void 0),y.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,void 0),f.set(this,void 0),v.set(this,!0),m.set(this,void 0),r.set(this,!1),b.set(this,this._register(new c.Emitter)),this.onDidDispose=Be(this,b,"f").event,o.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Be(this,o,"f").event,tt(this,A,d,"f"),tt(this,k,n,"f"),tt(this,y,i,"f"),tt(this,E,p.viewType,"f"),tt(this,w,p.panelOptions,"f"),tt(this,f,p.viewColumn,"f"),tt(this,h,p.title,"f"),tt(this,m,p.active,"f")}dispose(){Be(this,r,"f")||(tt(this,r,!0,"f"),Be(this,b,"f").fire(),Be(this,k,"f").$disposeWebview(Be(this,A,"f")),Be(this,y,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,y,"f")}get viewType(){return this.assertNotDisposed(),Be(this,E,"f")}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(d){this.assertNotDisposed(),Be(this,h,"f")!==d&&(tt(this,h,d,"f"),Be(this,k,"f").$setTitle(Be(this,A,"f"),d))}get iconPath(){return this.assertNotDisposed(),Be(this,g,"f")}set iconPath(d){this.assertNotDisposed(),Be(this,g,"f")!==d&&(tt(this,g,d,"f"),Be(this,k,"f").$setIconPath(Be(this,A,"f"),I.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Be(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,f,"f")=="number"&&Be(this,f,"f")<0))return Be(this,f,"f")}get active(){return this.assertNotDisposed(),Be(this,m,"f")}get visible(){return this.assertNotDisposed(),Be(this,v,"f")}_updateViewState(d){Be(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(tt(this,m,d.active,"f"),tt(this,v,d.visible,"f"),tt(this,f,d.viewColumn,"f"),Be(this,o,"f").fire({webviewPanel:this}))}reveal(d,n){this.assertNotDisposed(),Be(this,k,"f").$reveal(Be(this,A,"f"),{viewColumn:typeof d>"u"?void 0:C.ViewColumn.from(d),preserveFocus:!!n})}assertNotDisposed(){if(Be(this,r,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,E=new WeakMap,y=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,v=new WeakMap,m=new WeakMap,r=new WeakMap,b=new WeakMap,o=new WeakMap;class s{static newHandle(){return(0,P.generateUuid)()}constructor(d,n,i){this.webviews=n,this.workspace=i,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,n,i,p,_={}){const R=typeof p=="object"?p.viewColumn:p,M={viewColumn:C.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},H=(0,T.shouldSerializeBuffersForPostMessage)(d),$=s.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(d),$,n,{title:i,panelOptions:l(_),webviewOptions:(0,T.serializeWebviewOptions)(d,this.workspace,_),serializeBuffersForPostMessage:H},M);const L=this.webviews.createNewWebview($,_,d);return this.createNewWebviewPanel($,n,i,R,_,L,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((i,p)=>{const _=d[i],R=d[p];return _.active?1:R.active?-1:+_.visible-+R.visible});for(const i of n){const p=this.getWebviewPanel(i);if(!p)continue;const _=d[i];p._updateViewState({active:_.active,visible:_.visible,viewColumn:C.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,n,i){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:i,extension:d}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(d)}),new D.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,i,p){const _=this._serializers.get(n);if(!_)throw new Error(`No serializer found for '${n}'`);const{serializer:R,extension:M}=_,H=this.webviews.createNewWebview(d,i.webviewOptions,M),$=this.createNewWebviewPanel(d,n,i.title,p,i.panelOptions,H,i.active);await R.deserializeWebviewPanel($,i.state)}createNewWebviewPanel(d,n,i,p,_,R,M){const H=new u(d,this._proxy,R,{viewType:n,title:i,viewColumn:p,panelOptions:_,active:M});return this._webviewPanels.set(d,H),H}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=s;function l(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[270],De([1,0,4,6,71,15,5,7]),function(J,e,c,t,I,P,C,T){"use strict";var S,D,A,k,E,y,w,h,g,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(o,u,s,l,a,d,n){super(),S.set(this,void 0),D.set(this,void 0),A.set(this,void 0),k.set(this,void 0),E.set(this,!1),y.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,void 0),f.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Be(this,f,"f").event,v.set(this,this._register(new c.Emitter)),this.onDidDispose=Be(this,v,"f").event,tt(this,A,s,"f"),tt(this,w,l,"f"),tt(this,S,o,"f"),tt(this,D,u,"f"),tt(this,k,a,"f"),tt(this,y,n,"f")}dispose(){Be(this,E,"f")||(tt(this,E,!0,"f"),Be(this,v,"f").fire(),Be(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,w,"f")}set title(o){this.assertNotDisposed(),Be(this,w,"f")!==o&&(tt(this,w,o,"f"),Be(this,D,"f").$setWebviewViewTitle(Be(this,S,"f"),o))}get description(){return this.assertNotDisposed(),Be(this,h,"f")}set description(o){this.assertNotDisposed(),Be(this,h,"f")!==o&&(tt(this,h,o,"f"),Be(this,D,"f").$setWebviewViewDescription(Be(this,S,"f"),o))}get visible(){return Be(this,y,"f")}get webview(){return Be(this,k,"f")}get viewType(){return Be(this,A,"f")}_setVisible(o){o===Be(this,y,"f")||Be(this,E,"f")||(tt(this,y,o,"f"),Be(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Be(this,g,"f")}set badge(o){this.assertNotDisposed(),!(o?.value===Be(this,g,"f")?.value&&o?.tooltip===Be(this,g,"f")?.tooltip)&&(tt(this,g,P.ViewBadge.from(o),"f"),Be(this,D,"f").$setWebviewViewBadge(Be(this,S,"f"),o))}show(o){this.assertNotDisposed(),Be(this,D,"f").$show(Be(this,S,"f"),!!o)}assertNotDisposed(){if(Be(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,D=new WeakMap,A=new WeakMap,k=new WeakMap,E=new WeakMap,y=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,v=new WeakMap;class r{constructor(o,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,u,s,l){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:s,extension:o}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(o),u,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(o)}),new T.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(o,u,s,l,a){const d=this._viewProviders.get(u);if(!d)throw new Error(`No view provider found for '${u}'`);const{provider:n,extension:i}=d,p=this._extHostWebview.createNewWebview(o,{},i),_=new m(o,this._proxy,u,s,p,i,!0);this._webviewViews.set(o,_),await n.resolveWebviewView(_,{state:l},a)}async $onDidChangeWebviewViewVisibility(o,u){this.getWebviewView(o)._setVisible(u)}async $disposeWebviewView(o){const u=this.getWebviewView(o);this._webviewViews.delete(o),u.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const u=this._webviewViews.get(o);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=r}),define(Ce[139],De([1,0,4,5,2,14,8,3,16]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class ti{get state(){return this._state}constructor(k){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ti.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,E){let y;if(typeof k=="string"){y=k;try{k=I.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,y,E)}async asExternalUri(k,E){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this._proxy.$asExternalUri(k,E);return I.URI.from(y)}};D.InitialState={focused:!0},D=je([$e(0,S.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Ce[271],De([1,0,117,272,64,39,2,13,45]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(E,y,w){this._commands=E,this.logService=y,this._ipcHandlePath=w,this._server=t.createServer((h,g)=>this.onRequest(h,g)),this.setup().catch(h=>(y.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,y){const w=(g,f)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(f||null),v=>v&&this.logService.error(v))},h=[];E.setEncoding("utf8"),E.on("data",g=>h.push(g)),E.on("end",async()=>{try{const g=JSON.parse(h.join(""));let f;switch(g.type){case"open":f=await this.open(g);break;case"openExternal":f=await this.openExternal(g);break;case"status":f=await this.getStatus(g);break;case"extensionManagement":f=await this.manageExtensions(g);break;default:w(404,`Unknown message type: ${g.type}`);break}w(200,f)}catch(g){const f=g instanceof Error?g.message:JSON.stringify(g);w(500,f),this.logService.error("Error while processing pipe request",g)}})}async open(E){const{fileURIs:y,folderURIs:w,forceNewWindow:h,diffMode:g,mergeMode:f,addMode:v,forceReuseWindow:m,gotoLineMode:r,waitMarkerFilePath:b,remoteAuthority:o}=E,u=[];if(Array.isArray(w))for(const d of w)try{u.push({folderUri:C.URI.parse(d)})}catch{}if(Array.isArray(y))for(const d of y)try{(0,S.hasWorkspaceFileExtension)(d)?u.push({workspaceUri:C.URI.parse(d)}):u.push({fileUri:C.URI.parse(d)})}catch{}const s=b?C.URI.file(b):void 0,a={forceNewWindow:h,diffMode:g,mergeMode:f,addMode:v,gotoLineMode:r,forceReuseWindow:m,preferNewWindow:!m&&!s&&!v,waitMarkerFileURI:s,remoteAuthority:o};return this._commands.executeCommand("_remoteCLI.windowOpen",u,a),""}async openExternal(E){for(const y of E.uris){const w=C.URI.parse(y),h=w.scheme==="file"?w:y;await this._commands.executeCommand("_remoteCLI.openExternal",h)}}async manageExtensions(E){const y=h=>h?.map(g=>/\.vsix$/i.test(g)?C.URI.parse(g):g),w={list:E.list,install:y(E.install),uninstall:y(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let A=class extends D{constructor(E,y){super(E,y,(0,c.createRandomIPCHandle)())}};A=je([$e(0,P.IExtHostCommands),$e(1,T.ILogService)],A),e.CLIServer=A}),define(Ce[273],De([1,0,245,25,16]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let C=class extends c.AbstractExtHostConsoleForwarder{constructor(S,D){super(S,D),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,D,A){const k=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),D.apply(console,A),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,D){const A=process[S],k=A.write;let E="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,w,h)=>{if(!this._isMakingConsoleCall){E+=y.toString(w);const g=E.length>P?E.length:E.lastIndexOf(`
`);g!==-1&&(console[D](E.slice(0,g)),E=E.slice(g+1))}k.call(A,y,w,h)}})}};C=je([$e(0,I.IExtHostRpcService),$e(1,t.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(Ce[274],De([1,0,9,83,31,39,6,5,2,16]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=class extends C.Disposable{constructor(E,y){super();const w=E.getProxy(T.MainContext.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async h=>{const g=S.URI.file((0,c.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await w.$download(h,g),g})}};A=je([$e(0,D.IExtHostRpcService),$e(1,P.IExtHostCommands)],A),e.ExtHostDownloadService=A}),define(Ce[275],De([1,0,138,14,195,31]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends c.ExtHostLoggerService{doCreateLogger(S,D,A){return S.scheme===t.Schemas.file?new I.SpdLogLogger(A?.name||(0,P.generateUuid)(),S.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,D):super.doCreateLogger(S,D,A)}}e.ExtHostLoggerService=C}),define(Ce[276],De([1,0,64,9,2,70,6,14,18,29]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const u=await super._getWorkspaceStorageURI(o);if(u.scheme!==T.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const s=u.fsPath;let l=0;do{let a;l===0?a=s:a=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${l}`:`${s}-${l}`,await k(a);const d=t.join(a,"vscode.lock"),n=await h(this._logService,d,!1);if(n)return this._workspaceStorageLock=n,process.on("exit",()=>{n.dispose()}),I.URI.file(a);l++}while(l<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function k(b){try{await D.Promises.stat(b);return}catch{}try{await D.Promises.mkdir(b,{recursive:!0})}catch{}}const E=1e3,y=10*60*1e3;class w extends C.Disposable{constructor(o,u){super(),this.logService=o,this.filename=u,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await g(o,u);(!s||s.pid!==process.pid)&&(o.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(u,new Date,new Date)}catch(l){o.error(l),o.info(`Lock '${u}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{c.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+o};await D.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function h(b,o,u){try{const l={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(o,JSON.stringify(l),{flag:"wx"})}catch(l){b.error(l)}const s=await g(b,o);return!s||s.pid!==process.pid?u?(b.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),m(b,o)):(b.info(`Lock '${o}': Lock acquired.`),new w(b,o))}async function g(b,o){let u;try{u=await D.Promises.readFile(o)}catch(s){return b.error(s),null}try{return JSON.parse(String(u))}catch(s){return b.error(s),null}}async function f(b,o){let u;try{u=await D.Promises.stat(o)}catch(s){return b.error(s),0}return u.mtime.getTime()}function v(b){try{return process.kill(b,0),!0}catch{return!1}}async function m(b,o){const u=await g(b,o);if(!u)return b.info(`Lock '${o}': Could not read pid of lock holder.`),r(b,o);if(u.willReleaseAt){let n=u.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${o}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${o}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await f(b,o)===0)return r(b,o);n=u.willReleaseAt-Date.now()}return r(b,o)}}if(!v(u.pid))return b.info(`Lock '${o}': The pid ${u.pid} appears to be gone.`),r(b,o);const s=await f(b,o),l=Date.now()-s;if(l<=y)return b.info(`Lock '${o}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;b.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const a=await f(b,o),d=Date.now()-a;return d<=y?(b.info(`Lock '${o}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(b.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),r(b,o))}async function r(b,o){b.info(`Lock '${o}': Deleting a stale lock.`);try{await D.Promises.unlink(o)}catch{}return h(b,o,!0)}}),define(Ce[277],De([1,0,31,16,40]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends I.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,D){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:D})}createTerminalFromOptions(T,S){const D=new I.ExtHostTerminal(this._proxy,(0,c.generateUuid)(),T,T.name);return this._terminals.push(D),D.create(T,this._serializeParentTerminal(T,S)),D.value}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(Ce[278],De([1,0,5,16,179,6,25,2,44,22,29,7,10,53,4,128,99,13]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends h.DisposableTunnel{}function m(n){const i=n.trim().split(`
`),p=[];return i.forEach(R=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);M&&M.length>=3&&p.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),p.reduce((R,M)=>(R[M.socket]=M,R),{})}e.getSockets=m;function r(...n){const i=[].concat(...n.map(o));return[...new Map(i.filter(p=>p.st==="0A").map(p=>{const _=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:b(_[0]),port:parseInt(_[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=r;function b(n){let i="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)i+=parseInt(n.substr(p,2),16),p!==0&&(i+=".");else for(let p=n.length-4;p>=0;p-=4)i+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(i+=":");return i}e.parseIpAddress=b;function o(n){const i=n.trim().split(`
`),p=i.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return i.map(R=>R.trim().split(/\s+/).reduce((M,H,$)=>(M[p[$]||$]=H,M),{}))}e.loadConnectionTable=o;function u(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function s(n){const i=n.trim().split(`
`),p=[];return i.forEach(_=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);R&&R.length>=4&&p.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),p}e.getRootProcesses=s;async function l(n,i,p){const _=p.reduce((M,H)=>(M[H.pid]=H,M),{}),R=[];return n.forEach(({socket:M,ip:H,port:$})=>{const L=i[M]?i[M].pid:void 0,B=L?_[L]?.cmd:void 0;L&&B&&!u(B)&&R.push({host:H,port:$,detail:B,pid:L})}),R}e.findPorts=l;function a(n,i,p){const _=new Map,R=s(i);for(const M of n){const H=p.get(M.port);if(H){_.set(M.port,H);continue}const $=R.find(L=>L.cmd.includes(`${M.port}`));if($){let L=$,B;do B=R.find(O=>O.ppid===L.pid),B&&(L=B);while(B);_.set(M.port,{host:M.ip,port:M.port,pid:L.pid,detail:L.cmd,ppid:L.ppid})}else _.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=a;let d=class extends P.Disposable{constructor(i,p,_){super(),this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(c.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(i,p){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(p,i.displayName);if(_){const R=new v(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(i){return Math.max(i*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,p){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:i,provider:p}),this._proxy.$registerPortsAttributesProvider(i,_),new k.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(i,p,_,R,M){const H=[];for(const L of i){const B=this._portAttributesProviders.get(L);if(!B)return[];H.push(...await Promise.all(p.map(async O=>B.provider.providePortAttributes(O,_,R,M))))}const $=H.filter(L=>!!L);return $.length>0?$.map(L=>({autoForwardAction:L.autoForwardAction,port:L.port})):[]}async $registerCandidateFinder(i){if(i&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=i;const p=new g.MovingAverage;let _;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),M=(await this.findCandidatePorts()).filter($=>(0,h.isLocalhost)($.host)||(0,h.isAllInterfaces)($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map($=>$.port).join(", ")}`);const H=new Date().getTime()-R;p.update(H),(!_||JSON.stringify(_)!==JSON.stringify(M))&&(_=M,await this._proxy.$onFoundNewCandidates(_)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(p.value)))}}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter()),i.tunnelFactory){this._forwardPortProvider=i.tunnelFactory;let p=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const _=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:p}:void 0;this._proxy.$setTunnelProvider(_)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(i,p){if(this._extensionTunnels.has(i.host)){const _=this._extensionTunnels.get(i.host);_.has(i.port)&&(p&&_.get(i.port).disposeListener.dispose(),await _.get(i.port).tunnel.dispose(),_.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,p){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(i,p);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const R=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const M=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:R,disposeListener:M}),y.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const p=await Promise.all(i.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),_=i.filter((R,M)=>p[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(R=>R.port).join(", ")} to ${_.map(R=>R.port).join(", ")}`),_}async findCandidatePorts(){let i="",p="";try{i=await A.Promises.readFile("/proc/net/tcp","utf8"),p=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const _=r(i,p),R=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,V,x)=>{U(V)})}),M=m(R),H=await A.Promises.readdir("/proc"),$=[];for(const U of H)try{const F=Number(U),V=D.joinPath(T.URI.file("/proc"),U);if((await A.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(F)){const Q=await A.Promises.readlink(D.joinPath(V,"cwd").fsPath),K=await A.Promises.readFile(D.joinPath(V,"cmdline").fsPath,"utf8");$.push({pid:F,cwd:Q,cmd:K})}}catch{}const L=[],B=_.filter(U=>{const F=M[U.socket];return F||L.push(U),F}),O=l(B,M,$);let z;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${L.length}`),L.length>0){const U=await new Promise(F=>{(0,S.exec)("ps -F -A -l | grep root",(V,x,Q)=>{F(x)})});this._foundRootPorts=a(L,U,this._foundRootPorts),z=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return O.then(U=>z?U.concat(z):U)}};d=je([$e(0,t.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,f.ILogService)],d),e.ExtHostTunnelService=d}),define(Ce[279],De([1,0,18,23,21,11,4,6,112,239,56]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(_,R){try{return JSON.stringify(_,R)}catch{return"null"}}const y="$$ref$$",w={[y]:-1};class h{constructor(R,M){this.jsonString=R,this.referencedBuffers=M}}function g(_,R=null,M=!1){const H=[];return{jsonString:(M?E:JSON.stringify)(_,(L,B)=>{if(typeof B>"u")return w;if(typeof B=="object"){if(B instanceof t.VSBuffer){const O=H.push(B)-1;return{[y]:O}}if(R)return R(L,B)}return B}),referencedBuffers:H}}e.stringifyJsonWithBufferRefs=g;function f(_,R,M){return JSON.parse(_,(H,$)=>{if($){const L=$[y];if(typeof L=="number")return R[L];if(M&&$.$mid===1)return M.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=f;function v(_,R){return JSON.stringify(_,R)}function m(_){return _?(R,M)=>M&&M.$mid===1?_.transformOutgoing(M):M:null}var r;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},u=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class l extends T.Disposable{constructor(R,M=null,H=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=M,this._uriTransformer=H,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,L=A.ProxyIdentifier.count;$<L;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,S.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:M,sid:H}=R;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,H)),this._proxies[M]}_createProxy(R,M){const H={get:($,L)=>(typeof L=="string"&&!$[L]&&L.charCodeAt(0)===36&&($[L]=(...B)=>this._remoteCall(R,L,B)),L===s?M:$[L])};return new Proxy(Object.create(null),H)}set(R,M){return this._locals[R.nid]=M,M}assertRegistered(R){for(let M=0,H=R.length;M<H;M++){const $=R[M];if(!this._locals[$.nid])throw new Error(`Missing proxy instance ${$.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const M=R.byteLength,H=a.read(R,0),$=H.readUInt8(),L=H.readUInt32();switch($){case 1:case 2:{let{rpcId:B,method:O,args:z}=n.deserializeRequestJSONArgs(H);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(M,L,B,O,z,$===2);break}case 3:case 4:{let{rpcId:B,method:O,args:z}=n.deserializeRequestMixedArgs(H);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(M,L,B,O,z,$===4);break}case 5:{this._logger?.logIncoming(M,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(M,L);break}case 7:{this._receiveReply(M,L,void 0);break}case 9:{let B=n.deserializeReplyOKJSON(H);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(M,L,B);break}case 10:{const B=n.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(M,L,B);break}case 8:{const B=n.deserializeReplyOKVSBuffer(H);this._receiveReply(M,L,B);break}case 11:{let B=n.deserializeReplyErrError(H);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(M,L,B);break}case 12:{this._receiveReplyErr(M,L,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,M,H,$,L,B){this._logger?.logIncoming(R,M,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(H)}.${$}(`,L);const O=String(M);let z,U;if(B){const V=new I.CancellationTokenSource;L.push(V.token),z=this._invokeHandler(H,$,L),U=()=>V.cancel()}else z=this._invokeHandler(H,$,L),U=o;this._cancelInvokedHandlers[O]=U;const F=n.serializeAcknowledged(M);this._logger?.logOutgoing(F.byteLength,M,1,"ack"),this._protocol.send(F),z.then(V=>{delete this._cancelInvokedHandlers[O];const x=n.serializeReplyOK(M,V,this._uriReplacer);this._logger?.logOutgoing(x.byteLength,M,1,"reply:",V),this._protocol.send(x)},V=>{delete this._cancelInvokedHandlers[O];const x=n.serializeReplyErr(M,V);this._logger?.logOutgoing(x.byteLength,M,1,"replyErr:",V),this._protocol.send(x)})}_receiveCancel(R,M){this._logger?.logIncoming(R,M,1,"receiveCancel");const H=String(M);this._cancelInvokedHandlers[H]?.()}_receiveReply(R,M,H){this._logger?.logIncoming(R,M,0,"receiveReply:",H);const $=String(M);if(!this._pendingRPCReplies.hasOwnProperty($))return;const L=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],L.resolveOk(H)}_receiveReplyErr(R,M,H){this._logger?.logIncoming(R,M,0,"receiveReplyErr:",H);const $=String(M);if(!this._pendingRPCReplies.hasOwnProperty($))return;const L=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let B;H&&(H.$isError?(B=new Error,B.name=H.name,B.message=H.message,B.stack=H.stack):B=H),L.resolveErr(B)}_invokeHandler(R,M,H){try{return Promise.resolve(this._doInvokeHandler(R,M,H))}catch($){return Promise.reject($)}}_doInvokeHandler(R,M,H){const $=this._locals[R];if(!$)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(R));const L=$[M];if(typeof L!="function")throw new Error("Unknown method "+M+" on actor "+(0,A.getStringIdentifierForProxy)(R));return L.apply($,H)}_remoteCall(R,M,H){if(this._isDisposed)return new D.CanceledLazyPromise;let $=null;if(H.length>0&&I.CancellationToken.isCancellationToken(H[H.length-1])&&($=H.pop()),$&&$.isCancellationRequested)return Promise.reject(P.canceled());const L=n.serializeRequestArguments(H,this._uriReplacer),B=++this._lastMessageId,O=String(B),z=new D.LazyPromise;$&&$.onCancellationRequested(()=>{const F=n.serializeCancel(B);this._logger?.logOutgoing(F.byteLength,B,0,"cancel"),this._protocol.send(n.serializeCancel(B))}),this._pendingRPCReplies[O]=z,this._onWillSendRequest(B);const U=n.serializeRequest(B,R,M,L,!!$);return this._logger?.logOutgoing(U.byteLength,B,0,`request: ${(0,A.getStringIdentifierForProxy)(R)}.${M}(`,H),this._protocol.send(U),z}}e.RPCProtocol=l,k=u,l.UNRESPONSIVE_TIME=3*1e3;class a{static alloc(R,M,H){const $=new a(t.VSBuffer.alloc(H+1+4),0);return $.writeUInt8(R),$.writeUInt32(M),$}static read(R,M){return new a(R,M)}get buffer(){return this._buff}constructor(R,M){this._buff=R,this._offset=M}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,H}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,H}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,M}static sizeMixedArray(R){let M=0;M+=1;for(let H=0,$=R.length;H<$;H++){const L=R[H];switch(M+=1,L.type){case 1:M+=this.sizeLongString(L.value);break;case 2:M+=this.sizeVSBuffer(L.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(L.value);for(let B=0;B<L.buffers.length;++B)M+=this.sizeVSBuffer(L.buffers[B]);break;case 4:break}}return M}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let M=0,H=R.length;M<H;M++){const $=R[M];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let L=0;L<$.buffers.length;++L)this.writeBuffer($.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(R);for(let H=0;H<R;H++)switch(this.readUInt8()){case 1:M[H]=this.readLongString();break;case 2:M[H]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),B=this.readLongString(),O=[];for(let z=0;z<L;++z)O.push(this.readVSBuffer());M[H]=new A.SerializableObjectWithBuffers(f(B,O,null));break}case 4:M[H]=void 0;break}return M}}a.sizeUInt32=4;var d;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(d||(d={}));class n{static _useMixedArgSerialization(R){for(let M=0,H=R.length;M<H;M++)if(R[M]instanceof t.VSBuffer||R[M]instanceof A.SerializableObjectWithBuffers||typeof R[M]>"u")return!0;return!1}static serializeRequestArguments(R,M){if(this._useMixedArgSerialization(R)){const H=[];for(let $=0,L=R.length;$<L;$++){const B=R[$];if(B instanceof t.VSBuffer)H[$]={type:2,value:B};else if(typeof B>"u")H[$]={type:4};else if(B instanceof A.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:z}=g(B.value,M);H[$]={type:3,value:t.VSBuffer.fromString(O),buffers:z}}else H[$]={type:1,value:t.VSBuffer.fromString(v(B,M))}}return{type:1,args:H}}return{type:0,args:v(R,M)}}static serializeRequest(R,M,H,$,L){switch($.type){case 0:return this._requestJSONArgs(R,M,H,$.args,L);case 1:return this._requestMixedArgs(R,M,H,$.args,L)}}static _requestJSONArgs(R,M,H,$,L){const B=t.VSBuffer.fromString(H),O=t.VSBuffer.fromString($);let z=0;z+=a.sizeUInt8(),z+=a.sizeShortString(B),z+=a.sizeLongString(O);const U=a.alloc(L?2:1,R,z);return U.writeUInt8(M),U.writeShortString(B),U.writeLongString(O),U.buffer}static deserializeRequestJSONArgs(R){const M=R.readUInt8(),H=R.readShortString(),$=R.readLongString();return{rpcId:M,method:H,args:JSON.parse($)}}static _requestMixedArgs(R,M,H,$,L){const B=t.VSBuffer.fromString(H);let O=0;O+=a.sizeUInt8(),O+=a.sizeShortString(B),O+=a.sizeMixedArray($);const z=a.alloc(L?4:3,R,O);return z.writeUInt8(M),z.writeShortString(B),z.writeMixedArray($),z.buffer}static deserializeRequestMixedArgs(R){const M=R.readUInt8(),H=R.readShortString(),$=R.readMixedArray(),L=new Array($.length);for(let B=0,O=$.length;B<O;B++){const z=$[B];typeof z=="string"?L[B]=JSON.parse(z):L[B]=z}return{rpcId:M,method:H,args:L}}static serializeAcknowledged(R){return a.alloc(5,R,0).buffer}static serializeCancel(R){return a.alloc(6,R,0).buffer}static serializeReplyOK(R,M,H){if(typeof M>"u")return this._serializeReplyOKEmpty(R);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,M);if(M instanceof A.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:L}=g(M.value,H,!0);return this._serializeReplyOKJSONWithBuffers(R,$,L)}else return this._serializeReplyOKJSON(R,E(M,H))}static _serializeReplyOKEmpty(R){return a.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,M){let H=0;H+=a.sizeVSBuffer(M);const $=a.alloc(8,R,H);return $.writeVSBuffer(M),$.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,M){const H=t.VSBuffer.fromString(M);let $=0;$+=a.sizeLongString(H);const L=a.alloc(9,R,$);return L.writeLongString(H),L.buffer}static _serializeReplyOKJSONWithBuffers(R,M,H){const $=t.VSBuffer.fromString(M);let L=0;L+=a.sizeUInt32,L+=a.sizeLongString($);for(const O of H)L+=a.sizeVSBuffer(O);const B=a.alloc(10,R,L);B.writeUInt32(H.length),B.writeLongString($);for(const O of H)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(R){const M=R.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(R,M){const H=R.readUInt32(),$=R.readLongString(),L=[];for(let B=0;B<H;++B)L.push(R.readVSBuffer());return new A.SerializableObjectWithBuffers(f($,L,M))}static serializeReplyErr(R,M){const H=M?E(P.transformErrorForSerialization(M),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(R);const $=t.VSBuffer.fromString(H);let L=0;L+=a.sizeLongString($);const B=a.alloc(11,R,L);return B.writeLongString($),B.buffer}static deserializeReplyErrError(R){const M=R.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(R){return a.alloc(12,R,0).buffer}}var i;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(i||(i={}));var p;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(p||(p={}))}),define(Ce[280],De([1,0,4,43,52,3,38,11,18]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new c.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new c.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(h=>w.push(h)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new A);function k(y,w,h,g,f){return(0,S.createCancelablePromise)(async v=>{await(0,C.whenProviderRegistered)(h,g);const m=t.Registry.as(e.Extensions.OutputChannels);try{await E(h,1,g,f,v),m.registerChannel({id:y,label:w,file:h,log:!0})}catch(r){(0,T.isCancellationError)(r)||f.error("Error while registering log channel",h.toString(),(0,T.getErrorMessage)(r))}})}e.registerLogChannel=k;async function E(y,w,h,g,f){if(!await h.exists(y)){if(f.isCancellationRequested)throw new T.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",y.toString()),await(0,S.timeout)(1e3,f),await E(y,w+1,h,g,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Ce[140],De([1,0,5,3,16,26,13,280,69,25,46,153,23,12,38,4,6,27]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class v extends C.AbstractMessageLogger{get disposed(){return this._disposed}constructor(o,u,s,l,a){super(),this.id=o,this.name=u,this.logger=s,this.proxy=l,this.extension=a,this.offset=0,this._disposed=!1,this.visible=!1,this._register(s.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.logger.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const o=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,o)}replace(o){const u=this.offset;this.info(o),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,u),this.visible&&this.logger.flush()}show(o,u){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof o=="boolean"?o:u))}hide(){this.proxy.$close(this.id)}log(o,u){this.offset+=E.VSBuffer.fromString(u).byteLength,(0,C.log)(this.logger,o,u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class m extends v{appendLine(o){this.append(o)}}let r=class{constructor(o,u,s,l,a,d){this.initData=u,this.extHostFileSystem=s,this.extHostFileSystemInfo=l,this.loggerService=a,this.logService=d,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=o.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(u.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.visibleChannelId=o;for(const[u,s]of this.channels)s.visible=u===this.visibleChannelId}createOutputChannel(o,u,s){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const l=typeof u=="object"&&u.log;l&&(0,f.checkProposedApiEnabled)(s,"extensionLog");const a=(0,y.isString)(u)?u:void 0;if((0,y.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");const d=this.getDefaultLogLevel(s),n=l?this.doCreateLogOutputChannel(o,d,s):this.doCreateOutputChannel(o,a,s);return n.then(i=>{this.channels.set(i.id,i),i.visible=i.id===this.visibleChannelId}),l?this.createExtHostLogOutputChannel(o,d,n):this.createExtHostOutputChannel(o,n)}async doCreateOutputChannel(o,u,s){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const l=await this.outputDirectoryPromise,a=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),n=await this.proxy.$register(o,a,!1,u,s.identifier.value);return new v(n,o,d,this.proxy,s)}async doCreateLogOutputChannel(o,u,s){const l=await this.createExtensionLogDirectory(s),a=this.extHostFileSystemInfo.extUri.joinPath(l,`${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(a,{name:o},u),n=await this.proxy.$register(o,a,!0,void 0,s.identifier.value);return new m(n,o,d,this.proxy,s)}getDefaultLogLevel(o){let u;const s=this.initData.environment.extensionLogLevel?.find(([l])=>P.ExtensionIdentifier.equals(o.identifier,l))?.[1];return s&&(u=(0,C.parseLogLevel)(s)),u??this.logService.getLevel()}createExtensionLogDirectory(o){let u=this.extensionLogDirectoryPromise.get(o.identifier.value);if(!u){const s=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,o.identifier.value);this.extensionLogDirectoryPromise.set(o.identifier.value,u=(async()=>{try{await this.extHostFileSystem.value.createDirectory(s)}catch(l){if((0,w.toFileSystemProviderErrorCode)(l)!==w.FileSystemProviderErrorCode.FileExists)throw l}return s})())}return u}createExtHostOutputChannel(o,u){let s=!1;const l=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return o},append(a){l(),u.then(d=>d.append(a))},appendLine(a){l(),u.then(d=>d.appendLine(a))},clear(){l(),u.then(a=>a.clear())},replace(a){l(),u.then(d=>d.replace(a))},show(a,d){l(),u.then(n=>n.show(a,d))},hide(){l(),u.then(a=>a.hide())},dispose(){s=!0,u.then(a=>a.dispose())}}}createExtHostLogOutputChannel(o,u,s){const l=new g.DisposableStore,a=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},d=l.add(new h.Emitter);return s.then(n=>{l.add(n),l.add(n.onDidChangeLogLevel(i=>{u=i,d.fire(i)}))}),{...this.createExtHostOutputChannel(o,s),get logLevel(){return u},onDidChangeLogLevel:d.event,trace(n,...i){a(),s.then(p=>p.trace(n,...i))},debug(n,...i){a(),s.then(p=>p.debug(n,...i))},info(n,...i){a(),s.then(p=>p.info(n,...i))},warn(n,...i){a(),s.then(p=>p.warn(n,...i))},error(n,...i){a(),s.then(p=>p.error(n,...i))},dispose(){l.dispose()}}}};r=je([$e(0,I.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,S.IExtHostConsumerFileSystem),$e(3,A.IExtHostFileSystemInfo),$e(4,C.ILoggerService),$e(5,C.ILogService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Ce[281],De([1,0,3]),function(J,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(Ce[282],De([1,0,32,14,9,10,22,2,3,208,45,225,281]),function(J,e,c,t,I,P,C,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class ni{constructor(h,g,f,v){this.localUserHome=h,this.remoteAgentService=g,this.environmentService=f,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome??h})()}hasValidBasename(h,g,f){return typeof g=="string"||typeof g>"u"?this.resolveOS.then(v=>this.doHasValidBasename(h,v,g)):this.doHasValidBasename(h,g,f)}doHasValidBasename(h,g,f){return h.scheme===t.Schemas.file||h.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(f??(0,C.basename)(h),g===1):!0}get defaultUriScheme(){return ni.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,g){if(h.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,D.getVirtualWorkspaceScheme)(g.getWorkspace());if(f)return f;const v=g.getWorkspace().folders[0];if(v)return v.uri.scheme;const m=g.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?I.win32:I.posix)}async fileURI(h){let g="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(g=h.substring(2),h="/"):(g=h.substring(2,v),h=h.substring(v)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:g,path:h,query:"",fragment:""})}};y=je([$e(1,E.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,A.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(Ce[72],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(C,T){this.line=C,this.character=T}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,T){return new c(0,0)}with(C){return new c(0,0)}}e.Position=c;class t{constructor(C,T,S,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(C,T),this.end=new c(S,D)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new t(0,0,0,0)}with(C){return new t(0,0,0,0)}}e.Range=t;var I;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[30],De([1,0,17,37,24,32,8,3,9,11,72,18]),function(J,e,c,t,I,P,C,T,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",y=" characters skipped \u27EB",w=(E.length+y.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var h;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function f(K){return!!K.preview}e.resultIsMatch=f;function v(K){return!!K.resource}e.isFileMatch=v;function m(K){return!!K.message}e.isProgressMessage=m;var r;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=b;class o{constructor(ue,te,he){this.ranges=te;const Y=Array.isArray(te)?te:[te];if(he&&he.matchLines===1&&u(Y)){ue=(0,C.getNLines)(ue,he.matchLines);let fe="",be=0,ke=0;const Re=Math.floor(he.charsPerLine/5),ze=[];for(const oe of Y){const le=Math.max(oe.startColumn-Re,0),ge=oe.startColumn+he.charsPerLine;if(le>ke+Re+w){const Z=E+(le-ke)+y;fe+=Z+ue.slice(le,ge),be+=le-(ke+Z.length)}else fe+=ue.slice(ke,ge);ze.push(new l(0,oe.startColumn-be,oe.endColumn-be)),ke=ge}this.preview={text:fe,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const fe=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ue,matches:(0,c.mapArrayOrNot)(te,be=>new s(be.startLineNumber-fe,be.startColumn,be.endLineNumber-fe,be.endColumn))}}}}e.TextSearchMatch=o;function u(K){const ue=K[0].startLineNumber;for(const te of K)if(te.startLineNumber!==ue||te.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,te,he,Y){this.startLineNumber=ue,this.startColumn=te,this.endLineNumber=he,this.endColumn=Y}}e.SearchRange=s;class l extends s{constructor(ue,te,he){super(ue,te,ue,he)}}e.OneLineRange=l;var a;(function(K){K.List="list",K.Tree="tree"})(a=e.ViewMode||(e.ViewMode={}));var d;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function n(K,ue=!0){const te=K&&K.files&&K.files.exclude,he=ue&&K&&K.search&&K.search.exclude;if(!te&&!he)return;if(!te||!he)return te||he;let Y=Object.create(null);return Y=I.mixin(Y,I.deepClone(te)),Y=I.mixin(Y,I.deepClone(he),!0),Y}e.getExcludes=n;function i(K,ue){return K.excludePattern&&t.match(K.excludePattern,ue)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,ue)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(te=>{const he=te.folder.fsPath;if(P.isEqualOrParent(ue,he)){const Y=S.relative(he,ue);return!te.includePattern||!!t.match(te.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var p;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(ue,te){super(ue),this.code=te}}e.SearchError=_;function R(K){const ue=K.message;if((0,D.isCancellationError)(K))return new _(ue,p.canceled);try{const te=JSON.parse(ue);return new _(te.message,te.code)}catch{return new _(ue,p.other)}}e.deserializeSearchError=R;function M(K){const ue={message:K.message,code:K.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=M;function H(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=H;function $(K){return K.type==="success"}e.isSerializedSearchSuccess=$;function L(K){return!!K.path}e.isSerializedFileMatch=L;function B(K,ue){const te=K.searchPath?K.searchPath:K.relativePath;return(0,C.fuzzyContains)(te,ue)}e.isFilePatternMatch=B;class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(K,ue){const te={...K||{},...ue||{}};return Object.keys(te).filter(he=>{const Y=te[he];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=z;class U{constructor(ue,te){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=ue.includePattern;te.includePattern&&(he?he={...he,...te.includePattern}:he=te.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(ue,te,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,te,he))}includedInQuerySync(ue,te,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,te,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,te,he))}includedInQuery(ue,te,he){const Y=this._parsedExcludeExpression(ue,te,he),fe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,te,he):!0;return(0,k.isThenable)(Y)?Y.then(be=>be?!1:fe()):fe()}hasSiblingExcludeClauses(){return F(this._excludeExpression)}}e.QueryGlobTester=U;function F(K){for(const ue in K)if(typeof K[ue]!="boolean")return!0;return!1}function V(K){if(!K)return;let ue;return te=>(ue||(ue=(K()||Promise.resolve([])).then(he=>he?Q(he):{})),ue.then(he=>!!he[te]))}e.hasSiblingPromiseFn=V;function x(K){if(!K)return;let ue;return te=>{if(!ue){const he=K();ue=he?Q(he):{}}return!!ue[te]}}e.hasSiblingFn=x;function Q(K){const ue={};for(const te of K)ue[te]=!0;return ue}}),define(Ce[33],De([1,0,17,18,21,4,6,63,14,99,22,8,12,2,177,3,13,196,45,46,25,16,15,7,54,30,5]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r,b,o,u,s,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d($,L,B){return new A.ExtUri(O=>_(O,B)).isEqual($,L)}function n($,L,B){return d($.uri,L.uri,B)?0:(0,k.compare)($.uri.toString(),L.uri.toString())}function i($,L,B){return $.index!==L.index?$.index<L.index?-1:1:d($.uri,L.uri,B)?(0,k.compare)($.name,L.name):(0,k.compare)($.uri.toString(),L.uri.toString())}function p($,L,B,O){const z=$.slice(0).sort((F,V)=>B(F,V,O)),U=L.slice(0).sort((F,V)=>B(F,V,O));return(0,c.delta)(z,U,(F,V)=>B(F,V,O))}function _($,L){const B=L.getCapabilities($.scheme);return!(B&&B&1024)}class R extends v.Workspace{static toExtHostWorkspace(L,B,O,z){if(!L)return{workspace:null,added:[],removed:[]};const{id:U,name:F,folders:V,configuration:x,transient:Q,isUntitled:K}=L,ue=[],te=B;B?V.forEach((be,ke)=>{const Re=y.URI.revive(be.uri),ze=R._findFolder(O||B,Re,z);ze?(ze.name=be.name,ze.index=be.index,ue.push(ze)):ue.push({uri:Re,name:be.name,index:ke})}):ue.push(...V.map(({uri:be,name:ke,index:Re})=>({uri:y.URI.revive(be),name:ke,index:Re}))),ue.sort((be,ke)=>be.index<ke.index?-1:1);const he=new R(U,F,ue,!!Q,x?y.URI.revive(x):null,!!K,be=>_(be,z)),{added:Y,removed:fe}=p(te?te.workspaceFolders:[],he.workspaceFolders,n,z);return{workspace:he,added:Y,removed:fe}}static _findFolder(L,B,O){for(let z=0;z<L.folders.length;z++){const U=L.workspaceFolders[z];if(d(U.uri,B,O))return U}}constructor(L,B,O,z,U,F,V){super(L,O.map(x=>new v.WorkspaceFolder(x)),z,U,V),this._name=B,this._isUntitled=F,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(V),O.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let M=class{constructor(L,B,O,z,U){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=z,this._extHostFileSystemInfo=O,this._uriTransformerService=U,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(a.MainContext.MainThreadMessageService);const F=B.workspace;this._confirmedWorkspace=F?new R(F.id,F.name,[],!!F.transient,F.configuration?y.URI.revive(F.configuration):null,!!F.isUntitled,V=>_(V,O)):void 0}$initializeWorkspace(L,B){this._trusted=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?y.URI.from({scheme:S.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,O,...z){const U=[];if(Array.isArray(z)&&z.forEach(K=>{y.URI.isUri(K.uri)&&!U.some(ue=>d(ue.uri,K.uri,this._extHostFileSystemInfo))&&U.push({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[B,O].some(K=>typeof K!="number"||K<0)||O===0&&U.length===0)return!1;const F=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+O>F.length)return!1;const V=F.slice(0);V.splice(B,O,...U.map(K=>({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<V.length;K++){const ue=V[K];if(V.some((te,he)=>he!==K&&d(ue.uri,te.uri,this._extHostFileSystemInfo)))return!1}V.forEach((K,ue)=>K.index=ue);const{added:x,removed:Q}=p(F,V,i,this._extHostFileSystemInfo);if(x.length===0&&Q.length===0)return!1;if(this._proxy){const K=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(K,B,O,U).then(void 0,ue=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(f.Severity.Error,(0,w.localize)(0,null,K,ue.toString()),te,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,B){let O,z="";if(typeof L=="string"?(O=y.URI.file(L),z=L):typeof L<"u"&&(O=L,z=L.fsPath),!O)return z;const U=this.getWorkspaceFolder(O,!0);if(!U)return z;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let F=(0,A.relativePath)(U.uri,O);return B&&U.name&&(F=`${U.name}/${F}`),F}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:O,removed:z}=R.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:z}))}findFiles(L,B,O,z,U=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let F;if(B===null?F=!1:B&&(typeof B=="string"?F=B:F=B.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:x}=H(o.GlobPattern.from(L));return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(V),(0,E.withUndefinedAsNull)(x),(0,E.withUndefinedAsNull)(F),(0,E.withUndefinedAsNull)(O),U).then(Q=>Array.isArray(Q)?Q.map(K=>y.URI.revive(K)):[])}async findTextInFiles(L,B,O,z,U=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const F=this._requestIdProvider.getNext(),V=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:x,folder:Q}=H(o.GlobPattern.from(B.include)),K=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ue={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:x,excludePattern:K},te=!1;if(this._activeSearchCallbacks[F]=he=>{if(te)return;const Y=y.URI.revive(he.resource);he.results.forEach(fe=>{(0,l.resultIsMatch)(fe)?O({uri:Y,preview:{text:fe.preview.text,matches:(0,c.mapArrayOrNot)(fe.preview.matches,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,c.mapArrayOrNot)(fe.ranges,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):O({uri:Y,text:fe.text,lineNumber:fe.lineNumber})})},U.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch(L,(0,E.withUndefinedAsNull)(Q),ue,F,U);return delete this._activeSearchCallbacks[F],he||{}}catch(he){throw delete this._activeSearchCallbacks[F],he}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]?.(L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,B){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,B);const O=this._uriTransformerService.transformOutgoingScheme(L),z=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(z,O),(0,C.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(L,B){this._logService.info("Getting edit session identifier for workspaceFolder",L);const O=await this.resolveWorkspaceFolder(y.URI.revive(L));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const z=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!z),!z)return;const U=await z.provideEditSessionIdentity(O,B);if(this._logService.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(L,B,O,z){this._logService.info("Getting edit session identifier for workspaceFolder",L);const U=await this.resolveWorkspaceFolder(y.URI.revive(L));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const F=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!F),!F)return;const V=await F.provideEditSessionIdentityMatch?.(B,O,z);if(this._logService.info("Provider returned edit session identifier match result: ",V),!!V)return V}};M=je([$e(0,b.IExtHostRpcService),$e(1,r.IExtHostInitDataService),$e(2,m.IExtHostFileSystemInfo),$e(3,g.ILogService),$e(4,s.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function H($){let L,B;return $&&(typeof $=="string"?L=$:(L=$.pattern,B=y.URI.revive($.baseUri))),{includePattern:L,folder:B}}}),define(Ce[34],De([1,0,24,4,33,5,7,199,126,12,18,3,16,13,2]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(u,s){if(s){const l=s.split(".");let a=u;for(let d=0;a&&d<l.length;d++)a=a[l[d]];return a}}function g(u){return u instanceof w.URI}function f(u){return u&&u.uri instanceof w.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function m(u){return u&&u.uri instanceof w.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function r(u){if(g(u))return{resource:u};if(f(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(m(u))return{resource:u.uri};if(u===null)return{resource:null}}let b=class{constructor(s,l,a){this._proxy=s.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=a,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new o(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,l))}};b=je([$e(0,E.IExtHostRpcService),$e(1,I.IExtHostWorkspace),$e(2,y.ILogService)],b),e.ExtHostConfiguration=b;class o{constructor(s,l,a,d){this._onDidChangeConfiguration=new t.Emitter,this._proxy=s,this._logService=d,this._extHostWorkspace=l,this._configuration=T.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,l){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,a))}getConfiguration(s,l,a){const d=r(l)||{},n=this._toReadonlyValue(s?h(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,d,a?.identifier);function i(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(_){return typeof h(n,_)<"u"},get:(_,R)=>{this._validateConfigurationAccess(s?`${s}.${_}`:_,d,a?.identifier);let M=h(n,_);if(typeof M>"u")M=R;else{let H;const $=(L,B)=>{let O;const z=()=>{H=H||(0,c.deepClone)(n),O=O||h(H,B)};return(0,D.isObject)(L)?new Proxy(L,{get:(U,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return z(),()=>O;if(H)return O=O||h(H,B),O[F];const V=U[F];return typeof F=="string"?$(V,`${B}.${F}`):V},set:(U,F,V)=>(z(),O&&(O[F]=V),!0),deleteProperty:(U,F)=>(z(),O&&delete O[F],!0),defineProperty:(U,F,V)=>(z(),O&&Object.defineProperty(O,F,V),!0)}):L};M=$(M,_)}return M},update:(_,R,M,H)=>{_=s?`${s}.${_}`:_;const $=i(M);return R!==void 0?this._proxy.$updateConfigurationOption($,_,R,d,H):this._proxy.$removeConfigurationOption($,_,d,H)},inspect:_=>{_=s?`${s}.${_}`:_;const R=this._configuration.inspect(_,d,this._extHostWorkspace.workspace);if(R)return{key:_,defaultValue:(0,c.deepClone)(R.policy?.value??R.default?.value),globalValue:(0,c.deepClone)(R.user?.value??R.application?.value),workspaceValue:(0,c.deepClone)(R.workspace?.value),workspaceFolderValue:(0,c.deepClone)(R.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(R.default?.override),globalLanguageValue:(0,c.deepClone)(R.user?.override??R.application?.override),workspaceLanguageValue:(0,c.deepClone)(R.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(R.workspaceFolder?.override),languageIds:(0,c.deepClone)(R.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(p,n,!1),Object.freeze(p)}_toReadonlyValue(s){const l=a=>(0,D.isObject)(a)?new Proxy(a,{get:(d,n)=>l(d[n]),set:(d,n,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(d,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(d,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(s)}_validateConfigurationAccess(s,l,a){const d=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),n=a?`[${a.value}] `:"";if(d===4){typeof l?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){l?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,l){const a=new T.ConfigurationChangeEvent(s,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,n)=>a.affectsConfiguration(d,r(n))})}_toMap(s){return s.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[73],De([1,0,2,18,4,5,7,33,57,34,21,40,16,25,3,14,10,13,68,238,11]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var l;(function(B){function O(F){if(F){const V=F;return V&&!!V.process}else return!1}B.is=O;function z(F){if(F==null)return;const V={process:F.process,args:F.args};return F.options&&(V.options=s.from(F.options)),V}B.from=z;function U(F){if(F!=null)return new C.ProcessExecution(F.process,F.args,F.options)}B.to=U})(l=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(B){function O(U){if(U!=null)return U}B.from=O;function z(U){if(U!=null)return U}B.to=z})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(B){function O(F){if(F){const V=F;return V&&(!!V.commandLine||!!V.command)}else return!1}B.is=O;function z(F){if(F==null)return;const V={};return F.commandLine!==void 0?V.commandLine=F.commandLine:(V.command=F.command,V.args=F.args),F.options&&(V.options=a.from(F.options)),V}B.from=z;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new C.ShellExecution(F.commandLine,F.options):new C.ShellExecution(F.command,F.args?F.args:[],F.options)}B.to=U})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var n;(function(B){function O(F){if(F){const V=F;return V&&V.customExecution==="customExecution"}else return!1}B.is=O;function z(F){return{customExecution:"customExecution"}}B.from=z;function U(F,V){return V.get(F)}B.to=U})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var i;(function(B){function O(z,U){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===C.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=m.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:F}}B.from=O})(i=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(B){function O(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}B.from=O})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function(B){function O(F,V){if(F==null)return[];const x=[];for(const Q of F){const K=z(Q,V);K&&x.push(K)}return x}B.fromMany=O;function z(F,V){if(F==null)return;let x;F.execution instanceof C.ProcessExecution?x=l.from(F.execution):F.execution instanceof C.ShellExecution?x=d.from(F.execution):F.execution&&F.execution instanceof C.CustomExecution&&(x=n.from(F.execution));const Q=o.from(F.definition);let K;return F.scope?typeof F.scope=="number"?K=F.scope:K=F.scope.uri:K=C.TaskScope.Workspace,!Q||!K?void 0:{_id:F._id,definition:Q,name:F.name,source:{extensionId:V.identifier.value,label:F.source,scope:K},execution:x,isBackground:F.isBackground,group:p.from(F.group),presentationOptions:u.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}B.from=z;async function U(F,V,x){if(F==null)return;let Q;l.is(F.execution)?Q=l.to(F.execution):d.is(F.execution)?Q=d.to(F.execution):n.is(F.execution)&&(Q=n.to(F._id,x));const K=o.to(F.definition);let ue;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ue=F.source.scope:ue=await V.resolveWorkspaceFolder(c.URI.revive(F.source.scope)):ue=C.TaskScope.Workspace),!K||!ue)return;const te=new C.Task(K,ue,F.name,F.source.label,Q,F.problemMatchers);return F.isBackground!==void 0&&(te.isBackground=F.isBackground),F.group!==void 0&&(te.group=C.TaskGroup.from(F.group._id),te.group&&F.group.isDefault&&(te.group=new C.TaskGroup(te.group.id,te.group.label),F.group.isDefault===!0&&(te.group.isDefault=F.group.isDefault))),F.presentationOptions&&(te.presentationOptions=u.to(F.presentationOptions)),F._id&&(te._id=F._id),F.detail&&(te.detail=F.detail),te}B.to=U})(_=e.TaskDTO||(e.TaskDTO={}));var R;(function(B){function O(U){return U}B.from=O;function z(U){if(!!U)return Object.assign(Object.create(null),U)}B.to=z})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(O,z,U){this._id=z,this._task=U,b.set(this,void 0),tt(this,b,O,"f")}get task(){return this._task}terminate(){Be(this,b,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}b=new WeakMap;var H;(function(B){function O(z){return{id:z._id,task:void 0}}B.from=O})(H=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(O,z,U,F,V,x,Q,K){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=O.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=V,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,z,U){if(!U)return new C.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:z,provider:U,extension:O}),this._proxy.$registerTaskProvider(F,z),new C.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(O,z){this._proxy.$registerTaskSystem(O,z)}fetchTasks(O){return this._proxy.$fetchTasks(R.from(O)).then(async z=>{const U=[];for(const F of z){const V=await _.to(F,this._workspaceProvider,this._providedCustomExecutions2);V&&U.push(V)}return U})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(z=>O.push(z)),O}terminateTask(O){if(!(O instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,z,U){const F=this._providedCustomExecutions2.get(O.id);F&&(this._activeCustomExecutions2.set(O.id,F),this._terminalService.attachPtyToTerminal(z,await F.callback(U))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){const z=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const z=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:z,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const z=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:O.exitCode})}$provideTasks(O,z){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));const F=[],V=(0,t.asPromise)(()=>U.provider.provideTasks(A.CancellationToken.None)).then(x=>this.provideTasksInternal(z,F,U,x));return new Promise(x=>{V.then(Q=>{Promise.all(F).then(()=>{x(Q)})})})}async $resolveTask(O,z){const U=this._handlers.get(O);if(!U)return Promise.reject(new Error("no handler found"));if(z.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await _.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const V=await U.provider.resolveTask(F,A.CancellationToken.None);if(!V)return;this.checkDeprecation(V,U);const x=_.from(V,U.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(x.execution)&&await this.addCustomExecution(x,V,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,z,U){const F=await this._proxy.$createTaskId(O);!U&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,z.execution)),this._providedCustomExecutions2.set(F,z.execution)}async getTaskExecution(O,z){if(typeof O=="string"){const V=this._taskExecutionPromises.get(O);if(!V)throw new r.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const U=this._taskExecutionPromises.get(O.id);if(U)return U;const F=new Promise((V,x)=>{function Q(K,ue,te){te?V(new M(K,ue.id,te)):x("Unexpected: Task does not exist.")}z?Q(this,O,z):_.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>Q(this,O,K))});return this._taskExecutionPromises.set(O.id,F),F.then(V=>(this._taskExecutions.set(O.id,V),V),V=>Promise.reject(V))}checkDeprecation(O,z){O._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));const U=this._notProvidedCustomExecutions.values();let F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};$=je([$e(0,E.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,f.ILogService),$e(7,v.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let L=class extends ${constructor(O,z,U,F,V,x,Q,K){super(O,z,U,F,V,x,Q,K),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(O,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const U=_.from(z,O);if(U===void 0)throw new Error("Task is not valid");if(n.is(U.execution))await this.addCustomExecution(U,z,!1);else throw new r.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),z);return this._proxy.$executeTask(U).catch(V=>{throw new Error(V)}),F}provideTasksInternal(O,z,U,F){const V=[];if(F)for(const x of F){this.checkDeprecation(x,U),(!x.definition||!O[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=_.from(x,U.extension);Q&&n.is(Q.execution)?(V.push(Q),z.push(this.addCustomExecution(Q,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:U.extension}}async resolveTaskInternal(O){if(n.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,z,U){}};L=je([$e(0,E.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,f.ILogService),$e(7,v.IExtHostApiDeprecationService)],L),e.WorkerExtHostTask=L,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(Ce[283],De([1,0,9,21,50,37,22,51,30]),function(J,e,c,t,I,P,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(E,y,w){this.config=E,this.provider=y,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=E.filePattern,this.includePattern=E.includePattern&&P.parse(E.includePattern),this.maxResults=E.maxResults||void 0,this.exists=E.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=E.excludePattern&&P.parse(E.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(E=>E.cancel()),this.activeCancellationTokens=new Set}search(E){const y=this.config.folderQueries||[];return new Promise((w,h)=>{const g=f=>{this.resultCount++,E(f)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const v=f.toString(),m=c.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,m)||this.matchFile(g,{base:f,basename:m})}),Promise.all(y.map(f=>this.searchInFolder(f,g))).then(f=>{w({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{h(new Error((0,I.toErrorMessage)(f)))})})}async searchInFolder(E,y){const w=new t.CancellationTokenSource,h=this.getSearchOptionsForFolder(E),g=this.initDirectoryTree(),f=new S.QueryGlobTester(this.config,E),v=!f.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(w),m=T.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,w.token),b=m.elapsed(),o=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(u=>{const s=c.posix.relative(E.folder.path,u.path);if(v){const l=c.basename(u.path);this.matchFile(y,{base:E.folder,relativePath:s,basename:l});return}this.addDirectoryEntries(g,E.folder,s,y)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,f,y),{providerTime:b,postProcessTime:o.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(E){const y=(0,S.resolvePatternsForProvider)(this.config.includePattern,E.includePattern),w=(0,S.resolvePatternsForProvider)(this.config.excludePattern,E.excludePattern);return{folder:E.folder,excludes:w,includes:y,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}addDirectoryEntries({pathToEntries:E},y,w,h){if(w===this.filePattern){const f=c.basename(this.filePattern);this.matchFile(h,{base:y,relativePath:this.filePattern,basename:f})}function g(f){const v=c.basename(f),m=c.dirname(f);let r=E[m];r||(r=E[m]=[],g(m)),r.push({base:y,relativePath:f,basename:v})}g(w)}matchDirectoryTree({rootEntries:E,pathToEntries:y},w,h){const g=this,f=this.filePattern;function v(m){const r=(0,S.hasSiblingFn)(()=>m.map(b=>b.basename));for(let b=0,o=m.length;b<o;b++){const u=m[b],{relativePath:s,basename:l}=u;if(w.matchesExcludesSync(s,l,f!==l?r:void 0))continue;const a=y[s];if(a)v(a);else{if(s===f)continue;g.matchFile(h,u)}if(g.isLimitHit)break}}v(E)}matchFile(E,y){(!this.includePattern||y.relativePath&&this.includePattern(y.relativePath,y.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||E(y))}}class A{constructor(){this.sessions=new Map}fileSearch(E,y,w,h){const g=this.getSessionTokenSource(E.cacheKey),f=new D(E,y,g&&g.token);let v=0;const m=r=>{v+=r.length,w(r.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(f,A.BATCH_SIZE,m,h).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:r.stats}}))}clearCache(E){this.getSessionTokenSource(E)?.cancel()}getSessionTokenSource(E){if(!!E)return this.sessions.has(E)||this.sessions.set(E,new t.CancellationTokenSource),this.sessions.get(E)}rawMatchToSearchItem(E){return E.relativePath?{resource:C.joinPath(E.base,E.relativePath)}:{resource:E.base}}doSearch(E,y,w,h){h.onCancellationRequested(()=>{E.cancel()});const g=v=>{v&&(f.push(v),y>0&&f.length>=y&&(w(f),f=[]))};let f=[];return E.search(g).then(v=>(f.length&&w(f),v),v=>(f.length&&w(f),Promise.reject(v)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(Ce[284],De([1,0,17,78,37,111,28,14,9,22,8,12,2,161,188,66,13,45,132,282,30]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,_,R,M,H){this.configurationService=p,this.workspaceContextService=_,this.editorGroupsService=R,this.logService=M,this.pathService=H}text(p,_,R={}){p=this.getContentPattern(p,R);const M=this.configurationService.getValue(),H=_&&_.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(_?.map(f.toWorkspaceFolder),R),type:2,contentPattern:p,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:M.search.usePCRE2||H||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(p,_){const R=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const M={...p,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(p,_)&&(M.isCaseSensitive=!0),this.isMultiline(p)&&(M.isMultiline=!0),M}file(p,_={}){return{...this.commonQuery(p,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(p,_){return p?(p=Array.isArray(p)?p.map(a):a(p),_?this.parseSearchPaths(p):{pattern:u(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],_={}){const R=this.handleIncludeExclude(_.includePattern,_.expandPatterns),M=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),H=p.length>1,$=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,_,M)):p.map(O=>this.getFolderQueryForRoot(O,_,M,H))).filter(O=>!!O),L={_reason:_._reason,folderQueries:$,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:M.pattern,includePattern:R.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const O=c.coalesce(c.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(V=>V.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const z=O.filter(F=>(0,r.pathIncludedInQuery)(L,F.fsPath)),U=this.commonQueryFromFileList(z);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...L,...U}}const B=_.extraFileResources&&_.extraFileResources.filter(O=>(0,r.pathIncludedInQuery)(L,O.fsPath));return L.extraFileResources=B&&B.length?B:void 0,L}commonQueryFromFileList(p){const _=[],R=new C.ResourceMap,M={};let H=!1;return p.forEach($=>{if($.scheme===T.Schemas.walkThrough)return;if((0,D.isAbsolutePath)($)){const B=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:S.dirname($.fsPath)});let O=R.get(B);O||(H=!0,O={folder:B,includePattern:{}},_.push(O),R.set(B,O));const z=S.relative(B.fsPath,$.fsPath);(0,k.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else $.fsPath&&(H=!0,M[$.fsPath]=!0)}),{folderQueries:_,includePattern:M,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(p,_){if(_.isSmartCase){if(p.isRegExp){if(A.containsUppercaseCharacter(p.pattern,!0))return!0}else if(A.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,y.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const _=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),M=(Array.isArray(p)?p:s(p)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,P.untildify)(U,F.scheme===T.Schemas.file?F.fsPath:F.path):U}),H=t.groupBy(M,U=>_(U)?"searchPaths":"exprSegments"),$=(H.exprSegments||[]).map(U=>A.rtrim(U,"/")).map(U=>A.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),l(U))),L={},B=this.expandSearchPathPatterns(H.searchPaths||[]);B&&B.length&&(L.searchPaths=B);const O=c.flatten($),z=u(...O);return z&&(L.pattern=z),L}getExcludesForFolder(p,_){return _.disregardExcludeSettings?void 0:(0,r.getExcludes)(p,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const _=c.flatten(p.map(M=>{let{pathPortion:H,globPortion:$}=o(M);$&&($=d($));const L=this.expandOneSearchPath(H);return c.flatten(L.map(B=>this.resolveOneSearchPathPattern(B,$)))})),R=new Map;return _.forEach(M=>{const H=M.searchPath.toString(),$=R.get(H);$?M.pattern&&($.pattern=$.pattern||{},$.pattern[M.pattern]=!0):R.set(H,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(p){if(S.isAbsolute(p)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==T.Schemas.file?[{searchPath:_[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=a(p),p.startsWith("../")||p===".."){const M=S.posix.resolve(_.path,p);return[{searchPath:_.with({path:M})}]}const R=d(p);return[{searchPath:_,pattern:R}]}else{if(p==="./"||p===".\\")return[];{const _=p.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(H=>{const $=_.match(new RegExp(`^${A.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return $?{match:$,folder:H}:null}).filter(k.isDefined);if(M.length)return M.map(H=>{const $=H.match[1];return{searchPath:H.folder.uri,pattern:$&&d($)}});{const H=p.match(/\.[\/\\](.+)[\/\\]?/),$=H?H[1]:p,L=w.localize(0,null,$);throw new Error(L)}}}}resolveOneSearchPathPattern(p,_){const R=p.pattern&&_?`${p.pattern}/${_}`:p.pattern||_,M=[{searchPath:p.searchPath,pattern:R}];return R&&!R.endsWith("**")&&M.push({searchPath:p.searchPath,pattern:R+"/**"}),M}getFolderQueryForSearchPath(p,_,R){const M=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(p.searchPath),_,R,!1);return M?{...M,includePattern:p.pattern}:null}getFolderQueryForRoot(p,_,R,M){let H;const $=E.URI.isUri(p)?p:p.uri;if(R.searchPaths){const U=R.searchPaths.filter(F=>(0,D.isEqual)(F.searchPath,$))[0];if(U&&!U.pattern)return null;U&&(H=U.pattern)}const L=this.configurationService.getValue({resource:$}),O={...this.getExcludesForFolder(L,_)||{},...H||{}},z=E.URI.isUri(p)?(0,D.basename)(p):p.name;return{folder:$,folderName:M?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!L.search.followSymlinks}}};b=je([$e(0,h.IConfigurationService),$e(1,f.IWorkspaceContextService),$e(2,v.IEditorGroupsService),$e(3,g.ILogService),$e(4,m.IPathService)],b),e.QueryBuilder=b;function o(i){const p=i.match(/[\*\{\}\(\)\[\]\?]/);if(p){const _=p.index,R=i.substr(0,_).match(/[/|\\][^/\\]*$/);if(R){let M=i.substr(0,R.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:i.substr((R.index||0)+1)}}}return{pathPortion:i}}function u(...i){return i.length?i.reduce((p,_)=>(p[_]=!0,p),Object.create(null)):void 0}function s(i){return I.splitGlobAware(i,",").map(p=>p.trim()).filter(p=>!!p.length)}function l(i){return[`**/${i}/**`,`**/${i}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function a(i){return i.replace(/\\/g,"/")}function d(i){return a(i).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(i,p){i=c.distinct(i,M=>M.toString());const _=[],R=p.getWorkspace();return i&&i.forEach(M=>{let H;if(p.getWorkbenchState()===2)H=(0,D.relativePath)(R.folders[0].uri,M),H&&H!=="."&&(H="./"+H);else{const $=p.getWorkspaceFolder(M);if($){const L=$.name;if(R.folders.filter(O=>O.name===L).length===1){const O=(0,D.relativePath)($.uri,M);O===""?H=`./${$.name}`:H=`./${$.name}/${O}`}else H=M.fsPath}}H&&_.push(H)}),_}e.resolveResourcesForSearchIncludes=n}),define(Ce[285],De([1,0,22,2,21,11,3,284,30,45]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function k(h,g){const f=g.activationEvents;if(!f)return Promise.resolve(void 0);const v=[],m=[];for(const l of f)if(/^workspaceContains:/.test(l)){const a=l.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||h.forceUsingSearch?m.push(a):v.push(a)}if(v.length===0&&m.length===0)return Promise.resolve(void 0);let r;const b=new Promise((l,a)=>{r=l}),o=l=>r({activationEvent:l}),u=Promise.all(v.map(l=>E(h,l,o))).then(()=>{}),s=y(h,g.identifier,m,o);return Promise.all([u,s]).then(()=>{r(void 0)}),b}e.checkActivateWorkspaceContainsExtension=k;async function E(h,g,f){for(const v of h.folders)if(await h.exists(c.joinPath(t.URI.revive(v),g))){f(`workspaceContains:${g}`);return}}async function y(h,g,f,v){if(f.length===0)return Promise.resolve(void 0);const m=new I.CancellationTokenSource,r=h.checkExists(h.folders,f,m.token),b=setTimeout(async()=>{m.cancel(),h.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},A);let o=!1;try{o=await r}catch(u){P.isCancellationError(u)||P.onUnexpectedError(u)}m.dispose(),clearTimeout(b),o&&v(`workspaceContains:${f.join(",")}`)}function w(h,g,f,v){const m=h.get(C.IInstantiationService),r=h.get(S.ISearchService),o=m.createInstance(T.QueryBuilder).file(g.map(u=>(0,D.toWorkspaceFolder)(t.URI.revive(u))),{_reason:"checkExists",includePattern:f,exists:!0});return r.fileSearch(o,v).then(u=>!!u.limitHit,u=>P.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=w});var tt=this&&this.__classPrivateFieldSet||function(J,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,c):I?I.value=c:e.set(J,c),c},Be=this&&this.__classPrivateFieldGet||function(J,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(J):t?t.value:e.get(J)};define(Ce[41],De([1,0,172,9,74,22,18,6,63,2,13,5,34,228,96,33,27,226,11,26,23,209,7,127,3,25,70,16,85,53,40,4,285,95,211,14,94]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r,b,o,u,s,l,a,d,n,i,p,_,R,M,H,$,L){"use strict";var B,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let U=class On extends T.Disposable{constructor(te,he,Y,fe,be,ke,Re,ze,oe,le,ge){super(),this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=fe,this._extHostConfiguration=be,this._logService=ke,this._extHostTunnelService=oe,this._extHostTerminalService=le,this._extHostLocalizationService=ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const Z=(0,g.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(x(this._globalRegistry,Z)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=ze,this._instaService=te.createChild(new n.ServiceCollection([w.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let ae=[],ne=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(N=>!N.main&&!N.browser).map(N=>N.identifier),ne=this._initData.allExtensions.filter(N=>!Z.has(m.ExtensionIdentifier.toKey(N.identifier.value))).filter(N=>(N.main||N.browser)&&N.api==="none").map(N=>N.identifier));const ie=(0,g.extensionIdentifiersArrayToSet)(ne);this._activator=this._register(new y.ExtensionsActivator(this._myRegistry,ae,ne,{onExtensionActivationError:(N,j,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(N,v.transformErrorForSerialization(j),G)},actualActivateExtension:async(N,j)=>{if(ie.has(m.ExtensionIdentifier.toKey(N)))return await this._mainThreadExtensionsProxy.$activateExtension(N,j),new y.HostExtension;const G=this._myRegistry.getExtensionDescription(N);return this._activateExtension(G,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){v.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(te)}terminate(te,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(fe=>{this._logService.error(fe)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,C.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const he=await this._mainThreadExtensionsProxy.$getExtension(te);let Y;if(he?.browserNlsBundleUris){Y={};for(const fe of Object.keys(he.browserNlsBundleUris))Y[fe]=D.URI.revive(he.browserNlsBundleUris[fe])}return he&&{...he,identifier:new m.ExtensionIdentifier(he.identifier.value),extensionLocation:D.URI.revive(he.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(te,he){return this._activator.activateByEvent(te,he)}_activateById(te,he){return this._activator.activateById(te,he)}activateByIdWithErrors(te,he){return this._activateById(te,he).then(()=>{const Y=this._activator.getActivatedExtension(te);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==$.Schemas.file)return te;const he=await this._hostUtils.realpath(te.fsPath);return D.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new K(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const he=S.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(te.map(async Y=>{if(this._getEntryPoint(Y)){const fe=await this._realPathExtensionUri(Y.extensionLocation);he.set(fe,Y)}})),he}_deactivate(te){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return he;const Y=this._activator.getActivatedExtension(te);if(!Y)return he;try{typeof Y.module.deactivate=="function"&&(he=Promise.resolve(Y.module.deactivate()).then(void 0,fe=>(this._logService.error(fe),Promise.resolve(void 0))))}catch(fe){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(fe)}try{(0,T.dispose)(Y.subscriptions)}catch(fe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(fe)}return he}async _activateExtension(te,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,he).then(Y=>{const fe=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,fe.codeLoadingTime,fe.activateCallTime,fe.activateResolvedTime,he),this._logExtensionActivationTimes(te,he,"success",fe),Y},Y=>{throw this._logExtensionActivationTimes(te,he,"failure"),Y})}_logExtensionActivationTimes(te,he,Y,fe){const be=F(te,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...fe||{},outcome:Y})}_doActivateExtension(te,he){const Y=F(te,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const fe=this._getEntryPoint(te);if(!fe)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${te.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const be=new y.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(te,(0,P.joinPath)(te.extensionLocation,fe),be),this._loadExtensionContext(te)]).then(ke=>(I.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),On._callActivate(this._logService,te.identifier,ke[0],ke[1],be))).then(ke=>(I.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ke))}_loadExtensionContext(te){const he=new b.ExtensionGlobalMemento(te,this._storage),Y=new b.ExtensionMemento(te.identifier.value,!1,this._storage),fe=new H.ExtensionSecrets(te,this._secretState),be=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,ke=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([he.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let ze,oe;const le=(0,g.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:Y,secrets:fe,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(ge){return t.join(te.extensionLocation.fsPath,ge)},get storagePath(){return Re._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(te).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return D.URI.joinPath(Re._initData.logsLocation,te.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(te)},get globalStorageUri(){return Re._storagePath.globalValue(te)},get extensionMode(){return be},get extension(){return ze===void 0&&(ze=new V(Re,te.identifier,te,ke,!1)),ze},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(te,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!oe){if(!le)return;const ge=_.Event.buffer(_.Event.fromDOMEventEmitter(le,"message",Z=>Z.data));le.start(),oe={onDidReceiveMessage:ge,postMessage:le.postMessage.bind(le)}}return oe}})})}static _callActivate(te,he,Y,fe,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,he,Y,fe,be).then(ke=>new y.ActivatedExtension(!1,null,be.build(),Y,ke,fe.subscriptions))}static _callActivateOptional(te,he,Y,fe,be){if(typeof Y.activate=="function")try{be.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${he.value}`);const ke=typeof global=="object"?global:self,Re=Y.activate.apply(ke,[fe]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(ze=>(be.activateResolveStop(),ze))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Y)}_activateOneStartupFinished(te,he){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:he}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const he of te.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(te,he)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(he),fe=Promise.all([te,Y]).then(()=>{});return Promise.race([fe,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),fe}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(te,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,he){if(this.isActivated(he.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,fe={logService:this._logService,folders:te.map(ke=>ke.uri),forceUsingSearch:Y,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Re,ze)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Re,ze)},be=await(0,R.checkActivateWorkspaceContainsExtension)(fe,he);if(!!be)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:be.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:he}=this._initData.environment;if(!te||!he)throw new Error(c.localize(0,null));const Y=await this._loadCommonJSModule(null,he,new y.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(c.localize(1,null,he.toString()));return new Promise((fe,be)=>{const ke=(oe,le)=>{oe?be(oe):fe(typeof le=="number"&&le>0?1:0)},Re=(0,P.originalFSPath)(he),ze=Y.run(Re,ke);ze&&ze.then&&ze.then(()=>{fe(0)}).catch(oe=>{be(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,he){return this._resolvers[te]=he,(0,T.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const he=te.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const Y=te.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(te,he){this._logService.info(`$resolveAuthority invoked for authority (${Q(te)})`);const{authorityPrefix:Y,resolver:fe}=await this._activateAndGetResolver(te);if(!fe)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(fe)),I.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await fe.resolve(te,{resolveAttempt:he});I.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ke={authority:te,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(I.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(te,he){this._logService.info(`$getCanonicalURI invoked for authority (${Q(te)})`);const{resolver:Y}=await this._activateAndGetResolver(te);if(!Y)return null;const fe=D.URI.revive(he);if(typeof Y.getCanonicalURI>"u")return fe;const be=await(0,C.asPromise)(()=>Y.getCanonicalURI(fe));return be||fe}static _applyExtensionsDelta(te,he,Y){const fe=new f.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());fe.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,g.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(m.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(m.ExtensionIdentifier.toKey(Re));const ke=x(fe,be);return{globalRegistry:fe,myExtensions:ke}}$startExtensionHost(te){te.toAdd.forEach(fe=>fe.extensionLocation=D.URI.revive(fe.extensionLocation));const{globalRegistry:he,myExtensions:Y}=On._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(te,he){return he===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(te,!1))}async $activate(te,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,he),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ke=>ke.extensionLocation=D.URI.revive(ke.extensionLocation));const{globalRegistry:he,myExtensions:Y}=On._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),fe=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(fe),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const he=r.VSBuffer.alloc(te),Y=Math.random()%256;for(let fe=0;fe<te;fe++)he.writeUInt8(Y,fe);return he}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};U=je([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,h.IExtHostWorkspace),$e(4,E.IExtHostConfiguration),$e(5,A.ILogService),$e(6,l.IExtHostInitDataService),$e(7,a.IExtensionStoragePaths),$e(8,i.IExtHostTunnelService),$e(9,p.IExtHostTerminalService),$e(10,L.IExtHostLocalizationService)],U),e.AbstractExtHostExtensionService=U;function F(ue,te){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class V{constructor(te,he,Y,fe,be){B.set(this,void 0),O.set(this,void 0),z.set(this,void 0),tt(this,B,te,"f"),tt(this,O,he,"f"),tt(this,z,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=fe,this.isFromDifferentExtensionHost=be}get isActive(){return Be(this,B,"f").isActivated(Be(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,B,"f").getExtensionExports(Be(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,B,"f").activateByIdWithErrors(Be(this,z,"f"),{startup:!1,extensionId:Be(this,O,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,B=new WeakMap,O=new WeakMap,z=new WeakMap;function x(ue,te){return ue.getAllExtensionDescriptions().filter(he=>te.has(m.ExtensionIdentifier.toKey(he.identifier)))}function Q(ue){const te=ue.indexOf("+");return te===-1?ue:ue.substring(0,te)}class K{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=K}),define(Ce[286],De([1,0,74,2,5,34,27,26,16,25,3,41,36,13,8]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(b,o,u,s,l,a,d){this._apiFactory=b,this._extensionRegistry=o,this._instaService=u,this._extHostConfiguration=s,this._extHostExtensionService=l,this._initData=a,this._logService=d,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const b=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,o,this._extensionRegistry,b,this._logService)),this.register(this._instaService.createInstance(v,o)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,o,this._initData.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const o of b.nodeModuleName)this._factories.set(o,b);else this._factories.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this._alternatives.push(o=>b.alternativeModuleName(o))}};h=je([$e(2,A.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,D.IExtHostInitDataService),$e(6,y.ILogService)],h),e.RequireInterceptor=h;let g=class Jn{constructor(b){if(b.environment.appRoot&&Jn.aliased.size){const o=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(b.environment.appRoot.fsPath)),u="[a-z0-9_.-]",s=`@${u}+\\/${u}+|${u}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${l}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(b){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(b));if(!o)return;const[,u,s,l]=o,a=Jn.aliased.get(s);if(a!==void 0)return console.warn(`${s} as been renamed to ${a}, please update your imports`),u+a+l}forceForwardSlashes(b){return b.replace(/\\/g,"/")}};g.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=je([$e(0,D.IExtHostInitDataService)],g);class f{constructor(b,o,u,s,l){this._apiFactory=b,this._extensionPaths=o,this._extensionRegistry=u,this._configProvider=s,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(b,o){const u=this._extensionPaths.findSubstr(o);if(u){let s=this._extApiImpl.get(T.ExtensionIdentifier.toKey(u.identifier));return s||(s=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(u.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((l,a)=>s+=`	${a} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(b,o,u){this._extensionPaths=b,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(I.MainContext.MainThreadTelemetry);const{environment:s}=u,l=o.getProxy(I.MainContext.MainThreadKeytar);if(s.appRoot){let a=s.appRoot.fsPath;E.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,d)=>l.$getPassword(a,d),setPassword:(a,d,n)=>l.$setPassword(a,d,n),deletePassword:(a,d)=>l.$deletePassword(a,d),findPassword:a=>l.$findPassword(a),findCredentials(a){return l.$findCredentials(a)}}}load(b,o){const u=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(b){const o=b.length;if(o<=7||!this.alternativeNames)return;const u=o-7;if((b.charAt(u)==="/"||b.charAt(u)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.alternativeNames.has(b)))return"keytar"}};v=je([$e(1,S.IExtHostRpcService),$e(2,D.IExtHostInitDataService)],v);let m=class{constructor(b,o,u){this._extensionPaths=b,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(I.MainContext.MainThreadTelemetry);const s=u.getProxy(I.MainContext.MainThreadWindow);this._impl=(l,a)=>{const d=t.URI.parse(l);return a?this.callOriginal(l,a):d.scheme==="http"||d.scheme==="https"?s.$openUri(d,l,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this._appUriScheme?s.$openUri(d,l,{}):this.callOriginal(l,a)}}load(b,o,u){const s=this._extensionPaths.findSubstr(o);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=u(b),this._impl}callOriginal(b,o){return this.sendNoForwardTelemetry(),this._original(b,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([$e(2,S.IExtHostRpcService)],m)}),define(Ce[47],De([1,0,79,6,9,36,3,57,58,41,7,33,223,34]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class w extends E.AbstractVariableResolverService{constructor(f,v,m,r,b,o,u){function s(){if(m){const l=m.activeEditor();if(l)return l.document.uri;const a=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof A.TextDiffTabInput||a.input instanceof A.NotebookDiffEditorTabInput)return a.input.modified;if(a.input instanceof A.TextTabInput||a.input instanceof A.NotebookEditorTabInput||a.input instanceof A.CustomEditorTabInput)return a.input.uri}}}super({getFolderUri:l=>{const a=o.folders.filter(d=>d.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(l,a)=>b.getConfiguration(void 0,l).get(a),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=s();if(l)return I.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const l=s();if(l){const a=v.getWorkspaceFolder(l);if(a)return I.normalize(a.uri.fsPath)}}},getSelectedText:()=>{if(m){const l=m.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(m){const l=m.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>f.getExtension(l)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(P.env))}}let h=class extends t.Disposable{constructor(f,v,m,r,b){super(),this.extensionService=f,this.workspaceService=v,this.editorService=m,this.configurationService=r,this.editorTabs=b,this._resolver=new c.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,s,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=je([$e(0,D.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,T.IExtHostDocumentsAndEditors),$e(3,y.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(Ce[75],De([1,0,18,4,12,2,3,5,58,41,16,7,33,130,216,34,47]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,l,a,d,n,i){this._workspaceService=l,this._extensionService=a,this._configurationService=d,this._editorTabs=n,this._variableResolver=i,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=s.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new m(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(_=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}asDebugSourceUri(s,l){const a=s;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let d=`debug:${encodeURIComponent(a.path||"")}`,n="?";return l&&(d+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),d+=`${n}ref=${a.sourceReference}`,P.URI.parse(d)}else{if(a.path)return P.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const l=[];for(const a of s.getAllExtensionDescriptions())if(a.contributes){const d=a.contributes.debuggers;if(d&&d.length>0)for(const n of d)(0,w.isDebuggerMainContribution)(n)&&l.push(n.type)}this._debugServiceProxy.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(l=>s.push(l)),s}addBreakpoints(s){this.startBreakpoints();const l=s.filter(n=>{const i=n.id;return this._breakpoints.has(i)?!1:(this._breakpoints.set(i,n),!0)});this.fireBreakpointChanges(l,[],[]);const a=[],d=new Map;for(const n of l)if(n instanceof k.SourceBreakpoint){let i=d.get(n.location.uri.toString());i||(i={type:"sourceMulti",uri:n.location.uri,lines:[]},d.set(n.location.uri.toString(),i),a.push(i)),i.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof k.FunctionBreakpoint&&a.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(a)}removeBreakpoints(s){this.startBreakpoints();const l=s.filter(i=>this._breakpoints.delete(i.id));this.fireBreakpointChanges([],l,[]);const a=l.filter(i=>i instanceof k.SourceBreakpoint).map(i=>i.id),d=l.filter(i=>i instanceof k.FunctionBreakpoint).map(i=>i.id),n=l.filter(i=>i instanceof k.DataBreakpoint).map(i=>i.id);return this._debugServiceProxy.$unregisterBreakpoints(a,d,n)}startDebugging(s,l,a){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,l,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,l,a){if(!l)return new k.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:d,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,a,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,d),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(s,l,a){if(!a)return new k.Disposable(()=>{});if(!this.definesDebugType(s,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:d,factory:a}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,d),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==a),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(s,l){if(!l)return new k.Disposable(()=>{});const a=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:a,factory:l}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==l)})}async $runInTerminal(s,l){return Promise.resolve(void 0)}async $substituteVariables(s,l){let a;const d=await this.getFolder(s);return d&&(a={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(a,l)}createDebugAdapter(s,l){if(s.type==="implementation")return new b(s.implementation)}createSignService(){}async $startDASession(s,l){const a=this,d=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const i=this.convertToDto(n),p=this.createDebugAdapter(i,d);if(!p)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const _=p;return this._debugAdapters.set(s,_),this.getDebugAdapterTrackers(d).then(R=>(R&&this._debugAdaptersTrackers.set(s,R),_.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const H=M,$={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(H.arguments.value);$.body={signature:L},_.sendResponse($)}else throw new Error("no signer")}catch(L){$.success=!1,$.message=L.message,_.sendResponse($)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(M),M=(0,w.convertToVSCPaths)(M,!0),a._debugServiceProxy.$acceptDAMessage(s,M)}),_.onError(M=>{R&&R.onError&&R.onError(M),this._debugServiceProxy.$acceptDAError(s,M.name,M.message,M.stack)}),_.onExit(M=>{R&&R.onExit&&R.onExit((0,I.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,I.withNullAsUndefined)(M),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),_.startSession()))})}$sendDAMessage(s,l){l=(0,w.convertToDAPaths)(l,!1);const a=this._debugAdaptersTrackers.get(s);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(l),this._debugAdapters.get(s)?.sendMessage(l)}$stopDASession(s){const l=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),l&&l.onWillStopSession&&l.onWillStopSession();const a=this._debugAdapters.get(s);return this._debugAdapters.delete(s),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const l=[],a=[],d=[];if(s.added)for(const n of s.added){const i=n.id;if(i&&!this._breakpoints.has(i)){let p;if(n.type==="function")p=new k.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new k.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const _=P.URI.revive(n.uri);p=new k.SourceBreakpoint(new k.Location(_,new k.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=i,this._breakpoints.set(i,p),l.push(p)}}if(s.removed)for(const n of s.removed){const i=this._breakpoints.get(n);i&&(this._breakpoints.delete(n),a.push(i))}if(s.changed){for(const n of s.changed)if(n.id){const i=this._breakpoints.get(n.id);if(i){if(i instanceof k.FunctionBreakpoint&&n.type==="function"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(i instanceof k.SourceBreakpoint&&n.type==="source"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new k.Location(P.URI.revive(n.uri),new k.Position(n.line,n.character))}d.push(i)}}}this.fireBreakpointChanges(l,a,d)}$provideDebugConfigurations(s,l,a){return(0,c.asPromise)(async()=>{const d=this.getConfigProviderByHandle(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(l);return d.provideDebugConfigurations(n,a)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(s,l,a,d){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const i=await this.getFolder(l);return n.resolveDebugConfiguration(i,a,d)})}$resolveDebugConfigurationWithSubstitutedVariables(s,l,a,d){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const i=await this.getFolder(l);return n.resolveDebugConfigurationWithSubstitutedVariables(i,a,d)})}async $provideDebugAdapter(s,l){const a=this.getAdapterDescriptorFactoryByHandle(s);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(l);return this.getAdapterDescriptor(a,d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(s){const l=await this.getSession(s);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(s){const l=await this.getSession(s);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,l){(await this.getSession(s))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(s,l){const d={session:await this.getSession(s),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const l=this._adapterFactories.filter(a=>a.type===s);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(s){const l=this._adapterFactories.filter(a=>a.handle===s);if(l.length>0)return l[0].factory}getConfigProviderByHandle(s){const l=this._configProviders.filter(a=>a.handle===s);if(l.length>0)return l[0].provider}definesDebugType(s,l){if(s.contributes){const a=s.contributes.debuggers;if(a&&a.length>0){for(const d of a)if(d.label&&d.type&&d.type===l)return!0}}return!1}getDebugAdapterTrackers(s){const a=s.configuration.type,d=this._trackerFactories.filter(n=>n.type===a||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(s)).then(i=>i,i=>null));return Promise.race([Promise.all(d).then(n=>{const i=n.filter(p=>!!p);if(i.length>0)return new r(i)}),new Promise((n,i)=>{const p=setTimeout(()=>{clearTimeout(p),i(new Error("timeout"))},1e3)})]).catch(n=>{})}async getAdapterDescriptor(s,l){const a=l.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new k.DebugAdapterServer(a));if(s){const n=await this._extensionService.getExtensionRegistry();return(0,c.asPromise)(()=>s.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,n))).then(i=>{if(i)return i})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,d))}daExecutableFromPackage(s,l){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,l,a){(s.length>0||l.length>0||a.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:l,changed:a}))}async getSession(s){if(s)if(typeof s=="string"){const l=this._debugSessions.get(s);if(l)return l}else{let l=this._debugSessions.get(s.id);if(!l){const a=await this.getFolder(s.folderUri),d=s.parent?this._debugSessions.get(s.parent):void 0;l=new v(this._debugServiceProxy,s.id,s.type,s.name,a,s.configuration,d),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(s){if(s){const l=P.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};f=je([$e(0,A.IExtHostRpcService),$e(1,E.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,h.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs),$e(5,g.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class v{constructor(s,l,a,d,n,i,p){this._debugServiceProxy=s,this._id=l,this._type=a,this._name=d,this._workspaceFolder=n,this._configuration=i,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,l)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=v;class m{constructor(s){this.value=Object.freeze({append(l){s.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=m;class r{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(l=>l.onError?l.onError(s):void 0)}onExit(s,l){this.trackers.forEach(a=>a.onExit?a.onExit(s,l):void 0)}}class b extends y.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends f{constructor(s,l,a,d,n,i){super(s,l,a,d,n,i)}};o=je([$e(0,A.IExtHostRpcService),$e(1,E.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,h.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs),$e(5,g.IExtHostVariableResolverProvider)],o),e.WorkerExtHostDebugService=o}),define(Ce[287],De([1,0,11,74,2,5,279,13,84,85,25,194,16,54,41,93]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(m){const r=m.get(T.ILogService),o=m.get(E.IExtHostRpcService).getProxy(P.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(u=>{r.error(u);const s=c.transformErrorForSerialization(u);o.$onUnexpectedError(s)})}static async installFullHandler(m){const r=m.get(T.ILogService),b=m.get(E.IExtHostRpcService),o=m.get(w.IExtHostExtensionService),u=m.get(h.IExtHostTelemetry),s=b.getProxy(P.MainContext.MainThreadExtensionService),l=b.getProxy(P.MainContext.MainThreadErrors),a=await o.getExtensionPathIndex(),d=new WeakMap;Error.prepareStackTrace=(n,i)=>{let p="",_,R;for(const M of i)p+=`
	at ${M.toString()}`,R=M.getFileName(),!_&&R&&(_=a.findSubstr(I.URI.file(R)));return d.set(n,_?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},c.setUnexpectedErrorHandler(n=>{r.error(n);const i=c.transformErrorForSerialization(n),p=d.get(n);if(!p){l.$onUnexpectedError(i);return}s.$onExtensionRuntimeError(p,i);const _=u.onExtensionError(p,n);r.trace("forwarded error to extension?",_,p)})}}Error.stackTraceLimit=100;class f{constructor(m,r,b,o,u){this._hostUtils=b,this._rpcProtocol=new C.RPCProtocol(m,null,o),r=f._transform(r,this._rpcProtocol);const s=new D.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());s.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...r,messagePorts:u}),s.set(E.IExtHostRpcService,new E.ExtHostRpcService(this._rpcProtocol)),s.set(y.IURITransformerService,new y.URITransformerService(o)),s.set(w.IHostUtils,b);const l=new k.InstantiationService(s,!0);l.invokeFunction(g.installEarlyHandler),this._logService=l.invokeFunction(a=>a.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",r),this._extensionService=l.invokeFunction(a=>a.get(w.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(g.installFullHandler)}async asBrowserUri(m){const r=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return I.URI.revive(await r.$asBrowserUri(m))}terminate(m){this._extensionService.terminate(m)}static _transform(m,r){m.allExtensions.forEach(o=>{o.extensionLocation=I.URI.revive(r.transformIncomingURIs(o.extensionLocation));const u={};o.browserNlsBundleUris&&(Object.keys(o.browserNlsBundleUris).forEach(s=>u[s]=I.URI.revive(r.transformIncomingURIs(o.browserNlsBundleUris[s]))),o.browserNlsBundleUris=u)}),m.environment.appRoot=I.URI.revive(r.transformIncomingURIs(m.environment.appRoot));const b=m.environment.extensionDevelopmentLocationURI;return b&&(m.environment.extensionDevelopmentLocationURI=b.map(o=>I.URI.revive(r.transformIncomingURIs(o)))),m.environment.extensionTestsLocationURI=I.URI.revive(r.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=I.URI.revive(r.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=I.URI.revive(r.transformIncomingURIs(m.environment.workspaceStorageHome)),m.nlsBaseUrl=I.URI.revive(r.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=I.URI.revive(r.transformIncomingURIs(m.logsLocation)),m.logFile=I.URI.revive(r.transformIncomingURIs(m.logFile)),m.workspace=r.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=f}),define(Ce[288],De([1,0,18,10,178,193,201,75,58,41,16,40,7,47,33,217,219,34]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends T.ExtHostDebugServiceBase{constructor(u,s,l,a,d,n,i){super(u,s,l,a,n,i),this._terminalService=d,this._integratedTerminalInstances=new b}createDebugAdapter(u,s){switch(u.type){case"server":return new h.SocketDebugAdapter(u);case"pipeServer":return new h.NamedPipeDebugAdapter(u);case"executable":return new h.ExecutableDebugAdapter(u,s.type)}return super.createDebugAdapter(u,s)}daExecutableFromPackage(u,s){const l=h.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),u.type);if(l)return new E.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new C.SignService}async $runInTerminal(u,s){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const l=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0),d=this._terminalService.getDefaultShellArgs(!0),n=u.title||I.localize(0,null),i=JSON.stringify({shell:a,shellArgs:d});let p=await this._integratedTerminalInstances.checkout(i,n),_,R=!1;if(p)_=u.cwd;else{const L={shellPath:a,shellArgs:d,cwd:u.cwd,name:n,iconPath:new E.ThemeIcon("debug")};R=!0,p=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(p,i)}p.show(!0);const M=await p.processId;R?await new Promise(L=>setTimeout(L,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?p.sendText("cls"):a.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const H=(0,g.prepareCommand)(a,u.args,!!u.argsCanBeInterpretedByShell,_,u.env);p.sendText(H);const $=this.onDidTerminateDebugSession(L=>{L.id===s&&(this._integratedTerminalInstances.free(p),$.dispose())});return M}else if(u.kind==="external")return r(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,s)}};v=je([$e(0,A.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,f.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,S.IExtHostEditorTabs),$e(6,y.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let m;function r(o,u){if(!m)if(t.isWindows)m=new P.WindowsExternalTerminalService;else if(t.isMacintosh)m=new P.MacExternalTerminalService;else if(t.isLinux)m=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=u.getConfiguration("terminal");return m.runInTerminal(o.title,o.cwd,o.args,o.env||{},s.external||{})}e.runInExternalTerminal=r;class b{constructor(){this._terminalInstances=new Map}async checkout(u,s){const a=[...this._terminalInstances.entries()].map(([d,n])=>(0,c.createCancelablePromise)(async i=>{if(d.name!==s||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await d.processId))return null;const p=Date.now();return n.lastUsedAt+b.minUseDelay>p||i.isCancellationRequested||n.config!==u?null:(n.lastUsedAt=p,d)}));return await(0,c.firstParallel)(a,d=>!!d)}insert(u,s){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:s})}free(u){const s=this._terminalInstances.get(u);s&&(s.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}b.minUseDelay=1e3}),define(Ce[289],De([1,0,9,2,114,33,57,34,45,40,16,25,73,14,13,68,22,83,47]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends E.ExtHostTaskBase{constructor(b,o,u,s,l,a,d,n,i){super(b,o,u,s,l,a,d,n),this.workspaceService=u,this.variableResolver=i,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,o){const u=o;if(!o.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=E.TaskHandleDTO.from(u,this.workspaceService),l=await this._proxy.$getTaskExecution(s);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(l,o);return this._proxy.$executeTask(s).catch(()=>{}),a}else{const s=E.TaskDTO.from(o,b);if(s===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,o,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),o);return this._proxy.$executeTask(s).catch(()=>{}),l}}provideTasksInternal(b,o,u,s){const l=[];if(s)for(const a of s){this.checkDeprecation(a,u),(!a.definition||!b[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=E.TaskDTO.from(a,u.extension);d&&(l.push(d),E.CustomExecutionDTO.is(d.execution)&&o.push(this.addCustomExecution(d,a,!0)))}return{tasks:l,extension:u.extension}}async resolveTaskInternal(b){return b}async getAFolder(b){let o=b&&b.length>0?b[0]:void 0;if(!o){const u=t.URI.file((0,f.homedir)());o=new S.WorkspaceFolder({uri:u,name:g.basename(u),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,o){const u=t.URI.revive(b),s={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(u),a=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),n=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(const i of o.variables)s.variables[i]=await d.resolveAsync(n,i);if(o.process!==void 0){let i;if(o.process.path!==void 0){i=o.process.path.split(c.delimiter);for(let p=0;p<i.length;p++)i[p]=await d.resolveAsync(n,i[p])}s.process=await I.win32.findExecutable(await d.resolveAsync(n,o.process.name),o.process.cwd!==void 0?await d.resolveAsync(n,o.process.cwd):void 0,i)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(b,o,u){return I.win32.findExecutable(b,o,u)}};m=je([$e(0,A.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,D.IExtHostTerminalService),$e(6,w.ILogService),$e(7,h.IExtHostApiDeprecationService),$e(8,v.IExtHostVariableResolverProvider)],m),e.ExtHostTask=m}),define(Ce[290],De([1,0,83,47]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(Ce[141],De([1,0,17,18,21,50,14,9,22,2,30]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(v,m,r,b){this.query=v,this.provider=m,this.fileUtils=r,this.processType=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,m){const r=this.query.folderQueries||[],b=new I.CancellationTokenSource;return m.onCancellationRequested(()=>b.cancel()),new Promise((o,u)=>{this.collector=new y(v);let s=!1;const l=(a,d)=>{if(!s&&!this.isLimitHit){const n=this.resultSize(a);h(a)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,s=!0,b.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const i=this.resultSize(a);this.resultCount+=i,(i>0||!h(a))&&this.collector.add(a,d)}};Promise.all(r.map((a,d)=>this.searchInFolder(a,n=>l(n,d),b.token))).then(a=>{b.dispose(),this.collector.flush();const d=a.some(n=>!!n&&!!n.limitHit);o({limitHit:this.isLimitHit||d,messages:(0,c.flatten)(a.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},a=>{b.dispose();const d=(0,P.toErrorMessage)(a);u(new Error(d))})})}resultSize(v){return h(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,m){const r=Array.isArray(v.ranges)?v.ranges:[v.ranges],b=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:r.slice(0,m),preview:{matches:b.slice(0,m),text:v.preview.text},uri:v.uri}}async searchInFolder(v,m,r){const b=new A.QueryGlobTester(this.query,v),o=[],u={report:a=>{if(!this.validateProviderResult(a))return;const d=v.folder.scheme===C.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(a.uri))):void 0,n=S.relativePath(v.folder,a.uri);if(n){const i=b.includedInQuery(n,T.basename(n),d);(0,t.isThenable)(i)?o.push(i.then(p=>{p&&m(a)})):i&&m(a)}}},s=this.getSearchOptionsForFolder(v),l=await this.provider.provideTextSearchResults(E(this.query.contentPattern),s,u,r);return o.length&&await Promise.all(o),l}validateProviderResult(v){if(h(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const m=(0,A.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),r=(0,A.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),b={folder:D.URI.from(v.folder),excludes:r,includes:m,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=k;function E(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class y{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,m=>this.sendItems(m))}add(v,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!S.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(w(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=y;function w(f){return h(f)?{preview:{matches:(0,c.mapArrayOrNot)(f.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:f.preview.text},ranges:(0,c.mapArrayOrNot)(f.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function h(f){return!!f.preview}e.extensionResultIsMatch=h;class g{constructor(v,m){this.maxBatchSize=v,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,m){!v||this.addItemToBatch(v,m)}addItems(v,m){!v||this.addItemsToBatch(v,m)}addItemToBatch(v,m){this.batch.push(v),this.batchSize+=m,this.onUpdate()}addItemsToBatch(v,m){this.batch=this.batch.concat(v),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(Ce[76],De([1,0,6,5,3,283,16,54,13,2,141]),function(J,e,c,t,I,P,C,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let k=class{constructor(h,g,f){this.extHostRpc=h,this._uriTransformer=g,this._logService=f,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,g){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const f=this._handlePool++;return this._textSearchProvider.set(f,g),this._proxy.$registerTextSearchProvider(f,this._transformScheme(h)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(h,g){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const f=this._handlePool++;return this._fileSearchProvider.set(f,g),this._proxy.$registerFileSearchProvider(f,this._transformScheme(h)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(h,g,f,v){const m=E(f),r=this._fileSearchProvider.get(h);if(r)return this._fileSearchManager.fileSearch(m,r,b=>{this._proxy.$handleFileMatch(h,g,b.map(o=>o.resource))},v);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,g,f,v){const m=this._textSearchProvider.get(h);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const r=E(f);return this.createTextSearchManager(r,m).search(o=>this._proxy.$handleTextMatch(h,g,o),v)}$enableExtensionHostSearch(){}createTextSearchManager(h,g){return new A.TextSearchManager(h,g,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};k=je([$e(0,C.IExtHostRpcService),$e(1,T.IURITransformerService),$e(2,S.ILogService)],k),e.ExtHostSearch=k;function E(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(y),extraFileResources:w.extraFileResources&&w.extraFileResources.map(h=>D.URI.revive(h))}}e.reviveQuery=E;function y(w){return{...w,folder:D.URI.revive(w.folder)}}}),define(Ce[291],De([1,0,84,140,33,137,34,39,57,40,73,75,76,96,53,68,139,69,46,95,93,58,138,13,229,47,94]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r,b,o,u,s,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,c.registerSingleton)(u.ILoggerService,o.ExtHostLoggerService,1),(0,c.registerSingleton)(u.ILogService,s.ExtHostLogService,1),(0,c.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService,!1),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,!1),(0,c.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,!1),(0,c.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,!1),(0,c.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,!1),(0,c.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,!1),(0,c.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,!1),(0,c.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,!1),(0,c.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,!1),(0,c.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,!1),(0,c.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService,!1),(0,c.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,!1),(0,c.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,!1),(0,c.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,!1),(0,c.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry,!1),(0,c.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,!1),(0,c.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,!1)}),define(Ce[97],De([1,0,17,13,30,72]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function T(k,E,y,w){const h=(0,c.mapArrayOrNot)(y,S),g=new I.TextSearchMatch(E,h,w),f=g.preview.matches;return{ranges:(0,c.mapArrayOrNot)(h,D),uri:k,preview:{text:g.preview.text,matches:(0,c.mapArrayOrNot)(f,D)}}}e.createTextSearchResult=T;function S(k){return new I.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function D(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let A=class{constructor(E,y){this.prefix=E,this.logService=y}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};A=je([$e(1,t.ILogService)],A),e.OutputChannel=A}),define(Ce[292],De([1,0,44,9,80,32,10,8,97,293]),function(J,e,c,t,I,P,C,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const A=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(m,r,b,o){const u=E(m,r,b,o),s=r.folder.fsPath;return{cmd:c.spawn(A,u.args,{cwd:s}),rgDiskPath:A,siblingClauses:u.siblingClauses,rgArgs:u,cwd:s}}e.spawnRipgrepCmd=k;function E(m,r,b,o){const u=["--files","--hidden","--case-sensitive"];w([r],b,!1).forEach(l=>{const a=(0,S.anchorGlob)(l);if(u.push("-g",a),C.isMacintosh){const d=(0,I.normalizeNFD)(a);d!==a&&u.push("-g",d)}});const s=y([r],o,void 0,!1);return s.globArgs.forEach(l=>{const a=`!${(0,S.anchorGlob)(l)}`;if(u.push("-g",a),C.isMacintosh){const d=(0,I.normalizeNFD)(a);d!==a&&u.push("-g",d)}}),r.disregardIgnoreFiles!==!1?u.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),r.ignoreSymlinks||u.push("--follow"),m.exists&&u.push("--quiet"),u.push("--no-config"),r.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:s.siblingClauses}}function y(m,r,b,o=!0){const u=[];let s={};return m.forEach(l=>{const a=Object.assign({},l.excludePattern||{},r||{}),d=h(a,o?l.folder.fsPath:void 0,b);u.push(...d.globArgs),d.siblingClauses&&(s=Object.assign(s,d.siblingClauses))}),{globArgs:u,siblingClauses:s}}e.foldersToRgExcludeGlobs=y;function w(m,r,b=!0){const o=[];return m.forEach(u=>{const s=Object.assign({},r||{},u.includePattern||{}),l=h(s,b?u.folder.fsPath:void 0);o.push(...l.globArgs)}),o}e.foldersToIncludeGlobs=w;function h(m,r,b){const o=[],u={};return Object.keys(m).forEach(s=>{if(b&&b.has(s)||!s)return;const l=m[s];s=f(r?g(r,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof l=="boolean"&&l?(s.startsWith("\\\\")&&(s+="**"),o.push(v(s))):l&&l.when&&(u[s]=l)}),{globArgs:o,siblingClauses:u}}function g(m,r){return t.isAbsolute(r)?r:t.join(m,r)}e.getAbsoluteGlob=g;function f(m){return m=T.rtrim(m,"\\"),T.rtrim(m,"/")}function v(m){return P.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=v}),define(Ce[294],De([1,0,44,64,9,295,17,50,37,80,32,10,51,8,12,29,30,292,109]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(s=>s())});class r{constructor(l){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=l,this.filePattern=l.filePattern||"",this.includePattern=l.includePattern&&S.parse(l.includePattern),this.maxResults=l.maxResults||null,this.exists=!!l.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=l.excludePattern&&S.parse(l.excludePattern),this.folderExcludePatterns=new Map,l.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),n=a.folder.fsPath;l.folderQueries.map(i=>i.folder.fsPath).filter(i=>i!==n).forEach(i=>{(0,A.isEqualOrParent)(i,n)&&(d[I.relative(n,i)]=!0)}),this.folderExcludePatterns.set(n,new o(d,n))})}cancel(){this.isCanceled=!0,m.forEach(l=>l())}walk(l,a,d,n,i){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return i(null,this.isLimitHit);a.forEach(p=>{const _=I.basename(p.fsPath);this.globalExcludePattern&&this.globalExcludePattern(p.fsPath,_)||this.matchFile(d,{relativePath:p.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(l,(p,_)=>{this.call(this.cmdTraversal,this,p,d,n,R=>{if(R){const M=(0,T.toErrorMessage)(R);console.error(M),this.errors.push(M),_(R,void 0)}else _(null,void 0)})},(p,_)=>{this.fileWalkSW.stop();const R=p?C.coalesce(p)[0]:null;i(R,this.isLimitHit)})}parallel(l,a,d){const n=new Array(l.length),i=new Array(l.length);let p=!1,_=0;if(l.length===0)return d(null,[]);l.forEach((R,M)=>{a(R,(H,$)=>{if(H?(p=!0,n[M]=null,i[M]=H):(n[M]=$,i[M]=null),++_===l.length)return d(p?i:null,n)})})}call(l,a,...d){try{l.apply(a,d)}catch(n){d[d.length-1](n)}}cmdTraversal(l,a,d,n){const i=l.folder.fsPath,p=k.isMacintosh,_=()=>L&&L.kill();m.add(_);let R=U=>{m.delete(_),R=()=>{},n(U)},M="";const H=this.initDirectoryTree(),$=(0,f.spawnRipgrepCmd)(this.config,l,this.config.includePattern,this.folderExcludePatterns.get(l.folder.fsPath).expression),L=$.cmd,B=!Object.keys($.siblingClauses).length,O=$.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let z=`${$.rgDiskPath} ${O}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),d({message:z}),this.cmdResultCount=0,this.collectStdout(L,"utf8",d,(U,F,V)=>{if(U){R(U);return}if(this.isLimitHit){R();return}const Q=(M+(p?D.normalizeNFC(F||""):F)).split(`
`);if(V){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else M=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,B){for(const K of Q)if(this.matchFile(a,{base:i,relativePath:K,searchPath:this.getSearchPath(l,K)}),this.isLimitHit){_();break}(V||this.isLimitHit)&&R();return}this.addDirectoryEntries(l,H,i,Q,a),V&&(this.matchDirectoryTree(H,i,a),R())})}spawnFindCmd(l){const a=this.folderExcludePatterns.get(l.folder.fsPath),d=a.getBasenameTerms(),n=a.getPathTerms(),i=["-L","."];if(d.length||n.length){i.push("-not","(","(");for(const p of d)i.push("-name",p),i.push("-o");for(const p of n)i.push("-path",p),i.push("-o");i.pop(),i.push(")","-prune",")")}return i.push("-type","f"),c.spawn("find",i,{cwd:l.folder.fsPath})}readStdout(l,a,d){let n="";this.collectStdout(l,a,()=>{},(i,p,_)=>{if(i){d(i);return}n+=p,_&&d(null,n)})}collectStdout(l,a,d,n){let i=(R,M,H)=>{(R||H)&&(i=()=>{},this.cmdSW?.stop()),n(R,M,H)},p=!1;l.stdout?(this.forwardData(l.stdout,a,i),l.stdout.once("data",()=>p=!0)):d({message:"stdout is null"});let _;l.stderr?_=this.collectData(l.stderr):d({message:"stderr is null"}),l.on("error",R=>{i(R)}),l.on("close",R=>{let M;!p&&(M=this.decodeData(_,a))&&u(M)?i(new Error(`command failed with error code ${R}: ${this.decodeData(_,a)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),i(null,"",!0))})}forwardData(l,a,d){const n=new P.StringDecoder(a);return l.on("data",i=>{d(null,n.write(i))}),n}collectData(l){const a=[];return l.on("data",d=>{a.push(d)}),a}decodeData(l,a){const d=new P.StringDecoder(a);return l.map(n=>d.write(n)).join("")}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries(l,{pathToEntries:a},d,n,i){n.indexOf(this.filePattern)!==-1&&this.matchFile(i,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(l,this.filePattern)});const p=_=>{const R=I.basename(_),M=I.dirname(_);let H=a[M];H||(H=a[M]=[],p(M)),H.push({base:d,relativePath:_,basename:R,searchPath:this.getSearchPath(l,_)})};n.forEach(p)}matchDirectoryTree({rootEntries:l,pathToEntries:a},d,n){const i=this,p=this.folderExcludePatterns.get(d),_=this.filePattern;function R(M){i.directoriesWalked++;const H=(0,g.hasSiblingFn)(()=>M.map($=>$.basename));for(let $=0,L=M.length;$<L;$++){const B=M[$],{relativePath:O,basename:z}=B;if(p.test(O,z,_!==z?H:void 0))continue;const U=a[O];if(U)R(U);else{if(i.filesWalked++,O===_)continue;i.matchFile(n,B)}if(i.isLimitHit)break}}R(l)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(l,a,d,n,i){const p=l.folder,_=(0,g.hasSiblingFn)(()=>d);this.parallel(d,(R,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const H=a?[a,R].join(I.sep):R;if(this.folderExcludePatterns.get(l.folder.fsPath).test(H,R,this.config.filePattern!==R?_:void 0))return M(null);const $=[p.fsPath,H].join(I.sep);t.lstat($,(L,B)=>{if(L||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded($,B,(O,z)=>O||this.isCanceled||this.isLimitHit?M(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded($,B,(U,F)=>U||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?M(null):(this.walkedPaths[F]=!0,h.Promises.readdir($).then(V=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(l,H,V,n,x=>M(x||null))},V=>{M(null)})))):(this.filesWalked++,H===this.filePattern||this.maxFilesize&&w.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(n,{base:p.fsPath,relativePath:H,searchPath:this.getSearchPath(l,H)}),M(null,void 0)))})},R=>{const M=R&&C.coalesce(R);return i(M&&M.length>0?M[0]:void 0)})}matchFile(l,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,I.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||l(a))}isFileMatch(l){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,g.isFilePatternMatch)(l,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(l,a,d){return a.isSymbolicLink()?t.stat(l,d):d(null,a)}realPathIfNeeded(l,a,d){return a.isSymbolicLink()?t.realpath(l,(n,i)=>n?d(n):d(null,i)):d(null,l)}getSearchPath(l,a){return l.folderName?I.join(l.folderName,a):a}}e.FileWalker=r;class b{constructor(l){this.folderQueries=l.folderQueries,this.extraFiles=l.extraFileResources||[],this.walker=new r(l)}search(l,a,d){this.walker.walk(this.folderQueries,this.extraFiles,l,a,(n,i)=>{d(n,{limitHit:i,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=b;class o{constructor(l,a){this.expression=l,this.root=a,this.init(l)}init(l){let a,d;Object.keys(l).filter(n=>l[n]).forEach(n=>{I.isAbsolute(n)?(a=a||S.getEmptyExpression(),a[n]=l[n]):(d=d||S.getEmptyExpression(),d[n]=l[n])}),this.absoluteParsedExpr=a&&S.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(l,a,d){return this.relativeParsedExpr&&this.relativeParsedExpr(l,a,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,l),a,d)}getBasenameTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getBasenameTerms(this.relativeParsedExpr)),l}getPathTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getPathTerms(this.relativeParsedExpr)),l}}function u(s){const l=s.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return y.uppercaseFirstLetter(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=u}),define(Ce[296],De([1,0,100,23]),function(J,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===s)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,C=512,T=512*8,S=512*128;var D;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class A extends Error{constructor(l,a){super(l),this.decodeStreamErrorKind=a}}e.DecodeStreamError=A;class k{static async create(l){let a;if(l!==e.UTF8)a=(await new Promise((n,i)=>{J(["@vscode/iconv-lite-umd"],n,i)})).getDecoder(h(l));else{const d=new TextDecoder;a={write(n){return d.decode(n,{stream:!0})},end(){return d.decode()}}}return new k(a)}constructor(l){this.iconvLiteDecoder=l}write(l){return this.iconvLiteDecoder.write(l)}end(){return this.iconvLiteDecoder.end()}}function E(s,l){const a=l.minBytesRequiredForDetection??l.guessEncoding?T:C;return new Promise((d,n)=>{const i=(0,c.newWriteableStream)($=>$.join("")),p=[];let _=0,R,M;const H=async()=>{try{const $=await u({buffer:t.VSBuffer.concat(p),bytesRead:_},l.guessEncoding);if($.seemsBinary&&l.acceptTextOnly)throw new A("Stream is binary but only text is accepted for decoding",1);$.encoding=await l.overwriteEncoding($.encoding),R=await k.create($.encoding);const L=R.write(t.VSBuffer.concat(p).buffer);i.write(L),p.length=0,_=0,d({stream:i,detected:$})}catch($){M?.dispose(),i.destroy(),n($)}};M=(0,c.listenStream)(s,{onData:async $=>{R?i.write(R.write($.buffer)):(p.push($),_+=$.byteLength,_>=a&&(s.pause(),await H(),setTimeout(()=>s.resume())))},onError:$=>i.error($),onEnd:async()=>{R||await H(),i.end(R?.end())}})})}e.toDecodeStream=E;async function y(s,l,a){const n=(await new Promise((_,R)=>{J(["@vscode/iconv-lite-umd"],_,R)})).getEncoder(h(l),a);let i=!1,p=!1;return{read(){if(p)return null;const _=s.read();if(typeof _!="string"){if(p=!0,!i&&a?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=n.end();return R&&R.length>0?(i=!0,t.VSBuffer.wrap(R)):null}return i=!0,t.VSBuffer.wrap(n.write(_))}}}e.toEncodeReadable=y;async function w(s){return(await new Promise((a,d)=>{J(["@vscode/iconv-lite-umd"],a,d)})).encodingExists(h(s))}e.encodingExists=w;function h(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=h;function g(s,l){if(!s||l<e.UTF16be_BOM.length)return null;const a=s.readUInt8(0),d=s.readUInt8(1);if(a===e.UTF16be_BOM[0]&&d===e.UTF16be_BOM[1])return e.UTF16be;if(a===e.UTF16le_BOM[0]&&d===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const n=s.readUInt8(2);return a===e.UTF8_BOM[0]&&d===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const f=["ascii","utf-16","utf-32"];async function v(s){const l=await new Promise((p,_)=>{J(["jschardet"],p,_)}),a=s.slice(0,S),d=b(a.buffer),n=l.detect(d);if(!n||!n.encoding)return null;const i=n.encoding.toLowerCase();return 0<=f.indexOf(i)?null:r(n.encoding)}const m={ibm866:"cp866",big5:"cp950"};function r(s){const l=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[l]||l}function b(s){let l="";for(let a=0;a<s.length;a++)l+=String.fromCharCode(s[a]);return l}function o(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=s.match(/windows(\d+)/);return l?"windows-"+l[1]:s}}}e.toCanonicalName=o;function u({buffer:s,bytesRead:l},a){let d=g(s,l),n=!1;if(d!==e.UTF16be&&d!==e.UTF16le&&s){let i=!0,p=!0,_=!1;for(let R=0;R<l&&R<P;R++){const M=R%2===1,H=s.readUInt8(R)===0;if(H&&(_=!0),i&&(M&&!H||!M&&H)&&(i=!1),p&&(M&&H||!M&&!H)&&(p=!1),H&&!i&&!p)break}_&&(i?d=e.UTF16le:p?d=e.UTF16be:n=!0)}return a&&!n&&!d&&s?v(s.slice(0,l)).then(i=>({seemsBinary:!1,encoding:i})):{seemsBinary:n,encoding:d}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[142],De([1,0,296,29,141]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends I.TextSearchManager{constructor(T,S,D=t,A="searchProcess"){super(T,S,{readdir:k=>D.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,c.toCanonicalName)(k)},A)}}e.NativeTextSearchManager=P}),define(Ce[297],De([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const P=this._dragOperations.get(I);return this._dragOperations.delete(I),P}}addDragOperationTransfer(I,P){this._dragOperations.set(I,P)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,P){this._renderedElements.set(I,P)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=c}),define(Ce[298],De([1,0,176,7,22,2,4,6,18,7,12,17,15,21,297,27]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(m,r){if((0,A.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let b;return Array.isArray(m.highlights)&&(b=m.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),b=b.length?b:void 0),{label:m.label,highlights:b}}}class f{constructor(r,b,o){this._proxy=r,this.commands=b,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function u(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:s=>u(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(l=>u(l)?this.convertArgument(l):l):s})}registerTreeDataProvider(r,b,o){const u=this.createTreeView(r,{treeDataProvider:b},o);return{dispose:()=>u.dispose()}}createTreeView(r,b,o){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=b.dragAndDropController?.dropMimeTypes??[],s=b.dragAndDropController?.dragMimeTypes??[],l=!!b.dragAndDropController?.handleDrag,a=!!b.dragAndDropController?.handleDrop,d=this.createExtHostTreeView(r,b,o),n=this._proxy.$registerTreeViewDataProvider(r,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:u,dragMimeTypes:s,hasHandleDrag:l,hasHandleDrop:a});return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,h.checkProposedApiEnabled)(o,"treeItemCheckbox"),d.onDidChangeCheckboxState},get message(){return d.message},set message(i){d.message=i},get title(){return d.title},set title(i){d.title=i},get description(){return d.description},set description(i){d.description=i},get badge(){return d.badge},set badge(i){i!==void 0&&D.ViewBadge.isViewBadge(i)?d.badge={value:Math.floor(Math.abs(i.value)),tooltip:i.tooltip}:i===void 0&&(d.badge=void 0)},reveal:(i,p)=>d.reveal(i,p),dispose:async()=>{await n,this.treeViews.delete(r),d.dispose()}}}$getChildren(r,b){const o=this.treeViews.get(r);return o?o.getChildren(b):Promise.reject(new Error((0,c.localize)(0,null,r)))}async $handleDrop(r,b,o,u,s,l,a,d){const n=this.treeViews.get(r);if(!n)return Promise.reject(new Error((0,c.localize)(1,null,r)));const i=E.DataTransfer.toDataTransfer(o,async p=>(await this._proxy.$resolveDropFileData(r,b,p)).buffer);return a===r&&d&&await this.addAdditionalTransferItems(i,n,d,s,l),n.onDrop(i,u,s)}async addAdditionalTransferItems(r,b,o,u,s){const l=this.treeDragAndDropService.removeDragOperationTransfer(s);if(l)(await l)?.forEach((a,d)=>{a&&r.set(d,a)});else if(s&&b.handleDrag){const a=b.handleDrag(o,r,u);this.treeDragAndDropService.addDragOperationTransfer(s,a),await a}return r}async $handleDrag(r,b,o,u){const s=this.treeViews.get(r);if(!s)return Promise.reject(new Error((0,c.localize)(2,null,r)));const l=await this.addAdditionalTransferItems(new t.DataTransfer,s,b,u,o);if(!!l)return E.DataTransfer.toDataTransferDTO(l)}async $hasResolve(r){const b=this.treeViews.get(r);if(!b)throw new Error((0,c.localize)(3,null,r));return b.hasResolve}$resolve(r,b,o){const u=this.treeViews.get(r);if(!u)throw new Error((0,c.localize)(4,null,r));return u.resolveTreeItem(b,o)}$setExpanded(r,b,o){const u=this.treeViews.get(r);if(!u)throw new Error((0,c.localize)(5,null,r));u.setExpanded(b,o)}$setSelection(r,b){const o=this.treeViews.get(r);if(!o)throw new Error((0,c.localize)(6,null,r));o.setSelection(b)}$setFocus(r,b){const o=this.treeViews.get(r);if(!o)throw new Error((0,c.localize)(7,null,r));o.setFocus(b)}$setVisible(r,b){const o=this.treeViews.get(r);if(!o)throw new Error((0,c.localize)(8,null,r));o.setVisible(b)}$changeCheckboxState(r,b){const o=this.treeViews.get(r);if(!o)throw new Error((0,c.localize)(9,null,r));o.setCheckboxState(b)}createExtHostTreeView(r,b,o){const u=new v(r,b,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(r,u),u}convertArgument(r){const b=this.treeViews.get(r.$treeViewId);return b&&"$treeItemHandle"in r?b.getExtensionElement(r.$treeItemHandle):b&&"$focusedTreeItem"in r&&r.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=f;class v extends T.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(r=>this.getExtensionElement(r)).filter(r=>!(0,A.isUndefinedOrNull)(r))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(r,b,o,u,s,l){if(super(),this.viewId=r,this.proxy=o,this.commands=u,this.logService=s,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new C.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new y.CancellationTokenSource,l.contributes&&l.contributes.views)for(const n in l.contributes.views)for(const i of l.contributes.views[n])i.id===r&&(this._title=i.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let a,d;this._register(C.Event.debounce(this._onDidChangeData.event,(n,i)=>(n||(n={message:!1,elements:[]}),i.element!==!1&&(a||(a=new Promise(p=>d=p),this.refreshPromise=this.refreshPromise.then(()=>a)),Array.isArray(i.element)?n.elements.push(...i.element):n.elements.push(i.element)),i.message&&(n.message=!0),n),200,!0)(({message:n,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=d;return a=null,this.refresh(i).then(()=>p())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(r){const b=r?this.getExtensionElement(r):void 0;if(r&&!b)return this.logService.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(r);return o||(o=await this.fetchChildrenNodes(b)),o?o.map(u=>u.item):void 0}getExtensionElement(r){return this.elements.get(r)}reveal(r,b){b=b||{select:!0,focus:!1};const o=(0,A.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,A.isUndefinedOrNull)(b.focus)?!1:b.focus,s=(0,A.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.refreshPromise.then(()=>this.resolveUnknownParentChain(r)).then(l=>this.resolveTreeNode(r,l[l.length-1]).then(a=>this.proxy.$reveal(this.viewId,{item:a.item,parentChain:l.map(d=>d.item)},{select:o,focus:u,expand:s})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:u,expand:s})}get message(){return this._message}set message(r){this._message=r,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(r){this._title=r,this.proxy.$setTitle(this.viewId,r,this._description)}get description(){return this._description}set description(r){this._description=r,this.proxy.$setTitle(this.viewId,this._title,r)}get badge(){return this._badge}set badge(r){this._badge?.value===r?.value&&this._badge?.tooltip===r?.tooltip||(this._badge=E.ViewBadge.from(r),this.proxy.$setBadge(this.viewId,r))}setExpanded(r,b){const o=this.getExtensionElement(r);o&&(b?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(r){(0,k.equals)(this._selectedHandles,r)||(this._selectedHandles=r,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(r){this._focusedHandle=r}setVisible(r){r!==this._visible&&(this._visible=r,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(r){const b=(await Promise.all(r.map(async o=>{const u=this.getExtensionElement(o.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:o.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);b.forEach(o=>{o.treeItem.checkboxState=o.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:b.map(o=>[o.extensionItem,o.newState])})}async handleDrag(r,b,o){const u=[];for(const s of r){const l=this.getExtensionElement(s);l&&u.push(l)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,b,o),b}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(r,b,o){const u=b?this.getExtensionElement(b):void 0;if(!(!u&&b||!this.dndController?.handleDrop))return(0,S.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,r,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(r,b){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(r);if(o){const u=this.nodes.get(o);if(u){const s=await this.dataProvider.resolveTreeItem(u.extensionItem,o,b)??u.extensionItem;return this.validateTreeItem(s),u.item.tooltip=this.getTooltip(s.tooltip),u.item.command=this.getCommand(u.disposableStore,s.command),u.item}}}resolveUnknownParentChain(r){return this.resolveParent(r).then(b=>b?this.resolveUnknownParentChain(b).then(o=>this.resolveTreeNode(b,o[o.length-1]).then(u=>(o.push(u),o))):Promise.resolve([]))}resolveParent(r){const b=this.nodes.get(r);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(r))}resolveTreeNode(r,b){const o=this.nodes.get(r);return o?Promise.resolve(o):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(u=>this.createHandle(r,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const s=this.getExtensionElement(u);if(s){const l=this.nodes.get(s);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(r){if(r){let b;if(typeof r=="string"){const o=this.getExtensionElement(r);b=o?this.nodes.get(o):void 0}else b=r;return b&&b.children||void 0}return this.roots}async fetchChildrenNodes(r){this.clearChildren(r);const b=new y.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=r?this.nodes.get(r):void 0,u=await this.dataProvider.getChildren(r);if(b.token.isCancellationRequested)return;const s=await Promise.all((0,k.coalesce)(u||[]).map(async l=>{const a=await this.dataProvider.getTreeItem(l);return a&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(l,a,o):null}));return b.token.isCancellationRequested?void 0:(0,k.coalesce)(s)}finally{b.dispose()}}refresh(r){if(r.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new y.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(r);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(r){const b=new Set,o=r.map(s=>this.nodes.get(s));for(const s of o)if(s&&!b.has(s.item.handle)){let l=s;for(;l&&l.parent&&o.findIndex(a=>l&&l.parent&&a&&a.item.handle===l.parent.item.handle)===-1;){const a=this.elements.get(l.parent.item.handle);l=a?this.nodes.get(a):void 0}l&&!l.parent&&b.add(s.item.handle)}const u=[];return b.forEach(s=>{const l=this.elements.get(s);if(l){const a=this.nodes.get(l);a&&(!a.parent||!b.has(a.parent.item.handle))&&u.push(s)}}),u}refreshHandles(r){const b={};return Promise.all(r.map(o=>this.refreshNode(o).then(u=>{u&&(b[o]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(r){const b=this.getExtensionElement(r);if(b){const o=this.nodes.get(b);if(o)return this.clearChildren(b),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const s=this.createTreeNode(b,u,o.parent);return this.updateNodeCache(b,s,o,o.parent),o.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(r,b,o){const u=this.createTreeNode(r,b,o);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,c.localize)(10,null,b.id));return this.addNodeToCache(r,u),this.addNodeToParentCache(u,o),u}getTooltip(r){return D.MarkdownString.isMarkdownString(r)?E.MarkdownString.from(r):r}getCommand(r,b){return b?{...this.commands.toInternal(b,r),originalId:b.command}:void 0}getCheckbox(r){if(!r.checkboxState)return;let b,o;return typeof r.checkboxState=="number"?b=r.checkboxState:(b=r.checkboxState.state,o=r.checkboxState.tooltip),{isChecked:b===D.TreeItemCheckboxState.Checked,tooltip:o}}validateTreeItem(r){if(!D.TreeItem.isTreeItem(r,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(r,b,o){this.validateTreeItem(b);const u=new T.DisposableStore,s=this.createHandle(r,b,o),l=this.getLightIconPath(b);return{item:{handle:s,parentHandle:o?o.item.handle:void 0,label:g(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:l,iconDark:this.getDarkIconPath(b)||l,themeIcon:this.getThemeIcon(b),collapsibleState:(0,A.isUndefinedOrNull)(b.collapsibleState)?D.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.getCheckbox(b)},extensionItem:b,parent:o,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(r){return r.iconPath instanceof D.ThemeIcon?r.iconPath:void 0}createHandle(r,{id:b,label:o,resourceUri:u},s,l){if(b)return`${v.ID_HANDLE_PREFIX}/${b}`;const a=g(o,this.extension),d=s?s.item.handle:v.LABEL_HANDLE_PREFIX;let n=a?a.label:u?(0,I.basename)(u):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const i=this.nodes.has(r)?this.nodes.get(r).item.handle:void 0,p=this.getChildrenNodes(s)||[];let _,R=0;do{if(_=`${d}/${R}:${n}`,l||!this.elements.has(_)||i===_)break;R++}while(R<=p.length);return _}getLightIconPath(r){if(r.iconPath&&!(r.iconPath instanceof D.ThemeIcon))return typeof r.iconPath=="string"||P.URI.isUri(r.iconPath)?this.getIconPath(r.iconPath):this.getIconPath(r.iconPath.light)}getDarkIconPath(r){if(r.iconPath&&!(r.iconPath instanceof D.ThemeIcon)&&r.iconPath.dark)return this.getIconPath(r.iconPath.dark)}getIconPath(r){return P.URI.isUri(r)?r:P.URI.file(r)}addNodeToCache(r,b){this.elements.set(b.item.handle,r),this.nodes.set(r,b)}updateNodeCache(r,b,o,u){this.elements.delete(b.item.handle),this.nodes.delete(r),b.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(r,b);const s=this.getChildrenNodes(u)||[],l=s.filter(a=>a.item.handle===o.item.handle)[0];l&&s.splice(s.indexOf(l),1,b)}addNodeToParentCache(r,b){b?(b.children||(b.children=[]),b.children.push(r)):(this.roots||(this.roots=[]),this.roots.push(r))}clearChildren(r){if(r){const b=this.nodes.get(r);if(b){if(b.children)for(const o of b.children){const u=this.elements.get(o.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(r){const b=this.nodes.get(r);if(b){if(b.children)for(const o of b.children){const u=this.elements.get(o.item.handle);u&&this.clear(u)}this.nodes.delete(r),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(r=>r.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ce[299],De([1,0,21,11,4,42,2,119,104,149,159,38,5,92,243,242,39,244,34,246,247,248,231,249,57,41,250,251,254,255,256,140,234,260,261,262,96,40,264,298,15,7,267,71,139,33,214,253,86,137,73,75,76,13,54,16,25,257,230,53,68,240,265,70,69,270,268,269,241,46,263,266,95,58,93,258,72,259,14,123,233,210,252,6,27,215,94,207]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r,b,o,u,s,l,a,d,n,i,p,_,R,M,H,$,L,B,O,z,U,F,V,x,Q,K,ue,te,he,Y,fe,be,ke,Re,ze,oe,le,ge,Z,ae,ne,ie,N,j,G,X,pe,we,ce,Ie,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,xe,me,Ae,Oe,Me,Ke,Je,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function vt(nt){const it=nt.get(le.IExtHostInitDataService),bt=nt.get(Ie.IExtHostFileSystemInfo),yt=nt.get(G.IExtHostConsumerFileSystem),Ct=nt.get(l.IExtHostExtensionService),ht=nt.get(K.IExtHostWorkspace),Dt=nt.get(Ye.IExtHostTelemetry),Mt=nt.get(v.IExtHostConfiguration),Bt=nt.get(ze.IURITransformerService),Qe=nt.get(oe.IExtHostRpcService),Ot=nt.get(L.IExtHostStorage),Tt=nt.get(j.IExtensionStoragePaths),Nt=nt.get(Re.ILoggerService),gt=nt.get(Re.ILogService),Pe=nt.get(ae.IExtHostTunnelService),Le=nt.get(ne.IExtHostApiDeprecationService),_e=nt.get(Q.IExtHostWindow),ee=nt.get(qe.IExtHostSecretState),Fe=nt.get(Ze.IExtHostEditorTabs);Qe.set(E.ExtHostContext.ExtHostFileSystemInfo,bt),Qe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Qe.set(E.ExtHostContext.ExtHostWorkspace,ht),Qe.set(E.ExtHostContext.ExtHostConfiguration,Mt),Qe.set(E.ExtHostContext.ExtHostExtensionService,Ct),Qe.set(E.ExtHostContext.ExtHostStorage,Ot),Qe.set(E.ExtHostContext.ExtHostTunnelService,Pe),Qe.set(E.ExtHostContext.ExtHostWindow,_e),Qe.set(E.ExtHostContext.ExtHostSecretState,ee),Qe.set(E.ExtHostContext.ExtHostTelemetry,Dt),Qe.set(E.ExtHostContext.ExtHostEditorTabs,Fe);const Ve=Qe.set(E.ExtHostContext.ExtHostDecorations,nt.get(Y.IExtHostDecorations)),rt=Qe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(s.IExtHostDocumentsAndEditors)),Ge=Qe.set(E.ExtHostContext.ExtHostCommands,nt.get(g.IExtHostCommands)),ot=Qe.set(E.ExtHostContext.ExtHostTerminalService,nt.get(B.IExtHostTerminalService)),lt=Qe.set(E.ExtHostContext.ExtHostDebugService,nt.get(be.IExtHostDebugService)),It=Qe.set(E.ExtHostContext.ExtHostSearch,nt.get(ke.IExtHostSearch)),wt=Qe.set(E.ExtHostContext.ExtHostTask,nt.get(fe.IExtHostTask)),kt=Qe.set(E.ExtHostContext.ExtHostOutputService,nt.get(_.IExtHostOutputService)),Et=Qe.set(E.ExtHostContext.ExtHostLocalization,nt.get(Je.IExtHostLocalizationService)),Rt=Qe.set(E.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Qe)),mt=Qe.set(E.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Qe,rt)),en=Qe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Qe,rt,gt)),tn=Qe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(gt,mt,Qe.getProxy(E.MainContext.MainThreadBulkEdits))),St=Qe.set(E.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(Qe,Ge,rt,mt)),zt=Qe.set(E.ExtHostContext.ExtHostNotebookDocuments,new me.ExtHostNotebookDocuments(St)),nn=Qe.set(E.ExtHostContext.ExtHostNotebookEditors,new xe.ExtHostNotebookEditors(gt,St)),rn=Qe.set(E.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(Qe,it,St,Ge,gt)),bn=Qe.set(E.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Qe,St)),Pt=Qe.set(E.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Qe,rt)),sn=Qe.set(E.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Qe.getProxy(E.MainContext.MainThreadTreeViews),Ge,gt)),$t=Qe.set(E.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Qe.getProxy(E.MainContext.MainThreadEditorInsets),Pt,it.remote)),Qt=Qe.set(E.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(Qe,gt,bt)),on=Qe.set(E.ExtHostContext.ExtHostLanguages,new i.ExtHostLanguages(Qe,mt,Ge.converter,Bt)),dt=Qe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Qe,Bt,mt,Ge,Qt,gt,Le,Dt)),Yt=Qe.set(E.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(Qe,dt)),Wt=Qe.set(E.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Qe,gt,rt)),qt=Qe.set(E.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Qe,ht,Ge)),an=Qe.set(E.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(Qe,Ge,gt)),wn=Qe.set(E.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Qe,Ge,mt)),cn=Qe.set(E.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Qe.getProxy(E.MainContext.MainThreadProgress))),En=Qe.set(E.ExtHostContext.ExtHosLabelService,new te.ExtHostLabelService(Qe)),ln=Qe.set(E.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Qe)),Jt=Qe.set(E.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Qe)),Nn=Qe.set(E.ExtHostContext.ExtHostTimeline,new N.ExtHostTimeline(Qe,Ge)),Sn=Qe.set(E.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Qe,it.remote,ht,gt,Le)),Zt=Qe.set(E.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Qe,Sn,ht)),_n=Qe.set(E.ExtHostContext.ExtHostCustomEditors,new pe.ExtHostCustomEditors(Qe,mt,Tt,Sn,Zt)),yn=Qe.set(E.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Qe,Sn)),Gt=Qe.set(E.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Qe,Ge,rt)),Fn=Qe.set(E.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Qe));Qe.set(E.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Qe,St,rt,Ge,gt));const Cn=Object.values(E.ExtHostContext);Qe.assertRegistered(Cn);const Dn=new ce.ExtHostBulkEdits(Qe,rt),Mn=new h.ExtHostClipboard(Qe),In=new p.ExtHostMessageService(Qe,gt),Pn=new r.ExtHostDialogs(Qe),An=new $.ExtHostStatusBar(Qe,Ge.converter);return w.ExtHostApiCommands.register(Ge),function(He,xt,un){const pt=function(){let ve=!He.isUnderDevelopment;function Se(){ve||(gt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Se();else{const _t=ct;typeof _t.scheme>"u"&&Se(),typeof _t.exclusive=="boolean"&&(0,Me.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return ct}}(),Un={getSession(ve,Se,Ue){return Jt.getSession(He,ve,Se,Ue)},async hasSession(ve,Se){return(0,Me.checkProposedApiEnabled)(He,"authSession"),!!await Jt.getSession(He,ve,Se,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(ve,Se,Ue,ct){return Jt.registerAuthenticationProvider(ve,Se,Ue,ct)}},Bn={registerCommand(ve,Se,Ue){return Ge.registerCommand(!0,ve,Se,Ue,void 0,He)},registerTextEditorCommand(ve,Se,Ue){return Ge.registerCommand(!0,ve,(...ct)=>{const _t=Pt.getActiveTextEditor();if(!_t){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}return _t.edit(At=>{Se.apply(Ue,[_t,At,...ct])}).then(At=>{At||gt.warn("Edits from command "+ve+" were not applied.")},At=>{gt.warn("An error occurred while running command "+ve,At)})},void 0,void 0,He)},registerDiffInformationCommand:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"diffCommand"),Ge.registerCommand(!0,ve,async(...ct)=>{const _t=rt.activeEditor(!0);if(!_t){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}const At=await Pt.getDiffInformation(_t.id);Se.apply(Ue,[At,...ct])},void 0,void 0,He)),executeCommand(ve,...Se){return Ge.executeCommand(ve,...Se)},getCommands(ve=!1){return Ge.getCommands(ve)}},Rn={get machineId(){return it.telemetryInfo.machineId},get sessionId(){return it.telemetryInfo.sessionId},get language(){return it.environment.appLanguage},get appName(){return it.environment.appName},get appRoot(){return it.environment.appRoot?.fsPath??""},get appHost(){return it.environment.appHost},get uriScheme(){return it.environment.appUriScheme},get clipboard(){return Mn.value},get shell(){return ot.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.checkProposedApiEnabled)(He,"envShellEvent"),ot.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(it.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Dt.instantiateLogger(He,ve)},openExternal(ve,Se){return _e.openUri(ve,{allowTunneling:!!it.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===it.environment.appUriScheme)return Rt.createAppUri(ve);try{return await _e.asExternalUri(ve,{allowTunneling:!!it.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(ve,se.Schemas.http)||(0,Ee.matchesScheme)(ve,se.Schemas.https))return ve;throw Se}},get remoteName(){return(0,he.getRemoteName)(it.remote.authority)},get remoteAuthority(){return(0,Me.checkProposedApiEnabled)(He,"resolvers"),it.remote.authority},get uiKind(){return it.uiKind},get logLevel(){return(0,Me.checkProposedApiEnabled)(He,"extensionLog"),gt.getLevel()},get onDidChangeLogLevel(){return(0,Me.checkProposedApiEnabled)(He,"extensionLog"),gt.onDidChangeLogLevel}};it.environment.extensionTestsLocationURI||Object.freeze(Rn);const dn={createTestController(ve,Se,Ue){return Gt.createTestController(ve,Se,Ue)},createTestObserver(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Gt.createTestObserver()},runTests(ve){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Gt.runTests(ve)},get onDidChangeTestResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Gt.results}},hn=it.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,zn={getExtension(ve,Se){(0,Me.isProposedApiEnabled)(He,"extensionsAny")||(Se=!1);const Ue=xt.mine.getExtensionDescription(ve);if(Ue)return new l.Extension(Ct,He.identifier,Ue,hn,!1);if(Se){const ct=xt.all.getExtensionDescription(ve);if(ct)return new l.Extension(Ct,He.identifier,ct,hn,!0)}},get all(){const ve=[];for(const Se of xt.mine.getAllExtensionDescriptions())ve.push(new l.Extension(Ct,He.identifier,Se,hn,!1));return ve},get allAcrossExtensionHosts(){(0,Me.checkProposedApiEnabled)(He,"extensionsAny");const ve=new Me.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of xt.all.getAllExtensionDescriptions()){const ct=!ve.has(Ue.identifier);Se.push(new l.Extension(Ct,He.identifier,Ue,hn,ct))}return Se},get onDidChange(){return(0,Me.isProposedApiEnabled)(He,"extensionsAny")?I.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},Wn={createDiagnosticCollection(ve){return Qt.createDiagnosticCollection(He.identifier,ve)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:ve=>Qt.getDiagnostics(ve),getLanguages(){return on.getLanguages()},setTextDocumentLanguage(ve,Se){return on.changeLanguage(ve.uri,Se)},match(ve,Se){const Ue=mt.getDocumentData(Se.uri)?.notebook;return(0,A.score)(U.LanguageSelector.from(ve),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(ve,Se,Ue){return dt.registerCodeActionProvider(He,pt(ve),Se,Ue)},registerDocumentPasteEditProvider(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,pt(ve),Se,Ue)},registerCodeLensProvider(ve,Se){return dt.registerCodeLensProvider(He,pt(ve),Se)},registerDefinitionProvider(ve,Se){return dt.registerDefinitionProvider(He,pt(ve),Se)},registerDeclarationProvider(ve,Se){return dt.registerDeclarationProvider(He,pt(ve),Se)},registerImplementationProvider(ve,Se){return dt.registerImplementationProvider(He,pt(ve),Se)},registerTypeDefinitionProvider(ve,Se){return dt.registerTypeDefinitionProvider(He,pt(ve),Se)},registerHoverProvider(ve,Se){return dt.registerHoverProvider(He,pt(ve),Se,He.identifier)},registerEvaluatableExpressionProvider(ve,Se){return dt.registerEvaluatableExpressionProvider(He,pt(ve),Se,He.identifier)},registerInlineValuesProvider(ve,Se){return dt.registerInlineValuesProvider(He,pt(ve),Se,He.identifier)},registerDocumentHighlightProvider(ve,Se){return dt.registerDocumentHighlightProvider(He,pt(ve),Se)},registerLinkedEditingRangeProvider(ve,Se){return dt.registerLinkedEditingRangeProvider(He,pt(ve),Se)},registerReferenceProvider(ve,Se){return dt.registerReferenceProvider(He,pt(ve),Se)},registerRenameProvider(ve,Se){return dt.registerRenameProvider(He,pt(ve),Se)},registerDocumentSymbolProvider(ve,Se,Ue){return dt.registerDocumentSymbolProvider(He,pt(ve),Se,Ue)},registerWorkspaceSymbolProvider(ve){return dt.registerWorkspaceSymbolProvider(He,ve)},registerDocumentFormattingEditProvider(ve,Se){return dt.registerDocumentFormattingEditProvider(He,pt(ve),Se)},registerDocumentRangeFormattingEditProvider(ve,Se){return dt.registerDocumentRangeFormattingEditProvider(He,pt(ve),Se)},registerOnTypeFormattingEditProvider(ve,Se,Ue,...ct){return dt.registerOnTypeFormattingEditProvider(He,pt(ve),Se,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentSemanticTokensProvider(He,pt(ve),Se,Ue)},registerDocumentRangeSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentRangeSemanticTokensProvider(He,pt(ve),Se,Ue)},registerSignatureHelpProvider(ve,Se,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider(He,pt(ve),Se,Ue):dt.registerSignatureHelpProvider(He,pt(ve),Se,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(ve,Se,...Ue){return dt.registerCompletionItemProvider(He,pt(ve),Se,Ue)},registerInlineCompletionItemProvider(ve,Se){return Se.handleDidShowCompletionItem&&(0,Me.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,pt(ve),Se)},registerInlineCompletionItemProviderNew(ve,Se){if((0,Me.checkProposedApiEnabled)(He,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,Me.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,pt(ve),Se)},registerDocumentLinkProvider(ve,Se){return dt.registerDocumentLinkProvider(He,pt(ve),Se)},registerColorProvider(ve,Se){return dt.registerColorProvider(He,pt(ve),Se)},registerFoldingRangeProvider(ve,Se){return dt.registerFoldingRangeProvider(He,pt(ve),Se)},registerSelectionRangeProvider(ve,Se){return dt.registerSelectionRangeProvider(He,ve,Se)},registerCallHierarchyProvider(ve,Se){return dt.registerCallHierarchyProvider(He,ve,Se)},registerTypeHierarchyProvider(ve,Se){return dt.registerTypeHierarchyProvider(He,ve,Se)},setLanguageConfiguration:(ve,Se)=>dt.setLanguageConfiguration(He,ve,Se),getTokenInformationAtPosition(ve,Se){return(0,Me.checkProposedApiEnabled)(He,"tokenInformation"),on.tokenAtPosition(ve,Se)},registerInlayHintsProvider(ve,Se){return dt.registerInlayHintsProvider(He,ve,Se)},createLanguageStatusItem(ve,Se){return on.createLanguageStatusItem(He,ve,Se)},registerDocumentDropEditProvider(ve,Se){return dt.registerDocumentOnDropEditProvider(He,ve,Se)}},Hn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(ve,Se,Ue){const ct=await(C.URI.isUri(ve)?Promise.resolve(fn.openTextDocument(ve)):Promise.resolve(ve));return Pt.showTextDocument(ct,Se,Ue)},createTextEditorDecorationType(ve){return Pt.createTextEditorDecorationType(He,ve)},onDidChangeActiveTextEditor(ve,Se,Ue){return Pt.onDidChangeActiveTextEditor(ve,Se,Ue)},onDidChangeVisibleTextEditors(ve,Se,Ue){return Pt.onDidChangeVisibleTextEditors(ve,Se,Ue)},onDidChangeTextEditorSelection(ve,Se,Ue){return Pt.onDidChangeTextEditorSelection(ve,Se,Ue)},onDidChangeTextEditorOptions(ve,Se,Ue){return Pt.onDidChangeTextEditorOptions(ve,Se,Ue)},onDidChangeTextEditorVisibleRanges(ve,Se,Ue){return Pt.onDidChangeTextEditorVisibleRanges(ve,Se,Ue)},onDidChangeTextEditorViewColumn(ve,Se,Ue){return Pt.onDidChangeTextEditorViewColumn(ve,Se,Ue)},onDidCloseTerminal(ve,Se,Ue){return ot.onDidCloseTerminal(ve,Se,Ue)},onDidOpenTerminal(ve,Se,Ue){return ot.onDidOpenTerminal(ve,Se,Ue)},onDidChangeActiveTerminal(ve,Se,Ue){return ot.onDidChangeActiveTerminal(ve,Se,Ue)},onDidChangeTerminalDimensions(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDimensions"),ot.onDidChangeTerminalDimensions(ve,Se,Ue)},onDidChangeTerminalState(ve,Se,Ue){return ot.onDidChangeTerminalState(ve,Se,Ue)},onDidWriteTerminalData(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),ot.onDidWriteTerminalData(ve,Se,Ue)},get state(){return _e.state},onDidChangeWindowState(ve,Se,Ue){return _e.onDidChangeWindowState(ve,Se,Ue)},showInformationMessage(ve,...Se){return In.showMessage(He,P.default.Info,ve,Se[0],Se.slice(1))},showWarningMessage(ve,...Se){return In.showMessage(He,P.default.Warning,ve,Se[0],Se.slice(1))},showErrorMessage(ve,...Se){return In.showMessage(He,P.default.Error,ve,Se[0],Se.slice(1))},showQuickPick(ve,Se,Ue){return qt.showQuickPick(ve,Se,Ue)},showWorkspaceFolderPick(ve){return qt.showWorkspaceFolderPick(ve)},showInputBox(ve,Se){return qt.showInput(ve,Se)},showOpenDialog(ve){return Pn.showOpenDialog(ve)},showSaveDialog(ve){return Pn.showSaveDialog(ve)},createStatusBarItem(ve,Se,Ue){let ct,_t,At;return typeof ve=="string"?(ct=ve,_t=Se,At=Ue):(_t=ve,At=Se),An.createStatusBarEntry(He,ct,_t,At)},setStatusBarMessage(ve,Se){return An.setStatusBarMessage(ve,Se)},withScmProgress(ve){return Le.report("window.withScmProgress",He,"Use 'withProgress' instead."),cn.withProgress(He,{location:F.ProgressLocation.SourceControl},(Se,Ue)=>ve({report(ct){}}))},withProgress(ve,Se){return cn.withProgress(He,ve,Se)},createOutputChannel(ve,Se){return kt.createOutputChannel(ve,Se,He)},createWebviewPanel(ve,Se,Ue,ct){return Zt.createWebviewPanel(He,ve,Se,Ue,ct)},createWebviewTextEditorInset(ve,Se,Ue,ct){return(0,Me.checkProposedApiEnabled)(He,"editorInsets"),$t.createWebviewEditorInset(ve,Se,Ue,ct,He)},createTerminal(ve,Se,Ue){return typeof ve=="object"?"pty"in ve?ot.createExtensionTerminal(ve):ot.createTerminalFromOptions(ve):ot.createTerminal(ve,Se,Ue)},registerTerminalLinkProvider(ve){return ot.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,Se){return ot.registerProfileProvider(He,ve,Se)},registerTreeDataProvider(ve,Se){return sn.registerTreeDataProvider(ve,Se,He)},createTreeView(ve,Se){return sn.createTreeView(ve,Se,He)},registerWebviewPanelSerializer:(ve,Se)=>Zt.registerWebviewPanelSerializer(He,ve,Se),registerCustomEditorProvider:(ve,Se,Ue={})=>_n.registerCustomEditorProvider(He,ve,Se,Ue),registerFileDecorationProvider(ve){return Ve.registerFileDecorationProvider(ve,He.identifier)},registerUriHandler(ve){return Rt.registerUriHandler(He.identifier,ve)},createQuickPick(){return qt.createQuickPick(He)},createInputBox(){return qt.createInputBox(He)},get activeColorTheme(){return ln.activeColorTheme},onDidChangeActiveColorTheme(ve,Se,Ue){return ln.onDidChangeActiveColorTheme(ve,Se,Ue)},registerWebviewViewProvider(ve,Se,Ue){return yn.registerWebviewViewProvider(He,ve,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,Se,Ue){return St.onDidChangeActiveNotebookEditor(ve,Se,Ue)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,Se,Ue){return nn.onDidChangeNotebookEditorSelection(ve,Se,Ue)},onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue){return nn.onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue)},showNotebookDocument(ve,Se){return C.URI.isUri(ve)&&Le.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),St.showNotebookDocument(ve,Se)},registerExternalUriOpener(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"externalUriOpener"),Fn.registerExternalUriOpener(He.identifier,ve,Se,Ue)},get tabGroups(){return Fe.tabGroups}},fn={get rootPath(){return Le.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ve){throw t.readonly()},getWorkspaceFolder(ve){return ht.getWorkspaceFolder(ve)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ve){throw t.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ve){throw t.readonly()},updateWorkspaceFolders:(ve,Se,...Ue)=>ht.updateWorkspaceFolders(He,ve,Se||0,...Ue),onDidChangeWorkspaceFolders:function(ve,Se,Ue){return ht.onDidChangeWorkspace(ve,Se,Ue)},asRelativePath:(ve,Se)=>ht.getRelativePath(ve,Se),findFiles:(ve,Se,Ue,ct)=>ht.findFiles(ve,Se,Ue,He.identifier,ct),findTextInFiles:(ve,Se,Ue,ct)=>{(0,Me.checkProposedApiEnabled)(He,"findTextInFiles");let _t,At;return typeof Se=="object"?(_t=Se,At=Ue):(_t={},At=Se,ct=Ue),ht.findTextInFiles(ve,_t||{},At,He.identifier,ct)},saveAll:ve=>ht.saveAll(ve),applyEdit(ve,Se){return Dn.applyWorkspaceEdit(ve,He,Se)},createFileSystemWatcher:(ve,Se,Ue,ct)=>Wt.createFileSystemWatcher(ht,He,ve,Se,Ue,ct),get textDocuments(){return mt.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw t.readonly()},openTextDocument(ve){let Se;const Ue=ve;if(typeof ve=="string")Se=Promise.resolve(C.URI.file(ve));else if(C.URI.isUri(ve))Se=Promise.resolve(ve);else if(!Ue||typeof Ue=="object")Se=mt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ct=>mt.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(ve,Se,Ue)=>mt.onDidAddDocument(ve,Se,Ue),onDidCloseTextDocument:(ve,Se,Ue)=>mt.onDidRemoveDocument(ve,Se,Ue),onDidChangeTextDocument:(ve,Se,Ue)=>mt.onDidChangeDocument(ve,Se,Ue),onDidSaveTextDocument:(ve,Se,Ue)=>mt.onDidSaveDocument(ve,Se,Ue),onWillSaveTextDocument:(ve,Se,Ue)=>tn.getOnWillSaveTextDocumentEvent(He)(ve,Se,Ue),get notebookDocuments(){return St.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,Se){let Ue;if(C.URI.isUri(ve))Ue=ve,await St.openNotebookDocument(ve);else if(typeof ve=="string")Ue=C.URI.revive(await St.createNotebookDocument({viewType:ve,content:Se}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ve,Se,Ue){return zt.onDidSaveNotebookDocument(ve,Se,Ue)},onDidChangeNotebookDocument(ve,Se,Ue){return zt.onDidChangeNotebookDocument(ve,Se,Ue)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ve,Se,Ue,ct){return St.registerNotebookSerializer(He,ve,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(ve,Se,Ue,ct)=>((0,Me.checkProposedApiEnabled)(He,"notebookContentProvider"),Le.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),St.registerNotebookContentProvider(He,ve,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(ve,Se,Ue)=>un.onDidChangeConfiguration(ve,Se,Ue),getConfiguration(ve,Se){return Se=arguments.length===1?void 0:Se,un.getConfiguration(ve,Se,He)},registerTextDocumentContentProvider(ve,Se){return en.registerTextDocumentContentProvider(ve,Se)},registerTaskProvider:(ve,Se)=>(Le.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(He,ve,Se)),registerFileSystemProvider(ve,Se,Ue){return(0,Oe.combinedDisposable)(Yt.registerFileSystemProvider(He,ve,Se,Ue),yt.addFileSystemProvider(ve,Se))},get fs(){return yt.value},registerFileSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"fileSearchProvider"),It.registerFileSearchProvider(ve,Se)),registerTextSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"textSearchProvider"),It.registerTextSearchProvider(ve,Se)),registerRemoteAuthorityResolver:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),Ct.registerRemoteAuthorityResolver(ve,Se)),registerResourceLabelFormatter:ve=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),En.$registerResourceLabelFormatter(ve)),onDidCreateFiles:(ve,Se,Ue)=>Wt.onDidCreateFile(ve,Se,Ue),onDidDeleteFiles:(ve,Se,Ue)=>Wt.onDidDeleteFile(ve,Se,Ue),onDidRenameFiles:(ve,Se,Ue)=>Wt.onDidRenameFile(ve,Se,Ue),onWillCreateFiles:(ve,Se,Ue)=>Wt.getOnWillCreateFileEvent(He)(ve,Se,Ue),onWillDeleteFiles:(ve,Se,Ue)=>Wt.getOnWillDeleteFileEvent(He)(ve,Se,Ue),onWillRenameFiles:(ve,Se,Ue)=>Wt.getOnWillRenameFileEvent(He)(ve,Se,Ue),openTunnel:ve=>((0,Me.checkProposedApiEnabled)(He,"tunnels"),Pe.openTunnel(He,ve).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Me.checkProposedApiEnabled)(He,"tunnels"),Pe.getTunnels()},onDidChangeTunnels:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"tunnels"),Pe.onDidChangeTunnels(ve,Se,Ue)),registerPortAttributesProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"portsAttributes"),Pe.registerPortsAttributesProvider(ve,Se)),registerTimelineProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"timeline"),Nn.registerTimelineProvider(ve,Se,He.identifier,Ge.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ve=>((0,Me.checkProposedApiEnabled)(He,"workspaceTrust"),ht.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,Se,Ue)=>ht.onDidGrantWorkspaceTrust(ve,Se,Ue),registerEditSessionIdentityProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ve,Se))},$n={get inputBox(){return Le.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),an.getLastInputBox(He)},createSourceControl(ve,Se,Ue){return an.createSourceControl(He,ve,Se,Ue)}},Vt={createCommentController(ve,Se){return wn.createCommentController(He,ve,Se)}},mn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ve,Se,Ue){return lt.onDidStartDebugSession(ve,Se,Ue)},onDidTerminateDebugSession(ve,Se,Ue){return lt.onDidTerminateDebugSession(ve,Se,Ue)},onDidChangeActiveDebugSession(ve,Se,Ue){return lt.onDidChangeActiveDebugSession(ve,Se,Ue)},onDidReceiveDebugSessionCustomEvent(ve,Se,Ue){return lt.onDidReceiveDebugSessionCustomEvent(ve,Se,Ue)},onDidChangeBreakpoints(ve,Se,Ue){return lt.onDidChangeBreakpoints(ve,Se,Ue)},registerDebugConfigurationProvider(ve,Se,Ue){return lt.registerDebugConfigurationProvider(ve,Se,Ue||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,Se){return lt.registerDebugAdapterDescriptorFactory(He,ve,Se)},registerDebugAdapterTrackerFactory(ve,Se){return lt.registerDebugAdapterTrackerFactory(ve,Se)},startDebugging(ve,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?lt.startDebugging(ve,Se,{parentSession:Ue}):lt.startDebugging(ve,Se,Ue||{})},stopDebugging(ve){return lt.stopDebugging(ve)},addBreakpoints(ve){return lt.addBreakpoints(ve)},removeBreakpoints(ve){return lt.removeBreakpoints(ve)},asDebugSourceUri(ve,Se){return lt.asDebugSourceUri(ve,Se)}},xn={registerTaskProvider:(ve,Se)=>wt.registerTaskProvider(He,ve,Se),fetchTasks:ve=>wt.fetchTasks(ve),executeTask:ve=>wt.executeTask(He,ve),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(ve,Se,Ue)=>wt.onDidStartTask(ve,Se,Ue),onDidEndTask:(ve,Se,Ue)=>wt.onDidEndTask(ve,Se,Ue),onDidStartTaskProcess:(ve,Se,Ue)=>wt.onDidStartTaskProcess(ve,Se,Ue),onDidEndTaskProcess:(ve,Se,Ue)=>wt.onDidEndTaskProcess(ve,Se,Ue)},Ft={createNotebookController(ve,Se,Ue,ct,_t){return rn.createNotebookController(He,ve,Se,Ue,ct,(0,Me.isProposedApiEnabled)(He,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ve,Se)=>St.registerNotebookCellStatusBarItemProvider(He,ve,Se),createRendererMessaging(ve){return bn.createRendererMessaging(He,ve)},onDidChangeNotebookCellExecutionState(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"notebookCellExecutionState"),rn.onDidChangeNotebookCellExecutionState(ve,Se,Ue)}},gn={t(...ve){if(typeof ve[0]=="string"){const Se=ve.shift(),Ue=!ve||typeof ve[0]!="object"?ve:ve[0];return Et.getMessage(He.identifier.value,{message:Se,args:Ue})}return Et.getMessage(He.identifier.value,ve[0])},get bundle(){return Et.getBundle(He.identifier.value)},get uri(){return Et.getBundleUri(He.identifier.value)}};return{version:it.version,authentication:Un,commands:Bn,comments:Vt,debug:mn,env:Rn,extensions:zn,l10n:gn,languages:Wn,notebooks:Ft,scm:$n,tasks:xn,tests:dn,window:Hn,workspace:fn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:I.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestionList,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:D.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,SnippetTextEdit:F.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItem2:F.TreeItem,TreeItemCheckboxState:F.TreeItemCheckboxState,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:y.UIKind,Uri:C.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,DocumentDropEdit:F.DocumentDropEdit,DocumentPasteEdit:F.DocumentPasteEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,NotebookControllerAffinity2:F.NotebookControllerAffinity2,NotebookEdit:F.NotebookEdit,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:at.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputTextMerge:F.TextMergeTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput,TabInputInteractiveWindow:F.InteractiveWindowInput,TerminalExitReason:F.TerminalExitReason,LogLevel:Re.LogLevel,EditSessionIdentityMatch:st.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=vt}),define(Ce[300],De([1,0,272,309,310,2,311]),function(J,e,c,t,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(k,E,y,w,h,g){const f=g.environment.useHostProxy,v=typeof f=="boolean"?f:!g.remote.isRemote,m=(0,C.createProxyResolver)({resolveProxy:b=>k.resolveProxy(b),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(b,o,...u)=>{switch(b){case C.LogLevel.Trace:w.trace(o,...u);break;case C.LogLevel.Debug:w.debug(o,...u);break;case C.LogLevel.Info:w.info(o,...u);break;case C.LogLevel.Warning:w.warn(o,...u);break;case C.LogLevel.Error:w.error(o,...u);break;case C.LogLevel.Critical:w.critical(o,...u);break;case C.LogLevel.Off:break;default:s(b,o,u);break}function s(l,a,...d){w.error("Unknown log level",l),w.error(a,...d)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),r=S(E,m);return A(y,r)}e.connectProxyResolver=T;function S(k,E){const y={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(h=>{y.config=k.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(h=>{w.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,C.createHttpPatch)(c,E,{config:"off"},w,!0)),on:Object.assign({},c,(0,C.createHttpPatch)(c,E,{config:"on"},w,!0)),override:Object.assign({},c,(0,C.createHttpPatch)(c,E,{config:"override"},w,!0)),onRequest:Object.assign({},c,(0,C.createHttpPatch)(c,E,y,w,!0)),default:Object.assign(c,(0,C.createHttpPatch)(c,E,y,w,!1))},https:{off:Object.assign({},t,(0,C.createHttpPatch)(t,E,{config:"off"},w,!0)),on:Object.assign({},t,(0,C.createHttpPatch)(t,E,{config:"on"},w,!0)),override:Object.assign({},t,(0,C.createHttpPatch)(t,E,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,C.createHttpPatch)(t,E,y,w,!0)),default:Object.assign(t,(0,C.createHttpPatch)(t,E,y,w,!1))},tls:Object.assign(I,(0,C.createTlsPatch)(I))}}const D=new Map;function A(k,E){return k.getExtensionPathIndex().then(y=>{const w=J.__$__nodeRequire("module"),h=w._load;w._load=function(f,v,m){if(f==="tls")return E.tls;if(f!=="http"&&f!=="https")return h.apply(this,arguments);const r=E[f],b=y.findSubstr(P.URI.file(v.filename));let o=D.get(b);if(o||D.set(b,o={}),!o[f]){const u=r.default;o[f]={...u}}return o[f]}})}}),define(Ce[301],De([1,0,74,299,286,300,41,274,2,14,7,271,113,273]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends I.RequireInterceptor{_installInterceptor(){const f=this,v=J.__$__nodeRequire("module"),m=v._load;v._load=function(u,s,l){return u=b(u),f._factories.has(u)?f._factories.get(u).load(u,S.URI.file((0,E.realpathSync)(s.filename)),a=>m.apply(this,[a,s,l])):m.apply(this,arguments)};const r=v._resolveLookupPaths;v._resolveLookupPaths=(o,u)=>r.call(this,b(o),u);const b=o=>{for(const u of f._alternatives){const s=u(o);if(s){o=s;break}}return o}}}class h extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(T.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const r=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}await this._instaService.createInstance(w,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),c.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),c.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}async _loadCommonJSModule(f,v,m){if(v.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let r=null;m.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const b=f?.identifier.value;f&&await this._extHostLocalizationService.initializeLocalizedMessages(f);try{b&&c.mark(`code/extHost/willLoadExtensionCode/${b}`),r=J.__$__nodeRequire(v.fsPath)}finally{b&&c.mark(`code/extHost/didLoadExtensionCode/${b}`),m.codeLoadingStop()}return r}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const v in f){const m=f[v];m===null?delete process.env[v]:process.env[v]=m}}}e.ExtHostExtensionService=h}),define(Ce[143],De([1,0,44,312,295,17,78,37,9,8,2,30,72,313,293,97]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(p){this.outputChannel=p}provideTextSearchResults(p,_,R,M){return this.outputChannel.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({..._,folder:_.folder.toString()})}`),new Promise((H,$)=>{M.onCancellationRequested(()=>x());const L=u(p,_),B=_.folder.fsPath,O=L.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${g} ${O}
 - cwd: ${B}`);let z=c.spawn(g,L,{cwd:B});z.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),$((0,k.serializeSearchError)(new k.SearchError(he&&he.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const F=new r(_.maxResults,B,_.previewOptions);F.on("result",he=>{U=!0,K="",R.report(he)});let V=!1;const x=()=>{V=!0,z?.kill(),F?.cancel()};let Q=!1;F.on("hitLimit",()=>{Q=!0,x()});let K="";z.stdout.on("data",he=>{F.handleData(he),U||(K+=he)});let ue=!1;z.stdout.once("data",()=>ue=!0);let te="";z.stderr.on("data",he=>{const Y=he.toString();this.outputChannel.appendLine(Y),te.length+Y.length<1e6&&(te+=Y)}),z.on("close",()=>{if(this.outputChannel.appendLine(ue?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),V)H({limitHit:Q});else{F.flush(),z=null;let he;te&&!ue&&(he=v(te))?$((0,k.serializeSearchError)(new k.SearchError(he.message,he.code))):H({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=f;function v(i){const p=i.split(`
`),_=p[0].trim();if(p.some(M=>M.startsWith("regex parse error")))return new k.SearchError(m(p),k.SearchErrorCode.regexParseError);const R=_.match(/grep config error: unknown encoding: (.*)/);if(R)return new k.SearchError(`Unknown encoding: ${R[1]}`,k.SearchErrorCode.unknownEncoding);if(_.startsWith("error parsing glob"))return new k.SearchError(_.charAt(0).toUpperCase()+_.substr(1),k.SearchErrorCode.globParseError);if(_.startsWith("the literal"))return new k.SearchError(_.charAt(0).toUpperCase()+_.substr(1),k.SearchErrorCode.invalidLiteral);if(_.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(_,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function m(i){const p=["Regex parse error"],_=i.filter(R=>R.startsWith("PCRE2:"));if(_.length>=1){const R=_[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const M=R.split(":")[1];p.push(":"+M)}}return p.join("")}e.buildRegexParseError=m;class r extends t.EventEmitter{constructor(p,_,R){super(),this.maxResults=p,this.rootFolder=_,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(p,_){return super.on(p,_),this}handleData(p){if(this.isDone)return;const _=typeof p=="string"?p:this.stringDecoder.write(p);this.handleDecodedData(_)}handleDecodedData(p){let _=p.indexOf(`
`);const R=this.remainder+p;if(_>=0)_+=this.remainder.length;else{this.remainder=R;return}let M=0;for(;_>=0;)this.handleLine(R.substring(M,_).trim()),M=_+1,_=R.indexOf(`
`,M);this.remainder=R.substring(M)}handleLine(p){if(this.isDone||!p)return;let _;try{_=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(_.type==="match"){const R=b(_.data.path),M=A.URI.file(S.join(this.rootFolder,R)),H=this.createTextSearchMatch(_.data,M);this.onResult(H),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(_.type==="context"){const R=b(_.data.path),M=A.URI.file(S.join(this.rootFolder,R));this.createTextSearchContext(_.data,M).forEach($=>this.onResult($))}}createTextSearchMatch(p,_){const R=p.line_number-1,M=b(p.lines),H=Buffer.from(M);let $=0,L=0,B=R;p.submatches.length===0&&p.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const O=(0,P.coalesce)(p.submatches.map((z,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const F=b(z.match),V=H.slice($,z.start).toString(),x=o(V),Q=x.numLines>0?x.lastLineLength:x.lastLineLength+L,K=o(F),ue=x.numLines+B,te=K.numLines+ue,he=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return $=z.end,L=he,B=te,new E.Range(ue,Q,te,he)}));return(0,h.createTextSearchResult)(_,M,O,this.previewOptions)}createTextSearchContext(p,_){const R=b(p.lines),M=p.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((H,$)=>({text:H,uri:_,lineNumber:M+$}))}onResult(p){this.emit("result",p)}}e.RipgrepParser=r;function b(i){return i.bytes?Buffer.from(i.bytes,"base64").toString():i.text}function o(i){const p=/\n/g;let _=0,R=-1,M;for(;M=p.exec(i);)_++,R=M.index;const H=R>=0?i.length-R-1:i.length;return{numLines:_,lastLineLength:H}}function u(i,p){const _=["--hidden"];_.push(i.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:M}=(0,C.groupBy)(p.includes,$=>$.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const $=new Set;M.forEach(L=>{$.add(L)}),_.push("-g","!*"),$.forEach(L=>{s(L).map(h.anchorGlob).forEach(B=>{_.push("-g",B)})})}R&&R.length&&R.forEach($=>{_.push("-g",$)}),p.excludes.map(h.anchorGlob).forEach($=>_.push("-g",`!${$}`)),p.maxFileSize&&_.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||_.push("--no-ignore-parent"):_.push("--no-ignore"),p.followSymlinks&&_.push("--follow"),p.encoding&&p.encoding!=="utf8"&&_.push("--encoding",p.encoding),i.pattern==="--"&&(i.isRegExp=!0,i.pattern="\\-\\-"),i.isMultiline&&!i.isRegExp&&(i.pattern=(0,D.escapeRegExpCharacters)(i.pattern),i.isRegExp=!0),p.usePCRE2&&_.push("--pcre2"),_.push("--crlf"),i.isRegExp&&(i.pattern=l(i.pattern),_.push("--engine","auto"));let H;if(i.isWordMatch){const L=(0,D.createRegExp)(i.pattern,!!i.isRegExp,{wholeWord:i.isWordMatch}).source.replace(/\\\//g,"/");_.push("--regexp",L)}else if(i.isRegExp){let $=d(i.pattern);$=n($),_.push("--regexp",$)}else H=i.pattern,_.push("--fixed-strings");return _.push("--no-config"),p.useGlobalIgnoreFiles||_.push("--no-ignore-global"),_.push("--json"),i.isMultiline&&_.push("--multiline"),p.beforeContext&&_.push("--before-context",p.beforeContext+""),p.afterContext&&_.push("--after-context",p.afterContext+""),_.push("--"),H&&_.push(H),_.push("."),_}function s(i){const p=(0,T.splitGlobAware)(i,"/");return p.map((_,R)=>p.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function l(i){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;i.match(p);)i=i.replace(p,"$1\\x{$2}");const _=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;i.match(_);)i=i.replace(_,"$1\\x{$2}");return i}e.unicodeEscapesToPCRE2=l;const a=i=>i.type==="Assertion"&&i.kind==="lookbehind";function d(i){let p;try{p=new y.RegExpParser().parsePattern(i)}catch{return i}let _="",R=0;const M=(L,B,O)=>{_+=i.slice(R,L)+O,R=B},H=[];return new y.RegExpVisitor({onCharacterEnter(L){if(L.raw!=="\\n")return;const B=H[0];if(!B)M(L.start,L.end,"\\r?\\n");else if(!H.some(a))if(B.type==="CharacterClass")if(B.negate){const O=i.slice(B.start+2,L.start)+i.slice(L.end,B.end-1);B.parent?.type==="Quantifier"?M(B.start,B.end,O?`[^${O}]`:"."):M(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=i.slice(B.start+1,L.start)+i.slice(L.end,B.end-1);M(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&M(L.start,L.end,"(?:\\r?\\n)")},onQuantifierEnter(L){H.unshift(L)},onQuantifierLeave(){H.shift()},onCharacterClassRangeEnter(L){H.unshift(L)},onCharacterClassRangeLeave(){H.shift()},onCharacterClassEnter(L){H.unshift(L)},onCharacterClassLeave(){H.shift()},onAssertionEnter(L){a(L)&&H.push(L)},onAssertionLeave(L){H[0]===L&&H.shift()}}).visit(p),_+=i.slice(R),_}e.fixRegexNewline=d;function n(i){return i.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(Ce[302],De([1,0,21,143,124,14]),function(J,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,A,k,E){const y=new t.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===P.Schemas.vscodeUserData){const w={...A,folder:A.folder.with({scheme:P.Schemas.file})},h=new I.Progress(g=>k.report({...g,uri:g.uri.with({scheme:A.folder.scheme})}));return this.withToken(E,g=>y.provideTextSearchResults(D,w,h,g))}else return this.withToken(E,w=>y.provideTextSearchResults(D,A,k,w))}async withToken(D,A){const k=T(D);this.inProgress.add(k);const E=await A(k.token);return this.inProgress.delete(k),E}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=C;function T(S){const D=new c.CancellationTokenSource;return S.onCancellationRequested(()=>D.cancel()),D}}),define(Ce[303],De([1,0,29,143,142]),function(J,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(S){this.query=S}search(S,D,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(y){A({message:y})}},E=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),c);return new Promise((y,w)=>E.search(h=>{D(h.map(C))},S).then(h=>y({limitHit:h.limitHit,type:"success",stats:h.stats}),w))}}e.TextSearchEngineAdapter=P;function C(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,D)=>{if(D.ranges){const A=D;return S+(Array.isArray(A.ranges)?A.ranges.length:1)}else return S+1},0)}}}),define(Ce[304],De([1,0,17,18,11,4,109,9,51,2,38,30,294,303]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let b;const o=f(r),u=new P.Emitter({onFirstListenerDidAdd:()=>{b=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(E.Engine,o,l=>u.fire(l),s)),b.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{b.cancel()}});return u.event}textSearch(r){let b;const o=f(r),u=new P.Emitter({onFirstListenerDidAdd:()=>{b=(0,t.createCancelablePromise)(s=>this.ripgrepTextSearch(o,l=>u.fire(l),s)),b.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{b.cancel()}});return u.event}ripgrepTextSearch(r,b,o){return r.maxFileSize=(0,A.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new y.TextSearchEngineAdapter(r).search(o,b,b)}doFileSearch(r,b,o){return this.doFileSearchWithEngine(E.Engine,r,b,o)}doFileSearchWithEngine(r,b,o,u,s=w.BATCH_SIZE){let l=0;const a=n=>{Array.isArray(n)?(l+=n.length,o(n.map(i=>this.rawMatchToSearchItem(i)))):n.relativePath?(l++,o(this.rawMatchToSearchItem(n))):o(n)};if(b.sortByScore){let n=this.trySortedSearchFromCache(b,a,u);if(!n){const i=b.maxResults?Object.assign({},b,{maxResults:null}):b,p=new r(i);n=this.doSortedSearch(p,b,o,a,u)}return new Promise((i,p)=>{n.then(([_,R])=>{const M=R.map(H=>this.rawMatchToSearchItem(H));this.sendProgress(M,o,s),i(_)},p)})}const d=new r(b);return this.doSearch(d,a,s,u).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,T.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,b,o,u,s){const l=new P.Emitter;let a=(0,t.createCancelablePromise)(n=>{let i=[];const p=_=>{Array.isArray(_)?i=_:(u(_),l.fire(_))};return this.doSearch(r,p,-1,n).then(_=>[_,i])}),d;if(b.cacheKey){d=this.getOrCreateCache(b.cacheKey);const n={promise:a,event:l.event,resolved:!1};d.resultsToSearchCache[b.filePattern||""]=n,a.then(()=>{n.resolved=!0},i=>{delete d.resultsToSearchCache[b.filePattern||""]}),a=this.preventCancellation(a)}return a.then(([n,i])=>{const p=d?d.scorerCache:Object.create(null),_=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(b,i,p,s).then(R=>{const M=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:b.folderQueries.length,resultCount:R.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&i.length>b.maxResults},R]})})}getOrCreateCache(r){const b=this.caches[r];return b||(this.caches[r]=new h)}trySortedSearchFromCache(r,b,o){const u=r.cacheKey&&this.caches[r.cacheKey];if(!u)return;const s=this.getResultsFromCache(u,r.filePattern||"",b,o);if(s)return s.then(([l,a,d])=>{const n=S.StopWatch.create(!1);return this.sortResults(r,a,u.scorerCache,o).then(i=>{const p=n.elapsed(),_={fromCache:!0,detailStats:d,type:this.processType,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&a.length>r.maxResults,stats:_},i]})})}sortResults(r,b,o,u){const s=(0,C.prepareQuery)(r.filePattern||""),l=(d,n)=>(0,C.compareItemsByFuzzyScore)(d,n,s,!0,g,o),a=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return c.topAsync(b,l,a,1e4,u)}sendProgress(r,b,o){if(o&&o>0)for(let u=0;u<r.length;u+=o)b(r.slice(u,u+o));else b(r)}getResultsFromCache(r,b,o,u){const s=S.StopWatch.create(!1),l=b.indexOf(T.sep)>=0;let a;for(const p in r.resultsToSearchCache)if(b.startsWith(p)){if(l&&p.indexOf(T.sep)<0&&p!=="")continue;const _=r.resultsToSearchCache[p];a={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!a)return null;const d=s.elapsed(),n=S.StopWatch.create(!1),i=a.event(o);return u&&u.onCancellationRequested(()=>{i.dispose()}),a.promise.then(([p,_])=>{if(u&&u.isCancellationRequested)throw(0,I.canceled)();const R=[],M=(0,C.prepareQuery)(b).normalizedLowercase;for(const H of _)!(0,k.isFilePatternMatch)(H,M)||R.push(H);return[p,R,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:n.elapsed(),cacheEntryCount:_.length}]})}doSearch(r,b,o,u){return new Promise((s,l)=>{let a=[];u?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(o?(a.push(d),o>0&&a.length>=o&&(b(a),a=[])):b(d))},d=>{b(d)},(d,n)=>{a.length&&b(a),d?l(d):s(n)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,o){return r.then(b,o)}catch(b){return this.then(void 0,b)}finally(b){return r.finally(b)}}}}e.SearchService=w,w.BATCH_SIZE=512;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(m){return(0,T.basename)(m.relativePath)}getItemDescription(m){return(0,T.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(r=>D.URI.revive(r))}}function v(m){return{...m,folder:D.URI.revive(m.folder)}}}),define(Ce[305],De([1,0,6,14,2,29,13,25,16,76,54,30,304,302,97,142]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends D.ExtHostSearch{constructor(v,m,r,b){super(v,r,b),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new y.RipgrepSearchProvider(o)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new y.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new E.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,m){const r=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(v)),(0,c.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(v,m,r,b){const o=(0,D.reviveQuery)(r);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,m,o,b):super.$provideFileSearchResults(v,m,r,b)}doInternalFileSearch(v,m,r,b){const o=u=>{if((0,k.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(v,m,u.map(s=>I.URI.file(s.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,o,b)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,m){return new h.NativeTextSearchManager(v,m,void 0,"textSearchProvider")}};g=je([$e(0,S.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,A.IURITransformerService),$e(3,C.ILogService)],g),e.NativeExtHostSearch=g}),define(Ce[306],De([1,0,84,277,289,288,305,301,278,75,41,76,73,40,53,70,276,275,13,290,47]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f,v,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService,!1),(0,c.registerSingleton)(v.ILoggerService,f.ExtHostLoggerService,1),(0,c.registerSingleton)(h.IExtensionStoragePaths,g.ExtensionStoragePaths,!1),(0,c.registerSingleton)(D.IExtHostDebugService,P.ExtHostDebugService,!1),(0,c.registerSingleton)(k.IExtHostSearch,C.NativeExtHostSearch,!1),(0,c.registerSingleton)(E.IExtHostTask,I.ExtHostTask,!1),(0,c.registerSingleton)(y.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,c.registerSingleton)(w.IExtHostTunnelService,S.ExtHostTunnelService,!1),(0,c.registerSingleton)(r.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,!1)}),define(Ce[314],De([1,0,218,315,74,11,116,117,197,92,287,23,29,113,18,119,213,227,291,306]),function(J,e,c,t,I,P,C,T,S,D,A,k,E,y,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=J.__$__nodeRequire("module"),d=a._load;a._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const m=process.exit.bind(process);function r(a){process.exit=function(d){if(a)m(d);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(a){m()};function o(){const a=(0,f.readExtHostConnection)(process.env);if(a.type===3)return new Promise((d,n)=>{const i=p=>{const _=p[0],R=new C.BufferedEmitter;_.on("message",M=>R.fire(k.VSBuffer.wrap(M.data))),_.on("close",()=>{b("renderer closed the MessagePort")}),_.start(),d({onMessage:R.event,send:M=>_.postMessage(M.buffer)})};if(global.vscodePorts){const p=global.vscodePorts;delete global.vscodePorts,i(p)}else global.vscodePortsCallback=i});if(a.type===2)return new Promise((d,n)=>{let i=null;const p=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),_=108e5,R=3e5,M=new w.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),_),H=new w.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),R);process.on("message",(L,B)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let z;if(L.skipWebSocketFrames)z=new T.NodeSocket(B,"extHost-socket");else{const U=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));z=new T.WebSocketNodeSocket(new T.NodeSocket(B,"extHost-socket"),L.permessageDeflate,U,!1)}i?(M.cancel(),H.cancel(),i.beginAcceptReconnection(z,O),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(p),i=new C.PersistentProtocol(z,O),i.sendResume(),i.onDidDispose(()=>b("renderer disconnected")),d(i),i.onSocketClose(()=>{M.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(H.isScheduled())return;M.isScheduled()&&H.schedule()}});const $={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.($)});{const d=a.pipeName;return new Promise((n,i)=>{const p=c.createConnection(d,()=>{p.removeListener("error",i);const _=new C.PersistentProtocol(new T.NodeSocket(p,"extHost-renderer"));_.sendResume(),n(_)});p.once("error",i),p.on("close",()=>{b("renderer closed the socket")})})}}async function u(){const a=await o();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,a.onMessage(d=>{(0,D.isMessageOfType)(d,2)?(this._terminating=!0,b("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||a.send(d)}async drain(){if(a.drain)return a.drain()}}}function s(a){return new Promise(d=>{const n=a.onMessage(i=>{n.dispose();const p=JSON.parse(i.toString()),_=p.commit,R=S.default.commit;if(_&&R&&_!==R&&m(55),p.parentPid){let M=0;setInterval(function(){try{process.kill(p.parentPid,0),M=0}catch($){$&&$.code==="EPERM"?(M++,M>=3&&b(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):b(`parent process ${p.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let H;try{H=J.__$__nodeRequire("native-watchdog"),H.start(p.parentPid)}catch($){(0,P.onUnexpectedError)($)}}a.send((0,D.createMessageOfType)(0)),d({protocol:a,initData:p})});a.send((0,D.createMessageOfType)(1))})}async function l(){const a=[];process.on("unhandledRejection",(M,H)=>{a.push(H),setTimeout(()=>{const $=a.indexOf(H);$>=0&&H.catch(L=>{a.splice($,1),(0,P.isCancellationError)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const H=a.indexOf(M);H>=0&&a.splice(H,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),I.mark("code/extHost/willConnectToRenderer");const d=await u();I.mark("code/extHost/didConnectToRenderer");const n=await s(d);I.mark("code/extHost/didWaitForInitData");const{initData:i}=n;r(!!i.environment.extensionTestsLocationURI),i.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,i.environment.skipWorkspaceStorageLock=(0,h.boolean)(v.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(H){m(H)}exists(H){return E.Promises.exists(H)}realpath(H){return(0,y.realpath)(H)}};let _=null;i.remote.authority&&v.transformURIs&&(_=(0,g.createURITransformer)(i.remote.authority));const R=new A.ExtensionHostMain(n.protocol,i,p,_);b=M=>R.terminate(M)}e.startExtensionHostProcess=l,l().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1c78193f54fac6036829ec554ce218d99afc1f15/core/vs/workbench/api/node/extensionHostProcess.js.map
