/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configuration","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ne){for(var e=[],i=0,D=ne.length;i<D;i++)e[i]=De[ne[i]];return e};define(De[77],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(_,A){const y=Object.create(null);for(const k of _){const O=A(k);let w=y[O];w||(w=y[O]=[]),w.push(k)}return y}e.groupBy=i;function D(_,A){const y=[],k=[];for(const O of _)A.has(O)||y.push(O);for(const O of A)_.has(O)||k.push(O);return{removed:y,added:k}}e.diffSets=D;function S(_,A){const y=[],k=[];for(const[O,w]of _)A.has(O)||y.push(w);for(const[O,w]of A)_.has(O)||k.push(w);return{removed:y,added:k}}e.diffMaps=S;class F{constructor(){this.map=new Map}add(A,y){let k=this.map.get(A);k||(k=new Set,this.map.set(A,k)),k.add(y)}delete(A,y){const k=this.map.get(A);!k||(k.delete(y),k.size===0&&this.map.delete(A))}forEach(A,y){const k=this.map.get(A);!k||k.forEach(y)}}e.SetMap=F}),define(De[58],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function i(_){return(A,y,k)=>{let O=null,w=null;if(typeof k.value=="function"?(O="value",w=k.value):typeof k.get=="function"&&(O="get",w=k.get),!w)throw new Error("not supported");k[O]=_(w,y)}}e.createDecorator=i;function D(_,A,y){let k=null,O=null;if(typeof y.value=="function"?(k="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",O=y.get),!O)throw new Error("not supported");const w=`$memoize$${A}`;y[k]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,g)}),this[w]}}e.memoize=D;function S(_,A,y){return i((k,O)=>{const w=`$debounce$${O}`,g=`$debounce$result$${O}`;return function(...E){this[g]||(this[g]=y?y():void 0),clearTimeout(this[w]),A&&(this[g]=A(this[g],...E),E=[this[g]]),this[w]=setTimeout(()=>{k.apply(this,E),this[g]=y?y():void 0},_)}})}e.debounce=S;function F(_,A,y){return i((k,O)=>{const w=`$throttle$timer$${O}`,g=`$throttle$result$${O}`,E=`$throttle$lastRun$${O}`,m=`$throttle$pending$${O}`;return function(...t){if(this[g]||(this[g]=y?y():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),A&&(this[g]=A(this[g],...t)),this[m])return;const o=this[E]+_;o<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[g]]),this[g]=y?y():void 0):(this[m]=!0,this[w]=setTimeout(()=>{this[m]=!1,this[E]=Date.now(),k.apply(this,[this[g]]),this[g]=y?y():void 0},o-Date.now()))}})}e.throttle=F}),define(De[78],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(De[106],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var F;(function(s){s.DEFAULT={allowTrailingComma:!0}})(F=e.ParseOptions||(e.ParseOptions={}));function _(s,c=!1){let n=0;const d=s.length;let l="",f=0,r=16,h=0;function v(M){let R=0,B=0;for(;R<M;){const x=s.charCodeAt(n);if(x>=48&&x<=57)B=B*16+x-48;else if(x>=65&&x<=70)B=B*16+x-65+10;else if(x>=97&&x<=102)B=B*16+x-97+10;else break;n++,R++}return R<M&&(B=-1),B}function I(M){n=M,l="",f=0,r=16,h=0}function L(){const M=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&k(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&k(s.charCodeAt(n)))for(n++;n<s.length&&k(s.charCodeAt(n));)n++;else return h=3,s.substring(M,n);let R=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&k(s.charCodeAt(n))){for(n++;n<s.length&&k(s.charCodeAt(n));)n++;R=n}else h=3;return s.substring(M,R)}function j(){let M="",R=n;for(;;){if(n>=d){M+=s.substring(R,n),h=2;break}const B=s.charCodeAt(n);if(B===34){M+=s.substring(R,n),n++;break}if(B===92){if(M+=s.substring(R,n),n++,n>=d){h=2;break}switch(s.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const U=v(4);U>=0?M+=String.fromCharCode(U):h=4;break}default:h=5}R=n;continue}if(B>=0&&B<=31)if(y(B)){M+=s.substring(R,n),h=2;break}else h=6;n++}return M}function W(){if(l="",h=0,f=n,n>=d)return f=d,r=17;let M=s.charCodeAt(n);if(A(M)){do n++,l+=String.fromCharCode(M),M=s.charCodeAt(n);while(A(M));return r=15}if(y(M))return n++,l+=String.fromCharCode(M),M===13&&s.charCodeAt(n)===10&&(n++,l+=`
`),r=14;switch(M){case 123:return n++,r=1;case 125:return n++,r=2;case 91:return n++,r=3;case 93:return n++,r=4;case 58:return n++,r=6;case 44:return n++,r=5;case 34:return n++,l=j(),r=10;case 47:{const R=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<d&&!y(s.charCodeAt(n));)n++;return l=s.substring(R,n),r=12}if(s.charCodeAt(n+1)===42){n+=2;const B=d-1;let x=!1;for(;n<B;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,h=1),l=s.substring(R,n),r=13}return l+=String.fromCharCode(M),n++,r=16}case 45:if(l+=String.fromCharCode(M),n++,n===d||!k(s.charCodeAt(n)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=L(),r=11;default:for(;n<d&&H(M);)n++,M=s.charCodeAt(n);if(f!==n){switch(l=s.substring(f,n),l){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return l+=String.fromCharCode(M),n++,r=16}}function H(M){if(A(M)||y(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let M;do M=W();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>n,scan:c?P:W,getToken:()=>r,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>h}}e.createScanner=_;function A(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function y(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var O;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(O||(O={}));function w(s,c){const n=[],d=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function h(v,I,L,j){f.value=v,f.offset=I,f.length=L,f.type=j,f.colonOffset=void 0,l=f}try{b(s,{onObjectBegin:(v,I)=>{if(c<=v)throw d;l=void 0,r=c>v,n.push("")},onObjectProperty:(v,I,L)=>{if(c<I||(h(v,I,L,"property"),n[n.length-1]=v,c<=I+L))throw d},onObjectEnd:(v,I)=>{if(c<=v)throw d;l=void 0,n.pop()},onArrayBegin:(v,I)=>{if(c<=v)throw d;l=void 0,n.push(0)},onArrayEnd:(v,I)=>{if(c<=v)throw d;l=void 0,n.pop()},onLiteralValue:(v,I,L)=>{if(c<I||(h(v,I,L,C(v)),c<=I+L))throw d},onSeparator:(v,I,L)=>{if(c<=I)throw d;if(v===":"&&l&&l.type==="property")l.colonOffset=I,r=!1,l=void 0;else if(v===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(r=!0,n[n.length-1]=""),l=void 0}}})}catch(v){if(v!==d)throw v}return{path:n,previousNode:l,isAtPropertyKey:r,matches:v=>{let I=0;for(let L=0;I<v.length&&L<n.length;L++)if(v[I]===n[L]||v[I]==="*")I++;else if(v[I]!=="**")return!1;return I===v.length}}}e.getLocation=w;function g(s,c=[],n=F.DEFAULT){let d=null,l=[];const f=[];function r(v){Array.isArray(l)?l.push(v):d!==null&&(l[d]=v)}return b(s,{onObjectBegin:()=>{const v={};r(v),f.push(l),l=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const v=[];r(v),f.push(l),l=v,d=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:r,onError:(v,I,L)=>{c.push({error:v,offset:I,length:L})}},n),l[0]}e.parse=g;function E(s,c=[],n=F.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(v){d.type==="property"&&(d.length=v-d.offset,d=d.parent)}function f(v){return d.children.push(v),v}b(s,{onObjectBegin:v=>{d=f({type:"object",offset:v,length:-1,parent:d,children:[]})},onObjectProperty:(v,I,L)=>{d=f({type:"property",offset:I,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:v,offset:I,length:L,parent:d})},onObjectEnd:(v,I)=>{d.length=v+I-d.offset,d=d.parent,l(v+I)},onArrayBegin:(v,I)=>{d=f({type:"array",offset:v,length:-1,parent:d,children:[]})},onArrayEnd:(v,I)=>{d.length=v+I-d.offset,d=d.parent,l(v+I)},onLiteralValue:(v,I,L)=>{f({type:C(v),offset:I,length:L,parent:d,value:v}),l(I+L)},onSeparator:(v,I,L)=>{d.type==="property"&&(v===":"?d.colonOffset=I:v===","&&l(I))},onError:(v,I,L)=>{c.push({error:v,offset:I,length:L})}},n);const h=d.children[0];return h&&delete h.parent,h}e.parseTree=E;function m(s,c){if(!s)return;let n=s;for(const d of c)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===d){n=f.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=m;function t(s){if(!s.parent||!s.parent.children)return[];const c=t(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;c.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&c.push(n)}return c}e.getNodePath=t;function o(s){switch(s.type){case"array":return s.children.map(o);case"object":{const c=Object.create(null);for(const n of s.children){const d=n.children[1];d&&(c[n.children[0].value]=o(d))}return c}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=o;function a(s,c,n=!1){return c>=s.offset&&c<s.offset+s.length||n&&c===s.offset+s.length}e.contains=a;function p(s,c,n=!1){if(a(s,c,n)){const d=s.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=c;l++){const f=p(d[l],c,n);if(f)return f}return s}}e.findNodeAtOffset=p;function b(s,c,n=F.DEFAULT){const d=_(s,!1);function l(le){return le?()=>le(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(le){return le?fe=>le(fe,d.getTokenOffset(),d.getTokenLength()):()=>!0}const r=l(c.onObjectBegin),h=f(c.onObjectProperty),v=l(c.onObjectEnd),I=l(c.onArrayBegin),L=l(c.onArrayEnd),j=f(c.onLiteralValue),W=f(c.onSeparator),H=l(c.onComment),P=f(c.onError),M=n&&n.disallowComments,R=n&&n.allowTrailingComma;function B(){for(;;){const le=d.scan();switch(d.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:M||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(le){case 12:case 13:M?x(10):H();break;case 16:x(1);break;case 15:case 14:break;default:return le}}}function x(le,fe=[],Q=[]){if(P(le),fe.length+Q.length>0){let pe=d.getToken();for(;pe!==17;){if(fe.indexOf(pe)!==-1){B();break}else if(Q.indexOf(pe)!==-1)break;pe=B()}}}function U(le){const fe=d.getTokenValue();return le?j(fe):h(fe),B(),!0}function K(){switch(d.getToken()){case 11:{let le=0;try{le=JSON.parse(d.getTokenValue()),typeof le!="number"&&(x(2),le=0)}catch{x(2)}j(le);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return B(),!0}function te(){return d.getToken()!==10?(x(3,[],[2,5]),!1):(U(!1),d.getToken()===6?(W(":"),B(),be()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function de(){r(),B();let le=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(le||x(4,[],[]),W(","),B(),d.getToken()===2&&R)break}else le&&x(6,[],[]);te()||x(4,[],[2,5]),le=!0}return v(),d.getToken()!==2?x(7,[2],[]):B(),!0}function re(){I(),B();let le=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(le||x(4,[],[]),W(","),B(),d.getToken()===4&&R)break}else le&&x(6,[],[]);be()||x(4,[],[4,5]),le=!0}return L(),d.getToken()!==4?x(8,[4],[]):B(),!0}function be(){switch(d.getToken()){case 3:return re();case 1:return de();case 10:return U(!0);default:return K()}}return B(),d.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):be()?(d.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=b;function u(s,c){const n=_(s),d=[];let l,f=0,r;do switch(r=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:f!==r&&d.push(s.substring(f,r)),c!==void 0&&d.push(n.getTokenValue().replace(/[^\r\n]/g,c)),f=n.getPosition();break}while(l!==17);return d.join("")}e.stripComments=u;function C(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(De[28],Ce([1,0]),function(ne,e){"use strict";var i,D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function F(m,t,o){let a=m.get(t);return a===void 0&&(a=o,m.set(t,a)),a}e.getOrSet=F;function _(m){const t=[];return m.forEach((o,a)=>{t.push(`${a} => ${o}`)}),`Map(${m.size}) {${t.join(", ")}}`}e.mapToString=_;function A(m){const t=[];return m.forEach(o=>{t.push(o)}),`Set(${m.size}) {${t.join(", ")}}`}e.setToString=A;class y{constructor(t,o){this.uri=t,this.value=o}}class k{constructor(t,o){this[i]="ResourceMap",t instanceof k?(this.map=new Map(t.map),this.toKey=o??k.defaultToKey):(this.map=new Map,this.toKey=t??k.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new y(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[a,p]of this.map)t(p.value,p.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=k,k.defaultToKey=m=>m.toString();class O{constructor(t,o){this[D]="ResourceSet",!t||typeof t=="function"?this._map=new k(t):(this._map=new k(o),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,o){this._map.forEach((a,p)=>t.call(o,p,p,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var w;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class g{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const a=this._map.get(t);if(!!a)return o!==0&&this.touch(a,o),a.value}set(t,o,a=0){let p=this._map.get(t);if(p)p.value=o,a!==0&&this.touch(p,a);else{switch(p={key:t,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(t,p),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const a=this._state;let p=this._head;for(;p;){if(o?t.bind(o)(p.value,p.key,this):t(p.value,p.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const t=this,o=this._state;let a=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.key,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return p}values(){const t=this,o=this._state;let a=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.value,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return p}entries(){const t=this,o=this._state;let a=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:[a.key,a.value],done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return p}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>t;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,a=t.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const a=t.next,p=t.previous;t===this._tail?(p.next=void 0,this._tail=p):(a.previous=p,p.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const a=t.next,p=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=p,p.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,a)=>{t.push([a,o])}),t}fromJSON(t){this.clear();for(const[o,a]of t)this.set(o,a)}}e.LinkedMap=g;class E extends g{constructor(t,o=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[107],Ce([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(ke,ye){for(var Ie=0;Ie<ye.length;Ie++){var ae=ye[Ie];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function i(ke,ye,Ie){return ye&&e(ke.prototype,ye),Ie&&e(ke,Ie),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function D(ke,ye){if(!!ke){if(typeof ke=="string")return S(ke,ye);var Ie=Object.prototype.toString.call(ke).slice(8,-1);if(Ie==="Object"&&ke.constructor&&(Ie=ke.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(ke);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return S(ke,ye)}}function S(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var Ie=0,ae=new Array(ye);Ie<ye;Ie++)ae[Ie]=ke[Ie];return ae}function F(ke,ye){var Ie=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(Ie)return(Ie=Ie.call(ke)).next.bind(Ie);if(Array.isArray(ke)||(Ie=D(ke))||ye&&ke&&typeof ke.length=="number"){Ie&&(ke=Ie);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=_();function A(ke){ne.defaults=ke}var y=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ye){return g[ye]};function m(ke,ye){if(ye){if(y.test(ke))return ke.replace(k,E)}else if(O.test(ke))return ke.replace(w,E);return ke}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(t,function(ye,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var a=/(^|[^\[])\^/g;function p(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var Ie={replace:function(ue,ee){return ee=ee.source||ee,ee=ee.replace(a,"$1"),ke=ke.replace(ue,ee),Ie},getRegex:function(){return new RegExp(ke,ye)}};return Ie}var b=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(ke,ye,Ie){if(ke){var ae;try{ae=decodeURIComponent(o(Ie)).replace(b,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!u.test(Ie)&&(Ie=l(ye,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var s={},c=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(ke,ye){s[" "+ke]||(c.test(ke)?s[" "+ke]=ke+"/":s[" "+ke]=v(ke,"/",!0)),ke=s[" "+ke];var Ie=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ie?ye:ke.replace(n,"$1")+ye:ye.charAt(0)==="/"?Ie?ye:ke.replace(d,"$1")+ye:ke+ye}var f={exec:function(){}};function r(ke){for(var ye=1,Ie,ae;ye<arguments.length;ye++){Ie=arguments[ye];for(ae in Ie)Object.prototype.hasOwnProperty.call(Ie,ae)&&(ke[ae]=Ie[ae])}return ke}function h(ke,ye){var Ie=ke.replace(/\|/g,function(ee,Z,T){for(var z=!1,V=Z;--V>=0&&T[V]==="\\";)z=!z;return z?"|":" |"}),ae=Ie.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function v(ke,ye,Ie){var ae=ke.length;if(ae===0)return"";for(var ue=0;ue<ae;){var ee=ke.charAt(ae-ue-1);if(ee===ye&&!Ie)ue++;else if(ee!==ye&&Ie)ue++;else break}return ke.slice(0,ae-ue)}function I(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var Ie=ke.length,ae=0,ue=0;ue<Ie;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])ae++;else if(ke[ue]===ye[1]&&(ae--,ae<0))return ue;return-1}function L(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(ke,ye){if(ye<1)return"";for(var Ie="";ye>1;)ye&1&&(Ie+=ke),ye>>=1,ke+=ke;return Ie+ke}function W(ke,ye,Ie,ae){var ue=ye.href,ee=ye.title?m(ye.title):null,Z=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var T={type:"link",raw:Ie,href:ue,title:ee,text:Z,tokens:ae.inlineTokens(Z)};return ae.state.inLink=!1,T}return{type:"image",raw:Ie,href:ue,title:ee,text:m(Z)}}function H(ke,ye){var Ie=ke.match(/^(\s+)(?:```)/);if(Ie===null)return ye;var ae=Ie[1];return ye.split(`
`).map(function(ue){var ee=ue.match(/^\s+/);if(ee===null)return ue;var Z=ee[0];return Z.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var P=function(){function ke(Ie){this.options=Ie||ne.defaults}var ye=ke.prototype;return ye.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ye.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:v(ee,`
`)}}},ye.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var ee=ue[0],Z=H(ee,ue[3]||"");return{type:"code",raw:ee,lang:ue[2]?ue[2].trim():ue[2],text:Z}}},ye.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var ee=ue[2].trim();if(/#$/.test(ee)){var Z=v(ee,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(ee=Z.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ye.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var ee=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ye.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var ee,Z,T,z,V,q,oe,ce,J,Ee,ve,Ne,ze=ue[1].trim(),Je=ze.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+ze.slice(0,-1):"",loose:!1,items:[]};ze=Je?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=Je?ze:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ue=Pe.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=ue[0],ae=ae.substring(ee.length),ce=ue[2].split(`
`,1)[0],J=ae.split(`
`,1)[0],this.options.pedantic?(z=2,ve=ce.trimLeft()):(z=ue[2].search(/[^ ]/),z=z>4?1:z,ve=ce.slice(z),z+=ue[1].length),q=!1,!ce&&/^ *$/.test(J)&&(ee+=J+`
`,ae=ae.substring(J.length+1),Ne=!0),!Ne)for(var rt=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),X=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Y=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:```|~~~)"),me=new RegExp("^ {0,"+Math.min(3,z-1)+"}#");ae&&(Ee=ae.split(`
`,1)[0],ce=Ee,this.options.pedantic&&(ce=ce.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Y.test(ce)||me.test(ce)||rt.test(ce)||X.test(ae)));){if(ce.search(/[^ ]/)>=z||!ce.trim())ve+=`
`+ce.slice(z);else if(!q)ve+=`
`+ce;else break;!q&&!ce.trim()&&(q=!0),ee+=Ee+`
`,ae=ae.substring(Ee.length+1)}Ge.loose||(oe?Ge.loose=!0:/\n *\n *$/.test(ee)&&(oe=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(ve),Z&&(T=Z[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ee,task:!!Z,checked:T,loose:!1,text:ve}),Ge.raw+=ee}Ge.items[Ge.items.length-1].raw=ee.trimRight(),Ge.items[Ge.items.length-1].text=ve.trimRight(),Ge.raw=Ge.raw.trimRight();var Be=Ge.items.length;for(V=0;V<Be;V++){this.lexer.state.top=!1,Ge.items[V].tokens=this.lexer.blockTokens(Ge.items[V].text,[]);var je=Ge.items[V].tokens.filter(function(Ke){return Ke.type==="space"}),Ze=je.every(function(Ke){for(var Ve=Ke.raw.split(""),nt=0,st=F(Ve),dt;!(dt=st()).done;){var St=dt.value;if(St===`
`&&(nt+=1),nt>1)return!0}return!1});!Ge.loose&&je.length&&Ze&&(Ge.loose=!0,Ge.items[V].loose=!0)}return Ge}},ye.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]);ee.type="paragraph",ee.text=Z,ee.tokens=this.lexer.inline(Z)}return ee}},ye.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var ee={type:"table",header:h(ue[1]).map(function(oe){return{text:oe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ue[0];var Z=ee.align.length,T,z,V,q;for(T=0;T<Z;T++)/^ *-+: *$/.test(ee.align[T])?ee.align[T]="right":/^ *:-+: *$/.test(ee.align[T])?ee.align[T]="center":/^ *:-+ *$/.test(ee.align[T])?ee.align[T]="left":ee.align[T]=null;for(Z=ee.rows.length,T=0;T<Z;T++)ee.rows[T]=h(ee.rows[T],ee.header.length).map(function(oe){return{text:oe}});for(Z=ee.header.length,z=0;z<Z;z++)ee.header[z].tokens=this.lexer.inline(ee.header[z].text);for(Z=ee.rows.length,z=0;z<Z;z++)for(q=ee.rows[z],V=0;V<q.length;V++)q[V].tokens=this.lexer.inline(q[V].text);return ee}}},ye.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ye.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var ee=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:ee,tokens:this.lexer.inline(ee)}}},ye.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ye.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:m(ue[1])}},ye.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]):ue[0]}},ye.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var Z=v(ee.slice(0,-1),"\\");if((ee.length-Z.length)%2===0)return}else{var T=I(ue[2],"()");if(T>-1){var z=ue[0].indexOf("!")===0?5:4,V=z+ue[1].length+T;ue[2]=ue[2].substring(0,T),ue[0]=ue[0].substring(0,V).trim(),ue[3]=""}}var q=ue[2],oe="";if(this.options.pedantic){var ce=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);ce&&(q=ce[1],oe=ce[3])}else oe=ue[3]?ue[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(ee)?q=q.slice(1):q=q.slice(1,-1)),W(ue,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ae,ue){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var Z=(ee[2]||ee[1]).replace(/\s+/g," ");if(Z=ue[Z.toLowerCase()],!Z||!Z.href){var T=ee[0].charAt(0);return{type:"text",raw:T,text:T}}return W(ee,Z,ee[0],this.lexer)}},ye.emStrong=function(ae,ue,ee){ee===void 0&&(ee="");var Z=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Z&&!(Z[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var T=Z[1]||Z[2]||"";if(!T||T&&(ee===""||this.rules.inline.punctuation.exec(ee))){var z=Z[0].length-1,V,q,oe=z,ce=0,J=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,ue=ue.slice(-1*ae.length+z);(Z=J.exec(ue))!=null;)if(V=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!V){if(q=V.length,Z[3]||Z[4]){oe+=q;continue}else if((Z[5]||Z[6])&&z%3&&!((z+q)%3)){ce+=q;continue}if(oe-=q,!(oe>0)){if(q=Math.min(q,q+oe+ce),Math.min(z,q)%2){var Ee=ae.slice(1,z+Z.index+q);return{type:"em",raw:ae.slice(0,z+Z.index+q+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=ae.slice(2,z+Z.index+q-1);return{type:"strong",raw:ae.slice(0,z+Z.index+q+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ye.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var ee=ue[2].replace(/\n/g," "),Z=/[^ ]/.test(ee),T=/^ /.test(ee)&&/ $/.test(ee);return Z&&T&&(ee=ee.substring(1,ee.length-1)),ee=m(ee,!0),{type:"codespan",raw:ue[0],text:ee}}},ye.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ye.autolink=function(ae,ue){var ee=this.rules.inline.autolink.exec(ae);if(ee){var Z,T;return ee[2]==="@"?(Z=m(this.options.mangle?ue(ee[1]):ee[1]),T="mailto:"+Z):(Z=m(ee[1]),T=Z),{type:"link",raw:ee[0],text:Z,href:T,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(ae,ue){var ee;if(ee=this.rules.inline.url.exec(ae)){var Z,T;if(ee[2]==="@")Z=m(this.options.mangle?ue(ee[0]):ee[0]),T="mailto:"+Z;else{var z;do z=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(z!==ee[0]);Z=m(ee[0]),ee[1]==="www."?T="http://"+Z:T=Z}return{type:"link",raw:ee[0],text:Z,href:T,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(ae,ue){var ee=this.rules.inline.text.exec(ae);if(ee){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):m(ee[0]):ee[0]:Z=m(this.options.smartypants?ue(ee[0]):ee[0]),{type:"text",raw:ee[0],text:Z}}},ke}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=p(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=p(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=p(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=p(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=p(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=p(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=r({},M),M.gfm=r({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=p(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=p(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=r({},M.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:p(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=p(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=p(M._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=p(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=p(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=p(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=p(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=p(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=p(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=p(R.reflink).replace("label",R._label).replace("ref",M._label).getRegex(),R.nolink=p(R.nolink).replace("ref",M._label).getRegex(),R.reflinkSearch=p(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=r({},R),R.pedantic=r({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=r({},R.normal,{escape:p(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=p(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=r({},R.gfm,{br:p(R.br).replace("{2,}","*").getRegex(),text:p(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(ke){var ye="",Ie,ae,ue=ke.length;for(Ie=0;Ie<ue;Ie++)ae=ke.charCodeAt(Ie),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var U=function(){function ke(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ne.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:M.normal,inline:R.normal};this.options.pedantic?(ae.block=M.pedantic,ae.inline=R.pedantic):this.options.gfm&&(ae.block=M.gfm,this.options.breaks?ae.inline=R.breaks:ae.inline=R.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ue){var ee=new ke(ue);return ee.lex(ae)},ke.lexInline=function(ae,ue){var ee=new ke(ue);return ee.inlineTokens(ae)};var ye=ke.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(oe,ce,J){return ce+"    ".repeat(J.length)});for(var Z,T,z,V;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(Z=oe.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.space(ae)){ae=ae.substring(Z.raw.length),Z.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(Z);continue}if(Z=this.tokenizer.code(ae)){ae=ae.substring(Z.raw.length),T=ue[ue.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+Z.raw,T.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=T.text):ue.push(Z);continue}if(Z=this.tokenizer.fences(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.heading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.hr(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.blockquote(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.list(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.html(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.def(ae)){ae=ae.substring(Z.raw.length),T=ue[ue.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+Z.raw,T.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=T.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.lheading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(z=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,ce=ae.slice(1),J=void 0;ee.options.extensions.startBlock.forEach(function(Ee){J=Ee.call({lexer:this},ce),typeof J=="number"&&J>=0&&(oe=Math.min(oe,J))}),oe<1/0&&oe>=0&&(z=ae.substring(0,oe+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(z))){T=ue[ue.length-1],V&&T.type==="paragraph"?(T.raw+=`
`+Z.raw,T.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):ue.push(Z),V=z.length!==ae.length,ae=ae.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(ae)){ae=ae.substring(Z.raw.length),T=ue[ue.length-1],T&&T.type==="text"?(T.raw+=`
`+Z.raw,T.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):ue.push(Z);continue}if(ae){var q="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,ue},ye.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},ye.inlineTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]);var Z,T,z,V=ae,q,oe,ce;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)J.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,q.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(oe||(ce=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(Z=ve.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.tag(ae)){ae=ae.substring(Z.raw.length),T=ue[ue.length-1],T&&Z.type==="text"&&T.type==="text"?(T.raw+=Z.raw,T.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.link(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Z.raw.length),T=ue[ue.length-1],T&&Z.type==="text"&&T.type==="text"?(T.raw+=Z.raw,T.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.emStrong(ae,V,ce)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.codespan(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.br(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.del(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.autolink(ae,x)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(ae,x))){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(z=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ne=ae.slice(1),ze=void 0;ee.options.extensions.startInline.forEach(function(Je){ze=Je.call({lexer:this},Ne),typeof ze=="number"&&ze>=0&&(ve=Math.min(ve,ze))}),ve<1/0&&ve>=0&&(z=ae.substring(0,ve+1))}(),Z=this.tokenizer.inlineText(z,B)){ae=ae.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(ce=Z.raw.slice(-1)),oe=!0,T=ue[ue.length-1],T&&T.type==="text"?(T.raw+=Z.raw,T.text+=Z.text):ue.push(Z);continue}if(ae){var Ee="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},i(ke,null,[{key:"rules",get:function(){return{block:M,inline:R}}}]),ke}(),K=function(){function ke(Ie){this.options=Ie||ne.defaults}var ye=ke.prototype;return ye.code=function(ae,ue,ee){var Z=(ue||"").match(/\S*/)[0];if(this.options.highlight){var T=this.options.highlight(ae,Z);T!=null&&T!==ae&&(ee=!0,ae=T)}return ae=ae.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+m(Z,!0)+'">'+(ee?ae:m(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:m(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,ue,ee,Z){if(this.options.headerIds){var T=this.options.headerPrefix+Z.slug(ee);return"<h"+ue+' id="'+T+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,ue,ee){var Z=ue?"ol":"ul",T=ue&&ee!==1?' start="'+ee+'"':"";return"<"+Z+T+`>
`+ae+"</"+Z+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,ue){var ee=ue.header?"th":"td",Z=ue.align?"<"+ee+' align="'+ue.align+'">':"<"+ee+">";return Z+ae+("</"+ee+`>
`)},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,ue,ee){if(ae=C(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<a href="'+m(ae)+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=">"+ee+"</a>",Z},ye.image=function(ae,ue,ee){if(ae=C(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<img src="'+ae+'" alt="'+ee+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(ae){return ae},ke}(),te=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,ue,ee){return""+ee},ye.image=function(ae,ue,ee){return""+ee},ye.br=function(){return""},ke}(),de=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,ue){var ee=ae,Z=0;if(this.seen.hasOwnProperty(ee)){Z=this.seen[ae];do Z++,ee=ae+"-"+Z;while(this.seen.hasOwnProperty(ee))}return ue||(this.seen[ae]=Z,this.seen[ee]=0),ee},ye.slug=function(ae,ue){ue===void 0&&(ue={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,ue.dryrun)},ke}(),re=function(){function ke(Ie){this.options=Ie||ne.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new de}ke.parse=function(ae,ue){var ee=new ke(ue);return ee.parse(ae)},ke.parseInline=function(ae,ue){var ee=new ke(ue);return ee.parseInline(ae)};var ye=ke.prototype;return ye.parse=function(ae,ue){ue===void 0&&(ue=!0);var ee="",Z,T,z,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,rt,X,Y,me,Be=ae.length;for(Z=0;Z<Be;Z++){if(ve=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(me=this.options.extensions.renderers[ve.type].call({parser:this},ve),me!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){ee+=me||"";continue}switch(ve.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,o(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(J="",ce="",V=ve.header.length,T=0;T<V;T++)ce+=this.renderer.tablecell(this.parseInline(ve.header[T].tokens),{header:!0,align:ve.align[T]});for(J+=this.renderer.tablerow(ce),Ee="",V=ve.rows.length,T=0;T<V;T++){for(oe=ve.rows[T],ce="",q=oe.length,z=0;z<q;z++)ce+=this.renderer.tablecell(this.parseInline(oe[z].tokens),{header:!1,align:ve.align[z]});Ee+=this.renderer.tablerow(ce)}ee+=this.renderer.table(J,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),ee+=this.renderer.blockquote(Ee);continue}case"list":{for(Ne=ve.ordered,ze=ve.start,Je=ve.loose,V=ve.items.length,Ee="",T=0;T<V;T++)Pe=ve.items[T],rt=Pe.checked,X=Pe.task,Ge="",Pe.task&&(Y=this.renderer.checkbox(rt),Je?Pe.tokens.length>0&&Pe.tokens[0].type==="paragraph"?(Pe.tokens[0].text=Y+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=Y+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:Y}):Ge+=Y),Ge+=this.parse(Pe.tokens,Je),Ee+=this.renderer.listitem(Ge,X,rt);ee+=this.renderer.list(Ee,Ne,ze);continue}case"html":{ee+=this.renderer.html(ve.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;Z+1<Be&&ae[Z+1].type==="text";)ve=ae[++Z],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);ee+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var je='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ee},ye.parseInline=function(ae,ue){ue=ue||this.renderer;var ee="",Z,T,z,V=ae.length;for(Z=0;Z<V;Z++){if(T=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[T.type]&&(z=this.options.extensions.renderers[T.type].call({parser:this},T),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(T.type))){ee+=z||"";continue}switch(T.type){case"escape":{ee+=ue.text(T.text);break}case"html":{ee+=ue.html(T.text);break}case"link":{ee+=ue.link(T.href,T.title,this.parseInline(T.tokens,ue));break}case"image":{ee+=ue.image(T.href,T.title,T.text);break}case"strong":{ee+=ue.strong(this.parseInline(T.tokens,ue));break}case"em":{ee+=ue.em(this.parseInline(T.tokens,ue));break}case"codespan":{ee+=ue.codespan(T.text);break}case"br":{ee+=ue.br();break}case"del":{ee+=ue.del(this.parseInline(T.tokens,ue));break}case"text":{ee+=ue.text(T.text);break}default:{var q='Token with "'+T.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return ee},ke}();function be(ke,ye,Ie){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(Ie=ye,ye=null),ye=r({},be.defaults,ye||{}),L(ye),Ie){var ae=ye.highlight,ue;try{ue=U.lex(ke,ye)}catch(V){return Ie(V)}var ee=function(q){var oe;if(!q)try{ye.walkTokens&&be.walkTokens(ue,ye.walkTokens),oe=re.parse(ue,ye)}catch(ce){q=ce}return ye.highlight=ae,q?Ie(q):Ie(null,oe)};if(!ae||ae.length<3||(delete ye.highlight,!ue.length))return ee();var Z=0;be.walkTokens(ue,function(V){V.type==="code"&&(Z++,setTimeout(function(){ae(V.text,V.lang,function(q,oe){if(q)return ee(q);oe!=null&&oe!==V.text&&(V.text=oe,V.escaped=!0),Z--,Z===0&&ee()})},0))}),Z===0&&ee();return}function T(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(V.message+"",!0)+"</pre>";throw V}try{var z=U.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(be.walkTokens(z,ye.walkTokens)).then(function(){return re.parse(z,ye)}).catch(T);be.walkTokens(z,ye.walkTokens)}return re.parse(z,ye)}catch(V){T(V)}}be.options=be.setOptions=function(ke){return r(be.defaults,ke),A(be.defaults),be},be.getDefaults=_,be.defaults=ne.defaults,be.use=function(){for(var ke=arguments.length,ye=new Array(ke),Ie=0;Ie<ke;Ie++)ye[Ie]=arguments[Ie];var ae=r.apply(void 0,[{}].concat(ye)),ue=be.defaults.extensions||{renderers:{},childTokens:{}},ee;ye.forEach(function(Z){if(Z.extensions&&(ee=!0,Z.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var V=ue.renderers?ue.renderers[z.name]:null;V?ue.renderers[z.name]=function(){for(var q=arguments.length,oe=new Array(q),ce=0;ce<q;ce++)oe[ce]=arguments[ce];var J=z.renderer.apply(this,oe);return J===!1&&(J=V.apply(this,oe)),J}:ue.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[z.level]?ue[z.level].unshift(z.tokenizer):ue[z.level]=[z.tokenizer],z.start&&(z.level==="block"?ue.startBlock?ue.startBlock.push(z.start):ue.startBlock=[z.start]:z.level==="inline"&&(ue.startInline?ue.startInline.push(z.start):ue.startInline=[z.start]))}z.childTokens&&(ue.childTokens[z.name]=z.childTokens)})),Z.renderer&&function(){var z=be.defaults.renderer||new K,V=function(ce){var J=z[ce];z[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.renderer[ce].apply(z,ve);return ze===!1&&(ze=J.apply(z,ve)),ze}};for(var q in Z.renderer)V(q);ae.renderer=z}(),Z.tokenizer&&function(){var z=be.defaults.tokenizer||new P,V=function(ce){var J=z[ce];z[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.tokenizer[ce].apply(z,ve);return ze===!1&&(ze=J.apply(z,ve)),ze}};for(var q in Z.tokenizer)V(q);ae.tokenizer=z}(),Z.walkTokens){var T=be.defaults.walkTokens;ae.walkTokens=function(z){var V=[];return V.push(Z.walkTokens.call(this,z)),T&&(V=V.concat(T.call(this,z))),V}}ee&&(ae.extensions=ue),be.setOptions(ae)})},be.walkTokens=function(ke,ye){for(var Ie=[],ae=function(){var T=ee.value;switch(Ie=Ie.concat(ye.call(be,T)),T.type){case"table":{for(var z=F(T.header),V;!(V=z()).done;){var q=V.value;Ie=Ie.concat(be.walkTokens(q.tokens,ye))}for(var oe=F(T.rows),ce;!(ce=oe()).done;)for(var J=ce.value,Ee=F(J),ve;!(ve=Ee()).done;){var Ne=ve.value;Ie=Ie.concat(be.walkTokens(Ne.tokens,ye))}break}case"list":{Ie=Ie.concat(be.walkTokens(T.items,ye));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[T.type]?be.defaults.extensions.childTokens[T.type].forEach(function(ze){Ie=Ie.concat(be.walkTokens(T[ze],ye))}):T.tokens&&(Ie=Ie.concat(be.walkTokens(T.tokens,ye)))}},ue=F(ke),ee;!(ee=ue()).done;)ae();return Ie},be.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=r({},be.defaults,ye||{}),L(ye);try{var Ie=U.lexInline(ke,ye);return ye.walkTokens&&be.walkTokens(Ie,ye.walkTokens),re.parseInline(Ie,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(ae.message+"",!0)+"</pre>";throw ae}},be.Parser=re,be.parser=re.parse,be.Renderer=K,be.TextRenderer=te,be.Lexer=U,be.lexer=U.lex,be.Tokenizer=P,be.Slugger=de,be.parse=be;var le=be.options,fe=be.setOptions,Q=be.use,pe=be.walkTokens,Se=be.parseInline,Fe=be,Ue=re.parse,Xe=U.lex;ne.Lexer=U,ne.Parser=re,ne.Renderer=K,ne.Slugger=de,ne.TextRenderer=te,ne.Tokenizer=P,ne.getDefaults=_,ne.lexer=Xe,ne.marked=be,ne.options=le,ne.parse=Fe,ne.parseInline=Se,ne.parser=Ue,ne.setOptions=fe,ne.use=Q,ne.walkTokens=pe,Object.defineProperty(ne,"__esModule",{value:!0})}),define(De[108],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(A,y,k){return Math.min(Math.max(A,y),k)}e.clamp=i;function D(A,y){return(y+A%y)%y}e.rot=D;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class F{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=F;class _{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const k=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ne(S){const F=[];typeof S=="number"&&F.push("code/timeOrigin",S);function _(y){F.push(y,Date.now())}function A(){const y=[];for(let k=0;k<F.length;k+=2)y.push({name:F[k],startTime:F[k+1]});return y}return{mark:_,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const _ of performance.getEntriesByType("mark"))F.push({name:_.name,startTime:Math.round(S+_.startTime)});return F}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=i(D))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var D in i)(typeof exports=="object"?exports:ne)[D]=i[D]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function i(D){if(e[D])return e[D].exports;var S=e[D]={i:D,l:!1,exports:{}};return ne[D].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=ne,i.c=e,i.d=function(D,S,F){i.o(D,S)||Object.defineProperty(D,S,{enumerable:!0,get:F})},i.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},i.t=function(D,S){if(1&S&&(D=i(D)),8&S||4&S&&typeof D=="object"&&D&&D.__esModule)return D;var F=Object.create(null);if(i.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:D}),2&S&&typeof D!="string")for(var _ in D)i.d(F,_,function(A){return D[A]}.bind(null,_));return F},i.n=function(D){var S=D&&D.__esModule?function(){return D.default}:function(){return D};return i.d(S,"a",S),S},i.o=function(D,S){return Object.prototype.hasOwnProperty.call(D,S)},i.p="",i(i.s=0)}([function(ne,e,i){(function(D){var S;e=ne.exports=Q,S=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],k=0,O=k++;y[O]="0|[1-9]\\d*";var w=k++;y[w]="[0-9]+";var g=k++;y[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;y[E]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var m=k++;y[m]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var t=k++;y[t]="(?:"+y[O]+"|"+y[g]+")";var o=k++;y[o]="(?:"+y[w]+"|"+y[g]+")";var a=k++;y[a]="(?:-("+y[t]+"(?:\\."+y[t]+")*))";var p=k++;y[p]="(?:-?("+y[o]+"(?:\\."+y[o]+")*))";var b=k++;y[b]="[0-9A-Za-z-]+";var u=k++;y[u]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var C=k++,s="v?"+y[E]+y[a]+"?"+y[u]+"?";y[C]="^"+s+"$";var c="[v=\\s]*"+y[m]+y[p]+"?"+y[u]+"?",n=k++;y[n]="^"+c+"$";var d=k++;y[d]="((?:<|>)?=?)";var l=k++;y[l]=y[w]+"|x|X|\\*";var f=k++;y[f]=y[O]+"|x|X|\\*";var r=k++;y[r]="[v=\\s]*("+y[f]+")(?:\\.("+y[f]+")(?:\\.("+y[f]+")(?:"+y[a]+")?"+y[u]+"?)?)?";var h=k++;y[h]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[p]+")?"+y[u]+"?)?)?";var v=k++;y[v]="^"+y[d]+"\\s*"+y[r]+"$";var I=k++;y[I]="^"+y[d]+"\\s*"+y[h]+"$";var L=k++;y[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=k++;y[j]="(?:~>?)";var W=k++;y[W]="(\\s*)"+y[j]+"\\s+",A[W]=new RegExp(y[W],"g");var H=k++;y[H]="^"+y[j]+y[r]+"$";var P=k++;y[P]="^"+y[j]+y[h]+"$";var M=k++;y[M]="(?:\\^)";var R=k++;y[R]="(\\s*)"+y[M]+"\\s+",A[R]=new RegExp(y[R],"g");var B=k++;y[B]="^"+y[M]+y[r]+"$";var x=k++;y[x]="^"+y[M]+y[h]+"$";var U=k++;y[U]="^"+y[d]+"\\s*("+c+")$|^$";var K=k++;y[K]="^"+y[d]+"\\s*("+s+")$|^$";var te=k++;y[te]="(\\s*)"+y[d]+"\\s*("+c+"|"+y[r]+")",A[te]=new RegExp(y[te],"g");var de=k++;y[de]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var re=k++;y[re]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var be=k++;y[be]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)S(le,y[le]),A[le]||(A[le]=new RegExp(y[le]));function fe(J,Ee){if(J instanceof Q)return J;if(typeof J!="string"||J.length>F||!(Ee?A[n]:A[C]).test(J))return null;try{return new Q(J,Ee)}catch{return null}}function Q(J,Ee){if(J instanceof Q){if(J.loose===Ee)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof Q))return new Q(J,Ee);S("SemVer",J,Ee),this.loose=Ee;var ve=J.trim().match(Ee?A[n]:A[C]);if(!ve)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var ze=+Ne;if(ze>=0&&ze<_)return ze}return Ne}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=fe,e.valid=function(J,Ee){var ve=fe(J,Ee);return ve?ve.version:null},e.clean=function(J,Ee){var ve=fe(J.trim().replace(/^[=v]+/,""),Ee);return ve?ve.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return S("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),Se(this.major,J.major)||Se(this.minor,J.minor)||Se(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var Ee=0;do{var ve=this.prerelease[Ee],Ne=J.prerelease[Ee];if(S("prerelease compare",Ee,ve,Ne),ve===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ne)return Se(ve,Ne)}while(++Ee)},Q.prototype.inc=function(J,Ee){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,Ee,ve,Ne){typeof ve=="string"&&(Ne=ve,ve=void 0);try{return new Q(J,ve).inc(Ee,Ne).version}catch{return null}},e.diff=function(J,Ee){if(ke(J,Ee))return null;var ve=fe(J),Ne=fe(Ee);if(ve.prerelease.length||Ne.prerelease.length){for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return"pre"+ze;return"prerelease"}for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return ze},e.compareIdentifiers=Se;var pe=/^[0-9]+$/;function Se(J,Ee){var ve=pe.test(J),Ne=pe.test(Ee);return ve&&Ne&&(J=+J,Ee=+Ee),ve&&!Ne?-1:Ne&&!ve?1:J<Ee?-1:J>Ee?1:0}function Fe(J,Ee,ve){return new Q(J,ve).compare(new Q(Ee,ve))}function Ue(J,Ee,ve){return Fe(J,Ee,ve)>0}function Xe(J,Ee,ve){return Fe(J,Ee,ve)<0}function ke(J,Ee,ve){return Fe(J,Ee,ve)===0}function ye(J,Ee,ve){return Fe(J,Ee,ve)!==0}function Ie(J,Ee,ve){return Fe(J,Ee,ve)>=0}function ae(J,Ee,ve){return Fe(J,Ee,ve)<=0}function ue(J,Ee,ve,Ne){var ze;switch(Ee){case"===":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J===ve;break;case"!==":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J!==ve;break;case"":case"=":case"==":ze=ke(J,ve,Ne);break;case"!=":ze=ye(J,ve,Ne);break;case">":ze=Ue(J,ve,Ne);break;case">=":ze=Ie(J,ve,Ne);break;case"<":ze=Xe(J,ve,Ne);break;case"<=":ze=ae(J,ve,Ne);break;default:throw new TypeError("Invalid operator: "+Ee)}return ze}function ee(J,Ee){if(J instanceof ee){if(J.loose===Ee)return J;J=J.value}if(!(this instanceof ee))return new ee(J,Ee);S("comparator",J,Ee),this.loose=Ee,this.parse(J),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(J,Ee){return Se(Ee,J)},e.major=function(J,Ee){return new Q(J,Ee).major},e.minor=function(J,Ee){return new Q(J,Ee).minor},e.patch=function(J,Ee){return new Q(J,Ee).patch},e.compare=Fe,e.compareLoose=function(J,Ee){return Fe(J,Ee,!0)},e.rcompare=function(J,Ee,ve){return Fe(Ee,J,ve)},e.sort=function(J,Ee){return J.sort(function(ve,Ne){return e.compare(ve,Ne,Ee)})},e.rsort=function(J,Ee){return J.sort(function(ve,Ne){return e.rcompare(ve,Ne,Ee)})},e.gt=Ue,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=Ie,e.lte=ae,e.cmp=ue,e.Comparator=ee;var Z={};function T(J,Ee){if(J instanceof T)return J.loose===Ee?J:new T(J.raw,Ee);if(J instanceof ee)return new T(J.value,Ee);if(!(this instanceof T))return new T(J,Ee);if(this.loose=Ee,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function z(J){return!J||J.toLowerCase()==="x"||J==="*"}function V(J,Ee,ve,Ne,ze,Je,Ge,Pe,rt,X,Y,me,Be){return((Ee=z(ve)?"":z(Ne)?">="+ve+".0.0":z(ze)?">="+ve+"."+Ne+".0":">="+Ee)+" "+(Pe=z(rt)?"":z(X)?"<"+(+rt+1)+".0.0":z(Y)?"<"+rt+"."+(+X+1)+".0":me?"<="+rt+"."+X+"."+Y+"-"+me:"<="+Pe)).trim()}function q(J,Ee){for(var ve=0;ve<J.length;ve++)if(!J[ve].test(Ee))return!1;if(Ee.prerelease.length){for(ve=0;ve<J.length;ve++)if(S(J[ve].semver),J[ve].semver!==Z&&J[ve].semver.prerelease.length>0){var Ne=J[ve].semver;if(Ne.major===Ee.major&&Ne.minor===Ee.minor&&Ne.patch===Ee.patch)return!0}return!1}return!0}function oe(J,Ee,ve){try{Ee=new T(Ee,ve)}catch{return!1}return Ee.test(J)}function ce(J,Ee,ve,Ne){var ze,Je,Ge,Pe,rt;switch(J=new Q(J,Ne),Ee=new T(Ee,Ne),ve){case">":ze=Ue,Je=ae,Ge=Xe,Pe=">",rt=">=";break;case"<":ze=Xe,Je=Ie,Ge=Ue,Pe="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(oe(J,Ee,Ne))return!1;for(var X=0;X<Ee.set.length;++X){var Y=Ee.set[X],me=null,Be=null;if(Y.forEach(function(je){je.semver===Z&&(je=new ee(">=0.0.0")),me=me||je,Be=Be||je,ze(je.semver,me.semver,Ne)?me=je:Ge(je.semver,Be.semver,Ne)&&(Be=je)}),me.operator===Pe||me.operator===rt||(!Be.operator||Be.operator===Pe)&&Je(J,Be.semver)||Be.operator===rt&&Ge(J,Be.semver))return!1}return!0}ee.prototype.parse=function(J){var Ee=this.loose?A[U]:A[K],ve=J.match(Ee);if(!ve)throw new TypeError("Invalid comparator: "+J);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Q(ve[2],this.loose):this.semver=Z},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(J){return S("Comparator.test",J,this.loose),this.semver===Z||(typeof J=="string"&&(J=new Q(J,this.loose)),ue(J,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(J,Ee){if(!(J instanceof ee))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new T(J.value,Ee),oe(this.value,ve,Ee);if(J.operator==="")return ve=new T(this.value,Ee),oe(J.semver,ve,Ee);var Ne=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Je=this.semver.version===J.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Pe=ue(this.semver,"<",J.semver,Ee)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),rt=ue(this.semver,">",J.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ne||ze||Je&&Ge||Pe||rt},e.Range=T,T.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},T.prototype.toString=function(){return this.range},T.prototype.parseRange=function(J){var Ee=this.loose;J=J.trim(),S("range",J,Ee);var ve=Ee?A[re]:A[de];J=J.replace(ve,V),S("hyphen replace",J),J=J.replace(A[te],"$1$2$3"),S("comparator trim",J,A[te]),J=(J=(J=J.replace(A[W],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Ne=Ee?A[U]:A[K],ze=J.split(" ").map(function(Je){return function(Ge,Pe){return S("comp",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Y){return function(me,Be){S("caret",me,Be);var je=Be?A[x]:A[B];return me.replace(je,function(Ze,Ke,Ve,nt,st){var dt;return S("caret",me,Ze,Ke,Ve,nt,st),z(Ke)?dt="":z(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":z(nt)?dt=Ke==="0"?">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+".0 <"+(+Ke+1)+".0.0":st?(S("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+nt+st+" <"+Ke+"."+Ve+"."+(+nt+1):">="+Ke+"."+Ve+"."+nt+st+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+nt+st+" <"+(+Ke+1)+".0.0"):(S("no pr"),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+nt+" <"+Ke+"."+Ve+"."+(+nt+1):">="+Ke+"."+Ve+"."+nt+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+nt+" <"+(+Ke+1)+".0.0"),S("caret return",dt),dt})}(Y,X)}).join(" ")}(Ge,Pe),S("caret",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Y){return function(me,Be){var je=Be?A[P]:A[H];return me.replace(je,function(Ze,Ke,Ve,nt,st){var dt;return S("tilde",me,Ze,Ke,Ve,nt,st),z(Ke)?dt="":z(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":z(nt)?dt=">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":st?(S("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=">="+Ke+"."+Ve+"."+nt+st+" <"+Ke+"."+(+Ve+1)+".0"):dt=">="+Ke+"."+Ve+"."+nt+" <"+Ke+"."+(+Ve+1)+".0",S("tilde return",dt),dt})}(Y,X)}).join(" ")}(Ge,Pe),S("tildes",Ge),Ge=function(rt,X){return S("replaceXRanges",rt,X),rt.split(/\s+/).map(function(Y){return function(me,Be){me=me.trim();var je=Be?A[I]:A[v];return me.replace(je,function(Ze,Ke,Ve,nt,st,dt){S("xRange",me,Ze,Ke,Ve,nt,st,dt);var St=z(Ve),tt=St||z(nt),ut=tt||z(st);return Ke==="="&&ut&&(Ke=""),St?Ze=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&ut?(tt&&(nt=0),ut&&(st=0),Ke===">"?(Ke=">=",tt?(Ve=+Ve+1,nt=0,st=0):ut&&(nt=+nt+1,st=0)):Ke==="<="&&(Ke="<",tt?Ve=+Ve+1:nt=+nt+1),Ze=Ke+Ve+"."+nt+"."+st):tt?Ze=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":ut&&(Ze=">="+Ve+"."+nt+".0 <"+Ve+"."+(+nt+1)+".0"),S("xRange return",Ze),Ze})}(Y,X)}).join(" ")}(Ge,Pe),S("xrange",Ge),Ge=function(rt,X){return S("replaceStars",rt,X),rt.trim().replace(A[be],"")}(Ge,Pe),S("stars",Ge),Ge}(Je,Ee)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(Je){return!!Je.match(Ne)})),ze=ze.map(function(Je){return new ee(Je,Ee)})},T.prototype.intersects=function(J,Ee){if(!(J instanceof T))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ne){return J.set.some(function(ze){return ze.every(function(Je){return Ne.intersects(Je,Ee)})})})})},e.toComparators=function(J,Ee){return new T(J,Ee).set.map(function(ve){return ve.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},T.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(q(this.set[Ee],J))return!0;return!1},e.satisfies=oe,e.maxSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new T(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==-1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.minSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new T(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.validRange=function(J,Ee){try{return new T(J,Ee).range||"*"}catch{return null}},e.ltr=function(J,Ee,ve){return ce(J,Ee,"<",ve)},e.gtr=function(J,Ee,ve){return ce(J,Ee,">",ve)},e.outside=ce,e.prerelease=function(J,Ee){var ve=fe(J,Ee);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(J,Ee,ve){return J=new T(J,ve),Ee=new T(Ee,ve),J.intersects(Ee)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var Ee=J.match(A[L]);return Ee==null?null:fe((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,i(1))},function(ne,e){var i,D,S=ne.exports={};function F(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function A(o){if(i===setTimeout)return setTimeout(o,0);if((i===F||!i)&&setTimeout)return i=setTimeout,setTimeout(o,0);try{return i(o,0)}catch{try{return i.call(null,o,0)}catch{return i.call(this,o,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:F}catch{i=F}try{D=typeof clearTimeout=="function"?clearTimeout:_}catch{D=_}})();var y,k=[],O=!1,w=-1;function g(){O&&y&&(O=!1,y.length?k=y.concat(k):w=-1,k.length&&E())}function E(){if(!O){var o=A(g);O=!0;for(var a=k.length;a;){for(y=k,k=[];++w<a;)y&&y[w].run();w=-1,a=k.length}y=null,O=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===_||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(o)}}function m(o,a){this.fun=o,this.array=a}function t(){}S.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)a[p-1]=arguments[p];k.push(new m(o,a)),k.length!==1||O||A(E)},m.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=t,S.addListener=t,S.once=t,S.off=t,S.removeListener=t,S.removeAllListeners=t,S.emit=t,S.prependListener=t,S.prependOnceListener=t,S.listeners=function(o){return[]},S.binding=function(o){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(o){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(De[109],Ce([1,0,12,7]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(u){const C=u;return C?typeof C.read=="function":!1}e.isReadable=S;function F(u){const C=u;return C?[C.on,C.pause,C.resume,C.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=F;function _(u){const C=u;return C?F(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(u,C){return new y(u,C)}e.newWriteableStream=A;class y{constructor(C,s){this.reducer=C,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(s=>s(C))}emitError(C){this.listeners.error.length===0?(0,i.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(s=>s(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,s){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(C,s){if(this.state.destroyed)return;let c;switch(C){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const n=c.indexOf(s);n>=0&&c.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(u,C){const s=[];let c;for(;(c=u.read())!==null;)s.push(c);return C(s)}e.consumeReadable=k;function O(u,C,s){const c=[];let n;for(;(n=u.read())!==null&&c.length<s;)c.push(n);return n===null&&c.length>0?C(c):{read:()=>{if(c.length>0)return c.shift();if(typeof n<"u"){const d=n;return n=void 0,d}return u.read()}}}e.peekReadable=O;function w(u,C){return new Promise((s,c)=>{const n=[];g(u,{onData:d=>{C&&n.push(d)},onError:d=>{C?c(d):s(void 0)},onEnd:()=>{s(C?C(n):void 0)}})})}e.consumeStream=w;function g(u,C){let s=!1;return u.on("error",c=>{s||C.onError(c)}),u.on("end",()=>{s||C.onEnd()}),u.on("data",c=>{s||C.onData(c)}),(0,D.toDisposable)(()=>s=!0)}e.listenStream=g;function E(u,C){return new Promise((s,c)=>{const n=new D.DisposableStore,d=[],l=h=>{if(d.push(h),d.length>C)return n.dispose(),u.pause(),s({stream:u,buffer:d,ended:!1})},f=h=>c(h),r=()=>s({stream:u,buffer:d,ended:!0});n.add((0,D.toDisposable)(()=>u.removeListener("error",f))),u.on("error",f),n.add((0,D.toDisposable)(()=>u.removeListener("end",r))),u.on("end",r),n.add((0,D.toDisposable)(()=>u.removeListener("data",l))),u.on("data",l)})}e.peekStream=E;function m(u,C){const s=A(C);return s.end(u),s}e.toStream=m;function t(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function o(u){let C=!1;return{read:()=>C?null:(C=!0,u)}}e.toReadable=o;function a(u,C,s){const c=A(s);return g(u,{onData:n=>c.write(C.data(n)),onError:n=>c.error(C.error?C.error(n):n),onEnd:()=>c.end()}),c}e.transform=a;function p(u,C,s){let c=!1;return{read:()=>{const n=C.read();return c?n:(c=!0,n!==null?s([u,n]):u)}}}e.prefixedReadable=p;function b(u,C,s){let c=!1;const n=A(s);return g(C,{onData:d=>c?n.write(d):(c=!0,n.write(s([u,d]))),onError:d=>n.error(d),onEnd:()=>{c||(c=!0,n.write(u)),n.end()}}),n}e.prefixedStream=b}),define(De[23],Ce([1,0,109]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let S,F;class _{static alloc(h){return D?new _(Buffer.allocUnsafe(h)):new _(new Uint8Array(h))}static wrap(h){return D&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new _(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&D?new _(Buffer.from(h)):(S||(S=new TextEncoder),new _(S.encode(h)))}static fromByteArray(h){const v=_.alloc(h.length);for(let I=0,L=h.length;I<L;I++)v.buffer[I]=h[I];return v}static concat(h,v){if(typeof v>"u"){v=0;for(let j=0,W=h.length;j<W;j++)v+=h[j].byteLength}const I=_.alloc(v);let L=0;for(let j=0,W=h.length;j<W;j++){const H=h[j];I.set(H,L),L+=H.byteLength}return I}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=_.alloc(this.byteLength);return h.set(this),h}toString(){return D?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(h,v){return new _(this.buffer.subarray(h,v))}set(h,v){if(h instanceof _)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return k(this.buffer,h)}writeUInt32BE(h,v){O(this.buffer,h,v)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,v){g(this.buffer,h,v)}readUInt8(h){return E(this.buffer,h)}writeUInt8(h,v){m(this.buffer,h,v)}}e.VSBuffer=_;function A(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0}e.readUInt16LE=A;function y(r,h,v){r[v+0]=h&255,h=h>>>8,r[v+1]=h&255}e.writeUInt16LE=y;function k(r,h){return r[h]*2**24+r[h+1]*2**16+r[h+2]*2**8+r[h+3]}e.readUInt32BE=k;function O(r,h,v){r[v+3]=h,h=h>>>8,r[v+2]=h,h=h>>>8,r[v+1]=h,h=h>>>8,r[v]=h}e.writeUInt32BE=O;function w(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0|r[h+2]<<16>>>0|r[h+3]<<24>>>0}e.readUInt32LE=w;function g(r,h,v){r[v+0]=h&255,h=h>>>8,r[v+1]=h&255,h=h>>>8,r[v+2]=h&255,h=h>>>8,r[v+3]=h&255}e.writeUInt32LE=g;function E(r,h){return r[h]}e.readUInt8=E;function m(r,h,v){r[v]=h}e.writeUInt8=m;function t(r){return i.consumeReadable(r,h=>_.concat(h))}e.readableToBuffer=t;function o(r){return i.toReadable(r)}e.bufferToReadable=o;function a(r){return i.consumeStream(r,h=>_.concat(h))}e.streamToBuffer=a;async function p(r){return r.ended?_.concat(r.buffer):_.concat([...r.buffer,await a(r.stream)])}e.bufferedStreamToBuffer=p;function b(r){return i.toStream(r,h=>_.concat(h))}e.bufferToStream=b;function u(r){return i.transform(r,{data:h=>typeof h=="string"?_.fromString(h):_.wrap(h)},h=>_.concat(h))}e.streamToBufferReadableStream=u;function C(r){return i.newWriteableStream(h=>_.concat(h),r)}e.newWriteableBufferStream=C;function s(r,h){return i.prefixedReadable(r,h,v=>_.concat(v))}e.prefixedBufferReadable=s;function c(r,h){return i.prefixedStream(r,h,v=>_.concat(v))}e.prefixedBufferStream=c;function n(r){let h=0,v=0,I=0;const L=new Uint8Array(Math.floor(r.length/4*3)),j=H=>{switch(v){case 3:L[I++]=h|H,v=0;break;case 2:L[I++]=h|H>>>2,h=H<<6,v=3;break;case 1:L[I++]=h|H>>>4,h=H<<4,v=2;break;default:h=H<<2,v=1}};for(let H=0;H<r.length;H++){const P=r.charCodeAt(H);if(P>=65&&P<=90)j(P-65);else if(P>=97&&P<=122)j(P-97+26);else if(P>=48&&P<=57)j(P-48+52);else if(P===43||P===45)j(62);else if(P===47||P===95)j(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${r[H]}`)}}const W=I;for(;v>0;)j(0);return _.wrap(L).slice(0,W)}e.decodeBase64=n;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:r},h=!0,v=!1){const I=v?l:d;let L="";const j=r.byteLength%3;let W=0;for(;W<r.byteLength-j;W+=3){const H=r[W+0],P=r[W+1],M=r[W+2];L+=I[H>>>2],L+=I[(H<<4|P>>>4)&63],L+=I[(P<<2|M>>>6)&63],L+=I[M&63]}if(j===1){const H=r[W+0];L+=I[H>>>2],L+=I[H<<4&63],h&&(L+="==")}else if(j===2){const H=r[W+0],P=r[W+1];L+=I[H>>>2],L+=I[(H<<4|P>>>4)&63],L+=I[P<<2&63],h&&(L+="=")}return L}e.encodeBase64=f}),define(De[38],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(S){return i.test(S)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const F=new Uint8Array(16),_=[];for(let A=0;A<256;A++)_.push(A.toString(16).padStart(2,"0"));return function(){S(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let y=0,k="";return k+=_[F[y++]],k+=_[F[y++]],k+=_[F[y++]],k+=_[F[y++]],k+="-",k+=_[F[y++]],k+=_[F[y++]],k+="-",k+=_[F[y++]],k+=_[F[y++]],k+="-",k+=_[F[y++]],k+=_[F[y++]],k+="-",k+=_[F[y++]],k+=_[F[y++]],k+=_[F[y++]],k+=_[F[y++]],k+=_[F[y++]],k+=_[F[y++]],k}}()}),define(De[110],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[111],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class D{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,k=A.notIn.length;y<k;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const k=A.findTokenIndexAtOffset(y-2),O=A.getStandardTokenType(k);return this.isOK(O)}_findNeutralCharacterInRange(A,y){for(let k=A;k<=y;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=D;class S{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)F(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),F(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),F(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),F(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&F(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=S;function F(_,A,y){_.has(A)?_.get(A).push(y):_.set(A,[y])}}),define(De[112],Ce([16,17]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(De[113],Ce([1,0,112]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,S=D*60,F=S*24,_=F*7,A=F*30,y=F*365;function k(w,g,E){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,i.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,i.localize)(1,null);let t;return m<D?(t=m,g?t===1?E?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):E?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?E?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):E?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):m<S?(t=Math.floor(m/D),g?t===1?E?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):E?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?E?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):E?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):m<F?(t=Math.floor(m/S),g?t===1?E?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):E?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?E?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):E?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):m<_?(t=Math.floor(m/F),g?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):m<A?(t=Math.floor(m/_),g?t===1?E?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):E?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?E?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):E?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):m<y?(t=Math.floor(m/A),g?t===1?E?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):E?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?E?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):E?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(m/y),g?t===1?E?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):E?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?E?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):E?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=k;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(De[114],Ce([16,17]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(De[44],Ce([1,0,18,9,114]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(w,g){return g&&(w.stack||w.stacktrace)?S.localize(0,null,A(w),_(w.stack)||_(w.stacktrace)):A(w)}function _(w){return Array.isArray(w)?w.join(`
`):w}function A(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function y(w=null,g=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const E=i.coalesce(w),m=y(E[0],g);return E.length>1?S.localize(4,null,m,E.length):m}if(D.isString(w))return w;if(w.detail){const E=w.detail;if(E.error)return F(E.error,g);if(E.exception)return F(E.exception,g)}return w.stack?F(w,g):w.message?w.message:S.localize(5,null)}e.toErrorMessage=y;function k(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=k;function O(w,g){let E;return typeof w=="string"?E=new Error(w):E=w,E.actions=g,E}e.createErrorWithActions=O}),define(De[79],Ce([1,0,19]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(O){const w=(0,i.extname)(O),g=D[w.toLowerCase()];return g!==void 0?g:_(O)}e.getMediaOrTextMime=F;function _(O){const w=(0,i.extname)(O);return S[w.toLowerCase()]}e.getMediaMime=_;function A(O){for(const w in S)if(S[w]===O)return w}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function k(O,w){const g=y.exec(O);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:w?void 0:O}e.normalizeMimeType=k}),define(De[115],Ce([1,0,4,7]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const S=_=>({onDidChange:i.Event.None,value:_});e.staticObservableValue=S;class F extends D.Disposable{get value(){return this._value}set value(A){A!==this._value&&(this._value=A,this.changeEmitter.fire(A))}constructor(A){super(),this._value=A,this.changeEmitter=this._register(new i.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=F}),define(De[39],Ce([1,0,19,20,10,9]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(l){return l===47||l===92}e.isPathSeparator=_;function A(l){return l.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=A;function y(l){return l.indexOf("/")===-1&&(l=A(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function k(l,f=i.posix.sep){if(!l)return"";const r=l.length,h=l.charCodeAt(0);if(_(h)){if(_(l.charCodeAt(1))&&!_(l.charCodeAt(2))){let I=3;const L=I;for(;I<r&&!_(l.charCodeAt(I));I++);if(L!==I&&!_(l.charCodeAt(I+1))){for(I+=1;I<r;I++)if(_(l.charCodeAt(I)))return l.slice(0,I+1).replace(/[\\/]/g,f)}}return f}else if(a(h)&&l.charCodeAt(1)===58)return _(l.charCodeAt(2))?l.slice(0,2)+f:l.slice(0,2);let v=l.indexOf("://");if(v!==-1){for(v+=3;v<r;v++)if(_(l.charCodeAt(v)))return l.slice(0,v+1)}return""}e.getRoot=k;function O(l){if(!D.isWindows||!l||l.length<5)return!1;let f=l.charCodeAt(0);if(f!==92||(f=l.charCodeAt(1),f!==92))return!1;let r=2;const h=r;for(;r<l.length&&(f=l.charCodeAt(r),f!==92);r++);return!(h===r||(f=l.charCodeAt(r+1),isNaN(f)||f===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,f=D.isWindows){const r=f?w:g;return!(!l||l.length===0||/^\s+$/.test(l)||(r.lastIndex=0,r.test(l))||f&&E.test(l)||l==="."||l===".."||f&&l[l.length-1]==="."||f&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=m;function t(l,f,r){const h=l===f;return!r||h?h:!l||!f?!1:(0,S.equalsIgnoreCase)(l,f)}e.isEqual=t;function o(l,f,r,h=i.sep){if(l===f)return!0;if(!l||!f||f.length>l.length)return!1;if(r){if(!(0,S.startsWithIgnoreCase)(l,f))return!1;if(f.length===l.length)return!0;let I=f.length;return f.charAt(f.length-1)===h&&I--,l.charAt(I)===h}return f.charAt(f.length-1)!==h&&(f+=h),l.indexOf(f)===0}e.isEqualOrParent=o;function a(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=a;function p(l,f){return D.isWindows&&l.endsWith(":")&&(l+=i.sep),(0,i.isAbsolute)(l)||(l=(0,i.join)(f,l)),l=(0,i.normalize)(l),D.isWindows?(l=(0,S.rtrim)(l,i.sep),l.endsWith(":")&&(l+=i.sep)):(l=(0,S.rtrim)(l,i.sep),l||(l=i.sep)),l}e.sanitizeFilePath=p;function b(l){const f=(0,i.normalize)(l);return D.isWindows?l.length>3?!1:u(f)&&(l.length===2||f.charCodeAt(2)===92):f===i.posix.sep}e.isRootOrDriveLetter=b;function u(l,f=D.isWindows){return f?a(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function C(l){return u(l)?l[0]:void 0}e.getDriveLetter=C;function s(l,f,r){return f.length>l.length?-1:l===f?0:(r&&(l=l.toLowerCase(),f=f.toLowerCase()),l.indexOf(f))}e.indexOfPath=s;function c(l){const f=l.split(":");let r,h,v;for(const I of f){const L=Number(I);(0,F.isNumber)(L)?h===void 0?h=L:v===void 0&&(v=L):r=r?[r,I].join(":"):I}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(l,f,r=8){let h="";for(let I=0;I<r;I++)h+=n.charAt(Math.floor(Math.random()*n.length));let v;return f?v=`${f}-${h}`:v=h,l?(0,i.join)(l,v):v}e.randomPath=d}),define(De[116],Ce([1,0,28,10]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...ee){return function(Z,T){for(let z=0,V=ee.length;z<V;z++){const q=ee[z](Z,T);if(q)return q}return null}}e.or=S,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(ee,Z,T){if(!T||T.length<Z.length)return null;let z;return ee?z=D.startsWithIgnoreCase(T,Z):z=T.indexOf(Z)===0,z?Z.length>0?[{start:0,end:Z.length}]:[]:null}function _(ee,Z){const T=Z.toLowerCase().indexOf(ee.toLowerCase());return T===-1?null:[{start:T,end:T+ee.length}]}e.matchesContiguousSubString=_;function A(ee,Z){return y(ee.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=A;function y(ee,Z,T,z){if(T===ee.length)return[];if(z===Z.length)return null;if(ee[T]===Z[z]){let V=null;return(V=y(ee,Z,T+1,z+1))?a({start:z,end:z+1},V):null}return y(ee,Z,T,z+1)}function k(ee){return 97<=ee&&ee<=122}function O(ee){return 65<=ee&&ee<=90}e.isUpper=O;function w(ee){return 48<=ee&&ee<=57}function g(ee){return ee===32||ee===9||ee===10||ee===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>E.add(ee.charCodeAt(0)));function m(ee){return g(ee)||E.has(ee)}function t(ee,Z){return ee===Z||m(ee)&&m(Z)}function o(ee){return k(ee)||O(ee)||w(ee)}function a(ee,Z){return Z.length===0?Z=[ee]:ee.end===Z[0].start?Z[0].start=ee.start:Z.unshift(ee),Z}function p(ee,Z){for(let T=Z;T<ee.length;T++){const z=ee.charCodeAt(T);if(O(z)||w(z)||T>0&&!o(ee.charCodeAt(T-1)))return T}return ee.length}function b(ee,Z,T,z){if(T===ee.length)return[];if(z===Z.length)return null;if(ee[T]!==Z[z].toLowerCase())return null;{let V=null,q=z+1;for(V=b(ee,Z,T+1,z+1);!V&&(q=p(Z,q))<Z.length;)V=b(ee,Z,T+1,q),q++;return V===null?null:a({start:z,end:z+1},V)}}function u(ee){let Z=0,T=0,z=0,V=0,q=0;for(let ve=0;ve<ee.length;ve++)q=ee.charCodeAt(ve),O(q)&&Z++,k(q)&&T++,o(q)&&z++,w(q)&&V++;const oe=Z/ee.length,ce=T/ee.length,J=z/ee.length,Ee=V/ee.length;return{upperPercent:oe,lowerPercent:ce,alphaPercent:J,numericPercent:Ee}}function C(ee){const{upperPercent:Z,lowerPercent:T}=ee;return T===0&&Z>.6}function s(ee){const{upperPercent:Z,lowerPercent:T,alphaPercent:z,numericPercent:V}=ee;return T>.2&&Z<.8&&z>.6&&V<.2}function c(ee){let Z=0,T=0,z=0,V=0;for(let q=0;q<ee.length;q++)z=ee.charCodeAt(q),O(z)&&Z++,k(z)&&T++,g(z)&&V++;return(Z===0||T===0)&&V===0?ee.length<=30:Z<=5}function n(ee,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!c(ee)||Z.length>60)return null;const T=u(Z);if(!s(T)){if(!C(T))return null;Z=Z.toLowerCase()}let z=null,V=0;for(ee=ee.toLowerCase();V<Z.length&&(z=b(ee,Z,0,V))===null;)V=p(Z,V+1);return z}e.matchesCamelCase=n;function d(ee,Z,T=!1){if(!Z||Z.length===0)return null;let z=null,V=0;for(ee=ee.toLowerCase(),Z=Z.toLowerCase();V<Z.length&&(z=l(ee,Z,0,V,T))===null;)V=f(Z,V+1);return z}e.matchesWords=d;function l(ee,Z,T,z,V){if(T===ee.length)return[];if(z===Z.length)return null;if(t(ee.charCodeAt(T),Z.charCodeAt(z))){let q=null,oe=z+1;if(q=l(ee,Z,T+1,z+1,V),!V)for(;!q&&(oe=f(Z,oe))<Z.length;)q=l(ee,Z,T+1,oe,V),oe++;return q?ee.charCodeAt(T)!==Z.charCodeAt(z)?q:a({start:z,end:z+1},q):null}else return null}function f(ee,Z){for(let T=Z;T<ee.length;T++)if(m(ee.charCodeAt(T))||T>0&&m(ee.charCodeAt(T-1)))return T;return ee.length}const r=S(e.matchesPrefix,n,_),h=S(e.matchesPrefix,n,A),v=new i.LRUCache(1e4);function I(ee,Z,T=!1){if(typeof ee!="string"||typeof Z!="string")return null;let z=v.get(ee);z||(z=new RegExp(D.convertSimple2RegExpPattern(ee),"i"),v.set(ee,z));const V=z.exec(Z);return V?[{start:V.index,end:V.index+V[0].length}]:T?h(ee,Z):r(ee,Z)}e.matchesFuzzy=I;function L(ee,Z){const T=Ue(ee,ee.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?W(T):null}e.matchesFuzzy2=L;function j(ee,Z,T,z,V,q){const oe=Math.min(13,ee.length);for(;T<oe;T++){const ce=Ue(ee,Z,T,z,V,q,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ce)return ce}return[0,q]}e.anyScore=j;function W(ee){if(typeof ee>"u")return[];const Z=[],T=ee[1];for(let z=ee.length-1;z>1;z--){const V=ee[z]+T,q=Z[Z.length-1];q&&q.end===V?q.end=V+1:Z.push({start:V,end:V+1})}return Z}e.createMatches=W;const H=128;function P(){const ee=[],Z=[];for(let T=0;T<=H;T++)Z[T]=0;for(let T=0;T<=H;T++)ee.push(Z.slice(0));return ee}function M(ee){const Z=[];for(let T=0;T<=ee;T++)Z[T]=0;return Z}const R=M(2*H),B=M(2*H),x=P(),U=P(),K=P(),te=!1;function de(ee,Z,T,z,V){function q(ce,J,Ee=" "){for(;ce.length<J;)ce=Ee+ce;return ce}let oe=` |   |${z.split("").map(ce=>q(ce,3)).join("|")}
`;for(let ce=0;ce<=T;ce++)ce===0?oe+=" |":oe+=`${Z[ce-1]}|`,oe+=ee[ce].slice(0,V+1).map(J=>q(J.toString(),3)).join("|")+`
`;return oe}function re(ee,Z,T,z){ee=ee.substr(Z),T=T.substr(z),console.log(de(U,ee,ee.length,T,T.length)),console.log(de(K,ee,ee.length,T,T.length)),console.log(de(x,ee,ee.length,T,T.length))}function be(ee,Z){if(Z<0||Z>=ee.length)return!1;const T=ee.codePointAt(Z);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(T)}}function le(ee,Z){if(Z<0||Z>=ee.length)return!1;switch(ee.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function fe(ee,Z,T){return Z[ee]!==T[ee]}function Q(ee,Z,T,z,V,q,oe=!1){for(;Z<T&&V<q;)ee[Z]===z[V]&&(oe&&(R[Z]=V),Z+=1),V+=1;return Z===T}e.isPatternInWord=Q;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Se;(function(ee){ee.Default=[-100,0];function Z(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}ee.isDefault=Z})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Z,T){this.firstMatchCanBeWeak=Z,this.boostFullMatch=T}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ue(ee,Z,T,z,V,q,oe=Fe.default){const ce=ee.length>H?H:ee.length,J=z.length>H?H:z.length;if(T>=ce||q>=J||ce-T>J-q||!Q(Z,T,ce,V,q,J,!0))return;Xe(ce,J,T,q,Z,V);let Ee=1,ve=1,Ne=T,ze=q;const Je=[!1];for(Ee=1,Ne=T;Ne<ce;Ee++,Ne++){const Y=R[Ne],me=B[Ne],Be=Ne+1<ce?B[Ne+1]:J;for(ve=Y-q+1,ze=Y;ze<Be;ve++,ze++){let je=Number.MIN_SAFE_INTEGER,Ze=!1;ze<=me&&(je=ke(ee,Z,Ne,T,z,V,ze,J,q,x[Ee-1][ve-1]===0,Je));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Ke=je+U[Ee-1][ve-1]);const Ve=ze>Y,nt=Ve?U[Ee][ve-1]+(x[Ee][ve-1]>0?-5:0):0,st=ze>Y+1&&x[Ee][ve-1]>0,dt=st?U[Ee][ve-2]+(x[Ee][ve-2]>0?-5:0):0;if(st&&(!Ve||dt>=nt)&&(!Ze||dt>=Ke))U[Ee][ve]=dt,K[Ee][ve]=3,x[Ee][ve]=0;else if(Ve&&(!Ze||nt>=Ke))U[Ee][ve]=nt,K[Ee][ve]=2,x[Ee][ve]=0;else if(Ze)U[Ee][ve]=Ke,K[Ee][ve]=1,x[Ee][ve]=x[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(te&&re(ee,T,z,q),!Je[0]&&!oe.firstMatchCanBeWeak)return;Ee--,ve--;const Ge=[U[Ee][ve],q];let Pe=0,rt=0;for(;Ee>=1;){let Y=ve;do{const me=K[Ee][Y];if(me===3)Y=Y-2;else if(me===2)Y=Y-1;else break}while(Y>=1);Pe>1&&Z[T+Ee-1]===V[q+ve-1]&&!fe(Y+q-1,z,V)&&Pe+1>x[Ee][Y]&&(Y=ve),Y===ve?Pe++:Pe=1,rt||(rt=Y),Ee--,ve=Y-1,Ge.push(ve)}J===ce&&oe.boostFullMatch&&(Ge[0]+=2);const X=rt-ce;return Ge[0]-=X,Ge}e.fuzzyScore=Ue;function Xe(ee,Z,T,z,V,q){let oe=ee-1,ce=Z-1;for(;oe>=T&&ce>=z;)V[oe]===q[ce]&&(B[oe]=ce,oe--),ce--}function ke(ee,Z,T,z,V,q,oe,ce,J,Ee,ve){if(Z[T]!==q[oe])return Number.MIN_SAFE_INTEGER;let Ne=1,ze=!1;return oe===T-z?Ne=ee[T]===V[oe]?7:5:fe(oe,V,q)&&(oe===0||!fe(oe-1,V,q))?(Ne=ee[T]===V[oe]?7:5,ze=!0):be(q,oe)&&(oe===0||!be(q,oe-1))?Ne=5:(be(q,oe-1)||le(q,oe-1))&&(Ne=5,ze=!0),Ne>1&&T===z&&(ve[0]=!0),ze||(ze=fe(oe,V,q)||be(q,oe-1)||le(q,oe-1)),T===z?oe>J&&(Ne-=ze?3:5):Ee?Ne+=ze?2:0:Ne+=ze?0:1,oe+1===ce&&(Ne-=ze?3:5),Ne}function ye(ee,Z,T,z,V,q,oe){return ae(ee,Z,T,z,V,q,!0,oe)}e.fuzzyScoreGracefulAggressive=ye;function Ie(ee,Z,T,z,V,q,oe){return ae(ee,Z,T,z,V,q,!1,oe)}e.fuzzyScoreGraceful=Ie;function ae(ee,Z,T,z,V,q,oe,ce){let J=Ue(ee,Z,T,z,V,q,ce);if(J&&!oe)return J;if(ee.length>=3){const Ee=Math.min(7,ee.length-1);for(let ve=T+1;ve<Ee;ve++){const Ne=ue(ee,ve);if(Ne){const ze=Ue(Ne,Ne.toLowerCase(),T,z,V,q,ce);ze&&(ze[0]-=3,(!J||ze[0]>J[0])&&(J=ze))}}}return J}function ue(ee,Z){if(Z+1>=ee.length)return;const T=ee[Z],z=ee[Z+1];if(T!==z)return ee.slice(0,Z)+z+T+ee.slice(Z+2)}}),define(De[117],Ce([1,0,118,116,10]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const F=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(i.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${F.source}`,"g");function y(o){return o.replace(A,(a,p)=>p?a:`\\${a}`)}e.escapeIcons=y;const k=new RegExp(`\\\\${F.source}`,"g");function O(o){return o.replace(k,a=>`\\${a}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${F.source}(\\s)?`,"g");function g(o){return o.indexOf(e.iconStartMarker)===-1?o:o.replace(w,(a,p,b,u)=>b?a:p||u||"")}e.stripIcons=g;function E(o){const a=o.indexOf(e.iconStartMarker);return a===-1?{text:o}:m(o,a)}e.parseLabelWithIcons=E;function m(o,a){const p=[];let b="";function u(r){if(r){b+=r;for(const h of r)p.push(c)}}let C=-1,s="",c=0,n,d,l=a;const f=o.length;for(u(o.substr(0,a));l<f;)n=o[l],d=o[l+1],n===e.iconStartMarker[0]&&d===e.iconStartMarker[1]?(C=l,u(s),s=e.iconStartMarker,l++):n===")"&&C!==-1?(c+=l-C+1,C=-1,s=""):C!==-1?_.test(n)?s+=n:(u(s),C=-1,s=""):u(n),l++;return u(s),{text:b,iconOffsets:p}}function t(o,a,p=!1){const{text:b,iconOffsets:u}=a;if(!u||u.length===0)return(0,D.matchesFuzzy)(o,b,p);const C=(0,S.ltrim)(b," "),s=b.length-C.length,c=(0,D.matchesFuzzy)(o,C,p);if(c)for(const n of c){const d=u[n.start+s]+s;n.start+=d,n.end+=d}return c}e.matchesFuzzyIconAware=t}),define(De[29],Ce([1,0,10]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(D||(D={})),function(S){const F="error",_="warning",A="warn",y="info",k="ignore";function O(g){return g?i.equalsIgnoreCase(F,g)?S.Error:i.equalsIgnoreCase(_,g)||i.equalsIgnoreCase(A,g)?S.Warning:i.equalsIgnoreCase(y,g)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function w(g){switch(g){case S.Error:return F;case S.Warning:return _;case S.Info:return y;default:return k}}S.toString=w}(D||(D={})),e.default=D}),define(De[45],Ce([1,0,18,10]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const m=E.charCodeAt(0),t=this._value.charCodeAt(this._pos);return m-t}value(){return this._value[this._pos]}}e.StringIterator=S;class F{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,D.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=F;class _{constructor(E=!0,m=!0){this._splitOnBackslash=E,this._caseSensitive=m}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let m=E.length-1;m>=0;m--,this._valueLen--){const t=this._value.charCodeAt(m);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,D.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var A;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(E,m){this._ignorePathCasing=E,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,D.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(O||(O={}));class w{static forUris(E=()=>!1,m=()=>!1){return new w(new y(E,m))}static forPaths(E=!1){return new w(new _(void 0,!E))}static forStrings(){return new w(new S)}static forConfigKeys(){return new w(new F)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,m){if(m){const t=m.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o,E)}else{const t=E.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o[0],o[1])}}set(E,m){const t=this._iter.reset(E);let o;this._root||(this._root=new k,this._root.segment=t.value());const a=[];for(o=this._root;;){const b=t.cmp(o.segment);if(b>0)o.left||(o.left=new k,o.left.segment=t.value()),a.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new k,o.right.segment=t.value()),a.push([1,o]),o=o.right;else if(t.hasNext())t.next(),o.mid||(o.mid=new k,o.mid.segment=t.value()),a.push([0,o]),o=o.mid;else break}const p=o.value;o.value=m,o.key=E;for(let b=a.length-1;b>=0;b--){const u=a[b][1];u.updateHeight();const C=u.balanceFactor();if(C<-1||C>1){const s=a[b][0],c=a[b+1][0];if(s===1&&c===1)a[b][1]=u.rotateLeft();else if(s===-1&&c===-1)a[b][1]=u.rotateRight();else if(s===1&&c===-1)u.right=a[b+1][1]=a[b+1][1].rotateRight(),a[b][1]=u.rotateLeft();else if(s===-1&&c===1)u.left=a[b+1][1]=a[b+1][1].rotateLeft(),a[b][1]=u.rotateRight();else throw new Error;if(b>0)switch(a[b-1][0]){case-1:a[b-1][1].left=a[b][1];break;case 1:a[b-1][1].right=a[b][1];break;case 0:a[b-1][1].mid=a[b][1];break}else this._root=a[0][1]}}return p}get(E){return this._getNode(E)?.value}_getNode(E){const m=this._iter.reset(E);let t=this._root;for(;t;){const o=m.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(m.hasNext())m.next(),t=t.mid;else break}return t}has(E){const m=this._getNode(E);return!(m?.value===void 0&&m?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,m){const t=this._iter.reset(E),o=[];let a=this._root;for(;a;){const p=t.cmp(a.segment);if(p>0)o.push([-1,a]),a=a.left;else if(p<0)o.push([1,a]),a=a.right;else if(t.hasNext())t.next(),o.push([0,a]),a=a.mid;else break}if(!!a){if(m?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const p=this._min(a.right);if(p.key){const{key:b,value:u,segment:C}=p;this._delete(p.key,!1),a.key=b,a.value=u,a.segment=C}}else{const p=a.left??a.right;if(o.length>0){const[b,u]=o[o.length-1];switch(b){case-1:u.left=p;break;case 0:u.mid=p;break;case 1:u.right=p;break}}else this._root=p}for(let p=o.length-1;p>=0;p--){const b=o[p][1];b.updateHeight();const u=b.balanceFactor();if(u>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[p][1]=b.rotateLeft()):u<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[p][1]=b.rotateRight()),p>0)switch(o[p-1][0]){case-1:o[p-1][1].left=o[p][1];break;case 1:o[p-1][1].right=o[p][1];break;case 0:o[p-1][1].mid=o[p][1];break}else this._root=o[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const m=this._iter.reset(E);let t=this._root,o;for(;t;){const a=m.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(m.hasNext())m.next(),o=t.value||o,t=t.mid;else break}return t&&t.value||o}findSuperstr(E){const m=this._iter.reset(E);let t=this._root;for(;t;){const o=m.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(m.hasNext())m.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(E){for(const[m,t]of this)E(t,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const m=[];return this._dfsEntries(E,m),m[Symbol.iterator]()}_dfsEntries(E,m){!E||(E.left&&this._dfsEntries(E.left,m),E.value&&m.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,m),E.right&&this._dfsEntries(E.right,m))}_isBalanced(){const E=m=>{if(!m)return!0;const t=m.balanceFactor();return t<-1||t>1?!1:E(m.left)&&E(m.right)};return E(this._root)}}e.TernarySearchTree=w}),define(De[80],Ce([1,0,23,10,2]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function F(k){return JSON.stringify(k,A)}e.stringify=F;function _(k){let O=JSON.parse(k);return O=y(O),O}e.parse=_;function A(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,D.regExpFlags)(O)}:O}function y(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 15:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let w=0;w<k.length;++w)k[w]=y(k[w],O+1);else for(const w in k)Object.hasOwnProperty.call(k,w)&&(k[w]=y(k[w],O+1))}return k}e.revive=y}),define(De[13],Ce([1,0,20,2]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var S;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(S=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class F{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${S.vscodeRemoteResource}`}set(k,O,w){this._hosts[k]=O,this._ports[k]=w}setConnectionToken(k,O){this._connectionTokens[k]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const O=k.authority;let w=this._hosts[O];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const g=this._ports[O],E=this._connectionTokens[O];let m=`path=${encodeURIComponent(k.path)}`;return typeof E=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),D.URI.from({scheme:i.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${w}:${g}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new F;class _{asBrowserUri(k,O){const w=this.toUri(k,O);return w.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===S.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${S.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?w.with({scheme:S.vscodeFileResource,authority:w.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(k,O){const w=this.toUri(k,O);return w.scheme===S.vscodeFileResource?w.with({scheme:S.file,authority:w.authority!==_.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(k,O){return D.URI.isUri(k)?k:D.URI.parse(O.toUrl(k))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var A;(function(y){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(k.get("3"));const O="vscode-coi";function w(E){let m;typeof E=="string"?m=new URL(E).searchParams:E instanceof URL?m=E.searchParams:D.URI.isUri(E)&&(m=new URL(E.toString(!0)).searchParams);const t=m?.get(O);if(!!t)return k.get(t)}y.getHeadersFromQuery=w;function g(E,m,t){if(!globalThis.crossOriginIsolated)return;const o=m&&t?"3":t?"2":"1";E instanceof URLSearchParams?E.set(O,o):E[O]=o}y.addSearchParam=g})(A=e.COI||(e.COI={}))}),define(De[22],Ce([1,0,39,13,19,20,10,2]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(E){return(0,A.uriToFsPath)(E,!0)}e.originalFSPath=y;class k{constructor(m){this._ignorePathCasing=m}compare(m,t,o=!1){return m===t?0:(0,_.compare)(this.getComparisonKey(m,o),this.getComparisonKey(t,o))}isEqual(m,t,o=!1){return m===t?!0:!m||!t?!1:this.getComparisonKey(m,o)===this.getComparisonKey(t,o)}getComparisonKey(m,t=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,t,o=!1){if(m.scheme===t.scheme){if(m.scheme===D.Schemas.file)return i.isEqualOrParent(y(m),y(t),this._ignorePathCasing(m))&&m.query===t.query&&(o||m.fragment===t.fragment);if((0,e.isEqualAuthority)(m.authority,t.authority))return i.isEqualOrParent(m.path,t.path,this._ignorePathCasing(m),"/")&&m.query===t.query&&(o||m.fragment===t.fragment)}return!1}joinPath(m,...t){return A.URI.joinPath(m,...t)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return S.posix.basename(m.path)}extname(m){return S.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let t;return m.scheme===D.Schemas.file?t=A.URI.file(S.dirname(y(m))).path:(t=S.posix.dirname(m.path),m.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),t="/")),m.with({path:t})}normalizePath(m){if(!m.path.length)return m;let t;return m.scheme===D.Schemas.file?t=A.URI.file(S.normalize(y(m))).path:t=S.posix.normalize(m.path),m.with({path:t})}relativePath(m,t){if(m.scheme!==t.scheme||!(0,e.isEqualAuthority)(m.authority,t.authority))return;if(m.scheme===D.Schemas.file){const p=S.relative(y(m),y(t));return F.isWindows?i.toSlashes(p):p}let o=m.path||"/";const a=t.path||"/";if(this._ignorePathCasing(m)){let p=0;for(const b=Math.min(o.length,a.length);p<b&&!(o.charCodeAt(p)!==a.charCodeAt(p)&&o.charAt(p).toLowerCase()!==a.charAt(p).toLowerCase());p++);o=a.substr(0,p)+o.substr(p)}return S.posix.relative(o,a)}resolvePath(m,t){if(m.scheme===D.Schemas.file){const o=A.URI.file(S.resolve(y(m),t));return m.with({authority:o.authority,path:o.path})}return t=i.toPosixPath(t),m.with({path:S.posix.resolve(m.path,t)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,t){return m===t||m!==void 0&&t!==void 0&&(0,_.equalsIgnoreCase)(m,t)}hasTrailingPathSeparator(m,t=S.sep){if(m.scheme===D.Schemas.file){const o=y(m);return o.length>i.getRoot(o).length&&o[o.length-1]===t}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,t=S.sep){return(0,e.hasTrailingPathSeparator)(m,t)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,t=S.sep){let o=!1;if(m.scheme===D.Schemas.file){const a=y(m);o=a!==void 0&&a.length===i.getRoot(a).length&&a[a.length-1]===t}else{t="/";const a=m.path;o=a.length===1&&a.charCodeAt(a.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,t)?m.with({path:m.path+"/"}):m}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(E=>E.scheme===D.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new k(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(E,m){const t=[];for(let o=0;o<E.length;o++){const a=m(E[o]);E.some((p,b)=>b===o?!1:(0,e.isEqualOrParent)(a,m(p)))||t.push(E[o])}return t}e.distinctParents=O;var w;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function m(t){const o=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(b=>{const[u,C]=b.split(":");u&&C&&o.set(u,C)});const p=t.path.substring(0,t.path.indexOf(";"));return p&&o.set(E.META_DATA_MIME,p),o}E.parseMetaData=m})(w=e.DataUri||(e.DataUri={}));function g(E,m,t){if(m){let o=E.path;return o&&o[0]!==S.posix.sep&&(o=S.posix.sep+o),E.with({scheme:t,authority:m,path:o})}return E.with({scheme:t})}e.toLocalResource=g}),define(De[15],Ce([1,0,21,12,4,7,22,20]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=y;function k(fe){const Q=new i.CancellationTokenSource,pe=fe(Q.token),Se=new Promise((Fe,Ue)=>{const Xe=Q.token.onCancellationRequested(()=>{Xe.dispose(),Q.dispose(),Ue(new D.CancellationError)});Promise.resolve(pe).then(ke=>{Xe.dispose(),Q.dispose(),Fe(ke)},ke=>{Xe.dispose(),Q.dispose(),Ue(ke)})});return new class{cancel(){Q.cancel()}then(Fe,Ue){return Se.then(Fe,Ue)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Se.finally(Fe)}}}e.createCancelablePromise=k;function O(fe,Q,pe){return new Promise((Se,Fe)=>{const Ue=Q.onCancellationRequested(()=>{Ue.dispose(),Se(pe)});fe.then(Se,Fe).finally(()=>Ue.dispose())})}e.raceCancellation=O;function w(fe,Q){return new Promise((pe,Se)=>{const Fe=Q.onCancellationRequested(()=>{Fe.dispose(),Se(new D.CancellationError)});fe.then(pe,Se).finally(()=>Fe.dispose())})}e.raceCancellationError=w;async function g(fe){let Q=-1;const pe=fe.map((Fe,Ue)=>Fe.then(Xe=>(Q=Ue,Xe))),Se=await Promise.race(pe);return fe.forEach((Fe,Ue)=>{Ue!==Q&&Fe.cancel()}),Se}e.raceCancellablePromises=g;function E(fe,Q,pe){let Se;const Fe=setTimeout(()=>{Se?.(void 0),pe?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(Fe)),new Promise(Ue=>Se=Ue)])}e.raceTimeout=E;function m(fe){return new Promise((Q,pe)=>{const Se=fe();y(Se)?Se.then(Q,pe):Q(Se)})}e.asPromise=m;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(pe,pe).then(Se)})}return new Promise((pe,Se)=>{this.queuedPromise.then(pe,Se)})}return this.activePromise=Q(),new Promise((pe,Se)=>{this.activePromise.then(Fe=>{this.activePromise=null,pe(Fe)},Fe=>{this.activePromise=null,Se(Fe)})})}}e.Throttler=t;class o{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=o;class a{constructor(){this.promiseMap=new Map}queue(Q,pe){const Fe=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(Q)===Fe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Fe),Fe}}e.SequencerByKey=a;const p=(fe,Q)=>{let pe=!0;const Se=setTimeout(()=>{pe=!1,Q()},fe);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(Se),pe=!1}}},b=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,pe=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,Ue)=>{this.doResolve=Fe,this.doReject=Ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?b(Se):p(pe,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class C{constructor(Q){this.delayer=new u(Q),this.throttler=new t}trigger(Q,pe){return this.delayer.trigger(()=>this.throttler.queue(Q),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=C;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Q,pe)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class c extends s{constructor(Q){super(),this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function n(fe,Q){return Q?new Promise((pe,Se)=>{const Fe=setTimeout(()=>{Ue.dispose(),pe()},fe),Ue=Q.onCancellationRequested(()=>{clearTimeout(Fe),Ue.dispose(),Se(new D.CancellationError)})}):k(pe=>n(fe,pe))}e.timeout=n;function d(fe,Q=0){const pe=setTimeout(fe,Q);return(0,F.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=d;function l(fe){const Q=[];let pe=0;const Se=fe.length;function Fe(){return pe<Se?fe[pe++]():null}function Ue(Xe){Xe!=null&&Q.push(Xe);const ke=Fe();return ke?ke.then(Ue):Promise.resolve(Q)}return Promise.resolve(null).then(Ue)}e.sequence=l;function f(fe,Q=Se=>!!Se,pe=null){let Se=0;const Fe=fe.length,Ue=()=>{if(Se>=Fe)return Promise.resolve(pe);const Xe=fe[Se++];return Promise.resolve(Xe()).then(ye=>Q(ye)?Promise.resolve(ye):Ue())};return Ue()}e.first=f;function r(fe,Q=Se=>!!Se,pe=null){if(fe.length===0)return Promise.resolve(pe);let Se=fe.length;const Fe=()=>{Se=-1;for(const Ue of fe)Ue.cancel?.()};return new Promise((Ue,Xe)=>{for(const ke of fe)ke.then(ye=>{--Se>=0&&Q(ye)?(Fe(),Ue(ye)):Se===0&&Ue(pe)}).catch(ye=>{--Se>=0&&(Fe(),Xe(ye))})})}e.firstParallel=r;class h{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Q){return this._size++,new Promise((pe,Se)=>{this.outstandingPromises.push({factory:Q,c:pe,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const pe=Q.factory();pe.then(Q.c,Q.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new K;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,pe=_.extUri){const Se=pe.getComparisonKey(Q);let Fe=this.queues.get(Se);return Fe||(Fe=new v,S.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class L{constructor(Q,pe){this._token=-1,typeof Q=="function"&&typeof pe=="number"&&this.setIfNotSet(Q,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},pe)}setIfNotSet(Q,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},pe))}}e.TimeoutTimer=L;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setInterval(()=>{Q()},pe)}}e.IntervalTimer=j;class W{constructor(Q,pe){this.timeoutToken=-1,this.runner=Q,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class H{constructor(Q,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=H;class P extends W{constructor(Q,pe){super(Q,pe),this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner?.(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=P;class M extends F.Disposable{constructor(Q,pe){super(),this.options=Q,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new F.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(Q)return;const pe=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(fe,Q)=>{const pe=requestIdleCallback(fe,typeof Q=="number"?{timeout:Q}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(pe))}}}}();class R{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function B(fe,Q,pe){let Se;for(let Fe=0;Fe<pe;Fe++)try{return await fe()}catch(Ue){Se=Ue,await n(Q)}throw Se}e.retry=B;class x{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Q,pe,Se){return this._pending={taskId:Q,cancel:()=>Se?.(),promise:pe},pe.then(()=>this.donePending(Q),()=>this.donePending(Q)),pe}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let pe,Se;const Fe=new Promise((Ue,Xe)=>{pe=Ue,Se=Xe});this._next={run:Q,promise:Fe,promiseResolve:pe,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=x;class U{constructor(Q,pe=()=>Date.now()){this.interval=Q,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class K{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,pe)=>{this.completeCallback=Q,this.errorCallback=pe})}complete(Q){return new Promise(pe=>{this.completeCallback(Q),this.resolved=!0,pe()})}error(Q){return new Promise(pe=>{this.errorCallback(Q),this.rejected=!0,pe()})}cancel(){new Promise(Q=>{this.errorCallback(new D.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=K;var te;(function(fe){async function Q(Se){let Fe;const Ue=await Promise.all(Se.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return Ue}fe.settled=Q;function pe(Se){return new Promise(async(Fe,Ue)=>{try{await Se(Fe,Ue)}catch(Xe){Ue(Xe)}})}fe.withAsyncBody=pe})(te=e.Promises||(e.Promises={}));var de;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(de||(de={}));class re{static fromArray(Q){return new re(pe=>{pe.emitMany(Q)})}static fromPromise(Q){return new re(async pe=>{pe.emitMany(await Q)})}static fromPromises(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>pe.emitOne(await Se)))})}static merge(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>{for await(const Fe of Se)pe.emitOne(Fe)}))})}constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const pe={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(Q(pe)),this.resolve()}catch(Se){this.reject(Se)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,pe){return new re(async Se=>{for await(const Fe of Q)Se.emitOne(pe(Fe))})}map(Q){return re.map(this,Q)}static filter(Q,pe){return new re(async Se=>{for await(const Fe of Q)pe(Fe)&&Se.emitOne(Fe)})}filter(Q){return re.filter(this,Q)}static coalesce(Q){return re.filter(Q,pe=>!!pe)}coalesce(){return re.coalesce(this)}static async toPromise(Q){const pe=[];for await(const Se of Q)pe.push(Se);return pe}toPromise(){return re.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class be extends re{constructor(Q,pe){super(pe),this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function le(fe){const Q=new i.CancellationTokenSource,pe=fe(Q.token);return new be(Q,async Se=>{const Fe=Q.token.onCancellationRequested(()=>{Fe.dispose(),Q.dispose(),Se.reject(new D.CancellationError)});try{for await(const Ue of pe){if(Q.token.isCancellationRequested)return;Se.emitOne(Ue)}Fe.dispose(),Q.dispose()}catch(Ue){Fe.dispose(),Q.dispose(),Se.reject(Ue)}})}e.createCancelableAsyncIterable=le}),define(De[119],Ce([1,0,15,19]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new i.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),F=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(v,I,L=!1){const j=v||"",W=I||"",H=S.value.collator.compare(j,W);return S.value.collatorIsNumeric&&H===0&&j!==W?j<W?-1:1:H}e.compareFileNames=A;function y(v,I){const L=F.value.collator;return v=v||"",I=I||"",C(L,v,I)}e.compareFileNamesDefault=y;function k(v,I){const L=F.value.collator;return v=v||"",I=I||"",d(v,I)||C(L,v,I)}e.compareFileNamesUpper=k;function O(v,I){const L=F.value.collator;return v=v||"",I=I||"",n(v,I)||C(L,v,I)}e.compareFileNamesLower=O;function w(v,I){return v=v||"",I=I||"",v===I?0:v<I?-1:1}e.compareFileNamesUnicode=w;function g(v,I,L=!1){L||(v=v&&v.toLowerCase(),I=I&&I.toLowerCase());const[j,W]=b(v),[H,P]=b(I);return j!==H?j<H?-1:1:W===P?0:W<P?-1:1}e.noIntlCompareFileNames=g;function E(v,I){const[L,j]=b(v),[W,H]=b(I);let P=S.value.collator.compare(j,H);if(P===0){if(S.value.collatorIsNumeric&&j!==H)return j<H?-1:1;if(P=S.value.collator.compare(L,W),S.value.collatorIsNumeric&&P===0&&L!==W)return L<W?-1:1}return P}e.compareFileExtensions=E;function m(v,I){v=v||"",I=I||"";const L=u(v),j=u(I),W=F.value.collator,H=_.value.collator;return C(H,L,j)||C(W,v,I)}e.compareFileExtensionsDefault=m;function t(v,I){v=v||"",I=I||"";const L=u(v),j=u(I),W=F.value.collator,H=_.value.collator;return C(H,L,j)||d(v,I)||C(W,v,I)}e.compareFileExtensionsUpper=t;function o(v,I){v=v||"",I=I||"";const L=u(v),j=u(I),W=F.value.collator,H=_.value.collator;return C(H,L,j)||n(v,I)||C(W,v,I)}e.compareFileExtensionsLower=o;function a(v,I){v=v||"",I=I||"";const L=u(v).toLowerCase(),j=u(I).toLowerCase();return L!==j?L<j?-1:1:v!==I?v<I?-1:1:0}e.compareFileExtensionsUnicode=a;const p=/^(.*?)(\.([^.]*))?$/;function b(v,I=!1){const L=v?p.exec(v):[];let j=[L&&L[1]||"",L&&L[3]||""];return I&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function u(v){const I=v?p.exec(v):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function C(v,I,L){const j=v.compare(I,L);return j!==0?j:I.length!==L.length?I.length<L.length?-1:1:0}function s(v){const I=v.charAt(0);return I.toLocaleUpperCase()!==I}function c(v){const I=v.charAt(0);return I.toLocaleLowerCase()!==I}function n(v,I){return s(v)&&c(I)?-1:c(v)&&s(I)?1:0}function d(v,I){return c(v)&&s(I)?-1:s(v)&&c(I)?1:0}function l(v,I,L=!1){return L||(v=v&&v.toLowerCase(),I=I&&I.toLowerCase()),v===I?0:v<I?-1:1}function f(v,I,L=!1){const j=v.split(D.sep),W=I.split(D.sep),H=j.length-1,P=W.length-1;let M,R;for(let B=0;;B++){if(M=H===B,R=P===B,M&&R)return A(j[B],W[B],L);if(M)return-1;if(R)return 1;const x=l(j[B],W[B],L);if(x!==0)return x}}e.comparePaths=f;function r(v,I,L){const j=v.toLowerCase(),W=I.toLowerCase(),H=h(v,I,L);if(H)return H;const P=j.endsWith(L),M=W.endsWith(L);if(P!==M)return P?-1:1;const R=A(j,W);return R!==0?R:j.localeCompare(W)}e.compareAnything=r;function h(v,I,L){const j=v.toLowerCase(),W=I.toLowerCase(),H=j.startsWith(L),P=W.startsWith(L);if(H!==P)return H?-1:1;if(H&&P){if(j.length<W.length)return-1;if(j.length>W.length)return 1}return 0}e.compareByPrefix=h}),define(De[34],Ce([1,0,18,15,39,28,19,20,10]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",g=/\//g;function E(K,te){switch(K){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${te?`|${O}${w}+`:""})*?`}}function m(K,te){if(!K)return[];const de=[];let re=!1,be=!1,le="";for(const fe of K){switch(fe){case te:if(!re&&!be){de.push(le),le="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":be=!0;break;case"]":be=!1;break}le+=fe}return le&&de.push(le),de}e.splitGlobAware=m;function t(K){if(!K)return"";let te="";const de=m(K,e.GLOB_SPLIT);if(de.every(re=>re===e.GLOBSTAR))te=".*";else{let re=!1;de.forEach((be,le)=>{if(be===e.GLOBSTAR){if(re)return;te+=E(2,le===de.length-1)}else{let fe=!1,Q="",pe=!1,Se="";for(const Fe of be){if(Fe!=="}"&&fe){Q+=Fe;continue}if(pe&&(Fe!=="]"||!Se)){let Ue;Fe==="-"?Ue=Fe:(Fe==="^"||Fe==="!")&&!Se?Ue="^":Fe===e.GLOB_SPLIT?Ue="":Ue=(0,y.escapeRegExpCharacters)(Fe),Se+=Ue;continue}switch(Fe){case"{":fe=!0;continue;case"[":pe=!0;continue;case"}":{te+=`(?:${m(Q,",").map(ke=>t(ke)).join("|")})`,fe=!1,Q="";break}case"]":{te+="["+Se+"]",pe=!1,Se="";break}case"?":te+=w;continue;case"*":te+=E(1);continue;default:te+=(0,y.escapeRegExpCharacters)(Fe)}}le<de.length-1&&(de[le+1]!==e.GLOBSTAR||le+2<de.length)&&(te+=O)}re=be===e.GLOBSTAR})}return te}const o=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new F.LRUCache(1e4),c=function(){return!1},n=function(){return null};function d(K,te){if(!K)return n;let de;typeof K!="string"?de=K.pattern:de=K,de=de.trim();const re=`${de}_${!!te.trimForExclusions}`;let be=s.get(re);if(be)return l(be,K);let le;return o.test(de)?be=r(de.substr(4),de):(le=a.exec(f(de,te)))?be=h(le[1],de):(te.trimForExclusions?b:p).test(de)?be=v(de,te):(le=u.exec(f(de,te)))?be=I(le[1].substr(1),de,!0):(le=C.exec(f(de,te)))?be=I(le[1],de,!1):be=L(de),s.set(re,be),l(be,K)}function l(K,te){if(typeof te=="string")return K;const de=function(re,be){return(0,S.isEqualOrParent)(re,te.base,!A.isLinux)?K(re.substr(te.base.length+1),be):null};return de.allBasenames=K.allBasenames,de.allPaths=K.allPaths,de.basenames=K.basenames,de.patterns=K.patterns,de}function f(K,te){return te.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function r(K,te){return function(de,re){return typeof de=="string"&&de.endsWith(K)?te:null}}function h(K,te){const de=`/${K}`,re=`\\${K}`,be=function(fe,Q){return typeof fe!="string"?null:Q?Q===K?te:null:fe===K||fe.endsWith(de)||fe.endsWith(re)?te:null},le=[K];return be.basenames=le,be.patterns=[te],be.allBasenames=le,be}function v(K,te){const de=x(K.slice(1,-1).split(",").map(Q=>d(Q,te)).filter(Q=>Q!==n),K),re=de.length;if(!re)return n;if(re===1)return de[0];const be=function(Q,pe){for(let Se=0,Fe=de.length;Se<Fe;Se++)if(de[Se](Q,pe))return K;return null},le=de.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=de.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function I(K,te,de){const re=_.sep===_.posix.sep,be=re?K:K.replace(g,_.sep),le=_.sep+be,fe=_.posix.sep+K;let Q;return de?Q=function(pe,Se){return typeof pe=="string"&&(pe===be||pe.endsWith(le)||!re&&(pe===K||pe.endsWith(fe)))?te:null}:Q=function(pe,Se){return typeof pe=="string"&&(pe===be||!re&&pe===K)?te:null},Q.allPaths=[(de?"*/":"./")+K],Q}function L(K){try{const te=new RegExp(`^${t(K)}$`);return function(de){return te.lastIndex=0,typeof de=="string"&&te.test(de)?K:null}}catch{return n}}function j(K,te,de){return!K||typeof te!="string"?!1:W(K)(te,void 0,de)}e.match=j;function W(K,te={}){if(!K)return c;if(typeof K=="string"||H(K)){const de=d(K,te);if(de===n)return c;const re=function(be,le){return!!de(be,le)};return de.allBasenames&&(re.allBasenames=de.allBasenames),de.allPaths&&(re.allPaths=de.allPaths),re}return R(K,te)}e.parse=W;function H(K){const te=K;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.isRelativePattern=H;function P(K){return K.allBasenames||[]}e.getBasenameTerms=P;function M(K){return K.allPaths||[]}e.getPathTerms=M;function R(K,te){const de=x(Object.getOwnPropertyNames(K).map(Q=>B(Q,K[Q],te)).filter(Q=>Q!==n)),re=de.length;if(!re)return n;if(!de.some(Q=>!!Q.requiresSiblings)){if(re===1)return de[0];const Q=function(Fe,Ue){let Xe;for(let ke=0,ye=de.length;ke<ye;ke++){const Ie=de[ke](Fe,Ue);if(typeof Ie=="string")return Ie;(0,D.isThenable)(Ie)&&(Xe||(Xe=[]),Xe.push(Ie))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},pe=de.find(Fe=>!!Fe.allBasenames);pe&&(Q.allBasenames=pe.allBasenames);const Se=de.reduce((Fe,Ue)=>Ue.allPaths?Fe.concat(Ue.allPaths):Fe,[]);return Se.length&&(Q.allPaths=Se),Q}const be=function(Q,pe,Se){let Fe,Ue;for(let Xe=0,ke=de.length;Xe<ke;Xe++){const ye=de[Xe];ye.requiresSiblings&&Se&&(pe||(pe=(0,_.basename)(Q)),Fe||(Fe=pe.substr(0,pe.length-(0,_.extname)(Q).length)));const Ie=ye(Q,pe,Fe,Se);if(typeof Ie=="string")return Ie;(0,D.isThenable)(Ie)&&(Ue||(Ue=[]),Ue.push(Ie))}return Ue?(async()=>{for(const Xe of Ue){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},le=de.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=de.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function B(K,te,de){if(te===!1)return n;const re=d(K,de);if(re===n)return n;if(typeof te=="boolean")return re;if(te){const be=te.when;if(typeof be=="string"){const le=(fe,Q,pe,Se)=>{if(!Se||!re(fe,Q))return null;const Fe=be.replace("$(basename)",pe),Ue=Se(Fe);return(0,D.isThenable)(Ue)?Ue.then(Xe=>Xe?K:null):Ue?K:null};return le.requiresSiblings=!0,le}}return re}function x(K,te){const de=K.filter(Q=>!!Q.basenames);if(de.length<2)return K;const re=de.reduce((Q,pe)=>{const Se=pe.basenames;return Se?Q.concat(Se):Q},[]);let be;if(te){be=[];for(let Q=0,pe=re.length;Q<pe;Q++)be.push(te)}else be=de.reduce((Q,pe)=>{const Se=pe.patterns;return Se?Q.concat(Se):Q},[]);const le=function(Q,pe){if(typeof Q!="string")return null;if(!pe){let Fe;for(Fe=Q.length;Fe>0;Fe--){const Ue=Q.charCodeAt(Fe-1);if(Ue===47||Ue===92)break}pe=Q.substr(Fe)}const Se=re.indexOf(pe);return Se!==-1?be[Se]:null};le.basenames=re,le.patterns=be,le.allBasenames=re;const fe=K.filter(Q=>!Q.basenames);return fe.push(le),fe}function U(K,te){return(0,i.equals)(K,te,(de,re)=>typeof de=="string"&&typeof re=="string"?de===re:typeof de!="string"&&typeof re!="string"?de.base===re.base&&de.pattern===re.pattern:!1)}e.patternsEquals=U}),define(De[81],Ce([1,0,12,117,22,10,2]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(a="",p=!1){if(this.value=a,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(a,p=0){return this.value+=g(this.supportThemeIcons?(0,D.escapeIcons)(a):a).replace(/([ \t]+)/g,(b,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(a,p,b){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(a),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(a,p){const b=new RegExp((0,F.escapeRegExpCharacters)(p),"g");return a.replace(b,(u,C)=>a.charAt(C-1)!=="\\"?`\\${u}`:u)}}e.MarkdownString=y;function k(o){return O(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function O(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(o,a){return o===a?!0:!o||!a?!1:o.value===a.value&&o.isTrusted===a.isTrusted&&o.supportThemeIcons===a.supportThemeIcons&&o.supportHtml===a.supportHtml&&(o.baseUri===a.baseUri||!!o.baseUri&&!!a.baseUri&&(0,S.isEqual)(_.URI.from(o.baseUri),_.URI.from(a.baseUri)))}e.markdownStringEqual=w;function g(o){return o.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function E(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function m(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function t(o){const a=[],p=o.split("|").map(u=>u.trim());o=p[0];const b=p[1];if(b){const u=/height=(\d+)/.exec(b),C=/width=(\d+)/.exec(b),s=u?u[1]:"",c=C?C[1]:"",n=isFinite(parseInt(c)),d=isFinite(parseInt(s));n&&a.push(`width="${c}"`),d&&a.push(`height="${s}"`)}return{href:o,dimensions:a}}e.parseHrefAndDimensions=t}),define(De[82],Ce([1,0,18,39,19,20,22,10]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(n,d){const{os:l,tildify:f,relative:r}=d;if(r){const I=k(n,r,l);if(typeof I=="string")return I}let h=n.fsPath;if(l===1&&!F.isWindows?h=h.replace(/\//g,"\\"):l!==1&&F.isWindows&&(h=h.replace(/\\/g,"/")),l!==1&&f?.userHome){const I=f.userHome.fsPath;let L;n.scheme!==f.userHome.scheme&&n.path.startsWith(S.posix.sep)?L=f.userHome.with({path:n.path}).fsPath:L=n.fsPath,h=g(L,I,l)}return(l===1?S.win32:S.posix).normalize(O(h,l===1))}e.getPathLabel=y;function k(n,d,l){const f=l===1?S.win32:S.posix,r=l===3?_.extUri:_.extUriIgnorePathCase,h=d.getWorkspace(),v=(0,i.firstOrDefault)(h.folders);if(!v)return;n.scheme!==v.uri.scheme&&n.path.startsWith(S.posix.sep)&&(n=v.uri.with({path:n.path}));const I=d.getWorkspaceFolder(n);if(!I)return;let L;if(r.isEqual(I.uri,n)?L="":L=r.relativePath(I.uri,n)??"",L&&(L=f.normalize(L)),h.folders.length>1&&!d.noPrefix){const j=I.name?I.name:r.basenameOrAuthority(I.uri);L=L?`${j} \u2022 ${L}`:j}return L}function O(n,d=F.isWindows){return(0,D.hasDriveLetter)(n,d)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=O;let w=Object.create(null);function g(n,d,l=F.OS){if(l===1||!n||!d)return n;let f=w.original===d?w.normalized:void 0;f||(f=d,F.isWindows&&(f=(0,D.toSlashes)(f)),f=`${(0,A.rtrim)(f,S.posix.sep)}${S.posix.sep}`,w={original:d,normalized:f});let r=n;return F.isWindows&&(r=(0,D.toSlashes)(r)),(l===3?r.startsWith(f):(0,A.startsWithIgnoreCase)(r,f))?`~/${r.substr(f.length)}`:n}e.tildify=g;function E(n,d){return n.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=E;const m="\u2026",t="\\\\",o="~";function a(n,d=S.sep){const l=new Array(n.length);let f=!1;for(let r=0;r<n.length;r++){const h=n[r];if(h===""){l[r]=`.${d}`;continue}if(!h){l[r]=h;continue}f=!0;let v="",I=h;I.indexOf(t)===0?(v=I.substr(0,I.indexOf(t)+t.length),I=I.substr(I.indexOf(t)+t.length)):I.indexOf(d)===0?(v=I.substr(0,I.indexOf(d)+d.length),I=I.substr(I.indexOf(d)+d.length)):I.indexOf(o)===0&&(v=I.substr(0,I.indexOf(o)+o.length),I=I.substr(I.indexOf(o)+o.length));const L=I.split(d);for(let j=1;f&&j<=L.length;j++)for(let W=L.length-j;f&&W>=0;W--){f=!1;let H=L.slice(W,W+j).join(d);for(let P=0;!f&&P<n.length;P++)if(P!==r&&n[P]&&n[P].indexOf(H)>-1){const M=W+j===L.length,R=W>0&&n[P].indexOf(d)>-1?d+H:H,B=n[P].endsWith(R);f=!M||B}if(!f){let P="";(L[0].endsWith(":")||v!=="")&&(W===1&&(W=0,j++,H=L[0]+d+H),W>0&&(P=L[0]+d),P=v+P),W>0&&(P=P+m+d),P=P+H,W+j<L.length&&(P=P+d+m),l[r]=P}}f&&(l[r]=h)}return l}e.shorten=a;var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(n,d=Object.create(null)){const l=[];let f=!1,r="";for(const h of n)if(h==="$"||f&&h==="{")r&&l.push({value:r,type:p.TEXT}),r="",f=!0;else if(h==="}"&&f){const v=d[r];if(typeof v=="string")v.length&&l.push({value:v,type:p.VARIABLE});else if(v){const I=l[l.length-1];(!I||I.type!==p.SEPARATOR)&&l.push({value:v.label,type:p.SEPARATOR})}r="",f=!1}else r+=h;return r&&!f&&l.push({value:r,type:p.TEXT}),l.filter((h,v)=>{if(h.type===p.SEPARATOR){const I=l[v-1],L=l[v+1];return[I,L].every(j=>j&&(j.type===p.VARIABLE||j.type===p.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=b;function u(n,d){return F.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function C(n,d){return F.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,""):F.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=C;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function c(n){const d=n.indexOf("/")!==-1?S.posix:S.win32,l=d.basename(n),f=d.dirname(n);return l.length?{name:l,parentPath:f}:{name:f,parentPath:""}}e.splitName=c}),define(De[120],Ce([1,0,2]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(O){return O.toJSON()}class S{constructor(w){this._uriTransformer=w}transformIncoming(w){const g=this._uriTransformer.transformIncoming(w);return g===w?w:D(i.URI.from(g))}transformOutgoing(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:D(i.URI.from(g))}transformOutgoingURI(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:i.URI.from(g)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function F(O,w,g){if(!O||g>200)return null;if(typeof O=="object"){if(O instanceof i.URI)return w.transformOutgoing(O);for(const E in O)if(Object.hasOwnProperty.call(O,E)){const m=F(O[E],w,g+1);m!==null&&(O[E]=m)}}return null}function _(O,w){const g=F(O,w,0);return g===null?O:g}e.transformOutgoingURIs=_;function A(O,w,g,E){if(!O||E>200)return null;if(typeof O=="object"){if(O.$mid===1)return g?i.URI.revive(w.transformIncoming(O)):w.transformIncoming(O);for(const m in O)if(Object.hasOwnProperty.call(O,m)){const t=A(O[m],w,g,E+1);t!==null&&(O[m]=t)}}return null}function y(O,w){const g=A(O,w,!1,0);return g===null?O:g}e.transformIncomingURIs=y;function k(O,w){const g=A(O,w,!0,0);return g===null?O:g}e.transformAndReviveIncomingURIs=k}),define(De[121],Ce([1,0,34,19]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(F,_,A,y,k,O){if(Array.isArray(F)){let w=0;for(const g of F){const E=S(g,_,A,y,k,O);if(E===10)return E;E>w&&(w=E)}return w}else{if(typeof F=="string")return y?F==="*"?5:F===A?10:0:0;if(F){const{language:w,pattern:g,scheme:E,hasAccessToAllModels:m,notebookType:t}=F;if(!y&&!m)return 0;t&&k&&(_=k);let o=0;if(E)if(E===_.scheme)o=10;else if(E==="*")o=5;else return 0;if(w)if(w===A)o=10;else if(w==="*")o=Math.max(o,5);else return 0;if(t)if(t===O)o=10;else if(t==="*"&&O!==void 0)o=Math.max(o,5);else return 0;if(g){let a;if(typeof g=="string"?a=g:a={...g,base:(0,D.normalize)(g.base)},a===_.fsPath||(0,i.match)(a,_.fsPath))o=10;else return 0}return o}else return 0}}e.score=S}),define(De[83],Ce([1,0,23,20]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(S||(S={}));function F(w){for(let g=0,E=w.length;g<E;g+=4){const m=w[g+0],t=w[g+1],o=w[g+2],a=w[g+3];w[g+0]=a,w[g+1]=o,w[g+2]=t,w[g+3]=m}}function _(w){const g=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return D.isLittleEndian()||F(g),i.VSBuffer.wrap(g)}function A(w){const g=w.buffer;if(D.isLittleEndian()||F(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const E=new Uint8Array(g.byteLength);return E.set(g),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function y(w){const g=new Uint32Array(k(w));let E=0;if(g[E++]=w.id,w.type==="full")g[E++]=1,g[E++]=w.data.length,g.set(w.data,E),E+=w.data.length;else{g[E++]=2,g[E++]=w.deltas.length;for(const m of w.deltas)g[E++]=m.start,g[E++]=m.deleteCount,m.data?(g[E++]=m.data.length,g.set(m.data,E),E+=m.data.length):g[E++]=0}return _(g)}e.encodeSemanticTokensDto=y;function k(w){let g=0;if(g+=1+1,w.type==="full")g+=1+w.data.length;else{g+=1,g+=(1+1+1)*w.deltas.length;for(const E of w.deltas)E.data&&(g+=E.data.length)}return g}function O(w){const g=A(w);let E=0;const m=g[E++];if(g[E++]===1){const p=g[E++],b=g.subarray(E,E+p);return E+=p,{id:m,type:"full",data:b}}const o=g[E++],a=[];for(let p=0;p<o;p++){const b=g[E++],u=g[E++],C=g[E++];let s;C>0&&(s=g.subarray(E,E+C),E+=C),a[p]={start:b,deleteCount:u,data:s}}return{id:m,type:"delta",deltas:a}}e.decodeSemanticTokensDto=O}),define(De[122],Ce([16,17]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(De[123],Ce([1,0,122,20,124,18,24,110]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(Y,me,Be,je){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=je}applyUpdate(Y,me){return E(Y,me)}compute(Y,me,Be){return Be}}class g{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=g;function E(X,Y){if(typeof X!="object"||typeof Y!="object"||!X||!Y)return new g(Y,X!==Y);if(Array.isArray(X)||Array.isArray(Y)){const Be=Array.isArray(X)&&Array.isArray(Y)&&F.equals(X,Y);return new g(Y,!Be)}let me=!1;for(const Be in Y)if(Y.hasOwnProperty(Be)){const je=E(X[Be],Y[Be]);je.didChange&&(X[Be]=je.newValue,me=!0)}return new g(X,me)}class m{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return E(Y,me)}validate(Y){return this.defaultValue}}class t{constructor(Y,me,Be,je){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=je}applyUpdate(Y,me){return E(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,Be){return Be}}function o(X,Y){return typeof X>"u"?Y:X==="false"?!1:Boolean(X)}e.boolean=o;class a extends t{constructor(Y,me,Be,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Be),super(Y,me,Be,je)}validate(Y){return o(Y,this.defaultValue)}}function p(X,Y,me,Be){if(typeof X>"u")return Y;let je=parseInt(X,10);return isNaN(je)?Y:(je=Math.max(me,je),je=Math.min(Be,je),je|0)}e.clampedInt=p;class b extends t{static clampedInt(Y,me,Be,je){return p(Y,me,Be,je)}constructor(Y,me,Be,je,Ze,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Be,Ke.minimum=je,Ke.maximum=Ze),super(Y,me,Be,Ke),this.minimum=je,this.maximum=Ze}validate(Y){return b.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class u extends t{static clamp(Y,me,Be){return Y<me?me:Y>Be?Be:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const Be=parseFloat(Y);return isNaN(Be)?me:Be}constructor(Y,me,Be,je,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Be),super(Y,me,Be,Ze),this.validationFn=je}validate(Y){return this.validationFn(u.float(Y,this.defaultValue))}}class C extends t{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Be,je=void 0){typeof je<"u"&&(je.type="string",je.default=Be),super(Y,me,Be,je)}validate(Y){return C.string(Y,this.defaultValue)}}function s(X,Y,me){return typeof X!="string"||me.indexOf(X)===-1?Y:X}e.stringSet=s;class c extends t{constructor(Y,me,Be,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=je,Ze.default=Be),super(Y,me,Be,Ze),this._allowedValues=je}validate(Y){return s(Y,this.defaultValue,this._allowedValues)}}class n extends w{constructor(Y,me,Be,je,Ze,Ke,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=Ze,Ve.default=je),super(Y,me,Be,Ve),this._allowedValues=Ze,this._convert=Ke}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function d(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Be){return Be===0?Y.accessibilitySupport:Be}}class f extends w{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function I(X){switch(X){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function L(X){switch(X){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class j extends m{constructor(){super(130)}compute(Y,me,Be){const je=["monaco-editor"];return me.get(34)&&je.push(me.get(34)),Y.extraEditorClassName&&je.push(Y.extraEditorClassName),me.get(67)==="default"?je.push("mouse-default"):me.get(67)==="copy"&&je.push("mouse-copy"),me.get(101)&&je.push("showUnused"),me.get(128)&&je.push("showDeprecated"),je.join(" ")}}class W extends a{constructor(){super(33,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Y,me,Be){return Be&&Y.emptySelectionClipboard}}class H extends w{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:i.localize(16,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:i.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":s(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":s(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class P extends w{constructor(){super(46,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?P.OFF:Y==="true"?P.ON:Y:Boolean(Y)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class M extends m{constructor(){super(45)}compute(Y,me,Be){return Y.fontInfo}}class R extends t{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(22,null)})}validate(Y){const me=u.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(me,6,100)}compute(Y,me,Be){return Y.fontInfo.fontSize}}class B extends w{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:i.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(b.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class x extends w{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[i.localize(25,null),i.localize(26,null),i.localize(27,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:i.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:i.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:i.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Be,description:i.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Be,description:i.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Be,description:i.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Be,description:i.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Be,description:i.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:s(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??s(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??s(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??s(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??s(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??s(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:C.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:C.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:C.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:C.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:C.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends w{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:i.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:i.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:i.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:i.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:b.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),above:o(me.above,this.defaultValue.above)}}}var K;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class te extends m{constructor(){super(133)}compute(Y,me,Be){return te.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Be=Y.scrollBeyondLastLine?me-1:0,je=(Y.viewLineCount+Be)/(Y.pixelRatio*Y.height),Ze=Math.floor(Y.viewLineCount/je);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Be,desiredRatio:je,minimapLineCount:Ze}}static _computeMinimapLayout(Y,me){const Be=Y.outerWidth,je=Y.outerHeight,Ze=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ke=me.stableMinimapLayoutInput,Ve=Ke&&Y.outerHeight===Ke.outerHeight&&Y.lineHeight===Ke.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ke.pixelRatio&&Y.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Y.minimap.enabled===Ke.minimap.enabled&&Y.minimap.side===Ke.minimap.side&&Y.minimap.size===Ke.minimap.size&&Y.minimap.showSlider===Ke.minimap.showSlider&&Y.minimap.renderCharacters===Ke.minimap.renderCharacters&&Y.minimap.maxColumn===Ke.minimap.maxColumn&&Y.minimap.scale===Ke.minimap.scale&&Y.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Y.isViewportWrapping===Ke.isViewportWrapping,nt=Y.lineHeight,st=Y.typicalHalfwidthCharacterWidth,dt=Y.scrollBeyondLastLine,St=Y.minimap.renderCharacters;let tt=Ze>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const ut=Y.minimap.maxColumn,Rt=Y.minimap.size,xt=Y.minimap.side,kt=Y.verticalScrollbarWidth,mt=Y.viewLineCount,_t=Y.remainingWidth,Lt=Y.isViewportWrapping,Ut=St?2:3;let qe=Math.floor(Ze*je);const Ot=qe/Ze;let It=!1,Ft=!1,gt=Ut*tt,_e=tt/Ze,Te=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:it,extraLinesBeyondLastLine:at,desiredRatio:yt,minimapLineCount:vt}=te.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:dt,height:je,lineHeight:nt,pixelRatio:Ze});if(mt/vt>1)It=!0,Ft=!0,tt=1,gt=1,_e=tt/Ze;else{let Et=!1,Pt=tt+1;if(Rt==="fit"){const ft=Math.ceil((mt+at)*gt);Lt&&Ve&&_t<=me.stableFitRemainingWidth?(Et=!0,Pt=me.stableFitMaxMinimapScale):Et=ft>qe}if(Rt==="fill"||Et){It=!0;const ft=tt;gt=Math.min(nt*Ze,Math.max(1,Math.floor(1/yt))),Lt&&Ve&&_t<=me.stableFitRemainingWidth&&(Pt=me.stableFitMaxMinimapScale),tt=Math.min(Pt,Math.max(1,Math.floor(gt/Ut))),tt>ft&&(Te=Math.min(2,tt/ft)),_e=tt/Ze/Te,qe=Math.ceil(Math.max(it,mt+at)*gt),Lt?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=_t,me.stableFitMaxMinimapScale=tt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ge=Math.floor(ut*_e),G=Math.min(ge,Math.max(0,Math.floor((_t-kt-2)*_e/(st+_e)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*G);const Me=Ae/Ze;Ae=Math.floor(Ae*Te);const et=St?1:2,$e=xt==="left"?0:Be-G-kt;return{renderMinimap:et,minimapLeft:$e,minimapWidth:G,minimapHeightIsEditorHeight:It,minimapIsSampling:Ft,minimapScale:tt,minimapLineHeight:gt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ot}}static computeLayout(Y,me){const Be=me.outerWidth|0,je=me.outerHeight|0,Ze=me.lineHeight|0,Ke=me.lineNumbersDigitCount|0,Ve=me.typicalHalfwidthCharacterWidth,nt=me.maxDigitWidth,st=me.pixelRatio,dt=me.viewLineCount,St=Y.get(125),tt=St==="inherit"?Y.get(124):St,ut=tt==="inherit"?Y.get(120):tt,Rt=Y.get(123),xt=Y.get(2),kt=me.isDominatedByLongLines,mt=Y.get(51),_t=Y.get(61).renderType!==0,Lt=Y.get(62),Ut=Y.get(95),qe=Y.get(66),Ot=Y.get(93),It=Ot.verticalScrollbarSize,Ft=Ot.verticalHasArrows,gt=Ot.arrowSize,_e=Ot.horizontalScrollbarSize,Te=Y.get(59),ge=Y.get(38),G=Y.get(100)!=="never";let Ae;if(typeof Te=="string"&&/^\d+(\.\d+)?ch$/.test(Te)){const Bt=parseFloat(Te.substr(0,Te.length-2));Ae=b.clampedInt(Bt*Ve,0,0,1e3)}else Ae=b.clampedInt(Te,0,0,1e3);ge&&G&&(Ae+=16);let Me=0;if(_t){const Bt=Math.max(Ke,Lt);Me=Math.round(Bt*nt)}let et=0;mt&&(et=Ze);let $e=0,it=$e+et,at=it+Me,yt=at+Ae;const vt=Be-et-Me-Ae;let Dt=!1,Et=!1,Pt=-1;xt!==2&&(tt==="inherit"&&kt?(Dt=!0,Et=!0):ut==="on"||ut==="bounded"?Et=!0:ut==="wordWrapColumn"&&(Pt=Rt));const ft=te._computeMinimapLayout({outerWidth:Be,outerHeight:je,lineHeight:Ze,typicalHalfwidthCharacterWidth:Ve,pixelRatio:st,scrollBeyondLastLine:Ut,minimap:qe,verticalScrollbarWidth:It,viewLineCount:dt,remainingWidth:vt,isViewportWrapping:Et},me.memory||new O);ft.renderMinimap!==0&&ft.minimapLeft===0&&($e+=ft.minimapWidth,it+=ft.minimapWidth,at+=ft.minimapWidth,yt+=ft.minimapWidth);const ei=vt-ft.minimapWidth,ti=Math.max(1,Math.floor((ei-It-2)/Ve)),bt=Ft?gt:0;return Et&&(Pt=Math.max(1,ti),ut==="bounded"&&(Pt=Math.min(Pt,Rt))),{width:Be,height:je,glyphMarginLeft:$e,glyphMarginWidth:et,lineNumbersLeft:it,lineNumbersWidth:Me,decorationsLeft:at,decorationsWidth:Ae,contentLeft:yt,contentWidth:ei,minimap:ft,viewportColumn:ti,isWordWrapMinified:Dt,isViewportWrapping:Et,wrappingColumn:Pt,verticalScrollbarWidth:It,horizontalScrollbarHeight:_e,overviewRuler:{top:bt,width:It,height:je-2*bt,right:0}}}}e.EditorLayoutInfoComputer=te;class de extends w{constructor(){const Y={enabled:!0};super(58,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:i.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:o(Y.enabled,this.defaultValue.enabled)}}}class re extends w{constructor(){const Y={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:i.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:i.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class be extends w{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:i.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(47,null),i.localize(48,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(49,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:i.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:i.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:i.localize(53,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:s(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:C.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class le extends u{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>u.clamp(Y,0,150),{markdownDescription:i.localize(54,null)})}compute(Y,me,Be){return Y.fontInfo.lineHeight}}class fe extends w{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:i.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:i.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(57,null),i.localize(58,null),i.localize(59,null)],default:Y.size,description:i.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:i.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:i.localize(62,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:i.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:i.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:s(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(me.side,this.defaultValue.side,["right","left"]),showSlider:s(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(me.scale,1,1,3),maxColumn:b.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(X){return X==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends w{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(67,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:b.clampedInt(me.top,0,0,1e3),bottom:b.clampedInt(me.bottom,0,0,1e3)}}}class Se extends w{constructor(){const Y={enabled:!0,cycle:!1};super(77,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:i.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:i.localize(69,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class Fe extends m{constructor(){super(131)}compute(Y,me,Be){return Y.pixelRatio}}class Ue extends w{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(70,null),i.localize(71,null),i.localize(72,null)]}];super(80,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:i.localize(73,null)},comments:{anyOf:me,default:Y.comments,description:i.localize(74,null)},other:{anyOf:me,default:Y.other,description:i.localize(75,null)}},default:Y,markdownDescription:i.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const st=Y?"on":"off";return{comments:st,strings:st,other:st}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Be,strings:je}=Y,Ze=["on","inline","off"];let Ke,Ve,nt;return typeof me=="boolean"?Ke=me?"on":"off":Ke=s(me,this.defaultValue.other,Ze),typeof Be=="boolean"?Ve=Be?"on":"off":Ve=s(Be,this.defaultValue.comments,Ze),typeof je=="boolean"?nt=je?"on":"off":nt=s(je,this.defaultValue.strings,Ze),{other:Ke,comments:Ve,strings:nt}}}var Xe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends w{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(77,null),i.localize(78,null),i.localize(79,null),i.localize(80,null)],default:"on",description:i.localize(81,null)})}validate(Y){let me=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,Be=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Be}}}function ye(X){const Y=X.get(88);return Y==="editable"?X.get(82):Y!=="on"}e.filterValidationDecorations=ye;class Ie extends w{constructor(){const Y=[],me={type:"number",description:i.localize(82,null)};super(92,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:i.localize(83,null),format:"color-hex"}}}]},default:Y,description:i.localize(84,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const Be of Y)if(typeof Be=="number")me.push({column:b.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const je=Be;me.push({column:b.clampedInt(je.column,0,0,1e4),color:je.color})}return me.sort((Be,je)=>Be.column-je.column),me}return this.defaultValue}}function ae(X,Y){if(typeof X!="string")return Y;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends w{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(85,null),i.localize(86,null),i.localize(87,null)],default:"auto",description:i.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(89,null),i.localize(90,null),i.localize(91,null)],default:"auto",description:i.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:i.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:i.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:i.localize(95,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Be=b.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=b.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(me.vertical,this.defaultValue.vertical),horizontal:ae(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:b.clampedInt(me.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:je,verticalSliderSize:b.clampedInt(me.verticalSliderSize,je,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends w{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:i.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:i.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:i.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:i.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:i.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:i.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:i.localize(102,null)}})}applyUpdate(Y,me){let Be=!1;me.allowedCharacters&&Y&&(_.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Be=!0)),me.allowedLocales&&Y&&(_.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Be=!0));const je=super.applyUpdate(Y,me);return Be?new g(je.newValue,!0):je}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:V(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:V(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:V(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Be={};for(const[je,Ze]of Object.entries(Y))Ze===!0&&(Be[je]=!0);return Be}}class Z extends w{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:i.localize(103,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:s(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class T extends w{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:i.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:i.localize(105,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class z extends w{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(106,null),i.localize(107,null),i.localize(108,null)],default:Y.bracketPairs,description:i.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(110,null),i.localize(111,null),i.localize(112,null)],default:Y.bracketPairsHorizontal,description:i.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:i.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:i.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:Y.highlightActiveIndentation,description:i.localize(119,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:V(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:V(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:V(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function V(X,Y,me){const Be=me.indexOf(X);return Be===-1?Y:me[Be]}class q extends w{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(120,null),i.localize(121,null)],default:Y.insertMode,description:i.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:i.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:i.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:i.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:i.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:i.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:i.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:i.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:i.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:s(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:s(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class oe extends w{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(163,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends m{constructor(){super(132)}compute(Y,me,Be){return me.get(82)?!0:Y.tabFocusMode}}var J;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(J=e.WrappingIndent||(e.WrappingIndent={}));function Ee(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends m{constructor(){super(134)}compute(Y,me,Be){const je=me.get(133);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class Ne extends w{constructor(){const Y={enabled:!0};super(32,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:i.localize(164,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:o(Y.enabled,this.defaultValue.enabled)}}}const ze="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?Je:D.isLinux?Ge:ze,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Pe(X){return e.editorOptionsRegistry[X.id]=X,X}var rt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Pe(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(165,null)})),acceptSuggestionOnEnter:Pe(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(166,null),""],markdownDescription:i.localize(167,null)})),accessibilitySupport:Pe(new l),accessibilityPageSize:Pe(new b(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(168,null),tags:["accessibility"]})),ariaLabel:Pe(new C(4,"ariaLabel",i.localize(169,null))),autoClosingBrackets:Pe(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(170,null),i.localize(171,null),""],description:i.localize(172,null)})),autoClosingDelete:Pe(new c(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(173,null),""],description:i.localize(174,null)})),autoClosingOvertype:Pe(new c(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(175,null),""],description:i.localize(176,null)})),autoClosingQuotes:Pe(new c(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(177,null),i.localize(178,null),""],description:i.localize(179,null)})),autoIndent:Pe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[i.localize(180,null),i.localize(181,null),i.localize(182,null),i.localize(183,null),i.localize(184,null)],description:i.localize(185,null)})),automaticLayout:Pe(new a(10,"automaticLayout",!1)),autoSurround:Pe(new c(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(186,null),i.localize(187,null),i.localize(188,null),""],description:i.localize(189,null)})),bracketPairColorization:Pe(new T),bracketPairGuides:Pe(new z),stickyTabStops:Pe(new a(106,"stickyTabStops",!1,{description:i.localize(190,null)})),codeLens:Pe(new a(14,"codeLens",!0,{description:i.localize(191,null)})),codeLensFontFamily:Pe(new C(15,"codeLensFontFamily","",{description:i.localize(192,null)})),codeLensFontSize:Pe(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(193,null)})),colorDecorators:Pe(new a(17,"colorDecorators",!0,{description:i.localize(194,null)})),columnSelection:Pe(new a(18,"columnSelection",!1,{description:i.localize(195,null)})),comments:Pe(new f),contextmenu:Pe(new a(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Pe(new a(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(196,null)})),cursorBlinking:Pe(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:i.localize(197,null)})),cursorSmoothCaretAnimation:Pe(new a(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(198,null)})),cursorStyle:Pe(new n(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:i.localize(199,null)})),cursorSurroundingLines:Pe(new b(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(200,null)})),cursorSurroundingLinesStyle:Pe(new c(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(201,null),i.localize(202,null)],description:i.localize(203,null)})),cursorWidth:Pe(new b(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(204,null)})),disableLayerHinting:Pe(new a(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Pe(new a(29,"disableMonospaceOptimizations",!1)),domReadOnly:Pe(new a(30,"domReadOnly",!1)),dragAndDrop:Pe(new a(31,"dragAndDrop",!0,{description:i.localize(205,null)})),emptySelectionClipboard:Pe(new W),dropIntoEditor:Pe(new Ne),stickyScroll:Pe(new re),extraEditorClassName:Pe(new C(34,"extraEditorClassName","")),fastScrollSensitivity:Pe(new u(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:i.localize(206,null)})),find:Pe(new H),fixedOverflowWidgets:Pe(new a(37,"fixedOverflowWidgets",!1)),folding:Pe(new a(38,"folding",!0,{description:i.localize(207,null)})),foldingStrategy:Pe(new c(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(208,null),i.localize(209,null)],description:i.localize(210,null)})),foldingHighlight:Pe(new a(40,"foldingHighlight",!0,{description:i.localize(211,null)})),foldingImportsByDefault:Pe(new a(41,"foldingImportsByDefault",!1,{description:i.localize(212,null)})),foldingMaximumRegions:Pe(new b(42,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(213,null)})),unfoldOnClickAfterEndOfLine:Pe(new a(43,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(214,null)})),fontFamily:Pe(new C(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(215,null)})),fontInfo:Pe(new M),fontLigatures2:Pe(new P),fontSize:Pe(new R),fontWeight:Pe(new B),formatOnPaste:Pe(new a(49,"formatOnPaste",!1,{description:i.localize(216,null)})),formatOnType:Pe(new a(50,"formatOnType",!1,{description:i.localize(217,null)})),glyphMargin:Pe(new a(51,"glyphMargin",!0,{description:i.localize(218,null)})),gotoLocation:Pe(new x),hideCursorInOverviewRuler:Pe(new a(53,"hideCursorInOverviewRuler",!1,{description:i.localize(219,null)})),hover:Pe(new U),inDiffEditor:Pe(new a(55,"inDiffEditor",!1)),letterSpacing:Pe(new u(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:i.localize(220,null)})),lightbulb:Pe(new de),lineDecorationsWidth:Pe(new t(59,"lineDecorationsWidth",10)),lineHeight:Pe(new le),lineNumbers:Pe(new ke),lineNumbersMinChars:Pe(new b(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Pe(new a(63,"linkedEditing",!1,{description:i.localize(221,null)})),links:Pe(new a(64,"links",!0,{description:i.localize(222,null)})),matchBrackets:Pe(new c(65,"matchBrackets","always",["always","near","never"],{description:i.localize(223,null)})),minimap:Pe(new fe),mouseStyle:Pe(new c(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Pe(new u(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:i.localize(224,null)})),mouseWheelZoom:Pe(new a(69,"mouseWheelZoom",!1,{markdownDescription:i.localize(225,null)})),multiCursorMergeOverlapping:Pe(new a(70,"multiCursorMergeOverlapping",!0,{description:i.localize(226,null)})),multiCursorModifier:Pe(new n(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[i.localize(227,null),i.localize(228,null)],markdownDescription:i.localize(229,null)})),multiCursorPaste:Pe(new c(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(230,null),i.localize(231,null)],markdownDescription:i.localize(232,null)})),occurrencesHighlight:Pe(new a(73,"occurrencesHighlight",!0,{description:i.localize(233,null)})),overviewRulerBorder:Pe(new a(74,"overviewRulerBorder",!0,{description:i.localize(234,null)})),overviewRulerLanes:Pe(new b(75,"overviewRulerLanes",3,0,3)),padding:Pe(new pe),parameterHints:Pe(new Se),peekWidgetDefaultFocus:Pe(new c(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(235,null),i.localize(236,null)],description:i.localize(237,null)})),definitionLinkOpensInPeek:Pe(new a(79,"definitionLinkOpensInPeek",!1,{description:i.localize(238,null)})),quickSuggestions:Pe(new Ue),quickSuggestionsDelay:Pe(new b(81,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(239,null)})),readOnly:Pe(new a(82,"readOnly",!1)),renameOnType:Pe(new a(83,"renameOnType",!1,{description:i.localize(240,null),markdownDeprecationMessage:i.localize(241,null)})),renderControlCharacters:Pe(new a(84,"renderControlCharacters",!0,{description:i.localize(242,null),restricted:!0})),renderFinalNewline:Pe(new a(85,"renderFinalNewline",!0,{description:i.localize(243,null)})),renderLineHighlight:Pe(new c(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(244,null)],description:i.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Pe(new a(87,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(246,null)})),renderValidationDecorations:Pe(new c(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Pe(new c(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(247,null),i.localize(248,null),i.localize(249,null),""],description:i.localize(250,null)})),revealHorizontalRightPadding:Pe(new b(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Pe(new a(91,"roundedSelection",!0,{description:i.localize(251,null)})),rulers:Pe(new Ie),scrollbar:Pe(new ue),scrollBeyondLastColumn:Pe(new b(94,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(252,null)})),scrollBeyondLastLine:Pe(new a(95,"scrollBeyondLastLine",!0,{description:i.localize(253,null)})),scrollPredominantAxis:Pe(new a(96,"scrollPredominantAxis",!0,{description:i.localize(254,null)})),selectionClipboard:Pe(new a(97,"selectionClipboard",!0,{description:i.localize(255,null),included:D.isLinux})),selectionHighlight:Pe(new a(98,"selectionHighlight",!0,{description:i.localize(256,null)})),selectOnLineNumbers:Pe(new a(99,"selectOnLineNumbers",!0)),showFoldingControls:Pe(new c(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(257,null),i.localize(258,null),i.localize(259,null)],description:i.localize(260,null)})),showUnused:Pe(new a(101,"showUnused",!0,{description:i.localize(261,null)})),showDeprecated:Pe(new a(128,"showDeprecated",!0,{description:i.localize(262,null)})),inlayHints:Pe(new be),snippetSuggestions:Pe(new c(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(263,null),i.localize(264,null),i.localize(265,null),i.localize(266,null)],description:i.localize(267,null)})),smartSelect:Pe(new oe),smoothScrolling:Pe(new a(104,"smoothScrolling",!1,{description:i.localize(268,null)})),stopRenderingLineAfter:Pe(new b(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Pe(new q),inlineSuggest:Pe(new Z),suggestFontSize:Pe(new b(109,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Pe(new b(110,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Pe(new a(111,"suggestOnTriggerCharacters",!0,{description:i.localize(271,null)})),suggestSelection:Pe(new c(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(272,null),i.localize(273,null),i.localize(274,null)],description:i.localize(275,null)})),tabCompletion:Pe(new c(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(276,null),i.localize(277,null),i.localize(278,null)],description:i.localize(279,null)})),tabIndex:Pe(new b(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Pe(new ee),unusualLineTerminators:Pe(new c(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(280,null),i.localize(281,null),i.localize(282,null)],description:i.localize(283,null)})),useShadowDOM:Pe(new a(117,"useShadowDOM",!0)),useTabStops:Pe(new a(118,"useTabStops",!0,{description:i.localize(284,null)})),wordSeparators:Pe(new C(119,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:i.localize(285,null)})),wordWrap:Pe(new c(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(286,null),i.localize(287,null),i.localize(288,null),i.localize(289,null)],description:i.localize(290,null)})),wordWrapBreakAfterCharacters:Pe(new C(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Pe(new C(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Pe(new b(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(291,null)})),wordWrapOverride1:Pe(new c(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Pe(new c(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Pe(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ee,{enumDescriptions:[i.localize(292,null),i.localize(293,null),i.localize(294,null),i.localize(295,null)],description:i.localize(296,null)})),wrappingStrategy:Pe(new c(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[i.localize(297,null),i.localize(298,null)],description:i.localize(299,null)})),editorClassName:Pe(new j),pixelRatio:Pe(new Fe),tabFocusMode:Pe(new ce),layoutInfo:Pe(new te),wrappingInfo:Pe(new ve)}}),define(De[125],Ce([16,17]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[126],Ce([16,17]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[127],Ce([16,17]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[128],Ce([16,17]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(De[129],Ce([16,17]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(De[130],Ce([16,17]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(De[131],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[132],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[133],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(De[134],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[135],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[136],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[137],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[138],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(De[139],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[140],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[141],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[142],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[143],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[144],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[145],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[146],Ce([1,0,22,29,127,246]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(a){return a=a.trim(),a==="*"||_.test(a)}e.isValidVersionStr=y;function k(a){if(!y(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=a.match(_);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function O(a){if(!a)return null;const p=a.majorBase,b=a.majorMustEqual,u=a.minorBase;let C=a.minorMustEqual;const s=a.patchBase;let c=a.patchMustEqual;a.hasCaret&&(p===0||(C=!1),c=!1);let n=0;if(a.preRelease){const d=A.exec(a.preRelease);if(d){const[,l,f,r]=d;n=Date.UTC(Number(l),Number(f)-1,Number(r))}}return{majorBase:p,majorMustEqual:b,minorBase:u,minorMustEqual:C,patchBase:s,patchMustEqual:c,isMinimum:a.hasGreaterEquals,notBefore:n}}e.normalizeVersion=O;function w(a,p,b){let u;typeof a=="string"?u=O(k(a)):u=a;let C;p instanceof Date?C=p.getTime():typeof p=="string"&&(C=new Date(p).getTime());let s;if(typeof b=="string"?s=O(k(b)):s=b,!u||!s)return!1;const c=u.majorBase,n=u.minorBase,d=u.patchBase;let l=s.majorBase,f=s.minorBase,r=s.patchBase;const h=s.notBefore;let v=s.majorMustEqual,I=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?c>l?!0:c<l?!1:n>f?!0:n<f||C&&C<h?!1:d>=r:(c===1&&l===0&&(!v||!I||!L)&&(l=1,f=0,r=0,v=!0,I=!1,L=!1),c<l?!1:c>l?!v:n<f?!1:n>f?!I:d<r?!1:d>r?!L:!(C&&C<h))}e.isValidVersion=w;function g(a,p,b,u,C){const s=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return s.push([D.default.Error,S.localize(0,null)]),s;if(typeof u.name!="string")return s.push([D.default.Error,S.localize(1,null,"name")]),s;if(typeof u.version!="string")return s.push([D.default.Error,S.localize(2,null,"version")]),s;if(!u.engines)return s.push([D.default.Error,S.localize(3,null,"engines")]),s;if(typeof u.engines.vscode!="string")return s.push([D.default.Error,S.localize(4,null,"engines.vscode")]),s;if(typeof u.extensionDependencies<"u"&&!o(u.extensionDependencies))return s.push([D.default.Error,S.localize(5,null,"extensionDependencies")]),s;if(typeof u.activationEvents<"u"){if(!o(u.activationEvents))return s.push([D.default.Error,S.localize(6,null,"activationEvents")]),s;if(typeof u.main>"u"&&typeof u.browser>"u")return s.push([D.default.Error,S.localize(7,null,"activationEvents","main")]),s}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&s.push([D.default.Warning,S.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return s.push([D.default.Error,S.localize(9,null,"main")]),s;{const d=(0,i.joinPath)(b,u.main);(0,i.isEqualOrParent)(d,b)||s.push([D.default.Warning,S.localize(10,null,d.path,b.path)])}if(typeof u.activationEvents>"u")return s.push([D.default.Error,S.localize(11,null,"activationEvents","main")]),s}if(typeof u.browser<"u"){if(typeof u.browser!="string")return s.push([D.default.Error,S.localize(12,null,"browser")]),s;{const d=(0,i.joinPath)(b,u.browser);(0,i.isEqualOrParent)(d,b)||s.push([D.default.Warning,S.localize(13,null,d.path,b.path)])}if(typeof u.activationEvents>"u")return s.push([D.default.Error,S.localize(14,null,"activationEvents","browser")]),s}if(!F.valid(u.version))return s.push([D.default.Error,S.localize(15,null)]),s;const c=[];if(!E(a,p,u,C,c))for(const d of c)s.push([D.default.Error,d]);return s}e.validateExtensionManifest=g;function E(a,p,b,u,C){return u||typeof b.main>"u"&&typeof b.browser>"u"?!0:t(a,p,b.engines.vscode,C)}e.isValidExtensionVersion=E;function m(a,p,b){return a==="*"||t(p,b,a)}e.isEngineValid=m;function t(a,p,b,u=[]){const C=O(k(b));if(!C)return u.push(S.localize(16,null,b)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return u.push(S.localize(17,null,b)),!1}else if(!C.majorMustEqual)return u.push(S.localize(18,null,b)),!1;return w(a,p,C)?!0:(u.push(S.localize(19,null,a,b)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let p=0,b=a.length;p<b;p++)if(typeof a[p]!="string")return!1;return!0}}),define(De[84],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(S,F=[],_=!1){this.ctor=S,this.staticArguments=F,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=i}),define(De[59],Ce([1,0,84]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function F(A,y,k){y instanceof i.SyncDescriptor||(y=new i.SyncDescriptor(y,[],Boolean(k))),D.push([A,y])}e.registerSingleton=F;function _(){return D}e.getSingletonServiceDescriptors=_}),define(De[147],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(F,_){this.key=F,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class D{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(const _ of this._nodes.values())_.outgoing.size===0&&F.push(_);return F}insertEdge(F,_){const A=this.lookupOrInsertNode(F),y=this.lookupOrInsertNode(_);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(F){const _=this._hashFn(F);this._nodes.delete(_);for(const A of this._nodes.values())A.outgoing.delete(_),A.incoming.delete(_)}lookupOrInsertNode(F){const _=this._hashFn(F);let A=this._nodes.get(_);return A||(A=new i(_,F),this._nodes.set(_,A)),A}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){const F=[];for(const[_,A]of this._nodes)F.push(`${_}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,_]of this._nodes){const A=new Set([F]),y=this._findCycle(_,A);if(y)return y}}_findCycle(F,_){for(const[A,y]of F.outgoing){if(_.has(A))return[..._,A].join(" -> ");_.add(A);const k=this._findCycle(y,_);if(k)return k;_.delete(A)}}}e.Graph=D}),define(De[3],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(i=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function D(_,A,y){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:_,index:y}):(A[i.DI_DEPENDENCIES]=[{id:_,index:y}],A[i.DI_TARGET]=A)}function S(_){if(i.serviceIds.has(_))return i.serviceIds.get(_);const A=function(y,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(A,y,O)};return A.toString=()=>_,i.serviceIds.set(_,A),A}e.createDecorator=S;function F(_){return _}e.refineServiceDecorator=F}),define(De[46],Ce([1,0,9,2,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function F(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationOverrides=F;function _(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=_;var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(a,p){const b=Object.create(null);for(const u in a)O(b,u,a[u],p);return b}e.toValuesTree=k;function O(a,p,b,u){const C=p.split("."),s=C.pop();let c=a;for(let n=0;n<C.length;n++){const d=C[n];let l=c[d];switch(typeof l){case"undefined":l=c[d]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(l)}`);return}c=l}if(typeof c=="object"&&c!==null)try{c[s]=b}catch{u(`Ignoring ${p} as ${C.join(".")} is ${JSON.stringify(c)}`)}else u(`Ignoring ${p} as ${C.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=O;function w(a,p){const b=p.split(".");g(a,b)}e.removeFromValueTree=w;function g(a,p){const b=p.shift();if(p.length===0){delete a[b];return}if(Object.keys(a).indexOf(b)!==-1){const u=a[b];typeof u=="object"&&!Array.isArray(u)&&(g(u,p),Object.keys(u).length===0&&delete a[b])}}function E(a,p,b){function u(c,n){let d=c;for(const l of n){if(typeof d!="object"||d===null)return;d=d[l]}return d}const C=p.split("."),s=u(a,C);return typeof s>"u"?b:s}e.getConfigurationValue=E;function m(a,p,b){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in a?i.isObject(a[u])&&i.isObject(p[u])?m(a[u],p[u],b):b&&(a[u]=p[u]):a[u]=p[u])})}e.merge=m;function t(a,p,b){const u=a.inspect(p),C=a.inspect(b);return typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:typeof C.userValue<"u"||typeof C.workspaceValue<"u"||typeof C.workspaceFolderValue<"u"?C.value:u.defaultValue}e.getMigratedSettingValue=t;function o(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(De[40],Ce([1,0,20,10,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",i.isMacintosh),F.set("isLinux",i.isLinux),F.set("isWindows",i.isWindows),F.set("isWeb",i.isWeb),F.set("isMacNative",i.isMacintosh&&!i.isWeb),F.set("isEdge",i.isEdge),F.set("isFirefox",i.isFirefox),F.set("isChrome",i.isChrome),F.set("isSafari",i.isSafari);const _=Object.prototype.hasOwnProperty;var A;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return w.INSTANCE}static true(){return g.INSTANCE}static has(P){return E.create(P)}static equals(P,M){return m.create(P,M)}static notEquals(P,M){return a.create(P,M)}static regex(P,M){return n.create(P,M)}static in(P,M){return t.create(P,M)}static notIn(P,M){return o.create(P,M)}static not(P){return p.create(P)}static and(...P){return f.create(P,null,!0)}static or(...P){return r.create(P,null,!0)}static greater(P,M){return u.create(P,M)}static greaterEquals(P,M){return C.create(P,M)}static smaller(P,M){return s.create(P,M)}static smallerEquals(P,M){return c.create(P,M)}static deserialize(P,M=!1){if(!!P)return this._deserializeOrExpression(P,M)}static _deserializeOrExpression(P,M){const R=P.split("||");return r.create(R.map(B=>this._deserializeAndExpression(B,M)),null,!0)}static _deserializeAndExpression(P,M){const R=P.split("&&");return f.create(R.map(B=>this._deserializeOne(B,M)),null,!0)}static _deserializeOne(P,M){if(P=P.trim(),P.indexOf("!=")>=0){const R=P.split("!=");return a.create(R[0].trim(),this._deserializeValue(R[1],M))}if(P.indexOf("==")>=0){const R=P.split("==");return m.create(R[0].trim(),this._deserializeValue(R[1],M))}if(P.indexOf("=~")>=0){const R=P.split("=~");return n.create(R[0].trim(),this._deserializeRegexValue(R[1],M))}if(P.indexOf(" not in ")>=0){const R=P.split(" not in ");return o.create(R[0].trim(),this._deserializeValue(R[1],M))}if(P.indexOf(" in ")>=0){const R=P.split(" in ");return t.create(R[0].trim(),this._deserializeValue(R[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const R=P.split(">=");return C.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const R=P.split(">");return u.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const R=P.split("<=");return c.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const R=P.split("<");return s.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(P)?p.create(P.substr(1).trim()):E.create(P)}static _deserializeValue(P,M){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;const R=/^'([^']*)'$/.exec(P);return R?R[1].trim():P}static _deserializeRegexValue(P,M){if((0,D.isFalsyOrWhitespace)(P)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const R=P.indexOf("/"),B=P.lastIndexOf("/");if(R===B||R<0){if(M)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}const x=P.slice(R+1,B),U=P[B+1]==="i"?"i":"";try{return new RegExp(x,U)}catch(K){if(M)throw new Error(`bad regexp-value '${P}', parse error: ${K}`);return console.warn(`bad regexp-value '${P}', parse error: ${K}`),null}}}e.ContextKeyExpr=y;function k(H,P){const M=H?H.substituteConstants():void 0,R=P?P.substituteConstants():void 0;return!M&&!R?!0:!M||!R?!1:M.equals(R)}e.expressionsAreEqualWithConstantSubstitution=k;function O(H,P){return H.cmp(P)}class w{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class g{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class E{static create(P,M=null){const R=F.get(P);return typeof R=="boolean"?R?g.INSTANCE:w.INSTANCE:new E(P,M)}constructor(P,M){this.key=P,this.negated=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:v(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=F.get(this.key);return typeof P=="boolean"?P?g.INSTANCE:w.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class m{static create(P,M,R=null){if(typeof M=="boolean")return M?E.create(P,R):p.create(P,R);const B=F.get(P);return typeof B=="boolean"?M===(B?"true":"false")?g.INSTANCE:w.INSTANCE:new m(P,M,R)}constructor(P,M,R){this.key=P,this.value=M,this.negated=R,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:I(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=F.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?g.INSTANCE:w.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class t{static create(P,M){return new t(P,M)}constructor(P,M){this.key=P,this.valueKey=M,this.type=10,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:I(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.valueKey),R=P.getValue(this.key);return Array.isArray(M)?M.includes(R):typeof R=="string"&&typeof M=="object"&&M!==null?_.call(M,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=o.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=t;class o{static create(P,M){return new o(P,M)}constructor(P,M){this.key=P,this.valueKey=M,this.type=11,this._negated=t.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=o;class a{static create(P,M,R=null){if(typeof M=="boolean")return M?p.create(P,R):E.create(P,R);const B=F.get(P);return typeof B=="boolean"?M===(B?"true":"false")?w.INSTANCE:g.INSTANCE:new a(P,M,R)}constructor(P,M,R){this.key=P,this.value=M,this.negated=R,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:I(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=F.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?w.INSTANCE:g.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=a;class p{static create(P,M=null){const R=F.get(P);return typeof R=="boolean"?R?w.INSTANCE:g.INSTANCE:new p(P,M)}constructor(P,M){this.key=P,this.negated=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:v(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=F.get(this.key);return typeof P=="boolean"?P?w.INSTANCE:g.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function b(H,P){if(typeof H=="string"){const M=parseFloat(H);isNaN(M)||(H=M)}return typeof H=="string"||typeof H=="number"?P(H):w.INSTANCE}class u{static create(P,M,R=null){return b(M,B=>new u(P,B,R))}constructor(P,M,R){this.key=P,this.value=M,this.negated=R,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:I(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class C{static create(P,M,R=null){return b(M,B=>new C(P,B,R))}constructor(P,M,R){this.key=P,this.value=M,this.negated=R,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:I(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=C;class s{static create(P,M,R=null){return b(M,B=>new s(P,B,R))}constructor(P,M,R){this.key=P,this.value=M,this.negated=R,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:I(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class c{static create(P,M,R=null){return b(M,B=>new c(P,B,R))}constructor(P,M,R){this.key=P,this.value=M,this.negated=R,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:I(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class n{static create(P,M){return new n(P,M)}constructor(P,M){this.key=P,this.regexp=M,this.type=7,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const M=this.regexp?this.regexp.source:"",R=P.regexp?P.regexp.source:"";return M<R?-1:M>R?1:0}equals(P){if(P.type===this.type){const M=this.regexp?this.regexp.source:"",R=P.regexp?P.regexp.source:"";return this.key===P.key&&M===R}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class d{static create(P){return new d(P)}constructor(P){this._actual=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new d(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=d;function l(H){let P=null;for(let M=0,R=H.length;M<R;M++){const B=H[M].substituteConstants();if(H[M]!==B&&P===null){P=[];for(let x=0;x<M;x++)P[x]=H[x]}P!==null&&(P[M]=B)}return P===null?H:P}class f{static create(P,M,R){return f._normalizeArr(P,M,R)}constructor(P,M){this.expr=P,this.negated=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,R=this.expr.length;M<R;M++){const B=O(this.expr[M],P.expr[M]);if(B!==0)return B}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,R=this.expr.length;M<R;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=l(this.expr);return P===this.expr?this:f.create(P,this.negated,!1)}evaluate(P){for(let M=0,R=this.expr.length;M<R;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static _normalizeArr(P,M,R){const B=[];let x=!1;for(const U of P)if(!!U){if(U.type===1){x=!0;continue}if(U.type===0)return w.INSTANCE;if(U.type===6){B.push(...U.expr);continue}B.push(U)}if(B.length===0&&x)return g.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(O);for(let U=1;U<B.length;U++)B[U-1].equals(B[U])&&(B.splice(U,1),U--);if(B.length===1)return B[0];for(;B.length>1;){const U=B[B.length-1];if(U.type!==9)break;B.pop();const K=B.pop(),te=B.length===0,de=r.create(U.expr.map(re=>f.create([re,K],null,R)),null,te);de&&(B.push(de),B.sort(O))}if(B.length===1)return B[0];if(R){for(let U=0;U<B.length;U++)for(let K=U+1;K<B.length;K++)if(B[U].negate().equals(B[K]))return w.INSTANCE;if(B.length===1)return B[0]}return new f(B,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new f(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){const P=[];for(const M of this.expr)P.push(M.negate());this.negated=r.create(P,this,!0)}return this.negated}}class r{static create(P,M,R){return r._normalizeArr(P,M,R)}constructor(P,M){this.expr=P,this.negated=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,R=this.expr.length;M<R;M++){const B=O(this.expr[M],P.expr[M]);if(B!==0)return B}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,R=this.expr.length;M<R;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=l(this.expr);return P===this.expr?this:r.create(P,this.negated,!1)}evaluate(P){for(let M=0,R=this.expr.length;M<R;M++)if(this.expr[M].evaluate(P))return!0;return!1}static _normalizeArr(P,M,R){let B=[],x=!1;if(P){for(let U=0,K=P.length;U<K;U++){const te=P[U];if(!!te){if(te.type===0){x=!0;continue}if(te.type===1)return g.INSTANCE;if(te.type===9){B=B.concat(te.expr);continue}B.push(te)}}if(B.length===0&&x)return w.INSTANCE;B.sort(O)}if(B.length!==0){if(B.length===1)return B[0];for(let U=1;U<B.length;U++)B[U-1].equals(B[U])&&(B.splice(U,1),U--);if(B.length===1)return B[0];if(R){for(let U=0;U<B.length;U++)for(let K=U+1;K<B.length;K++)if(B[U].negate().equals(B[K]))return g.INSTANCE;if(B.length===1)return B[0]}return new r(B,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new r(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),R=P.shift(),B=[];for(const x of W(M))for(const U of W(R))B.push(f.create([x,U],null,!1));P.unshift(r.create(B,null,!1))}this.negated=r.create(P,this,!0)}return this.negated}}class h extends E{static all(){return h._info.values()}constructor(P,M,R){super(P,null),this._defaultValue=M,typeof R=="object"?h._info.push({...R,key:P}):R!==!0&&h._info.push({key:P,description:R,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return m.create(this.key,P)}notEqualsTo(P){return a.create(this.key,P)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(H,P){return H<P?-1:H>P?1:0}function I(H,P,M,R){return H<M?-1:H>M?1:P<R?-1:P>R?1:0}function L(H,P){if(H.type===0||P.type===1)return!0;if(H.type===9)return P.type===9?j(H.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(L(H,M))return!0;return!1}if(H.type===6){if(P.type===6)return j(P.expr,H.expr);for(const M of H.expr)if(L(M,P))return!0;return!1}return H.equals(P)}e.implies=L;function j(H,P){let M=0,R=0;for(;M<H.length&&R<P.length;){const B=H[M].cmp(P[R]);if(B<0)return!1;B===0&&M++,R++}return M===H.length}function W(H){return H.type===9?H.expr:[H]}}),define(De[148],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(De[85],Ce([1,0,126,3]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function F(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function _(a,p){switch(a){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function A(a,p){return p==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(a,p,b){return A(p,b)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===b?!0:k(b).includes(a)}e.isTargetPlatformCompatible=y;function k(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var g;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var E;(function(a){a.Install="install",a.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var m;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var t;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[35],Ce([1,0,45,19,10,9,2,128,3]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k(x){return x.create===!0}e.isFileOpenForWriteOptions=k;var O;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var w;(function(x){x[x.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var g;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=E;function m(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=m;function t(x){return!!(x.capabilities&32768)}e.hasFileCloneCapability=t;function o(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function a(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=a;function p(x){return E(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var b;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(U,K){super(U),this.code=K}}e.FileSystemProviderError=u;function C(x,U){const K=new u(x.toString(),U);return c(K,U),K}e.createFileSystemProviderError=C;function s(x){return x||C((0,A.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function c(x,U){return x.name=U?`${U} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=c;function n(x){if(!x)return b.Unknown;if(x instanceof u)return x.code;const U=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!U)return b.Unknown;switch(U[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=n;function d(x){if(x instanceof I)return x.fileOperationResult;switch(n(x)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var l;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class f{constructor(U,K,te){this.resource=U,this.operation=K,this.target=te}isOperation(U){return this.operation===U}}e.FileOperationEvent=f;var r;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class h{constructor(U,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const te=new Map;for(const de of U){const re=te.get(de.type);switch(re?re.push([de.resource,de]):te.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,re]of te)switch(de){case 1:this.added=i.TernarySearchTree.forUris(()=>K),this.added.fill(re);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>K),this.updated.fill(re);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>K),this.deleted.fill(re);break}}contains(U,...K){return this.doContains(U,{includeChildren:!1},...K)}affects(U,...K){return this.doContains(U,{includeChildren:!0},...K)}doContains(U,K,...te){if(!U)return!1;const de=te.length>0;return!!((!de||te.includes(1))&&(this.added?.get(U)||K.includeChildren&&this.added?.findSuperstr(U))||(!de||te.includes(0))&&(this.updated?.get(U)||K.includeChildren&&this.updated?.findSuperstr(U))||(!de||te.includes(2))&&(this.deleted?.findSubstr(U)||K.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function v(x,U,K){return!x||!U||x===U||U.length>x.length?!1:(U.charAt(U.length-1)!==D.sep&&(U+=D.sep),K?(0,S.startsWithIgnoreCase)(x,U):x.indexOf(U)===0)}e.isParent=v;class I extends Error{constructor(U,K,te){super(U),this.fileOperationResult=K,this.options=te}}e.FileOperationError=I;class L extends I{constructor(U,K,te){super(U,2,te),this.stat=K}}e.NotModifiedSinceFileOperationError=L;var j;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function H(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=H;async function P(x,U){if(!U.hasProvider(_.URI.from({scheme:x.scheme})))return new Promise(K=>{const te=U.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===x.scheme&&de.added&&(te.dispose(),K())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(U){return(0,F.isNumber)(U)||(U=0),U<M.KB?(0,A.localize)(1,null,U.toFixed(0)):U<M.MB?(0,A.localize)(2,null,(U/M.KB).toFixed(2)):U<M.GB?(0,A.localize)(3,null,(U/M.MB).toFixed(2)):U<M.TB?(0,A.localize)(4,null,(U/M.GB).toFixed(2)):(0,A.localize)(5,null,(U/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var R;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function B(x){return{maxFileSize:x===0?300*M.MB:16*M.GB,maxHeapSize:x===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=B}),define(De[60],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...S){this._entries=new Map;for(const[F,_]of S)this.set(F,_)}set(S,F){const _=this._entries.get(S);return this._entries.set(S,F),_}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=i}),define(De[149],Ce([1,0,15,12,7,84,147,3,60,150]),function(ne,e,i,D,S,F,_,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class g{constructor(o=new y.ServiceCollection,a=!1,p,b=O){this._services=o,this._strict=a,this._parent=p,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new _.Graph(u=>u):void 0}createChild(o){return new g(o,this._strict,this,this._enableTracing)}invokeFunction(o,...a){const p=m.traceInvocation(this._enableTracing,o);let b=!1;try{return o({get:C=>{if(b)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(C,p);if(!s)throw new Error(`[invokeFunction] unknown service '${C}'`);return s}},...a)}finally{b=!0,p.stop()}}createInstance(o,...a){let p,b;return o instanceof F.SyncDescriptor?(p=m.traceCreation(this._enableTracing,o.ctor),b=this._createInstance(o.ctor,o.staticArguments.concat(a),p)):(p=m.traceCreation(this._enableTracing,o),b=this._createInstance(o,a,p)),p.stop(),b}_createInstance(o,a=[],p){const b=A._util.getServiceDependencies(o).sort((s,c)=>s.index-c.index),u=[];for(const s of b){const c=this._getOrCreateServiceInstance(s.id,p);c||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${s.id}.`,!1),u.push(c)}const C=b.length>0?b[0].index:a.length;if(a.length!==C){console.trace(`[createInstance] First service dependency of ${o.name} at position ${C+1} conflicts with ${a.length} static arguments`);const s=C-a.length;s>0?a=a.concat(new Array(s)):a=a.slice(0,C)}return Reflect.construct(o,a.concat(u))}_setServiceInstance(o,a){if(this._services.get(o)instanceof F.SyncDescriptor)this._services.set(o,a);else if(this._parent)this._parent._setServiceInstance(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const a=this._services.get(o);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):a}_getOrCreateServiceInstance(o,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const p=this._getServiceInstanceOrDescriptor(o);return p instanceof F.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,p,a.branch(o,!0)):(a.branch(o,!1),p)}_safeCreateAndCacheServiceInstance(o,a,p){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,a,p)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,a,p){const b=new _.Graph(s=>s.id.toString());let u=0;const C=[{id:o,desc:a,_trace:p}];for(;C.length;){const s=C.pop();if(b.lookupOrInsertNode(s),u++>1e3)throw new w(b);for(const c of A._util.getServiceDependencies(s.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${o} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(c.id)),n instanceof F.SyncDescriptor){const d={id:c.id,desc:n,_trace:s._trace.branch(c.id,!0)};b.insertEdge(s,d),C.push(d)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:c}of s){if(this._getServiceInstanceOrDescriptor(c.id)instanceof F.SyncDescriptor){const d=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,d)}b.removeNode(c)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,a,p=[],b,u){if(this._services.get(o)instanceof F.SyncDescriptor)return this._createServiceInstance(o,a,p,b,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,a,p,b,u);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(o,a,p=[],b,u){if(b){const C=new g(void 0,this._strict,this,this._enableTracing);C._globalGraphImplicitDependency=String(o);const s=new Map,c=new i.IdleValue(()=>{const n=C._createInstance(a,p,u);for(const[d,l]of s){const f=n[d];if(typeof f=="function")for(const r of l)f.apply(n,r)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,d){if(!c.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let r=s.get(d);return r||(r=new k.LinkedList,s.set(d,r)),(v,I,L)=>{const j=r.push([v,I,L]);return(0,S.toDisposable)(j)}}if(d in n)return n[d];const l=c.value;let f=l[d];return typeof f!="function"||(f=f.bind(l),n[d]=f),f},set(n,d,l){return c.value[d]=l,!0}})}else return this._createInstance(a,p,u)}_throwIfStrict(o,a){if(a&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=g;var E;(function(t){t[t.Creation=0]="Creation",t[t.Invocation=1]="Invocation",t[t.Branch=2]="Branch"})(E||(E={}));class m{static traceInvocation(o,a){return o?new m(1,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(o,a){return o?new m(0,a.name):m._None}constructor(o,a){this.type=o,this.name=a,this._start=Date.now(),this._dep=[]}branch(o,a){const p=new m(2,o.toString());return this._dep.push([o,a,p]),p}stop(){const o=Date.now()-this._start;m._totals+=o;let a=!1;function p(u,C){const s=[],c=new Array(u+1).join("	");for(const[n,d,l]of C._dep)if(d&&l){a=!0,s.push(`${c}CREATES -> ${n}`);const f=p(u+1,l);f&&s.push(f)}else s.push(`${c}uses -> ${n}`);return s.join(`
`)}const b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(o>2||a)&&m.all.add(b.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(De[11],Ce([1,0,44,4,7,28,20,2,3]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function k(){return new Date().toISOString()}var O;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function w(f,r,h){switch(r){case O.Trace:f.trace(h);break;case O.Debug:f.debug(h);break;case O.Info:f.info(h);break;case O.Warning:f.warn(h);break;case O.Error:f.error(h);break;case O.Critical:f.critical(h);break;default:throw new Error("Invalid log level")}}e.log=w;function g(f){let r="";for(let h=0;h<f.length;h++){let v=f[h];if(typeof v=="object")try{v=JSON.stringify(v)}catch{}r+=(h>0?" ":"")+v}return r}e.format=g;class E extends S.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(r){super(),this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...h){this.checkLogLevel(O.Trace)&&this.log(O.Trace,g([r,...h]))}debug(r,...h){this.checkLogLevel(O.Debug)&&this.log(O.Debug,g([r,...h]))}info(r,...h){this.checkLogLevel(O.Info)&&this.log(O.Info,g([r,...h]))}warn(r,...h){this.checkLogLevel(O.Warning)&&this.log(O.Warning,g([r,...h]))}error(r,...h){if(this.checkLogLevel(O.Error))if(r instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=r.stack,this.log(O.Error,g(v))}else this.log(O.Error,g([r,...h]))}critical(r,...h){this.checkLogLevel(O.Critical)&&this.log(O.Critical,g([r,...h]))}flush(){}}e.AbstractMessageLogger=m;class t extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.useColors=!_.isWindows}trace(r,...h){this.getLevel()<=O.Trace&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,r,...h):console.log(`[main ${k()}]`,r,...h))}debug(r,...h){this.getLevel()<=O.Debug&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,r,...h):console.log(`[main ${k()}]`,r,...h))}info(r,...h){this.getLevel()<=O.Info&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,r,...h):console.log(`[main ${k()}]`,r,...h))}warn(r,...h){this.getLevel()<=O.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,r,...h):console.warn(`[main ${k()}]`,r,...h))}error(r,...h){this.getLevel()<=O.Error&&(this.useColors?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,r,...h):console.error(`[main ${k()}]`,r,...h))}critical(r,...h){this.getLevel()<=O.Critical&&(this.useColors?console.error(`\x1B[90m[main ${k()}]\x1B[0m`,r,...h):console.error(`[main ${k()}]`,r,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class o extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...h){this.getLevel()<=O.Trace&&console.log("%cTRACE","color: #888",r,...h)}debug(r,...h){this.getLevel()<=O.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...h)}info(r,...h){this.getLevel()<=O.Info&&console.log("%c INFO","color: #33f",r,...h)}warn(r,...h){this.getLevel()<=O.Warning&&console.log("%c WARN","color: #993",r,...h)}error(r,...h){this.getLevel()<=O.Error&&console.log("%c  ERR","color: #f33",r,...h)}critical(r,...h){this.getLevel()<=O.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...h)}dispose(){}flush(){}}e.ConsoleLogger=o;class a extends E{constructor(r,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=r,this.setLevel(h)}trace(r,...h){this.getLevel()<=O.Trace&&this.adapter.log(O.Trace,[this.extractMessage(r),...h])}debug(r,...h){this.getLevel()<=O.Debug&&this.adapter.log(O.Debug,[this.extractMessage(r),...h])}info(r,...h){this.getLevel()<=O.Info&&this.adapter.log(O.Info,[this.extractMessage(r),...h])}warn(r,...h){this.getLevel()<=O.Warning&&this.adapter.log(O.Warning,[this.extractMessage(r),...h])}error(r,...h){this.getLevel()<=O.Error&&this.adapter.log(O.Error,[this.extractMessage(r),...h])}critical(r,...h){this.getLevel()<=O.Critical&&this.adapter.log(O.Critical,[this.extractMessage(r),...h])}extractMessage(r){return typeof r=="string"?r:(0,i.toErrorMessage)(r,this.getLevel()<=O.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class p extends E{constructor(r){super(),this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const h of this.logServices)h.setLevel(r);super.setLevel(r)}trace(r,...h){for(const v of this.logServices)v.trace(r,...h)}debug(r,...h){for(const v of this.logServices)v.debug(r,...h)}info(r,...h){for(const v of this.logServices)v.info(r,...h)}warn(r,...h){for(const v of this.logServices)v.warn(r,...h)}error(r,...h){for(const v of this.logServices)v.error(r,...h)}critical(r,...h){for(const v of this.logServices)v.critical(r,...h)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=p;class b extends S.Disposable{constructor(r){super(),this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...h){this.logger.trace(r,...h)}debug(r,...h){this.logger.debug(r,...h)}info(r,...h){this.logger.info(r,...h)}warn(r,...h){this.logger.warn(r,...h)}error(r,...h){this.logger.error(r,...h)}critical(r,...h){this.logger.critical(r,...h)}flush(){this.logger.flush()}}e.LogService=b;class u extends S.Disposable{constructor(r,h){super(),this.logLevel=r,this.loggerItems=new F.ResourceMap,this._register(h(v=>this.setLevel(v)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:r})=>r)}getLogger(r){return this.loggerItems.get(r)?.logger}createLogger(r,h,v){let I=this.loggerItems.get(r)?.logger;return I||(v=h?.always?O.Trace:v,I=this.doCreateLogger(r,v??this.logLevel,h),this.loggerItems.set(r,{logger:I,logLevel:v})),I}setLevel(r,h){const v=A.URI.isUri(r)?r:void 0,I=v?h:r;if(v){const L=this.loggerItems.get(v);L&&L.logLevel!==I&&(L.logLevel=I,L.logger.setLevel(I))}else this.logLevel=I,this.loggerItems.forEach(({logLevel:L,logger:j})=>{L===void 0&&j.setLevel(this.logLevel)})}getLogLevel(r){return this.loggerItems.get(r)?.logLevel}dispose(){this.loggerItems.forEach(({logger:r})=>r.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=u;class C{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(r){}getLevel(){return O.Info}trace(r,...h){}debug(r,...h){}info(r,...h){}warn(r,...h){}error(r,...h){}critical(r,...h){}dispose(){}flush(){}}e.NullLogger=C;class s extends C{}e.NullLogService=s;class c extends u{constructor(){super(O.Info,D.Event.None)}doCreateLogger(r,h,v){return new C}}e.NullLoggerService=c;function n(f){if(f.verbose)return O.Trace;if(typeof f.logLevel=="string"){const r=d(f.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function d(f){switch(f){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Critical;case"off":return O.Off}}e.parseLogLevel=d;function l(f){switch(f){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Critical:return"critical";case O.Off:return"off"}}e.LogLevelToString=l}),define(De[86],Ce([1,0,29,129,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(F=e.MarkerTag||(e.MarkerTag={}));var _;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(m,t){return t-m}y.compare=k;const O=Object.create(null);O[y.Error]=(0,D.localize)(0,null),O[y.Warning]=(0,D.localize)(1,null),O[y.Info]=(0,D.localize)(2,null);function w(m){return O[m]||""}y.toString=w;function g(m){switch(m){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=g;function E(m){switch(m){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=E}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const k="";function O(g){return w(g,!0)}y.makeKey=O;function w(g,E){const m=[k];return g.source?m.push(g.source.replace("\xA6","\\\xA6")):m.push(k),g.code?typeof g.code=="string"?m.push(g.code.replace("\xA6","\\\xA6")):m.push(g.code.value.replace("\xA6","\\\xA6")):m.push(k),g.severity!==void 0&&g.severity!==null?m.push(_.toString(g.severity)):m.push(k),g.message&&E?m.push(g.message.replace("\xA6","\\\xA6")):m.push(k),g.startLineNumber!==void 0&&g.startLineNumber!==null?m.push(g.startLineNumber.toString()):m.push(k),g.startColumn!==void 0&&g.startColumn!==null?m.push(g.startColumn.toString()):m.push(k),g.endLineNumber!==void 0&&g.endLineNumber!==null?m.push(g.endLineNumber.toString()):m.push(k),g.endColumn!==void 0&&g.endColumn!==null?m.push(g.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}y.makeKeyOptionalMessage=w})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(De[151],Ce([1,0,4,29,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=D.default,e.INotificationService=(0,S.createDecorator)("notificationService");var F;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(F=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(De[87],Ce([1,0,7,10,2,3]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,F.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return i.Disposable.None},registerValidator(){return i.Disposable.None},registerExternalUriResolver(){return i.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return i.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function _(O,w){return S.URI.isUri(O)?(0,D.equalsIgnoreCase)(O.scheme,w):(0,D.startsWithIgnoreCase)(O,w+":")}e.matchesScheme=_;function A(O,...w){return w.some(g=>_(O,g))}e.matchesSomeScheme=A;function y(O,w){return O.with({fragment:`${w.startLineNumber},${w.startColumn}${w.endLineNumber?`-${w.endLineNumber}${w.endColumn?`,${w.endColumn}`:""}`:""}`})}e.withSelection=y;function k(O){let w;const g=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return g&&(w={startLineNumber:parseInt(g[1]),startColumn:g[2]?parseInt(g[2]):1,endLineNumber:g[4]?parseInt(g[4]):void 0,endColumn:g[4]?g[5]?parseInt(g[5]):1:void 0},O=O.with({fragment:""})),{selection:w,uri:O}}e.extractSelection=k}),define(De[152],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__decorate||function(ne,e,i,D){var S=arguments.length,F=S<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,i):D,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ne,e,i,D);else for(var A=ne.length-1;A>=0;A--)(_=ne[A])&&(F=(S<3?_(F):S>3?_(e,i,F):_(e,i))||F);return S>3&&F&&Object.defineProperty(e,i,F),F},We=this&&this.__param||function(ne,e){return function(i,D){e(i,D,ne)}};define(De[153],Ce([1,0,15,21,7,3]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var _;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(w){this.callback=w}report(w){this._value=w,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends S.Disposable{constructor(w,g){super(),this.deferred=new i.DeferredPromise,g.withProgress(w,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};y=xe([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends S.Disposable{constructor(w){super(),this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(w){this.stop();const g=++this.currentOperationId,E=new D.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:E.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(De[30],Ce([1,0,47,9]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(_,A){i.ok(D.isString(_)),i.ok(D.isObject(A)),i.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new S}),define(De[88],Ce([1,0,4,30]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class F{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[S(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new F;D.Registry.add(e.Extensions.JSONContribution,_)}),define(De[89],Ce([1,0,18,4,9,125,46,88,30]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=y.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,c=!0){this.registerConfigurations([s],c)}registerConfigurations(s,c=!0){const n=this.doRegisterConfigurations(s,c);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const c=this.doDeregisterConfigurations(s);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:s,remove:c}){const n=[];n.push(...this.doDeregisterConfigurations(c)),n.push(...this.doRegisterConfigurations(s,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,i.distinct)(n)})}registerDefaultConfigurations(s){const c=[],n=[];for(const{overrides:d,source:l}of s)for(const f in d)if(c.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const r=this.configurationDefaultsOverrides.get(f),h=r?.valuesSources??new Map;if(l)for(const j of Object.keys(d[f]))h.set(j,l);const v={...r?.value||{},...d[f]};this.configurationDefaultsOverrides.set(f,{source:l,value:v,valuesSources:h});const I=(0,_.getLanguageTagSettingPlainKey)(f),L={type:"object",default:v,description:F.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:S.isString(l)?void 0:l,defaultValueSource:l};n.push(...t(f)),this.configurationProperties[f]=L,this.defaultLanguageConfigurationOverridesNode.properties[f]=L}else{this.configurationDefaultsOverrides.set(f,{value:d[f],source:l});const r=this.configurationProperties[f];r&&(this.updatePropertyDefaultValue(f,r),this.updateSchema(f,r))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const c=[];for(const{overrides:n,source:d}of s)for(const l in n){const f=this.configurationDefaultsOverrides.get(l),r=S.isString(d)?d:d?.id,h=S.isString(f?.source)?f?.source:f?.source?.id;if(r===h)if(c.push(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const v=this.configurationProperties[l];v&&(this.updatePropertyDefaultValue(l,v),this.updateSchema(l,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const c of s)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,c){const n=[];return s.forEach(d=>{n.push(...this.validateAndRegisterProperties(d,c,d.extensionInfo,d.restrictedProperties)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),n}doDeregisterConfigurations(s){const c=[],n=d=>{if(d.properties)for(const l in d.properties){c.push(l);const f=this.configurationProperties[l];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,d.properties[l])}d.allOf?.forEach(l=>n(l))};for(const d of s){n(d);const l=this.configurationContributors.indexOf(d);l!==-1&&this.configurationContributors.splice(l,1)}return c}validateAndRegisterProperties(s,c=!0,n,d,l=3){l=S.isUndefinedOrNull(s.scope)?l:s.scope;const f=[],r=s.properties;if(r)for(const v in r){const I=r[v];if(c&&b(v,I)){delete r[v];continue}if(I.source=n,I.defaultDefaultValue=r[v].default,this.updatePropertyDefaultValue(v,I),e.OVERRIDE_PROPERTY_REGEX.test(v)?I.scope=void 0:(I.scope=S.isUndefinedOrNull(I.scope)?l:I.scope,I.restricted=S.isUndefinedOrNull(I.restricted)?!!d?.includes(v):I.restricted),r[v].hasOwnProperty("included")&&!r[v].included){this.excludedConfigurationProperties[v]=r[v],delete r[v];continue}else this.configurationProperties[v]=r[v],r[v].policy?.name&&this.policyConfigurations.set(r[v].policy.name,v);!r[v].deprecationMessage&&r[v].markdownDeprecationMessage&&(r[v].deprecationMessage=r[v].markdownDeprecationMessage),f.push(v)}const h=s.allOf;if(h)for(const v of h)f.push(...this.validateAndRegisterProperties(v,c,n,d,l));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const c=n=>{const d=n.properties;if(d)for(const f in d)this.updateSchema(f,d[f]);n.allOf?.forEach(c)};c(s)}updateSchema(s,c){switch(e.allSettings.properties[s]=c,c.scope){case 1:e.applicationSettings.properties[s]=c;break;case 2:e.machineSettings.properties[s]=c;break;case 6:e.machineOverridableSettings.properties[s]=c;break;case 3:e.windowSettings.properties[s]=c;break;case 4:e.resourceSettings.properties[s]=c;break;case 5:e.resourceSettings.properties[s]=c,this.resourceLanguageSettingsSchema.properties[s]=c;break}}removeFromSchema(s,c){switch(delete e.allSettings.properties[s],c.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const c=`[${s}]`,n={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,n),e.allSettings.properties[c]=n,e.applicationSettings.properties[c]=n,e.machineSettings.properties[c]=n,e.machineOverridableSettings.properties[c]=n,e.windowSettings.properties[c]=n,e.resourceSettings.properties[c]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,c){const n=this.configurationDefaultsOverrides.get(s);let d=n?.value,l=n?.source;S.isUndefined(d)&&(d=c.defaultDefaultValue,l=void 0),S.isUndefined(d)&&(d=a(c.type)),c.default=d,c.defaultValueSource=l}}const E="\\[([^\\]]+)\\]",m=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(C){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let c=m.exec(C);for(;c?.length;){const n=c[1].trim();n&&s.push(n),c=m.exec(C)}}return(0,i.distinct)(s)}e.overrideIdentifiersFromKey=t;function o(C){return C.reduce((s,c)=>`${s}[${c}]`,"")}e.keyFromOverrideIdentifiers=o;function a(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const p=new g;y.Registry.add(e.Extensions.Configuration,p);function b(C,s){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?F.localize(7,null,C):p.getConfigurationProperties()[C]!==void 0?F.localize(8,null,C):s.policy?.name&&p.getPolicyConfigurations().get(s.policy?.name)!==void 0?F.localize(9,null,C,s.policy?.name,p.getPolicyConfigurations().get(s.policy?.name)):null:F.localize(6,null)}e.validateProperty=b;function u(){const C=[],s=p.getConfigurationProperties();for(const c of Object.keys(s))C.push([c,s[c].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=u}),define(De[154],Ce([1,0,18,4,106,7,28,24,9,2,46,89,30]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class E{constructor(c={},n=[],d=[],l){this._contents=c,this._keys=n,this._overrides=d,this.raw=l,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const c=this.raw.map(n=>{if(n instanceof E)return n;const d=new m("");return d.parseRaw(n),d.configurationModel});this._rawConfiguration=c.reduce((n,d)=>d===n?d:n.merge(d),c[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(c){return c?(0,O.getConfigurationValue)(this.contents,c):this.contents}inspect(c,n){const d=this.rawConfiguration.getValue(c),l=n?this.rawConfiguration.getOverrideValue(c,n):void 0,f=n?this.rawConfiguration.override(n).getValue(c):d;return{value:d,override:l,merged:f}}getOverrideValue(c,n){const d=this.getContentsForOverrideIdentifer(n);return d?c?(0,O.getConfigurationValue)(d,c):d:void 0}getKeysForOverrideIdentifier(c){const n=[];for(const d of this.overrides)d.identifiers.includes(c)&&n.push(...d.keys);return i.distinct(n)}getAllOverrideIdentifiers(){const c=[];for(const n of this.overrides)c.push(...n.identifiers);return i.distinct(c)}override(c){let n=this.overrideConfigurations.get(c);return n||(n=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,n)),n}merge(...c){const n=A.deepClone(this.contents),d=A.deepClone(this.overrides),l=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const r of c)if(f.push(...r.raw?.length?r.raw:[r]),!r.isEmpty()){this.mergeContents(n,r.contents);for(const h of r.overrides){const[v]=d.filter(I=>i.equals(I.identifiers,h.identifiers));v?(this.mergeContents(v.contents,h.contents),v.keys.push(...h.keys),v.keys=i.distinct(v.keys)):d.push(A.deepClone(h))}for(const h of r.keys)l.indexOf(h)===-1&&l.push(h)}return new E(n,l,d,f.every(r=>r instanceof E)?void 0:f)}freeze(){return this.frozen=!0,this}clone(){return new E(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(c){const n=this.getContentsForOverrideIdentifer(c);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const d={};for(const l of i.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[l];const r=n[l];r&&(typeof f=="object"&&typeof r=="object"?(f=A.deepClone(f),this.mergeContents(f,r)):f=r),d[l]=f}return new E(d,this.keys,this.overrides)}mergeContents(c,n){for(const d of Object.keys(n)){if(d in c&&y.isObject(c[d])&&y.isObject(n[d])){this.mergeContents(c[d],n[d]);continue}c[d]=A.deepClone(n[d])}}checkAndFreeze(c){return this.frozen&&!Object.isFrozen(c)?A.deepFreeze(c):c}getContentsForOverrideIdentifer(c){let n=null,d=null;const l=f=>{f&&(d?this.mergeContents(d,f):d=A.deepClone(f))};for(const f of this.overrides)i.equals(f.identifiers,[c])?n=f.contents:f.identifiers.includes(c)&&l(f.contents);return l(n),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(c,n){this.addKey(c),(0,O.addToValueTree)(this.contents,c,n,d=>{throw new Error(d)})}removeValue(c){this.removeKey(c)&&(0,O.removeFromValueTree)(this.contents,c)}addKey(c){let n=this.keys.length;for(let d=0;d<n;d++)c.indexOf(this.keys[d])===0&&(n=d);this.keys.splice(n,1,c)}removeKey(c){const n=this.keys.indexOf(c);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=E;class m{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,n){if(!y.isUndefinedOrNull(c)){const d=this.doParseContent(c);this.parseRaw(d,n)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,n){this._raw=c;const{contents:d,keys:l,overrides:f,restricted:r,hasExcludedProperties:h}=this.doParseRaw(c,n);this._configurationModel=new E(d,l,f,h?[c]:void 0),this._restrictedConfigurations=r||[]}doParseContent(c){let n={},d=null,l=[];const f=[],r=[];function h(I){Array.isArray(l)?l.push(I):d!==null&&(l[d]=I)}const v={onObjectBegin:()=>{const I={};h(I),f.push(l),l=I,d=null},onObjectProperty:I=>{d=I},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const I=[];h(I),f.push(l),l=I,d=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:h,onError:(I,L,j)=>{r.push({error:I,offset:L,length:j})}};if(c)try{S.visit(c,v),n=l[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return n}doParseRaw(c,n){const d=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),l=this.filter(c,d,!0,n);c=l.raw;const f=(0,O.toValuesTree)(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),r=Object.keys(c),h=this.toOverrides(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:f,keys:r,overrides:h,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(c,n,d,l){let f=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:c,restricted:[],hasExcludedProperties:f};const r={},h=[];for(const v in c)if(w.OVERRIDE_PROPERTY_REGEX.test(v)&&d){const I=this.filter(c[v],n,!1,l);r[v]=I.raw,f=f||I.hasExcludedProperties,h.push(...I.restricted)}else{const I=n[v],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&h.push(v),(L===void 0||l.scopes===void 0||l.scopes.includes(L))&&!(l.skipRestricted&&I?.restricted)?r[v]=c[v]:f=!0}return{raw:r,restricted:h,hasExcludedProperties:f}}toOverrides(c,n){const d=[];for(const l of Object.keys(c))if(w.OVERRIDE_PROPERTY_REGEX.test(l)){const f={};for(const r in c[l])f[r]=c[l][r];d.push({identifiers:(0,w.overrideIdentifiersFromKey)(l),keys:Object.keys(f),contents:(0,O.toValuesTree)(f,n)})}return d}}e.ConfigurationModelParser=m;class t extends F.Disposable{constructor(c,n,d,l){super(),this.userSettingsResource=c,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(d.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&d.isEqual(f.resource,c)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class o{constructor(c,n,d,l,f,r,h,v,I,L,j,W,H){this.key=c,this.overrides=n,this.value=d,this.overrideIdentifiers=l,this.defaultConfiguration=f,this.policyConfiguration=r,this.applicationConfiguration=h,this.userConfiguration=v,this.localUserConfiguration=I,this.remoteUserConfiguration=L,this.workspaceConfiguration=j,this.folderConfigurationModel=W,this.memoryInspectValue=H}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(c,n,d,l,f=new E,r=new E,h=new _.ResourceMap,v=new E,I=new _.ResourceMap,L=!0){this._defaultConfiguration=c,this._policyConfiguration=n,this._applicationConfiguration=d,this._localUserConfiguration=l,this._remoteUserConfiguration=f,this._workspaceConfiguration=r,this._folderConfigurations=h,this._memoryConfiguration=v,this._memoryConfigurationByResource=I,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(c,n,d){return this.getConsolidatedConfigurationModel(c,n,d).getValue(c)}updateValue(c,n,d={}){let l;d.resource?(l=this._memoryConfigurationByResource.get(d.resource),l||(l=new E,this._memoryConfigurationByResource.set(d.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(c):l.setValue(c,n),d.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,n,d){const l=this.getConsolidatedConfigurationModel(c,n,d),f=i.distinct(l.overrides.map(v=>v.identifiers).flat()).filter(v=>l.getOverrideValue(c,v)!==void 0),r=this.getFolderConfigurationModelForResource(n.resource,d),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new o(c,n,l.getValue(c),f.length?f:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this._workspaceConfiguration.freeze():void 0,r?r.freeze():void 0,h.inspect(c,n.overrideIdentifier))}keys(c){const n=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(c){this._policyConfiguration=c}updateApplicationConfiguration(c){this._applicationConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,n){this._folderConfigurations.set(c,n),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,n){const d=[];if(!n){const{added:l,updated:f,removed:r}=u(this._defaultConfiguration,c);n=[...l,...f,...r]}for(const l of n)for(const f of(0,w.overrideIdentifiersFromKey)(l)){const r=this._defaultConfiguration.getKeysForOverrideIdentifier(f),h=c.getKeysForOverrideIdentifier(f),v=[...h.filter(I=>r.indexOf(I)===-1),...r.filter(I=>h.indexOf(I)===-1),...r.filter(I=>!A.equals(this._defaultConfiguration.override(f).getValue(I),c.override(f).getValue(I)))];d.push([f,v])}return this.updateDefaultConfiguration(c),{keys:n,overrides:d}}compareAndUpdatePolicyConfiguration(c){const{added:n,updated:d,removed:l}=u(this._policyConfiguration,c),f=[...n,...d,...l];return f.length&&this.updatePolicyConfiguration(c),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.applicationConfiguration,c),r=[...n,...d,...l];return r.length&&this.updateApplicationConfiguration(c),{keys:r,overrides:f}}compareAndUpdateLocalUserConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.localUserConfiguration,c),r=[...n,...d,...l];return r.length&&this.updateLocalUserConfiguration(c),{keys:r,overrides:f}}compareAndUpdateRemoteUserConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.remoteUserConfiguration,c),r=[...n,...d,...l];return r.length&&this.updateRemoteUserConfiguration(c),{keys:r,overrides:f}}compareAndUpdateWorkspaceConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.workspaceConfiguration,c),r=[...n,...d,...l];return r.length&&this.updateWorkspaceConfiguration(c),{keys:r,overrides:f}}compareAndUpdateFolderConfiguration(c,n){const d=this.folderConfigurations.get(c),{added:l,updated:f,removed:r,overrides:h}=u(d,n),v=[...l,...f,...r];return(v.length||!d)&&this.updateFolderConfiguration(c,n),{keys:v,overrides:h}}compareAndDeleteFolderConfiguration(c){const n=this.folderConfigurations.get(c);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:d,updated:l,removed:f,overrides:r}=u(n,void 0);return{keys:[...d,...l,...f],overrides:r}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(c,n,d){let l=this.getConsolidatedConfigurationModelForResource(n,d);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(c)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:c},n){let d=this.getWorkspaceConsolidatedConfiguration();if(n&&c){const l=n.getFolder(c);l&&(d=this.getFolderConsolidatedConfiguration(l.uri)||d);const f=this._memoryConfigurationByResource.get(c);f&&(d=d.merge(f))}return d}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let n=this._foldersConsolidatedConfigurations.get(c);if(!n){const d=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(c);l?(n=d.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(c,n)):n=d}return n}getFolderConfigurationModelForResource(c,n){if(n&&c){const d=n.getFolder(c);if(d)return this._folderConfigurations.get(d.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,n)=>{const{contents:d,overrides:l,keys:f}=this._folderConfigurations.get(n);return c.push([n,{contents:d,overrides:l,keys:f}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>c.add(n)),this.userConfiguration.freeze().keys.forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(d=>c.add(d))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(d=>c.add(d))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(d=>n.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(d=>n.add(d)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(d=>n.add(d)),this._folderConfigurations.forEach(d=>d.getKeysForOverrideIdentifier(c).forEach(l=>n.add(l))),[...n.values()]}static parse(c){const n=this.parseConfigurationModel(c.defaults),d=this.parseConfigurationModel(c.policy),l=this.parseConfigurationModel(c.application),f=this.parseConfigurationModel(c.user),r=this.parseConfigurationModel(c.workspace),h=c.folders.reduce((v,I)=>(v.set(k.URI.revive(I[0]),this.parseConfigurationModel(I[1])),v),new _.ResourceMap);return new a(n,d,l,f,new E,r,h,new E,new _.ResourceMap,!1)}static parseConfigurationModel(c){return new E(c.contents,c.keys,c.overrides).freeze()}}e.Configuration=a;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const c=new Set,n=new Map;for(const l of s)l.keys.forEach(f=>c.add(f)),l.overrides.forEach(([f,r])=>{const h=(0,_.getOrSet)(n,f,new Set);r.forEach(v=>h.add(v))});const d=[];return n.forEach((l,f)=>d.push([f,[...l.values()]])),{keys:[...c.values()],overrides:d}}e.mergeChanges=p;class b{constructor(c,n,d,l){this.change=c,this.previous=n,this.currentConfiguraiton=d,this.currentWorkspace=l,this._previousConfiguration=void 0;const f=new Set;c.keys.forEach(h=>f.add(h)),c.overrides.forEach(([,h])=>h.forEach(v=>f.add(v))),this.affectedKeys=[...f.values()];const r=new E;this.affectedKeys.forEach(h=>r.setValue(h,{})),this.affectedKeysTree=r.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,c)){if(n){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(c,n,this.currentWorkspace);return!A.equals(d,l)}return!0}return!1}doesAffectedKeysTreeContains(c,n){let d=(0,O.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof d=="object"&&(l=Object.keys(d)[0]);){if(c=c[l],!c)return!1;d=d[l]}return!0}}e.ConfigurationChangeEvent=b;function u(s,c){const{added:n,removed:d,updated:l}=C(c?.rawConfiguration,s?.rawConfiguration),f=[],r=s?.getAllOverrideIdentifiers()||[],h=c?.getAllOverrideIdentifiers()||[];if(c){const v=h.filter(I=>!r.includes(I));for(const I of v)f.push([I,c.getKeysForOverrideIdentifier(I)])}if(s){const v=r.filter(I=>!h.includes(I));for(const I of v)f.push([I,s.getKeysForOverrideIdentifier(I)])}if(c&&s){for(const v of r)if(h.includes(v)){const I=C({contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)},{contents:c.getOverrideValue(void 0,v)||{},keys:c.getKeysForOverrideIdentifier(v)});f.push([v,[...I.added,...I.removed,...I.updated]])}}return{added:n,removed:d,updated:l,overrides:f}}function C(s,c){const n=s?c?s.keys.filter(f=>c.keys.indexOf(f)===-1):[...s.keys]:[],d=c?s?c.keys.filter(f=>s.keys.indexOf(f)===-1):[...c.keys]:[],l=[];if(s&&c){for(const f of c.keys)if(s.keys.indexOf(f)!==-1){const r=(0,O.getConfigurationValue)(c.contents,f),h=(0,O.getConfigurationValue)(s.contents,f);A.equals(r,h)||l.push(f)}}return{added:n,removed:d,updated:l}}}),define(De[90],Ce([1,0,12,3]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var S;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class F extends i.ErrorNoTelemetry{static isTemporarilyNotAvailable(A){return A instanceof F&&A._code===S.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof F&&A._code===S.NoResolverFound}static isHandled(A){return A instanceof F&&A.isHandled}constructor(A,y=S.Unknown,k){super(A),this._message=A,this._code=y,this._detail=k,this.isHandled=y===S.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,F.prototype)}}e.RemoteAuthorityResolverError=F}),define(De[61],Ce([1,0,13]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=D;function S(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=S;function F(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=F;function _(k){const{host:O,port:w}=y(k);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=_;function A(k,O){let{host:w,port:g}=y(k);return typeof g>"u"&&(g=O),{host:w,port:g}}e.parseAuthorityWithOptionalPort=A;function y(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=k.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const g=k.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:k,port:void 0}}}),define(De[25],Ce([1,0,10,3,61]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=F;function _(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,o){if(typeof t>"u"||t===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof t=="string"||typeof o=="string"){const a=typeof t=="string"?t:t.value,p=typeof o=="string"?o:o.value;return i.equalsIgnoreCase(a,p)}return t._lower===o._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=k;function O(m){return w(m)}e.isApplicationScopedExtension=O;function w(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function E(m,t){if(t){const o=`onResolveRemoteAuthority:${(0,S.getRemoteName)(t)}`;return m.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[155],Ce([1,0,10,85,25,20,2,12,48]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(c,n){return c.uuid&&n.uuid?c.uuid===n.uuid:c.id===n.id?!0:(0,i.compareIgnoreCase)(c.id,n.id)===0}e.areSameExtensions=k;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(n){const d=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new w(n.identifier,d,l)}static parse(n){const d=O.exec(n);return d&&d[1]&&d[2]?new w({id:d[1]},d[2],d[4]||void 0):null}constructor(n,d,l="undefined"){this.version=d,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof w?k(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=w;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(c){const n=g.exec(c);return n&&n[1]?[t(n[1]),n[2]]:[t(c),void 0]}e.getIdAndVersion=E;function m(c,n){return`${c}.${n}`}e.getExtensionId=m;function t(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function o(c,n){return t(m(c,n))}e.getGalleryExtensionId=o;function a(c,n){const d=[],l=f=>{for(const r of d)if(r.some(h=>k(n(h),n(f))))return r;return null};for(const f of c){const r=l(f);r?r.push(f):d.push([f])}return d}e.groupByExtension=a;function p(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function b(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function u(c,n){const d=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const f=l.shift();if(f&&d.every(r=>!k(r.identifier,{id:f}))){const r=c.filter(h=>k(h.identifier,{id:f}));r.length===1&&(d.push(r[0]),l.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=u;async function C(c,n){if(!F.isLinux)return!1;let d;try{d=(await c.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await c.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(f))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=C;async function s(c,n){const d=await C(c,n),l=(0,D.getTargetPlatform)(d?"alpine":F.platform,y.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=s}),define(De[156],Ce([1,0,20,48,2,38]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function A(k,O,w,g,E,m,t,o,a,p){const b=Object.create(null);b["common.machineId"]=t,b.sessionID=(0,F.generateUuid)()+Date.now(),b.commitHash=E,b.version=m,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,i.PlatformToString)(i.platform),b["common.nodePlatform"]=D.platform,b["common.nodeArch"]=g,b["common.product"]=p||"desktop",o&&(b["common.msftInternal"]=o);let u=0;const C=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-C,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),i.isLinuxSnap&&(b["common.snap"]="true");const s=_(w);s&&(b["common.platformDetail"]=s);try{const c=await k.readFile(S.URI.file(a));b["common.source"]=c.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(k){const O=D.env.USERDNSDOMAIN;if(!O)return!1;const w=O.toLowerCase();return k.some(g=>w===g)}e.verifyMicrosoftInternalDomain=y}),define(De[157],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var S;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(S=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[158],Ce([1,0,24,115,9,46,156,157]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,D.staticObservableValue)(0)}publicLog(d,l){return Promise.resolve(void 0)}publicLog2(d,l){return this.publicLog(d,l)}publicLogError(d,l){return Promise.resolve(void 0)}publicLogError2(d,l){return this.publicLogError(d,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class k{async publicLog(d,l,f){}async publicLogError(d,l,f){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function O(n,d){return d.onDidChangeConfiguration(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(l.source),configurationKeys:a(l.sourceConfig)})})}e.configurationTelemetry=O;function w(n,d){return!(d.disableTelemetry||!n.enableTelemetry||d.extensionTestsLocationURI)}e.supportsTelemetry=w;function g(n){const d=n.getValue(A.TELEMETRY_SETTING_ID),l=n.getValue("telemetry.enableCrashReporter");if(n.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=g;function E(n){const d={},l={},f={};o(n,f);for(let r in f){r=r.length>150?r.substr(r.length-149):r;const h=f[r];typeof h=="number"?l[r]=h:typeof h=="boolean"?l[r]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${h.length}`),d[r]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(d[r]=h)}return{properties:d,measurements:l}}e.validateTelemetryData=E;const m=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function t(n){if(!n)return"none";for(const d of m)if(n.startsWith(`${d}+`))return d;return"other"}e.cleanRemoteAuthority=t;function o(n,d,l=0,f){if(!!n)for(const r of Object.getOwnPropertyNames(n)){const h=n[r],v=f?f+r:r;Array.isArray(h)?d[v]=(0,i.safeStringify)(h):h instanceof Date?d[v]=h.toISOString():(0,S.isObject)(h)?l<2?o(h,d,l+1,v+"."):d[v]=(0,i.safeStringify)(h):d[v]=h}}function a(n){if(!n)return[];const d=[];return p(d,"",n),d}function p(n,d,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(f=>p(n,d?`${d}.${f}`:f,l[f])):n.push(d)}function b(n,d){const l=n.msftInternalDomains||[],f=d.getValue("telemetry.internalTesting");return(0,_.verifyMicrosoftInternalDomain)(l)||f}e.isInternalTelemetry=b;function u(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=u;function C(n,d){let l=n;const f=[];for(const I of d)for(;;){const L=I.exec(n);if(!L)break;f.push([L.index,I.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(l="";;){const I=h.exec(n);if(!I)break;!r.test(I[0])&&f.every(([L,j])=>I.index<L||I.index>=j)&&(l+=n.substring(v,I.index)+"<REDACTED: user-file-path>",v=h.lastIndex)}return v<n.length&&(l+=n.substr(v)),l}function s(n){if(!n)return n;const d=n.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of l)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return n}function c(n,d){return(0,i.cloneAndChange)(n,l=>{if(typeof l=="string"){let f=l;f=C(f,d);for(const r of d)f=f.replace(r,"");return f=s(f),f}})}e.cleanData=c}),define(De[159],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,F,_=5){const A=F(y=>{const k=typeof y=="string"?y:y.data;let O=this._terminalBufferMap.get(S);if(O){O.data.push(k);return}const w=setTimeout(()=>this.flushBuffer(S),_);O={data:[k],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(S),A.dispose()}},this._terminalBufferMap.set(S,O)});return A}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const F=this._terminalBufferMap.get(S);F&&(this._terminalBufferMap.delete(S),this._callback(S,F.data.join("")))}}e.TerminalDataBufferer=i}),define(De[160],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST_DARK="hcDark",F.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function D(F){return F===i.HIGH_CONTRAST_DARK||F===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=D;function S(F){return F===i.DARK||F===i.HIGH_CONTRAST_DARK}e.isDark=S}),define(De[62],Ce([1,0,118,4,7,3,30,160]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,F.createDecorator)("themeService");var y;(function(o){function a(p){return p&&typeof p=="object"&&typeof p.id=="string"}o.isThemeColor=a})(y=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var O;(function(o){function a(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||y.isThemeColor(d.color))}o.isThemeIcon=a;const p=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function b(d){const l=p.exec(d);if(!l)return;const[,f]=l;return{id:f}}o.fromString=b;function u(d){return{id:d}}o.fromId=u;function C(d,l){let f=d.id;const r=f.lastIndexOf("~");return r!==-1&&(f=f.substring(0,r)),l&&(f=`${f}~${l}`),{id:f}}o.modify=C;function s(d){const l=d.id.lastIndexOf("~");if(l!==-1)return d.id.substring(l+1)}o.getModifier=s;function c(d,l){return d.id===l.id&&d.color?.id===l.color?.id}o.isEqual=c;function n(d,l){return{id:d.id,color:l?k(l):void 0}}o.asThemeIcon=n,o.asClassNameArray=i.CSSIcon.asClassNameArray,o.asClassName=i.CSSIcon.asClassName,o.asCSSSelector=i.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function w(o){switch(o){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(a){return this.themingParticipants.push(a),this.onThemingParticipantAddedEmitter.fire(a),(0,S.toDisposable)(()=>{const p=this.themingParticipants.indexOf(a);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const E=new g;_.Registry.add(e.Extensions.ThemingContribution,E);function m(o){return E.onColorThemeChange(o)}e.registerThemingParticipant=m;class t extends S.Disposable{constructor(a){super(),this.themeService=a,this.theme=a.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(a){this.theme=a,this.updateStyles()}updateStyles(){}getColor(a,p){let b=this.theme.getColor(a);return b&&p&&(b=p(b,this.theme)),b?b.toString():null}}e.Themable=t}),define(De[161],Ce([1,0,4,20,3,11]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var _;(function(t){t.Http="http",t.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=w;function g(t,o){return o?o!==1&&t<1024:!D.isWindows&&t<1024}e.isPortPrivileged=g;class E{constructor(o,a,p){this.remoteAddress=o,this.localAddress=a,this._dispose=p,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let m=class{constructor(o){this.logService=o,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],a=Array.from(this._tunnels.values());for(const p of a){const b=Array.from(p.values());for(const u of b){const C=await u.value;C&&o.push(C)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:a}of o.values())await a.then(p=>p?.dispose());o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,a,p,b,u){this.addTunnelToMap(o,a,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:a,localAddress:p,privacy:b,protocol:u,dispose:()=>Promise.resolve()}))}openTunnel(o,a,p,b,u=!1,C,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${p} on local port ${b}.`),!o)return;if(a||(a="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.retainOrCreateTunnel(o,a,p,b,u,C,s);return c?c.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(a,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.makeTunnel(n);return(n.tunnelRemoteHost!==a||n.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(d),d}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const a=this._tunnels.get(o.tunnelRemoteHost);if(a){const p=a.get(o.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,p))}}}}async tryDisposeTunnel(o,a,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${a}.`);const b=p.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(a),b}}async closeTunnel(o,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${a} `);const p=this._tunnels.get(o);if(p&&p.has(a)){const b=p.get(a);b.refcount=0,await this.tryDisposeTunnel(o,a,b)}}addTunnelToMap(o,a,p){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(a,{refcount:1,value:p})}async removeEmptyTunnelFromMap(o,a){const p=this._tunnels.get(o);p&&(await p.get(a)||p.delete(a),p.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,a){const p=[o];O(o)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):w(o)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(u=>this._tunnels.get(u));for(const u of b){const C=u?.get(a);if(C)return C}}canTunnel(o){return!!k(o)}doIsPortPrivileged(o,a,p,b){if(a)return!1;if(p){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(u?.length===4){const C=parseInt(u[1]),s=parseInt(u[2]);if(C>10||C===10&&s>=14)return!1}}return o<1024}createWithProvider(o,a,p,b,u,C,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${p} on local port ${b}.`);const c=p;this._factoryInProgress.add(c);const n=b===void 0?p:b,d={elevationRequired:u?this.isPortPrivileged(n):!1},l={remoteAddress:{host:a,port:p},localAddressPort:b,privacy:C,public:C?C!==A.Private:void 0,protocol:s},f=o.forwardPort(l,d);return f?(this.addTunnelToMap(a,p,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(c)})):this._factoryInProgress.delete(c),f}};m=xe([We(0,F.ILogService)],m),e.AbstractTunnelService=m}),define(De[162],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var D;(function(S){S[S.Complete=100]="Complete",S[S.Partial=50]="Partial",S[S.None=0]="None"})(D=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[163],Ce([1,0,13]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function D(y){return y.scheme!==i.Schemas.file&&y.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=D;function S(y){if(y.folders.length)return y.folders.every(k=>D(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&D(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function F(y){return S(y)?.scheme}e.getVirtualWorkspaceScheme=F;function _(y){return S(y)?.authority}e.getVirtualWorkspaceAuthority=_;function A(y){return S(y)!==void 0}e.isVirtualWorkspace=A}),define(De[49],Ce([1,0,130,19,45,22,2,3,13]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function k(c){const n=c;return typeof n?.id=="string"&&_.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(c,n){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,D.basename)(c)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const d=c;if(d.configuration)return{id:d.id,configPath:d.configuration};if(d.folders.length===1)return{id:d.id,uri:d.folders[0].uri}}e.toWorkspaceIdentifier=O;function w(c){const n=c;return typeof n?.id=="string"&&_.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=w;function g(c){const n=c;if(n?.uri)return{id:n.id,uri:_.URI.revive(n.uri)};const d=c;if(d?.configPath)return{id:d.id,configPath:_.URI.revive(d.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=g;var E;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function m(c){const n=c;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=m;function t(c){const n=c;return!!(n&&typeof n=="object"&&_.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=t;class o{constructor(n,d,l,f,r){this._id=n,this._transient=l,this._configuration=f,this._ignorePathCasing=r,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class a{constructor(n,d){this.raw=d,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,F.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function p(c){return new a({uri:c,index:0,name:(0,F.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(c,n){return F.extUriBiasedIgnorePathCase.isEqualOrParent(c,n.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function u(c){let n;return _.URI.isUri(c)?n=c:n=c.configuration,n?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=u;function C(c,n){return!b(c,n)&&!u(c)}e.isSavedWorkspace=C;function s(c){return(typeof c=="string"?(0,D.extname)(c):(0,F.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[63],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const F=this._idPool++;return this._data.set(F,S),this.logDebugInfo(),F}get(S,F){return this._data.has(S)?this._data.get(S)[F]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!i.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=i,i.enableDebugLogging=!1}),define(De[36],Ce([1,0,13,22,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this._systemSchemes=new Set(Object.keys(i.Schemas)),this._providerInfo=new Map,this.extUri=new D.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(De[164],Ce([1,0,15]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class D{constructor(_,A,y){this._deferredPromises=new Map,this._id=_,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new i.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of k.values())O.complete()}catch(O){for(const w of k.values())w.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,A){let y=this._value[_];return typeof y>"u"&&(y=A),y}update(_,A){this._value[_]=A;const y=this._deferredPromises.get(_);if(y!==void 0)return y.p;const k=new i.DeferredPromise;return this._deferredPromises.set(_,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=D;class S extends D{setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}constructor(_,A){super(_.identifier.value,!0,A),this._extension=_}}e.ExtensionGlobalMemento=S}),define(De[165],Ce([1,0,4,2]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new i.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new i.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,A,y,k){const w=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(_)).acceptModelChanged(A.value,y,k);this._onDidChangeNotebookDocument.fire(w)}$acceptDirtyStateChanged(_,A){this._notebooksAndEditors.getNotebookDocument(D.URI.revive(_)).acceptDirty(A)}$acceptModelSaved(_){const A=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(_));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(De[14],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class D{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=D});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[166],Ce([1,0,25,4]),function(ne,e,i,D){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class F{constructor(A,y){S.set(this,void 0),this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._id=i.ExtensionIdentifier.toKey(A.identifier),Ye(this,S,y,"f"),Oe(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(A){return Oe(this,S,"f").get(this._id,A)}store(A,y){return Oe(this,S,"f").store(this._id,A,y)}delete(A){return Oe(this,S,"f").delete(this._id,A)}}e.ExtensionSecrets=F,S=new WeakMap}),define(De[64],Ce([1,0,3,161,4,14]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(y){function k(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:w.protocol}}y.fromApiTunnel=k;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==D.TunnelPrivacyId.ConstantPrivate&&w.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}y.fromServiceTunnel=O})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,w,g,E){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=xe([We(0,F.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(De[50],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class D{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=D}),define(De[167],Ce([1,0,23]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class D{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function S(A,y){if(y.serializeBuffersForPostMessage){const k=new D,O=(E,m)=>{if(m instanceof ArrayBuffer){const t=k.add(m);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(m)){const t=F(m);if(t){const o=k.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:t,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},w=JSON.stringify(A,O),g=k.buffers.map(E=>{const m=new Uint8Array(E);return i.VSBuffer.wrap(m)});return{message:w,buffers:g}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=S;function F(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(A,y){const k=y.map(g=>{const E=new ArrayBuffer(g.byteLength);return new Uint8Array(E).set(g.buffer),E}),O=y.length?(g,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const m=E,{index:t}=m,o=k[t];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return E}:void 0;return{message:JSON.parse(A,O),arrayBuffers:k}}e.deserializeWebviewMessage=_}),define(De[91],Ce([1,0,138,9,2,7,3,30,35,13]),function(ne,e,i,D,S,F,_,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var w;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(w=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(K){const te=K;return!!te&&typeof te.getSelection=="function"&&!!te.onDidChangeSelection}e.isEditorPaneWithSelection=g;function E(K,te,de){for(const re of de.visibleEditorPanes)if(re.group.id===te&&K.matches(re.input))return re.getViewState()}e.findViewStateForEditor=E;function m(K){if(l(K))return!1;const te=K;return S.URI.isUri(te?.resource)}e.isResourceEditorInput=m;function t(K){if(l(K))return!1;const te=K;return te?.original!==void 0&&te.modified!==void 0}e.isResourceDiffEditorInput=t;function o(K){if(l(K)||t(K))return!1;const te=K;return te?.primary!==void 0&&te.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function a(K){if(l(K))return!1;const te=K;return te?te.resource===void 0||te.resource.scheme===k.Schemas.untitled||te.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;const p=/Untitled-\d+/;function b(K){return K.scheme===k.Schemas.untitled&&K.path.length>1&&!p.test(K.path)}e.isUntitledWithAssociatedResource=b;function u(K){if(l(K))return!1;const te=K;return S.URI.isUri(te?.base?.resource)&&S.URI.isUri(te?.input1?.resource)&&S.URI.isUri(te?.input2?.resource)&&S.URI.isUri(te?.result?.resource)}e.isResourceMergeEditorInput=u;var C;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(C=e.Verbosity||(e.Verbosity={}));var s;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(te,de){let re=this.mapIdToSaveSource.get(te);return re||(re={source:te,label:de},this.mapIdToSaveSource.set(te,re)),re.source}getSourceLabel(te){return this.mapIdToSaveSource.get(te)?.label??te}}e.SaveSourceRegistry=new c;var n;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends F.Disposable{}e.AbstractEditorInput=d;function l(K){return K instanceof d}e.isEditorInput=l;function f(K){const te=K;return S.URI.isUri(te?.preferredResource)}function r(K){const te=K;return l(te?.primary)&&l(te?.secondary)}e.isSideBySideEditorInput=r;function h(K){const te=K;return l(te?.modified)&&l(te?.original)}e.isDiffEditorInput=h;function v(K){return l(K?.editor)}e.isEditorInputWithOptions=v;function I(K){const te=K;return v(K)&&te?.group!==void 0}e.isEditorInputWithOptionsAndGroup=I;function L(K){const te=K;return typeof te?.groupId=="number"&&l(te.editor)}e.isEditorIdentifier=L;var j;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var W;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(W=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var H;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(H=e.SideBySideEditor||(e.SideBySideEditor={}));class P{getOriginalUri(te,de){if(!te)return;if(u(te))return e.EditorResourceAccessor.getOriginalUri(te.result,de);if(de?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(de?.supportSideBySide===H.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===H.ANY)return this.getOriginalUri(be,{filterByScheme:de.filterByScheme})??this.getOriginalUri(le,{filterByScheme:de.filterByScheme});te=de.supportSideBySide===H.PRIMARY?be:le}}if(t(te)||o(te)||u(te))return;const re=f(te)?te.preferredResource:te.resource;return!re||!de||!de.filterByScheme?re:this.filterUri(re,de.filterByScheme)}getSideEditors(te){return r(te)||o(te)?{primary:te.primary,secondary:te.secondary}:h(te)||t(te)?{primary:te.modified,secondary:te.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(te,de){if(!te)return;if(u(te))return e.EditorResourceAccessor.getCanonicalUri(te.result,de);if(de?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(de?.supportSideBySide===H.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===H.ANY)return this.getCanonicalUri(be,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:de.filterByScheme});te=de.supportSideBySide===H.PRIMARY?be:le}}if(t(te)||o(te)||u(te))return;const re=te.resource;return!re||!de||!de.filterByScheme?re:this.filterUri(re,de.filterByScheme)}filterUri(te,de){if(Array.isArray(de)){if(de.some(re=>te.scheme===re))return te}else if(de===te.scheme)return te}}e.EditorResourceAccessor=new P;var M;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(te){const de=this.instantiationService=te.get(_.IInstantiationService);for(const[re,be]of this.editorSerializerConstructors)this.createEditorSerializer(re,be,de);this.editorSerializerConstructors.clear()}createEditorSerializer(te,de,re){const be=re.createInstance(de);this.editorSerializerInstances.set(te,be)}registerFileEditorFactory(te){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=te}getFileEditorFactory(){return(0,D.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(te,de){if(this.editorSerializerConstructors.has(te)||this.editorSerializerInstances.has(te))throw new Error(`A editor serializer with type ID '${te}' was already registered.`);return this.instantiationService?this.createEditorSerializer(te,de,this.instantiationService):this.editorSerializerConstructors.set(te,de),(0,F.toDisposable)(()=>{this.editorSerializerConstructors.delete(te),this.editorSerializerInstances.delete(te)})}getEditorSerializer(te){return this.editorSerializerInstances.get(typeof te=="string"?te:te.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new R);async function B(K,te,de){return!K||!K.length?[]:await Promise.all(K.map(async re=>{const be=S.URI.revive(re.fileUri);if(!be){de.info("Cannot resolve the path because it is not valid.",re);return}if(!await te.canHandleResource(be)){de.info("Cannot resolve the path because it cannot be handled",re);return}let fe=re.exists,Q=re.type;if(typeof fe!="boolean"||typeof Q!="number")try{Q=(await te.stat(be)).isDirectory?y.FileType.Directory:y.FileType.Unknown,fe=!0}catch(Se){de.error(Se),fe=!1}if(!fe&&re.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",re);return}if(Q===y.FileType.Directory){de.info("Cannot resolve the path because it is a directory",re);return}const pe={...re.options,pinned:!0};return fe?{resource:be,options:pe}:{resource:be,options:pe,forceUntitled:!0}}))}e.pathsToEditors=B;var x;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}));function U(K){const te=K;if(!te)return!1;const de=te;if(de.modified)return U(de.modified);const re=te;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.isTextEditorViewState=U}),define(De[65],Ce([1,0,13,2]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(A,y){return A.scheme===i.Schemas.http||A.scheme===i.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===i.Schemas.file&&(A=D.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:A.path})),D.URI.from({scheme:i.Schemas.https,authority:`${A.scheme}+${F(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=S;function F(A){return A.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function _(A){return A.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=_}),define(De[168],Ce([1,0,4,7,65]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(A,y,k){this._proxy=A,this._editors=y,this._remoteInfo=k,this._handlePool=0,this._disposables=new D.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const w of this._insets.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,k,O,w){let g;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===A){g=b;break}if(!g)throw new Error("not a visible editor");const E=this,m=this._handlePool++,t=new i.Emitter,o=new i.Emitter,a=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,S.asWebviewUri)(b,E._remoteInfo)}get cspSource(){return S.webviewGenericCspSource}set options(b){this._options=b,E._proxy.$setOptions(m,b)}get options(){return this._options}set html(b){this._html=b,E._proxy.$setHtml(m,b)}get html(){return this._html}get onDidReceiveMessage(){return t.event}postMessage(b){return E._proxy.$postMessage(m,b)}},p=new class{constructor(){this.editor=A,this.line=y,this.height=k,this.webview=a,this.onDidDispose=o.event}dispose(){E._insets.has(m)&&(E._insets.delete(m),E._proxy.$disposeEditorInset(m),o.fire(),o.dispose(),t.dispose())}};return this._proxy.$createEditorInset(m,g.id,g.value.document.uri,y+1,k,O||{},w.identifier,w.extensionLocation),this._insets.set(m,{editor:A,inset:p,onDidReceiveMessage:t}),p}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this._insets.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=F}),define(De[169],Ce([1,0,4,15,139]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,k,O){const w={command:A};if(y&&Object.keys(y).length>0&&(w.arguments=y),this.internalSend("request",w),typeof O=="number"){const g=setTimeout(()=>{clearTimeout(g);const E=this.pendingRequests.get(w.seq);if(E){this.pendingRequests.delete(w.seq);const m={type:"response",seq:0,request_seq:w.seq,success:!1,command:A,message:(0,S.localize)(0,null,O,A)};E(m)}},O)}return k&&this.pendingRequests.set(w.seq,k),w.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,D.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const y=A,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,k)=>A.set(k,y)),await(0,D.timeout)(500),A.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=F}),define(De[170],Ce([1,0,140,40,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new D.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new D.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new D.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new D.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new D.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new D.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new D.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new D.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new D.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new D.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new D.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new D.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new D.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new D.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new D.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new D.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new D.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new D.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new D.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new D.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new D.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new D.RawContextKey("breakpointAccessType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new D.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new D.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new D.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new D.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new D.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new D.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new D.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new D.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new D.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new D.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new D.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new D.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new D.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new D.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new D.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new D.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new D.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new D.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new D.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new D.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new D.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new D.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new D.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new D.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new D.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new D.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new D.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new D.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new D.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const F=g=>i.localize(51,null,g);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var _;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(_=e.State||(e.State={}));function A(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)(e.DEBUG_SERVICE_ID);var w;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[171],Ce([1,0,10,2,19,24,13]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(n,d,l){return n.replace(A,function(f,r){return d&&r.length>0&&r[0]!=="_"?f:l&&l.hasOwnProperty(r)?l[r]:f})}e.formatPII=y;function k(n){const d={};for(const l of Object.keys(n))l.startsWith("!")||(d[l]=n[l]);return d}e.filterExceptionsFromTelemetry=k;function O(n){return n.configuration.request==="attach"&&!w(n)&&(!n.parentSession||O(n.parentSession))}e.isSessionAttach=O;function w(n){let d=n.configuration.type;if(!!d)return d==="vslsShare"&&(d=n.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(d,"extensionhost")||(0,i.equalsIgnoreCase)(d,"pwa-extensionhost")?n:n.parentSession?w(n.parentSession):void 0}e.getExtensionHostDebugSession=w;function g(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=g;function E(n,d,l){let f,r=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=h.exec(n);){const I=v.index+1,L=I+v[0].length;if(I<=d&&L>=l){f=v[0],r=I;break}}if(f){const I=/\w+/g;let L=null;for(;(L=I.exec(f))&&!(L.index+1+r+L[0].length>=l););L&&(f=f.substring(0,I.lastIndex))}return f?{start:r,end:r+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(n){return!!(n&&n.match(m))}e.isUri=t;function o(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(t(n.path))return D.URI.parse(n.path);if((0,S.isAbsolute)(n.path))return D.URI.file(n.path)}return n.path}function a(n){if(typeof n.path=="object"){const d=D.URI.revive(n.path);if(d)return d.scheme===_.Schemas.file?d.fsPath:d.toString()}return n.path}function p(n,d){const l=d?o:a,f=(0,F.deepClone)(n);return u(f,(r,h)=>{r&&h&&(h.path=l(h))}),f}e.convertToDAPaths=p;function b(n,d){const l=d?o:a,f=(0,F.deepClone)(n);return u(f,(r,h)=>{!r&&h&&(h.path=l(h))}),f}e.convertToVSCPaths=b;function u(n,d){switch(n.type){case"event":{const l=n;switch(l.event){case"output":d(!1,l.body.source);break;case"loadedSource":d(!1,l.body.source);break;case"breakpoint":d(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=n;switch(l.command){case"setBreakpoints":d(!0,l.arguments.source);break;case"breakpointLocations":d(!0,l.arguments.source);break;case"source":d(!0,l.arguments.source);break;case"gotoTargets":d(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(f=>d(!1,f));break;default:break}break}case"response":{const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(f=>d(!1,f.source));break;case"loadedSources":l.body.sources.forEach(f=>d(!1,f));break;case"scopes":l.body.scopes.forEach(f=>d(!1,f.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(f=>d(!1,f.source));break;case"setBreakpoints":l.body.breakpoints.forEach(f=>d(!1,f.source));break;case"disassemble":l.body?.instructions.forEach(r=>d(!1,r.location));break;default:break}break}}}function C(n){return n.filter(d=>!d.presentation?.hidden).sort((d,l)=>d.presentation?l.presentation?d.presentation.group?l.presentation.group?d.presentation.group!==l.presentation.group?d.presentation.group.localeCompare(l.presentation.group):s(d.presentation.order,l.presentation.order):-1:l.presentation.group?1:s(d.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=C;function s(n,d){return typeof n!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:n-d}async function c(n,d){const l=n.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(l!=="none"&&(await d.saveAll(),l==="allEditorsInActiveGroup")){const f=d.activeEditorPane;f&&f.input.resource?.scheme===_.Schemas.untitled&&await d.save({editor:f.input,groupId:f.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=c}),define(De[66],Ce([1,0,23,34,172,79,13,19,20,40]),function(ne,e,i,D,S,F,_,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var g;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(g=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var p;(function(B){B.scheme=_.Schemas.vscodeNotebookCell;const x=["W","X","Y","Z","a","b","c","d","e","f"],U=new RegExp(`^[${x.join("")}]+`),K=7;function te(Q,pe){const Se=pe.toString(K),Ue=`${Se.length<x.length?x[Se.length-1]:"z"}${Se}s${(0,i.encodeBase64)(i.VSBuffer.fromString(Q.scheme),!0,!0)}`;return Q.with({scheme:B.scheme,fragment:Ue})}B.generate=te;function de(Q){if(Q.scheme!==B.scheme)return;const pe=Q.fragment.indexOf("s");if(pe<0)return;const Se=parseInt(Q.fragment.substring(0,pe).replace(U,""),K),Fe=(0,i.decodeBase64)(Q.fragment.substring(pe+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Q.with({scheme:Fe,fragment:null})}}B.parse=de;function re(Q,pe){return Q.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Q.scheme!==_.Schemas.file?Q.scheme:""}`})}B.generateCellOutputUri=re;function be(Q){if(Q.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!pe)return;const Se=pe[1]&&pe[1]!==""?pe[1]:void 0,Fe=pe[2];return{outputId:Se,notebook:Q.with({scheme:Fe||_.Schemas.file,fragment:null})}}B.parseCellOutputUri=be;function le(Q,pe,Se){return B.generate(Q,pe).with({scheme:Se})}B.generateCellPropertyUri=le;function fe(Q,pe){if(Q.scheme===pe)return B.parse(Q.with({scheme:B.scheme}))}B.parseCellPropertyUri=fe})(p=e.CellUri||(e.CellUri={}));const b=B=>y.isWindows?B.replace(/\//g,"\\"):B;class u{constructor(x=[],U=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=U,this.order=[...new Set(x)].map(K=>({pattern:K,matches:D.parse(b(K))}))}sort(x){const U=new Map(S.Iterable.map(x,te=>[te,b(te)]));let K=[];for(const{matches:te}of this.order)for(const[de,re]of U)if(te(re)){K.push(de),U.delete(de);break}return U.size&&(K=K.concat([...U.keys()].sort((te,de)=>this.defaultOrder.indexOf(te)-this.defaultOrder.indexOf(de)))),K}prioritize(x,U){const K=this.findIndex(x);if(K===-1){this.order.unshift({pattern:x,matches:D.parse(b(x))});return}const te=new Set(U.map(re=>this.findIndex(re,K)));te.delete(-1);const de=Array.from(te).sort();this.order.splice(K+1,0,...de.map(re=>this.order[re]));for(let re=de.length-1;re>=0;re--)this.order.splice(de[re],1)}toArray(){return this.order.map(x=>x.pattern)}findIndex(x,U=this.order.length){const K=b(x);for(let te=0;te<U;te++)if(this.order[te].matches(K))return te;return-1}}e.MimeTypeDisplayOrder=u;function C(B,x,U,K=(te,de)=>te===de){const te=[];function de(le,fe,Q){if(fe===0&&Q.length===0)return;const pe=te[te.length-1];pe&&pe.start+pe.deleteCount===le?(pe.deleteCount+=fe,pe.toInsert.push(...Q)):te.push({start:le,deleteCount:fe,toInsert:Q})}let re=0,be=0;for(;;){if(re===B.length){de(re,0,x.slice(be));break}if(be===x.length){de(re,B.length-re,[]);break}const le=B[re],fe=x[be];if(K(le,fe)){re+=1,be+=1;continue}U(fe)?(de(re,1,[]),re+=1):(de(re,0,[fe]),be+=1)}return te}e.diff=C,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(B){const x=B;return!!((typeof x.include=="string"||D.isRelativePattern(x.include))&&(typeof x.exclude=="string"||D.isRelativePattern(x.exclude)))}e.isDocumentExcludePattern=c;function n(B,x,U){if(Array.isArray(B.viewType)&&B.viewType.indexOf(x)>=0||B.viewType===x)return!0;if(B.filenamePattern){const K=c(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,te=c(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(D.match(K,(0,A.basename)(U.fsPath).toLowerCase()))return!(te&&D.match(te,(0,A.basename)(U.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var d;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(x){return`${l._prefix}${x}`}static parse(x){if(x.startsWith(l._prefix))return x.substring(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l._prefix="notebook/";function f(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=f;const r=new TextDecoder;function h(B){const x=[];let U=!1;for(const K of B)(x.length===0||U)&&(x.push(K),U=!0);return j(x),R(i.VSBuffer.concat(x.map(K=>i.VSBuffer.wrap(K))))}e.compressOutputItemStreams=h;const v=`${String.fromCharCode(27)}[A`,I=v.split("").map(B=>B.charCodeAt(0)),L=10;function j(B){B.forEach((x,U)=>{if(U===0||x.length<v.length)return;const K=B[U-1],te=x.subarray(0,v.length);if(te[0]===I[0]&&te[1]===I[1]&&te[2]===I[2]){const de=K.lastIndexOf(L);if(de===-1)return;B[U-1]=K.subarray(0,de),B[U]=x.subarray(v.length)}})}function W(B){let x=B;do B=x,x=B.replace(/[^\n]\x08/gm,"");while(x.length<B.length);return B}function H(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const x=B.match(/^(.*)\r+/m)[1];let U=B.match(/\r+(.*)$/m)[1];U=U+x.slice(U.length,x.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,U)}return B}const P="\b".charCodeAt(0),M="\r".charCodeAt(0);function R(B){return!B.buffer.includes(P)&&!B.buffer.includes(M)?B:i.VSBuffer.fromString(H(W(r.decode(B.buffer))))}}),define(De[173],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var D;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(D=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(De[174],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=i;function D(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=D;function S(_){return Array.from(_.entries()).map(A=>[A[0],i(A[1].map)])}e.serializeEnvironmentVariableCollections=S;function F(_){return new Map(_.map(A=>[A[0],{map:D(A[1])}]))}e.deserializeEnvironmentVariableCollections=F}),define(De[41],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(F){F.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var D;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(D=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(_,A,y=_.parent){if(_._isRoot)return new S([A]);const k=[_.id];for(let O=y;O&&O.id!==A;O=O.parent)k.push(O.id);return k.push(A),new S(k.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const A=_.indexOf("\0");return A===-1?_:_.slice(0,A)}static fromString(_){return new S(_.split("\0"))}static join(_,A){return new S([..._.path,A])}static joinToString(_,A){return _.toString()+"\0"+A}static parentId(_){const A=_.lastIndexOf("\0");return A===-1?void 0:_.slice(0,A)}static compare(_,A){return _===A?0:A.startsWith(_+"\0")?2:_.startsWith(A+"\0")?3:1}constructor(_,A=_.length){if(this.path=_,this.viewEnd=A,_.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new S(this.path,_)}*idsToRoot(){for(let _=this.viewEnd;_>0;_--)yield new S(this.path,_)}compare(_){if(typeof _=="string")return S.compare(this.toString(),_);for(let A=0;A<_.viewEnd&&A<this.viewEnd;A++)if(_.path[A]!==this.path[A])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=S}),define(De[51],Ce([1,0,2,52,41]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var F;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(F=e.TestResultState||(e.TestResultState={}));var _;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(_=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(r){r.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),r.deserialize=h=>({range:D.Range.lift(h.range),uri:i.URI.revive(h.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var k;(function(r){r.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.serialize(h.location)}),r.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.deserialize(h.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(r,h)=>`${h?"s":"e"}${r}`;e.getMarkId=O;var w;(function(r){r.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.serialize(h.location)}),r.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.deserialize(h.location)})})(w=e.ITestOutputMessage||(e.ITestOutputMessage={}));var g;(function(r){r.serialize=h=>h.type===0?k.serialize(h):w.serialize(h),r.deserialize=h=>h.type===0?k.deserialize(h):w.deserialize(h)})(g=e.ITestMessage||(e.ITestMessage={}));var E;(function(r){r.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),r.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(g.serialize)}),r.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(g.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",t=(r,h)=>r+m+h;e.namespaceTestTag=t;const o=r=>{const h=r.indexOf(m);return{ctrlId:r.slice(0,h),tagId:r.slice(h+1)}};e.denamespaceTestTag=o;var a;(function(r){r.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),r.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?i.URI.revive(h.uri):void 0,range:h.range?D.Range.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(a=e.ITestItem||(e.ITestItem={}));var p;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var b;(function(r){r.serialize=h=>({expand:h.expand,item:a.serialize(h.item)}),r.deserialize=h=>({controllerId:S.TestId.root(h.item.extId),expand:h.expand,item:a.deserialize(h.item)})})(b=e.InternalTestItem||(e.InternalTestItem={}));var u;(function(r){r.serialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.uri!==void 0&&(v.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(v.range=h.item.range?.toJSON()),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}},r.deserialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.range!==void 0&&(v.range=h.item.range?D.Range.lift(h.item.range):null),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}}})(u=e.ITestItemUpdate||(e.ITestItemUpdate={}));const C=(r,h)=>{h.expand!==void 0&&(r.expand=h.expand),h.item!==void 0&&(r.item=r.item?Object.assign(r.item,h.item):h.item)};e.applyTestItemUpdate=C;var s;(function(r){r.serializeWithoutMessages=h=>({...b.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serializeWithoutMessages),retired:h.retired}),r.serialize=h=>({...b.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serialize),retired:h.retired}),r.deserialize=h=>({...b.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var c;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(c=e.DetailType||(e.DetailType={}));var n;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(r){r.deserialize=h=>h.op===0?{op:h.op,item:b.deserialize(h.item)}:h.op===1?{op:h.op,item:u.deserialize(h.item)}:h.op===2?{op:h.op,uri:i.URI.revive(h.uri),docv:h.docv}:h,r.serialize=h=>h.op===0?{op:h.op,item:b.serialize(h.item)}:h.op===1?{op:h.op,item:u.serialize(h.item)}:h})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class l{add(h){}update(h){}remove(h,v){}complete(){}}e.IncrementalChangeCollector=l;class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(h){const v=this.createChangeCollector();for(const I of h)switch(I.op){case 0:{const L=b.deserialize(I.item),j=S.TestId.parentId(L.item.extId)?.toString();if(j){if(this.items.has(j)){const W=this.items.get(j);W.children.add(L.item.extId);const H=this.createItem(L,W);this.items.set(L.item.extId,H),v.add(H)}}else{const W=this.createItem(L);this.roots.add(W),this.items.set(L.item.extId,W),v.add(W)}L.expand===2&&this.busyControllerCount++;break}case 1:{const L=u.deserialize(I.item),j=this.items.get(L.extId);if(!j)break;L.expand!==void 0&&(j.expand===2&&this.busyControllerCount--,L.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,L),v.update(j);break}case 3:{const L=this.items.get(I.itemId);if(!L)break;const j=S.TestId.parentId(L.item.extId)?.toString();j?this.items.get(j).children.delete(L.item.extId):this.roots.delete(L);const W=[[I.itemId]];for(;W.length;)for(const H of W.pop()){const P=this.items.get(H);P&&(W.push(P.children),this.items.delete(H),v.remove(P,P!==L),P.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(I.itemId);break;case 4:this.updatePendingRoots(I.amount);break;case 6:this._tags.set(I.tag.id,I.tag);break;case 7:this._tags.delete(I.id);break}v.complete()}retireTest(h){}updatePendingRoots(h){this.pendingRootCount+=h}createChangeCollector(){return new l}}e.AbstractIncrementalTestCollection=f}),define(De[67],Ce([1,0,15,4,7,47,51,41]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(a,p)=>a===p,O={range:(a,p)=>a===p?!0:!a||!p?!1:a.equalsRange(p),busy:k,label:k,description:k,error:k,tags:(a,p)=>!(a.length!==p.length||a.some(b=>!p.includes(b)))},w=(a,p)=>{let b;for(const[u,C]of Object.entries(O))C(a[u],p[u])||(b?b[u]=p[u]:b={[u]:p[u]});return b};class g extends S.Disposable{get root(){return this.options.root}constructor(p){super(),this.options=p,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new D.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(p){this._resolveHandler=p;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){switch(p.op){case 2:{for(const b of this.diff)if(b.op===2&&b.uri===p.uri){b.docv=p.docv;return}break}case 1:{const b=this.diff[this.diff.length-1];if(b){if(b.op===1&&b.item.extId===p.item.extId){(0,_.applyTestItemUpdate)(b.item,p.item);return}if(b.op===0&&b.item.item.extId===p.item.extId){(0,_.applyTestItemUpdate)(b.item,p.item);return}}break}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,b){const u=this.tree.get(p);if(!!u){if((u.expandLevels===void 0||b>u.expandLevels)&&(u.expandLevels=b),u.expand===1){const C=this.resolveChildren(u);return C.isOpen()?this.expandChildren(u,b-1):C.wait().then(()=>this.expandChildren(u,b-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,b-1)):this.expandChildren(u,b-1)}}dispose(){for(const p of this.tree.values())this.options.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,b){switch(b.op){case 3:this.removeItem(A.TestId.joinToString(p.fullId,b.id));break;case 0:this.upsertItem(b.item,p);break;case 5:for(const u of b.ops)this.onTestItemEvent(p,u);break;case 1:this.diffTagRefs(b.new,b.old,p.fullId.toString());break;case 2:this.updateExpandability(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:b.update}});break;case 6:this.documentSynced(p.actual.uri);break;default:(0,F.assertNever)(b)}}documentSynced(p){p&&this.pushDiff({op:2,uri:p,docv:this.options.getDocumentVersion(p)})}upsertItem(p,b){const u=A.TestId.fromExtHostTestItem(p,this.root.id,b?.actual),C=this.options.getApiFor(p);C.parent&&C.parent!==b?.actual&&this.options.getChildren(C.parent).delete(p.id);let s=this.tree.get(u.toString());if(!s){s={fullId:u,actual:p,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(p,b),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(p)}}),this.connectItemAndChildren(p,s,b);return}if(s.actual===p){this.connectItem(p,s,b);return}const c=this.options.getChildren(s.actual),n=s.actual,d=w(this.options.toITestItem(n),this.options.toITestItem(p));this.options.getApiFor(n).listener=void 0,s.actual=p,s.expand=0,d&&(d.hasOwnProperty("tags")&&(this.diffTagRefs(p.tags,n.tags,u.toString()),delete d.tags),this.onTestItemEvent(s,{op:4,update:d})),this.connectItemAndChildren(p,s,b);for(const[l,f]of c)this.options.getChildren(p).get(f.id)||this.removeItem(A.TestId.joinToString(u,f.id));this.documentSynced(s.actual.uri)}diffTagRefs(p,b,u){const C=new Set(b.map(s=>s.id));for(const s of p)C.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:u,item:{tags:p.map(s=>(0,_.namespaceTestTag)(this.options.controllerId,s.id))}}}),C.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const b=this.tags.get(p.id);b?b.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,p.id)}}))}decrementTagRefs(p){const b=this.tags.get(p);b&&!--b.refCount&&(this.tags.delete(p),this.pushDiff({op:7,id:(0,_.namespaceTestTag)(this.options.controllerId,p)}))}setItemParent(p,b){this.options.getApiFor(p).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(p,b,u){this.setItemParent(p,u);const C=this.options.getApiFor(p);C.parent=u?.actual,C.listener=s=>this.onTestItemEvent(b,s),this.updateExpandability(b)}connectItemAndChildren(p,b,u){this.connectItem(p,b,u);for(const[C,s]of this.options.getChildren(p))this.upsertItem(s,b)}updateExpandability(p){let b;this._resolveHandler?p.resolveBarrier?b=p.resolveBarrier.isOpen()?3:2:b=p.actual.canResolveChildren?1:0:b=0,b!==p.expand&&(p.expand=b,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:b}}),b===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,b){if(b<0)return;const u=[];for(const[C,s]of this.options.getChildren(p.actual)){const c=this.expand(A.TestId.joinToString(p.fullId,s.id),b);(0,i.isThenable)(c)&&u.push(c)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const s=new i.Barrier;return s.open(),s}p.expand=2,this.pushExpandStateUpdate(p);const b=p.resolveBarrier=new i.Barrier,u=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let C;try{C=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(s){u(s)}return(0,i.isThenable)(C)?C.catch(u).then(()=>{b.open(),this.updateExpandability(p)}):(b.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const b=this.tree.get(p);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const u=[b];for(;u.length;){const C=u.pop();if(!!C){this.options.getApiFor(C.actual).listener=void 0;for(const s of C.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(C.fullId.toString());for(const[s,c]of this.options.getChildren(C.actual))u.push(this.tree.get(A.TestId.joinToString(C.fullId,c.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.TestItemCollection=g;class E extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=E;class m extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class t extends Error{constructor(p,b,u){super(`TestItem with ID "${p}" is from controller "${b}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=t;const o=(a,p,b)=>{let u=new Map;return{get size(){return u.size},forEach(C,s){for(const c of u.values())C.call(s,c,this)},[Symbol.iterator](){return u.entries()},replace(C){const s=new Map,c=new Set(u.keys()),n={op:5,ops:[]};for(const d of C){if(!(d instanceof b))throw new m(d.id);const l=p(d).controllerId;if(l!==a.controllerId)throw new t(d.id,l,a.controllerId);if(s.has(d.id))throw new E(d.id);s.set(d.id,d),c.delete(d.id),n.ops.push({op:0,item:d})}for(const d of c.keys())n.ops.push({op:3,id:d});a.listener?.(n),u=s},add(C){if(!(C instanceof b))throw new m(C.id);u.set(C.id,C),a.listener?.({op:0,item:C})},delete(C){u.delete(C)&&a.listener?.({op:3,id:C})},get(C){return u.get(C)},toJSON(){return Array.from(u.values())}}};e.createTestItemChildren=o}),define(De[92],Ce([1,0,67]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const D=new WeakMap,S=(_,A)=>{const y={controllerId:A};return D.set(_,y),y};e.createPrivateApiFor=S;const F=_=>{const A=D.get(_);if(!A)throw new i.InvalidTestItemError(_?.id||"<unknown>");return A};e.getPrivateApiFor=F}),define(De[175],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var D;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(D=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(_,A){super(A),this.variable=_}}e.VariableError=S}),define(De[176],Ce([1,0,19,48,9,24,20,82,143,175,10]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(E,m,t,o){this._contributedVariables=new Map,this._context=E,this._labelService=m,this._userHomePromise=t,o&&(this._envVariablesPromise=o.then(a=>this.prepareEnv(a)))}prepareEnv(E){if(_.isWindows){const m=Object.create(null);return Object.keys(E).forEach(t=>{m[t.toLowerCase()]=E[t]}),m}return E}resolveWithEnvironment(E,m,t){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},m?m.uri:void 0,t)}async resolveAsync(E,m){const t={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(t,E?E.uri:void 0,m)}async resolveAnyBase(E,m,t,o){const a=F.deepClone(m);_.isWindows&&a.windows?Object.keys(a.windows).forEach(b=>a[b]=a.windows[b]):_.isMacintosh&&a.osx?Object.keys(a.osx).forEach(b=>a[b]=a.osx[b]):_.isLinux&&a.linux&&Object.keys(a.linux).forEach(b=>a[b]=a.linux[b]),delete a.windows,delete a.osx,delete a.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,E?E.uri:void 0,a,t,o)}async resolveAnyAsync(E,m,t){return this.resolveAnyBase(E,m,t)}async resolveAnyMap(E,m,t){const o=new Map;return{newConfig:await this.resolveAnyBase(E,m,t,o),resolvedVariables:o}}resolveWithInteractionReplace(E,m,t,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,m,t,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,m){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,m)}async recursiveResolve(E,m,t,o,a){if(S.isString(t))return this.resolveString(E,m,t,o,a);if(Array.isArray(t))return Promise.all(t.map(p=>this.recursiveResolve(E,m,p,o,a)));if(S.isObject(t)){const p=Object.create(null),b=await Promise.all(Object.keys(t).map(async u=>[await this.resolveString(E,m,u,o,a),await this.recursiveResolve(E,m,t[u],o,a)]));for(const[u,C]of b)p[u]=C;return p}return t}resolveString(E,m,t,o,a){return(0,O.replaceAsync)(t,w.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(w.VARIABLE_LHS))return p;let u=await this.evaluateSingleVariable(E,p,b,m,o);return a?.set(b,u),u!==p&&S.isString(u)&&u.match(w.VARIABLE_REGEXP)&&(u=await this.resolveString(E,m,u,o,a)),u})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,m,t,o,a){let p;const b=t.split(":");b.length>1&&(t=b[0],p=b[1]);const u=c=>{const n=this._context.getFilePath();if(n)return n;throw new k.VariableError(c,(0,y.localize)(0,null,m))},C=c=>{const n=u(c);if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new k.VariableError(c,(0,y.localize)(1,null,m,i.basename(n)))},s=c=>{if(p){const n=this._context.getFolderUri(p);if(n)return n;throw new k.VariableError(c,(0,y.localize)(2,null,m,p))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(c,(0,y.localize)(3,null,m)):new k.VariableError(c,(0,y.localize)(4,null,m))};switch(t){case"env":if(p){if(E.env){const c=E.env[_.isWindows?p.toLowerCase():p];if(S.isString(c))return c}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(p){const c=this._context.getConfigurationValue(o,p);if(S.isUndefinedOrNull(c))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,m,p));if(S.isObject(c))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,m,p));return c}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.resolveFromMap(k.VariableKind.Command,m,p,a,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,m,p,a,"input");case"extensionInstallFolder":if(p){const c=await this._context.getExtension(p);if(!c)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,p));return this.fsPath(c.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(s(k.VariableKind.WorkspaceFolder)));case"cwd":return o||p?(0,A.normalizeDriveLetter)(this.fsPath(s(k.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(this.fsPath(s(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(E.userHome)return E.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return u(k.VariableKind.File);case"fileWorkspaceFolder":return C(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||p?i.relative(this.fsPath(s(k.VariableKind.RelativeFile)),u(k.VariableKind.RelativeFile)):u(k.VariableKind.RelativeFile);case"relativeFileDirname":{const c=i.dirname(u(k.VariableKind.RelativeFileDirname));if(o||p){const n=i.relative(this.fsPath(s(k.VariableKind.RelativeFileDirname)),c);return n.length===0?".":n}return c}case"fileDirname":return i.dirname(u(k.VariableKind.FileDirname));case"fileExtname":return i.extname(u(k.VariableKind.FileExtname));case"fileBasename":return i.basename(u(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=i.basename(u(k.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-i.extname(c).length)}case"fileDirnameBasename":return i.basename(i.dirname(u(k.VariableKind.FileDirnameBasename)));case"execPath":{const c=this._context.getExecPath();return c||m}case"execInstallFolder":{const c=this._context.getAppRoot();return c||m}case"pathSeparator":return i.sep;default:try{const c=p?`${t}:${p}`:t;return this.resolveFromMap(k.VariableKind.Unknown,m,c,a,void 0)}catch{return m}}}}resolveFromMap(E,m,t,o,a){if(t&&o){const p=a===void 0?o[t]:o[a+":"+t];if(typeof p=="string")return p;throw new k.VariableError(E,(0,y.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[93],Ce([1,0,3,91]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var S;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var F;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(F=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var A;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(m){const t=m;return(0,D.isEditorInput)(t?.editor)&&(0,D.isEditorInput)(t?.replacement)}e.isEditorReplacement=k;var O;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function g(m){const t=m;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=g;function E(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(De[177],Ce([1,0,3,93]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(F){const _=F;return typeof F=="number"||(0,D.isEditorGroup)(_)}e.isPreferredGroup=S}),define(De[178],Ce([1,0,3,148]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(D.IEnvironmentService)}),define(De[179],Ce([1,0,25,4,19]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class F{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=F;class _{constructor(w){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=w,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const w of this._extensionDescriptions){if(this._extensionsMap.has(i.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(i.ExtensionIdentifier.toKey(w.identifier),w),this._extensionsArr.push(w),Array.isArray(w.activationEvents))for(let g of w.activationEvents)g==="onUri"&&(g=`onUri:${i.ExtensionIdentifier.toKey(w.identifier)}`),this._activationMap.has(g)||this._activationMap.set(g,[]),this._activationMap.get(g).push(w)}}set(w){this._extensionDescriptions=w,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(w,g){this._extensionDescriptions=k(this._extensionDescriptions,g),this._extensionDescriptions=this._extensionDescriptions.concat(w);const E=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,E.map(m=>m.identifier)),this._initialize(),this._onDidChange.fire(void 0),new F(E)}static _findLoopingExtensions(w){const g=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(a){this._nodesSet.has(a)||(this._nodesSet.add(a),this._nodesArr.push(a))}addArc(a,p){this.addNode(a),this.addNode(p),this._arcs.has(a)?this._arcs.get(a).push(p):this._arcs.set(a,[p])}getArcs(a){return this._arcs.has(a)?this._arcs.get(a):[]}hasOnlyGoodArcs(a,p){const b=g.getArcs(a);for(let u=0;u<b.length;u++)if(!p.has(b[u]))return!1;return!0}getNodes(){return this._nodesArr}},E=new Map;for(const a of w){const p=i.ExtensionIdentifier.toKey(a.identifier);if(E.set(p,a),a.extensionDependencies)for(const b of a.extensionDependencies){const u=i.ExtensionIdentifier.toKey(b);g.addArc(p,u)}}const m=new Set;g.getNodes().filter(a=>g.getArcs(a).length===0).forEach(a=>m.add(a));const t=g.getNodes().filter(a=>!m.has(a));let o;do{o=!1;for(let a=0;a<t.length;a++){const p=t[a];g.hasOnlyGoodArcs(p,m)&&(t.splice(a,1),a--,m.add(p),o=!0)}}while(o);return t.map(a=>E.get(a))}containsActivationEvent(w){return this._activationMap.has(w)}containsExtension(w){return this._extensionsMap.has(i.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const g=this._activationMap.get(w);return g?g.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(w){const g=this._extensionsMap.get(i.ExtensionIdentifier.toKey(w));return g||void 0}getExtensionDescriptionByUUID(w){for(const g of this._extensionsArr)if(g.uuid===w)return g}getExtensionDescriptionByIdOrUUID(w,g){return this.getExtensionDescription(w)??(g?this.getExtensionDescriptionByUUID(g):void 0)}}e.ExtensionDescriptionRegistry=_;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function y(O,w){const g=O.isBuiltin?0:O.isUnderDevelopment?2:1,E=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(g!==E)return g-E;const m=S.posix.basename(O.extensionLocation.path),t=S.posix.basename(w.extensionLocation.path);return m<t?-1:m>t?1:0}function k(O,w){const g=new Set;return w.forEach(E=>g.add(i.ExtensionIdentifier.toKey(E))),O.filter(E=>!g.has(i.ExtensionIdentifier.toKey(E.identifier)))}}),define(De[68],Ce([1,0,23]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var D;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var F;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(F=e.MessageType||(e.MessageType={}));function _(k){const O=i.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=_;function A(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[69],Ce([1,0,3,4,11,26,68,61,158,24,2]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let w=class{constructor(t,o){this.initData=t,this._onDidChangeTelemetryEnabled=new D.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new D.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=o.createLogger(O.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(t,o){const a=this.getTelemetryDetails(),p=new g(o,t,this._outputLogger,this.getBuiltInCommonProperties(t),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled});return this._telemetryLoggers.set(t.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(t,o){this._level=t,this._productConfig=o||{usage:!0,error:!0}}getBuiltInCommonProperties(t){const o={};switch(o["common.extname"]=t.name,o["common.extversion"]=t.version,o["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,o["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,o["common.vscodeversion"]=this.initData.version,o["common.isnewappinstall"]=E(this.initData.telemetryInfo.firstSessionDate),o["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case _.UIKind.Web:o["common.uikind"]="web";break;case _.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),o}$onDidChangeTelemetryLevel(t){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=t;const o=this.getTelemetryDetails();this._telemetryLoggers.forEach(a=>{a.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(t,o){const a=this._telemetryLoggers.get(t.value);return a?(a.logError(o),!0):!1}};w=xe([We(0,F.IExtHostInitDataService),We(1,S.ILoggerService)],w),e.ExtHostTelemetry=w;class g{constructor(t,o,a,p,b){this._extension=o,this._logger=a,this._commonProperties=p,this._onDidChangeEnableStates=new D.Emitter,this._appender=t,this._telemetryEnablements={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(t,o){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:t,isErrorsEnabled:o},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(t){return this._appender.ignoreBuiltInCommonProperties||(t=(0,k.mixin)(t,this._commonProperties)),this._appender.additionalCommonProperties&&(t=(0,k.mixin)(t,this._appender.additionalCommonProperties)),t=(0,y.cleanData)(t,[]),t}logEvent(t,o){t=this._extension.identifier.value+"/"+t,o=this.mixInCommonPropsAndCleanData(o||{}),this._appender.logEvent(t,o),this._logger.trace(t,o)}logUsage(t,o){!this._telemetryEnablements.isUsageEnabled||this.logEvent(t,o)}logError(t,o){!this._telemetryEnablements.isErrorsEnabled||(typeof t=="string"?this.logEvent(t,o):this._appender.logException(t,o))}get apiTelemetryLogger(){if(!this._apiObject){const t=this,o={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return t._telemetryEnablements.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t._onDidChangeEnableStates.event.bind(t)};this._apiObject=Object.freeze(o)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=g;function E(m){const t=Date.now()-new Date(m).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(De[27],Ce([1,0,4,2,3,25,155]),function(ne,e,i,D,S,F,_){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new F.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(f){this.affinity=f,this.kind=1}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(){this.kind=2,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class w{constructor(f){this.dependency=f}}e.MissingExtensionDependency=w;var g;(function(l){l[l.LocalProcess=1]="LocalProcess",l[l.LocalWebWorker=2]="LocalWebWorker",l[l.Remote=3]="Remote"})(g=e.ExtensionHostKind||(e.ExtensionHostKind={}));function E(l){if(l===null)return"None";switch(l){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=E;class m{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(f,r){const h=[],v=[],I=[],L=[],j=a(this._allExtensions),W=a(f),H=(B,x)=>B.extensionLocation.toString()===x.extensionLocation.toString()||B.isBuiltin===x.isBuiltin||B.isUserBuiltin===x.isUserBuiltin||B.isUnderDevelopment===x.isUnderDevelopment;for(const B of this._allExtensions){const x=W.get(F.ExtensionIdentifier.toKey(B.identifier));if(!x){h.push(B.identifier),j.delete(F.ExtensionIdentifier.toKey(B.identifier));continue}if(!H(B,x)){h.push(B.identifier),j.delete(F.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of f){const x=j.get(F.ExtensionIdentifier.toKey(B.identifier));if(!x){v.push(B);continue}if(!H(x,B)){h.push(x.identifier),j.delete(F.ExtensionIdentifier.toKey(x.identifier));continue}}const P=o(this._myExtensions),M=o(r);for(const B of this._myExtensions)M.has(F.ExtensionIdentifier.toKey(B))||I.push(B);for(const B of r)P.has(F.ExtensionIdentifier.toKey(B))||L.push(B);const R={toRemove:h,toAdd:v,myToRemove:I,myToAdd:L};return this.delta(R),R}delta(f){const{toRemove:r,toAdd:h,myToRemove:v,myToAdd:I}=f,L=o(r),j=o(v);for(let W=0;W<this._allExtensions.length;W++)L.has(F.ExtensionIdentifier.toKey(this._allExtensions[W].identifier))&&(this._allExtensions.splice(W,1),W--);for(let W=0;W<this._myExtensions.length;W++)j.has(F.ExtensionIdentifier.toKey(this._myExtensions[W]))&&(this._myExtensions.splice(W,1),W--);for(const W of h)this._allExtensions.push(W);for(const W of I)this._myExtensions.push(W)}containsExtension(f){for(const r of this._myExtensions)if(F.ExtensionIdentifier.equals(r,f))return!0;return!1}}e.ExtensionHostExtensions=m;class t{constructor(f){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=F.ExtensionIdentifier.toKey,f)for(const r of f)this.add(r)}get size(){return this._map.size}add(f){return this._map.set(this._toKey(f),f),this}clear(){this._map.clear()}delete(f){return this._map.delete(this._toKey(f))}has(f){return this._map.has(this._toKey(f))}forEach(f,r){this._map.forEach(h=>f.call(r,h,h,this))}*entries(){for(const[f,r]of this._map)yield[r,r]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=t;function o(l){const f=new Set;for(const r of l)f.add(F.ExtensionIdentifier.toKey(r));return f}e.extensionIdentifiersArrayToSet=o;function a(l){const f=new Map;for(const r of l)f.set(F.ExtensionIdentifier.toKey(r.identifier),r);return f}function p(l,f){return l.enabledApiProposals?l.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=p;function b(l,f){if(!p(l,f))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=b;class u{constructor(f,r,h,v){this.codeLoadingTime=f,this.activateCallTime=r,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=u;class C{constructor(f,r){this.description=f,this.value=r}}e.ExtensionPointContribution=C,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function c(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}e.toExtension=c;function n(l,f){return{identifier:new F.ExtensionIdentifier((0,_.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!f,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,browserNlsBundleUris:l.browserNlsBundleUris}}e.toExtensionDescription=n;class d{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f,r){return Promise.resolve(0)}getInspectPorts(f,r){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,r){return Promise.resolve()}}e.NullExtensionService=d}),define(De[180],Ce([1,0,12,25,27,11,15]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(o,a,p,b){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=b}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,a){return o===-1||a===-1?-1:a-o}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class k{constructor(o,a,p,b,u,C){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=p,this.module=b,this.exports=u,this.subscriptions=C}}e.ActivatedExtension=k;class O extends k{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class w extends k{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class g extends k{constructor(o){super(!0,o,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let E=class{constructor(o,a,p,b,u){this._logService=u,this._registry=o,this._resolvedExtensionsSet=new Set,a.forEach(C=>this._resolvedExtensionsSet.add(D.ExtensionIdentifier.toKey(C))),this._externalExtensionsMap=new Map,p.forEach(C=>this._externalExtensionsMap.set(D.ExtensionIdentifier.toKey(C),C)),this._host=b,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,a]of this._operations)a.dispose()}isActivated(o){const a=this._operations.get(D.ExtensionIdentifier.toKey(o));return Boolean(a&&a.value)}getActivatedExtension(o){const a=this._operations.get(D.ExtensionIdentifier.toKey(o));if(!a||!a.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return a.value}async activateByEvent(o,a){if(this._alreadyActivatedEvents[o])return;const p=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(p.map(b=>({id:b.identifier,reason:{startup:a,extensionId:b.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,a){const p=this._registry.getExtensionDescription(o);if(!p)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:p.identifier,reason:a}])}async _activateExtensions(o){const a=o.filter(p=>!this.isActivated(p.id)).map(p=>this._handleActivationRequest(p));await Promise.all(a.map(p=>p.wait()))}_handleActivationRequest(o){if(this._operations.has(D.ExtensionIdentifier.toKey(o.id)))return this._operations.get(D.ExtensionIdentifier.toKey(o.id));if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(o.id)))return this._createAndSaveOperation(o,null,[],null);const a=this._registry.getExtensionDescription(o.id);if(!a){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),C=this._createAndSaveOperation(o,null,[],new g(u));return this._host.onExtensionActivationError(o.id,u,new S.MissingExtensionDependency(o.id.value)),C}const p=[],b=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const u of b){if(this._resolvedExtensionsSet.has(D.ExtensionIdentifier.toKey(u)))continue;const C=this._operations.get(D.ExtensionIdentifier.toKey(u));if(C){p.push(C);continue}if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(u))){p.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(D.ExtensionIdentifier.toKey(u)),reason:o.reason}));continue}const s=this._registry.getExtensionDescription(u);if(s){if(!s.main&&!s.browser)continue;p.push(this._handleActivationRequest({id:s.identifier,reason:o.reason}));continue}const c=a.displayName||a.identifier.value,n=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${u}'`),d=this._createAndSaveOperation(o,a.displayName,[],new g(n));return this._host.onExtensionActivationError(a.identifier,n,new S.MissingExtensionDependency(u)),d}return this._createAndSaveOperation(o,a.displayName,p,null)}_createAndSaveOperation(o,a,p,b){const u=new m(o.id,a,o.reason,p,b,this._host,this._logService);return this._operations.set(D.ExtensionIdentifier.toKey(o.id),u),u}};E=xe([We(4,F.ILogService)],E),e.ExtensionsActivator=E;let m=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,a,p,b,u,C,s){this._id=o,this._displayName=a,this._reason=p,this._deps=b,this._value=u,this._host=C,this._logService=s,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const a=this._deps[o];if(a.value&&!a.value.activationFailed){this._deps.splice(o,1),o--;continue}if(a.value&&a.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);p.detail=a.value.activationFailedError,this._value=new g(p),this._host.onExtensionActivationError(this._id,p,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const a=new Error;if(o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this._value=new g(a),this._isDisposed&&i.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};m=xe([We(6,F.ILogService)],m)}),define(De[181],Ce([1,0,11,26,27]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends i.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:S.ExtensionHostLogFileName}))}};F=xe([We(0,i.ILoggerService),We(1,D.IExtHostInitDataService)],F),e.ExtHostLogService=F});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[6],Ce([1,0,18,12,81,28,79,10,9,2,38,35,90,66,27]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m){"use strict";var t,o,a,p,b,u,C,s,c,n,d,l,f,r,h,v,I,L,j,W,H,P,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R($){return Object.assign($,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct($,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct($,[]);{const[ie,...we]=arguments;return Reflect.construct($,we,ie.constructor)}}})}let B=u=class{static from(...N){let ie=N;return new u(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(N){t.set(this,void 0),Ye(this,t,N,"f")}dispose(){typeof Oe(this,t,"f")=="function"&&(Oe(this,t,"f").call(this),Ye(this,t,void 0,"f"))}};t=new WeakMap,B=u=xe([R],B),e.Disposable=B;let x=C=class{static Min(...N){if(N.length===0)throw new TypeError;let ie=N[0];for(let we=1;we<N.length;we++){const He=N[we];He.isBefore(ie)&&(ie=He)}return ie}static Max(...N){if(N.length===0)throw new TypeError;let ie=N[0];for(let we=1;we<N.length;we++){const He=N[we];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(N){if(!N)return!1;if(N instanceof C)return!0;const{line:ie,character:we}=N;return typeof ie=="number"&&typeof we=="number"}static of(N){if(N instanceof C)return N;if(this.isPosition(N))return new C(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(N,ie){if(N<0)throw(0,D.illegalArgument)("line must be non-negative");if(ie<0)throw(0,D.illegalArgument)("character must be non-negative");this._line=N,this._character=ie}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,ie=0){if(N===null||ie===null)throw(0,D.illegalArgument)();let we;return typeof N>"u"?we=0:typeof N=="number"?we=N:(we=typeof N.lineDelta=="number"?N.lineDelta:0,ie=typeof N.characterDelta=="number"?N.characterDelta:0),we===0&&ie===0?this:new C(this.line+we,this.character+ie)}with(N,ie=this.character){if(N===null||ie===null)throw(0,D.illegalArgument)();let we;return typeof N>"u"?we=this.line:typeof N=="number"?we=N:(we=typeof N.line=="number"?N.line:this.line,ie=typeof N.character=="number"?N.character:this.character),we===this.line&&ie===this.character?this:new C(we,ie)}toJSON(){return{line:this.line,character:this.character}}};x=C=xe([R],x),e.Position=x;let U=s=class{static isRange(N){return N instanceof s?!0:N?x.isPosition(N.start)&&x.isPosition(N.end):!1}static of(N){if(N instanceof s)return N;if(this.isRange(N))return new s(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(N,ie,we,He){let Qe,lt;if(typeof N=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new x(N,ie),lt=new x(we,He)):x.isPosition(N)&&x.isPosition(ie)&&(Qe=x.of(N),lt=x.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");Qe.isBefore(lt)?(this._start=Qe,this._end=lt):(this._start=lt,this._end=Qe)}contains(N){return s.isRange(N)?this.contains(N.start)&&this.contains(N.end):x.isPosition(N)?!(x.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const ie=x.Max(N.start,this._start),we=x.Min(N.end,this._end);if(!ie.isAfter(we))return new s(ie,we)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ie=x.Min(N.start,this._start),we=x.Max(N.end,this.end);return new s(ie,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,ie=this.end){if(N===null||ie===null)throw(0,D.illegalArgument)();let we;return N?x.isPosition(N)?we=N:(we=N.start||this.start,ie=N.end||this.end):we=this.start,we.isEqual(this._start)&&ie.isEqual(this.end)?this:new s(we,ie)}toJSON(){return[this.start,this.end]}};U=s=xe([R],U),e.Range=U;let K=c=class extends U{static isSelection(N){return N instanceof c?!0:N?U.isRange(N)&&x.isPosition(N.anchor)&&x.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(N,ie,we,He){let Qe,lt;if(typeof N=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new x(N,ie),lt=new x(we,He)):x.isPosition(N)&&x.isPosition(ie)&&(Qe=x.of(N),lt=x.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");super(Qe,lt),this._anchor=Qe,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};K=c=xe([R],K),e.Selection=K;class te{constructor(N,ie,we){if(typeof N!="string"||N.length===0)throw(0,D.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,D.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,D.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=te;class de extends Error{static NotAvailable(N,ie){return new de(N,g.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(N){return new de(N,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ie=g.RemoteAuthorityResolverErrorCode.Unknown,we){super(N),this._message=N,this._code=ie,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var re;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var be;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(be=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=n=class{static isTextEdit(N){return N instanceof n?!0:N?U.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ie){return new n(N,ie)}static insert(N,ie){return n.replace(new U(N,N),ie)}static delete(N){return n.replace(N,"")}static setEndOfLine(N){const ie=new n(new U(new x(0,0),new x(0,0)),"");return ie.newEol=N,ie}get range(){return this._range}set range(N){if(N&&!U.isRange(N))throw(0,D.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,D.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,D.illegalArgument)("newEol");this._newEol=N}constructor(N,ie){this._range=N,this._newText=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=n=xe([R],le),e.TextEdit=le;let fe=d=class{static isNotebookCellEdit(N){return N instanceof d?!0:N?Vt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ie){return new d(N,ie)}static insertCells(N,ie){return new d(new Vt(N,N),ie)}static deleteCells(N){return new d(N,[])}static updateCellMetadata(N,ie){const we=new d(new Vt(N,N),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(N){const ie=new d(new Vt(0,0),[]);return ie.newNotebookMetadata=N,ie}constructor(N,ie){this.range=N,this.newCells=ie}};fe=d=xe([R],fe),e.NotebookEdit=fe;class Q{static isSnippetTextEdit(N){return N instanceof Q?!0:N?U.isRange(N.range)&&Fe.isSnippetString(N.snippet):!1}static replace(N,ie){return new Q(N,ie)}static insert(N,ie){return Q.replace(new U(N,N),ie)}constructor(N,ie){this.range=N,this.snippet=ie}}e.SnippetTextEdit=Q;var pe;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,ie,we,He){this._edits.push({_type:1,from:N,to:ie,options:we,metadata:He})}createFile(N,ie,we){this._edits.push({_type:1,from:void 0,to:N,options:ie,metadata:we})}deleteFile(N,ie,we){this._edits.push({_type:1,from:N,to:void 0,options:ie,metadata:we})}replaceNotebookMetadata(N,ie,we){this._edits.push({_type:3,metadata:we,uri:N,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(N,ie,we,He){const Qe=ie.start,lt=ie.end;(Qe!==lt||we.length>0)&&this._edits.push({_type:5,uri:N,index:Qe,count:lt-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(N,ie,we,He){this._edits.push({_type:3,metadata:He,uri:N,edit:{editType:8,index:ie,metadata:we}})}replace(N,ie,we,He){this._edits.push({_type:2,uri:N,edit:new le(ie,we),metadata:He})}insert(N,ie,we,He){this.replace(N,new U(ie,ie),we,He)}delete(N,ie,we){this.replace(N,ie,"",we)}has(N){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===N.toString())}set(N,ie){if(ie)for(const we of ie){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,fe.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(N,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(N,He.newNotebookMetadata,Qe):this.replaceNotebookCells(N,He.range,He.newCells,Qe):Q.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:N,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:N,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===N.toString()&&(this._edits[we]=void 0);break}}(0,i.coalesceInPlace)(this._edits)}}get(N){const ie=[];for(const we of this._edits)we._type===2&&we.uri.toString()===N.toString()&&ie.push(we.edit);return ie}entries(){const N=new F.ResourceMap;for(const ie of this._edits)if(ie._type===2){let we=N.get(ie.uri);we||(we=[ie.uri,[]],N.set(ie.uri,we)),we[1].push(ie.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=xe([R],Se),e.WorkspaceEdit=Se;let Fe=l=class{static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this._tabstop=1,this.value=N||""}appendText(N){return this.value+=l._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ie=this._tabstop++){if(typeof N=="function"){const we=new l;we._tabstop=this._tabstop,N(we),this._tabstop=we._tabstop,N=we.value}else N=l._escape(N);return this.value+="${",this.value+=ie,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ie=this._tabstop++){const we=N.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(N,ie){if(typeof ie=="function"){const we=new l;we._tabstop=this._tabstop,ie(we),this._tabstop=we._tabstop,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Fe=l=xe([R],Fe),e.SnippetString=Fe;var Ue;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(Ue=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=f=class{static isLocation(N){return N instanceof f?!0:N?U.isRange(N.range)&&k.URI.isUri(N.uri):!1}constructor(N,ie){if(this.uri=N,ie)if(U.isRange(ie))this.range=U.of(ie);else if(x.isPosition(ie))this.range=new U(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=f=xe([R],ke),e.Location=ke;let ye=class{static is(N){return N?typeof N.message=="string"&&N.location&&U.isRange(N.location.range)&&k.URI.isUri(N.location.uri):!1}constructor(N,ie){this.location=N,this.message=ie}static isEqual(N,ie){return N===ie?!0:!N||!ie?!1:N.message===ie.message&&N.location.range.isEqual(ie.location.range)&&N.location.uri.toString()===ie.location.uri.toString()}};ye=xe([R],ye),e.DiagnosticRelatedInformation=ye;let Ie=class{constructor(N,ie,we=Xe.Error){if(!U.isRange(N))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=N,this.message=ie,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ie){return N===ie?!0:!N||!ie?!1:N.message===ie.message&&N.severity===ie.severity&&N.code===ie.code&&N.severity===ie.severity&&N.source===ie.source&&N.range.isEqual(ie.range)&&(0,i.equals)(N.tags,ie.tags)&&(0,i.equals)(N.relatedInformation,ie.relatedInformation,ye.isEqual)}};Ie=xe([R],Ie),e.Diagnostic=Ie;let ae=class{constructor(N,ie){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ie}};ae=xe([R],ae),e.Hover=ae;var ue;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ee=class{constructor(N,ie=ue.Text){this.range=N,this.kind=ie}toJSON(){return{range:this.range,kind:ue[this.kind]}}};ee=xe([R],ee),e.DocumentHighlight=ee;var Z;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Z=e.SymbolKind||(e.SymbolKind={}));var T;(function($){$[$.Deprecated=1]="Deprecated"})(T=e.SymbolTag||(e.SymbolTag={}));let z=r=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ie,we,He,Qe){this.name=N,this.kind=ie,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof ke?this.location=He:we instanceof U&&(this.location=new ke(He,we)),r.validate(this)}toJSON(){return{name:this.name,kind:Z[this.kind],location:this.location,containerName:this.containerName}}};z=r=xe([R],z),e.SymbolInformation=z;let V=h=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(h.validate)}constructor(N,ie,we,He,Qe){this.name=N,this.detail=ie,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],h.validate(this)}};V=h=xe([R],V),e.DocumentSymbol=V;var q;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(N,ie){this.title=N,this.kind=ie}};oe=xe([R],oe),e.CodeAction=oe;let ce=v=class{constructor(N){this.value=N}append(N){return new v(this.value?this.value+v.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+v.sep)}};ce.sep=".",ce=v=xe([R],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorMove=ce.Refactor.append("move"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let J=class{constructor(N,ie){if(this.range=N,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=xe([R],J),e.SelectionRange=J;class Ee{constructor(N,ie,we,He,Qe,lt){this.kind=N,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.CallHierarchyItem=Ee;class ve{constructor(N,ie){this.fromRanges=ie,this.from=N}}e.CallHierarchyIncomingCall=ve;class Ne{constructor(N,ie){this.fromRanges=ie,this.to=N}}e.CallHierarchyOutgoingCall=Ne;var ze;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(N,ie){this.range=N,this.command=ie}get isResolved(){return!!this.command}};Je=xe([R],Je),e.CodeLens=Je;let Ge=I=class{static isMarkdownString(N){return N instanceof I?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ie=!1){o.set(this,void 0),Ye(this,o,new S.MarkdownString(N,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,o,"f").value}set value(N){Oe(this,o,"f").value=N}get isTrusted(){return Oe(this,o,"f").isTrusted}set isTrusted(N){Oe(this,o,"f").isTrusted=N}get supportThemeIcons(){return Oe(this,o,"f").supportThemeIcons}set supportThemeIcons(N){Oe(this,o,"f").supportThemeIcons=N}get supportHtml(){return Oe(this,o,"f").supportHtml}set supportHtml(N){Oe(this,o,"f").supportHtml=N}get baseUri(){return Oe(this,o,"f").baseUri}set baseUri(N){Oe(this,o,"f").baseUri=N}appendText(N){return Oe(this,o,"f").appendText(N),this}appendMarkdown(N){return Oe(this,o,"f").appendMarkdown(N),this}appendCodeblock(N,ie){return Oe(this,o,"f").appendCodeblock(ie??"",N),this}};o=new WeakMap,Ge=I=xe([R],Ge),e.MarkdownString=Ge;let Pe=class{constructor(N,ie){this.label=N,this.documentation=ie}};Pe=xe([R],Pe),e.ParameterInformation=Pe;let rt=class{constructor(N,ie){this.label=N,this.documentation=ie,this.parameters=[]}};rt=xe([R],rt),e.SignatureInformation=rt;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=xe([R],X),e.SignatureHelp=X;var Y;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let Be=class{constructor(N){this.value=N}};Be=xe([R],Be),e.InlayHintLabelPart=Be;let je=class{constructor(N,ie,we){this.position=N,this.label=ie,this.kind=we}};je=xe([R],je),e.InlayHint=je;var Ze;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function($){$[$.Deprecated=1]="Deprecated"})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(N,ie){this.label=N,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=xe([R],nt),e.CompletionItem=nt;let st=class{constructor(N=[],ie=!1){this.items=N,this.isIncomplete=ie}};st=xe([R],st),e.CompletionList=st;let dt=class{constructor(N,ie,we){this.insertText=N,this.range=ie,this.command=we}};dt=xe([R],dt),e.InlineSuggestion=dt;let St=class{constructor(N){this.commands=void 0,this.items=N}};St=xe([R],St),e.InlineSuggestionList=St;let tt=class{constructor(N,ie,we){this.insertText=N,this.range=ie,this.command=we}};tt=xe([R],tt),e.InlineSuggestionNew=tt;let ut=class{constructor(N,ie){this.items=N,this.commands=ie}};ut=xe([R],ut),e.InlineSuggestionsNew=ut;var Rt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(Rt=e.ViewColumn||(e.ViewColumn={}));var xt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(xt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var kt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(kt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var mt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(mt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var _t;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(_t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Lt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ut;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(Ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var qe;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function N(ie){switch(ie){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=N}(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ot=class{constructor(N,ie){if(ie&&!k.URI.isUri(ie))throw(0,D.illegalArgument)("target");if(!U.isRange(N)||N.isEmpty)throw(0,D.illegalArgument)("range");this.range=N,this.target=ie}};Ot=xe([R],Ot),e.DocumentLink=Ot;let It=class{constructor(N,ie,we,He){this.red=N,this.green=ie,this.blue=we,this.alpha=He}};It=xe([R],It),e.Color=It;let Ft=class{constructor(N,ie){if(ie&&!(ie instanceof It))throw(0,D.illegalArgument)("color");if(!U.isRange(N)||N.isEmpty)throw(0,D.illegalArgument)("range");this.range=N,this.color=ie}};Ft=xe([R],Ft),e.ColorInformation=Ft;let gt=class{constructor(N){if(!N||typeof N!="string")throw(0,D.illegalArgument)("label");this.label=N}};gt=xe([R],gt),e.ColorPresentation=gt;var _e;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(_e=e.ColorFormat||(e.ColorFormat={}));var Te;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Te=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ge;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(ge=e.TerminalExitReason||(e.TerminalExitReason={}));class G{constructor(N,ie,we){if(this.startIndex=N,this.length=ie,this.tooltip=we,typeof N!="number"||N<0)throw(0,D.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,D.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,D.illegalArgument)("tooltip")}}e.TerminalLink=G;var Ae;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Me{constructor(N){if(this.options=N,typeof N!="object")throw(0,D.illegalArgument)("options")}}e.TerminalProfile=Me;var et;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(et=e.TaskRevealKind||(e.TaskRevealKind={}));var $e;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})($e=e.TaskPanelKind||(e.TaskPanelKind={}));let it=L=class{static from(N){switch(N){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(N,ie){if(this.label=ie,typeof N!="string"||typeof ie!="string")throw(0,D.illegalArgument)("name");this._id=N}get id(){return this._id}};it.Clean=new L("clean","Clean"),it.Build=new L("build","Build"),it.Rebuild=new L("rebuild","Rebuild"),it.Test=new L("test","Test"),it=L=xe([R],it),e.TaskGroup=it;function at($){let N="";for(let ie=0;ie<$.length;ie++)N+=$[ie].replace(/,/g,",,")+",";return N}let yt=class{constructor(N,ie,we){if(typeof N!="string")throw(0,D.illegalArgument)("process");this._args=[],this._process=N,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=we):this._options=ie)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,D.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)N.push(ie);return at(N)}};yt=xe([R],yt),e.ProcessExecution=yt;let vt=class{constructor(N,ie,we){if(this._args=[],Array.isArray(ie)){if(!N)throw(0,D.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,D.illegalArgument)("command");this._command=N,this._args=ie,this._options=we}else{if(typeof N!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=N,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,D.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)N.push(typeof ie=="string"?ie:ie.value);return at(N)}};vt=xe([R],vt),e.ShellExecution=vt;var Dt;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(Dt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Pt{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=Pt;let ft=j=class{constructor(N,ie,we,He,Qe,lt){this.__deprecated=!1,this._definition=this.definition=N;let ht;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=we,this.execution=He,ht=Qe,this.__deprecated=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=lt):(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof yt?this._definition={type:j.ProcessType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:j.ShellType,id:this._execution.computeId()}:this._execution instanceof Pt?this._definition={type:j.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:j.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,D.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,D.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const ie=this._definition.type;(j.EmptyType===ie||j.ProcessType===ie||j.ShellType===ie||j.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,D.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=j=xe([R],ft),e.Task=ft;var ei;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(ei=e.ProgressLocation||(e.ProgressLocation={}));var ti;(function($){function N(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}$.isViewBadge=N})(ti=e.ViewBadge||(e.ViewBadge={}));let bt=W=class{static isTreeItem(N,ie){if(N instanceof W)return!0;const we=N;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!k.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,y.isString)(He.light)&&!k.URI.isUri(He.light)&&!(0,y.isString)(He.dark)&&!k.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!k.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<Bt.None&&we.collapsibleState>Bt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(ie,"treeItemCheckbox");const He=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==ii.Checked&&He!==ii.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(N,ie=Bt.None){this.collapsibleState=ie,k.URI.isUri(N)?this.resourceUri=N:this.label=N}};bt=W=xe([R],bt),e.TreeItem=bt;var Bt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(Bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ii;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(ii=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ni=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N,ie){this.value=N,this.id=ie??(0,O.generateUuid)()}};ni=xe([R],ni),e.DataTransferItem=ni;let vi=class{constructor(N){a.set(this,new Map);for(const[ie,we]of N??[]){const He=Oe(this,a,"f").get(ie);He?He.push(we):Oe(this,a,"f").set(ie,[we])}}get(N){return Oe(this,a,"f").get(N)?.[0]}set(N,ie){Oe(this,a,"f").set(N,[ie])}forEach(N,ie){for(const[we,He]of Oe(this,a,"f"))for(const Qe of He)N.call(ie,Qe,we,this)}*[(a=new WeakMap,Symbol.iterator)](){for(const[N,ie]of Oe(this,a,"f"))for(const we of ie)yield[N,we]}};vi=xe([R],vi),e.DataTransfer=vi;let Ct=class{constructor(N){this.insertText=N}};Ct=xe([R],Ct),e.DocumentDropEdit=Ct;let ri=class{constructor(N){this.insertText=N}};ri=xe([R],ri),e.DocumentPasteEdit=ri;let Wt=class{constructor(N,ie){this.id=N,this.color=ie}};Wt=xe([R],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let Qt=class{constructor(N){this.id=N}};Qt=xe([R],Qt),e.ThemeColor=Qt;var si;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(si=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this._base}set base(N){this._base=N,this._baseUri=k.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}constructor(N,ie){if(typeof N!="string"&&(!N||!k.URI.isUri(N)&&!k.URI.isUri(N.uri)))throw(0,D.illegalArgument)("base");if(typeof ie!="string")throw(0,D.illegalArgument)("pattern");typeof N=="string"?this.baseUri=k.URI.file(N):k.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=xe([R],ct),e.RelativePattern=ct;let Yt=class{constructor(N,ie,we,He){this.enabled=typeof N=="boolean"?N:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};Yt=xe([R],Yt),e.Breakpoint=Yt;let zt=class extends Yt{constructor(N,ie,we,He,Qe){if(super(ie,we,He,Qe),N===null)throw(0,D.illegalArgument)("location");this.location=N}};zt=xe([R],zt),e.SourceBreakpoint=zt;let qt=class extends Yt{constructor(N,ie,we,He,Qe){super(ie,we,He,Qe),this.functionName=N}};qt=xe([R],qt),e.FunctionBreakpoint=qt;let oi=class extends Yt{constructor(N,ie,we,He,Qe,lt,ht){if(super(He,Qe,lt,ht),!ie)throw(0,D.illegalArgument)("dataId");this.label=N,this.dataId=ie,this.canPersist=we}};oi=xe([R],oi),e.DataBreakpoint=oi;let Ei=class{constructor(N,ie,we){this.command=N,this.args=ie||[],this.options=we}};Ei=xe([R],Ei),e.DebugAdapterExecutable=Ei;let ai=class{constructor(N,ie){this.port=N,this.host=ie}};ai=xe([R],ai),e.DebugAdapterServer=ai;let bi=class{constructor(N){this.path=N}};bi=xe([R],bi),e.DebugAdapterNamedPipeServer=bi;let li=class{constructor(N){this.implementation=N}};li=xe([R],li),e.DebugAdapterInlineImplementation=li;let Jt=class{constructor(N,ie){this.range=N,this.expression=ie}};Jt=xe([R],Jt),e.EvaluatableExpression=Jt;var Fi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Fi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var wi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(wi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Zt=class{constructor(N,ie){this.range=N,this.text=ie}};Zt=xe([R],Zt),e.InlineValueText=Zt;let Si=class{constructor(N,ie,we=!0){this.range=N,this.variableName=ie,this.caseSensitiveLookup=we}};Si=xe([R],Si),e.InlineValueVariableLookup=Si;let _i=class{constructor(N,ie){this.range=N,this.expression=ie}};_i=xe([R],_i),e.InlineValueEvaluatableExpression=_i;let Kt=class{constructor(N,ie){this.frameId=N,this.stoppedLocation=ie}};Kt=xe([R],Kt),e.InlineValueContext=Kt;var Ni;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Ni=e.FileChangeType||(e.FileChangeType={}));let yi=H=class extends Error{static FileExists(N){return new H(N,w.FileSystemProviderErrorCode.FileExists,H.FileExists)}static FileNotFound(N){return new H(N,w.FileSystemProviderErrorCode.FileNotFound,H.FileNotFound)}static FileNotADirectory(N){return new H(N,w.FileSystemProviderErrorCode.FileNotADirectory,H.FileNotADirectory)}static FileIsADirectory(N){return new H(N,w.FileSystemProviderErrorCode.FileIsADirectory,H.FileIsADirectory)}static NoPermissions(N){return new H(N,w.FileSystemProviderErrorCode.NoPermissions,H.NoPermissions)}static Unavailable(N){return new H(N,w.FileSystemProviderErrorCode.Unavailable,H.Unavailable)}constructor(N,ie=w.FileSystemProviderErrorCode.Unknown,we){super(k.URI.isUri(N)?N.toString(!0):N),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};yi=H=xe([R],yi),e.FileSystemError=yi;let Di=class{constructor(N,ie,we){this.start=N,this.end=ie,this.kind=we}};Di=xe([R],Di),e.FoldingRange=Di;var Li;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Li=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ii;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ii=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ki;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(ki=e.CommentMode||(e.CommentMode={}));var Pi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Pi=e.CommentThreadState||(e.CommentThreadState={}));class Le{constructor(N,ie=[]){this.tokenTypes=N,this.tokenModifiers=ie}}e.SemanticTokensLegend=Le;function Ht($){return typeof $>"u"||(0,y.isStringArray)($)}class ci{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let ie=0,we=N.tokenTypes.length;ie<we;ie++)this._tokenTypeStrToInt.set(N.tokenTypes[ie],ie);for(let ie=0,we=N.tokenModifiers.length;ie<we;ie++)this._tokenModifierStrToInt.set(N.tokenModifiers[ie],ie)}}push(N,ie,we,He,Qe){if(typeof N=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(N,ie,we,He,Qe);if(U.isRange(N)&&typeof ie=="string"&&Ht(we))return this._push(N,ie,we);throw(0,D.illegalArgument)()}_push(N,ie,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=N.start.line,Qe=N.start.character,lt=N.end.character-N.start.character,ht=this._tokenTypeStrToInt.get(ie);let At=0;if(we)for(const Mt of we){if(!this._tokenModifierStrToInt.has(Mt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Mt);At|=1<<$t>>>0}this._pushEncoded(He,Qe,lt,ht,At)}_pushEncoded(N,ie,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Mt=0,$t=0;for(let jt=0;jt<At;jt++){let Gt=this._data[5*jt],Ci=this._data[5*jt+1];Gt===0?(Gt=Mt,Ci+=$t):Gt+=Mt,this._data[5*jt]=Gt,this._data[5*jt+1]=Ci,Mt=Gt,$t=Ci}}let lt=N,ht=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=N,this._prevChar=ie}static _sortAndDeltaEncode(N){const ie=[],we=N.length/5|0;for(let ht=0;ht<we;ht++)ie[ht]=ht;ie.sort((ht,At)=>{const Mt=N[5*ht],$t=N[5*At];if(Mt===$t){const jt=N[5*ht+1],Gt=N[5*At+1];return jt-Gt}return Mt-$t});const He=new Uint32Array(N.length);let Qe=0,lt=0;for(let ht=0;ht<we;ht++){const At=5*ie[ht],Mt=N[At+0],$t=N[At+1],jt=N[At+2],Gt=N[At+3],Ci=N[At+4],Ji=Mt-Qe,In=Ji===0?$t-lt:$t,Ti=5*ht;He[Ti+0]=Ji,He[Ti+1]=In,He[Ti+2]=jt,He[Ti+3]=Gt,He[Ti+4]=Ci,Qe=Mt,lt=$t}return He}build(N){return this._dataIsSortedAndDeltaEncoded?new pt(new Uint32Array(this._data),N):new pt(ci._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=ci;class pt{constructor(N,ie){this.resultId=ie,this.data=N}}e.SemanticTokens=pt;class Mi{constructor(N,ie,we){this.start=N,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Mi;class Ui{constructor(N,ie){this.resultId=ie,this.edits=N}}e.SemanticTokensEdits=Ui;var Ai;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Ai=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ui=class{constructor(){}};ui.Back={iconPath:new Wt("arrow-left")},ui=xe([R],ui),e.QuickInputButtons=ui;var di;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Bi;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Bi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zi;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(zi=e.ExtensionKind||(e.ExtensionKind={}));class $i{static validate(N){if(N.badge){let ie=(0,A.nextCharLength)(N.badge,0);if(ie<N.badge.length&&(ie+=(0,A.nextCharLength)(N.badge,ie)),N.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ie,we){this.badge=N,this.tooltip=ie,this.color=we}}e.FileDecoration=$i;let hi=class{constructor(N){this.kind=N}};hi=xe([R],hi),e.ColorTheme=hi;var xi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(N){return N instanceof Vt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(N,ie){if(N<0)throw(0,D.illegalArgument)("start must be positive");if(ie<0)throw(0,D.illegalArgument)("end must be positive");N<=ie?(this._start=N,this._end=ie):(this._start=ie,this._end=N)}with(N){let ie=this._start,we=this._end;return N.start!==void 0&&(ie=N.start),N.end!==void 0&&(we=N.end),ie===this._start&&we===this._end?this:new Vt(ie,we)}}e.NotebookRange=Vt;class fi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ie=>fi.isNotebookCellData(ie))}static isNotebookCellData(N){return!0}constructor(N,ie,we,He,Qe,lt,ht){this.kind=N,this.value=ie,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=lt,this.executionSummary=ht,fi.validate(this)}}e.NotebookCellData=fi;class Wi{constructor(N){this.cells=N}}e.NotebookData=Wi;class Nt{static isNotebookCellOutputItem(N){return N instanceof Nt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ie={name:N.name,message:N.message,stack:N.stack};return Nt.json(ie,"application/vnd.code.notebook.error")}static stdout(N){return Nt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Nt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ie="application/octet-stream"){return new Nt(N,ie)}static text(N,ie=_.Mimes.text){const we=Oe(Nt,p,"f",b).encode(String(N));return new Nt(we,ie)}static json(N,ie="text/x-json"){const we=JSON.stringify(N,void 0,"	");return Nt.text(we,ie)}constructor(N,ie){this.data=N,this.mime=ie;const we=(0,_.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Nt,p=Nt,b={value:new TextEncoder};class mi{static isNotebookCellOutput(N){return N instanceof mi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ie=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<N.length;Qe++){const lt=N[Qe],ht=(0,_.normalizeMimeType)(lt.mime);if(!we.has(ht)||(0,E.isTextStreamMime)(ht)){we.add(ht);continue}He.add(Qe),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return He.size===0?N:N.filter((Qe,lt)=>!He.has(lt))}constructor(N,ie,we){this.items=mi.ensureUniqueMimeTypes(N,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=mi;var se;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(se=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(he=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Re;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Re=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ot;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(ot=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class wt{constructor(N,ie){this.text=N,this.alignment=ie}}e.NotebookCellStatusBarItem=wt;var Tt;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(Tt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var nn;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred",$[$.Hidden=-1]="Hidden"})(nn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rn{constructor(N,ie=[]){this.uri=N,this.provides=(0,i.asArray)(ie)}}e.NotebookRendererScript=rn;let Hi=class{constructor(N,ie){this.label=N,this.timestamp=ie}};Hi=xe([R],Hi),e.TimelineItem=Hi;var sn;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(N,ie){this.ranges=N,this.wordPattern=ie}}e.LinkedEditingRanges=ln;class cn{constructor(N,ie){this._port=N,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=cn;var un;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(un=e.TestResultState||(e.TestResultState={}));var dn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vi=class{constructor(N=void 0,ie=void 0,we=void 0){this.include=N,this.exclude=ie,this.profile=we}};Vi=xe([R],Vi),e.TestRunRequest=Vi;let ji=P=class{static diff(N,ie,we){const He=new P(N);return He.expectedOutput=ie,He.actualOutput=we,He}constructor(N){this.message=N}};ji=P=xe([R],ji),e.TestMessage=ji;let qi=class{constructor(N){this.id=N}};qi=xe([R],qi),e.TestTag=qi;let gi=class{constructor(N,ie){this.covered=N,this.total=ie}};gi=xe([R],gi),e.CoveredCount=gi;let Ki=M=class{static fromDetails(N,ie){const we=new gi(0,0),He=new gi(0,0),Qe=new gi(0,0);for(const ht of ie)if("branches"in ht){we.total+=1,we.covered+=ht.executionCount>0?1:0;for(const At of ht.branches)He.total+=1,He.covered+=At.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ht.executionCount>0?1:0;const lt=new M(N,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return lt.detailedCoverage=ie,lt}constructor(N,ie,we,He){this.uri=N,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=He}};Ki=M=xe([R],Ki),e.FileCoverage=Ki;let Gi=class{constructor(N,ie,we=[]){this.executionCount=N,this.location=ie,this.branches=we}};Gi=xe([R],Gi),e.StatementCoverage=Gi;let Xi=class{constructor(N,ie){this.executionCount=N,this.location=ie}};Xi=xe([R],Xi),e.BranchCoverage=Xi;let Qi=class{constructor(N,ie){this.executionCount=N,this.location=ie}};Qi=xe([R],Qi),e.FunctionCoverage=Qi;var hn;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(N,ie,we,He,Qe,lt){this.kind=N,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.TypeHierarchyItem=gn;class pn{constructor(N){this.uri=N}}e.TextTabInput=pn;class vn{constructor(N,ie){this.original=N,this.modified=ie}}e.TextDiffTabInput=vn;class En{constructor(N,ie,we,He){this.base=N,this.input1=ie,this.input2=we,this.result=He}}e.TextMergeTabInput=En;class bn{constructor(N,ie){this.uri=N,this.viewType=ie}}e.CustomEditorTabInput=bn;class wn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=wn;class Sn{constructor(N,ie){this.uri=N,this.notebookType=ie}}e.NotebookEditorTabInput=Sn;class _n{constructor(N,ie,we){this.original=N,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=_n;class yn{constructor(){}}e.TerminalEditorTabInput=yn;class Dn{constructor(N,ie){this.uri=N,this.inputBoxUri=ie}}e.InteractiveWindowInput=Dn}),define(De[94],Ce([1,0,47,13,10,247,124,6,18]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function O(m,t){t?k.set(m,t):k.delete(m)}e.setWordDefinitionFor=O;function w(m){return k.get(m)}e.getWordDefinitionFor=w;class g extends F.MirrorTextModel{constructor(t,o,a,p,b,u,C,s){super(o,a,p,b),this._proxy=t,this._languageId=u,this._isDirty=C,this.notebook=s,this._isDisposed=!1}dispose(){(0,i.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(t){return(0,y.equals)(this._lines,t)}get document(){if(!this._document){const t=this;this._document={get uri(){return t._uri},get fileName(){return t._uri.fsPath},get isUntitled(){return t._uri.scheme===D.Schemas.untitled},get languageId(){return t._languageId},get version(){return t._versionId},get isClosed(){return t._isDisposed},get isDirty(){return t._isDirty},save(){return t._save()},getText(o){return o?t._getTextInRange(o):t.getText()},get eol(){return t._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return t._lines.length},lineAt(o){return t._lineAt(o)},offsetAt(o){return t._offsetAt(o)},positionAt(o){return t._positionAt(o)},validateRange(o){return t._validateRange(o)},validatePosition(o){return t._validatePosition(o)},getWordRangeAtPosition(o,a){return t._getWordRangeAtPosition(o,a)}}}return Object.freeze(this._document)}_acceptLanguageId(t){(0,i.ok)(!this._isDisposed),this._languageId=t}_acceptIsDirty(t){(0,i.ok)(!this._isDisposed),this._isDirty=t}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(t){const o=this._validateRange(t);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const a=this._eol,p=o.start.line,b=o.end.line,u=[];u.push(this._lines[p].substring(o.start.character));for(let C=p+1;C<b;C++)u.push(this._lines[C]);return u.push(this._lines[b].substring(0,o.end.character)),u.join(a)}_lineAt(t){let o;if(t instanceof A.Position?o=t.line:typeof t=="number"&&(o=t),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this._lines[o],o===this._lines.length-1)}_offsetAt(t){return t=this._validatePosition(t),this._ensureLineStarts(),this._lineStarts.getPrefixSum(t.line-1)+t.character}_positionAt(t){t=Math.floor(t),t=Math.max(0,t),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(t),a=this._lines[o.index].length;return new A.Position(o.index,Math.min(o.remainder,a))}_validateRange(t){if(!(t instanceof A.Range))throw new Error("Invalid argument");const o=this._validatePosition(t.start),a=this._validatePosition(t.end);return o===t.start&&a===t.end?t:new A.Range(o.line,o.character,a.line,a.character)}_validatePosition(t){if(!(t instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return t.with(0,0);let{line:o,character:a}=t,p=!1;if(o<0)o=0,a=0,p=!0;else if(o>=this._lines.length)o=this._lines.length-1,a=this._lines[o].length,p=!0;else{const b=this._lines[o].length;a<0?(a=0,p=!0):a>b&&(a=b,p=!0)}return p?new A.Position(o,a):t}_getWordRangeAtPosition(t,o){const a=this._validatePosition(t);if(!o)o=w(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const p=(0,_.getWordAtText)(a.character+1,(0,_.ensureValidWordDefinition)(o),this._lines[a.line],0);if(p)return new A.Range(a.line,p.startColumn-1,a.line,p.endColumn-1)}}e.ExtHostDocumentData=g;class E{constructor(t,o,a){this._line=t,this._text=o,this._isLastLine=a}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(De[182],Ce([1,0,6,14,4]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=class{constructor(A){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y;switch(A){case"light":y=i.ColorThemeKind.Light;break;case"hcDark":y=i.ColorThemeKind.HighContrast;break;case"hcLight":y=i.ColorThemeKind.HighContrastLight;break;default:y=i.ColorThemeKind.Dark}this._actual=new i.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};F=xe([We(0,D.IExtHostRpcService)],F),e.ExtHostTheming=F}),define(De[8],Ce([1,0,18,23,81,28,107,80,24,9,2,52,70,86,92,91,66,41,51,177,6,183]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(_e){function Te(G){const{selectionStartLineNumber:Ae,selectionStartColumn:Me,positionLineNumber:et,positionColumn:$e}=G,it=new u.Position(Ae-1,Me-1),at=new u.Position(et-1,$e-1);return new u.Selection(it,at)}_e.to=Te;function ge(G){const{anchor:Ae,active:Me}=G;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}_e.from=ge})(s=e.Selection||(e.Selection={}));var c;(function(_e){function Te(G){if(!G)return;const{start:Ae,end:Me}=G;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}_e.from=Te;function ge(G){if(!G)return;const{startLineNumber:Ae,startColumn:Me,endLineNumber:et,endColumn:$e}=G;return new u.Range(Ae-1,Me-1,et-1,$e-1)}_e.to=ge})(c=e.Range||(e.Range={}));var n;(function(_e){function Te(ge){switch(ge){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}_e.to=Te})(n=e.TokenType||(e.TokenType={}));var d;(function(_e){function Te(G){return new u.Position(G.lineNumber-1,G.column-1)}_e.to=Te;function ge(G){return{lineNumber:G.line+1,column:G.character+1}}_e.from=ge})(d=e.Position||(e.Position={}));var l;(function(_e){function Te(Ae,Me){return(0,i.coalesce)((0,i.asArray)(Ae).map(et=>ge(et,Me)))}_e.from=Te;function ge(Ae,Me){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:G(Ae.scheme,Me),pattern:me.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function G(Ae,Me){return Me&&typeof Ae=="string"?Me.transformOutgoingScheme(Ae):Ae}})(l=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(_e){function Te(G){switch(G){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}_e.from=Te;function ge(G){switch(G){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}_e.to=ge})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function Te(G){let Ae;return G.code&&((0,k.isString)(G.code)||(0,k.isNumber)(G.code)?Ae=String(G.code):Ae={value:String(G.code.value),target:G.code.target}),{...c.from(G.range),message:G.message,source:G.source,code:Ae,severity:v.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(h.from),tags:Array.isArray(G.tags)?(0,i.coalesce)(G.tags.map(f.from)):void 0}}_e.from=Te;function ge(G){const Ae=new u.Diagnostic(c.to(G),G.message,v.to(G.severity));return Ae.source=G.source,Ae.code=(0,k.isString)(G.code)?G.code:G.code?.value,Ae.relatedInformation=G.relatedInformation&&G.relatedInformation.map(h.to),Ae.tags=G.tags&&(0,i.coalesce)(G.tags.map(f.to)),Ae}_e.to=ge})(r=e.Diagnostic||(e.Diagnostic={}));var h;(function(_e){function Te(G){return{...c.from(G.location.range),message:G.message,resource:G.location.uri}}_e.from=Te;function ge(G){return new u.DiagnosticRelatedInformation(new u.Location(G.resource,c.to(G)),G.message)}_e.to=ge})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var v;(function(_e){function Te(G){switch(G){case u.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}_e.from=Te;function ge(G){switch(G){case E.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}_e.to=ge})(v=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var I;(function(_e){function Te(G){return typeof G=="number"&&G>=u.ViewColumn.One?G-1:G===u.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}_e.from=Te;function ge(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=ge})(I=e.ViewColumn||(e.ViewColumn={}));function L(_e){return typeof _e.range<"u"}function j(_e){return _e.length===0?!0:!!L(_e[0])}e.isDecorationOptionsArr=j;var W;(function(_e){function Te($e){return $e.map(_e.from)}_e.fromMany=Te;function ge($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function G($e){let it;if(ge($e)){const{language:Dt,value:Et}=$e;it={value:"```"+Dt+`
`+Et+"\n```\n"}}else u.MarkdownString.isMarkdownString($e)?it={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml,baseUri:$e.baseUri}:typeof $e=="string"?it={value:$e}:it={value:""};const at=Object.create(null);it.uris=at;const yt=Dt=>{try{let Et=O.URI.parse(Dt,!0);Et=Et.with({query:Ae(Et.query,at)}),at[Dt]=Et}catch{}return""},vt=new _.marked.Renderer;return vt.link=yt,vt.image=Dt=>typeof Dt=="string"?yt(S.parseHrefAndDimensions(Dt).href):"",(0,_.marked)(it.value,{renderer:vt}),it}_e.from=G;function Ae($e,it){if(!$e)return $e;let at;try{at=(0,A.parse)($e)}catch{}if(!at)return $e;let yt=!1;return at=(0,y.cloneAndChange)(at,vt=>{if(O.URI.isUri(vt)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[Dt]=vt,yt=!0,Dt}else return}),yt?JSON.stringify(at):$e}function Me($e){const it=new u.MarkdownString($e.value,$e.supportThemeIcons);return it.isTrusted=$e.isTrusted,it.supportHtml=$e.supportHtml,it.baseUri=$e.baseUri?O.URI.from($e.baseUri):void 0,it}_e.to=Me;function et($e){if(!!$e)return typeof $e=="string"?$e:_e.from($e)}_e.fromStrict=et})(W=e.MarkdownString||(e.MarkdownString={}));function H(_e){return j(_e)?_e.map(Te=>({range:c.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?W.fromMany(Te.hoverMessage):Te.hoverMessage?W.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):_e.map(Te=>({range:c.from(Te)}))}e.fromRangeOrRangeWithMessage=H;function P(_e){return typeof _e>"u"?_e:typeof _e=="string"?O.URI.file(_e):_e}e.pathOrURIToURI=P;var M;(function(_e){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?P(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}_e.from=Te})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(_e){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}_e.from=Te})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(_e){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=Te})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(_e){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?B.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?R.from(ge.light):void 0,dark:ge.dark?R.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}_e.from=Te})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(_e){function Te(G){return{text:G.newText,eol:G.newEol&&Ge.from(G.newEol),range:c.from(G.range)}}_e.from=Te;function ge(G){const Ae=new u.TextEdit(c.to(G.range),G.text);return Ae.newEol=typeof G.eol>"u"?void 0:Ge.to(G.eol),Ae}_e.to=ge})(U=e.TextEdit||(e.TextEdit={}));var K;(function(_e){function Te(G,Ae){const Me={edits:[]};if(G instanceof u.WorkspaceEdit){const et=new F.ResourceSet;for(const $e of G._allEntries())$e._type===1&&O.URI.isUri($e.to)&&$e.from===void 0&&et.add($e.to);for(const $e of G._allEntries())$e._type===1?Me.edits.push({oldResource:$e.from,newResource:$e.to,options:{...$e.options,contentsBase64:$e.options?.contents&&(0,D.encodeBase64)(D.VSBuffer.wrap($e.options.contents))},metadata:$e.metadata}):$e._type===2?Me.edits.push({resource:$e.uri,textEdit:U.from($e.edit),versionId:et.has($e.uri)?void 0:Ae?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===6?Me.edits.push({resource:$e.uri,textEdit:{range:c.from($e.range),text:$e.edit.value,insertAsSnippet:!0},versionId:et.has($e.uri)?void 0:Ae?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Me.edits.push({metadata:$e.metadata,resource:$e.uri,cellEdit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Me.edits.push({metadata:$e.metadata,resource:$e.uri,notebookVersionId:Ae?.getNotebookDocumentVersion($e.uri),cellEdit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(st.from)}})}return Me}_e.from=Te;function ge(G){const Ae=new u.WorkspaceEdit;for(const Me of G.edits)Me.textEdit?Ae.replace(O.URI.revive(Me.resource),c.to(Me.textEdit.range),Me.textEdit.text):Ae.renameFile(O.URI.revive(Me.oldResource),O.URI.revive(Me.newResource),Me.options);return Ae}_e.to=ge})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var te;(function(_e){const Te=Object.create(null);Te[u.SymbolKind.File]=0,Te[u.SymbolKind.Module]=1,Te[u.SymbolKind.Namespace]=2,Te[u.SymbolKind.Package]=3,Te[u.SymbolKind.Class]=4,Te[u.SymbolKind.Method]=5,Te[u.SymbolKind.Property]=6,Te[u.SymbolKind.Field]=7,Te[u.SymbolKind.Constructor]=8,Te[u.SymbolKind.Enum]=9,Te[u.SymbolKind.Interface]=10,Te[u.SymbolKind.Function]=11,Te[u.SymbolKind.Variable]=12,Te[u.SymbolKind.Constant]=13,Te[u.SymbolKind.String]=14,Te[u.SymbolKind.Number]=15,Te[u.SymbolKind.Boolean]=16,Te[u.SymbolKind.Array]=17,Te[u.SymbolKind.Object]=18,Te[u.SymbolKind.Key]=19,Te[u.SymbolKind.Null]=20,Te[u.SymbolKind.EnumMember]=21,Te[u.SymbolKind.Struct]=22,Te[u.SymbolKind.Event]=23,Te[u.SymbolKind.Operator]=24,Te[u.SymbolKind.TypeParameter]=25;function ge(Ae){return typeof Te[Ae]=="number"?Te[Ae]:6}_e.from=ge;function G(Ae){for(const Me in Te)if(Te[Me]===Ae)return Number(Me);return u.SymbolKind.Property}_e.to=G})(te=e.SymbolKind||(e.SymbolKind={}));var de;(function(_e){function Te(G){switch(G){case u.SymbolTag.Deprecated:return 1}}_e.from=Te;function ge(G){switch(G){case 1:return u.SymbolTag.Deprecated}}_e.to=ge})(de=e.SymbolTag||(e.SymbolTag={}));var re;(function(_e){function Te(G){return{name:G.name,kind:te.from(G.kind),tags:G.tags&&G.tags.map(de.from),containerName:G.containerName,location:pe.from(G.location)}}_e.from=Te;function ge(G){const Ae=new u.SymbolInformation(G.name,te.to(G.kind),G.containerName,pe.to(G.location));return Ae.tags=G.tags&&G.tags.map(de.to),Ae}_e.to=ge})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var be;(function(_e){function Te(G){const Ae={name:G.name||"!!MISSING: name!!",detail:G.detail,range:c.from(G.range),selectionRange:c.from(G.selectionRange),kind:te.from(G.kind),tags:G.tags?.map(de.from)??[]};return G.children&&(Ae.children=G.children.map(Te)),Ae}_e.from=Te;function ge(G){const Ae=new u.DocumentSymbol(G.name,G.detail,te.to(G.kind),c.to(G.range),c.to(G.selectionRange));return(0,i.isNonEmptyArray)(G.tags)&&(Ae.tags=G.tags.map(de.to)),G.children&&(Ae.children=G.children.map(ge)),Ae}_e.to=ge})(be=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(_e){function Te(G){const Ae=new u.CallHierarchyItem(te.to(G.kind),G.name,G.detail||"",O.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Ae._sessionId=G._sessionId,Ae._itemId=G._itemId,Ae}_e.to=Te;function ge(G,Ae,Me){if(Ae=Ae??G._sessionId,Me=Me??G._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,name:G.name,detail:G.detail,kind:te.from(G.kind),uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(de.from)}}_e.from=ge})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(_e){function Te(ge){return new u.CallHierarchyIncomingCall(le.to(ge.from),ge.fromRanges.map(G=>c.to(G)))}_e.to=Te})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(_e){function Te(ge){return new u.CallHierarchyOutgoingCall(le.to(ge.to),ge.fromRanges.map(G=>c.to(G)))}_e.to=Te})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(_e){function Te(G){return{range:G.range&&c.from(G.range),uri:G.uri}}_e.from=Te;function ge(G){return new u.Location(O.URI.revive(G.uri),c.to(G.range))}_e.to=ge})(pe=e.location||(e.location={}));var Se;(function(_e){function Te(G){const Ae=G,Me=G;return{originSelectionRange:Ae.originSelectionRange?c.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Me.uri,range:c.from(Ae.targetRange?Ae.targetRange:Me.range),targetSelectionRange:Ae.targetSelectionRange?c.from(Ae.targetSelectionRange):void 0}}_e.from=Te;function ge(G){return{targetUri:O.URI.revive(G.uri),targetRange:c.to(G.range),targetSelectionRange:G.targetSelectionRange?c.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?c.to(G.originSelectionRange):void 0}}_e.to=ge})(Se=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(_e){function Te(G){return{range:c.from(G.range),contents:W.fromMany(G.contents)}}_e.from=Te;function ge(G){return new u.Hover(G.contents.map(W.to),c.to(G.range))}_e.to=ge})(Fe=e.Hover||(e.Hover={}));var Ue;(function(_e){function Te(G){return{range:c.from(G.range),expression:G.expression}}_e.from=Te;function ge(G){return new u.EvaluatableExpression(c.to(G.range),G.expression)}_e.to=ge})(Ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(_e){function Te(G){if(G instanceof u.InlineValueText)return{type:"text",range:c.from(G.range),text:G.text};if(G instanceof u.InlineValueVariableLookup)return{type:"variable",range:c.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=Te;function ge(G){switch(G.type){case"text":return{range:c.to(G.range),text:G.text};case"variable":return{range:c.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:c.to(G.range),expression:G.expression}}}_e.to=ge})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(_e){function Te(G){return{frameId:G.frameId,stoppedLocation:c.from(G.stoppedLocation)}}_e.from=Te;function ge(G){return new u.InlineValueContext(G.frameId,c.to(G.stoppedLocation))}_e.to=ge})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(_e){function Te(G){return{range:c.from(G.range),kind:G.kind}}_e.from=Te;function ge(G){return new u.DocumentHighlight(c.to(G.range),G.kind)}_e.to=ge})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(_e){function Te(ge){switch(ge){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}_e.to=Te})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(_e){function Te(ge){return{triggerKind:Ie.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}_e.to=Te})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(_e){function Te(G){switch(G){case u.CompletionItemTag.Deprecated:return 1}}_e.from=Te;function ge(G){switch(G){case 1:return u.CompletionItemTag.Deprecated}}_e.to=ge})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(_e){const Te=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ge(Me){return Te.get(Me)??9}_e.from=ge;const G=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Ae(Me){return G.get(Me)??u.CompletionItemKind.Property}_e.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(_e){function Te(ge,G){const Ae=new u.CompletionItem(ge.label);return Ae.insertText=ge.insertText,Ae.kind=ee.to(ge.kind),Ae.tags=ge.tags?.map(ue.to),Ae.detail=ge.detail,Ae.documentation=S.isMarkdownString(ge.documentation)?W.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,w.Range.isIRange(ge.range)?Ae.range=c.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:c.to(ge.range.insert),replacing:c.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Ae.insertText=new u.SnippetString(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof u.Range?new u.TextEdit(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Me=>U.to(Me))),Ae.command=G&&ge.command?G.fromInternal(ge.command):void 0,Ae}_e.to=Te})(Z=e.CompletionItem||(e.CompletionItem={}));var T;(function(_e){function Te(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:W.fromStrict(G.documentation)}}_e.from=Te;function ge(G){return{label:G.label,documentation:S.isMarkdownString(G.documentation)?W.to(G.documentation):G.documentation}}_e.to=ge})(T=e.ParameterInformation||(e.ParameterInformation={}));var z;(function(_e){function Te(G){return{label:G.label,documentation:W.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(T.from):[],activeParameter:G.activeParameter}}_e.from=Te;function ge(G){return{label:G.label,documentation:S.isMarkdownString(G.documentation)?W.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(T.to):[],activeParameter:G.activeParameter}}_e.to=ge})(z=e.SignatureInformation||(e.SignatureInformation={}));var V;(function(_e){function Te(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(z.from):[]}}_e.from=Te;function ge(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(z.to):[]}}_e.to=ge})(V=e.SignatureHelp||(e.SignatureHelp={}));var q;(function(_e){function Te(ge,G){const Ae=new u.InlayHint(d.to(G.position),typeof G.label=="string"?G.label:G.label.map(oe.to.bind(void 0,ge)),G.kind&&ce.to(G.kind));return Ae.textEdits=G.textEdits&&G.textEdits.map(U.to),Ae.tooltip=S.isMarkdownString(G.tooltip)?W.to(G.tooltip):G.tooltip,Ae.paddingLeft=G.paddingLeft,Ae.paddingRight=G.paddingRight,Ae}_e.to=Te})(q=e.InlayHint||(e.InlayHint={}));var oe;(function(_e){function Te(ge,G){const Ae=new u.InlayHintLabelPart(G.label);return Ae.tooltip=S.isMarkdownString(G.tooltip)?W.to(G.tooltip):G.tooltip,g.Command.is(G.command)&&(Ae.command=ge.fromInternal(G.command)),G.location&&(Ae.location=pe.to(G.location)),Ae}_e.to=Te})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ce;(function(_e){function Te(G){return G}_e.from=Te;function ge(G){return G}_e.to=ge})(ce=e.InlayHintKind||(e.InlayHintKind={}));var J;(function(_e){function Te(G){return{range:c.from(G.range),url:G.target,tooltip:G.tooltip}}_e.from=Te;function ge(G){let Ae;if(G.url)try{Ae=typeof G.url=="string"?O.URI.parse(G.url,!0):O.URI.revive(G.url)}catch{}return new u.DocumentLink(c.to(G.range),Ae)}_e.to=ge})(J=e.DocumentLink||(e.DocumentLink={}));var Ee;(function(_e){function Te(G){const Ae=new u.ColorPresentation(G.label);return G.textEdit&&(Ae.textEdit=U.to(G.textEdit)),G.additionalTextEdits&&(Ae.additionalTextEdits=G.additionalTextEdits.map(Me=>U.to(Me))),Ae}_e.to=Te;function ge(G){return{label:G.label,textEdit:G.textEdit?U.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ae=>U.from(Ae)):void 0}}_e.from=ge})(Ee=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function Te(G){return new u.Color(G[0],G[1],G[2],G[3])}_e.to=Te;function ge(G){return[G.red,G.green,G.blue,G.alpha]}_e.from=ge})(ve=e.Color||(e.Color={}));var Ne;(function(_e){function Te(G){return{range:c.from(G.range)}}_e.from=Te;function ge(G){return new u.SelectionRange(c.to(G.range))}_e.to=ge})(Ne=e.SelectionRange||(e.SelectionRange={}));var ze;(function(_e){function Te(ge){switch(ge){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}_e.to=Te})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function Te(G){switch(G){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=Te;function ge(G){switch(G){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}_e.to=ge})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(_e){function Te(G){if(G===u.EndOfLine.CRLF)return 1;if(G===u.EndOfLine.LF)return 0}_e.from=Te;function ge(G){if(G===1)return u.EndOfLine.CRLF;if(G===0)return u.EndOfLine.LF}_e.to=ge})(Ge=e.EndOfLine||(e.EndOfLine={}));var Pe;(function(_e){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=Te})(Pe=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(_e){function Te(ge){const G={start:ge.start+1,end:ge.end+1};return ge.kind&&(G.kind=X.from(ge.kind)),G}_e.from=Te})(rt=e.FoldingRange||(e.FoldingRange={}));var X;(function(_e){function Te(ge){if(ge)switch(ge){case u.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}_e.from=Te})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(_e){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?c.from(ge.selection):void 0,override:typeof ge.override=="boolean"?t.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=Te})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var me;(function(_e){function Te(Me){return Me instanceof u.RelativePattern?Me.toJSON():typeof Me=="string"?Me:ge(Me)||G(Me)?new u.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}_e.from=Te;function ge(Me){const et=Me;return et?O.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function G(Me){const et=Me;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Ae(Me){return typeof Me=="string"?Me:new u.RelativePattern(O.URI.revive(Me.baseUri),Me.pattern)}_e.to=Ae})(me=e.GlobPattern||(e.GlobPattern={}));var Be;(function(_e){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const G=ge;return{language:G.language,scheme:G.scheme,pattern:me.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}_e.from=Te})(Be=e.LanguageSelector||(e.LanguageSelector={}));var je;(function(_e){function Te(G){return{start:G.start,end:G.end}}_e.from=Te;function ge(G){return new u.NotebookRange(G.start,G.end)}_e.to=ge})(je=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(_e){function Te(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}_e.to=Te;function ge(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}_e.from=ge})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(_e){function Te(ge){if(ge===o.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(ge===o.NotebookCellExecutionState.Pending)return;if(ge===o.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}_e.to=Te})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(_e){function Te(G){switch(G){case u.NotebookCellKind.Markup:return o.CellKind.Markup;case u.NotebookCellKind.Code:default:return o.CellKind.Code}}_e.from=Te;function ge(G){switch(G){case o.CellKind.Markup:return u.NotebookCellKind.Markup;case o.CellKind.Code:default:return u.NotebookCellKind.Code}}_e.to=ge})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(_e){function Te(G){const Ae={metadata:G.metadata??Object.create(null),cells:[]};for(const Me of G.cells)u.NotebookCellData.validate(Me),Ae.cells.push(st.from(Me));return Ae}_e.from=Te;function ge(G){const Ae=new u.NotebookData(G.cells.map(st.to));return(0,k.isEmptyObject)(G.metadata)||(Ae.metadata=G.metadata),Ae}_e.to=ge})(nt=e.NotebookData||(e.NotebookData={}));var st;(function(_e){function Te(G){return{cellKind:Ve.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ze.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(St.from):[]}}_e.from=Te;function ge(G){return new u.NotebookCellData(Ve.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(St.to):void 0,G.metadata,G.internalMetadata?Ze.to(G.internalMetadata):void 0)}_e.to=ge})(st=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(_e){function Te(G){return{mime:G.mime,valueBytes:D.VSBuffer.wrap(G.data)}}_e.from=Te;function ge(G){return new u.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}_e.to=ge})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var St;(function(_e){function Te(G){return{outputId:G.id,items:G.items.map(dt.from),metadata:G.metadata}}_e.from=Te;function ge(G){const Ae=G.items.map(dt.to);return new u.NotebookCellOutput(Ae,G.outputId,G.metadata)}_e.to=ge})(St=e.NotebookCellOutput||(e.NotebookCellOutput={}));var tt;(function(_e){function Te(Ae){return G(Ae)?{include:(0,k.withNullAsUndefined)(me.from(Ae.include)),exclude:(0,k.withNullAsUndefined)(me.from(Ae.exclude))}:(0,k.withNullAsUndefined)(me.from(Ae))}_e.from=Te;function ge(Ae){return G(Ae)?{include:me.to(Ae.include),exclude:me.to(Ae.exclude)}:me.to(Ae)}_e.to=ge;function G(Ae){const Me=Ae;return Me?!(0,k.isUndefinedOrNull)(Me.include)&&!(0,k.isUndefinedOrNull)(Me.exclude):!1}})(tt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(_e){function Te(ge,G,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Me,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}_e.from=Te})(ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(_e){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}_e.from=Te})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var xt;(function(_e){function Te(G){return{uri:G.uri,provides:G.provides}}_e.from=Te;function ge(G){return new u.NotebookRendererScript(O.URI.revive(G.uri),G.provides)}_e.to=ge})(xt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(_e){function Te(G){return{message:W.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:c.from(G.location.range),uri:G.location.uri}}}_e.from=Te;function ge(G){const Ae=new u.TestMessage(typeof G.message=="string"?G.message:W.to(G.message));return Ae.actualOutput=G.actual,Ae.expectedOutput=G.expected,Ae.location=G.location?pe.to(G.location):void 0,Ae}_e.to=ge})(kt=e.TestMessage||(e.TestMessage={}));var mt;(function(_e){_e.namespace=p.namespaceTestTag,_e.denamespace=p.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var _t;(function(_e){function Te(G){const Ae=(0,m.getPrivateApiFor)(G).controllerId;return{extId:a.TestId.fromExtHostTestItem(G,Ae).toString(),label:G.label,uri:O.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Me=>mt.namespace(Ae,Me.id)),range:w.Range.lift(c.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&W.fromStrict(G.error)||null}}_e.from=Te;function ge(G){return{parent:void 0,error:void 0,id:a.TestId.fromString(G.extId).localId,label:G.label,uri:O.URI.revive(G.uri),tags:(G.tags||[]).map(Ae=>{const{tagId:Me}=mt.denamespace(Ae);return new u.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}_e.toPlain=ge})(_t=e.TestItem||(e.TestItem={})),function(_e){function Te(G){return{id:G.id}}_e.from=Te;function ge(G){return new u.TestTag(G.id)}_e.to=ge}(mt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){const Te=(G,Ae)=>{const Me=[];for(const[$e,it]of Ae)a.TestId.compare(it.item.extId,$e)===2&&(Ae.delete($e),Me.push(it));const et={..._t.toPlain(G.item),parent:void 0,taskStates:G.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(it=>it.type===0).map(kt.to)})),children:Me.map($e=>Te($e,Ae))};for(const $e of et.children)$e.parent=et;return et};function ge(G){const Ae=[],Me=new Map;for(const et of G.items){Me.set(et.item.extId,et);const $e=a.TestId.root(et.item.extId);G.request.targets.some(it=>it.controllerId===$e&&it.testIds.includes(et.item.extId))&&Ae.push(et)}return{completedAt:G.completedAt,results:Ae.map(et=>Te(et,Me))}}_e.to=ge})(Lt=e.TestResults||(e.TestResults={}));var Ut;(function(_e){function Te(Me){return{covered:Me.covered,total:Me.covered}}function ge(Me){return"line"in Me?d.from(Me):c.from(Me)}function G(Me){return"branches"in Me?{count:Me.executionCount,location:ge(Me.location),type:1,branches:Me.branches.length?Me.branches.map(et=>({count:et.executionCount,location:et.location&&ge(et.location)})):void 0}:{type:0,count:Me.executionCount,location:ge(Me.location)}}_e.fromDetailed=G;function Ae(Me){return{uri:Me.uri,statement:Te(Me.statementCoverage),branch:Me.branchCoverage&&Te(Me.branchCoverage),function:Me.functionCoverage&&Te(Me.functionCoverage),details:Me.detailedCoverage?.map(G)}}_e.fromFile=Ae})(Ut=e.TestCoverage||(e.TestCoverage={}));var qe;(function(_e){function Te(ge){switch(ge){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}_e.to=Te})(qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(_e){function Te(G){const Ae=new u.TypeHierarchyItem(te.to(G.kind),G.name,G.detail||"",O.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Ae._sessionId=G._sessionId,Ae._itemId=G._itemId,Ae}_e.to=Te;function ge(G,Ae,Me){if(Ae=Ae??G._sessionId,Me=Me??G._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,kind:te.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(de.from)}}_e.from=ge})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var It;(function(_e){function Te(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}_e.from=Te})(It=e.ViewBadge||(e.ViewBadge={}));var Ft;(function(_e){function Te(ge,G){const Ae=ge.fileData;return Ae?new class extends u.DataTransferItem{asFile(){return{name:Ae.name,uri:O.URI.revive(Ae.uri),data:(0,C.once)(()=>G())}}}("",ge.id):new u.DataTransferItem(ge.asString)}_e.toDataTransferItem=Te})(Ft=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(_e){function Te(G,Ae){const Me=G.items.map(([et,$e])=>[et,Ft.toDataTransferItem($e,()=>Ae($e.id))]);return new u.DataTransfer(Me)}_e.toDataTransfer=Te;async function ge(G){const Ae={items:[]},Me=[];return G.forEach((et,$e)=>{Me.push((async()=>{const it=await et.asString(),at=et.asFile();Ae.items.push([$e,{id:et.id,asString:it,fileData:at?{name:at.name,uri:at.uri}:void 0}])})())}),await Promise.all(Me),Ae}_e.toDataTransferDTO=ge})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(De[184],Ce([1,0,2,12,6,8,150]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,O,w,g={timeout:1500,errors:3}){this._logService=k,this._documents=O,this._mainThreadBulkEdits=w,this._thresholds=g,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(O,w,g)=>{const m={dispose:this._callbacks.push([O,w,k])};return Array.isArray(g)&&g.push(m),m}}async $participateInSave(k,O){const w=i.URI.revive(k);let g=!1;const E=setTimeout(()=>g=!0,this._thresholds.timeout),m=[];try{for(const t of[...this._callbacks]){if(g)break;const o=this._documents.getDocument(w),a=await this._deliverEventAsyncAndBlameBadListeners(t,{document:o,reason:F.TextDocumentSaveReason.to(O)});m.push(a)}}finally{clearTimeout(E)}return m}_deliverEventAsyncAndBlameBadListeners([k,O,w],g){const E=this._badListeners.get(k);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,k,O,g).then(()=>!0,m=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const t=this._badListeners.get(k);this._badListeners.set(k,t?t+1:1),typeof t=="number"&&t>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,O,w,g){const E=[],m=Date.now(),{document:t,reason:o}=g,{version:a}=t,p=Object.freeze({document:t,reason:o,waitUntil(b){if(Object.isFrozen(E))throw(0,D.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(b))}});try{O.apply(w,[p])}catch(b){return Promise.reject(b)}return Object.freeze(E),new Promise((b,u)=>{const C=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(C),b(s)}).catch(s=>{clearTimeout(C),u(s)})}).then(b=>{const u={edits:[]};for(const C of b)if(Array.isArray(C)&&C.every(s=>s instanceof S.TextEdit))for(const{newText:s,newEol:c,range:n}of C)u.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:n&&F.Range.from(n),text:s,eol:c&&F.EndOfLine.from(c)}});if(u.edits.length!==0)return a===t.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(De[185],Ce([1,0,13,2,8,6,66]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(w,g,E,m){this.start=w,this.deletedCount=g,this.deletedItems=E,this.items=m}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(w,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,g,E){this.notebook=w,this._extHostDocument=g,this._cellData=E,this.handle=E.handle,this.uri=D.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return w._mime},set mime(m){w._mime=m},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(w){this._outputs=w.map(S.NotebookCellOutput.to)}setOutputItems(w,g,E){const m=E.map(S.NotebookCellOutputItem.to),t=this._outputs.find(o=>o.id===w);if(t&&(g||(t.items.length=0),t.items.push(...m),t.items.length>1&&t.items.every(o=>_.isTextStreamMime(o.mime)))){const o=new Map,a=[];t.items.forEach(p=>{let b;o.has(p.mime)?b=o.get(p.mime):(b=[],o.set(p.mime,b),a.push(p.mime)),b.push(p.data)}),t.items.length=0,a.forEach(p=>{const b=_.compressOutputItemStreams(o.get(p));t.items.push({mime:p,data:b.buffer})})}}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=y;class k{constructor(w,g,E,m,t){this._proxy=w,this._textDocumentsAndEditors=g,this._textDocuments=E,this.uri=m,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=t.viewType,this._metadata=Object.freeze(t.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,t.cells]],!0,void 0),this._versionId=t.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this,g={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===i.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(E){return E=w._validateIndex(E),w._cells[E].apiCell},getCells(E){return(E?w._getCells(E):w._cells).map(t=>t.apiCell)},save(){return w._save()}};this._notebook=Object.freeze(g)}return this._notebook}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,g,E){this._versionId=w.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:E});const m={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},t=[];for(const a of w.rawEvents)a.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1,m.contentChanges):a.kind===_.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx,m.contentChanges):a.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(a.index,a.outputs),t.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems),t.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(a.index,a.language),t.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document})):a.kind===_.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document}):a.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(a.index,a.metadata),t.push({cell:this._cells[a.index].apiCell,metadata:this._cells[a.index].apiCell.metadata})):a.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(a.index,a.internalMetadata),t.push({cell:this._cells[a.index].apiCell,executionSummary:this._cells[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<t.length;a++){const p=t[a],b=o.get(p.cell);if(b===void 0){const u=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});o.set(p.cell,u-1)}else m.cellChanges[b]={...m.cellChanges[b],...p}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let g=w.start|0,E=w.end|0;return g<0&&(g=0),E>this._cells.length&&(E=this._cells.length),w.with({start:g,end:E})}_getCells(w){w=this._validateRange(w);const g=[];for(let E=w.start;E<w.end;E++)g.push(this._cells[E]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,g,E){if(this._disposed)return;const m=[],t=[],o=[];if(w.reverse().forEach(a=>{const b=a[2].map(s=>{const c=new y(this,this._textDocumentsAndEditors,s);return g||t.push(y.asModelAddData(this.apiNotebook,s)),c}),u=new A(a[0],a[1],[],b),C=this._cells.splice(a[0],a[1],...b);for(const s of C)o.push(s.uri),u.deletedItems.push(s.apiCell);m.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:o}),E)for(const a of m)E.push(a.asApiEvent())}_moveCell(w,g,E){const m=this._cells.splice(w,1);this._cells.splice(g,0,...m);const t=[new A(w,1,m.map(o=>o.apiCell),[]),new A(g,0,[],m)];for(const o of t)E.push(o.asApiEvent())}_setCellOutputs(w,g){this._cells[w].setOutputs(g)}_setCellOutputItems(w,g,E,m){this._cells[w].setOutputItems(g,E,m)}_changeCellLanguage(w,g){const E=this._cells[w];E.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(E.uri,g)}_changeCellMime(w,g){const E=this._cells[w];E.apiCell.mime=g}_changeCellMetadata(w,g){this._cells[w].setMetadata(g)}_changeCellInternalMetadata(w,g){this._cells[w].setInternalMetadata(g)}getCellFromApiCell(w){return this._cells.find(g=>g.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(g=>g.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(De[95],Ce([1,0,12,8,6]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{constructor(A,y,k,O,w,g){this.id=A,this._proxy=y,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=w,this._visibleRanges=O,this._viewColumn=g}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(y){this.selections=[y]},get selections(){return A._selections},set selections(y){if(!Array.isArray(y)||!y.every(S.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");A._selections=y,A._trySetSelections(y)},get visibleRanges(){return A._visibleRanges},revealRange(y,k){A._proxy.$tryRevealRange(A.id,D.NotebookRange.from(y),k??S.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(D.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(De[186],Ce([1,0,4,11,8]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let F=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookEditorSelection=new i.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new i.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const k=this._notebooksAndEditors.getEditorById(A);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(S.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(S.NotebookRange.to)),y.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this._notebooksAndEditors.getEditorById(y)._acceptViewColumn(S.ViewColumn.to(A[y]))}};F=xe([We(0,D.ILogService)],F),e.ExtHostNotebookEditors=F}),define(De[187],Ce([1,0,8,153,133,21,58,12]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,E,m){const t=this._handles++,{title:o,location:a,cancellable:p}=E,b={label:(0,S.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(t,{location:i.ProgressLocation.from(a),title:o,source:b,cancellable:p},g.isUnderDevelopment?void 0:g.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(t,m,!!p)}_withProgress(g,E,m){let t;m&&(t=new F.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,t));const o=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),t?.dispose()};let a;try{a=E(new O(this._proxy,g),m&&t?t.token:F.CancellationToken.None)}catch(p){throw o(g),p}return a.then(p=>o(g),p=>o(g)),a}$acceptProgressCanceled(g){const E=this._mapHandleToCancellationSource.get(g);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=y;function k(w,g){return w.message=g.message,typeof g.increment=="number"&&(typeof w.increment=="number"?w.increment+=g.increment:w.increment=g.increment),w}class O extends D.Progress{constructor(g,E){super(m=>this.throttledReport(m)),this._proxy=g,this._handle=E}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}xe([(0,_.throttle)(100,(w,g)=>k(w,g),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(De[96],Ce([1,0,52,92,41,67,51,8,2]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,u,C,s)=>{let c=u;return{enumerable:!0,configurable:!1,get(){return c},set(n){if(!C(c,n)){const d=c;c=n,b.listener?.(s(n,d))}}}},O=(b,u)=>b===u,w={range:(b,u)=>b===u?!0:!b||!u?!1:b.isEqual(u),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,u)=>!(b.length!==u.length||b.some(C=>!u.find(s=>C.id===s.id)))},g=b=>u=>({op:4,update:b(u)}),E=(b,u)=>({range:(()=>{let C;const s=g(c=>({range:i.Range.lift(A.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return C},set(c){b.listener?.({op:6}),w.range(C,c)||(C=c,b.listener?.(s(c)))}}})(),label:k(b,u,w.label,g(C=>({label:C}))),description:k(b,void 0,w.description,g(C=>({description:C}))),sortText:k(b,void 0,w.sortText,g(C=>({sortText:C}))),canResolveChildren:k(b,!1,w.canResolveChildren,C=>({op:2,state:C})),busy:k(b,!1,w.busy,g(C=>({busy:C}))),error:k(b,void 0,w.error,g(C=>({error:A.MarkdownString.fromStrict(C)||null}))),tags:k(b,[],w.tags,(C,s)=>({op:1,new:C.map(A.TestTag.from),old:s.map(A.TestTag.from)}))}),m=b=>{const u=S.TestId.fromString(b.extId),C=new o(u.controllerId,u.localId,b.label,y.URI.revive(b.uri)||void 0);return C.range=A.Range.to(b.range||void 0),C.description=b.description||void 0,C.sortText=b.sortText||void 0,C.tags=b.tags.map(s=>A.TestTag.to({id:(0,_.denamespaceTestTag)(s).tagId})),C},t=b=>{let u;for(const C of b.tests){const s=m(C.item);(0,D.getPrivateApiFor)(s).parent=u,u=s}return u};e.toItemFromContext=t;class o{constructor(u,C,s,c){if(C.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(C)} symbol`);const n=(0,D.createPrivateApiFor)(this,u);Object.defineProperties(this,{id:{value:C,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof a?void 0:n.parent}},children:{value:(0,F.createTestItemChildren)(n,D.getPrivateApiFor,o),enumerable:!0,writable:!1},...E(n,s)})}}e.TestItemImpl=o;class a extends o{constructor(u,C){super(u,u,C,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class p extends F.TestItemCollection{constructor(u,C,s){super({controllerId:u,getDocumentVersion:c=>c&&s.getDocument(c)?.version,getApiFor:D.getPrivateApiFor,getChildren:c=>c.children,root:new a(u,C),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(De[97],Ce([1,0,47,12,78,8,6]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(g,E,m){const t=A._Keys.nextId();g.$registerTextEditorDecorationType(E.identifier,t,F.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:t,dispose(){g.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=A,A._Keys=new S.IdGenerator("TextEditorDecorationType");class y{constructor(g,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,E){this._throwIfFinalized();let m=null;if(g instanceof _.Position)m=new _.Range(g,g);else if(g instanceof _.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,E,!1)}insert(g,E){this._throwIfFinalized(),this._pushEdit(new _.Range(g,g),E,!0)}delete(g){this._throwIfFinalized();let E=null;if(g instanceof _.Range)E=g;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(g,E,m){const t=this._document.validateRange(g);this._collectedEdits.push({range:t,text:E,forceMoveMarkers:m})}setEndOfLine(g){if(this._throwIfFinalized(),g!==_.EndOfLine.LF&&g!==_.EndOfLine.CRLF)throw(0,D.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=y;class k{constructor(g,E,m,t){this._proxy=g,this._id=E,this._accept(m),this._logService=t;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(a){o._setTabSize(a)},get insertSpaces(){return o._insertSpaces},set insertSpaces(a){o._setInsertSpaces(a)},get cursorStyle(){return o._cursorStyle},set cursorStyle(a){o._setCursorStyle(a)},get lineNumbers(){return o._lineNumbers},set lineNumbers(a){o._setLineNumbers(a)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=F.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const E=Math.floor(g);return E>0?E:null}if(typeof g=="string"){const E=parseInt(g,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(g){const E=this._validateTabSize(g);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const E=this._validateInsertSpaces(g);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:F.TextEditorLineNumbersStyle.from(g)})))}assign(g){const E={};let m=!1;if(typeof g.tabSize<"u"){const t=this._validateTabSize(g.tabSize);t==="auto"?(m=!0,E.tabSize=t):typeof t=="number"&&this._tabSize!==t&&(this._tabSize=t,m=!0,E.tabSize=t)}if(typeof g.insertSpaces<"u"){const t=this._validateInsertSpaces(g.insertSpaces);t==="auto"?(m=!0,E.insertSpaces=t):this._insertSpaces!==t&&(this._insertSpaces=t,m=!0,E.insertSpaces=t)}typeof g.cursorStyle<"u"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,m=!0,E.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,m=!0,E.lineNumbers=F.TextEditorLineNumbersStyle.from(g.lineNumbers)),m&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(g,E){E.catch(m=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(m)})}}e.ExtHostTextEditorOptions=k;class O{constructor(g,E,m,t,o,a,p,b){this.id=g,this._proxy=E,this._logService=m,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new k(this._proxy,this.id,a,m),this._visibleRanges=p,this._viewColumn=b;const u=this;this.value=Object.freeze({get document(){return t.getValue()},set document(C){throw(0,D.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(C){if(!(C instanceof _.Selection))throw(0,D.illegalArgument)("selection");u._selections=[C],u._trySetSelection()},get selections(){return u._selections},set selections(C){if(!Array.isArray(C)||C.some(s=>!(s instanceof _.Selection)))throw(0,D.illegalArgument)("selections");u._selections=C,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(C){throw(0,D.readonly)("visibleRanges")},get options(){return u._options.value},set options(C){u._disposed||u._options.assign(C)},get viewColumn(){return u._viewColumn},set viewColumn(C){throw(0,D.readonly)("viewColumn")},edit(C,s={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new y(t.getValue(),s);return C(c),u._applyEdit(c)},insertSnippet(C,s,c={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=u._selections.map(d=>F.Range.from(d));else if(s instanceof _.Position){const{lineNumber:d,column:l}=F.Position.from(s);n=[{startLineNumber:d,startColumn:l,endLineNumber:d,endColumn:l}]}else if(s instanceof _.Range)n=[F.Range.from(s)];else{n=[];for(const d of s)if(d instanceof _.Range)n.push(F.Range.from(d));else{const{lineNumber:l,column:f}=F.Position.from(d);n.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return E.$tryInsertSnippet(g,t.getValue().version,C.value,n,c)},setDecorations(C,s){const c=s.length===0;c&&!u._hasDecorationsForKey.has(C.key)||(c?u._hasDecorationsForKey.delete(C.key):u._hasDecorationsForKey.add(C.key),u._runOnProxy(()=>{if(F.isDecorationOptionsArr(s))return E.$trySetDecorations(g,C.key,F.fromRangeOrRangeWithMessage(s));{const n=new Array(4*s.length);for(let d=0,l=s.length;d<l;d++){const f=s[d];n[4*d]=f.start.line+1,n[4*d+1]=f.start.character+1,n[4*d+2]=f.end.line+1,n[4*d+3]=f.end.character+1}return E.$trySetDecorationsFast(g,C.key,n)}}))},revealRange(C,s){u._runOnProxy(()=>E.$tryRevealRange(g,F.Range.from(C),s||_.TextEditorRevealType.Default))},show(C){E.$tryShowEditor(g,F.ViewColumn.from(C))},hide(){E.$tryHideEditor(g)}})}dispose(){(0,i.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,i.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,i.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,i.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,i.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(F.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const E=g.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const m=E.edits.map(o=>o.range);m.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=m.length-1;o<a;o++){const p=m[o].end;if(m[o+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=E.edits.map(o=>({range:F.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,t,{setEndOfLine:typeof E.setEndOfLine=="number"?F.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=O}),define(De[188],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[189],Ce([1,0,144,12,29,85,88,30,25,188,152]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const w=A.Registry.as(_.Extensions.JSONContribution);class g{constructor(u,C,s){this._messageHandler=u,this._extension=C,this._extensionPointId=s}_msg(u,C){this._messageHandler({type:u,message:C,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(u){this._msg(S.default.Error,u)}warn(u){this._msg(S.default.Warning,u)}info(u){this._msg(S.default.Info,u)}}e.ExtensionMessageCollector=g;class E{static _toSet(u){const C=new Set;for(let s=0,c=u.length;s<c;s++)C.add(y.ExtensionIdentifier.toKey(u[s].description.identifier));return C}static compute(u,C){if(!u||!u.length)return new E(C,[]);if(!C||!C.length)return new E([],u);const s=this._toSet(u),c=this._toSet(C),n=C.filter(l=>!s.has(y.ExtensionIdentifier.toKey(l.description.identifier))),d=u.filter(l=>!c.has(y.ExtensionIdentifier.toKey(l.description.identifier)));return new E(n,d)}constructor(u,C){this.added=u,this.removed=C}}e.ExtensionPointUserDelta=E;class m{constructor(u,C){this.name=u,this.defaultExtensionKind=C,this._handler=null,this._users=null,this._delta=null}setHandler(u){if(this._handler!==null)throw new Error("Handler already set!");this._handler=u,this._handle()}acceptUsers(u){this._delta=E.compute(this._users,u),this._users=u,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(u){(0,D.onUnexpectedError)(u)}}}e.ExtensionPoint=m;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:i.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:i.localize(31,null)},{label:"onUri",body:"onUri",description:i.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(36,null)},{label:"onRenderer",description:i.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(39,null)},{label:"*",description:i.localize(40,null),body:"*"}]}},badges:{type:"array",description:i.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(42,null)},href:{type:"string",description:i.localize(43,null)},description:{type:"string",description:i.localize(44,null)}}}},markdown:{type:"string",description:i.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(49,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(50,null)},{body:["workspace"],description:i.localize(51,null)},{body:["ui","workspace"],description:i.localize(52,null)},{body:["workspace","ui"],description:i.localize(53,null)},{body:[],description:i.localize(54,null)}]},capabilities:{description:i.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(58,null),i.localize(59,null),i.localize(60,null)]},description:{type:"string",markdownDescription:i.localize(61,null)}}},untrustedWorkspaces:{description:i.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(64,null),i.localize(65,null),i.localize(66,null)]},restrictedConfigurations:{description:i.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(68,null)}}}}},sponsor:{description:i.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(71,null),type:"string"},"vscode:uninstall":{description:i.localize(72,null),type:"string"}}},icon:{type:"string",description:i.localize(73,null)},l10n:{type:"string",description:i.localize(74,null)}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(u){if(this._extensionPoints.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const C=new m(u.extensionPoint,u.defaultExtensionKind);return this._extensionPoints.set(u.extensionPoint,C),e.schema.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,w.registerSchema(o,e.schema),C}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const p={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(p.ExtensionsRegistry,new a),e.ExtensionsRegistry=A.Registry.as(p.ExtensionsRegistry),w.registerSchema(o,e.schema),w.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(De[190],Ce([1,0,141,9,24,189,40,4]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(g){function E(m,t,o){if(!m)return;const a=D.isString(m.type)?m.type:void 0;if(!a||a.length===0){o.error(i.localize(3,null));return}const p=[];if(Array.isArray(m.required))for(const b of m.required)D.isString(b)&&p.push(b);return{extensionId:t.value,taskType:a,required:p,properties:m.properties?S.deepClone(m.properties):{},when:m.when?_.ContextKeyExpr.deserialize(m.when):void 0}}g.from=E})(k||(k={}));const O=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:y}});class w{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,m)=>{O.setHandler((t,o)=>{this._schema=void 0;try{for(const a of o.removed){const p=a.value;for(const b of p)this.taskTypes&&b.type&&this.taskTypes[b.type]&&delete this.taskTypes[b.type]}for(const a of o.added){const p=a.value;for(const b of p){const u=k.from(b,a.description.identifier,a.collector);u&&(this.taskTypes[u.taskType]=u)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const m of this.all()){const t={type:"object",additionalProperties:!1};m.required.length>0&&(t.required=m.required.slice(0)),m.properties!==void 0?t.properties=S.deepClone(m.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[m.taskType]},E.push(t)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistryImpl=w,e.TaskDefinitionRegistry=new w}),define(De[191],Ce([1,0,142,9,22,24,40,190]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var y;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function B(x){if(!x)return R.Strong;switch(x.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=B}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(R){function B(x){switch(x.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=B}(O=e.RevealKind||(e.RevealKind={}));var w;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function B(x){switch(x.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=B}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var g;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(g=e.PanelKind||(e.PanelKind={})),function(R){function B(x){switch(x.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=B}(g=e.PanelKind||(e.PanelKind={}));var E;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(R){function B(U){switch(U.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=B;function x(U){switch(U){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=x}(m=e.RuntimeType||(e.RuntimeType={}));var t;(function(R){function B(x){return D.isString(x)?x:x.value}R.value=B})(t=e.CommandString||(e.CommandString={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function B(U){return U===R.Clean._id||U===R.Build._id||U===R.Rebuild._id||U===R.Test._id}R.is=B;function x(U){if(U!==void 0)return D.isString(U)?B(U)?{_id:U,isDefault:!1}:void 0:U}R.from=x})(o=e.TaskGroup||(e.TaskGroup={}));var a;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var p;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function B(x){switch(x){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=B})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(R){R.parallel="parallel",R.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var u;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(u=e.RunOnOptions||(e.RunOnOptions={}));var C;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(C=e.RunOptions||(e.RunOptions={}));class s{constructor(B,x,U,K,te,de){this._label="",this._id=B,x&&(this._label=x),U&&(this.type=U),this.runOptions=K,this.configurationProperties=te,this._source=de}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.getFolderId(),id:this._id};return JSON.stringify(B)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,x=!1){if(B===void 0)return!1;if(D.isString(B))return B===this._label||B===this.configurationProperties.identifier||x&&B===this._id;const U=this.getDefinition(!0);return U!==void 0&&U._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),B&&(this._taskLoadMessages=this._taskLoadMessages.concat(B))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class c extends s{constructor(B,x,U,K,te,de,re,be){super(B,U,void 0,re,be,x),this.command={},this._source=x,this.hasDefinedMatchers=de,te&&(this.command=te)}clone(){return new c(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case m.Shell:x="shell";break;case m.Process:x="process";break;case m.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(B){return B instanceof c}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.getFolderId();if(!B)return;let x=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(x+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:x};return JSON.stringify(U)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(B){return new c(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=c;class n extends s{constructor(B,x,U,K,te,de,re){super(B,U,K,de,re,x),this._source=x,this.configures=te}static is(B){return B instanceof n}fromObject(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.getFolderId();if(!B)return;let x=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(x+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:x};return JSON.stringify(U)}}e.ConfiguringTask=n;class d extends s{constructor(B,x,U,K,te,de,re,be,le){super(B,U,K,be,le,x),this.defines=te,this.hasDefinedMatchers=re,this.command=de,this.icon=le.icon,this.hide=le.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof d}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.getFolderId(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(B){return new d(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=d;class l extends s{constructor(B,x,U,K,te,de){super(B,U,K,te,de,x),this._source=x}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(B){return new l(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=l;var f;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(f=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(f=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(B){this._order=new Map;for(let x=0;x<B.length;x++)this._order.set(B[x].uri.toString(),x)}compare(B,x){const U=B.getWorkspaceFolder(),K=x.getWorkspaceFolder();if(U&&K){let te=this._order.get(U.uri.toString());te=te===void 0?0:te+1;let de=this._order.get(K.uri.toString());return de=de===void 0?0:de+1,te===de?B._label.localeCompare(x._label):te-de}else return!U&&K?-1:U&&!K?1:0}}e.TaskSorter=h;var v;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var I;(function(R){R.SingleRun="singleRun",R.Background="background"})(I=e.TaskRunType||(e.TaskRunType={}));var L;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(R){function B(x,U,K,te,de){if(U){const re={kind:x,taskId:U._id,taskName:U.configurationProperties.name,runType:U.configurationProperties.isBackground?"background":"singleRun",group:U.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:U};return x==="start"?(re.terminalId=K,re.resolvedVariables=te):x==="processStarted"?re.processId=K:x==="processEnded"&&(re.exitCode=K),Object.freeze(re)}else return Object.freeze({kind:"changed"})}R.create=B})(j=e.TaskEvent||(e.TaskEvent={}));var W;(function(R){function B(U){const K=Object.keys(U).sort();let te="";for(const de of K){let re=U[de];re instanceof Object?re=B(re):typeof re=="string"&&(re=re.replace(/,/g,",,")),te+=de+","+re+","}return te}function x(U){const te={_key:B(U),type:U.taskType};return Object.assign(te,U),te}R.create=x})(W=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var H;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(H=e.TaskSettingId||(e.TaskSettingId={}));var P;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(P=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(R){function B(x,U){const K=A.TaskDefinitionRegistry.get(x.type);if(K===void 0){const be=F.deepClone(x);return delete be._key,W.create(be)}const te=Object.create(null);te.type=K.taskType;const de=new Set;K.required.forEach(be=>de.add(be));const re=K.properties;for(const be of Object.keys(re)){const le=x[be];if(le!=null)te[be]=le;else if(de.has(be)){const fe=re[be];if(fe.default!==void 0)te[be]=F.deepClone(fe.default);else switch(fe.type){case"boolean":te[be]=!1;break;case"number":case"integer":te[be]=0;break;case"string":te[be]="";break;default:U.error(i.localize(2,null,JSON.stringify(x,void 0,0),be));return}}}return W.create(te)}R.createTaskIdentifier=B})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[192],Ce([1,0,12]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class D{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,A)=>{this._actualOk=_,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,i.onUnexpectedError)(_))}then(_,A){return this._ensureActual().then(_,A)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=D;class S extends D{constructor(){super(),this._hasErr=!0,this._err=new i.CancellationError}}e.CanceledLazyPromise=S}),define(De[42],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const D=[];function S(A){const y=new i(A);return D[y.nid]=y,y}e.createProxyIdentifier=S;function F(A){return D[A].sid}e.getStringIdentifierForProxy=F;class _{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=_}),define(De[5],Ce([1,0,42]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var F;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(F=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(o){return o._id=w._n++,o}}e.IdObject=w,w._n=0;var g;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.command="m",t.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(De[71],Ce([1,0,3,11,5,14]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(S.MainContext.MainThreadTelemetry)}report(y,k,O){const w=this.getUsageKey(y,k);this._reportedUsages.has(w)||(this._reportedUsages.add(w),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};_=xe([We(0,F.IExtHostRpcService),We(1,D.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,k){}})}),define(De[193],Ce([1,0,4,5,6,25]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,k,O,w={}){const g=F.ExtensionIdentifier.toKey(y.identifier),E=this._inFlightRequests.get(g)||[],m=[...O].sort().join(" ");let t=E.find(o=>o.providerId===k&&o.scopes===m);if(t)return t.result;{const o=this._getSession(y,g,k,O,w);t={providerId:k,scopes:m,result:o},E.push(t),this._inFlightRequests.set(g,E);try{await o}finally{const a=E.findIndex(p=>p.providerId===k&&p.scopes===m);a>-1&&(E.splice(a),this._inFlightRequests.set(g,E))}return o}}async _getSession(y,k,O,w,g={}){await this._proxy.$ensureProvider(O);const E=y.displayName||y.name;return this._proxy.$getSession(O,w,k,E,g)}async removeSession(y,k){const O=this._authenticationProviders.get(y);return O?O.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,O,w){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:O,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===y)||this._providers.push({id:y,label:k});const g=O.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(y,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,k,w?.supportsMultipleAccounts??!1),new S.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const E=this._providers.findIndex(m=>m.id===y);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(De[194],Ce([1,0,5,14,8]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=class{constructor(A,y){this._proxy=A.getProxy(i.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,k){const O=S.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};F=xe([We(0,D.IExtHostRpcService)],F),e.ExtHostBulkEdits=F}),define(De[195],Ce([1,0,5]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class D{constructor(F){const _=F.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(A){return _.$writeText(A)}})}}e.ExtHostClipboard=D});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[37],Ce([1,0,9,6,8,24,5,18,11,80,52,248,2,7,3,14,96,23,42,44]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b){"use strict";var u,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(r,h){u.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,C.set(this,void 0),Ye(this,u,r.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=h,Ye(this,C,r.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,v=>{const I=this._apiCommands.get(v);return I?.result===d.Void?I:void 0},h),this._argumentProcessors=[{processArgument(v){return(0,k.revive)(v)}},{processArgument(v){return(0,F.cloneAndChange)(v,function(I){if(O.Range.isIRange(I))return S.Range.to(I);if(w.Position.isIPosition(I))return S.Position.to(I);if(O.Range.isIRange(I.range)&&g.URI.isUri(I.uri))return S.location.to(I);if(I instanceof a.VSBuffer)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const h=this.registerCommand(!1,r.id,async(...v)=>{const I=r.args.map((j,W)=>{if(!j.validate(v[W]))throw new Error(`Invalid argument '${j.name}' when running '${r.id}', received: ${v[W]}`);return j.convert(v[W])}),L=await this.executeCommand(r.internalId,...I);return r.result.convert(L,v,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new D.Disposable(()=>{h.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,h,v,I,L,j){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:v,thisArg:I,description:L,extension:j}),r&&Oe(this,u,"f").$registerCommand(h),new D.Disposable(()=>{this._commands.delete(h)&&r&&Oe(this,u,"f").$unregisterCommand(h)})}executeCommand(r,...h){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,h,!0)}async _doExecuteCommand(r,h,v){if(this._commands.has(r))return Oe(this,u,"f").$fireCommandActivationEvent(r),this._executeContributedCommand(r,h,!1);{let I=!1;const L=(0,F.cloneAndChange)(h,function(j){if(j instanceof D.Position)return S.Position.from(j);if(j instanceof D.Range)return S.Range.from(j);if(j instanceof D.Location)return S.location.from(j);if(D.NotebookRange.isNotebookRange(j))return S.NotebookRange.from(j);if(j instanceof ArrayBuffer)return I=!0,a.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return I=!0,a.VSBuffer.wrap(j);if(j instanceof a.VSBuffer)return I=!0,j;if(!Array.isArray(j))return j});try{const j=await Oe(this,u,"f").$executeCommand(r,I?new p.SerializableObjectWithBuffers(L):L,v);return(0,k.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(r,h,!1);throw j}}}async _executeContributedCommand(r,h,v){const I=this._commands.get(r);if(!I)throw new Error("Unknown command");this._reportTelemetry(I,r);const{callback:L,thisArg:j,description:W}=I;if(W)for(let H=0;H<W.args.length;H++)try{(0,i.validateConstraint)(h[H],W.args[H].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${W.args[H].name}' - ${W.args[H].description}`)}try{return await L.apply(j,h)}catch(H){if(r===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...h);P&&(r=P.command)}throw this._logService.error(H,r,I.extension?.identifier),v?new class extends Error{constructor(){super((0,b.toErrorMessage)(H)),this.id=r,this.source=I.extension?.displayName??I.extension?.name}}:H}}_reportTelemetry(r,h){!r.extension||r.extension.isBuiltin||Oe(this,C,"f").$publicLog2("Extension:ActionExecuted",{extensionId:r.extension.identifier.value,id:h})}$executeContributedCommand(r,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",r),this._commands.has(r)?(h=h.map(v=>this._argumentProcessors.reduce((I,L)=>L.processArgument(I),v)),this._executeContributedCommand(r,h,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),Oe(this,u,"f").$getCommands().then(h=>(r&&(h=h.filter(v=>v[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(const[h,v]of this._commands){const{description:I}=v;I&&(r[h]=I)}return Promise.resolve(r)}};u=new WeakMap,C=new WeakMap,s=xe([We(0,t.IExtHostRpcService),We(1,y.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class c{constructor(r,h,v){this._commands=r,this._lookupApiCommand=h,this._logService=v,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,h){if(!r)return;const v={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return v;const I=this._lookupApiCommand(r.command);if(I)v.id=I.internalId,v.arguments=I.args.map((L,j)=>L.convert(r.arguments&&r.arguments[j]));else if((0,A.isNonEmptyArray)(r.arguments)){const L=++this._cachIdPool;this._cache.set(L,r),h.add((0,E.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),v.$ident=L,v.id=this.delegatingCommandId,v.arguments=[L],this._logService.trace("CommandsConverter#CREATE",r.command,L)}return v}fromInternal(r){return typeof r.$ident=="number"?this._cache.get(r.$ident):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const h=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=c;class n{constructor(r,h,v,I){this.name=r,this.description=h,this.validate=v,this.convert=I}optional(){return new n(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,h){return new n(r??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",f=>g.URI.isUri(f),f=>f),n.Position=new n("position","A position in a text document",f=>D.Position.isPosition(f),S.Position.from),n.Range=new n("range","A range in a text document",f=>D.Range.isRange(f),S.Range.from),n.Selection=new n("selection","A selection in a text document",f=>D.Selection.isSelection(f),S.Selection.from),n.Number=new n("number","",f=>typeof f=="number",f=>f),n.String=new n("string","",f=>typeof f=="string",f=>f),n.CallHierarchyItem=new n("item","A call hierarchy item",f=>f instanceof D.CallHierarchyItem,S.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",f=>f instanceof D.TypeHierarchyItem,S.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",f=>f instanceof o.TestItemImpl,S.TestItem.from);class d{constructor(r,h){this.description=r,this.convert=h}}e.ApiCommandResult=d,d.Void=new d("no result",f=>f);class l{constructor(r,h,v,I,L){this.id=r,this.internalId=h,this.description=v,this.args=I,this.result=L}}e.ApiCommand=l}),define(De[196],Ce([1,0,2,8,6,70,37,18,83,87,13]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(D.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,o)=>{if((0,A.isFalsyOrEmpty)(t))return;class a extends S.SymbolInformation{static to(b){const u=new a(b.name,D.SymbolKind.to(b.kind),b.containerName||"",new S.Location(o[0],D.Range.to(b.range)));return u.detail=b.detail,u.range=u.location.range,u.selectionRange=D.Range.to(b.selectionRange),u.children=b.children?b.children.map(a.to):[],u}}return t.map(a.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(D.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(D.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new _.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(D.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(D.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(D.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(o=>S.Position.isPosition(o)),t=>t.map(D.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(o=>{let a;for(const p of o.reverse())a=new S.SelectionRange(D.Range.to(p),a);return a}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(D.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(D.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(D.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(D.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:D.Range.to(t.range),placeholder:t.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return D.WorkspaceEdit.to(t)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(D.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,y.decodeSemanticTokensDto)(t);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,y.decodeSemanticTokensDto)(t);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,o,a)=>{if(!t)return new S.CompletionList([]);const p=t.suggestions.map(b=>D.CompletionItem.to(b,a));return new S.CompletionList(p,t.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return D.SignatureHelp.to(t)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,o,a)=>E(p=>new S.CodeLens(D.Range.to(p.range),p.command&&a.fromInternal(p.command)))(t))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.Range.isRange(t),t=>S.Selection.isSelection(t)?D.Selection.from(t):D.Range.from(t)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,o,a)=>E(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(p.command)}else{const b=new S.CodeAction(p.title,p.kind?new S.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=D.WorkspaceEdit.to(p.edit)),p.command&&(b.command=a.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(t))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(o=>new S.ColorInformation(D.Range.to(o.range),D.Color.to(o.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",t=>t instanceof S.Color,D.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:D.Range.from(t.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(D.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,o,a)=>t.map(D.InlayHint.to.bind(void 0,a)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(o=>D.NotebookExclusiveDocumentPattern.to(o))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(D.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,k.matchesSomeScheme)(t,O.Schemas.http,O.Schemas.https),t=>t),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[D.ViewColumn.from(t),void 0]:[D.ViewColumn.from(t.viewColumn),D.TextEditorOpenOptions.from(t)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[D.ViewColumn.from(t),void 0]:[D.ViewColumn.from(t.viewColumn),D.TextEditorOpenOptions.from(t)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[D.ViewColumn.from(t.viewColumn),D.TextEditorOpenOptions.from(t)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(D.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(D.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(D.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class g{static register(o){w.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=g;function E(t){return o=>{if(Array.isArray(o))return o.map(t)}}function m(t){if(!Array.isArray(t))return;const o=[];for(const a of t)F.isLocationLink(a)?o.push(D.DefinitionLink.to(a)):o.push(D.location.to(a));return o}}),define(De[197],Ce([1,0,15,58,4,7,2,70,25,8,6,27,5]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(m,t,o){const a=m.getProxy(g.MainContext.MainThreadComments);class p{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,t.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const r=this._commentControllers.get(f.handle);return r?r.value:f}else if(f&&f.$mid===7){const r=this._commentControllers.get(f.commentControlHandle);if(!r)return f;const h=r.getCommentThread(f.commentThreadHandle);return h?h.value:f}else if(f&&f.$mid===8){const r=this._commentControllers.get(f.thread.commentControlHandle);if(!r)return f;const h=r.getCommentThread(f.thread.commentThreadHandle);return h?{thread:h.value,text:f.text}:f}else if(f&&f.$mid===9){const r=this._commentControllers.get(f.thread.commentControlHandle);if(!r)return f;const h=r.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.commentUniqueId,I=h.getCommentByUniqueId(v);return I||f}else if(f&&f.$mid===10){const r=this._commentControllers.get(f.thread.commentControlHandle);if(!r)return f;const h=r.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.text,I=f.commentUniqueId,L=h.getCommentByUniqueId(I);return L?(typeof L.body=="string"?L.body=v:L.body.value=v,L):f}return f}})}createCommentController(f,r,h){const v=p.handlePool++,I=new u(f,v,r,h);this._commentControllers.set(I.handle,I);const L=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(f.identifier))||[];return L.push(I),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(f.identifier),L),I.value}$createCommentThreadTemplate(f,r,h){const v=this._commentControllers.get(f);!v||v.$createCommentThreadTemplate(r,h)}async $updateCommentThreadTemplate(f,r,h){const v=this._commentControllers.get(f);!v||v.$updateCommentThreadTemplate(r,h)}$deleteCommentThread(f,r){this._commentControllers.get(f)?.$deleteCommentThread(r)}$provideCommentingRanges(f,r,h){const v=this._commentControllers.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const I=o.getDocument(_.URI.revive(r));return(0,i.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(I,h)).then(L=>L?L.map(j=>k.Range.from(j)):void 0)}$toggleReaction(f,r,h,v,I){const L=this._commentControllers.get(f);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const j=L.getCommentThread(r);if(j){const W=j.getCommentByUniqueId(v.uniqueIdInThread);if(L!==void 0&&W&&L.reactionHandler)return L.reactionHandler(W,c(I))}return Promise.resolve(void 0)})}dispose(){}}p.handlePool=0;class b{set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(f){(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,r,h,v,I,L,j,W){this._commentControllerHandle=r,this._id=h,this._uri=v,this._range=I,this._comments=L,this.extensionDescription=j,this._isTemplate=W,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputDisposables.value=new F.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),a.$createCommentThread(r,this.handle,this._id,this._uri,k.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(r,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(P){H.range=P},get comments(){return H.comments},set comments(P){H.comments=P},get collapsibleState(){return H.collapsibleState},set collapsibleState(P){H.collapsibleState=P},get canReply(){return H.canReply},set canReply(P){H.canReply=P},get contextValue(){return H.contextValue},set contextValue(P){H.contextValue=P},get label(){return H.label},set label(P){H.label=P},get state(){return H.state},set state(P){H.state=P},dispose:()=>{H.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new F.DisposableStore);const f=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),r={};f("range")&&(r.range=k.Range.from(this._range)),f("label")&&(r.label=this.label),f("contextValue")&&(r.contextValue=this.contextValue??null),f("comments")&&(r.comments=this._comments.map(h=>C(this,h,this._commentsMap))),f("collapsibleState")&&(r.collapseState=n(this._collapseState)),f("canReply")&&(r.canReply=this.canReply),f("state")&&(r.state=d(this._state)),f("isTemplate")&&(r.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(f){for(const r of this._commentsMap){const h=r[0],v=r[1];if(f===v)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}b._handlePool=0,xe([(0,D.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,r,h,v){this._extension=f,this._handle=r,this._id=h,this._label=v,this._threads=new Map,a.$registerCommentController(this.handle,h,v);const I=this;this.value=Object.freeze({id:I.id,label:I.label,get options(){return I.options},set options(L){I.options=L},get commentingRangeProvider(){return I.commentingRangeProvider},set commentingRangeProvider(L){I.commentingRangeProvider=L},get reactionHandler(){return I.reactionHandler},set reactionHandler(L){I.reactionHandler=L},createCommentThread(L,j,W){return I.createCommentThread(L,j,W).value},dispose:()=>{I.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(f,r,h,v){if(typeof f=="string"){const I=new b(this.id,this.handle,f,r,h,v,this._extension,!1);return this._threads.set(I.handle,I),I}else{const I=new b(this.id,this.handle,void 0,f,r,h,this._extension,!1);return this._threads.set(I.handle,I),I}}$createCommentThreadTemplate(f,r){const h=new b(this.id,this.handle,void 0,_.URI.revive(f),k.Range.to(r),[],this._extension,!0);return h.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(f,r){const h=this._threads.get(f);h&&(h.range=k.Range.to(r))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function C(l,f,r){let h=r.get(f);h||(h=++l.commentHandle,r.set(f,h));const v=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:h,body:typeof f.body=="string"?f.body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:v,label:f.label,commentReactions:f.reactions?f.reactions.map(I=>s(I)):void 0,timestamp:f.timestamp?.toJSON()}}function s(l){return{label:l.label,iconPath:l.iconPath?k.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function c(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?_.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function n(l){if(l!==void 0)switch(l){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function d(l){if(l!==void 0)switch(l){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new p}e.createExtHostComments=E}),define(De[198],Ce([1,0,24,5,26,14]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(O,w){this._mainThreadConsole=O.getProxy(D.MainContext.MainThreadConsole),this._includeStack=w.consoleForward.includeStack,this._logNative=w.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,w){const g=this,E=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){g._handleConsoleCall(O,w,E,arguments)}})}_handleConsoleCall(O,w,g,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:w,arguments:y(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,g,E)}};_=xe([We(0,F.IExtHostRpcService),We(1,S.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const A=1e5;function y(k,O){const w=[];if(k.length)for(let g=0;g<k.length;g++){let E=k[g];if(typeof E>"u")E="undefined";else if(E instanceof Error){const m=E;m.stack?E=m.stack:E=m.toString()}w.push(E)}if(O){const g=new Error().stack;g&&w.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,i.safeStringify)(w);return g.length>A?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(De[98],Ce([1,0,2,5,6,3,14,11,18,10,19]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Ri{constructor(E,m){this._logService=m,this._provider=new Map,this._proxy=E.getProxy(D.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,m){const t=Ri._handlePool++;this._provider.set(t,{provider:E,extensionId:m}),this._proxy.$registerDecorationProvider(t,m.value);const o=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(a=>{if(!a){this._proxy.$onDidChange(t,null);return}const p=(0,y.asArray)(a);if(p.length<=Ri._maxEventSize){this._proxy.$onDidChange(t,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.value,p.length);const b=p.map(s=>({uri:s,rank:(0,k.count)(s.path,"/")})),u=(0,y.groupBy)(b,(s,c)=>s.rank-c.rank||(0,k.compare)(s.uri.path,c.uri.path)),C=[];e:for(const s of u){let c;for(const n of s){const d=(0,O.dirname)(n.uri.path);if(c!==d&&(c=d,C.push(n.uri)>=Ri._maxEventSize))break e}}this._proxy.$onDidChange(t,C)});return new S.Disposable(()=>{o?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(E,m,t){if(!this._provider.has(E))return Object.create(null);const o=Object.create(null),{provider:a,extensionId:p}=this._provider.get(E);return await Promise.all(m.map(async b=>{try{const{uri:u,id:C}=b,s=await Promise.resolve(a.provideFileDecoration(i.URI.revive(u),t));if(!s)return;try{S.FileDecoration.validate(s),o[C]=[s.propagate,s.tooltip,s.badge,s.color]}catch(c){this._logService.warn(`INVALID decoration from extension '${p.value}': ${c}`)}}catch(u){this._logService.error(u)}})),o}};w._handlePool=0,w._maxEventSize=250,w=xe([We(0,_.IExtHostRpcService),We(1,A.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[199],Ce([1,0,131,86,2,5,6,8,4,11,28,36]),function(ne,e,i,D,S,F,_,A,y,k,O,w){"use strict";var g,E,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(p,b,u,C,s,c){this._name=p,this._owner=b,this._maxDiagnosticsPerFile=u,g.set(this,void 0),E.set(this,void 0),m.set(this,void 0),this._isDisposed=!1,Ye(this,m,new O.ResourceMap(n=>C.getComparisonKey(n)),"f"),Ye(this,g,s,"f"),Ye(this,E,c,"f")}dispose(){this._isDisposed||(Oe(this,E,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,g,"f")?.$clear(this._owner),Oe(this,m,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,b){if(!p){this.clear();return}this._checkDisposed();let u=[];if(S.URI.isUri(p)){if(!b){this.delete(p);return}Oe(this,m,"f").set(p,b.slice()),u=[p]}else if(Array.isArray(p)){u=[];let s;p=[...p].sort(t._compareIndexedTuplesByUri);for(const c of p){const[n,d]=c;if((!s||n.toString()!==s.toString())&&(s&&Oe(this,m,"f").get(s).length===0&&Oe(this,m,"f").delete(s),s=n,u.push(n),Oe(this,m,"f").set(n,[])),d)Oe(this,m,"f").get(n)?.push(...d);else{const l=Oe(this,m,"f").get(n);l&&(l.length=0)}}}if(Oe(this,E,"f").fire(u),!Oe(this,g,"f"))return;const C=[];for(const s of u){let c=[];const n=Oe(this,m,"f").get(s);if(n)if(n.length>this._maxDiagnosticsPerFile){c=[];const d=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const f of n)if(f.severity===d[l]&&c.push(A.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;c.push({severity:D.MarkerSeverity.Info,message:(0,i.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=n.map(d=>A.Diagnostic.from(d));C.push([s,c])}Oe(this,g,"f").$changeMany(this._owner,C)}delete(p){this._checkDisposed(),Oe(this,E,"f").fire([p]),Oe(this,m,"f").delete(p),Oe(this,g,"f")?.$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Oe(this,E,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,m,"f").clear(),Oe(this,g,"f")?.$clear(this._owner)}forEach(p,b){this._checkDisposed();for(const[u,C]of this)p.call(b,u,C,this)}*[(g=new WeakMap,E=new WeakMap,m=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const p of Oe(this,m,"f").keys())yield[p,this.get(p)]}get(p){this._checkDisposed();const b=Oe(this,m,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Oe(this,m,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=t;let o=class pi{static _mapper(p){const b=new O.ResourceMap;for(const u of p)b.set(u,u);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,u){this._logService=b,this._fileSystemInfoService=u,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:C=>C.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,pi._mapper),this._proxy=p.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{_collections:u,_proxy:C,_onDidChangeDiagnostics:s,_logService:c,_fileSystemInfoService:n}=this,d=new class{$changeMany(r,h){C.$changeMany(r,h),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,r,h.length===0?"CLEARING":h)}$clear(r){C.$clear(r),c.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,r)}dispose(){C.dispose()}};let l;if(!b)b="_generated_diagnostic_collection_name_#"+pi._idPool++,l=b;else if(!u.has(b))l=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do l=b+pi._idPool++;while(u.has(l))}return new class extends t{constructor(){super(b,l,pi._maxDiagnosticsPerFile,n.extUri,d,s),u.set(l,this)}dispose(){super.dispose(),u.delete(l)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const b=new Map,u=[];for(const C of this._collections.values())C.forEach((s,c)=>{let n=b.get(s.toString());typeof n>"u"&&(n=u.length,b.set(s.toString(),n),u.push([s,[]])),u[n][1]=u[n][1].concat(...c)});return u}}_getDiagnostics(p){let b=[];for(const u of this._collections.values())u.has(p)&&(b=b.concat(u.get(p)));return b}$acceptMarkersChange(p){if(!this._mirrorCollection){const b="_generated_mirror",u=new t(b,b,pi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,u),this._mirrorCollection=u}for(const[b,u]of p)this._mirrorCollection.set(S.URI.revive(b),u.map(A.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=xe([We(1,k.ILogService),We(2,w.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(De[200],Ce([1,0,2,5]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(_){this._proxy=_.getProxy(D.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(A=>A?A.map(y=>i.URI.revive(y)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(A=>A?i.URI.revive(A):void 0)}}e.ExtHostDialogs=S}),define(De[201],Ce([1,0,12,2,6,5,13,21,10]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(w,g,E){this._documentsAndEditors=g,this._logService=E,this._documentContentProviders=new Map,this._proxy=w.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,g){if(Object.keys(_.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const E=k._handlePool++;this._documentContentProviders.set(E,g),this._proxy.$registerTextContentProvider(E,w);let m;return typeof g.onDidChange=="function"&&(m=g.onDidChange(t=>{if(t.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(t)&&this.$provideTextDocumentContent(E,t).then(o=>{if(!o&&typeof o!="string")return;const a=this._documentsAndEditors.getDocument(t);if(!a)return;const p=(0,y.splitLines)(o);if(!a.equalLines(p))return this._proxy.$onVirtualDocumentChange(t,o)},i.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(w,g){const E=this._documentContentProviders.get(w);return E?Promise.resolve(E.provideTextDocumentContent(D.URI.revive(g),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(De[202],Ce([1,0,4,7,2,5,94,8,9,24,6]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(E,m){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new D.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(F.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const o of t)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const o of t)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const m=this._documentsAndEditors.getDocument(E);if(m)return m}getDocument(E){const m=this.getDocumentData(E);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return m.document}ensureDocumentData(E){const m=this._documentsAndEditors.getDocument(E);if(m)return Promise.resolve(m);let t=this._documentLoader.get(E.toString());return t||(t=this._proxy.$tryOpenDocument(E).then(o=>{this._documentLoader.delete(E.toString());const a=S.URI.revive(o);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(a))},o=>(this._documentLoader.delete(E.toString()),Promise.reject(o))),this._documentLoader.set(E.toString(),t)),t}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(m=>S.URI.revive(m))}$acceptModelLanguageChanged(E,m){const t=S.URI.revive(E),o=this._documentsAndEditors.getDocument(t);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(m),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(E){const m=S.URI.revive(E),t=this._documentsAndEditors.getDocument(m);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(E,m){const t=S.URI.revive(E),o=this._documentsAndEditors.getDocument(t);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,m,t){const o=S.URI.revive(E),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(m);let p;m.isUndoing?p=O.TextDocumentChangeReason.Undo:m.isRedoing&&(p=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:a.document,contentChanges:m.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(E,m){(0,_.setWordDefinitionFor)(E,m)}}e.ExtHostDocuments=w}),define(De[53],Ce([1,0,47,4,7,2,3,5,94,14,97,8,11,28,13,172,203]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let p=class{constructor(u,C){this._extHostRpc=u,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new D.Emitter,this._onDidRemoveDocuments=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const C=[],s=[],c=[];if(u.removedDocuments)for(const n of u.removedDocuments){const d=F.URI.revive(n),l=this._documents.get(d);l?.unref()&&(this._documents.delete(d),C.push(l.value))}if(u.addedDocuments)for(const n of u.addedDocuments){const d=F.URI.revive(n.uri);let l=this._documents.get(d);if(l&&d.scheme!==m.Schemas.vscodeNotebookCell&&d.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);l||(l=new a(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),d,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(d,l),s.push(l.value)),l.ref()}if(u.removedEditors)for(const n of u.removedEditors){const d=this._editors.get(n);this._editors.delete(n),d&&c.push(d)}if(u.addedEditors)for(const n of u.addedEditors){const d=F.URI.revive(n.documentUri);i.ok(this._documents.has(d),`document '${d}' does not exist`),i.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const l=this._documents.get(d).value,f=new O.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>l.document),n.selections.map(w.Selection.to),n.options,n.visibleRanges.map(r=>w.Range.to(r)),typeof n.editorPosition=="number"?w.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,f)}u.newActiveEditor!==void 0&&(i.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,S.dispose)(C),(0,S.dispose)(c),u.removedDocuments&&this._onDidRemoveDocuments.fire(C),u.addedDocuments&&this._onDidAddDocuments.fire(s),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){return this._documents.get(u)?.value}allDocuments(){return t.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return u?C:C?.value}allEditors(){return[...this._editors.values()]}};p=xe([We(0,k.IExtHostRpcService),We(1,g.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[54],Ce([1,0,8,5,2,4,3,6,14,9,77]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class w{constructor(o,a,p){this._activeTabIdGetter=p,this._parentGroup=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,a={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(a)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(S.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(S.URI.revive(this._dto.input.base),S.URI.revive(this._dto.input.input1),S.URI.revive(this._dto.input.input2),S.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(S.URI.revive(this._dto.input.uri),S.URI.revive(this._dto.input.inputBoxUri));default:return}}}class g{constructor(o,a){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=a;for(const p of o.tabs)p.isActive&&(this._activeTabId=p.id),this._tabs.push(new w(p,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,a={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return i.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(p=>p.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(p=>p.apiObject))}};this._apiObject=Object.freeze(a)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const p=new w(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,p),o.tabDto.isActive&&(this._activeTabId=p.tabId),p}else if(o.kind===1){const p=this._tabs.splice(o.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return p.tabId===this._activeTabId&&(this._activeTabId=""),p}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this._tabs.splice(o.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,p),p}const a=this._tabs.find(p=>p.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this._activeTabId}}let E=class{constructor(o){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(D.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,a={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(p=>p.apiObject))},get activeTabGroup(){const p=o._activeGroupId;return(0,k.assertIsDefined)(o._extHostTabGroups.find(u=>u.groupId===p)?.apiObject)},close:async(p,b)=>{const u=Array.isArray(p)?p:[p];return u.length?m(u[0])?this._closeGroups(u,b):this._closeTabs(u,b):!0}};this._apiObject=Object.freeze(a)}return this._apiObject}$acceptEditorTabModel(o){const a=new Set(this._extHostTabGroups.map(n=>n.groupId)),p=new Set(o.map(n=>n.groupId)),b=(0,O.diffSets)(a,p),u=this._extHostTabGroups.filter(n=>b.removed.includes(n.groupId)).map(n=>n.apiObject),C=[],s=[];this._extHostTabGroups=o.map(n=>{const d=new g(n,()=>this._activeGroupId);return b.added.includes(d.groupId)?C.push(d.apiObject):s.push(d.apiObject),d});const c=(0,k.assertIsDefined)(o.find(n=>n.isActive===!0)?.groupId);c!==void 0&&this._activeGroupId!==c&&(this._activeGroupId=c),this._onDidChangeTabGroups.fire(Object.freeze({opened:C,closed:u,changed:s}))}$acceptTabGroupUpdate(o){const a=this._extHostTabGroups.find(p=>p.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this._extHostTabGroups.find(b=>b.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const p=a.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}_findExtHostTabFromApi(o){for(const a of this._extHostTabGroups)for(const p of a.tabs)if(p.apiObject===o)return p}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(a=>a.apiObject===o)}async _closeTabs(o,a){const p=[];for(const b of o){const u=this._findExtHostTabFromApi(b);if(!u)throw new Error("Tab close: Invalid tab not found!");p.push(u.tabId)}return this._proxy.$closeTab(p,a)}async _closeGroups(o,a){const p=[];for(const b of o){const u=this._findExtHostTabGroupFromApi(b);if(!u)throw new Error("Group close: Invalid group not found!");p.push(u.groupId)}return this._proxy.$closeGroup(p,a)}};E=xe([We(0,y.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function m(t){return t.tabs!==void 0}}),define(De[204],Ce([1,0,2,5,7,6,8,249,10,23,27]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const t=this._schemes.indexOf(m);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),t=[];let o,a,p=14,b=14;for(const u of m){let C=o?(0,y.commonPrefixLength)(o,u):0;for(C===0?a=1:a=b;C<u.length;C++)C+1===u.length?(p=b,b=9):b+=1,t.push([a,u.toUpperCase().charCodeAt(C),b]),t.push([a,u.toLowerCase().charCodeAt(C),b]),a=b;o=u,b=p}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new A.StateMachine(t)}}provideDocumentLinks(m){this._initStateMachine();const t=[],o=A.LinkComputer.computeLinks({getLineContent(a){return m.lineAt(a-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const a of o){const p=_.DocumentLink.to(a);p.target&&t.push(p)}return t}}class g{constructor(m,t){this._extHostLanguageFeatures=t,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(D.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(m,t,o,a={}){if(this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(m,"*",this._linkProvider));const p=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(p,o);let b=2;a.isCaseSensitive&&(b+=1024),a.isReadonly&&(b+=2048),typeof o.copy=="function"&&(b+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,O.checkProposedApiEnabled)(m,"fsChunks"),b+=4),this._proxy.$registerFileSystemProvider(p,t,b).catch(C=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${t}`),console.error(C)});const u=o.onDidChangeFile(C=>{const s=[];for(const c of C){const{uri:n,type:d}=c;if(n.scheme!==t)continue;let l;switch(d){case F.FileChangeType.Changed:l=0;break;case F.FileChangeType.Created:l=1;break;case F.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:n,type:l})}this._proxy.$onFileSystemChange(p,s)});return(0,S.toDisposable)(()=>{u.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(m){const{type:t,ctime:o,mtime:a,size:p,permissions:b}=m;return{type:t,ctime:o,mtime:a,size:p,permissions:b}}$stat(m,t){return Promise.resolve(this._getFsProvider(m).stat(i.URI.revive(t))).then(o=>g._asIStat(o))}$readdir(m,t){return Promise.resolve(this._getFsProvider(m).readDirectory(i.URI.revive(t)))}$readFile(m,t){return Promise.resolve(this._getFsProvider(m).readFile(i.URI.revive(t))).then(o=>k.VSBuffer.wrap(o))}$writeFile(m,t,o,a){return Promise.resolve(this._getFsProvider(m).writeFile(i.URI.revive(t),o.buffer,a))}$delete(m,t,o){return Promise.resolve(this._getFsProvider(m).delete(i.URI.revive(t),o))}$rename(m,t,o,a){return Promise.resolve(this._getFsProvider(m).rename(i.URI.revive(t),i.URI.revive(o),a))}$copy(m,t,o,a){const p=this._getFsProvider(m);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(i.URI.revive(t),i.URI.revive(o),a))}$mkdir(m,t){return Promise.resolve(this._getFsProvider(m).createDirectory(i.URI.revive(t)))}$watch(m,t,o,a){const p=this._getFsProvider(m).watch(i.URI.revive(o),a);this._watches.set(t,p)}$unwatch(m,t){const o=this._watches.get(t);o&&(o.dispose(),this._watches.delete(t))}$open(m,t,o){const a=this._getFsProvider(m);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(i.URI.revive(t),o))}$close(m,t){const o=this._getFsProvider(m);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(t))}$read(m,t,o,a){const p=this._getFsProvider(m);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(a);return Promise.resolve(p.read(t,o,b.buffer,0,a)).then(u=>b.slice(0,u))}$write(m,t,o,a){const p=this._getFsProvider(m);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(t,o,a.buffer,0,a.byteLength))}_getFsProvider(m){const t=this._fsProvider.get(m);if(!t){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return t}}e.ExtHostFileSystem=g}),define(De[55],Ce([1,0,5,35,6,23,3,14,36,7]),function(ne,e,i,D,S,F,_,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Xt{constructor(g,E){this._fileSystemProvider=new Map,this._proxy=g.getProxy(i.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(t){try{const o=m._fileSystemProvider.get(t.scheme);if(!o)return await m._proxy.$stat(t);await m._proxy.$ensureActivation(t.scheme);const a=await o.stat(t);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(o){Xt._handleError(o)}},async readDirectory(t){try{const o=m._fileSystemProvider.get(t.scheme);return o?(await m._proxy.$ensureActivation(t.scheme),(await o.readDirectory(t)).slice()):await m._proxy.$readdir(t)}catch(o){return Xt._handleError(o)}},async createDirectory(t){try{return await m._proxy.$mkdir(t)}catch(o){return Xt._handleError(o)}},async readFile(t){try{const o=m._fileSystemProvider.get(t.scheme);return o?(await m._proxy.$ensureActivation(t.scheme),(await o.readFile(t)).slice()):(await m._proxy.$readFile(t)).buffer}catch(o){return Xt._handleError(o)}},async writeFile(t,o){try{return await m._proxy.$writeFile(t,F.VSBuffer.wrap(o))}catch(a){return Xt._handleError(a)}},async delete(t,o){try{const a=m._fileSystemProvider.get(t.scheme);return a?(await m._proxy.$ensureActivation(t.scheme),await a.delete(t,{recursive:!1,...o})):await m._proxy.$delete(t,{recursive:!1,useTrash:!1,...o})}catch(a){return Xt._handleError(a)}},async rename(t,o,a){try{return await m._proxy.$rename(t,o,{overwrite:!1,...a})}catch(p){return Xt._handleError(p)}},async copy(t,o,a){try{return await m._proxy.$copy(t,o,{overwrite:!1,...a})}catch(p){return Xt._handleError(p)}},isWritableFileSystem(t){const o=E.getCapabilities(t);if(typeof o=="number")return!(o&2048)}})}static _handleError(g){if(g instanceof S.FileSystemError)throw g;if(!(g instanceof Error))throw new S.FileSystemError(String(g));if(g.name==="ENOPRO")throw S.FileSystemError.Unavailable(g.message);switch(g.name){case D.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(g.message);case D.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(g.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(g.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(g.message);case D.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(g.message);case D.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(g.message);default:throw new S.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,E){return this._fileSystemProvider.set(g,E),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(g))}};O=xe([We(0,A.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(De[205],Ce([1,0,4,34,2,5,8,6]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(w,g,E,m,t,o,a,p){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter;const b=this.ensureWatching(w,E,t);this._config=0,o&&(this._config+=1),a&&(this._config+=2),p&&(this._config+=4);const u=(0,D.parse)(t),C=typeof t=="string",s=m(c=>{if(!o)for(const n of c.created){const d=S.URI.revive(n);u(d.fsPath)&&(!C||g.getWorkspaceFolder(d))&&this._onDidCreate.fire(d)}if(!a)for(const n of c.changed){const d=S.URI.revive(n);u(d.fsPath)&&(!C||g.getWorkspaceFolder(d))&&this._onDidChange.fire(d)}if(!p)for(const n of c.deleted){const d=S.URI.revive(n);u(d.fsPath)&&(!C||g.getWorkspaceFolder(d))&&this._onDidDelete.fire(d)}});this._disposable=A.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}ensureWatching(w,g,E){const m=A.Disposable.from();if(typeof E=="string")return m;const t=w.getProxy(F.MainContext.MainThreadFileSystem);let o=!1;(E.pattern.includes(D.GLOBSTAR)||E.pattern.includes(D.GLOB_SPLIT))&&(o=!0);const a=Math.random();return t.$watch(g.identifier.value,a,E.baseUri,{recursive:o,excludes:[]}),A.Disposable.from({dispose:()=>t.$unwatch(a)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(w,g,E){this._mainContext=w,this._logService=g,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,g,E,m,t,o){return new y(this._mainContext,w,g,this._onFileSystemEvent.event,_.GlobPattern.from(E),m,t,o)}$onFileEvent(w){this._onFileSystemEvent.fire(w)}$onDidRunFileOperation(w,g){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(E=>({oldUri:S.URI.revive(E.source),newUri:S.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(E=>S.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:g.map(E=>S.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,g){return(E,m,t)=>{const o=function(p){E.call(m,p)};return o.extension=w,g.event(o,void 0,t)}}async $onWillRunFileOperation(w,g,E,m){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(t=>({oldUri:S.URI.revive(t.source),newUri:S.URI.revive(t.target)}))},E,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(t=>S.URI.revive(t.target))},E,m);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(t=>S.URI.revive(t.target))},E,m)}}async _fireWillEvent(w,g,E,m){const t=new Set,o=[];if(await w.fireAsync(g,m,async(p,b)=>{const u=Date.now(),C=await Promise.resolve(p);C instanceof A.WorkspaceEdit&&(o.push([b.extension,C]),t.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-u>E&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),m.isCancellationRequested||o.length===0)return;const a={edits:[]};for(const[,p]of o){const{edits:b}=_.WorkspaceEdit.from(p,{getTextDocumentVersion:u=>this._extHostDocumentsAndEditors.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(b)}return{edit:a,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=k}),define(De[206],Ce([1,0,2,37]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(_,A,y,k,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=k;const w=new D.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new D.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new D.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new D.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new D.ApiCommandResult("Notebook and input URI",g=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(g.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:i.URI.revive(g.notebookUri),inputUri:i.URI.revive(g.inputUri),notebookEditor:E.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:i.URI.revive(g.notebookUri),inputUri:i.URI.revive(g.inputUri)}}));this._commands.registerApiCommand(w)}$willAddInteractiveDocument(_,A,y,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=S}),define(De[207],Ce([1,0,7,5]),function(ne,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(_){this._handlePool=0,this._proxy=_.getProxy(D.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,_),(0,i.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=S}),define(De[208],Ce([1,0,2,24,8,6,70,5,10,52,18,9,250,21,7,83,78,63,209,12,15,27]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(T,z){this._documents=T,this._provider=z}async provideDocumentSymbols(T,z){const V=this._documents.getDocument(T),q=await this._provider.provideDocumentSymbols(V,z);if(!(0,O.isFalsyOrEmpty)(q))return q[0]instanceof F.DocumentSymbol?q.map(S.DocumentSymbol.from):s._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(T){T=T.slice(0).sort((q,oe)=>{let ce=q.location.range.start.compareTo(oe.location.range.start);return ce===0&&(ce=oe.location.range.end.compareTo(q.location.range.end)),ce});const z=[],V=[];for(const q of T){const oe={name:q.name||"!!MISSING: name!!",kind:S.SymbolKind.from(q.kind),tags:q.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:S.Range.from(q.location.range),selectionRange:S.Range.from(q.location.range),children:[]};for(;;){if(V.length===0){V.push(oe),z.push(oe);break}const ce=V[V.length-1];if(k.Range.containsRange(ce.range,oe.range)&&!k.Range.equalsRange(ce.range,oe.range)){ce.children?.push(oe),V.push(oe);break}V.pop()}}return z}}class c{constructor(T,z,V){this._documents=T,this._commands=z,this._provider=V,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(T,z){const V=this._documents.getDocument(T),q=await this._provider.provideCodeLenses(V,z);if(!q||z.isCancellationRequested)return;const oe=this._cache.add(q),ce=new m.DisposableStore;this._disposables.set(oe,ce);const J={cacheId:oe,lenses:[]};for(let Ee=0;Ee<q.length;Ee++)J.lenses.push({cacheId:[oe,Ee],range:S.Range.from(q[Ee].range),command:this._commands.toInternal(q[Ee].command,ce)});return J}async resolveCodeLens(T,z){const V=T.cacheId&&this._cache.get(...T.cacheId);if(!V)return;let q;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?q=V:q=await this._provider.resolveCodeLens(V,z),q||(q=V),z.isCancellationRequested)return;const oe=T.cacheId&&this._disposables.get(T.cacheId[0]);if(!!oe)return T.command=this._commands.toInternal(q.command??c._badCmd,oe),T}releaseCodeLenses(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(Z){return Array.isArray(Z)?Z.map(S.DefinitionLink.from):Z?[S.DefinitionLink.from(Z)]:[]}class d{constructor(T,z){this._documents=T,this._provider=z}async provideDefinition(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideDefinition(q,oe,V);return n(ce)}}class l{constructor(T,z){this._documents=T,this._provider=z}async provideDeclaration(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideDeclaration(q,oe,V);return n(ce)}}class f{constructor(T,z){this._documents=T,this._provider=z}async provideImplementation(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideImplementation(q,oe,V);return n(ce)}}class r{constructor(T,z){this._documents=T,this._provider=z}async provideTypeDefinition(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideTypeDefinition(q,oe,V);return n(ce)}}class h{constructor(T,z){this._documents=T,this._provider=z}async provideHover(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideHover(q,oe,V);if(!(!ce||(0,O.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=q.getWordRangeAtPosition(oe)),ce.range||(ce.range=new F.Range(oe,oe)),S.Hover.from(ce)}}class v{constructor(T,z){this._documents=T,this._provider=z}async provideEvaluatableExpression(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideEvaluatableExpression(q,oe,V);if(ce)return S.EvaluatableExpression.from(ce)}}class I{constructor(T,z){this._documents=T,this._provider=z}async provideInlineValues(T,z,V,q){const oe=this._documents.getDocument(T),ce=await this._provider.provideInlineValues(oe,S.Range.to(z),S.InlineValueContext.to(V),q);if(Array.isArray(ce))return ce.map(J=>S.InlineValue.from(J))}}class L{constructor(T,z){this._documents=T,this._provider=z}async provideDocumentHighlights(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideDocumentHighlights(q,oe,V);if(Array.isArray(ce))return ce.map(S.DocumentHighlight.from)}}class j{constructor(T,z){this._documents=T,this._provider=z}async provideLinkedEditingRanges(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.provideLinkedEditingRanges(q,oe,V);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,O.coalesce)(ce.ranges.map(S.Range.from)),wordPattern:ce.wordPattern}}}class W{constructor(T,z){this._documents=T,this._provider=z}async provideReferences(T,z,V,q){const oe=this._documents.getDocument(T),ce=S.Position.to(z),J=await this._provider.provideReferences(oe,ce,V,q);if(Array.isArray(J))return J.map(S.location.from)}}class H{constructor(T,z,V,q,oe,ce,J){this._documents=T,this._commands=z,this._diagnostics=V,this._provider=q,this._logService=oe,this._extension=ce,this._apiDeprecation=J,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(T,z,V,q){const oe=this._documents.getDocument(T),ce=g.Selection.isISelection(z)?S.Selection.to(z):S.Range.to(z),J=[];for(const Ge of this._diagnostics.getDiagnostics(T))if(ce.intersection(Ge.range)&&J.push(Ge)>H._maxCodeActionsPerFile)break;const Ee={diagnostics:J,only:V.only?new F.CodeActionKind(V.only):void 0,triggerKind:S.CodeActionTriggerKind.to(V.trigger)},ve=await this._provider.provideCodeActions(oe,ce,Ee,q);if(!(0,O.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const Ne=this._cache.add(ve),ze=new m.DisposableStore;this._disposables.set(Ne,ze);const Je=[];for(let Ge=0;Ge<ve.length;Ge++){const Pe=ve[Ge];!Pe||(H._isCommand(Pe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Pe.title,command:this._commands.toInternal(Pe,ze)})):(Ee.only&&(Pe.kind?Ee.only.contains(Pe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,Ge],title:Pe.title,command:Pe.command&&this._commands.toInternal(Pe.command,ze),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(S.Diagnostic.from),edit:Pe.edit&&S.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,disabled:Pe.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(T,z){const[V,q]=T,oe=this._cache.get(V,q);if(!oe||H._isCommand(oe)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(oe,z)??oe;return ce?.edit?S.WorkspaceEdit.from(ce.edit,void 0):void 0}releaseCodeActions(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}static _isCommand(T){return typeof T.command=="string"&&typeof T.title=="string"}}H._maxCodeActionsPerFile=1e3;class P{constructor(T,z,V,q){this._proxy=T,this._documents=z,this._provider=V,this._handle=q}async prepareDocumentPaste(T,z,V,q){if(!this._provider.prepareDocumentPaste)return;const oe=this._documents.getDocument(T),ce=z.map(Ee=>S.Range.to(Ee)),J=S.DataTransfer.toDataTransfer(V,()=>{throw new b.NotImplementedError});return await this._provider.prepareDocumentPaste(oe,ce,J,q),S.DataTransfer.toDataTransferDTO(J)}async providePasteEdits(T,z,V,q,oe){const ce=this._documents.getDocument(z),J=V.map(Ne=>S.Range.to(Ne)),Ee=S.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,T,Ne)).buffer),ve=await this._provider.provideDocumentPasteEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?S.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class M{constructor(T,z){this._documents=T,this._provider=z}async provideDocumentFormattingEdits(T,z,V){const q=this._documents.getDocument(T),oe=await this._provider.provideDocumentFormattingEdits(q,z,V);if(Array.isArray(oe))return oe.map(S.TextEdit.from)}}class R{constructor(T,z){this._documents=T,this._provider=z}async provideDocumentRangeFormattingEdits(T,z,V,q){const oe=this._documents.getDocument(T),ce=S.Range.to(z),J=await this._provider.provideDocumentRangeFormattingEdits(oe,ce,V,q);if(Array.isArray(J))return J.map(S.TextEdit.from)}}class B{constructor(T,z){this._documents=T,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,z,V,q,oe){const ce=this._documents.getDocument(T),J=S.Position.to(z),Ee=await this._provider.provideOnTypeFormattingEdits(ce,J,V,q,oe);if(Array.isArray(Ee))return Ee.map(S.TextEdit.from)}}class x{constructor(T,z){this._provider=T,this._logService=z,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(T,z){const V=await this._provider.provideWorkspaceSymbols(T,z);if(!(0,O.isNonEmptyArray)(V))return{symbols:[]};const q=this._cache.add(V),oe={cacheId:q,symbols:[]};for(let ce=0;ce<V.length;ce++){const J=V[ce];if(!J||!J.name){this._logService.warn("INVALID SymbolInformation",J);continue}oe.symbols.push({...S.WorkspaceSymbol.from(J),cacheId:[q,ce]})}return oe}async resolveWorkspaceSymbol(T,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const V=this._cache.get(...T.cacheId);if(V){const q=await this._provider.resolveWorkspaceSymbol(V,z);return q&&(0,D.mixin)(T,S.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(T){this._cache.delete(T)}}class U{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,z,V){this._documents=T,this._provider=z,this._logService=V}async provideRenameEdits(T,z,V,q){const oe=this._documents.getDocument(T),ce=S.Position.to(z);try{const J=await this._provider.provideRenameEdits(oe,ce,V,q);return J?S.WorkspaceEdit.from(J):void 0}catch(J){const Ee=U._asMessage(J);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(J)}}async resolveRenameLocation(T,z,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(T),oe=S.Position.to(z);try{const ce=await this._provider.prepareRename(q,oe,V);let J,Ee;if(F.Range.isRange(ce)?(J=ce,Ee=q.getText(ce)):(0,w.isObject)(ce)&&(J=ce.range,Ee=ce.placeholder),!J||!Ee)return;if(J.start.line>oe.line||J.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(J),text:Ee}}catch(ce){const J=U._asMessage(ce);return J?{rejectReason:J,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class K{constructor(T,z){this.resultId=T,this.tokens=z}}class te{constructor(T,z){this._documents=T,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(T,z,V){const q=this._documents.getDocument(T),oe=z!==0?this._previousResults.get(z):null;let ce=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,oe.resultId,V):await this._provider.provideDocumentSemanticTokens(q,V);return oe&&this._previousResults.delete(z),ce?(ce=te._fixProvidedSemanticTokens(ce),this._send(te._convertToEdits(oe,ce),ce)):null}async releaseDocumentSemanticColoring(T){this._previousResults.delete(T)}static _fixProvidedSemanticTokens(T){return te._isSemanticTokens(T)?te._isCorrectSemanticTokens(T)?T:new F.SemanticTokens(new Uint32Array(T.data),T.resultId):te._isSemanticTokensEdits(T)?te._isCorrectSemanticTokensEdits(T)?T:new F.SemanticTokensEdits(T.edits.map(z=>new F.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),T.resultId):T}static _isSemanticTokens(T){return T&&!!T.data}static _isCorrectSemanticTokens(T){return T.data instanceof Uint32Array}static _isSemanticTokensEdits(T){return T&&Array.isArray(T.edits)}static _isCorrectSemanticTokensEdits(T){for(const z of T.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(T,z){if(!te._isSemanticTokens(z)||!T||!T.tokens)return z;const V=T.tokens,q=V.length,oe=z.data,ce=oe.length;let J=0;const Ee=Math.min(q,ce);for(;J<Ee&&V[J]===oe[J];)J++;if(J===q&&J===ce)return new F.SemanticTokensEdits([],z.resultId);let ve=0;const Ne=Ee-J;for(;ve<Ne&&V[q-ve-1]===oe[ce-ve-1];)ve++;return new F.SemanticTokensEdits([{start:J,deleteCount:q-J-ve,data:oe.subarray(J,ce-ve)}],z.resultId)}_send(T,z){if(te._isSemanticTokens(T)){const V=this._nextResultId++;return this._previousResults.set(V,new K(T.resultId,T.data)),(0,t.encodeSemanticTokensDto)({id:V,type:"full",data:T.data})}if(te._isSemanticTokensEdits(T)){const V=this._nextResultId++;return te._isSemanticTokens(z)?this._previousResults.set(V,new K(z.resultId,z.data)):this._previousResults.set(V,new K(T.resultId)),(0,t.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(T.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}e.DocumentSemanticTokensAdapter=te;class de{constructor(T,z){this._documents=T,this._provider=z}async provideDocumentRangeSemanticTokens(T,z,V){const q=this._documents.getDocument(T),oe=await this._provider.provideDocumentRangeSemanticTokens(q,S.Range.to(z),V);return oe?this._send(oe):null}_send(T){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:T.data})}}e.DocumentRangeSemanticTokensAdapter=de;class re{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,z,V,q,oe){this._documents=T,this._commands=z,this._provider=V,this._apiDeprecation=q,this._extension=oe,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(T,z,V,q){const oe=this._documents.getDocument(T),ce=S.Position.to(z),J=oe.getWordRangeAtPosition(ce)||new F.Range(ce,ce),Ee=J.with({end:ce}),ve=new p.StopWatch(!0),Ne=await this._provider.provideCompletionItems(oe,ce,q,S.CompletionContext.to(V));if(!Ne||q.isCancellationRequested)return;const ze=Array.isArray(Ne)?new F.CompletionList(Ne):Ne,Je=re.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ge=new m.DisposableStore;this._disposables.set(Je,Ge);const Pe=[],rt={x:Je,b:Pe,a:{replace:S.Range.from(J),insert:S.Range.from(Ee)},c:ze.isIncomplete||void 0,d:ve.elapsed()};for(let X=0;X<ze.items.length;X++){const Y=ze.items[X],me=this._convertCompletionItem(Y,[Je,X],Ee,J);Pe.push(me)}return rt}async resolveCompletionItem(T,z){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...T);if(!V)return;const q=await this._provider.resolveCompletionItem(V,z);if(!!q)return this._convertCompletionItem(q,T)}releaseCompletionItems(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}_convertCompletionItem(T,z,V,q){const oe=this._disposables.get(z[0]);if(!oe)throw Error("DisposableStore is missing...");const ce={x:z,a:T.label,b:T.kind!==void 0?S.CompletionItemKind.from(T.kind):void 0,n:T.tags&&T.tags.map(S.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:S.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters,l:T.additionalTextEdits&&T.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(T.command,oe)};T.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=T.textEdit.newText):typeof T.insertText=="string"?ce.h=T.insertText:T.insertText instanceof F.SnippetString&&(ce.h=T.insertText.value,ce.i|=4);let J;return T.textEdit?J=T.textEdit.range:T.range&&(J=T.range),F.Range.isRange(J)?ce.j=S.Range.from(J):J&&(!V?.isEqual(J.inserting)||!q?.isEqual(J.replacing))&&(ce.j={insert:S.Range.from(J.inserting),replace:S.Range.from(J.replacing)}),ce}}class be{async provideInlineCompletions(T,z,V,q){}disposeCompletions(T){}handleDidShowCompletionItem(T,z){}}class le extends be{constructor(T,z,V,q){super(),this._extension=T,this._documents=z,this._provider=V,this._commands=q,this._references=new Q,this._isAdditionsProposedApiEnabled=(0,C.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,C.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(T,z,V,q){const oe=this._documents.getDocument(T),ce=S.Position.to(z),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:S.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=this._isAdditionsProposedApiEnabled?Array.isArray(J)?[]:J.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new m.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?S.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new m.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(T){this._references.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,z){const V=this._references.get(T)?.items[z];V&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class fe extends be{constructor(T,z,V,q){super(),this.extension=T,this._documents=z,this._provider=V,this._commands=q,this._references=new Q,this.isAdditionProposedApiEnabled=(0,C.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(T,z,V,q){const oe=this._documents.getDocument(T),ce=S.Position.to(z),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:S.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=Array.isArray(J)?[]:J.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new m.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?S.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new m.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(T){this._references.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,z){const V=this._references.get(T)?.items[z];V&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class Q{constructor(){this._references=new Map,this._idPool=1}createReferenceId(T){const z=this._idPool++;return this._references.set(z,T),z}disposeReferenceId(T){const z=this._references.get(T);return this._references.delete(T),z}get(T){return this._references.get(T)}}class pe{constructor(T,z){this._documents=T,this._provider=z,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(T,z,V,q){const oe=this._documents.getDocument(T),ce=S.Position.to(z),J=this.reviveContext(V),Ee=await this._provider.provideSignatureHelp(oe,ce,q,J);if(Ee){const ve=this._cache.add([Ee]);return{...S.SignatureHelp.from(Ee),id:ve}}}reviveContext(T){let z;if(T.activeSignatureHelp){const V=S.SignatureHelp.to(T.activeSignatureHelp),q=this._cache.get(T.activeSignatureHelp.id,0);q?(z=q,z.activeSignature=V.activeSignature,z.activeParameter=V.activeParameter):z=V}return{...T,activeSignatureHelp:z}}releaseSignatureHelp(T){this._cache.delete(T)}}class Se{constructor(T,z,V,q,oe){this._documents=T,this._commands=z,this._provider=V,this._logService=q,this._extension=oe,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(T,z,V){const q=this._documents.getDocument(T),oe=S.Range.to(z),ce=await this._provider.provideInlayHints(q,oe,V);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${z}`);return}if(V.isCancellationRequested)return;const J=this._cache.add(ce);this._disposables.set(J,new m.DisposableStore);const Ee={hints:[],cacheId:J};for(let ve=0;ve<ce.length;ve++)this._isValidInlayHint(ce[ve],oe)&&Ee.hints.push(this._convertInlayHint(ce[ve],[J,ve]));return this._logService.trace(`[InlayHints] ${Ee.hints.length} inlay hints from '${this._extension.identifier.value}' for ${z}`),Ee}async resolveInlayHint(T,z){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...T);if(!V)return;const q=await this._provider.resolveInlayHint(V,z);if(!!q&&!!this._isValidInlayHint(q))return this._convertInlayHint(q,T)}releaseHints(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}_isValidInlayHint(T,z){return T.label.length===0||Array.isArray(T.label)&&T.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(z&&!z.contains(T.position))}_convertInlayHint(T,z){const V=this._disposables.get(z[0]);if(!V)throw Error("DisposableStore is missing...");const q={label:"",cacheId:z,tooltip:S.MarkdownString.fromStrict(T.tooltip),position:S.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(S.TextEdit.from),kind:T.kind&&S.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?q.label=T.label:q.label=T.label.map(oe=>{const ce={label:oe.value};return ce.tooltip=S.MarkdownString.fromStrict(oe.tooltip),F.Location.isLocation(oe.location)&&(ce.location=S.location.from(oe.location)),oe.command&&(ce.command=this._commands.toInternal(oe.command,V)),ce}),q}}class Fe{constructor(T,z){this._documents=T,this._provider=z,this._cache=new a.Cache("DocumentLink")}async provideLinks(T,z){const V=this._documents.getDocument(T),q=await this._provider.provideDocumentLinks(V,z);if(!(!Array.isArray(q)||q.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Fe._validateLink).map(S.DocumentLink.from)};{const oe=this._cache.add(q),ce={links:[],cacheId:oe};for(let J=0;J<q.length;J++){if(!Fe._validateLink(q[J]))continue;const Ee=S.DocumentLink.from(q[J]);Ee.cacheId=[oe,J],ce.links.push(Ee)}return ce}}}static _validateLink(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,z){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...T);if(!V)return;const q=await this._provider.resolveDocumentLink(V,z);if(!(!q||!Fe._validateLink(q)))return S.DocumentLink.from(q)}releaseLinks(T){this._cache.delete(T)}}class Ue{constructor(T,z){this._documents=T,this._provider=z}async provideColors(T,z){const V=this._documents.getDocument(T),q=await this._provider.provideDocumentColors(V,z);return Array.isArray(q)?q.map(ce=>({color:S.Color.from(ce.color),range:S.Range.from(ce.range)})):[]}async provideColorPresentations(T,z,V){const q=this._documents.getDocument(T),oe=S.Range.to(z.range),ce=S.Color.to(z.color),J=await this._provider.provideColorPresentations(ce,{document:q,range:oe},V);if(!!Array.isArray(J))return J.map(S.ColorPresentation.from)}}class Xe{constructor(T,z){this._documents=T,this._provider=z}async provideFoldingRanges(T,z,V){const q=this._documents.getDocument(T),oe=await this._provider.provideFoldingRanges(q,z,V);if(!!Array.isArray(oe))return oe.map(S.FoldingRange.from)}}class ke{constructor(T,z,V){this._documents=T,this._provider=z,this._logService=V}async provideSelectionRanges(T,z,V){const q=this._documents.getDocument(T),oe=z.map(S.Position.to),ce=await this._provider.provideSelectionRanges(q,oe,V);if(!(0,O.isNonEmptyArray)(ce))return[];if(ce.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const J=[];for(let Ee=0;Ee<oe.length;Ee++){const ve=[];J.push(ve);let Ne=oe[Ee],ze=ce[Ee];for(;;){if(!ze.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(S.SelectionRange.from(ze)),!ze.parent)break;Ne=ze.range,ze=ze.parent}}return J}}class ye{constructor(T,z){this._documents=T,this._provider=z,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.prepareCallHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideCallsTo(T,z,V){const q=this._itemFromCache(T,z);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(q,V);if(!!oe)return oe.map(ce=>({from:this._cacheAndConvertItem(T,ce.from),fromRanges:ce.fromRanges.map(J=>S.Range.from(J))}))}async provideCallsFrom(T,z,V){const q=this._itemFromCache(T,z);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(q,V);if(!!oe)return oe.map(ce=>({to:this._cacheAndConvertItem(T,ce.to),fromRanges:ce.fromRanges.map(J=>S.Range.from(J))}))}releaseSession(T){this._cache.delete(T)}_cacheAndConvertItem(T,z){const V=this._cache.get(T),q=S.CallHierarchyItem.from(z,T,V.size.toString(36));return V.set(q._itemId,z),q}_itemFromCache(T,z){return this._cache.get(T)?.get(z)}}class Ie{constructor(T,z){this._documents=T,this._provider=z,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(T,z,V){const q=this._documents.getDocument(T),oe=S.Position.to(z),ce=await this._provider.prepareTypeHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideSupertypes(T,z,V){const q=this._itemFromCache(T,z);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(T,ce))}async provideSubtypes(T,z,V){const q=this._itemFromCache(T,z);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(T,ce))}releaseSession(T){this._cache.delete(T)}_cacheAndConvertItem(T,z){const V=this._cache.get(T),q=S.TypeHierarchyItem.from(z,T,V.size.toString(36));return V.set(q._itemId,z),q}_itemFromCache(T,z){return this._cache.get(T)?.get(z)}}class ae{constructor(T,z,V,q){this._proxy=T,this._documents=z,this._provider=V,this._handle=q}async provideDocumentOnDropEdits(T,z,V,q,oe){const ce=this._documents.getDocument(z),J=S.Position.to(V),Ee=S.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,T,Ne)).buffer),ve=await this._provider.provideDocumentDropEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?S.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class ue{constructor(T,z){this.adapter=T,this.extension=z}}class ee{constructor(T,z,V,q,oe,ce,J,Ee){this._uriTransformer=z,this._documents=V,this._commands=q,this._diagnostics=oe,this._logService=ce,this._apiDeprecation=J,this._extensionTelemetry=Ee,this._adapter=new Map,this._proxy=T.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(T){return S.DocumentSelector.from(T,this._uriTransformer)}_createDisposable(T){return new F.Disposable(()=>{this._adapter.delete(T),this._proxy.$unregister(T)})}_nextHandle(){return ee._handlePool++}async _withAdapter(T,z,V,q,oe,ce=!1){const J=this._adapter.get(T);if(!J||!(J.adapter instanceof z))return q;const Ee=Date.now();ce||this._logService.trace(`[${J.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const ve=V(J.adapter,J.extension);return Promise.resolve(ve).catch(Ne=>{(0,b.isCancellationError)(Ne)||(this._logService.error(`[${J.extension.identifier.value}] provider FAILED`),this._logService.error(Ne),this._extensionTelemetry.onExtensionError(J.extension.identifier,Ne))}).finally(()=>{ce||this._logService.trace(`[${J.extension.identifier.value}] provider DONE after ${Date.now()-Ee}ms`)}),E.CancellationToken.isCancellationToken(oe)?(0,u.raceCancellationError)(ve,oe):ve}_addNewAdapter(T,z){const V=this._nextHandle();return this._adapter.set(V,new ue(T,z)),V}static _extLabel(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,z,V,q){const oe=this._addNewAdapter(new s(this._documents,V),T),ce=q&&q.label||ee._extLabel(T);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(z),ce),this._createDisposable(oe)}$provideDocumentSymbols(T,z,V){return this._withAdapter(T,s,q=>q.provideDocumentSymbols(i.URI.revive(z),V),void 0,V)}registerCodeLensProvider(T,z,V){const q=this._nextHandle(),oe=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new c(this._documents,this._commands.converter,V),T)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(z),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(oe));ce=F.Disposable.from(ce,J)}return ce}$provideCodeLenses(T,z,V){return this._withAdapter(T,c,q=>q.provideCodeLenses(i.URI.revive(z),V),void 0,V)}$resolveCodeLens(T,z,V){return this._withAdapter(T,c,q=>q.resolveCodeLens(z,V),void 0,void 0)}$releaseCodeLenses(T,z){this._withAdapter(T,c,V=>Promise.resolve(V.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(T,z,V){const q=this._addNewAdapter(new d(this._documents,V),T);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideDefinition(T,z,V,q){return this._withAdapter(T,d,oe=>oe.provideDefinition(i.URI.revive(z),V,q),[],q)}registerDeclarationProvider(T,z,V){const q=this._addNewAdapter(new l(this._documents,V),T);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideDeclaration(T,z,V,q){return this._withAdapter(T,l,oe=>oe.provideDeclaration(i.URI.revive(z),V,q),[],q)}registerImplementationProvider(T,z,V){const q=this._addNewAdapter(new f(this._documents,V),T);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideImplementation(T,z,V,q){return this._withAdapter(T,f,oe=>oe.provideImplementation(i.URI.revive(z),V,q),[],q)}registerTypeDefinitionProvider(T,z,V){const q=this._addNewAdapter(new r(this._documents,V),T);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideTypeDefinition(T,z,V,q){return this._withAdapter(T,r,oe=>oe.provideTypeDefinition(i.URI.revive(z),V,q),[],q)}registerHoverProvider(T,z,V,q){const oe=this._addNewAdapter(new h(this._documents,V),T);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(z)),this._createDisposable(oe)}$provideHover(T,z,V,q){return this._withAdapter(T,h,oe=>oe.provideHover(i.URI.revive(z),V,q),void 0,q)}registerEvaluatableExpressionProvider(T,z,V,q){const oe=this._addNewAdapter(new v(this._documents,V),T);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(z)),this._createDisposable(oe)}$provideEvaluatableExpression(T,z,V,q){return this._withAdapter(T,v,oe=>oe.provideEvaluatableExpression(i.URI.revive(z),V,q),void 0,q)}registerInlineValuesProvider(T,z,V,q){const oe=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new I(this._documents,V),T);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(z),oe);let J=this._createDisposable(ce);if(oe!==void 0){const Ee=V.onDidChangeInlineValues(ve=>this._proxy.$emitInlineValuesEvent(oe));J=F.Disposable.from(J,Ee)}return J}$provideInlineValues(T,z,V,q,oe){return this._withAdapter(T,I,ce=>ce.provideInlineValues(i.URI.revive(z),V,q,oe),void 0,oe)}registerDocumentHighlightProvider(T,z,V){const q=this._addNewAdapter(new L(this._documents,V),T);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideDocumentHighlights(T,z,V,q){return this._withAdapter(T,L,oe=>oe.provideDocumentHighlights(i.URI.revive(z),V,q),void 0,q)}registerLinkedEditingRangeProvider(T,z,V){const q=this._addNewAdapter(new j(this._documents,V),T);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideLinkedEditingRanges(T,z,V,q){return this._withAdapter(T,j,async oe=>{const ce=await oe.provideLinkedEditingRanges(i.URI.revive(z),V,q);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ee._serializeRegExp(ce.wordPattern):void 0}},void 0,q)}registerReferenceProvider(T,z,V){const q=this._addNewAdapter(new W(this._documents,V),T);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideReferences(T,z,V,q,oe){return this._withAdapter(T,W,ce=>ce.provideReferences(i.URI.revive(z),V,q,oe),void 0,oe)}registerCodeActionProvider(T,z,V,q){const oe=new m.DisposableStore,ce=this._addNewAdapter(new H(this._documents,this._commands.converter,this._diagnostics,V,this._logService,T,this._apiDeprecation),T);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(z),{providedKinds:q?.providedCodeActionKinds?.map(J=>J.value),documentation:q?.documentation?.map(J=>({kind:J.kind.value,command:this._commands.converter.toInternal(J.command,oe)}))},ee._extLabel(T),Boolean(V.resolveCodeAction)),oe.add(this._createDisposable(ce)),oe}$provideCodeActions(T,z,V,q,oe){return this._withAdapter(T,H,ce=>ce.provideCodeActions(i.URI.revive(z),V,q,oe),void 0,oe)}$resolveCodeAction(T,z,V){return this._withAdapter(T,H,q=>q.resolveCodeAction(z,V),void 0,void 0)}$releaseCodeActions(T,z){this._withAdapter(T,H,V=>Promise.resolve(V.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(T,z,V){const q=this._addNewAdapter(new M(this._documents,V),T);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(z),T.identifier,T.displayName||T.name),this._createDisposable(q)}$provideDocumentFormattingEdits(T,z,V,q){return this._withAdapter(T,M,oe=>oe.provideDocumentFormattingEdits(i.URI.revive(z),V,q),void 0,q)}registerDocumentRangeFormattingEditProvider(T,z,V){const q=this._addNewAdapter(new R(this._documents,V),T);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(z),T.identifier,T.displayName||T.name),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(T,z,V,q,oe){return this._withAdapter(T,R,ce=>ce.provideDocumentRangeFormattingEdits(i.URI.revive(z),V,q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(T,z,V,q){const oe=this._addNewAdapter(new B(this._documents,V),T);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(z),q,T.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(T,z,V,q,oe,ce){return this._withAdapter(T,B,J=>J.provideOnTypeFormattingEdits(i.URI.revive(z),V,q,oe,ce),void 0,ce)}registerWorkspaceSymbolProvider(T,z){const V=this._addNewAdapter(new x(z,this._logService),T);return this._proxy.$registerNavigateTypeSupport(V,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(T,z,V){return this._withAdapter(T,x,q=>q.provideWorkspaceSymbols(z,V),{symbols:[]},V)}$resolveWorkspaceSymbol(T,z,V){return this._withAdapter(T,x,q=>q.resolveWorkspaceSymbol(z,V),void 0,void 0)}$releaseWorkspaceSymbols(T,z){this._withAdapter(T,x,V=>V.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(T,z,V){const q=this._addNewAdapter(new U(this._documents,V,this._logService),T);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(z),U.supportsResolving(V)),this._createDisposable(q)}$provideRenameEdits(T,z,V,q,oe){return this._withAdapter(T,U,ce=>ce.provideRenameEdits(i.URI.revive(z),V,q,oe),void 0,oe)}$resolveRenameLocation(T,z,V,q){return this._withAdapter(T,U,oe=>oe.resolveRenameLocation(i.URI.revive(z),V,q),void 0,q)}registerDocumentSemanticTokensProvider(T,z,V,q){const oe=this._addNewAdapter(new te(this._documents,V),T),ce=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(z),q,ce);let J=this._createDisposable(oe);if(ce){const Ee=V.onDidChangeSemanticTokens(ve=>this._proxy.$emitDocumentSemanticTokensEvent(ce));J=F.Disposable.from(J,Ee)}return J}$provideDocumentSemanticTokens(T,z,V,q){return this._withAdapter(T,te,oe=>oe.provideDocumentSemanticTokens(i.URI.revive(z),V,q),null,q)}$releaseDocumentSemanticTokens(T,z){this._withAdapter(T,te,V=>V.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,z,V,q){const oe=this._addNewAdapter(new de(this._documents,V),T);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(z),q),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(T,z,V,q){return this._withAdapter(T,de,oe=>oe.provideDocumentRangeSemanticTokens(i.URI.revive(z),V,q),null,q)}registerCompletionItemProvider(T,z,V,q){const oe=this._addNewAdapter(new re(this._documents,this._commands.converter,V,this._apiDeprecation,T),T);return this._proxy.$registerCompletionsProvider(oe,this._transformDocumentSelector(z),q,re.supportsResolving(V),`${T.identifier.value}(${q.join("")})`),this._createDisposable(oe)}$provideCompletionItems(T,z,V,q,oe){return this._withAdapter(T,re,ce=>ce.provideCompletionItems(i.URI.revive(z),V,q,oe),void 0,oe)}$resolveCompletionItem(T,z,V){return this._withAdapter(T,re,q=>q.resolveCompletionItem(z,V),void 0,V)}$releaseCompletionItems(T,z){this._withAdapter(T,re,V=>V.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(T,z,V){const q=new le(T,this._documents,V,this._commands.converter),oe=this._addNewAdapter(q,T);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(z),q.supportsHandleDidShowCompletionItem),this._createDisposable(oe)}registerInlineCompletionsProviderNew(T,z,V){const q=this._addNewAdapter(new fe(T,this._documents,V,this._commands.converter),T);return this._proxy.$registerInlineCompletionsSupport(q,this._transformDocumentSelector(z),!0),this._createDisposable(q)}$provideInlineCompletions(T,z,V,q,oe){return this._withAdapter(T,be,ce=>ce.provideInlineCompletions(i.URI.revive(z),V,q,oe),void 0,oe)}$handleInlineCompletionDidShow(T,z,V){this._withAdapter(T,be,async q=>{q.handleDidShowCompletionItem(z,V)},void 0,void 0)}$freeInlineCompletionsList(T,z){this._withAdapter(T,be,async V=>{V.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(T,z,V,q){const oe=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ce=this._addNewAdapter(new pe(this._documents,V),T);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(z),oe),this._createDisposable(ce)}$provideSignatureHelp(T,z,V,q,oe){return this._withAdapter(T,pe,ce=>ce.provideSignatureHelp(i.URI.revive(z),V,q,oe),void 0,oe)}$releaseSignatureHelp(T,z){this._withAdapter(T,pe,V=>V.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(T,z,V){const q=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new Se(this._documents,this._commands.converter,V,this._logService,T),T);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(z),typeof V.resolveInlayHint=="function",q,ee._extLabel(T));let ce=this._createDisposable(oe);if(q!==void 0){const J=V.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(q));ce=F.Disposable.from(ce,J)}return ce}$provideInlayHints(T,z,V,q){return this._withAdapter(T,Se,oe=>oe.provideInlayHints(i.URI.revive(z),V,q),void 0,q)}$resolveInlayHint(T,z,V){return this._withAdapter(T,Se,q=>q.resolveInlayHint(z,V),void 0,V)}$releaseInlayHints(T,z){this._withAdapter(T,Se,V=>V.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(T,z,V){const q=this._addNewAdapter(new Fe(this._documents,V),T);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(z),typeof V.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(T,z,V){return this._withAdapter(T,Fe,q=>q.provideLinks(i.URI.revive(z),V),void 0,V,z.scheme==="output")}$resolveDocumentLink(T,z,V){return this._withAdapter(T,Fe,q=>q.resolveLink(z,V),void 0,void 0,!0)}$releaseDocumentLinks(T,z){this._withAdapter(T,Fe,V=>V.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(T,z,V){const q=this._addNewAdapter(new Ue(this._documents,V),T);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideDocumentColors(T,z,V){return this._withAdapter(T,Ue,q=>q.provideColors(i.URI.revive(z),V),[],V)}$provideColorPresentations(T,z,V,q){return this._withAdapter(T,Ue,oe=>oe.provideColorPresentations(i.URI.revive(z),V,q),void 0,q)}registerFoldingRangeProvider(T,z,V){const q=this._nextHandle(),oe=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new Xe(this._documents,V),T)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(z),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));ce=F.Disposable.from(ce,J)}return ce}$provideFoldingRanges(T,z,V,q){return this._withAdapter(T,Xe,oe=>oe.provideFoldingRanges(i.URI.revive(z),V,q),void 0,q)}registerSelectionRangeProvider(T,z,V){const q=this._addNewAdapter(new ke(this._documents,V,this._logService),T);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideSelectionRanges(T,z,V,q){return this._withAdapter(T,ke,oe=>oe.provideSelectionRanges(i.URI.revive(z),V,q),[],q)}registerCallHierarchyProvider(T,z,V){const q=this._addNewAdapter(new ye(this._documents,V),T);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$prepareCallHierarchy(T,z,V,q){return this._withAdapter(T,ye,oe=>Promise.resolve(oe.prepareSession(i.URI.revive(z),V,q)),void 0,q)}$provideCallHierarchyIncomingCalls(T,z,V,q){return this._withAdapter(T,ye,oe=>oe.provideCallsTo(z,V,q),void 0,q)}$provideCallHierarchyOutgoingCalls(T,z,V,q){return this._withAdapter(T,ye,oe=>oe.provideCallsFrom(z,V,q),void 0,q)}$releaseCallHierarchy(T,z){this._withAdapter(T,ye,V=>Promise.resolve(V.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(T,z,V){const q=this._addNewAdapter(new Ie(this._documents,V),T);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$prepareTypeHierarchy(T,z,V,q){return this._withAdapter(T,Ie,oe=>Promise.resolve(oe.prepareSession(i.URI.revive(z),V,q)),void 0,q)}$provideTypeHierarchySupertypes(T,z,V,q){return this._withAdapter(T,Ie,oe=>oe.provideSupertypes(z,V,q),void 0,q)}$provideTypeHierarchySubtypes(T,z,V,q){return this._withAdapter(T,Ie,oe=>oe.provideSubtypes(z,V,q),void 0,q)}$releaseTypeHierarchy(T,z){this._withAdapter(T,Ie,V=>Promise.resolve(V.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(T,z,V){const q=this._nextHandle();return this._adapter.set(q,new ue(new ae(this._proxy,this._documents,V,q),T)),this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(z)),this._createDisposable(q)}$provideDocumentOnDropEdits(T,z,V,q,oe,ce){return this._withAdapter(T,ae,J=>Promise.resolve(J.provideDocumentOnDropEdits(z,i.URI.revive(V),q,oe,ce)),void 0,void 0)}registerDocumentPasteEditProvider(T,z,V,q){const oe=this._nextHandle();return this._adapter.set(oe,new ue(new P(this._proxy,this._documents,V,oe),T)),this._proxy.$registerPasteEditProvider(oe,this._transformDocumentSelector(z),!!V.prepareDocumentPaste,q.pasteMimeTypes),this._createDisposable(oe)}$prepareDocumentPaste(T,z,V,q,oe){return this._withAdapter(T,P,ce=>ce.prepareDocumentPaste(i.URI.revive(z),V,q,oe),void 0,oe)}$providePasteEdits(T,z,V,q,oe,ce){return this._withAdapter(T,P,J=>J.providePasteEdits(z,i.URI.revive(V),q,oe,ce),void 0,ce)}static _serializeRegExp(T){return{pattern:T.source,flags:(0,y.regExpFlags)(T)}}static _serializeIndentationRule(T){return{decreaseIndentPattern:ee._serializeRegExp(T.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?ee._serializeRegExp(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?ee._serializeRegExp(T.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(T){return{beforeText:ee._serializeRegExp(T.beforeText),afterText:T.afterText?ee._serializeRegExp(T.afterText):void 0,previousLineText:T.previousLineText?ee._serializeRegExp(T.previousLineText):void 0,action:T.action}}static _serializeOnEnterRules(T){return T.map(ee._serializeOnEnterRule)}setLanguageConfiguration(T,z,V){const{wordPattern:q}=V;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(z,q):this._documents.setWordDefinitionFor(z,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const oe=this._nextHandle(),ce={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ee._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?ee._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ee._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,z,ce),this._createDisposable(oe)}$setWordDefinitions(T){for(const z of T)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(De[210],Ce([1,0,5,8,6,29,15,7]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,w,g,E){this._documents=w,this._commands=g,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,w){await this._proxy.$changeLanguage(O,w);const g=this._documents.getDocumentData(O);if(!g)throw new Error(`document '${O.toString()}' NOT found`);return g.document}async tokenAtPosition(O,w){const g=O.version,E=D.Position.from(w),m=await this._proxy.$tokensAtPosition(O.uri,E),t={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new S.Range(w.line,w.character,w.line,w.character)};if(!m)return t;const o={range:D.Range.to(m.range),type:D.TokenType.to(m.type)};return!o.range.contains(w)||g!==O.version?t:o}createLanguageStatusItem(O,w,g){const E=this._handlePool++,m=this._proxy,t=this._ids,o=`${O.identifier.value}/${w}`;if(t.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);t.add(o);const a={selector:g,id:w,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new A.DisposableStore,u=()=>{p?.dispose(),p=(0,_.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(E,{id:o,name:a.name??O.displayName??O.name,source:O.displayName??O.name,selector:D.DocumentSelector.from(a.selector,this._uriTransformer),label:a.text,detail:a.detail??"",severity:a.severity===S.LanguageStatusSeverity.Error?F.default.Error:a.severity===S.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:a.command&&this._commands.toInternal(a.command,b),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},C={dispose(){b.dispose(),p?.dispose(),m.$removeLanguageStatus(E),t.delete(o)},get id(){return a.id},get name(){return a.name},set name(s){a.name=s,u()},get selector(){return a.selector},set selector(s){a.selector=s,u()},get text(){return a.text},set text(s){a.text=s,u()},get detail(){return a.detail},set detail(s){a.detail=s,u()},get severity(){return a.severity},set severity(s){a.severity=s,u()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(s){a.accessibilityInformation=s,u()},get command(){return a.command},set command(s){a.command=s,u()},get busy(){return a.busy},set busy(s){a.busy=s,u()}};return u(),C}}e.ExtHostLanguages=y}),define(De[72],Ce([1,0,20,10,2,3,11,5,26,14]),function(ne,e,i,D,S,F,_,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(g,E,m){this.logService=m,this.bundleCache=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=g.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===i.LANGUAGE_DEFAULT}getMessage(g,E){const{message:m,args:t,comment:o}=E;if(this.isDefaultLanguage)return(0,D.format2)(m,t??{});let a=m;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join():o}`);const p=this.bundleCache.get(g)?.contents[a];return p||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,D.format2)(p??a,t??{})}getBundle(g){return this.bundleCache.get(g)?.contents}getBundleUri(g){return this.bundleCache.get(g)?.uri}async initializeLocalizedMessages(g){if(this.isDefaultLanguage||!g.l10n&&!g.isBuiltin||this.bundleCache.has(g.identifier.value))return;let E;const m=await this.getBundleLocation(g);if(!m){this.logService.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const t=await this._proxy.$fetchBundleContents(m),o=JSON.parse(t);E=g.isBuiltin?o.contents?.bundle:o}catch(t){this.logService.error(`Failed to load translations for ${g.identifier.value} from ${m}: ${t.message}`);return}E&&this.bundleCache.set(g.identifier.value,{contents:E,uri:m})}async getBundleLocation(g){if(g.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(g.identifier.value);return S.URI.revive(E)}return g.l10n?S.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};O=xe([We(0,y.IExtHostInitDataService),We(1,k.IExtHostRpcService),We(2,_.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(De[211],Ce([1,0,11,5,26,14,2,4,9]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(g,E){super(E.logLevel,A.Event.None),this._proxy=g.getProxy(D.MainContext.MainThreadLogger)}$setLevel(g,E){E?this.setLevel(_.URI.revive(E),g):(0,y.isUndefined)(g)||this.setLevel(g)}doCreateLogger(g,E,m){return new O(this._proxy,g,E,m)}};k=xe([We(0,F.IExtHostRpcService),We(1,S.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class O extends i.AbstractMessageLogger{constructor(g,E,m,t){super(t?.always),this.proxy=g,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(E,t).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,E){const m=[[g,E]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(g){this.proxy.$log(this.file,g)}}}),define(De[212],Ce([1,0,5,11,27]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(A){return A&&A.title}let _=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,k,O,w,g){const E={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof w=="string"||F(w)?m=[w,...g]:(E.modal=w?.modal,E.useCustom=w?.useCustom,E.detail=w?.detail,m=g),E.useCustom&&(0,S.checkProposedApiEnabled)(y,"resolvers");const t=[];for(let o=0;o<m.length;o++){const a=m[o];if(typeof a=="string")t.push({title:a,handle:o,isCloseAffordance:!1});else if(typeof a=="object"){const{title:p,isCloseAffordance:b}=a;t.push({title:p,isCloseAffordance:!!b,handle:o})}else this._logService.warn("Invalid message item:",a)}return this._proxy.$showMessage(k,O,E,t).then(o=>{if(typeof o=="number")return m[o]})}};_=xe([We(1,D.ILogService)],_),e.ExtHostMessageService=_}),define(De[213],Ce([1,0,23,4,7,28,10,9,2,63,5,37,8,6,42,185,95]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class a{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}constructor(b,u,C,s){this._textDocumentsAndEditors=C,this._textDocuments=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=b.getProxy(O.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(O.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const n=c.notebookEditor?.notebookUri,d=c.cell.handle,f=this._documents.get(n)?.getCell(d);if(f)return f.apiCell}if(c&&c.$mid===13){const n=c.uri,d=this._documents.get(n);if(d)return d.apiNotebook}return c}}),a._registerApiCommands(u)}getEditorById(b){const u=this._editors.get(b);if(!u)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(b){for(const[u,C]of this._editors)if(C.apiEditor===b)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,u){const C=this._documents.get(b);if(!C&&!u)throw new Error(`NO notebook document for '${b}'`);return C}_getProviderData(b){const u=this._notebookContentProviders.get(b);if(!u)throw new Error(`NO provider for '${b}'`);return u}registerNotebookContentProvider(b,u,C,s,c){if((0,_.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);return this._notebookContentProviders.set(u,{extension:b,provider:C}),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},u,g.NotebookDocumentContentOptions.from(s),a._convertNotebookRegistrationData(b,c)),new E.Disposable(()=>{this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(b,u){if(!u)return;const C=u.filenamePattern.map(s=>g.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(u.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:u.displayName,filenamePattern:C,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,u,C){const s=a._notebookStatusBarItemProviderHandlePool++,c=typeof C.onDidChangeCellStatusBarItems=="function"?a._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,c,u);let n;return c!==void 0&&(n=C.onDidChangeCellStatusBarItems(d=>this._notebookProxy.$emitCellStatusBarEvent(c))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,c),n?.dispose()})}async createNotebookDocument(b){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&g.NotebookData.from(b.content)});return y.URI.revive(u)}async openNotebookDocument(b){const u=this._documents.get(b);if(u)return u.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(b),s=this._documents.get(y.URI.revive(C));return(0,A.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(b,u){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let C;typeof u=="object"?C={position:g.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(g.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:C={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,C),c=s&&this._editors.get(s)?.apiEditor;if(c)return c;throw s?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,u,C,s){const c=this._notebookStatusBarItemProviders.get(b),n=y.URI.revive(u),d=this._documents.get(n);if(!d||!c)return;const l=d.getCellFromIndex(C);if(!l)return;const f=await c.provideCellStatusBarItems(l.apiCell,s);if(!f)return;const r=new S.DisposableStore,h=this._statusBarCache.add([r]),I=(Array.isArray(f)?f:[f]).map(L=>g.NotebookStatusBarItem.from(L,this._commandsConverter,r));return{cacheId:h,items:I}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,u,C,s,c){if((0,_.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,C),this._notebookProxy.$registerNotebookSerializer(n,{id:b.identifier,location:b.extensionLocation},u,g.NotebookDocumentContentOptions.from(s),a._convertNotebookRegistrationData(b,c)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(b,u,C){const s=this._notebookSerializer.get(b);if(!s)throw new Error("NO serializer found");const c=await s.deserializeNotebook(u.buffer,C);return new m.SerializableObjectWithBuffers(g.NotebookData.from(c))}async $notebookToData(b,u,C){const s=this._notebookSerializer.get(b);if(!s)throw new Error("NO serializer found");const c=await s.serializeNotebook(g.NotebookData.to(u.value),C);return i.VSBuffer.wrap(c)}async $openNotebook(b,u,C,s,c){const{provider:n}=this._getProviderData(b),d=await n.openNotebook(y.URI.revive(u),{backupId:C,untitledDocumentData:s?.buffer},c);return new m.SerializableObjectWithBuffers({metadata:d.metadata??Object.create(null),cells:d.cells.map(g.NotebookCellData.from)})}_createExtHostEditor(b,u,C){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const s=new o.ExtHostNotebookEditor(u,this._notebookEditorsProxy,b,C.visibleRanges.map(g.NotebookRange.to),C.selections.map(g.NotebookRange.to),typeof C.viewColumn=="number"?g.ViewColumn.to(C.viewColumn):void 0);this._editors.set(u,s)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const C of b.value.removedDocuments){const s=y.URI.revive(C),c=this._documents.get(s);c&&(c.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:c.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(c.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===s.toString()&&this._editors.delete(n.id)}if(b.value.addedDocuments){const C=[];for(const s of b.value.addedDocuments){const c=y.URI.revive(s.uri);if(this._documents.has(c))throw new Error(`adding EXISTING notebook ${c} `);const n=new t.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,c,s);C.push(...s.cells.map(d=>t.ExtHostCell.asModelAddData(n.apiNotebook,d))),this._documents.get(c)?.dispose(),this._documents.set(c,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(b.value.addedEditors)for(const C of b.value.addedEditors){if(this._editors.has(C.id))return;const s=y.URI.revive(C.documentUri),c=this._documents.get(s);c&&this._createExtHostEditor(c,C.id,C)}const u=[];if(b.value.removedEditors)for(const C of b.value.removedEditors){const s=this._editors.get(C);s&&(this._editors.delete(C),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),u.push(s))}if(b.value.visibleEditors){this._visibleNotebookEditors=b.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const C=new Set;this._visibleNotebookEditors.forEach(s=>C.add(s.id));for(const s of this._editors.values()){const c=C.has(s.id);s._acceptVisibility(c)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this._activeNotebookEditor=void 0:b.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(b){const u=w.ApiCommandArgument.String.with("notebookType","A notebook type"),C=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[u,new w.ApiCommandArgument("data","Bytes to convert to data",c=>c instanceof Uint8Array,c=>i.VSBuffer.wrap(c))],new w.ApiCommandResult("Notebook Data",c=>g.NotebookData.to(c.value))),s=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[u,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",c=>!0,c=>new m.SerializableObjectWithBuffers(g.NotebookData.from(c)))],new w.ApiCommandResult("Bytes",c=>c.buffer));b.registerApiCommand(C),b.registerApiCommand(s)}}e.ExtHostNotebookController=a,a._notebookStatusBarItemProviderHandlePool=0}),define(De[214],Ce([1,0,18,15,21,4,7,28,2,25,11,5,37,8,6,65,173,27,42]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let b=class{constructor(d,l,f,r,h){this._initData=l,this._extHostNotebook=f,this._commands=r,this._logService=h,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=d.getProxy(w.MainContext.MainThreadNotebookKernels);const v=new g.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.ApiCommandArgument("options","Select kernel options",I=>!0,I=>{if(I&&"notebookEditor"in I&&"id"in I){const L=this._extHostNotebook.getIdByEditor(I.notebookEditor);return{id:I.id,extension:I.extension,notebookEditorId:L}}else if(I&&"notebookEditor"in I){const L=this._extHostNotebook.getIdByEditor(I.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${I.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return I})],g.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(d,l,f,r,h,v){for(const re of this._kernelData.values())if(re.controller.id===l&&k.ExtensionIdentifier.equals(d.identifier,re.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const I=this._handlePool++,L=this;this._logService.trace(`NotebookController[${I}], CREATED by ${d.identifier.value}, ${l}`);const j=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${d.identifier}'`);let W=!1;const H=new _.DisposableStore,P=new F.Emitter,M=new F.Emitter,R={id:c(d.identifier,l),notebookType:f,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:r||d.identifier.value,preloads:v?v.map(E.NotebookRendererScript.from):[]};let B=h??j,x;this._proxy.$addKernel(I,R).catch(re=>{console.log(re),W=!0});let U=0;const K=()=>{if(W)return;const re=++U;Promise.resolve().then(()=>{re===U&&this._proxy.$updateKernel(I,R)})},te=new A.ResourceMap,de={get id(){return l},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:P.event,get label(){return R.label},set label(re){R.label=re??d.displayName??d.name,K()},get detail(){return R.detail??""},set detail(re){R.detail=re,K()},get description(){return R.description??""},set description(re){R.description=re,K()},get kind(){return(0,a.checkProposedApiEnabled)(d,"notebookControllerKind"),R.kind??""},set kind(re){(0,a.checkProposedApiEnabled)(d,"notebookControllerKind"),R.kind=re,K()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(re){R.supportedLanguages=re,K()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(re){R.supportsExecutionOrder=re,K()},get rendererScripts(){return R.preloads?R.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(re){B=re??j},get interruptHandler(){return x},set interruptHandler(re){x=re,R.supportsInterrupt=Boolean(re),K()},createNotebookCellExecution(re){if(W)throw new Error("notebook controller is DISPOSED");if(!te.has(re.notebook.uri))throw L._logService.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(te.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return L._createNotebookCellExecution(re,c(d.identifier,this.id))},dispose:()=>{W||(this._logService.trace(`NotebookController[${I}], DISPOSED`),W=!0,this._kernelData.delete(I),H.dispose(),P.dispose(),M.dispose(),this._proxy.$removeKernel(I))},updateNotebookAffinity(re,be){be===m.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(d,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(I,re.uri,be)},onDidReceiveMessage:M.event,postMessage(re,be){return(0,a.checkProposedApiEnabled)(d,"notebookMessaging"),L._proxy.$postMessage(I,be&&L._extHostNotebook.getIdByEditor(be),re)},asWebviewUri(re){return(0,a.checkProposedApiEnabled)(d,"notebookMessaging"),(0,t.asWebviewUri)(re,L._initData.remote)}};return this._kernelData.set(I,{extensionId:d.identifier,controller:de,onDidReceiveMessage:M,onDidChangeSelection:P,associatedNotebooks:te}),de}getIdByController(d){for(const[l,f]of this._kernelData)if(f.controller===d)return c(f.extensionId,d.id);return null}$acceptNotebookAssociation(d,l,f){const r=this._kernelData.get(d);if(r){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));f?r.associatedNotebooks.set(h.uri,!0):r.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${d}] ASSOCIATE notebook`,h.uri.toString(),f),r.onDidChangeSelection.fire({selected:f,notebook:h.apiNotebook})}}async $executeCells(d,l,f){const r=this._kernelData.get(d);if(!r)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)),v=[];for(const I of f){const L=h.getCell(I);L&&v.push(L.apiCell)}try{this._logService.trace(`NotebookController[${d}] EXECUTE cells`,h.uri.toString(),v.length),await r.controller.executeHandler.call(r.controller,v,h.apiNotebook,r.controller)}catch(I){this._logService.error(`NotebookController[${d}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(d,l,f){const r=this._kernelData.get(d);if(!r)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,h.apiNotebook);else for(const v of f){const I=h.getCell(v);I&&this._activeExecutions.get(I.uri)?.cancel()}}$acceptKernelMessageFromRenderer(d,l,f){const r=this._kernelData.get(d);if(!r)return;const h=this._extHostNotebook.getEditorById(l);r.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:f}))}$cellExecutionChanged(d,l,f){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(d)).getCell(l);if(h){const v=f?E.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;v!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:v})}}_createNotebookCellExecution(d,l){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const h=new C(l,r,this._proxy);this._activeExecutions.set(r.uri,h);const v=h.onDidChangeState(()=>{h.state===u.Resolved&&(h.dispose(),v.dispose(),this._activeExecutions.delete(r.uri))});return h.asApiObject()}};b=xe([We(4,O.ILogService)],b),e.ExtHostNotebookKernels=b;var u;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(u||(u={}));class C extends _.Disposable{get state(){return this._state}constructor(d,l,f){super(),this._cell=l,this._proxy=f,this._handle=C.HANDLE++,this._onDidChangeState=new F.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new s(10,r=>this.update(r)),this._executionOrder=l.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,d,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(d){await this._collector.addItem(d)}async update(d){const l=Array.isArray(d)?d:[d];return this._proxy.$updateExecution(this._handle,new p.SerializableObjectWithBuffers(l))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(d){let l=this._cell;if(d&&(l=this._cell.notebook.getCellFromApiCell(d)),!l)throw new Error("INVALID cell");return l.handle}validateAndConvertOutputs(d){return d.map(l=>{const f=m.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return f===l.items?E.NotebookCellOutput.from(l):E.NotebookCellOutput.from({items:f,id:l.id,metadata:l.metadata})})}async updateOutputs(d,l,f){const r=this.cellIndexToHandle(l),h=this.validateAndConvertOutputs((0,i.asArray)(d));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:r,append:f,outputs:h})}async updateOutputItems(d,l,f){return d=m.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(d),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:d.map(E.NotebookCellOutputItem.from),outputId:l.id,append:f})}asApiObject(){const d=this;return Object.freeze({get token(){return d._tokenSource.token},get cell(){return d._cell.apiCell},get executionOrder(){return d._executionOrder},set executionOrder(f){d._executionOrder=f,d.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:d._executionOrder}])},start(f){if(d._state===u.Resolved||d._state===u.Started)throw new Error("Cannot call start again");d._state=u.Started,d._onDidChangeState.fire(),d.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,r){if(d._state===u.Resolved)throw new Error("Cannot call resolve twice");d._state=u.Resolved,d._onDidChangeState.fire(),d._collector.flush(),d._proxy.$completeExecution(d._handle,new p.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:f}))},clearOutput(f){return d.verifyStateForOutput(),d.updateOutputs([],f,!1)},appendOutput(f,r){return d.verifyStateForOutput(),d.updateOutputs(f,r,!0)},replaceOutput(f,r){return d.verifyStateForOutput(),d.updateOutputs(f,r,!1)},appendOutputItems(f,r){return d.verifyStateForOutput(),d.updateOutputItems(f,r,!0)},replaceOutputItems(f,r){return d.verifyStateForOutput(),d.updateOutputItems(f,r,!1)}})}}C.HANDLE=0;class s{constructor(d,l){this.delay=d,this.callback=l,this.batch=[],this.startedTimer=Date.now()}addItem(d){return this.batch.push(d),this.currentDeferred||(this.currentDeferred=new D.DeferredPromise,this.startedTimer=Date.now(),(0,D.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const d=this.currentDeferred;this.currentDeferred=void 0;const l=this.batch;return this.batch=[],this.callback(l).finally(()=>d.complete())}}function c(n,d){return`${n.value}/${d}`}e.createKernelId=c}),define(De[215],Ce([1,0,4,5,95]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(A,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(D.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,k){const O=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(y)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,w,g)=>this.getOrCreateEmitterFor(y).event(O,w,g),postMessage:(O,w)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const g=w&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(g?.id,y,O)}}}getOrCreateEmitterFor(A){let y=this._rendererMessageEmitters.get(A);return y||(y=new i.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,y),y)}}e.ExtHostNotebookRenderers=F}),define(De[216],Ce([1,0,21,4,7,5,2,6,12,18,29,62]),function(ne,e,i,D,S,F,_,A,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(E,m,t){const o=E.getProxy(F.MainContext.MainThreadQuickOpen);class a{constructor(l,f){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=f}showQuickPick(l,f,r=i.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(l),v=++this._instances,I=o.$show(v,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},r),L={},j=I.then(()=>L);return Promise.race([j,h]).then(W=>{if(W!==L)return h.then(H=>{const P=[];for(let M=0;M<H.length;M++){const R=H[M];typeof R=="string"?P.push({label:R,handle:M}):R.kind===A.QuickPickItemKind.Separator?P.push({type:"separator",label:R.label}):P.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:M})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=M=>{f.onDidSelectItem(H[M])}),o.$setItems(v,P),I.then(M=>{if(typeof M=="number")return H[M];if(Array.isArray(M))return M.map(R=>H[R])})})}).then(void 0,W=>{if(!(0,y.isCancellationError)(W))return o.$setError(v,W),Promise.reject(W)})}$onItemSelected(l){this._onDidSelectItem?.(l)}showInput(l,f=i.CancellationToken.None){return this._validateInput=l?.validateInput,o.$input(l,typeof this._validateInput=="function",f).then(void 0,r=>{if(!(0,y.isCancellationError)(r))return Promise.reject(r)})}async $validateInput(l){if(!this._validateInput)return;const f=await this._validateInput(l);if(!f||typeof f=="string")return f;let r;switch(f.severity){case A.InputBoxValidationSeverity.Info:r=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:r=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:r=O.default.Error;break;default:r=f.message?O.default.Error:O.default.Ignore;break}return{content:f.message,severity:r}}async showWorkspaceFolderPick(l,f=i.CancellationToken.None){const r=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!r)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(v=>v.uri.toString()===r.uri.toString())}createQuickPick(l){const f=new c(l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(l){const f=new n(l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(l,f){this._sessions.get(l)?._fireDidChangeValue(f)}$onDidAccept(l){this._sessions.get(l)?._fireDidAccept()}$onDidChangeActive(l,f){const r=this._sessions.get(l);r instanceof c&&r._fireDidChangeActive(f)}$onDidChangeSelection(l,f){const r=this._sessions.get(l);r instanceof c&&r._fireDidChangeSelection(f)}$onDidTriggerButton(l,f){this._sessions.get(l)?._fireDidTriggerButton(f)}$onDidTriggerItemButton(l,f,r){const h=this._sessions.get(l);h instanceof c&&h._fireDidTriggerItemButton(f,r)}$onDidHide(l){this._sessions.get(l)?._fireDidHide()}}class p{constructor(l,f){this._extensionId=l,this._onDidDispose=f,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((f,r)=>{const h=f===A.QuickInputButtons.Back?-1:r;this._handlesToButtons.set(h,f)}),this.update({buttons:l.map((f,r)=>({...s(f),tooltip:f.tooltip,handle:f===A.QuickInputButtons.Back?-1:r}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const f=this._handlesToButtons.get(l);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),o.$dispose(this._id))}update(l){if(!this._disposed){for(const f of Object.keys(l)){const r=l[f];this._pendingUpdate[f]=r===void 0?null:r}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){o.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function b(d){if(d instanceof A.ThemeIcon)return{id:d.id};const l=C(d),f=u(d);return{dark:typeof l=="string"?_.URI.file(l):l,light:typeof f=="string"?_.URI.file(f):f}}function u(d){return typeof d=="object"&&"light"in d?d.light:d}function C(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const l=b(d.iconPath);let f,r;return"id"in l?r=w.ThemeIcon.asClassName(l):f=l,{iconPath:f,iconClass:r}}class c extends p{constructor(l,f){super(l.identifier,f),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((r,h)=>{this._handlesToItems.set(h,r),this._itemsToHandles.set(r,h)});const f=[];for(let r=0;r<l.length;r++){const h=l[r];h.kind===A.QuickPickItemKind.Separator?f.push({type:"separator",label:h.label}):f.push({handle:r,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((v,I)=>({...s(v),tooltip:v.tooltip,handle:I}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(l){const f=(0,k.coalesce)(l.map(r=>this._handlesToItems.get(r)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(l){const f=(0,k.coalesce)(l.map(r=>this._handlesToItems.get(r)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(l,f){const r=this._handlesToItems.get(l);if(!r||!r.buttons||!r.buttons.length)return;const h=r.buttons[f];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:r})}}class n extends p{constructor(l,f){super(l.identifier,f),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,l?typeof l=="string"?this.update({validationMessage:l,severity:O.default.Error}):this.update({validationMessage:l.message,severity:l.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new a(m,t)}e.createExtHostQuickOpen=g});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i};define(De[217],Ce([1,0,2,4,58,7,15,5,18,119,11,25,62,8,27]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(h){if(h)return typeof h.iconPath=="string"?i.URI.file(h.iconPath):i.URI.isUri(h.iconPath)||g.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function p(h,v){if(!h.iconPath&&!v.iconPath)return 0;if(h.iconPath){if(!v.iconPath)return 1}else return-1;const I=typeof h.iconPath=="string"?h.iconPath:i.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,L=typeof v.iconPath=="string"?v.iconPath:i.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,k.comparePaths)(I,L)}function b(h,v){let I=0;if(h.strikeThrough!==v.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==v.faded)return h.faded?1:-1;if(h.tooltip!==v.tooltip)return(h.tooltip||"").localeCompare(v.tooltip||"");if(I=p(h,v),I!==0)return I;if(h.light&&v.light)I=p(h.light,v.light);else{if(h.light)return 1;if(v.light)return-1}if(I!==0)return I;if(h.dark&&v.dark)I=p(h.dark,v.dark);else{if(h.dark)return 1;if(v.dark)return-1}return I}function u(h,v){if(h.command!==v.command)return h.command<v.command?-1:1;if(h.title!==v.title)return h.title<v.title?-1:1;if(h.tooltip!==v.tooltip){if(h.tooltip!==void 0&&v.tooltip!==void 0)return h.tooltip<v.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(h.arguments===v.arguments)return 0;if(h.arguments)if(v.arguments){if(h.arguments.length!==v.arguments.length)return h.arguments.length-v.arguments.length}else return 1;else return-1;for(let I=0;I<h.arguments.length;I++){const L=h.arguments[I],j=v.arguments[I];if(L!==j)return L<j?-1:1}return 0}function C(h,v){let I=(0,k.comparePaths)(h.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(I!==0)return I;if(h.command&&v.command)I=u(h.command,v.command);else{if(h.command)return 1;if(v.command)return-1}if(I!==0)return I;if(h.decorations&&v.decorations)I=b(h.decorations,v.decorations);else{if(h.decorations)return 1;if(v.decorations)return-1}return I}function s(h,v){for(let I=0;I<h.length;I++)if(h[I]!==v[I])return!1;return!0}function c(h,v){return h.command===v.command&&h.title===v.title&&h.tooltip===v.tooltip&&(h.arguments&&v.arguments?s(h.arguments,v.arguments):h.arguments===v.arguments)}function n(h,v){return(0,y.equals)(h,v,c)}class d{get value(){return this._value}set value(v){v=v??"",Oe(this,t,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Oe(this,t,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Oe(this,t,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Oe(this,t,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Oe(this,t,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}constructor(v,I,L){this._extension=v,this._sourceControlHandle=L,t.set(this,void 0),this._value="",this._onDidChange=new D.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,t,I,"f")}showValidationMessage(v,I){(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,t,"f").$showValidationMessage(this._sourceControlHandle,v,I)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=d,t=new WeakMap;class l{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}constructor(v,I,L,j,W){this._proxy=v,this._commands=I,this._sourceControlHandle=L,this._id=j,this._label=W,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new D.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=l._handlePool++}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,I){const L=this._resourceStatesCommandsMap.get(v);return L?(0,_.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],I)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(C),L=(0,y.sortedDiff)(this._resourceSnapshot,v,C).map(H=>{const P=H.toInsert.map(M=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,M);const B=M.resourceUri;let x;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const pe=new F.DisposableStore;x=this._commands.converter.toInternal(M.command,pe),this._resourceStatesDisposablesMap.set(R,pe)}else this._resourceStatesCommandsMap.set(R,M.command);const U=a(M.decorations),K=M.decorations&&a(M.decorations.light)||U,te=M.decorations&&a(M.decorations.dark)||U,de=[K,te],re=M.decorations&&M.decorations.tooltip||"",be=M.decorations&&!!M.decorations.strikeThrough,le=M.decorations&&!!M.decorations.faded,fe=M.contextValue||"";return{rawResource:[R,B,de,re,be,le,fe,x],handle:R}});return{start:H.start,deleteCount:H.deleteCount,toInsert:P}}),j=L.map(({start:H,deleteCount:P,toInsert:M})=>[H,P,M.map(R=>R.rawResource)]),W=L.reverse();for(const{start:H,deleteCount:P,toInsert:M}of W){const R=M.map(x=>x.handle),B=this._handlesSnapshot.splice(H,P,...R);for(const x of B)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),this._resourceStatesDisposablesMap.get(x)?.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=v,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}l._handlePool=0;class f{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Oe(this,o,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Oe(this,o,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Oe(this,o,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new F.DisposableStore,this._acceptInputCommand=v;const I=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Oe(this,o,"f").$updateSourceControl(this.handle,{acceptInputCommand:I})}get actionButton(){return(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new F.DisposableStore,this._actionButton=v;const I=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(L=>L.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Oe(this,o,"f").$updateSourceControl(this.handle,{actionButton:I??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&n(this._statusBarCommands,v))return;this._statusBarDisposables.value=new F.DisposableStore,this._statusBarCommands=v;const I=(v||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Oe(this,o,"f").$updateSourceControl(this.handle,{statusBarCommands:I})}get selected(){return this._selected}constructor(v,I,L,j,W,H){this._extension=v,this._commands=L,this._id=j,this._label=W,this._rootUri=H,o.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new F.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new F.MutableDisposable,this._statusBarDisposables=new F.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new D.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,o,I,"f"),this._inputBox=new d(v,Oe(this,o,"f"),this.handle),Oe(this,o,"f").$registerSourceControl(this.handle,j,W,H)}createResourceGroup(v,I){const L=new l(Oe(this,o,"f"),this._commands,this.handle,v,I),j=D.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,j),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const v=[],I=[];for(const[L,j]of this.createdResourceGroups){j.dispose();const W=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});D.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),W.dispose(),this._groups.delete(L.handle),Oe(this,o,"f").$unregisterGroup(this.handle,L.handle)}),v.push([L.handle,L.id,L.label,L.features]);const H=L._takeResourceStateSnapshot();H.length>0&&I.push([L.handle,H]),this._groups.set(L.handle,L)}Oe(this,o,"f").$registerGroups(this.handle,v,I),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(I=>{const L=I._takeResourceStateSnapshot();L.length!==0&&v.push([I.handle,L])}),v.length>0&&Oe(this,o,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Oe(this,o,"f").$unregisterSourceControl(this.handle)}}o=new WeakMap,f._handlePool=0,xe([(0,S.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),xe([(0,S.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let r=class Zi{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(v,I,L){this._commands=I,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new D.Emitter,this._proxy=v.getProxy(A.MainContext.MainThreadSCM),this._telemetry=v.getProxy(A.MainContext.MainThreadTelemetry),I.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const W=this._sourceControls.get(j.sourceControlHandle);if(!W)return j;const H=W.getResourceGroup(j.groupHandle);return H?H.getResourceState(j.handle):j}else if(j&&j.$mid===4){const W=this._sourceControls.get(j.sourceControlHandle);return W?W.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const W=this._sourceControls.get(j.handle);return W||j}return j}})}createSourceControl(v,I,L,j){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,I,L,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const W=Zi._handlePool++,H=new f(v,this._proxy,this._commands,I,L,j);this._sourceControls.set(W,H);const P=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(v.identifier))||[];return P.push(H),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(v.identifier),P),H}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const I=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(v.identifier)),L=I&&I[I.length-1];return L&&L.inputBox}$provideOriginalResource(v,I,L){const j=i.URI.revive(I);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,j.toString());const W=this._sourceControls.get(v);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>W.quickDiffProvider.provideOriginalResource(j,L)).then(H=>H||null)}$onInputBoxValueChange(v,I){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const L=this._sourceControls.get(v);return L&&L.inputBox.$onInputBoxValueChange(I),Promise.resolve(void 0)}$executeResourceCommand(v,I,L,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,I,L);const W=this._sourceControls.get(v);if(!W)return Promise.resolve(void 0);const H=W.getResourceGroup(I);return H?H.$executeResourceCommand(L,j):Promise.resolve(void 0)}$validateInput(v,I,L){this.logService.trace("ExtHostSCM#$validateInput",v);const j=this._sourceControls.get(v);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>j.inputBox.validateInput(I,L)).then(W=>{if(!W)return Promise.resolve(void 0);const H=E.MarkdownString.fromStrict(W.message);return H?Promise.resolve([H,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};r._handlePool=0,r=xe([We(2,O.ILogService)],r),e.ExtHostSCM=r}),define(De[73],Ce([1,0,5,4,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(A){this._onDidChangePassword=new D.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,k){return this._proxy.$setPassword(A,y,k)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[218],Ce([1,0,6,5,134,7,8,9]),function(ne,e,i,D,S,F,_,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(m,t,o,a,p=i.StatusBarAlignment.Left,b){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new F.DisposableStore,Ye(this,y,m,"f"),Ye(this,k,t,"f"),this._entryId=O.ID_GEN++,this._extension=o,this._id=a,this._alignment=p,this._priority=this.validatePriority(b)}validatePriority(m){if(!!(0,A.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!O.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:Oe(this,k,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:Oe(this,k,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let t;this._name?t=this._name:t=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let o=this._color;this._backgroundColor&&(o=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=_.MarkdownString.fromStrict(this._tooltip);Oe(this,y,"f").$setEntry(this._entryId,m,t,this._text,a,this._command?.internal,o,this._backgroundColor,this._alignment===i.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,k=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const t={message:m};return this._messages.unshift(t),this._update(),new i.Disposable(()=>{const o=this._messages.indexOf(t);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class g{constructor(m,t){this._proxy=m.getProxy(D.MainContext.MainThreadStatusBar),this._commands=t,this._statusMessage=new w(this)}createStatusBarEntry(m,t,o,a){return new O(this._proxy,this._commands,m,t,o,a)}setStatusBarMessage(m,t){const o=this._statusMessage.setMessage(m);let a;return typeof t=="number"?a=setTimeout(()=>o.dispose(),t):typeof t<"u"&&t.then(()=>o.dispose(),()=>o.dispose()),new i.Disposable(()=>{o.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=g}),define(De[74],Ce([1,0,5,4,3]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(A){this._onDidChangeStorage=new D.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,k){return this._proxy.$initializeExtensionStorage(A,y).then(O=>O||k)}setValue(A,y,k){return this._proxy.$setValue(A,y,k)}$acceptValue(A,y,k){this._onDidChangeStorage.fire({shared:A,key:y,value:k})}}e.ExtHostStorage=F,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(De[75],Ce([1,0,3,26,11,55,2]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,O,w){this._logService=O,this._extHostFileSystem=w,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(k){return _.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,O=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(k){if(this._value)return _.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return _.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=xe([We(0,D.IExtHostInitDataService),We(1,S.ILogService),We(2,F.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(De[56],Ce([1,0,4,5,3,2,14,7,6,135,12,174,21,38,159,62,9,15,8]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class b{constructor(r,h,v,I){this._proxy=r,this._id=h,this._creationOptions=v,this._name=I,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const L=this;this.value={get name(){return L._name||""},get processId(){return L._pidPromise},get creationOptions(){return L._creationOptions},get exitStatus(){return L._exitStatus},get state(){return L._state},sendText(j,W=!0){L._checkDisposed(),L._proxy.$sendText(L._id,j,W)},show(j){L._checkDisposed(),L._proxy.$show(L._id,j)},hide(){L._checkDisposed(),L._proxy.$hide(L._id)},dispose(){L._disposed||(L._disposed=!0,L._proxy.$dispose(L._id))},get dimensions(){if(!(L._cols===void 0||L._rows===void 0))return{columns:L._cols,rows:L._rows}}}}async create(r,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,o.withNullAsUndefined)(r.shellPath),shellArgs:(0,o.withNullAsUndefined)(r.shellArgs),cwd:(0,o.withNullAsUndefined)(r.cwd),env:(0,o.withNullAsUndefined)(r.env),icon:(0,o.withNullAsUndefined)(d(r.iconPath)),color:t.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,o.withNullAsUndefined)(r.message),strictEnv:(0,o.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(r.location,h?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,h,v,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:t.ThemeColor.isThemeColor(I)?I.id:void 0,location:this._serializeParentTerminal(r,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(r,h){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in r?{viewColumn:p.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitStatus(r,h){this._exitStatus=Object.freeze({code:r,reason:h})}setDimensions(r,h){return r===this._cols&&h===this._rows||r===0||h===0?!1:(this._cols=r,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=b;class u{get onProcessReady(){return this._onProcessReady.event}constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new i.Emitter,this._onDidChangeProperty=new i.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput?.(r)}resize(r,h){this._pty.setDimensions?.({columns:r,rows:h})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(r||void 0),r&&this._pty.setDimensions?.(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=u;let C=1,s=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(r,h){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new i.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new i.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new i.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new i.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new i.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new i.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=h.getProxy(D.MainContext.MainThreadTerminalService),this._bufferer=new m.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[v,I]of this._terminalProcesses)I.shutdown(!0)}})}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,h){const v=new b(this._proxy,(0,E.generateUuid)(),r,r.name),I=new u(r.pty);return v.createExtensionTerminal(r.location,this._serializeParentTerminal(r,h).resolvedExtHostIdentifier,d(r.iconPath),l(r.color)).then(L=>{const j=this._setupExtHostProcessListeners(L,I);this._terminalProcessDisposables[L]=j}),this._terminals.push(v),v.value}_serializeParentTerminal(r,h){if(h=h||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const I=this._terminals.find(L=>L.value===v);I&&(h.resolvedExtHostIdentifier=I._id)}}else r.location&&typeof r.location!="object"?h.location=r.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(r,h){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const I=new u(h),L=this._setupExtHostProcessListeners(r,I);this._terminalProcessDisposables[r]=L}async $acceptActiveTerminalChanged(r){const h=this._activeTerminal;if(r===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(r);v&&(this._activeTerminal=v,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,h){const v=this._getTerminalById(r);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:h})}async $acceptTerminalDimensions(r,h,v){const I=this._getTerminalById(r);I&&I.setDimensions(h,v)&&this._onDidChangeTerminalDimensions.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptTerminalMaximumDimensions(r,h,v){this._terminalProcesses.get(r)?.resize(h,v)}async $acceptTerminalTitleChange(r,h){const v=this._getTerminalById(r);v&&(v.name=h)}async $acceptTerminalClosed(r,h,v){const I=this._getTerminalObjectIndexById(this._terminals,r);if(I!==null){const L=this._terminals.splice(I,1)[0];L.setExitStatus(h,v),this._onDidCloseTerminal.fire(L.value)}}$acceptTerminalOpened(r,h,v,I){if(h){const W=this._getTerminalObjectIndexById(this._terminals,h);if(W!==null){this._terminals[W]._id=r,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const L={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:F.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},j=new b(this._proxy,r,L,v);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(r,h){this._getTerminalById(r)?._setProcessId(h)}async $startExtensionTerminal(r,h){const v=this._getTerminalById(r);if(!v)return{message:(0,k.localize)(0,null,r)};v.isOpen||await new Promise(L=>{const j=this.onDidOpenTerminal(async W=>{W===v.value&&(j.dispose(),L())})});const I=this._terminalProcesses.get(r);I?I.startSendingEvents(h):this._extensionTerminalAwaitingStart[r]={initialDimensions:h}}_setupExtHostProcessListeners(r,h){const v=new A.DisposableStore;v.add(h.onProcessReady(L=>this._proxy.$sendProcessReady(r,L.pid,L.cwd))),v.add(h.onDidChangeProperty(L=>this._proxy.$sendProcessProperty(r,L))),this._bufferer.startBuffering(r,h.onProcessData),v.add(h.onProcessExit(L=>this._onProcessExit(r,L))),this._terminalProcesses.set(r,h);const I=this._extensionTerminalAwaitingStart[r];return I&&h instanceof u&&(h.startSendingEvents(I.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),v}$acceptProcessAckDataEvent(r,h){this._terminalProcesses.get(r)?.acknowledgeDataEvent(h)}$acceptProcessInput(r,h){this._terminalProcesses.get(r)?.input(h)}$acceptTerminalInteraction(r){const h=this._getTerminalById(r);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(r,h,v){try{this._terminalProcesses.get(r)?.resize(h,v)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(r,h){this._terminalProcesses.get(r)?.shutdown(h)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(r,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(h=>this._proxy.$sendProcessProperty(r,{type:"cwd",value:h}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,h,v){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,v),this._proxy.$registerProfileProvider(h,r.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(r,h){const v=new g.CancellationTokenSource().token;let I=await this._profileProviders.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,h);return}this.createTerminalFromOptions(I.options,h)}}async $provideLinks(r,h){const v=this._getTerminalById(r);if(!v)return[];this._terminalLinkCache.delete(r),this._terminalLinkCancellationSource.get(r)?.dispose(!0);const L=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,L);const j=[],W={terminal:v.value,line:h},H=[];for(const R of this._linkProviders)H.push(a.Promises.withAsyncBody(async B=>{L.token.onCancellationRequested(()=>B({provider:R,links:[]}));const x=await R.provideTerminalLinks(W,L.token)||[];L.token.isCancellationRequested||B({provider:R,links:x})}));const P=await Promise.all(H);if(L.token.isCancellationRequested)return[];const M=new Map;for(const R of P)R&&R.links.length>0&&j.push(...R.links.map(B=>{const x={id:C++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return M.set(x.id,{provider:R.provider,link:B}),x}));return this._terminalLinkCache.set(r,M),j}$activateLink(r,h){const v=this._terminalLinkCache.get(r)?.get(h);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(r,h){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const v=this._terminalProcessDisposables[r];v&&(v.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,h)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,h){const v=this._getTerminalObjectIndexById(r,h);return v!==null?r[v]:null}_getTerminalObjectIndexById(r,h){let v=null;return r.some((I,L)=>I._id===h?(v=L,!0):!1),v}getEnvironmentVariableCollection(r){let h=this._environmentVariableCollections.get(r.identifier.value);return h||(h=new c,this._setEnvironmentVariableCollection(r.identifier.value,h)),h}_syncEnvironmentVariableCollection(r,h){const v=(0,w.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(r,h.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(r){r.forEach(h=>{const v=h[0],I=new c(h[1]);this._setEnvironmentVariableCollection(v,I)})}$acceptDefaultProfile(r,h){const v=this._defaultProfile;this._defaultProfile=r,this._defaultAutomationProfile=h,v?.path!==r.path&&this._onDidChangeShell.fire(r.path)}_setEnvironmentVariableCollection(r,h){this._environmentVariableCollections.set(r,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,h)})}};s=xe([We(1,_.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class c{get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,h){this._setIfDiffers(r,{value:h,type:y.EnvironmentVariableMutatorType.Replace})}append(r,h){this._setIfDiffers(r,{value:h,type:y.EnvironmentVariableMutatorType.Append})}prepend(r,h){this._setIfDiffers(r,{value:h,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,h){const v=this.map.get(r);(!v||v.value!==h.value||v.type!==h.type)&&(this.map.set(r,h),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,h){this.map.forEach((v,I)=>r.call(h,I,v,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let n=class extends s{constructor(r){super(!1,r)}createTerminal(r,h,v){throw new O.NotSupportedError}createTerminalFromOptions(r,h){throw new O.NotSupportedError}};n=xe([We(0,_.IExtHostRpcService)],n),e.WorkerExtHostTerminalService=n;function d(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function l(f){return t.ThemeColor.isThemeColor(f)?f:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i};define(De[219],Ce([1,0,18,23,21,4,183,220,7,24,9,38,5,14,96,8,6,41,67,51]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b){"use strict";var u,C;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(W,H,P){this.editors=P,this.resultsChangedEmitter=new F.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=W.getProxy(g.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new n(this.proxy),H.registerArgumentProcessor({processArgument:M=>{if(M?.$mid!==14)return M;const R=M,B=R.tests[R.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(B))?.collection.tree.get(B)?.actual??(0,m.toItemFromContext)(M)}})}createTestController(W,H,P){if(this.controllers.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const M=new y.DisposableStore,R=M.add(new m.ExtHostTestItemCollection(W,H,this.editors));R.root.label=H;const B=new Map,x=this.proxy,U={items:R.root.children,get label(){return H},set label(te){H=te,R.root.label=te,x.$updateController(W,{label:H})},get refreshHandler(){return P},set refreshHandler(te){P=te,x.$updateController(W,{canRefresh:!!te})},get id(){return W},createRunProfile:(te,de,re,be,le)=>{let fe=(0,A.hash)(te);for(;B.has(fe);)fe++;return new I(this.proxy,B,W,fe,te,de,re,be,le)},createTestItem(te,de,re){return new m.TestItemImpl(W,te,de,re)},createTestRun:(te,de,re=!0)=>this.runTracker.createTestRun(W,R,te,de,re),set resolveHandler(te){R.resolveHandler=te},get resolveHandler(){return R.resolveHandler},dispose:()=>{M.dispose()}};x.$registerTestController(W,H,!!P),M.add((0,y.toDisposable)(()=>x.$unregisterTestController(W)));const K={controller:U,collection:R,profiles:B};return this.controllers.set(W,K),M.add((0,y.toDisposable)(()=>this.controllers.delete(W))),M.add(R.onDidGenerateDiff(te=>x.$publishDiff(W,te.map(b.TestsDiffOp.serialize)))),U}createTestObserver(){return this.observer.checkout()}async runTests(W,H=S.CancellationToken.None){const P=d(W);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(P.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:W.include?.map(R=>a.TestId.fromExtHostTestItem(R,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:L[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:W.exclude?.map(R=>R.id)},H)}$syncTests(){for(const{collection:W}of this.controllers.values())W.flushDiff();return Promise.resolve()}$provideFileCoverage(W,H,P){return(0,i.mapFind)(this.runTracker.trackers,R=>R.id===W?R.getCoverage(H):void 0)?.provideFileCoverage(P)??Promise.resolve([])}$resolveFileCoverage(W,H,P,M){return(0,i.mapFind)(this.runTracker.trackers,B=>B.id===W?B.getCoverage(H):void 0)?.resolveFileCoverage(P,M)??Promise.resolve([])}$configureRunProfile(W,H){this.controllers.get(W)?.profiles.get(H)?.configureHandler?.()}async $refreshTests(W,H){await this.controllers.get(W)?.controller.refreshHandler?.(H)}$publishTestResults(W){this.results=Object.freeze(W.map(H=>(0,k.deepFreeze)(t.TestResults.to(H))).concat(this.results).sort((H,P)=>P.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(W,H){const P=this.controllers.get(a.TestId.fromString(W).controllerId)?.collection;P&&(await P.expand(W,H<0?1/0:H),P.flushDiff())}$acceptDiff(W){this.observer.applyDiff(W.map(b.TestsDiffOp.deserialize))}async $runControllerTests(W,H){return Promise.all(W.map(P=>this.runControllerTestRequest(P,H)))}async runControllerTestRequest(W,H){const P=this.controllers.get(W.controllerId);if(!P)return{};const{collection:M,profiles:R}=P,B=R.get(W.profileId);if(!B)return{};const x=W.testIds.map(de=>M.tree.get(de)).filter(O.isDefined),U=W.excludeExtIds.map(de=>P.collection.tree.get(de)).filter(O.isDefined).filter(de=>x.some(re=>re.fullId.compare(de.fullId)===2));if(!x.length)return{};const K=new o.TestRunRequest(x.some(de=>de.actual instanceof m.TestItemRootImpl)?void 0:x.map(de=>de.actual),U.map(de=>de.actual),B),te=this.runTracker.prepareForMainThreadTestRun(K,l.fromInternal(W,P.collection),H);try{return await B.runHandler(K,H),{}}catch(de){return{error:String(de)}}finally{te.isRunning&&!H.isCancellationRequested&&await F.Event.toPromise(te.onEnd),te.dispose()}}$cancelExtensionTestRun(W){W===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(W)}};s=xe([We(0,E.IExtHostRpcService)],s),e.ExtHostTesting=s;class c extends y.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(W,H,P){super(),this.dto=W,this.proxy=H,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new F.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(P)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}getCoverage(W){return this.tasks.get(W)?.coverage}createRun(W){const H=this.dto.id,P=this.dto.controllerId,M=(0,w.generateUuid)(),R=new f(this.proxy,H,M),B=te=>(de,...re)=>{if(U){console.warn(`Setting the state of test "${de.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(de)||(this.ensureTestIsKnown(de),te(de,...re))},x=(te,de)=>{const re=de instanceof Array?de.map(t.TestMessage.from):[t.TestMessage.from(de)];if(te.uri&&te.range){const be={range:t.Range.from(te.range),uri:te.uri};for(const le of re)le.location=le.location||be}this.proxy.$appendTestMessagesInRun(H,M,a.TestId.fromExtHostTestItem(te,P).toString(),re)};let U=!1;const K={isPersisted:this.dto.isPersisted,token:this.cts.token,name:W,get coverageProvider(){return R.coverageProvider},set coverageProvider(te){R.coverageProvider=te},enqueued:B(te=>{this.proxy.$updateTestStateInRun(H,M,a.TestId.fromExtHostTestItem(te,P).toString(),1)}),skipped:B(te=>{this.proxy.$updateTestStateInRun(H,M,a.TestId.fromExtHostTestItem(te,P).toString(),5)}),started:B(te=>{this.proxy.$updateTestStateInRun(H,M,a.TestId.fromExtHostTestItem(te,P).toString(),2)}),errored:B((te,de,re)=>{x(te,de),this.proxy.$updateTestStateInRun(H,M,a.TestId.fromExtHostTestItem(te,P).toString(),6,re)}),failed:B((te,de,re)=>{x(te,de),this.proxy.$updateTestStateInRun(H,M,a.TestId.fromExtHostTestItem(te,P).toString(),4,re)}),passed:B((te,de)=>{this.proxy.$updateTestStateInRun(H,M,a.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,de)}),appendOutput:(te,de,re)=>{U||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(H,M,D.VSBuffer.fromString(te),de&&t.location.from(de),re&&a.TestId.fromExtHostTestItem(re,P).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(H,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:K,coverage:R}),this.proxy.$startedTestRunTask(H,{id:M,name:W,running:!0}),K}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(W){if(!(W instanceof m.TestItemImpl))throw new p.InvalidTestItemError(W.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString()))return;const H=[],P=this.dto.colllection.root;for(;;){const M=t.TestItem.from(W);if(H.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),W===P))break;W=W.parent||P}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,H)}}class n{get trackers(){return this.tracked.values()}constructor(W){this.proxy=W,this.tracked=new Map}prepareForMainThreadTestRun(W,H,P){return this.getTracker(W,H,P)}cancelRunById(W){for(const H of this.tracked.values())if(H.id===W){H.dispose();return}}cancelAllRuns(){for(const W of this.tracked.values())W.dispose()}createTestRun(W,H,P,M,R){const B=this.tracked.get(P);if(B)return B.createRun(M);const x=l.fromPublic(W,H,P,R),U=d(P);this.proxy.$startedExtensionTestRun({controllerId:W,profile:U&&{group:L[U.kind],id:U.profileId},exclude:P.exclude?.map(te=>a.TestId.fromExtHostTestItem(te,H.root.id).toString())??[],id:x.id,include:P.include?.map(te=>a.TestId.fromExtHostTestItem(te,H.root.id).toString())??[H.root.id],persist:R});const K=this.getTracker(P,x);return K.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),K.createRun(M)}getTracker(W,H,P){const M=new c(H,this.proxy,P);return this.tracked.set(W,M),M.onEnd(()=>this.tracked.delete(W)),M}}e.TestRunCoordinator=n;const d=j=>{if(!!j.profile){if(!(j.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class l{static fromPublic(W,H,P,M){return new l(W,(0,w.generateUuid)(),P.include?.map(R=>a.TestId.fromExtHostTestItem(R,W).toString())??[W],P.exclude?.map(R=>a.TestId.fromExtHostTestItem(R,W).toString())??[],M,H)}static fromInternal(W,H){return new l(W.controllerId,W.runId,W.testIds,W.excludeExtIds,!0,H)}constructor(W,H,P,M,R,B){this.controllerId=W,this.id=H,this.isPersisted=R,this.colllection=B,this.includePrefix=P.map(x=>x+"\0"),this.excludePrefix=M.map(x=>x+"\0")}isIncluded(W){const H=a.TestId.fromExtHostTestItem(W,this.controllerId).toString()+"\0";for(const P of this.excludePrefix)if(H===P||H.startsWith(P))return!1;for(const P of this.includePrefix)if(H===P||H.startsWith(P))return!0;return!1}}e.TestRunDto=l;class f{set coverageProvider(W){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!W||(this._coverageProvider=W,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(W,H,P){this.proxy=W,this.runId=H,this.taskId=P}async provideFileCoverage(W){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(W))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(H){throw this.fileCoverage=void 0,H}}async resolveFileCoverage(W,H){const P=await this.fileCoverage;let M=P?.[W];return!this._coverageProvider||!P||!M?[]:(M.detailedCoverage||(M=P[W]=await this._coverageProvider.resolveFileCoverage?.(M,H)??M),M.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class r extends b.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(W){super(),this.emitter=W,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(W){this.added.add(W)}update(W){Object.assign(W.revived,t.TestItem.toPlain(W.item)),this.added.has(W)||this.updated.add(W)}remove(W){if(this.added.has(W)){this.added.delete(W);return}this.updated.delete(W);const H=a.TestId.parentId(W.item.extId);if(H&&this.alreadyRemoved.has(H.toString())){this.alreadyRemoved.add(W.item.extId);return}this.removed.add(W)}getChangeEvent(){const{added:W,updated:H,removed:P}=this;return{get added(){return[...W].map(M=>M.revived)},get updated(){return[...H].map(M=>M.revived)},get removed(){return[...P].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new F.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(W){return this.items.get(W)}getMirroredTestDataByReference(W){return this.items.get(W.id)}createItem(W,H){return{...W,revived:t.TestItem.toPlain(W.item),depth:H?H.depth+1:0,children:new Set}}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=h;class v{constructor(W){this.proxy=W}checkout(){this.current||(this.current=this.createObserverData());const W=this.current;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(H=>H.revived)},dispose:(0,_.once)(()=>{--W.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(W){return this.current?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.current?.tests.apply(W)}createObserverData(){const W=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:W}}}class I{get label(){return this._label}set label(W){W!==this._label&&(this._label=W,Oe(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:W}))}get isDefault(){return this._isDefault}set isDefault(W){W!==this._isDefault&&(this._isDefault=W,Oe(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:W}))}get tag(){return this._tag}set tag(W){W?.id!==this._tag?.id&&(this._tag=W,Oe(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:W?t.TestTag.namespace(this.controllerId,W.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(W){W!==this._configureHandler&&(this._configureHandler=W,Oe(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!W}))}constructor(W,H,P,M,R,B,x,U=!1,K=void 0){this.controllerId=P,this.profileId=M,this._label=R,this.kind=B,this.runHandler=x,this._isDefault=U,this._tag=K,u.set(this,void 0),C.set(this,void 0),Ye(this,u,W,"f"),Ye(this,C,H,"f"),H.set(M,this);const te=L[B];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${B}`);Oe(this,u,"f").$publishTestRunProfile({profileId:M,controllerId:P,tag:K?t.TestTag.namespace(this.controllerId,K.id):null,label:R,group:te,isDefault:U,hasConfigurationHandler:!1})}dispose(){Oe(this,C,"f")?.delete(this.profileId)&&(Ye(this,C,void 0,"f"),Oe(this,u,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=I,u=new WeakMap,C=new WeakMap;const L={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[221],Ce([1,0,18,4,5,97,8,6]),function(ne,e,i,D,S,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new D.Emitter,this._onDidChangeTextEditorOptions=new D.Emitter,this._onDidChangeTextEditorVisibleRanges=new D.Emitter,this._onDidChangeTextEditorViewColumn=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const w=this._extHostDocumentsAndEditors.allEditors();return O?w:w.map(g=>g.value)}async showTextDocument(O,w,g){let E;typeof w=="number"?E={position:_.ViewColumn.from(w),preserveFocus:g}:typeof w=="object"?E={position:_.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?_.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:E={preserveFocus:!1};const m=await this._proxy.$tryShowTextDocument(O.uri,E),t=m&&this._extHostDocumentsAndEditors.getEditor(m);if(t)return t.value;throw m?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,w){return new F.TextEditorDecorationType(this._proxy,O,w).value}$acceptEditorPropertiesChanged(O,w){const g=this._extHostDocumentsAndEditors.getEditor(O);if(!g)throw new Error("unknown text editor");if(w.options&&g._acceptOptions(w.options),w.selections){const E=w.selections.selections.map(_.Selection.to);g._acceptSelections(E)}if(w.visibleRanges){const E=i.coalesce(w.visibleRanges.map(_.Range.to));g._acceptVisibleRanges(E)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:{...w.options,lineNumbers:_.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const E=A.TextEditorSelectionChangeKind.fromValue(w.selections.source),m=w.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:m,kind:E})}if(w.visibleRanges){const E=i.coalesce(w.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:E})}}$acceptEditorPositionData(O){for(const w in O){const g=this._extHostDocumentsAndEditors.getEditor(w);if(!g)throw new Error("Unknown text editor");const E=_.ViewColumn.to(O[w]);g.value.viewColumn!==E&&(g._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:E}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(De[222],Ce([1,0,2,3,5,7,6,8,9]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,D.createDecorator)("IExtHostTimeline");class k{constructor(g,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=g.getProxy(S.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===11){const t=m.uri===void 0?void 0:i.URI.revive(m.uri);return this._itemsBySourceAndUriMap.get(m.source)?.get(O(t))?.get(m.handle)}return m}})}async $getTimeline(g,E,m,t){return this._providers.get(g)?.provideTimeline(i.URI.revive(E),m,t)}registerTimelineProvider(g,E,m,t){const o=new F.DisposableStore,a=this.convertTimelineItem(E.id,t,o).bind(this);let p;E.onDidChange&&(p=E.onDidChange(u=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:E.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:g,onDidChange:void 0,async provideTimeline(u,C,s){C?.resetCache&&(o.clear(),b.get(E.id)?.clear());const c=await E.provideTimeline(u,C,s);if(c==null)return;const n=a(u,C);return{...c,source:E.id,items:c.items.map(n)}},dispose(){for(const u of b.values())u.get(E.id)?.clear();p?.dispose(),o.dispose()}})}convertTimelineItem(g,E,m){return(t,o)=>{let a;if(o?.cacheResults){let p=this._itemsBySourceAndUriMap.get(g);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(g,p));const b=O(t);a=p.get(b),a===void 0&&(a=new Map,p.set(b,a))}return p=>{const{iconPath:b,...u}=p,C=`${g}|${p.id??p.timestamp}`;a?.set(C,p);let s,c,n;p.iconPath&&(b instanceof _.ThemeIcon?n={id:b.id,color:b.color}:i.URI.isUri(b)?(s=b,c=b):{light:s,dark:c}=b);let d;return _.MarkdownString.isMarkdownString(u.tooltip)?d=A.MarkdownString.from(u.tooltip):(0,y.isString)(u.tooltip)?d=u.tooltip:_.MarkdownString.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=A.MarkdownString.from(u.detail)):(0,y.isString)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=u.detail),{...u,id:u.id??void 0,handle:C,source:g,command:p.command?E.toInternal(p.command,m):void 0,icon:s,iconDark:c,themeIcon:n,tooltip:d,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(g){if(this._providers.get(g.id))throw new Error(`Timeline Provider ${g.id} already exists.`);return this._proxy.$registerTimelineProvider({id:g.id,label:g.label,scheme:g.scheme}),this._providers.set(g.id,g),(0,F.toDisposable)(()=>{for(const m of this._itemsBySourceAndUriMap.values())m.get(g.id)?.clear();this._providers.delete(g.id),this._proxy.$unregisterTimelineProvider(g.id),g.dispose()})}}e.ExtHostTimeline=k;function O(w){return w?.toString()}}),define(De[223],Ce([1,0,7,13,2,5]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(y){this._openers=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,O,w){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const g=w.schemes.find(E=>!_.supportedSchemes.has(E));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,O),this._proxy.$registerUriOpener(k,w.schemes,y,w.label),(0,i.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,O){const w=this._openers.get(y);if(!w)throw new Error(`Unknown opener with id: ${y}`);const g=S.URI.revive(k);return w.canOpenExternalUri(g,O)}async $openUri(y,k,O){const w=this._openers.get(y);if(!w)throw new Error(`Unknown opener id: '${y}'`);return w.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([D.Schemas.http,D.Schemas.https])}),define(De[224],Ce([1,0,5,2,7,12,25]),function(ne,e,i,D,S,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.handles.has(_.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const w=A.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(k)),this.handlers.set(w,O),this._proxy.$registerUriHandler(w,k),(0,S.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(k)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(k,O){const w=this.handlers.get(k);if(!w)return Promise.resolve(void 0);try{w.handleUri(D.URI.revive(O))}catch(g){(0,F.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(k){return D.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=A,A.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[57],Ce([1,0,4,13,2,146,167,65,5]),function(ne,e,i,D,S,F,_,A,y){"use strict";var k,O,w,g,E,m,t,o,a,p,b,u,C;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(I,L,j,W,H,P,M){k.set(this,void 0),O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),E.set(this,void 0),m.set(this,void 0),t.set(this,""),o.set(this,void 0),a.set(this,!1),p.set(this,!1),b.set(this,void 0),u.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,C.set(this,new i.Emitter),this._onDidDispose=Oe(this,C,"f").event,Ye(this,k,I,"f"),Ye(this,O,L,"f"),Ye(this,o,j,"f"),Ye(this,g,W,"f"),Ye(this,E,H,"f"),Ye(this,m,P,"f"),Ye(this,b,c(P),"f"),Ye(this,u,n(P),"f"),Ye(this,w,M,"f")}dispose(){Ye(this,a,!0,"f"),Oe(this,C,"f").fire(),Oe(this,C,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(I){return Ye(this,p,!0,"f"),(0,A.asWebviewUri)(I,Oe(this,g,"f"))}get cspSource(){const I=Oe(this,m,"f").extensionLocation;if(I.scheme===D.Schemas.https||I.scheme===D.Schemas.http){let L=I.toString();return L.endsWith("/")||(L+="/"),L+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,t,"f")}set html(I){this.assertNotDisposed(),Oe(this,t,"f")!==I&&(Ye(this,t,I,"f"),Oe(this,u,"f")&&!Oe(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(I)&&(Ye(this,p,!0,"f"),Oe(this,w,"f").report("Webview vscode-resource: uris",Oe(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,k,"f"),this.rewriteOldResourceUrlsIfNeeded(I)))}get options(){return this.assertNotDisposed(),Oe(this,o,"f")}set options(I){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,k,"f"),f(Oe(this,m,"f"),Oe(this,E,"f"),I)),Ye(this,o,I,"f")}async postMessage(I){if(Oe(this,a,"f"))return!1;const L=(0,_.serializeWebviewMessage)(I,{serializeBuffersForPostMessage:Oe(this,b,"f")});return Oe(this,O,"f").$postMessage(Oe(this,k,"f"),L.message,...L.buffers)}assertNotDisposed(){if(Oe(this,a,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(I){if(!Oe(this,u,"f"))return I;const L=Oe(this,m,"f").extensionLocation?.scheme===D.Schemas.vscodeRemote,j=Oe(this,m,"f").extensionLocation.scheme===D.Schemas.vscodeRemote?Oe(this,m,"f").extensionLocation.authority:void 0;return I.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,H,P,M,R,B)=>{const x=S.URI.from({scheme:M||"file",path:decodeURIComponent(R)}),U=(0,A.asWebviewUri)(x,{isRemote:L,authority:j}).toString();return`${H}${U}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,H,P,M,R,B)=>{const x=S.URI.from({scheme:M||"file",path:decodeURIComponent(R)}),U=(0,A.asWebviewUri)(x,{isRemote:L,authority:j}).toString();return`${H}${U}${B}`})}}e.ExtHostWebview=s,k=new WeakMap,O=new WeakMap,w=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,o=new WeakMap,a=new WeakMap,p=new WeakMap,b=new WeakMap,u=new WeakMap,C=new WeakMap;function c(v){try{const I=(0,F.normalizeVersion)((0,F.parseVersion)(v.engines.vscode));return!!I&&I.majorBase>=1&&I.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;function n(v){try{const I=(0,F.normalizeVersion)((0,F.parseVersion)(v.engines.vscode));return I?I.majorBase<1||I.majorBase===1&&I.minorBase<60:!1}catch{return!1}}class d{constructor(I,L,j,W,H){this.remoteInfo=L,this.workspace=j,this._logService=W,this._deprecationService=H,this._webviews=new Map,this._webviewProxy=I.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(I,L,j){const W=this.getWebview(I);if(W){const{message:H}=(0,_.deserializeWebviewMessage)(L,j.value);W._onMessageEmitter.fire(H)}}$onMissingCsp(I,L){this._logService.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(I,L,j){const W=new s(I,this._webviewProxy,r(L),this.remoteInfo,this.workspace,j,this._deprecationService);return this._webviews.set(I,W),W._onDidDispose(()=>{this._webviews.delete(I)}),W}deleteWebview(I){this._webviews.delete(I)}getWebview(I){return this._webviews.get(I)}}e.ExtHostWebviews=d;function l(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=l;function f(v,I,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||h(v,I)}}e.serializeWebviewOptions=f;function r(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(I=>S.URI.from(I))}}e.reviveOptions=r;function h(v,I){return[...(I?.getWorkspaceFolders()||[]).map(L=>L.uri),v.extensionLocation]}}),define(De[225],Ce([1,0,21,220,7,13,22,2,8,57,63,5,6]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(c,n){this.document=c,this._storagePath=n,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,n){await this.getEdit(c).undo(),n||this.disposeBackup()}async redo(c,n){await this.getEdit(c).redo(),n||this.disposeBackup()}disposeEdits(c){for(const n of c)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=C(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const n=this._edits.get(c,0);if(!n)throw new Error("No edit found");return n}}class m{constructor(){this._documents=new Map}get(c,n){return this._documents.get(this.key(c,n))}add(c,n,d){const l=this.key(c,n.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${c} resource:${n.uri}`);const f=new E(n,d);return this._documents.set(l,f),f}delete(c,n){const d=this.key(c,n.uri);this._documents.delete(d)}key(c,n){return`${c}@@@${n}`}}var t;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(t||(t={}));class o{constructor(){this._providers=new Map}addTextProvider(c,n,d){return this.add(0,c,n,d)}addCustomProvider(c,n,d){return this.add(1,c,n,d)}get(c){return this._providers.get(c)}add(c,n,d,l){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:c,extension:d,provider:l}),new g.Disposable(()=>this._providers.delete(n))}}class a{constructor(c,n,d,l,f){this._extHostDocuments=n,this._extensionStoragePaths=d,this._extHostWebview=l,this._extHostWebviewPanels=f,this._editorProviders=new o,this._documents=new m,this._proxy=c.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,n,d,l){const f=new S.DisposableStore;return b(d)?(f.add(this._editorProviders.addTextProvider(n,c,d)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(c),n,l.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(c))):(f.add(this._editorProviders.addCustomProvider(n,c,d)),p(d)&&f.add(d.onDidChangeCustomDocument(r=>{const h=this.getCustomDocumentEntry(n,r.document.uri);if(u(r)){const v=h.addEdit(r);this._proxy.$onDidEdit(r.document.uri,n,v,r.label)}else this._proxy.$onContentChange(r.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(c),n,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(c))),g.Disposable.from(f,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(c,n,d,l,f){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${n}'`);const h=A.URI.revive(c),v=await r.provider.openCustomDocument(h,{backupId:d,untitledDocumentData:l?.buffer},f);let I;return p(r.provider)&&this._extensionStoragePaths&&(I=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension)),this._documents.add(n,v,I),{editable:p(r.provider)}}async $disposeCustomDocument(c,n){const d=this._editorProviders.get(n);if(!d)throw new Error(`No provider found for '${n}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${n}'`);const l=A.URI.revive(c),{document:f}=this.getCustomDocumentEntry(n,l);this._documents.delete(n,f),f.dispose()}async $resolveWebviewEditor(c,n,d,l,f,r){const h=this._editorProviders.get(d);if(!h)throw new Error(`No provider found for '${d}'`);const v=y.ViewColumn.to(f),I=this._extHostWebview.createNewWebview(n,l.contentOptions,h.extension),L=this._extHostWebviewPanels.createNewWebviewPanel(n,d,l.title,v,l.options,I,!0),j=A.URI.revive(c);switch(h.type){case 1:{const{document:W}=this.getCustomDocumentEntry(d,j);return h.provider.resolveCustomEditor(W,L,r)}case 0:{const W=this._extHostDocuments.getDocument(j);return h.provider.resolveCustomTextEditor(W,L,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,n,d){this.getCustomDocumentEntry(n,c).disposeEdits(d)}async $onMoveCustomEditor(c,n,d){const l=this._editorProviders.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this._extHostWebviewPanels.getWebviewPanel(c);if(!f)throw new Error("No webview found");const r=A.URI.revive(n),h=this._extHostDocuments.getDocument(r);await l.provider.moveCustomTextEditor(h,f,i.CancellationToken.None)}async $undo(c,n,d,l){return this.getCustomDocumentEntry(n,c).undo(d,l)}async $redo(c,n,d,l){return this.getCustomDocumentEntry(n,c).redo(d,l)}async $revert(c,n,d){const l=this.getCustomDocumentEntry(n,c);await this.getCustomEditorProvider(n).revertCustomDocument(l.document,d),l.disposeBackup()}async $onSave(c,n,d){const l=this.getCustomDocumentEntry(n,c);await this.getCustomEditorProvider(n).saveCustomDocument(l.document,d),l.disposeBackup()}async $onSaveAs(c,n,d,l){const f=this.getCustomDocumentEntry(n,c);return this.getCustomEditorProvider(n).saveCustomDocumentAs(f.document,A.URI.revive(d),l)}async $backup(c,n,d){const l=this.getCustomDocumentEntry(n,c),r=await this.getCustomEditorProvider(n).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},d);return l.updateBackup(r),r.id}getCustomDocumentEntry(c,n){const d=this._documents.get(c,A.URI.revive(n));if(!d)throw new Error("No custom document found");return d}getCustomEditorProvider(c){const d=this._editorProviders.get(c)?.provider;if(!d||!p(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=a;function p(s){return!!s.onDidChangeCustomDocument}function b(s){return typeof s.resolveCustomTextEditor=="function"}function u(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function C(s){const c=s.scheme===F.Schemas.file||s.scheme===F.Schemas.untitled?s.fsPath:s.toString();return(0,D.hash)(c)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[226],Ce([1,0,4,7,2,38,8,57,5,6]),function(ne,e,i,D,S,F,_,A,y,k){"use strict";var O,w,g,E,m,t,o,a,p,b,u,C,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class c extends D.Disposable{constructor(f,r,h,v){super(),O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),o.set(this,void 0),a.set(this,void 0),p.set(this,!0),b.set(this,void 0),u.set(this,!1),C.set(this,this._register(new i.Emitter)),this.onDidDispose=Oe(this,C,"f").event,s.set(this,this._register(new i.Emitter)),this.onDidChangeViewState=Oe(this,s,"f").event,Ye(this,O,f,"f"),Ye(this,w,r,"f"),Ye(this,E,h,"f"),Ye(this,g,v.viewType,"f"),Ye(this,m,v.panelOptions,"f"),Ye(this,a,v.viewColumn,"f"),Ye(this,t,v.title,"f"),Ye(this,b,v.active,"f")}dispose(){Oe(this,u,"f")||(Ye(this,u,!0,"f"),Oe(this,C,"f").fire(),Oe(this,w,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,E,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,g,"f")}get title(){return this.assertNotDisposed(),Oe(this,t,"f")}set title(f){this.assertNotDisposed(),Oe(this,t,"f")!==f&&(Ye(this,t,f,"f"),Oe(this,w,"f").$setTitle(Oe(this,O,"f"),f))}get iconPath(){return this.assertNotDisposed(),Oe(this,o,"f")}set iconPath(f){this.assertNotDisposed(),Oe(this,o,"f")!==f&&(Ye(this,o,f,"f"),Oe(this,w,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Oe(this,m,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,a,"f")=="number"&&Oe(this,a,"f")<0))return Oe(this,a,"f")}get active(){return this.assertNotDisposed(),Oe(this,b,"f")}get visible(){return this.assertNotDisposed(),Oe(this,p,"f")}_updateViewState(f){Oe(this,u,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Ye(this,b,f.active,"f"),Ye(this,p,f.visible,"f"),Ye(this,a,f.viewColumn,"f"),Oe(this,s,"f").fire({webviewPanel:this}))}reveal(f,r){this.assertNotDisposed(),Oe(this,w,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof f>"u"?void 0:_.ViewColumn.from(f),preserveFocus:!!r})}assertNotDisposed(){if(Oe(this,u,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,o=new WeakMap,a=new WeakMap,p=new WeakMap,b=new WeakMap,u=new WeakMap,C=new WeakMap,s=new WeakMap;class n{static newHandle(){return(0,F.generateUuid)()}constructor(f,r,h){this.webviews=r,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(f,r,h,v,I={}){const L=typeof v=="object"?v.viewColumn:v,j={viewColumn:_.ViewColumn.from(L),preserveFocus:typeof v=="object"&&!!v.preserveFocus},W=(0,A.shouldSerializeBuffersForPostMessage)(f),H=n.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(f),H,r,{title:h,panelOptions:d(I),webviewOptions:(0,A.serializeWebviewOptions)(f,this.workspace,I),serializeBuffersForPostMessage:W},j);const P=this.webviews.createNewWebview(H,I,f);return this.createNewWebviewPanel(H,r,h,L,I,P,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((h,v)=>{const I=f[h],L=f[v];return I.active?1:L.active?-1:+I.visible-+L.visible});for(const h of r){const v=this.getWebviewPanel(h);if(!v)continue;const I=f[h];v._updateViewState({active:I.active,visible:I.visible,viewColumn:_.ViewColumn.to(I.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,r,h){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:h,extension:f}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(f)}),new k.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,h,v){const I=this._serializers.get(r);if(!I)throw new Error(`No serializer found for '${r}'`);const{serializer:L,extension:j}=I,W=this.webviews.createNewWebview(f,h.webviewOptions,j),H=this.createNewWebviewPanel(f,r,h.title,v,h.panelOptions,W,h.active);await L.deserializeWebviewPanel(H,h.state)}createNewWebviewPanel(f,r,h,v,I,L,j){const W=new c(f,this._proxy,L,{viewType:r,title:h,viewColumn:v,panelOptions:I,active:j});return this._webviewPanels.set(f,W),W}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=n;function d(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[227],Ce([1,0,4,7,57,8,5,6]),function(ne,e,i,D,S,F,_,A){"use strict";var y,k,O,w,g,E,m,t,o,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends D.Disposable{constructor(s,c,n,d,l,f,r){super(),y.set(this,void 0),k.set(this,void 0),O.set(this,void 0),w.set(this,void 0),g.set(this,!1),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),o.set(this,void 0),a.set(this,this._register(new i.Emitter)),this.onDidChangeVisibility=Oe(this,a,"f").event,p.set(this,this._register(new i.Emitter)),this.onDidDispose=Oe(this,p,"f").event,Ye(this,O,n,"f"),Ye(this,m,d,"f"),Ye(this,y,s,"f"),Ye(this,k,c,"f"),Ye(this,w,l,"f"),Ye(this,E,r,"f")}dispose(){Oe(this,g,"f")||(Ye(this,g,!0,"f"),Oe(this,p,"f").fire(),Oe(this,w,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,m,"f")}set title(s){this.assertNotDisposed(),Oe(this,m,"f")!==s&&(Ye(this,m,s,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,y,"f"),s))}get description(){return this.assertNotDisposed(),Oe(this,t,"f")}set description(s){this.assertNotDisposed(),Oe(this,t,"f")!==s&&(Ye(this,t,s,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,y,"f"),s))}get visible(){return Oe(this,E,"f")}get webview(){return Oe(this,w,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(s){s===Oe(this,E,"f")||Oe(this,g,"f")||(Ye(this,E,s,"f"),Oe(this,a,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,o,"f")}set badge(s){this.assertNotDisposed(),!(s?.value===Oe(this,o,"f")?.value&&s?.tooltip===Oe(this,o,"f")?.tooltip)&&(Ye(this,o,F.ViewBadge.from(s),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,y,"f"),s))}show(s){this.assertNotDisposed(),Oe(this,k,"f").$show(Oe(this,y,"f"),!!s)}assertNotDisposed(){if(Oe(this,g,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,O=new WeakMap,w=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,o=new WeakMap,a=new WeakMap,p=new WeakMap;class u{constructor(s,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,c,n,d){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:n,extension:s}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(s),c,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(s)}),new A.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(s,c,n,d,l){const f=this._viewProviders.get(c);if(!f)throw new Error(`No view provider found for '${c}'`);const{provider:r,extension:h}=f,v=this._extHostWebview.createNewWebview(s,{},h),I=new b(s,this._proxy,c,n,v,h,!0);this._webviewViews.set(s,I),await r.resolveWebviewView(I,{state:d},l)}async $onDidChangeWebviewViewVisibility(s,c){this.getWebviewView(s)._setVisible(c)}async $disposeWebviewView(s){const c=this.getWebviewView(s);this._webviewViews.delete(s),c.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const c=this._webviewViews.get(s);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=u}),define(De[99],Ce([1,0,4,5,2,13,10,3,14]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class en{get state(){return this._state}constructor(w){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=en.InitialState,this._proxy=w.getProxy(D.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,g){let E;if(typeof w=="string"){E=w;try{w=S.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,_.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,E,g)}async asExternalUri(w,g){if((0,_.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(w,g);return S.URI.from(E)}};k.InitialState={focused:!0},k=xe([We(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(De[228],Ce([1,0,198,26,14]),function(ne,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=class extends i.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}_nativeConsoleLogMessage(A,y,k){y.apply(console,k)}};F=xe([We(0,S.IExtHostRpcService),We(1,D.IExtHostInitDataService)],F),e.ExtHostConsoleForwarder=F}),define(De[229],Ce([1,0,15,23,21,12,4,7,120,192,42]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(I,L){try{return JSON.stringify(I,L)}catch{return"null"}}const E="$$ref$$",m={[E]:-1};class t{constructor(L,j){this.jsonString=L,this.referencedBuffers=j}}function o(I,L=null,j=!1){const W=[];return{jsonString:(j?g:JSON.stringify)(I,(P,M)=>{if(typeof M>"u")return m;if(typeof M=="object"){if(M instanceof D.VSBuffer){const R=W.push(M)-1;return{[E]:R}}if(L)return L(P,M)}return M}),referencedBuffers:W}}e.stringifyJsonWithBufferRefs=o;function a(I,L,j){return JSON.parse(I,(W,H)=>{if(H){const P=H[E];if(typeof P=="number")return L[P];if(j&&H.$mid===1)return j.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=a;function p(I,L){return JSON.stringify(I,L)}function b(I){return I?(L,j)=>j&&j.$mid===1?I.transformOutgoing(j):j:null}var u;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},c=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class d extends A.Disposable{constructor(L,j=null,W=null){super(),this[w]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=j,this._uriTransformer=W,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,P=O.ProxyIdentifier.count;H<P;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(H=>this._receiveOneMessage(H))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(F.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,y.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:j,sid:W}=L;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,W)),this._proxies[j]}_createProxy(L,j){const W={get:(H,P)=>(typeof P=="string"&&!H[P]&&P.charCodeAt(0)===36&&(H[P]=(...M)=>this._remoteCall(L,P,M)),P===n?j:H[P])};return new Proxy(Object.create(null),W)}set(L,j){return this._locals[L.nid]=j,j}assertRegistered(L){for(let j=0,W=L.length;j<W;j++){const H=L[j];if(!this._locals[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const j=L.byteLength,W=l.read(L,0),H=W.readUInt8(),P=W.readUInt32();switch(H){case 1:case 2:{let{rpcId:M,method:R,args:B}=r.deserializeRequestJSONArgs(W);this._uriTransformer&&(B=(0,y.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(j,P,M,R,B,H===2);break}case 3:case 4:{let{rpcId:M,method:R,args:B}=r.deserializeRequestMixedArgs(W);this._uriTransformer&&(B=(0,y.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(j,P,M,R,B,H===4);break}case 5:{this._logger?.logIncoming(j,P,0,"ack"),this._onDidReceiveAcknowledge(P);break}case 6:{this._receiveCancel(j,P);break}case 7:{this._receiveReply(j,P,void 0);break}case 9:{let M=r.deserializeReplyOKJSON(W);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(j,P,M);break}case 10:{const M=r.deserializeReplyOKJSONWithBuffers(W,this._uriTransformer);this._receiveReply(j,P,M);break}case 8:{const M=r.deserializeReplyOKVSBuffer(W);this._receiveReply(j,P,M);break}case 11:{let M=r.deserializeReplyErrError(W);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(j,P,M);break}case 12:{this._receiveReplyErr(j,P,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,j,W,H,P,M){this._logger?.logIncoming(L,j,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(W)}.${H}(`,P);const R=String(j);let B,x;if(M){const K=new S.CancellationTokenSource;P.push(K.token),B=this._invokeHandler(W,H,P),x=()=>K.cancel()}else B=this._invokeHandler(W,H,P),x=s;this._cancelInvokedHandlers[R]=x;const U=r.serializeAcknowledged(j);this._logger?.logOutgoing(U.byteLength,j,1,"ack"),this._protocol.send(U),B.then(K=>{delete this._cancelInvokedHandlers[R];const te=r.serializeReplyOK(j,K,this._uriReplacer);this._logger?.logOutgoing(te.byteLength,j,1,"reply:",K),this._protocol.send(te)},K=>{delete this._cancelInvokedHandlers[R];const te=r.serializeReplyErr(j,K);this._logger?.logOutgoing(te.byteLength,j,1,"replyErr:",K),this._protocol.send(te)})}_receiveCancel(L,j){this._logger?.logIncoming(L,j,1,"receiveCancel");const W=String(j);this._cancelInvokedHandlers[W]?.()}_receiveReply(L,j,W){this._logger?.logIncoming(L,j,0,"receiveReply:",W);const H=String(j);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const P=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],P.resolveOk(W)}_receiveReplyErr(L,j,W){this._logger?.logIncoming(L,j,0,"receiveReplyErr:",W);const H=String(j);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const P=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let M;W&&(W.$isError?(M=new Error,M.name=W.name,M.message=W.message,M.stack=W.stack):M=W),P.resolveErr(M)}_invokeHandler(L,j,W){try{return Promise.resolve(this._doInvokeHandler(L,j,W))}catch(H){return Promise.reject(H)}}_doInvokeHandler(L,j,W){const H=this._locals[L];if(!H)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(L));const P=H[j];if(typeof P!="function")throw new Error("Unknown method "+j+" on actor "+(0,O.getStringIdentifierForProxy)(L));return P.apply(H,W)}_remoteCall(L,j,W){if(this._isDisposed)return new k.CanceledLazyPromise;let H=null;if(W.length>0&&S.CancellationToken.isCancellationToken(W[W.length-1])&&(H=W.pop()),H&&H.isCancellationRequested)return Promise.reject(F.canceled());const P=r.serializeRequestArguments(W,this._uriReplacer),M=++this._lastMessageId,R=String(M),B=new k.LazyPromise;H&&H.onCancellationRequested(()=>{const U=r.serializeCancel(M);this._logger?.logOutgoing(U.byteLength,M,0,"cancel"),this._protocol.send(r.serializeCancel(M))}),this._pendingRPCReplies[R]=B,this._onWillSendRequest(M);const x=r.serializeRequest(M,L,j,P,!!H);return this._logger?.logOutgoing(x.byteLength,M,0,`request: ${(0,O.getStringIdentifierForProxy)(L)}.${j}(`,W),this._protocol.send(x),B}}e.RPCProtocol=d,w=c,d.UNRESPONSIVE_TIME=3*1e3;class l{static alloc(L,j,W){const H=new l(D.VSBuffer.alloc(W+1+4),0);return H.writeUInt8(L),H.writeUInt32(j),H}static read(L,j){return new l(L,j)}get buffer(){return this._buff}constructor(L,j){this._buff=L,this._offset=j}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const W=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,W}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,W}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,j}static sizeMixedArray(L){let j=0;j+=1;for(let W=0,H=L.length;W<H;W++){const P=L[W];switch(j+=1,P.type){case 1:j+=this.sizeLongString(P.value);break;case 2:j+=this.sizeVSBuffer(P.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(P.value);for(let M=0;M<P.buffers.length;++M)j+=this.sizeVSBuffer(P.buffers[M]);break;case 4:break}}return j}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let j=0,W=L.length;j<W;j++){const H=L[j];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let P=0;P<H.buffers.length;++P)this.writeBuffer(H.buffers[P]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(L);for(let W=0;W<L;W++)switch(this.readUInt8()){case 1:j[W]=this.readLongString();break;case 2:j[W]=this.readVSBuffer();break;case 3:{const P=this.readUInt32(),M=this.readLongString(),R=[];for(let B=0;B<P;++B)R.push(this.readVSBuffer());j[W]=new O.SerializableObjectWithBuffers(a(M,R,null));break}case 4:j[W]=void 0;break}return j}}l.sizeUInt32=4;var f;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(f||(f={}));class r{static _useMixedArgSerialization(L){for(let j=0,W=L.length;j<W;j++)if(L[j]instanceof D.VSBuffer||L[j]instanceof O.SerializableObjectWithBuffers||typeof L[j]>"u")return!0;return!1}static serializeRequestArguments(L,j){if(this._useMixedArgSerialization(L)){const W=[];for(let H=0,P=L.length;H<P;H++){const M=L[H];if(M instanceof D.VSBuffer)W[H]={type:2,value:M};else if(typeof M>"u")W[H]={type:4};else if(M instanceof O.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:B}=o(M.value,j);W[H]={type:3,value:D.VSBuffer.fromString(R),buffers:B}}else W[H]={type:1,value:D.VSBuffer.fromString(p(M,j))}}return{type:1,args:W}}return{type:0,args:p(L,j)}}static serializeRequest(L,j,W,H,P){switch(H.type){case 0:return this._requestJSONArgs(L,j,W,H.args,P);case 1:return this._requestMixedArgs(L,j,W,H.args,P)}}static _requestJSONArgs(L,j,W,H,P){const M=D.VSBuffer.fromString(W),R=D.VSBuffer.fromString(H);let B=0;B+=l.sizeUInt8(),B+=l.sizeShortString(M),B+=l.sizeLongString(R);const x=l.alloc(P?2:1,L,B);return x.writeUInt8(j),x.writeShortString(M),x.writeLongString(R),x.buffer}static deserializeRequestJSONArgs(L){const j=L.readUInt8(),W=L.readShortString(),H=L.readLongString();return{rpcId:j,method:W,args:JSON.parse(H)}}static _requestMixedArgs(L,j,W,H,P){const M=D.VSBuffer.fromString(W);let R=0;R+=l.sizeUInt8(),R+=l.sizeShortString(M),R+=l.sizeMixedArray(H);const B=l.alloc(P?4:3,L,R);return B.writeUInt8(j),B.writeShortString(M),B.writeMixedArray(H),B.buffer}static deserializeRequestMixedArgs(L){const j=L.readUInt8(),W=L.readShortString(),H=L.readMixedArray(),P=new Array(H.length);for(let M=0,R=H.length;M<R;M++){const B=H[M];typeof B=="string"?P[M]=JSON.parse(B):P[M]=B}return{rpcId:j,method:W,args:P}}static serializeAcknowledged(L){return l.alloc(5,L,0).buffer}static serializeCancel(L){return l.alloc(6,L,0).buffer}static serializeReplyOK(L,j,W){if(typeof j>"u")return this._serializeReplyOKEmpty(L);if(j instanceof D.VSBuffer)return this._serializeReplyOKVSBuffer(L,j);if(j instanceof O.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:P}=o(j.value,W,!0);return this._serializeReplyOKJSONWithBuffers(L,H,P)}else return this._serializeReplyOKJSON(L,g(j,W))}static _serializeReplyOKEmpty(L){return l.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,j){let W=0;W+=l.sizeVSBuffer(j);const H=l.alloc(8,L,W);return H.writeVSBuffer(j),H.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,j){const W=D.VSBuffer.fromString(j);let H=0;H+=l.sizeLongString(W);const P=l.alloc(9,L,H);return P.writeLongString(W),P.buffer}static _serializeReplyOKJSONWithBuffers(L,j,W){const H=D.VSBuffer.fromString(j);let P=0;P+=l.sizeUInt32,P+=l.sizeLongString(H);for(const R of W)P+=l.sizeVSBuffer(R);const M=l.alloc(10,L,P);M.writeUInt32(W.length),M.writeLongString(H);for(const R of W)M.writeBuffer(R);return M.buffer}static deserializeReplyOKJSON(L){const j=L.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(L,j){const W=L.readUInt32(),H=L.readLongString(),P=[];for(let M=0;M<W;++M)P.push(L.readVSBuffer());return new O.SerializableObjectWithBuffers(a(H,P,j))}static serializeReplyErr(L,j){const W=j?g(F.transformErrorForSerialization(j),null):void 0;if(typeof W!="string")return this._serializeReplyErrEmpty(L);const H=D.VSBuffer.fromString(W);let P=0;P+=l.sizeLongString(H);const M=l.alloc(11,L,P);return M.writeLongString(H),M.buffer}static deserializeReplyErrError(L){const j=L.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(L){return l.alloc(12,L,0).buffer}}var h;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var v;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(v||(v={}))}),define(De[230],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(F){const _=A=>{self.removeEventListener("message",_);const y=A.data;Object.defineProperties(self,{postMessage:{value(k,O){y.postMessage(k,O)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};self.addEventListener("message",_)}.toString();class D extends EventTarget{constructor(F,_,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${_}'))`,k=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(k),w=new MessageChannel,g=O,E={type:"_newWorker",id:g,port:w.port2,url:O,options:A};F(E,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{F({type:"_terminateWorker",id:g}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(m){w.port1.onmessage=m}},onmessageerror:{get(){return w.port1.onmessageerror},set(m){w.port1.onmessageerror=m}}}),w.port1.addEventListener("messageerror",m=>{const t=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(t)}),w.port1.addEventListener("message",m=>{const t=new MessageEvent("message",{data:m.data});this.dispatchEvent(t)}),w.port1.start()}}e.NestedWorker=D}),define(De[231],Ce([1,0,4,30,40,3,35,12,15]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new i.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new i.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(t=>m.push(t)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}D.Registry.add(e.Extensions.OutputChannels,new O);function w(E,m,t,o,a){return(0,y.createCancelablePromise)(async p=>{await(0,_.whenProviderRegistered)(t,o);const b=D.Registry.as(e.Extensions.OutputChannels);try{await g(t,1,o,a,p),b.registerChannel({id:E,label:m,file:t,log:!0})}catch(u){(0,A.isCancellationError)(u)||a.error("Error while registering log channel",t.toString(),(0,A.getErrorMessage)(u))}})}e.registerLogChannel=w;async function g(E,m,t,o,a){if(!await t.exists(E)){if(a.isCancellationRequested)throw new A.CancellationError;if(m>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",E.toString()),await(0,y.timeout)(1e3,a),await g(E,m+1,t,o,a)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new S.RawContextKey("activeOutputChannel","")}),define(De[100],Ce([1,0,5,3,14,25,11,231,55,26,36,113,23,9,35,4,7,27]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class p extends _.AbstractMessageLogger{get disposed(){return this._disposed}constructor(s,c,n,d,l){super(),this.id=s,this.name=c,this.logger=n,this.proxy=d,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this._register(n.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.logger.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const s=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,s)}replace(s){const c=this.offset;this.info(s),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,c),this.visible&&this.logger.flush()}show(s,c){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof s=="boolean"?s:c))}hide(){this.proxy.$close(this.id)}log(s,c){this.offset+=g.VSBuffer.fromString(c).byteLength,(0,_.log)(this.logger,s,c)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class b extends p{appendLine(s){this.append(s)}}let u=class{constructor(s,c,n,d,l,f){this.initData=c,this.extHostFileSystem=n,this.extHostFileSystemInfo=d,this.loggerService=l,this.logService=f,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=s.getProxy(i.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(c.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.visibleChannelId=s;for(const[c,n]of this.channels)n.visible=c===this.visibleChannelId}createOutputChannel(s,c,n){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof c=="object"&&c.log;d&&(0,a.checkProposedApiEnabled)(n,"extensionLog");const l=(0,E.isString)(c)?c:void 0;if((0,E.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");const f=this.getDefaultLogLevel(n),r=d?this.doCreateLogOutputChannel(s,f,n):this.doCreateOutputChannel(s,l,n);return r.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),d?this.createExtHostLogOutputChannel(s,f,r):this.createExtHostOutputChannel(s,r)}async doCreateOutputChannel(s,c,n){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const d=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(d,`${this.namePool++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),r=await this.proxy.$register(s,l,!1,c,n.identifier.value);return new p(r,s,f,this.proxy,n)}async doCreateLogOutputChannel(s,c,n){const d=await this.createExtensionLogDirectory(n),l=this.extHostFileSystemInfo.extUri.joinPath(d,`${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(l,{name:s},c),r=await this.proxy.$register(s,l,!0,void 0,n.identifier.value);return new b(r,s,f,this.proxy,n)}getDefaultLogLevel(s){let c;const n=this.initData.environment.extensionLogLevel?.find(([d])=>F.ExtensionIdentifier.equals(s.identifier,d))?.[1];return n&&(c=(0,_.parseLogLevel)(n)),c??this.logService.getLevel()}createExtensionLogDirectory(s){let c=this.extensionLogDirectoryPromise.get(s.identifier.value);if(!c){const n=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,s.identifier.value);this.extensionLogDirectoryPromise.set(s.identifier.value,c=(async()=>{try{await this.extHostFileSystem.value.createDirectory(n)}catch(d){if((0,m.toFileSystemProviderErrorCode)(d)!==m.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return c}createExtHostOutputChannel(s,c){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),c.then(f=>f.append(l))},appendLine(l){d(),c.then(f=>f.appendLine(l))},clear(){d(),c.then(l=>l.clear())},replace(l){d(),c.then(f=>f.replace(l))},show(l,f){d(),c.then(r=>r.show(l,f))},hide(){d(),c.then(l=>l.hide())},dispose(){n=!0,c.then(l=>l.dispose())}}}createExtHostLogOutputChannel(s,c,n){const d=new o.DisposableStore,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},f=d.add(new t.Emitter);return n.then(r=>{d.add(r),d.add(r.onDidChangeLogLevel(h=>{c=h,f.fire(h)}))}),{...this.createExtHostOutputChannel(s,n),get logLevel(){return c},onDidChangeLogLevel:f.event,trace(r,...h){l(),n.then(v=>v.trace(r,...h))},debug(r,...h){l(),n.then(v=>v.debug(r,...h))},info(r,...h){l(),n.then(v=>v.info(r,...h))},warn(r,...h){l(),n.then(v=>v.warn(r,...h))},error(r,...h){l(),n.then(v=>v.error(r,...h))},dispose(){d.dispose()}}}};u=xe([We(0,S.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,O.IExtHostFileSystemInfo),We(4,_.ILoggerService),We(5,_.ILogService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(De[232],Ce([1,0,3]),function(ne,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(De[233],Ce([1,0,39,13,19,20,22,2,3,163,49,178,232]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let E=class tn{constructor(t,o,a,p){this.localUserHome=t,this.remoteAgentService=o,this.environmentService=a,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||F.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome??t})()}hasValidBasename(t,o,a){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(p=>this.doHasValidBasename(t,p,o)):this.doHasValidBasename(t,o,a)}doHasValidBasename(t,o,a){return t.scheme===D.Schemas.file||t.scheme===D.Schemas.vscodeRemote?(0,i.isValidBasename)(a??(0,_.basename)(t),o===1):!0}get defaultUriScheme(){return tn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,o){if(t.remoteAuthority)return D.Schemas.vscodeRemote;const a=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(a)return a;const p=o.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=o.getWorkspace().configuration;return b?b.scheme:D.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?S.win32:S.posix)}async fileURI(t){let o="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const p=t.indexOf("/",2);p===-1?(o=t.substring(2),t="/"):(o=t.substring(2,p),t=t.substring(p)||"/")}return A.URI.from({scheme:D.Schemas.file,authority:o,path:t,query:"",fragment:""})}};E=xe([We(1,g.IRemoteAgentService),We(2,w.IWorkbenchEnvironmentService),We(3,O.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(De[101],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(_,A){this.line=_,this.character=A}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,A){return new i(0,0)}with(_){return new i(0,0)}}e.Position=i;class D{constructor(_,A,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(_,A),this.end=new i(y,k)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new D(0,0,0,0)}with(_){return new D(0,0,0,0)}}e.Range=D;var S;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[43],Ce([1,0,18,34,24,39,10,3,19,12,101,15]),function(ne,e,i,D,S,F,_,A,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",E=" characters skipped \u27EB",m=(g.length+E.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var t;(function(re){re[re.file=0]="file",re[re.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(re){re[re.File=1]="File",re[re.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function a(re){return!!re.preview}e.resultIsMatch=a;function p(re){return!!re.resource}e.isFileMatch=p;function b(re){return!!re.message}e.isProgressMessage=b;var u;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(be){this.resource=be,this.results=[]}}e.FileMatch=C;class s{constructor(be,le,fe){this.ranges=le;const Q=Array.isArray(le)?le:[le];if(fe&&fe.matchLines===1&&c(Q)){be=(0,_.getNLines)(be,fe.matchLines);let pe="",Se=0,Fe=0;const Ue=Math.floor(fe.charsPerLine/5),Xe=[];for(const ke of Q){const ye=Math.max(ke.startColumn-Ue,0),Ie=ke.startColumn+fe.charsPerLine;if(ye>Fe+Ue+m){const ae=g+(ye-Fe)+E;pe+=ae+be.slice(ye,Ie),Se+=ye-(Fe+ae.length)}else pe+=be.slice(Fe,Ie);Xe.push(new d(0,ke.startColumn-Se,ke.endColumn-Se)),Fe=Ie}this.preview={text:pe,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const pe=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:be,matches:(0,i.mapArrayOrNot)(le,Se=>new n(Se.startLineNumber-pe,Se.startColumn,Se.endLineNumber-pe,Se.endColumn))}}}}e.TextSearchMatch=s;function c(re){const be=re[0].startLineNumber;for(const le of re)if(le.startLineNumber!==be||le.endLineNumber!==be)return!1;return!0}class n{constructor(be,le,fe,Q){this.startLineNumber=be,this.startColumn=le,this.endLineNumber=fe,this.endColumn=Q}}e.SearchRange=n;class d extends n{constructor(be,le,fe){super(be,le,be,fe)}}e.OneLineRange=d;var l;(function(re){re.List="list",re.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var f;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function r(re,be=!0){const le=re&&re.files&&re.files.exclude,fe=be&&re&&re.search&&re.search.exclude;if(!le&&!fe)return;if(!le||!fe)return le||fe;let Q=Object.create(null);return Q=S.mixin(Q,S.deepClone(le)),Q=S.mixin(Q,S.deepClone(fe),!0),Q}e.getExcludes=r;function h(re,be){return re.excludePattern&&D.match(re.excludePattern,be)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&D.match(re.includePattern,be)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(le=>{const fe=le.folder.fsPath;if(F.isEqualOrParent(be,fe)){const Q=y.relative(fe,be);return!le.includePattern||!!D.match(le.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var v;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(be,le){super(be),this.code=le}}e.SearchError=I;function L(re){const be=re.message;if((0,k.isCancellationError)(re))return new I(be,v.canceled);try{const le=JSON.parse(be);return new I(le.message,le.code)}catch{return new I(be,v.other)}}e.deserializeSearchError=L;function j(re){const be={message:re.message,code:re.code};return new Error(JSON.stringify(be))}e.serializeSearchError=j;function W(re){return re.type==="error"?!0:re.type==="success"}e.isSerializedSearchComplete=W;function H(re){return re.type==="success"}e.isSerializedSearchSuccess=H;function P(re){return!!re.path}e.isSerializedFileMatch=P;function M(re,be){const le=re.searchPath?re.searchPath:re.relativePath;return(0,_.fuzzyContains)(le,be)}e.isFilePatternMatch=M;class R{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function B(re,be){const le={...re||{},...be||{}};return Object.keys(le).filter(fe=>{const Q=le[fe];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=B;class x{constructor(be,le){this._parsedIncludeExpression=null,this._excludeExpression={...be.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=D.parse(this._excludeExpression);let fe=be.includePattern;le.includePattern&&(fe?fe={...fe,...le.includePattern}:fe=le.includePattern),fe&&(this._parsedIncludeExpression=D.parse(fe))}matchesExcludesSync(be,le,fe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe))}includedInQuerySync(be,le,fe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(be,le,fe))}includedInQuery(be,le,fe){const Q=this._parsedExcludeExpression(be,le,fe),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(be,le,fe):!0;return(0,w.isThenable)(Q)?Q.then(Se=>Se?!1:pe()):pe()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=x;function U(re){for(const be in re)if(typeof re[be]!="boolean")return!0;return!1}function K(re){if(!re)return;let be;return le=>(be||(be=(re()||Promise.resolve([])).then(fe=>fe?de(fe):{})),be.then(fe=>!!fe[le]))}e.hasSiblingPromiseFn=K;function te(re){if(!re)return;let be;return le=>{if(!be){const fe=re();be=fe?de(fe):{}}return!!be[le]}}e.hasSiblingFn=te;function de(re){const be={};for(const le of re)be[le]=!0;return be}}),define(De[31],Ce([1,0,18,15,21,4,7,45,13,108,22,10,9,2,137,3,11,151,49,36,26,14,8,6,50,43,5]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u,C,s,c,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(H,P,M){return new O.ExtUri(R=>I(R,M)).isEqual(H,P)}function r(H,P,M){return f(H.uri,P.uri,M)?0:(0,w.compare)(H.uri.toString(),P.uri.toString())}function h(H,P,M){return H.index!==P.index?H.index<P.index?-1:1:f(H.uri,P.uri,M)?(0,w.compare)(H.name,P.name):(0,w.compare)(H.uri.toString(),P.uri.toString())}function v(H,P,M,R){const B=H.slice(0).sort((U,K)=>M(U,K,R)),x=P.slice(0).sort((U,K)=>M(U,K,R));return(0,i.delta)(B,x,(U,K)=>M(U,K,R))}function I(H,P){const M=P.getCapabilities(H.scheme);return!(M&&M&1024)}class L extends p.Workspace{static toExtHostWorkspace(P,M,R,B){if(!P)return{workspace:null,added:[],removed:[]};const{id:x,name:U,folders:K,configuration:te,transient:de,isUntitled:re}=P,be=[],le=M;M?K.forEach((Se,Fe)=>{const Ue=E.URI.revive(Se.uri),Xe=L._findFolder(R||M,Ue,B);Xe?(Xe.name=Se.name,Xe.index=Se.index,be.push(Xe)):be.push({uri:Ue,name:Se.name,index:Fe})}):be.push(...K.map(({uri:Se,name:Fe,index:Ue})=>({uri:E.URI.revive(Se),name:Fe,index:Ue}))),be.sort((Se,Fe)=>Se.index<Fe.index?-1:1);const fe=new L(x,U,be,!!de,te?E.URI.revive(te):null,!!re,Se=>I(Se,B)),{added:Q,removed:pe}=v(le?le.workspaceFolders:[],fe.workspaceFolders,r,B);return{workspace:fe,added:Q,removed:pe}}static _findFolder(P,M,R){for(let B=0;B<P.folders.length;B++){const x=P.workspaceFolders[B];if(f(x.uri,M,R))return x}}constructor(P,M,R,B,x,U,K){super(P,R.map(te=>new p.WorkspaceFolder(te)),B,x,K),this._name=M,this._isUntitled=U,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(K),R.forEach(te=>{this._workspaceFolders.push(te),this._structure.set(te.uri,te)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(P,M){return M&&this._structure.get(P)&&(P=(0,O.dirname)(P)),this._structure.findSubstr(P)}resolveWorkspaceFolder(P){return this._structure.get(P)}}let j=class{constructor(P,M,R,B,x){this._onDidChangeWorkspace=new F.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new F.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=B,this._extHostFileSystemInfo=R,this._uriTransformerService=x,this._requestIdProvider=new k.Counter,this._barrier=new D.Barrier,this._proxy=P.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=P.getProxy(l.MainContext.MainThreadMessageService);const U=M.workspace;this._confirmedWorkspace=U?new L(U.id,U.name,[],!!U.transient,U.configuration?E.URI.revive(U.configuration):null,!!U.isUntitled,K=>I(K,R)):void 0}$initializeWorkspace(P,M){this._trusted=M,this.$acceptWorkspaceData(P),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(P,M,R,...B){const x=[];if(Array.isArray(B)&&B.forEach(re=>{E.URI.isUri(re.uri)&&!x.some(be=>f(be.uri,re.uri,this._extHostFileSystemInfo))&&x.push({uri:re.uri,name:re.name||(0,O.basenameOrAuthority)(re.uri)})}),this._unconfirmedWorkspace||[M,R].some(re=>typeof re!="number"||re<0)||R===0&&x.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+R>U.length)return!1;const K=U.slice(0);K.splice(M,R,...x.map(re=>({uri:re.uri,name:re.name||(0,O.basenameOrAuthority)(re.uri),index:void 0})));for(let re=0;re<K.length;re++){const be=K[re];if(K.some((le,fe)=>fe!==re&&f(be.uri,le.uri,this._extHostFileSystemInfo)))return!1}K.forEach((re,be)=>re.index=be);const{added:te,removed:de}=v(U,K,h,this._extHostFileSystemInfo);if(te.length===0&&de.length===0)return!1;if(this._proxy){const re=P.displayName||P.name;this._proxy.$updateWorkspaceFolders(re,M,R,x).then(void 0,be=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:P.identifier,label:P.displayName||P.name}};this._messageService.$showMessage(a.Severity.Error,(0,m.localize)(0,null,re,be.toString()),le,[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(P,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,M)}async getWorkspaceFolder2(P,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,M)}async resolveWorkspaceFolder(P){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(P)}getPath(){if(!this._actualWorkspace)return;const{folders:P}=this._actualWorkspace;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,M){let R,B="";if(typeof P=="string"?(R=E.URI.file(P),B=P):typeof P<"u"&&(R=P,B=P.fsPath),!R)return B;const x=this.getWorkspaceFolder(R,!0);if(!x)return B;typeof M>"u"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let U=(0,O.relativePath)(x.uri,R);return M&&x.name&&(U=`${x.name}/${U}`),U}trySetWorkspaceFolders(P){this._actualWorkspace&&(this._unconfirmedWorkspace=L.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:P,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:M,added:R,removed:B}=L.toExtHostWorkspace(P,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:B}))}findFiles(P,M,R,B,x=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let U;if(M===null?U=!1:M&&(typeof M=="string"?U=M:U=M.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:te}=W(s.GlobPattern.from(P));return this._proxy.$startFileSearch((0,g.withUndefinedAsNull)(K),(0,g.withUndefinedAsNull)(te),(0,g.withUndefinedAsNull)(U),(0,g.withUndefinedAsNull)(R),x).then(de=>Array.isArray(de)?de.map(re=>E.URI.revive(re)):[])}async findTextInFiles(P,M,R,B,x=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),K=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:te,folder:de}=W(s.GlobPattern.from(M.include)),re=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,be={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:K,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:te,excludePattern:re},le=!1;if(this._activeSearchCallbacks[U]=fe=>{if(le)return;const Q=E.URI.revive(fe.resource);fe.results.forEach(pe=>{(0,d.resultIsMatch)(pe)?R({uri:Q,preview:{text:pe.preview.text,matches:(0,i.mapArrayOrNot)(pe.preview.matches,Se=>new c.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,i.mapArrayOrNot)(pe.ranges,Se=>new c.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):R({uri:Q,text:pe.text,lineNumber:pe.lineNumber})})},x.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch(P,(0,g.withUndefinedAsNull)(de),be,U,x);return delete this._activeSearchCallbacks[U],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[U],fe}}$handleTextSearchResult(P,M){this._activeSearchCallbacks[M]?.(P)}saveAll(P){return this._proxy.$saveAll(P)}resolveProxy(P){return this._proxy.$resolveProxy(P)}get trusted(){return this._trusted}requestWorkspaceTrust(P){return this._proxy.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(P,M){if(this._editSessionIdentityProviders.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this._editSessionIdentityProviders.set(P,M);const R=this._uriTransformerService.transformOutgoingScheme(P),B=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(B,R),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(P),this._proxy.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(P,M){this._logService.info("Getting edit session identifier for workspaceFolder",P);const R=await this.resolveWorkspaceFolder(E.URI.revive(P));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const B=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!B),!B)return;const x=await B.provideEditSessionIdentity(R,M);if(this._logService.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch(P,M,R,B){this._logService.info("Getting edit session identifier for workspaceFolder",P);const x=await this.resolveWorkspaceFolder(E.URI.revive(P));if(!x){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const U=this._editSessionIdentityProviders.get(x.uri.scheme);if(this._logService.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentityMatch?.(M,R,B);if(this._logService.info("Provider returned edit session identifier match result: ",K),!!K)return K}};j=xe([We(0,C.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,o.ILogService),We(4,n.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function W(H){let P,M;return H&&(typeof H=="string"?P=H:(P=H.pattern,M=E.URI.revive(H.baseUri))),{includePattern:P,folder:M}}}),define(De[32],Ce([1,0,24,4,31,5,6,154,89,9,15,3,14,11,2]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(c,n){if(n){const d=n.split(".");let l=c;for(let f=0;l&&f<d.length;f++)l=l[d[f]];return l}}function o(c){return c instanceof m.URI}function a(c){return c&&c.uri instanceof m.URI&&c.languageId&&typeof c.languageId=="string"}function p(c){return c&&!c.uri&&c.languageId&&typeof c.languageId=="string"}function b(c){return c&&c.uri instanceof m.URI&&(!c.name||typeof c.name=="string")&&(!c.index||typeof c.index=="number")}function u(c){if(o(c))return{resource:c};if(a(c))return{resource:c.uri,overrideIdentifier:c.languageId};if(p(c))return{overrideIdentifier:c.languageId};if(b(c))return{resource:c.uri};if(c===null)return{resource:null}}let C=class{constructor(n,d,l){this._proxy=n.getProxy(F.MainContext.MainThreadConfiguration),this._extHostWorkspace=d,this._logService=l,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new s(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,d){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(n,d))}};C=xe([We(0,g.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,E.ILogService)],C),e.ExtHostConfiguration=C;class s{constructor(n,d,l,f){this._onDidChangeConfiguration=new D.Emitter,this._proxy=n,this._logService=f,this._extHostWorkspace=d,this._configuration=A.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,d){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(d,l))}getConfiguration(n,d,l){const f=u(d)||{},r=this._toReadonlyValue(n?t(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,f,l?.identifier);function h(I){if(I==null)return null;if(typeof I=="boolean")return I?2:5;switch(I){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(I){return typeof t(r,I)<"u"},get:(I,L)=>{this._validateConfigurationAccess(n?`${n}.${I}`:I,f,l?.identifier);let j=t(r,I);if(typeof j>"u")j=L;else{let W;const H=(P,M)=>{let R;const B=()=>{W=W||(0,i.deepClone)(r),R=R||t(W,M)};return(0,k.isObject)(P)?new Proxy(P,{get:(x,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return B(),()=>R;if(W)return R=R||t(W,M),R[U];const K=x[U];return typeof U=="string"?H(K,`${M}.${U}`):K},set:(x,U,K)=>(B(),R&&(R[U]=K),!0),deleteProperty:(x,U)=>(B(),R&&delete R[U],!0),defineProperty:(x,U,K)=>(B(),R&&Object.defineProperty(R,U,K),!0)}):P};j=H(j,I)}return j},update:(I,L,j,W)=>{I=n?`${n}.${I}`:I;const H=h(j);return L!==void 0?this._proxy.$updateConfigurationOption(H,I,L,f,W):this._proxy.$removeConfigurationOption(H,I,f,W)},inspect:I=>{I=n?`${n}.${I}`:I;const L=this._configuration.inspect(I,f,this._extHostWorkspace.workspace);if(L)return{key:I,defaultValue:(0,i.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,i.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,i.deepClone)(L.workspace?.value),workspaceFolderValue:(0,i.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(L.default?.override),globalLanguageValue:(0,i.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,i.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(L.workspaceFolder?.override),languageIds:(0,i.deepClone)(L.overrideIdentifiers)}}};return typeof r=="object"&&(0,i.mixin)(v,r,!1),Object.freeze(v)}_toReadonlyValue(n){const d=l=>(0,k.isObject)(l)?new Proxy(l,{get:(f,r)=>d(f[r]),set:(f,r,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(f,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(f,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return d(n)}_validateConfigurationAccess(n,d,l){const f=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),r=l?`[${l.value}] `:"";if(f===4){typeof d?.resource>"u"&&this._logService.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this._logService.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,d){const l=new A.ConfigurationChangeEvent(n,d,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,r)=>l.affectsConfiguration(f,u(r))})}_toMap(n){return n.reduce((d,l)=>(d.set(l[0],l[1]),d),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[102],Ce([1,0,2,15,4,5,6,31,53,32,21,56,14,26,3,13,20,11,71,191,12]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(M){function R(x){if(x!=null)return x}M.from=R;function B(x){if(x!=null)return x}M.to=B})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var c;(function(M){function R(x){if(x!=null)return x}M.from=R;function B(x){if(x!=null)return x}M.to=B})(c=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(M){function R(x){if(x!=null)return x}M.from=R;function B(x){if(x!=null)return x}M.to=B})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var d;(function(M){function R(U){if(U){const K=U;return K&&!!K.process}else return!1}M.is=R;function B(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=n.from(U.options)),K}M.from=B;function x(U){if(U!=null)return new _.ProcessExecution(U.process,U.args,U.options)}M.to=x})(d=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(M){function R(x){if(x!=null)return x}M.from=R;function B(x){if(x!=null)return x}M.to=B})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(M){function R(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}M.is=R;function B(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=l.from(U.options)),K}M.from=B;function x(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new _.ShellExecution(U.commandLine,U.options):new _.ShellExecution(U.command,U.args?U.args:[],U.options)}M.to=x})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var r;(function(M){function R(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}M.is=R;function B(U){return{customExecution:"customExecution"}}M.from=B;function x(U,K){return K.get(U)}M.to=x})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(M){function R(B,x){let U;return B.scope!==void 0&&typeof B.scope!="number"?U=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===_.TaskScope.Workspace&&x&&x.workspaceFile?U=x.workspaceFile:U=b.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:U}}M.from=R})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(M){function R(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}M.from=R})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var I;(function(M){function R(U,K){if(U==null)return[];const te=[];for(const de of U){const re=B(de,K);re&&te.push(re)}return te}M.fromMany=R;function B(U,K){if(U==null)return;let te;U.execution instanceof _.ProcessExecution?te=d.from(U.execution):U.execution instanceof _.ShellExecution?te=f.from(U.execution):U.execution&&U.execution instanceof _.CustomExecution&&(te=r.from(U.execution));const de=s.from(U.definition);let re;return U.scope?typeof U.scope=="number"?re=U.scope:re=U.scope.uri:re=_.TaskScope.Workspace,!de||!re?void 0:{_id:U._id,definition:de,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:re},execution:te,isBackground:U.isBackground,group:v.from(U.group),presentationOptions:c.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}M.from=B;async function x(U,K,te){if(U==null)return;let de;d.is(U.execution)?de=d.to(U.execution):f.is(U.execution)?de=f.to(U.execution):r.is(U.execution)&&(de=r.to(U._id,te));const re=s.to(U.definition);let be;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?be=U.source.scope:be=await K.resolveWorkspaceFolder(i.URI.revive(U.source.scope)):be=_.TaskScope.Workspace),!re||!be)return;const le=new _.Task(re,be,U.name,U.source.label,de,U.problemMatchers);return U.isBackground!==void 0&&(le.isBackground=U.isBackground),U.group!==void 0&&(le.group=_.TaskGroup.from(U.group._id),le.group&&U.group.isDefault&&(le.group=new _.TaskGroup(le.group.id,le.group.label),U.group.isDefault===!0&&(le.group.isDefault=U.group.isDefault))),U.presentationOptions&&(le.presentationOptions=c.to(U.presentationOptions)),U._id&&(le._id=U._id),U.detail&&(le.detail=U.detail),le}M.to=x})(I=e.TaskDTO||(e.TaskDTO={}));var L;(function(M){function R(x){return x}M.from=R;function B(x){if(!!x)return Object.assign(Object.create(null),x)}M.to=B})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class j{constructor(R,B,x){this._id=B,this._task=x,C.set(this,void 0),Ye(this,C,R,"f")}get task(){return this._task}terminate(){Oe(this,C,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}C=new WeakMap;var W;(function(M){function R(B){return{id:B._id,task:void 0}}M.from=R})(W=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(R,B,x,U,K,te,de,re){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=R.getProxy(F.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=U,this._configurationService=K,this._terminalService=te,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=de,this._deprecationService=re,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(R,B,x){if(!x)return new _.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:B,provider:x,extension:R}),this._proxy.$registerTaskProvider(U,B),new _.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(R,B){this._proxy.$registerTaskSystem(R,B)}fetchTasks(R){return this._proxy.$fetchTasks(L.from(R)).then(async B=>{const x=[];for(const U of B){const K=await I.to(U,this._workspaceProvider,this._providedCustomExecutions2);K&&x.push(K)}return x})}get taskExecutions(){const R=[];return this._taskExecutions.forEach(B=>R.push(B)),R}terminateTask(R){if(!(R instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(R._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(R,B,x){const U=this._providedCustomExecutions2.get(R.id);U&&(this._activeCustomExecutions2.set(R.id,U),this._terminalService.attachPtyToTerminal(B,await U.callback(x))),this._lastStartedTask=R.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(R)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(R){const B=await this.getTaskExecution(R);this._taskExecutionPromises.delete(R.id),this._taskExecutions.delete(R.id),this.customExecutionComplete(R),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(R){const B=await this.getTaskExecution(R.id);this._onDidTaskProcessStarted.fire({execution:B,processId:R.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(R){const B=await this.getTaskExecution(R.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:R.exitCode})}$provideTasks(R,B){const x=this._handlers.get(R);if(!x)return Promise.reject(new Error("no handler found"));const U=[],K=(0,D.asPromise)(()=>x.provider.provideTasks(O.CancellationToken.None)).then(te=>this.provideTasksInternal(B,U,x,te));return new Promise(te=>{K.then(de=>{Promise.all(U).then(()=>{te(de)})})})}async $resolveTask(R,B){const x=this._handlers.get(R);if(!x)return Promise.reject(new Error("no handler found"));if(B.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${x.type}].`);const U=await I.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await x.provider.resolveTask(U,O.CancellationToken.None);if(!K)return;this.checkDeprecation(K,x);const te=I.from(K,x.extension);if(!te)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(te.execution)&&await this.addCustomExecution(te,K,!0),await this.resolveTaskInternal(te)}nextHandle(){return this._handleCounter++}async addCustomExecution(R,B,x){const U=await this._proxy.$createTaskId(R);!x&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,B.execution)),this._providedCustomExecutions2.set(U,B.execution)}async getTaskExecution(R,B){if(typeof R=="string"){const K=this._taskExecutionPromises.get(R);if(!K)throw new u.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return K}const x=this._taskExecutionPromises.get(R.id);if(x)return x;const U=new Promise((K,te)=>{function de(re,be,le){le?K(new j(re,be.id,le)):te("Unexpected: Task does not exist.")}B?de(this,R,B):I.to(R.task,this._workspaceProvider,this._providedCustomExecutions2).then(re=>de(this,R,re))});return this._taskExecutionPromises.set(R.id,U),U.then(K=>(this._taskExecutions.set(R.id,K),K),K=>Promise.reject(K))}checkDeprecation(R,B){R._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(R){this._activeCustomExecutions2.get(R.id)&&this._activeCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.has(R.id)&&this._lastStartedTask!==R.id&&(this._providedCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.delete(R.id));const x=this._notProvidedCustomExecutions.values();let U=x.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=x.next()}};H=xe([We(0,g.IExtHostRpcService),We(1,E.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,w.IExtHostTerminalService),We(6,a.ILogService),We(7,p.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let P=class extends H{constructor(R,B,x,U,K,te,de,re){super(R,B,x,U,K,te,de,re),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(R,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const x=I.from(B,R);if(x===void 0)throw new Error("Task is not valid");if(r.is(x.execution))await this.addCustomExecution(x,B,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),B);return this._proxy.$executeTask(x).catch(K=>{throw new Error(K)}),U}provideTasksInternal(R,B,x,U){const K=[];if(U)for(const te of U){this.checkDeprecation(te,x),(!te.definition||!R[te.definition.type])&&this._logService.warn(`The task [${te.source}, ${te.name}] uses an undefined task type. The task will be ignored in the future.`);const de=I.from(te,x.extension);de&&r.is(de.execution)?(K.push(de),B.push(this.addCustomExecution(de,te,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:x.extension}}async resolveTaskInternal(R){if(r.is(R.execution))return R;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(R,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,B,x){}};P=xe([We(0,g.IExtHostRpcService),We(1,E.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,w.IExtHostTerminalService),We(6,a.ILogService),We(7,p.IExtHostApiDeprecationService)],P),e.WorkerExtHostTask=P,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(De[234],Ce([1,0,19,21,44,34,22,209,43]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(g,E,m){this.config=g,this.provider=E,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&F.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&F.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const E=this.config.folderQueries||[];return new Promise((m,t)=>{const o=a=>{this.resultCount++,g(a)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(a=>{const p=a.toString(),b=i.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,b)||this.matchFile(o,{base:a,basename:b})}),Promise.all(E.map(a=>this.searchInFolder(a,o))).then(a=>{m({limitHit:this.isLimitHit,stats:a[0]||void 0})},a=>{t(new Error((0,S.toErrorMessage)(a)))})})}async searchInFolder(g,E){const m=new D.CancellationTokenSource,t=this.getSearchOptionsForFolder(g),o=this.initDirectoryTree(),a=new y.QueryGlobTester(this.config,g),p=!a.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(m),b=A.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},t,m.token),C=b.elapsed(),s=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(c=>{const n=i.posix.relative(g.folder.path,c.path);if(p){const d=i.basename(c.path);this.matchFile(E,{base:g.folder,relativePath:n,basename:d});return}this.addDirectoryEntries(o,g.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,a,E),{providerTime:C,postProcessTime:s.elapsed()})}finally{m.dispose(),this.activeCancellationTokens.delete(m)}}getSearchOptionsForFolder(g){const E=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),m=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:m,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},E,m,t){if(m===this.filePattern){const a=i.basename(this.filePattern);this.matchFile(t,{base:E,relativePath:this.filePattern,basename:a})}function o(a){const p=i.basename(a),b=i.dirname(a);let u=g[b];u||(u=g[b]=[],o(b)),u.push({base:E,relativePath:a,basename:p})}o(m)}matchDirectoryTree({rootEntries:g,pathToEntries:E},m,t){const o=this,a=this.filePattern;function p(b){const u=(0,y.hasSiblingFn)(()=>b.map(C=>C.basename));for(let C=0,s=b.length;C<s;C++){const c=b[C],{relativePath:n,basename:d}=c;if(m.matchesExcludesSync(n,d,a!==d?u:void 0))continue;const l=E[n];if(l)p(l);else{if(n===a)continue;o.matchFile(t,c)}if(o.isLimitHit)break}}p(g)}matchFile(g,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(E))}}class O{constructor(){this.sessions=new Map}fileSearch(g,E,m,t){const o=this.getSessionTokenSource(g.cacheKey),a=new k(g,E,o&&o.token);let p=0;const b=u=>{p+=u.length,m(u.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(a,O.BATCH_SIZE,b,t).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:u.stats}}))}clearCache(g){this.getSessionTokenSource(g)?.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new D.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:_.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,E,m,t){t.onCancellationRequested(()=>{g.cancel()});const o=p=>{p&&(a.push(p),E>0&&a.length>=E&&(m(a),a=[]))};let a=[];return g.search(o).then(p=>(a.length&&m(a),p),p=>(a.length&&m(a),Promise.reject(p)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(De[235],Ce([1,0,18,77,34,82,28,13,19,22,10,9,2,251,145,46,11,49,93,233,43]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let C=class{constructor(v,I,L,j,W){this.configurationService=v,this.workspaceContextService=I,this.editorGroupsService=L,this.logService=j,this.pathService=W}text(v,I,L={}){v=this.getContentPattern(v,L);const j=this.configurationService.getValue(),W=I&&I.some(P=>!this.configurationService.getValue({resource:P}).search.useRipgrep);return{...this.commonQuery(I?.map(a.toWorkspaceFolder),L),type:2,contentPattern:v,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:j.search.usePCRE2||W||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(v,I){const L=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const j={...v,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(v,I)&&(j.isCaseSensitive=!0),this.isMultiline(v)&&(j.isMultiline=!0),j}file(v,I={}){return{...this.commonQuery(v,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}handleIncludeExclude(v,I){return v?(v=Array.isArray(v)?v.map(l):l(v),I?this.parseSearchPaths(v):{pattern:c(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],I={}){const L=this.handleIncludeExclude(I.includePattern,I.expandPatterns),j=this.handleIncludeExclude(I.excludePattern,I.expandPatterns),W=v.length>1,H=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,I,j)):v.map(R=>this.getFolderQueryForRoot(R,I,j,W))).filter(R=>!!R),P={_reason:I._reason,folderQueries:H,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:j.pattern,includePattern:L.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const R=i.coalesce(i.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(K=>K.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const B=R.filter(U=>(0,u.pathIncludedInQuery)(P,U.fsPath)),x=this.commonQueryFromFileList(B);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...P,...x}}const M=I.extraFileResources&&I.extraFileResources.filter(R=>(0,u.pathIncludedInQuery)(P,R.fsPath));return P.extraFileResources=M&&M.length?M:void 0,P}commonQueryFromFileList(v){const I=[],L=new _.ResourceMap,j={};let W=!1;return v.forEach(H=>{if(H.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(H)){const M=this.workspaceContextService.getWorkspaceFolder(H)?.uri??H.with({path:y.dirname(H.fsPath)});let R=L.get(M);R||(W=!0,R={folder:M,includePattern:{}},I.push(R),L.set(M,R));const B=y.relative(M.fsPath,H.fsPath);(0,w.assertIsDefined)(R.includePattern)[B.replace(/\\/g,"/")]=!0}else H.fsPath&&(W=!0,j[H.fsPath]=!0)}),{folderQueries:I,includePattern:j,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}isCaseSensitive(v,I){if(I.isSmartCase){if(v.isRegExp){if(O.containsUppercaseCharacter(v.pattern,!0))return!0}else if(O.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,E.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const I=x=>y.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),j=(Array.isArray(v)?v:n(v)).map(x=>{const U=this.pathService.resolvedUserHome;return U?(0,F.untildify)(x,U.scheme===A.Schemas.file?U.fsPath:U.path):x}),W=D.groupBy(j,x=>I(x)?"searchPaths":"exprSegments"),H=(W.exprSegments||[]).map(x=>O.rtrim(x,"/")).map(x=>O.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),d(x))),P={},M=this.expandSearchPathPatterns(W.searchPaths||[]);M&&M.length&&(P.searchPaths=M);const R=i.flatten(H),B=c(...R);return B&&(P.pattern=B),P}getExcludesForFolder(v,I){return I.disregardExcludeSettings?void 0:(0,u.getExcludes)(v,!I.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const I=i.flatten(v.map(j=>{let{pathPortion:W,globPortion:H}=s(j);H&&(H=f(H));const P=this.expandOneSearchPath(W);return i.flatten(P.map(M=>this.resolveOneSearchPathPattern(M,H)))})),L=new Map;return I.forEach(j=>{const W=j.searchPath.toString(),H=L.get(W);H?j.pattern&&(H.pattern=H.pattern||{},H.pattern[j.pattern]=!0):L.set(W,{searchPath:j.searchPath,pattern:j.pattern?c(j.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(v){if(y.isAbsolute(v)){const I=this.workspaceContextService.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==A.Schemas.file?[{searchPath:I[0].uri.with({path:v})}]:[{searchPath:g.URI.file(y.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const I=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=l(v),v.startsWith("../")||v===".."){const j=y.posix.resolve(I.path,v);return[{searchPath:I.with({path:j})}]}const L=f(v);return[{searchPath:I,pattern:L}]}else{if(v==="./"||v===".\\")return[];{const I=v.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(W=>{const H=I.match(new RegExp(`^${O.escapeRegExpCharacters(W.name)}(?:/(.*)|$)`));return H?{match:H,folder:W}:null}).filter(w.isDefined);if(j.length)return j.map(W=>{const H=W.match[1];return{searchPath:W.folder.uri,pattern:H&&f(H)}});{const W=v.match(/\.[\/\\](.+)[\/\\]?/),H=W?W[1]:v,P=m.localize(0,null,H);throw new Error(P)}}}}resolveOneSearchPathPattern(v,I){const L=v.pattern&&I?`${v.pattern}/${I}`:v.pattern||I,j=[{searchPath:v.searchPath,pattern:L}];return L&&!L.endsWith("**")&&j.push({searchPath:v.searchPath,pattern:L+"/**"}),j}getFolderQueryForSearchPath(v,I,L){const j=this.getFolderQueryForRoot((0,a.toWorkspaceFolder)(v.searchPath),I,L,!1);return j?{...j,includePattern:v.pattern}:null}getFolderQueryForRoot(v,I,L,j){let W;const H=g.URI.isUri(v)?v:v.uri;if(L.searchPaths){const x=L.searchPaths.filter(U=>(0,k.isEqual)(U.searchPath,H))[0];if(x&&!x.pattern)return null;x&&(W=x.pattern)}const P=this.configurationService.getValue({resource:H}),R={...this.getExcludesForFolder(P,I)||{},...W||{}},B=g.URI.isUri(v)?(0,k.basename)(v):v.name;return{folder:H,folderName:j?B:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:P.files&&P.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!P.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!P.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!P.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!P.search.followSymlinks}}};C=xe([We(0,t.IConfigurationService),We(1,a.IWorkspaceContextService),We(2,p.IEditorGroupsService),We(3,o.ILogService),We(4,b.IPathService)],C),e.QueryBuilder=C;function s(h){const v=h.match(/[\*\{\}\(\)\[\]\?]/);if(v){const I=v.index,L=h.substr(0,I).match(/[/|\\][^/\\]*$/);if(L){let j=h.substr(0,L.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((L.index||0)+1)}}}return{pathPortion:h}}function c(...h){return h.length?h.reduce((v,I)=>(v[I]=!0,v),Object.create(null)):void 0}function n(h){return S.splitGlobAware(h,",").map(v=>v.trim()).filter(v=>!!v.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function l(h){return h.replace(/\\/g,"/")}function f(h){return l(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(h,v){h=i.distinct(h,j=>j.toString());const I=[],L=v.getWorkspace();return h&&h.forEach(j=>{let W;if(v.getWorkbenchState()===2)W=(0,k.relativePath)(L.folders[0].uri,j),W&&W!=="."&&(W="./"+W);else{const H=v.getWorkspaceFolder(j);if(H){const P=H.name;if(L.folders.filter(R=>R.name===P).length===1){const R=(0,k.relativePath)(H.uri,j);R===""?W=`./${H.name}`:W=`./${H.name}/${R}`}else W=j.fsPath}}W&&I.push(W)}),I}e.resolveResourcesForSearchIncludes=r}),define(De[236],Ce([1,0,22,2,21,12,3,235,43,49]),function(ne,e,i,D,S,F,_,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(t,o){const a=o.activationEvents;if(!a)return Promise.resolve(void 0);const p=[],b=[];for(const d of a)if(/^workspaceContains:/.test(d)){const l=d.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||t.forceUsingSearch?b.push(l):p.push(l)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let u;const C=new Promise((d,l)=>{u=d}),s=d=>u({activationEvent:d}),c=Promise.all(p.map(d=>g(t,d,s))).then(()=>{}),n=E(t,o.identifier,b,s);return Promise.all([c,n]).then(()=>{u(void 0)}),C}e.checkActivateWorkspaceContainsExtension=w;async function g(t,o,a){for(const p of t.folders)if(await t.exists(i.joinPath(D.URI.revive(p),o))){a(`workspaceContains:${o}`);return}}async function E(t,o,a,p){if(a.length===0)return Promise.resolve(void 0);const b=new S.CancellationTokenSource,u=t.checkExists(t.folders,a,b.token),C=setTimeout(async()=>{b.cancel(),t.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},O);let s=!1;try{s=await u}catch(c){F.isCancellationError(c)||F.onUnexpectedError(c)}b.dispose(),clearTimeout(C),s&&p(`workspaceContains:${a.join(",")}`)}function m(t,o,a,p){const b=t.get(_.IInstantiationService),u=t.get(y.ISearchService),s=b.createInstance(A.QueryBuilder).file(o.map(c=>(0,k.toWorkspaceFolder)(D.URI.revive(c))),{_reason:"checkExists",includePattern:a,exists:!0});return u.fileSearch(s,p).then(c=>!!c.limitHit,c=>F.isCancellationError(c)?!1:Promise.reject(c))}e.checkGlobFileExists=m});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,i,D,S){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?S.call(ne,i):S?S.value=i:e.set(ne,i),i},Oe=this&&this.__classPrivateFieldGet||function(ne,e,i,D){if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?D:i==="a"?D.call(ne):D?D.value:e.get(ne)};define(De[33],Ce([1,0,132,19,76,22,15,7,45,2,11,5,32,180,74,31,27,179,12,25,23,164,6,90,3,26,75,14,60,64,56,4,236,73,166,13,72]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u,C,s,c,n,d,l,f,r,h,v,I,L,j,W,H,P){"use strict";var M,R,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let x=class Oi extends A.Disposable{constructor(le,fe,Q,pe,Se,Fe,Ue,Xe,ke,ye,Ie){super(),this._onDidChangeRemoteConnectionData=this._register(new I.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=fe,this._extHostContext=Q,this._initData=Ue,this._extHostWorkspace=pe,this._extHostConfiguration=Se,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new a.ExtensionDescriptionRegistry(this._initData.allExtensions);const ae=(0,o.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new a.ExtensionDescriptionRegistry(te(this._globalRegistry,ae)),this._storage=new m.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=le.createChild(new r.ServiceCollection([m.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let ue=[],ee=[];this._initData.remote.isRemote&&(ue=this._initData.allExtensions.filter(T=>!T.main&&!T.browser).map(T=>T.identifier),ee=this._initData.allExtensions.filter(T=>!ae.has(b.ExtensionIdentifier.toKey(T.identifier.value))).filter(T=>(T.main||T.browser)&&T.api==="none").map(T=>T.identifier));const Z=(0,o.extensionIdentifiersArrayToSet)(ee);this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,ue,ee,{onExtensionActivationError:(T,z,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(T,p.transformErrorForSerialization(z),V)},actualActivateExtension:async(T,z)=>{if(Z.has(b.ExtensionIdentifier.toKey(T)))return await this._mainThreadExtensionsProxy.$activateExtension(T,z),new E.HostExtension;const V=this._myRegistry.getExtensionDescription(T);return this._activateExtension(V,z)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(le){p.onUnexpectedError(le)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let le=[];try{le=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(le)}terminate(le,fe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${le}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),p.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const Q=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),Q]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${fe}`):this._logService.info(`Extension host exiting with code ${fe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(fe)})}isActivated(le){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(le):!1}async getExtension(le){const fe=await this._mainThreadExtensionsProxy.$getExtension(le);let Q;if(fe?.browserNlsBundleUris){Q={};for(const pe of Object.keys(fe.browserNlsBundleUris))Q[pe]=k.URI.revive(fe.browserNlsBundleUris[pe])}return fe&&{...fe,identifier:new b.ExtensionIdentifier(fe.identifier.value),extensionLocation:k.URI.revive(fe.extensionLocation),browserNlsBundleUris:Q}}_activateByEvent(le,fe){return this._activator.activateByEvent(le,fe)}_activateById(le,fe){return this._activator.activateById(le,fe)}activateByIdWithErrors(le,fe){return this._activateById(le,fe).then(()=>{const Q=this._activator.getActivatedExtension(le);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(le=>this._myRegistry)}getExtensionExports(le){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(le).exports:null}async _realPathExtensionUri(le){if(le.scheme!==H.Schemas.file)return le;const fe=await this._hostUtils.realpath(le.fsPath);return k.URI.file(fe)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(le=>new re(le))),this._extensionPathIndex}async _createExtensionPathIndex(le){const fe=y.TernarySearchTree.forUris(Q=>F.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(le.map(async Q=>{if(this._getEntryPoint(Q)){const pe=await this._realPathExtensionUri(Q.extensionLocation);fe.set(pe,Q)}})),fe}_deactivate(le){let fe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(le))return fe;const Q=this._activator.getActivatedExtension(le);if(!Q)return fe;try{typeof Q.module.deactivate=="function"&&(fe=Promise.resolve(Q.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${le.value}':`),this._logService.error(pe)}try{(0,A.dispose)(Q.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this._logService.error(pe)}return fe}async _activateExtension(le,fe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier),this._doActivateExtension(le,fe).then(Q=>{const pe=Q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(le.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,fe),this._logExtensionActivationTimes(le,fe,"success",pe),Q},Q=>{throw this._logExtensionActivationTimes(le,fe,"failure"),Q})}_logExtensionActivationTimes(le,fe,Q,pe){const Se=U(le,fe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...pe||{},outcome:Q})}_doActivateExtension(le,fe){const Q=U(le,fe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Q);const pe=this._getEntryPoint(le);if(!pe)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${le.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this._logService.flush();const Se=new E.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this._loadCommonJSModule(le,(0,F.joinPath)(le.extensionLocation,pe),Se),this._loadExtensionContext(le)]).then(Fe=>(S.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),Oi._callActivate(this._logService,le.identifier,Fe[0],Fe[1],Se))).then(Fe=>(S.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),Fe))}_loadExtensionContext(le){const fe=new C.ExtensionGlobalMemento(le,this._storage),Q=new C.ExtensionMemento(le.identifier.value,!1,this._storage),pe=new W.ExtensionSecrets(le,this._secretState),Se=le.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Fe=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([fe.whenReady,Q.whenReady,this._storagePath.whenReady]).then(()=>{const Ue=this;let Xe,ke;const ye=(0,o.isProposedApiEnabled)(le,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(le.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:Q,secrets:pe,subscriptions:[],get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(Ie){return D.join(le.extensionLocation.fsPath,Ie)},get storagePath(){return Ue._storagePath.workspaceValue(le)?.fsPath},get globalStoragePath(){return Ue._storagePath.globalValue(le).fsPath},get logPath(){return D.join(Ue._initData.logsLocation.fsPath,le.identifier.value)},get logUri(){return k.URI.joinPath(Ue._initData.logsLocation,le.identifier.value)},get storageUri(){return Ue._storagePath.workspaceValue(le)},get globalStorageUri(){return Ue._storagePath.globalValue(le)},get extensionMode(){return Se},get extension(){return Xe===void 0&&(Xe=new K(Ue,le.identifier,le,Fe,!1)),Xe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(le,"extensionRuntime"),Ue.extensionRuntime},get environmentVariableCollection(){return Ue._extHostTerminalService.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!ke){if(!ye)return;const Ie=I.Event.buffer(I.Event.fromDOMEventEmitter(ye,"message",ae=>ae.data));ye.start(),ke={onDidReceiveMessage:Ie,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(le,fe,Q,pe,Se){return Q=Q||{activate:void 0,deactivate:void 0},this._callActivateOptional(le,fe,Q,pe,Se).then(Fe=>new E.ActivatedExtension(!1,null,Se.build(),Q,Fe,pe.subscriptions))}static _callActivateOptional(le,fe,Q,pe,Se){if(typeof Q.activate=="function")try{Se.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const Fe=typeof global=="object"?global:self,Ue=Q.activate.apply(Fe,[pe]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(Ue).then(Xe=>(Se.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(Q)}_activateOneStartupFinished(le,fe){this._activateById(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:fe}).then(void 0,Q=>{this._logService.error(Q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const le of this._myRegistry.getAllExtensionDescriptions())if(le.activationEvents)for(const fe of le.activationEvents)fe==="onStartupFinished"&&this._activateOneStartupFinished(le,fe)}_handleEagerExtensions(){const le=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const fe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Q=this._handleWorkspaceContainsEagerExtensions(fe),pe=Promise.all([le,Q]).then(()=>{});return Promise.race([pe,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(le){return le.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(fe=>this._handleWorkspaceContainsEagerExtension(le,fe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(le,fe){if(this.isActivated(fe.identifier))return;const Q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:le.map(Fe=>Fe.uri),forceUsingSearch:Q,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ue,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ue,Xe)},Se=await(0,L.checkActivateWorkspaceContainsExtension)(pe,fe);if(!!Se)return this._activateById(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:Se.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(le){throw console.error(le),le}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:fe}=this._initData.environment;if(!le||!fe)throw new Error(i.localize(0,null));const Q=await this._loadCommonJSModule(null,fe,new E.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(i.localize(1,null,fe.toString()));return new Promise((pe,Se)=>{const Fe=(ke,ye)=>{ke?Se(ke):pe(typeof ye=="number"&&ye>0?1:0)},Ue=(0,F.originalFSPath)(fe),Xe=Q.run(Ue,Fe);Xe&&Xe.then&&Xe.then(()=>{pe(0)}).catch(ke=>{Se(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,fe){return this._resolvers[le]=fe,(0,A.toDisposable)(()=>{delete this._resolvers[le]})}async _activateAndGetResolver(le){const fe=le.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const Q=le.substr(0,fe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this._resolvers[Q]}}async $resolveAuthority(le,fe){this._logService.info(`$resolveAuthority invoked for authority (${de(le)})`);const{authorityPrefix:Q,resolver:pe}=await this._activateAndGetResolver(le);if(!pe)return{type:"error",error:{code:c.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),S.mark(`code/extHost/willResolveAuthority/${Q}`);const Se=await pe.resolve(le,{resolveAttempt:fe});S.mark(`code/extHost/didResolveAuthorityOK/${Q}`);const Fe={authority:le,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},Ue={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Ue,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(S.mark(`code/extHost/didResolveAuthorityError/${Q}`),Se instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(le,fe){this._logService.info(`$getCanonicalURI invoked for authority (${de(le)})`);const{resolver:Q}=await this._activateAndGetResolver(le);if(!Q)return null;const pe=k.URI.revive(fe);if(typeof Q.getCanonicalURI>"u")return pe;const Se=await(0,_.asPromise)(()=>Q.getCanonicalURI(pe));return Se||pe}static _applyExtensionsDelta(le,fe,Q){const pe=new a.ExtensionDescriptionRegistry(le.getAllExtensionDescriptions());pe.deltaExtensions(Q.toAdd,Q.toRemove);const Se=(0,o.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(Ue=>Ue.identifier));for(const Ue of Q.myToRemove)Se.delete(b.ExtensionIdentifier.toKey(Ue));for(const Ue of Q.myToAdd)Se.add(b.ExtensionIdentifier.toKey(Ue));const Fe=te(pe,Se);return{globalRegistry:pe,myExtensions:Fe}}$startExtensionHost(le){le.toAdd.forEach(pe=>pe.extensionLocation=k.URI.revive(pe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Oi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le);return this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),this._startExtensionHost()}$activateByEvent(le,fe){return fe===1?this._activateByEvent(le,!1):this._readyToRunExtensions.wait().then(Q=>this._activateByEvent(le,!1))}async $activate(le,fe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(le)?(await this._activateById(le,fe),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(Fe=>Fe.extensionLocation=k.URI.revive(Fe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Oi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le),pe=await this._createExtensionPathIndex(Q);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const fe=u.VSBuffer.alloc(le),Q=Math.random()%256;for(let pe=0;pe<le;pe++)fe.writeUInt8(Q,pe);return fe}async $updateRemoteConnectionData(le){this._remoteConnectionData=le,this._onDidChangeRemoteConnectionData.fire()}};x=xe([We(0,n.IInstantiationService),We(1,e.IHostUtils),We(2,f.IExtHostRpcService),We(3,t.IExtHostWorkspace),We(4,g.IExtHostConfiguration),We(5,O.ILogService),We(6,d.IExtHostInitDataService),We(7,l.IExtensionStoragePaths),We(8,h.IExtHostTunnelService),We(9,v.IExtHostTerminalService),We(10,P.IExtHostLocalizationService)],x),e.AbstractExtHostExtensionService=x;function U(be,le){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class K{constructor(le,fe,Q,pe,Se){M.set(this,void 0),R.set(this,void 0),B.set(this,void 0),Ye(this,M,le,"f"),Ye(this,R,fe,"f"),Ye(this,B,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=D.normalize((0,F.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=pe,this.isFromDifferentExtensionHost=Se}get isActive(){return Oe(this,M,"f").isActivated(Oe(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,M,"f").getExtensionExports(Oe(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,M,"f").activateByIdWithErrors(Oe(this,B,"f"),{startup:!1,extensionId:Oe(this,R,"f"),activationEvent:"api"}),this.exports}}e.Extension=K,M=new WeakMap,R=new WeakMap,B=new WeakMap;function te(be,le){return be.getAllExtensionDescriptions().filter(fe=>le.has(b.ExtensionIdentifier.toKey(fe.identifier)))}function de(be){const le=be.indexOf("+");return le===-1?be:be.substring(0,le)}class re{constructor(le){this._searchTree=le}setSearchTree(le){this._searchTree=le}findSubstr(le){return this._searchTree.findSubstr(le)}forEach(le){return this._searchTree.forEach(le)}}e.ExtensionPaths=re}),define(De[237],Ce([1,0,76,2,5,32,27,25,14,26,3,33,48,11,10]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(C,s,c,n,d,l,f){this._apiFactory=C,this._extensionRegistry=s,this._instaService=c,this._extHostConfiguration=n,this._extHostExtensionService=d,this._initData=l,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),i.mark("code/extHost/willWaitForConfig");const C=await this._extHostConfiguration.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,s,this._extensionRegistry,C,this._logService)),this.register(this._instaService.createInstance(p,s)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,s,this._initData.environment.appUriScheme))}register(C){if("nodeModuleName"in C)if(Array.isArray(C.nodeModuleName))for(const s of C.nodeModuleName)this._factories.set(s,C);else this._factories.set(C.nodeModuleName,C);typeof C.alternativeModuleName=="function"&&this._alternatives.push(s=>C.alternativeModuleName(s))}};t=xe([We(2,O.IInstantiationService),We(3,F.IExtHostConfiguration),We(4,w.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,E.ILogService)],t),e.RequireInterceptor=t;let o=class Yi{constructor(C){if(C.environment.appRoot&&Yi.aliased.size){const s=(0,m.escapeRegExpCharacters)(this.forceForwardSlashes(C.environment.appRoot.fsPath)),c="[a-z0-9_.-]",n=`@${c}+\\/${c}+|${c}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(C){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(C));if(!s)return;const[,c,n,d]=s,l=Yi.aliased.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),c+l+d}forceForwardSlashes(C){return C.replace(/\\/g,"/")}};o.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=xe([We(0,k.IExtHostInitDataService)],o);class a{constructor(C,s,c,n,d){this._apiFactory=C,this._extensionPaths=s,this._extensionRegistry=c,this._configProvider=n,this._logService=d,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(C,s){const c=this._extensionPaths.findSubstr(s);if(c){let n=this._extApiImpl.get(A.ExtensionIdentifier.toKey(c.identifier));return n||(n=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(c.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(C,s,c){this._extensionPaths=C,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(S.MainContext.MainThreadTelemetry);const{environment:n}=c,d=s.getProxy(S.MainContext.MainThreadKeytar);if(n.appRoot){let l=n.appRoot.fsPath;g.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${l}/node_modules.asar/keytar`),this.alternativeNames.add(`${l}/node_modules/keytar`)}this._impl={getPassword:(l,f)=>d.$getPassword(l,f),setPassword:(l,f,r)=>d.$setPassword(l,f,r),deletePassword:(l,f)=>d.$deletePassword(l,f),findPassword:l=>d.$findPassword(l),findCredentials(l){return d.$findCredentials(l)}}}load(C,s){const c=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:c?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(C){const s=C.length;if(s<=7||!this.alternativeNames)return;const c=s-7;if((C.charAt(c)==="/"||C.charAt(c)==="\\")&&C.endsWith("keytar")&&(C=C.replace(/\\/g,"/"),this.alternativeNames.has(C)))return"keytar"}};p=xe([We(1,y.IExtHostRpcService),We(2,k.IExtHostInitDataService)],p);let b=class{constructor(C,s,c){this._extensionPaths=C,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(S.MainContext.MainThreadTelemetry);const n=c.getProxy(S.MainContext.MainThreadWindow);this._impl=(d,l)=>{const f=D.URI.parse(d);return l?this.callOriginal(d,l):f.scheme==="http"||f.scheme==="https"?n.$openUri(f,d,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?n.$openUri(f,d,{}):this.callOriginal(d,l)}}load(C,s,c){const n=this._extensionPaths.findSubstr(s);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=c(C),this._impl}callOriginal(C,s){return this.sendNoForwardTelemetry(),this._original(C,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=xe([We(2,y.IExtHostRpcService)],b)}),define(De[103],Ce([1,0,203,7,19,48,3,53,54,33,6,31,176,32]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class m extends g.AbstractVariableResolverService{constructor(a,p,b,u,C,s,c){function n(){if(b){const d=b.activeEditor();if(d)return d.document.uri;const l=u.tabGroups.all.find(f=>f.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof O.TextDiffTabInput||l.input instanceof O.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof O.TextTabInput||l.input instanceof O.NotebookEditorTabInput||l.input instanceof O.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:d=>{const l=s.folders.filter(f=>f.name===d);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(d,l)=>C.getConfiguration(void 0,d).get(l),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=n();if(d)return S.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const d=n();if(d){const l=p.getWorkspaceFolder(d);if(l)return S.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(b){const d=b.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(b){const d=b.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>a.getExtension(d)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(F.env))}}let t=class extends D.Disposable{constructor(a,p,b,u,C){super(),this.extensionService=a,this.workspaceService=p,this.editorService=b,this.configurationService=u,this.editorTabs=C,this._resolver=new i.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async d=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new m(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};t=xe([We(0,k.IExtHostExtensionService),We(1,w.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,E.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(De[104],Ce([1,0,15,4,9,2,3,5,54,33,14,6,31,169,171,32,103]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,d,l,f,r,h){this._workspaceService=d,this._extensionService=l,this._configurationService=f,this._editorTabs=r,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(I=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(n,d){const l=n;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let f=`debug:${encodeURIComponent(l.path||"")}`,r="?";return d&&(f+=`${r}session=${encodeURIComponent(d.id)}`,r="&"),f+=`${r}ref=${l.sourceReference}`,F.URI.parse(f)}else{if(l.path)return F.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const d=[];for(const l of n.getAllExtensionDescriptions())if(l.contributes){const f=l.contributes.debuggers;if(f&&f.length>0)for(const r of f)(0,m.isDebuggerMainContribution)(r)&&d.push(r.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(d=>n.push(d)),n}addBreakpoints(n){this.startBreakpoints();const d=n.filter(r=>{const h=r.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,r),!0)});this.fireBreakpointChanges(d,[],[]);const l=[],f=new Map;for(const r of d)if(r instanceof w.SourceBreakpoint){let h=f.get(r.location.uri.toString());h||(h={type:"sourceMulti",uri:r.location.uri,lines:[]},f.set(r.location.uri.toString(),h),l.push(h)),h.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof w.FunctionBreakpoint&&l.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(n){this.startBreakpoints();const d=n.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],d,[]);const l=d.filter(h=>h instanceof w.SourceBreakpoint).map(h=>h.id),f=d.filter(h=>h instanceof w.FunctionBreakpoint).map(h=>h.id),r=d.filter(h=>h instanceof w.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(l,f,r)}startDebugging(n,d,l){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,d,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,d,l){if(!d)return new w.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:f,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,l,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,f),new w.Disposable(()=>{this._configProviders=this._configProviders.filter(r=>r.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(n,d,l){if(!l)return new w.Disposable(()=>{});if(!this.definesDebugType(n,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:f,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,f),new w.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(r=>r.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(n,d){if(!d)return new w.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:l,factory:d}),new w.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==d)})}async $runInTerminal(n,d){return Promise.resolve(void 0)}async $substituteVariables(n,d){let l;const f=await this.getFolder(n);return f&&(l={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(l,d)}createDebugAdapter(n,d){if(n.type==="implementation")return new C(n.implementation)}createSignService(){}async $startDASession(n,d){const l=this,f=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const h=this.convertToDto(r),v=this.createDebugAdapter(h,f);if(!v)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const I=v;return this._debugAdapters.set(n,I),this.getDebugAdapterTrackers(f).then(L=>(L&&this._debugAdaptersTrackers.set(n,L),I.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const W=j,H={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const P=await this._signService.sign(W.arguments.value);H.body={signature:P},I.sendResponse(H)}else throw new Error("no signer")}catch(P){H.success=!1,H.message=P.message,I.sendResponse(H)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(j),j=(0,m.convertToVSCPaths)(j,!0),l._debugServiceProxy.$acceptDAMessage(n,j)}),I.onError(j=>{L&&L.onError&&L.onError(j),this._debugServiceProxy.$acceptDAError(n,j.name,j.message,j.stack)}),I.onExit(j=>{L&&L.onExit&&L.onExit((0,S.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,S.withNullAsUndefined)(j),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),I.startSession()))})}$sendDAMessage(n,d){d=(0,m.convertToDAPaths)(d,!1);const l=this._debugAdaptersTrackers.get(n);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(d),this._debugAdapters.get(n)?.sendMessage(d)}$stopDASession(n){const d=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),d&&d.onWillStopSession&&d.onWillStopSession();const l=this._debugAdapters.get(n);return this._debugAdapters.delete(n),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const d=[],l=[],f=[];if(n.added)for(const r of n.added){const h=r.id;if(h&&!this._breakpoints.has(h)){let v;if(r.type==="function")v=new w.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")v=new w.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const I=F.URI.revive(r.uri);v=new w.SourceBreakpoint(new w.Location(I,new w.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}v._id=h,this._breakpoints.set(h,v),d.push(v)}}if(n.removed)for(const r of n.removed){const h=this._breakpoints.get(r);h&&(this._breakpoints.delete(r),l.push(h))}if(n.changed){for(const r of n.changed)if(r.id){const h=this._breakpoints.get(r.id);if(h){if(h instanceof w.FunctionBreakpoint&&r.type==="function"){const v=h;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.functionName=r.functionName}else if(h instanceof w.SourceBreakpoint&&r.type==="source"){const v=h;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.location=new w.Location(F.URI.revive(r.uri),new w.Position(r.line,r.character))}f.push(h)}}}this.fireBreakpointChanges(d,l,f)}$provideDebugConfigurations(n,d,l){return(0,i.asPromise)(async()=>{const f=this.getConfigProviderByHandle(n);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.getFolder(d);return f.provideDebugConfigurations(r,l)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(n,d,l,f){return(0,i.asPromise)(async()=>{const r=this.getConfigProviderByHandle(n);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(d);return r.resolveDebugConfiguration(h,l,f)})}$resolveDebugConfigurationWithSubstitutedVariables(n,d,l,f){return(0,i.asPromise)(async()=>{const r=this.getConfigProviderByHandle(n);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(d);return r.resolveDebugConfigurationWithSubstitutedVariables(h,l,f)})}async $provideDebugAdapter(n,d){const l=this.getAdapterDescriptorFactoryByHandle(n);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(d);return this.getAdapterDescriptor(l,f).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(r)})}async $acceptDebugSessionStarted(n){const d=await this.getSession(n);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(n){const d=await this.getSession(n);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,d){(await this.getSession(n))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(n,d){const f={session:await this.getSession(n),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(n){if(n instanceof w.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof w.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const d=this._adapterFactories.filter(l=>l.type===n);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(n){const d=this._adapterFactories.filter(l=>l.handle===n);if(d.length>0)return d[0].factory}getConfigProviderByHandle(n){const d=this._configProviders.filter(l=>l.handle===n);if(d.length>0)return d[0].provider}definesDebugType(n,d){if(n.contributes){const l=n.contributes.debuggers;if(l&&l.length>0){for(const f of l)if(f.label&&f.type&&f.type===d)return!0}}return!1}getDebugAdapterTrackers(n){const l=n.configuration.type,f=this._trackerFactories.filter(r=>r.type===l||r.type==="*").map(r=>(0,i.asPromise)(()=>r.factory.createDebugAdapterTracker(n)).then(h=>h,h=>null));return Promise.race([Promise.all(f).then(r=>{const h=r.filter(v=>!!v);if(h.length>0)return new u(h)}),new Promise((r,h)=>{const v=setTimeout(()=>{clearTimeout(v),h(new Error("timeout"))},1e3)})]).catch(r=>{})}async getAdapterDescriptor(n,d){const l=d.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new w.DebugAdapterServer(l));if(n){const r=await this._extensionService.getExtensionRegistry();return(0,i.asPromise)(()=>n.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,r))).then(h=>{if(h)return h})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,f))}daExecutableFromPackage(n,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,d,l){(n.length>0||d.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:d,changed:l}))}async getSession(n){if(n)if(typeof n=="string"){const d=this._debugSessions.get(n);if(d)return d}else{let d=this._debugSessions.get(n.id);if(!d){const l=await this.getFolder(n.folderUri),f=n.parent?this._debugSessions.get(n.parent):void 0;d=new p(this._debugServiceProxy,n.id,n.type,n.name,l,n.configuration,f),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(n){if(n){const d=F.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};a=xe([We(0,O.IExtHostRpcService),We(1,g.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,t.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,o.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class p{constructor(n,d,l,f,r,h,v){this._debugServiceProxy=n,this._id=d,this._type=l,this._name=f,this._workspaceFolder=r,this._configuration=h,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,d)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=p;class b{constructor(n){this.value=Object.freeze({append(d){n.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=b;class u{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(d=>d.onError?d.onError(n):void 0)}onExit(n,d){this.trackers.forEach(l=>l.onExit?l.onExit(n,d):void 0)}}class C extends E.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends a{constructor(n,d,l,f,r,h){super(n,d,l,f,r,h)}};s=xe([We(0,O.IExtHostRpcService),We(1,g.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,t.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,o.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(De[238],Ce([1,0,12,76,2,5,229,11,59,60,26,149,14,50,33,69]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(b){const u=b.get(A.ILogService),s=b.get(g.IExtHostRpcService).getProxy(F.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(c=>{u.error(c);const n=i.transformErrorForSerialization(c);s.$onUnexpectedError(n)})}static async installFullHandler(b){const u=b.get(A.ILogService),C=b.get(g.IExtHostRpcService),s=b.get(m.IExtHostExtensionService),c=b.get(t.IExtHostTelemetry),n=C.getProxy(F.MainContext.MainThreadExtensionService),d=C.getProxy(F.MainContext.MainThreadErrors),l=await s.getExtensionPathIndex(),f=new WeakMap;Error.prepareStackTrace=(r,h)=>{let v="",I,L;for(const j of h)v+=`
	at ${j.toString()}`,L=j.getFileName(),!I&&L&&(I=l.findSubstr(S.URI.file(L)));return f.set(r,I?.identifier),`${r.name||"Error"}: ${r.message||""}${v}`},i.setUnexpectedErrorHandler(r=>{u.error(r);const h=i.transformErrorForSerialization(r),v=f.get(r);if(!v){d.$onUnexpectedError(h);return}n.$onExtensionRuntimeError(v,h);const I=c.onExtensionError(v,r);u.trace("forwarded error to extension?",I,v)})}}Error.stackTraceLimit=100;class a{constructor(b,u,C,s,c){this._hostUtils=C,this._rpcProtocol=new _.RPCProtocol(b,null,s),u=a._transform(u,this._rpcProtocol);const n=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...u,messagePorts:c}),n.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),n.set(E.IURITransformerService,new E.URITransformerService(s)),n.set(m.IHostUtils,C);const d=new w.InstantiationService(n,!0);d.invokeFunction(o.installEarlyHandler),this._logService=d.invokeFunction(l=>l.get(A.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",u),this._extensionService=d.invokeFunction(l=>l.get(m.IExtHostExtensionService)),this._extensionService.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(b){const u=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService);return S.URI.revive(await u.$asBrowserUri(b))}terminate(b){this._extensionService.terminate(b)}static _transform(b,u){b.allExtensions.forEach(s=>{s.extensionLocation=S.URI.revive(u.transformIncomingURIs(s.extensionLocation));const c={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(n=>c[n]=S.URI.revive(u.transformIncomingURIs(s.browserNlsBundleUris[n]))),s.browserNlsBundleUris=c)}),b.environment.appRoot=S.URI.revive(u.transformIncomingURIs(b.environment.appRoot));const C=b.environment.extensionDevelopmentLocationURI;return C&&(b.environment.extensionDevelopmentLocationURI=C.map(s=>S.URI.revive(u.transformIncomingURIs(s)))),b.environment.extensionTestsLocationURI=S.URI.revive(u.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=S.URI.revive(u.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=S.URI.revive(u.transformIncomingURIs(b.environment.workspaceStorageHome)),b.nlsBaseUrl=S.URI.revive(u.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=S.URI.revive(u.transformIncomingURIs(b.logsLocation)),b.logFile=S.URI.revive(u.transformIncomingURIs(b.logFile)),b.workspace=u.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=a}),define(De[239],Ce([1,0,18,15,21,44,13,19,22,2,43]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(p,b,u,C){this.query=p,this.provider=b,this.fileUtils=u,this.processType=C,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(p,b){const u=this.query.folderQueries||[],C=new S.CancellationTokenSource;return b.onCancellationRequested(()=>C.cancel()),new Promise((s,c)=>{this.collector=new E(p);let n=!1;const d=(l,f)=>{if(!n&&!this.isLimitHit){const r=this.resultSize(l);t(l)&&typeof this.query.maxResults=="number"&&this.resultCount+r>this.query.maxResults&&(this.isLimitHit=!0,n=!0,C.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const h=this.resultSize(l);this.resultCount+=h,(h>0||!t(l))&&this.collector.add(l,f)}};Promise.all(u.map((l,f)=>this.searchInFolder(l,r=>d(r,f),C.token))).then(l=>{C.dispose(),this.collector.flush();const f=l.some(r=>!!r&&!!r.limitHit);s({limitHit:this.isLimitHit||f,messages:(0,i.flatten)(l.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.processType}})},l=>{C.dispose();const f=(0,F.toErrorMessage)(l);c(new Error(f))})})}resultSize(p){return t(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}trimResultToSize(p,b){const u=Array.isArray(p.ranges)?p.ranges:[p.ranges],C=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:u.slice(0,b),preview:{matches:C.slice(0,b),text:p.preview.text},uri:p.uri}}async searchInFolder(p,b,u){const C=new O.QueryGlobTester(this.query,p),s=[],c={report:l=>{if(!this.validateProviderResult(l))return;const f=p.folder.scheme===_.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(l.uri))):void 0,r=y.relativePath(p.folder,l.uri);if(r){const h=C.includedInQuery(r,A.basename(r),f);(0,D.isThenable)(h)?s.push(h.then(v=>{v&&b(l)})):h&&b(l)}}},n=this.getSearchOptionsForFolder(p),d=await this.provider.provideTextSearchResults(g(this.query.contentPattern),n,c,u);return s.length&&await Promise.all(s),d}validateProviderResult(p){if(t(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(p){const b=(0,O.resolvePatternsForProvider)(this.query.includePattern,p.includePattern),u=(0,O.resolvePatternsForProvider)(this.query.excludePattern,p.excludePattern),C={folder:k.URI.from(p.folder),excludes:u,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.fileUtils.toCanonicalName(p.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return C.usePCRE2=this.query.usePCRE2,C}}e.TextSearchManager=w;function g(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(p){this._onResult=p,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,b=>this.sendItems(b))}add(p,b){this._currentFileMatch&&(this._currentFolderIdx!==b||!y.isEqual(this._currentUri,p.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=b,this._currentFileMatch={resource:p.uri,results:[]}),this._currentFileMatch.results.push(m(p))}pushToCollector(){const p=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,p)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(p){this._onResult(p)}}e.TextSearchResultsCollector=E;function m(a){return t(a)?{preview:{matches:(0,i.mapArrayOrNot)(a.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:a.preview.text},ranges:(0,i.mapArrayOrNot)(a.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function t(a){return!!a.preview}e.extensionResultIsMatch=t;class o{constructor(p,b){this.maxBatchSize=p,this.cb=b,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(p,b){!p||this.addItemToBatch(p,b)}addItems(p,b){!p||this.addItemsToBatch(p,b)}addItemToBatch(p,b){this.batch.push(p),this.batchSize+=b,this.onUpdate()}addItemsToBatch(p,b){this.batch=this.batch.concat(p),this.batchSize+=b,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=o,o.TIMEOUT=4e3,o.START_BATCH_AFTER_COUNT=50}),define(De[105],Ce([1,0,7,5,3,234,14,50,11,2,239]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let w=class{constructor(t,o,a){this.extHostRpc=t,this._uriTransformer=o,this._logService=a,this._proxy=this.extHostRpc.getProxy(D.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new F.FileSearchManager}_transformScheme(t){return this._uriTransformer.transformOutgoingScheme(t)}registerTextSearchProvider(t,o){if(this._textSearchUsedSchemes.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this._textSearchUsedSchemes.add(t);const a=this._handlePool++;return this._textSearchProvider.set(a,o),this._proxy.$registerTextSearchProvider(a,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._textSearchUsedSchemes.delete(t),this._textSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerFileSearchProvider(t,o){if(this._fileSearchUsedSchemes.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this._fileSearchUsedSchemes.add(t);const a=this._handlePool++;return this._fileSearchProvider.set(a,o),this._proxy.$registerFileSearchProvider(a,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(t),this._fileSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(t,o,a,p){const b=g(a),u=this._fileSearchProvider.get(t);if(u)return this._fileSearchManager.fileSearch(b,u,C=>{this._proxy.$handleFileMatch(t,o,C.map(s=>s.resource))},p);throw new Error("unknown provider: "+t)}$clearCache(t){return this._fileSearchManager.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,o,a,p){const b=this._textSearchProvider.get(t);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const u=g(a);return this.createTextSearchManager(u,b).search(s=>this._proxy.$handleTextMatch(t,o,s),p)}$enableExtensionHostSearch(){}createTextSearchManager(t,o){return new O.TextSearchManager(t,o,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};w=xe([We(0,_.IExtHostRpcService),We(1,A.IURITransformerService),We(2,y.ILogService)],w),e.ExtHostSearch=w;function g(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(E),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>k.URI.revive(t))}}e.reviveQuery=g;function E(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(De[240],Ce([1,0,59,100,31,98,32,37,53,56,102,104,105,74,64,71,99,55,36,73,69,54,211,11,181,103,72]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u,C,s,c,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(l.IExtHostLocalizationService,l.ExtHostLocalizationService,1),(0,i.registerSingleton)(c.ILoggerService,s.ExtHostLoggerService,1),(0,i.registerSingleton)(c.ILogService,n.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,!1),(0,i.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,i.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,i.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,!1),(0,i.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,!1),(0,i.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,!1),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,!1),(0,i.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,!1),(0,i.registerSingleton)(D.IExtHostOutputService,D.ExtHostOutputService,1),(0,i.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,!1),(0,i.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,!1),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,!1),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,!1),(0,i.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,!1),(0,i.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,!1),(0,i.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,!1),(0,i.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,!1),(0,i.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry,!1),(0,i.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs,!1),(0,i.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,!1)}),define(De[241],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const F=this._dragOperations.get(S);return this._dragOperations.delete(S),F}}addDragOperationTransfer(S,F){this._dragOperations.set(S,F)}getRenderedTreeElement(S){if(this._renderedElements.has(S))return this._renderedElements.get(S)}addRenderedTreeItemElement(S,F){this._renderedElements.set(S,F)}removeRenderedTreeItemElement(S){this._renderedElements.has(S)&&this._renderedElements.delete(S)}}e.TreeviewsService=i}),define(De[242],Ce([1,0,136,6,22,2,4,7,15,6,9,18,8,21,241,27]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(b,u){if((0,O.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let C;return Array.isArray(b.highlights)&&(C=b.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),C=C.length?C:void 0),{label:b.label,highlights:C}}}class a{constructor(u,C,s){this._proxy=u,this.commands=C,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new m.TreeviewsService;function c(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}C.registerArgumentProcessor({processArgument:n=>c(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(d=>c(d)?this.convertArgument(d):d):n})}registerTreeDataProvider(u,C,s){const c=this.createTreeView(u,{treeDataProvider:C},s);return{dispose:()=>c.dispose()}}createTreeView(u,C,s){if(!C||!C.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=C.dragAndDropController?.dropMimeTypes??[],n=C.dragAndDropController?.dragMimeTypes??[],d=!!C.dragAndDropController?.handleDrag,l=!!C.dragAndDropController?.handleDrop,f=this.createExtHostTreeView(u,C,s),r=this._proxy.$registerTreeViewDataProvider(u,{showCollapseAll:!!C.showCollapseAll,canSelectMany:!!C.canSelectMany,dropMimeTypes:c,dragMimeTypes:n,hasHandleDrag:d,hasHandleDrop:l});return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(s,"treeItemCheckbox"),f.onDidChangeCheckboxState},get message(){return f.message},set message(h){f.message=h},get title(){return f.title},set title(h){f.title=h},get description(){return f.description},set description(h){f.description=h},get badge(){return f.badge},set badge(h){h!==void 0&&k.ViewBadge.isViewBadge(h)?f.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(f.badge=void 0)},reveal:(h,v)=>f.reveal(h,v),dispose:async()=>{await r,this.treeViews.delete(u),f.dispose()}}}$getChildren(u,C){const s=this.treeViews.get(u);return s?s.getChildren(C):Promise.reject(new Error((0,i.localize)(0,null,u)))}async $handleDrop(u,C,s,c,n,d,l,f){const r=this.treeViews.get(u);if(!r)return Promise.reject(new Error((0,i.localize)(1,null,u)));const h=g.DataTransfer.toDataTransfer(s,async v=>(await this._proxy.$resolveDropFileData(u,C,v)).buffer);return l===u&&f&&await this.addAdditionalTransferItems(h,r,f,n,d),r.onDrop(h,c,n)}async addAdditionalTransferItems(u,C,s,c,n){const d=this.treeDragAndDropService.removeDragOperationTransfer(n);if(d)(await d)?.forEach((l,f)=>{l&&u.set(f,l)});else if(n&&C.handleDrag){const l=C.handleDrag(s,u,c);this.treeDragAndDropService.addDragOperationTransfer(n,l),await l}return u}async $handleDrag(u,C,s,c){const n=this.treeViews.get(u);if(!n)return Promise.reject(new Error((0,i.localize)(2,null,u)));const d=await this.addAdditionalTransferItems(new D.DataTransfer,n,C,c,s);if(!!d)return g.DataTransfer.toDataTransferDTO(d)}async $hasResolve(u){const C=this.treeViews.get(u);if(!C)throw new Error((0,i.localize)(3,null,u));return C.hasResolve}$resolve(u,C,s){const c=this.treeViews.get(u);if(!c)throw new Error((0,i.localize)(4,null,u));return c.resolveTreeItem(C,s)}$setExpanded(u,C,s){const c=this.treeViews.get(u);if(!c)throw new Error((0,i.localize)(5,null,u));c.setExpanded(C,s)}$setSelection(u,C){const s=this.treeViews.get(u);if(!s)throw new Error((0,i.localize)(6,null,u));s.setSelection(C)}$setFocus(u,C){const s=this.treeViews.get(u);if(!s)throw new Error((0,i.localize)(7,null,u));s.setFocus(C)}$setVisible(u,C){const s=this.treeViews.get(u);if(!s)throw new Error((0,i.localize)(8,null,u));s.setVisible(C)}$changeCheckboxState(u,C){const s=this.treeViews.get(u);if(!s)throw new Error((0,i.localize)(9,null,u));s.setCheckboxState(C)}createExtHostTreeView(u,C,s){const c=new p(u,C,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(u,c),c}convertArgument(u){const C=this.treeViews.get(u.$treeViewId);return C&&"$treeItemHandle"in u?C.getExtensionElement(u.$treeItemHandle):C&&"$focusedTreeItem"in u&&u.$focusedTreeItem?C.focusedElement:null}}e.ExtHostTreeViews=a;class p extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,O.isUndefinedOrNull)(u))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(u,C,s,c,n,d){if(super(),this.viewId=u,this.proxy=s,this.commands=c,this.logService=n,this.extension=d,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new _.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,d.contributes&&d.contributes.views)for(const r in d.contributes.views)for(const h of d.contributes.views[r])h.id===u&&(this._title=h.name);this.dataProvider=C.treeDataProvider,this.dndController=C.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let l,f;this._register(_.Event.debounce(this._onDidChangeData.event,(r,h)=>(r||(r={message:!1,elements:[]}),h.element!==!1&&(l||(l=new Promise(v=>f=v),this.refreshPromise=this.refreshPromise.then(()=>l)),Array.isArray(h.element)?r.elements.push(...h.element):r.elements.push(h.element)),h.message&&(r.message=!0),r),200,!0)(({message:r,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=f;return l=null,this.refresh(h).then(()=>v())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(u){const C=u?this.getExtensionElement(u):void 0;if(u&&!C)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(u);return s||(s=await this.fetchChildrenNodes(C)),s?s.map(c=>c.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,C){C=C||{select:!0,focus:!1};const s=(0,O.isUndefinedOrNull)(C.select)?!0:C.select,c=(0,O.isUndefinedOrNull)(C.focus)?!1:C.focus,n=(0,O.isUndefinedOrNull)(C.expand)?!1:C.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(d=>this.resolveTreeNode(u,d[d.length-1]).then(l=>this.proxy.$reveal(this.viewId,{item:l.item,parentChain:d.map(f=>f.item)},{select:s,focus:c,expand:n})),d=>this.logService.error(d)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:c,expand:n})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}get badge(){return this._badge}set badge(u){this._badge?.value===u?.value&&this._badge?.tooltip===u?.tooltip||(this._badge=g.ViewBadge.from(u),this.proxy.$setBadge(this.viewId,u))}setExpanded(u,C){const s=this.getExtensionElement(u);s&&(C?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(u){(0,w.equals)(this._selectedHandles,u)||(this._selectedHandles=u,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(u){this._focusedHandle=u}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(u){const C=(await Promise.all(u.map(async s=>{const c=this.getExtensionElement(s.treeItemHandle);return c?{extensionItem:c,treeItem:await this.dataProvider.getTreeItem(c),newState:s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);C.forEach(s=>{s.treeItem.checkboxState=s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:C.map(s=>[s.extensionItem,s.newState])})}async handleDrag(u,C,s){const c=[];for(const n of u){const d=this.getExtensionElement(n);d&&c.push(d)}if(!(!this.dndController?.handleDrag||c.length===0))return await this.dndController.handleDrag(c,C,s),C}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,C,s){const c=C?this.getExtensionElement(C):void 0;if(!(!c&&C||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(c,u,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,C){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(u);if(s){const c=this.nodes.get(s);if(c){const n=await this.dataProvider.resolveTreeItem(c.extensionItem,s,C)??c.extensionItem;return this.validateTreeItem(n),c.item.tooltip=this.getTooltip(n.tooltip),c.item.command=this.getCommand(c.disposableStore,n.command),c.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(C=>C?this.resolveUnknownParentChain(C).then(s=>this.resolveTreeNode(C,s[s.length-1]).then(c=>(s.push(c),s))):Promise.resolve([]))}resolveParent(u){const C=this.nodes.get(u);return C?Promise.resolve(C.parent?this.elements.get(C.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,C){const s=this.nodes.get(u);return s?Promise.resolve(s):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(c=>this.createHandle(u,c,C,!0)).then(c=>this.getChildren(C?C.item.handle:void 0).then(()=>{const n=this.getExtensionElement(c);if(n){const d=this.nodes.get(n);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(u){if(u){let C;if(typeof u=="string"){const s=this.getExtensionElement(u);C=s?this.nodes.get(s):void 0}else C=u;return C&&C.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const C=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=u?this.nodes.get(u):void 0,c=await this.dataProvider.getChildren(u);if(C.token.isCancellationRequested)return;const n=await Promise.all((0,w.coalesce)(c||[]).map(async d=>{const l=await this.dataProvider.getTreeItem(d);return l&&!C.token.isCancellationRequested?this.createAndRegisterTreeNode(d,l,s):null}));return C.token.isCancellationRequested?void 0:(0,w.coalesce)(n)}finally{C.dispose()}}refresh(u){if(u.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(u);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const C=new Set,s=u.map(n=>this.nodes.get(n));for(const n of s)if(n&&!C.has(n.item.handle)){let d=n;for(;d&&d.parent&&s.findIndex(l=>d&&d.parent&&l&&l.item.handle===d.parent.item.handle)===-1;){const l=this.elements.get(d.parent.item.handle);d=l?this.nodes.get(l):void 0}d&&!d.parent&&C.add(n.item.handle)}const c=[];return C.forEach(n=>{const d=this.elements.get(n);if(d){const l=this.nodes.get(d);l&&(!l.parent||!C.has(l.parent.item.handle))&&c.push(n)}}),c}refreshHandles(u){const C={};return Promise.all(u.map(s=>this.refreshNode(s).then(c=>{c&&(C[s]=c.item)}))).then(()=>Object.keys(C).length?this.proxy.$refresh(this.viewId,C):void 0)}refreshNode(u){const C=this.getExtensionElement(u);if(C){const s=this.nodes.get(C);if(s)return this.clearChildren(C),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(C)).then(c=>{if(c){const n=this.createTreeNode(C,c,s.parent);return this.updateNodeCache(C,n,s,s.parent),s.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,C,s){const c=this.createTreeNode(u,C,s);if(C.id&&this.elements.has(c.item.handle))throw new Error((0,i.localize)(10,null,C.id));return this.addNodeToCache(u,c),this.addNodeToParentCache(c,s),c}getTooltip(u){return k.MarkdownString.isMarkdownString(u)?g.MarkdownString.from(u):u}getCommand(u,C){return C?{...this.commands.toInternal(C,u),originalId:C.command}:void 0}getCheckbox(u){if(!u.checkboxState)return;let C,s;return typeof u.checkboxState=="number"?C=u.checkboxState:(C=u.checkboxState.state,s=u.checkboxState.tooltip),{isChecked:C===k.TreeItemCheckboxState.Checked,tooltip:s}}validateTreeItem(u){if(!k.TreeItem.isTreeItem(u,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(u,C,s){this.validateTreeItem(C);const c=new A.DisposableStore,n=this.createHandle(u,C,s),d=this.getLightIconPath(C);return{item:{handle:n,parentHandle:s?s.item.handle:void 0,label:o(C.label,this.extension),description:C.description,resourceUri:C.resourceUri,tooltip:this.getTooltip(C.tooltip),command:this.getCommand(c,C.command),contextValue:C.contextValue,icon:d,iconDark:this.getDarkIconPath(C)||d,themeIcon:this.getThemeIcon(C),collapsibleState:(0,O.isUndefinedOrNull)(C.collapsibleState)?k.TreeItemCollapsibleState.None:C.collapsibleState,accessibilityInformation:C.accessibilityInformation,checkbox:this.getCheckbox(C)},extensionItem:C,parent:s,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(u){return u.iconPath instanceof k.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:C,label:s,resourceUri:c},n,d){if(C)return`${p.ID_HANDLE_PREFIX}/${C}`;const l=o(s,this.extension),f=n?n.item.handle:p.LABEL_HANDLE_PREFIX;let r=l?l.label:c?(0,S.basename)(c):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const h=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,v=this.getChildrenNodes(n)||[];let I,L=0;do{if(I=`${f}/${L}:${r}`,d||!this.elements.has(I)||h===I)break;L++}while(L<=v.length);return I}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof k.ThemeIcon))return typeof u.iconPath=="string"||F.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof k.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return F.URI.isUri(u)?u:F.URI.file(u)}addNodeToCache(u,C){this.elements.set(C.item.handle,u),this.nodes.set(u,C)}updateNodeCache(u,C,s,c){this.elements.delete(C.item.handle),this.nodes.delete(u),C.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(u,C);const n=this.getChildrenNodes(c)||[],d=n.filter(l=>l.item.handle===s.item.handle)[0];d&&n.splice(n.indexOf(d),1,C)}addNodeToParentCache(u,C){C?(C.children||(C.children=[]),C.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const C=this.nodes.get(u);if(C){if(C.children)for(const s of C.children){const c=this.elements.get(s.item.handle);c&&this.clear(c)}C.children=void 0}}else this.clearAll()}clear(u){const C=this.nodes.get(u);if(C){if(C.children)for(const s of C.children){const c=this.elements.get(s.item.handle);c&&this.clear(c)}this.nodes.delete(u),this.elements.delete(C.item.handle),C.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}p.LABEL_HANDLE_PREFIX="0",p.ID_HANDLE_PREFIX="1"}),define(De[243],Ce([1,0,21,12,4,29,2,123,252,111,121,35,5,68,196,195,37,197,32,199,200,201,184,202,53,33,204,205,208,210,212,100,187,216,217,218,74,56,221,242,8,6,224,57,99,31,168,207,61,98,102,104,105,11,50,14,26,213,182,64,71,193,222,75,55,227,225,226,194,36,219,223,73,54,69,214,101,215,13,87,186,165,206,7,27,170,72,162]),function(ne,e,i,D,S,F,_,A,y,k,O,w,g,E,m,t,o,a,p,b,u,C,s,c,n,d,l,f,r,h,v,I,L,j,W,H,P,M,R,B,x,U,K,te,de,re,be,le,fe,Q,pe,Se,Fe,Ue,Xe,ke,ye,Ie,ae,ue,ee,Z,T,z,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,rt,X,Y,me,Be,je,Ze,Ke,Ve,nt,st,dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function St(tt){const ut=tt.get(ye.IExtHostInitDataService),Rt=tt.get(Ee.IExtHostFileSystemInfo),xt=tt.get(V.IExtHostConsumerFileSystem),kt=tt.get(d.IExtHostExtensionService),mt=tt.get(re.IExtHostWorkspace),_t=tt.get(Ge.IExtHostTelemetry),Lt=tt.get(p.IExtHostConfiguration),Ut=tt.get(Xe.IURITransformerService),qe=tt.get(ke.IExtHostRpcService),Ot=tt.get(P.IExtHostStorage),It=tt.get(z.IExtensionStoragePaths),Ft=tt.get(Ue.ILoggerService),gt=tt.get(Ue.ILogService),_e=tt.get(ue.IExtHostTunnelService),Te=tt.get(ee.IExtHostApiDeprecationService),ge=tt.get(de.IExtHostWindow),G=tt.get(ze.IExtHostSecretState),Ae=tt.get(Je.IExtHostEditorTabs);qe.set(g.ExtHostContext.ExtHostFileSystemInfo,Rt),qe.set(g.ExtHostContext.ExtHostLogLevelServiceShape,Ft),qe.set(g.ExtHostContext.ExtHostWorkspace,mt),qe.set(g.ExtHostContext.ExtHostConfiguration,Lt),qe.set(g.ExtHostContext.ExtHostExtensionService,kt),qe.set(g.ExtHostContext.ExtHostStorage,Ot),qe.set(g.ExtHostContext.ExtHostTunnelService,_e),qe.set(g.ExtHostContext.ExtHostWindow,ge),qe.set(g.ExtHostContext.ExtHostSecretState,G),qe.set(g.ExtHostContext.ExtHostTelemetry,_t),qe.set(g.ExtHostContext.ExtHostEditorTabs,Ae);const Me=qe.set(g.ExtHostContext.ExtHostDecorations,tt.get(Q.IExtHostDecorations)),et=qe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(n.IExtHostDocumentsAndEditors)),$e=qe.set(g.ExtHostContext.ExtHostCommands,tt.get(o.IExtHostCommands)),it=qe.set(g.ExtHostContext.ExtHostTerminalService,tt.get(M.IExtHostTerminalService)),at=qe.set(g.ExtHostContext.ExtHostDebugService,tt.get(Se.IExtHostDebugService)),yt=qe.set(g.ExtHostContext.ExtHostSearch,tt.get(Fe.IExtHostSearch)),vt=qe.set(g.ExtHostContext.ExtHostTask,tt.get(pe.IExtHostTask)),Dt=qe.set(g.ExtHostContext.ExtHostOutputService,tt.get(I.IExtHostOutputService)),Et=qe.set(g.ExtHostContext.ExtHostLocalization,tt.get(st.IExtHostLocalizationService)),Pt=qe.set(g.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(qe)),ft=qe.set(g.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(qe,et)),ei=qe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new C.ExtHostDocumentContentProvider(qe,et,gt)),ti=qe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(gt,ft,qe.getProxy(g.MainContext.MainThreadBulkEdits))),bt=qe.set(g.ExtHostContext.ExtHostNotebook,new Ie.ExtHostNotebookController(qe,$e,et,ft)),Bt=qe.set(g.ExtHostContext.ExtHostNotebookDocuments,new je.ExtHostNotebookDocuments(bt)),ii=qe.set(g.ExtHostContext.ExtHostNotebookEditors,new Be.ExtHostNotebookEditors(gt,bt)),ni=qe.set(g.ExtHostContext.ExtHostNotebookKernels,new Pe.ExtHostNotebookKernels(qe,ut,bt,$e,gt)),vi=qe.set(g.ExtHostContext.ExtHostNotebookRenderers,new X.ExtHostNotebookRenderers(qe,bt)),Ct=qe.set(g.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(qe,et)),ri=qe.set(g.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(qe.getProxy(g.MainContext.MainThreadTreeViews),$e,gt)),Wt=qe.set(g.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(qe.getProxy(g.MainContext.MainThreadEditorInsets),Ct,ut.remote)),Qt=qe.set(g.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(qe,gt,Rt)),si=qe.set(g.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(qe,ft,$e.converter,Ut)),ct=qe.set(g.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(qe,Ut,ft,$e,Qt,gt,Te,_t)),Yt=qe.set(g.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(qe,ct)),zt=qe.set(g.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(qe,gt,et)),qt=qe.set(g.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(qe,mt,$e)),oi=qe.set(g.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(qe,$e,gt)),Ei=qe.set(g.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(qe,$e,ft)),ai=qe.set(g.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(qe.getProxy(g.MainContext.MainThreadProgress))),bi=qe.set(g.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(qe)),li=qe.set(g.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),Jt=qe.set(g.ExtHostContext.ExtHostAuthentication,new Z.ExtHostAuthentication(qe)),Fi=qe.set(g.ExtHostContext.ExtHostTimeline,new T.ExtHostTimeline(qe,$e)),wi=qe.set(g.ExtHostContext.ExtHostWebviews,new te.ExtHostWebviews(qe,ut.remote,mt,gt,Te)),Zt=qe.set(g.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(qe,wi,mt)),Si=qe.set(g.ExtHostContext.ExtHostCustomEditors,new oe.ExtHostCustomEditors(qe,ft,It,wi,Zt)),_i=qe.set(g.ExtHostContext.ExtHostWebviewViews,new q.ExtHostWebviewViews(qe,wi)),Kt=qe.set(g.ExtHostContext.ExtHostTesting,new ve.ExtHostTesting(qe,$e,et)),Ni=qe.set(g.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(qe));qe.set(g.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(qe,bt,et,$e,gt));const yi=Object.values(g.ExtHostContext);qe.assertRegistered(yi);const Di=new J.ExtHostBulkEdits(qe,et),Li=new t.ExtHostClipboard(qe),Ii=new v.ExtHostMessageService(qe,gt),ki=new u.ExtHostDialogs(qe),Pi=new H.ExtHostStatusBar(qe,$e.converter);return m.ExtHostApiCommands.register($e),function(Le,Ht,ci){const pt=function(){let se=!Le.isUnderDevelopment;function he(){se||(gt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")he();else{const wt=ot;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return ot}}(),Mi={getSession(se,he,Re){return Jt.getSession(Le,se,he,Re)},async hasSession(se,he){return(0,Ve.checkProposedApiEnabled)(Le,"authSession"),!!await Jt.getSession(Le,se,he,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(se,he,Re,ot){return Jt.registerAuthenticationProvider(se,he,Re,ot)}},Ui={registerCommand(se,he,Re){return $e.registerCommand(!0,se,he,Re,void 0,Le)},registerTextEditorCommand(se,he,Re){return $e.registerCommand(!0,se,(...ot)=>{const wt=Ct.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+se+" because there is no active text editor.");return}return wt.edit(Tt=>{he.apply(Re,[wt,Tt,...ot])}).then(Tt=>{Tt||gt.warn("Edits from command "+se+" were not applied.")},Tt=>{gt.warn("An error occurred while running command "+se,Tt)})},void 0,void 0,Le)},registerDiffInformationCommand:(se,he,Re)=>((0,Ve.checkProposedApiEnabled)(Le,"diffCommand"),$e.registerCommand(!0,se,async(...ot)=>{const wt=et.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Tt=await Ct.getDiffInformation(wt.id);he.apply(Re,[Tt,...ot])},void 0,void 0,Le)),executeCommand(se,...he){return $e.executeCommand(se,...he)},getCommands(se=!1){return $e.getCommands(se)}},Ai={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Li.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Le,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return _t.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return _t.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),_t.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),_t.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ge.isNewAppInstall)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(se){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),_t.instantiateLogger(Le,se)},openExternal(se,he){return ge.openUri(se,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===ut.environment.appUriScheme)return Pt.createAppUri(se);try{return await ge.asExternalUri(se,{allowTunneling:!!ut.remote.authority})}catch(he){if((0,me.matchesScheme)(se,Y.Schemas.http)||(0,me.matchesScheme)(se,Y.Schemas.https))return se;throw he}},get remoteName(){return(0,fe.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Le,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return(0,Ve.checkProposedApiEnabled)(Le,"extensionLog"),gt.getLevel()},get onDidChangeLogLevel(){return(0,Ve.checkProposedApiEnabled)(Le,"extensionLog"),gt.onDidChangeLogLevel}};ut.environment.extensionTestsLocationURI||Object.freeze(Ai);const ui={createTestController(se,he,Re){return Kt.createTestController(se,he,Re)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Kt.createTestObserver()},runTests(se){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Kt.runTests(se)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Kt.results}},di=ut.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Bi={getExtension(se,he){(0,Ve.isProposedApiEnabled)(Le,"extensionsAny")||(he=!1);const Re=Ht.mine.getExtensionDescription(se);if(Re)return new d.Extension(kt,Le.identifier,Re,di,!1);if(he){const ot=Ht.all.getExtensionDescription(se);if(ot)return new d.Extension(kt,Le.identifier,ot,di,!0)}},get all(){const se=[];for(const he of Ht.mine.getAllExtensionDescriptions())se.push(new d.Extension(kt,Le.identifier,he,di,!1));return se},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Le,"extensionsAny");const se=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Ht.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);he.push(new d.Extension(kt,Le.identifier,Re,di,ot))}return he},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Le,"extensionsAny")?S.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},zi={createDiagnosticCollection(se){return Qt.createDiagnosticCollection(Le.identifier,se)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:se=>Qt.getDiagnostics(se),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(se,he){return si.changeLanguage(se.uri,he)},match(se,he){const Re=ft.getDocumentData(he.uri)?.notebook;return(0,O.score)(x.LanguageSelector.from(se),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,he,Re){return ct.registerCodeActionProvider(Le,pt(se),he,Re)},registerDocumentPasteEditProvider(se,he,Re){return(0,Ve.checkProposedApiEnabled)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,pt(se),he,Re)},registerCodeLensProvider(se,he){return ct.registerCodeLensProvider(Le,pt(se),he)},registerDefinitionProvider(se,he){return ct.registerDefinitionProvider(Le,pt(se),he)},registerDeclarationProvider(se,he){return ct.registerDeclarationProvider(Le,pt(se),he)},registerImplementationProvider(se,he){return ct.registerImplementationProvider(Le,pt(se),he)},registerTypeDefinitionProvider(se,he){return ct.registerTypeDefinitionProvider(Le,pt(se),he)},registerHoverProvider(se,he){return ct.registerHoverProvider(Le,pt(se),he,Le.identifier)},registerEvaluatableExpressionProvider(se,he){return ct.registerEvaluatableExpressionProvider(Le,pt(se),he,Le.identifier)},registerInlineValuesProvider(se,he){return ct.registerInlineValuesProvider(Le,pt(se),he,Le.identifier)},registerDocumentHighlightProvider(se,he){return ct.registerDocumentHighlightProvider(Le,pt(se),he)},registerLinkedEditingRangeProvider(se,he){return ct.registerLinkedEditingRangeProvider(Le,pt(se),he)},registerReferenceProvider(se,he){return ct.registerReferenceProvider(Le,pt(se),he)},registerRenameProvider(se,he){return ct.registerRenameProvider(Le,pt(se),he)},registerDocumentSymbolProvider(se,he,Re){return ct.registerDocumentSymbolProvider(Le,pt(se),he,Re)},registerWorkspaceSymbolProvider(se){return ct.registerWorkspaceSymbolProvider(Le,se)},registerDocumentFormattingEditProvider(se,he){return ct.registerDocumentFormattingEditProvider(Le,pt(se),he)},registerDocumentRangeFormattingEditProvider(se,he){return ct.registerDocumentRangeFormattingEditProvider(Le,pt(se),he)},registerOnTypeFormattingEditProvider(se,he,Re,...ot){return ct.registerOnTypeFormattingEditProvider(Le,pt(se),he,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,he,Re){return ct.registerDocumentSemanticTokensProvider(Le,pt(se),he,Re)},registerDocumentRangeSemanticTokensProvider(se,he,Re){return ct.registerDocumentRangeSemanticTokensProvider(Le,pt(se),he,Re)},registerSignatureHelpProvider(se,he,Re,...ot){return typeof Re=="object"?ct.registerSignatureHelpProvider(Le,pt(se),he,Re):ct.registerSignatureHelpProvider(Le,pt(se),he,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(se,he,...Re){return ct.registerCompletionItemProvider(Le,pt(se),he,Re)},registerInlineCompletionItemProvider(se,he){return he.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,pt(se),he)},registerInlineCompletionItemProviderNew(se,he){if((0,Ve.checkProposedApiEnabled)(Le,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(Le,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ct.registerInlineCompletionsProviderNew(Le,pt(se),he)},registerDocumentLinkProvider(se,he){return ct.registerDocumentLinkProvider(Le,pt(se),he)},registerColorProvider(se,he){return ct.registerColorProvider(Le,pt(se),he)},registerFoldingRangeProvider(se,he){return ct.registerFoldingRangeProvider(Le,pt(se),he)},registerSelectionRangeProvider(se,he){return ct.registerSelectionRangeProvider(Le,se,he)},registerCallHierarchyProvider(se,he){return ct.registerCallHierarchyProvider(Le,se,he)},registerTypeHierarchyProvider(se,he){return ct.registerTypeHierarchyProvider(Le,se,he)},setLanguageConfiguration:(se,he)=>ct.setLanguageConfiguration(Le,se,he),getTokenInformationAtPosition(se,he){return(0,Ve.checkProposedApiEnabled)(Le,"tokenInformation"),si.tokenAtPosition(se,he)},registerInlayHintsProvider(se,he){return ct.registerInlayHintsProvider(Le,se,he)},createLanguageStatusItem(se,he){return si.createLanguageStatusItem(Le,se,he)},registerDocumentDropEditProvider(se,he){return ct.registerDocumentOnDropEditProvider(Le,se,he)}},$i={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(se,he,Re){const ot=await(_.URI.isUri(se)?Promise.resolve(hi.openTextDocument(se)):Promise.resolve(se));return Ct.showTextDocument(ot,he,Re)},createTextEditorDecorationType(se){return Ct.createTextEditorDecorationType(Le,se)},onDidChangeActiveTextEditor(se,he,Re){return Ct.onDidChangeActiveTextEditor(se,he,Re)},onDidChangeVisibleTextEditors(se,he,Re){return Ct.onDidChangeVisibleTextEditors(se,he,Re)},onDidChangeTextEditorSelection(se,he,Re){return Ct.onDidChangeTextEditorSelection(se,he,Re)},onDidChangeTextEditorOptions(se,he,Re){return Ct.onDidChangeTextEditorOptions(se,he,Re)},onDidChangeTextEditorVisibleRanges(se,he,Re){return Ct.onDidChangeTextEditorVisibleRanges(se,he,Re)},onDidChangeTextEditorViewColumn(se,he,Re){return Ct.onDidChangeTextEditorViewColumn(se,he,Re)},onDidCloseTerminal(se,he,Re){return it.onDidCloseTerminal(se,he,Re)},onDidOpenTerminal(se,he,Re){return it.onDidOpenTerminal(se,he,Re)},onDidChangeActiveTerminal(se,he,Re){return it.onDidChangeActiveTerminal(se,he,Re)},onDidChangeTerminalDimensions(se,he,Re){return(0,Ve.checkProposedApiEnabled)(Le,"terminalDimensions"),it.onDidChangeTerminalDimensions(se,he,Re)},onDidChangeTerminalState(se,he,Re){return it.onDidChangeTerminalState(se,he,Re)},onDidWriteTerminalData(se,he,Re){return(0,Ve.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),it.onDidWriteTerminalData(se,he,Re)},get state(){return ge.state},onDidChangeWindowState(se,he,Re){return ge.onDidChangeWindowState(se,he,Re)},showInformationMessage(se,...he){return Ii.showMessage(Le,F.default.Info,se,he[0],he.slice(1))},showWarningMessage(se,...he){return Ii.showMessage(Le,F.default.Warning,se,he[0],he.slice(1))},showErrorMessage(se,...he){return Ii.showMessage(Le,F.default.Error,se,he[0],he.slice(1))},showQuickPick(se,he,Re){return qt.showQuickPick(se,he,Re)},showWorkspaceFolderPick(se){return qt.showWorkspaceFolderPick(se)},showInputBox(se,he){return qt.showInput(se,he)},showOpenDialog(se){return ki.showOpenDialog(se)},showSaveDialog(se){return ki.showSaveDialog(se)},createStatusBarItem(se,he,Re){let ot,wt,Tt;return typeof se=="string"?(ot=se,wt=he,Tt=Re):(wt=se,Tt=he),Pi.createStatusBarEntry(Le,ot,wt,Tt)},setStatusBarMessage(se,he){return Pi.setStatusBarMessage(se,he)},withScmProgress(se){return Te.report("window.withScmProgress",Le,"Use 'withProgress' instead."),ai.withProgress(Le,{location:U.ProgressLocation.SourceControl},(he,Re)=>se({report(ot){}}))},withProgress(se,he){return ai.withProgress(Le,se,he)},createOutputChannel(se,he){return Dt.createOutputChannel(se,he,Le)},createWebviewPanel(se,he,Re,ot){return Zt.createWebviewPanel(Le,se,he,Re,ot)},createWebviewTextEditorInset(se,he,Re,ot){return(0,Ve.checkProposedApiEnabled)(Le,"editorInsets"),Wt.createWebviewEditorInset(se,he,Re,ot,Le)},createTerminal(se,he,Re){return typeof se=="object"?"pty"in se?it.createExtensionTerminal(se):it.createTerminalFromOptions(se):it.createTerminal(se,he,Re)},registerTerminalLinkProvider(se){return it.registerLinkProvider(se)},registerTerminalProfileProvider(se,he){return it.registerProfileProvider(Le,se,he)},registerTreeDataProvider(se,he){return ri.registerTreeDataProvider(se,he,Le)},createTreeView(se,he){return ri.createTreeView(se,he,Le)},registerWebviewPanelSerializer:(se,he)=>Zt.registerWebviewPanelSerializer(Le,se,he),registerCustomEditorProvider:(se,he,Re={})=>Si.registerCustomEditorProvider(Le,se,he,Re),registerFileDecorationProvider(se){return Me.registerFileDecorationProvider(se,Le.identifier)},registerUriHandler(se){return Pt.registerUriHandler(Le.identifier,se)},createQuickPick(){return qt.createQuickPick(Le)},createInputBox(){return qt.createInputBox(Le)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(se,he,Re){return li.onDidChangeActiveColorTheme(se,he,Re)},registerWebviewViewProvider(se,he,Re){return _i.registerWebviewViewProvider(Le,se,he,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,he,Re){return bt.onDidChangeActiveNotebookEditor(se,he,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,he,Re){return ii.onDidChangeNotebookEditorSelection(se,he,Re)},onDidChangeNotebookEditorVisibleRanges(se,he,Re){return ii.onDidChangeNotebookEditorVisibleRanges(se,he,Re)},showNotebookDocument(se,he){return _.URI.isUri(se)&&Te.report("window.showNotebookDocument(uri)",Le,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(se,he)},registerExternalUriOpener(se,he,Re){return(0,Ve.checkProposedApiEnabled)(Le,"externalUriOpener"),Ni.registerExternalUriOpener(Le.identifier,se,he,Re)},get tabGroups(){return Ae.tabGroups}},hi={get rootPath(){return Te.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(se){throw D.readonly()},getWorkspaceFolder(se){return mt.getWorkspaceFolder(se)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(se){throw D.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(se){throw D.readonly()},updateWorkspaceFolders:(se,he,...Re)=>mt.updateWorkspaceFolders(Le,se,he||0,...Re),onDidChangeWorkspaceFolders:function(se,he,Re){return mt.onDidChangeWorkspace(se,he,Re)},asRelativePath:(se,he)=>mt.getRelativePath(se,he),findFiles:(se,he,Re,ot)=>mt.findFiles(se,he,Re,Le.identifier,ot),findTextInFiles:(se,he,Re,ot)=>{(0,Ve.checkProposedApiEnabled)(Le,"findTextInFiles");let wt,Tt;return typeof he=="object"?(wt=he,Tt=Re):(wt={},Tt=he,ot=Re),mt.findTextInFiles(se,wt||{},Tt,Le.identifier,ot)},saveAll:se=>mt.saveAll(se),applyEdit(se,he){return Di.applyWorkspaceEdit(se,Le,he)},createFileSystemWatcher:(se,he,Re,ot)=>zt.createFileSystemWatcher(mt,Le,se,he,Re,ot),get textDocuments(){return ft.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw D.readonly()},openTextDocument(se){let he;const Re=se;if(typeof se=="string")he=Promise.resolve(_.URI.file(se));else if(_.URI.isUri(se))he=Promise.resolve(se);else if(!Re||typeof Re=="object")he=ft.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ot=>ft.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(se,he,Re)=>ft.onDidAddDocument(se,he,Re),onDidCloseTextDocument:(se,he,Re)=>ft.onDidRemoveDocument(se,he,Re),onDidChangeTextDocument:(se,he,Re)=>ft.onDidChangeDocument(se,he,Re),onDidSaveTextDocument:(se,he,Re)=>ft.onDidSaveDocument(se,he,Re),onWillSaveTextDocument:(se,he,Re)=>ti.getOnWillSaveTextDocumentEvent(Le)(se,he,Re),get notebookDocuments(){return bt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,he){let Re;if(_.URI.isUri(se))Re=se,await bt.openNotebookDocument(se);else if(typeof se=="string")Re=_.URI.revive(await bt.createNotebookDocument({viewType:se,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,he,Re){return Bt.onDidSaveNotebookDocument(se,he,Re)},onDidChangeNotebookDocument(se,he,Re){return Bt.onDidChangeNotebookDocument(se,he,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(se,he,Re,ot){return bt.registerNotebookSerializer(Le,se,he,Re,(0,Ve.isProposedApiEnabled)(Le,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,he,Re,ot)=>((0,Ve.checkProposedApiEnabled)(Le,"notebookContentProvider"),Te.report("workspace.registerNotebookContentProvider",Le,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Le,se,he,Re,(0,Ve.isProposedApiEnabled)(Le,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,he,Re)=>ci.onDidChangeConfiguration(se,he,Re),getConfiguration(se,he){return he=arguments.length===1?void 0:he,ci.getConfiguration(se,he,Le)},registerTextDocumentContentProvider(se,he){return ei.registerTextDocumentContentProvider(se,he)},registerTaskProvider:(se,he)=>(Te.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Le,se,he)),registerFileSystemProvider(se,he,Re){return(0,Ke.combinedDisposable)(Yt.registerFileSystemProvider(Le,se,he,Re),xt.addFileSystemProvider(se,he))},get fs(){return xt.value},registerFileSearchProvider:(se,he)=>((0,Ve.checkProposedApiEnabled)(Le,"fileSearchProvider"),yt.registerFileSearchProvider(se,he)),registerTextSearchProvider:(se,he)=>((0,Ve.checkProposedApiEnabled)(Le,"textSearchProvider"),yt.registerTextSearchProvider(se,he)),registerRemoteAuthorityResolver:(se,he)=>((0,Ve.checkProposedApiEnabled)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(se,he)),registerResourceLabelFormatter:se=>((0,Ve.checkProposedApiEnabled)(Le,"resolvers"),bi.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,he,Re)=>zt.onDidCreateFile(se,he,Re),onDidDeleteFiles:(se,he,Re)=>zt.onDidDeleteFile(se,he,Re),onDidRenameFiles:(se,he,Re)=>zt.onDidRenameFile(se,he,Re),onWillCreateFiles:(se,he,Re)=>zt.getOnWillCreateFileEvent(Le)(se,he,Re),onWillDeleteFiles:(se,he,Re)=>zt.getOnWillDeleteFileEvent(Le)(se,he,Re),onWillRenameFiles:(se,he,Re)=>zt.getOnWillRenameFileEvent(Le)(se,he,Re),openTunnel:se=>((0,Ve.checkProposedApiEnabled)(Le,"tunnels"),_e.openTunnel(Le,se).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Le,"tunnels"),_e.getTunnels()},onDidChangeTunnels:(se,he,Re)=>((0,Ve.checkProposedApiEnabled)(Le,"tunnels"),_e.onDidChangeTunnels(se,he,Re)),registerPortAttributesProvider:(se,he)=>((0,Ve.checkProposedApiEnabled)(Le,"portsAttributes"),_e.registerPortsAttributesProvider(se,he)),registerTimelineProvider:(se,he)=>((0,Ve.checkProposedApiEnabled)(Le,"timeline"),Fi.registerTimelineProvider(se,he,Le.identifier,$e.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:se=>((0,Ve.checkProposedApiEnabled)(Le,"workspaceTrust"),mt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,he,Re)=>mt.onDidGrantWorkspaceTrust(se,he,Re),registerEditSessionIdentityProvider:(se,he)=>((0,Ve.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(se,he))},xi={get inputBox(){return Te.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),oi.getLastInputBox(Le)},createSourceControl(se,he,Re){return oi.createSourceControl(Le,se,he,Re)}},Vt={createCommentController(se,he){return Ei.createCommentController(Le,se,he)}},fi={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(se,he,Re){return at.onDidStartDebugSession(se,he,Re)},onDidTerminateDebugSession(se,he,Re){return at.onDidTerminateDebugSession(se,he,Re)},onDidChangeActiveDebugSession(se,he,Re){return at.onDidChangeActiveDebugSession(se,he,Re)},onDidReceiveDebugSessionCustomEvent(se,he,Re){return at.onDidReceiveDebugSessionCustomEvent(se,he,Re)},onDidChangeBreakpoints(se,he,Re){return at.onDidChangeBreakpoints(se,he,Re)},registerDebugConfigurationProvider(se,he,Re){return at.registerDebugConfigurationProvider(se,he,Re||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,he){return at.registerDebugAdapterDescriptorFactory(Le,se,he)},registerDebugAdapterTrackerFactory(se,he){return at.registerDebugAdapterTrackerFactory(se,he)},startDebugging(se,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?at.startDebugging(se,he,{parentSession:Re}):at.startDebugging(se,he,Re||{})},stopDebugging(se){return at.stopDebugging(se)},addBreakpoints(se){return at.addBreakpoints(se)},removeBreakpoints(se){return at.removeBreakpoints(se)},asDebugSourceUri(se,he){return at.asDebugSourceUri(se,he)}},Wi={registerTaskProvider:(se,he)=>vt.registerTaskProvider(Le,se,he),fetchTasks:se=>vt.fetchTasks(se),executeTask:se=>vt.executeTask(Le,se),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(se,he,Re)=>vt.onDidStartTask(se,he,Re),onDidEndTask:(se,he,Re)=>vt.onDidEndTask(se,he,Re),onDidStartTaskProcess:(se,he,Re)=>vt.onDidStartTaskProcess(se,he,Re),onDidEndTaskProcess:(se,he,Re)=>vt.onDidEndTaskProcess(se,he,Re)},Nt={createNotebookController(se,he,Re,ot,wt){return ni.createNotebookController(Le,se,he,Re,ot,(0,Ve.isProposedApiEnabled)(Le,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(se,he)=>bt.registerNotebookCellStatusBarItemProvider(Le,se,he),createRendererMessaging(se){return vi.createRendererMessaging(Le,se)},onDidChangeNotebookCellExecutionState(se,he,Re){return(0,Ve.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),ni.onDidChangeNotebookCellExecutionState(se,he,Re)}},mi={t(...se){if(typeof se[0]=="string"){const he=se.shift(),Re=!se||typeof se[0]!="object"?se:se[0];return Et.getMessage(Le.identifier.value,{message:he,args:Re})}return Et.getMessage(Le.identifier.value,se[0])},get bundle(){return Et.getBundle(Le.identifier.value)},get uri(){return Et.getBundleUri(Le.identifier.value)}};return{version:ut.version,authentication:Mi,commands:Ui,comments:Vt,debug:fi,env:Ai,extensions:Bi,l10n:mi,languages:zi,notebooks:Nt,scm:xi,tasks:Wi,tests:ui,window:$i,workspace:hi,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:D.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:U.InlineCompletionTriggerKindNew,EventEmitter:S.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionItemNew:U.InlineSuggestionNew,InlineCompletionList:U.InlineSuggestionList,InlineCompletionListNew:U.InlineSuggestionsNew,Hover:U.Hover,IndentAction:k.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,SnippetTextEdit:U.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItem2:U.TreeItem,TreeItemCheckboxState:U.TreeItemCheckboxState,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:E.UIKind,Uri:_.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,DocumentDropEdit:U.DocumentDropEdit,DocumentPasteEdit:U.DocumentPasteEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,NotebookControllerAffinity2:U.NotebookControllerAffinity2,NotebookEdit:U.NotebookEdit,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:U.DataTransfer,DataTransferItem:U.DataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind,InputBoxValidationSeverity:U.InputBoxValidationSeverity,TabInputText:U.TextTabInput,TabInputTextDiff:U.TextDiffTabInput,TabInputTextMerge:U.TextMergeTabInput,TabInputCustom:U.CustomEditorTabInput,TabInputNotebook:U.NotebookEditorTabInput,TabInputNotebookDiff:U.NotebookDiffEditorTabInput,TabInputWebview:U.WebviewEditorTabInput,TabInputTerminal:U.TerminalEditorTabInput,TabInputInteractiveWindow:U.InteractiveWindowInput,TerminalExitReason:U.TerminalExitReason,LogLevel:Ue.LogLevel,EditSessionIdentityMatch:dt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=St}),define(De[244],Ce([1,0,243,33,2,237,6,15,228]),function(ne,e,i,D,S,F,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends F.RequireInterceptor{_installInterceptor(){}getModule(E,m){for(const t of this._alternatives){const o=t(E);if(o){E=o;break}}if(this._factories.has(E))return this._factories.get(E).load(E,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends D.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(k,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,m,t){m=m.with({path:w(m.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=S.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(m)),p=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),p.status!==200)throw new Error(p.statusText);const b=await p.text(),u=`${m.toString(!0)}#vscode-extension`,C=`${b}
//# sourceURL=${u}`;let s;try{s=new Function("module","exports","require",C)}catch(l){throw console.error(o?`Loading code for extension ${o} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${m.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const c={},n={exports:c},d=l=>{const f=this._fakeModules.getModule(l,m);if(f===void 0)throw new Error(`Cannot load module '${l}'`);return f};try{return t.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),s(n,c,d),n.exports!==c?n.exports:c}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),t.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+E;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function w(g,E){return g.endsWith(E)?g:g+E}}),define(De[245],Ce([1,0,59,33,75,244]),function(ne,e,i,D,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(D.IExtHostExtensionService,F.ExtHostExtensionService,!1),(0,i.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,!1)}),define(De[253],Ce([1,0,23,4,68,238,230,19,76,13,2,240,245]),function(ne,e,i,D,S,F,_,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(s){return/^(file|vscode-remote):/i.test(s)}const m=fetch.bind(self);function t(s){self.fetch=async function(c,n){return c instanceof Request||E(String(c))&&(c=(await s(O.URI.parse(String(c)))).toString(!0)),m(c,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,n,d,l,f){(async()=>(E(n.toString())&&(n=(await s(O.URI.parse(n.toString()))).toString(!0)),super.open(c,n,d??!0,l,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(c,n){if(/^file:/i.test(c.toString()))c=k.FileAccess.asBrowserUri(O.URI.parse(c.toString())).toString(!0);else if(/^vscode-remote:/i.test(c.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const l=`(${function(v){function I(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const L=fetch.bind(self);self.fetch=function(W,H){return W instanceof Request?L(W,H):L(I(W),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,H,P,M,R){return super.open(W,I(H),P??!0,M,R)}};const j=importScripts.bind(self);self.importScripts=(...W)=>{j(...W.map(I))},j(v)}.toString()}('${c}'))`;n=n||{},n.name=n.name||A.basename(c.toString());const f=new Blob([l],{type:"application/javascript"}),r=URL.createObjectURL(f);return new s(r,n)}}else self.Worker=class extends _.NestedWorker{constructor(s,c){super(g,s,{name:A.basename(s.toString()),...c})}};const o=new class{constructor(){this.pid=void 0}exit(s){w()}async exists(s){return!0}async realpath(s){return s}};class a{constructor(){const c=new MessageChannel,n=new D.Emitter;let d=!1;g(c.port2,[c.port2]),c.port1.onmessage=l=>{const{data:f}=l;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const r=i.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,S.isMessageOfType)(r,2)){d=!0,b("received terminate message from renderer");return}n.fire(r)},this.protocol={onMessage:n.event,send:l=>{if(!d){const f=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);c.port1.postMessage(f,[f])}}}}}function p(s){return new Promise(c=>{const n=s.onMessage(d=>{n.dispose();const l=JSON.parse(d.toString());s.send((0,S.createMessageOfType)(0)),c({protocol:s,initData:l})});s.send((0,S.createMessageOfType)(1))})}let b=s=>w();function u(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function C(){y.mark("code/extHost/willConnectToRenderer");const s=new a;return{onmessage(c){!u(c)||p(s.protocol).then(n=>{y.mark("code/extHost/didWaitForInitData");const d=new F.ExtensionHostMain(n.protocol,n.initData,o,null,c.data);t(l=>d.asBrowserUri(l)),b=l=>d.terminate(l)})}}}e.create=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1c78193f54fac6036829ec554ce218d99afc1f15/core/vs/workbench/api/worker/extensionHostWorker.js.map
